# MySQL-Front 5.1  (Build 3.35)

/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE */;
/*!40101 SET SQL_MODE='' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES */;
/*!40103 SET SQL_NOTES='ON' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS */;
/*!40014 SET FOREIGN_KEY_CHECKS=0 */;


# Host: localhost    Database: schaafnet
# ------------------------------------------------------
# Server version 5.0.51b-community-nt

#
# Source for table vss_locations
#

DROP TABLE IF EXISTS `vss_locations`;
CREATE TABLE `vss_locations` (
  `Id` int(11) NOT NULL auto_increment,
  `business` char(100) default NULL COMMENT 'Name of Business',
  `city` char(30) default NULL COMMENT 'City name',
  `state` char(2) default NULL COMMENT 'State',
  `zip` varchar(20) default NULL COMMENT 'zip code',
  `address1` char(100) default NULL,
  `address2` varchar(100) default NULL,
  `active` tinyint(1) default '1',
  PRIMARY KEY  (`Id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

#
# Dumping data for table vss_locations
#
LOCK TABLES `vss_locations` WRITE;
/*!40000 ALTER TABLE `vss_locations` DISABLE KEYS */;

INSERT INTO `vss_locations` VALUES (1,'The Home Depot','Albert Lea','MN','56007','2400 Consul Street',NULL,1);
INSERT INTO `vss_locations` VALUES (2,'Hillcrest United Methodist Church','Bloomington','MN','55431','9100 Russell Avenue South',NULL,1);
INSERT INTO `vss_locations` VALUES (3,'Best Buy','St Paul','MN','55123','1235 Town Centre Drive',NULL,1);
INSERT INTO `vss_locations` VALUES (4,'Walmart','Eagan','MN','55123','1360 Town Centre Drive',NULL,1);
INSERT INTO `vss_locations` VALUES (5,'Osland Janitorial Supply','Burnsville','MN','55337','1401 Cliff Road East',NULL,1);
INSERT INTO `vss_locations` VALUES (6,'Al Baker\'s Restaurant','Eagan','MN','55123','3434 Washington Drive',NULL,1);
INSERT INTO `vss_locations` VALUES (7,'The UPS Store - 2636','Eagan','MN','55123','3432 Denmark Avenue',NULL,1);
INSERT INTO `vss_locations` VALUES (8,'Rainbow Foods Pharmacy','Eagan','MN','55123','1276 Town Centre Drive',NULL,1);
INSERT INTO `vss_locations` VALUES (9,'Twincity Transportation','Eagan','MN','55123','2020 Silver Bell Road',NULL,1);
INSERT INTO `vss_locations` VALUES (10,'Byerly\'s Wines & Spirits','Eagan','MN','55121','1299 Promenade Place',NULL,1);
INSERT INTO `vss_locations` VALUES (11,'Eagan Montessori Child Care','Eagan','MN','55121','1250 Lone Oak Road',NULL,1);
INSERT INTO `vss_locations` VALUES (12,'Bunker Hills Activities Center','Andover','MN','55304','550 Bunker Lake Boulevard',NULL,1);
INSERT INTO `vss_locations` VALUES (13,'Menards','West St Paul','MN','55118','1445 South Robert Street',NULL,1);
INSERT INTO `vss_locations` VALUES (14,'Burlington Coat Factory','West St Paul','MN','55118','2035 South Robert Street',NULL,1);
INSERT INTO `vss_locations` VALUES (15,'Jimmy John\'s Gourmet Sandwiches','St Paul','MN','55118','Robert St S',NULL,1);
INSERT INTO `vss_locations` VALUES (16,'Lowe\'s','West St Paul','MN','55118','1795 South Robert Street',NULL,1);
INSERT INTO `vss_locations` VALUES (17,'Old Country Buffet','West St Paul','MN','55118','2000 South Robert Street',NULL,1);
INSERT INTO `vss_locations` VALUES (18,'Sam\'s Club','Shakopee','MN','55379','8201 Old Carriage Court',NULL,1);
INSERT INTO `vss_locations` VALUES (19,'Kohl\'s','Shakopee','MN','55379','akoppe Valley Marketplace',NULL,1);
INSERT INTO `vss_locations` VALUES (20,'Positive Connections Inc','Chaska','MN','55318','460 North Hickory Street',NULL,1);
INSERT INTO `vss_locations` VALUES (21,'Mary Mother of the Church','Burnsville','MN','55337','3333 Cliff Road East',NULL,1);
INSERT INTO `vss_locations` VALUES (22,'Kota Connections Inc','Lakeville','MN','55044','8500 210th Street West',NULL,1);
INSERT INTO `vss_locations` VALUES (23,'Burnhaven Library','Burnsville','MN','55306','1101 County Road 42 W',NULL,1);
INSERT INTO `vss_locations` VALUES (24,'Ryt-Way Industries Inc','Lakeville','MN','55044','21850 Grenada Avenue',NULL,1);
INSERT INTO `vss_locations` VALUES (25,'Mc Donald\'s','Farmington','MN','55024','4655 Knutsen Dr',NULL,1);
INSERT INTO `vss_locations` VALUES (26,'Cub Foods - Lakeville','Lakeville','MN','55044','7435 179th Street West',NULL,1);
INSERT INTO `vss_locations` VALUES (27,'Lakeville 21','Lakeville','MN','55044','20653 Keokuk Avenue',NULL,1);
INSERT INTO `vss_locations` VALUES (28,'Walmart','Inver Grove Hts','MN','55076','9165 Cahill Ave',NULL,1);
INSERT INTO `vss_locations` VALUES (29,'Clancy\'s','Hastings','MN','55033','1399 South Frontage Road',NULL,1);
INSERT INTO `vss_locations` VALUES (30,'Cub Foods','Apple Valley','MN','55124','15350 Cedar Avenue',NULL,1);
INSERT INTO `vss_locations` VALUES (31,'Chap Value Store','Burnsville','MN','55337','2020 East Highway 13',NULL,1);
INSERT INTO `vss_locations` VALUES (32,'Walmart','Apple Valley','MN','55124','7835 150th Street West',NULL,1);
INSERT INTO `vss_locations` VALUES (33,'New Market Mechanical Heating','Elko','MN','55020','26148 Newton Circle',NULL,1);
INSERT INTO `vss_locations` VALUES (34,'Paradise Car Wash','Apple Valley','MN','55124','7600 145th Street West',NULL,1);
/*!40000 ALTER TABLE `vss_locations` ENABLE KEYS */;
UNLOCK TABLES;

/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
