<?php
if (session_id() == "") session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg12.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql12.php") ?>
<?php include_once "phpfn12.php" ?>
<?php include_once "Cust_Client_Activity2info.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn12.php" ?>
<?php

//
// Page class
//

$Cust_Client_Activity2_list = NULL; // Initialize page object first

class cCust_Client_Activity2_list extends cCust_Client_Activity2 {

	// Page ID
	var $PageID = 'list';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'Cust_Client_Activity2';

	// Page object name
	var $PageObjName = 'Cust_Client_Activity2_list';

	// Grid form hidden field names
	var $FormName = 'fCust_Client_Activity2list';
	var $FormActionName = 'k_action';
	var $FormKeyName = 'k_key';
	var $FormOldKeyName = 'k_oldkey';
	var $FormBlankRowName = 'k_blankrow';
	var $FormKeyCountName = 'key_count';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Page URLs
	var $AddUrl;
	var $EditUrl;
	var $CopyUrl;
	var $DeleteUrl;
	var $ViewUrl;
	var $ListUrl;

	// Export URLs
	var $ExportPrintUrl;
	var $ExportHtmlUrl;
	var $ExportExcelUrl;
	var $ExportWordUrl;
	var $ExportXmlUrl;
	var $ExportCsvUrl;
	var $ExportPdfUrl;

	// Custom export
	var $ExportExcelCustom = FALSE;
	var $ExportWordCustom = FALSE;
	var $ExportPdfCustom = FALSE;
	var $ExportEmailCustom = FALSE;

	// Update URLs
	var $InlineAddUrl;
	var $InlineCopyUrl;
	var $InlineEditUrl;
	var $GridAddUrl;
	var $GridEditUrl;
	var $MultiDeleteUrl;
	var $MultiUpdateUrl;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (Cust_Client_Activity2)
		if (!isset($GLOBALS["Cust_Client_Activity2"]) || get_class($GLOBALS["Cust_Client_Activity2"]) == "cCust_Client_Activity2") {
			$GLOBALS["Cust_Client_Activity2"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["Cust_Client_Activity2"];
		}

		// Initialize URLs
		$this->ExportPrintUrl = $this->PageUrl() . "export=print";
		$this->ExportExcelUrl = $this->PageUrl() . "export=excel";
		$this->ExportWordUrl = $this->PageUrl() . "export=word";
		$this->ExportHtmlUrl = $this->PageUrl() . "export=html";
		$this->ExportXmlUrl = $this->PageUrl() . "export=xml";
		$this->ExportCsvUrl = $this->PageUrl() . "export=csv";
		$this->ExportPdfUrl = $this->PageUrl() . "export=pdf";
		$this->AddUrl = "Cust_Client_Activity2add.php";
		$this->InlineAddUrl = $this->PageUrl() . "a=add";
		$this->GridAddUrl = $this->PageUrl() . "a=gridadd";
		$this->GridEditUrl = $this->PageUrl() . "a=gridedit";
		$this->MultiDeleteUrl = "Cust_Client_Activity2delete.php";
		$this->MultiUpdateUrl = "Cust_Client_Activity2update.php";

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'list', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'Cust_Client_Activity2', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}

		// List options
		$this->ListOptions = new cListOptions();
		$this->ListOptions->TableVar = $this->TableVar;

		// Export options
		$this->ExportOptions = new cListOptions();
		$this->ExportOptions->Tag = "div";
		$this->ExportOptions->TagClassName = "ewExportOption";

		// Other options
		$this->OtherOptions['addedit'] = new cListOptions();
		$this->OtherOptions['addedit']->Tag = "div";
		$this->OtherOptions['addedit']->TagClassName = "ewAddEditOption";
		$this->OtherOptions['detail'] = new cListOptions();
		$this->OtherOptions['detail']->Tag = "div";
		$this->OtherOptions['detail']->TagClassName = "ewDetailOption";
		$this->OtherOptions['action'] = new cListOptions();
		$this->OtherOptions['action']->Tag = "div";
		$this->OtherOptions['action']->TagClassName = "ewActionOption";

		// Filter options
		$this->FilterOptions = new cListOptions();
		$this->FilterOptions->Tag = "div";
		$this->FilterOptions->TagClassName = "ewFilterOption fCust_Client_Activity2listsrch";

		// List actions
		$this->ListActions = new cListActions();
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanList()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			$this->Page_Terminate(ew_GetUrl("index.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Get export parameters
		$custom = "";
		if (@$_GET["export"] <> "") {
			$this->Export = $_GET["export"];
			$custom = @$_GET["custom"];
		} elseif (@$_POST["export"] <> "") {
			$this->Export = $_POST["export"];
			$custom = @$_POST["custom"];
		} elseif (ew_IsHttpPost()) {
			if (@$_POST["exporttype"] <> "")
				$this->Export = $_POST["exporttype"];
			$custom = @$_POST["custom"];
		} else {
			$this->setExportReturnUrl(ew_CurrentUrl());
		}
		$gsExportFile = $this->TableVar; // Get export file, used in header

		// Get custom export parameters
		if ($this->Export <> "" && $custom <> "") {
			$this->CustomExport = $this->Export;
			$this->Export = "print";
		}
		$gsCustomExport = $this->CustomExport;
		$gsExport = $this->Export; // Get export parameter, used in header

		// Update Export URLs
		if (defined("EW_USE_PHPEXCEL"))
			$this->ExportExcelCustom = FALSE;
		if ($this->ExportExcelCustom)
			$this->ExportExcelUrl .= "&amp;custom=1";
		if (defined("EW_USE_PHPWORD"))
			$this->ExportWordCustom = FALSE;
		if ($this->ExportWordCustom)
			$this->ExportWordUrl .= "&amp;custom=1";
		if ($this->ExportPdfCustom)
			$this->ExportPdfUrl .= "&amp;custom=1";
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action

		// Get grid add count
		$gridaddcnt = @$_GET[EW_TABLE_GRID_ADD_ROW_COUNT];
		if (is_numeric($gridaddcnt) && $gridaddcnt > 0)
			$this->GridAddRowCount = $gridaddcnt;

		// Set up list options
		$this->SetupListOptions();

		// Setup export options
		$this->SetupExportOptions();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();

		// Setup other options
		$this->SetupOtherOptions();

		// Set up custom action (compatible with old version)
		foreach ($this->CustomActions as $name => $action)
			$this->ListActions->Add($name, $action);

		// Show checkbox column if multiple action
		foreach ($this->ListActions->Items as $listaction) {
			if ($listaction->Select == EW_ACTION_MULTIPLE && $listaction->Allow) {
				$this->ListOptions->Items["checkbox"]->Visible = TRUE;
				break;
			}
		}
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $Cust_Client_Activity2;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($Cust_Client_Activity2);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}

	// Class variables
	var $ListOptions; // List options
	var $ExportOptions; // Export options
	var $SearchOptions; // Search options
	var $OtherOptions = array(); // Other options
	var $FilterOptions; // Filter options
	var $ListActions; // List actions
	var $SelectedCount = 0;
	var $SelectedIndex = 0;
	var $DisplayRecs = 20;
	var $StartRec;
	var $StopRec;
	var $TotalRecs = 0;
	var $RecRange = 10;
	var $Pager;
	var $DefaultSearchWhere = ""; // Default search WHERE clause
	var $SearchWhere = ""; // Search WHERE clause
	var $RecCnt = 0; // Record count
	var $EditRowCnt;
	var $StartRowCnt = 1;
	var $RowCnt = 0;
	var $Attrs = array(); // Row attributes and cell attributes
	var $RowIndex = 0; // Row index
	var $KeyCount = 0; // Key count
	var $RowAction = ""; // Row action
	var $RowOldKey = ""; // Row old key (for copy)
	var $RecPerRow = 0;
	var $MultiColumnClass;
	var $MultiColumnEditClass = "col-sm-12";
	var $MultiColumnCnt = 12;
	var $MultiColumnEditCnt = 12;
	var $GridCnt = 0;
	var $ColCnt = 0;
	var $DbMasterFilter = ""; // Master filter
	var $DbDetailFilter = ""; // Detail filter
	var $MasterRecordExists;	
	var $MultiSelectKey;
	var $Command;
	var $RestoreSearch = FALSE;
	var $DetailPages;
	var $Recordset;
	var $OldRecordset;

	//
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError, $gsSearchError, $Security;

		// Search filters
		$sSrchAdvanced = ""; // Advanced search filter
		$sSrchBasic = ""; // Basic search filter
		$sFilter = "";

		// Get command
		$this->Command = strtolower(@$_GET["cmd"]);
		if ($this->IsPageRequest()) { // Validate request

			// Process list action first
			if ($this->ProcessListAction()) // Ajax request
				$this->Page_Terminate();

			// Handle reset command
			$this->ResetCmd();

			// Set up Breadcrumb
			if ($this->Export == "")
				$this->SetupBreadcrumb();

			// Hide list options
			if ($this->Export <> "") {
				$this->ListOptions->HideAllOptions(array("sequence"));
				$this->ListOptions->UseDropDownButton = FALSE; // Disable drop down button
				$this->ListOptions->UseButtonGroup = FALSE; // Disable button group
			} elseif ($this->CurrentAction == "gridadd" || $this->CurrentAction == "gridedit") {
				$this->ListOptions->HideAllOptions();
				$this->ListOptions->UseDropDownButton = FALSE; // Disable drop down button
				$this->ListOptions->UseButtonGroup = FALSE; // Disable button group
			}

			// Hide options
			if ($this->Export <> "" || $this->CurrentAction <> "") {
				$this->ExportOptions->HideAllOptions();
				$this->FilterOptions->HideAllOptions();
			}

			// Hide other options
			if ($this->Export <> "") {
				foreach ($this->OtherOptions as &$option)
					$option->HideAllOptions();
			}

			// Get default search criteria
			ew_AddFilter($this->DefaultSearchWhere, $this->AdvancedSearchWhere(TRUE));

			// Get and validate search values for advanced search
			$this->LoadSearchValues(); // Get search values

			// Restore filter list
			$this->RestoreFilterList();
			if (!$this->ValidateSearch())
				$this->setFailureMessage($gsSearchError);

			// Restore search parms from Session if not searching / reset / export
			if (($this->Export <> "" || $this->Command <> "search" && $this->Command <> "reset" && $this->Command <> "resetall") && $this->CheckSearchParms())
				$this->RestoreSearchParms();

			// Call Recordset SearchValidated event
			$this->Recordset_SearchValidated();

			// Set up sorting order
			$this->SetUpSortOrder();

			// Get search criteria for advanced search
			if ($gsSearchError == "")
				$sSrchAdvanced = $this->AdvancedSearchWhere();
		}

		// Restore display records
		if ($this->getRecordsPerPage() <> "") {
			$this->DisplayRecs = $this->getRecordsPerPage(); // Restore from Session
		} else {
			$this->DisplayRecs = 20; // Load default
		}

		// Load Sorting Order
		$this->LoadSortOrder();

		// Load search default if no existing search criteria
		if (!$this->CheckSearchParms()) {

			// Load advanced search from default
			if ($this->LoadAdvancedSearchDefault()) {
				$sSrchAdvanced = $this->AdvancedSearchWhere();
			}
		}

		// Build search criteria
		ew_AddFilter($this->SearchWhere, $sSrchAdvanced);
		ew_AddFilter($this->SearchWhere, $sSrchBasic);

		// Call Recordset_Searching event
		$this->Recordset_Searching($this->SearchWhere);

		// Save search criteria
		if ($this->Command == "search" && !$this->RestoreSearch) {
			$this->setSearchWhere($this->SearchWhere); // Save to Session
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} else {
			$this->SearchWhere = $this->getSearchWhere();
		}

		// Build filter
		$sFilter = "";
		if (!$Security->CanList())
			$sFilter = "(0=1)"; // Filter all records
		ew_AddFilter($sFilter, $this->DbDetailFilter);
		ew_AddFilter($sFilter, $this->SearchWhere);

		// Set up filter in session
		$this->setSessionWhere($sFilter);
		$this->CurrentFilter = "";

		// Export data only
		if ($this->CustomExport == "" && in_array($this->Export, array("html","word","excel","xml","csv","email","pdf"))) {
			$this->ExportData();
			$this->Page_Terminate(); // Terminate response
			exit();
		}

		// Load record count first
		if (!$this->IsAddOrEdit()) {
			$bSelectLimit = $this->UseSelectLimit;
			if ($bSelectLimit) {
				$this->TotalRecs = $this->SelectRecordCount();
			} else {
				if ($this->Recordset = $this->LoadRecordset())
					$this->TotalRecs = $this->Recordset->RecordCount();
			}
		}

		// Search options
		$this->SetupSearchOptions();
	}

	// Build filter for all keys
	function BuildKeyFilter() {
		global $objForm;
		$sWrkFilter = "";

		// Update row index and get row key
		$rowindex = 1;
		$objForm->Index = $rowindex;
		$sThisKey = strval($objForm->GetValue($this->FormKeyName));
		while ($sThisKey <> "") {
			if ($this->SetupKeyValues($sThisKey)) {
				$sFilter = $this->KeyFilter();
				if ($sWrkFilter <> "") $sWrkFilter .= " OR ";
				$sWrkFilter .= $sFilter;
			} else {
				$sWrkFilter = "0=1";
				break;
			}

			// Update row index and get row key
			$rowindex++; // Next row
			$objForm->Index = $rowindex;
			$sThisKey = strval($objForm->GetValue($this->FormKeyName));
		}
		return $sWrkFilter;
	}

	// Set up key values
	function SetupKeyValues($key) {
		$arrKeyFlds = explode($GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"], $key);
		if (count($arrKeyFlds) >= 0) {
		}
		return TRUE;
	}

	// Get list of filters
	function GetFilterList() {

		// Initialize
		$sFilterList = "";
		$sFilterList = ew_Concat($sFilterList, $this->dbkey_councilor->AdvancedSearch->ToJSON(), ","); // Field dbkey_councilor
		$sFilterList = ew_Concat($sFilterList, $this->dbkey_client->AdvancedSearch->ToJSON(), ","); // Field dbkey_client
		$sFilterList = ew_Concat($sFilterList, $this->date->AdvancedSearch->ToJSON(), ","); // Field date
		$sFilterList = ew_Concat($sFilterList, $this->time->AdvancedSearch->ToJSON(), ","); // Field time
		$sFilterList = ew_Concat($sFilterList, $this->comment->AdvancedSearch->ToJSON(), ","); // Field comment
		$sFilterList = ew_Concat($sFilterList, $this->dbkey_activity->AdvancedSearch->ToJSON(), ","); // Field dbkey_activity
		$sFilterList = ew_Concat($sFilterList, $this->attachment->AdvancedSearch->ToJSON(), ","); // Field attachment
		$sFilterList = ew_Concat($sFilterList, $this->budget->AdvancedSearch->ToJSON(), ","); // Field budget
		$sFilterList = ew_Concat($sFilterList, $this->allocated->AdvancedSearch->ToJSON(), ","); // Field allocated
		$sFilterList = ew_Concat($sFilterList, $this->remain->AdvancedSearch->ToJSON(), ","); // Field remain
		$sFilterList = ew_Concat($sFilterList, $this->total_allocated->AdvancedSearch->ToJSON(), ","); // Field total_allocated
		$sFilterList = ew_Concat($sFilterList, $this->total_remain->AdvancedSearch->ToJSON(), ","); // Field total_remain

		// Return filter list in json
		return ($sFilterList <> "") ? "{" . $sFilterList . "}" : "null";
	}

	// Restore list of filters
	function RestoreFilterList() {

		// Return if not reset filter
		if (@$_POST["cmd"] <> "resetfilter")
			return FALSE;
		$filter = json_decode(ew_StripSlashes(@$_POST["filter"]), TRUE);
		$this->Command = "search";

		// Field dbkey_councilor
		$this->dbkey_councilor->AdvancedSearch->SearchValue = @$filter["x_dbkey_councilor"];
		$this->dbkey_councilor->AdvancedSearch->SearchOperator = @$filter["z_dbkey_councilor"];
		$this->dbkey_councilor->AdvancedSearch->SearchCondition = @$filter["v_dbkey_councilor"];
		$this->dbkey_councilor->AdvancedSearch->SearchValue2 = @$filter["y_dbkey_councilor"];
		$this->dbkey_councilor->AdvancedSearch->SearchOperator2 = @$filter["w_dbkey_councilor"];
		$this->dbkey_councilor->AdvancedSearch->Save();

		// Field dbkey_client
		$this->dbkey_client->AdvancedSearch->SearchValue = @$filter["x_dbkey_client"];
		$this->dbkey_client->AdvancedSearch->SearchOperator = @$filter["z_dbkey_client"];
		$this->dbkey_client->AdvancedSearch->SearchCondition = @$filter["v_dbkey_client"];
		$this->dbkey_client->AdvancedSearch->SearchValue2 = @$filter["y_dbkey_client"];
		$this->dbkey_client->AdvancedSearch->SearchOperator2 = @$filter["w_dbkey_client"];
		$this->dbkey_client->AdvancedSearch->Save();

		// Field date
		$this->date->AdvancedSearch->SearchValue = @$filter["x_date"];
		$this->date->AdvancedSearch->SearchOperator = @$filter["z_date"];
		$this->date->AdvancedSearch->SearchCondition = @$filter["v_date"];
		$this->date->AdvancedSearch->SearchValue2 = @$filter["y_date"];
		$this->date->AdvancedSearch->SearchOperator2 = @$filter["w_date"];
		$this->date->AdvancedSearch->Save();

		// Field time
		$this->time->AdvancedSearch->SearchValue = @$filter["x_time"];
		$this->time->AdvancedSearch->SearchOperator = @$filter["z_time"];
		$this->time->AdvancedSearch->SearchCondition = @$filter["v_time"];
		$this->time->AdvancedSearch->SearchValue2 = @$filter["y_time"];
		$this->time->AdvancedSearch->SearchOperator2 = @$filter["w_time"];
		$this->time->AdvancedSearch->Save();

		// Field comment
		$this->comment->AdvancedSearch->SearchValue = @$filter["x_comment"];
		$this->comment->AdvancedSearch->SearchOperator = @$filter["z_comment"];
		$this->comment->AdvancedSearch->SearchCondition = @$filter["v_comment"];
		$this->comment->AdvancedSearch->SearchValue2 = @$filter["y_comment"];
		$this->comment->AdvancedSearch->SearchOperator2 = @$filter["w_comment"];
		$this->comment->AdvancedSearch->Save();

		// Field dbkey_activity
		$this->dbkey_activity->AdvancedSearch->SearchValue = @$filter["x_dbkey_activity"];
		$this->dbkey_activity->AdvancedSearch->SearchOperator = @$filter["z_dbkey_activity"];
		$this->dbkey_activity->AdvancedSearch->SearchCondition = @$filter["v_dbkey_activity"];
		$this->dbkey_activity->AdvancedSearch->SearchValue2 = @$filter["y_dbkey_activity"];
		$this->dbkey_activity->AdvancedSearch->SearchOperator2 = @$filter["w_dbkey_activity"];
		$this->dbkey_activity->AdvancedSearch->Save();

		// Field attachment
		$this->attachment->AdvancedSearch->SearchValue = @$filter["x_attachment"];
		$this->attachment->AdvancedSearch->SearchOperator = @$filter["z_attachment"];
		$this->attachment->AdvancedSearch->SearchCondition = @$filter["v_attachment"];
		$this->attachment->AdvancedSearch->SearchValue2 = @$filter["y_attachment"];
		$this->attachment->AdvancedSearch->SearchOperator2 = @$filter["w_attachment"];
		$this->attachment->AdvancedSearch->Save();

		// Field budget
		$this->budget->AdvancedSearch->SearchValue = @$filter["x_budget"];
		$this->budget->AdvancedSearch->SearchOperator = @$filter["z_budget"];
		$this->budget->AdvancedSearch->SearchCondition = @$filter["v_budget"];
		$this->budget->AdvancedSearch->SearchValue2 = @$filter["y_budget"];
		$this->budget->AdvancedSearch->SearchOperator2 = @$filter["w_budget"];
		$this->budget->AdvancedSearch->Save();

		// Field allocated
		$this->allocated->AdvancedSearch->SearchValue = @$filter["x_allocated"];
		$this->allocated->AdvancedSearch->SearchOperator = @$filter["z_allocated"];
		$this->allocated->AdvancedSearch->SearchCondition = @$filter["v_allocated"];
		$this->allocated->AdvancedSearch->SearchValue2 = @$filter["y_allocated"];
		$this->allocated->AdvancedSearch->SearchOperator2 = @$filter["w_allocated"];
		$this->allocated->AdvancedSearch->Save();

		// Field remain
		$this->remain->AdvancedSearch->SearchValue = @$filter["x_remain"];
		$this->remain->AdvancedSearch->SearchOperator = @$filter["z_remain"];
		$this->remain->AdvancedSearch->SearchCondition = @$filter["v_remain"];
		$this->remain->AdvancedSearch->SearchValue2 = @$filter["y_remain"];
		$this->remain->AdvancedSearch->SearchOperator2 = @$filter["w_remain"];
		$this->remain->AdvancedSearch->Save();

		// Field total_allocated
		$this->total_allocated->AdvancedSearch->SearchValue = @$filter["x_total_allocated"];
		$this->total_allocated->AdvancedSearch->SearchOperator = @$filter["z_total_allocated"];
		$this->total_allocated->AdvancedSearch->SearchCondition = @$filter["v_total_allocated"];
		$this->total_allocated->AdvancedSearch->SearchValue2 = @$filter["y_total_allocated"];
		$this->total_allocated->AdvancedSearch->SearchOperator2 = @$filter["w_total_allocated"];
		$this->total_allocated->AdvancedSearch->Save();

		// Field total_remain
		$this->total_remain->AdvancedSearch->SearchValue = @$filter["x_total_remain"];
		$this->total_remain->AdvancedSearch->SearchOperator = @$filter["z_total_remain"];
		$this->total_remain->AdvancedSearch->SearchCondition = @$filter["v_total_remain"];
		$this->total_remain->AdvancedSearch->SearchValue2 = @$filter["y_total_remain"];
		$this->total_remain->AdvancedSearch->SearchOperator2 = @$filter["w_total_remain"];
		$this->total_remain->AdvancedSearch->Save();
	}

	// Advanced search WHERE clause based on QueryString
	function AdvancedSearchWhere($Default = FALSE) {
		global $Security;
		$sWhere = "";
		if (!$Security->CanSearch()) return "";
		$this->BuildSearchSql($sWhere, $this->dbkey_councilor, $Default, FALSE); // dbkey_councilor
		$this->BuildSearchSql($sWhere, $this->dbkey_client, $Default, FALSE); // dbkey_client
		$this->BuildSearchSql($sWhere, $this->date, $Default, FALSE); // date
		$this->BuildSearchSql($sWhere, $this->time, $Default, FALSE); // time
		$this->BuildSearchSql($sWhere, $this->comment, $Default, FALSE); // comment
		$this->BuildSearchSql($sWhere, $this->dbkey_activity, $Default, FALSE); // dbkey_activity
		$this->BuildSearchSql($sWhere, $this->attachment, $Default, FALSE); // attachment
		$this->BuildSearchSql($sWhere, $this->budget, $Default, FALSE); // budget
		$this->BuildSearchSql($sWhere, $this->allocated, $Default, FALSE); // allocated
		$this->BuildSearchSql($sWhere, $this->remain, $Default, FALSE); // remain
		$this->BuildSearchSql($sWhere, $this->total_allocated, $Default, FALSE); // total_allocated
		$this->BuildSearchSql($sWhere, $this->total_remain, $Default, FALSE); // total_remain

		// Set up search parm
		if (!$Default && $sWhere <> "") {
			$this->Command = "search";
		}
		if (!$Default && $this->Command == "search") {
			$this->dbkey_councilor->AdvancedSearch->Save(); // dbkey_councilor
			$this->dbkey_client->AdvancedSearch->Save(); // dbkey_client
			$this->date->AdvancedSearch->Save(); // date
			$this->time->AdvancedSearch->Save(); // time
			$this->comment->AdvancedSearch->Save(); // comment
			$this->dbkey_activity->AdvancedSearch->Save(); // dbkey_activity
			$this->attachment->AdvancedSearch->Save(); // attachment
			$this->budget->AdvancedSearch->Save(); // budget
			$this->allocated->AdvancedSearch->Save(); // allocated
			$this->remain->AdvancedSearch->Save(); // remain
			$this->total_allocated->AdvancedSearch->Save(); // total_allocated
			$this->total_remain->AdvancedSearch->Save(); // total_remain
		}
		return $sWhere;
	}

	// Build search SQL
	function BuildSearchSql(&$Where, &$Fld, $Default, $MultiValue) {
		$FldParm = substr($Fld->FldVar, 2);
		$FldVal = ($Default) ? $Fld->AdvancedSearch->SearchValueDefault : $Fld->AdvancedSearch->SearchValue; // @$_GET["x_$FldParm"]
		$FldOpr = ($Default) ? $Fld->AdvancedSearch->SearchOperatorDefault : $Fld->AdvancedSearch->SearchOperator; // @$_GET["z_$FldParm"]
		$FldCond = ($Default) ? $Fld->AdvancedSearch->SearchConditionDefault : $Fld->AdvancedSearch->SearchCondition; // @$_GET["v_$FldParm"]
		$FldVal2 = ($Default) ? $Fld->AdvancedSearch->SearchValue2Default : $Fld->AdvancedSearch->SearchValue2; // @$_GET["y_$FldParm"]
		$FldOpr2 = ($Default) ? $Fld->AdvancedSearch->SearchOperator2Default : $Fld->AdvancedSearch->SearchOperator2; // @$_GET["w_$FldParm"]
		$sWrk = "";

		//$FldVal = ew_StripSlashes($FldVal);
		if (is_array($FldVal)) $FldVal = implode(",", $FldVal);

		//$FldVal2 = ew_StripSlashes($FldVal2);
		if (is_array($FldVal2)) $FldVal2 = implode(",", $FldVal2);
		$FldOpr = strtoupper(trim($FldOpr));
		if ($FldOpr == "") $FldOpr = "=";
		$FldOpr2 = strtoupper(trim($FldOpr2));
		if ($FldOpr2 == "") $FldOpr2 = "=";
		if (EW_SEARCH_MULTI_VALUE_OPTION == 1 || $FldOpr <> "LIKE" ||
			($FldOpr2 <> "LIKE" && $FldVal2 <> ""))
			$MultiValue = FALSE;
		if ($MultiValue) {
			$sWrk1 = ($FldVal <> "") ? ew_GetMultiSearchSql($Fld, $FldOpr, $FldVal, $this->DBID) : ""; // Field value 1
			$sWrk2 = ($FldVal2 <> "") ? ew_GetMultiSearchSql($Fld, $FldOpr2, $FldVal2, $this->DBID) : ""; // Field value 2
			$sWrk = $sWrk1; // Build final SQL
			if ($sWrk2 <> "")
				$sWrk = ($sWrk <> "") ? "($sWrk) $FldCond ($sWrk2)" : $sWrk2;
		} else {
			$FldVal = $this->ConvertSearchValue($Fld, $FldVal);
			$FldVal2 = $this->ConvertSearchValue($Fld, $FldVal2);
			$sWrk = ew_GetSearchSql($Fld, $FldVal, $FldOpr, $FldCond, $FldVal2, $FldOpr2, $this->DBID);
		}
		ew_AddFilter($Where, $sWrk);
	}

	// Convert search value
	function ConvertSearchValue(&$Fld, $FldVal) {
		if ($FldVal == EW_NULL_VALUE || $FldVal == EW_NOT_NULL_VALUE)
			return $FldVal;
		$Value = $FldVal;
		if ($Fld->FldDataType == EW_DATATYPE_BOOLEAN) {
			if ($FldVal <> "") $Value = ($FldVal == "1" || strtolower(strval($FldVal)) == "y" || strtolower(strval($FldVal)) == "t") ? $Fld->TrueValue : $Fld->FalseValue;
		} elseif ($Fld->FldDataType == EW_DATATYPE_DATE) {
			if ($FldVal <> "") $Value = ew_UnFormatDateTime($FldVal, $Fld->FldDateTimeFormat);
		}
		return $Value;
	}

	// Check if search parm exists
	function CheckSearchParms() {
		if ($this->dbkey_councilor->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->dbkey_client->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->date->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->time->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->comment->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->dbkey_activity->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->attachment->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->budget->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->allocated->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->remain->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->total_allocated->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->total_remain->AdvancedSearch->IssetSession())
			return TRUE;
		return FALSE;
	}

	// Clear all search parameters
	function ResetSearchParms() {

		// Clear search WHERE clause
		$this->SearchWhere = "";
		$this->setSearchWhere($this->SearchWhere);

		// Clear advanced search parameters
		$this->ResetAdvancedSearchParms();
	}

	// Load advanced search default values
	function LoadAdvancedSearchDefault() {
		return FALSE;
	}

	// Clear all advanced search parameters
	function ResetAdvancedSearchParms() {
		$this->dbkey_councilor->AdvancedSearch->UnsetSession();
		$this->dbkey_client->AdvancedSearch->UnsetSession();
		$this->date->AdvancedSearch->UnsetSession();
		$this->time->AdvancedSearch->UnsetSession();
		$this->comment->AdvancedSearch->UnsetSession();
		$this->dbkey_activity->AdvancedSearch->UnsetSession();
		$this->attachment->AdvancedSearch->UnsetSession();
		$this->budget->AdvancedSearch->UnsetSession();
		$this->allocated->AdvancedSearch->UnsetSession();
		$this->remain->AdvancedSearch->UnsetSession();
		$this->total_allocated->AdvancedSearch->UnsetSession();
		$this->total_remain->AdvancedSearch->UnsetSession();
	}

	// Restore all search parameters
	function RestoreSearchParms() {
		$this->RestoreSearch = TRUE;

		// Restore advanced search values
		$this->dbkey_councilor->AdvancedSearch->Load();
		$this->dbkey_client->AdvancedSearch->Load();
		$this->date->AdvancedSearch->Load();
		$this->time->AdvancedSearch->Load();
		$this->comment->AdvancedSearch->Load();
		$this->dbkey_activity->AdvancedSearch->Load();
		$this->attachment->AdvancedSearch->Load();
		$this->budget->AdvancedSearch->Load();
		$this->allocated->AdvancedSearch->Load();
		$this->remain->AdvancedSearch->Load();
		$this->total_allocated->AdvancedSearch->Load();
		$this->total_remain->AdvancedSearch->Load();
	}

	// Set up sort parameters
	function SetUpSortOrder() {

		// Check for "order" parameter
		if (@$_GET["order"] <> "") {
			$this->CurrentOrder = ew_StripSlashes(@$_GET["order"]);
			$this->CurrentOrderType = @$_GET["ordertype"];
			$this->UpdateSort($this->dbkey_councilor); // dbkey_councilor
			$this->UpdateSort($this->dbkey_client); // dbkey_client
			$this->UpdateSort($this->date); // date
			$this->UpdateSort($this->time); // time
			$this->UpdateSort($this->dbkey_activity); // dbkey_activity
			$this->UpdateSort($this->attachment); // attachment
			$this->UpdateSort($this->budget); // budget
			$this->UpdateSort($this->allocated); // allocated
			$this->UpdateSort($this->remain); // remain
			$this->UpdateSort($this->total_allocated); // total_allocated
			$this->UpdateSort($this->total_remain); // total_remain
			$this->setStartRecordNumber(1); // Reset start position
		}
	}

	// Load sort order parameters
	function LoadSortOrder() {
		$sOrderBy = $this->getSessionOrderBy(); // Get ORDER BY from Session
		if ($sOrderBy == "") {
			if ($this->getSqlOrderBy() <> "") {
				$sOrderBy = $this->getSqlOrderBy();
				$this->setSessionOrderBy($sOrderBy);
			}
		}
	}

	// Reset command
	// - cmd=reset (Reset search parameters)
	// - cmd=resetall (Reset search and master/detail parameters)
	// - cmd=resetsort (Reset sort parameters)
	function ResetCmd() {

		// Check if reset command
		if (substr($this->Command,0,5) == "reset") {

			// Reset search criteria
			if ($this->Command == "reset" || $this->Command == "resetall")
				$this->ResetSearchParms();

			// Reset sorting order
			if ($this->Command == "resetsort") {
				$sOrderBy = "";
				$this->setSessionOrderBy($sOrderBy);
				$this->setSessionOrderByList($sOrderBy);
				$this->dbkey_councilor->setSort("");
				$this->dbkey_client->setSort("");
				$this->date->setSort("");
				$this->time->setSort("");
				$this->dbkey_activity->setSort("");
				$this->attachment->setSort("");
				$this->budget->setSort("");
				$this->allocated->setSort("");
				$this->remain->setSort("");
				$this->total_allocated->setSort("");
				$this->total_remain->setSort("");
			}

			// Reset start position
			$this->StartRec = 1;
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Set up list options
	function SetupListOptions() {
		global $Security, $Language;

		// Add group option item
		$item = &$this->ListOptions->Add($this->ListOptions->GroupOptionName);
		$item->Body = "";
		$item->OnLeft = FALSE;
		$item->Visible = FALSE;

		// List actions
		$item = &$this->ListOptions->Add("listactions");
		$item->CssStyle = "white-space: nowrap;";
		$item->OnLeft = FALSE;
		$item->Visible = FALSE;
		$item->ShowInButtonGroup = FALSE;
		$item->ShowInDropDown = FALSE;

		// "checkbox"
		$item = &$this->ListOptions->Add("checkbox");
		$item->Visible = FALSE;
		$item->OnLeft = FALSE;
		$item->Header = "<input type=\"checkbox\" name=\"key\" id=\"key\" onclick=\"ew_SelectAllKey(this);\">";
		$item->ShowInDropDown = FALSE;
		$item->ShowInButtonGroup = FALSE;

		// Drop down button for ListOptions
		$this->ListOptions->UseImageAndText = TRUE;
		$this->ListOptions->UseDropDownButton = FALSE;
		$this->ListOptions->DropDownButtonPhrase = $Language->Phrase("ButtonListOptions");
		$this->ListOptions->UseButtonGroup = FALSE;
		if ($this->ListOptions->UseButtonGroup && ew_IsMobile())
			$this->ListOptions->UseDropDownButton = TRUE;
		$this->ListOptions->ButtonClass = "btn-sm"; // Class for button group

		// Call ListOptions_Load event
		$this->ListOptions_Load();
		$this->SetupListOptionsExt();
		$item = &$this->ListOptions->GetItem($this->ListOptions->GroupOptionName);
		$item->Visible = $this->ListOptions->GroupOptionVisible();
	}

	// Render list options
	function RenderListOptions() {
		global $Security, $Language, $objForm;
		$this->ListOptions->LoadDefault();

		// Set up list action buttons
		$oListOpt = &$this->ListOptions->GetItem("listactions");
		if ($oListOpt && $this->Export == "" && $this->CurrentAction == "") {
			$body = "";
			$links = array();
			foreach ($this->ListActions->Items as $listaction) {
				if ($listaction->Select == EW_ACTION_SINGLE && $listaction->Allow) {
					$action = $listaction->Action;
					$caption = $listaction->Caption;
					$icon = ($listaction->Icon <> "") ? "<span class=\"" . ew_HtmlEncode(str_replace(" ewIcon", "", $listaction->Icon)) . "\" data-caption=\"" . ew_HtmlTitle($caption) . "\"></span> " : "";
					$links[] = "<li><a class=\"ewAction ewListAction\" data-action=\"" . ew_HtmlEncode($action) . "\" data-caption=\"" . ew_HtmlTitle($caption) . "\" href=\"\" onclick=\"ew_SubmitAction(event,jQuery.extend({key:" . $this->KeyToJson() . "}," . $listaction->ToJson(TRUE) . "));return false;\">" . $icon . $listaction->Caption . "</a></li>";
					if (count($links) == 1) // Single button
						$body = "<a class=\"ewAction ewListAction\" data-action=\"" . ew_HtmlEncode($action) . "\" title=\"" . ew_HtmlTitle($caption) . "\" data-caption=\"" . ew_HtmlTitle($caption) . "\" href=\"\" onclick=\"ew_SubmitAction(event,jQuery.extend({key:" . $this->KeyToJson() . "}," . $listaction->ToJson(TRUE) . "));return false;\">" . $Language->Phrase("ListActionButton") . "</a>";
				}
			}
			if (count($links) > 1) { // More than one buttons, use dropdown
				$body = "<button class=\"dropdown-toggle btn btn-default btn-sm ewActions\" title=\"" . ew_HtmlTitle($Language->Phrase("ListActionButton")) . "\" data-toggle=\"dropdown\">" . $Language->Phrase("ListActionButton") . "<b class=\"caret\"></b></button>";
				$content = "";
				foreach ($links as $link)
					$content .= "<li>" . $link . "</li>";
				$body .= "<ul class=\"dropdown-menu" . ($oListOpt->OnLeft ? "" : " dropdown-menu-right") . "\">". $content . "</ul>";
				$body = "<div class=\"btn-group\">" . $body . "</div>";
			}
			if (count($links) > 0) {
				$oListOpt->Body = $body;
				$oListOpt->Visible = TRUE;
			}
		}

		// "checkbox"
		$oListOpt = &$this->ListOptions->Items["checkbox"];
		$this->RenderListOptionsExt();

		// Call ListOptions_Rendered event
		$this->ListOptions_Rendered();
	}

	// Set up other options
	function SetupOtherOptions() {
		global $Language, $Security;
		$options = &$this->OtherOptions;
		$option = $options["action"];

		// Set up options default
		foreach ($options as &$option) {
			$option->UseImageAndText = TRUE;
			$option->UseDropDownButton = FALSE;
			$option->UseButtonGroup = TRUE;
			$option->ButtonClass = "btn-sm"; // Class for button group
			$item = &$option->Add($option->GroupOptionName);
			$item->Body = "";
			$item->Visible = FALSE;
		}
		$options["addedit"]->DropDownButtonPhrase = $Language->Phrase("ButtonAddEdit");
		$options["detail"]->DropDownButtonPhrase = $Language->Phrase("ButtonDetails");
		$options["action"]->DropDownButtonPhrase = $Language->Phrase("ButtonActions");

		// Filter button
		$item = &$this->FilterOptions->Add("savecurrentfilter");
		$item->Body = "<a class=\"ewSaveFilter\" data-form=\"fCust_Client_Activity2listsrch\" href=\"#\">" . $Language->Phrase("SaveCurrentFilter") . "</a>";
		$item->Visible = TRUE;
		$item = &$this->FilterOptions->Add("deletefilter");
		$item->Body = "<a class=\"ewDeleteFilter\" data-form=\"fCust_Client_Activity2listsrch\" href=\"#\">" . $Language->Phrase("DeleteFilter") . "</a>";
		$item->Visible = TRUE;
		$this->FilterOptions->UseDropDownButton = TRUE;
		$this->FilterOptions->UseButtonGroup = !$this->FilterOptions->UseDropDownButton;
		$this->FilterOptions->DropDownButtonPhrase = $Language->Phrase("Filters");

		// Add group option item
		$item = &$this->FilterOptions->Add($this->FilterOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;
	}

	// Render other options
	function RenderOtherOptions() {
		global $Language, $Security;
		$options = &$this->OtherOptions;
			$option = &$options["action"];

			// Set up list action buttons
			foreach ($this->ListActions->Items as $listaction) {
				if ($listaction->Select == EW_ACTION_MULTIPLE) {
					$item = &$option->Add("custom_" . $listaction->Action);
					$caption = $listaction->Caption;
					$icon = ($listaction->Icon <> "") ? "<span class=\"" . ew_HtmlEncode($listaction->Icon) . "\" data-caption=\"" . ew_HtmlEncode($caption) . "\"></span> " : $caption;
					$item->Body = "<a class=\"ewAction ewListAction\" title=\"" . ew_HtmlEncode($caption) . "\" data-caption=\"" . ew_HtmlEncode($caption) . "\" href=\"\" onclick=\"ew_SubmitAction(event,jQuery.extend({f:document.fCust_Client_Activity2list}," . $listaction->ToJson(TRUE) . "));return false;\">" . $icon . "</a>";
					$item->Visible = $listaction->Allow;
				}
			}

			// Hide grid edit and other options
			if ($this->TotalRecs <= 0) {
				$option = &$options["addedit"];
				$item = &$option->GetItem("gridedit");
				if ($item) $item->Visible = FALSE;
				$option = &$options["action"];
				$option->HideAllOptions();
			}
	}

	// Process list action
	function ProcessListAction() {
		global $Language, $Security;
		$userlist = "";
		$user = "";
		$sFilter = $this->GetKeyFilter();
		$UserAction = @$_POST["useraction"];
		if ($sFilter <> "" && $UserAction <> "") {

			// Check permission first
			$ActionCaption = $UserAction;
			if (array_key_exists($UserAction, $this->ListActions->Items)) {
				$ActionCaption = $this->ListActions->Items[$UserAction]->Caption;
				if (!$this->ListActions->Items[$UserAction]->Allow) {
					$errmsg = str_replace('%s', $ActionCaption, $Language->Phrase("CustomActionNotAllowed"));
					if (@$_POST["ajax"] == $UserAction) // Ajax
						echo "<p class=\"text-danger\">" . $errmsg . "</p>";
					else
						$this->setFailureMessage($errmsg);
					return FALSE;
				}
			}
			$this->CurrentFilter = $sFilter;
			$sSql = $this->SQL();
			$conn = &$this->Connection();
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			$rs = $conn->Execute($sSql);
			$conn->raiseErrorFn = '';
			$this->CurrentAction = $UserAction;

			// Call row action event
			if ($rs && !$rs->EOF) {
				$conn->BeginTrans();
				$this->SelectedCount = $rs->RecordCount();
				$this->SelectedIndex = 0;
				while (!$rs->EOF) {
					$this->SelectedIndex++;
					$row = $rs->fields;
					$Processed = $this->Row_CustomAction($UserAction, $row);
					if (!$Processed) break;
					$rs->MoveNext();
				}
				if ($Processed) {
					$conn->CommitTrans(); // Commit the changes
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage(str_replace('%s', $ActionCaption, $Language->Phrase("CustomActionCompleted"))); // Set up success message
				} else {
					$conn->RollbackTrans(); // Rollback changes

					// Set up error message
					if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

						// Use the message, do nothing
					} elseif ($this->CancelMessage <> "") {
						$this->setFailureMessage($this->CancelMessage);
						$this->CancelMessage = "";
					} else {
						$this->setFailureMessage(str_replace('%s', $ActionCaption, $Language->Phrase("CustomActionFailed")));
					}
				}
			}
			if ($rs)
				$rs->Close();
			$this->CurrentAction = ""; // Clear action
			if (@$_POST["ajax"] == $UserAction) { // Ajax
				if ($this->getSuccessMessage() <> "") {
					echo "<p class=\"text-success\">" . $this->getSuccessMessage() . "</p>";
					$this->ClearSuccessMessage(); // Clear message
				}
				if ($this->getFailureMessage() <> "") {
					echo "<p class=\"text-danger\">" . $this->getFailureMessage() . "</p>";
					$this->ClearFailureMessage(); // Clear message
				}
				return TRUE;
			}
		}
		return FALSE; // Not ajax request
	}

	// Set up search options
	function SetupSearchOptions() {
		global $Language;
		$this->SearchOptions = new cListOptions();
		$this->SearchOptions->Tag = "div";
		$this->SearchOptions->TagClassName = "ewSearchOption";

		// Search button
		$item = &$this->SearchOptions->Add("searchtoggle");
		$SearchToggleClass = ($this->SearchWhere <> "") ? " active" : " active";
		$item->Body = "<button type=\"button\" class=\"btn btn-default ewSearchToggle" . $SearchToggleClass . "\" title=\"" . $Language->Phrase("SearchPanel") . "\" data-caption=\"" . $Language->Phrase("SearchPanel") . "\" data-toggle=\"button\" data-form=\"fCust_Client_Activity2listsrch\">" . $Language->Phrase("SearchBtn") . "</button>";
		$item->Visible = TRUE;

		// Show all button
		$item = &$this->SearchOptions->Add("showall");
		$item->Body = "<a class=\"btn btn-default ewShowAll\" title=\"" . $Language->Phrase("ShowAll") . "\" data-caption=\"" . $Language->Phrase("ShowAll") . "\" href=\"" . $this->PageUrl() . "cmd=reset\">" . $Language->Phrase("ShowAllBtn") . "</a>";
		$item->Visible = ($this->SearchWhere <> $this->DefaultSearchWhere && $this->SearchWhere <> "0=101");

		// Button group for search
		$this->SearchOptions->UseDropDownButton = FALSE;
		$this->SearchOptions->UseImageAndText = TRUE;
		$this->SearchOptions->UseButtonGroup = TRUE;
		$this->SearchOptions->DropDownButtonPhrase = $Language->Phrase("ButtonSearch");

		// Add group option item
		$item = &$this->SearchOptions->Add($this->SearchOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;

		// Hide search options
		if ($this->Export <> "" || $this->CurrentAction <> "")
			$this->SearchOptions->HideAllOptions();
		global $Security;
		if (!$Security->CanSearch()) {
			$this->SearchOptions->HideAllOptions();
			$this->FilterOptions->HideAllOptions();
		}
	}

	function SetupListOptionsExt() {
		global $Security, $Language;
	}

	function RenderListOptionsExt() {
		global $Security, $Language;
	}

	// Set up starting record parameters
	function SetUpStartRec() {
		if ($this->DisplayRecs == 0)
			return;
		if ($this->IsPageRequest()) { // Validate request
			if (@$_GET[EW_TABLE_START_REC] <> "") { // Check for "start" parameter
				$this->StartRec = $_GET[EW_TABLE_START_REC];
				$this->setStartRecordNumber($this->StartRec);
			} elseif (@$_GET[EW_TABLE_PAGE_NO] <> "") {
				$PageNo = $_GET[EW_TABLE_PAGE_NO];
				if (is_numeric($PageNo)) {
					$this->StartRec = ($PageNo-1)*$this->DisplayRecs+1;
					if ($this->StartRec <= 0) {
						$this->StartRec = 1;
					} elseif ($this->StartRec >= intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1) {
						$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1;
					}
					$this->setStartRecordNumber($this->StartRec);
				}
			}
		}
		$this->StartRec = $this->getStartRecordNumber();

		// Check if correct start record counter
		if (!is_numeric($this->StartRec) || $this->StartRec == "") { // Avoid invalid start record counter
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} elseif (intval($this->StartRec) > intval($this->TotalRecs)) { // Avoid starting record > total records
			$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to last page first record
			$this->setStartRecordNumber($this->StartRec);
		} elseif (($this->StartRec-1) % $this->DisplayRecs <> 0) {
			$this->StartRec = intval(($this->StartRec-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to page boundary
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Load search values for validation
	function LoadSearchValues() {
		global $objForm;

		// Load search values
		// dbkey_councilor

		$this->dbkey_councilor->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_dbkey_councilor"]);
		if ($this->dbkey_councilor->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->dbkey_councilor->AdvancedSearch->SearchOperator = @$_GET["z_dbkey_councilor"];

		// dbkey_client
		$this->dbkey_client->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_dbkey_client"]);
		if ($this->dbkey_client->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->dbkey_client->AdvancedSearch->SearchOperator = @$_GET["z_dbkey_client"];

		// date
		$this->date->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_date"]);
		if ($this->date->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->date->AdvancedSearch->SearchOperator = @$_GET["z_date"];
		$this->date->AdvancedSearch->SearchCondition = @$_GET["v_date"];
		$this->date->AdvancedSearch->SearchValue2 = ew_StripSlashes(@$_GET["y_date"]);
		if ($this->date->AdvancedSearch->SearchValue2 <> "") $this->Command = "search";
		$this->date->AdvancedSearch->SearchOperator2 = @$_GET["w_date"];

		// time
		$this->time->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_time"]);
		if ($this->time->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->time->AdvancedSearch->SearchOperator = @$_GET["z_time"];

		// comment
		$this->comment->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_comment"]);
		if ($this->comment->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->comment->AdvancedSearch->SearchOperator = @$_GET["z_comment"];

		// dbkey_activity
		$this->dbkey_activity->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_dbkey_activity"]);
		if ($this->dbkey_activity->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->dbkey_activity->AdvancedSearch->SearchOperator = @$_GET["z_dbkey_activity"];

		// attachment
		$this->attachment->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_attachment"]);
		if ($this->attachment->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->attachment->AdvancedSearch->SearchOperator = @$_GET["z_attachment"];

		// budget
		$this->budget->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_budget"]);
		if ($this->budget->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->budget->AdvancedSearch->SearchOperator = @$_GET["z_budget"];

		// allocated
		$this->allocated->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_allocated"]);
		if ($this->allocated->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->allocated->AdvancedSearch->SearchOperator = @$_GET["z_allocated"];

		// remain
		$this->remain->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_remain"]);
		if ($this->remain->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->remain->AdvancedSearch->SearchOperator = @$_GET["z_remain"];

		// total_allocated
		$this->total_allocated->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_total_allocated"]);
		if ($this->total_allocated->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->total_allocated->AdvancedSearch->SearchOperator = @$_GET["z_total_allocated"];

		// total_remain
		$this->total_remain->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_total_remain"]);
		if ($this->total_remain->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->total_remain->AdvancedSearch->SearchOperator = @$_GET["z_total_remain"];
	}

	// Load recordset
	function LoadRecordset($offset = -1, $rowcnt = -1) {

		// Load List page SQL
		$sSql = $this->SelectSQL();
		$conn = &$this->Connection();

		// Load recordset
		$dbtype = ew_GetConnectionType($this->DBID);
		if ($this->UseSelectLimit) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			if ($dbtype == "MSSQL") {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset, array("_hasOrderBy" => trim($this->getOrderBy()) || trim($this->getSessionOrderByList())));
			} else {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset);
			}
			$conn->raiseErrorFn = '';
		} else {
			$rs = ew_LoadRecordset($sSql, $conn);
		}

		// Call Recordset Selected event
		$this->Recordset_Selected($rs);
		return $rs;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->dbkey_councilor->setDbValue($rs->fields('dbkey_councilor'));
		if (array_key_exists('EV__dbkey_councilor', $rs->fields)) {
			$this->dbkey_councilor->VirtualValue = $rs->fields('EV__dbkey_councilor'); // Set up virtual field value
		} else {
			$this->dbkey_councilor->VirtualValue = ""; // Clear value
		}
		$this->dbkey_client->setDbValue($rs->fields('dbkey_client'));
		if (array_key_exists('EV__dbkey_client', $rs->fields)) {
			$this->dbkey_client->VirtualValue = $rs->fields('EV__dbkey_client'); // Set up virtual field value
		} else {
			$this->dbkey_client->VirtualValue = ""; // Clear value
		}
		$this->date->setDbValue($rs->fields('date'));
		$this->time->setDbValue($rs->fields('time'));
		$this->comment->setDbValue($rs->fields('comment'));
		$this->dbkey_activity->setDbValue($rs->fields('dbkey_activity'));
		if (array_key_exists('EV__dbkey_activity', $rs->fields)) {
			$this->dbkey_activity->VirtualValue = $rs->fields('EV__dbkey_activity'); // Set up virtual field value
		} else {
			$this->dbkey_activity->VirtualValue = ""; // Clear value
		}
		$this->attachment->Upload->DbValue = $rs->fields('attachment');
		$this->attachment->CurrentValue = $this->attachment->Upload->DbValue;
		$this->counselor->setDbValue($rs->fields('counselor'));
		$this->budget->setDbValue($rs->fields('budget'));
		$this->allocated->setDbValue($rs->fields('allocated'));
		$this->remain->setDbValue($rs->fields('remain'));
		$this->total_allocated->setDbValue($rs->fields('total_allocated'));
		$this->total_remain->setDbValue($rs->fields('total_remain'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey->DbValue = $row['dbkey'];
		$this->dbkey_councilor->DbValue = $row['dbkey_councilor'];
		$this->dbkey_client->DbValue = $row['dbkey_client'];
		$this->date->DbValue = $row['date'];
		$this->time->DbValue = $row['time'];
		$this->comment->DbValue = $row['comment'];
		$this->dbkey_activity->DbValue = $row['dbkey_activity'];
		$this->attachment->Upload->DbValue = $row['attachment'];
		$this->counselor->DbValue = $row['counselor'];
		$this->budget->DbValue = $row['budget'];
		$this->allocated->DbValue = $row['allocated'];
		$this->remain->DbValue = $row['remain'];
		$this->total_allocated->DbValue = $row['total_allocated'];
		$this->total_remain->DbValue = $row['total_remain'];
	}

	// Load old record
	function LoadOldRecord() {

		// Load key values from Session
		$bValidKey = TRUE;

		// Load old recordset
		if ($bValidKey) {
			$this->CurrentFilter = $this->KeyFilter();
			$sSql = $this->SQL();
			$conn = &$this->Connection();
			$this->OldRecordset = ew_LoadRecordset($sSql, $conn);
			$this->LoadRowValues($this->OldRecordset); // Load row values
		} else {
			$this->OldRecordset = NULL;
		}
		return $bValidKey;
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		$this->ViewUrl = $this->GetViewUrl();
		$this->EditUrl = $this->GetEditUrl();
		$this->InlineEditUrl = $this->GetInlineEditUrl();
		$this->CopyUrl = $this->GetCopyUrl();
		$this->InlineCopyUrl = $this->GetInlineCopyUrl();
		$this->DeleteUrl = $this->GetDeleteUrl();

		// Convert decimal values if posted back
		if ($this->time->FormValue == $this->time->CurrentValue && is_numeric(ew_StrToFloat($this->time->CurrentValue)))
			$this->time->CurrentValue = ew_StrToFloat($this->time->CurrentValue);

		// Convert decimal values if posted back
		if ($this->budget->FormValue == $this->budget->CurrentValue && is_numeric(ew_StrToFloat($this->budget->CurrentValue)))
			$this->budget->CurrentValue = ew_StrToFloat($this->budget->CurrentValue);

		// Convert decimal values if posted back
		if ($this->allocated->FormValue == $this->allocated->CurrentValue && is_numeric(ew_StrToFloat($this->allocated->CurrentValue)))
			$this->allocated->CurrentValue = ew_StrToFloat($this->allocated->CurrentValue);

		// Convert decimal values if posted back
		if ($this->remain->FormValue == $this->remain->CurrentValue && is_numeric(ew_StrToFloat($this->remain->CurrentValue)))
			$this->remain->CurrentValue = ew_StrToFloat($this->remain->CurrentValue);

		// Convert decimal values if posted back
		if ($this->total_allocated->FormValue == $this->total_allocated->CurrentValue && is_numeric(ew_StrToFloat($this->total_allocated->CurrentValue)))
			$this->total_allocated->CurrentValue = ew_StrToFloat($this->total_allocated->CurrentValue);

		// Convert decimal values if posted back
		if ($this->total_remain->FormValue == $this->total_remain->CurrentValue && is_numeric(ew_StrToFloat($this->total_remain->CurrentValue)))
			$this->total_remain->CurrentValue = ew_StrToFloat($this->total_remain->CurrentValue);

		// Call Row_Rendering event
		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey

		$this->dbkey->CellCssStyle = "white-space: nowrap;";

		// dbkey_councilor
		$this->dbkey_councilor->CellCssStyle = "white-space: nowrap;";

		// dbkey_client
		$this->dbkey_client->CellCssStyle = "white-space: nowrap;";

		// date
		// time
		// comment
		// dbkey_activity
		// attachment

		$this->attachment->CellCssStyle = "white-space: nowrap;";

		// counselor
		$this->counselor->CellCssStyle = "white-space: nowrap;";

		// budget
		// allocated
		// remain
		// total_allocated
		// total_remain
		// Accumulate aggregate value

		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT && $this->RowType <> EW_ROWTYPE_AGGREGATE) {
			if (is_numeric($this->time->CurrentValue))
				$this->time->Total += $this->time->CurrentValue; // Accumulate total
		}
		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// dbkey
		$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// dbkey_councilor
		if ($this->dbkey_councilor->VirtualValue <> "") {
			$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->VirtualValue;
		} else {
		if (strval($this->dbkey_councilor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_councilor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->CurrentValue;
			}
		} else {
			$this->dbkey_councilor->ViewValue = NULL;
		}
		}
		$this->dbkey_councilor->ViewCustomAttributes = "";

		// dbkey_client
		if ($this->dbkey_client->VirtualValue <> "") {
			$this->dbkey_client->ViewValue = $this->dbkey_client->VirtualValue;
		} else {
		if (strval($this->dbkey_client->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		$lookuptblfilter = "`active` = 1";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_client->ViewValue = $this->dbkey_client->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_client->ViewValue = $this->dbkey_client->CurrentValue;
			}
		} else {
			$this->dbkey_client->ViewValue = NULL;
		}
		}
		$this->dbkey_client->ViewCustomAttributes = "";

		// date
		$this->date->ViewValue = $this->date->CurrentValue;
		$this->date->ViewValue = ew_FormatDateTime($this->date->ViewValue, 9);
		$this->date->ViewCustomAttributes = "";

		// time
		$this->time->ViewValue = $this->time->CurrentValue;
		$this->time->ViewCustomAttributes = "";

		// comment
		$this->comment->ViewValue = $this->comment->CurrentValue;
		$this->comment->ViewCustomAttributes = "";

		// dbkey_activity
		if ($this->dbkey_activity->VirtualValue <> "") {
			$this->dbkey_activity->ViewValue = $this->dbkey_activity->VirtualValue;
		} else {
		if (strval($this->dbkey_activity->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_activity->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `activity`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `description`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->CurrentValue;
			}
		} else {
			$this->dbkey_activity->ViewValue = NULL;
		}
		}
		$this->dbkey_activity->ViewCustomAttributes = "";

		// attachment
		if (!ew_Empty($this->attachment->Upload->DbValue)) {
			$this->attachment->ViewValue = $this->attachment->Upload->DbValue;
		} else {
			$this->attachment->ViewValue = "";
		}
		$this->attachment->ViewCustomAttributes = "";

		// budget
		$this->budget->ViewValue = $this->budget->CurrentValue;
		$this->budget->ViewCustomAttributes = "";

		// allocated
		$this->allocated->ViewValue = $this->allocated->CurrentValue;
		$this->allocated->ViewCustomAttributes = "";

		// remain
		$this->remain->ViewValue = $this->remain->CurrentValue;
		$this->remain->CellCssStyle .= "text-align: left;";
		$this->remain->ViewCustomAttributes = "";

		// total_allocated
		$this->total_allocated->ViewValue = $this->total_allocated->CurrentValue;
		$this->total_allocated->ViewCustomAttributes = "";

		// total_remain
		$this->total_remain->ViewValue = $this->total_remain->CurrentValue;
		$this->total_remain->ViewCustomAttributes = "";

			// dbkey_councilor
			$this->dbkey_councilor->LinkCustomAttributes = "";
			$this->dbkey_councilor->HrefValue = "";
			$this->dbkey_councilor->TooltipValue = "";

			// dbkey_client
			$this->dbkey_client->LinkCustomAttributes = "";
			$this->dbkey_client->HrefValue = "";
			$this->dbkey_client->TooltipValue = "";

			// date
			$this->date->LinkCustomAttributes = "";
			$this->date->HrefValue = "";
			$this->date->TooltipValue = "";

			// time
			$this->time->LinkCustomAttributes = "";
			$this->time->HrefValue = "";
			$this->time->TooltipValue = "";

			// dbkey_activity
			$this->dbkey_activity->LinkCustomAttributes = "";
			$this->dbkey_activity->HrefValue = "";
			$this->dbkey_activity->TooltipValue = "";

			// attachment
			$this->attachment->LinkCustomAttributes = "";
			$this->attachment->HrefValue = "";
			$this->attachment->HrefValue2 = $this->attachment->UploadPath . $this->attachment->Upload->DbValue;
			$this->attachment->TooltipValue = "";

			// budget
			$this->budget->LinkCustomAttributes = "";
			$this->budget->HrefValue = "";
			$this->budget->TooltipValue = "";

			// allocated
			$this->allocated->LinkCustomAttributes = "";
			$this->allocated->HrefValue = "";
			$this->allocated->TooltipValue = "";

			// remain
			$this->remain->LinkCustomAttributes = "";
			$this->remain->HrefValue = "";
			$this->remain->TooltipValue = "";

			// total_allocated
			$this->total_allocated->LinkCustomAttributes = "";
			$this->total_allocated->HrefValue = "";
			$this->total_allocated->TooltipValue = "";

			// total_remain
			$this->total_remain->LinkCustomAttributes = "";
			$this->total_remain->HrefValue = "";
			$this->total_remain->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_SEARCH) { // Search row

			// dbkey_councilor
			$this->dbkey_councilor->EditAttrs["class"] = "form-control";
			$this->dbkey_councilor->EditCustomAttributes = "";
			$this->dbkey_councilor->EditValue = ew_HtmlEncode($this->dbkey_councilor->AdvancedSearch->SearchValue);
			$this->dbkey_councilor->PlaceHolder = ew_RemoveHtml($this->dbkey_councilor->FldCaption());

			// dbkey_client
			$this->dbkey_client->EditAttrs["class"] = "form-control";
			$this->dbkey_client->EditCustomAttributes = "";
			$this->dbkey_client->EditValue = ew_HtmlEncode($this->dbkey_client->AdvancedSearch->SearchValue);
			$this->dbkey_client->PlaceHolder = ew_RemoveHtml($this->dbkey_client->FldCaption());

			// date
			$this->date->EditAttrs["class"] = "form-control";
			$this->date->EditCustomAttributes = "";
			$this->date->EditValue = ew_HtmlEncode(ew_FormatDateTime(ew_UnFormatDateTime($this->date->AdvancedSearch->SearchValue, 9), 9));
			$this->date->PlaceHolder = ew_RemoveHtml($this->date->FldCaption());
			$this->date->EditAttrs["class"] = "form-control";
			$this->date->EditCustomAttributes = "";
			$this->date->EditValue2 = ew_HtmlEncode(ew_FormatDateTime(ew_UnFormatDateTime($this->date->AdvancedSearch->SearchValue2, 9), 9));
			$this->date->PlaceHolder = ew_RemoveHtml($this->date->FldCaption());

			// time
			$this->time->EditAttrs["class"] = "form-control";
			$this->time->EditCustomAttributes = "";
			$this->time->EditValue = ew_HtmlEncode($this->time->AdvancedSearch->SearchValue);
			$this->time->PlaceHolder = ew_RemoveHtml($this->time->FldCaption());

			// dbkey_activity
			$this->dbkey_activity->EditAttrs["class"] = "form-control";
			$this->dbkey_activity->EditCustomAttributes = "";
			$this->dbkey_activity->EditValue = ew_HtmlEncode($this->dbkey_activity->AdvancedSearch->SearchValue);
			$this->dbkey_activity->PlaceHolder = ew_RemoveHtml($this->dbkey_activity->FldCaption());

			// attachment
			$this->attachment->EditAttrs["class"] = "form-control";
			$this->attachment->EditCustomAttributes = "";
			$this->attachment->EditValue = ew_HtmlEncode($this->attachment->AdvancedSearch->SearchValue);
			$this->attachment->PlaceHolder = ew_RemoveHtml($this->attachment->FldCaption());

			// budget
			$this->budget->EditAttrs["class"] = "form-control";
			$this->budget->EditCustomAttributes = "";
			$this->budget->EditValue = ew_HtmlEncode($this->budget->AdvancedSearch->SearchValue);
			$this->budget->PlaceHolder = ew_RemoveHtml($this->budget->FldCaption());

			// allocated
			$this->allocated->EditAttrs["class"] = "form-control";
			$this->allocated->EditCustomAttributes = "";
			$this->allocated->EditValue = ew_HtmlEncode($this->allocated->AdvancedSearch->SearchValue);
			$this->allocated->PlaceHolder = ew_RemoveHtml($this->allocated->FldCaption());

			// remain
			$this->remain->EditAttrs["class"] = "form-control";
			$this->remain->EditCustomAttributes = "";
			$this->remain->EditValue = ew_HtmlEncode($this->remain->AdvancedSearch->SearchValue);
			$this->remain->PlaceHolder = ew_RemoveHtml($this->remain->FldCaption());

			// total_allocated
			$this->total_allocated->EditAttrs["class"] = "form-control";
			$this->total_allocated->EditCustomAttributes = "";
			$this->total_allocated->EditValue = ew_HtmlEncode($this->total_allocated->AdvancedSearch->SearchValue);
			$this->total_allocated->PlaceHolder = ew_RemoveHtml($this->total_allocated->FldCaption());

			// total_remain
			$this->total_remain->EditAttrs["class"] = "form-control";
			$this->total_remain->EditCustomAttributes = "";
			$this->total_remain->EditValue = ew_HtmlEncode($this->total_remain->AdvancedSearch->SearchValue);
			$this->total_remain->PlaceHolder = ew_RemoveHtml($this->total_remain->FldCaption());
		} elseif ($this->RowType == EW_ROWTYPE_AGGREGATEINIT) { // Initialize aggregate row
			$this->time->Total = 0; // Initialize total
		} elseif ($this->RowType == EW_ROWTYPE_AGGREGATE) { // Aggregate row
			$this->time->CurrentValue = $this->time->Total;
			$this->time->ViewValue = $this->time->CurrentValue;
			$this->time->ViewCustomAttributes = "";
			$this->time->HrefValue = ""; // Clear href value
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate search
	function ValidateSearch() {
		global $gsSearchError;

		// Initialize
		$gsSearchError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return TRUE;
		if (!ew_CheckDate($this->date->AdvancedSearch->SearchValue)) {
			ew_AddMessage($gsSearchError, $this->date->FldErrMsg());
		}
		if (!ew_CheckDate($this->date->AdvancedSearch->SearchValue2)) {
			ew_AddMessage($gsSearchError, $this->date->FldErrMsg());
		}

		// Return validate result
		$ValidateSearch = ($gsSearchError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateSearch = $ValidateSearch && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsSearchError, $sFormCustomError);
		}
		return $ValidateSearch;
	}

	// Load advanced search
	function LoadAdvancedSearch() {
		$this->dbkey_councilor->AdvancedSearch->Load();
		$this->dbkey_client->AdvancedSearch->Load();
		$this->date->AdvancedSearch->Load();
		$this->time->AdvancedSearch->Load();
		$this->comment->AdvancedSearch->Load();
		$this->dbkey_activity->AdvancedSearch->Load();
		$this->attachment->AdvancedSearch->Load();
		$this->budget->AdvancedSearch->Load();
		$this->allocated->AdvancedSearch->Load();
		$this->remain->AdvancedSearch->Load();
		$this->total_allocated->AdvancedSearch->Load();
		$this->total_remain->AdvancedSearch->Load();
	}

	// Set up export options
	function SetupExportOptions() {
		global $Language;

		// Printer friendly
		$item = &$this->ExportOptions->Add("print");
		$item->Body = "<a href=\"" . $this->ExportPrintUrl . "\" class=\"ewExportLink ewPrint\" title=\"" . ew_HtmlEncode($Language->Phrase("PrinterFriendlyText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("PrinterFriendlyText")) . "\">" . $Language->Phrase("PrinterFriendly") . "</a>";
		$item->Visible = TRUE;

		// Export to Excel
		$item = &$this->ExportOptions->Add("excel");
		$item->Body = "<a href=\"" . $this->ExportExcelUrl . "\" class=\"ewExportLink ewExcel\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToExcelText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToExcelText")) . "\">" . $Language->Phrase("ExportToExcel") . "</a>";
		$item->Visible = TRUE;

		// Export to Word
		$item = &$this->ExportOptions->Add("word");
		$item->Body = "<a href=\"" . $this->ExportWordUrl . "\" class=\"ewExportLink ewWord\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToWordText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToWordText")) . "\">" . $Language->Phrase("ExportToWord") . "</a>";
		$item->Visible = TRUE;

		// Export to Html
		$item = &$this->ExportOptions->Add("html");
		$item->Body = "<a href=\"" . $this->ExportHtmlUrl . "\" class=\"ewExportLink ewHtml\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToHtmlText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToHtmlText")) . "\">" . $Language->Phrase("ExportToHtml") . "</a>";
		$item->Visible = TRUE;

		// Export to Xml
		$item = &$this->ExportOptions->Add("xml");
		$item->Body = "<a href=\"" . $this->ExportXmlUrl . "\" class=\"ewExportLink ewXml\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToXmlText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToXmlText")) . "\">" . $Language->Phrase("ExportToXml") . "</a>";
		$item->Visible = FALSE;

		// Export to Csv
		$item = &$this->ExportOptions->Add("csv");
		$item->Body = "<a href=\"" . $this->ExportCsvUrl . "\" class=\"ewExportLink ewCsv\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToCsvText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToCsvText")) . "\">" . $Language->Phrase("ExportToCsv") . "</a>";
		$item->Visible = TRUE;

		// Export to Pdf
		$item = &$this->ExportOptions->Add("pdf");
		$item->Body = "<a href=\"" . $this->ExportPdfUrl . "\" class=\"ewExportLink ewPdf\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToPDFText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToPDFText")) . "\">" . $Language->Phrase("ExportToPDF") . "</a>";
		$item->Visible = FALSE;

		// Export to Email
		$item = &$this->ExportOptions->Add("email");
		$url = "";
		$item->Body = "<button id=\"emf_Cust_Client_Activity2\" class=\"ewExportLink ewEmail\" title=\"" . $Language->Phrase("ExportToEmailText") . "\" data-caption=\"" . $Language->Phrase("ExportToEmailText") . "\" onclick=\"ew_EmailDialogShow({lnk:'emf_Cust_Client_Activity2',hdr:ewLanguage.Phrase('ExportToEmailText'),f:document.fCust_Client_Activity2list,sel:false" . $url . "});\">" . $Language->Phrase("ExportToEmail") . "</button>";
		$item->Visible = TRUE;

		// Drop down button for export
		$this->ExportOptions->UseButtonGroup = TRUE;
		$this->ExportOptions->UseImageAndText = TRUE;
		$this->ExportOptions->UseDropDownButton = FALSE;
		if ($this->ExportOptions->UseButtonGroup && ew_IsMobile())
			$this->ExportOptions->UseDropDownButton = TRUE;
		$this->ExportOptions->DropDownButtonPhrase = $Language->Phrase("ButtonExport");

		// Add group option item
		$item = &$this->ExportOptions->Add($this->ExportOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;
	}

	// Export data in HTML/CSV/Word/Excel/XML/Email/PDF format
	function ExportData() {
		$utf8 = (strtolower(EW_CHARSET) == "utf-8");
		$bSelectLimit = $this->UseSelectLimit;

		// Load recordset
		if ($bSelectLimit) {
			$this->TotalRecs = $this->SelectRecordCount();
		} else {
			if (!$this->Recordset)
				$this->Recordset = $this->LoadRecordset();
			$rs = &$this->Recordset;
			if ($rs)
				$this->TotalRecs = $rs->RecordCount();
		}
		$this->StartRec = 1;

		// Export all
		if ($this->ExportAll) {
			set_time_limit(EW_EXPORT_ALL_TIME_LIMIT);
			$this->DisplayRecs = $this->TotalRecs;
			$this->StopRec = $this->TotalRecs;
		} else { // Export one page only
			$this->SetUpStartRec(); // Set up start record position

			// Set the last record to display
			if ($this->DisplayRecs <= 0) {
				$this->StopRec = $this->TotalRecs;
			} else {
				$this->StopRec = $this->StartRec + $this->DisplayRecs - 1;
			}
		}
		if ($bSelectLimit)
			$rs = $this->LoadRecordset($this->StartRec-1, $this->DisplayRecs <= 0 ? $this->TotalRecs : $this->DisplayRecs);
		if (!$rs) {
			header("Content-Type:"); // Remove header
			header("Content-Disposition:");
			$this->ShowMessage();
			return;
		}
		$this->ExportDoc = ew_ExportDocument($this, "h");
		$Doc = &$this->ExportDoc;
		if ($bSelectLimit) {
			$this->StartRec = 1;
			$this->StopRec = $this->DisplayRecs <= 0 ? $this->TotalRecs : $this->DisplayRecs;
		} else {

			//$this->StartRec = $this->StartRec;
			//$this->StopRec = $this->StopRec;

		}

		// Call Page Exporting server event
		$this->ExportDoc->ExportCustom = !$this->Page_Exporting();
		$ParentTable = "";
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		$Doc->Text .= $sHeader;
		$this->ExportDocument($Doc, $rs, $this->StartRec, $this->StopRec, "");
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		$Doc->Text .= $sFooter;

		// Close recordset
		$rs->Close();

		// Call Page Exported server event
		$this->Page_Exported();

		// Export header and footer
		$Doc->ExportHeaderAndFooter();

		// Clean output buffer
		if (!EW_DEBUG_ENABLED && ob_get_length())
			ob_end_clean();

		// Write debug message if enabled
		if (EW_DEBUG_ENABLED && $this->Export <> "pdf")
			echo ew_DebugMsg();

		// Output data
		if ($this->Export == "email") {
			echo $this->ExportEmail($Doc->Text);
		} else {
			$Doc->Export();
		}
	}

	// Export email
	function ExportEmail($EmailContent) {
		global $gTmpImages, $Language;
		$sSender = @$_POST["sender"];
		$sRecipient = @$_POST["recipient"];
		$sCc = @$_POST["cc"];
		$sBcc = @$_POST["bcc"];
		$sContentType = @$_POST["contenttype"];

		// Subject
		$sSubject = ew_StripSlashes(@$_POST["subject"]);
		$sEmailSubject = $sSubject;

		// Message
		$sContent = ew_StripSlashes(@$_POST["message"]);
		$sEmailMessage = $sContent;

		// Check sender
		if ($sSender == "") {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterSenderEmail") . "</p>";
		}
		if (!ew_CheckEmail($sSender)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperSenderEmail") . "</p>";
		}

		// Check recipient
		if (!ew_CheckEmailList($sRecipient, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperRecipientEmail") . "</p>";
		}

		// Check cc
		if (!ew_CheckEmailList($sCc, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperCcEmail") . "</p>";
		}

		// Check bcc
		if (!ew_CheckEmailList($sBcc, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperBccEmail") . "</p>";
		}

		// Check email sent count
		if (!isset($_SESSION[EW_EXPORT_EMAIL_COUNTER]))
			$_SESSION[EW_EXPORT_EMAIL_COUNTER] = 0;
		if (intval($_SESSION[EW_EXPORT_EMAIL_COUNTER]) > EW_MAX_EMAIL_SENT_COUNT) {
			return "<p class=\"text-danger\">" . $Language->Phrase("ExceedMaxEmailExport") . "</p>";
		}

		// Send email
		$Email = new cEmail();
		$Email->Sender = $sSender; // Sender
		$Email->Recipient = $sRecipient; // Recipient
		$Email->Cc = $sCc; // Cc
		$Email->Bcc = $sBcc; // Bcc
		$Email->Subject = $sEmailSubject; // Subject
		$Email->Format = ($sContentType == "url") ? "text" : "html";
		if ($sEmailMessage <> "") {
			$sEmailMessage = ew_RemoveXSS($sEmailMessage);
			$sEmailMessage .= ($sContentType == "url") ? "\r\n\r\n" : "<br><br>";
		}
		if ($sContentType == "url") {
			$sUrl = ew_ConvertFullUrl(ew_CurrentPage() . "?" . $this->ExportQueryString());
			$sEmailMessage .= $sUrl; // Send URL only
		} else {
			foreach ($gTmpImages as $tmpimage)
				$Email->AddEmbeddedImage($tmpimage);
			$sEmailMessage .= ew_CleanEmailContent($EmailContent); // Send HTML
		}
		$Email->Content = $sEmailMessage; // Content
		$EventArgs = array();
		if ($this->Recordset) {
			$this->RecCnt = $this->StartRec - 1;
			$this->Recordset->MoveFirst();
			if ($this->StartRec > 1)
				$this->Recordset->Move($this->StartRec - 1);
			$EventArgs["rs"] = &$this->Recordset;
		}
		$bEmailSent = FALSE;
		if ($this->Email_Sending($Email, $EventArgs))
			$bEmailSent = $Email->Send();

		// Check email sent status
		if ($bEmailSent) {

			// Update email sent count
			$_SESSION[EW_EXPORT_EMAIL_COUNTER]++;

			// Sent email success
			return "<p class=\"text-success\">" . $Language->Phrase("SendEmailSuccess") . "</p>"; // Set up success message
		} else {

			// Sent email failure
			return "<p class=\"text-danger\">" . $Email->SendErrDescription . "</p>";
		}
	}

	// Export QueryString
	function ExportQueryString() {

		// Initialize
		$sQry = "export=html";

		// Build QueryString for search
		$this->AddSearchQueryString($sQry, $this->dbkey_councilor); // dbkey_councilor
		$this->AddSearchQueryString($sQry, $this->dbkey_client); // dbkey_client
		$this->AddSearchQueryString($sQry, $this->date); // date
		$this->AddSearchQueryString($sQry, $this->time); // time
		$this->AddSearchQueryString($sQry, $this->comment); // comment
		$this->AddSearchQueryString($sQry, $this->dbkey_activity); // dbkey_activity
		$this->AddSearchQueryString($sQry, $this->budget); // budget
		$this->AddSearchQueryString($sQry, $this->allocated); // allocated
		$this->AddSearchQueryString($sQry, $this->remain); // remain
		$this->AddSearchQueryString($sQry, $this->total_allocated); // total_allocated
		$this->AddSearchQueryString($sQry, $this->total_remain); // total_remain

		// Build QueryString for pager
		$sQry .= "&" . EW_TABLE_REC_PER_PAGE . "=" . urlencode($this->getRecordsPerPage()) . "&" . EW_TABLE_START_REC . "=" . urlencode($this->getStartRecordNumber());
		return $sQry;
	}

	// Add search QueryString
	function AddSearchQueryString(&$Qry, &$Fld) {
		$FldSearchValue = $Fld->AdvancedSearch->getValue("x");
		$FldParm = substr($Fld->FldVar,2);
		if (strval($FldSearchValue) <> "") {
			$Qry .= "&x_" . $FldParm . "=" . urlencode($FldSearchValue) .
				"&z_" . $FldParm . "=" . urlencode($Fld->AdvancedSearch->getValue("z"));
		}
		$FldSearchValue2 = $Fld->AdvancedSearch->getValue("y");
		if (strval($FldSearchValue2) <> "") {
			$Qry .= "&v_" . $FldParm . "=" . urlencode($Fld->AdvancedSearch->getValue("v")) .
				"&y_" . $FldParm . "=" . urlencode($FldSearchValue2) .
				"&w_" . $FldParm . "=" . urlencode($Fld->AdvancedSearch->getValue("w"));
		}
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$url = preg_replace('/\?cmd=reset(all){0,1}$/i', '', $url); // Remove cmd=reset / cmd=resetall
		$Breadcrumb->Add("list", $this->TableVar, $url, "", $this->TableVar, TRUE);
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}

	// ListOptions Load event
	function ListOptions_Load() {

		// Example:
		//$opt = &$this->ListOptions->Add("new");
		//$opt->Header = "xxx";
		//$opt->OnLeft = TRUE; // Link on left
		//$opt->MoveTo(0); // Move to first column

	}

	// ListOptions Rendered event
	function ListOptions_Rendered() {

		// Example: 
		//$this->ListOptions->Items["new"]->Body = "xxx";

	}

	// Row Custom Action event
	function Row_CustomAction($action, $row) {

		// Return FALSE to abort
		return TRUE;
	}

	// Page Exporting event
	// $this->ExportDoc = export document object
	function Page_Exporting() {

		//$this->ExportDoc->Text = "my header"; // Export header
		//return FALSE; // Return FALSE to skip default export and use Row_Export event

		return TRUE; // Return TRUE to use default export and skip Row_Export event
	}

	// Row Export event
	// $this->ExportDoc = export document object
	function Row_Export($rs) {

	    //$this->ExportDoc->Text .= "my content"; // Build HTML with field value: $rs["MyField"] or $this->MyField->ViewValue
	}

	// Page Exported event
	// $this->ExportDoc = export document object
	function Page_Exported() {

		//$this->ExportDoc->Text .= "my footer"; // Export footer
		//echo $this->ExportDoc->Text;

	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($Cust_Client_Activity2_list)) $Cust_Client_Activity2_list = new cCust_Client_Activity2_list();

// Page init
$Cust_Client_Activity2_list->Page_Init();

// Page main
$Cust_Client_Activity2_list->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$Cust_Client_Activity2_list->Page_Render();
?>
<?php include_once "header.php" ?>
<?php if ($Cust_Client_Activity2->Export == "") { ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "list";
var CurrentForm = fCust_Client_Activity2list = new ew_Form("fCust_Client_Activity2list", "list");
fCust_Client_Activity2list.FormKeyCountName = '<?php echo $Cust_Client_Activity2_list->FormKeyCountName ?>';

// Form_CustomValidate event
fCust_Client_Activity2list.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fCust_Client_Activity2list.ValidateRequired = true;
<?php } else { ?>
fCust_Client_Activity2list.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fCust_Client_Activity2list.Lists["x_dbkey_councilor"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_last","x_first","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
fCust_Client_Activity2list.Lists["x_dbkey_client"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_last","x_first","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
fCust_Client_Activity2list.Lists["x_dbkey_activity"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};

// Form object for search
var CurrentSearchForm = fCust_Client_Activity2listsrch = new ew_Form("fCust_Client_Activity2listsrch");

// Validate function for search
fCust_Client_Activity2listsrch.Validate = function(fobj) {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	fobj = fobj || this.Form;
	var infix = "";
	elm = this.GetElements("x" + infix + "_date");
	if (elm && !ew_CheckDate(elm.value))
		return this.OnError(elm, "<?php echo ew_JsEncode2($Cust_Client_Activity2->date->FldErrMsg()) ?>");

	// Fire Form_CustomValidate event
	if (!this.Form_CustomValidate(fobj))
		return false;
	return true;
}

// Form_CustomValidate event
fCust_Client_Activity2listsrch.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fCust_Client_Activity2listsrch.ValidateRequired = true; // Use JavaScript validation
<?php } else { ?>
fCust_Client_Activity2listsrch.ValidateRequired = false; // No JavaScript validation
<?php } ?>

// Dynamic selection lists
fCust_Client_Activity2listsrch.Lists["x_dbkey_client"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_last","x_first","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php } ?>
<?php if ($Cust_Client_Activity2->Export == "") { ?>
<div class="ewToolbar">
<?php if ($Cust_Client_Activity2->Export == "") { ?>
<?php $Breadcrumb->Render(); ?>
<?php } ?>
<?php if ($Cust_Client_Activity2_list->TotalRecs > 0 && $Cust_Client_Activity2_list->ExportOptions->Visible()) { ?>
<?php $Cust_Client_Activity2_list->ExportOptions->Render("body") ?>
<?php } ?>
<?php if ($Cust_Client_Activity2_list->SearchOptions->Visible()) { ?>
<?php $Cust_Client_Activity2_list->SearchOptions->Render("body") ?>
<?php } ?>
<?php if ($Cust_Client_Activity2_list->FilterOptions->Visible()) { ?>
<?php $Cust_Client_Activity2_list->FilterOptions->Render("body") ?>
<?php } ?>
<?php if ($Cust_Client_Activity2->Export == "") { ?>
<?php echo $Language->SelectionForm(); ?>
<?php } ?>
<div class="clearfix"></div>
</div>
<?php } ?>
<?php
	$bSelectLimit = $Cust_Client_Activity2_list->UseSelectLimit;
	if ($bSelectLimit) {
		if ($Cust_Client_Activity2_list->TotalRecs <= 0)
			$Cust_Client_Activity2_list->TotalRecs = $Cust_Client_Activity2->SelectRecordCount();
	} else {
		if (!$Cust_Client_Activity2_list->Recordset && ($Cust_Client_Activity2_list->Recordset = $Cust_Client_Activity2_list->LoadRecordset()))
			$Cust_Client_Activity2_list->TotalRecs = $Cust_Client_Activity2_list->Recordset->RecordCount();
	}
	$Cust_Client_Activity2_list->StartRec = 1;
	if ($Cust_Client_Activity2_list->DisplayRecs <= 0 || ($Cust_Client_Activity2->Export <> "" && $Cust_Client_Activity2->ExportAll)) // Display all records
		$Cust_Client_Activity2_list->DisplayRecs = $Cust_Client_Activity2_list->TotalRecs;
	if (!($Cust_Client_Activity2->Export <> "" && $Cust_Client_Activity2->ExportAll))
		$Cust_Client_Activity2_list->SetUpStartRec(); // Set up start record position
	if ($bSelectLimit)
		$Cust_Client_Activity2_list->Recordset = $Cust_Client_Activity2_list->LoadRecordset($Cust_Client_Activity2_list->StartRec-1, $Cust_Client_Activity2_list->DisplayRecs);

	// Set no record found message
	if ($Cust_Client_Activity2->CurrentAction == "" && $Cust_Client_Activity2_list->TotalRecs == 0) {
		if (!$Security->CanList())
			$Cust_Client_Activity2_list->setWarningMessage(ew_DeniedMsg());
		if ($Cust_Client_Activity2_list->SearchWhere == "0=101")
			$Cust_Client_Activity2_list->setWarningMessage($Language->Phrase("EnterSearchCriteria"));
		else
			$Cust_Client_Activity2_list->setWarningMessage($Language->Phrase("NoRecord"));
	}
$Cust_Client_Activity2_list->RenderOtherOptions();
?>
<?php if ($Security->CanSearch()) { ?>
<?php if ($Cust_Client_Activity2->Export == "" && $Cust_Client_Activity2->CurrentAction == "") { ?>
<form name="fCust_Client_Activity2listsrch" id="fCust_Client_Activity2listsrch" class="form-inline ewForm" action="<?php echo ew_CurrentPage() ?>">
<?php $SearchPanelClass = ($Cust_Client_Activity2_list->SearchWhere <> "") ? " in" : " in"; ?>
<div id="fCust_Client_Activity2listsrch_SearchPanel" class="ewSearchPanel collapse<?php echo $SearchPanelClass ?>">
<input type="hidden" name="cmd" value="search">
<input type="hidden" name="t" value="Cust_Client_Activity2">
	<div class="ewBasicSearch">
<?php
if ($gsSearchError == "")
	$Cust_Client_Activity2_list->LoadAdvancedSearch(); // Load advanced search

// Render for search
$Cust_Client_Activity2->RowType = EW_ROWTYPE_SEARCH;

// Render row
$Cust_Client_Activity2->ResetAttrs();
$Cust_Client_Activity2_list->RenderRow();
?>
<div id="xsr_1" class="ewRow">
<?php if ($Cust_Client_Activity2->dbkey_client->Visible) { // dbkey_client ?>
	<div id="xsc_dbkey_client" class="ewCell form-group">
		<label for="x_dbkey_client" class="ewSearchCaption ewLabel"><?php echo $Cust_Client_Activity2->dbkey_client->FldCaption() ?></label>
		<span class="ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_dbkey_client" id="z_dbkey_client" value="="></span>
		<span class="ewSearchField">
<input type="text" data-table="Cust_Client_Activity2" data-field="x_dbkey_client" name="x_dbkey_client" id="x_dbkey_client" size="30" placeholder="<?php echo ew_HtmlEncode($Cust_Client_Activity2->dbkey_client->getPlaceHolder()) ?>" value="<?php echo $Cust_Client_Activity2->dbkey_client->EditValue ?>"<?php echo $Cust_Client_Activity2->dbkey_client->EditAttributes() ?>>
</span>
	</div>
<?php } ?>
</div>
<div id="xsr_2" class="ewRow">
<?php if ($Cust_Client_Activity2->date->Visible) { // date ?>
	<div id="xsc_date" class="ewCell form-group">
		<label for="x_date" class="ewSearchCaption ewLabel"><?php echo $Cust_Client_Activity2->date->FldCaption() ?></label>
		<span class="ewSearchOperator"><?php echo $Language->Phrase(">=") ?><input type="hidden" name="z_date" id="z_date" value=">="></span>
		<span class="ewSearchField">
<input type="text" data-table="Cust_Client_Activity2" data-field="x_date" data-format="9" name="x_date" id="x_date" placeholder="<?php echo ew_HtmlEncode($Cust_Client_Activity2->date->getPlaceHolder()) ?>" value="<?php echo $Cust_Client_Activity2->date->EditValue ?>"<?php echo $Cust_Client_Activity2->date->EditAttributes() ?>>
<?php if (!$Cust_Client_Activity2->date->ReadOnly && !$Cust_Client_Activity2->date->Disabled && !isset($Cust_Client_Activity2->date->EditAttrs["readonly"]) && !isset($Cust_Client_Activity2->date->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fCust_Client_Activity2listsrch", "x_date", "%Y/%m/%d %H:%M:%S");
</script>
<?php } ?>
</span>
		<span class="ewSearchCond btw0_date"><label class="radio-inline ewRadio" style="white-space: nowrap;"><input type="radio" name="v_date" value="AND"<?php if ($Cust_Client_Activity2->date->AdvancedSearch->SearchCondition <> "OR") echo " checked" ?>><?php echo $Language->Phrase("AND") ?></label><label class="radio-inline ewRadio" style="white-space: nowrap;"><input type="radio" name="v_date" value="OR"<?php if ($Cust_Client_Activity2->date->AdvancedSearch->SearchCondition == "OR") echo " checked" ?>><?php echo $Language->Phrase("OR") ?></label>&nbsp;</span>
		<span class="ewSearchOperator btw0_date"><?php echo $Language->Phrase("<=") ?><input type="hidden" name="w_date" id="w_date" value="<="></span>
		<span class="ewSearchField">
<input type="text" data-table="Cust_Client_Activity2" data-field="x_date" data-format="9" name="y_date" id="y_date" placeholder="<?php echo ew_HtmlEncode($Cust_Client_Activity2->date->getPlaceHolder()) ?>" value="<?php echo $Cust_Client_Activity2->date->EditValue2 ?>"<?php echo $Cust_Client_Activity2->date->EditAttributes() ?>>
<?php if (!$Cust_Client_Activity2->date->ReadOnly && !$Cust_Client_Activity2->date->Disabled && !isset($Cust_Client_Activity2->date->EditAttrs["readonly"]) && !isset($Cust_Client_Activity2->date->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fCust_Client_Activity2listsrch", "y_date", "%Y/%m/%d %H:%M:%S");
</script>
<?php } ?>
</span>
	</div>
<?php } ?>
</div>
<div id="xsr_3" class="ewRow">
	<button class="btn btn-primary ewButton" name="btnsubmit" id="btnsubmit" type="submit"><?php echo $Language->Phrase("QuickSearchBtn") ?></button>
</div>
	</div>
</div>
</form>
<?php } ?>
<?php } ?>
<?php $Cust_Client_Activity2_list->ShowPageHeader(); ?>
<?php
$Cust_Client_Activity2_list->ShowMessage();
?>
<?php if ($Cust_Client_Activity2_list->TotalRecs > 0 || $Cust_Client_Activity2->CurrentAction <> "") { ?>
<div class="panel panel-default ewGrid">
<form name="fCust_Client_Activity2list" id="fCust_Client_Activity2list" class="form-inline ewForm ewListForm" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($Cust_Client_Activity2_list->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $Cust_Client_Activity2_list->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="Cust_Client_Activity2">
<div id="gmp_Cust_Client_Activity2" class="<?php if (ew_IsResponsiveLayout()) { echo "table-responsive "; } ?>ewGridMiddlePanel">
<?php if ($Cust_Client_Activity2_list->TotalRecs > 0) { ?>
<table id="tbl_Cust_Client_Activity2list" class="table ewTable">
<?php echo $Cust_Client_Activity2->TableCustomInnerHtml ?>
<thead><!-- Table header -->
	<tr class="ewTableHeader">
<?php

// Header row
$Cust_Client_Activity2_list->RowType = EW_ROWTYPE_HEADER;

// Render list options
$Cust_Client_Activity2_list->RenderListOptions();

// Render list options (header, left)
$Cust_Client_Activity2_list->ListOptions->Render("header", "left");
?>
<?php if ($Cust_Client_Activity2->dbkey_councilor->Visible) { // dbkey_councilor ?>
	<?php if ($Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->dbkey_councilor) == "") { ?>
		<th data-name="dbkey_councilor"><div id="elh_Cust_Client_Activity2_dbkey_councilor" class="Cust_Client_Activity2_dbkey_councilor"><div class="ewTableHeaderCaption" style="white-space: nowrap;"><?php echo $Cust_Client_Activity2->dbkey_councilor->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="dbkey_councilor"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->dbkey_councilor) ?>',1);"><div id="elh_Cust_Client_Activity2_dbkey_councilor" class="Cust_Client_Activity2_dbkey_councilor">
			<div class="ewTableHeaderBtn" style="white-space: nowrap;"><span class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->dbkey_councilor->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Client_Activity2->dbkey_councilor->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Client_Activity2->dbkey_councilor->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Client_Activity2->dbkey_client->Visible) { // dbkey_client ?>
	<?php if ($Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->dbkey_client) == "") { ?>
		<th data-name="dbkey_client"><div id="elh_Cust_Client_Activity2_dbkey_client" class="Cust_Client_Activity2_dbkey_client"><div class="ewTableHeaderCaption" style="white-space: nowrap;"><?php echo $Cust_Client_Activity2->dbkey_client->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="dbkey_client"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->dbkey_client) ?>',1);"><div id="elh_Cust_Client_Activity2_dbkey_client" class="Cust_Client_Activity2_dbkey_client">
			<div class="ewTableHeaderBtn" style="white-space: nowrap;"><span class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->dbkey_client->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Client_Activity2->dbkey_client->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Client_Activity2->dbkey_client->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Client_Activity2->date->Visible) { // date ?>
	<?php if ($Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->date) == "") { ?>
		<th data-name="date"><div id="elh_Cust_Client_Activity2_date" class="Cust_Client_Activity2_date"><div class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->date->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="date"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->date) ?>',1);"><div id="elh_Cust_Client_Activity2_date" class="Cust_Client_Activity2_date">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->date->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Client_Activity2->date->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Client_Activity2->date->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Client_Activity2->time->Visible) { // time ?>
	<?php if ($Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->time) == "") { ?>
		<th data-name="time"><div id="elh_Cust_Client_Activity2_time" class="Cust_Client_Activity2_time"><div class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->time->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="time"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->time) ?>',1);"><div id="elh_Cust_Client_Activity2_time" class="Cust_Client_Activity2_time">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->time->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Client_Activity2->time->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Client_Activity2->time->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Client_Activity2->dbkey_activity->Visible) { // dbkey_activity ?>
	<?php if ($Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->dbkey_activity) == "") { ?>
		<th data-name="dbkey_activity"><div id="elh_Cust_Client_Activity2_dbkey_activity" class="Cust_Client_Activity2_dbkey_activity"><div class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->dbkey_activity->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="dbkey_activity"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->dbkey_activity) ?>',1);"><div id="elh_Cust_Client_Activity2_dbkey_activity" class="Cust_Client_Activity2_dbkey_activity">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->dbkey_activity->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Client_Activity2->dbkey_activity->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Client_Activity2->dbkey_activity->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Client_Activity2->attachment->Visible) { // attachment ?>
	<?php if ($Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->attachment) == "") { ?>
		<th data-name="attachment"><div id="elh_Cust_Client_Activity2_attachment" class="Cust_Client_Activity2_attachment"><div class="ewTableHeaderCaption" style="white-space: nowrap;"><?php echo $Cust_Client_Activity2->attachment->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="attachment"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->attachment) ?>',1);"><div id="elh_Cust_Client_Activity2_attachment" class="Cust_Client_Activity2_attachment">
			<div class="ewTableHeaderBtn" style="white-space: nowrap;"><span class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->attachment->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Client_Activity2->attachment->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Client_Activity2->attachment->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Client_Activity2->budget->Visible) { // budget ?>
	<?php if ($Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->budget) == "") { ?>
		<th data-name="budget"><div id="elh_Cust_Client_Activity2_budget" class="Cust_Client_Activity2_budget"><div class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->budget->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="budget"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->budget) ?>',1);"><div id="elh_Cust_Client_Activity2_budget" class="Cust_Client_Activity2_budget">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->budget->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Client_Activity2->budget->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Client_Activity2->budget->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Client_Activity2->allocated->Visible) { // allocated ?>
	<?php if ($Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->allocated) == "") { ?>
		<th data-name="allocated"><div id="elh_Cust_Client_Activity2_allocated" class="Cust_Client_Activity2_allocated"><div class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->allocated->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="allocated"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->allocated) ?>',1);"><div id="elh_Cust_Client_Activity2_allocated" class="Cust_Client_Activity2_allocated">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->allocated->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Client_Activity2->allocated->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Client_Activity2->allocated->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Client_Activity2->remain->Visible) { // remain ?>
	<?php if ($Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->remain) == "") { ?>
		<th data-name="remain"><div id="elh_Cust_Client_Activity2_remain" class="Cust_Client_Activity2_remain"><div class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->remain->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="remain"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->remain) ?>',1);"><div id="elh_Cust_Client_Activity2_remain" class="Cust_Client_Activity2_remain">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->remain->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Client_Activity2->remain->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Client_Activity2->remain->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Client_Activity2->total_allocated->Visible) { // total_allocated ?>
	<?php if ($Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->total_allocated) == "") { ?>
		<th data-name="total_allocated"><div id="elh_Cust_Client_Activity2_total_allocated" class="Cust_Client_Activity2_total_allocated"><div class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->total_allocated->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="total_allocated"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->total_allocated) ?>',1);"><div id="elh_Cust_Client_Activity2_total_allocated" class="Cust_Client_Activity2_total_allocated">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->total_allocated->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Client_Activity2->total_allocated->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Client_Activity2->total_allocated->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Client_Activity2->total_remain->Visible) { // total_remain ?>
	<?php if ($Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->total_remain) == "") { ?>
		<th data-name="total_remain"><div id="elh_Cust_Client_Activity2_total_remain" class="Cust_Client_Activity2_total_remain"><div class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->total_remain->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="total_remain"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Client_Activity2->SortUrl($Cust_Client_Activity2->total_remain) ?>',1);"><div id="elh_Cust_Client_Activity2_total_remain" class="Cust_Client_Activity2_total_remain">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Client_Activity2->total_remain->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Client_Activity2->total_remain->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Client_Activity2->total_remain->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php

// Render list options (header, right)
$Cust_Client_Activity2_list->ListOptions->Render("header", "right");
?>
	</tr>
</thead>
<tbody>
<?php
if ($Cust_Client_Activity2->ExportAll && $Cust_Client_Activity2->Export <> "") {
	$Cust_Client_Activity2_list->StopRec = $Cust_Client_Activity2_list->TotalRecs;
} else {

	// Set the last record to display
	if ($Cust_Client_Activity2_list->TotalRecs > $Cust_Client_Activity2_list->StartRec + $Cust_Client_Activity2_list->DisplayRecs - 1)
		$Cust_Client_Activity2_list->StopRec = $Cust_Client_Activity2_list->StartRec + $Cust_Client_Activity2_list->DisplayRecs - 1;
	else
		$Cust_Client_Activity2_list->StopRec = $Cust_Client_Activity2_list->TotalRecs;
}
$Cust_Client_Activity2_list->RecCnt = $Cust_Client_Activity2_list->StartRec - 1;
if ($Cust_Client_Activity2_list->Recordset && !$Cust_Client_Activity2_list->Recordset->EOF) {
	$Cust_Client_Activity2_list->Recordset->MoveFirst();
	$bSelectLimit = $Cust_Client_Activity2_list->UseSelectLimit;
	if (!$bSelectLimit && $Cust_Client_Activity2_list->StartRec > 1)
		$Cust_Client_Activity2_list->Recordset->Move($Cust_Client_Activity2_list->StartRec - 1);
} elseif (!$Cust_Client_Activity2->AllowAddDeleteRow && $Cust_Client_Activity2_list->StopRec == 0) {
	$Cust_Client_Activity2_list->StopRec = $Cust_Client_Activity2->GridAddRowCount;
}

// Initialize aggregate
$Cust_Client_Activity2->RowType = EW_ROWTYPE_AGGREGATEINIT;
$Cust_Client_Activity2->ResetAttrs();
$Cust_Client_Activity2_list->RenderRow();
while ($Cust_Client_Activity2_list->RecCnt < $Cust_Client_Activity2_list->StopRec) {
	$Cust_Client_Activity2_list->RecCnt++;
	if (intval($Cust_Client_Activity2_list->RecCnt) >= intval($Cust_Client_Activity2_list->StartRec)) {
		$Cust_Client_Activity2_list->RowCnt++;

		// Set up key count
		$Cust_Client_Activity2_list->KeyCount = $Cust_Client_Activity2_list->RowIndex;

		// Init row class and style
		$Cust_Client_Activity2->ResetAttrs();
		$Cust_Client_Activity2->CssClass = "";
		if ($Cust_Client_Activity2->CurrentAction == "gridadd") {
		} else {
			$Cust_Client_Activity2_list->LoadRowValues($Cust_Client_Activity2_list->Recordset); // Load row values
		}
		$Cust_Client_Activity2->RowType = EW_ROWTYPE_VIEW; // Render view

		// Set up row id / data-rowindex
		$Cust_Client_Activity2->RowAttrs = array_merge($Cust_Client_Activity2->RowAttrs, array('data-rowindex'=>$Cust_Client_Activity2_list->RowCnt, 'id'=>'r' . $Cust_Client_Activity2_list->RowCnt . '_Cust_Client_Activity2', 'data-rowtype'=>$Cust_Client_Activity2->RowType));

		// Render row
		$Cust_Client_Activity2_list->RenderRow();

		// Render list options
		$Cust_Client_Activity2_list->RenderListOptions();
?>
	<tr<?php echo $Cust_Client_Activity2->RowAttributes() ?>>
<?php

// Render list options (body, left)
$Cust_Client_Activity2_list->ListOptions->Render("body", "left", $Cust_Client_Activity2_list->RowCnt);
?>
	<?php if ($Cust_Client_Activity2->dbkey_councilor->Visible) { // dbkey_councilor ?>
		<td data-name="dbkey_councilor"<?php echo $Cust_Client_Activity2->dbkey_councilor->CellAttributes() ?>>
<span id="el<?php echo $Cust_Client_Activity2_list->RowCnt ?>_Cust_Client_Activity2_dbkey_councilor" class="Cust_Client_Activity2_dbkey_councilor">
<span<?php echo $Cust_Client_Activity2->dbkey_councilor->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity2->dbkey_councilor->ListViewValue() ?></span>
</span>
<a id="<?php echo $Cust_Client_Activity2_list->PageObjName . "_row_" . $Cust_Client_Activity2_list->RowCnt ?>"></a></td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->dbkey_client->Visible) { // dbkey_client ?>
		<td data-name="dbkey_client"<?php echo $Cust_Client_Activity2->dbkey_client->CellAttributes() ?>>
<span id="el<?php echo $Cust_Client_Activity2_list->RowCnt ?>_Cust_Client_Activity2_dbkey_client" class="Cust_Client_Activity2_dbkey_client">
<span<?php echo $Cust_Client_Activity2->dbkey_client->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity2->dbkey_client->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->date->Visible) { // date ?>
		<td data-name="date"<?php echo $Cust_Client_Activity2->date->CellAttributes() ?>>
<span id="el<?php echo $Cust_Client_Activity2_list->RowCnt ?>_Cust_Client_Activity2_date" class="Cust_Client_Activity2_date">
<span<?php echo $Cust_Client_Activity2->date->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity2->date->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->time->Visible) { // time ?>
		<td data-name="time"<?php echo $Cust_Client_Activity2->time->CellAttributes() ?>>
<span id="el<?php echo $Cust_Client_Activity2_list->RowCnt ?>_Cust_Client_Activity2_time" class="Cust_Client_Activity2_time">
<span<?php echo $Cust_Client_Activity2->time->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity2->time->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->dbkey_activity->Visible) { // dbkey_activity ?>
		<td data-name="dbkey_activity"<?php echo $Cust_Client_Activity2->dbkey_activity->CellAttributes() ?>>
<span id="el<?php echo $Cust_Client_Activity2_list->RowCnt ?>_Cust_Client_Activity2_dbkey_activity" class="Cust_Client_Activity2_dbkey_activity">
<span<?php echo $Cust_Client_Activity2->dbkey_activity->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity2->dbkey_activity->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->attachment->Visible) { // attachment ?>
		<td data-name="attachment"<?php echo $Cust_Client_Activity2->attachment->CellAttributes() ?>>
<span id="el<?php echo $Cust_Client_Activity2_list->RowCnt ?>_Cust_Client_Activity2_attachment" class="Cust_Client_Activity2_attachment">
<span<?php echo $Cust_Client_Activity2->attachment->ViewAttributes() ?>>
<?php echo ew_GetFileViewTag($Cust_Client_Activity2->attachment, $Cust_Client_Activity2->attachment->ListViewValue()) ?>
</span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->budget->Visible) { // budget ?>
		<td data-name="budget"<?php echo $Cust_Client_Activity2->budget->CellAttributes() ?>>
<span id="el<?php echo $Cust_Client_Activity2_list->RowCnt ?>_Cust_Client_Activity2_budget" class="Cust_Client_Activity2_budget">
<span<?php echo $Cust_Client_Activity2->budget->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity2->budget->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->allocated->Visible) { // allocated ?>
		<td data-name="allocated"<?php echo $Cust_Client_Activity2->allocated->CellAttributes() ?>>
<span id="el<?php echo $Cust_Client_Activity2_list->RowCnt ?>_Cust_Client_Activity2_allocated" class="Cust_Client_Activity2_allocated">
<span<?php echo $Cust_Client_Activity2->allocated->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity2->allocated->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->remain->Visible) { // remain ?>
		<td data-name="remain"<?php echo $Cust_Client_Activity2->remain->CellAttributes() ?>>
<span id="el<?php echo $Cust_Client_Activity2_list->RowCnt ?>_Cust_Client_Activity2_remain" class="Cust_Client_Activity2_remain">
<span<?php echo $Cust_Client_Activity2->remain->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity2->remain->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->total_allocated->Visible) { // total_allocated ?>
		<td data-name="total_allocated"<?php echo $Cust_Client_Activity2->total_allocated->CellAttributes() ?>>
<span id="el<?php echo $Cust_Client_Activity2_list->RowCnt ?>_Cust_Client_Activity2_total_allocated" class="Cust_Client_Activity2_total_allocated">
<span<?php echo $Cust_Client_Activity2->total_allocated->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity2->total_allocated->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->total_remain->Visible) { // total_remain ?>
		<td data-name="total_remain"<?php echo $Cust_Client_Activity2->total_remain->CellAttributes() ?>>
<span id="el<?php echo $Cust_Client_Activity2_list->RowCnt ?>_Cust_Client_Activity2_total_remain" class="Cust_Client_Activity2_total_remain">
<span<?php echo $Cust_Client_Activity2->total_remain->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity2->total_remain->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
<?php

// Render list options (body, right)
$Cust_Client_Activity2_list->ListOptions->Render("body", "right", $Cust_Client_Activity2_list->RowCnt);
?>
	</tr>
<?php
	}
	if ($Cust_Client_Activity2->CurrentAction <> "gridadd")
		$Cust_Client_Activity2_list->Recordset->MoveNext();
}
?>
</tbody>
<?php

// Render aggregate row
$Cust_Client_Activity2->RowType = EW_ROWTYPE_AGGREGATE;
$Cust_Client_Activity2->ResetAttrs();
$Cust_Client_Activity2_list->RenderRow();
?>
<?php if ($Cust_Client_Activity2_list->TotalRecs > 0 && ($Cust_Client_Activity2->CurrentAction <> "gridadd" && $Cust_Client_Activity2->CurrentAction <> "gridedit")) { ?>
<tfoot><!-- Table footer -->
	<tr class="ewTableFooter">
<?php

// Render list options
$Cust_Client_Activity2_list->RenderListOptions();

// Render list options (footer, left)
$Cust_Client_Activity2_list->ListOptions->Render("footer", "left");
?>
	<?php if ($Cust_Client_Activity2->dbkey_councilor->Visible) { // dbkey_councilor ?>
		<td data-name="dbkey_councilor"><span id="elf_Cust_Client_Activity2_dbkey_councilor" class="Cust_Client_Activity2_dbkey_councilor">
		&nbsp;
		</span></td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->dbkey_client->Visible) { // dbkey_client ?>
		<td data-name="dbkey_client"><span id="elf_Cust_Client_Activity2_dbkey_client" class="Cust_Client_Activity2_dbkey_client">
		&nbsp;
		</span></td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->date->Visible) { // date ?>
		<td data-name="date"><span id="elf_Cust_Client_Activity2_date" class="Cust_Client_Activity2_date">
		&nbsp;
		</span></td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->time->Visible) { // time ?>
		<td data-name="time"><span id="elf_Cust_Client_Activity2_time" class="Cust_Client_Activity2_time">
<span class="ewAggregate"><?php echo $Language->Phrase("TOTAL") ?></span>
<?php echo $Cust_Client_Activity2->time->ViewValue ?>
		</span></td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->dbkey_activity->Visible) { // dbkey_activity ?>
		<td data-name="dbkey_activity"><span id="elf_Cust_Client_Activity2_dbkey_activity" class="Cust_Client_Activity2_dbkey_activity">
		&nbsp;
		</span></td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->attachment->Visible) { // attachment ?>
		<td data-name="attachment"><span id="elf_Cust_Client_Activity2_attachment" class="Cust_Client_Activity2_attachment">
		&nbsp;
		</span></td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->budget->Visible) { // budget ?>
		<td data-name="budget"><span id="elf_Cust_Client_Activity2_budget" class="Cust_Client_Activity2_budget">
		&nbsp;
		</span></td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->allocated->Visible) { // allocated ?>
		<td data-name="allocated"><span id="elf_Cust_Client_Activity2_allocated" class="Cust_Client_Activity2_allocated">
		&nbsp;
		</span></td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->remain->Visible) { // remain ?>
		<td data-name="remain"><span id="elf_Cust_Client_Activity2_remain" class="Cust_Client_Activity2_remain">
		&nbsp;
		</span></td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->total_allocated->Visible) { // total_allocated ?>
		<td data-name="total_allocated"><span id="elf_Cust_Client_Activity2_total_allocated" class="Cust_Client_Activity2_total_allocated">
		&nbsp;
		</span></td>
	<?php } ?>
	<?php if ($Cust_Client_Activity2->total_remain->Visible) { // total_remain ?>
		<td data-name="total_remain"><span id="elf_Cust_Client_Activity2_total_remain" class="Cust_Client_Activity2_total_remain">
		&nbsp;
		</span></td>
	<?php } ?>
<?php

// Render list options (footer, right)
$Cust_Client_Activity2_list->ListOptions->Render("footer", "right");
?>
	</tr>
</tfoot>	
<?php } ?>
</table>
<?php } ?>
<?php if ($Cust_Client_Activity2->CurrentAction == "") { ?>
<input type="hidden" name="a_list" id="a_list" value="">
<?php } ?>
</div>
</form>
<?php

// Close recordset
if ($Cust_Client_Activity2_list->Recordset)
	$Cust_Client_Activity2_list->Recordset->Close();
?>
<?php if ($Cust_Client_Activity2->Export == "") { ?>
<div class="panel-footer ewGridLowerPanel">
<?php if ($Cust_Client_Activity2->CurrentAction <> "gridadd" && $Cust_Client_Activity2->CurrentAction <> "gridedit") { ?>
<form name="ewPagerForm" class="ewForm form-inline ewPagerForm" action="<?php echo ew_CurrentPage() ?>">
<?php if (!isset($Cust_Client_Activity2_list->Pager)) $Cust_Client_Activity2_list->Pager = new cPrevNextPager($Cust_Client_Activity2_list->StartRec, $Cust_Client_Activity2_list->DisplayRecs, $Cust_Client_Activity2_list->TotalRecs) ?>
<?php if ($Cust_Client_Activity2_list->Pager->RecordCount > 0) { ?>
<div class="ewPager">
<span><?php echo $Language->Phrase("Page") ?>&nbsp;</span>
<div class="ewPrevNext"><div class="input-group">
<div class="input-group-btn">
<!--first page button-->
	<?php if ($Cust_Client_Activity2_list->Pager->FirstButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerFirst") ?>" href="<?php echo $Cust_Client_Activity2_list->PageUrl() ?>start=<?php echo $Cust_Client_Activity2_list->Pager->FirstButton->Start ?>"><span class="icon-first ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerFirst") ?>"><span class="icon-first ewIcon"></span></a>
	<?php } ?>
<!--previous page button-->
	<?php if ($Cust_Client_Activity2_list->Pager->PrevButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerPrevious") ?>" href="<?php echo $Cust_Client_Activity2_list->PageUrl() ?>start=<?php echo $Cust_Client_Activity2_list->Pager->PrevButton->Start ?>"><span class="icon-prev ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerPrevious") ?>"><span class="icon-prev ewIcon"></span></a>
	<?php } ?>
</div>
<!--current page number-->
	<input class="form-control input-sm" type="text" name="<?php echo EW_TABLE_PAGE_NO ?>" value="<?php echo $Cust_Client_Activity2_list->Pager->CurrentPage ?>">
<div class="input-group-btn">
<!--next page button-->
	<?php if ($Cust_Client_Activity2_list->Pager->NextButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerNext") ?>" href="<?php echo $Cust_Client_Activity2_list->PageUrl() ?>start=<?php echo $Cust_Client_Activity2_list->Pager->NextButton->Start ?>"><span class="icon-next ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerNext") ?>"><span class="icon-next ewIcon"></span></a>
	<?php } ?>
<!--last page button-->
	<?php if ($Cust_Client_Activity2_list->Pager->LastButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerLast") ?>" href="<?php echo $Cust_Client_Activity2_list->PageUrl() ?>start=<?php echo $Cust_Client_Activity2_list->Pager->LastButton->Start ?>"><span class="icon-last ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerLast") ?>"><span class="icon-last ewIcon"></span></a>
	<?php } ?>
</div>
</div>
</div>
<span>&nbsp;<?php echo $Language->Phrase("of") ?>&nbsp;<?php echo $Cust_Client_Activity2_list->Pager->PageCount ?></span>
</div>
<div class="ewPager ewRec">
	<span><?php echo $Language->Phrase("Record") ?>&nbsp;<?php echo $Cust_Client_Activity2_list->Pager->FromIndex ?>&nbsp;<?php echo $Language->Phrase("To") ?>&nbsp;<?php echo $Cust_Client_Activity2_list->Pager->ToIndex ?>&nbsp;<?php echo $Language->Phrase("Of") ?>&nbsp;<?php echo $Cust_Client_Activity2_list->Pager->RecordCount ?></span>
</div>
<?php } ?>
</form>
<?php } ?>
<div class="ewListOtherOptions">
<?php
	foreach ($Cust_Client_Activity2_list->OtherOptions as &$option)
		$option->Render("body", "bottom");
?>
</div>
<div class="clearfix"></div>
</div>
<?php } ?>
</div>
<?php } ?>
<?php if ($Cust_Client_Activity2_list->TotalRecs == 0 && $Cust_Client_Activity2->CurrentAction == "") { // Show other options ?>
<div class="ewListOtherOptions">
<?php
	foreach ($Cust_Client_Activity2_list->OtherOptions as &$option) {
		$option->ButtonClass = "";
		$option->Render("body", "");
	}
?>
</div>
<div class="clearfix"></div>
<?php } ?>
<?php if ($Cust_Client_Activity2->Export == "") { ?>
<script type="text/javascript">
fCust_Client_Activity2listsrch.Init();
fCust_Client_Activity2listsrch.FilterList = <?php echo $Cust_Client_Activity2_list->GetFilterList() ?>;
fCust_Client_Activity2list.Init();
</script>
<?php } ?>
<?php
$Cust_Client_Activity2_list->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<?php if ($Cust_Client_Activity2->Export == "") { ?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php } ?>
<?php include_once "footer.php" ?>
<?php
$Cust_Client_Activity2_list->Page_Terminate();
?>
