<?php
if (session_id() == "") session_start(); // Init session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg13.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql13.php") ?>
<?php include_once "phpfn13.php" ?>
<?php include_once "Cust_Client_Activity_Adminsinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn13.php" ?>
<?php

//
// Page class
//

$Cust_Client_Activity_Admins_edit = NULL; // Initialize page object first

class cCust_Client_Activity_Admins_edit extends cCust_Client_Activity_Admins {

	// Page ID
	var $PageID = 'edit';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'Cust_Client_Activity_Admins';

	// Page object name
	var $PageObjName = 'Cust_Client_Activity_Admins_edit';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}
	var $AuditTrailOnAdd = FALSE;
	var $AuditTrailOnEdit = TRUE;
	var $AuditTrailOnDelete = FALSE;
	var $AuditTrailOnView = FALSE;
	var $AuditTrailOnViewData = FALSE;
	var $AuditTrailOnSearch = FALSE;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (Cust_Client_Activity_Admins)
		if (!isset($GLOBALS["Cust_Client_Activity_Admins"]) || get_class($GLOBALS["Cust_Client_Activity_Admins"]) == "cCust_Client_Activity_Admins") {
			$GLOBALS["Cust_Client_Activity_Admins"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["Cust_Client_Activity_Admins"];
		}

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'edit', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'Cust_Client_Activity_Admins', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	//
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanEdit()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("Cust_Client_Activity_Adminslist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Create form object
		$objForm = new cFormObj();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action
		$this->dbkey_councilor->SetVisibility();
		$this->dbkey_client->SetVisibility();
		$this->date->SetVisibility();
		$this->time->SetVisibility();
		$this->comment->SetVisibility();
		$this->dbkey_activity->SetVisibility();
		$this->Rate->SetVisibility();
		$this->Rate->Visible = !$this->IsAddOrEdit();
		$this->Client_Type->SetVisibility();
		$this->Client_Type->Visible = !$this->IsAddOrEdit();
		$this->Contract_ID->SetVisibility();
		$this->Contract_ID->Visible = !$this->IsAddOrEdit();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $Cust_Client_Activity_Admins;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($Cust_Client_Activity_Admins);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();

			// Handle modal response
			if ($this->IsModal) {
				$row = array();
				$row["url"] = $url;
				echo ew_ArrayToJson(array($row));
			} else {
				header("Location: " . $url);
			}
		}
		exit();
	}
	var $FormClassName = "form-horizontal ewForm ewEditForm";
	var $IsModal = FALSE;
	var $DbMasterFilter;
	var $DbDetailFilter;

	// 
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError;
		global $gbSkipHeaderFooter;

		// Check modal
		$this->IsModal = (@$_GET["modal"] == "1" || @$_POST["modal"] == "1");
		if ($this->IsModal)
			$gbSkipHeaderFooter = TRUE;

		// Load key from QueryString
		if (@$_GET["dbkey"] <> "") {
			$this->dbkey->setQueryStringValue($_GET["dbkey"]);
		}

		// Process form if post back
		if (@$_POST["a_edit"] <> "") {
			$this->CurrentAction = $_POST["a_edit"]; // Get action code
			$this->LoadFormValues(); // Get form values
		} else {
			$this->CurrentAction = "I"; // Default action is display
		}

		// Check if valid key
		if ($this->dbkey->CurrentValue == "") {
			$this->Page_Terminate("Cust_Client_Activity_Adminslist.php"); // Invalid key, return to list
		}

		// Validate form if post back
		if (@$_POST["a_edit"] <> "") {
			if (!$this->ValidateForm()) {
				$this->CurrentAction = ""; // Form error, reset action
				$this->setFailureMessage($gsFormError);
				$this->EventCancelled = TRUE; // Event cancelled
				$this->RestoreFormValues();
			}
		}
		switch ($this->CurrentAction) {
			case "I": // Get a record to display
				if (!$this->LoadRow()) { // Load record based on key
					if ($this->getFailureMessage() == "") $this->setFailureMessage($Language->Phrase("NoRecord")); // No record found
					$this->Page_Terminate("Cust_Client_Activity_Adminslist.php"); // No matching record, return to list
				}
				break;
			Case "U": // Update
				$sReturnUrl = $this->getReturnUrl();
				if (ew_GetPageName($sReturnUrl) == "Cust_Client_Activity_Adminslist.php")
					$sReturnUrl = $this->AddMasterUrl($sReturnUrl); // List page, return to list page with correct master key if necessary
				$this->SendEmail = TRUE; // Send email on update success
				if ($this->EditRow()) { // Update record based on key
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage($Language->Phrase("UpdateSuccess")); // Update success
					$this->Page_Terminate($sReturnUrl); // Return to caller
				} elseif ($this->getFailureMessage() == $Language->Phrase("NoRecord")) {
					$this->Page_Terminate($sReturnUrl); // Return to caller
				} else {
					$this->EventCancelled = TRUE; // Event cancelled
					$this->RestoreFormValues(); // Restore form values if update failed
				}
		}

		// Set up Breadcrumb
		$this->SetupBreadcrumb();

		// Render the record
		$this->RowType = EW_ROWTYPE_EDIT; // Render as Edit
		$this->ResetAttrs();
		$this->RenderRow();
	}

	// Set up starting record parameters
	function SetUpStartRec() {
		if ($this->DisplayRecs == 0)
			return;
		if ($this->IsPageRequest()) { // Validate request
			if (@$_GET[EW_TABLE_START_REC] <> "") { // Check for "start" parameter
				$this->StartRec = $_GET[EW_TABLE_START_REC];
				$this->setStartRecordNumber($this->StartRec);
			} elseif (@$_GET[EW_TABLE_PAGE_NO] <> "") {
				$PageNo = $_GET[EW_TABLE_PAGE_NO];
				if (is_numeric($PageNo)) {
					$this->StartRec = ($PageNo-1)*$this->DisplayRecs+1;
					if ($this->StartRec <= 0) {
						$this->StartRec = 1;
					} elseif ($this->StartRec >= intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1) {
						$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1;
					}
					$this->setStartRecordNumber($this->StartRec);
				}
			}
		}
		$this->StartRec = $this->getStartRecordNumber();

		// Check if correct start record counter
		if (!is_numeric($this->StartRec) || $this->StartRec == "") { // Avoid invalid start record counter
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} elseif (intval($this->StartRec) > intval($this->TotalRecs)) { // Avoid starting record > total records
			$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to last page first record
			$this->setStartRecordNumber($this->StartRec);
		} elseif (($this->StartRec-1) % $this->DisplayRecs <> 0) {
			$this->StartRec = intval(($this->StartRec-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to page boundary
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Get upload files
	function GetUploadFiles() {
		global $objForm, $Language;

		// Get upload data
	}

	// Load form values
	function LoadFormValues() {

		// Load from form
		global $objForm;
		if (!$this->dbkey_councilor->FldIsDetailKey) {
			$this->dbkey_councilor->setFormValue($objForm->GetValue("x_dbkey_councilor"));
		}
		if (!$this->dbkey_client->FldIsDetailKey) {
			$this->dbkey_client->setFormValue($objForm->GetValue("x_dbkey_client"));
		}
		if (!$this->date->FldIsDetailKey) {
			$this->date->setFormValue($objForm->GetValue("x_date"));
			$this->date->CurrentValue = ew_UnFormatDateTime($this->date->CurrentValue, 1);
		}
		if (!$this->time->FldIsDetailKey) {
			$this->time->setFormValue($objForm->GetValue("x_time"));
		}
		if (!$this->comment->FldIsDetailKey) {
			$this->comment->setFormValue($objForm->GetValue("x_comment"));
		}
		if (!$this->dbkey_activity->FldIsDetailKey) {
			$this->dbkey_activity->setFormValue($objForm->GetValue("x_dbkey_activity"));
		}
		if (!$this->Rate->FldIsDetailKey) {
			$this->Rate->setFormValue($objForm->GetValue("x_Rate"));
		}
		if (!$this->Client_Type->FldIsDetailKey) {
			$this->Client_Type->setFormValue($objForm->GetValue("x_Client_Type"));
		}
		if (!$this->Contract_ID->FldIsDetailKey) {
			$this->Contract_ID->setFormValue($objForm->GetValue("x_Contract_ID"));
		}
		if (!$this->dbkey->FldIsDetailKey)
			$this->dbkey->setFormValue($objForm->GetValue("x_dbkey"));
	}

	// Restore form values
	function RestoreFormValues() {
		global $objForm;
		$this->LoadRow();
		$this->dbkey->CurrentValue = $this->dbkey->FormValue;
		$this->dbkey_councilor->CurrentValue = $this->dbkey_councilor->FormValue;
		$this->dbkey_client->CurrentValue = $this->dbkey_client->FormValue;
		$this->date->CurrentValue = $this->date->FormValue;
		$this->date->CurrentValue = ew_UnFormatDateTime($this->date->CurrentValue, 1);
		$this->time->CurrentValue = $this->time->FormValue;
		$this->comment->CurrentValue = $this->comment->FormValue;
		$this->dbkey_activity->CurrentValue = $this->dbkey_activity->FormValue;
		$this->Rate->CurrentValue = $this->Rate->FormValue;
		$this->Client_Type->CurrentValue = $this->Client_Type->FormValue;
		$this->Contract_ID->CurrentValue = $this->Contract_ID->FormValue;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->dbkey_councilor->setDbValue($rs->fields('dbkey_councilor'));
		if (array_key_exists('EV__dbkey_councilor', $rs->fields)) {
			$this->dbkey_councilor->VirtualValue = $rs->fields('EV__dbkey_councilor'); // Set up virtual field value
		} else {
			$this->dbkey_councilor->VirtualValue = ""; // Clear value
		}
		$this->dbkey_client->setDbValue($rs->fields('dbkey_client'));
		if (array_key_exists('EV__dbkey_client', $rs->fields)) {
			$this->dbkey_client->VirtualValue = $rs->fields('EV__dbkey_client'); // Set up virtual field value
		} else {
			$this->dbkey_client->VirtualValue = ""; // Clear value
		}
		$this->date->setDbValue($rs->fields('date'));
		$this->time->setDbValue($rs->fields('time'));
		$this->comment->setDbValue($rs->fields('comment'));
		$this->dbkey_activity->setDbValue($rs->fields('dbkey_activity'));
		$this->dbkey_activity_list->setDbValue($rs->fields('dbkey_activity_list'));
		$this->attachment->Upload->DbValue = $rs->fields('attachment');
		$this->attachment->CurrentValue = $this->attachment->Upload->DbValue;
		$this->Rate->setDbValue($rs->fields('Rate'));
		$this->Client_Type->setDbValue($rs->fields('Client_Type'));
		$this->Contract_ID->setDbValue($rs->fields('Contract_ID'));
		$this->created_by->setDbValue($rs->fields('created_by'));
		$this->created_on->setDbValue($rs->fields('created_on'));
		$this->updated_by->setDbValue($rs->fields('updated_by'));
		$this->updated_on->setDbValue($rs->fields('updated_on'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey->DbValue = $row['dbkey'];
		$this->dbkey_councilor->DbValue = $row['dbkey_councilor'];
		$this->dbkey_client->DbValue = $row['dbkey_client'];
		$this->date->DbValue = $row['date'];
		$this->time->DbValue = $row['time'];
		$this->comment->DbValue = $row['comment'];
		$this->dbkey_activity->DbValue = $row['dbkey_activity'];
		$this->dbkey_activity_list->DbValue = $row['dbkey_activity_list'];
		$this->attachment->Upload->DbValue = $row['attachment'];
		$this->Rate->DbValue = $row['Rate'];
		$this->Client_Type->DbValue = $row['Client_Type'];
		$this->Contract_ID->DbValue = $row['Contract_ID'];
		$this->created_by->DbValue = $row['created_by'];
		$this->created_on->DbValue = $row['created_on'];
		$this->updated_by->DbValue = $row['updated_by'];
		$this->updated_on->DbValue = $row['updated_on'];
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Convert decimal values if posted back

		if ($this->time->FormValue == $this->time->CurrentValue && is_numeric(ew_StrToFloat($this->time->CurrentValue)))
			$this->time->CurrentValue = ew_StrToFloat($this->time->CurrentValue);

		// Convert decimal values if posted back
		if ($this->Rate->FormValue == $this->Rate->CurrentValue && is_numeric(ew_StrToFloat($this->Rate->CurrentValue)))
			$this->Rate->CurrentValue = ew_StrToFloat($this->Rate->CurrentValue);

		// Call Row_Rendering event
		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey
		// dbkey_councilor
		// dbkey_client
		// date
		// time
		// comment
		// dbkey_activity
		// dbkey_activity_list
		// attachment
		// Rate
		// Client_Type
		// Contract_ID
		// created_by
		// created_on
		// updated_by
		// updated_on

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// dbkey_councilor
		if ($this->dbkey_councilor->VirtualValue <> "") {
			$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->VirtualValue;
		} else {
		if (strval($this->dbkey_councilor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->dbkey_councilor->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_councilor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->CurrentValue;
			}
		} else {
			$this->dbkey_councilor->ViewValue = NULL;
		}
		}
		$this->dbkey_councilor->ViewCustomAttributes = "";

		// dbkey_client
		if ($this->dbkey_client->VirtualValue <> "") {
			$this->dbkey_client->ViewValue = $this->dbkey_client->VirtualValue;
		} else {
		if (strval($this->dbkey_client->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		$this->dbkey_client->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_client->ViewValue = $this->dbkey_client->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_client->ViewValue = $this->dbkey_client->CurrentValue;
			}
		} else {
			$this->dbkey_client->ViewValue = NULL;
		}
		}
		$this->dbkey_client->ViewCustomAttributes = "";

		// date
		$this->date->ViewValue = $this->date->CurrentValue;
		$this->date->ViewValue = ew_FormatDateTime($this->date->ViewValue, 1);
		$this->date->ViewCustomAttributes = "";

		// time
		$this->time->ViewValue = $this->time->CurrentValue;
		$this->time->ViewCustomAttributes = "";

		// comment
		$this->comment->ViewValue = $this->comment->CurrentValue;
		$this->comment->ViewCustomAttributes = "";

		// dbkey_activity
		if (strval($this->dbkey_activity->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey_activity`" . ew_SearchString("=", $this->dbkey_activity->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey_activity`, (select activity.description from activity where activity.dbkey = dbkey_activity) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client_to_activity_code`";
		$sWhereWrk = "";
		$this->dbkey_activity->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->CurrentValue;
			}
		} else {
			$this->dbkey_activity->ViewValue = NULL;
		}
		$this->dbkey_activity->ViewCustomAttributes = "";

		// Rate
		$this->Rate->ViewValue = $this->Rate->CurrentValue;
		$this->Rate->ViewValue = ew_FormatNumber($this->Rate->ViewValue, 3, -2, -2, -2);
		$this->Rate->ViewCustomAttributes = "";

		// Client_Type
		$this->Client_Type->ViewValue = $this->Client_Type->CurrentValue;
		if (strval($this->Client_Type->CurrentValue) <> "") {
			$sFilterWrk = "`code`" . ew_SearchString("=", $this->Client_Type->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT `code`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `waivered`";
		$sWhereWrk = "";
		$this->Client_Type->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->Client_Type, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->Client_Type->ViewValue = $this->Client_Type->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->Client_Type->ViewValue = $this->Client_Type->CurrentValue;
			}
		} else {
			$this->Client_Type->ViewValue = NULL;
		}
		$this->Client_Type->ViewCustomAttributes = "";

		// Contract_ID
		$this->Contract_ID->ViewValue = $this->Contract_ID->CurrentValue;
		$this->Contract_ID->ViewCustomAttributes = "";

		// created_by
		if (strval($this->created_by->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->created_by->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->created_by->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->created_by, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->created_by->ViewValue = $this->created_by->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->created_by->ViewValue = $this->created_by->CurrentValue;
			}
		} else {
			$this->created_by->ViewValue = NULL;
		}
		$this->created_by->ViewCustomAttributes = "";

		// created_on
		$this->created_on->ViewValue = $this->created_on->CurrentValue;
		$this->created_on->ViewValue = ew_FormatDateTime($this->created_on->ViewValue, 1);
		$this->created_on->ViewCustomAttributes = "";

		// updated_by
		if (strval($this->updated_by->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->updated_by->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->updated_by->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->updated_by, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->updated_by->ViewValue = $this->updated_by->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->updated_by->ViewValue = $this->updated_by->CurrentValue;
			}
		} else {
			$this->updated_by->ViewValue = NULL;
		}
		$this->updated_by->ViewCustomAttributes = "";

		// updated_on
		$this->updated_on->ViewValue = $this->updated_on->CurrentValue;
		$this->updated_on->ViewValue = ew_FormatDateTime($this->updated_on->ViewValue, 1);
		$this->updated_on->ViewCustomAttributes = "";

			// dbkey_councilor
			$this->dbkey_councilor->LinkCustomAttributes = "";
			$this->dbkey_councilor->HrefValue = "";
			$this->dbkey_councilor->TooltipValue = "";

			// dbkey_client
			$this->dbkey_client->LinkCustomAttributes = "";
			$this->dbkey_client->HrefValue = "";
			$this->dbkey_client->TooltipValue = "";

			// date
			$this->date->LinkCustomAttributes = "";
			$this->date->HrefValue = "";
			$this->date->TooltipValue = "";

			// time
			$this->time->LinkCustomAttributes = "";
			$this->time->HrefValue = "";
			$this->time->TooltipValue = "";

			// comment
			$this->comment->LinkCustomAttributes = "";
			$this->comment->HrefValue = "";
			$this->comment->TooltipValue = "";

			// dbkey_activity
			$this->dbkey_activity->LinkCustomAttributes = "";
			$this->dbkey_activity->HrefValue = "";
			$this->dbkey_activity->TooltipValue = "";

			// Rate
			$this->Rate->LinkCustomAttributes = "";
			$this->Rate->HrefValue = "";
			$this->Rate->TooltipValue = "";

			// Client_Type
			$this->Client_Type->LinkCustomAttributes = "";
			$this->Client_Type->HrefValue = "";
			$this->Client_Type->TooltipValue = "";

			// Contract_ID
			$this->Contract_ID->LinkCustomAttributes = "";
			$this->Contract_ID->HrefValue = "";
			$this->Contract_ID->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_EDIT) { // Edit row

			// dbkey_councilor
			$this->dbkey_councilor->EditAttrs["class"] = "form-control";
			$this->dbkey_councilor->EditCustomAttributes = "";
			if (trim(strval($this->dbkey_councilor->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `counselor`";
			$sWhereWrk = "";
			$this->dbkey_councilor->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			if (!$GLOBALS["Cust_Client_Activity_Admins"]->UserIDAllow("edit")) $sWhereWrk = $GLOBALS["counselor"]->AddUserIDFilter($sWhereWrk);
			$this->Lookup_Selecting($this->dbkey_councilor, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->dbkey_councilor->EditValue = $arwrk;

			// dbkey_client
			$this->dbkey_client->EditAttrs["class"] = "form-control";
			$this->dbkey_client->EditCustomAttributes = "";
			if (trim(strval($this->dbkey_client->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `client`";
			$sWhereWrk = "";
			$this->dbkey_client->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->dbkey_client->EditValue = $arwrk;

			// date
			$this->date->EditAttrs["class"] = "form-control";
			$this->date->EditCustomAttributes = "";
			$this->date->EditValue = ew_HtmlEncode(ew_FormatDateTime($this->date->CurrentValue, 8));
			$this->date->PlaceHolder = ew_RemoveHtml($this->date->FldCaption());

			// time
			$this->time->EditAttrs["class"] = "form-control";
			$this->time->EditCustomAttributes = "";
			$this->time->EditValue = ew_HtmlEncode($this->time->CurrentValue);
			$this->time->PlaceHolder = ew_RemoveHtml($this->time->FldCaption());
			if (strval($this->time->EditValue) <> "" && is_numeric($this->time->EditValue)) $this->time->EditValue = ew_FormatNumber($this->time->EditValue, -2, -1, -2, 0);

			// comment
			$this->comment->EditAttrs["class"] = "form-control";
			$this->comment->EditCustomAttributes = "";
			$this->comment->EditValue = ew_HtmlEncode($this->comment->CurrentValue);
			$this->comment->PlaceHolder = ew_RemoveHtml($this->comment->FldCaption());

			// dbkey_activity
			$this->dbkey_activity->EditAttrs["class"] = "form-control";
			$this->dbkey_activity->EditCustomAttributes = "";
			if (trim(strval($this->dbkey_activity->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey_activity`" . ew_SearchString("=", $this->dbkey_activity->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT `dbkey_activity`, (select activity.description from activity where activity.dbkey = dbkey_activity) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, `dbkey_client` AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `client_to_activity_code`";
			$sWhereWrk = "";
			$this->dbkey_activity->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->dbkey_activity->EditValue = $arwrk;

			// Rate
			$this->Rate->EditAttrs["class"] = "form-control";
			$this->Rate->EditCustomAttributes = "";
			$this->Rate->EditValue = $this->Rate->CurrentValue;
			$this->Rate->EditValue = ew_FormatNumber($this->Rate->EditValue, 3, -2, -2, -2);
			$this->Rate->ViewCustomAttributes = "";

			// Client_Type
			$this->Client_Type->EditAttrs["class"] = "form-control";
			$this->Client_Type->EditCustomAttributes = "";
			$this->Client_Type->EditValue = $this->Client_Type->CurrentValue;
			if (strval($this->Client_Type->CurrentValue) <> "") {
				$sFilterWrk = "`code`" . ew_SearchString("=", $this->Client_Type->CurrentValue, EW_DATATYPE_STRING, "");
			$sSqlWrk = "SELECT `code`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `waivered`";
			$sWhereWrk = "";
			$this->Client_Type->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->Client_Type, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
				$rswrk = Conn()->Execute($sSqlWrk);
				if ($rswrk && !$rswrk->EOF) { // Lookup values found
					$arwrk = array();
					$arwrk[1] = $rswrk->fields('DispFld');
					$this->Client_Type->EditValue = $this->Client_Type->DisplayValue($arwrk);
					$rswrk->Close();
				} else {
					$this->Client_Type->EditValue = $this->Client_Type->CurrentValue;
				}
			} else {
				$this->Client_Type->EditValue = NULL;
			}
			$this->Client_Type->ViewCustomAttributes = "";

			// Contract_ID
			$this->Contract_ID->EditAttrs["class"] = "form-control";
			$this->Contract_ID->EditCustomAttributes = "";
			$this->Contract_ID->EditValue = ew_HtmlEncode($this->Contract_ID->CurrentValue);
			$this->Contract_ID->PlaceHolder = ew_RemoveHtml($this->Contract_ID->FldCaption());

			// Edit refer script
			// dbkey_councilor

			$this->dbkey_councilor->LinkCustomAttributes = "";
			$this->dbkey_councilor->HrefValue = "";

			// dbkey_client
			$this->dbkey_client->LinkCustomAttributes = "";
			$this->dbkey_client->HrefValue = "";

			// date
			$this->date->LinkCustomAttributes = "";
			$this->date->HrefValue = "";

			// time
			$this->time->LinkCustomAttributes = "";
			$this->time->HrefValue = "";

			// comment
			$this->comment->LinkCustomAttributes = "";
			$this->comment->HrefValue = "";

			// dbkey_activity
			$this->dbkey_activity->LinkCustomAttributes = "";
			$this->dbkey_activity->HrefValue = "";

			// Rate
			$this->Rate->LinkCustomAttributes = "";
			$this->Rate->HrefValue = "";
			$this->Rate->TooltipValue = "";

			// Client_Type
			$this->Client_Type->LinkCustomAttributes = "";
			$this->Client_Type->HrefValue = "";
			$this->Client_Type->TooltipValue = "";

			// Contract_ID
			$this->Contract_ID->LinkCustomAttributes = "";
			$this->Contract_ID->HrefValue = "";
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate form
	function ValidateForm() {
		global $Language, $gsFormError;

		// Initialize form error message
		$gsFormError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return ($gsFormError == "");
		if (!$this->dbkey_councilor->FldIsDetailKey && !is_null($this->dbkey_councilor->FormValue) && $this->dbkey_councilor->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->dbkey_councilor->FldCaption(), $this->dbkey_councilor->ReqErrMsg));
		}
		if (!$this->dbkey_client->FldIsDetailKey && !is_null($this->dbkey_client->FormValue) && $this->dbkey_client->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->dbkey_client->FldCaption(), $this->dbkey_client->ReqErrMsg));
		}
		if (!ew_CheckDateDef($this->date->FormValue)) {
			ew_AddMessage($gsFormError, $this->date->FldErrMsg());
		}
		if (!$this->time->FldIsDetailKey && !is_null($this->time->FormValue) && $this->time->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->time->FldCaption(), $this->time->ReqErrMsg));
		}
		if (!ew_CheckNumber($this->time->FormValue)) {
			ew_AddMessage($gsFormError, $this->time->FldErrMsg());
		}
		if (!$this->comment->FldIsDetailKey && !is_null($this->comment->FormValue) && $this->comment->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->comment->FldCaption(), $this->comment->ReqErrMsg));
		}
		if (!$this->dbkey_activity->FldIsDetailKey && !is_null($this->dbkey_activity->FormValue) && $this->dbkey_activity->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->dbkey_activity->FldCaption(), $this->dbkey_activity->ReqErrMsg));
		}

		// Return validate result
		$ValidateForm = ($gsFormError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateForm = $ValidateForm && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsFormError, $sFormCustomError);
		}
		return $ValidateForm;
	}

	// Update record based on key values
	function EditRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$conn = &$this->Connection();
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
		$rs = $conn->Execute($sSql);
		$conn->raiseErrorFn = '';
		if ($rs === FALSE)
			return FALSE;
		if ($rs->EOF) {
			$this->setFailureMessage($Language->Phrase("NoRecord")); // Set no record message
			$EditRow = FALSE; // Update Failed
		} else {

			// Save old values
			$rsold = &$rs->fields;
			$this->LoadDbValues($rsold);
			$rsnew = array();

			// dbkey_councilor
			$this->dbkey_councilor->SetDbValueDef($rsnew, $this->dbkey_councilor->CurrentValue, 0, $this->dbkey_councilor->ReadOnly);

			// dbkey_client
			$this->dbkey_client->SetDbValueDef($rsnew, $this->dbkey_client->CurrentValue, 0, $this->dbkey_client->ReadOnly);

			// date
			$this->date->SetDbValueDef($rsnew, ew_UnFormatDateTime($this->date->CurrentValue, 1), NULL, $this->date->ReadOnly);

			// time
			$this->time->SetDbValueDef($rsnew, $this->time->CurrentValue, 0, $this->time->ReadOnly);

			// comment
			$this->comment->SetDbValueDef($rsnew, $this->comment->CurrentValue, NULL, $this->comment->ReadOnly);

			// dbkey_activity
			$this->dbkey_activity->SetDbValueDef($rsnew, $this->dbkey_activity->CurrentValue, 0, $this->dbkey_activity->ReadOnly);

			// Call Row Updating event
			$bUpdateRow = $this->Row_Updating($rsold, $rsnew);
			if ($bUpdateRow) {
				$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
				if (count($rsnew) > 0)
					$EditRow = $this->Update($rsnew, "", $rsold);
				else
					$EditRow = TRUE; // No field to update
				$conn->raiseErrorFn = '';
				if ($EditRow) {
				}
			} else {
				if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

					// Use the message, do nothing
				} elseif ($this->CancelMessage <> "") {
					$this->setFailureMessage($this->CancelMessage);
					$this->CancelMessage = "";
				} else {
					$this->setFailureMessage($Language->Phrase("UpdateCancelled"));
				}
				$EditRow = FALSE;
			}
		}

		// Call Row_Updated event
		if ($EditRow)
			$this->Row_Updated($rsold, $rsnew);
		if ($EditRow) {
			$this->WriteAuditTrailOnEdit($rsold, $rsnew);
		}
		$rs->Close();
		return $EditRow;
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, $this->AddMasterUrl("Cust_Client_Activity_Adminslist.php"), "", $this->TableVar, TRUE);
		$PageId = "edit";
		$Breadcrumb->Add("edit", $PageId, $url);
	}

	// Setup lookup filters of a field
	function SetupLookupFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		case "x_dbkey_councilor":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT DISTINCT `dbkey` AS `LinkFld`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
			$sWhereWrk = "";
			$this->dbkey_councilor->LookupFilters = array();
			if (!$GLOBALS["Cust_Client_Activity_Admins"]->UserIDAllow("edit")) $sWhereWrk = $GLOBALS["counselor"]->AddUserIDFilter($sWhereWrk);
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey` = {filter_value}', "t0" => "3", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->dbkey_councilor, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last` ASC";
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		case "x_dbkey_client":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT DISTINCT `dbkey` AS `LinkFld`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
			$sWhereWrk = "";
			$this->dbkey_client->LookupFilters = array();
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey` = {filter_value}', "t0" => "3", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last` ASC";
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		case "x_dbkey_activity":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT `dbkey_activity` AS `LinkFld`, (select activity.description from activity where activity.dbkey = dbkey_activity) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client_to_activity_code`";
			$sWhereWrk = "{filter}";
			$this->dbkey_activity->LookupFilters = array();
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey_activity` = {filter_value}', "t0" => "3", "fn0" => "", "f1" => '`dbkey_client` IN ({filter_value})', "t1" => "3", "fn1" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		}
	}

	// Setup AutoSuggest filters of a field
	function SetupAutoSuggestFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Write Audit Trail start/end for grid update
	function WriteAuditTrailDummy($typ) {
		$table = 'Cust_Client_Activity_Admins';
		$usr = CurrentUserID();
		ew_WriteAuditTrail("log", ew_StdCurrentDateTime(), ew_ScriptName(), $usr, $typ, $table, "", "", "", "");
	}

	// Write Audit Trail (edit page)
	function WriteAuditTrailOnEdit(&$rsold, &$rsnew) {
		global $Language;
		if (!$this->AuditTrailOnEdit) return;
		$table = 'Cust_Client_Activity_Admins';

		// Get key value
		$key = "";
		if ($key <> "") $key .= $GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"];
		$key .= $rsold['dbkey'];

		// Write Audit Trail
		$dt = ew_StdCurrentDateTime();
		$id = ew_ScriptName();
		$usr = CurrentUserID();
		foreach (array_keys($rsnew) as $fldname) {
			if ($this->fields[$fldname]->FldDataType <> EW_DATATYPE_BLOB) { // Ignore BLOB fields
				if ($this->fields[$fldname]->FldDataType == EW_DATATYPE_DATE) { // DateTime field
					$modified = (ew_FormatDateTime($rsold[$fldname], 0) <> ew_FormatDateTime($rsnew[$fldname], 0));
				} else {
					$modified = !ew_CompareValue($rsold[$fldname], $rsnew[$fldname]);
				}
				if ($modified) {
					if ($this->fields[$fldname]->FldHtmlTag == "PASSWORD") { // Password Field
						$oldvalue = $Language->Phrase("PasswordMask");
						$newvalue = $Language->Phrase("PasswordMask");
					} elseif ($this->fields[$fldname]->FldDataType == EW_DATATYPE_MEMO) { // Memo field
						if (EW_AUDIT_TRAIL_TO_DATABASE) {
							$oldvalue = $rsold[$fldname];
							$newvalue = $rsnew[$fldname];
						} else {
							$oldvalue = "[MEMO]";
							$newvalue = "[MEMO]";
						}
					} elseif ($this->fields[$fldname]->FldDataType == EW_DATATYPE_XML) { // XML field
						$oldvalue = "[XML]";
						$newvalue = "[XML]";
					} else {
						$oldvalue = $rsold[$fldname];
						$newvalue = $rsnew[$fldname];
					}
					ew_WriteAuditTrail("log", $dt, $id, $usr, "U", $table, $fldname, $key, $oldvalue, $newvalue);
				}
			}
		}
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($Cust_Client_Activity_Admins_edit)) $Cust_Client_Activity_Admins_edit = new cCust_Client_Activity_Admins_edit();

// Page init
$Cust_Client_Activity_Admins_edit->Page_Init();

// Page main
$Cust_Client_Activity_Admins_edit->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$Cust_Client_Activity_Admins_edit->Page_Render();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "edit";
var CurrentForm = fCust_Client_Activity_Adminsedit = new ew_Form("fCust_Client_Activity_Adminsedit", "edit");

// Validate form
fCust_Client_Activity_Adminsedit.Validate = function() {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	var $ = jQuery, fobj = this.GetForm(), $fobj = $(fobj);
	if ($fobj.find("#a_confirm").val() == "F")
		return true;
	var elm, felm, uelm, addcnt = 0;
	var $k = $fobj.find("#" + this.FormKeyCountName); // Get key_count
	var rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1;
	var startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
	var gridinsert = $fobj.find("#a_list").val() == "gridinsert";
	for (var i = startcnt; i <= rowcnt; i++) {
		var infix = ($k[0]) ? String(i) : "";
		$fobj.data("rowindex", infix);
			elm = this.GetElements("x" + infix + "_dbkey_councilor");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $Cust_Client_Activity_Admins->dbkey_councilor->FldCaption(), $Cust_Client_Activity_Admins->dbkey_councilor->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_dbkey_client");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $Cust_Client_Activity_Admins->dbkey_client->FldCaption(), $Cust_Client_Activity_Admins->dbkey_client->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_date");
			if (elm && !ew_CheckDateDef(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($Cust_Client_Activity_Admins->date->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_time");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $Cust_Client_Activity_Admins->time->FldCaption(), $Cust_Client_Activity_Admins->time->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_time");
			if (elm && !ew_CheckNumber(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($Cust_Client_Activity_Admins->time->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_comment");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $Cust_Client_Activity_Admins->comment->FldCaption(), $Cust_Client_Activity_Admins->comment->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_dbkey_activity");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $Cust_Client_Activity_Admins->dbkey_activity->FldCaption(), $Cust_Client_Activity_Admins->dbkey_activity->ReqErrMsg)) ?>");

			// Fire Form_CustomValidate event
			if (!this.Form_CustomValidate(fobj))
				return false;
	}

	// Process detail forms
	var dfs = $fobj.find("input[name='detailpage']").get();
	for (var i = 0; i < dfs.length; i++) {
		var df = dfs[i], val = df.value;
		if (val && ewForms[val])
			if (!ewForms[val].Validate())
				return false;
	}
	return true;
}

// Form_CustomValidate event
fCust_Client_Activity_Adminsedit.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fCust_Client_Activity_Adminsedit.ValidateRequired = true;
<?php } else { ?>
fCust_Client_Activity_Adminsedit.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fCust_Client_Activity_Adminsedit.Lists["x_dbkey_councilor"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_last","x_first","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"counselor"};
fCust_Client_Activity_Adminsedit.Lists["x_dbkey_client"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_last","x_first","",""],"ParentFields":[],"ChildFields":["x_dbkey_activity"],"FilterFields":[],"Options":[],"Template":"","LinkTable":"client"};
fCust_Client_Activity_Adminsedit.Lists["x_dbkey_activity"] = {"LinkField":"x_dbkey_activity","Ajax":true,"AutoFill":false,"DisplayFields":["x_activity_description","","",""],"ParentFields":["x_dbkey_client"],"ChildFields":[],"FilterFields":["x_dbkey_client"],"Options":[],"Template":"","LinkTable":"client_to_activity_code"};
fCust_Client_Activity_Adminsedit.Lists["x_Client_Type"] = {"LinkField":"x_code","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"waivered"};

// Form object for search
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php if (!$Cust_Client_Activity_Admins_edit->IsModal) { ?>
<div class="ewToolbar">
<?php $Breadcrumb->Render(); ?>
<?php echo $Language->SelectionForm(); ?>
<div class="clearfix"></div>
</div>
<?php } ?>
<?php $Cust_Client_Activity_Admins_edit->ShowPageHeader(); ?>
<?php
$Cust_Client_Activity_Admins_edit->ShowMessage();
?>
<form name="fCust_Client_Activity_Adminsedit" id="fCust_Client_Activity_Adminsedit" class="<?php echo $Cust_Client_Activity_Admins_edit->FormClassName ?>" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($Cust_Client_Activity_Admins_edit->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $Cust_Client_Activity_Admins_edit->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="Cust_Client_Activity_Admins">
<input type="hidden" name="a_edit" id="a_edit" value="U">
<?php if ($Cust_Client_Activity_Admins_edit->IsModal) { ?>
<input type="hidden" name="modal" value="1">
<?php } ?>
<div>
<?php if ($Cust_Client_Activity_Admins->dbkey_councilor->Visible) { // dbkey_councilor ?>
	<div id="r_dbkey_councilor" class="form-group">
		<label id="elh_Cust_Client_Activity_Admins_dbkey_councilor" for="x_dbkey_councilor" class="col-sm-2 control-label ewLabel"><?php echo $Cust_Client_Activity_Admins->dbkey_councilor->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_Client_Activity_Admins->dbkey_councilor->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_dbkey_councilor">
<select data-table="Cust_Client_Activity_Admins" data-field="x_dbkey_councilor" data-value-separator="<?php echo $Cust_Client_Activity_Admins->dbkey_councilor->DisplayValueSeparatorAttribute() ?>" id="x_dbkey_councilor" name="x_dbkey_councilor"<?php echo $Cust_Client_Activity_Admins->dbkey_councilor->EditAttributes() ?>>
<?php echo $Cust_Client_Activity_Admins->dbkey_councilor->SelectOptionListHtml("x_dbkey_councilor") ?>
</select>
<input type="hidden" name="s_x_dbkey_councilor" id="s_x_dbkey_councilor" value="<?php echo $Cust_Client_Activity_Admins->dbkey_councilor->LookupFilterQuery() ?>">
</span>
<?php echo $Cust_Client_Activity_Admins->dbkey_councilor->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->dbkey_client->Visible) { // dbkey_client ?>
	<div id="r_dbkey_client" class="form-group">
		<label id="elh_Cust_Client_Activity_Admins_dbkey_client" for="x_dbkey_client" class="col-sm-2 control-label ewLabel"><?php echo $Cust_Client_Activity_Admins->dbkey_client->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_Client_Activity_Admins->dbkey_client->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_dbkey_client">
<?php $Cust_Client_Activity_Admins->dbkey_client->EditAttrs["onchange"] = "ew_UpdateOpt.call(this); " . @$Cust_Client_Activity_Admins->dbkey_client->EditAttrs["onchange"]; ?>
<select data-table="Cust_Client_Activity_Admins" data-field="x_dbkey_client" data-value-separator="<?php echo $Cust_Client_Activity_Admins->dbkey_client->DisplayValueSeparatorAttribute() ?>" id="x_dbkey_client" name="x_dbkey_client"<?php echo $Cust_Client_Activity_Admins->dbkey_client->EditAttributes() ?>>
<?php echo $Cust_Client_Activity_Admins->dbkey_client->SelectOptionListHtml("x_dbkey_client") ?>
</select>
<input type="hidden" name="s_x_dbkey_client" id="s_x_dbkey_client" value="<?php echo $Cust_Client_Activity_Admins->dbkey_client->LookupFilterQuery() ?>">
</span>
<?php echo $Cust_Client_Activity_Admins->dbkey_client->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->date->Visible) { // date ?>
	<div id="r_date" class="form-group">
		<label id="elh_Cust_Client_Activity_Admins_date" for="x_date" class="col-sm-2 control-label ewLabel"><?php echo $Cust_Client_Activity_Admins->date->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_Client_Activity_Admins->date->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_date">
<input type="text" data-table="Cust_Client_Activity_Admins" data-field="x_date" data-format="1" name="x_date" id="x_date" placeholder="<?php echo ew_HtmlEncode($Cust_Client_Activity_Admins->date->getPlaceHolder()) ?>" value="<?php echo $Cust_Client_Activity_Admins->date->EditValue ?>"<?php echo $Cust_Client_Activity_Admins->date->EditAttributes() ?>>
<?php if (!$Cust_Client_Activity_Admins->date->ReadOnly && !$Cust_Client_Activity_Admins->date->Disabled && !isset($Cust_Client_Activity_Admins->date->EditAttrs["readonly"]) && !isset($Cust_Client_Activity_Admins->date->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fCust_Client_Activity_Adminsedit", "x_date", 1);
</script>
<?php } ?>
</span>
<?php echo $Cust_Client_Activity_Admins->date->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->time->Visible) { // time ?>
	<div id="r_time" class="form-group">
		<label id="elh_Cust_Client_Activity_Admins_time" for="x_time" class="col-sm-2 control-label ewLabel"><?php echo $Cust_Client_Activity_Admins->time->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_Client_Activity_Admins->time->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_time">
<input type="text" data-table="Cust_Client_Activity_Admins" data-field="x_time" name="x_time" id="x_time" size="30" placeholder="<?php echo ew_HtmlEncode($Cust_Client_Activity_Admins->time->getPlaceHolder()) ?>" value="<?php echo $Cust_Client_Activity_Admins->time->EditValue ?>"<?php echo $Cust_Client_Activity_Admins->time->EditAttributes() ?>>
</span>
<?php echo $Cust_Client_Activity_Admins->time->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->comment->Visible) { // comment ?>
	<div id="r_comment" class="form-group">
		<label id="elh_Cust_Client_Activity_Admins_comment" class="col-sm-2 control-label ewLabel"><?php echo $Cust_Client_Activity_Admins->comment->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_Client_Activity_Admins->comment->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_comment">
<?php ew_AppendClass($Cust_Client_Activity_Admins->comment->EditAttrs["class"], "editor"); ?>
<textarea data-table="Cust_Client_Activity_Admins" data-field="x_comment" name="x_comment" id="x_comment" cols="35" rows="4" placeholder="<?php echo ew_HtmlEncode($Cust_Client_Activity_Admins->comment->getPlaceHolder()) ?>"<?php echo $Cust_Client_Activity_Admins->comment->EditAttributes() ?>><?php echo $Cust_Client_Activity_Admins->comment->EditValue ?></textarea>
<script type="text/javascript">
ew_CreateEditor("fCust_Client_Activity_Adminsedit", "x_comment", 35, 4, <?php echo ($Cust_Client_Activity_Admins->comment->ReadOnly || FALSE) ? "true" : "false" ?>);
</script>
</span>
<?php echo $Cust_Client_Activity_Admins->comment->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->dbkey_activity->Visible) { // dbkey_activity ?>
	<div id="r_dbkey_activity" class="form-group">
		<label id="elh_Cust_Client_Activity_Admins_dbkey_activity" for="x_dbkey_activity" class="col-sm-2 control-label ewLabel"><?php echo $Cust_Client_Activity_Admins->dbkey_activity->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_Client_Activity_Admins->dbkey_activity->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_dbkey_activity">
<select data-table="Cust_Client_Activity_Admins" data-field="x_dbkey_activity" data-value-separator="<?php echo $Cust_Client_Activity_Admins->dbkey_activity->DisplayValueSeparatorAttribute() ?>" id="x_dbkey_activity" name="x_dbkey_activity"<?php echo $Cust_Client_Activity_Admins->dbkey_activity->EditAttributes() ?>>
<?php echo $Cust_Client_Activity_Admins->dbkey_activity->SelectOptionListHtml("x_dbkey_activity") ?>
</select>
<?php if (AllowAdd(CurrentProjectID() . "client_to_activity_code")) { ?>
<button type="button" title="<?php echo ew_HtmlTitle($Language->Phrase("AddLink")) . "&nbsp;" . $Cust_Client_Activity_Admins->dbkey_activity->FldCaption() ?>" onclick="ew_AddOptDialogShow({lnk:this,el:'x_dbkey_activity',url:'client_to_activity_codeaddopt.php'});" class="ewAddOptBtn btn btn-default btn-sm" id="aol_x_dbkey_activity"><span class="glyphicon glyphicon-plus ewIcon"></span><span class="hide"><?php echo $Language->Phrase("AddLink") ?>&nbsp;<?php echo $Cust_Client_Activity_Admins->dbkey_activity->FldCaption() ?></span></button>
<?php } ?>
<input type="hidden" name="s_x_dbkey_activity" id="s_x_dbkey_activity" value="<?php echo $Cust_Client_Activity_Admins->dbkey_activity->LookupFilterQuery() ?>">
</span>
<?php echo $Cust_Client_Activity_Admins->dbkey_activity->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->Rate->Visible) { // Rate ?>
	<div id="r_Rate" class="form-group">
		<label id="elh_Cust_Client_Activity_Admins_Rate" for="x_Rate" class="col-sm-2 control-label ewLabel"><?php echo $Cust_Client_Activity_Admins->Rate->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_Client_Activity_Admins->Rate->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_Rate">
<span<?php echo $Cust_Client_Activity_Admins->Rate->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $Cust_Client_Activity_Admins->Rate->EditValue ?></p></span>
</span>
<input type="hidden" data-table="Cust_Client_Activity_Admins" data-field="x_Rate" name="x_Rate" id="x_Rate" value="<?php echo ew_HtmlEncode($Cust_Client_Activity_Admins->Rate->CurrentValue) ?>">
<?php echo $Cust_Client_Activity_Admins->Rate->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->Client_Type->Visible) { // Client_Type ?>
	<div id="r_Client_Type" class="form-group">
		<label id="elh_Cust_Client_Activity_Admins_Client_Type" class="col-sm-2 control-label ewLabel"><?php echo $Cust_Client_Activity_Admins->Client_Type->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_Client_Activity_Admins->Client_Type->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_Client_Type">
<span<?php echo $Cust_Client_Activity_Admins->Client_Type->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $Cust_Client_Activity_Admins->Client_Type->EditValue ?></p></span>
</span>
<input type="hidden" data-table="Cust_Client_Activity_Admins" data-field="x_Client_Type" name="x_Client_Type" id="x_Client_Type" value="<?php echo ew_HtmlEncode($Cust_Client_Activity_Admins->Client_Type->CurrentValue) ?>">
<?php echo $Cust_Client_Activity_Admins->Client_Type->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->Contract_ID->Visible) { // Contract_ID ?>
	<div id="r_Contract_ID" class="form-group">
		<label id="elh_Cust_Client_Activity_Admins_Contract_ID" for="x_Contract_ID" class="col-sm-2 control-label ewLabel"><?php echo $Cust_Client_Activity_Admins->Contract_ID->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_Client_Activity_Admins->Contract_ID->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_Contract_ID">
<input type="text" data-table="Cust_Client_Activity_Admins" data-field="x_Contract_ID" name="x_Contract_ID" id="x_Contract_ID" size="30" maxlength="50" placeholder="<?php echo ew_HtmlEncode($Cust_Client_Activity_Admins->Contract_ID->getPlaceHolder()) ?>" value="<?php echo $Cust_Client_Activity_Admins->Contract_ID->EditValue ?>"<?php echo $Cust_Client_Activity_Admins->Contract_ID->EditAttributes() ?>>
</span>
<?php echo $Cust_Client_Activity_Admins->Contract_ID->CustomMsg ?></div></div>
	</div>
<?php } ?>
</div>
<input type="hidden" data-table="Cust_Client_Activity_Admins" data-field="x_dbkey" name="x_dbkey" id="x_dbkey" value="<?php echo ew_HtmlEncode($Cust_Client_Activity_Admins->dbkey->CurrentValue) ?>">
<?php if (!$Cust_Client_Activity_Admins_edit->IsModal) { ?>
<div class="form-group">
	<div class="col-sm-offset-2 col-sm-10">
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit"><?php echo $Language->Phrase("SaveBtn") ?></button>
<button class="btn btn-default ewButton" name="btnCancel" id="btnCancel" type="button" data-href="<?php echo $Cust_Client_Activity_Admins_edit->getReturnUrl() ?>"><?php echo $Language->Phrase("CancelBtn") ?></button>
	</div>
</div>
<?php } ?>
</form>
<script type="text/javascript">
fCust_Client_Activity_Adminsedit.Init();
</script>
<?php
$Cust_Client_Activity_Admins_edit->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$Cust_Client_Activity_Admins_edit->Page_Terminate();
?>
