<?php

// Global variable for table object
$Cust_Client_Activity_Admins = NULL;

//
// Table class for Cust_Client_Activity_Admins
//
class cCust_Client_Activity_Admins extends cTable {
	var $dbkey;
	var $dbkey_councilor;
	var $dbkey_client;
	var $date;
	var $time;
	var $comment;
	var $dbkey_activity;
	var $dbkey_activity_list;
	var $attachment;
	var $Rate;
	var $Client_Type;
	var $Contract_ID;
	var $created_by;
	var $created_on;
	var $updated_by;
	var $updated_on;

	//
	// Table class constructor
	//
	function __construct() {
		global $Language;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();
		$this->TableVar = 'Cust_Client_Activity_Admins';
		$this->TableName = 'Cust_Client_Activity_Admins';
		$this->TableType = 'CUSTOMVIEW';

		// Update Table
		$this->UpdateTable = "client_activity";
		$this->DBID = 'DB';
		$this->ExportAll = TRUE;
		$this->ExportPageBreakCount = 0; // Page break per every n record (PDF only)
		$this->ExportPageOrientation = "portrait"; // Page orientation (PDF only)
		$this->ExportPageSize = "a4"; // Page size (PDF only)
		$this->ExportExcelPageOrientation = ""; // Page orientation (PHPExcel only)
		$this->ExportExcelPageSize = ""; // Page size (PHPExcel only)
		$this->DetailAdd = FALSE; // Allow detail add
		$this->DetailEdit = FALSE; // Allow detail edit
		$this->DetailView = FALSE; // Allow detail view
		$this->ShowMultipleDetails = FALSE; // Show multiple details
		$this->GridAddRowCount = 1;
		$this->AllowAddDeleteRow = ew_AllowAddDeleteRow(); // Allow add/delete row
		$this->UserIDAllowSecurity = 0; // User ID Allow
		$this->BasicSearch = new cBasicSearch($this->TableVar);

		// dbkey
		$this->dbkey = new cField('Cust_Client_Activity_Admins', 'Cust_Client_Activity_Admins', 'x_dbkey', 'dbkey', 'client_activity.dbkey', 'client_activity.dbkey', 3, -1, FALSE, 'client_activity.dbkey', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'NO');
		$this->dbkey->Sortable = TRUE; // Allow sort
		$this->dbkey->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey'] = &$this->dbkey;

		// dbkey_councilor
		$this->dbkey_councilor = new cField('Cust_Client_Activity_Admins', 'Cust_Client_Activity_Admins', 'x_dbkey_councilor', 'dbkey_councilor', 'client_activity.dbkey_councilor', 'client_activity.dbkey_councilor', 3, -1, FALSE, '`EV__dbkey_councilor`', TRUE, TRUE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_councilor->Sortable = TRUE; // Allow sort
		$this->dbkey_councilor->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->dbkey_councilor->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->dbkey_councilor->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_councilor'] = &$this->dbkey_councilor;

		// dbkey_client
		$this->dbkey_client = new cField('Cust_Client_Activity_Admins', 'Cust_Client_Activity_Admins', 'x_dbkey_client', 'dbkey_client', 'client_activity.dbkey_client', 'client_activity.dbkey_client', 3, -1, FALSE, '`EV__dbkey_client`', TRUE, TRUE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_client->Sortable = TRUE; // Allow sort
		$this->dbkey_client->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->dbkey_client->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->dbkey_client->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_client'] = &$this->dbkey_client;

		// date
		$this->date = new cField('Cust_Client_Activity_Admins', 'Cust_Client_Activity_Admins', 'x_date', 'date', 'client_activity.date', ew_CastDateFieldForLike('client_activity.date', 1, "DB"), 135, 1, FALSE, 'client_activity.date', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->date->Sortable = TRUE; // Allow sort
		$this->date->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->date->AdvancedSearch->SearchValueDefault = date("Ymd", strtotime("-1 months"));
		$this->date->AdvancedSearch->SearchOperatorDefault = ">=";
		$this->date->AdvancedSearch->SearchOperatorDefault2 = "<=";
		$this->date->AdvancedSearch->SearchConditionDefault = "AND";
		$this->fields['date'] = &$this->date;

		// time
		$this->time = new cField('Cust_Client_Activity_Admins', 'Cust_Client_Activity_Admins', 'x_time', 'time', 'client_activity.time', 'client_activity.time', 131, -1, FALSE, 'client_activity.time', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->time->Sortable = TRUE; // Allow sort
		$this->time->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['time'] = &$this->time;

		// comment
		$this->comment = new cField('Cust_Client_Activity_Admins', 'Cust_Client_Activity_Admins', 'x_comment', 'comment', 'client_activity.comment', 'client_activity.comment', 201, -1, FALSE, 'client_activity.comment', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXTAREA');
		$this->comment->Sortable = TRUE; // Allow sort
		$this->fields['comment'] = &$this->comment;

		// dbkey_activity
		$this->dbkey_activity = new cField('Cust_Client_Activity_Admins', 'Cust_Client_Activity_Admins', 'x_dbkey_activity', 'dbkey_activity', 'client_activity.dbkey_activity', 'client_activity.dbkey_activity', 3, -1, FALSE, 'client_activity.dbkey_activity', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_activity->Sortable = TRUE; // Allow sort
		$this->dbkey_activity->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->dbkey_activity->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->dbkey_activity->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_activity'] = &$this->dbkey_activity;

		// dbkey_activity_list
		$this->dbkey_activity_list = new cField('Cust_Client_Activity_Admins', 'Cust_Client_Activity_Admins', 'x_dbkey_activity_list', 'dbkey_activity_list', 'dbkey_activity', 'dbkey_activity', 3, -1, FALSE, 'dbkey_activity', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_activity_list->FldIsCustom = TRUE; // Custom field
		$this->dbkey_activity_list->Sortable = TRUE; // Allow sort
		$this->dbkey_activity_list->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->dbkey_activity_list->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->dbkey_activity_list->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_activity_list'] = &$this->dbkey_activity_list;

		// attachment
		$this->attachment = new cField('Cust_Client_Activity_Admins', 'Cust_Client_Activity_Admins', 'x_attachment', 'attachment', 'client_activity.attachment', 'client_activity.attachment', 201, -1, TRUE, 'client_activity.attachment', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'FILE');
		$this->attachment->Sortable = FALSE; // Allow sort
		$this->attachment->UploadMultiple = TRUE;
		$this->attachment->Upload->UploadMultiple = TRUE;
		$this->attachment->UploadMaxFileCount = 0;
		$this->fields['attachment'] = &$this->attachment;

		// Rate
		$this->Rate = new cField('Cust_Client_Activity_Admins', 'Cust_Client_Activity_Admins', 'x_Rate', 'Rate', '`Rate`', '`Rate`', 131, -1, FALSE, '`Rate`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Rate->Sortable = TRUE; // Allow sort
		$this->Rate->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Rate'] = &$this->Rate;

		// Client_Type
		$this->Client_Type = new cField('Cust_Client_Activity_Admins', 'Cust_Client_Activity_Admins', 'x_Client_Type', 'Client_Type', '`Client_Type`', '`Client_Type`', 200, -1, FALSE, '`Client_Type`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Client_Type->Sortable = TRUE; // Allow sort
		$this->fields['Client_Type'] = &$this->Client_Type;

		// Contract_ID
		$this->Contract_ID = new cField('Cust_Client_Activity_Admins', 'Cust_Client_Activity_Admins', 'x_Contract_ID', 'Contract_ID', '`Contract_ID`', '`Contract_ID`', 200, -1, FALSE, '`Contract_ID`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Contract_ID->Sortable = TRUE; // Allow sort
		$this->fields['Contract_ID'] = &$this->Contract_ID;

		// created_by
		$this->created_by = new cField('Cust_Client_Activity_Admins', 'Cust_Client_Activity_Admins', 'x_created_by', 'created_by', '`created_by`', '`created_by`', 3, -1, FALSE, '`created_by`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->created_by->Sortable = TRUE; // Allow sort
		$this->created_by->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->created_by->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->created_by->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['created_by'] = &$this->created_by;

		// created_on
		$this->created_on = new cField('Cust_Client_Activity_Admins', 'Cust_Client_Activity_Admins', 'x_created_on', 'created_on', '`created_on`', ew_CastDateFieldForLike('`created_on`', 1, "DB"), 135, 1, FALSE, '`created_on`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->created_on->Sortable = TRUE; // Allow sort
		$this->created_on->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['created_on'] = &$this->created_on;

		// updated_by
		$this->updated_by = new cField('Cust_Client_Activity_Admins', 'Cust_Client_Activity_Admins', 'x_updated_by', 'updated_by', '`updated_by`', '`updated_by`', 3, -1, FALSE, '`updated_by`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->updated_by->Sortable = TRUE; // Allow sort
		$this->updated_by->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->updated_by->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->updated_by->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['updated_by'] = &$this->updated_by;

		// updated_on
		$this->updated_on = new cField('Cust_Client_Activity_Admins', 'Cust_Client_Activity_Admins', 'x_updated_on', 'updated_on', '`updated_on`', ew_CastDateFieldForLike('`updated_on`', 1, "DB"), 135, 1, FALSE, '`updated_on`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->updated_on->Sortable = TRUE; // Allow sort
		$this->updated_on->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['updated_on'] = &$this->updated_on;
	}

	// Set Field Visibility
	function SetFieldVisibility($fldparm) {
		global $Security;
		return $this->$fldparm->Visible; // Returns original value
	}

	// Single column sort
	function UpdateSort(&$ofld) {
		if ($this->CurrentOrder == $ofld->FldName) {
			$sSortField = $ofld->FldExpression;
			$sLastSort = $ofld->getSort();
			if ($this->CurrentOrderType == "ASC" || $this->CurrentOrderType == "DESC") {
				$sThisSort = $this->CurrentOrderType;
			} else {
				$sThisSort = ($sLastSort == "ASC") ? "DESC" : "ASC";
			}
			$ofld->setSort($sThisSort);
			$this->setSessionOrderBy($sSortField . " " . $sThisSort); // Save to Session
			$sSortFieldList = ($ofld->FldVirtualExpression <> "") ? $ofld->FldVirtualExpression : $sSortField;
			$this->setSessionOrderByList($sSortFieldList . " " . $sThisSort); // Save to Session
		} else {
			$ofld->setSort("");
		}
	}

	// Session ORDER BY for List page
	function getSessionOrderByList() {
		return @$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_ORDER_BY_LIST];
	}

	function setSessionOrderByList($v) {
		$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_ORDER_BY_LIST] = $v;
	}

	// Table level SQL
	var $_SqlFrom = "";

	function getSqlFrom() { // From
		return ($this->_SqlFrom <> "") ? $this->_SqlFrom : "client_activity";
	}

	function SqlFrom() { // For backward compatibility
		return $this->getSqlFrom();
	}

	function setSqlFrom($v) {
		$this->_SqlFrom = $v;
	}
	var $_SqlSelect = "";

	function getSqlSelect() { // Select
		return ($this->_SqlSelect <> "") ? $this->_SqlSelect : "SELECT client_activity.dbkey, client_activity.dbkey_councilor, client_activity.dbkey_client, client_activity.date, client_activity.time, client_activity.comment, client_activity.dbkey_activity, client_activity.attachment, (select rate from client_budget where client_budget.dbkey_client = client_activity.dbkey_client AND client_activity.dbkey_activity = client_budget.dbkey_activity and client_budget.from <= client_activity.date and client_budget.through >= client_activity.date LIMIT 1) As Rate,(SELECT waived FROM client WHERE client.dbkey = client_activity.dbkey_client limit 1) AS Client_Type,(select contractid from client_budget where client_budget.dbkey_client = client_activity.dbkey_client AND client_budget.from <= client_activity.date and client_budget.through >= client_activity.date limit 1) As Contract_ID , created_by, created_on, updated_by, updated_on, dbkey_activity AS `dbkey_activity_list` FROM " . $this->getSqlFrom();
	}

	function SqlSelect() { // For backward compatibility
		return $this->getSqlSelect();
	}

	function setSqlSelect($v) {
		$this->_SqlSelect = $v;
	}
	var $_SqlSelectList = "";

	function getSqlSelectList() { // Select for List page
		$select = "";
		$select = "SELECT * FROM (" .
			"SELECT client_activity.dbkey, client_activity.dbkey_councilor, client_activity.dbkey_client, client_activity.date, client_activity.time, client_activity.comment, client_activity.dbkey_activity, client_activity.attachment, (select rate from client_budget where client_budget.dbkey_client = client_activity.dbkey_client AND client_activity.dbkey_activity = client_budget.dbkey_activity and client_budget.from <= client_activity.date and client_budget.through >= client_activity.date LIMIT 1) As Rate,(SELECT waived FROM client WHERE client.dbkey = client_activity.dbkey_client limit 1) AS Client_Type,(select contractid from client_budget where client_budget.dbkey_client = client_activity.dbkey_client AND client_budget.from <= client_activity.date and client_budget.through >= client_activity.date limit 1) As Contract_ID , created_by, created_on, updated_by, updated_on, dbkey_activity AS `dbkey_activity_list`, (SELECT DISTINCT CONCAT(`last`,'" . ew_ValueSeparator(1, $this->dbkey_councilor) . "',`first`) FROM `counselor` `EW_TMP_LOOKUPTABLE` WHERE `EW_TMP_LOOKUPTABLE`.`dbkey` = client_activity.dbkey_councilor LIMIT 1) AS `EV__dbkey_councilor`, (SELECT DISTINCT CONCAT(`last`,'" . ew_ValueSeparator(1, $this->dbkey_client) . "',`first`) FROM `client` `EW_TMP_LOOKUPTABLE` WHERE `EW_TMP_LOOKUPTABLE`.`dbkey` = client_activity.dbkey_client LIMIT 1) AS `EV__dbkey_client` FROM client_activity" .
			") `EW_TMP_TABLE`";
		return ($this->_SqlSelectList <> "") ? $this->_SqlSelectList : $select;
	}

	function SqlSelectList() { // For backward compatibility
		return $this->getSqlSelectList();
	}

	function setSqlSelectList($v) {
		$this->_SqlSelectList = $v;
	}
	var $_SqlWhere = "";

	function getSqlWhere() { // Where
		$sWhere = ($this->_SqlWhere <> "") ? $this->_SqlWhere : "";
		$this->TableFilter = "";
		ew_AddFilter($sWhere, $this->TableFilter);
		return $sWhere;
	}

	function SqlWhere() { // For backward compatibility
		return $this->getSqlWhere();
	}

	function setSqlWhere($v) {
		$this->_SqlWhere = $v;
	}
	var $_SqlGroupBy = "";

	function getSqlGroupBy() { // Group By
		return ($this->_SqlGroupBy <> "") ? $this->_SqlGroupBy : "";
	}

	function SqlGroupBy() { // For backward compatibility
		return $this->getSqlGroupBy();
	}

	function setSqlGroupBy($v) {
		$this->_SqlGroupBy = $v;
	}
	var $_SqlHaving = "";

	function getSqlHaving() { // Having
		return ($this->_SqlHaving <> "") ? $this->_SqlHaving : "";
	}

	function SqlHaving() { // For backward compatibility
		return $this->getSqlHaving();
	}

	function setSqlHaving($v) {
		$this->_SqlHaving = $v;
	}
	var $_SqlOrderBy = "";

	function getSqlOrderBy() { // Order By
		return ($this->_SqlOrderBy <> "") ? $this->_SqlOrderBy : "client_activity.dbkey_client, client_activity.date DESC";
	}

	function SqlOrderBy() { // For backward compatibility
		return $this->getSqlOrderBy();
	}

	function setSqlOrderBy($v) {
		$this->_SqlOrderBy = $v;
	}

	// Apply User ID filters
	function ApplyUserIDFilters($sFilter) {
		return $sFilter;
	}

	// Check if User ID security allows view all
	function UserIDAllow($id = "") {
		$allow = EW_USER_ID_ALLOW;
		switch ($id) {
			case "add":
			case "copy":
			case "gridadd":
			case "register":
			case "addopt":
				return (($allow & 1) == 1);
			case "edit":
			case "gridedit":
			case "update":
			case "changepwd":
			case "forgotpwd":
				return (($allow & 4) == 4);
			case "delete":
				return (($allow & 2) == 2);
			case "view":
				return (($allow & 32) == 32);
			case "search":
				return (($allow & 64) == 64);
			default:
				return (($allow & 8) == 8);
		}
	}

	// Get SQL
	function GetSQL($where, $orderby) {
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$where, $orderby);
	}

	// Table SQL
	function SQL() {
		$sFilter = $this->CurrentFilter;
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$sFilter, $sSort);
	}

	// Table SQL with List page filter
	function SelectSQL() {
		$sFilter = $this->getSessionWhere();
		ew_AddFilter($sFilter, $this->CurrentFilter);
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$this->Recordset_Selecting($sFilter);
		if ($this->UseVirtualFields()) {
			$sSort = $this->getSessionOrderByList();
			return ew_BuildSelectSql($this->getSqlSelectList(), $this->getSqlWhere(), $this->getSqlGroupBy(),
				$this->getSqlHaving(), $this->getSqlOrderBy(), $sFilter, $sSort);
		} else {
			$sSort = $this->getSessionOrderBy();
			return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(), $this->getSqlGroupBy(),
				$this->getSqlHaving(), $this->getSqlOrderBy(), $sFilter, $sSort);
		}
	}

	// Get ORDER BY clause
	function GetOrderBy() {
		$sSort = ($this->UseVirtualFields()) ? $this->getSessionOrderByList() : $this->getSessionOrderBy();
		return ew_BuildSelectSql("", "", "", "", $this->getSqlOrderBy(), "", $sSort);
	}

	// Check if virtual fields is used in SQL
	function UseVirtualFields() {
		$sWhere = $this->getSessionWhere();
		$sOrderBy = $this->getSessionOrderByList();
		if ($sWhere <> "")
			$sWhere = " " . str_replace(array("(",")"), array("",""), $sWhere) . " ";
		if ($sOrderBy <> "")
			$sOrderBy = " " . str_replace(array("(",")"), array("",""), $sOrderBy) . " ";
		if (strpos($sOrderBy, " " . $this->dbkey_councilor->FldVirtualExpression . " ") !== FALSE)
			return TRUE;
		if (strpos($sOrderBy, " " . $this->dbkey_client->FldVirtualExpression . " ") !== FALSE)
			return TRUE;
		return FALSE;
	}

	// Try to get record count
	function TryGetRecordCount($sSql) {
		$cnt = -1;
		if (($this->TableType == 'TABLE' || $this->TableType == 'VIEW' || $this->TableType == 'LINKTABLE') && preg_match("/^SELECT \* FROM/i", $sSql)) {
			$sSql = "SELECT COUNT(*) FROM" . preg_replace('/^SELECT\s([\s\S]+)?\*\sFROM/i', "", $sSql);
			$sOrderBy = $this->GetOrderBy();
			if (substr($sSql, strlen($sOrderBy) * -1) == $sOrderBy)
				$sSql = substr($sSql, 0, strlen($sSql) - strlen($sOrderBy)); // Remove ORDER BY clause
		} else {
			$sSql = "SELECT COUNT(*) FROM (" . $sSql . ") EW_COUNT_TABLE";
		}
		$conn = &$this->Connection();
		if ($rs = $conn->Execute($sSql)) {
			if (!$rs->EOF && $rs->FieldCount() > 0) {
				$cnt = $rs->fields[0];
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// Get record count based on filter (for detail record count in master table pages)
	function LoadRecordCount($sFilter) {
		$origFilter = $this->CurrentFilter;
		$this->CurrentFilter = $sFilter;
		$this->Recordset_Selecting($this->CurrentFilter);

		//$sSql = $this->SQL();
		$sSql = $this->GetSQL($this->CurrentFilter, "");
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			if ($rs = $this->LoadRs($this->CurrentFilter)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		$this->CurrentFilter = $origFilter;
		return intval($cnt);
	}

	// Get record count (for current List page)
	function SelectRecordCount() {
		$sSql = $this->SelectSQL();
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			$conn = &$this->Connection();
			if ($rs = $conn->Execute($sSql)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// INSERT statement
	function InsertSQL(&$rs) {
		$names = "";
		$values = "";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$names .= $this->fields[$name]->FldExpression . ",";
			$values .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($names, -1) == ",")
			$names = substr($names, 0, -1);
		while (substr($values, -1) == ",")
			$values = substr($values, 0, -1);
		return "INSERT INTO " . $this->UpdateTable . " ($names) VALUES ($values)";
	}

	// Insert
	function Insert(&$rs) {
		$conn = &$this->Connection();
		return $conn->Execute($this->InsertSQL($rs));
	}

	// UPDATE statement
	function UpdateSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "UPDATE " . $this->UpdateTable . " SET ";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$sql .= $this->fields[$name]->FldExpression . "=";
			$sql .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($sql, -1) == ",")
			$sql = substr($sql, 0, -1);
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		ew_AddFilter($filter, $where);
		if ($filter <> "")	$sql .= " WHERE " . $filter;
		return $sql;
	}

	// Update
	function Update(&$rs, $where = "", $rsold = NULL, $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->UpdateSQL($rs, $where, $curfilter));
	}

	// DELETE statement
	function DeleteSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "DELETE FROM " . $this->UpdateTable . " WHERE ";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		if ($rs) {
			if (array_key_exists('dbkey', $rs))
				ew_AddFilter($where, ew_QuotedName('dbkey', $this->DBID) . '=' . ew_QuotedValue($rs['dbkey'], $this->dbkey->FldDataType, $this->DBID));
		}
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		ew_AddFilter($filter, $where);
		if ($filter <> "")
			$sql .= $filter;
		else
			$sql .= "0=1"; // Avoid delete
		return $sql;
	}

	// Delete
	function Delete(&$rs, $where = "", $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->DeleteSQL($rs, $where, $curfilter));
	}

	// Key filter WHERE clause
	function SqlKeyFilter() {
		return "client_activity.dbkey = @dbkey@";
	}

	// Key filter
	function KeyFilter() {
		$sKeyFilter = $this->SqlKeyFilter();
		if (!is_numeric($this->dbkey->CurrentValue))
			$sKeyFilter = "0=1"; // Invalid key
		$sKeyFilter = str_replace("@dbkey@", ew_AdjustSql($this->dbkey->CurrentValue, $this->DBID), $sKeyFilter); // Replace key value
		return $sKeyFilter;
	}

	// Return page URL
	function getReturnUrl() {
		$name = EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL;

		// Get referer URL automatically
		if (ew_ServerVar("HTTP_REFERER") <> "" && ew_ReferPage() <> ew_CurrentPage() && ew_ReferPage() <> "login.php") // Referer not same page or login page
			$_SESSION[$name] = ew_ServerVar("HTTP_REFERER"); // Save to Session
		if (@$_SESSION[$name] <> "") {
			return $_SESSION[$name];
		} else {
			return "Cust_Client_Activity_Adminslist.php";
		}
	}

	function setReturnUrl($v) {
		$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL] = $v;
	}

	// List URL
	function GetListUrl() {
		return "Cust_Client_Activity_Adminslist.php";
	}

	// View URL
	function GetViewUrl($parm = "") {
		if ($parm <> "")
			$url = $this->KeyUrl("Cust_Client_Activity_Adminsview.php", $this->UrlParm($parm));
		else
			$url = $this->KeyUrl("Cust_Client_Activity_Adminsview.php", $this->UrlParm(EW_TABLE_SHOW_DETAIL . "="));
		return $this->AddMasterUrl($url);
	}

	// Add URL
	function GetAddUrl($parm = "") {
		if ($parm <> "")
			$url = "Cust_Client_Activity_Adminsadd.php?" . $this->UrlParm($parm);
		else
			$url = "Cust_Client_Activity_Adminsadd.php";
		return $this->AddMasterUrl($url);
	}

	// Edit URL
	function GetEditUrl($parm = "") {
		$url = $this->KeyUrl("Cust_Client_Activity_Adminsedit.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline edit URL
	function GetInlineEditUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=edit"));
		return $this->AddMasterUrl($url);
	}

	// Copy URL
	function GetCopyUrl($parm = "") {
		$url = $this->KeyUrl("Cust_Client_Activity_Adminsadd.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline copy URL
	function GetInlineCopyUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=copy"));
		return $this->AddMasterUrl($url);
	}

	// Delete URL
	function GetDeleteUrl() {
		return $this->KeyUrl("Cust_Client_Activity_Adminsdelete.php", $this->UrlParm());
	}

	// Add master url
	function AddMasterUrl($url) {
		return $url;
	}

	function KeyToJson() {
		$json = "";
		$json .= "dbkey:" . ew_VarToJson($this->dbkey->CurrentValue, "number", "'");
		return "{" . $json . "}";
	}

	// Add key value to URL
	function KeyUrl($url, $parm = "") {
		$sUrl = $url . "?";
		if ($parm <> "") $sUrl .= $parm . "&";
		if (!is_null($this->dbkey->CurrentValue)) {
			$sUrl .= "dbkey=" . urlencode($this->dbkey->CurrentValue);
		} else {
			return "javascript:ew_Alert(ewLanguage.Phrase('InvalidRecord'));";
		}
		return $sUrl;
	}

	// Sort URL
	function SortUrl(&$fld) {
		if ($this->CurrentAction <> "" || $this->Export <> "" ||
			in_array($fld->FldType, array(128, 204, 205))) { // Unsortable data type
				return "";
		} elseif ($fld->Sortable) {
			$sUrlParm = $this->UrlParm("order=" . urlencode($fld->FldName) . "&amp;ordertype=" . $fld->ReverseSort());
			return $this->AddMasterUrl(ew_CurrentPage() . "?" . $sUrlParm);
		} else {
			return "";
		}
	}

	// Get record keys from $_POST/$_GET/$_SESSION
	function GetRecordKeys() {
		global $EW_COMPOSITE_KEY_SEPARATOR;
		$arKeys = array();
		$arKey = array();
		if (isset($_POST["key_m"])) {
			$arKeys = ew_StripSlashes($_POST["key_m"]);
			$cnt = count($arKeys);
		} elseif (isset($_GET["key_m"])) {
			$arKeys = ew_StripSlashes($_GET["key_m"]);
			$cnt = count($arKeys);
		} elseif (!empty($_GET) || !empty($_POST)) {
			$isPost = ew_IsHttpPost();
			if ($isPost && isset($_POST["dbkey"]))
				$arKeys[] = ew_StripSlashes($_POST["dbkey"]);
			elseif (isset($_GET["dbkey"]))
				$arKeys[] = ew_StripSlashes($_GET["dbkey"]);
			else
				$arKeys = NULL; // Do not setup

			//return $arKeys; // Do not return yet, so the values will also be checked by the following code
		}

		// Check keys
		$ar = array();
		if (is_array($arKeys)) {
			foreach ($arKeys as $key) {
				if (!is_numeric($key))
					continue;
				$ar[] = $key;
			}
		}
		return $ar;
	}

	// Get key filter
	function GetKeyFilter() {
		$arKeys = $this->GetRecordKeys();
		$sKeyFilter = "";
		foreach ($arKeys as $key) {
			if ($sKeyFilter <> "") $sKeyFilter .= " OR ";
			$this->dbkey->CurrentValue = $key;
			$sKeyFilter .= "(" . $this->KeyFilter() . ")";
		}
		return $sKeyFilter;
	}

	// Load rows based on filter
	function &LoadRs($sFilter) {

		// Set up filter (SQL WHERE clause) and get return SQL
		//$this->CurrentFilter = $sFilter;
		//$sSql = $this->SQL();

		$sSql = $this->GetSQL($sFilter, "");
		$conn = &$this->Connection();
		$rs = $conn->Execute($sSql);
		return $rs;
	}

	// Load row values from recordset
	function LoadListRowValues(&$rs) {
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->dbkey_councilor->setDbValue($rs->fields('dbkey_councilor'));
		$this->dbkey_client->setDbValue($rs->fields('dbkey_client'));
		$this->date->setDbValue($rs->fields('date'));
		$this->time->setDbValue($rs->fields('time'));
		$this->comment->setDbValue($rs->fields('comment'));
		$this->dbkey_activity->setDbValue($rs->fields('dbkey_activity'));
		$this->dbkey_activity_list->setDbValue($rs->fields('dbkey_activity_list'));
		$this->attachment->Upload->DbValue = $rs->fields('attachment');
		$this->Rate->setDbValue($rs->fields('Rate'));
		$this->Client_Type->setDbValue($rs->fields('Client_Type'));
		$this->Contract_ID->setDbValue($rs->fields('Contract_ID'));
		$this->created_by->setDbValue($rs->fields('created_by'));
		$this->created_on->setDbValue($rs->fields('created_on'));
		$this->updated_by->setDbValue($rs->fields('updated_by'));
		$this->updated_on->setDbValue($rs->fields('updated_on'));
	}

	// Render list row values
	function RenderListRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

   // Common render codes
		// dbkey

		$this->dbkey->CellCssStyle = "white-space: nowrap;";

		// dbkey_councilor
		$this->dbkey_councilor->CellCssStyle = "white-space: nowrap;";

		// dbkey_client
		// date
		// time
		// comment
		// dbkey_activity
		// dbkey_activity_list
		// attachment

		$this->attachment->CellCssStyle = "white-space: nowrap;";

		// Rate
		// Client_Type
		// Contract_ID
		// created_by
		// created_on
		// updated_by
		// updated_on
		// dbkey

		$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// dbkey_councilor
		if ($this->dbkey_councilor->VirtualValue <> "") {
			$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->VirtualValue;
		} else {
		if (strval($this->dbkey_councilor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->dbkey_councilor->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_councilor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->CurrentValue;
			}
		} else {
			$this->dbkey_councilor->ViewValue = NULL;
		}
		}
		$this->dbkey_councilor->ViewCustomAttributes = "";

		// dbkey_client
		if ($this->dbkey_client->VirtualValue <> "") {
			$this->dbkey_client->ViewValue = $this->dbkey_client->VirtualValue;
		} else {
		if (strval($this->dbkey_client->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		$this->dbkey_client->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_client->ViewValue = $this->dbkey_client->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_client->ViewValue = $this->dbkey_client->CurrentValue;
			}
		} else {
			$this->dbkey_client->ViewValue = NULL;
		}
		}
		$this->dbkey_client->ViewCustomAttributes = "";

		// date
		$this->date->ViewValue = $this->date->CurrentValue;
		$this->date->ViewValue = ew_FormatDateTime($this->date->ViewValue, 1);
		$this->date->ViewCustomAttributes = "";

		// time
		$this->time->ViewValue = $this->time->CurrentValue;
		$this->time->ViewCustomAttributes = "";

		// comment
		$this->comment->ViewValue = $this->comment->CurrentValue;
		$this->comment->ViewCustomAttributes = "";

		// dbkey_activity
		if (strval($this->dbkey_activity->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey_activity`" . ew_SearchString("=", $this->dbkey_activity->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey_activity`, (select activity.description from activity where activity.dbkey = dbkey_activity) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client_to_activity_code`";
		$sWhereWrk = "";
		$this->dbkey_activity->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->CurrentValue;
			}
		} else {
			$this->dbkey_activity->ViewValue = NULL;
		}
		$this->dbkey_activity->ViewCustomAttributes = "";

		// dbkey_activity_list
		if (strval($this->dbkey_activity_list->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_activity_list->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `activity`";
		$sWhereWrk = "";
		$this->dbkey_activity_list->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_activity_list, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_activity_list->ViewValue = $this->dbkey_activity_list->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_activity_list->ViewValue = $this->dbkey_activity_list->CurrentValue;
			}
		} else {
			$this->dbkey_activity_list->ViewValue = NULL;
		}
		$this->dbkey_activity_list->ViewCustomAttributes = "";

		// attachment
		if (!ew_Empty($this->attachment->Upload->DbValue)) {
			$this->attachment->ViewValue = $this->attachment->Upload->DbValue;
		} else {
			$this->attachment->ViewValue = "";
		}
		$this->attachment->ViewCustomAttributes = "";

		// Rate
		$this->Rate->ViewValue = $this->Rate->CurrentValue;
		$this->Rate->ViewValue = ew_FormatNumber($this->Rate->ViewValue, 3, -2, -2, -2);
		$this->Rate->ViewCustomAttributes = "";

		// Client_Type
		$this->Client_Type->ViewValue = $this->Client_Type->CurrentValue;
		if (strval($this->Client_Type->CurrentValue) <> "") {
			$sFilterWrk = "`code`" . ew_SearchString("=", $this->Client_Type->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT `code`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `waivered`";
		$sWhereWrk = "";
		$this->Client_Type->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->Client_Type, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->Client_Type->ViewValue = $this->Client_Type->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->Client_Type->ViewValue = $this->Client_Type->CurrentValue;
			}
		} else {
			$this->Client_Type->ViewValue = NULL;
		}
		$this->Client_Type->ViewCustomAttributes = "";

		// Contract_ID
		$this->Contract_ID->ViewValue = $this->Contract_ID->CurrentValue;
		$this->Contract_ID->ViewCustomAttributes = "";

		// created_by
		if (strval($this->created_by->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->created_by->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->created_by->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->created_by, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->created_by->ViewValue = $this->created_by->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->created_by->ViewValue = $this->created_by->CurrentValue;
			}
		} else {
			$this->created_by->ViewValue = NULL;
		}
		$this->created_by->ViewCustomAttributes = "";

		// created_on
		$this->created_on->ViewValue = $this->created_on->CurrentValue;
		$this->created_on->ViewValue = ew_FormatDateTime($this->created_on->ViewValue, 1);
		$this->created_on->ViewCustomAttributes = "";

		// updated_by
		if (strval($this->updated_by->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->updated_by->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->updated_by->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->updated_by, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->updated_by->ViewValue = $this->updated_by->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->updated_by->ViewValue = $this->updated_by->CurrentValue;
			}
		} else {
			$this->updated_by->ViewValue = NULL;
		}
		$this->updated_by->ViewCustomAttributes = "";

		// updated_on
		$this->updated_on->ViewValue = $this->updated_on->CurrentValue;
		$this->updated_on->ViewValue = ew_FormatDateTime($this->updated_on->ViewValue, 1);
		$this->updated_on->ViewCustomAttributes = "";

		// dbkey
		$this->dbkey->LinkCustomAttributes = "";
		$this->dbkey->HrefValue = "";
		$this->dbkey->TooltipValue = "";

		// dbkey_councilor
		$this->dbkey_councilor->LinkCustomAttributes = "";
		$this->dbkey_councilor->HrefValue = "";
		$this->dbkey_councilor->TooltipValue = "";

		// dbkey_client
		$this->dbkey_client->LinkCustomAttributes = "";
		$this->dbkey_client->HrefValue = "";
		$this->dbkey_client->TooltipValue = "";

		// date
		$this->date->LinkCustomAttributes = "";
		$this->date->HrefValue = "";
		$this->date->TooltipValue = "";

		// time
		$this->time->LinkCustomAttributes = "";
		$this->time->HrefValue = "";
		$this->time->TooltipValue = "";

		// comment
		$this->comment->LinkCustomAttributes = "";
		$this->comment->HrefValue = "";
		$this->comment->TooltipValue = "";

		// dbkey_activity
		$this->dbkey_activity->LinkCustomAttributes = "";
		$this->dbkey_activity->HrefValue = "";
		$this->dbkey_activity->TooltipValue = "";

		// dbkey_activity_list
		$this->dbkey_activity_list->LinkCustomAttributes = "";
		$this->dbkey_activity_list->HrefValue = "";
		$this->dbkey_activity_list->TooltipValue = "";

		// attachment
		$this->attachment->LinkCustomAttributes = "";
		$this->attachment->HrefValue = "";
		$this->attachment->HrefValue2 = $this->attachment->UploadPath . $this->attachment->Upload->DbValue;
		$this->attachment->TooltipValue = "";

		// Rate
		$this->Rate->LinkCustomAttributes = "";
		$this->Rate->HrefValue = "";
		$this->Rate->TooltipValue = "";

		// Client_Type
		$this->Client_Type->LinkCustomAttributes = "";
		$this->Client_Type->HrefValue = "";
		$this->Client_Type->TooltipValue = "";

		// Contract_ID
		$this->Contract_ID->LinkCustomAttributes = "";
		$this->Contract_ID->HrefValue = "";
		$this->Contract_ID->TooltipValue = "";

		// created_by
		$this->created_by->LinkCustomAttributes = "";
		$this->created_by->HrefValue = "";
		$this->created_by->TooltipValue = "";

		// created_on
		$this->created_on->LinkCustomAttributes = "";
		$this->created_on->HrefValue = "";
		$this->created_on->TooltipValue = "";

		// updated_by
		$this->updated_by->LinkCustomAttributes = "";
		$this->updated_by->HrefValue = "";
		$this->updated_by->TooltipValue = "";

		// updated_on
		$this->updated_on->LinkCustomAttributes = "";
		$this->updated_on->HrefValue = "";
		$this->updated_on->TooltipValue = "";

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Render edit row values
	function RenderEditRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

		// dbkey
		$this->dbkey->EditAttrs["class"] = "form-control";
		$this->dbkey->EditCustomAttributes = "";
		$this->dbkey->EditValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// dbkey_councilor
		$this->dbkey_councilor->EditAttrs["class"] = "form-control";
		$this->dbkey_councilor->EditCustomAttributes = "";

		// dbkey_client
		$this->dbkey_client->EditAttrs["class"] = "form-control";
		$this->dbkey_client->EditCustomAttributes = "";

		// date
		$this->date->EditAttrs["class"] = "form-control";
		$this->date->EditCustomAttributes = "";
		$this->date->EditValue = ew_FormatDateTime($this->date->CurrentValue, 8);
		$this->date->PlaceHolder = ew_RemoveHtml($this->date->FldCaption());

		// time
		$this->time->EditAttrs["class"] = "form-control";
		$this->time->EditCustomAttributes = "";
		$this->time->EditValue = $this->time->CurrentValue;
		$this->time->PlaceHolder = ew_RemoveHtml($this->time->FldCaption());
		if (strval($this->time->EditValue) <> "" && is_numeric($this->time->EditValue)) $this->time->EditValue = ew_FormatNumber($this->time->EditValue, -2, -1, -2, 0);

		// comment
		$this->comment->EditAttrs["class"] = "form-control";
		$this->comment->EditCustomAttributes = "";
		$this->comment->EditValue = $this->comment->CurrentValue;
		$this->comment->PlaceHolder = ew_RemoveHtml($this->comment->FldCaption());

		// dbkey_activity
		$this->dbkey_activity->EditAttrs["class"] = "form-control";
		$this->dbkey_activity->EditCustomAttributes = "";

		// dbkey_activity_list
		$this->dbkey_activity_list->EditAttrs["class"] = "form-control";
		$this->dbkey_activity_list->EditCustomAttributes = "";

		// attachment
		$this->attachment->EditAttrs["class"] = "form-control";
		$this->attachment->EditCustomAttributes = "";
		if (!ew_Empty($this->attachment->Upload->DbValue)) {
			$this->attachment->EditValue = $this->attachment->Upload->DbValue;
		} else {
			$this->attachment->EditValue = "";
		}
		if (!ew_Empty($this->attachment->CurrentValue))
			$this->attachment->Upload->FileName = $this->attachment->CurrentValue;

		// Rate
		$this->Rate->EditAttrs["class"] = "form-control";
		$this->Rate->EditCustomAttributes = "";
		$this->Rate->EditValue = $this->Rate->CurrentValue;
		$this->Rate->EditValue = ew_FormatNumber($this->Rate->EditValue, 3, -2, -2, -2);
		$this->Rate->ViewCustomAttributes = "";

		// Client_Type
		$this->Client_Type->EditAttrs["class"] = "form-control";
		$this->Client_Type->EditCustomAttributes = "";
		$this->Client_Type->EditValue = $this->Client_Type->CurrentValue;
		if (strval($this->Client_Type->CurrentValue) <> "") {
			$sFilterWrk = "`code`" . ew_SearchString("=", $this->Client_Type->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT `code`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `waivered`";
		$sWhereWrk = "";
		$this->Client_Type->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->Client_Type, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->Client_Type->EditValue = $this->Client_Type->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->Client_Type->EditValue = $this->Client_Type->CurrentValue;
			}
		} else {
			$this->Client_Type->EditValue = NULL;
		}
		$this->Client_Type->ViewCustomAttributes = "";

		// Contract_ID
		$this->Contract_ID->EditAttrs["class"] = "form-control";
		$this->Contract_ID->EditCustomAttributes = "";
		$this->Contract_ID->EditValue = $this->Contract_ID->CurrentValue;
		$this->Contract_ID->PlaceHolder = ew_RemoveHtml($this->Contract_ID->FldCaption());

		// created_by
		$this->created_by->EditAttrs["class"] = "form-control";
		$this->created_by->EditCustomAttributes = "";

		// created_on
		$this->created_on->EditAttrs["class"] = "form-control";
		$this->created_on->EditCustomAttributes = "";
		$this->created_on->EditValue = ew_FormatDateTime($this->created_on->CurrentValue, 8);
		$this->created_on->PlaceHolder = ew_RemoveHtml($this->created_on->FldCaption());

		// updated_by
		$this->updated_by->EditAttrs["class"] = "form-control";
		$this->updated_by->EditCustomAttributes = "";

		// updated_on
		$this->updated_on->EditAttrs["class"] = "form-control";
		$this->updated_on->EditCustomAttributes = "";
		$this->updated_on->EditValue = ew_FormatDateTime($this->updated_on->CurrentValue, 8);
		$this->updated_on->PlaceHolder = ew_RemoveHtml($this->updated_on->FldCaption());

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Aggregate list row values
	function AggregateListRowValues() {
			if (is_numeric($this->time->CurrentValue))
				$this->time->Total += $this->time->CurrentValue; // Accumulate total
	}

	// Aggregate list row (for rendering)
	function AggregateListRow() {
			$this->time->CurrentValue = $this->time->Total;
			$this->time->ViewValue = $this->time->CurrentValue;
			$this->time->ViewCustomAttributes = "";
			$this->time->HrefValue = ""; // Clear href value

		// Call Row Rendered event
		$this->Row_Rendered();
	}
	var $ExportDoc;

	// Export data in HTML/CSV/Word/Excel/Email/PDF format
	function ExportDocument(&$Doc, &$Recordset, $StartRec, $StopRec, $ExportPageType = "") {
		if (!$Recordset || !$Doc)
			return;
		if (!$Doc->ExportCustom) {

			// Write header
			$Doc->ExportTableHeader();
			if ($Doc->Horizontal) { // Horizontal format, write header
				$Doc->BeginExportRow();
				if ($ExportPageType == "view") {
					if ($this->dbkey_client->Exportable) $Doc->ExportCaption($this->dbkey_client);
					if ($this->date->Exportable) $Doc->ExportCaption($this->date);
					if ($this->time->Exportable) $Doc->ExportCaption($this->time);
					if ($this->comment->Exportable) $Doc->ExportCaption($this->comment);
					if ($this->dbkey_activity->Exportable) $Doc->ExportCaption($this->dbkey_activity);
					if ($this->Rate->Exportable) $Doc->ExportCaption($this->Rate);
					if ($this->Client_Type->Exportable) $Doc->ExportCaption($this->Client_Type);
					if ($this->Contract_ID->Exportable) $Doc->ExportCaption($this->Contract_ID);
					if ($this->created_by->Exportable) $Doc->ExportCaption($this->created_by);
					if ($this->created_on->Exportable) $Doc->ExportCaption($this->created_on);
					if ($this->updated_by->Exportable) $Doc->ExportCaption($this->updated_by);
					if ($this->updated_on->Exportable) $Doc->ExportCaption($this->updated_on);
				} else {
					if ($this->dbkey_councilor->Exportable) $Doc->ExportCaption($this->dbkey_councilor);
					if ($this->dbkey_client->Exportable) $Doc->ExportCaption($this->dbkey_client);
					if ($this->date->Exportable) $Doc->ExportCaption($this->date);
					if ($this->time->Exportable) $Doc->ExportCaption($this->time);
					if ($this->comment->Exportable) $Doc->ExportCaption($this->comment);
					if ($this->dbkey_activity->Exportable) $Doc->ExportCaption($this->dbkey_activity);
					if ($this->Rate->Exportable) $Doc->ExportCaption($this->Rate);
					if ($this->Client_Type->Exportable) $Doc->ExportCaption($this->Client_Type);
					if ($this->Contract_ID->Exportable) $Doc->ExportCaption($this->Contract_ID);
					if ($this->created_by->Exportable) $Doc->ExportCaption($this->created_by);
					if ($this->created_on->Exportable) $Doc->ExportCaption($this->created_on);
					if ($this->updated_by->Exportable) $Doc->ExportCaption($this->updated_by);
					if ($this->updated_on->Exportable) $Doc->ExportCaption($this->updated_on);
				}
				$Doc->EndExportRow();
			}
		}

		// Move to first record
		$RecCnt = $StartRec - 1;
		if (!$Recordset->EOF) {
			$Recordset->MoveFirst();
			if ($StartRec > 1)
				$Recordset->Move($StartRec - 1);
		}
		while (!$Recordset->EOF && $RecCnt < $StopRec) {
			$RecCnt++;
			if (intval($RecCnt) >= intval($StartRec)) {
				$RowCnt = intval($RecCnt) - intval($StartRec) + 1;

				// Page break
				if ($this->ExportPageBreakCount > 0) {
					if ($RowCnt > 1 && ($RowCnt - 1) % $this->ExportPageBreakCount == 0)
						$Doc->ExportPageBreak();
				}
				$this->LoadListRowValues($Recordset);
				$this->AggregateListRowValues(); // Aggregate row values

				// Render row
				$this->RowType = EW_ROWTYPE_VIEW; // Render view
				$this->ResetAttrs();
				$this->RenderListRow();
				if (!$Doc->ExportCustom) {
					$Doc->BeginExportRow($RowCnt); // Allow CSS styles if enabled
					if ($ExportPageType == "view") {
						if ($this->dbkey_client->Exportable) $Doc->ExportField($this->dbkey_client);
						if ($this->date->Exportable) $Doc->ExportField($this->date);
						if ($this->time->Exportable) $Doc->ExportField($this->time);
						if ($this->comment->Exportable) $Doc->ExportField($this->comment);
						if ($this->dbkey_activity->Exportable) $Doc->ExportField($this->dbkey_activity);
						if ($this->Rate->Exportable) $Doc->ExportField($this->Rate);
						if ($this->Client_Type->Exportable) $Doc->ExportField($this->Client_Type);
						if ($this->Contract_ID->Exportable) $Doc->ExportField($this->Contract_ID);
						if ($this->created_by->Exportable) $Doc->ExportField($this->created_by);
						if ($this->created_on->Exportable) $Doc->ExportField($this->created_on);
						if ($this->updated_by->Exportable) $Doc->ExportField($this->updated_by);
						if ($this->updated_on->Exportable) $Doc->ExportField($this->updated_on);
					} else {
						if ($this->dbkey_councilor->Exportable) $Doc->ExportField($this->dbkey_councilor);
						if ($this->dbkey_client->Exportable) $Doc->ExportField($this->dbkey_client);
						if ($this->date->Exportable) $Doc->ExportField($this->date);
						if ($this->time->Exportable) $Doc->ExportField($this->time);
						if ($this->comment->Exportable) $Doc->ExportField($this->comment);
						if ($this->dbkey_activity->Exportable) $Doc->ExportField($this->dbkey_activity);
						if ($this->Rate->Exportable) $Doc->ExportField($this->Rate);
						if ($this->Client_Type->Exportable) $Doc->ExportField($this->Client_Type);
						if ($this->Contract_ID->Exportable) $Doc->ExportField($this->Contract_ID);
						if ($this->created_by->Exportable) $Doc->ExportField($this->created_by);
						if ($this->created_on->Exportable) $Doc->ExportField($this->created_on);
						if ($this->updated_by->Exportable) $Doc->ExportField($this->updated_by);
						if ($this->updated_on->Exportable) $Doc->ExportField($this->updated_on);
					}
					$Doc->EndExportRow();
				}
			}

			// Call Row Export server event
			if ($Doc->ExportCustom)
				$this->Row_Export($Recordset->fields);
			$Recordset->MoveNext();
		}

		// Export aggregates (horizontal format only)
		if ($Doc->Horizontal) {
			$this->RowType = EW_ROWTYPE_AGGREGATE;
			$this->ResetAttrs();
			$this->AggregateListRow();
			if (!$Doc->ExportCustom) {
				$Doc->BeginExportRow(-1);
				if ($this->dbkey_councilor->Exportable) $Doc->ExportAggregate($this->dbkey_councilor, '');
				if ($this->dbkey_client->Exportable) $Doc->ExportAggregate($this->dbkey_client, '');
				if ($this->date->Exportable) $Doc->ExportAggregate($this->date, '');
				if ($this->time->Exportable) $Doc->ExportAggregate($this->time, 'TOTAL');
				if ($this->comment->Exportable) $Doc->ExportAggregate($this->comment, '');
				if ($this->dbkey_activity->Exportable) $Doc->ExportAggregate($this->dbkey_activity, '');
				if ($this->Rate->Exportable) $Doc->ExportAggregate($this->Rate, '');
				if ($this->Client_Type->Exportable) $Doc->ExportAggregate($this->Client_Type, '');
				if ($this->Contract_ID->Exportable) $Doc->ExportAggregate($this->Contract_ID, '');
				if ($this->created_by->Exportable) $Doc->ExportAggregate($this->created_by, '');
				if ($this->created_on->Exportable) $Doc->ExportAggregate($this->created_on, '');
				if ($this->updated_by->Exportable) $Doc->ExportAggregate($this->updated_by, '');
				if ($this->updated_on->Exportable) $Doc->ExportAggregate($this->updated_on, '');
				$Doc->EndExportRow();
			}
		}
		if (!$Doc->ExportCustom) {
			$Doc->ExportTableFooter();
		}
	}

	// Get auto fill value
	function GetAutoFill($id, $val) {
		$rsarr = array();
		$rowcnt = 0;

		// Output
		if (is_array($rsarr) && $rowcnt > 0) {
			$fldcnt = count($rsarr[0]);
			for ($i = 0; $i < $rowcnt; $i++) {
				for ($j = 0; $j < $fldcnt; $j++) {
					$str = strval($rsarr[$i][$j]);
					$str = ew_ConvertToUtf8($str);
					if (isset($post["keepCRLF"])) {
						$str = str_replace(array("\r", "\n"), array("\\r", "\\n"), $str);
					} else {
						$str = str_replace(array("\r", "\n"), array(" ", " "), $str);
					}
					$rsarr[$i][$j] = $str;
				}
			}
			return ew_ArrayToJson($rsarr);
		} else {
			return FALSE;
		}
	}

	// Table level events
	// Recordset Selecting event
	function Recordset_Selecting(&$filter) {

		// Enter your code here	
	}

	// Recordset Selected event
	function Recordset_Selected(&$rs) {

		//echo "Recordset Selected";
	}

	// Recordset Search Validated event
	function Recordset_SearchValidated() {

		// Example:
		//$this->MyField1->AdvancedSearch->SearchValue = "your search criteria"; // Search value

	}

	// Recordset Searching event
	function Recordset_Searching(&$filter) {

		// Enter your code here
	//	var_dump($filter);

	}

	// Row_Selecting event
	function Row_Selecting(&$filter) {

		// Enter your code here	
	}

	// Row Selected event
	function Row_Selected(&$rs) {

		//echo "Row Selected";
	}

	// Row Inserting event
	function Row_Inserting($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		$rsnew['updated_by'] = CurrentUserID();
		$rsnew['created_by'] = CurrentUserID();
		$rsnew['updated_on'] = date('Y-m-d H:i:s', time());
		$rsnew['created_on'] = date('Y-m-d H:i:s', time());
		return TRUE;
	}

	// Row Inserted event
	function Row_Inserted($rsold, &$rsnew) {

		//echo "Row Inserted"
	}

	// Row Updating event
	function Row_Updating($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		$rsnew['updated_by'] = CurrentUserID();
		$rsnew['updated_on'] = date('Y-m-d H:i:s', time());
		return TRUE;
	}

	// Row Updated event
	function Row_Updated($rsold, &$rsnew) {

		//echo "Row Updated";
	}

	// Row Update Conflict event
	function Row_UpdateConflict($rsold, &$rsnew) {

		// Enter your code here
		// To ignore conflict, set return value to FALSE

		return TRUE;
	}

	// Grid Inserting event
	function Grid_Inserting() {

		// Enter your code here
		// To reject grid insert, set return value to FALSE

		$rsnew['updated_by'] = CurrentUserID();
		$rsnew['created_by'] = CurrentUserID();
		$rsnew['updated_on'] = date('Y-m-d H:i:s', time());
		$rsnew['created_on'] = date('Y-m-d H:i:s', time());
		return TRUE;
	}

	// Grid Inserted event
	function Grid_Inserted($rsnew) {

		//echo "Grid Inserted";
	}

	// Grid Updating event
	function Grid_Updating($rsold) {

		// Enter your code here
		// To reject grid update, set return value to FALSE

		$rsnew['updated_by'] = CurrentUserID();
		$rsnew['updated_on'] = date('Y-m-d H:i:s', time());
		return TRUE;
	}

	// Grid Updated event
	function Grid_Updated($rsold, $rsnew) {

		//echo "Grid Updated";
	}

	// Row Deleting event
	function Row_Deleting(&$rs) {

		// Enter your code here
		// To cancel, set return value to False

		return TRUE;
	}

	// Row Deleted event
	function Row_Deleted(&$rs) {

		//echo "Row Deleted";
	}

	// Email Sending event
	function Email_Sending(&$Email, &$Args) {

		//var_dump($Email); var_dump($Args); exit();
		return TRUE;
	}

	// Lookup Selecting event
	function Lookup_Selecting($fld, &$filter) {

		//var_dump($fld->FldName, $fld->LookupFilters, $filter); // Uncomment to view the filter
		// Enter your code here

	}

	// Row Rendering event
	function Row_Rendering() {

		// Enter your code here	
	}

	// Row Rendered event
	function Row_Rendered() {

		// If over budget red.
		if ($this->remain->DbValue < 0)
		{
			$this->remain->CssStyle = "color:red;";
		}

		// Hide the client field in edit and add
		if (CurrentPageID() == "add" or CurrentPageID() == "edit") {
			$this->client->Visible = FALSE;
			$this->counselor->Visible = FALSE;
			$this->remain->Visible = FALSE;
			$this->budget->Visible = FALSE;
			$this->allocated->Visible = FALSE;
			$this->comment->Required = FALSE;
			$this->total_allocated->Visible = FALSE;
			$this->total_remain->Visible = FALSE;
			$this->dbkey_budget->Visible = FALSE;
			$this->Rate->Visible = FALSE;
			$this->Client_Type->Visible = FALSE;
			$this->Contract_ID->Visible = FALSE;

			//var_dump($this->comment);
			}

			//var_dump($this);
			//exit();

				if (CurrentPageID() == "add")
		{
			date_default_timezone_set("America/Chicago");

			//echo "<h1> TIME SET " . date('Y-m-d H:m:s') . "</h1>";
		}
	}

	// User ID Filtering event
	function UserID_Filtering(&$filter) {

		// Enter your code here
	}
}
?>
