<?php
if (session_id() == "") session_start(); // Init session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg13.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql13.php") ?>
<?php include_once "phpfn13.php" ?>
<?php include_once "Cust_Client_Activity_Adminsinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn13.php" ?>
<?php

//
// Page class
//

$Cust_Client_Activity_Admins_view = NULL; // Initialize page object first

class cCust_Client_Activity_Admins_view extends cCust_Client_Activity_Admins {

	// Page ID
	var $PageID = 'view';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'Cust_Client_Activity_Admins';

	// Page object name
	var $PageObjName = 'Cust_Client_Activity_Admins_view';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Page URLs
	var $AddUrl;
	var $EditUrl;
	var $CopyUrl;
	var $DeleteUrl;
	var $ViewUrl;
	var $ListUrl;

	// Export URLs
	var $ExportPrintUrl;
	var $ExportHtmlUrl;
	var $ExportExcelUrl;
	var $ExportWordUrl;
	var $ExportXmlUrl;
	var $ExportCsvUrl;
	var $ExportPdfUrl;

	// Custom export
	var $ExportExcelCustom = FALSE;
	var $ExportWordCustom = FALSE;
	var $ExportPdfCustom = FALSE;
	var $ExportEmailCustom = FALSE;

	// Update URLs
	var $InlineAddUrl;
	var $InlineCopyUrl;
	var $InlineEditUrl;
	var $GridAddUrl;
	var $GridEditUrl;
	var $MultiDeleteUrl;
	var $MultiUpdateUrl;
	var $AuditTrailOnAdd = FALSE;
	var $AuditTrailOnEdit = FALSE;
	var $AuditTrailOnDelete = FALSE;
	var $AuditTrailOnView = FALSE;
	var $AuditTrailOnViewData = FALSE;
	var $AuditTrailOnSearch = FALSE;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (Cust_Client_Activity_Admins)
		if (!isset($GLOBALS["Cust_Client_Activity_Admins"]) || get_class($GLOBALS["Cust_Client_Activity_Admins"]) == "cCust_Client_Activity_Admins") {
			$GLOBALS["Cust_Client_Activity_Admins"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["Cust_Client_Activity_Admins"];
		}
		$KeyUrl = "";
		if (@$_GET["dbkey"] <> "") {
			$this->RecKey["dbkey"] = $_GET["dbkey"];
			$KeyUrl .= "&amp;dbkey=" . urlencode($this->RecKey["dbkey"]);
		}
		$this->ExportPrintUrl = $this->PageUrl() . "export=print" . $KeyUrl;
		$this->ExportHtmlUrl = $this->PageUrl() . "export=html" . $KeyUrl;
		$this->ExportExcelUrl = $this->PageUrl() . "export=excel" . $KeyUrl;
		$this->ExportWordUrl = $this->PageUrl() . "export=word" . $KeyUrl;
		$this->ExportXmlUrl = $this->PageUrl() . "export=xml" . $KeyUrl;
		$this->ExportCsvUrl = $this->PageUrl() . "export=csv" . $KeyUrl;
		$this->ExportPdfUrl = $this->PageUrl() . "export=pdf" . $KeyUrl;

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'view', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'Cust_Client_Activity_Admins', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}

		// Export options
		$this->ExportOptions = new cListOptions();
		$this->ExportOptions->Tag = "div";
		$this->ExportOptions->TagClassName = "ewExportOption";

		// Other options
		$this->OtherOptions['action'] = new cListOptions();
		$this->OtherOptions['action']->Tag = "div";
		$this->OtherOptions['action']->TagClassName = "ewActionOption";
		$this->OtherOptions['detail'] = new cListOptions();
		$this->OtherOptions['detail']->Tag = "div";
		$this->OtherOptions['detail']->TagClassName = "ewDetailOption";
	}

	//
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanView()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("Cust_Client_Activity_Adminslist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Get export parameters
		$custom = "";
		if (@$_GET["export"] <> "") {
			$this->Export = $_GET["export"];
			$custom = @$_GET["custom"];
		} elseif (@$_POST["export"] <> "") {
			$this->Export = $_POST["export"];
			$custom = @$_POST["custom"];
		} elseif (ew_IsHttpPost()) {
			if (@$_POST["exporttype"] <> "")
				$this->Export = $_POST["exporttype"];
			$custom = @$_POST["custom"];
		} else {
			$this->setExportReturnUrl(ew_CurrentUrl());
		}
		$gsExportFile = $this->TableVar; // Get export file, used in header
		if (@$_GET["dbkey"] <> "") {
			if ($gsExportFile <> "") $gsExportFile .= "_";
			$gsExportFile .= ew_StripSlashes($_GET["dbkey"]);
		}

		// Get custom export parameters
		if ($this->Export <> "" && $custom <> "") {
			$this->CustomExport = $this->Export;
			$this->Export = "print";
		}
		$gsCustomExport = $this->CustomExport;
		$gsExport = $this->Export; // Get export parameter, used in header

		// Update Export URLs
		if (defined("EW_USE_PHPEXCEL"))
			$this->ExportExcelCustom = FALSE;
		if ($this->ExportExcelCustom)
			$this->ExportExcelUrl .= "&amp;custom=1";
		if (defined("EW_USE_PHPWORD"))
			$this->ExportWordCustom = FALSE;
		if ($this->ExportWordCustom)
			$this->ExportWordUrl .= "&amp;custom=1";
		if ($this->ExportPdfCustom)
			$this->ExportPdfUrl .= "&amp;custom=1";
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action

		// Setup export options
		$this->SetupExportOptions();
		$this->dbkey_client->SetVisibility();
		$this->date->SetVisibility();
		$this->time->SetVisibility();
		$this->comment->SetVisibility();
		$this->dbkey_activity->SetVisibility();
		$this->Rate->SetVisibility();
		$this->Rate->Visible = !$this->IsAddOrEdit();
		$this->Client_Type->SetVisibility();
		$this->Client_Type->Visible = !$this->IsAddOrEdit();
		$this->Contract_ID->SetVisibility();
		$this->Contract_ID->Visible = !$this->IsAddOrEdit();
		$this->created_by->SetVisibility();
		$this->created_on->SetVisibility();
		$this->updated_by->SetVisibility();
		$this->updated_on->SetVisibility();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $Cust_Client_Activity_Admins;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($Cust_Client_Activity_Admins);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();

			// Handle modal response
			if ($this->IsModal) {
				$row = array();
				$row["url"] = $url;
				echo ew_ArrayToJson(array($row));
			} else {
				header("Location: " . $url);
			}
		}
		exit();
	}
	var $ExportOptions; // Export options
	var $OtherOptions = array(); // Other options
	var $DisplayRecs = 1;
	var $DbMasterFilter;
	var $DbDetailFilter;
	var $StartRec;
	var $StopRec;
	var $TotalRecs = 0;
	var $RecRange = 10;
	var $RecCnt;
	var $RecKey = array();
	var $IsModal = FALSE;
	var $Recordset;

	//
	// Page main
	//
	function Page_Main() {
		global $Language;
		global $gbSkipHeaderFooter;

		// Check modal
		$this->IsModal = (@$_GET["modal"] == "1" || @$_POST["modal"] == "1");
		if ($this->IsModal)
			$gbSkipHeaderFooter = TRUE;

		// Load current record
		$bLoadCurrentRecord = FALSE;
		$sReturnUrl = "";
		$bMatchRecord = FALSE;
		if ($this->IsPageRequest()) { // Validate request
			if (@$_GET["dbkey"] <> "") {
				$this->dbkey->setQueryStringValue($_GET["dbkey"]);
				$this->RecKey["dbkey"] = $this->dbkey->QueryStringValue;
			} elseif (@$_POST["dbkey"] <> "") {
				$this->dbkey->setFormValue($_POST["dbkey"]);
				$this->RecKey["dbkey"] = $this->dbkey->FormValue;
			} else {
				$sReturnUrl = "Cust_Client_Activity_Adminslist.php"; // Return to list
			}

			// Get action
			$this->CurrentAction = "I"; // Display form
			switch ($this->CurrentAction) {
				case "I": // Get a record to display
					if (!$this->LoadRow()) { // Load record based on key
						if ($this->getSuccessMessage() == "" && $this->getFailureMessage() == "")
							$this->setFailureMessage($Language->Phrase("NoRecord")); // Set no record message
						$sReturnUrl = "Cust_Client_Activity_Adminslist.php"; // No matching record, return to list
					}
			}

			// Export data only
			if ($this->CustomExport == "" && in_array($this->Export, array("html","word","excel","xml","csv","email","pdf"))) {
				$this->ExportData();
				$this->Page_Terminate(); // Terminate response
				exit();
			}
		} else {
			$sReturnUrl = "Cust_Client_Activity_Adminslist.php"; // Not page request, return to list
		}
		if ($sReturnUrl <> "")
			$this->Page_Terminate($sReturnUrl);

		// Set up Breadcrumb
		if ($this->Export == "")
			$this->SetupBreadcrumb();

		// Render row
		$this->RowType = EW_ROWTYPE_VIEW;
		$this->ResetAttrs();
		$this->RenderRow();
	}

	// Set up other options
	function SetupOtherOptions() {
		global $Language, $Security;
		$options = &$this->OtherOptions;
		$option = &$options["action"];

		// Add
		$item = &$option->Add("add");
		$addcaption = ew_HtmlTitle($Language->Phrase("ViewPageAddLink"));
		if ($this->IsModal) // Modal
			$item->Body = "<a class=\"ewAction ewAdd\" title=\"" . $addcaption . "\" data-caption=\"" . $addcaption . "\" href=\"javascript:void(0);\" onclick=\"ew_ModalDialogShow({lnk:this,url:'" . ew_HtmlEncode($this->AddUrl) . "',caption:'" . $addcaption . "'});\">" . $Language->Phrase("ViewPageAddLink") . "</a>";
		else
			$item->Body = "<a class=\"ewAction ewAdd\" title=\"" . $addcaption . "\" data-caption=\"" . $addcaption . "\" href=\"" . ew_HtmlEncode($this->AddUrl) . "\">" . $Language->Phrase("ViewPageAddLink") . "</a>";
		$item->Visible = ($this->AddUrl <> "" && $Security->CanAdd());

		// Edit
		$item = &$option->Add("edit");
		$editcaption = ew_HtmlTitle($Language->Phrase("ViewPageEditLink"));
		if ($this->IsModal) // Modal
			$item->Body = "<a class=\"ewAction ewEdit\" title=\"" . $editcaption . "\" data-caption=\"" . $editcaption . "\" href=\"javascript:void(0);\" onclick=\"ew_ModalDialogShow({lnk:this,url:'" . ew_HtmlEncode($this->EditUrl) . "',caption:'" . $editcaption . "'});\">" . $Language->Phrase("ViewPageEditLink") . "</a>";
		else
			$item->Body = "<a class=\"ewAction ewEdit\" title=\"" . $editcaption . "\" data-caption=\"" . $editcaption . "\" href=\"" . ew_HtmlEncode($this->EditUrl) . "\">" . $Language->Phrase("ViewPageEditLink") . "</a>";
		$item->Visible = ($this->EditUrl <> "" && $Security->CanEdit());

		// Copy
		$item = &$option->Add("copy");
		$copycaption = ew_HtmlTitle($Language->Phrase("ViewPageCopyLink"));
		if ($this->IsModal) // Modal
			$item->Body = "<a class=\"ewAction ewCopy\" title=\"" . $copycaption . "\" data-caption=\"" . $copycaption . "\" href=\"javascript:void(0);\" onclick=\"ew_ModalDialogShow({lnk:this,url:'" . ew_HtmlEncode($this->CopyUrl) . "',caption:'" . $copycaption . "'});\">" . $Language->Phrase("ViewPageCopyLink") . "</a>";
		else
			$item->Body = "<a class=\"ewAction ewCopy\" title=\"" . $copycaption . "\" data-caption=\"" . $copycaption . "\" href=\"" . ew_HtmlEncode($this->CopyUrl) . "\">" . $Language->Phrase("ViewPageCopyLink") . "</a>";
		$item->Visible = ($this->CopyUrl <> "" && $Security->CanAdd());

		// Delete
		$item = &$option->Add("delete");
		if ($this->IsModal) // Handle as inline delete
			$item->Body = "<a onclick=\"return ew_ConfirmDelete(this);\" class=\"ewAction ewDelete\" title=\"" . ew_HtmlTitle($Language->Phrase("ViewPageDeleteLink")) . "\" data-caption=\"" . ew_HtmlTitle($Language->Phrase("ViewPageDeleteLink")) . "\" href=\"" . ew_HtmlEncode(ew_AddQueryStringToUrl($this->DeleteUrl, "a_delete=1")) . "\">" . $Language->Phrase("ViewPageDeleteLink") . "</a>";
		else
			$item->Body = "<a class=\"ewAction ewDelete\" title=\"" . ew_HtmlTitle($Language->Phrase("ViewPageDeleteLink")) . "\" data-caption=\"" . ew_HtmlTitle($Language->Phrase("ViewPageDeleteLink")) . "\" href=\"" . ew_HtmlEncode($this->DeleteUrl) . "\">" . $Language->Phrase("ViewPageDeleteLink") . "</a>";
		$item->Visible = ($this->DeleteUrl <> "" && $Security->CanDelete());

		// Set up action default
		$option = &$options["action"];
		$option->DropDownButtonPhrase = $Language->Phrase("ButtonActions");
		$option->UseImageAndText = TRUE;
		$option->UseDropDownButton = FALSE;
		$option->UseButtonGroup = TRUE;
		$item = &$option->Add($option->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;
	}

	// Set up starting record parameters
	function SetUpStartRec() {
		if ($this->DisplayRecs == 0)
			return;
		if ($this->IsPageRequest()) { // Validate request
			if (@$_GET[EW_TABLE_START_REC] <> "") { // Check for "start" parameter
				$this->StartRec = $_GET[EW_TABLE_START_REC];
				$this->setStartRecordNumber($this->StartRec);
			} elseif (@$_GET[EW_TABLE_PAGE_NO] <> "") {
				$PageNo = $_GET[EW_TABLE_PAGE_NO];
				if (is_numeric($PageNo)) {
					$this->StartRec = ($PageNo-1)*$this->DisplayRecs+1;
					if ($this->StartRec <= 0) {
						$this->StartRec = 1;
					} elseif ($this->StartRec >= intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1) {
						$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1;
					}
					$this->setStartRecordNumber($this->StartRec);
				}
			}
		}
		$this->StartRec = $this->getStartRecordNumber();

		// Check if correct start record counter
		if (!is_numeric($this->StartRec) || $this->StartRec == "") { // Avoid invalid start record counter
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} elseif (intval($this->StartRec) > intval($this->TotalRecs)) { // Avoid starting record > total records
			$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to last page first record
			$this->setStartRecordNumber($this->StartRec);
		} elseif (($this->StartRec-1) % $this->DisplayRecs <> 0) {
			$this->StartRec = intval(($this->StartRec-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to page boundary
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Load recordset
	function LoadRecordset($offset = -1, $rowcnt = -1) {

		// Load List page SQL
		$sSql = $this->SelectSQL();
		$conn = &$this->Connection();

		// Load recordset
		$dbtype = ew_GetConnectionType($this->DBID);
		if ($this->UseSelectLimit) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			if ($dbtype == "MSSQL") {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset, array("_hasOrderBy" => trim($this->getOrderBy()) || trim($this->getSessionOrderByList())));
			} else {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset);
			}
			$conn->raiseErrorFn = '';
		} else {
			$rs = ew_LoadRecordset($sSql, $conn);
		}

		// Call Recordset Selected event
		$this->Recordset_Selected($rs);
		return $rs;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		if ($this->AuditTrailOnView) $this->WriteAuditTrailOnView($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->dbkey_councilor->setDbValue($rs->fields('dbkey_councilor'));
		if (array_key_exists('EV__dbkey_councilor', $rs->fields)) {
			$this->dbkey_councilor->VirtualValue = $rs->fields('EV__dbkey_councilor'); // Set up virtual field value
		} else {
			$this->dbkey_councilor->VirtualValue = ""; // Clear value
		}
		$this->dbkey_client->setDbValue($rs->fields('dbkey_client'));
		if (array_key_exists('EV__dbkey_client', $rs->fields)) {
			$this->dbkey_client->VirtualValue = $rs->fields('EV__dbkey_client'); // Set up virtual field value
		} else {
			$this->dbkey_client->VirtualValue = ""; // Clear value
		}
		$this->date->setDbValue($rs->fields('date'));
		$this->time->setDbValue($rs->fields('time'));
		$this->comment->setDbValue($rs->fields('comment'));
		$this->dbkey_activity->setDbValue($rs->fields('dbkey_activity'));
		$this->dbkey_activity_list->setDbValue($rs->fields('dbkey_activity_list'));
		$this->attachment->Upload->DbValue = $rs->fields('attachment');
		$this->attachment->CurrentValue = $this->attachment->Upload->DbValue;
		$this->Rate->setDbValue($rs->fields('Rate'));
		$this->Client_Type->setDbValue($rs->fields('Client_Type'));
		$this->Contract_ID->setDbValue($rs->fields('Contract_ID'));
		$this->created_by->setDbValue($rs->fields('created_by'));
		$this->created_on->setDbValue($rs->fields('created_on'));
		$this->updated_by->setDbValue($rs->fields('updated_by'));
		$this->updated_on->setDbValue($rs->fields('updated_on'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey->DbValue = $row['dbkey'];
		$this->dbkey_councilor->DbValue = $row['dbkey_councilor'];
		$this->dbkey_client->DbValue = $row['dbkey_client'];
		$this->date->DbValue = $row['date'];
		$this->time->DbValue = $row['time'];
		$this->comment->DbValue = $row['comment'];
		$this->dbkey_activity->DbValue = $row['dbkey_activity'];
		$this->dbkey_activity_list->DbValue = $row['dbkey_activity_list'];
		$this->attachment->Upload->DbValue = $row['attachment'];
		$this->Rate->DbValue = $row['Rate'];
		$this->Client_Type->DbValue = $row['Client_Type'];
		$this->Contract_ID->DbValue = $row['Contract_ID'];
		$this->created_by->DbValue = $row['created_by'];
		$this->created_on->DbValue = $row['created_on'];
		$this->updated_by->DbValue = $row['updated_by'];
		$this->updated_on->DbValue = $row['updated_on'];
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		$this->AddUrl = $this->GetAddUrl();
		$this->EditUrl = $this->GetEditUrl();
		$this->CopyUrl = $this->GetCopyUrl();
		$this->DeleteUrl = $this->GetDeleteUrl();
		$this->ListUrl = $this->GetListUrl();
		$this->SetupOtherOptions();

		// Convert decimal values if posted back
		if ($this->time->FormValue == $this->time->CurrentValue && is_numeric(ew_StrToFloat($this->time->CurrentValue)))
			$this->time->CurrentValue = ew_StrToFloat($this->time->CurrentValue);

		// Convert decimal values if posted back
		if ($this->Rate->FormValue == $this->Rate->CurrentValue && is_numeric(ew_StrToFloat($this->Rate->CurrentValue)))
			$this->Rate->CurrentValue = ew_StrToFloat($this->Rate->CurrentValue);

		// Call Row_Rendering event
		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey
		// dbkey_councilor
		// dbkey_client
		// date
		// time
		// comment
		// dbkey_activity
		// dbkey_activity_list
		// attachment
		// Rate
		// Client_Type
		// Contract_ID
		// created_by
		// created_on
		// updated_by
		// updated_on

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// dbkey_councilor
		if ($this->dbkey_councilor->VirtualValue <> "") {
			$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->VirtualValue;
		} else {
		if (strval($this->dbkey_councilor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->dbkey_councilor->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_councilor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->CurrentValue;
			}
		} else {
			$this->dbkey_councilor->ViewValue = NULL;
		}
		}
		$this->dbkey_councilor->ViewCustomAttributes = "";

		// dbkey_client
		if ($this->dbkey_client->VirtualValue <> "") {
			$this->dbkey_client->ViewValue = $this->dbkey_client->VirtualValue;
		} else {
		if (strval($this->dbkey_client->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		$this->dbkey_client->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_client->ViewValue = $this->dbkey_client->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_client->ViewValue = $this->dbkey_client->CurrentValue;
			}
		} else {
			$this->dbkey_client->ViewValue = NULL;
		}
		}
		$this->dbkey_client->ViewCustomAttributes = "";

		// date
		$this->date->ViewValue = $this->date->CurrentValue;
		$this->date->ViewValue = ew_FormatDateTime($this->date->ViewValue, 1);
		$this->date->ViewCustomAttributes = "";

		// time
		$this->time->ViewValue = $this->time->CurrentValue;
		$this->time->ViewCustomAttributes = "";

		// comment
		$this->comment->ViewValue = $this->comment->CurrentValue;
		$this->comment->ViewCustomAttributes = "";

		// dbkey_activity
		if (strval($this->dbkey_activity->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey_activity`" . ew_SearchString("=", $this->dbkey_activity->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey_activity`, (select activity.description from activity where activity.dbkey = dbkey_activity) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client_to_activity_code`";
		$sWhereWrk = "";
		$this->dbkey_activity->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->CurrentValue;
			}
		} else {
			$this->dbkey_activity->ViewValue = NULL;
		}
		$this->dbkey_activity->ViewCustomAttributes = "";

		// Rate
		$this->Rate->ViewValue = $this->Rate->CurrentValue;
		$this->Rate->ViewValue = ew_FormatNumber($this->Rate->ViewValue, 3, -2, -2, -2);
		$this->Rate->ViewCustomAttributes = "";

		// Client_Type
		$this->Client_Type->ViewValue = $this->Client_Type->CurrentValue;
		if (strval($this->Client_Type->CurrentValue) <> "") {
			$sFilterWrk = "`code`" . ew_SearchString("=", $this->Client_Type->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT `code`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `waivered`";
		$sWhereWrk = "";
		$this->Client_Type->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->Client_Type, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->Client_Type->ViewValue = $this->Client_Type->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->Client_Type->ViewValue = $this->Client_Type->CurrentValue;
			}
		} else {
			$this->Client_Type->ViewValue = NULL;
		}
		$this->Client_Type->ViewCustomAttributes = "";

		// Contract_ID
		$this->Contract_ID->ViewValue = $this->Contract_ID->CurrentValue;
		$this->Contract_ID->ViewCustomAttributes = "";

		// created_by
		if (strval($this->created_by->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->created_by->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->created_by->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->created_by, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->created_by->ViewValue = $this->created_by->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->created_by->ViewValue = $this->created_by->CurrentValue;
			}
		} else {
			$this->created_by->ViewValue = NULL;
		}
		$this->created_by->ViewCustomAttributes = "";

		// created_on
		$this->created_on->ViewValue = $this->created_on->CurrentValue;
		$this->created_on->ViewValue = ew_FormatDateTime($this->created_on->ViewValue, 1);
		$this->created_on->ViewCustomAttributes = "";

		// updated_by
		if (strval($this->updated_by->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->updated_by->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->updated_by->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->updated_by, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->updated_by->ViewValue = $this->updated_by->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->updated_by->ViewValue = $this->updated_by->CurrentValue;
			}
		} else {
			$this->updated_by->ViewValue = NULL;
		}
		$this->updated_by->ViewCustomAttributes = "";

		// updated_on
		$this->updated_on->ViewValue = $this->updated_on->CurrentValue;
		$this->updated_on->ViewValue = ew_FormatDateTime($this->updated_on->ViewValue, 1);
		$this->updated_on->ViewCustomAttributes = "";

			// dbkey_client
			$this->dbkey_client->LinkCustomAttributes = "";
			$this->dbkey_client->HrefValue = "";
			$this->dbkey_client->TooltipValue = "";

			// date
			$this->date->LinkCustomAttributes = "";
			$this->date->HrefValue = "";
			$this->date->TooltipValue = "";

			// time
			$this->time->LinkCustomAttributes = "";
			$this->time->HrefValue = "";
			$this->time->TooltipValue = "";

			// comment
			$this->comment->LinkCustomAttributes = "";
			$this->comment->HrefValue = "";
			$this->comment->TooltipValue = "";

			// dbkey_activity
			$this->dbkey_activity->LinkCustomAttributes = "";
			$this->dbkey_activity->HrefValue = "";
			$this->dbkey_activity->TooltipValue = "";

			// Rate
			$this->Rate->LinkCustomAttributes = "";
			$this->Rate->HrefValue = "";
			$this->Rate->TooltipValue = "";

			// Client_Type
			$this->Client_Type->LinkCustomAttributes = "";
			$this->Client_Type->HrefValue = "";
			$this->Client_Type->TooltipValue = "";

			// Contract_ID
			$this->Contract_ID->LinkCustomAttributes = "";
			$this->Contract_ID->HrefValue = "";
			$this->Contract_ID->TooltipValue = "";

			// created_by
			$this->created_by->LinkCustomAttributes = "";
			$this->created_by->HrefValue = "";
			$this->created_by->TooltipValue = "";

			// created_on
			$this->created_on->LinkCustomAttributes = "";
			$this->created_on->HrefValue = "";
			$this->created_on->TooltipValue = "";

			// updated_by
			$this->updated_by->LinkCustomAttributes = "";
			$this->updated_by->HrefValue = "";
			$this->updated_by->TooltipValue = "";

			// updated_on
			$this->updated_on->LinkCustomAttributes = "";
			$this->updated_on->HrefValue = "";
			$this->updated_on->TooltipValue = "";
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Set up export options
	function SetupExportOptions() {
		global $Language;

		// Printer friendly
		$item = &$this->ExportOptions->Add("print");
		$item->Body = "<a href=\"" . $this->ExportPrintUrl . "\" class=\"ewExportLink ewPrint\" title=\"" . ew_HtmlEncode($Language->Phrase("PrinterFriendlyText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("PrinterFriendlyText")) . "\">" . $Language->Phrase("PrinterFriendly") . "</a>";
		$item->Visible = TRUE;

		// Export to Excel
		$item = &$this->ExportOptions->Add("excel");
		$item->Body = "<a href=\"" . $this->ExportExcelUrl . "\" class=\"ewExportLink ewExcel\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToExcelText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToExcelText")) . "\">" . $Language->Phrase("ExportToExcel") . "</a>";
		$item->Visible = TRUE;

		// Export to Word
		$item = &$this->ExportOptions->Add("word");
		$item->Body = "<a href=\"" . $this->ExportWordUrl . "\" class=\"ewExportLink ewWord\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToWordText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToWordText")) . "\">" . $Language->Phrase("ExportToWord") . "</a>";
		$item->Visible = TRUE;

		// Export to Html
		$item = &$this->ExportOptions->Add("html");
		$item->Body = "<a href=\"" . $this->ExportHtmlUrl . "\" class=\"ewExportLink ewHtml\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToHtmlText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToHtmlText")) . "\">" . $Language->Phrase("ExportToHtml") . "</a>";
		$item->Visible = TRUE;

		// Export to Xml
		$item = &$this->ExportOptions->Add("xml");
		$item->Body = "<a href=\"" . $this->ExportXmlUrl . "\" class=\"ewExportLink ewXml\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToXmlText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToXmlText")) . "\">" . $Language->Phrase("ExportToXml") . "</a>";
		$item->Visible = FALSE;

		// Export to Csv
		$item = &$this->ExportOptions->Add("csv");
		$item->Body = "<a href=\"" . $this->ExportCsvUrl . "\" class=\"ewExportLink ewCsv\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToCsvText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToCsvText")) . "\">" . $Language->Phrase("ExportToCsv") . "</a>";
		$item->Visible = TRUE;

		// Export to Pdf
		$item = &$this->ExportOptions->Add("pdf");
		$item->Body = "<a href=\"" . $this->ExportPdfUrl . "\" class=\"ewExportLink ewPdf\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToPDFText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToPDFText")) . "\">" . $Language->Phrase("ExportToPDF") . "</a>";
		$item->Visible = TRUE;

		// Export to Email
		$item = &$this->ExportOptions->Add("email");
		$url = "";
		$item->Body = "<button id=\"emf_Cust_Client_Activity_Admins\" class=\"ewExportLink ewEmail\" title=\"" . $Language->Phrase("ExportToEmailText") . "\" data-caption=\"" . $Language->Phrase("ExportToEmailText") . "\" onclick=\"ew_EmailDialogShow({lnk:'emf_Cust_Client_Activity_Admins',hdr:ewLanguage.Phrase('ExportToEmailText'),f:document.fCust_Client_Activity_Adminsview,key:" . ew_ArrayToJsonAttr($this->RecKey) . ",sel:false" . $url . "});\">" . $Language->Phrase("ExportToEmail") . "</button>";
		$item->Visible = TRUE;

		// Drop down button for export
		$this->ExportOptions->UseButtonGroup = TRUE;
		$this->ExportOptions->UseImageAndText = TRUE;
		$this->ExportOptions->UseDropDownButton = FALSE;
		if ($this->ExportOptions->UseButtonGroup && ew_IsMobile())
			$this->ExportOptions->UseDropDownButton = TRUE;
		$this->ExportOptions->DropDownButtonPhrase = $Language->Phrase("ButtonExport");

		// Add group option item
		$item = &$this->ExportOptions->Add($this->ExportOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;

		// Hide options for export
		if ($this->Export <> "")
			$this->ExportOptions->HideAllOptions();
	}

	// Export data in HTML/CSV/Word/Excel/XML/Email/PDF format
	function ExportData() {
		$utf8 = (strtolower(EW_CHARSET) == "utf-8");
		$bSelectLimit = FALSE;

		// Load recordset
		if ($bSelectLimit) {
			$this->TotalRecs = $this->SelectRecordCount();
		} else {
			if (!$this->Recordset)
				$this->Recordset = $this->LoadRecordset();
			$rs = &$this->Recordset;
			if ($rs)
				$this->TotalRecs = $rs->RecordCount();
		}
		$this->StartRec = 1;
		$this->SetUpStartRec(); // Set up start record position

		// Set the last record to display
		if ($this->DisplayRecs <= 0) {
			$this->StopRec = $this->TotalRecs;
		} else {
			$this->StopRec = $this->StartRec + $this->DisplayRecs - 1;
		}
		if (!$rs) {
			header("Content-Type:"); // Remove header
			header("Content-Disposition:");
			$this->ShowMessage();
			return;
		}
		$this->ExportDoc = ew_ExportDocument($this, "v");
		$Doc = &$this->ExportDoc;
		if ($bSelectLimit) {
			$this->StartRec = 1;
			$this->StopRec = $this->DisplayRecs <= 0 ? $this->TotalRecs : $this->DisplayRecs;
		} else {

			//$this->StartRec = $this->StartRec;
			//$this->StopRec = $this->StopRec;

		}

		// Call Page Exporting server event
		$this->ExportDoc->ExportCustom = !$this->Page_Exporting();
		$ParentTable = "";
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		$Doc->Text .= $sHeader;
		$this->ExportDocument($Doc, $rs, $this->StartRec, $this->StopRec, "view");
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		$Doc->Text .= $sFooter;

		// Close recordset
		$rs->Close();

		// Call Page Exported server event
		$this->Page_Exported();

		// Export header and footer
		$Doc->ExportHeaderAndFooter();

		// Clean output buffer
		if (!EW_DEBUG_ENABLED && ob_get_length())
			ob_end_clean();

		// Write debug message if enabled
		if (EW_DEBUG_ENABLED && $this->Export <> "pdf")
			echo ew_DebugMsg();

		// Output data
		if ($this->Export == "email") {
			echo $this->ExportEmail($Doc->Text);
		} else {
			$Doc->Export();
		}
	}

	// Export email
	function ExportEmail($EmailContent) {
		global $gTmpImages, $Language;
		$sSender = @$_POST["sender"];
		$sRecipient = @$_POST["recipient"];
		$sCc = @$_POST["cc"];
		$sBcc = @$_POST["bcc"];
		$sContentType = @$_POST["contenttype"];

		// Subject
		$sSubject = ew_StripSlashes(@$_POST["subject"]);
		$sEmailSubject = $sSubject;

		// Message
		$sContent = ew_StripSlashes(@$_POST["message"]);
		$sEmailMessage = $sContent;

		// Check sender
		if ($sSender == "") {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterSenderEmail") . "</p>";
		}
		if (!ew_CheckEmail($sSender)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperSenderEmail") . "</p>";
		}

		// Check recipient
		if (!ew_CheckEmailList($sRecipient, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperRecipientEmail") . "</p>";
		}

		// Check cc
		if (!ew_CheckEmailList($sCc, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperCcEmail") . "</p>";
		}

		// Check bcc
		if (!ew_CheckEmailList($sBcc, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperBccEmail") . "</p>";
		}

		// Check email sent count
		if (!isset($_SESSION[EW_EXPORT_EMAIL_COUNTER]))
			$_SESSION[EW_EXPORT_EMAIL_COUNTER] = 0;
		if (intval($_SESSION[EW_EXPORT_EMAIL_COUNTER]) > EW_MAX_EMAIL_SENT_COUNT) {
			return "<p class=\"text-danger\">" . $Language->Phrase("ExceedMaxEmailExport") . "</p>";
		}

		// Send email
		$Email = new cEmail();
		$Email->Sender = $sSender; // Sender
		$Email->Recipient = $sRecipient; // Recipient
		$Email->Cc = $sCc; // Cc
		$Email->Bcc = $sBcc; // Bcc
		$Email->Subject = $sEmailSubject; // Subject
		$Email->Format = ($sContentType == "url") ? "text" : "html";
		if ($sEmailMessage <> "") {
			$sEmailMessage = ew_RemoveXSS($sEmailMessage);
			$sEmailMessage .= ($sContentType == "url") ? "\r\n\r\n" : "<br><br>";
		}
		if ($sContentType == "url") {
			$sUrl = ew_ConvertFullUrl(ew_CurrentPage() . "?" . $this->ExportQueryString());
			$sEmailMessage .= $sUrl; // Send URL only
		} else {
			foreach ($gTmpImages as $tmpimage)
				$Email->AddEmbeddedImage($tmpimage);
			$sEmailMessage .= ew_CleanEmailContent($EmailContent); // Send HTML
		}
		$Email->Content = $sEmailMessage; // Content
		$EventArgs = array();
		if ($this->Recordset) {
			$this->RecCnt = $this->StartRec - 1;
			$this->Recordset->MoveFirst();
			if ($this->StartRec > 1)
				$this->Recordset->Move($this->StartRec - 1);
			$EventArgs["rs"] = &$this->Recordset;
		}
		$bEmailSent = FALSE;
		if ($this->Email_Sending($Email, $EventArgs))
			$bEmailSent = $Email->Send();

		// Check email sent status
		if ($bEmailSent) {

			// Update email sent count
			$_SESSION[EW_EXPORT_EMAIL_COUNTER]++;

			// Sent email success
			return "<p class=\"text-success\">" . $Language->Phrase("SendEmailSuccess") . "</p>"; // Set up success message
		} else {

			// Sent email failure
			return "<p class=\"text-danger\">" . $Email->SendErrDescription . "</p>";
		}
	}

	// Export QueryString
	function ExportQueryString() {

		// Initialize
		$sQry = "export=html";

		// Add record key QueryString
		$sQry .= "&" . substr($this->KeyUrl("", ""), 1);
		return $sQry;
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, $this->AddMasterUrl("Cust_Client_Activity_Adminslist.php"), "", $this->TableVar, TRUE);
		$PageId = "view";
		$Breadcrumb->Add("view", $PageId, $url);
	}

	// Setup lookup filters of a field
	function SetupLookupFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Setup AutoSuggest filters of a field
	function SetupAutoSuggestFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Write Audit Trail start/end for grid update
	function WriteAuditTrailDummy($typ) {
		$table = 'Cust_Client_Activity_Admins';
		$usr = CurrentUserID();
		ew_WriteAuditTrail("log", ew_StdCurrentDateTime(), ew_ScriptName(), $usr, $typ, $table, "", "", "", "");
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Page Exporting event
	// $this->ExportDoc = export document object
	function Page_Exporting() {

		//$this->ExportDoc->Text = "my header"; // Export header
		//return FALSE; // Return FALSE to skip default export and use Row_Export event

		return TRUE; // Return TRUE to use default export and skip Row_Export event
	}

	// Row Export event
	// $this->ExportDoc = export document object
	function Row_Export($rs) {

		//$this->ExportDoc->Text .= "my content"; // Build HTML with field value: $rs["MyField"] or $this->MyField->ViewValue
	}

	// Page Exported event
	// $this->ExportDoc = export document object
	function Page_Exported() {

		//$this->ExportDoc->Text .= "my footer"; // Export footer
		//echo $this->ExportDoc->Text;

	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($Cust_Client_Activity_Admins_view)) $Cust_Client_Activity_Admins_view = new cCust_Client_Activity_Admins_view();

// Page init
$Cust_Client_Activity_Admins_view->Page_Init();

// Page main
$Cust_Client_Activity_Admins_view->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$Cust_Client_Activity_Admins_view->Page_Render();
?>
<?php include_once "header.php" ?>
<?php if ($Cust_Client_Activity_Admins->Export == "") { ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "view";
var CurrentForm = fCust_Client_Activity_Adminsview = new ew_Form("fCust_Client_Activity_Adminsview", "view");

// Form_CustomValidate event
fCust_Client_Activity_Adminsview.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fCust_Client_Activity_Adminsview.ValidateRequired = true;
<?php } else { ?>
fCust_Client_Activity_Adminsview.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fCust_Client_Activity_Adminsview.Lists["x_dbkey_client"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_last","x_first","",""],"ParentFields":[],"ChildFields":["x_dbkey_activity"],"FilterFields":[],"Options":[],"Template":"","LinkTable":"client"};
fCust_Client_Activity_Adminsview.Lists["x_dbkey_activity"] = {"LinkField":"x_dbkey_activity","Ajax":true,"AutoFill":false,"DisplayFields":["x_activity_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"client_to_activity_code"};
fCust_Client_Activity_Adminsview.Lists["x_Client_Type"] = {"LinkField":"x_code","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"waivered"};
fCust_Client_Activity_Adminsview.Lists["x_created_by"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"counselor"};
fCust_Client_Activity_Adminsview.Lists["x_updated_by"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"counselor"};

// Form object for search
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->Export == "") { ?>
<div class="ewToolbar">
<?php if (!$Cust_Client_Activity_Admins_view->IsModal) { ?>
<?php if ($Cust_Client_Activity_Admins->Export == "") { ?>
<?php $Breadcrumb->Render(); ?>
<?php } ?>
<?php } ?>
<?php $Cust_Client_Activity_Admins_view->ExportOptions->Render("body") ?>
<?php
	foreach ($Cust_Client_Activity_Admins_view->OtherOptions as &$option)
		$option->Render("body");
?>
<?php if (!$Cust_Client_Activity_Admins_view->IsModal) { ?>
<?php if ($Cust_Client_Activity_Admins->Export == "") { ?>
<?php echo $Language->SelectionForm(); ?>
<?php } ?>
<?php } ?>
<div class="clearfix"></div>
</div>
<?php } ?>
<?php $Cust_Client_Activity_Admins_view->ShowPageHeader(); ?>
<?php
$Cust_Client_Activity_Admins_view->ShowMessage();
?>
<form name="fCust_Client_Activity_Adminsview" id="fCust_Client_Activity_Adminsview" class="form-inline ewForm ewViewForm" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($Cust_Client_Activity_Admins_view->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $Cust_Client_Activity_Admins_view->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="Cust_Client_Activity_Admins">
<?php if ($Cust_Client_Activity_Admins_view->IsModal) { ?>
<input type="hidden" name="modal" value="1">
<?php } ?>
<table class="table table-bordered table-striped ewViewTable">
<?php if ($Cust_Client_Activity_Admins->dbkey_client->Visible) { // dbkey_client ?>
	<tr id="r_dbkey_client">
		<td><span id="elh_Cust_Client_Activity_Admins_dbkey_client"><?php echo $Cust_Client_Activity_Admins->dbkey_client->FldCaption() ?></span></td>
		<td data-name="dbkey_client"<?php echo $Cust_Client_Activity_Admins->dbkey_client->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_dbkey_client">
<span<?php echo $Cust_Client_Activity_Admins->dbkey_client->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity_Admins->dbkey_client->ViewValue ?></span>
</span>
</td>
	</tr>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->date->Visible) { // date ?>
	<tr id="r_date">
		<td><span id="elh_Cust_Client_Activity_Admins_date"><?php echo $Cust_Client_Activity_Admins->date->FldCaption() ?></span></td>
		<td data-name="date"<?php echo $Cust_Client_Activity_Admins->date->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_date">
<span<?php echo $Cust_Client_Activity_Admins->date->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity_Admins->date->ViewValue ?></span>
</span>
</td>
	</tr>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->time->Visible) { // time ?>
	<tr id="r_time">
		<td><span id="elh_Cust_Client_Activity_Admins_time"><?php echo $Cust_Client_Activity_Admins->time->FldCaption() ?></span></td>
		<td data-name="time"<?php echo $Cust_Client_Activity_Admins->time->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_time">
<span<?php echo $Cust_Client_Activity_Admins->time->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity_Admins->time->ViewValue ?></span>
</span>
</td>
	</tr>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->comment->Visible) { // comment ?>
	<tr id="r_comment">
		<td><span id="elh_Cust_Client_Activity_Admins_comment"><?php echo $Cust_Client_Activity_Admins->comment->FldCaption() ?></span></td>
		<td data-name="comment"<?php echo $Cust_Client_Activity_Admins->comment->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_comment">
<span<?php echo $Cust_Client_Activity_Admins->comment->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity_Admins->comment->ViewValue ?></span>
</span>
</td>
	</tr>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->dbkey_activity->Visible) { // dbkey_activity ?>
	<tr id="r_dbkey_activity">
		<td><span id="elh_Cust_Client_Activity_Admins_dbkey_activity"><?php echo $Cust_Client_Activity_Admins->dbkey_activity->FldCaption() ?></span></td>
		<td data-name="dbkey_activity"<?php echo $Cust_Client_Activity_Admins->dbkey_activity->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_dbkey_activity">
<span<?php echo $Cust_Client_Activity_Admins->dbkey_activity->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity_Admins->dbkey_activity->ViewValue ?></span>
</span>
</td>
	</tr>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->Rate->Visible) { // Rate ?>
	<tr id="r_Rate">
		<td><span id="elh_Cust_Client_Activity_Admins_Rate"><?php echo $Cust_Client_Activity_Admins->Rate->FldCaption() ?></span></td>
		<td data-name="Rate"<?php echo $Cust_Client_Activity_Admins->Rate->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_Rate">
<span<?php echo $Cust_Client_Activity_Admins->Rate->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity_Admins->Rate->ViewValue ?></span>
</span>
</td>
	</tr>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->Client_Type->Visible) { // Client_Type ?>
	<tr id="r_Client_Type">
		<td><span id="elh_Cust_Client_Activity_Admins_Client_Type"><?php echo $Cust_Client_Activity_Admins->Client_Type->FldCaption() ?></span></td>
		<td data-name="Client_Type"<?php echo $Cust_Client_Activity_Admins->Client_Type->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_Client_Type">
<span<?php echo $Cust_Client_Activity_Admins->Client_Type->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity_Admins->Client_Type->ViewValue ?></span>
</span>
</td>
	</tr>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->Contract_ID->Visible) { // Contract_ID ?>
	<tr id="r_Contract_ID">
		<td><span id="elh_Cust_Client_Activity_Admins_Contract_ID"><?php echo $Cust_Client_Activity_Admins->Contract_ID->FldCaption() ?></span></td>
		<td data-name="Contract_ID"<?php echo $Cust_Client_Activity_Admins->Contract_ID->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_Contract_ID">
<span<?php echo $Cust_Client_Activity_Admins->Contract_ID->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity_Admins->Contract_ID->ViewValue ?></span>
</span>
</td>
	</tr>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->created_by->Visible) { // created_by ?>
	<tr id="r_created_by">
		<td><span id="elh_Cust_Client_Activity_Admins_created_by"><?php echo $Cust_Client_Activity_Admins->created_by->FldCaption() ?></span></td>
		<td data-name="created_by"<?php echo $Cust_Client_Activity_Admins->created_by->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_created_by">
<span<?php echo $Cust_Client_Activity_Admins->created_by->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity_Admins->created_by->ViewValue ?></span>
</span>
</td>
	</tr>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->created_on->Visible) { // created_on ?>
	<tr id="r_created_on">
		<td><span id="elh_Cust_Client_Activity_Admins_created_on"><?php echo $Cust_Client_Activity_Admins->created_on->FldCaption() ?></span></td>
		<td data-name="created_on"<?php echo $Cust_Client_Activity_Admins->created_on->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_created_on">
<span<?php echo $Cust_Client_Activity_Admins->created_on->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity_Admins->created_on->ViewValue ?></span>
</span>
</td>
	</tr>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->updated_by->Visible) { // updated_by ?>
	<tr id="r_updated_by">
		<td><span id="elh_Cust_Client_Activity_Admins_updated_by"><?php echo $Cust_Client_Activity_Admins->updated_by->FldCaption() ?></span></td>
		<td data-name="updated_by"<?php echo $Cust_Client_Activity_Admins->updated_by->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_updated_by">
<span<?php echo $Cust_Client_Activity_Admins->updated_by->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity_Admins->updated_by->ViewValue ?></span>
</span>
</td>
	</tr>
<?php } ?>
<?php if ($Cust_Client_Activity_Admins->updated_on->Visible) { // updated_on ?>
	<tr id="r_updated_on">
		<td><span id="elh_Cust_Client_Activity_Admins_updated_on"><?php echo $Cust_Client_Activity_Admins->updated_on->FldCaption() ?></span></td>
		<td data-name="updated_on"<?php echo $Cust_Client_Activity_Admins->updated_on->CellAttributes() ?>>
<span id="el_Cust_Client_Activity_Admins_updated_on">
<span<?php echo $Cust_Client_Activity_Admins->updated_on->ViewAttributes() ?>>
<?php echo $Cust_Client_Activity_Admins->updated_on->ViewValue ?></span>
</span>
</td>
	</tr>
<?php } ?>
</table>
</form>
<?php if ($Cust_Client_Activity_Admins->Export == "") { ?>
<script type="text/javascript">
fCust_Client_Activity_Adminsview.Init();
</script>
<?php } ?>
<?php
$Cust_Client_Activity_Admins_view->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<?php if ($Cust_Client_Activity_Admins->Export == "") { ?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php } ?>
<?php include_once "footer.php" ?>
<?php
$Cust_Client_Activity_Admins_view->Page_Terminate();
?>
