<?php

// Global variable for table object
$Cust_Rpt_Client_Activity_Week = NULL;

//
// Table class for Cust_Rpt_Client_Activity_Week
//
class cCust_Rpt_Client_Activity_Week extends cTable {
	var $description;
	var $dbkey;
	var $First;
	var $Last;
	var $Total_Hours;
	var $Week_23;
	var $From_Date;
	var $Through_Date;
	var $Sunday;
	var $Monday;
	var $Tuesday;
	var $Wednesday;
	var $Thursday;
	var $Friday;
	var $Saturday;

	//
	// Table class constructor
	//
	function __construct() {
		global $Language;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();
		$this->TableVar = 'Cust_Rpt_Client_Activity_Week';
		$this->TableName = 'Cust_Rpt_Client_Activity_Week';
		$this->TableType = 'CUSTOMVIEW';

		// Update Table
		$this->UpdateTable = "client_activity, counselor, tables_data, tables_data b";
		$this->DBID = 'DB';
		$this->ExportAll = TRUE;
		$this->ExportPageBreakCount = 0; // Page break per every n record (PDF only)
		$this->ExportPageOrientation = "portrait"; // Page orientation (PDF only)
		$this->ExportPageSize = "a4"; // Page size (PDF only)
		$this->ExportExcelPageOrientation = ""; // Page orientation (PHPExcel only)
		$this->ExportExcelPageSize = ""; // Page size (PHPExcel only)
		$this->DetailAdd = FALSE; // Allow detail add
		$this->DetailEdit = FALSE; // Allow detail edit
		$this->DetailView = FALSE; // Allow detail view
		$this->ShowMultipleDetails = FALSE; // Show multiple details
		$this->GridAddRowCount = 1;
		$this->AllowAddDeleteRow = ew_AllowAddDeleteRow(); // Allow add/delete row
		$this->UserIDAllowSecurity = 0; // User ID Allow
		$this->BasicSearch = new cBasicSearch($this->TableVar);

		// description
		$this->description = new cField('Cust_Rpt_Client_Activity_Week', 'Cust_Rpt_Client_Activity_Week', 'x_description', 'description', 'b.description', 'b.description', 200, -1, FALSE, 'b.description', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->description->Sortable = TRUE; // Allow sort
		$this->fields['description'] = &$this->description;

		// dbkey
		$this->dbkey = new cField('Cust_Rpt_Client_Activity_Week', 'Cust_Rpt_Client_Activity_Week', 'x_dbkey', 'dbkey', 'tables_data.dbkey', 'tables_data.dbkey', 200, -1, FALSE, 'tables_data.dbkey', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->dbkey->Sortable = TRUE; // Allow sort
		$this->fields['dbkey'] = &$this->dbkey;

		// First
		$this->First = new cField('Cust_Rpt_Client_Activity_Week', 'Cust_Rpt_Client_Activity_Week', 'x_First', 'First', '`First`', '`First`', 200, -1, FALSE, '`First`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->First->Sortable = TRUE; // Allow sort
		$this->fields['First'] = &$this->First;

		// Last
		$this->Last = new cField('Cust_Rpt_Client_Activity_Week', 'Cust_Rpt_Client_Activity_Week', 'x_Last', 'Last', '`Last`', '`Last`', 200, -1, FALSE, '`Last`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Last->Sortable = TRUE; // Allow sort
		$this->fields['Last'] = &$this->Last;

		// Total Hours
		$this->Total_Hours = new cField('Cust_Rpt_Client_Activity_Week', 'Cust_Rpt_Client_Activity_Week', 'x_Total_Hours', 'Total Hours', '`Total Hours`', '`Total Hours`', 131, -1, FALSE, '`Total Hours`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Total_Hours->Sortable = TRUE; // Allow sort
		$this->Total_Hours->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Total Hours'] = &$this->Total_Hours;

		// Week #
		$this->Week_23 = new cField('Cust_Rpt_Client_Activity_Week', 'Cust_Rpt_Client_Activity_Week', 'x_Week_23', 'Week #', '`Week #`', '`Week #`', 20, -1, FALSE, '`Week #`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Week_23->Sortable = TRUE; // Allow sort
		$this->Week_23->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['Week #'] = &$this->Week_23;

		// From Date
		$this->From_Date = new cField('Cust_Rpt_Client_Activity_Week', 'Cust_Rpt_Client_Activity_Week', 'x_From_Date', 'From Date', '`From Date`', ew_CastDateFieldForLike('`From Date`', 0, "DB"), 133, 0, FALSE, '`From Date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->From_Date->Sortable = TRUE; // Allow sort
		$this->From_Date->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['From Date'] = &$this->From_Date;

		// Through Date
		$this->Through_Date = new cField('Cust_Rpt_Client_Activity_Week', 'Cust_Rpt_Client_Activity_Week', 'x_Through_Date', 'Through Date', '`Through Date`', ew_CastDateFieldForLike('`Through Date`', 0, "DB"), 135, 0, FALSE, '`Through Date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Through_Date->Sortable = TRUE; // Allow sort
		$this->Through_Date->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['Through Date'] = &$this->Through_Date;

		// Sunday
		$this->Sunday = new cField('Cust_Rpt_Client_Activity_Week', 'Cust_Rpt_Client_Activity_Week', 'x_Sunday', 'Sunday', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Sunday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Sunday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Sunday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Sunday->Sortable = TRUE; // Allow sort
		$this->Sunday->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Sunday'] = &$this->Sunday;

		// Monday
		$this->Monday = new cField('Cust_Rpt_Client_Activity_Week', 'Cust_Rpt_Client_Activity_Week', 'x_Monday', 'Monday', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Monday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Monday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Monday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Monday->Sortable = TRUE; // Allow sort
		$this->Monday->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Monday'] = &$this->Monday;

		// Tuesday
		$this->Tuesday = new cField('Cust_Rpt_Client_Activity_Week', 'Cust_Rpt_Client_Activity_Week', 'x_Tuesday', 'Tuesday', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Tuesday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Tuesday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Tuesday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Tuesday->Sortable = TRUE; // Allow sort
		$this->Tuesday->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Tuesday'] = &$this->Tuesday;

		// Wednesday
		$this->Wednesday = new cField('Cust_Rpt_Client_Activity_Week', 'Cust_Rpt_Client_Activity_Week', 'x_Wednesday', 'Wednesday', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Wednesday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Wednesday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Wednesday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Wednesday->Sortable = TRUE; // Allow sort
		$this->Wednesday->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Wednesday'] = &$this->Wednesday;

		// Thursday
		$this->Thursday = new cField('Cust_Rpt_Client_Activity_Week', 'Cust_Rpt_Client_Activity_Week', 'x_Thursday', 'Thursday', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Thursday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Thursday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Thursday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Thursday->Sortable = TRUE; // Allow sort
		$this->Thursday->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Thursday'] = &$this->Thursday;

		// Friday
		$this->Friday = new cField('Cust_Rpt_Client_Activity_Week', 'Cust_Rpt_Client_Activity_Week', 'x_Friday', 'Friday', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Friday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Friday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Friday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Friday->Sortable = TRUE; // Allow sort
		$this->Friday->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Friday'] = &$this->Friday;

		// Saturday
		$this->Saturday = new cField('Cust_Rpt_Client_Activity_Week', 'Cust_Rpt_Client_Activity_Week', 'x_Saturday', 'Saturday', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Saturday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Saturday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Saturday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Saturday->Sortable = TRUE; // Allow sort
		$this->Saturday->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Saturday'] = &$this->Saturday;
	}

	// Set Field Visibility
	function SetFieldVisibility($fldparm) {
		global $Security;
		return $this->$fldparm->Visible; // Returns original value
	}

	// Single column sort
	function UpdateSort(&$ofld) {
		if ($this->CurrentOrder == $ofld->FldName) {
			$sSortField = $ofld->FldExpression;
			$sLastSort = $ofld->getSort();
			if ($this->CurrentOrderType == "ASC" || $this->CurrentOrderType == "DESC") {
				$sThisSort = $this->CurrentOrderType;
			} else {
				$sThisSort = ($sLastSort == "ASC") ? "DESC" : "ASC";
			}
			$ofld->setSort($sThisSort);
			$this->setSessionOrderBy($sSortField . " " . $sThisSort); // Save to Session
		} else {
			$ofld->setSort("");
		}
	}

	// Table level SQL
	var $_SqlFrom = "";

	function getSqlFrom() { // From
		return ($this->_SqlFrom <> "") ? $this->_SqlFrom : "client_activity, counselor, tables_data, tables_data b";
	}

	function SqlFrom() { // For backward compatibility
		return $this->getSqlFrom();
	}

	function setSqlFrom($v) {
		$this->_SqlFrom = $v;
	}
	var $_SqlSelect = "";

	function getSqlSelect() { // Select
		return ($this->_SqlSelect <> "") ? $this->_SqlSelect : "SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Sunday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Monday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Tuesday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Wednesday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Thursday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Friday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Saturday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM " . $this->getSqlFrom();
	}

	function SqlSelect() { // For backward compatibility
		return $this->getSqlSelect();
	}

	function setSqlSelect($v) {
		$this->_SqlSelect = $v;
	}
	var $_SqlWhere = "";

	function getSqlWhere() { // Where
		$sWhere = ($this->_SqlWhere <> "") ? $this->_SqlWhere : "client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR'";
		$this->TableFilter = "";
		ew_AddFilter($sWhere, $this->TableFilter);
		return $sWhere;
	}

	function SqlWhere() { // For backward compatibility
		return $this->getSqlWhere();
	}

	function setSqlWhere($v) {
		$this->_SqlWhere = $v;
	}
	var $_SqlGroupBy = "";

	function getSqlGroupBy() { // Group By
		return ($this->_SqlGroupBy <> "") ? $this->_SqlGroupBy : "b.description, tables_data.dbkey, Week(client_activity.date), Year(client_activity.date), client_activity.dbkey_councilor, client_activity.date";
	}

	function SqlGroupBy() { // For backward compatibility
		return $this->getSqlGroupBy();
	}

	function setSqlGroupBy($v) {
		$this->_SqlGroupBy = $v;
	}
	var $_SqlHaving = "";

	function getSqlHaving() { // Having
		return ($this->_SqlHaving <> "") ? $this->_SqlHaving : "";
	}

	function SqlHaving() { // For backward compatibility
		return $this->getSqlHaving();
	}

	function setSqlHaving($v) {
		$this->_SqlHaving = $v;
	}
	var $_SqlOrderBy = "";

	function getSqlOrderBy() { // Order By
		return ($this->_SqlOrderBy <> "") ? $this->_SqlOrderBy : "b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor";
	}

	function SqlOrderBy() { // For backward compatibility
		return $this->getSqlOrderBy();
	}

	function setSqlOrderBy($v) {
		$this->_SqlOrderBy = $v;
	}

	// Apply User ID filters
	function ApplyUserIDFilters($sFilter) {
		return $sFilter;
	}

	// Check if User ID security allows view all
	function UserIDAllow($id = "") {
		$allow = EW_USER_ID_ALLOW;
		switch ($id) {
			case "add":
			case "copy":
			case "gridadd":
			case "register":
			case "addopt":
				return (($allow & 1) == 1);
			case "edit":
			case "gridedit":
			case "update":
			case "changepwd":
			case "forgotpwd":
				return (($allow & 4) == 4);
			case "delete":
				return (($allow & 2) == 2);
			case "view":
				return (($allow & 32) == 32);
			case "search":
				return (($allow & 64) == 64);
			default:
				return (($allow & 8) == 8);
		}
	}

	// Get SQL
	function GetSQL($where, $orderby) {
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$where, $orderby);
	}

	// Table SQL
	function SQL() {
		$sFilter = $this->CurrentFilter;
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$sFilter, $sSort);
	}

	// Table SQL with List page filter
	function SelectSQL() {
		$sFilter = $this->getSessionWhere();
		ew_AddFilter($sFilter, $this->CurrentFilter);
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$this->Recordset_Selecting($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(), $this->getSqlGroupBy(),
			$this->getSqlHaving(), $this->getSqlOrderBy(), $sFilter, $sSort);
	}

	// Get ORDER BY clause
	function GetOrderBy() {
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql("", "", "", "", $this->getSqlOrderBy(), "", $sSort);
	}

	// Try to get record count
	function TryGetRecordCount($sSql) {
		$cnt = -1;
		if (($this->TableType == 'TABLE' || $this->TableType == 'VIEW' || $this->TableType == 'LINKTABLE') && preg_match("/^SELECT \* FROM/i", $sSql)) {
			$sSql = "SELECT COUNT(*) FROM" . preg_replace('/^SELECT\s([\s\S]+)?\*\sFROM/i', "", $sSql);
			$sOrderBy = $this->GetOrderBy();
			if (substr($sSql, strlen($sOrderBy) * -1) == $sOrderBy)
				$sSql = substr($sSql, 0, strlen($sSql) - strlen($sOrderBy)); // Remove ORDER BY clause
		} else {
			$sSql = "SELECT COUNT(*) FROM (" . $sSql . ") EW_COUNT_TABLE";
		}
		$conn = &$this->Connection();
		if ($rs = $conn->Execute($sSql)) {
			if (!$rs->EOF && $rs->FieldCount() > 0) {
				$cnt = $rs->fields[0];
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// Get record count based on filter (for detail record count in master table pages)
	function LoadRecordCount($sFilter) {
		$origFilter = $this->CurrentFilter;
		$this->CurrentFilter = $sFilter;
		$this->Recordset_Selecting($this->CurrentFilter);

		//$sSql = $this->SQL();
		$sSql = $this->GetSQL($this->CurrentFilter, "");
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			if ($rs = $this->LoadRs($this->CurrentFilter)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		$this->CurrentFilter = $origFilter;
		return intval($cnt);
	}

	// Get record count (for current List page)
	function SelectRecordCount() {
		$sSql = $this->SelectSQL();
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			$conn = &$this->Connection();
			if ($rs = $conn->Execute($sSql)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// INSERT statement
	function InsertSQL(&$rs) {
		$names = "";
		$values = "";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$names .= $this->fields[$name]->FldExpression . ",";
			$values .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($names, -1) == ",")
			$names = substr($names, 0, -1);
		while (substr($values, -1) == ",")
			$values = substr($values, 0, -1);
		return "INSERT INTO " . $this->UpdateTable . " ($names) VALUES ($values)";
	}

	// Insert
	function Insert(&$rs) {
		$conn = &$this->Connection();
		return $conn->Execute($this->InsertSQL($rs));
	}

	// UPDATE statement
	function UpdateSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "UPDATE " . $this->UpdateTable . " SET ";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$sql .= $this->fields[$name]->FldExpression . "=";
			$sql .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($sql, -1) == ",")
			$sql = substr($sql, 0, -1);
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		ew_AddFilter($filter, $where);
		if ($filter <> "")	$sql .= " WHERE " . $filter;
		return $sql;
	}

	// Update
	function Update(&$rs, $where = "", $rsold = NULL, $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->UpdateSQL($rs, $where, $curfilter));
	}

	// DELETE statement
	function DeleteSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "DELETE FROM " . $this->UpdateTable . " WHERE ";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		if ($rs) {
		}
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		ew_AddFilter($filter, $where);
		if ($filter <> "")
			$sql .= $filter;
		else
			$sql .= "0=1"; // Avoid delete
		return $sql;
	}

	// Delete
	function Delete(&$rs, $where = "", $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->DeleteSQL($rs, $where, $curfilter));
	}

	// Key filter WHERE clause
	function SqlKeyFilter() {
		return "";
	}

	// Key filter
	function KeyFilter() {
		$sKeyFilter = $this->SqlKeyFilter();
		return $sKeyFilter;
	}

	// Return page URL
	function getReturnUrl() {
		$name = EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL;

		// Get referer URL automatically
		if (ew_ServerVar("HTTP_REFERER") <> "" && ew_ReferPage() <> ew_CurrentPage() && ew_ReferPage() <> "login.php") // Referer not same page or login page
			$_SESSION[$name] = ew_ServerVar("HTTP_REFERER"); // Save to Session
		if (@$_SESSION[$name] <> "") {
			return $_SESSION[$name];
		} else {
			return "Cust_Rpt_Client_Activity_Weeklist.php";
		}
	}

	function setReturnUrl($v) {
		$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL] = $v;
	}

	// List URL
	function GetListUrl() {
		return "Cust_Rpt_Client_Activity_Weeklist.php";
	}

	// View URL
	function GetViewUrl($parm = "") {
		if ($parm <> "")
			$url = $this->KeyUrl("Cust_Rpt_Client_Activity_Weekview.php", $this->UrlParm($parm));
		else
			$url = $this->KeyUrl("Cust_Rpt_Client_Activity_Weekview.php", $this->UrlParm(EW_TABLE_SHOW_DETAIL . "="));
		return $this->AddMasterUrl($url);
	}

	// Add URL
	function GetAddUrl($parm = "") {
		if ($parm <> "")
			$url = "Cust_Rpt_Client_Activity_Weekadd.php?" . $this->UrlParm($parm);
		else
			$url = "Cust_Rpt_Client_Activity_Weekadd.php";
		return $this->AddMasterUrl($url);
	}

	// Edit URL
	function GetEditUrl($parm = "") {
		$url = $this->KeyUrl("Cust_Rpt_Client_Activity_Weekedit.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline edit URL
	function GetInlineEditUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=edit"));
		return $this->AddMasterUrl($url);
	}

	// Copy URL
	function GetCopyUrl($parm = "") {
		$url = $this->KeyUrl("Cust_Rpt_Client_Activity_Weekadd.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline copy URL
	function GetInlineCopyUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=copy"));
		return $this->AddMasterUrl($url);
	}

	// Delete URL
	function GetDeleteUrl() {
		return $this->KeyUrl("Cust_Rpt_Client_Activity_Weekdelete.php", $this->UrlParm());
	}

	// Add master url
	function AddMasterUrl($url) {
		return $url;
	}

	function KeyToJson() {
		$json = "";
		return "{" . $json . "}";
	}

	// Add key value to URL
	function KeyUrl($url, $parm = "") {
		$sUrl = $url . "?";
		if ($parm <> "") $sUrl .= $parm . "&";
		return $sUrl;
	}

	// Sort URL
	function SortUrl(&$fld) {
		if ($this->CurrentAction <> "" || $this->Export <> "" ||
			in_array($fld->FldType, array(128, 204, 205))) { // Unsortable data type
				return "";
		} elseif ($fld->Sortable) {
			$sUrlParm = $this->UrlParm("order=" . urlencode($fld->FldName) . "&amp;ordertype=" . $fld->ReverseSort());
			return $this->AddMasterUrl(ew_CurrentPage() . "?" . $sUrlParm);
		} else {
			return "";
		}
	}

	// Get record keys from $_POST/$_GET/$_SESSION
	function GetRecordKeys() {
		global $EW_COMPOSITE_KEY_SEPARATOR;
		$arKeys = array();
		$arKey = array();
		if (isset($_POST["key_m"])) {
			$arKeys = ew_StripSlashes($_POST["key_m"]);
			$cnt = count($arKeys);
		} elseif (isset($_GET["key_m"])) {
			$arKeys = ew_StripSlashes($_GET["key_m"]);
			$cnt = count($arKeys);
		} elseif (!empty($_GET) || !empty($_POST)) {
			$isPost = ew_IsHttpPost();

			//return $arKeys; // Do not return yet, so the values will also be checked by the following code
		}

		// Check keys
		$ar = array();
		if (is_array($arKeys)) {
			foreach ($arKeys as $key) {
				$ar[] = $key;
			}
		}
		return $ar;
	}

	// Get key filter
	function GetKeyFilter() {
		$arKeys = $this->GetRecordKeys();
		$sKeyFilter = "";
		foreach ($arKeys as $key) {
			if ($sKeyFilter <> "") $sKeyFilter .= " OR ";
			$sKeyFilter .= "(" . $this->KeyFilter() . ")";
		}
		return $sKeyFilter;
	}

	// Load rows based on filter
	function &LoadRs($sFilter) {

		// Set up filter (SQL WHERE clause) and get return SQL
		//$this->CurrentFilter = $sFilter;
		//$sSql = $this->SQL();

		$sSql = $this->GetSQL($sFilter, "");
		$conn = &$this->Connection();
		$rs = $conn->Execute($sSql);
		return $rs;
	}

	// Load row values from recordset
	function LoadListRowValues(&$rs) {
		$this->description->setDbValue($rs->fields('description'));
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->First->setDbValue($rs->fields('First'));
		$this->Last->setDbValue($rs->fields('Last'));
		$this->Total_Hours->setDbValue($rs->fields('Total Hours'));
		$this->Week_23->setDbValue($rs->fields('Week #'));
		$this->From_Date->setDbValue($rs->fields('From Date'));
		$this->Through_Date->setDbValue($rs->fields('Through Date'));
		$this->Sunday->setDbValue($rs->fields('Sunday'));
		$this->Monday->setDbValue($rs->fields('Monday'));
		$this->Tuesday->setDbValue($rs->fields('Tuesday'));
		$this->Wednesday->setDbValue($rs->fields('Wednesday'));
		$this->Thursday->setDbValue($rs->fields('Thursday'));
		$this->Friday->setDbValue($rs->fields('Friday'));
		$this->Saturday->setDbValue($rs->fields('Saturday'));
	}

	// Render list row values
	function RenderListRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

   // Common render codes
		// description
		// dbkey
		// First
		// Last
		// Total Hours
		// Week #
		// From Date
		// Through Date
		// Sunday
		// Monday
		// Tuesday
		// Wednesday
		// Thursday
		// Friday
		// Saturday
		// description

		$this->description->ViewValue = $this->description->CurrentValue;
		$this->description->ViewCustomAttributes = "";

		// dbkey
		$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// First
		$this->First->ViewValue = $this->First->CurrentValue;
		$this->First->ViewCustomAttributes = "";

		// Last
		$this->Last->ViewValue = $this->Last->CurrentValue;
		$this->Last->ViewCustomAttributes = "";

		// Total Hours
		$this->Total_Hours->ViewValue = $this->Total_Hours->CurrentValue;
		$this->Total_Hours->ViewCustomAttributes = "";

		// Week #
		$this->Week_23->ViewValue = $this->Week_23->CurrentValue;
		$this->Week_23->ViewCustomAttributes = "";

		// From Date
		$this->From_Date->ViewValue = $this->From_Date->CurrentValue;
		$this->From_Date->ViewValue = ew_FormatDateTime($this->From_Date->ViewValue, 0);
		$this->From_Date->ViewCustomAttributes = "";

		// Through Date
		$this->Through_Date->ViewValue = $this->Through_Date->CurrentValue;
		$this->Through_Date->ViewValue = ew_FormatDateTime($this->Through_Date->ViewValue, 0);
		$this->Through_Date->ViewCustomAttributes = "";

		// Sunday
		$this->Sunday->ViewValue = $this->Sunday->CurrentValue;
		$this->Sunday->ViewCustomAttributes = "";

		// Monday
		$this->Monday->ViewValue = $this->Monday->CurrentValue;
		$this->Monday->ViewCustomAttributes = "";

		// Tuesday
		$this->Tuesday->ViewValue = $this->Tuesday->CurrentValue;
		$this->Tuesday->ViewCustomAttributes = "";

		// Wednesday
		$this->Wednesday->ViewValue = $this->Wednesday->CurrentValue;
		$this->Wednesday->ViewCustomAttributes = "";

		// Thursday
		$this->Thursday->ViewValue = $this->Thursday->CurrentValue;
		$this->Thursday->ViewCustomAttributes = "";

		// Friday
		$this->Friday->ViewValue = $this->Friday->CurrentValue;
		$this->Friday->ViewCustomAttributes = "";

		// Saturday
		$this->Saturday->ViewValue = $this->Saturday->CurrentValue;
		$this->Saturday->ViewCustomAttributes = "";

		// description
		$this->description->LinkCustomAttributes = "";
		$this->description->HrefValue = "";
		$this->description->TooltipValue = "";

		// dbkey
		$this->dbkey->LinkCustomAttributes = "";
		$this->dbkey->HrefValue = "";
		$this->dbkey->TooltipValue = "";

		// First
		$this->First->LinkCustomAttributes = "";
		$this->First->HrefValue = "";
		$this->First->TooltipValue = "";

		// Last
		$this->Last->LinkCustomAttributes = "";
		$this->Last->HrefValue = "";
		$this->Last->TooltipValue = "";

		// Total Hours
		$this->Total_Hours->LinkCustomAttributes = "";
		$this->Total_Hours->HrefValue = "";
		$this->Total_Hours->TooltipValue = "";

		// Week #
		$this->Week_23->LinkCustomAttributes = "";
		$this->Week_23->HrefValue = "";
		$this->Week_23->TooltipValue = "";

		// From Date
		$this->From_Date->LinkCustomAttributes = "";
		$this->From_Date->HrefValue = "";
		$this->From_Date->TooltipValue = "";

		// Through Date
		$this->Through_Date->LinkCustomAttributes = "";
		$this->Through_Date->HrefValue = "";
		$this->Through_Date->TooltipValue = "";

		// Sunday
		$this->Sunday->LinkCustomAttributes = "";
		$this->Sunday->HrefValue = "";
		$this->Sunday->TooltipValue = "";

		// Monday
		$this->Monday->LinkCustomAttributes = "";
		$this->Monday->HrefValue = "";
		$this->Monday->TooltipValue = "";

		// Tuesday
		$this->Tuesday->LinkCustomAttributes = "";
		$this->Tuesday->HrefValue = "";
		$this->Tuesday->TooltipValue = "";

		// Wednesday
		$this->Wednesday->LinkCustomAttributes = "";
		$this->Wednesday->HrefValue = "";
		$this->Wednesday->TooltipValue = "";

		// Thursday
		$this->Thursday->LinkCustomAttributes = "";
		$this->Thursday->HrefValue = "";
		$this->Thursday->TooltipValue = "";

		// Friday
		$this->Friday->LinkCustomAttributes = "";
		$this->Friday->HrefValue = "";
		$this->Friday->TooltipValue = "";

		// Saturday
		$this->Saturday->LinkCustomAttributes = "";
		$this->Saturday->HrefValue = "";
		$this->Saturday->TooltipValue = "";

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Render edit row values
	function RenderEditRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

		// description
		$this->description->EditAttrs["class"] = "form-control";
		$this->description->EditCustomAttributes = "";
		$this->description->EditValue = $this->description->CurrentValue;
		$this->description->PlaceHolder = ew_RemoveHtml($this->description->FldCaption());

		// dbkey
		$this->dbkey->EditAttrs["class"] = "form-control";
		$this->dbkey->EditCustomAttributes = "";
		$this->dbkey->EditValue = $this->dbkey->CurrentValue;
		$this->dbkey->PlaceHolder = ew_RemoveHtml($this->dbkey->FldCaption());

		// First
		$this->First->EditAttrs["class"] = "form-control";
		$this->First->EditCustomAttributes = "";
		$this->First->EditValue = $this->First->CurrentValue;
		$this->First->PlaceHolder = ew_RemoveHtml($this->First->FldCaption());

		// Last
		$this->Last->EditAttrs["class"] = "form-control";
		$this->Last->EditCustomAttributes = "";
		$this->Last->EditValue = $this->Last->CurrentValue;
		$this->Last->PlaceHolder = ew_RemoveHtml($this->Last->FldCaption());

		// Total Hours
		$this->Total_Hours->EditAttrs["class"] = "form-control";
		$this->Total_Hours->EditCustomAttributes = "";
		$this->Total_Hours->EditValue = $this->Total_Hours->CurrentValue;
		$this->Total_Hours->PlaceHolder = ew_RemoveHtml($this->Total_Hours->FldCaption());
		if (strval($this->Total_Hours->EditValue) <> "" && is_numeric($this->Total_Hours->EditValue)) $this->Total_Hours->EditValue = ew_FormatNumber($this->Total_Hours->EditValue, -2, -1, -2, 0);

		// Week #
		$this->Week_23->EditAttrs["class"] = "form-control";
		$this->Week_23->EditCustomAttributes = "";
		$this->Week_23->EditValue = $this->Week_23->CurrentValue;
		$this->Week_23->PlaceHolder = ew_RemoveHtml($this->Week_23->FldCaption());

		// From Date
		$this->From_Date->EditAttrs["class"] = "form-control";
		$this->From_Date->EditCustomAttributes = "";
		$this->From_Date->EditValue = ew_FormatDateTime($this->From_Date->CurrentValue, 8);
		$this->From_Date->PlaceHolder = ew_RemoveHtml($this->From_Date->FldCaption());

		// Through Date
		$this->Through_Date->EditAttrs["class"] = "form-control";
		$this->Through_Date->EditCustomAttributes = "";
		$this->Through_Date->EditValue = ew_FormatDateTime($this->Through_Date->CurrentValue, 8);
		$this->Through_Date->PlaceHolder = ew_RemoveHtml($this->Through_Date->FldCaption());

		// Sunday
		$this->Sunday->EditAttrs["class"] = "form-control";
		$this->Sunday->EditCustomAttributes = "";
		$this->Sunday->EditValue = $this->Sunday->CurrentValue;
		$this->Sunday->PlaceHolder = ew_RemoveHtml($this->Sunday->FldCaption());
		if (strval($this->Sunday->EditValue) <> "" && is_numeric($this->Sunday->EditValue)) $this->Sunday->EditValue = ew_FormatNumber($this->Sunday->EditValue, -2, -1, -2, 0);

		// Monday
		$this->Monday->EditAttrs["class"] = "form-control";
		$this->Monday->EditCustomAttributes = "";
		$this->Monday->EditValue = $this->Monday->CurrentValue;
		$this->Monday->PlaceHolder = ew_RemoveHtml($this->Monday->FldCaption());
		if (strval($this->Monday->EditValue) <> "" && is_numeric($this->Monday->EditValue)) $this->Monday->EditValue = ew_FormatNumber($this->Monday->EditValue, -2, -1, -2, 0);

		// Tuesday
		$this->Tuesday->EditAttrs["class"] = "form-control";
		$this->Tuesday->EditCustomAttributes = "";
		$this->Tuesday->EditValue = $this->Tuesday->CurrentValue;
		$this->Tuesday->PlaceHolder = ew_RemoveHtml($this->Tuesday->FldCaption());
		if (strval($this->Tuesday->EditValue) <> "" && is_numeric($this->Tuesday->EditValue)) $this->Tuesday->EditValue = ew_FormatNumber($this->Tuesday->EditValue, -2, -1, -2, 0);

		// Wednesday
		$this->Wednesday->EditAttrs["class"] = "form-control";
		$this->Wednesday->EditCustomAttributes = "";
		$this->Wednesday->EditValue = $this->Wednesday->CurrentValue;
		$this->Wednesday->PlaceHolder = ew_RemoveHtml($this->Wednesday->FldCaption());
		if (strval($this->Wednesday->EditValue) <> "" && is_numeric($this->Wednesday->EditValue)) $this->Wednesday->EditValue = ew_FormatNumber($this->Wednesday->EditValue, -2, -1, -2, 0);

		// Thursday
		$this->Thursday->EditAttrs["class"] = "form-control";
		$this->Thursday->EditCustomAttributes = "";
		$this->Thursday->EditValue = $this->Thursday->CurrentValue;
		$this->Thursday->PlaceHolder = ew_RemoveHtml($this->Thursday->FldCaption());
		if (strval($this->Thursday->EditValue) <> "" && is_numeric($this->Thursday->EditValue)) $this->Thursday->EditValue = ew_FormatNumber($this->Thursday->EditValue, -2, -1, -2, 0);

		// Friday
		$this->Friday->EditAttrs["class"] = "form-control";
		$this->Friday->EditCustomAttributes = "";
		$this->Friday->EditValue = $this->Friday->CurrentValue;
		$this->Friday->PlaceHolder = ew_RemoveHtml($this->Friday->FldCaption());
		if (strval($this->Friday->EditValue) <> "" && is_numeric($this->Friday->EditValue)) $this->Friday->EditValue = ew_FormatNumber($this->Friday->EditValue, -2, -1, -2, 0);

		// Saturday
		$this->Saturday->EditAttrs["class"] = "form-control";
		$this->Saturday->EditCustomAttributes = "";
		$this->Saturday->EditValue = $this->Saturday->CurrentValue;
		$this->Saturday->PlaceHolder = ew_RemoveHtml($this->Saturday->FldCaption());
		if (strval($this->Saturday->EditValue) <> "" && is_numeric($this->Saturday->EditValue)) $this->Saturday->EditValue = ew_FormatNumber($this->Saturday->EditValue, -2, -1, -2, 0);

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Aggregate list row values
	function AggregateListRowValues() {
	}

	// Aggregate list row (for rendering)
	function AggregateListRow() {

		// Call Row Rendered event
		$this->Row_Rendered();
	}
	var $ExportDoc;

	// Export data in HTML/CSV/Word/Excel/Email/PDF format
	function ExportDocument(&$Doc, &$Recordset, $StartRec, $StopRec, $ExportPageType = "") {
		if (!$Recordset || !$Doc)
			return;
		if (!$Doc->ExportCustom) {

			// Write header
			$Doc->ExportTableHeader();
			if ($Doc->Horizontal) { // Horizontal format, write header
				$Doc->BeginExportRow();
				if ($ExportPageType == "view") {
					if ($this->description->Exportable) $Doc->ExportCaption($this->description);
					if ($this->dbkey->Exportable) $Doc->ExportCaption($this->dbkey);
					if ($this->First->Exportable) $Doc->ExportCaption($this->First);
					if ($this->Last->Exportable) $Doc->ExportCaption($this->Last);
					if ($this->Total_Hours->Exportable) $Doc->ExportCaption($this->Total_Hours);
					if ($this->Week_23->Exportable) $Doc->ExportCaption($this->Week_23);
					if ($this->From_Date->Exportable) $Doc->ExportCaption($this->From_Date);
					if ($this->Through_Date->Exportable) $Doc->ExportCaption($this->Through_Date);
					if ($this->Sunday->Exportable) $Doc->ExportCaption($this->Sunday);
					if ($this->Monday->Exportable) $Doc->ExportCaption($this->Monday);
					if ($this->Tuesday->Exportable) $Doc->ExportCaption($this->Tuesday);
					if ($this->Wednesday->Exportable) $Doc->ExportCaption($this->Wednesday);
					if ($this->Thursday->Exportable) $Doc->ExportCaption($this->Thursday);
					if ($this->Friday->Exportable) $Doc->ExportCaption($this->Friday);
					if ($this->Saturday->Exportable) $Doc->ExportCaption($this->Saturday);
				} else {
					if ($this->description->Exportable) $Doc->ExportCaption($this->description);
					if ($this->dbkey->Exportable) $Doc->ExportCaption($this->dbkey);
					if ($this->First->Exportable) $Doc->ExportCaption($this->First);
					if ($this->Last->Exportable) $Doc->ExportCaption($this->Last);
					if ($this->Total_Hours->Exportable) $Doc->ExportCaption($this->Total_Hours);
					if ($this->Week_23->Exportable) $Doc->ExportCaption($this->Week_23);
					if ($this->From_Date->Exportable) $Doc->ExportCaption($this->From_Date);
					if ($this->Through_Date->Exportable) $Doc->ExportCaption($this->Through_Date);
					if ($this->Sunday->Exportable) $Doc->ExportCaption($this->Sunday);
					if ($this->Monday->Exportable) $Doc->ExportCaption($this->Monday);
					if ($this->Tuesday->Exportable) $Doc->ExportCaption($this->Tuesday);
					if ($this->Wednesday->Exportable) $Doc->ExportCaption($this->Wednesday);
					if ($this->Thursday->Exportable) $Doc->ExportCaption($this->Thursday);
					if ($this->Friday->Exportable) $Doc->ExportCaption($this->Friday);
					if ($this->Saturday->Exportable) $Doc->ExportCaption($this->Saturday);
				}
				$Doc->EndExportRow();
			}
		}

		// Move to first record
		$RecCnt = $StartRec - 1;
		if (!$Recordset->EOF) {
			$Recordset->MoveFirst();
			if ($StartRec > 1)
				$Recordset->Move($StartRec - 1);
		}
		while (!$Recordset->EOF && $RecCnt < $StopRec) {
			$RecCnt++;
			if (intval($RecCnt) >= intval($StartRec)) {
				$RowCnt = intval($RecCnt) - intval($StartRec) + 1;

				// Page break
				if ($this->ExportPageBreakCount > 0) {
					if ($RowCnt > 1 && ($RowCnt - 1) % $this->ExportPageBreakCount == 0)
						$Doc->ExportPageBreak();
				}
				$this->LoadListRowValues($Recordset);

				// Render row
				$this->RowType = EW_ROWTYPE_VIEW; // Render view
				$this->ResetAttrs();
				$this->RenderListRow();
				if (!$Doc->ExportCustom) {
					$Doc->BeginExportRow($RowCnt); // Allow CSS styles if enabled
					if ($ExportPageType == "view") {
						if ($this->description->Exportable) $Doc->ExportField($this->description);
						if ($this->dbkey->Exportable) $Doc->ExportField($this->dbkey);
						if ($this->First->Exportable) $Doc->ExportField($this->First);
						if ($this->Last->Exportable) $Doc->ExportField($this->Last);
						if ($this->Total_Hours->Exportable) $Doc->ExportField($this->Total_Hours);
						if ($this->Week_23->Exportable) $Doc->ExportField($this->Week_23);
						if ($this->From_Date->Exportable) $Doc->ExportField($this->From_Date);
						if ($this->Through_Date->Exportable) $Doc->ExportField($this->Through_Date);
						if ($this->Sunday->Exportable) $Doc->ExportField($this->Sunday);
						if ($this->Monday->Exportable) $Doc->ExportField($this->Monday);
						if ($this->Tuesday->Exportable) $Doc->ExportField($this->Tuesday);
						if ($this->Wednesday->Exportable) $Doc->ExportField($this->Wednesday);
						if ($this->Thursday->Exportable) $Doc->ExportField($this->Thursday);
						if ($this->Friday->Exportable) $Doc->ExportField($this->Friday);
						if ($this->Saturday->Exportable) $Doc->ExportField($this->Saturday);
					} else {
						if ($this->description->Exportable) $Doc->ExportField($this->description);
						if ($this->dbkey->Exportable) $Doc->ExportField($this->dbkey);
						if ($this->First->Exportable) $Doc->ExportField($this->First);
						if ($this->Last->Exportable) $Doc->ExportField($this->Last);
						if ($this->Total_Hours->Exportable) $Doc->ExportField($this->Total_Hours);
						if ($this->Week_23->Exportable) $Doc->ExportField($this->Week_23);
						if ($this->From_Date->Exportable) $Doc->ExportField($this->From_Date);
						if ($this->Through_Date->Exportable) $Doc->ExportField($this->Through_Date);
						if ($this->Sunday->Exportable) $Doc->ExportField($this->Sunday);
						if ($this->Monday->Exportable) $Doc->ExportField($this->Monday);
						if ($this->Tuesday->Exportable) $Doc->ExportField($this->Tuesday);
						if ($this->Wednesday->Exportable) $Doc->ExportField($this->Wednesday);
						if ($this->Thursday->Exportable) $Doc->ExportField($this->Thursday);
						if ($this->Friday->Exportable) $Doc->ExportField($this->Friday);
						if ($this->Saturday->Exportable) $Doc->ExportField($this->Saturday);
					}
					$Doc->EndExportRow();
				}
			}

			// Call Row Export server event
			if ($Doc->ExportCustom)
				$this->Row_Export($Recordset->fields);
			$Recordset->MoveNext();
		}
		if (!$Doc->ExportCustom) {
			$Doc->ExportTableFooter();
		}
	}

	// Get auto fill value
	function GetAutoFill($id, $val) {
		$rsarr = array();
		$rowcnt = 0;

		// Output
		if (is_array($rsarr) && $rowcnt > 0) {
			$fldcnt = count($rsarr[0]);
			for ($i = 0; $i < $rowcnt; $i++) {
				for ($j = 0; $j < $fldcnt; $j++) {
					$str = strval($rsarr[$i][$j]);
					$str = ew_ConvertToUtf8($str);
					if (isset($post["keepCRLF"])) {
						$str = str_replace(array("\r", "\n"), array("\\r", "\\n"), $str);
					} else {
						$str = str_replace(array("\r", "\n"), array(" ", " "), $str);
					}
					$rsarr[$i][$j] = $str;
				}
			}
			return ew_ArrayToJson($rsarr);
		} else {
			return FALSE;
		}
	}

	// Table level events
	// Recordset Selecting event
	function Recordset_Selecting(&$filter) {

		// Enter your code here	
	}

	// Recordset Selected event
	function Recordset_Selected(&$rs) {

		//echo "Recordset Selected";
	}

	// Recordset Search Validated event
	function Recordset_SearchValidated() {

		// Example:
		//$this->MyField1->AdvancedSearch->SearchValue = "your search criteria"; // Search value

	}

	// Recordset Searching event
	function Recordset_Searching(&$filter) {

		// Enter your code here	
	}

	// Row_Selecting event
	function Row_Selecting(&$filter) {

		// Enter your code here	
	}

	// Row Selected event
	function Row_Selected(&$rs) {

		//echo "Row Selected";
	}

	// Row Inserting event
	function Row_Inserting($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Inserted event
	function Row_Inserted($rsold, &$rsnew) {

		//echo "Row Inserted"
	}

	// Row Updating event
	function Row_Updating($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Updated event
	function Row_Updated($rsold, &$rsnew) {

		//echo "Row Updated";
	}

	// Row Update Conflict event
	function Row_UpdateConflict($rsold, &$rsnew) {

		// Enter your code here
		// To ignore conflict, set return value to FALSE

		return TRUE;
	}

	// Grid Inserting event
	function Grid_Inserting() {

		// Enter your code here
		// To reject grid insert, set return value to FALSE

		return TRUE;
	}

	// Grid Inserted event
	function Grid_Inserted($rsnew) {

		//echo "Grid Inserted";
	}

	// Grid Updating event
	function Grid_Updating($rsold) {

		// Enter your code here
		// To reject grid update, set return value to FALSE

		return TRUE;
	}

	// Grid Updated event
	function Grid_Updated($rsold, $rsnew) {

		//echo "Grid Updated";
	}

	// Row Deleting event
	function Row_Deleting(&$rs) {

		// Enter your code here
		// To cancel, set return value to False

		return TRUE;
	}

	// Row Deleted event
	function Row_Deleted(&$rs) {

		//echo "Row Deleted";
	}

	// Email Sending event
	function Email_Sending(&$Email, &$Args) {

		//var_dump($Email); var_dump($Args); exit();
		return TRUE;
	}

	// Lookup Selecting event
	function Lookup_Selecting($fld, &$filter) {

		//var_dump($fld->FldName, $fld->LookupFilters, $filter); // Uncomment to view the filter
		// Enter your code here

	}

	// Row Rendering event
	function Row_Rendering() {

		// Enter your code here	
	}

	// Row Rendered event
	function Row_Rendered() {

		// To view properties of field class, use:
		//var_dump($this-><FieldName>); 

	}

	// User ID Filtering event
	function UserID_Filtering(&$filter) {

		// Enter your code here
	}
}
?>
