<?php

// Global variable for table object
$Cust_Rpt_Client_Budget_Summary = NULL;

//
// Table class for Cust_Rpt_Client_Budget_Summary
//
class cCust_Rpt_Client_Budget_Summary extends cTable {
	var $dbkey_client;
	var $first;
	var $last;
	var $dbkey_activity;
	var $budget;
	var $allocated;
	var $remain;
	var $waived;
	var $from;
	var $through;
	var $dbkey;

	//
	// Table class constructor
	//
	function __construct() {
		global $Language;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();
		$this->TableVar = 'Cust_Rpt_Client_Budget_Summary';
		$this->TableName = 'Cust_Rpt_Client_Budget_Summary';
		$this->TableType = 'CUSTOMVIEW';

		// Update Table
		$this->UpdateTable = "client_budget, client";
		$this->DBID = 'DB';
		$this->ExportAll = TRUE;
		$this->ExportPageBreakCount = 0; // Page break per every n record (PDF only)
		$this->ExportPageOrientation = "portrait"; // Page orientation (PDF only)
		$this->ExportPageSize = "a4"; // Page size (PDF only)
		$this->ExportExcelPageOrientation = ""; // Page orientation (PHPExcel only)
		$this->ExportExcelPageSize = ""; // Page size (PHPExcel only)
		$this->DetailAdd = FALSE; // Allow detail add
		$this->DetailEdit = FALSE; // Allow detail edit
		$this->DetailView = FALSE; // Allow detail view
		$this->ShowMultipleDetails = FALSE; // Show multiple details
		$this->GridAddRowCount = 1;
		$this->AllowAddDeleteRow = ew_AllowAddDeleteRow(); // Allow add/delete row
		$this->UserIDAllowSecurity = 0; // User ID Allow
		$this->BasicSearch = new cBasicSearch($this->TableVar);

		// dbkey_client
		$this->dbkey_client = new cField('Cust_Rpt_Client_Budget_Summary', 'Cust_Rpt_Client_Budget_Summary', 'x_dbkey_client', 'dbkey_client', 'client_budget.dbkey_client', 'client_budget.dbkey_client', 3, -1, FALSE, 'client_budget.dbkey_client', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_client->Sortable = TRUE; // Allow sort
		$this->dbkey_client->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->dbkey_client->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->dbkey_client->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_client'] = &$this->dbkey_client;

		// first
		$this->first = new cField('Cust_Rpt_Client_Budget_Summary', 'Cust_Rpt_Client_Budget_Summary', 'x_first', 'first', 'client.first', 'client.first', 200, -1, FALSE, 'client.first', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->first->Sortable = TRUE; // Allow sort
		$this->fields['first'] = &$this->first;

		// last
		$this->last = new cField('Cust_Rpt_Client_Budget_Summary', 'Cust_Rpt_Client_Budget_Summary', 'x_last', 'last', 'client.last', 'client.last', 200, -1, FALSE, 'client.last', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->last->Sortable = TRUE; // Allow sort
		$this->fields['last'] = &$this->last;

		// dbkey_activity
		$this->dbkey_activity = new cField('Cust_Rpt_Client_Budget_Summary', 'Cust_Rpt_Client_Budget_Summary', 'x_dbkey_activity', 'dbkey_activity', '`dbkey_activity`', '`dbkey_activity`', 3, -1, FALSE, '`dbkey_activity`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_activity->Sortable = TRUE; // Allow sort
		$this->dbkey_activity->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->dbkey_activity->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->dbkey_activity->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_activity'] = &$this->dbkey_activity;

		// budget
		$this->budget = new cField('Cust_Rpt_Client_Budget_Summary', 'Cust_Rpt_Client_Budget_Summary', 'x_budget', 'budget', 'client_budget.budget', 'client_budget.budget', 131, -1, FALSE, 'client_budget.budget', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->budget->Sortable = TRUE; // Allow sort
		$this->budget->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['budget'] = &$this->budget;

		// allocated
		$this->allocated = new cField('Cust_Rpt_Client_Budget_Summary', 'Cust_Rpt_Client_Budget_Summary', 'x_allocated', 'allocated', 'Sum(IfNull(client_activity.time, 0))', 'Sum(IfNull(client_activity.time, 0))', 20, -1, FALSE, 'Sum(IfNull(client_activity.time, 0))', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->allocated->Sortable = TRUE; // Allow sort
		$this->allocated->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['allocated'] = &$this->allocated;

		// remain
		$this->remain = new cField('Cust_Rpt_Client_Budget_Summary', 'Cust_Rpt_Client_Budget_Summary', 'x_remain', 'remain', '(client_budget.budget - Sum(IfNull(client_activity.time, 0)))', '(client_budget.budget - Sum(IfNull(client_activity.time, 0)))', 20, -1, FALSE, '(client_budget.budget - Sum(IfNull(client_activity.time, 0)))', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->remain->Sortable = TRUE; // Allow sort
		$this->remain->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['remain'] = &$this->remain;

		// waived
		$this->waived = new cField('Cust_Rpt_Client_Budget_Summary', 'Cust_Rpt_Client_Budget_Summary', 'x_waived', 'waived', 'client.waived', 'client.waived', 200, -1, FALSE, 'client.waived', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->waived->Sortable = TRUE; // Allow sort
		$this->waived->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->waived->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->fields['waived'] = &$this->waived;

		// from
		$this->from = new cField('Cust_Rpt_Client_Budget_Summary', 'Cust_Rpt_Client_Budget_Summary', 'x_from', 'from', '`from`', ew_CastDateFieldForLike('`from`', 0, "DB"), 133, 0, FALSE, '`from`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->from->Sortable = TRUE; // Allow sort
		$this->from->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['from'] = &$this->from;

		// through
		$this->through = new cField('Cust_Rpt_Client_Budget_Summary', 'Cust_Rpt_Client_Budget_Summary', 'x_through', 'through', '`through`', ew_CastDateFieldForLike('`through`', 0, "DB"), 133, 0, FALSE, '`through`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->through->Sortable = TRUE; // Allow sort
		$this->through->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['through'] = &$this->through;

		// dbkey
		$this->dbkey = new cField('Cust_Rpt_Client_Budget_Summary', 'Cust_Rpt_Client_Budget_Summary', 'x_dbkey', 'dbkey', '`dbkey`', '`dbkey`', 3, -1, FALSE, '`dbkey`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'NO');
		$this->dbkey->Sortable = FALSE; // Allow sort
		$this->dbkey->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey'] = &$this->dbkey;
	}

	// Set Field Visibility
	function SetFieldVisibility($fldparm) {
		global $Security;
		return $this->$fldparm->Visible; // Returns original value
	}

	// Single column sort
	function UpdateSort(&$ofld) {
		if ($this->CurrentOrder == $ofld->FldName) {
			$sSortField = $ofld->FldExpression;
			$sLastSort = $ofld->getSort();
			if ($this->CurrentOrderType == "ASC" || $this->CurrentOrderType == "DESC") {
				$sThisSort = $this->CurrentOrderType;
			} else {
				$sThisSort = ($sLastSort == "ASC") ? "DESC" : "ASC";
			}
			$ofld->setSort($sThisSort);
			$this->setSessionOrderBy($sSortField . " " . $sThisSort); // Save to Session
		} else {
			$ofld->setSort("");
		}
	}

	// Table level SQL
	var $_SqlFrom = "";

	function getSqlFrom() { // From
		return ($this->_SqlFrom <> "") ? $this->_SqlFrom : "client_budget, client";
	}

	function SqlFrom() { // For backward compatibility
		return $this->getSqlFrom();
	}

	function setSqlFrom($v) {
		$this->_SqlFrom = $v;
	}
	var $_SqlSelect = "";

	function getSqlSelect() { // Select
		return ($this->_SqlSelect <> "") ? $this->_SqlSelect : "SELECT client_budget.dbkey, client_budget.dbkey_activity, `from`, client_budget.through, client_budget.budget, client.first, client.last, client.waived, client_budget.dbkey_client, 0 AS allocated, 0 AS remain FROM " . $this->getSqlFrom();
	}

	function SqlSelect() { // For backward compatibility
		return $this->getSqlSelect();
	}

	function setSqlSelect($v) {
		$this->_SqlSelect = $v;
	}
	var $_SqlWhere = "";

	function getSqlWhere() { // Where
		$sWhere = ($this->_SqlWhere <> "") ? $this->_SqlWhere : "client.dbkey = client_budget.dbkey_client";
		$this->TableFilter = "";
		ew_AddFilter($sWhere, $this->TableFilter);
		return $sWhere;
	}

	function SqlWhere() { // For backward compatibility
		return $this->getSqlWhere();
	}

	function setSqlWhere($v) {
		$this->_SqlWhere = $v;
	}
	var $_SqlGroupBy = "";

	function getSqlGroupBy() { // Group By
		return ($this->_SqlGroupBy <> "") ? $this->_SqlGroupBy : "";
	}

	function SqlGroupBy() { // For backward compatibility
		return $this->getSqlGroupBy();
	}

	function setSqlGroupBy($v) {
		$this->_SqlGroupBy = $v;
	}
	var $_SqlHaving = "";

	function getSqlHaving() { // Having
		return ($this->_SqlHaving <> "") ? $this->_SqlHaving : "";
	}

	function SqlHaving() { // For backward compatibility
		return $this->getSqlHaving();
	}

	function setSqlHaving($v) {
		$this->_SqlHaving = $v;
	}
	var $_SqlOrderBy = "";

	function getSqlOrderBy() { // Order By
		return ($this->_SqlOrderBy <> "") ? $this->_SqlOrderBy : "client_budget.from DESC";
	}

	function SqlOrderBy() { // For backward compatibility
		return $this->getSqlOrderBy();
	}

	function setSqlOrderBy($v) {
		$this->_SqlOrderBy = $v;
	}

	// Apply User ID filters
	function ApplyUserIDFilters($sFilter) {
		return $sFilter;
	}

	// Check if User ID security allows view all
	function UserIDAllow($id = "") {
		$allow = EW_USER_ID_ALLOW;
		switch ($id) {
			case "add":
			case "copy":
			case "gridadd":
			case "register":
			case "addopt":
				return (($allow & 1) == 1);
			case "edit":
			case "gridedit":
			case "update":
			case "changepwd":
			case "forgotpwd":
				return (($allow & 4) == 4);
			case "delete":
				return (($allow & 2) == 2);
			case "view":
				return (($allow & 32) == 32);
			case "search":
				return (($allow & 64) == 64);
			default:
				return (($allow & 8) == 8);
		}
	}

	// Get SQL
	function GetSQL($where, $orderby) {
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$where, $orderby);
	}

	// Table SQL
	function SQL() {
		$sFilter = $this->CurrentFilter;
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$sFilter, $sSort);
	}

	// Table SQL with List page filter
	function SelectSQL() {
		$sFilter = $this->getSessionWhere();
		ew_AddFilter($sFilter, $this->CurrentFilter);
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$this->Recordset_Selecting($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(), $this->getSqlGroupBy(),
			$this->getSqlHaving(), $this->getSqlOrderBy(), $sFilter, $sSort);
	}

	// Get ORDER BY clause
	function GetOrderBy() {
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql("", "", "", "", $this->getSqlOrderBy(), "", $sSort);
	}

	// Try to get record count
	function TryGetRecordCount($sSql) {
		$cnt = -1;
		if (($this->TableType == 'TABLE' || $this->TableType == 'VIEW' || $this->TableType == 'LINKTABLE') && preg_match("/^SELECT \* FROM/i", $sSql)) {
			$sSql = "SELECT COUNT(*) FROM" . preg_replace('/^SELECT\s([\s\S]+)?\*\sFROM/i', "", $sSql);
			$sOrderBy = $this->GetOrderBy();
			if (substr($sSql, strlen($sOrderBy) * -1) == $sOrderBy)
				$sSql = substr($sSql, 0, strlen($sSql) - strlen($sOrderBy)); // Remove ORDER BY clause
		} else {
			$sSql = "SELECT COUNT(*) FROM (" . $sSql . ") EW_COUNT_TABLE";
		}
		$conn = &$this->Connection();
		if ($rs = $conn->Execute($sSql)) {
			if (!$rs->EOF && $rs->FieldCount() > 0) {
				$cnt = $rs->fields[0];
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// Get record count based on filter (for detail record count in master table pages)
	function LoadRecordCount($sFilter) {
		$origFilter = $this->CurrentFilter;
		$this->CurrentFilter = $sFilter;
		$this->Recordset_Selecting($this->CurrentFilter);

		//$sSql = $this->SQL();
		$sSql = $this->GetSQL($this->CurrentFilter, "");
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			if ($rs = $this->LoadRs($this->CurrentFilter)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		$this->CurrentFilter = $origFilter;
		return intval($cnt);
	}

	// Get record count (for current List page)
	function SelectRecordCount() {
		$sSql = $this->SelectSQL();
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			$conn = &$this->Connection();
			if ($rs = $conn->Execute($sSql)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// INSERT statement
	function InsertSQL(&$rs) {
		$names = "";
		$values = "";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$names .= $this->fields[$name]->FldExpression . ",";
			$values .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($names, -1) == ",")
			$names = substr($names, 0, -1);
		while (substr($values, -1) == ",")
			$values = substr($values, 0, -1);
		return "INSERT INTO " . $this->UpdateTable . " ($names) VALUES ($values)";
	}

	// Insert
	function Insert(&$rs) {
		$conn = &$this->Connection();
		return $conn->Execute($this->InsertSQL($rs));
	}

	// UPDATE statement
	function UpdateSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "UPDATE " . $this->UpdateTable . " SET ";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$sql .= $this->fields[$name]->FldExpression . "=";
			$sql .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($sql, -1) == ",")
			$sql = substr($sql, 0, -1);
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		ew_AddFilter($filter, $where);
		if ($filter <> "")	$sql .= " WHERE " . $filter;
		return $sql;
	}

	// Update
	function Update(&$rs, $where = "", $rsold = NULL, $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->UpdateSQL($rs, $where, $curfilter));
	}

	// DELETE statement
	function DeleteSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "DELETE FROM " . $this->UpdateTable . " WHERE ";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		if ($rs) {
			if (array_key_exists('dbkey', $rs))
				ew_AddFilter($where, ew_QuotedName('dbkey', $this->DBID) . '=' . ew_QuotedValue($rs['dbkey'], $this->dbkey->FldDataType, $this->DBID));
		}
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		ew_AddFilter($filter, $where);
		if ($filter <> "")
			$sql .= $filter;
		else
			$sql .= "0=1"; // Avoid delete
		return $sql;
	}

	// Delete
	function Delete(&$rs, $where = "", $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->DeleteSQL($rs, $where, $curfilter));
	}

	// Key filter WHERE clause
	function SqlKeyFilter() {
		return "`dbkey` = @dbkey@";
	}

	// Key filter
	function KeyFilter() {
		$sKeyFilter = $this->SqlKeyFilter();
		if (!is_numeric($this->dbkey->CurrentValue))
			$sKeyFilter = "0=1"; // Invalid key
		$sKeyFilter = str_replace("@dbkey@", ew_AdjustSql($this->dbkey->CurrentValue, $this->DBID), $sKeyFilter); // Replace key value
		return $sKeyFilter;
	}

	// Return page URL
	function getReturnUrl() {
		$name = EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL;

		// Get referer URL automatically
		if (ew_ServerVar("HTTP_REFERER") <> "" && ew_ReferPage() <> ew_CurrentPage() && ew_ReferPage() <> "login.php") // Referer not same page or login page
			$_SESSION[$name] = ew_ServerVar("HTTP_REFERER"); // Save to Session
		if (@$_SESSION[$name] <> "") {
			return $_SESSION[$name];
		} else {
			return "Cust_Rpt_Client_Budget_Summarylist.php";
		}
	}

	function setReturnUrl($v) {
		$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL] = $v;
	}

	// List URL
	function GetListUrl() {
		return "Cust_Rpt_Client_Budget_Summarylist.php";
	}

	// View URL
	function GetViewUrl($parm = "") {
		if ($parm <> "")
			$url = $this->KeyUrl("Cust_Rpt_Client_Budget_Summaryview.php", $this->UrlParm($parm));
		else
			$url = $this->KeyUrl("Cust_Rpt_Client_Budget_Summaryview.php", $this->UrlParm(EW_TABLE_SHOW_DETAIL . "="));
		return $this->AddMasterUrl($url);
	}

	// Add URL
	function GetAddUrl($parm = "") {
		if ($parm <> "")
			$url = "Cust_Rpt_Client_Budget_Summaryadd.php?" . $this->UrlParm($parm);
		else
			$url = "Cust_Rpt_Client_Budget_Summaryadd.php";
		return $this->AddMasterUrl($url);
	}

	// Edit URL
	function GetEditUrl($parm = "") {
		$url = $this->KeyUrl("Cust_Rpt_Client_Budget_Summaryedit.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline edit URL
	function GetInlineEditUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=edit"));
		return $this->AddMasterUrl($url);
	}

	// Copy URL
	function GetCopyUrl($parm = "") {
		$url = $this->KeyUrl("Cust_Rpt_Client_Budget_Summaryadd.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline copy URL
	function GetInlineCopyUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=copy"));
		return $this->AddMasterUrl($url);
	}

	// Delete URL
	function GetDeleteUrl() {
		return $this->KeyUrl("Cust_Rpt_Client_Budget_Summarydelete.php", $this->UrlParm());
	}

	// Add master url
	function AddMasterUrl($url) {
		return $url;
	}

	function KeyToJson() {
		$json = "";
		$json .= "dbkey:" . ew_VarToJson($this->dbkey->CurrentValue, "number", "'");
		return "{" . $json . "}";
	}

	// Add key value to URL
	function KeyUrl($url, $parm = "") {
		$sUrl = $url . "?";
		if ($parm <> "") $sUrl .= $parm . "&";
		if (!is_null($this->dbkey->CurrentValue)) {
			$sUrl .= "dbkey=" . urlencode($this->dbkey->CurrentValue);
		} else {
			return "javascript:ew_Alert(ewLanguage.Phrase('InvalidRecord'));";
		}
		return $sUrl;
	}

	// Sort URL
	function SortUrl(&$fld) {
		if ($this->CurrentAction <> "" || $this->Export <> "" ||
			in_array($fld->FldType, array(128, 204, 205))) { // Unsortable data type
				return "";
		} elseif ($fld->Sortable) {
			$sUrlParm = $this->UrlParm("order=" . urlencode($fld->FldName) . "&amp;ordertype=" . $fld->ReverseSort());
			return $this->AddMasterUrl(ew_CurrentPage() . "?" . $sUrlParm);
		} else {
			return "";
		}
	}

	// Get record keys from $_POST/$_GET/$_SESSION
	function GetRecordKeys() {
		global $EW_COMPOSITE_KEY_SEPARATOR;
		$arKeys = array();
		$arKey = array();
		if (isset($_POST["key_m"])) {
			$arKeys = ew_StripSlashes($_POST["key_m"]);
			$cnt = count($arKeys);
		} elseif (isset($_GET["key_m"])) {
			$arKeys = ew_StripSlashes($_GET["key_m"]);
			$cnt = count($arKeys);
		} elseif (!empty($_GET) || !empty($_POST)) {
			$isPost = ew_IsHttpPost();
			if ($isPost && isset($_POST["dbkey"]))
				$arKeys[] = ew_StripSlashes($_POST["dbkey"]);
			elseif (isset($_GET["dbkey"]))
				$arKeys[] = ew_StripSlashes($_GET["dbkey"]);
			else
				$arKeys = NULL; // Do not setup

			//return $arKeys; // Do not return yet, so the values will also be checked by the following code
		}

		// Check keys
		$ar = array();
		if (is_array($arKeys)) {
			foreach ($arKeys as $key) {
				if (!is_numeric($key))
					continue;
				$ar[] = $key;
			}
		}
		return $ar;
	}

	// Get key filter
	function GetKeyFilter() {
		$arKeys = $this->GetRecordKeys();
		$sKeyFilter = "";
		foreach ($arKeys as $key) {
			if ($sKeyFilter <> "") $sKeyFilter .= " OR ";
			$this->dbkey->CurrentValue = $key;
			$sKeyFilter .= "(" . $this->KeyFilter() . ")";
		}
		return $sKeyFilter;
	}

	// Load rows based on filter
	function &LoadRs($sFilter) {

		// Set up filter (SQL WHERE clause) and get return SQL
		//$this->CurrentFilter = $sFilter;
		//$sSql = $this->SQL();

		$sSql = $this->GetSQL($sFilter, "");
		$conn = &$this->Connection();
		$rs = $conn->Execute($sSql);
		return $rs;
	}

	// Load row values from recordset
	function LoadListRowValues(&$rs) {
		$this->dbkey_client->setDbValue($rs->fields('dbkey_client'));
		$this->first->setDbValue($rs->fields('first'));
		$this->last->setDbValue($rs->fields('last'));
		$this->dbkey_activity->setDbValue($rs->fields('dbkey_activity'));
		$this->budget->setDbValue($rs->fields('budget'));
		$this->allocated->setDbValue($rs->fields('allocated'));
		$this->remain->setDbValue($rs->fields('remain'));
		$this->waived->setDbValue($rs->fields('waived'));
		$this->from->setDbValue($rs->fields('from'));
		$this->through->setDbValue($rs->fields('through'));
		$this->dbkey->setDbValue($rs->fields('dbkey'));
	}

	// Render list row values
	function RenderListRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

   // Common render codes
		// dbkey_client
		// first
		// last
		// dbkey_activity
		// budget
		// allocated
		// remain
		// waived
		// from
		// through
		// dbkey

		$this->dbkey->CellCssStyle = "white-space: nowrap;";

		// dbkey_client
		if (strval($this->dbkey_client->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		$this->dbkey_client->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_client->ViewValue = $this->dbkey_client->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_client->ViewValue = $this->dbkey_client->CurrentValue;
			}
		} else {
			$this->dbkey_client->ViewValue = NULL;
		}
		$this->dbkey_client->ViewCustomAttributes = "";

		// first
		$this->first->ViewValue = $this->first->CurrentValue;
		$this->first->ViewCustomAttributes = "";

		// last
		$this->last->ViewValue = $this->last->CurrentValue;
		$this->last->ViewCustomAttributes = "";

		// dbkey_activity
		if (strval($this->dbkey_activity->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_activity->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `activity`";
		$sWhereWrk = "";
		$this->dbkey_activity->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->CurrentValue;
			}
		} else {
			$this->dbkey_activity->ViewValue = NULL;
		}
		$this->dbkey_activity->ViewCustomAttributes = "";

		// budget
		$this->budget->ViewValue = $this->budget->CurrentValue;
		$this->budget->ViewValue = ew_FormatNumber($this->budget->ViewValue, 2, -2, -2, -2);
		$this->budget->ViewCustomAttributes = "";

		// allocated
		$this->allocated->ViewValue = $this->allocated->CurrentValue;
		$this->allocated->ViewCustomAttributes = "";

		// remain
		$this->remain->ViewValue = $this->remain->CurrentValue;
		$this->remain->ViewCustomAttributes = "";

		// waived
		if (strval($this->waived->CurrentValue) <> "") {
			$sFilterWrk = "`code`" . ew_SearchString("=", $this->waived->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT `code`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `waivered`";
		$sWhereWrk = "";
		$this->waived->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->waived, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->waived->ViewValue = $this->waived->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->waived->ViewValue = $this->waived->CurrentValue;
			}
		} else {
			$this->waived->ViewValue = NULL;
		}
		$this->waived->ViewCustomAttributes = "";

		// from
		$this->from->ViewValue = $this->from->CurrentValue;
		$this->from->ViewValue = ew_FormatDateTime($this->from->ViewValue, 0);
		$this->from->ViewCustomAttributes = "";

		// through
		$this->through->ViewValue = $this->through->CurrentValue;
		$this->through->ViewValue = ew_FormatDateTime($this->through->ViewValue, 0);
		$this->through->ViewCustomAttributes = "";

		// dbkey
		$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// dbkey_client
		$this->dbkey_client->LinkCustomAttributes = "";
		$this->dbkey_client->HrefValue = "";
		$this->dbkey_client->TooltipValue = "";

		// first
		$this->first->LinkCustomAttributes = "";
		$this->first->HrefValue = "";
		$this->first->TooltipValue = "";

		// last
		$this->last->LinkCustomAttributes = "";
		$this->last->HrefValue = "";
		$this->last->TooltipValue = "";

		// dbkey_activity
		$this->dbkey_activity->LinkCustomAttributes = "";
		$this->dbkey_activity->HrefValue = "";
		$this->dbkey_activity->TooltipValue = "";

		// budget
		$this->budget->LinkCustomAttributes = "";
		$this->budget->HrefValue = "";
		$this->budget->TooltipValue = "";

		// allocated
		$this->allocated->LinkCustomAttributes = "";
		$this->allocated->HrefValue = "";
		$this->allocated->TooltipValue = "";

		// remain
		$this->remain->LinkCustomAttributes = "";
		$this->remain->HrefValue = "";
		$this->remain->TooltipValue = "";

		// waived
		$this->waived->LinkCustomAttributes = "";
		$this->waived->HrefValue = "";
		$this->waived->TooltipValue = "";

		// from
		$this->from->LinkCustomAttributes = "";
		$this->from->HrefValue = "";
		$this->from->TooltipValue = "";

		// through
		$this->through->LinkCustomAttributes = "";
		$this->through->HrefValue = "";
		$this->through->TooltipValue = "";

		// dbkey
		$this->dbkey->LinkCustomAttributes = "";
		$this->dbkey->HrefValue = "";
		$this->dbkey->TooltipValue = "";

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Render edit row values
	function RenderEditRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

		// dbkey_client
		$this->dbkey_client->EditAttrs["class"] = "form-control";
		$this->dbkey_client->EditCustomAttributes = "";

		// first
		$this->first->EditAttrs["class"] = "form-control";
		$this->first->EditCustomAttributes = "";
		$this->first->EditValue = $this->first->CurrentValue;
		$this->first->PlaceHolder = ew_RemoveHtml($this->first->FldCaption());

		// last
		$this->last->EditAttrs["class"] = "form-control";
		$this->last->EditCustomAttributes = "";
		$this->last->EditValue = $this->last->CurrentValue;
		$this->last->PlaceHolder = ew_RemoveHtml($this->last->FldCaption());

		// dbkey_activity
		$this->dbkey_activity->EditAttrs["class"] = "form-control";
		$this->dbkey_activity->EditCustomAttributes = "";

		// budget
		$this->budget->EditAttrs["class"] = "form-control";
		$this->budget->EditCustomAttributes = "";
		$this->budget->EditValue = $this->budget->CurrentValue;
		$this->budget->PlaceHolder = ew_RemoveHtml($this->budget->FldCaption());
		if (strval($this->budget->EditValue) <> "" && is_numeric($this->budget->EditValue)) $this->budget->EditValue = ew_FormatNumber($this->budget->EditValue, -2, -2, -2, -2);

		// allocated
		$this->allocated->EditAttrs["class"] = "form-control";
		$this->allocated->EditCustomAttributes = "";
		$this->allocated->EditValue = $this->allocated->CurrentValue;
		$this->allocated->PlaceHolder = ew_RemoveHtml($this->allocated->FldCaption());

		// remain
		$this->remain->EditAttrs["class"] = "form-control";
		$this->remain->EditCustomAttributes = "";
		$this->remain->EditValue = $this->remain->CurrentValue;
		$this->remain->PlaceHolder = ew_RemoveHtml($this->remain->FldCaption());

		// waived
		$this->waived->EditAttrs["class"] = "form-control";
		$this->waived->EditCustomAttributes = "";

		// from
		$this->from->EditAttrs["class"] = "form-control";
		$this->from->EditCustomAttributes = "";
		$this->from->EditValue = ew_FormatDateTime($this->from->CurrentValue, 8);
		$this->from->PlaceHolder = ew_RemoveHtml($this->from->FldCaption());

		// through
		$this->through->EditAttrs["class"] = "form-control";
		$this->through->EditCustomAttributes = "";
		$this->through->EditValue = ew_FormatDateTime($this->through->CurrentValue, 8);
		$this->through->PlaceHolder = ew_RemoveHtml($this->through->FldCaption());

		// dbkey
		$this->dbkey->EditAttrs["class"] = "form-control";
		$this->dbkey->EditCustomAttributes = "";
		$this->dbkey->EditValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Aggregate list row values
	function AggregateListRowValues() {
	}

	// Aggregate list row (for rendering)
	function AggregateListRow() {

		// Call Row Rendered event
		$this->Row_Rendered();
	}
	var $ExportDoc;

	// Export data in HTML/CSV/Word/Excel/Email/PDF format
	function ExportDocument(&$Doc, &$Recordset, $StartRec, $StopRec, $ExportPageType = "") {
		if (!$Recordset || !$Doc)
			return;
		if (!$Doc->ExportCustom) {

			// Write header
			$Doc->ExportTableHeader();
			if ($Doc->Horizontal) { // Horizontal format, write header
				$Doc->BeginExportRow();
				if ($ExportPageType == "view") {
					if ($this->dbkey_activity->Exportable) $Doc->ExportCaption($this->dbkey_activity);
					if ($this->allocated->Exportable) $Doc->ExportCaption($this->allocated);
					if ($this->remain->Exportable) $Doc->ExportCaption($this->remain);
					if ($this->from->Exportable) $Doc->ExportCaption($this->from);
					if ($this->through->Exportable) $Doc->ExportCaption($this->through);
				} else {
					if ($this->first->Exportable) $Doc->ExportCaption($this->first);
					if ($this->last->Exportable) $Doc->ExportCaption($this->last);
					if ($this->dbkey_activity->Exportable) $Doc->ExportCaption($this->dbkey_activity);
					if ($this->budget->Exportable) $Doc->ExportCaption($this->budget);
					if ($this->allocated->Exportable) $Doc->ExportCaption($this->allocated);
					if ($this->remain->Exportable) $Doc->ExportCaption($this->remain);
					if ($this->from->Exportable) $Doc->ExportCaption($this->from);
					if ($this->through->Exportable) $Doc->ExportCaption($this->through);
				}
				$Doc->EndExportRow();
			}
		}

		// Move to first record
		$RecCnt = $StartRec - 1;
		if (!$Recordset->EOF) {
			$Recordset->MoveFirst();
			if ($StartRec > 1)
				$Recordset->Move($StartRec - 1);
		}
		while (!$Recordset->EOF && $RecCnt < $StopRec) {
			$RecCnt++;
			if (intval($RecCnt) >= intval($StartRec)) {
				$RowCnt = intval($RecCnt) - intval($StartRec) + 1;

				// Page break
				if ($this->ExportPageBreakCount > 0) {
					if ($RowCnt > 1 && ($RowCnt - 1) % $this->ExportPageBreakCount == 0)
						$Doc->ExportPageBreak();
				}
				$this->LoadListRowValues($Recordset);

				// Render row
				$this->RowType = EW_ROWTYPE_VIEW; // Render view
				$this->ResetAttrs();
				$this->RenderListRow();
				if (!$Doc->ExportCustom) {
					$Doc->BeginExportRow($RowCnt); // Allow CSS styles if enabled
					if ($ExportPageType == "view") {
						if ($this->dbkey_activity->Exportable) $Doc->ExportField($this->dbkey_activity);
						if ($this->allocated->Exportable) $Doc->ExportField($this->allocated);
						if ($this->remain->Exportable) $Doc->ExportField($this->remain);
						if ($this->from->Exportable) $Doc->ExportField($this->from);
						if ($this->through->Exportable) $Doc->ExportField($this->through);
					} else {
						if ($this->first->Exportable) $Doc->ExportField($this->first);
						if ($this->last->Exportable) $Doc->ExportField($this->last);
						if ($this->dbkey_activity->Exportable) $Doc->ExportField($this->dbkey_activity);
						if ($this->budget->Exportable) $Doc->ExportField($this->budget);
						if ($this->allocated->Exportable) $Doc->ExportField($this->allocated);
						if ($this->remain->Exportable) $Doc->ExportField($this->remain);
						if ($this->from->Exportable) $Doc->ExportField($this->from);
						if ($this->through->Exportable) $Doc->ExportField($this->through);
					}
					$Doc->EndExportRow();
				}
			}

			// Call Row Export server event
			if ($Doc->ExportCustom)
				$this->Row_Export($Recordset->fields);
			$Recordset->MoveNext();
		}
		if (!$Doc->ExportCustom) {
			$Doc->ExportTableFooter();
		}
	}

	// Get auto fill value
	function GetAutoFill($id, $val) {
		$rsarr = array();
		$rowcnt = 0;

		// Output
		if (is_array($rsarr) && $rowcnt > 0) {
			$fldcnt = count($rsarr[0]);
			for ($i = 0; $i < $rowcnt; $i++) {
				for ($j = 0; $j < $fldcnt; $j++) {
					$str = strval($rsarr[$i][$j]);
					$str = ew_ConvertToUtf8($str);
					if (isset($post["keepCRLF"])) {
						$str = str_replace(array("\r", "\n"), array("\\r", "\\n"), $str);
					} else {
						$str = str_replace(array("\r", "\n"), array(" ", " "), $str);
					}
					$rsarr[$i][$j] = $str;
				}
			}
			return ew_ArrayToJson($rsarr);
		} else {
			return FALSE;
		}
	}

	// Table level events
	// Recordset Selecting event
	function Recordset_Selecting(&$filter) {

		// Enter your code here	
	}

	// Recordset Selected event
	function Recordset_Selected(&$rs) {

		//echo "Recordset Selected";
	}

	// Recordset Search Validated event
	function Recordset_SearchValidated() {

		// Example:
		//$this->MyField1->AdvancedSearch->SearchValue = "your search criteria"; // Search value

	}

	// Recordset Searching event
	function Recordset_Searching(&$filter) {

		// Enter your code here	
	}

	// Row_Selecting event
	function Row_Selecting(&$filter) {

		// Enter your code here	
	}

	// Row Selected event
	function Row_Selected(&$rs) {

		//echo "Row Selected";
	}

	// Row Inserting event
	function Row_Inserting($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Inserted event
	function Row_Inserted($rsold, &$rsnew) {

		//echo "Row Inserted"
	}

	// Row Updating event
	function Row_Updating($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Updated event
	function Row_Updated($rsold, &$rsnew) {

		//echo "Row Updated";
	}

	// Row Update Conflict event
	function Row_UpdateConflict($rsold, &$rsnew) {

		// Enter your code here
		// To ignore conflict, set return value to FALSE

		return TRUE;
	}

	// Grid Inserting event
	function Grid_Inserting() {

		// Enter your code here
		// To reject grid insert, set return value to FALSE

		return TRUE;
	}

	// Grid Inserted event
	function Grid_Inserted($rsnew) {

		//echo "Grid Inserted";
	}

	// Grid Updating event
	function Grid_Updating($rsold) {

		// Enter your code here
		// To reject grid update, set return value to FALSE

		return TRUE;
	}

	// Grid Updated event
	function Grid_Updated($rsold, $rsnew) {

		//echo "Grid Updated";
	}

	// Row Deleting event
	function Row_Deleting(&$rs) {

		// Enter your code here
		// To cancel, set return value to False

		return TRUE;
	}

	// Row Deleted event
	function Row_Deleted(&$rs) {

		//echo "Row Deleted";
	}

	// Email Sending event
	function Email_Sending(&$Email, &$Args) {

		//var_dump($Email); var_dump($Args); exit();
		return TRUE;
	}

	// Lookup Selecting event
	function Lookup_Selecting($fld, &$filter) {

		//var_dump($fld->FldName, $fld->LookupFilters, $filter); // Uncomment to view the filter
		// Enter your code here

	}

	// Row Rendering event
	function Row_Rendering() {

		// Enter your code here	
	}

	// Row Rendered event
	function Row_Rendered() {

		// If over budget red.
		if ($this->remain->DbValue < 0)
		{
			$this->remain->CssStyle = "color:red;";
		}

		// Get Total Allocated and Remain
		if ($this->dbkey_client->DbValue <> 0)
		{
			$sql = "SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_activity b where   b.dbkey_client = " . $this->dbkey_client->DbValue . " and b.dbkey_activity = " . $this->dbkey_activity->DbValue . "  AND date(b.date) >= date('". $this->from->DbValue ."') and date(b.date) <= date('". $this->through->DbValue ."')";	

			//echo "<h1> SQL: " . $sql . "</h1>";
			$rs = ew_Execute($sql);
			if ($rs && $rs->RecordCount() > 0)
			{

				//echo "<h1> FOUND IT " . $rs->fields[0] . " </h1>";
				//var_dump($rs);

				$this->allocated->ViewValue = $rs->fields[0];
				$this->remain->ViewValue = (float)$this->budget->DbValue - (float)$this->allocated->ViewValue;
				$rs->Close();
			} else $this->allocated->ViewValue = "0.00";
		}

		// Format
		$this->allocated->ViewValue = number_format($this->allocated->ViewValue,2);
		$this->remain->ViewValue = number_format($this->remain->ViewValue,2);

	//	$this->budget->ViewValue = number_format($this->budget->ViewValue,2);
	}

	// User ID Filtering event
	function UserID_Filtering(&$filter) {

		// Enter your code here
	}
}
?>
