<?php

// Global variable for table object
$Cust_Rpt_Monthly = NULL;

//
// Table class for Cust_Rpt_Monthly
//
class cCust_Rpt_Monthly extends cTable {
	var $dbkey;
	var $First;
	var $Last;
	var $Total_Hours;
	var $January;
	var $Feburary;
	var $March;
	var $April;
	var $May;
	var $June;
	var $July;
	var $August;
	var $September;
	var $October;
	var $November;
	var $December;

	//
	// Table class constructor
	//
	function __construct() {
		global $Language;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();
		$this->TableVar = 'Cust_Rpt_Monthly';
		$this->TableName = 'Cust_Rpt_Monthly';
		$this->TableType = 'CUSTOMVIEW';

		// Update Table
		$this->UpdateTable = "client_activity, counselor, tables_data";
		$this->DBID = 'DB';
		$this->ExportAll = TRUE;
		$this->ExportPageBreakCount = 0; // Page break per every n record (PDF only)
		$this->ExportPageOrientation = "portrait"; // Page orientation (PDF only)
		$this->ExportPageSize = "a4"; // Page size (PDF only)
		$this->ExportExcelPageOrientation = ""; // Page orientation (PHPExcel only)
		$this->ExportExcelPageSize = ""; // Page size (PHPExcel only)
		$this->DetailAdd = FALSE; // Allow detail add
		$this->DetailEdit = FALSE; // Allow detail edit
		$this->DetailView = FALSE; // Allow detail view
		$this->ShowMultipleDetails = FALSE; // Show multiple details
		$this->GridAddRowCount = 1;
		$this->AllowAddDeleteRow = ew_AllowAddDeleteRow(); // Allow add/delete row
		$this->UserIDAllowSecurity = 0; // User ID Allow
		$this->BasicSearch = new cBasicSearch($this->TableVar);

		// dbkey
		$this->dbkey = new cField('Cust_Rpt_Monthly', 'Cust_Rpt_Monthly', 'x_dbkey', 'dbkey', 'tables_data.dbkey', 'tables_data.dbkey', 200, -1, FALSE, 'tables_data.dbkey', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->dbkey->Sortable = TRUE; // Allow sort
		$this->fields['dbkey'] = &$this->dbkey;

		// First
		$this->First = new cField('Cust_Rpt_Monthly', 'Cust_Rpt_Monthly', 'x_First', 'First', '`First`', '`First`', 200, -1, FALSE, '`First`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->First->Sortable = TRUE; // Allow sort
		$this->fields['First'] = &$this->First;

		// Last
		$this->Last = new cField('Cust_Rpt_Monthly', 'Cust_Rpt_Monthly', 'x_Last', 'Last', '`Last`', '`Last`', 200, -1, FALSE, '`Last`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Last->Sortable = TRUE; // Allow sort
		$this->fields['Last'] = &$this->Last;

		// Total Hours
		$this->Total_Hours = new cField('Cust_Rpt_Monthly', 'Cust_Rpt_Monthly', 'x_Total_Hours', 'Total Hours', '`Total Hours`', '`Total Hours`', 131, -1, FALSE, '`Total Hours`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Total_Hours->Sortable = TRUE; // Allow sort
		$this->Total_Hours->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Total Hours'] = &$this->Total_Hours;

		// January
		$this->January = new cField('Cust_Rpt_Monthly', 'Cust_Rpt_Monthly', 'x_January', 'January', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 1 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 1 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 1 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->January->Sortable = TRUE; // Allow sort
		$this->January->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['January'] = &$this->January;

		// Feburary
		$this->Feburary = new cField('Cust_Rpt_Monthly', 'Cust_Rpt_Monthly', 'x_Feburary', 'Feburary', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 2 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 2 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 2 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Feburary->Sortable = TRUE; // Allow sort
		$this->Feburary->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Feburary'] = &$this->Feburary;

		// March
		$this->March = new cField('Cust_Rpt_Monthly', 'Cust_Rpt_Monthly', 'x_March', 'March', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 3 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 3 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 3 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->March->Sortable = TRUE; // Allow sort
		$this->March->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['March'] = &$this->March;

		// April
		$this->April = new cField('Cust_Rpt_Monthly', 'Cust_Rpt_Monthly', 'x_April', 'April', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 4 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 4 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 4 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->April->Sortable = TRUE; // Allow sort
		$this->April->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['April'] = &$this->April;

		// May
		$this->May = new cField('Cust_Rpt_Monthly', 'Cust_Rpt_Monthly', 'x_May', 'May', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 5 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 5 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 5 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->May->Sortable = TRUE; // Allow sort
		$this->May->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['May'] = &$this->May;

		// June
		$this->June = new cField('Cust_Rpt_Monthly', 'Cust_Rpt_Monthly', 'x_June', 'June', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 6 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 6 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 6 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->June->Sortable = TRUE; // Allow sort
		$this->June->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['June'] = &$this->June;

		// July
		$this->July = new cField('Cust_Rpt_Monthly', 'Cust_Rpt_Monthly', 'x_July', 'July', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 7 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 7 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 7 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->July->Sortable = TRUE; // Allow sort
		$this->July->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['July'] = &$this->July;

		// August
		$this->August = new cField('Cust_Rpt_Monthly', 'Cust_Rpt_Monthly', 'x_August', 'August', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 8 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 8 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 8 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->August->Sortable = TRUE; // Allow sort
		$this->August->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['August'] = &$this->August;

		// September
		$this->September = new cField('Cust_Rpt_Monthly', 'Cust_Rpt_Monthly', 'x_September', 'September', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 9 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 9 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 9 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->September->Sortable = TRUE; // Allow sort
		$this->September->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['September'] = &$this->September;

		// October
		$this->October = new cField('Cust_Rpt_Monthly', 'Cust_Rpt_Monthly', 'x_October', 'October', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 10 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 10 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 10 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->October->Sortable = TRUE; // Allow sort
		$this->October->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['October'] = &$this->October;

		// November
		$this->November = new cField('Cust_Rpt_Monthly', 'Cust_Rpt_Monthly', 'x_November', 'November', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 11 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 11 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 11 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->November->Sortable = TRUE; // Allow sort
		$this->November->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['November'] = &$this->November;

		// December
		$this->December = new cField('Cust_Rpt_Monthly', 'Cust_Rpt_Monthly', 'x_December', 'December', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 12 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 12 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where Month(friday.date) = 12 And Month(friday.date) = Month(client_activity.date) And friday.dbkey_councilor = client_activity.dbkey_councilor And Year(friday.date) = Year(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->December->Sortable = TRUE; // Allow sort
		$this->December->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['December'] = &$this->December;
	}

	// Set Field Visibility
	function SetFieldVisibility($fldparm) {
		global $Security;
		return $this->$fldparm->Visible; // Returns original value
	}

	// Single column sort
	function UpdateSort(&$ofld) {
		if ($this->CurrentOrder == $ofld->FldName) {
			$sSortField = $ofld->FldExpression;
			$sLastSort = $ofld->getSort();
			if ($this->CurrentOrderType == "ASC" || $this->CurrentOrderType == "DESC") {
				$sThisSort = $this->CurrentOrderType;
			} else {
				$sThisSort = ($sLastSort == "ASC") ? "DESC" : "ASC";
			}
			$ofld->setSort($sThisSort);
			$this->setSessionOrderBy($sSortField . " " . $sThisSort); // Save to Session
		} else {
			$ofld->setSort("");
		}
	}

	// Table level SQL
	var $_SqlFrom = "";

	function getSqlFrom() { // From
		return ($this->_SqlFrom <> "") ? $this->_SqlFrom : "client_activity, counselor, tables_data";
	}

	function SqlFrom() { // For backward compatibility
		return $this->getSqlFrom();
	}

	function setSqlFrom($v) {
		$this->_SqlFrom = $v;
	}
	var $_SqlSelect = "";

	function getSqlSelect() { // Select
		return ($this->_SqlSelect <> "") ? $this->_SqlSelect : "SELECT tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", (SELECT Sum(friday.time) FROM client_activity friday WHERE Month(friday.date) = 1 AND Month(friday.date) = Month(client_activity.date) AND friday.dbkey_councilor = client_activity.dbkey_councilor AND Year(friday.date) = Year(client_activity.date) GROUP BY friday.dbkey_councilor) AS January, (SELECT Sum(friday.time) FROM client_activity friday WHERE Month(friday.date) = 2 AND Month(friday.date) = Month(client_activity.date) AND friday.dbkey_councilor = client_activity.dbkey_councilor AND Year(friday.date) = Year(client_activity.date) GROUP BY friday.dbkey_councilor) AS Feburary, (SELECT Sum(friday.time) FROM client_activity friday WHERE Month(friday.date) = 3 AND Month(friday.date) = Month(client_activity.date) AND friday.dbkey_councilor = client_activity.dbkey_councilor AND Year(friday.date) = Year(client_activity.date) GROUP BY friday.dbkey_councilor) AS March, (SELECT Sum(friday.time) FROM client_activity friday WHERE Month(friday.date) = 4 AND Month(friday.date) = Month(client_activity.date) AND friday.dbkey_councilor = client_activity.dbkey_councilor AND Year(friday.date) = Year(client_activity.date) GROUP BY friday.dbkey_councilor) AS April, (SELECT Sum(friday.time) FROM client_activity friday WHERE Month(friday.date) = 5 AND Month(friday.date) = Month(client_activity.date) AND friday.dbkey_councilor = client_activity.dbkey_councilor AND Year(friday.date) = Year(client_activity.date) GROUP BY friday.dbkey_councilor) AS May, (SELECT Sum(friday.time) FROM client_activity friday WHERE Month(friday.date) = 6 AND Month(friday.date) = Month(client_activity.date) AND friday.dbkey_councilor = client_activity.dbkey_councilor AND Year(friday.date) = Year(client_activity.date) GROUP BY friday.dbkey_councilor) AS June, (SELECT Sum(friday.time) FROM client_activity friday WHERE Month(friday.date) = 7 AND Month(friday.date) = Month(client_activity.date) AND friday.dbkey_councilor = client_activity.dbkey_councilor AND Year(friday.date) = Year(client_activity.date) GROUP BY friday.dbkey_councilor) AS July, (SELECT Sum(friday.time) FROM client_activity friday WHERE Month(friday.date) = 8 AND Month(friday.date) = Month(client_activity.date) AND friday.dbkey_councilor = client_activity.dbkey_councilor AND Year(friday.date) = Year(client_activity.date) GROUP BY friday.dbkey_councilor) AS August, (SELECT Sum(friday.time) FROM client_activity friday WHERE Month(friday.date) = 9 AND Month(friday.date) = Month(client_activity.date) AND friday.dbkey_councilor = client_activity.dbkey_councilor AND Year(friday.date) = Year(client_activity.date) GROUP BY friday.dbkey_councilor) AS September, (SELECT Sum(friday.time) FROM client_activity friday WHERE Month(friday.date) = 10 AND Month(friday.date) = Month(client_activity.date) AND friday.dbkey_councilor = client_activity.dbkey_councilor AND Year(friday.date) = Year(client_activity.date) GROUP BY friday.dbkey_councilor) AS October, (SELECT Sum(friday.time) FROM client_activity friday WHERE Month(friday.date) = 11 AND Month(friday.date) = Month(client_activity.date) AND friday.dbkey_councilor = client_activity.dbkey_councilor AND Year(friday.date) = Year(client_activity.date) GROUP BY friday.dbkey_councilor) AS November, (SELECT Sum(friday.time) FROM client_activity friday WHERE Month(friday.date) = 12 AND Month(friday.date) = Month(client_activity.date) AND friday.dbkey_councilor = client_activity.dbkey_councilor AND Year(friday.date) = Year(client_activity.date) GROUP BY friday.dbkey_councilor) AS December FROM " . $this->getSqlFrom();
	}

	function SqlSelect() { // For backward compatibility
		return $this->getSqlSelect();
	}

	function setSqlSelect($v) {
		$this->_SqlSelect = $v;
	}
	var $_SqlWhere = "";

	function getSqlWhere() { // Where
		$sWhere = ($this->_SqlWhere <> "") ? $this->_SqlWhere : "client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'YEAR'";
		$this->TableFilter = "";
		ew_AddFilter($sWhere, $this->TableFilter);
		return $sWhere;
	}

	function SqlWhere() { // For backward compatibility
		return $this->getSqlWhere();
	}

	function setSqlWhere($v) {
		$this->_SqlWhere = $v;
	}
	var $_SqlGroupBy = "";

	function getSqlGroupBy() { // Group By
		return ($this->_SqlGroupBy <> "") ? $this->_SqlGroupBy : "tables_data.dbkey, Year(client_activity.date), client_activity.dbkey_councilor, client_activity.date";
	}

	function SqlGroupBy() { // For backward compatibility
		return $this->getSqlGroupBy();
	}

	function setSqlGroupBy($v) {
		$this->_SqlGroupBy = $v;
	}
	var $_SqlHaving = "";

	function getSqlHaving() { // Having
		return ($this->_SqlHaving <> "") ? $this->_SqlHaving : "";
	}

	function SqlHaving() { // For backward compatibility
		return $this->getSqlHaving();
	}

	function setSqlHaving($v) {
		$this->_SqlHaving = $v;
	}
	var $_SqlOrderBy = "";

	function getSqlOrderBy() { // Order By
		return ($this->_SqlOrderBy <> "") ? $this->_SqlOrderBy : "";
	}

	function SqlOrderBy() { // For backward compatibility
		return $this->getSqlOrderBy();
	}

	function setSqlOrderBy($v) {
		$this->_SqlOrderBy = $v;
	}

	// Apply User ID filters
	function ApplyUserIDFilters($sFilter) {
		return $sFilter;
	}

	// Check if User ID security allows view all
	function UserIDAllow($id = "") {
		$allow = EW_USER_ID_ALLOW;
		switch ($id) {
			case "add":
			case "copy":
			case "gridadd":
			case "register":
			case "addopt":
				return (($allow & 1) == 1);
			case "edit":
			case "gridedit":
			case "update":
			case "changepwd":
			case "forgotpwd":
				return (($allow & 4) == 4);
			case "delete":
				return (($allow & 2) == 2);
			case "view":
				return (($allow & 32) == 32);
			case "search":
				return (($allow & 64) == 64);
			default:
				return (($allow & 8) == 8);
		}
	}

	// Get SQL
	function GetSQL($where, $orderby) {
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$where, $orderby);
	}

	// Table SQL
	function SQL() {
		$sFilter = $this->CurrentFilter;
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$sFilter, $sSort);
	}

	// Table SQL with List page filter
	function SelectSQL() {
		$sFilter = $this->getSessionWhere();
		ew_AddFilter($sFilter, $this->CurrentFilter);
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$this->Recordset_Selecting($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(), $this->getSqlGroupBy(),
			$this->getSqlHaving(), $this->getSqlOrderBy(), $sFilter, $sSort);
	}

	// Get ORDER BY clause
	function GetOrderBy() {
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql("", "", "", "", $this->getSqlOrderBy(), "", $sSort);
	}

	// Try to get record count
	function TryGetRecordCount($sSql) {
		$cnt = -1;
		if (($this->TableType == 'TABLE' || $this->TableType == 'VIEW' || $this->TableType == 'LINKTABLE') && preg_match("/^SELECT \* FROM/i", $sSql)) {
			$sSql = "SELECT COUNT(*) FROM" . preg_replace('/^SELECT\s([\s\S]+)?\*\sFROM/i', "", $sSql);
			$sOrderBy = $this->GetOrderBy();
			if (substr($sSql, strlen($sOrderBy) * -1) == $sOrderBy)
				$sSql = substr($sSql, 0, strlen($sSql) - strlen($sOrderBy)); // Remove ORDER BY clause
		} else {
			$sSql = "SELECT COUNT(*) FROM (" . $sSql . ") EW_COUNT_TABLE";
		}
		$conn = &$this->Connection();
		if ($rs = $conn->Execute($sSql)) {
			if (!$rs->EOF && $rs->FieldCount() > 0) {
				$cnt = $rs->fields[0];
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// Get record count based on filter (for detail record count in master table pages)
	function LoadRecordCount($sFilter) {
		$origFilter = $this->CurrentFilter;
		$this->CurrentFilter = $sFilter;
		$this->Recordset_Selecting($this->CurrentFilter);

		//$sSql = $this->SQL();
		$sSql = $this->GetSQL($this->CurrentFilter, "");
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			if ($rs = $this->LoadRs($this->CurrentFilter)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		$this->CurrentFilter = $origFilter;
		return intval($cnt);
	}

	// Get record count (for current List page)
	function SelectRecordCount() {
		$sSql = $this->SelectSQL();
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			$conn = &$this->Connection();
			if ($rs = $conn->Execute($sSql)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// INSERT statement
	function InsertSQL(&$rs) {
		$names = "";
		$values = "";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$names .= $this->fields[$name]->FldExpression . ",";
			$values .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($names, -1) == ",")
			$names = substr($names, 0, -1);
		while (substr($values, -1) == ",")
			$values = substr($values, 0, -1);
		return "INSERT INTO " . $this->UpdateTable . " ($names) VALUES ($values)";
	}

	// Insert
	function Insert(&$rs) {
		$conn = &$this->Connection();
		return $conn->Execute($this->InsertSQL($rs));
	}

	// UPDATE statement
	function UpdateSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "UPDATE " . $this->UpdateTable . " SET ";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$sql .= $this->fields[$name]->FldExpression . "=";
			$sql .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($sql, -1) == ",")
			$sql = substr($sql, 0, -1);
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		ew_AddFilter($filter, $where);
		if ($filter <> "")	$sql .= " WHERE " . $filter;
		return $sql;
	}

	// Update
	function Update(&$rs, $where = "", $rsold = NULL, $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->UpdateSQL($rs, $where, $curfilter));
	}

	// DELETE statement
	function DeleteSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "DELETE FROM " . $this->UpdateTable . " WHERE ";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		if ($rs) {
		}
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		ew_AddFilter($filter, $where);
		if ($filter <> "")
			$sql .= $filter;
		else
			$sql .= "0=1"; // Avoid delete
		return $sql;
	}

	// Delete
	function Delete(&$rs, $where = "", $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->DeleteSQL($rs, $where, $curfilter));
	}

	// Key filter WHERE clause
	function SqlKeyFilter() {
		return "";
	}

	// Key filter
	function KeyFilter() {
		$sKeyFilter = $this->SqlKeyFilter();
		return $sKeyFilter;
	}

	// Return page URL
	function getReturnUrl() {
		$name = EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL;

		// Get referer URL automatically
		if (ew_ServerVar("HTTP_REFERER") <> "" && ew_ReferPage() <> ew_CurrentPage() && ew_ReferPage() <> "login.php") // Referer not same page or login page
			$_SESSION[$name] = ew_ServerVar("HTTP_REFERER"); // Save to Session
		if (@$_SESSION[$name] <> "") {
			return $_SESSION[$name];
		} else {
			return "Cust_Rpt_Monthlylist.php";
		}
	}

	function setReturnUrl($v) {
		$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL] = $v;
	}

	// List URL
	function GetListUrl() {
		return "Cust_Rpt_Monthlylist.php";
	}

	// View URL
	function GetViewUrl($parm = "") {
		if ($parm <> "")
			$url = $this->KeyUrl("Cust_Rpt_Monthlyview.php", $this->UrlParm($parm));
		else
			$url = $this->KeyUrl("Cust_Rpt_Monthlyview.php", $this->UrlParm(EW_TABLE_SHOW_DETAIL . "="));
		return $this->AddMasterUrl($url);
	}

	// Add URL
	function GetAddUrl($parm = "") {
		if ($parm <> "")
			$url = "Cust_Rpt_Monthlyadd.php?" . $this->UrlParm($parm);
		else
			$url = "Cust_Rpt_Monthlyadd.php";
		return $this->AddMasterUrl($url);
	}

	// Edit URL
	function GetEditUrl($parm = "") {
		$url = $this->KeyUrl("Cust_Rpt_Monthlyedit.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline edit URL
	function GetInlineEditUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=edit"));
		return $this->AddMasterUrl($url);
	}

	// Copy URL
	function GetCopyUrl($parm = "") {
		$url = $this->KeyUrl("Cust_Rpt_Monthlyadd.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline copy URL
	function GetInlineCopyUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=copy"));
		return $this->AddMasterUrl($url);
	}

	// Delete URL
	function GetDeleteUrl() {
		return $this->KeyUrl("Cust_Rpt_Monthlydelete.php", $this->UrlParm());
	}

	// Add master url
	function AddMasterUrl($url) {
		return $url;
	}

	function KeyToJson() {
		$json = "";
		return "{" . $json . "}";
	}

	// Add key value to URL
	function KeyUrl($url, $parm = "") {
		$sUrl = $url . "?";
		if ($parm <> "") $sUrl .= $parm . "&";
		return $sUrl;
	}

	// Sort URL
	function SortUrl(&$fld) {
		if ($this->CurrentAction <> "" || $this->Export <> "" ||
			in_array($fld->FldType, array(128, 204, 205))) { // Unsortable data type
				return "";
		} elseif ($fld->Sortable) {
			$sUrlParm = $this->UrlParm("order=" . urlencode($fld->FldName) . "&amp;ordertype=" . $fld->ReverseSort());
			return $this->AddMasterUrl(ew_CurrentPage() . "?" . $sUrlParm);
		} else {
			return "";
		}
	}

	// Get record keys from $_POST/$_GET/$_SESSION
	function GetRecordKeys() {
		global $EW_COMPOSITE_KEY_SEPARATOR;
		$arKeys = array();
		$arKey = array();
		if (isset($_POST["key_m"])) {
			$arKeys = ew_StripSlashes($_POST["key_m"]);
			$cnt = count($arKeys);
		} elseif (isset($_GET["key_m"])) {
			$arKeys = ew_StripSlashes($_GET["key_m"]);
			$cnt = count($arKeys);
		} elseif (!empty($_GET) || !empty($_POST)) {
			$isPost = ew_IsHttpPost();

			//return $arKeys; // Do not return yet, so the values will also be checked by the following code
		}

		// Check keys
		$ar = array();
		if (is_array($arKeys)) {
			foreach ($arKeys as $key) {
				$ar[] = $key;
			}
		}
		return $ar;
	}

	// Get key filter
	function GetKeyFilter() {
		$arKeys = $this->GetRecordKeys();
		$sKeyFilter = "";
		foreach ($arKeys as $key) {
			if ($sKeyFilter <> "") $sKeyFilter .= " OR ";
			$sKeyFilter .= "(" . $this->KeyFilter() . ")";
		}
		return $sKeyFilter;
	}

	// Load rows based on filter
	function &LoadRs($sFilter) {

		// Set up filter (SQL WHERE clause) and get return SQL
		//$this->CurrentFilter = $sFilter;
		//$sSql = $this->SQL();

		$sSql = $this->GetSQL($sFilter, "");
		$conn = &$this->Connection();
		$rs = $conn->Execute($sSql);
		return $rs;
	}

	// Load row values from recordset
	function LoadListRowValues(&$rs) {
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->First->setDbValue($rs->fields('First'));
		$this->Last->setDbValue($rs->fields('Last'));
		$this->Total_Hours->setDbValue($rs->fields('Total Hours'));
		$this->January->setDbValue($rs->fields('January'));
		$this->Feburary->setDbValue($rs->fields('Feburary'));
		$this->March->setDbValue($rs->fields('March'));
		$this->April->setDbValue($rs->fields('April'));
		$this->May->setDbValue($rs->fields('May'));
		$this->June->setDbValue($rs->fields('June'));
		$this->July->setDbValue($rs->fields('July'));
		$this->August->setDbValue($rs->fields('August'));
		$this->September->setDbValue($rs->fields('September'));
		$this->October->setDbValue($rs->fields('October'));
		$this->November->setDbValue($rs->fields('November'));
		$this->December->setDbValue($rs->fields('December'));
	}

	// Render list row values
	function RenderListRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

   // Common render codes
		// dbkey
		// First
		// Last
		// Total Hours
		// January
		// Feburary
		// March
		// April
		// May
		// June
		// July
		// August
		// September
		// October
		// November
		// December
		// dbkey

		$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// First
		$this->First->ViewValue = $this->First->CurrentValue;
		$this->First->ViewCustomAttributes = "";

		// Last
		$this->Last->ViewValue = $this->Last->CurrentValue;
		$this->Last->ViewCustomAttributes = "";

		// Total Hours
		$this->Total_Hours->ViewValue = $this->Total_Hours->CurrentValue;
		$this->Total_Hours->ViewCustomAttributes = "";

		// January
		$this->January->ViewValue = $this->January->CurrentValue;
		$this->January->ViewCustomAttributes = "";

		// Feburary
		$this->Feburary->ViewValue = $this->Feburary->CurrentValue;
		$this->Feburary->ViewCustomAttributes = "";

		// March
		$this->March->ViewValue = $this->March->CurrentValue;
		$this->March->ViewCustomAttributes = "";

		// April
		$this->April->ViewValue = $this->April->CurrentValue;
		$this->April->ViewCustomAttributes = "";

		// May
		$this->May->ViewValue = $this->May->CurrentValue;
		$this->May->ViewCustomAttributes = "";

		// June
		$this->June->ViewValue = $this->June->CurrentValue;
		$this->June->ViewCustomAttributes = "";

		// July
		$this->July->ViewValue = $this->July->CurrentValue;
		$this->July->ViewCustomAttributes = "";

		// August
		$this->August->ViewValue = $this->August->CurrentValue;
		$this->August->ViewCustomAttributes = "";

		// September
		$this->September->ViewValue = $this->September->CurrentValue;
		$this->September->ViewCustomAttributes = "";

		// October
		$this->October->ViewValue = $this->October->CurrentValue;
		$this->October->ViewCustomAttributes = "";

		// November
		$this->November->ViewValue = $this->November->CurrentValue;
		$this->November->ViewCustomAttributes = "";

		// December
		$this->December->ViewValue = $this->December->CurrentValue;
		$this->December->ViewCustomAttributes = "";

		// dbkey
		$this->dbkey->LinkCustomAttributes = "";
		$this->dbkey->HrefValue = "";
		$this->dbkey->TooltipValue = "";

		// First
		$this->First->LinkCustomAttributes = "";
		$this->First->HrefValue = "";
		$this->First->TooltipValue = "";

		// Last
		$this->Last->LinkCustomAttributes = "";
		$this->Last->HrefValue = "";
		$this->Last->TooltipValue = "";

		// Total Hours
		$this->Total_Hours->LinkCustomAttributes = "";
		$this->Total_Hours->HrefValue = "";
		$this->Total_Hours->TooltipValue = "";

		// January
		$this->January->LinkCustomAttributes = "";
		$this->January->HrefValue = "";
		$this->January->TooltipValue = "";

		// Feburary
		$this->Feburary->LinkCustomAttributes = "";
		$this->Feburary->HrefValue = "";
		$this->Feburary->TooltipValue = "";

		// March
		$this->March->LinkCustomAttributes = "";
		$this->March->HrefValue = "";
		$this->March->TooltipValue = "";

		// April
		$this->April->LinkCustomAttributes = "";
		$this->April->HrefValue = "";
		$this->April->TooltipValue = "";

		// May
		$this->May->LinkCustomAttributes = "";
		$this->May->HrefValue = "";
		$this->May->TooltipValue = "";

		// June
		$this->June->LinkCustomAttributes = "";
		$this->June->HrefValue = "";
		$this->June->TooltipValue = "";

		// July
		$this->July->LinkCustomAttributes = "";
		$this->July->HrefValue = "";
		$this->July->TooltipValue = "";

		// August
		$this->August->LinkCustomAttributes = "";
		$this->August->HrefValue = "";
		$this->August->TooltipValue = "";

		// September
		$this->September->LinkCustomAttributes = "";
		$this->September->HrefValue = "";
		$this->September->TooltipValue = "";

		// October
		$this->October->LinkCustomAttributes = "";
		$this->October->HrefValue = "";
		$this->October->TooltipValue = "";

		// November
		$this->November->LinkCustomAttributes = "";
		$this->November->HrefValue = "";
		$this->November->TooltipValue = "";

		// December
		$this->December->LinkCustomAttributes = "";
		$this->December->HrefValue = "";
		$this->December->TooltipValue = "";

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Render edit row values
	function RenderEditRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

		// dbkey
		$this->dbkey->EditAttrs["class"] = "form-control";
		$this->dbkey->EditCustomAttributes = "";
		$this->dbkey->EditValue = $this->dbkey->CurrentValue;
		$this->dbkey->PlaceHolder = ew_RemoveHtml($this->dbkey->FldCaption());

		// First
		$this->First->EditAttrs["class"] = "form-control";
		$this->First->EditCustomAttributes = "";
		$this->First->EditValue = $this->First->CurrentValue;
		$this->First->PlaceHolder = ew_RemoveHtml($this->First->FldCaption());

		// Last
		$this->Last->EditAttrs["class"] = "form-control";
		$this->Last->EditCustomAttributes = "";
		$this->Last->EditValue = $this->Last->CurrentValue;
		$this->Last->PlaceHolder = ew_RemoveHtml($this->Last->FldCaption());

		// Total Hours
		$this->Total_Hours->EditAttrs["class"] = "form-control";
		$this->Total_Hours->EditCustomAttributes = "";
		$this->Total_Hours->EditValue = $this->Total_Hours->CurrentValue;
		$this->Total_Hours->PlaceHolder = ew_RemoveHtml($this->Total_Hours->FldCaption());
		if (strval($this->Total_Hours->EditValue) <> "" && is_numeric($this->Total_Hours->EditValue)) $this->Total_Hours->EditValue = ew_FormatNumber($this->Total_Hours->EditValue, -2, -1, -2, 0);

		// January
		$this->January->EditAttrs["class"] = "form-control";
		$this->January->EditCustomAttributes = "";
		$this->January->EditValue = $this->January->CurrentValue;
		$this->January->PlaceHolder = ew_RemoveHtml($this->January->FldCaption());
		if (strval($this->January->EditValue) <> "" && is_numeric($this->January->EditValue)) $this->January->EditValue = ew_FormatNumber($this->January->EditValue, -2, -1, -2, 0);

		// Feburary
		$this->Feburary->EditAttrs["class"] = "form-control";
		$this->Feburary->EditCustomAttributes = "";
		$this->Feburary->EditValue = $this->Feburary->CurrentValue;
		$this->Feburary->PlaceHolder = ew_RemoveHtml($this->Feburary->FldCaption());
		if (strval($this->Feburary->EditValue) <> "" && is_numeric($this->Feburary->EditValue)) $this->Feburary->EditValue = ew_FormatNumber($this->Feburary->EditValue, -2, -1, -2, 0);

		// March
		$this->March->EditAttrs["class"] = "form-control";
		$this->March->EditCustomAttributes = "";
		$this->March->EditValue = $this->March->CurrentValue;
		$this->March->PlaceHolder = ew_RemoveHtml($this->March->FldCaption());
		if (strval($this->March->EditValue) <> "" && is_numeric($this->March->EditValue)) $this->March->EditValue = ew_FormatNumber($this->March->EditValue, -2, -1, -2, 0);

		// April
		$this->April->EditAttrs["class"] = "form-control";
		$this->April->EditCustomAttributes = "";
		$this->April->EditValue = $this->April->CurrentValue;
		$this->April->PlaceHolder = ew_RemoveHtml($this->April->FldCaption());
		if (strval($this->April->EditValue) <> "" && is_numeric($this->April->EditValue)) $this->April->EditValue = ew_FormatNumber($this->April->EditValue, -2, -1, -2, 0);

		// May
		$this->May->EditAttrs["class"] = "form-control";
		$this->May->EditCustomAttributes = "";
		$this->May->EditValue = $this->May->CurrentValue;
		$this->May->PlaceHolder = ew_RemoveHtml($this->May->FldCaption());
		if (strval($this->May->EditValue) <> "" && is_numeric($this->May->EditValue)) $this->May->EditValue = ew_FormatNumber($this->May->EditValue, -2, -1, -2, 0);

		// June
		$this->June->EditAttrs["class"] = "form-control";
		$this->June->EditCustomAttributes = "";
		$this->June->EditValue = $this->June->CurrentValue;
		$this->June->PlaceHolder = ew_RemoveHtml($this->June->FldCaption());
		if (strval($this->June->EditValue) <> "" && is_numeric($this->June->EditValue)) $this->June->EditValue = ew_FormatNumber($this->June->EditValue, -2, -1, -2, 0);

		// July
		$this->July->EditAttrs["class"] = "form-control";
		$this->July->EditCustomAttributes = "";
		$this->July->EditValue = $this->July->CurrentValue;
		$this->July->PlaceHolder = ew_RemoveHtml($this->July->FldCaption());
		if (strval($this->July->EditValue) <> "" && is_numeric($this->July->EditValue)) $this->July->EditValue = ew_FormatNumber($this->July->EditValue, -2, -1, -2, 0);

		// August
		$this->August->EditAttrs["class"] = "form-control";
		$this->August->EditCustomAttributes = "";
		$this->August->EditValue = $this->August->CurrentValue;
		$this->August->PlaceHolder = ew_RemoveHtml($this->August->FldCaption());
		if (strval($this->August->EditValue) <> "" && is_numeric($this->August->EditValue)) $this->August->EditValue = ew_FormatNumber($this->August->EditValue, -2, -1, -2, 0);

		// September
		$this->September->EditAttrs["class"] = "form-control";
		$this->September->EditCustomAttributes = "";
		$this->September->EditValue = $this->September->CurrentValue;
		$this->September->PlaceHolder = ew_RemoveHtml($this->September->FldCaption());
		if (strval($this->September->EditValue) <> "" && is_numeric($this->September->EditValue)) $this->September->EditValue = ew_FormatNumber($this->September->EditValue, -2, -1, -2, 0);

		// October
		$this->October->EditAttrs["class"] = "form-control";
		$this->October->EditCustomAttributes = "";
		$this->October->EditValue = $this->October->CurrentValue;
		$this->October->PlaceHolder = ew_RemoveHtml($this->October->FldCaption());
		if (strval($this->October->EditValue) <> "" && is_numeric($this->October->EditValue)) $this->October->EditValue = ew_FormatNumber($this->October->EditValue, -2, -1, -2, 0);

		// November
		$this->November->EditAttrs["class"] = "form-control";
		$this->November->EditCustomAttributes = "";
		$this->November->EditValue = $this->November->CurrentValue;
		$this->November->PlaceHolder = ew_RemoveHtml($this->November->FldCaption());
		if (strval($this->November->EditValue) <> "" && is_numeric($this->November->EditValue)) $this->November->EditValue = ew_FormatNumber($this->November->EditValue, -2, -1, -2, 0);

		// December
		$this->December->EditAttrs["class"] = "form-control";
		$this->December->EditCustomAttributes = "";
		$this->December->EditValue = $this->December->CurrentValue;
		$this->December->PlaceHolder = ew_RemoveHtml($this->December->FldCaption());
		if (strval($this->December->EditValue) <> "" && is_numeric($this->December->EditValue)) $this->December->EditValue = ew_FormatNumber($this->December->EditValue, -2, -1, -2, 0);

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Aggregate list row values
	function AggregateListRowValues() {
	}

	// Aggregate list row (for rendering)
	function AggregateListRow() {

		// Call Row Rendered event
		$this->Row_Rendered();
	}
	var $ExportDoc;

	// Export data in HTML/CSV/Word/Excel/Email/PDF format
	function ExportDocument(&$Doc, &$Recordset, $StartRec, $StopRec, $ExportPageType = "") {
		if (!$Recordset || !$Doc)
			return;
		if (!$Doc->ExportCustom) {

			// Write header
			$Doc->ExportTableHeader();
			if ($Doc->Horizontal) { // Horizontal format, write header
				$Doc->BeginExportRow();
				if ($ExportPageType == "view") {
				} else {
					if ($this->dbkey->Exportable) $Doc->ExportCaption($this->dbkey);
					if ($this->First->Exportable) $Doc->ExportCaption($this->First);
					if ($this->Last->Exportable) $Doc->ExportCaption($this->Last);
					if ($this->Total_Hours->Exportable) $Doc->ExportCaption($this->Total_Hours);
					if ($this->January->Exportable) $Doc->ExportCaption($this->January);
					if ($this->Feburary->Exportable) $Doc->ExportCaption($this->Feburary);
					if ($this->March->Exportable) $Doc->ExportCaption($this->March);
					if ($this->April->Exportable) $Doc->ExportCaption($this->April);
					if ($this->May->Exportable) $Doc->ExportCaption($this->May);
					if ($this->June->Exportable) $Doc->ExportCaption($this->June);
					if ($this->July->Exportable) $Doc->ExportCaption($this->July);
					if ($this->August->Exportable) $Doc->ExportCaption($this->August);
					if ($this->September->Exportable) $Doc->ExportCaption($this->September);
					if ($this->October->Exportable) $Doc->ExportCaption($this->October);
					if ($this->November->Exportable) $Doc->ExportCaption($this->November);
					if ($this->December->Exportable) $Doc->ExportCaption($this->December);
				}
				$Doc->EndExportRow();
			}
		}

		// Move to first record
		$RecCnt = $StartRec - 1;
		if (!$Recordset->EOF) {
			$Recordset->MoveFirst();
			if ($StartRec > 1)
				$Recordset->Move($StartRec - 1);
		}
		while (!$Recordset->EOF && $RecCnt < $StopRec) {
			$RecCnt++;
			if (intval($RecCnt) >= intval($StartRec)) {
				$RowCnt = intval($RecCnt) - intval($StartRec) + 1;

				// Page break
				if ($this->ExportPageBreakCount > 0) {
					if ($RowCnt > 1 && ($RowCnt - 1) % $this->ExportPageBreakCount == 0)
						$Doc->ExportPageBreak();
				}
				$this->LoadListRowValues($Recordset);

				// Render row
				$this->RowType = EW_ROWTYPE_VIEW; // Render view
				$this->ResetAttrs();
				$this->RenderListRow();
				if (!$Doc->ExportCustom) {
					$Doc->BeginExportRow($RowCnt); // Allow CSS styles if enabled
					if ($ExportPageType == "view") {
					} else {
						if ($this->dbkey->Exportable) $Doc->ExportField($this->dbkey);
						if ($this->First->Exportable) $Doc->ExportField($this->First);
						if ($this->Last->Exportable) $Doc->ExportField($this->Last);
						if ($this->Total_Hours->Exportable) $Doc->ExportField($this->Total_Hours);
						if ($this->January->Exportable) $Doc->ExportField($this->January);
						if ($this->Feburary->Exportable) $Doc->ExportField($this->Feburary);
						if ($this->March->Exportable) $Doc->ExportField($this->March);
						if ($this->April->Exportable) $Doc->ExportField($this->April);
						if ($this->May->Exportable) $Doc->ExportField($this->May);
						if ($this->June->Exportable) $Doc->ExportField($this->June);
						if ($this->July->Exportable) $Doc->ExportField($this->July);
						if ($this->August->Exportable) $Doc->ExportField($this->August);
						if ($this->September->Exportable) $Doc->ExportField($this->September);
						if ($this->October->Exportable) $Doc->ExportField($this->October);
						if ($this->November->Exportable) $Doc->ExportField($this->November);
						if ($this->December->Exportable) $Doc->ExportField($this->December);
					}
					$Doc->EndExportRow();
				}
			}

			// Call Row Export server event
			if ($Doc->ExportCustom)
				$this->Row_Export($Recordset->fields);
			$Recordset->MoveNext();
		}
		if (!$Doc->ExportCustom) {
			$Doc->ExportTableFooter();
		}
	}

	// Get auto fill value
	function GetAutoFill($id, $val) {
		$rsarr = array();
		$rowcnt = 0;

		// Output
		if (is_array($rsarr) && $rowcnt > 0) {
			$fldcnt = count($rsarr[0]);
			for ($i = 0; $i < $rowcnt; $i++) {
				for ($j = 0; $j < $fldcnt; $j++) {
					$str = strval($rsarr[$i][$j]);
					$str = ew_ConvertToUtf8($str);
					if (isset($post["keepCRLF"])) {
						$str = str_replace(array("\r", "\n"), array("\\r", "\\n"), $str);
					} else {
						$str = str_replace(array("\r", "\n"), array(" ", " "), $str);
					}
					$rsarr[$i][$j] = $str;
				}
			}
			return ew_ArrayToJson($rsarr);
		} else {
			return FALSE;
		}
	}

	// Table level events
	// Recordset Selecting event
	function Recordset_Selecting(&$filter) {

		// Enter your code here	
	}

	// Recordset Selected event
	function Recordset_Selected(&$rs) {

		//echo "Recordset Selected";
	}

	// Recordset Search Validated event
	function Recordset_SearchValidated() {

		// Example:
		//$this->MyField1->AdvancedSearch->SearchValue = "your search criteria"; // Search value

	}

	// Recordset Searching event
	function Recordset_Searching(&$filter) {

		// Enter your code here	
	}

	// Row_Selecting event
	function Row_Selecting(&$filter) {

		// Enter your code here	
	}

	// Row Selected event
	function Row_Selected(&$rs) {

		//echo "Row Selected";
	}

	// Row Inserting event
	function Row_Inserting($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Inserted event
	function Row_Inserted($rsold, &$rsnew) {

		//echo "Row Inserted"
	}

	// Row Updating event
	function Row_Updating($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Updated event
	function Row_Updated($rsold, &$rsnew) {

		//echo "Row Updated";
	}

	// Row Update Conflict event
	function Row_UpdateConflict($rsold, &$rsnew) {

		// Enter your code here
		// To ignore conflict, set return value to FALSE

		return TRUE;
	}

	// Grid Inserting event
	function Grid_Inserting() {

		// Enter your code here
		// To reject grid insert, set return value to FALSE

		return TRUE;
	}

	// Grid Inserted event
	function Grid_Inserted($rsnew) {

		//echo "Grid Inserted";
	}

	// Grid Updating event
	function Grid_Updating($rsold) {

		// Enter your code here
		// To reject grid update, set return value to FALSE

		return TRUE;
	}

	// Grid Updated event
	function Grid_Updated($rsold, $rsnew) {

		//echo "Grid Updated";
	}

	// Row Deleting event
	function Row_Deleting(&$rs) {

		// Enter your code here
		// To cancel, set return value to False

		return TRUE;
	}

	// Row Deleted event
	function Row_Deleted(&$rs) {

		//echo "Row Deleted";
	}

	// Email Sending event
	function Email_Sending(&$Email, &$Args) {

		//var_dump($Email); var_dump($Args); exit();
		return TRUE;
	}

	// Lookup Selecting event
	function Lookup_Selecting($fld, &$filter) {

		//var_dump($fld->FldName, $fld->LookupFilters, $filter); // Uncomment to view the filter
		// Enter your code here

	}

	// Row Rendering event
	function Row_Rendering() {

		// Enter your code here	
	}

	// Row Rendered event
	function Row_Rendered() {

		// To view properties of field class, use:
		//var_dump($this-><FieldName>); 

	}

	// User ID Filtering event
	function UserID_Filtering(&$filter) {

		// Enter your code here
	}
}
?>
