<?php
if (session_id() == "") session_start(); // Init session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg13.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql13.php") ?>
<?php include_once "phpfn13.php" ?>
<?php include_once "Cust_case_notes_admininfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "case_notesinfo.php" ?>
<?php include_once "userfn13.php" ?>
<?php

//
// Page class
//

$Cust_case_notes_admin_edit = NULL; // Initialize page object first

class cCust_case_notes_admin_edit extends cCust_case_notes_admin {

	// Page ID
	var $PageID = 'edit';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'Cust_case_notes_admin';

	// Page object name
	var $PageObjName = 'Cust_case_notes_admin_edit';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}
	var $AuditTrailOnAdd = FALSE;
	var $AuditTrailOnEdit = TRUE;
	var $AuditTrailOnDelete = FALSE;
	var $AuditTrailOnView = FALSE;
	var $AuditTrailOnViewData = FALSE;
	var $AuditTrailOnSearch = FALSE;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (Cust_case_notes_admin)
		if (!isset($GLOBALS["Cust_case_notes_admin"]) || get_class($GLOBALS["Cust_case_notes_admin"]) == "cCust_case_notes_admin") {
			$GLOBALS["Cust_case_notes_admin"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["Cust_case_notes_admin"];
		}

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Table object (case_notes)
		if (!isset($GLOBALS['case_notes'])) $GLOBALS['case_notes'] = new ccase_notes();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'edit', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'Cust_case_notes_admin', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	//
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanEdit()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("Cust_case_notes_adminlist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Create form object
		$objForm = new cFormObj();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action
		$this->counselor->SetVisibility();
		$this->counselor->Visible = !$this->IsAddOrEdit();
		$this->dbkey_counselor->SetVisibility();
		$this->create_date->SetVisibility();
		$this->case_notes->SetVisibility();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $Cust_case_notes_admin;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($Cust_case_notes_admin);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();

			// Handle modal response
			if ($this->IsModal) {
				$row = array();
				$row["url"] = $url;
				echo ew_ArrayToJson(array($row));
			} else {
				header("Location: " . $url);
			}
		}
		exit();
	}
	var $FormClassName = "form-horizontal ewForm ewEditForm";
	var $IsModal = FALSE;
	var $DbMasterFilter;
	var $DbDetailFilter;

	// 
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError;
		global $gbSkipHeaderFooter;

		// Check modal
		$this->IsModal = (@$_GET["modal"] == "1" || @$_POST["modal"] == "1");
		if ($this->IsModal)
			$gbSkipHeaderFooter = TRUE;

		// Load key from QueryString
		if (@$_GET["dbkey"] <> "") {
			$this->dbkey->setQueryStringValue($_GET["dbkey"]);
		}

		// Process form if post back
		if (@$_POST["a_edit"] <> "") {
			$this->CurrentAction = $_POST["a_edit"]; // Get action code
			$this->LoadFormValues(); // Get form values
		} else {
			$this->CurrentAction = "I"; // Default action is display
		}

		// Check if valid key
		if ($this->dbkey->CurrentValue == "") {
			$this->Page_Terminate("Cust_case_notes_adminlist.php"); // Invalid key, return to list
		}

		// Validate form if post back
		if (@$_POST["a_edit"] <> "") {
			if (!$this->ValidateForm()) {
				$this->CurrentAction = ""; // Form error, reset action
				$this->setFailureMessage($gsFormError);
				$this->EventCancelled = TRUE; // Event cancelled
				$this->RestoreFormValues();
			}
		}
		switch ($this->CurrentAction) {
			case "I": // Get a record to display
				if (!$this->LoadRow()) { // Load record based on key
					if ($this->getFailureMessage() == "") $this->setFailureMessage($Language->Phrase("NoRecord")); // No record found
					$this->Page_Terminate("Cust_case_notes_adminlist.php"); // No matching record, return to list
				}
				break;
			Case "U": // Update
				$sReturnUrl = $this->getReturnUrl();
				if (ew_GetPageName($sReturnUrl) == "Cust_case_notes_adminlist.php")
					$sReturnUrl = $this->AddMasterUrl($sReturnUrl); // List page, return to list page with correct master key if necessary
				$this->SendEmail = TRUE; // Send email on update success
				if ($this->EditRow()) { // Update record based on key
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage($Language->Phrase("UpdateSuccess")); // Update success
					$this->Page_Terminate($sReturnUrl); // Return to caller
				} elseif ($this->getFailureMessage() == $Language->Phrase("NoRecord")) {
					$this->Page_Terminate($sReturnUrl); // Return to caller
				} else {
					$this->EventCancelled = TRUE; // Event cancelled
					$this->RestoreFormValues(); // Restore form values if update failed
				}
		}

		// Set up Breadcrumb
		$this->SetupBreadcrumb();

		// Render the record
		$this->RowType = EW_ROWTYPE_EDIT; // Render as Edit
		$this->ResetAttrs();
		$this->RenderRow();
	}

	// Set up starting record parameters
	function SetUpStartRec() {
		if ($this->DisplayRecs == 0)
			return;
		if ($this->IsPageRequest()) { // Validate request
			if (@$_GET[EW_TABLE_START_REC] <> "") { // Check for "start" parameter
				$this->StartRec = $_GET[EW_TABLE_START_REC];
				$this->setStartRecordNumber($this->StartRec);
			} elseif (@$_GET[EW_TABLE_PAGE_NO] <> "") {
				$PageNo = $_GET[EW_TABLE_PAGE_NO];
				if (is_numeric($PageNo)) {
					$this->StartRec = ($PageNo-1)*$this->DisplayRecs+1;
					if ($this->StartRec <= 0) {
						$this->StartRec = 1;
					} elseif ($this->StartRec >= intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1) {
						$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1;
					}
					$this->setStartRecordNumber($this->StartRec);
				}
			}
		}
		$this->StartRec = $this->getStartRecordNumber();

		// Check if correct start record counter
		if (!is_numeric($this->StartRec) || $this->StartRec == "") { // Avoid invalid start record counter
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} elseif (intval($this->StartRec) > intval($this->TotalRecs)) { // Avoid starting record > total records
			$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to last page first record
			$this->setStartRecordNumber($this->StartRec);
		} elseif (($this->StartRec-1) % $this->DisplayRecs <> 0) {
			$this->StartRec = intval(($this->StartRec-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to page boundary
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Get upload files
	function GetUploadFiles() {
		global $objForm, $Language;

		// Get upload data
	}

	// Load form values
	function LoadFormValues() {

		// Load from form
		global $objForm;
		if (!$this->counselor->FldIsDetailKey) {
			$this->counselor->setFormValue($objForm->GetValue("x_counselor"));
		}
		if (!$this->dbkey_counselor->FldIsDetailKey) {
			$this->dbkey_counselor->setFormValue($objForm->GetValue("x_dbkey_counselor"));
		}
		if (!$this->create_date->FldIsDetailKey) {
			$this->create_date->setFormValue($objForm->GetValue("x_create_date"));
			$this->create_date->CurrentValue = ew_UnFormatDateTime($this->create_date->CurrentValue, 0);
		}
		if (!$this->case_notes->FldIsDetailKey) {
			$this->case_notes->setFormValue($objForm->GetValue("x_case_notes"));
		}
		if (!$this->dbkey->FldIsDetailKey)
			$this->dbkey->setFormValue($objForm->GetValue("x_dbkey"));
	}

	// Restore form values
	function RestoreFormValues() {
		global $objForm;
		$this->LoadRow();
		$this->dbkey->CurrentValue = $this->dbkey->FormValue;
		$this->counselor->CurrentValue = $this->counselor->FormValue;
		$this->dbkey_counselor->CurrentValue = $this->dbkey_counselor->FormValue;
		$this->create_date->CurrentValue = $this->create_date->FormValue;
		$this->create_date->CurrentValue = ew_UnFormatDateTime($this->create_date->CurrentValue, 0);
		$this->case_notes->CurrentValue = $this->case_notes->FormValue;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->counselor->setDbValue($rs->fields('counselor'));
		$this->dbkey_counselor->setDbValue($rs->fields('dbkey_counselor'));
		$this->create_date->setDbValue($rs->fields('create_date'));
		$this->case_notes->setDbValue($rs->fields('case_notes'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey->DbValue = $row['dbkey'];
		$this->counselor->DbValue = $row['counselor'];
		$this->dbkey_counselor->DbValue = $row['dbkey_counselor'];
		$this->create_date->DbValue = $row['create_date'];
		$this->case_notes->DbValue = $row['case_notes'];
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Call Row_Rendering event

		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey
		// counselor
		// dbkey_counselor
		// create_date
		// case_notes

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// counselor
		if (strval($this->counselor->CurrentValue) <> "") {
			$sFilterWrk = "(SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor)" . ew_SearchString("=", $this->counselor->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor), (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `case_notes`";
		$sWhereWrk = "";
		$this->counselor->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->counselor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->counselor->ViewValue = $this->counselor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->counselor->ViewValue = $this->counselor->CurrentValue;
			}
		} else {
			$this->counselor->ViewValue = NULL;
		}
		$this->counselor->ViewCustomAttributes = "";

		// dbkey_counselor
		if (strval($this->dbkey_counselor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey_counselor`" . ew_SearchString("=", $this->dbkey_counselor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey_counselor`, (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `case_notes`";
		$sWhereWrk = "";
		$this->dbkey_counselor->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_counselor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_counselor->ViewValue = $this->dbkey_counselor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_counselor->ViewValue = $this->dbkey_counselor->CurrentValue;
			}
		} else {
			$this->dbkey_counselor->ViewValue = NULL;
		}
		$this->dbkey_counselor->ViewCustomAttributes = "";

		// create_date
		$this->create_date->ViewValue = $this->create_date->CurrentValue;
		$this->create_date->ViewValue = ew_FormatDateTime($this->create_date->ViewValue, 0);
		$this->create_date->ViewCustomAttributes = "";

		// case_notes
		$this->case_notes->ViewValue = $this->case_notes->CurrentValue;
		$this->case_notes->ViewCustomAttributes = "";

			// counselor
			$this->counselor->LinkCustomAttributes = "";
			$this->counselor->HrefValue = "";
			$this->counselor->TooltipValue = "";

			// dbkey_counselor
			$this->dbkey_counselor->LinkCustomAttributes = "";
			$this->dbkey_counselor->HrefValue = "";
			$this->dbkey_counselor->TooltipValue = "";

			// create_date
			$this->create_date->LinkCustomAttributes = "";
			$this->create_date->HrefValue = "";
			$this->create_date->TooltipValue = "";

			// case_notes
			$this->case_notes->LinkCustomAttributes = "";
			$this->case_notes->HrefValue = "";
			$this->case_notes->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_EDIT) { // Edit row

			// counselor
			$this->counselor->EditAttrs["class"] = "form-control";
			$this->counselor->EditCustomAttributes = "";
			if (trim(strval($this->counselor->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "(SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor)" . ew_SearchString("=", $this->counselor->CurrentValue, EW_DATATYPE_STRING, "");
			}
			$sSqlWrk = "SELECT DISTINCT (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor), (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `case_notes`";
			$sWhereWrk = "";
			$this->counselor->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			if (!$GLOBALS["Cust_case_notes_admin"]->UserIDAllow("edit")) $sWhereWrk = $GLOBALS["case_notes"]->AddUserIDFilter($sWhereWrk);
			$this->Lookup_Selecting($this->counselor, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->counselor->EditValue = $arwrk;

			// dbkey_counselor
			$this->dbkey_counselor->EditAttrs["class"] = "form-control";
			$this->dbkey_counselor->EditCustomAttributes = "";
			if (trim(strval($this->dbkey_counselor->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey_counselor`" . ew_SearchString("=", $this->dbkey_counselor->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT DISTINCT `dbkey_counselor`, (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `case_notes`";
			$sWhereWrk = "";
			$this->dbkey_counselor->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			if (!$GLOBALS["Cust_case_notes_admin"]->UserIDAllow("edit")) $sWhereWrk = $GLOBALS["case_notes"]->AddUserIDFilter($sWhereWrk);
			$this->Lookup_Selecting($this->dbkey_counselor, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->dbkey_counselor->EditValue = $arwrk;

			// create_date
			$this->create_date->EditAttrs["class"] = "form-control";
			$this->create_date->EditCustomAttributes = "";
			$this->create_date->EditValue = ew_HtmlEncode(ew_FormatDateTime($this->create_date->CurrentValue, 8));
			$this->create_date->PlaceHolder = ew_RemoveHtml($this->create_date->FldCaption());

			// case_notes
			$this->case_notes->EditAttrs["class"] = "form-control";
			$this->case_notes->EditCustomAttributes = "";
			$this->case_notes->EditValue = ew_HtmlEncode($this->case_notes->CurrentValue);
			$this->case_notes->PlaceHolder = ew_RemoveHtml($this->case_notes->FldCaption());

			// Edit refer script
			// counselor

			$this->counselor->LinkCustomAttributes = "";
			$this->counselor->HrefValue = "";

			// dbkey_counselor
			$this->dbkey_counselor->LinkCustomAttributes = "";
			$this->dbkey_counselor->HrefValue = "";

			// create_date
			$this->create_date->LinkCustomAttributes = "";
			$this->create_date->HrefValue = "";

			// case_notes
			$this->case_notes->LinkCustomAttributes = "";
			$this->case_notes->HrefValue = "";
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate form
	function ValidateForm() {
		global $Language, $gsFormError;

		// Initialize form error message
		$gsFormError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return ($gsFormError == "");
		if (!$this->dbkey_counselor->FldIsDetailKey && !is_null($this->dbkey_counselor->FormValue) && $this->dbkey_counselor->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->dbkey_counselor->FldCaption(), $this->dbkey_counselor->ReqErrMsg));
		}
		if (!$this->create_date->FldIsDetailKey && !is_null($this->create_date->FormValue) && $this->create_date->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->create_date->FldCaption(), $this->create_date->ReqErrMsg));
		}
		if (!ew_CheckDateDef($this->create_date->FormValue)) {
			ew_AddMessage($gsFormError, $this->create_date->FldErrMsg());
		}
		if (!$this->case_notes->FldIsDetailKey && !is_null($this->case_notes->FormValue) && $this->case_notes->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->case_notes->FldCaption(), $this->case_notes->ReqErrMsg));
		}

		// Return validate result
		$ValidateForm = ($gsFormError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateForm = $ValidateForm && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsFormError, $sFormCustomError);
		}
		return $ValidateForm;
	}

	// Update record based on key values
	function EditRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$conn = &$this->Connection();
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
		$rs = $conn->Execute($sSql);
		$conn->raiseErrorFn = '';
		if ($rs === FALSE)
			return FALSE;
		if ($rs->EOF) {
			$this->setFailureMessage($Language->Phrase("NoRecord")); // Set no record message
			$EditRow = FALSE; // Update Failed
		} else {

			// Save old values
			$rsold = &$rs->fields;
			$this->LoadDbValues($rsold);
			$rsnew = array();

			// dbkey_counselor
			$this->dbkey_counselor->SetDbValueDef($rsnew, $this->dbkey_counselor->CurrentValue, NULL, $this->dbkey_counselor->ReadOnly);

			// create_date
			$this->create_date->SetDbValueDef($rsnew, ew_UnFormatDateTime($this->create_date->CurrentValue, 0), NULL, $this->create_date->ReadOnly);

			// case_notes
			$this->case_notes->SetDbValueDef($rsnew, $this->case_notes->CurrentValue, NULL, $this->case_notes->ReadOnly);

			// Call Row Updating event
			$bUpdateRow = $this->Row_Updating($rsold, $rsnew);
			if ($bUpdateRow) {
				$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
				if (count($rsnew) > 0)
					$EditRow = $this->Update($rsnew, "", $rsold);
				else
					$EditRow = TRUE; // No field to update
				$conn->raiseErrorFn = '';
				if ($EditRow) {
				}
			} else {
				if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

					// Use the message, do nothing
				} elseif ($this->CancelMessage <> "") {
					$this->setFailureMessage($this->CancelMessage);
					$this->CancelMessage = "";
				} else {
					$this->setFailureMessage($Language->Phrase("UpdateCancelled"));
				}
				$EditRow = FALSE;
			}
		}

		// Call Row_Updated event
		if ($EditRow)
			$this->Row_Updated($rsold, $rsnew);
		if ($EditRow) {
			$this->WriteAuditTrailOnEdit($rsold, $rsnew);
		}
		$rs->Close();
		return $EditRow;
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, $this->AddMasterUrl("Cust_case_notes_adminlist.php"), "", $this->TableVar, TRUE);
		$PageId = "edit";
		$Breadcrumb->Add("edit", $PageId, $url);
	}

	// Setup lookup filters of a field
	function SetupLookupFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		case "x_counselor":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT DISTINCT (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor) AS `LinkFld`, (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `case_notes`";
			$sWhereWrk = "";
			$this->counselor->LookupFilters = array();
			if (!$GLOBALS["Cust_case_notes_admin"]->UserIDAllow("edit")) $sWhereWrk = $GLOBALS["case_notes"]->AddUserIDFilter($sWhereWrk);
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '(SELECT Concat(Concat(counselor.last, \' , \'), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor) = {filter_value}', "t0" => "200", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->counselor, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		case "x_dbkey_counselor":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT DISTINCT `dbkey_counselor` AS `LinkFld`, (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `case_notes`";
			$sWhereWrk = "";
			$this->dbkey_counselor->LookupFilters = array();
			if (!$GLOBALS["Cust_case_notes_admin"]->UserIDAllow("edit")) $sWhereWrk = $GLOBALS["case_notes"]->AddUserIDFilter($sWhereWrk);
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey_counselor` = {filter_value}', "t0" => "3", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->dbkey_counselor, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		}
	}

	// Setup AutoSuggest filters of a field
	function SetupAutoSuggestFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Write Audit Trail start/end for grid update
	function WriteAuditTrailDummy($typ) {
		$table = 'Cust_case_notes_admin';
		$usr = CurrentUserID();
		ew_WriteAuditTrail("log", ew_StdCurrentDateTime(), ew_ScriptName(), $usr, $typ, $table, "", "", "", "");
	}

	// Write Audit Trail (edit page)
	function WriteAuditTrailOnEdit(&$rsold, &$rsnew) {
		global $Language;
		if (!$this->AuditTrailOnEdit) return;
		$table = 'Cust_case_notes_admin';

		// Get key value
		$key = "";
		if ($key <> "") $key .= $GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"];
		$key .= $rsold['dbkey'];

		// Write Audit Trail
		$dt = ew_StdCurrentDateTime();
		$id = ew_ScriptName();
		$usr = CurrentUserID();
		foreach (array_keys($rsnew) as $fldname) {
			if ($this->fields[$fldname]->FldDataType <> EW_DATATYPE_BLOB) { // Ignore BLOB fields
				if ($this->fields[$fldname]->FldDataType == EW_DATATYPE_DATE) { // DateTime field
					$modified = (ew_FormatDateTime($rsold[$fldname], 0) <> ew_FormatDateTime($rsnew[$fldname], 0));
				} else {
					$modified = !ew_CompareValue($rsold[$fldname], $rsnew[$fldname]);
				}
				if ($modified) {
					if ($this->fields[$fldname]->FldHtmlTag == "PASSWORD") { // Password Field
						$oldvalue = $Language->Phrase("PasswordMask");
						$newvalue = $Language->Phrase("PasswordMask");
					} elseif ($this->fields[$fldname]->FldDataType == EW_DATATYPE_MEMO) { // Memo field
						if (EW_AUDIT_TRAIL_TO_DATABASE) {
							$oldvalue = $rsold[$fldname];
							$newvalue = $rsnew[$fldname];
						} else {
							$oldvalue = "[MEMO]";
							$newvalue = "[MEMO]";
						}
					} elseif ($this->fields[$fldname]->FldDataType == EW_DATATYPE_XML) { // XML field
						$oldvalue = "[XML]";
						$newvalue = "[XML]";
					} else {
						$oldvalue = $rsold[$fldname];
						$newvalue = $rsnew[$fldname];
					}
					ew_WriteAuditTrail("log", $dt, $id, $usr, "U", $table, $fldname, $key, $oldvalue, $newvalue);
				}
			}
		}
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($Cust_case_notes_admin_edit)) $Cust_case_notes_admin_edit = new cCust_case_notes_admin_edit();

// Page init
$Cust_case_notes_admin_edit->Page_Init();

// Page main
$Cust_case_notes_admin_edit->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$Cust_case_notes_admin_edit->Page_Render();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "edit";
var CurrentForm = fCust_case_notes_adminedit = new ew_Form("fCust_case_notes_adminedit", "edit");

// Validate form
fCust_case_notes_adminedit.Validate = function() {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	var $ = jQuery, fobj = this.GetForm(), $fobj = $(fobj);
	if ($fobj.find("#a_confirm").val() == "F")
		return true;
	var elm, felm, uelm, addcnt = 0;
	var $k = $fobj.find("#" + this.FormKeyCountName); // Get key_count
	var rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1;
	var startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
	var gridinsert = $fobj.find("#a_list").val() == "gridinsert";
	for (var i = startcnt; i <= rowcnt; i++) {
		var infix = ($k[0]) ? String(i) : "";
		$fobj.data("rowindex", infix);
			elm = this.GetElements("x" + infix + "_dbkey_counselor");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $Cust_case_notes_admin->dbkey_counselor->FldCaption(), $Cust_case_notes_admin->dbkey_counselor->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_create_date");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $Cust_case_notes_admin->create_date->FldCaption(), $Cust_case_notes_admin->create_date->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_create_date");
			if (elm && !ew_CheckDateDef(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($Cust_case_notes_admin->create_date->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_case_notes");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $Cust_case_notes_admin->case_notes->FldCaption(), $Cust_case_notes_admin->case_notes->ReqErrMsg)) ?>");

			// Fire Form_CustomValidate event
			if (!this.Form_CustomValidate(fobj))
				return false;
	}

	// Process detail forms
	var dfs = $fobj.find("input[name='detailpage']").get();
	for (var i = 0; i < dfs.length; i++) {
		var df = dfs[i], val = df.value;
		if (val && ewForms[val])
			if (!ewForms[val].Validate())
				return false;
	}
	return true;
}

// Form_CustomValidate event
fCust_case_notes_adminedit.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fCust_case_notes_adminedit.ValidateRequired = true;
<?php } else { ?>
fCust_case_notes_adminedit.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fCust_case_notes_adminedit.Lists["x_counselor"] = {"LinkField":"x_counselor","Ajax":true,"AutoFill":false,"DisplayFields":["x_counselor","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"case_notes"};
fCust_case_notes_adminedit.Lists["x_dbkey_counselor"] = {"LinkField":"x_dbkey_counselor","Ajax":true,"AutoFill":false,"DisplayFields":["x_counselor","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"case_notes"};

// Form object for search
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php if (!$Cust_case_notes_admin_edit->IsModal) { ?>
<div class="ewToolbar">
<?php $Breadcrumb->Render(); ?>
<?php echo $Language->SelectionForm(); ?>
<div class="clearfix"></div>
</div>
<?php } ?>
<?php $Cust_case_notes_admin_edit->ShowPageHeader(); ?>
<?php
$Cust_case_notes_admin_edit->ShowMessage();
?>
<form name="fCust_case_notes_adminedit" id="fCust_case_notes_adminedit" class="<?php echo $Cust_case_notes_admin_edit->FormClassName ?>" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($Cust_case_notes_admin_edit->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $Cust_case_notes_admin_edit->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="Cust_case_notes_admin">
<input type="hidden" name="a_edit" id="a_edit" value="U">
<?php if ($Cust_case_notes_admin_edit->IsModal) { ?>
<input type="hidden" name="modal" value="1">
<?php } ?>
<div>
<?php if ($Cust_case_notes_admin->counselor->Visible) { // counselor ?>
	<div id="r_counselor" class="form-group">
		<label id="elh_Cust_case_notes_admin_counselor" for="x_counselor" class="col-sm-2 control-label ewLabel"><?php echo $Cust_case_notes_admin->counselor->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_case_notes_admin->counselor->CellAttributes() ?>>
<span id="el_Cust_case_notes_admin_counselor">
<select data-table="Cust_case_notes_admin" data-field="x_counselor" data-value-separator="<?php echo $Cust_case_notes_admin->counselor->DisplayValueSeparatorAttribute() ?>" id="x_counselor" name="x_counselor"<?php echo $Cust_case_notes_admin->counselor->EditAttributes() ?>>
<?php echo $Cust_case_notes_admin->counselor->SelectOptionListHtml("x_counselor") ?>
</select>
<input type="hidden" name="s_x_counselor" id="s_x_counselor" value="<?php echo $Cust_case_notes_admin->counselor->LookupFilterQuery() ?>">
</span>
<?php echo $Cust_case_notes_admin->counselor->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_case_notes_admin->dbkey_counselor->Visible) { // dbkey_counselor ?>
	<div id="r_dbkey_counselor" class="form-group">
		<label id="elh_Cust_case_notes_admin_dbkey_counselor" for="x_dbkey_counselor" class="col-sm-2 control-label ewLabel"><?php echo $Cust_case_notes_admin->dbkey_counselor->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_case_notes_admin->dbkey_counselor->CellAttributes() ?>>
<span id="el_Cust_case_notes_admin_dbkey_counselor">
<select data-table="Cust_case_notes_admin" data-field="x_dbkey_counselor" data-value-separator="<?php echo $Cust_case_notes_admin->dbkey_counselor->DisplayValueSeparatorAttribute() ?>" id="x_dbkey_counselor" name="x_dbkey_counselor"<?php echo $Cust_case_notes_admin->dbkey_counselor->EditAttributes() ?>>
<?php echo $Cust_case_notes_admin->dbkey_counselor->SelectOptionListHtml("x_dbkey_counselor") ?>
</select>
<input type="hidden" name="s_x_dbkey_counselor" id="s_x_dbkey_counselor" value="<?php echo $Cust_case_notes_admin->dbkey_counselor->LookupFilterQuery() ?>">
</span>
<?php echo $Cust_case_notes_admin->dbkey_counselor->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_case_notes_admin->create_date->Visible) { // create_date ?>
	<div id="r_create_date" class="form-group">
		<label id="elh_Cust_case_notes_admin_create_date" for="x_create_date" class="col-sm-2 control-label ewLabel"><?php echo $Cust_case_notes_admin->create_date->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_case_notes_admin->create_date->CellAttributes() ?>>
<span id="el_Cust_case_notes_admin_create_date">
<input type="text" data-table="Cust_case_notes_admin" data-field="x_create_date" name="x_create_date" id="x_create_date" placeholder="<?php echo ew_HtmlEncode($Cust_case_notes_admin->create_date->getPlaceHolder()) ?>" value="<?php echo $Cust_case_notes_admin->create_date->EditValue ?>"<?php echo $Cust_case_notes_admin->create_date->EditAttributes() ?>>
<?php if (!$Cust_case_notes_admin->create_date->ReadOnly && !$Cust_case_notes_admin->create_date->Disabled && !isset($Cust_case_notes_admin->create_date->EditAttrs["readonly"]) && !isset($Cust_case_notes_admin->create_date->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fCust_case_notes_adminedit", "x_create_date", 0);
</script>
<?php } ?>
</span>
<?php echo $Cust_case_notes_admin->create_date->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_case_notes_admin->case_notes->Visible) { // case_notes ?>
	<div id="r_case_notes" class="form-group">
		<label id="elh_Cust_case_notes_admin_case_notes" class="col-sm-2 control-label ewLabel"><?php echo $Cust_case_notes_admin->case_notes->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_case_notes_admin->case_notes->CellAttributes() ?>>
<span id="el_Cust_case_notes_admin_case_notes">
<?php ew_AppendClass($Cust_case_notes_admin->case_notes->EditAttrs["class"], "editor"); ?>
<textarea data-table="Cust_case_notes_admin" data-field="x_case_notes" name="x_case_notes" id="x_case_notes" cols="35" rows="4" placeholder="<?php echo ew_HtmlEncode($Cust_case_notes_admin->case_notes->getPlaceHolder()) ?>"<?php echo $Cust_case_notes_admin->case_notes->EditAttributes() ?>><?php echo $Cust_case_notes_admin->case_notes->EditValue ?></textarea>
<script type="text/javascript">
ew_CreateEditor("fCust_case_notes_adminedit", "x_case_notes", 35, 4, <?php echo ($Cust_case_notes_admin->case_notes->ReadOnly || FALSE) ? "true" : "false" ?>);
</script>
</span>
<?php echo $Cust_case_notes_admin->case_notes->CustomMsg ?></div></div>
	</div>
<?php } ?>
</div>
<input type="hidden" data-table="Cust_case_notes_admin" data-field="x_dbkey" name="x_dbkey" id="x_dbkey" value="<?php echo ew_HtmlEncode($Cust_case_notes_admin->dbkey->CurrentValue) ?>">
<?php if (!$Cust_case_notes_admin_edit->IsModal) { ?>
<div class="form-group">
	<div class="col-sm-offset-2 col-sm-10">
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit"><?php echo $Language->Phrase("SaveBtn") ?></button>
<button class="btn btn-default ewButton" name="btnCancel" id="btnCancel" type="button" data-href="<?php echo $Cust_case_notes_admin_edit->getReturnUrl() ?>"><?php echo $Language->Phrase("CancelBtn") ?></button>
	</div>
</div>
<?php } ?>
</form>
<script type="text/javascript">
fCust_case_notes_adminedit.Init();
</script>
<?php
$Cust_case_notes_admin_edit->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$Cust_case_notes_admin_edit->Page_Terminate();
?>
