<?php
if (session_id() == "") session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg12.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql12.php") ?>
<?php include_once "phpfn12.php" ?>
<?php include_once "Cust_task_viewinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn12.php" ?>
<?php

//
// Page class
//

$Cust_task_view_add = NULL; // Initialize page object first

class cCust_task_view_add extends cCust_task_view {

	// Page ID
	var $PageID = 'add';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'Cust_task_view';

	// Page object name
	var $PageObjName = 'Cust_task_view_add';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (Cust_task_view)
		if (!isset($GLOBALS["Cust_task_view"]) || get_class($GLOBALS["Cust_task_view"]) == "cCust_task_view") {
			$GLOBALS["Cust_task_view"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["Cust_task_view"];
		}

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'add', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'Cust_task_view', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanAdd()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage($Language->Phrase("NoPermission")); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("Cust_task_viewlist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Create form object
		$objForm = new cFormObj();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $Cust_task_view;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($Cust_task_view);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}
	var $FormClassName = "form-horizontal ewForm ewAddForm";
	var $DbMasterFilter = "";
	var $DbDetailFilter = "";
	var $StartRec;
	var $Priv = 0;
	var $OldRecordset;
	var $CopyRecord;

	// 
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError;

		// Process form if post back
		if (@$_POST["a_add"] <> "") {
			$this->CurrentAction = $_POST["a_add"]; // Get form action
			$this->CopyRecord = $this->LoadOldRecord(); // Load old recordset
			$this->LoadFormValues(); // Load form values
		} else { // Not post back

			// Load key values from QueryString
			$this->CopyRecord = TRUE;
			if (@$_GET["dbkey"] != "") {
				$this->dbkey->setQueryStringValue($_GET["dbkey"]);
				$this->setKey("dbkey", $this->dbkey->CurrentValue); // Set up key
			} else {
				$this->setKey("dbkey", ""); // Clear key
				$this->CopyRecord = FALSE;
			}
			if ($this->CopyRecord) {
				$this->CurrentAction = "C"; // Copy record
			} else {
				$this->CurrentAction = "I"; // Display blank record
				$this->LoadDefaultValues(); // Load default values
			}
		}

		// Set up Breadcrumb
		$this->SetupBreadcrumb();

		// Validate form if post back
		if (@$_POST["a_add"] <> "") {
			if (!$this->ValidateForm()) {
				$this->CurrentAction = "I"; // Form error, reset action
				$this->EventCancelled = TRUE; // Event cancelled
				$this->RestoreFormValues(); // Restore form values
				$this->setFailureMessage($gsFormError);
			}
		}

		// Perform action based on action code
		switch ($this->CurrentAction) {
			case "I": // Blank record, no action required
				break;
			case "C": // Copy an existing record
				if (!$this->LoadRow()) { // Load record based on key
					if ($this->getFailureMessage() == "") $this->setFailureMessage($Language->Phrase("NoRecord")); // No record found
					$this->Page_Terminate("Cust_task_viewlist.php"); // No matching record, return to list
				}
				break;
			case "A": // Add new record
				$this->SendEmail = TRUE; // Send email on add success
				if ($this->AddRow($this->OldRecordset)) { // Add successful
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage($Language->Phrase("AddSuccess")); // Set up success message
					$sReturnUrl = $this->getReturnUrl();
					if (ew_GetPageName($sReturnUrl) == "Cust_task_viewview.php")
						$sReturnUrl = $this->GetViewUrl(); // View paging, return to view page with keyurl directly
					$this->Page_Terminate($sReturnUrl); // Clean up and return
				} else {
					$this->EventCancelled = TRUE; // Event cancelled
					$this->RestoreFormValues(); // Add failed, restore form values
				}
		}

		// Render row based on row type
		$this->RowType = EW_ROWTYPE_ADD; // Render add type

		// Render row
		$this->ResetAttrs();
		$this->RenderRow();
	}

	// Get upload files
	function GetUploadFiles() {
		global $objForm, $Language;

		// Get upload data
	}

	// Load default values
	function LoadDefaultValues() {
		$this->dbkey_counciler_from->CurrentValue = 0;
		$this->dbkey_counciler_to->CurrentValue = 0;
		$this->task_description->CurrentValue = NULL;
		$this->task_description->OldValue = $this->task_description->CurrentValue;
		$this->date_requested->CurrentValue = NULL;
		$this->date_requested->OldValue = $this->date_requested->CurrentValue;
		$this->approve->CurrentValue = 0;
	}

	// Load form values
	function LoadFormValues() {

		// Load from form
		global $objForm;
		if (!$this->dbkey_counciler_from->FldIsDetailKey) {
			$this->dbkey_counciler_from->setFormValue($objForm->GetValue("x_dbkey_counciler_from"));
		}
		if (!$this->dbkey_counciler_to->FldIsDetailKey) {
			$this->dbkey_counciler_to->setFormValue($objForm->GetValue("x_dbkey_counciler_to"));
		}
		if (!$this->task_description->FldIsDetailKey) {
			$this->task_description->setFormValue($objForm->GetValue("x_task_description"));
		}
		if (!$this->date_requested->FldIsDetailKey) {
			$this->date_requested->setFormValue($objForm->GetValue("x_date_requested"));
			$this->date_requested->CurrentValue = ew_UnFormatDateTime($this->date_requested->CurrentValue, 5);
		}
		if (!$this->approve->FldIsDetailKey) {
			$this->approve->setFormValue($objForm->GetValue("x_approve"));
		}
	}

	// Restore form values
	function RestoreFormValues() {
		global $objForm;
		$this->LoadOldRecord();
		$this->dbkey_counciler_from->CurrentValue = $this->dbkey_counciler_from->FormValue;
		$this->dbkey_counciler_to->CurrentValue = $this->dbkey_counciler_to->FormValue;
		$this->task_description->CurrentValue = $this->task_description->FormValue;
		$this->date_requested->CurrentValue = $this->date_requested->FormValue;
		$this->date_requested->CurrentValue = ew_UnFormatDateTime($this->date_requested->CurrentValue, 5);
		$this->approve->CurrentValue = $this->approve->FormValue;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->approved_by->setDbValue($rs->fields('approved_by'));
		$this->date_approved->setDbValue($rs->fields('date_approved'));
		$this->dbkey_counciler_from->setDbValue($rs->fields('dbkey_counciler_from'));
		$this->dbkey_counciler_to->setDbValue($rs->fields('dbkey_counciler_to'));
		$this->task_description->setDbValue($rs->fields('task_description'));
		$this->task_response->setDbValue($rs->fields('task_response'));
		$this->date_requested->setDbValue($rs->fields('date_requested'));
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->approve->setDbValue($rs->fields('approve'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->approved_by->DbValue = $row['approved_by'];
		$this->date_approved->DbValue = $row['date_approved'];
		$this->dbkey_counciler_from->DbValue = $row['dbkey_counciler_from'];
		$this->dbkey_counciler_to->DbValue = $row['dbkey_counciler_to'];
		$this->task_description->DbValue = $row['task_description'];
		$this->task_response->DbValue = $row['task_response'];
		$this->date_requested->DbValue = $row['date_requested'];
		$this->dbkey->DbValue = $row['dbkey'];
		$this->approve->DbValue = $row['approve'];
	}

	// Load old record
	function LoadOldRecord() {

		// Load key values from Session
		$bValidKey = TRUE;
		if (strval($this->getKey("dbkey")) <> "")
			$this->dbkey->CurrentValue = $this->getKey("dbkey"); // dbkey
		else
			$bValidKey = FALSE;

		// Load old recordset
		if ($bValidKey) {
			$this->CurrentFilter = $this->KeyFilter();
			$sSql = $this->SQL();
			$conn = &$this->Connection();
			$this->OldRecordset = ew_LoadRecordset($sSql, $conn);
			$this->LoadRowValues($this->OldRecordset); // Load row values
		} else {
			$this->OldRecordset = NULL;
		}
		return $bValidKey;
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Call Row_Rendering event

		$this->Row_Rendering();

		// Common render codes for all row types
		// approved_by
		// date_approved
		// dbkey_counciler_from
		// dbkey_counciler_to
		// task_description
		// task_response
		// date_requested
		// dbkey
		// approve

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// date_approved
		$this->date_approved->ViewValue = $this->date_approved->CurrentValue;
		$this->date_approved->ViewCustomAttributes = "";

		// dbkey_counciler_from
		if (strval($this->dbkey_counciler_from->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_counciler_from->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_counciler_from, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_counciler_from->ViewValue = $this->dbkey_counciler_from->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_counciler_from->ViewValue = $this->dbkey_counciler_from->CurrentValue;
			}
		} else {
			$this->dbkey_counciler_from->ViewValue = NULL;
		}
		$this->dbkey_counciler_from->ViewCustomAttributes = "";

		// dbkey_counciler_to
		if (strval($this->dbkey_counciler_to->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_counciler_to->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_counciler_to, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_counciler_to->ViewValue = $this->dbkey_counciler_to->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_counciler_to->ViewValue = $this->dbkey_counciler_to->CurrentValue;
			}
		} else {
			$this->dbkey_counciler_to->ViewValue = NULL;
		}
		$this->dbkey_counciler_to->ViewCustomAttributes = "";

		// task_description
		$this->task_description->ViewValue = $this->task_description->CurrentValue;
		$this->task_description->ViewCustomAttributes = "";

		// date_requested
		$this->date_requested->ViewValue = $this->date_requested->CurrentValue;
		$this->date_requested->ViewValue = ew_FormatDateTime($this->date_requested->ViewValue, 5);
		$this->date_requested->ViewCustomAttributes = "";

		// dbkey
		$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// approve
		$this->approve->ViewValue = $this->approve->CurrentValue;
		$this->approve->ViewCustomAttributes = "";

			// dbkey_counciler_from
			$this->dbkey_counciler_from->LinkCustomAttributes = "";
			$this->dbkey_counciler_from->HrefValue = "";
			$this->dbkey_counciler_from->TooltipValue = "";

			// dbkey_counciler_to
			$this->dbkey_counciler_to->LinkCustomAttributes = "";
			$this->dbkey_counciler_to->HrefValue = "";
			$this->dbkey_counciler_to->TooltipValue = "";

			// task_description
			$this->task_description->LinkCustomAttributes = "";
			$this->task_description->HrefValue = "";
			$this->task_description->TooltipValue = "";

			// date_requested
			$this->date_requested->LinkCustomAttributes = "";
			$this->date_requested->HrefValue = "";
			$this->date_requested->TooltipValue = "";

			// approve
			$this->approve->LinkCustomAttributes = "";
			$this->approve->HrefValue = "";
			$this->approve->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_ADD) { // Add row

			// dbkey_counciler_from
			// dbkey_counciler_to

			$this->dbkey_counciler_to->EditAttrs["class"] = "form-control";
			$this->dbkey_counciler_to->EditCustomAttributes = "";
			if (trim(strval($this->dbkey_counciler_to->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_counciler_to->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `counselor`";
			$sWhereWrk = "";
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			if (!$GLOBALS["Cust_task_view"]->UserIDAllow("add")) $sWhereWrk = $GLOBALS["counselor"]->AddUserIDFilter($sWhereWrk);
			$this->Lookup_Selecting($this->dbkey_counciler_to, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect"), "", "", "", "", "", "", ""));
			$this->dbkey_counciler_to->EditValue = $arwrk;

			// task_description
			$this->task_description->EditAttrs["class"] = "form-control";
			$this->task_description->EditCustomAttributes = "";
			$this->task_description->EditValue = ew_HtmlEncode($this->task_description->CurrentValue);
			$this->task_description->PlaceHolder = ew_RemoveHtml($this->task_description->FldCaption());

			// date_requested
			$this->date_requested->EditAttrs["class"] = "form-control";
			$this->date_requested->EditCustomAttributes = "";
			$this->date_requested->EditValue = ew_HtmlEncode(ew_FormatDateTime($this->date_requested->CurrentValue, 5));
			$this->date_requested->PlaceHolder = ew_RemoveHtml($this->date_requested->FldCaption());

			// approve
			$this->approve->EditAttrs["class"] = "form-control";
			$this->approve->EditCustomAttributes = "";
			$this->approve->EditValue = ew_HtmlEncode($this->approve->CurrentValue);
			$this->approve->PlaceHolder = ew_RemoveHtml($this->approve->FldCaption());

			// Edit refer script
			// dbkey_counciler_from

			$this->dbkey_counciler_from->HrefValue = "";

			// dbkey_counciler_to
			$this->dbkey_counciler_to->HrefValue = "";

			// task_description
			$this->task_description->HrefValue = "";

			// date_requested
			$this->date_requested->HrefValue = "";

			// approve
			$this->approve->HrefValue = "";
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate form
	function ValidateForm() {
		global $Language, $gsFormError;

		// Initialize form error message
		$gsFormError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return ($gsFormError == "");
		if (!$this->dbkey_counciler_to->FldIsDetailKey && !is_null($this->dbkey_counciler_to->FormValue) && $this->dbkey_counciler_to->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->dbkey_counciler_to->FldCaption(), $this->dbkey_counciler_to->ReqErrMsg));
		}
		if (!$this->task_description->FldIsDetailKey && !is_null($this->task_description->FormValue) && $this->task_description->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->task_description->FldCaption(), $this->task_description->ReqErrMsg));
		}
		if (!$this->date_requested->FldIsDetailKey && !is_null($this->date_requested->FormValue) && $this->date_requested->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->date_requested->FldCaption(), $this->date_requested->ReqErrMsg));
		}
		if (!ew_CheckTime($this->date_requested->FormValue)) {
			ew_AddMessage($gsFormError, $this->date_requested->FldErrMsg());
		}
		if (!ew_CheckInteger($this->approve->FormValue)) {
			ew_AddMessage($gsFormError, $this->approve->FldErrMsg());
		}

		// Return validate result
		$ValidateForm = ($gsFormError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateForm = $ValidateForm && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsFormError, $sFormCustomError);
		}
		return $ValidateForm;
	}

	// Add record
	function AddRow($rsold = NULL) {
		global $Language, $Security;
		$conn = &$this->Connection();

		// Load db values from rsold
		if ($rsold) {
			$this->LoadDbValues($rsold);
		}
		$rsnew = array();

		// dbkey_counciler_from
		$this->dbkey_counciler_from->SetDbValueDef($rsnew, CurrentUserName(), 0);
		$rsnew['dbkey_counciler_from'] = &$this->dbkey_counciler_from->DbValue;

		// dbkey_counciler_to
		$this->dbkey_counciler_to->SetDbValueDef($rsnew, $this->dbkey_counciler_to->CurrentValue, 0, strval($this->dbkey_counciler_to->CurrentValue) == "");

		// task_description
		$this->task_description->SetDbValueDef($rsnew, $this->task_description->CurrentValue, "", FALSE);

		// date_requested
		$this->date_requested->SetDbValueDef($rsnew, ew_UnFormatDateTime($this->date_requested->CurrentValue, 5), NULL, FALSE);

		// approve
		$this->approve->SetDbValueDef($rsnew, $this->approve->CurrentValue, NULL, strval($this->approve->CurrentValue) == "");

		// Call Row Inserting event
		$rs = ($rsold == NULL) ? NULL : $rsold->fields;
		$bInsertRow = $this->Row_Inserting($rs, $rsnew);
		if ($bInsertRow) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			$AddRow = $this->Insert($rsnew);
			$conn->raiseErrorFn = '';
			if ($AddRow) {

				// Get insert id if necessary
				$this->dbkey->setDbValue($conn->Insert_ID());
				$rsnew['dbkey'] = $this->dbkey->DbValue;
			}
		} else {
			if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

				// Use the message, do nothing
			} elseif ($this->CancelMessage <> "") {
				$this->setFailureMessage($this->CancelMessage);
				$this->CancelMessage = "";
			} else {
				$this->setFailureMessage($Language->Phrase("InsertCancelled"));
			}
			$AddRow = FALSE;
		}
		if ($AddRow) {

			// Call Row Inserted event
			$rs = ($rsold == NULL) ? NULL : $rsold->fields;
			$this->Row_Inserted($rs, $rsnew);
		}
		return $AddRow;
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, "Cust_task_viewlist.php", "", $this->TableVar, TRUE);
		$PageId = ($this->CurrentAction == "C") ? "Copy" : "Add";
		$Breadcrumb->Add("add", $PageId, $url);
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($Cust_task_view_add)) $Cust_task_view_add = new cCust_task_view_add();

// Page init
$Cust_task_view_add->Page_Init();

// Page main
$Cust_task_view_add->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$Cust_task_view_add->Page_Render();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "add";
var CurrentForm = fCust_task_viewadd = new ew_Form("fCust_task_viewadd", "add");

// Validate form
fCust_task_viewadd.Validate = function() {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	var $ = jQuery, fobj = this.GetForm(), $fobj = $(fobj);
	if ($fobj.find("#a_confirm").val() == "F")
		return true;
	var elm, felm, uelm, addcnt = 0;
	var $k = $fobj.find("#" + this.FormKeyCountName); // Get key_count
	var rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1;
	var startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
	var gridinsert = $fobj.find("#a_list").val() == "gridinsert";
	for (var i = startcnt; i <= rowcnt; i++) {
		var infix = ($k[0]) ? String(i) : "";
		$fobj.data("rowindex", infix);
			elm = this.GetElements("x" + infix + "_dbkey_counciler_to");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $Cust_task_view->dbkey_counciler_to->FldCaption(), $Cust_task_view->dbkey_counciler_to->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_task_description");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $Cust_task_view->task_description->FldCaption(), $Cust_task_view->task_description->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_date_requested");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $Cust_task_view->date_requested->FldCaption(), $Cust_task_view->date_requested->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_date_requested");
			if (elm && !ew_CheckTime(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($Cust_task_view->date_requested->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_approve");
			if (elm && !ew_CheckInteger(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($Cust_task_view->approve->FldErrMsg()) ?>");

			// Fire Form_CustomValidate event
			if (!this.Form_CustomValidate(fobj))
				return false;
	}

	// Process detail forms
	var dfs = $fobj.find("input[name='detailpage']").get();
	for (var i = 0; i < dfs.length; i++) {
		var df = dfs[i], val = df.value;
		if (val && ewForms[val])
			if (!ewForms[val].Validate())
				return false;
	}
	return true;
}

// Form_CustomValidate event
fCust_task_viewadd.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fCust_task_viewadd.ValidateRequired = true;
<?php } else { ?>
fCust_task_viewadd.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fCust_task_viewadd.Lists["x_dbkey_counciler_from"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
fCust_task_viewadd.Lists["x_dbkey_counciler_to"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};

// Form object for search
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<div class="ewToolbar">
<?php $Breadcrumb->Render(); ?>
<?php echo $Language->SelectionForm(); ?>
<div class="clearfix"></div>
</div>
<?php $Cust_task_view_add->ShowPageHeader(); ?>
<?php
$Cust_task_view_add->ShowMessage();
?>
<form name="fCust_task_viewadd" id="fCust_task_viewadd" class="<?php echo $Cust_task_view_add->FormClassName ?>" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($Cust_task_view_add->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $Cust_task_view_add->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="Cust_task_view">
<input type="hidden" name="a_add" id="a_add" value="A">
<div>
<?php if ($Cust_task_view->dbkey_counciler_to->Visible) { // dbkey_counciler_to ?>
	<div id="r_dbkey_counciler_to" class="form-group">
		<label id="elh_Cust_task_view_dbkey_counciler_to" for="x_dbkey_counciler_to" class="col-sm-2 control-label ewLabel"><?php echo $Cust_task_view->dbkey_counciler_to->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_task_view->dbkey_counciler_to->CellAttributes() ?>>
<span id="el_Cust_task_view_dbkey_counciler_to">
<select data-table="Cust_task_view" data-field="x_dbkey_counciler_to" data-value-separator="<?php echo ew_HtmlEncode(is_array($Cust_task_view->dbkey_counciler_to->DisplayValueSeparator) ? json_encode($Cust_task_view->dbkey_counciler_to->DisplayValueSeparator) : $Cust_task_view->dbkey_counciler_to->DisplayValueSeparator) ?>" id="x_dbkey_counciler_to" name="x_dbkey_counciler_to"<?php echo $Cust_task_view->dbkey_counciler_to->EditAttributes() ?>>
<?php
if (is_array($Cust_task_view->dbkey_counciler_to->EditValue)) {
	$arwrk = $Cust_task_view->dbkey_counciler_to->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = ew_SameStr($Cust_task_view->dbkey_counciler_to->CurrentValue, $arwrk[$rowcntwrk][0]) ? " selected" : "";
		if ($selwrk <> "") $emptywrk = FALSE;		
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $Cust_task_view->dbkey_counciler_to->DisplayValue($arwrk[$rowcntwrk]) ?>
</option>
<?php
	}
	if ($emptywrk && strval($Cust_task_view->dbkey_counciler_to->CurrentValue) <> "") {
?>
<option value="<?php echo ew_HtmlEncode($Cust_task_view->dbkey_counciler_to->CurrentValue) ?>" selected><?php echo $Cust_task_view->dbkey_counciler_to->CurrentValue ?></option>
<?php
    }
}
?>
</select>
<?php
$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
$sWhereWrk = "";
if (!$GLOBALS["Cust_task_view"]->UserIDAllow("add")) $sWhereWrk = $GLOBALS["counselor"]->AddUserIDFilter($sWhereWrk);
$Cust_task_view->dbkey_counciler_to->LookupFilters = array("s" => $sSqlWrk, "d" => "");
$Cust_task_view->dbkey_counciler_to->LookupFilters += array("f0" => "`dbkey` = {filter_value}", "t0" => "3", "fn0" => "");
$sSqlWrk = "";
$Cust_task_view->Lookup_Selecting($Cust_task_view->dbkey_counciler_to, $sWhereWrk); // Call Lookup selecting
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
if ($sSqlWrk <> "") $Cust_task_view->dbkey_counciler_to->LookupFilters["s"] .= $sSqlWrk;
?>
<input type="hidden" name="s_x_dbkey_counciler_to" id="s_x_dbkey_counciler_to" value="<?php echo $Cust_task_view->dbkey_counciler_to->LookupFilterQuery() ?>">
</span>
<?php echo $Cust_task_view->dbkey_counciler_to->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_task_view->task_description->Visible) { // task_description ?>
	<div id="r_task_description" class="form-group">
		<label id="elh_Cust_task_view_task_description" class="col-sm-2 control-label ewLabel"><?php echo $Cust_task_view->task_description->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_task_view->task_description->CellAttributes() ?>>
<span id="el_Cust_task_view_task_description">
<?php ew_AppendClass($Cust_task_view->task_description->EditAttrs["class"], "editor"); ?>
<textarea data-table="Cust_task_view" data-field="x_task_description" name="x_task_description" id="x_task_description" cols="35" rows="4" placeholder="<?php echo ew_HtmlEncode($Cust_task_view->task_description->getPlaceHolder()) ?>"<?php echo $Cust_task_view->task_description->EditAttributes() ?>><?php echo $Cust_task_view->task_description->EditValue ?></textarea>
<script type="text/javascript">
ew_CreateEditor("fCust_task_viewadd", "x_task_description", 35, 4, <?php echo ($Cust_task_view->task_description->ReadOnly || FALSE) ? "true" : "false" ?>);
</script>
</span>
<?php echo $Cust_task_view->task_description->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_task_view->date_requested->Visible) { // date_requested ?>
	<div id="r_date_requested" class="form-group">
		<label id="elh_Cust_task_view_date_requested" for="x_date_requested" class="col-sm-2 control-label ewLabel"><?php echo $Cust_task_view->date_requested->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_task_view->date_requested->CellAttributes() ?>>
<span id="el_Cust_task_view_date_requested">
<input type="text" data-table="Cust_task_view" data-field="x_date_requested" data-format="5" name="x_date_requested" id="x_date_requested" size="30" placeholder="<?php echo ew_HtmlEncode($Cust_task_view->date_requested->getPlaceHolder()) ?>" value="<?php echo $Cust_task_view->date_requested->EditValue ?>"<?php echo $Cust_task_view->date_requested->EditAttributes() ?>>
</span>
<?php echo $Cust_task_view->date_requested->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_task_view->approve->Visible) { // approve ?>
	<div id="r_approve" class="form-group">
		<label id="elh_Cust_task_view_approve" for="x_approve" class="col-sm-2 control-label ewLabel"><?php echo $Cust_task_view->approve->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_task_view->approve->CellAttributes() ?>>
<span id="el_Cust_task_view_approve">
<input type="text" data-table="Cust_task_view" data-field="x_approve" name="x_approve" id="x_approve" size="30" placeholder="<?php echo ew_HtmlEncode($Cust_task_view->approve->getPlaceHolder()) ?>" value="<?php echo $Cust_task_view->approve->EditValue ?>"<?php echo $Cust_task_view->approve->EditAttributes() ?>>
</span>
<?php echo $Cust_task_view->approve->CustomMsg ?></div></div>
	</div>
<?php } ?>
</div>
<div class="form-group">
	<div class="col-sm-offset-2 col-sm-10">
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit"><?php echo $Language->Phrase("AddBtn") ?></button>
<button class="btn btn-default ewButton" name="btnCancel" id="btnCancel" type="button" data-href="<?php echo $Cust_task_view_add->getReturnUrl() ?>"><?php echo $Language->Phrase("CancelBtn") ?></button>
	</div>
</div>
</form>
<script type="text/javascript">
fCust_task_viewadd.Init();
</script>
<?php
$Cust_task_view_add->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$Cust_task_view_add->Page_Terminate();
?>
