<?php
if (session_id() == "") session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg12.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql12.php") ?>
<?php include_once "phpfn12.php" ?>
<?php include_once "Cust_task_viewinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn12.php" ?>
<?php

//
// Page class
//

$Cust_task_view_edit = NULL; // Initialize page object first

class cCust_task_view_edit extends cCust_task_view {

	// Page ID
	var $PageID = 'edit';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'Cust_task_view';

	// Page object name
	var $PageObjName = 'Cust_task_view_edit';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (Cust_task_view)
		if (!isset($GLOBALS["Cust_task_view"]) || get_class($GLOBALS["Cust_task_view"]) == "cCust_task_view") {
			$GLOBALS["Cust_task_view"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["Cust_task_view"];
		}

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'edit', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'Cust_task_view', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanEdit()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage($Language->Phrase("NoPermission")); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("Cust_task_viewlist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Create form object
		$objForm = new cFormObj();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $Cust_task_view;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($Cust_task_view);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}
	var $FormClassName = "form-horizontal ewForm ewEditForm";
	var $DbMasterFilter;
	var $DbDetailFilter;

	// 
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError;

		// Load key from QueryString
		if (@$_GET["dbkey"] <> "") {
			$this->dbkey->setQueryStringValue($_GET["dbkey"]);
		}

		// Set up Breadcrumb
		$this->SetupBreadcrumb();

		// Process form if post back
		if (@$_POST["a_edit"] <> "") {
			$this->CurrentAction = $_POST["a_edit"]; // Get action code
			$this->LoadFormValues(); // Get form values
		} else {
			$this->CurrentAction = "I"; // Default action is display
		}

		// Check if valid key
		if ($this->dbkey->CurrentValue == "")
			$this->Page_Terminate("Cust_task_viewlist.php"); // Invalid key, return to list

		// Validate form if post back
		if (@$_POST["a_edit"] <> "") {
			if (!$this->ValidateForm()) {
				$this->CurrentAction = ""; // Form error, reset action
				$this->setFailureMessage($gsFormError);
				$this->EventCancelled = TRUE; // Event cancelled
				$this->RestoreFormValues();
			}
		}
		switch ($this->CurrentAction) {
			case "I": // Get a record to display
				if (!$this->LoadRow()) { // Load record based on key
					if ($this->getFailureMessage() == "") $this->setFailureMessage($Language->Phrase("NoRecord")); // No record found
					$this->Page_Terminate("Cust_task_viewlist.php"); // No matching record, return to list
				}
				break;
			Case "U": // Update
				$sReturnUrl = $this->getReturnUrl();
				$this->SendEmail = TRUE; // Send email on update success
				if ($this->EditRow()) { // Update record based on key
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage($Language->Phrase("UpdateSuccess")); // Update success
					$this->Page_Terminate($sReturnUrl); // Return to caller
				} elseif ($this->getFailureMessage() == $Language->Phrase("NoRecord")) {
					$this->Page_Terminate($sReturnUrl); // Return to caller
				} else {
					$this->EventCancelled = TRUE; // Event cancelled
					$this->RestoreFormValues(); // Restore form values if update failed
				}
		}

		// Render the record
		$this->RowType = EW_ROWTYPE_EDIT; // Render as Edit
		$this->ResetAttrs();
		$this->RenderRow();
	}

	// Set up starting record parameters
	function SetUpStartRec() {
		if ($this->DisplayRecs == 0)
			return;
		if ($this->IsPageRequest()) { // Validate request
			if (@$_GET[EW_TABLE_START_REC] <> "") { // Check for "start" parameter
				$this->StartRec = $_GET[EW_TABLE_START_REC];
				$this->setStartRecordNumber($this->StartRec);
			} elseif (@$_GET[EW_TABLE_PAGE_NO] <> "") {
				$PageNo = $_GET[EW_TABLE_PAGE_NO];
				if (is_numeric($PageNo)) {
					$this->StartRec = ($PageNo-1)*$this->DisplayRecs+1;
					if ($this->StartRec <= 0) {
						$this->StartRec = 1;
					} elseif ($this->StartRec >= intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1) {
						$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1;
					}
					$this->setStartRecordNumber($this->StartRec);
				}
			}
		}
		$this->StartRec = $this->getStartRecordNumber();

		// Check if correct start record counter
		if (!is_numeric($this->StartRec) || $this->StartRec == "") { // Avoid invalid start record counter
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} elseif (intval($this->StartRec) > intval($this->TotalRecs)) { // Avoid starting record > total records
			$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to last page first record
			$this->setStartRecordNumber($this->StartRec);
		} elseif (($this->StartRec-1) % $this->DisplayRecs <> 0) {
			$this->StartRec = intval(($this->StartRec-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to page boundary
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Get upload files
	function GetUploadFiles() {
		global $objForm, $Language;

		// Get upload data
	}

	// Load form values
	function LoadFormValues() {

		// Load from form
		global $objForm;
		if (!$this->approved_by->FldIsDetailKey) {
			$this->approved_by->setFormValue($objForm->GetValue("x_approved_by"));
		}
		if (!$this->date_approved->FldIsDetailKey) {
			$this->date_approved->setFormValue($objForm->GetValue("x_date_approved"));
			$this->date_approved->CurrentValue = ew_UnFormatDateTime($this->date_approved->CurrentValue, 0);
		}
		if (!$this->dbkey_counciler_from->FldIsDetailKey) {
			$this->dbkey_counciler_from->setFormValue($objForm->GetValue("x_dbkey_counciler_from"));
		}
		if (!$this->dbkey_counciler_to->FldIsDetailKey) {
			$this->dbkey_counciler_to->setFormValue($objForm->GetValue("x_dbkey_counciler_to"));
		}
		if (!$this->task_description->FldIsDetailKey) {
			$this->task_description->setFormValue($objForm->GetValue("x_task_description"));
		}
		if (!$this->task_response->FldIsDetailKey) {
			$this->task_response->setFormValue($objForm->GetValue("x_task_response"));
		}
		if (!$this->date_requested->FldIsDetailKey) {
			$this->date_requested->setFormValue($objForm->GetValue("x_date_requested"));
			$this->date_requested->CurrentValue = ew_UnFormatDateTime($this->date_requested->CurrentValue, 5);
		}
		if (!$this->dbkey->FldIsDetailKey)
			$this->dbkey->setFormValue($objForm->GetValue("x_dbkey"));
	}

	// Restore form values
	function RestoreFormValues() {
		global $objForm;
		$this->LoadRow();
		$this->dbkey->CurrentValue = $this->dbkey->FormValue;
		$this->approved_by->CurrentValue = $this->approved_by->FormValue;
		$this->date_approved->CurrentValue = $this->date_approved->FormValue;
		$this->date_approved->CurrentValue = ew_UnFormatDateTime($this->date_approved->CurrentValue, 0);
		$this->dbkey_counciler_from->CurrentValue = $this->dbkey_counciler_from->FormValue;
		$this->dbkey_counciler_to->CurrentValue = $this->dbkey_counciler_to->FormValue;
		$this->task_description->CurrentValue = $this->task_description->FormValue;
		$this->task_response->CurrentValue = $this->task_response->FormValue;
		$this->date_requested->CurrentValue = $this->date_requested->FormValue;
		$this->date_requested->CurrentValue = ew_UnFormatDateTime($this->date_requested->CurrentValue, 5);
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->approved_by->setDbValue($rs->fields('approved_by'));
		$this->date_approved->setDbValue($rs->fields('date_approved'));
		$this->dbkey_counciler_from->setDbValue($rs->fields('dbkey_counciler_from'));
		$this->dbkey_counciler_to->setDbValue($rs->fields('dbkey_counciler_to'));
		$this->task_description->setDbValue($rs->fields('task_description'));
		$this->task_response->setDbValue($rs->fields('task_response'));
		$this->date_requested->setDbValue($rs->fields('date_requested'));
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->approve->setDbValue($rs->fields('approve'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->approved_by->DbValue = $row['approved_by'];
		$this->date_approved->DbValue = $row['date_approved'];
		$this->dbkey_counciler_from->DbValue = $row['dbkey_counciler_from'];
		$this->dbkey_counciler_to->DbValue = $row['dbkey_counciler_to'];
		$this->task_description->DbValue = $row['task_description'];
		$this->task_response->DbValue = $row['task_response'];
		$this->date_requested->DbValue = $row['date_requested'];
		$this->dbkey->DbValue = $row['dbkey'];
		$this->approve->DbValue = $row['approve'];
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Call Row_Rendering event

		$this->Row_Rendering();

		// Common render codes for all row types
		// approved_by
		// date_approved
		// dbkey_counciler_from
		// dbkey_counciler_to
		// task_description
		// task_response
		// date_requested
		// dbkey
		// approve

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// approved_by
		if (strval($this->approved_by->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->approved_by->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->approved_by, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->approved_by->ViewValue = $this->approved_by->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->approved_by->ViewValue = $this->approved_by->CurrentValue;
			}
		} else {
			$this->approved_by->ViewValue = NULL;
		}
		$this->approved_by->ViewCustomAttributes = "";

		// date_approved
		$this->date_approved->ViewValue = $this->date_approved->CurrentValue;
		$this->date_approved->ViewCustomAttributes = "";

		// dbkey_counciler_from
		if (strval($this->dbkey_counciler_from->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_counciler_from->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_counciler_from, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_counciler_from->ViewValue = $this->dbkey_counciler_from->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_counciler_from->ViewValue = $this->dbkey_counciler_from->CurrentValue;
			}
		} else {
			$this->dbkey_counciler_from->ViewValue = NULL;
		}
		$this->dbkey_counciler_from->ViewCustomAttributes = "";

		// dbkey_counciler_to
		if (strval($this->dbkey_counciler_to->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_counciler_to->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_counciler_to, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_counciler_to->ViewValue = $this->dbkey_counciler_to->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_counciler_to->ViewValue = $this->dbkey_counciler_to->CurrentValue;
			}
		} else {
			$this->dbkey_counciler_to->ViewValue = NULL;
		}
		$this->dbkey_counciler_to->ViewCustomAttributes = "";

		// task_description
		$this->task_description->ViewValue = $this->task_description->CurrentValue;
		$this->task_description->ViewCustomAttributes = "";

		// task_response
		$this->task_response->ViewValue = $this->task_response->CurrentValue;
		$this->task_response->ViewCustomAttributes = "";

		// date_requested
		$this->date_requested->ViewValue = $this->date_requested->CurrentValue;
		$this->date_requested->ViewValue = ew_FormatDateTime($this->date_requested->ViewValue, 5);
		$this->date_requested->ViewCustomAttributes = "";

		// dbkey
		$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// approve
		$this->approve->ViewValue = $this->approve->CurrentValue;
		$this->approve->ViewCustomAttributes = "";

			// approved_by
			$this->approved_by->LinkCustomAttributes = "";
			$this->approved_by->HrefValue = "";
			$this->approved_by->TooltipValue = "";

			// date_approved
			$this->date_approved->LinkCustomAttributes = "";
			$this->date_approved->HrefValue = "";
			$this->date_approved->TooltipValue = "";

			// dbkey_counciler_from
			$this->dbkey_counciler_from->LinkCustomAttributes = "";
			$this->dbkey_counciler_from->HrefValue = "";
			$this->dbkey_counciler_from->TooltipValue = "";

			// dbkey_counciler_to
			$this->dbkey_counciler_to->LinkCustomAttributes = "";
			$this->dbkey_counciler_to->HrefValue = "";
			$this->dbkey_counciler_to->TooltipValue = "";

			// task_description
			$this->task_description->LinkCustomAttributes = "";
			$this->task_description->HrefValue = "";
			$this->task_description->TooltipValue = "";

			// task_response
			$this->task_response->LinkCustomAttributes = "";
			$this->task_response->HrefValue = "";
			$this->task_response->TooltipValue = "";

			// date_requested
			$this->date_requested->LinkCustomAttributes = "";
			$this->date_requested->HrefValue = "";
			$this->date_requested->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_EDIT) { // Edit row

			// approved_by
			$this->approved_by->EditAttrs["class"] = "form-control";
			$this->approved_by->EditCustomAttributes = "";
			if (trim(strval($this->approved_by->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->approved_by->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `counselor`";
			$sWhereWrk = "";
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			if (!$GLOBALS["Cust_task_view"]->UserIDAllow("edit")) $sWhereWrk = $GLOBALS["counselor"]->AddUserIDFilter($sWhereWrk);
			$this->Lookup_Selecting($this->approved_by, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect"), "", "", "", "", "", "", ""));
			$this->approved_by->EditValue = $arwrk;

			// date_approved
			$this->date_approved->EditAttrs["class"] = "form-control";
			$this->date_approved->EditCustomAttributes = "";
			$this->date_approved->EditValue = ew_HtmlEncode($this->date_approved->CurrentValue);
			$this->date_approved->PlaceHolder = ew_RemoveHtml($this->date_approved->FldCaption());

			// dbkey_counciler_from
			// dbkey_counciler_to

			$this->dbkey_counciler_to->EditAttrs["class"] = "form-control";
			$this->dbkey_counciler_to->EditCustomAttributes = "";
			if (strval($this->dbkey_counciler_to->CurrentValue) <> "") {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_counciler_to->CurrentValue, EW_DATATYPE_NUMBER, "");
			$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
			$sWhereWrk = "";
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_counciler_to, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
				$rswrk = Conn()->Execute($sSqlWrk);
				if ($rswrk && !$rswrk->EOF) { // Lookup values found
					$arwrk = array();
					$arwrk[1] = $rswrk->fields('DispFld');
					$arwrk[2] = $rswrk->fields('Disp2Fld');
					$this->dbkey_counciler_to->EditValue = $this->dbkey_counciler_to->DisplayValue($arwrk);
					$rswrk->Close();
				} else {
					$this->dbkey_counciler_to->EditValue = $this->dbkey_counciler_to->CurrentValue;
				}
			} else {
				$this->dbkey_counciler_to->EditValue = NULL;
			}
			$this->dbkey_counciler_to->ViewCustomAttributes = "";

			// task_description
			$this->task_description->EditAttrs["class"] = "form-control";
			$this->task_description->EditCustomAttributes = "";
			$this->task_description->EditValue = $this->task_description->CurrentValue;
			$this->task_description->ViewCustomAttributes = "";

			// task_response
			$this->task_response->EditAttrs["class"] = "form-control";
			$this->task_response->EditCustomAttributes = "";
			$this->task_response->EditValue = $this->task_response->CurrentValue;
			$this->task_response->ViewCustomAttributes = "";

			// date_requested
			$this->date_requested->EditAttrs["class"] = "form-control";
			$this->date_requested->EditCustomAttributes = "";
			$this->date_requested->EditValue = $this->date_requested->CurrentValue;
			$this->date_requested->EditValue = ew_FormatDateTime($this->date_requested->EditValue, 5);
			$this->date_requested->ViewCustomAttributes = "";

			// Edit refer script
			// approved_by

			$this->approved_by->HrefValue = "";

			// date_approved
			$this->date_approved->HrefValue = "";

			// dbkey_counciler_from
			$this->dbkey_counciler_from->HrefValue = "";

			// dbkey_counciler_to
			$this->dbkey_counciler_to->HrefValue = "";

			// task_description
			$this->task_description->HrefValue = "";

			// task_response
			$this->task_response->HrefValue = "";

			// date_requested
			$this->date_requested->HrefValue = "";
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate form
	function ValidateForm() {
		global $Language, $gsFormError;

		// Initialize form error message
		$gsFormError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return ($gsFormError == "");
		if (!$this->approved_by->FldIsDetailKey && !is_null($this->approved_by->FormValue) && $this->approved_by->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->approved_by->FldCaption(), $this->approved_by->ReqErrMsg));
		}
		if (!ew_CheckTime($this->date_approved->FormValue)) {
			ew_AddMessage($gsFormError, $this->date_approved->FldErrMsg());
		}

		// Return validate result
		$ValidateForm = ($gsFormError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateForm = $ValidateForm && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsFormError, $sFormCustomError);
		}
		return $ValidateForm;
	}

	// Update record based on key values
	function EditRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$conn = &$this->Connection();
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
		$rs = $conn->Execute($sSql);
		$conn->raiseErrorFn = '';
		if ($rs === FALSE)
			return FALSE;
		if ($rs->EOF) {
			$this->setFailureMessage($Language->Phrase("NoRecord")); // Set no record message
			$EditRow = FALSE; // Update Failed
		} else {

			// Save old values
			$rsold = &$rs->fields;
			$this->LoadDbValues($rsold);
			$rsnew = array();

			// approved_by
			$this->approved_by->SetDbValueDef($rsnew, $this->approved_by->CurrentValue, 0, $this->approved_by->ReadOnly);

			// date_approved
			$this->date_approved->SetDbValueDef($rsnew, $this->date_approved->CurrentValue, NULL, $this->date_approved->ReadOnly);

			// Call Row Updating event
			$bUpdateRow = $this->Row_Updating($rsold, $rsnew);
			if ($bUpdateRow) {
				$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
				if (count($rsnew) > 0)
					$EditRow = $this->Update($rsnew, "", $rsold);
				else
					$EditRow = TRUE; // No field to update
				$conn->raiseErrorFn = '';
				if ($EditRow) {
				}
			} else {
				if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

					// Use the message, do nothing
				} elseif ($this->CancelMessage <> "") {
					$this->setFailureMessage($this->CancelMessage);
					$this->CancelMessage = "";
				} else {
					$this->setFailureMessage($Language->Phrase("UpdateCancelled"));
				}
				$EditRow = FALSE;
			}
		}

		// Call Row_Updated event
		if ($EditRow)
			$this->Row_Updated($rsold, $rsnew);
		$rs->Close();
		return $EditRow;
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, "Cust_task_viewlist.php", "", $this->TableVar, TRUE);
		$PageId = "edit";
		$Breadcrumb->Add("edit", $PageId, $url);
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($Cust_task_view_edit)) $Cust_task_view_edit = new cCust_task_view_edit();

// Page init
$Cust_task_view_edit->Page_Init();

// Page main
$Cust_task_view_edit->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$Cust_task_view_edit->Page_Render();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "edit";
var CurrentForm = fCust_task_viewedit = new ew_Form("fCust_task_viewedit", "edit");

// Validate form
fCust_task_viewedit.Validate = function() {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	var $ = jQuery, fobj = this.GetForm(), $fobj = $(fobj);
	if ($fobj.find("#a_confirm").val() == "F")
		return true;
	var elm, felm, uelm, addcnt = 0;
	var $k = $fobj.find("#" + this.FormKeyCountName); // Get key_count
	var rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1;
	var startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
	var gridinsert = $fobj.find("#a_list").val() == "gridinsert";
	for (var i = startcnt; i <= rowcnt; i++) {
		var infix = ($k[0]) ? String(i) : "";
		$fobj.data("rowindex", infix);
			elm = this.GetElements("x" + infix + "_approved_by");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $Cust_task_view->approved_by->FldCaption(), $Cust_task_view->approved_by->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_date_approved");
			if (elm && !ew_CheckTime(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($Cust_task_view->date_approved->FldErrMsg()) ?>");

			// Fire Form_CustomValidate event
			if (!this.Form_CustomValidate(fobj))
				return false;
	}

	// Process detail forms
	var dfs = $fobj.find("input[name='detailpage']").get();
	for (var i = 0; i < dfs.length; i++) {
		var df = dfs[i], val = df.value;
		if (val && ewForms[val])
			if (!ewForms[val].Validate())
				return false;
	}
	return true;
}

// Form_CustomValidate event
fCust_task_viewedit.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fCust_task_viewedit.ValidateRequired = true;
<?php } else { ?>
fCust_task_viewedit.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fCust_task_viewedit.Lists["x_approved_by"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
fCust_task_viewedit.Lists["x_dbkey_counciler_from"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
fCust_task_viewedit.Lists["x_dbkey_counciler_to"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};

// Form object for search
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<div class="ewToolbar">
<?php $Breadcrumb->Render(); ?>
<?php echo $Language->SelectionForm(); ?>
<div class="clearfix"></div>
</div>
<?php $Cust_task_view_edit->ShowPageHeader(); ?>
<?php
$Cust_task_view_edit->ShowMessage();
?>
<form name="fCust_task_viewedit" id="fCust_task_viewedit" class="<?php echo $Cust_task_view_edit->FormClassName ?>" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($Cust_task_view_edit->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $Cust_task_view_edit->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="Cust_task_view">
<input type="hidden" name="a_edit" id="a_edit" value="U">
<div>
<?php if ($Cust_task_view->approved_by->Visible) { // approved_by ?>
	<div id="r_approved_by" class="form-group">
		<label id="elh_Cust_task_view_approved_by" for="x_approved_by" class="col-sm-2 control-label ewLabel"><?php echo $Cust_task_view->approved_by->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_task_view->approved_by->CellAttributes() ?>>
<span id="el_Cust_task_view_approved_by">
<select data-table="Cust_task_view" data-field="x_approved_by" data-value-separator="<?php echo ew_HtmlEncode(is_array($Cust_task_view->approved_by->DisplayValueSeparator) ? json_encode($Cust_task_view->approved_by->DisplayValueSeparator) : $Cust_task_view->approved_by->DisplayValueSeparator) ?>" id="x_approved_by" name="x_approved_by"<?php echo $Cust_task_view->approved_by->EditAttributes() ?>>
<?php
if (is_array($Cust_task_view->approved_by->EditValue)) {
	$arwrk = $Cust_task_view->approved_by->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = ew_SameStr($Cust_task_view->approved_by->CurrentValue, $arwrk[$rowcntwrk][0]) ? " selected" : "";
		if ($selwrk <> "") $emptywrk = FALSE;		
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $Cust_task_view->approved_by->DisplayValue($arwrk[$rowcntwrk]) ?>
</option>
<?php
	}
	if ($emptywrk && strval($Cust_task_view->approved_by->CurrentValue) <> "") {
?>
<option value="<?php echo ew_HtmlEncode($Cust_task_view->approved_by->CurrentValue) ?>" selected><?php echo $Cust_task_view->approved_by->CurrentValue ?></option>
<?php
    }
}
?>
</select>
<?php
$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
$sWhereWrk = "";
if (!$GLOBALS["Cust_task_view"]->UserIDAllow("edit")) $sWhereWrk = $GLOBALS["counselor"]->AddUserIDFilter($sWhereWrk);
$Cust_task_view->approved_by->LookupFilters = array("s" => $sSqlWrk, "d" => "");
$Cust_task_view->approved_by->LookupFilters += array("f0" => "`dbkey` = {filter_value}", "t0" => "3", "fn0" => "");
$sSqlWrk = "";
$Cust_task_view->Lookup_Selecting($Cust_task_view->approved_by, $sWhereWrk); // Call Lookup selecting
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
if ($sSqlWrk <> "") $Cust_task_view->approved_by->LookupFilters["s"] .= $sSqlWrk;
?>
<input type="hidden" name="s_x_approved_by" id="s_x_approved_by" value="<?php echo $Cust_task_view->approved_by->LookupFilterQuery() ?>">
</span>
<?php echo $Cust_task_view->approved_by->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_task_view->date_approved->Visible) { // date_approved ?>
	<div id="r_date_approved" class="form-group">
		<label id="elh_Cust_task_view_date_approved" for="x_date_approved" class="col-sm-2 control-label ewLabel"><?php echo $Cust_task_view->date_approved->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_task_view->date_approved->CellAttributes() ?>>
<span id="el_Cust_task_view_date_approved">
<input type="text" data-table="Cust_task_view" data-field="x_date_approved" name="x_date_approved" id="x_date_approved" size="30" placeholder="<?php echo ew_HtmlEncode($Cust_task_view->date_approved->getPlaceHolder()) ?>" value="<?php echo $Cust_task_view->date_approved->EditValue ?>"<?php echo $Cust_task_view->date_approved->EditAttributes() ?>>
</span>
<?php echo $Cust_task_view->date_approved->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_task_view->dbkey_counciler_to->Visible) { // dbkey_counciler_to ?>
	<div id="r_dbkey_counciler_to" class="form-group">
		<label id="elh_Cust_task_view_dbkey_counciler_to" for="x_dbkey_counciler_to" class="col-sm-2 control-label ewLabel"><?php echo $Cust_task_view->dbkey_counciler_to->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_task_view->dbkey_counciler_to->CellAttributes() ?>>
<span id="el_Cust_task_view_dbkey_counciler_to">
<span<?php echo $Cust_task_view->dbkey_counciler_to->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $Cust_task_view->dbkey_counciler_to->EditValue ?></p></span>
</span>
<input type="hidden" data-table="Cust_task_view" data-field="x_dbkey_counciler_to" name="x_dbkey_counciler_to" id="x_dbkey_counciler_to" value="<?php echo ew_HtmlEncode($Cust_task_view->dbkey_counciler_to->CurrentValue) ?>">
<?php echo $Cust_task_view->dbkey_counciler_to->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_task_view->task_description->Visible) { // task_description ?>
	<div id="r_task_description" class="form-group">
		<label id="elh_Cust_task_view_task_description" class="col-sm-2 control-label ewLabel"><?php echo $Cust_task_view->task_description->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_task_view->task_description->CellAttributes() ?>>
<span id="el_Cust_task_view_task_description">
<?php ew_AppendClass($Cust_task_view->task_description->EditAttrs["class"], "editor"); ?>
<textarea data-table="Cust_task_view" data-field="x_task_description" name="x_task_description" id="x_task_description" cols="35" rows="4" placeholder="<?php echo ew_HtmlEncode($Cust_task_view->task_description->getPlaceHolder()) ?>"<?php echo $Cust_task_view->task_description->EditAttributes() ?>><?php echo $Cust_task_view->task_description->EditValue ?></textarea>
<script type="text/javascript">
ew_CreateEditor("fCust_task_viewedit", "x_task_description", 35, 4, <?php echo ($Cust_task_view->task_description->ReadOnly || TRUE) ? "true" : "false" ?>);
</script>
</span>
<?php echo $Cust_task_view->task_description->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_task_view->task_response->Visible) { // task_response ?>
	<div id="r_task_response" class="form-group">
		<label id="elh_Cust_task_view_task_response" class="col-sm-2 control-label ewLabel"><?php echo $Cust_task_view->task_response->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_task_view->task_response->CellAttributes() ?>>
<span id="el_Cust_task_view_task_response">
<?php ew_AppendClass($Cust_task_view->task_response->EditAttrs["class"], "editor"); ?>
<textarea data-table="Cust_task_view" data-field="x_task_response" name="x_task_response" id="x_task_response" cols="35" rows="4" placeholder="<?php echo ew_HtmlEncode($Cust_task_view->task_response->getPlaceHolder()) ?>"<?php echo $Cust_task_view->task_response->EditAttributes() ?>><?php echo $Cust_task_view->task_response->EditValue ?></textarea>
<script type="text/javascript">
ew_CreateEditor("fCust_task_viewedit", "x_task_response", 35, 4, <?php echo ($Cust_task_view->task_response->ReadOnly || TRUE) ? "true" : "false" ?>);
</script>
</span>
<?php echo $Cust_task_view->task_response->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($Cust_task_view->date_requested->Visible) { // date_requested ?>
	<div id="r_date_requested" class="form-group">
		<label id="elh_Cust_task_view_date_requested" for="x_date_requested" class="col-sm-2 control-label ewLabel"><?php echo $Cust_task_view->date_requested->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $Cust_task_view->date_requested->CellAttributes() ?>>
<span id="el_Cust_task_view_date_requested">
<span<?php echo $Cust_task_view->date_requested->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $Cust_task_view->date_requested->EditValue ?></p></span>
</span>
<input type="hidden" data-table="Cust_task_view" data-field="x_date_requested" name="x_date_requested" id="x_date_requested" value="<?php echo ew_HtmlEncode($Cust_task_view->date_requested->CurrentValue) ?>">
<?php echo $Cust_task_view->date_requested->CustomMsg ?></div></div>
	</div>
<?php } ?>
</div>
<input type="hidden" data-table="Cust_task_view" data-field="x_dbkey" name="x_dbkey" id="x_dbkey" value="<?php echo ew_HtmlEncode($Cust_task_view->dbkey->CurrentValue) ?>">
<div class="form-group">
	<div class="col-sm-offset-2 col-sm-10">
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit"><?php echo $Language->Phrase("SaveBtn") ?></button>
<button class="btn btn-default ewButton" name="btnCancel" id="btnCancel" type="button" data-href="<?php echo $Cust_task_view_edit->getReturnUrl() ?>"><?php echo $Language->Phrase("CancelBtn") ?></button>
	</div>
</div>
</form>
<script type="text/javascript">
fCust_task_viewedit.Init();
</script>
<?php
$Cust_task_view_edit->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$Cust_task_view_edit->Page_Terminate();
?>
