<?php
if (session_id() == "") session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg12.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql12.php") ?>
<?php include_once "phpfn12.php" ?>
<?php

// Global variable for table object
$Report1 = NULL;

//
// Table class for Report1
//
class cReport1 extends cTableBase {
	var $First;
	var $Last;
	var $description;
	var $dbkey;
	var $Year;
	var $From_Date;
	var $Through_Date;
	var $allocated;
	var $Monday;
	var $Tuesday;
	var $Wednesday;
	var $Thursday;
	var $Friday;
	var $Saturday;
	var $Sunday;
	var $Week_23;
	var $Total_Hours;

	//
	// Table class constructor
	//
	function __construct() {
		global $Language;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();
		$this->TableVar = 'Report1';
		$this->TableName = 'Report1';
		$this->TableType = 'REPORT';

		// Update Table
		$this->UpdateTable = "client_activity, counselor, tables_data, tables_data b";
		$this->DBID = 'DB';
		$this->ExportAll = TRUE;
		$this->ExportPageBreakCount = 0; // Page break per every n record (PDF only)
		$this->ExportPageOrientation = "portrait"; // Page orientation (PDF only)
		$this->ExportPageSize = "a4"; // Page size (PDF only)
		$this->ExportExcelPageOrientation = ""; // Page orientation (PHPExcel only)
		$this->ExportExcelPageSize = ""; // Page size (PHPExcel only)
		$this->UserIDAllowSecurity = 0; // User ID Allow

		// First
		$this->First = new cField('Report1', 'Report1', 'x_First', 'First', '`First`', '`First`', 200, -1, FALSE, '`First`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->fields['First'] = &$this->First;

		// Last
		$this->Last = new cField('Report1', 'Report1', 'x_Last', 'Last', '`Last`', '`Last`', 200, -1, FALSE, '`Last`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->fields['Last'] = &$this->Last;

		// description
		$this->description = new cField('Report1', 'Report1', 'x_description', 'description', 'b.description', 'b.description', 200, -1, FALSE, 'b.description', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->description->AdvancedSearch->SearchValueDefault = date("Y");
		$this->description->AdvancedSearch->SearchOperatorDefault = "=";
		$this->description->AdvancedSearch->SearchOperatorDefault2 = "";
		$this->description->AdvancedSearch->SearchConditionDefault = "AND";
		$this->fields['description'] = &$this->description;

		// dbkey
		$this->dbkey = new cField('Report1', 'Report1', 'x_dbkey', 'dbkey', 'tables_data.dbkey', 'tables_data.dbkey', 200, -1, FALSE, 'tables_data.dbkey', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey->AdvancedSearch->SearchValueDefault = date("W");
		$this->dbkey->AdvancedSearch->SearchOperatorDefault = "=";
		$this->dbkey->AdvancedSearch->SearchOperatorDefault2 = "";
		$this->dbkey->AdvancedSearch->SearchConditionDefault = "AND";
		$this->fields['dbkey'] = &$this->dbkey;

		// Year
		$this->Year = new cField('Report1', 'Report1', 'x_Year', 'Year', '`Year`', '`Year`', 20, -1, FALSE, '`Year`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->Year->OptionCount = 3;
		$this->Year->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['Year'] = &$this->Year;

		// From Date
		$this->From_Date = new cField('Report1', 'Report1', 'x_From_Date', 'From Date', '`From Date`', 'DATE_FORMAT(`From Date`, \'%Y/%m/%d\')', 133, 5, FALSE, '`From Date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->From_Date->FldDefaultErrMsg = str_replace("%s", "/", $Language->Phrase("IncorrectDateYMD"));
		$this->fields['From Date'] = &$this->From_Date;

		// Through Date
		$this->Through_Date = new cField('Report1', 'Report1', 'x_Through_Date', 'Through Date', '`Through Date`', 'DATE_FORMAT(`Through Date`, \'%Y/%m/%d\')', 135, 5, FALSE, '`Through Date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Through_Date->FldDefaultErrMsg = str_replace("%s", "/", $Language->Phrase("IncorrectDateYMD"));
		$this->fields['Through Date'] = &$this->Through_Date;

		// allocated
		$this->allocated = new cField('Report1', 'Report1', 'x_allocated', 'allocated', '(SELECT sum(IfNull(b.time, 0)) FROM client_activity b where client_activity.dbkey_client = b.dbkey_client AND Year(client_activity.date) = Year(b.date) AND Month(client_activity.date) = Month(b.date))', '(SELECT sum(IfNull(b.time, 0)) FROM client_activity b where client_activity.dbkey_client = b.dbkey_client AND Year(client_activity.date) = Year(b.date) AND Month(client_activity.date) = Month(b.date))', 201, -1, FALSE, '(SELECT sum(IfNull(b.time, 0)) FROM client_activity b where client_activity.dbkey_client = b.dbkey_client AND Year(client_activity.date) = Year(b.date) AND Month(client_activity.date) = Month(b.date))', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->allocated->FldIsCustom = TRUE; // Custom field
		$this->allocated->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['allocated'] = &$this->allocated;

		// Monday
		$this->Monday = new cField('Report1', 'Report1', 'x_Monday', 'Monday', '\'\'', '\'\'', 131, -1, FALSE, '\'\'', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXTAREA');
		$this->Monday->FldIsCustom = TRUE; // Custom field
		$this->fields['Monday'] = &$this->Monday;

		// Tuesday
		$this->Tuesday = new cField('Report1', 'Report1', 'x_Tuesday', 'Tuesday', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Tuesday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Tuesday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Tuesday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Tuesday->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Tuesday'] = &$this->Tuesday;

		// Wednesday
		$this->Wednesday = new cField('Report1', 'Report1', 'x_Wednesday', 'Wednesday', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Wednesday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Wednesday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Wednesday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Wednesday->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Wednesday'] = &$this->Wednesday;

		// Thursday
		$this->Thursday = new cField('Report1', 'Report1', 'x_Thursday', 'Thursday', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Thursday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Thursday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Thursday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Thursday->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Thursday'] = &$this->Thursday;

		// Friday
		$this->Friday = new cField('Report1', 'Report1', 'x_Friday', 'Friday', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Friday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Friday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Friday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Friday->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Friday'] = &$this->Friday;

		// Saturday
		$this->Saturday = new cField('Report1', 'Report1', 'x_Saturday', 'Saturday', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Saturday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Saturday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Saturday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Saturday->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Saturday'] = &$this->Saturday;

		// Sunday
		$this->Sunday = new cField('Report1', 'Report1', 'x_Sunday', 'Sunday', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Sunday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Sunday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', 131, -1, FALSE, '(Select Sum(friday.time) From client_activity friday Where DayName(friday.date) = \'Sunday\' And friday.dbkey_councilor = client_activity.dbkey_councilor And friday.date >= Min(client_activity.date) And friday.date <= Max(client_activity.date) Group By friday.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Sunday->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Sunday'] = &$this->Sunday;

		// Week #
		$this->Week_23 = new cField('Report1', 'Report1', 'x_Week_23', 'Week #', '`Week #`', '`Week #`', 20, -1, FALSE, '`Week #`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Week_23->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['Week #'] = &$this->Week_23;

		// Total Hours
		$this->Total_Hours = new cField('Report1', 'Report1', 'x_Total_Hours', 'Total Hours', '`Total Hours`', '`Total Hours`', 131, -1, FALSE, '`Total Hours`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Total_Hours->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Total Hours'] = &$this->Total_Hours;
	}

	// Report detail level SQL
	var $_SqlDetailSelect = "";

	function getSqlDetailSelect() { // Select
		return ($this->_SqlDetailSelect <> "") ? $this->_SqlDetailSelect : "SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Sunday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Monday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Tuesday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Wednesday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Thursday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Friday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Saturday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday, (SELECT sum(IfNull(b.time, 0)) FROM client_activity b where client_activity.dbkey_client = b.dbkey_client AND Year(client_activity.date) = Year(b.date) AND Month(client_activity.date) = Month(b.date)) AS `allocated`, '' AS `Monday` FROM client_activity, counselor, tables_data, tables_data b";
	}

	function SqlDetailSelect() { // For backward compatibility
    	return $this->getSqlDetailSelect();
	}

	function setSqlDetailSelect($v) {
    	$this->_SqlDetailSelect = $v;
	}
	var $_SqlDetailWhere = "";

	function getSqlDetailWhere() { // Where
		return ($this->_SqlDetailWhere <> "") ? $this->_SqlDetailWhere : "client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR'";
	}

	function SqlDetailWhere() { // For backward compatibility
    	return $this->getSqlDetailWhere();
	}

	function setSqlDetailWhere($v) {
    	$this->_SqlDetailWhere = $v;
	}
	var $_SqlDetailGroupBy = "";

	function getSqlDetailGroupBy() { // Group By
		return ($this->_SqlDetailGroupBy <> "") ? $this->_SqlDetailGroupBy : "Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor";
	}

	function SqlDetailGroupBy() { // For backward compatibility
    	return $this->getSqlDetailGroupBy();
	}

	function setSqlDetailGroupBy($v) {
    	$this->_SqlDetailGroupBy = $v;
	}
	var $_SqlDetailHaving = "";

	function getSqlDetailHaving() { // Having
		return ($this->_SqlDetailHaving <> "") ? $this->_SqlDetailHaving : "";
	}

	function SqlDetailHaving() { // For backward compatibility
    	return $this->getSqlDetailHaving();
	}

	function setSqlDetailHaving($v) {
    	$this->_SqlDetailHaving = $v;
	}
	var $_SqlDetailOrderBy = "";

	function getSqlDetailOrderBy() { // Order By
		return ($this->_SqlDetailOrderBy <> "") ? $this->_SqlDetailOrderBy : "b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor";
	}

	function SqlDetailOrderBy() { // For backward compatibility
    	return $this->getSqlDetailOrderBy();
	}

	function setSqlDetailOrderBy($v) {
    	$this->_SqlDetailOrderBy = $v;
	}

	// Apply User ID filters
	function ApplyUserIDFilters($sFilter) {
		return $sFilter;
	}

	// Check if User ID security allows view all
	function UserIDAllow($id = "") {
		$allow = EW_USER_ID_ALLOW;
		switch ($id) {
			case "add":
			case "copy":
			case "gridadd":
			case "register":
			case "addopt":
				return (($allow & 1) == 1);
			case "edit":
			case "gridedit":
			case "update":
			case "changepwd":
			case "forgotpwd":
				return (($allow & 4) == 4);
			case "delete":
				return (($allow & 2) == 2);
			case "view":
				return (($allow & 32) == 32);
			case "search":
				return (($allow & 64) == 64);
			default:
				return (($allow & 8) == 8);
		}
	}

	// Report detail SQL
	function DetailSQL() {
		$sFilter = $this->CurrentFilter;
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = "";
		return ew_BuildSelectSql($this->getSqlDetailSelect(), $this->getSqlDetailWhere(),
			$this->getSqlDetailGroupBy(), $this->getSqlDetailHaving(),
			$this->getSqlDetailOrderBy(), $sFilter, $sSort);
	}

	// Return page URL
	function getReturnUrl() {
		$name = EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL;

		// Get referer URL automatically
		if (ew_ServerVar("HTTP_REFERER") <> "" && ew_ReferPage() <> ew_CurrentPage() && ew_ReferPage() <> "login.php") // Referer not same page or login page
			$_SESSION[$name] = ew_ServerVar("HTTP_REFERER"); // Save to Session
		if (@$_SESSION[$name] <> "") {
			return $_SESSION[$name];
		} else {
			return "Report1report.php";
		}
	}

	function setReturnUrl($v) {
		$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL] = $v;
	}

	// List URL
	function GetListUrl() {
		return "Report1report.php";
	}

	// View URL
	function GetViewUrl($parm = "") {
		if ($parm <> "")
			$url = $this->KeyUrl("", $this->UrlParm($parm));
		else
			$url = $this->KeyUrl("", $this->UrlParm(EW_TABLE_SHOW_DETAIL . "="));
		return $this->AddMasterUrl($url);
	}

	// Add URL
	function GetAddUrl($parm = "") {
		if ($parm <> "")
			$url = "?" . $this->UrlParm($parm);
		else
			$url = "";
		return $this->AddMasterUrl($url);
	}

	// Edit URL
	function GetEditUrl($parm = "") {
		$url = $this->KeyUrl("", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline edit URL
	function GetInlineEditUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=edit"));
		return $this->AddMasterUrl($url);
	}

	// Copy URL
	function GetCopyUrl($parm = "") {
		$url = $this->KeyUrl("", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline copy URL
	function GetInlineCopyUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=copy"));
		return $this->AddMasterUrl($url);
	}

	// Delete URL
	function GetDeleteUrl() {
		return $this->KeyUrl("", $this->UrlParm());
	}

	// Add master url
	function AddMasterUrl($url) {
		return $url;
	}

	function KeyToJson() {
		$json = "";
		return "{" . $json . "}";
	}

	// Add key value to URL
	function KeyUrl($url, $parm = "") {
		$sUrl = $url . "?";
		if ($parm <> "") $sUrl .= $parm . "&";
		return $sUrl;
	}

	// Sort URL
	function SortUrl(&$fld) {
		if ($this->CurrentAction <> "" || $this->Export <> "" ||
			in_array($fld->FldType, array(128, 204, 205))) { // Unsortable data type
				return "";
		} elseif ($fld->Sortable) {
			$sUrlParm = $this->UrlParm("order=" . urlencode($fld->FldName) . "&amp;ordertype=" . $fld->ReverseSort());
			return ew_CurrentPage() . "?" . $sUrlParm;
		} else {
			return "";
		}
	}

	// Get record keys from $_POST/$_GET/$_SESSION
	function GetRecordKeys() {
		global $EW_COMPOSITE_KEY_SEPARATOR;
		$arKeys = array();
		$arKey = array();
		if (isset($_POST["key_m"])) {
			$arKeys = ew_StripSlashes($_POST["key_m"]);
			$cnt = count($arKeys);
		} elseif (isset($_GET["key_m"])) {
			$arKeys = ew_StripSlashes($_GET["key_m"]);
			$cnt = count($arKeys);
		} elseif (!empty($_GET) || !empty($_POST)) {
			$isPost = ew_IsHttpPost();

			//return $arKeys; // Do not return yet, so the values will also be checked by the following code
		}

		// Check keys
		$ar = array();
		foreach ($arKeys as $key) {
			$ar[] = $key;
		}
		return $ar;
	}

	// Get key filter
	function GetKeyFilter() {
		$arKeys = $this->GetRecordKeys();
		$sKeyFilter = "";
		foreach ($arKeys as $key) {
			if ($sKeyFilter <> "") $sKeyFilter .= " OR ";
			$sKeyFilter .= "(" . $this->KeyFilter() . ")";
		}
		return $sKeyFilter;
	}

	// Load rows based on filter
	function &LoadRs($sFilter) {

		// Set up filter (SQL WHERE clause) and get return SQL
		//$this->CurrentFilter = $sFilter;
		//$sSql = $this->SQL();

		$sSql = $this->GetSQL($sFilter, "");
		$conn = &$this->Connection();
		$rs = $conn->Execute($sSql);
		return $rs;
	}

	// Row Rendering event
	function Row_Rendering() {

		// Enter your code here	
	}

	// Row Rendered event
	function Row_Rendered() {

		// To view properties of field class, use:
		//var_dump($this-><FieldName>); 

	}

	// User ID Filtering event
	function UserID_Filtering(&$filter) {

		// Enter your code here
	}
}
?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn12.php" ?>
<?php

//
// Page class
//

$Report1_report = NULL; // Initialize page object first

class cReport1_report extends cReport1 {

	// Page ID
	var $PageID = 'report';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'Report1';

	// Page object name
	var $PageObjName = 'Report1_report';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		return $PageUrl;
	}

	// Page URLs
	var $AddUrl;
	var $EditUrl;
	var $CopyUrl;
	var $DeleteUrl;
	var $ViewUrl;
	var $ListUrl;

	// Export URLs
	var $ExportPrintUrl;
	var $ExportHtmlUrl;
	var $ExportExcelUrl;
	var $ExportWordUrl;
	var $ExportXmlUrl;
	var $ExportCsvUrl;
	var $ExportPdfUrl;

	// Custom export
	var $ExportExcelCustom = FALSE;
	var $ExportWordCustom = FALSE;
	var $ExportPdfCustom = FALSE;
	var $ExportEmailCustom = FALSE;

	// Update URLs
	var $InlineAddUrl;
	var $InlineCopyUrl;
	var $InlineEditUrl;
	var $GridAddUrl;
	var $GridEditUrl;
	var $MultiDeleteUrl;
	var $MultiUpdateUrl;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		return TRUE;
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (Report1)
		if (!isset($GLOBALS["Report1"]) || get_class($GLOBALS["Report1"]) == "cReport1") {
			$GLOBALS["Report1"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["Report1"];
		}

		// Initialize URLs
		$this->ExportPrintUrl = $this->PageUrl() . "export=print";
		$this->ExportExcelUrl = $this->PageUrl() . "export=excel";
		$this->ExportWordUrl = $this->PageUrl() . "export=word";

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'report', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'Report1', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}

		// Export options
		$this->ExportOptions = new cListOptions();
		$this->ExportOptions->Tag = "div";
		$this->ExportOptions->TagClassName = "ewExportOption";
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanReport()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage($Language->Phrase("NoPermission")); // Set no permission
			$this->Page_Terminate(ew_GetUrl("index.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Get export parameters
		$custom = "";
		if (@$_GET["export"] <> "") {
			$this->Export = $_GET["export"];
			$custom = @$_GET["custom"];
		} elseif (@$_POST["export"] <> "") {
			$this->Export = $_POST["export"];
			$custom = @$_POST["custom"];
		}
		$gsExportFile = $this->TableVar; // Get export file, used in header

		// Get custom export parameters
		if ($this->Export <> "" && $custom <> "") {
			$this->CustomExport = $this->Export;
			$this->Export = "print";
		}
		$gsCustomExport = $this->CustomExport;
		$gsExport = $this->Export; // Get export parameter, used in header

		// Update Export URLs
		if (defined("EW_USE_PHPEXCEL"))
			$this->ExportExcelCustom = FALSE;
		if ($this->ExportExcelCustom)
			$this->ExportExcelUrl .= "&amp;custom=1";
		if (defined("EW_USE_PHPWORD"))
			$this->ExportWordCustom = FALSE;
		if ($this->ExportWordCustom)
			$this->ExportWordUrl .= "&amp;custom=1";
		if ($this->ExportPdfCustom)
			$this->ExportPdfUrl .= "&amp;custom=1";
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action

		// Setup export options
		$this->SetupExportOptions();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT_REPORT;
		if ($this->Export <> "" && array_key_exists($this->Export, $EW_EXPORT_REPORT)) {
			$sContent = ob_get_contents();
			$fn = $EW_EXPORT_REPORT[$this->Export];
			$this->$fn($sContent);
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}
	var $ExportOptions; // Export options
	var $RecCnt = 0;
	var $RowCnt = 0; // For custom view tag
	var $ReportSql = "";
	var $ReportFilter = "";
	var $DefaultFilter = "";
	var $DbMasterFilter = "";
	var $DbDetailFilter = "";
	var $MasterRecordExists;
	var $Command;
	var $DtlRecordCount;
	var $ReportGroups;
	var $ReportCounts;
	var $LevelBreak;
	var $ReportTotals;
	var $ReportMaxs;
	var $ReportMins;
	var $Recordset;
	var $DetailRecordset;
	var $RecordExists;

	//
	// Page main
	//
	function Page_Main() {
		global $Language;
		$this->ReportGroups = &ew_InitArray(1, NULL);
		$this->ReportCounts = &ew_InitArray(1, 0);
		$this->LevelBreak = &ew_InitArray(1, FALSE);
		$this->ReportTotals = &ew_Init2DArray(1, 14, 0);
		$this->ReportMaxs = &ew_Init2DArray(1, 14, 0);
		$this->ReportMins = &ew_Init2DArray(1, 14, 0);

		// Set up Breadcrumb
		$this->SetupBreadcrumb();
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Convert decimal values if posted back

		if ($this->Tuesday->FormValue == $this->Tuesday->CurrentValue && is_numeric(ew_StrToFloat($this->Tuesday->CurrentValue)))
			$this->Tuesday->CurrentValue = ew_StrToFloat($this->Tuesday->CurrentValue);

		// Convert decimal values if posted back
		if ($this->Wednesday->FormValue == $this->Wednesday->CurrentValue && is_numeric(ew_StrToFloat($this->Wednesday->CurrentValue)))
			$this->Wednesday->CurrentValue = ew_StrToFloat($this->Wednesday->CurrentValue);

		// Convert decimal values if posted back
		if ($this->Thursday->FormValue == $this->Thursday->CurrentValue && is_numeric(ew_StrToFloat($this->Thursday->CurrentValue)))
			$this->Thursday->CurrentValue = ew_StrToFloat($this->Thursday->CurrentValue);

		// Convert decimal values if posted back
		if ($this->Friday->FormValue == $this->Friday->CurrentValue && is_numeric(ew_StrToFloat($this->Friday->CurrentValue)))
			$this->Friday->CurrentValue = ew_StrToFloat($this->Friday->CurrentValue);

		// Convert decimal values if posted back
		if ($this->Saturday->FormValue == $this->Saturday->CurrentValue && is_numeric(ew_StrToFloat($this->Saturday->CurrentValue)))
			$this->Saturday->CurrentValue = ew_StrToFloat($this->Saturday->CurrentValue);

		// Convert decimal values if posted back
		if ($this->Sunday->FormValue == $this->Sunday->CurrentValue && is_numeric(ew_StrToFloat($this->Sunday->CurrentValue)))
			$this->Sunday->CurrentValue = ew_StrToFloat($this->Sunday->CurrentValue);

		// Convert decimal values if posted back
		if ($this->Total_Hours->FormValue == $this->Total_Hours->CurrentValue && is_numeric(ew_StrToFloat($this->Total_Hours->CurrentValue)))
			$this->Total_Hours->CurrentValue = ew_StrToFloat($this->Total_Hours->CurrentValue);

		// Call Row_Rendering event
		$this->Row_Rendering();

		// Common render codes for all row types
		// First
		// Last
		// description
		// dbkey
		// Year
		// From Date
		// Through Date
		// allocated
		// Monday
		// Tuesday
		// Wednesday
		// Thursday
		// Friday
		// Saturday
		// Sunday
		// Week #
		// Total Hours

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// First
		if (strval($this->First->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.`First`" . ew_SearchString("=", $this->First->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`First`, `EW_TMP_LOOKUPTABLE`.`First` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Sunday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Monday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Tuesday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Wednesday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Thursday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Friday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Saturday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->First->ViewValue = $this->First->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->First->ViewValue = $this->First->CurrentValue;
			}
		} else {
			$this->First->ViewValue = NULL;
		}
		$this->First->ViewCustomAttributes = "";

		// Last
		if (strval($this->Last->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.`Last`" . ew_SearchString("=", $this->Last->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`Last`, `EW_TMP_LOOKUPTABLE`.`Last` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Sunday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Monday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Tuesday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Wednesday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Thursday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Friday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Saturday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->Last->ViewValue = $this->Last->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->Last->ViewValue = $this->Last->CurrentValue;
			}
		} else {
			$this->Last->ViewValue = NULL;
		}
		$this->Last->ViewCustomAttributes = "";

		// Year
		if (strval($this->Year->CurrentValue) <> "") {
			$this->Year->ViewValue = $this->Year->OptionCaption($this->Year->CurrentValue);
		} else {
			$this->Year->ViewValue = NULL;
		}
		$this->Year->ViewCustomAttributes = "";

		// From Date
		if (strval($this->From_Date->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.`From Date`" . ew_SearchString("=", $this->From_Date->CurrentValue, EW_DATATYPE_DATE, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.`From Date`, `EW_TMP_LOOKUPTABLE`.`From Date` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Sunday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Monday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Tuesday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Wednesday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Thursday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Friday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Saturday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = ew_FormatDateTime($rswrk->fields('DispFld'), 5);
				$this->From_Date->ViewValue = $this->From_Date->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->From_Date->ViewValue = $this->From_Date->CurrentValue;
			}
		} else {
			$this->From_Date->ViewValue = NULL;
		}
		$this->From_Date->ViewValue = ew_FormatDateTime($this->From_Date->ViewValue, 5);
		$this->From_Date->ViewCustomAttributes = "";

		// Through Date
		$this->Through_Date->ViewValue = $this->Through_Date->CurrentValue;
		$this->Through_Date->ViewValue = ew_FormatDateTime($this->Through_Date->ViewValue, 5);
		$this->Through_Date->ViewCustomAttributes = "";

		// Monday
		$this->Monday->ViewValue = $this->Monday->CurrentValue;
		$this->Monday->ViewCustomAttributes = "";

		// Tuesday
		$this->Tuesday->ViewValue = $this->Tuesday->CurrentValue;
		$this->Tuesday->ViewCustomAttributes = "";

		// Wednesday
		$this->Wednesday->ViewValue = $this->Wednesday->CurrentValue;
		$this->Wednesday->ViewCustomAttributes = "";

		// Thursday
		$this->Thursday->ViewValue = $this->Thursday->CurrentValue;
		$this->Thursday->ViewCustomAttributes = "";

		// Friday
		$this->Friday->ViewValue = $this->Friday->CurrentValue;
		$this->Friday->ViewCustomAttributes = "";

		// Saturday
		$this->Saturday->ViewValue = $this->Saturday->CurrentValue;
		$this->Saturday->ViewCustomAttributes = "";

		// Sunday
		$this->Sunday->ViewValue = $this->Sunday->CurrentValue;
		$this->Sunday->ViewCustomAttributes = "";

		// Total Hours
		$this->Total_Hours->ViewValue = $this->Total_Hours->CurrentValue;
		$this->Total_Hours->ViewCustomAttributes = "";

			// First
			$this->First->LinkCustomAttributes = "";
			$this->First->HrefValue = "";
			$this->First->TooltipValue = "";

			// Last
			$this->Last->LinkCustomAttributes = "";
			$this->Last->HrefValue = "";
			$this->Last->TooltipValue = "";

			// Year
			$this->Year->LinkCustomAttributes = "";
			$this->Year->HrefValue = "";
			$this->Year->TooltipValue = "";

			// From Date
			$this->From_Date->LinkCustomAttributes = "";
			$this->From_Date->HrefValue = "";
			$this->From_Date->TooltipValue = "";

			// Through Date
			$this->Through_Date->LinkCustomAttributes = "";
			$this->Through_Date->HrefValue = "";
			$this->Through_Date->TooltipValue = "";

			// Monday
			$this->Monday->LinkCustomAttributes = "";
			$this->Monday->HrefValue = "";
			$this->Monday->TooltipValue = "";

			// Tuesday
			$this->Tuesday->LinkCustomAttributes = "";
			$this->Tuesday->HrefValue = "";
			$this->Tuesday->TooltipValue = "";

			// Wednesday
			$this->Wednesday->LinkCustomAttributes = "";
			$this->Wednesday->HrefValue = "";
			$this->Wednesday->TooltipValue = "";

			// Thursday
			$this->Thursday->LinkCustomAttributes = "";
			$this->Thursday->HrefValue = "";
			$this->Thursday->TooltipValue = "";

			// Friday
			$this->Friday->LinkCustomAttributes = "";
			$this->Friday->HrefValue = "";
			$this->Friday->TooltipValue = "";

			// Saturday
			$this->Saturday->LinkCustomAttributes = "";
			$this->Saturday->HrefValue = "";
			$this->Saturday->TooltipValue = "";

			// Sunday
			$this->Sunday->LinkCustomAttributes = "";
			$this->Sunday->HrefValue = "";
			$this->Sunday->TooltipValue = "";

			// Total Hours
			$this->Total_Hours->LinkCustomAttributes = "";
			$this->Total_Hours->HrefValue = "";
			$this->Total_Hours->TooltipValue = "";
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Set up export options
	function SetupExportOptions() {
		global $Language;

		// Printer friendly
		$item = &$this->ExportOptions->Add("print");
		$item->Body = "<a href=\"" . $this->ExportPrintUrl . "\" class=\"ewExportLink ewPrint\" title=\"" . ew_HtmlEncode($Language->Phrase("PrinterFriendlyText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("PrinterFriendlyText")) . "\">" . $Language->Phrase("PrinterFriendly") . "</a>";
		$item->Visible = TRUE;

		// Export to Excel
		$item = &$this->ExportOptions->Add("excel");
		$item->Body = "<a href=\"" . $this->ExportExcelUrl . "\" class=\"ewExportLink ewExcel\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToExcelText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToExcelText")) . "\">" . $Language->Phrase("ExportToExcel") . "</a>";
		$item->Visible = TRUE;

		// Export to Word
		$item = &$this->ExportOptions->Add("word");
		$item->Body = "<a href=\"" . $this->ExportWordUrl . "\" class=\"ewExportLink ewWord\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToWordText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToWordText")) . "\">" . $Language->Phrase("ExportToWord") . "</a>";
		$item->Visible = TRUE;

		// Drop down button for export
		$this->ExportOptions->UseButtonGroup = TRUE;
		$this->ExportOptions->UseImageAndText = TRUE;
		$this->ExportOptions->UseDropDownButton = FALSE;
		if ($this->ExportOptions->UseButtonGroup && ew_IsMobile())
			$this->ExportOptions->UseDropDownButton = TRUE;
		$this->ExportOptions->DropDownButtonPhrase = $Language->Phrase("ButtonExport");

		// Add group option item
		$item = &$this->ExportOptions->Add($this->ExportOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;

		// Hide options for export
		if ($this->Export <> "")
			$this->ExportOptions->HideAllOptions();
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$url = preg_replace('/\?cmd=reset(all){0,1}$/i', '', $url); // Remove cmd=reset / cmd=resetall
		$Breadcrumb->Add("report", $this->TableVar, $url, "", $this->TableVar, TRUE);
	}

	// Export report to HTML
	function ExportReportHtml($html) {

		//global $gsExportFile;
		//header('Content-Type: text/html' . (EW_CHARSET <> '' ? ';charset=' . EW_CHARSET : ''));
		//header('Content-Disposition: attachment; filename=' . $gsExportFile . '.html');
		//echo $html;

	}

	// Export report to WORD
	function ExportReportWord($html) {
		global $gsExportFile;
		header('Content-Type: application/vnd.ms-word' . (EW_CHARSET <> '' ? ';charset=' . EW_CHARSET : ''));
		header('Content-Disposition: attachment; filename=' . $gsExportFile . '.doc');
		echo $html;
	}

	// Export report to EXCEL
	function ExportReportExcel($html) {
		global $gsExportFile;
		header('Content-Type: application/vnd.ms-excel' . (EW_CHARSET <> '' ? ';charset=' . EW_CHARSET : ''));
		header('Content-Disposition: attachment; filename=' . $gsExportFile . '.xls');
		echo $html;
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($Report1_report)) $Report1_report = new cReport1_report();

// Page init
$Report1_report->Page_Init();

// Page main
$Report1_report->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$Report1_report->Page_Render();
?>
<?php include_once "header.php" ?>
<?php if ($Report1->Export == "") { ?>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php } ?>
<div class="ewToolbar">
<?php if ($Report1->Export == "") { ?>
<?php $Breadcrumb->Render(); ?>
<?php } ?>
<?php if ($Report1->Export == "") { ?>
<?php echo $Language->SelectionForm(); ?>
<?php } ?>
<div class="clearfix"></div>
</div>
<?php
$Report1_report->RecCnt = 1; // No grouping
if ($Report1_report->DbDetailFilter <> "") {
	if ($Report1_report->ReportFilter <> "") $Report1_report->ReportFilter .= " AND ";
	$Report1_report->ReportFilter .= "(" . $Report1_report->DbDetailFilter . ")";
}
$ReportConn = &$Report1_report->Connection();

// Set up detail SQL
$Report1->CurrentFilter = $Report1_report->ReportFilter;
$Report1_report->ReportSql = $Report1->DetailSQL();

// Load recordset
$Report1_report->Recordset = $ReportConn->Execute($Report1_report->ReportSql);
$Report1_report->RecordExists = !$Report1_report->Recordset->EOF;
?>
<?php if ($Report1->Export == "") { ?>
<?php if ($Report1_report->RecordExists) { ?>
<div class="ewViewExportOptions"><?php $Report1_report->ExportOptions->Render("body") ?></div>
<?php } ?>
<?php } ?>
<?php $Report1_report->ShowPageHeader(); ?>
<table class="ewReportTable">
<?php

	// Get detail records
	$Report1_report->ReportFilter = $Report1_report->DefaultFilter;
	if ($Report1_report->DbDetailFilter <> "") {
		if ($Report1_report->ReportFilter <> "")
			$Report1_report->ReportFilter .= " AND ";
		$Report1_report->ReportFilter .= "(" . $Report1_report->DbDetailFilter . ")";
	}
	if (!$Security->CanReport()) {
		if ($sFilter <> "") $sFilter .= " AND ";
		$sFilter .= "(0=1)";
	}

	// Set up detail SQL
	$Report1->CurrentFilter = $Report1_report->ReportFilter;
	$Report1_report->ReportSql = $Report1->DetailSQL();

	// Load detail records
	$Report1_report->DetailRecordset = $ReportConn->Execute($Report1_report->ReportSql);
	$Report1_report->DtlRecordCount = $Report1_report->DetailRecordset->RecordCount();

	// Initialize aggregates
	if (!$Report1_report->DetailRecordset->EOF) {
		$Report1_report->RecCnt++;
	}
	if ($Report1_report->RecCnt == 1) {
		$Report1_report->ReportCounts[0] = 0;
	}
	$Report1_report->ReportCounts[0] += $Report1_report->DtlRecordCount;
	if ($Report1_report->RecordExists) {
?>
	<tr>
		<td class="ewGroupHeader"><?php echo $Report1->First->FldCaption() ?></td>
		<td class="ewGroupHeader"><?php echo $Report1->Last->FldCaption() ?></td>
		<td class="ewGroupHeader"><?php echo $Report1->Year->FldCaption() ?></td>
		<td class="ewGroupHeader"><?php echo $Report1->From_Date->FldCaption() ?></td>
		<td class="ewGroupHeader"><?php echo $Report1->Through_Date->FldCaption() ?></td>
		<td class="ewGroupHeader"><?php echo $Report1->Monday->FldCaption() ?></td>
		<td class="ewGroupHeader"><?php echo $Report1->Tuesday->FldCaption() ?></td>
		<td class="ewGroupHeader"><?php echo $Report1->Wednesday->FldCaption() ?></td>
		<td class="ewGroupHeader"><?php echo $Report1->Thursday->FldCaption() ?></td>
		<td class="ewGroupHeader"><?php echo $Report1->Friday->FldCaption() ?></td>
		<td class="ewGroupHeader"><?php echo $Report1->Saturday->FldCaption() ?></td>
		<td class="ewGroupHeader"><?php echo $Report1->Sunday->FldCaption() ?></td>
		<td class="ewGroupHeader"><?php echo $Report1->Total_Hours->FldCaption() ?></td>
	</tr>
<?php
	}
	while (!$Report1_report->DetailRecordset->EOF) {
		$Report1_report->RowCnt++;
		$Report1->First->setDbValue($Report1_report->DetailRecordset->fields('First'));
		$Report1->Last->setDbValue($Report1_report->DetailRecordset->fields('Last'));
		$Report1->Year->setDbValue($Report1_report->DetailRecordset->fields('Year'));
		$Report1->From_Date->setDbValue($Report1_report->DetailRecordset->fields('From Date'));
		$Report1->Through_Date->setDbValue($Report1_report->DetailRecordset->fields('Through Date'));
		$Report1->Monday->setDbValue($Report1_report->DetailRecordset->fields('Monday'));
		$Report1->Tuesday->setDbValue($Report1_report->DetailRecordset->fields('Tuesday'));
		$Report1->Wednesday->setDbValue($Report1_report->DetailRecordset->fields('Wednesday'));
		$Report1->Thursday->setDbValue($Report1_report->DetailRecordset->fields('Thursday'));
		$Report1->Friday->setDbValue($Report1_report->DetailRecordset->fields('Friday'));
		$Report1->Saturday->setDbValue($Report1_report->DetailRecordset->fields('Saturday'));
		$Report1->Sunday->setDbValue($Report1_report->DetailRecordset->fields('Sunday'));
		$Report1->Total_Hours->setDbValue($Report1_report->DetailRecordset->fields('Total Hours'));

		// Render for view
		$Report1->RowType = EW_ROWTYPE_VIEW;
		$Report1->ResetAttrs();
		$Report1_report->RenderRow();
?>
	<tr>
		<td<?php echo $Report1->First->CellAttributes() ?>>
<span<?php echo $Report1->First->ViewAttributes() ?>>
<?php echo $Report1->First->ViewValue ?></span>
</td>
		<td<?php echo $Report1->Last->CellAttributes() ?>>
<span<?php echo $Report1->Last->ViewAttributes() ?>>
<?php echo $Report1->Last->ViewValue ?></span>
</td>
		<td<?php echo $Report1->Year->CellAttributes() ?>>
<span<?php echo $Report1->Year->ViewAttributes() ?>>
<?php echo $Report1->Year->ViewValue ?></span>
</td>
		<td<?php echo $Report1->From_Date->CellAttributes() ?>>
<span<?php echo $Report1->From_Date->ViewAttributes() ?>>
<?php echo $Report1->From_Date->ViewValue ?></span>
</td>
		<td<?php echo $Report1->Through_Date->CellAttributes() ?>>
<span<?php echo $Report1->Through_Date->ViewAttributes() ?>>
<?php echo $Report1->Through_Date->ViewValue ?></span>
</td>
		<td<?php echo $Report1->Monday->CellAttributes() ?>>
<span<?php echo $Report1->Monday->ViewAttributes() ?>>
<?php echo $Report1->Monday->ViewValue ?></span>
</td>
		<td<?php echo $Report1->Tuesday->CellAttributes() ?>>
<span<?php echo $Report1->Tuesday->ViewAttributes() ?>>
<?php echo $Report1->Tuesday->ViewValue ?></span>
</td>
		<td<?php echo $Report1->Wednesday->CellAttributes() ?>>
<span<?php echo $Report1->Wednesday->ViewAttributes() ?>>
<?php echo $Report1->Wednesday->ViewValue ?></span>
</td>
		<td<?php echo $Report1->Thursday->CellAttributes() ?>>
<span<?php echo $Report1->Thursday->ViewAttributes() ?>>
<?php echo $Report1->Thursday->ViewValue ?></span>
</td>
		<td<?php echo $Report1->Friday->CellAttributes() ?>>
<span<?php echo $Report1->Friday->ViewAttributes() ?>>
<?php echo $Report1->Friday->ViewValue ?></span>
</td>
		<td<?php echo $Report1->Saturday->CellAttributes() ?>>
<span<?php echo $Report1->Saturday->ViewAttributes() ?>>
<?php echo $Report1->Saturday->ViewValue ?></span>
</td>
		<td<?php echo $Report1->Sunday->CellAttributes() ?>>
<span<?php echo $Report1->Sunday->ViewAttributes() ?>>
<?php echo $Report1->Sunday->ViewValue ?></span>
</td>
		<td<?php echo $Report1->Total_Hours->CellAttributes() ?>>
<span<?php echo $Report1->Total_Hours->ViewAttributes() ?>>
<?php echo $Report1->Total_Hours->ViewValue ?></span>
</td>
	</tr>
<?php
		$Report1_report->DetailRecordset->MoveNext();
	}
	$Report1_report->DetailRecordset->Close();
?>
<?php if ($Report1_report->RecordExists) { ?>
	<tr><td colspan=13>&nbsp;<br></td></tr>
	<tr><td colspan=13 class="ewGrandSummary"><?php echo $Language->Phrase("RptGrandTotal") ?>&nbsp;(<?php echo ew_FormatNumber($Report1_report->ReportCounts[0], 0) ?>&nbsp;<?php echo $Language->Phrase("RptDtlRec") ?>)</td></tr>
<?php } ?>
<?php if ($Report1_report->RecordExists) { ?>
	<tr><td colspan=13>&nbsp;<br></td></tr>
<?php } else { ?>
	<tr><td><?php echo $Language->Phrase("NoRecord") ?></td></tr>
<?php } ?>
</table>
<?php
$Report1_report->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<?php if ($Report1->Export == "") { ?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php } ?>
<?php include_once "footer.php" ?>
<?php
$Report1_report->Page_Terminate();
?>
