<?php
if (session_id() == "") session_start(); // Init session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg13.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql13.php") ?>
<?php include_once "phpfn13.php" ?>
<?php include_once "case_notesinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn13.php" ?>
<?php

//
// Page class
//

$case_notes_delete = NULL; // Initialize page object first

class ccase_notes_delete extends ccase_notes {

	// Page ID
	var $PageID = 'delete';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'case_notes';

	// Page object name
	var $PageObjName = 'case_notes_delete';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}
	var $AuditTrailOnAdd = FALSE;
	var $AuditTrailOnEdit = FALSE;
	var $AuditTrailOnDelete = TRUE;
	var $AuditTrailOnView = FALSE;
	var $AuditTrailOnViewData = FALSE;
	var $AuditTrailOnSearch = FALSE;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (case_notes)
		if (!isset($GLOBALS["case_notes"]) || get_class($GLOBALS["case_notes"]) == "ccase_notes") {
			$GLOBALS["case_notes"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["case_notes"];
		}

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'delete', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'case_notes', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	//
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanDelete()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("case_noteslist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
			if (strval($Security->CurrentUserID()) == "") {
				$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
				$this->Page_Terminate(ew_GetUrl("case_noteslist.php"));
			}
		}
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action
		$this->weeknumber->SetVisibility();
		$this->counselor->SetVisibility();
		$this->client->SetVisibility();
		$this->outcome_note->SetVisibility();
		$this->client_met_outcome->SetVisibility();
		$this->case_notes->SetVisibility();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $case_notes;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($case_notes);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}
	var $DbMasterFilter = "";
	var $DbDetailFilter = "";
	var $StartRec;
	var $TotalRecs = 0;
	var $RecCnt;
	var $RecKeys = array();
	var $Recordset;
	var $StartRowCnt = 1;
	var $RowCnt = 0;

	//
	// Page main
	//
	function Page_Main() {
		global $Language;

		// Set up Breadcrumb
		$this->SetupBreadcrumb();

		// Load key parameters
		$this->RecKeys = $this->GetRecordKeys(); // Load record keys
		$sFilter = $this->GetKeyFilter();
		if ($sFilter == "")
			$this->Page_Terminate("case_noteslist.php"); // Prevent SQL injection, return to list

		// Set up filter (SQL WHHERE clause) and get return SQL
		// SQL constructor in case_notes class, case_notesinfo.php

		$this->CurrentFilter = $sFilter;

		// Check if valid user id
		$conn = &$this->Connection();
		$sql = $this->GetSQL($this->CurrentFilter, "");
		if ($this->Recordset = ew_LoadRecordset($sql, $conn)) {
			$res = TRUE;
			while (!$this->Recordset->EOF) {
				$this->LoadRowValues($this->Recordset);
				if (!$this->ShowOptionLink('delete')) {
					$sUserIdMsg = $Language->Phrase("NoDeletePermission");
					$this->setFailureMessage($sUserIdMsg);
					$res = FALSE;
					break;
				}
				$this->Recordset->MoveNext();
			}
			$this->Recordset->Close();
			if (!$res) $this->Page_Terminate("case_noteslist.php"); // Return to list
		}

		// Get action
		if (@$_POST["a_delete"] <> "") {
			$this->CurrentAction = $_POST["a_delete"];
		} elseif (@$_GET["a_delete"] == "1") {
			$this->CurrentAction = "D"; // Delete record directly
		} else {
			$this->CurrentAction = "I"; // Display record
		}
		if ($this->CurrentAction == "D") {
			$this->SendEmail = TRUE; // Send email on delete success
			if ($this->DeleteRows()) { // Delete rows
				if ($this->getSuccessMessage() == "")
					$this->setSuccessMessage($Language->Phrase("DeleteSuccess")); // Set up success message
				$this->Page_Terminate($this->getReturnUrl()); // Return to caller
			} else { // Delete failed
				$this->CurrentAction = "I"; // Display record
			}
		}
		if ($this->CurrentAction == "I") { // Load records for display
			if ($this->Recordset = $this->LoadRecordset())
				$this->TotalRecs = $this->Recordset->RecordCount(); // Get record count
			if ($this->TotalRecs <= 0) { // No record found, exit
				if ($this->Recordset)
					$this->Recordset->Close();
				$this->Page_Terminate("case_noteslist.php"); // Return to list
			}
		}
	}

	// Load recordset
	function LoadRecordset($offset = -1, $rowcnt = -1) {

		// Load List page SQL
		$sSql = $this->SelectSQL();
		$conn = &$this->Connection();

		// Load recordset
		$dbtype = ew_GetConnectionType($this->DBID);
		if ($this->UseSelectLimit) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			if ($dbtype == "MSSQL") {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset, array("_hasOrderBy" => trim($this->getOrderBy()) || trim($this->getSessionOrderBy())));
			} else {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset);
			}
			$conn->raiseErrorFn = '';
		} else {
			$rs = ew_LoadRecordset($sSql, $conn);
		}

		// Call Recordset Selected event
		$this->Recordset_Selected($rs);
		return $rs;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->start->setDbValue($rs->fields('start'));
		$this->end->setDbValue($rs->fields('end'));
		$this->weeknumber->setDbValue($rs->fields('weeknumber'));
		$this->counselor->setDbValue($rs->fields('counselor'));
		$this->dbkey_counselor->setDbValue($rs->fields('dbkey_counselor'));
		$this->date->setDbValue($rs->fields('date'));
		$this->client->setDbValue($rs->fields('client'));
		$this->dbkey_client->setDbValue($rs->fields('dbkey_client'));
		$this->outcome_note->setDbValue($rs->fields('outcome_note'));
		$this->outcome->setDbValue($rs->fields('outcome'));
		$this->client_met_outcome->setDbValue($rs->fields('client_met_outcome'));
		$this->how_objective->setDbValue($rs->fields('how_objective'));
		$this->case_notes->setDbValue($rs->fields('case_notes'));
		$this->create_date->setDbValue($rs->fields('create_date'));
		$this->update_date->setDbValue($rs->fields('update_date'));
		$this->updated_by->setDbValue($rs->fields('updated_by'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey->DbValue = $row['dbkey'];
		$this->start->DbValue = $row['start'];
		$this->end->DbValue = $row['end'];
		$this->weeknumber->DbValue = $row['weeknumber'];
		$this->counselor->DbValue = $row['counselor'];
		$this->dbkey_counselor->DbValue = $row['dbkey_counselor'];
		$this->date->DbValue = $row['date'];
		$this->client->DbValue = $row['client'];
		$this->dbkey_client->DbValue = $row['dbkey_client'];
		$this->outcome_note->DbValue = $row['outcome_note'];
		$this->outcome->DbValue = $row['outcome'];
		$this->client_met_outcome->DbValue = $row['client_met_outcome'];
		$this->how_objective->DbValue = $row['how_objective'];
		$this->case_notes->DbValue = $row['case_notes'];
		$this->create_date->DbValue = $row['create_date'];
		$this->update_date->DbValue = $row['update_date'];
		$this->updated_by->DbValue = $row['updated_by'];
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Call Row_Rendering event

		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey

		$this->dbkey->CellCssStyle = "white-space: nowrap;";

		// start
		$this->start->CellCssStyle = "white-space: nowrap;";

		// end
		$this->end->CellCssStyle = "white-space: nowrap;";

		// weeknumber
		// counselor
		// dbkey_counselor

		$this->dbkey_counselor->CellCssStyle = "white-space: nowrap;";

		// date
		$this->date->CellCssStyle = "white-space: nowrap;";

		// client
		// dbkey_client

		$this->dbkey_client->CellCssStyle = "white-space: nowrap;";

		// outcome_note
		// outcome

		$this->outcome->CellCssStyle = "white-space: nowrap;";

		// client_met_outcome
		// how_objective
		// case_notes
		// create_date

		$this->create_date->CellCssStyle = "white-space: nowrap;";

		// update_date
		$this->update_date->CellCssStyle = "white-space: nowrap;";

		// updated_by
		$this->updated_by->CellCssStyle = "white-space: nowrap;";
		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// weeknumber
		if (strval($this->weeknumber->CurrentValue) <> "") {
			$sFilterWrk = "WEEKOFYEAR(adddate(case_notes.date, INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY))" . ew_SearchString("=", $this->weeknumber->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT WEEKOFYEAR(adddate(case_notes.date, INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY)), adddate(case_notes.date,  INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY) AS `DispFld`, adddate(case_notes.date, INTERVAL 8-DAYOFWEEK(case_notes.date) DAY) AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `case_notes`";
		$sWhereWrk = "";
		$this->weeknumber->LookupFilters = array("df1" => "0", "df2" => "0");
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->weeknumber, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = ew_FormatDateTime($rswrk->fields('DispFld'), 0);
				$arwrk[2] = ew_FormatDateTime($rswrk->fields('Disp2Fld'), 0);
				$this->weeknumber->ViewValue = $this->weeknumber->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->weeknumber->ViewValue = $this->weeknumber->CurrentValue;
			}
		} else {
			$this->weeknumber->ViewValue = NULL;
		}
		$this->weeknumber->ViewCustomAttributes = "";

		// counselor
		if (strval($this->counselor->CurrentValue) <> "") {
			$sFilterWrk = "(SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor)" . ew_SearchString("=", $this->counselor->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor), (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `case_notes`";
		$sWhereWrk = "";
		$this->counselor->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->counselor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->counselor->ViewValue = $this->counselor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->counselor->ViewValue = $this->counselor->CurrentValue;
			}
		} else {
			$this->counselor->ViewValue = NULL;
		}
		$this->counselor->ViewCustomAttributes = "";

		// client
		$this->client->ViewValue = $this->client->CurrentValue;
		$this->client->ViewCustomAttributes = "";

		// outcome_note
		$this->outcome_note->ViewValue = $this->outcome_note->CurrentValue;
		$this->outcome_note->ViewCustomAttributes = "";

		// client_met_outcome
		if (strval($this->client_met_outcome->CurrentValue) <> "") {
			$this->client_met_outcome->ViewValue = $this->client_met_outcome->OptionCaption($this->client_met_outcome->CurrentValue);
		} else {
			$this->client_met_outcome->ViewValue = NULL;
		}
		$this->client_met_outcome->ViewCustomAttributes = "";

		// case_notes
		$this->case_notes->ViewValue = $this->case_notes->CurrentValue;
		$this->case_notes->ViewCustomAttributes = "";

			// weeknumber
			$this->weeknumber->LinkCustomAttributes = "";
			$this->weeknumber->HrefValue = "";
			$this->weeknumber->TooltipValue = "";

			// counselor
			$this->counselor->LinkCustomAttributes = "";
			$this->counselor->HrefValue = "";
			$this->counselor->TooltipValue = "";

			// client
			$this->client->LinkCustomAttributes = "";
			$this->client->HrefValue = "";
			$this->client->TooltipValue = "";

			// outcome_note
			$this->outcome_note->LinkCustomAttributes = "";
			$this->outcome_note->HrefValue = "";
			$this->outcome_note->TooltipValue = "";

			// client_met_outcome
			$this->client_met_outcome->LinkCustomAttributes = "";
			$this->client_met_outcome->HrefValue = "";
			$this->client_met_outcome->TooltipValue = "";

			// case_notes
			$this->case_notes->LinkCustomAttributes = "";
			$this->case_notes->HrefValue = "";
			$this->case_notes->TooltipValue = "";
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	//
	// Delete records based on current filter
	//
	function DeleteRows() {
		global $Language, $Security;
		if (!$Security->CanDelete()) {
			$this->setFailureMessage($Language->Phrase("NoDeletePermission")); // No delete permission
			return FALSE;
		}
		$DeleteRows = TRUE;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
		$rs = $conn->Execute($sSql);
		$conn->raiseErrorFn = '';
		if ($rs === FALSE) {
			return FALSE;
		} elseif ($rs->EOF) {
			$this->setFailureMessage($Language->Phrase("NoRecord")); // No record found
			$rs->Close();
			return FALSE;

		//} else {
		//	$this->LoadRowValues($rs); // Load row values

		}
		$rows = ($rs) ? $rs->GetRows() : array();
		$conn->BeginTrans();
		if ($this->AuditTrailOnDelete) $this->WriteAuditTrailDummy($Language->Phrase("BatchDeleteBegin")); // Batch delete begin

		// Clone old rows
		$rsold = $rows;
		if ($rs)
			$rs->Close();

		// Call row deleting event
		if ($DeleteRows) {
			foreach ($rsold as $row) {
				$DeleteRows = $this->Row_Deleting($row);
				if (!$DeleteRows) break;
			}
		}
		if ($DeleteRows) {
			$sKey = "";
			foreach ($rsold as $row) {
				$sThisKey = "";
				if ($sThisKey <> "") $sThisKey .= $GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"];
				$sThisKey .= $row['dbkey'];
				$this->LoadDbValues($row);
				$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
				$DeleteRows = $this->Delete($row); // Delete
				$conn->raiseErrorFn = '';
				if ($DeleteRows === FALSE)
					break;
				if ($sKey <> "") $sKey .= ", ";
				$sKey .= $sThisKey;
			}
		} else {

			// Set up error message
			if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

				// Use the message, do nothing
			} elseif ($this->CancelMessage <> "") {
				$this->setFailureMessage($this->CancelMessage);
				$this->CancelMessage = "";
			} else {
				$this->setFailureMessage($Language->Phrase("DeleteCancelled"));
			}
		}
		if ($DeleteRows) {
			$conn->CommitTrans(); // Commit the changes
			if ($DeleteRows) {
				foreach ($rsold as $row)
					$this->WriteAuditTrailOnDelete($row);
			}
			if ($this->AuditTrailOnDelete) $this->WriteAuditTrailDummy($Language->Phrase("BatchDeleteSuccess")); // Batch delete success
		} else {
			$conn->RollbackTrans(); // Rollback changes
			if ($this->AuditTrailOnDelete) $this->WriteAuditTrailDummy($Language->Phrase("BatchDeleteRollback")); // Batch delete rollback
		}

		// Call Row Deleted event
		if ($DeleteRows) {
			foreach ($rsold as $row) {
				$this->Row_Deleted($row);
			}
		}
		return $DeleteRows;
	}

	// Show link optionally based on User ID
	function ShowOptionLink($id = "") {
		global $Security;
		if ($Security->IsLoggedIn() && !$Security->IsAdmin() && !$this->UserIDAllow($id))
			return $Security->IsValidUserID($this->dbkey_counselor->CurrentValue);
		return TRUE;
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, $this->AddMasterUrl("case_noteslist.php"), "", $this->TableVar, TRUE);
		$PageId = "delete";
		$Breadcrumb->Add("delete", $PageId, $url);
	}

	// Setup lookup filters of a field
	function SetupLookupFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Setup AutoSuggest filters of a field
	function SetupAutoSuggestFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Write Audit Trail start/end for grid update
	function WriteAuditTrailDummy($typ) {
		$table = 'case_notes';
		$usr = CurrentUserID();
		ew_WriteAuditTrail("log", ew_StdCurrentDateTime(), ew_ScriptName(), $usr, $typ, $table, "", "", "", "");
	}

	// Write Audit Trail (delete page)
	function WriteAuditTrailOnDelete(&$rs) {
		global $Language;
		if (!$this->AuditTrailOnDelete) return;
		$table = 'case_notes';

		// Get key value
		$key = "";
		if ($key <> "")
			$key .= $GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"];
		$key .= $rs['dbkey'];

		// Write Audit Trail
		$dt = ew_StdCurrentDateTime();
		$id = ew_ScriptName();
		$curUser = CurrentUserID();
		foreach (array_keys($rs) as $fldname) {
			if (array_key_exists($fldname, $this->fields) && $this->fields[$fldname]->FldDataType <> EW_DATATYPE_BLOB) { // Ignore BLOB fields
				if ($this->fields[$fldname]->FldHtmlTag == "PASSWORD") {
					$oldvalue = $Language->Phrase("PasswordMask"); // Password Field
				} elseif ($this->fields[$fldname]->FldDataType == EW_DATATYPE_MEMO) {
					if (EW_AUDIT_TRAIL_TO_DATABASE)
						$oldvalue = $rs[$fldname];
					else
						$oldvalue = "[MEMO]"; // Memo field
				} elseif ($this->fields[$fldname]->FldDataType == EW_DATATYPE_XML) {
					$oldvalue = "[XML]"; // XML field
				} else {
					$oldvalue = $rs[$fldname];
				}
				ew_WriteAuditTrail("log", $dt, $id, $curUser, "D", $table, $fldname, $key, $oldvalue, "");
			}
		}
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($case_notes_delete)) $case_notes_delete = new ccase_notes_delete();

// Page init
$case_notes_delete->Page_Init();

// Page main
$case_notes_delete->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$case_notes_delete->Page_Render();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "delete";
var CurrentForm = fcase_notesdelete = new ew_Form("fcase_notesdelete", "delete");

// Form_CustomValidate event
fcase_notesdelete.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fcase_notesdelete.ValidateRequired = true;
<?php } else { ?>
fcase_notesdelete.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fcase_notesdelete.Lists["x_weeknumber"] = {"LinkField":"x_weeknumber","Ajax":true,"AutoFill":false,"DisplayFields":["x_start","x_end","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"case_notes"};
fcase_notesdelete.Lists["x_counselor"] = {"LinkField":"x_counselor","Ajax":true,"AutoFill":false,"DisplayFields":["x_counselor","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"case_notes"};
fcase_notesdelete.Lists["x_client_met_outcome"] = {"LinkField":"","Ajax":null,"AutoFill":false,"DisplayFields":["","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
fcase_notesdelete.Lists["x_client_met_outcome"].Options = <?php echo json_encode($case_notes->client_met_outcome->Options()) ?>;

// Form object for search
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<div class="ewToolbar">
<?php $Breadcrumb->Render(); ?>
<?php echo $Language->SelectionForm(); ?>
<div class="clearfix"></div>
</div>
<?php $case_notes_delete->ShowPageHeader(); ?>
<?php
$case_notes_delete->ShowMessage();
?>
<form name="fcase_notesdelete" id="fcase_notesdelete" class="form-inline ewForm ewDeleteForm" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($case_notes_delete->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $case_notes_delete->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="case_notes">
<input type="hidden" name="a_delete" id="a_delete" value="D">
<?php foreach ($case_notes_delete->RecKeys as $key) { ?>
<?php $keyvalue = is_array($key) ? implode($EW_COMPOSITE_KEY_SEPARATOR, $key) : $key; ?>
<input type="hidden" name="key_m[]" value="<?php echo ew_HtmlEncode($keyvalue) ?>">
<?php } ?>
<div class="ewGrid">
<div class="<?php if (ew_IsResponsiveLayout()) { echo "table-responsive "; } ?>ewGridMiddlePanel">
<table class="table ewTable">
<?php echo $case_notes->TableCustomInnerHtml ?>
	<thead>
	<tr class="ewTableHeader">
<?php if ($case_notes->weeknumber->Visible) { // weeknumber ?>
		<th><span id="elh_case_notes_weeknumber" class="case_notes_weeknumber"><?php echo $case_notes->weeknumber->FldCaption() ?></span></th>
<?php } ?>
<?php if ($case_notes->counselor->Visible) { // counselor ?>
		<th><span id="elh_case_notes_counselor" class="case_notes_counselor"><?php echo $case_notes->counselor->FldCaption() ?></span></th>
<?php } ?>
<?php if ($case_notes->client->Visible) { // client ?>
		<th><span id="elh_case_notes_client" class="case_notes_client"><?php echo $case_notes->client->FldCaption() ?></span></th>
<?php } ?>
<?php if ($case_notes->outcome_note->Visible) { // outcome_note ?>
		<th><span id="elh_case_notes_outcome_note" class="case_notes_outcome_note"><?php echo $case_notes->outcome_note->FldCaption() ?></span></th>
<?php } ?>
<?php if ($case_notes->client_met_outcome->Visible) { // client_met_outcome ?>
		<th><span id="elh_case_notes_client_met_outcome" class="case_notes_client_met_outcome"><?php echo $case_notes->client_met_outcome->FldCaption() ?></span></th>
<?php } ?>
<?php if ($case_notes->case_notes->Visible) { // case_notes ?>
		<th><span id="elh_case_notes_case_notes" class="case_notes_case_notes"><?php echo $case_notes->case_notes->FldCaption() ?></span></th>
<?php } ?>
	</tr>
	</thead>
	<tbody>
<?php
$case_notes_delete->RecCnt = 0;
$i = 0;
while (!$case_notes_delete->Recordset->EOF) {
	$case_notes_delete->RecCnt++;
	$case_notes_delete->RowCnt++;

	// Set row properties
	$case_notes->ResetAttrs();
	$case_notes->RowType = EW_ROWTYPE_VIEW; // View

	// Get the field contents
	$case_notes_delete->LoadRowValues($case_notes_delete->Recordset);

	// Render row
	$case_notes_delete->RenderRow();
?>
	<tr<?php echo $case_notes->RowAttributes() ?>>
<?php if ($case_notes->weeknumber->Visible) { // weeknumber ?>
		<td<?php echo $case_notes->weeknumber->CellAttributes() ?>>
<span id="el<?php echo $case_notes_delete->RowCnt ?>_case_notes_weeknumber" class="case_notes_weeknumber">
<span<?php echo $case_notes->weeknumber->ViewAttributes() ?>>
<?php echo $case_notes->weeknumber->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($case_notes->counselor->Visible) { // counselor ?>
		<td<?php echo $case_notes->counselor->CellAttributes() ?>>
<span id="el<?php echo $case_notes_delete->RowCnt ?>_case_notes_counselor" class="case_notes_counselor">
<span<?php echo $case_notes->counselor->ViewAttributes() ?>>
<?php echo $case_notes->counselor->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($case_notes->client->Visible) { // client ?>
		<td<?php echo $case_notes->client->CellAttributes() ?>>
<span id="el<?php echo $case_notes_delete->RowCnt ?>_case_notes_client" class="case_notes_client">
<span<?php echo $case_notes->client->ViewAttributes() ?>>
<?php echo $case_notes->client->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($case_notes->outcome_note->Visible) { // outcome_note ?>
		<td<?php echo $case_notes->outcome_note->CellAttributes() ?>>
<span id="el<?php echo $case_notes_delete->RowCnt ?>_case_notes_outcome_note" class="case_notes_outcome_note">
<span<?php echo $case_notes->outcome_note->ViewAttributes() ?>>
<?php echo $case_notes->outcome_note->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($case_notes->client_met_outcome->Visible) { // client_met_outcome ?>
		<td<?php echo $case_notes->client_met_outcome->CellAttributes() ?>>
<span id="el<?php echo $case_notes_delete->RowCnt ?>_case_notes_client_met_outcome" class="case_notes_client_met_outcome">
<span<?php echo $case_notes->client_met_outcome->ViewAttributes() ?>>
<?php echo $case_notes->client_met_outcome->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($case_notes->case_notes->Visible) { // case_notes ?>
		<td<?php echo $case_notes->case_notes->CellAttributes() ?>>
<span id="el<?php echo $case_notes_delete->RowCnt ?>_case_notes_case_notes" class="case_notes_case_notes">
<span<?php echo $case_notes->case_notes->ViewAttributes() ?>>
<?php echo $case_notes->case_notes->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
	</tr>
<?php
	$case_notes_delete->Recordset->MoveNext();
}
$case_notes_delete->Recordset->Close();
?>
</tbody>
</table>
</div>
</div>
<div>
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit"><?php echo $Language->Phrase("DeleteBtn") ?></button>
<button class="btn btn-default ewButton" name="btnCancel" id="btnCancel" type="button" data-href="<?php echo $case_notes_delete->getReturnUrl() ?>"><?php echo $Language->Phrase("CancelBtn") ?></button>
</div>
</form>
<script type="text/javascript">
fcase_notesdelete.Init();
</script>
<?php
$case_notes_delete->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$case_notes_delete->Page_Terminate();
?>
