<?php
if (session_id() == "") session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg9.php" ?>
<?php include_once "ewmysql9.php" ?>
<?php include_once "phpfn9.php" ?>
<?php include_once "client_activity_activitiesinfo.php" ?>
<?php include_once "userfn9.php" ?>
<?php

//
// Page class
//

$client_activity_activities_list = NULL; // Initialize page object first

class cclient_activity_activities_list extends cclient_activity_activities {

	// Page ID
	var $PageID = 'list';

	// Project ID
	var $ProjectID = "{095601E1-93A8-4664-8CCA-D6A58AA0A39D}";

	// Table name
	var $TableName = 'client_activity_activities';

	// Page object name
	var $PageObjName = 'client_activity_activities_list';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Page URLs
	var $AddUrl;
	var $EditUrl;
	var $CopyUrl;
	var $DeleteUrl;
	var $ViewUrl;
	var $ListUrl;

	// Export URLs
	var $ExportPrintUrl;
	var $ExportHtmlUrl;
	var $ExportExcelUrl;
	var $ExportWordUrl;
	var $ExportXmlUrl;
	var $ExportCsvUrl;
	var $ExportPdfUrl;

	// Update URLs
	var $InlineAddUrl;
	var $InlineCopyUrl;
	var $InlineEditUrl;
	var $GridAddUrl;
	var $GridEditUrl;
	var $MultiDeleteUrl;
	var $MultiUpdateUrl;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			$html .= "<p class=\"ewMessage\">" . $sMessage . "</p>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			$html .= "<table class=\"ewMessageTable\"><tr><td class=\"ewWarningIcon\"></td><td class=\"ewWarningMessage\">" . $sWarningMessage . "</td></tr></table>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			$html .= "<table class=\"ewMessageTable\"><tr><td class=\"ewSuccessIcon\"></td><td class=\"ewSuccessMessage\">" . $sSuccessMessage . "</td></tr></table>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			$html .= "<table class=\"ewMessageTable\"><tr><td class=\"ewErrorIcon\"></td><td class=\"ewErrorMessage\">" . $sErrorMessage . "</td></tr></table>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p class=\"phpmaker\">" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Fotoer exists, display
			echo "<p class=\"phpmaker\">" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language, $UserAgent;

		// User agent
		$UserAgent = ew_UserAgent();
		$GLOBALS["Page"] = &$this;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (client_activity_activities)
		if (!isset($GLOBALS["client_activity_activities"])) {
			$GLOBALS["client_activity_activities"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["client_activity_activities"];
		}

		// Initialize URLs
		$this->ExportPrintUrl = $this->PageUrl() . "export=print";
		$this->ExportExcelUrl = $this->PageUrl() . "export=excel";
		$this->ExportWordUrl = $this->PageUrl() . "export=word";
		$this->ExportHtmlUrl = $this->PageUrl() . "export=html";
		$this->ExportXmlUrl = $this->PageUrl() . "export=xml";
		$this->ExportCsvUrl = $this->PageUrl() . "export=csv";
		$this->ExportPdfUrl = $this->PageUrl() . "export=pdf";
		$this->AddUrl = "client_activity_activitiesadd.php";
		$this->InlineAddUrl = $this->PageUrl() . "a=add";
		$this->GridAddUrl = $this->PageUrl() . "a=gridadd";
		$this->GridEditUrl = $this->PageUrl() . "a=gridedit";
		$this->MultiDeleteUrl = "client_activity_activitiesdelete.php";
		$this->MultiUpdateUrl = "client_activity_activitiesupdate.php";

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'list', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'client_activity_activities', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect();

		// List options
		$this->ListOptions = new cListOptions();
		$this->ListOptions->TableVar = $this->TableVar;

		// Export options
		$this->ExportOptions = new cListOptions();
		$this->ExportOptions->Tag = "span";
		$this->ExportOptions->TagClassName = "ewExportOption";
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// Get grid add count
		$gridaddcnt = @$_GET[EW_TABLE_GRID_ADD_ROW_COUNT];
		if (is_numeric($gridaddcnt) && $gridaddcnt > 0)
			$this->GridAddRowCount = $gridaddcnt;

		// Set up list options
		$this->SetupListOptions();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"];
		$this->dbkey->Visible = !$this->IsAdd() && !$this->IsCopy() && !$this->IsGridAdd();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $conn;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();
		$this->Page_Redirecting($url);

		 // Close connection
		$conn->Close();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}

	// Class variables
	var $ListOptions; // List options
	var $ExportOptions; // Export options
	var $DisplayRecs = 20;
	var $StartRec;
	var $StopRec;
	var $TotalRecs = 0;
	var $RecRange = 10;
	var $Pager;
	var $SearchWhere = ""; // Search WHERE clause
	var $RecCnt = 0; // Record count
	var $EditRowCnt;
	var $StartRowCnt = 1;
	var $RowCnt = 0;
	var $Attrs = array(); // Row attributes and cell attributes
	var $RowIndex = 0; // Row index
	var $KeyCount = 0; // Key count
	var $RowAction = ""; // Row action
	var $RowOldKey = ""; // Row old key (for copy)
	var $RecPerRow = 0;
	var $ColCnt = 0;
	var $DbMasterFilter = ""; // Master filter
	var $DbDetailFilter = ""; // Detail filter
	var $MasterRecordExists;	
	var $MultiSelectKey;
	var $Command;
	var $Recordset;
	var $OldRecordset;

	//
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError, $gsSearchError, $Security;

		// Search filters
		$sSrchAdvanced = ""; // Advanced search filter
		$sSrchBasic = ""; // Basic search filter
		$sFilter = "";

		// Get command
		$this->Command = strtolower(@$_GET["cmd"]);
		if ($this->IsPageRequest()) { // Validate request

			// Handle reset command
			$this->ResetCmd();

			// Hide all options
			if ($this->Export <> "" ||
				$this->CurrentAction == "gridadd" ||
				$this->CurrentAction == "gridedit") {
				$this->ListOptions->HideAllOptions();
				$this->ExportOptions->HideAllOptions();
			}

			// Set up sorting order
			$this->SetUpSortOrder();
		}

		// Restore display records
		if ($this->getRecordsPerPage() <> "") {
			$this->DisplayRecs = $this->getRecordsPerPage(); // Restore from Session
		} else {
			$this->DisplayRecs = 20; // Load default
		}

		// Load Sorting Order
		$this->LoadSortOrder();

		// Build filter
		$sFilter = "";
		ew_AddFilter($sFilter, $this->DbDetailFilter);
		ew_AddFilter($sFilter, $this->SearchWhere);

		// Set up filter in session
		$this->setSessionWhere($sFilter);
		$this->CurrentFilter = "";
	}

	// Build filter for all keys
	function BuildKeyFilter() {
		global $objForm;
		$sWrkFilter = "";

		// Update row index and get row key
		$rowindex = 1;
		$objForm->Index = $rowindex;
		$sThisKey = strval($objForm->GetValue("k_key"));
		while ($sThisKey <> "") {
			if ($this->SetupKeyValues($sThisKey)) {
				$sFilter = $this->KeyFilter();
				if ($sWrkFilter <> "") $sWrkFilter .= " OR ";
				$sWrkFilter .= $sFilter;
			} else {
				$sWrkFilter = "0=1";
				break;
			}

			// Update row index and get row key
			$rowindex++; // next row
			$objForm->Index = $rowindex;
			$sThisKey = strval($objForm->GetValue("k_key"));
		}
		return $sWrkFilter;
	}

	// Set up key values
	function SetupKeyValues($key) {
		$arrKeyFlds = explode($GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"], $key);
		if (count($arrKeyFlds) >= 1) {
			$this->dbkey->setFormValue($arrKeyFlds[0]);
			if (!is_numeric($this->dbkey->FormValue))
				return FALSE;
		}
		return TRUE;
	}

	// Set up sort parameters
	function SetUpSortOrder() {

		// Check for "order" parameter
		if (@$_GET["order"] <> "") {
			$this->CurrentOrder = ew_StripSlashes(@$_GET["order"]);
			$this->CurrentOrderType = @$_GET["ordertype"];
			$this->UpdateSort($this->dbkey); // dbkey
			$this->UpdateSort($this->dbkey_client_activity); // dbkey_client_activity
			$this->setStartRecordNumber(1); // Reset start position
		}
	}

	// Load sort order parameters
	function LoadSortOrder() {
		$sOrderBy = $this->getSessionOrderBy(); // Get ORDER BY from Session
		if ($sOrderBy == "") {
			if ($this->SqlOrderBy() <> "") {
				$sOrderBy = $this->SqlOrderBy();
				$this->setSessionOrderBy($sOrderBy);
			}
		}
	}

	// Reset command
	// cmd=reset (Reset search parameters)
	// cmd=resetall (Reset search and master/detail parameters)
	// cmd=resetsort (Reset sort parameters)
	function ResetCmd() {

		// Check if reset command
		if (substr($this->Command,0,5) == "reset") {

			// Reset sorting order
			if ($this->Command == "resetsort") {
				$sOrderBy = "";
				$this->setSessionOrderBy($sOrderBy);
				$this->dbkey->setSort("");
				$this->dbkey_client_activity->setSort("");
			}

			// Reset start position
			$this->StartRec = 1;
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Set up list options
	function SetupListOptions() {
		global $Security, $Language;

		// "view"
		$item = &$this->ListOptions->Add("view");
		$item->CssStyle = "white-space: nowrap;";
		$item->Visible = TRUE;
		$item->OnLeft = FALSE;

		// "edit"
		$item = &$this->ListOptions->Add("edit");
		$item->CssStyle = "white-space: nowrap;";
		$item->Visible = TRUE;
		$item->OnLeft = FALSE;

		// "copy"
		$item = &$this->ListOptions->Add("copy");
		$item->CssStyle = "white-space: nowrap;";
		$item->Visible = TRUE;
		$item->OnLeft = FALSE;

		// "delete"
		$item = &$this->ListOptions->Add("delete");
		$item->CssStyle = "white-space: nowrap;";
		$item->Visible = TRUE;
		$item->OnLeft = FALSE;

		// Call ListOptions_Load event
		$this->ListOptions_Load();
	}

	// Render list options
	function RenderListOptions() {
		global $Security, $Language, $objForm;
		$this->ListOptions->LoadDefault();

		// "view"
		$oListOpt = &$this->ListOptions->Items["view"];
		if (TRUE)
			$oListOpt->Body = "<a class=\"ewRowLink\" href=\"" . $this->ViewUrl . "\">" . $Language->Phrase("ViewLink") . "</a>";

		// "edit"
		$oListOpt = &$this->ListOptions->Items["edit"];
		if (TRUE) {
			$oListOpt->Body = "<a class=\"ewRowLink\" href=\"" . $this->EditUrl . "\">" . $Language->Phrase("EditLink") . "</a>";
		}

		// "copy"
		$oListOpt = &$this->ListOptions->Items["copy"];
		if (TRUE) {
			$oListOpt->Body = "<a class=\"ewRowLink\" href=\"" . $this->CopyUrl . "\">" . $Language->Phrase("CopyLink") . "</a>";
		}

		// "delete"
		$oListOpt = &$this->ListOptions->Items["delete"];
		if (TRUE)
			$oListOpt->Body = "<a class=\"ewRowLink\"" . "" . " href=\"" . $this->DeleteUrl . "\">" . $Language->Phrase("DeleteLink") . "</a>";
		$this->RenderListOptionsExt();

		// Call ListOptions_Rendered event
		$this->ListOptions_Rendered();
	}

	function RenderListOptionsExt() {
		global $Security, $Language;
	}

	// Set up starting record parameters
	function SetUpStartRec() {
		if ($this->DisplayRecs == 0)
			return;
		if ($this->IsPageRequest()) { // Validate request
			if (@$_GET[EW_TABLE_START_REC] <> "") { // Check for "start" parameter
				$this->StartRec = $_GET[EW_TABLE_START_REC];
				$this->setStartRecordNumber($this->StartRec);
			} elseif (@$_GET[EW_TABLE_PAGE_NO] <> "") {
				$PageNo = $_GET[EW_TABLE_PAGE_NO];
				if (is_numeric($PageNo)) {
					$this->StartRec = ($PageNo-1)*$this->DisplayRecs+1;
					if ($this->StartRec <= 0) {
						$this->StartRec = 1;
					} elseif ($this->StartRec >= intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1) {
						$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1;
					}
					$this->setStartRecordNumber($this->StartRec);
				}
			}
		}
		$this->StartRec = $this->getStartRecordNumber();

		// Check if correct start record counter
		if (!is_numeric($this->StartRec) || $this->StartRec == "") { // Avoid invalid start record counter
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} elseif (intval($this->StartRec) > intval($this->TotalRecs)) { // Avoid starting record > total records
			$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to last page first record
			$this->setStartRecordNumber($this->StartRec);
		} elseif (($this->StartRec-1) % $this->DisplayRecs <> 0) {
			$this->StartRec = intval(($this->StartRec-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to page boundary
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Load recordset
	function LoadRecordset($offset = -1, $rowcnt = -1) {
		global $conn;

		// Call Recordset Selecting event
		$this->Recordset_Selecting($this->CurrentFilter);

		// Load List page SQL
		$sSql = $this->SelectSQL();
		if ($offset > -1 && $rowcnt > -1)
			$sSql .= " LIMIT $rowcnt OFFSET $offset";

		// Load recordset
		$rs = ew_LoadRecordset($sSql);

		// Call Recordset Selected event
		$this->Recordset_Selected($rs);
		return $rs;
	}

	// Load row based on key values
	function LoadRow() {
		global $conn, $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		global $conn;
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->dbkey_client_activity->setDbValue($rs->fields('dbkey_client_activity'));
	}

	// Load old record
	function LoadOldRecord() {

		// Load key values from Session
		$bValidKey = TRUE;
		if (strval($this->getKey("dbkey")) <> "")
			$this->dbkey->CurrentValue = $this->getKey("dbkey"); // dbkey
		else
			$bValidKey = FALSE;

		// Load old recordset
		if ($bValidKey) {
			$this->CurrentFilter = $this->KeyFilter();
			$sSql = $this->SQL();
			$this->OldRecordset = ew_LoadRecordset($sSql);
			$this->LoadRowValues($this->OldRecordset); // Load row values
		} else {
			$this->OldRecordset = NULL;
		}
		return $bValidKey;
	}

	// Render row values based on field settings
	function RenderRow() {
		global $conn, $Security, $Language;
		global $gsLanguage;

		// Initialize URLs
		$this->ViewUrl = $this->GetViewUrl();
		$this->EditUrl = $this->GetEditUrl();
		$this->InlineEditUrl = $this->GetInlineEditUrl();
		$this->CopyUrl = $this->GetCopyUrl();
		$this->InlineCopyUrl = $this->GetInlineCopyUrl();
		$this->DeleteUrl = $this->GetDeleteUrl();

		// Call Row_Rendering event
		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey
		// dbkey_client_activity

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

			// dbkey
			$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
			$this->dbkey->ViewCustomAttributes = "";

			// dbkey_client_activity
			$this->dbkey_client_activity->ViewValue = $this->dbkey_client_activity->CurrentValue;
			$this->dbkey_client_activity->ViewCustomAttributes = "";

			// dbkey
			$this->dbkey->LinkCustomAttributes = "";
			$this->dbkey->HrefValue = "";
			$this->dbkey->TooltipValue = "";

			// dbkey_client_activity
			$this->dbkey_client_activity->LinkCustomAttributes = "";
			$this->dbkey_client_activity->HrefValue = "";
			$this->dbkey_client_activity->TooltipValue = "";
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}

	// ListOptions Load event
	function ListOptions_Load() {

		// Example:
		//$opt = &$this->ListOptions->Add("new");
		//$opt->Header = "xxx";
		//$opt->OnLeft = TRUE; // Link on left
		//$opt->MoveTo(0); // Move to first column

	}

	// ListOptions Rendered event
	function ListOptions_Rendered() {

		// Example: 
		//$this->ListOptions->Items["new"]->Body = "xxx";

	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($client_activity_activities_list)) $client_activity_activities_list = new cclient_activity_activities_list();

// Page init
$client_activity_activities_list->Page_Init();

// Page main
$client_activity_activities_list->Page_Main();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Page object
var client_activity_activities_list = new ew_Page("client_activity_activities_list");
client_activity_activities_list.PageID = "list"; // Page ID
var EW_PAGE_ID = client_activity_activities_list.PageID; // For backward compatibility

// Form object
var fclient_activity_activitieslist = new ew_Form("fclient_activity_activitieslist");

// Form_CustomValidate event
fclient_activity_activitieslist.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fclient_activity_activitieslist.ValidateRequired = true;
<?php } else { ?>
fclient_activity_activitieslist.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
// Form object for search

</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php
	$bSelectLimit = EW_SELECT_LIMIT;
	if ($bSelectLimit) {
		$client_activity_activities_list->TotalRecs = $client_activity_activities->SelectRecordCount();
	} else {
		if ($client_activity_activities_list->Recordset = $client_activity_activities_list->LoadRecordset())
			$client_activity_activities_list->TotalRecs = $client_activity_activities_list->Recordset->RecordCount();
	}
	$client_activity_activities_list->StartRec = 1;
	if ($client_activity_activities_list->DisplayRecs <= 0 || ($client_activity_activities->Export <> "" && $client_activity_activities->ExportAll)) // Display all records
		$client_activity_activities_list->DisplayRecs = $client_activity_activities_list->TotalRecs;
	if (!($client_activity_activities->Export <> "" && $client_activity_activities->ExportAll))
		$client_activity_activities_list->SetUpStartRec(); // Set up start record position
	if ($bSelectLimit)
		$client_activity_activities_list->Recordset = $client_activity_activities_list->LoadRecordset($client_activity_activities_list->StartRec-1, $client_activity_activities_list->DisplayRecs);
?>
<p style="white-space: nowrap;"><span id="ewPageCaption" class="ewTitle ewTableTitle"><?php echo $Language->Phrase("TblTypeTABLE") ?><?php echo $client_activity_activities->TableCaption() ?>&nbsp;&nbsp;</span>
<?php $client_activity_activities_list->ExportOptions->Render("body"); ?>
</p>
<?php $client_activity_activities_list->ShowPageHeader(); ?>
<?php
$client_activity_activities_list->ShowMessage();
?>
<br>
<table cellspacing="0" class="ewGrid"><tr><td class="ewGridContent">
<form name="fclient_activity_activitieslist" id="fclient_activity_activitieslist" class="ewForm" action="" method="post">
<input type="hidden" name="t" value="client_activity_activities">
<div id="gmp_client_activity_activities" class="ewGridMiddlePanel">
<?php if ($client_activity_activities_list->TotalRecs > 0) { ?>
<table id="tbl_client_activity_activitieslist" class="ewTable ewTableSeparate">
<?php echo $client_activity_activities->TableCustomInnerHtml ?>
<thead><!-- Table header -->
	<tr class="ewTableHeader">
<?php

// Render list options
$client_activity_activities_list->RenderListOptions();

// Render list options (header, left)
$client_activity_activities_list->ListOptions->Render("header", "left");
?>
<?php if ($client_activity_activities->dbkey->Visible) { // dbkey ?>
	<?php if ($client_activity_activities->SortUrl($client_activity_activities->dbkey) == "") { ?>
		<td><span id="elh_client_activity_activities_dbkey" class="client_activity_activities_dbkey"><table class="ewTableHeaderBtn"><thead><tr><td><?php echo $client_activity_activities->dbkey->FldCaption() ?></td></tr></thead></table></span></td>
	<?php } else { ?>
		<td><div onmousedown="ew_Sort(event,'<?php echo $client_activity_activities->SortUrl($client_activity_activities->dbkey) ?>',1);"><span id="elh_client_activity_activities_dbkey" class="client_activity_activities_dbkey">
			<table class="ewTableHeaderBtn"><thead><tr><td class="ewTableHeaderCaption"><?php echo $client_activity_activities->dbkey->FldCaption() ?></td><td class="ewTableHeaderSort"><?php if ($client_activity_activities->dbkey->getSort() == "ASC") { ?><img src="phpimages/sortup.gif" width="10" height="9" alt="" style="border: 0;"><?php } elseif ($client_activity_activities->dbkey->getSort() == "DESC") { ?><img src="phpimages/sortdown.gif" width="10" height="9" alt="" style="border: 0;"><?php } ?></td></tr></thead></table>
		</span></div></td>		
	<?php } ?>
<?php } ?>		
<?php if ($client_activity_activities->dbkey_client_activity->Visible) { // dbkey_client_activity ?>
	<?php if ($client_activity_activities->SortUrl($client_activity_activities->dbkey_client_activity) == "") { ?>
		<td><span id="elh_client_activity_activities_dbkey_client_activity" class="client_activity_activities_dbkey_client_activity"><table class="ewTableHeaderBtn"><thead><tr><td><?php echo $client_activity_activities->dbkey_client_activity->FldCaption() ?></td></tr></thead></table></span></td>
	<?php } else { ?>
		<td><div onmousedown="ew_Sort(event,'<?php echo $client_activity_activities->SortUrl($client_activity_activities->dbkey_client_activity) ?>',1);"><span id="elh_client_activity_activities_dbkey_client_activity" class="client_activity_activities_dbkey_client_activity">
			<table class="ewTableHeaderBtn"><thead><tr><td class="ewTableHeaderCaption"><?php echo $client_activity_activities->dbkey_client_activity->FldCaption() ?></td><td class="ewTableHeaderSort"><?php if ($client_activity_activities->dbkey_client_activity->getSort() == "ASC") { ?><img src="phpimages/sortup.gif" width="10" height="9" alt="" style="border: 0;"><?php } elseif ($client_activity_activities->dbkey_client_activity->getSort() == "DESC") { ?><img src="phpimages/sortdown.gif" width="10" height="9" alt="" style="border: 0;"><?php } ?></td></tr></thead></table>
		</span></div></td>		
	<?php } ?>
<?php } ?>		
<?php

// Render list options (header, right)
$client_activity_activities_list->ListOptions->Render("header", "right");
?>
	</tr>
</thead>
<tbody>
<?php
if ($client_activity_activities->ExportAll && $client_activity_activities->Export <> "") {
	$client_activity_activities_list->StopRec = $client_activity_activities_list->TotalRecs;
} else {

	// Set the last record to display
	if ($client_activity_activities_list->TotalRecs > $client_activity_activities_list->StartRec + $client_activity_activities_list->DisplayRecs - 1)
		$client_activity_activities_list->StopRec = $client_activity_activities_list->StartRec + $client_activity_activities_list->DisplayRecs - 1;
	else
		$client_activity_activities_list->StopRec = $client_activity_activities_list->TotalRecs;
}
$client_activity_activities_list->RecCnt = $client_activity_activities_list->StartRec - 1;
if ($client_activity_activities_list->Recordset && !$client_activity_activities_list->Recordset->EOF) {
	$client_activity_activities_list->Recordset->MoveFirst();
	if (!$bSelectLimit && $client_activity_activities_list->StartRec > 1)
		$client_activity_activities_list->Recordset->Move($client_activity_activities_list->StartRec - 1);
} elseif (!$client_activity_activities->AllowAddDeleteRow && $client_activity_activities_list->StopRec == 0) {
	$client_activity_activities_list->StopRec = $client_activity_activities->GridAddRowCount;
}

// Initialize aggregate
$client_activity_activities->RowType = EW_ROWTYPE_AGGREGATEINIT;
$client_activity_activities->ResetAttrs();
$client_activity_activities_list->RenderRow();
while ($client_activity_activities_list->RecCnt < $client_activity_activities_list->StopRec) {
	$client_activity_activities_list->RecCnt++;
	if (intval($client_activity_activities_list->RecCnt) >= intval($client_activity_activities_list->StartRec)) {
		$client_activity_activities_list->RowCnt++;

		// Set up key count
		$client_activity_activities_list->KeyCount = $client_activity_activities_list->RowIndex;

		// Init row class and style
		$client_activity_activities->ResetAttrs();
		$client_activity_activities->CssClass = "";
		if ($client_activity_activities->CurrentAction == "gridadd") {
		} else {
			$client_activity_activities_list->LoadRowValues($client_activity_activities_list->Recordset); // Load row values
		}
		$client_activity_activities->RowType = EW_ROWTYPE_VIEW; // Render view

		// Set up row id / data-rowindex
		$client_activity_activities->RowAttrs = array_merge($client_activity_activities->RowAttrs, array('data-rowindex'=>$client_activity_activities_list->RowCnt, 'id'=>'r' . $client_activity_activities_list->RowCnt . '_client_activity_activities', 'data-rowtype'=>$client_activity_activities->RowType));

		// Render row
		$client_activity_activities_list->RenderRow();

		// Render list options
		$client_activity_activities_list->RenderListOptions();
?>
	<tr<?php echo $client_activity_activities->RowAttributes() ?>>
<?php

// Render list options (body, left)
$client_activity_activities_list->ListOptions->Render("body", "left", $client_activity_activities_list->RowCnt);
?>
	<?php if ($client_activity_activities->dbkey->Visible) { // dbkey ?>
		<td<?php echo $client_activity_activities->dbkey->CellAttributes() ?>><span id="el<?php echo $client_activity_activities_list->RowCnt ?>_client_activity_activities_dbkey" class="client_activity_activities_dbkey">
<span<?php echo $client_activity_activities->dbkey->ViewAttributes() ?>>
<?php echo $client_activity_activities->dbkey->ListViewValue() ?></span>
</span><a id="<?php echo $client_activity_activities_list->PageObjName . "_row_" . $client_activity_activities_list->RowCnt ?>"></a></td>
	<?php } ?>
	<?php if ($client_activity_activities->dbkey_client_activity->Visible) { // dbkey_client_activity ?>
		<td<?php echo $client_activity_activities->dbkey_client_activity->CellAttributes() ?>><span id="el<?php echo $client_activity_activities_list->RowCnt ?>_client_activity_activities_dbkey_client_activity" class="client_activity_activities_dbkey_client_activity">
<span<?php echo $client_activity_activities->dbkey_client_activity->ViewAttributes() ?>>
<?php echo $client_activity_activities->dbkey_client_activity->ListViewValue() ?></span>
</span><a id="<?php echo $client_activity_activities_list->PageObjName . "_row_" . $client_activity_activities_list->RowCnt ?>"></a></td>
	<?php } ?>
<?php

// Render list options (body, right)
$client_activity_activities_list->ListOptions->Render("body", "right", $client_activity_activities_list->RowCnt);
?>
	</tr>
<?php
	}
	if ($client_activity_activities->CurrentAction <> "gridadd")
		$client_activity_activities_list->Recordset->MoveNext();
}
?>
</tbody>
</table>
<?php } ?>
<?php if ($client_activity_activities->CurrentAction == "") { ?>
<input type="hidden" name="a_list" id="a_list" value="">
<?php } ?>
</div>
</form>
<?php

// Close recordset
if ($client_activity_activities_list->Recordset)
	$client_activity_activities_list->Recordset->Close();
?>
<div class="ewGridLowerPanel">
<?php if ($client_activity_activities->CurrentAction <> "gridadd" && $client_activity_activities->CurrentAction <> "gridedit") { ?>
<form name="ewpagerform" id="ewpagerform" class="ewForm" action="<?php echo ew_CurrentPage() ?>">
<table class="ewPager"><tr><td>
<?php if (!isset($client_activity_activities_list->Pager)) $client_activity_activities_list->Pager = new cPrevNextPager($client_activity_activities_list->StartRec, $client_activity_activities_list->DisplayRecs, $client_activity_activities_list->TotalRecs) ?>
<?php if ($client_activity_activities_list->Pager->RecordCount > 0) { ?>
	<table cellspacing="0" class="ewStdTable"><tbody><tr><td><span class="phpmaker"><?php echo $Language->Phrase("Page") ?>&nbsp;</span></td>
<!--first page button-->
	<?php if ($client_activity_activities_list->Pager->FirstButton->Enabled) { ?>
	<td><a href="<?php echo $client_activity_activities_list->PageUrl() ?>start=<?php echo $client_activity_activities_list->Pager->FirstButton->Start ?>"><img src="phpimages/first.gif" alt="<?php echo $Language->Phrase("PagerFirst") ?>" width="16" height="16" style="border: 0;"></a></td>
	<?php } else { ?>
	<td><img src="phpimages/firstdisab.gif" alt="<?php echo $Language->Phrase("PagerFirst") ?>" width="16" height="16" style="border: 0;"></td>
	<?php } ?>
<!--previous page button-->
	<?php if ($client_activity_activities_list->Pager->PrevButton->Enabled) { ?>
	<td><a href="<?php echo $client_activity_activities_list->PageUrl() ?>start=<?php echo $client_activity_activities_list->Pager->PrevButton->Start ?>"><img src="phpimages/prev.gif" alt="<?php echo $Language->Phrase("PagerPrevious") ?>" width="16" height="16" style="border: 0;"></a></td>
	<?php } else { ?>
	<td><img src="phpimages/prevdisab.gif" alt="<?php echo $Language->Phrase("PagerPrevious") ?>" width="16" height="16" style="border: 0;"></td>
	<?php } ?>
<!--current page number-->
	<td><input type="text" name="<?php echo EW_TABLE_PAGE_NO ?>" id="<?php echo EW_TABLE_PAGE_NO ?>" value="<?php echo $client_activity_activities_list->Pager->CurrentPage ?>" size="4"></td>
<!--next page button-->
	<?php if ($client_activity_activities_list->Pager->NextButton->Enabled) { ?>
	<td><a href="<?php echo $client_activity_activities_list->PageUrl() ?>start=<?php echo $client_activity_activities_list->Pager->NextButton->Start ?>"><img src="phpimages/next.gif" alt="<?php echo $Language->Phrase("PagerNext") ?>" width="16" height="16" style="border: 0;"></a></td>	
	<?php } else { ?>
	<td><img src="phpimages/nextdisab.gif" alt="<?php echo $Language->Phrase("PagerNext") ?>" width="16" height="16" style="border: 0;"></td>
	<?php } ?>
<!--last page button-->
	<?php if ($client_activity_activities_list->Pager->LastButton->Enabled) { ?>
	<td><a href="<?php echo $client_activity_activities_list->PageUrl() ?>start=<?php echo $client_activity_activities_list->Pager->LastButton->Start ?>"><img src="phpimages/last.gif" alt="<?php echo $Language->Phrase("PagerLast") ?>" width="16" height="16" style="border: 0;"></a></td>	
	<?php } else { ?>
	<td><img src="phpimages/lastdisab.gif" alt="<?php echo $Language->Phrase("PagerLast") ?>" width="16" height="16" style="border: 0;"></td>
	<?php } ?>
	<td><span class="phpmaker">&nbsp;<?php echo $Language->Phrase("of") ?>&nbsp;<?php echo $client_activity_activities_list->Pager->PageCount ?></span></td>
	</tr></tbody></table>
	</td>	
	<td>&nbsp;&nbsp;&nbsp;&nbsp;</td>
	<td>
	<span class="phpmaker"><?php echo $Language->Phrase("Record") ?>&nbsp;<?php echo $client_activity_activities_list->Pager->FromIndex ?>&nbsp;<?php echo $Language->Phrase("To") ?>&nbsp;<?php echo $client_activity_activities_list->Pager->ToIndex ?>&nbsp;<?php echo $Language->Phrase("Of") ?>&nbsp;<?php echo $client_activity_activities_list->Pager->RecordCount ?></span>
<?php } else { ?>
	<?php if ($client_activity_activities_list->SearchWhere == "0=101") { ?>
	<span class="phpmaker"><?php echo $Language->Phrase("EnterSearchCriteria") ?></span>
	<?php } else { ?>
	<span class="phpmaker"><?php echo $Language->Phrase("NoRecord") ?></span>
	<?php } ?>
<?php } ?>
	</td>
</tr></table>
</form>
<?php } ?>
<span class="phpmaker">
<?php if ($client_activity_activities_list->AddUrl <> "") { ?>
<a class="ewGridLink" href="<?php echo $client_activity_activities_list->AddUrl ?>"><?php echo $Language->Phrase("AddLink") ?></a>&nbsp;&nbsp;
<?php } ?>
</span>
</div>
</td></tr></table>
<script type="text/javascript">
fclient_activity_activitieslist.Init();
</script>
<?php
$client_activity_activities_list->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$client_activity_activities_list->Page_Terminate();
?>
