<?php
if (session_id() == "") session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg12.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql12.php") ?>
<?php include_once "phpfn12.php" ?>
<?php include_once "client_activity_viewinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn12.php" ?>
<?php

//
// Page class
//

$client_activity_view_delete = NULL; // Initialize page object first

class cclient_activity_view_delete extends cclient_activity_view {

	// Page ID
	var $PageID = 'delete';

	// Project ID
	var $ProjectID = "{7F51207E-5F60-42DA-A8C0-DC97EF669AEE}";

	// Table name
	var $TableName = 'client_activity_view';

	// Page object name
	var $PageObjName = 'client_activity_view_delete';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}
    var $AuditTrailOnAdd = FALSE;
    var $AuditTrailOnEdit = FALSE;
    var $AuditTrailOnDelete = TRUE;
    var $AuditTrailOnView = FALSE;
    var $AuditTrailOnViewData = FALSE;
    var $AuditTrailOnSearch = FALSE;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (client_activity_view)
		if (!isset($GLOBALS["client_activity_view"]) || get_class($GLOBALS["client_activity_view"]) == "cclient_activity_view") {
			$GLOBALS["client_activity_view"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["client_activity_view"];
		}

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'delete', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'client_activity_view', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanDelete()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage($Language->Phrase("NoPermission")); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("client_activity_viewlist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
			if (strval($Security->CurrentUserID()) == "") {
				$this->setFailureMessage($Language->Phrase("NoPermission")); // Set no permission
				$this->Page_Terminate(ew_GetUrl("client_activity_viewlist.php"));
			}
		}
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $client_activity_view;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($client_activity_view);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}
	var $DbMasterFilter = "";
	var $DbDetailFilter = "";
	var $StartRec;
	var $TotalRecs = 0;
	var $RecCnt;
	var $RecKeys = array();
	var $Recordset;
	var $StartRowCnt = 1;
	var $RowCnt = 0;

	//
	// Page main
	//
	function Page_Main() {
		global $Language;

		// Set up Breadcrumb
		$this->SetupBreadcrumb();

		// Load key parameters
		$this->RecKeys = $this->GetRecordKeys(); // Load record keys
		$sFilter = $this->GetKeyFilter();
		if ($sFilter == "")
			$this->Page_Terminate("client_activity_viewlist.php"); // Prevent SQL injection, return to list

		// Set up filter (SQL WHHERE clause) and get return SQL
		// SQL constructor in client_activity_view class, client_activity_viewinfo.php

		$this->CurrentFilter = $sFilter;

		// Check if valid user id
		$conn = &$this->Connection();
		$sql = $this->GetSQL($this->CurrentFilter, "");
		if ($this->Recordset = ew_LoadRecordset($sql, $conn)) {
			$res = TRUE;
			while (!$this->Recordset->EOF) {
				$this->LoadRowValues($this->Recordset);
				if (!$this->ShowOptionLink('delete')) {
					$sUserIdMsg = $Language->Phrase("NoDeletePermission");
					$this->setFailureMessage($sUserIdMsg);
					$res = FALSE;
					break;
				}
				$this->Recordset->MoveNext();
			}
			$this->Recordset->Close();
			if (!$res) $this->Page_Terminate("client_activity_viewlist.php"); // Return to list
		}

		// Get action
		if (@$_POST["a_delete"] <> "") {
			$this->CurrentAction = $_POST["a_delete"];
		} else {
			$this->CurrentAction = "I"; // Display record
		}
		switch ($this->CurrentAction) {
			case "D": // Delete
				$this->SendEmail = TRUE; // Send email on delete success
				if ($this->DeleteRows()) { // Delete rows
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage($Language->Phrase("DeleteSuccess")); // Set up success message
					$this->Page_Terminate($this->getReturnUrl()); // Return to caller
				}
		}
	}

	// Load recordset
	function LoadRecordset($offset = -1, $rowcnt = -1) {

		// Load List page SQL
		$sSql = $this->SelectSQL();
		$conn = &$this->Connection();

		// Load recordset
		$dbtype = ew_GetConnectionType($this->DBID);
		if ($this->UseSelectLimit) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			if ($dbtype == "MSSQL") {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset, array("_hasOrderBy" => trim($this->getOrderBy()) || trim($this->getSessionOrderBy())));
			} else {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset);
			}
			$conn->raiseErrorFn = '';
		} else {
			$rs = ew_LoadRecordset($sSql, $conn);
		}

		// Call Recordset Selected event
		$this->Recordset_Selected($rs);
		return $rs;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->dbkey_councilor->setDbValue($rs->fields('dbkey_councilor'));
		$this->dbkey_client->setDbValue($rs->fields('dbkey_client'));
		$this->date->setDbValue($rs->fields('date'));
		$this->dbkey_activity->setDbValue($rs->fields('dbkey_activity'));
		$this->comment->setDbValue($rs->fields('comment'));
		$this->time->setDbValue($rs->fields('time'));
		$this->attachment->Upload->DbValue = $rs->fields('attachment');
		$this->attachment->CurrentValue = $this->attachment->Upload->DbValue;
		$this->budget->setDbValue($rs->fields('budget'));
		$this->total_allocated->setDbValue($rs->fields('total_allocated'));
		$this->available->setDbValue($rs->fields('available'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey->DbValue = $row['dbkey'];
		$this->dbkey_councilor->DbValue = $row['dbkey_councilor'];
		$this->dbkey_client->DbValue = $row['dbkey_client'];
		$this->date->DbValue = $row['date'];
		$this->dbkey_activity->DbValue = $row['dbkey_activity'];
		$this->comment->DbValue = $row['comment'];
		$this->time->DbValue = $row['time'];
		$this->attachment->Upload->DbValue = $row['attachment'];
		$this->budget->DbValue = $row['budget'];
		$this->total_allocated->DbValue = $row['total_allocated'];
		$this->available->DbValue = $row['available'];
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Convert decimal values if posted back

		if ($this->total_allocated->FormValue == $this->total_allocated->CurrentValue && is_numeric(ew_StrToFloat($this->total_allocated->CurrentValue)))
			$this->total_allocated->CurrentValue = ew_StrToFloat($this->total_allocated->CurrentValue);

		// Convert decimal values if posted back
		if ($this->available->FormValue == $this->available->CurrentValue && is_numeric(ew_StrToFloat($this->available->CurrentValue)))
			$this->available->CurrentValue = ew_StrToFloat($this->available->CurrentValue);

		// Call Row_Rendering event
		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey

		$this->dbkey->CellCssStyle = "white-space: nowrap;";

		// dbkey_councilor
		$this->dbkey_councilor->CellCssStyle = "white-space: nowrap;";

		// dbkey_client
		// date
		// dbkey_activity
		// comment
		// time
		// attachment

		$this->attachment->CellCssStyle = "white-space: nowrap;";

		// budget
		// total_allocated
		// available

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// dbkey
		$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// dbkey_councilor
		if (strval($this->dbkey_councilor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_councilor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->CurrentValue;
			}
		} else {
			$this->dbkey_councilor->ViewValue = NULL;
		}
		$this->dbkey_councilor->ViewCustomAttributes = "";

		// dbkey_client
		if (strval($this->dbkey_client->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey_client`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey_client`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client_counselor_drop_down`";
		$sWhereWrk = "";
		$lookuptblfilter = "`email` = '" . $_SESSION["user"]."'";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_client->ViewValue = $this->dbkey_client->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_client->ViewValue = $this->dbkey_client->CurrentValue;
			}
		} else {
			$this->dbkey_client->ViewValue = NULL;
		}
		$this->dbkey_client->ViewCustomAttributes = "";

		// date
		$this->date->ViewValue = $this->date->CurrentValue;
		$this->date->ViewValue = ew_FormatDateTime($this->date->ViewValue, 5);
		$this->date->ViewCustomAttributes = "";

		// dbkey_activity
		if (strval($this->dbkey_activity->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_activity->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `activity`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->CurrentValue;
			}
		} else {
			$this->dbkey_activity->ViewValue = NULL;
		}
		$this->dbkey_activity->ViewCustomAttributes = "";

		// comment
		$this->comment->ViewValue = $this->comment->CurrentValue;
		$this->comment->ViewCustomAttributes = "";

		// time
		$this->time->ViewValue = $this->time->CurrentValue;
		$this->time->ViewCustomAttributes = "";

		// attachment
		if (!ew_Empty($this->attachment->Upload->DbValue)) {
			$this->attachment->ViewValue = $this->attachment->Upload->DbValue;
		} else {
			$this->attachment->ViewValue = "";
		}
		$this->attachment->ViewCustomAttributes = "";

		// budget
		$this->budget->ViewValue = $this->budget->CurrentValue;
		$this->budget->ViewCustomAttributes = "";

		// total_allocated
		$this->total_allocated->ViewValue = $this->total_allocated->CurrentValue;
		$this->total_allocated->ViewCustomAttributes = "";

		// available
		$this->available->ViewValue = $this->available->CurrentValue;
		$this->available->ViewCustomAttributes = "";

			// dbkey_councilor
			$this->dbkey_councilor->LinkCustomAttributes = "";
			$this->dbkey_councilor->HrefValue = "";
			$this->dbkey_councilor->TooltipValue = "";

			// dbkey_client
			$this->dbkey_client->LinkCustomAttributes = "";
			$this->dbkey_client->HrefValue = "";
			$this->dbkey_client->TooltipValue = "";

			// date
			$this->date->LinkCustomAttributes = "";
			$this->date->HrefValue = "";
			$this->date->TooltipValue = "";

			// dbkey_activity
			$this->dbkey_activity->LinkCustomAttributes = "";
			$this->dbkey_activity->HrefValue = "";
			$this->dbkey_activity->TooltipValue = "";

			// time
			$this->time->LinkCustomAttributes = "";
			$this->time->HrefValue = "";
			$this->time->TooltipValue = "";

			// attachment
			$this->attachment->LinkCustomAttributes = "";
			$this->attachment->HrefValue = "";
			$this->attachment->HrefValue2 = $this->attachment->UploadPath . $this->attachment->Upload->DbValue;
			$this->attachment->TooltipValue = "";

			// budget
			$this->budget->LinkCustomAttributes = "";
			$this->budget->HrefValue = "";
			$this->budget->TooltipValue = "";

			// total_allocated
			$this->total_allocated->LinkCustomAttributes = "";
			$this->total_allocated->HrefValue = "";
			$this->total_allocated->TooltipValue = "";

			// available
			$this->available->LinkCustomAttributes = "";
			$this->available->HrefValue = "";
			$this->available->TooltipValue = "";
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	//
	// Delete records based on current filter
	//
	function DeleteRows() {
		global $Language, $Security;
		if (!$Security->CanDelete()) {
			$this->setFailureMessage($Language->Phrase("NoDeletePermission")); // No delete permission
			return FALSE;
		}
		$DeleteRows = TRUE;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
		$rs = $conn->Execute($sSql);
		$conn->raiseErrorFn = '';
		if ($rs === FALSE) {
			return FALSE;
		} elseif ($rs->EOF) {
			$this->setFailureMessage($Language->Phrase("NoRecord")); // No record found
			$rs->Close();
			return FALSE;

		//} else {
		//	$this->LoadRowValues($rs); // Load row values

		}
		$rows = ($rs) ? $rs->GetRows() : array();
		$conn->BeginTrans();
		if ($this->AuditTrailOnDelete) $this->WriteAuditTrailDummy($Language->Phrase("BatchDeleteBegin")); // Batch delete begin

		// Clone old rows
		$rsold = $rows;
		if ($rs)
			$rs->Close();

		// Call row deleting event
		if ($DeleteRows) {
			foreach ($rsold as $row) {
				$DeleteRows = $this->Row_Deleting($row);
				if (!$DeleteRows) break;
			}
		}
		if ($DeleteRows) {
			$sKey = "";
			foreach ($rsold as $row) {
				$sThisKey = "";
				if ($sThisKey <> "") $sThisKey .= $GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"];
				$sThisKey .= $row['dbkey'];
				$this->LoadDbValues($row);
				$OldFiles = explode(EW_MULTIPLE_UPLOAD_SEPARATOR, $row['attachment']);
				$FileCount = count($OldFiles);
				for ($i = 0; $i < $FileCount; $i++) {
					@unlink(ew_UploadPathEx(TRUE, $this->attachment->OldUploadPath) . $OldFiles[$i]);
				}
				$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
				$DeleteRows = $this->Delete($row); // Delete
				$conn->raiseErrorFn = '';
				if ($DeleteRows === FALSE)
					break;
				if ($sKey <> "") $sKey .= ", ";
				$sKey .= $sThisKey;
			}
		} else {

			// Set up error message
			if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

				// Use the message, do nothing
			} elseif ($this->CancelMessage <> "") {
				$this->setFailureMessage($this->CancelMessage);
				$this->CancelMessage = "";
			} else {
				$this->setFailureMessage($Language->Phrase("DeleteCancelled"));
			}
		}
		if ($DeleteRows) {
			$conn->CommitTrans(); // Commit the changes
			if ($DeleteRows) {
				foreach ($rsold as $row)
					$this->WriteAuditTrailOnDelete($row);
			}
			if ($this->AuditTrailOnDelete) $this->WriteAuditTrailDummy($Language->Phrase("BatchDeleteSuccess")); // Batch delete success
		} else {
			$conn->RollbackTrans(); // Rollback changes
			if ($this->AuditTrailOnDelete) $this->WriteAuditTrailDummy($Language->Phrase("BatchDeleteRollback")); // Batch delete rollback
		}

		// Call Row Deleted event
		if ($DeleteRows) {
			foreach ($rsold as $row) {
				$this->Row_Deleted($row);
			}
		}
		return $DeleteRows;
	}

	// Show link optionally based on User ID
	function ShowOptionLink($id = "") {
		global $Security;
		if ($Security->IsLoggedIn() && !$Security->IsAdmin() && !$this->UserIDAllow($id))
			return $Security->IsValidUserID($this->dbkey_councilor->CurrentValue);
		return TRUE;
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, "client_activity_viewlist.php", "", $this->TableVar, TRUE);
		$PageId = "delete";
		$Breadcrumb->Add("delete", $PageId, $url);
	}

	// Write Audit Trail start/end for grid update
	function WriteAuditTrailDummy($typ) {
		$table = 'client_activity_view';
		$usr = CurrentUserID();
		ew_WriteAuditTrail("log", ew_StdCurrentDateTime(), ew_ScriptName(), $usr, $typ, $table, "", "", "", "");
	}

	// Write Audit Trail (delete page)
	function WriteAuditTrailOnDelete(&$rs) {
		global $Language;
		if (!$this->AuditTrailOnDelete) return;
		$table = 'client_activity_view';

		// Get key value
		$key = "";
		if ($key <> "")
			$key .= $GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"];
		$key .= $rs['dbkey'];

		// Write Audit Trail
		$dt = ew_StdCurrentDateTime();
		$id = ew_ScriptName();
		$curUser = CurrentUserID();
		foreach (array_keys($rs) as $fldname) {
			if (array_key_exists($fldname, $this->fields) && $this->fields[$fldname]->FldDataType <> EW_DATATYPE_BLOB) { // Ignore BLOB fields
				if ($this->fields[$fldname]->FldHtmlTag == "PASSWORD") {
					$oldvalue = $Language->Phrase("PasswordMask"); // Password Field
				} elseif ($this->fields[$fldname]->FldDataType == EW_DATATYPE_MEMO) {
					if (EW_AUDIT_TRAIL_TO_DATABASE)
						$oldvalue = $rs[$fldname];
					else
						$oldvalue = "[MEMO]"; // Memo field
				} elseif ($this->fields[$fldname]->FldDataType == EW_DATATYPE_XML) {
					$oldvalue = "[XML]"; // XML field
				} else {
					$oldvalue = $rs[$fldname];
				}
				ew_WriteAuditTrail("log", $dt, $id, $curUser, "D", $table, $fldname, $key, $oldvalue, "");
			}
		}
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($client_activity_view_delete)) $client_activity_view_delete = new cclient_activity_view_delete();

// Page init
$client_activity_view_delete->Page_Init();

// Page main
$client_activity_view_delete->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$client_activity_view_delete->Page_Render();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "delete";
var CurrentForm = fclient_activity_viewdelete = new ew_Form("fclient_activity_viewdelete", "delete");

// Form_CustomValidate event
fclient_activity_viewdelete.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fclient_activity_viewdelete.ValidateRequired = true;
<?php } else { ?>
fclient_activity_viewdelete.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fclient_activity_viewdelete.Lists["x_dbkey_councilor"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
fclient_activity_viewdelete.Lists["x_dbkey_client"] = {"LinkField":"x_dbkey_client","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
fclient_activity_viewdelete.Lists["x_dbkey_activity"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};

// Form object for search
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php

// Load records for display
if ($client_activity_view_delete->Recordset = $client_activity_view_delete->LoadRecordset())
	$client_activity_view_deleteTotalRecs = $client_activity_view_delete->Recordset->RecordCount(); // Get record count
if ($client_activity_view_deleteTotalRecs <= 0) { // No record found, exit
	if ($client_activity_view_delete->Recordset)
		$client_activity_view_delete->Recordset->Close();
	$client_activity_view_delete->Page_Terminate("client_activity_viewlist.php"); // Return to list
}
?>
<div class="ewToolbar">
<?php $Breadcrumb->Render(); ?>
<?php echo $Language->SelectionForm(); ?>
<div class="clearfix"></div>
</div>
<?php $client_activity_view_delete->ShowPageHeader(); ?>
<?php
$client_activity_view_delete->ShowMessage();
?>
<form name="fclient_activity_viewdelete" id="fclient_activity_viewdelete" class="form-inline ewForm ewDeleteForm" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($client_activity_view_delete->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $client_activity_view_delete->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="client_activity_view">
<input type="hidden" name="a_delete" id="a_delete" value="D">
<?php foreach ($client_activity_view_delete->RecKeys as $key) { ?>
<?php $keyvalue = is_array($key) ? implode($EW_COMPOSITE_KEY_SEPARATOR, $key) : $key; ?>
<input type="hidden" name="key_m[]" value="<?php echo ew_HtmlEncode($keyvalue) ?>">
<?php } ?>
<div class="ewGrid">
<div class="<?php if (ew_IsResponsiveLayout()) { echo "table-responsive "; } ?>ewGridMiddlePanel">
<table class="table ewTable">
<?php echo $client_activity_view->TableCustomInnerHtml ?>
	<thead>
	<tr class="ewTableHeader">
<?php if ($client_activity_view->dbkey_councilor->Visible) { // dbkey_councilor ?>
		<th><span id="elh_client_activity_view_dbkey_councilor" class="client_activity_view_dbkey_councilor"><?php echo $client_activity_view->dbkey_councilor->FldCaption() ?></span></th>
<?php } ?>
<?php if ($client_activity_view->dbkey_client->Visible) { // dbkey_client ?>
		<th><span id="elh_client_activity_view_dbkey_client" class="client_activity_view_dbkey_client"><?php echo $client_activity_view->dbkey_client->FldCaption() ?></span></th>
<?php } ?>
<?php if ($client_activity_view->date->Visible) { // date ?>
		<th><span id="elh_client_activity_view_date" class="client_activity_view_date"><?php echo $client_activity_view->date->FldCaption() ?></span></th>
<?php } ?>
<?php if ($client_activity_view->dbkey_activity->Visible) { // dbkey_activity ?>
		<th><span id="elh_client_activity_view_dbkey_activity" class="client_activity_view_dbkey_activity"><?php echo $client_activity_view->dbkey_activity->FldCaption() ?></span></th>
<?php } ?>
<?php if ($client_activity_view->time->Visible) { // time ?>
		<th><span id="elh_client_activity_view_time" class="client_activity_view_time"><?php echo $client_activity_view->time->FldCaption() ?></span></th>
<?php } ?>
<?php if ($client_activity_view->attachment->Visible) { // attachment ?>
		<th><span id="elh_client_activity_view_attachment" class="client_activity_view_attachment"><?php echo $client_activity_view->attachment->FldCaption() ?></span></th>
<?php } ?>
<?php if ($client_activity_view->budget->Visible) { // budget ?>
		<th><span id="elh_client_activity_view_budget" class="client_activity_view_budget"><?php echo $client_activity_view->budget->FldCaption() ?></span></th>
<?php } ?>
<?php if ($client_activity_view->total_allocated->Visible) { // total_allocated ?>
		<th><span id="elh_client_activity_view_total_allocated" class="client_activity_view_total_allocated"><?php echo $client_activity_view->total_allocated->FldCaption() ?></span></th>
<?php } ?>
<?php if ($client_activity_view->available->Visible) { // available ?>
		<th><span id="elh_client_activity_view_available" class="client_activity_view_available"><?php echo $client_activity_view->available->FldCaption() ?></span></th>
<?php } ?>
	</tr>
	</thead>
	<tbody>
<?php
$client_activity_view_delete->RecCnt = 0;
$i = 0;
while (!$client_activity_view_delete->Recordset->EOF) {
	$client_activity_view_delete->RecCnt++;
	$client_activity_view_delete->RowCnt++;

	// Set row properties
	$client_activity_view->ResetAttrs();
	$client_activity_view->RowType = EW_ROWTYPE_VIEW; // View

	// Get the field contents
	$client_activity_view_delete->LoadRowValues($client_activity_view_delete->Recordset);

	// Render row
	$client_activity_view_delete->RenderRow();
?>
	<tr<?php echo $client_activity_view->RowAttributes() ?>>
<?php if ($client_activity_view->dbkey_councilor->Visible) { // dbkey_councilor ?>
		<td<?php echo $client_activity_view->dbkey_councilor->CellAttributes() ?>>
<span id="el<?php echo $client_activity_view_delete->RowCnt ?>_client_activity_view_dbkey_councilor" class="client_activity_view_dbkey_councilor">
<span<?php echo $client_activity_view->dbkey_councilor->ViewAttributes() ?>>
<?php echo $client_activity_view->dbkey_councilor->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($client_activity_view->dbkey_client->Visible) { // dbkey_client ?>
		<td<?php echo $client_activity_view->dbkey_client->CellAttributes() ?>>
<span id="el<?php echo $client_activity_view_delete->RowCnt ?>_client_activity_view_dbkey_client" class="client_activity_view_dbkey_client">
<span<?php echo $client_activity_view->dbkey_client->ViewAttributes() ?>>
<?php echo $client_activity_view->dbkey_client->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($client_activity_view->date->Visible) { // date ?>
		<td<?php echo $client_activity_view->date->CellAttributes() ?>>
<span id="el<?php echo $client_activity_view_delete->RowCnt ?>_client_activity_view_date" class="client_activity_view_date">
<span<?php echo $client_activity_view->date->ViewAttributes() ?>>
<?php echo $client_activity_view->date->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($client_activity_view->dbkey_activity->Visible) { // dbkey_activity ?>
		<td<?php echo $client_activity_view->dbkey_activity->CellAttributes() ?>>
<span id="el<?php echo $client_activity_view_delete->RowCnt ?>_client_activity_view_dbkey_activity" class="client_activity_view_dbkey_activity">
<span<?php echo $client_activity_view->dbkey_activity->ViewAttributes() ?>>
<?php echo $client_activity_view->dbkey_activity->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($client_activity_view->time->Visible) { // time ?>
		<td<?php echo $client_activity_view->time->CellAttributes() ?>>
<span id="el<?php echo $client_activity_view_delete->RowCnt ?>_client_activity_view_time" class="client_activity_view_time">
<span<?php echo $client_activity_view->time->ViewAttributes() ?>>
<?php echo $client_activity_view->time->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($client_activity_view->attachment->Visible) { // attachment ?>
		<td<?php echo $client_activity_view->attachment->CellAttributes() ?>>
<span id="el<?php echo $client_activity_view_delete->RowCnt ?>_client_activity_view_attachment" class="client_activity_view_attachment">
<span<?php echo $client_activity_view->attachment->ViewAttributes() ?>>
<?php echo ew_GetFileViewTag($client_activity_view->attachment, $client_activity_view->attachment->ListViewValue()) ?>
</span>
</span>
</td>
<?php } ?>
<?php if ($client_activity_view->budget->Visible) { // budget ?>
		<td<?php echo $client_activity_view->budget->CellAttributes() ?>>
<span id="el<?php echo $client_activity_view_delete->RowCnt ?>_client_activity_view_budget" class="client_activity_view_budget">
<span<?php echo $client_activity_view->budget->ViewAttributes() ?>>
<?php echo $client_activity_view->budget->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($client_activity_view->total_allocated->Visible) { // total_allocated ?>
		<td<?php echo $client_activity_view->total_allocated->CellAttributes() ?>>
<span id="el<?php echo $client_activity_view_delete->RowCnt ?>_client_activity_view_total_allocated" class="client_activity_view_total_allocated">
<span<?php echo $client_activity_view->total_allocated->ViewAttributes() ?>>
<?php echo $client_activity_view->total_allocated->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($client_activity_view->available->Visible) { // available ?>
		<td<?php echo $client_activity_view->available->CellAttributes() ?>>
<span id="el<?php echo $client_activity_view_delete->RowCnt ?>_client_activity_view_available" class="client_activity_view_available">
<span<?php echo $client_activity_view->available->ViewAttributes() ?>>
<?php echo $client_activity_view->available->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
	</tr>
<?php
	$client_activity_view_delete->Recordset->MoveNext();
}
$client_activity_view_delete->Recordset->Close();
?>
</tbody>
</table>
</div>
</div>
<div>
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit"><?php echo $Language->Phrase("DeleteBtn") ?></button>
<button class="btn btn-default ewButton" name="btnCancel" id="btnCancel" type="button" data-href="<?php echo $client_activity_view_delete->getReturnUrl() ?>"><?php echo $Language->Phrase("CancelBtn") ?></button>
</div>
</form>
<script type="text/javascript">
fclient_activity_viewdelete.Init();
</script>
<?php
$client_activity_view_delete->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$client_activity_view_delete->Page_Terminate();
?>
