<?php
if (session_id() == "") session_start(); // Init session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg13.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql13.php") ?>
<?php include_once "phpfn13.php" ?>
<?php include_once "client_budgetinfo.php" ?>
<?php include_once "activityinfo.php" ?>
<?php include_once "clientinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn13.php" ?>
<?php

//
// Page class
//

$client_budget_add = NULL; // Initialize page object first

class cclient_budget_add extends cclient_budget {

	// Page ID
	var $PageID = 'add';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'client_budget';

	// Page object name
	var $PageObjName = 'client_budget_add';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}
	var $AuditTrailOnAdd = TRUE;
	var $AuditTrailOnEdit = FALSE;
	var $AuditTrailOnDelete = FALSE;
	var $AuditTrailOnView = FALSE;
	var $AuditTrailOnViewData = FALSE;
	var $AuditTrailOnSearch = FALSE;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (client_budget)
		if (!isset($GLOBALS["client_budget"]) || get_class($GLOBALS["client_budget"]) == "cclient_budget") {
			$GLOBALS["client_budget"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["client_budget"];
		}

		// Table object (activity)
		if (!isset($GLOBALS['activity'])) $GLOBALS['activity'] = new cactivity();

		// Table object (client)
		if (!isset($GLOBALS['client'])) $GLOBALS['client'] = new cclient();

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'add', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'client_budget', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	//
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanAdd()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("client_budgetlist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Create form object
		$objForm = new cFormObj();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action
		$this->dbkey_client->SetVisibility();
		$this->dbkey_activity->SetVisibility();
		$this->budget->SetVisibility();
		$this->from->SetVisibility();
		$this->through->SetVisibility();
		$this->contractid->SetVisibility();
		$this->rate->SetVisibility();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $client_budget;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($client_budget);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();

			// Handle modal response
			if ($this->IsModal) {
				$row = array();
				$row["url"] = $url;
				echo ew_ArrayToJson(array($row));
			} else {
				header("Location: " . $url);
			}
		}
		exit();
	}
	var $FormClassName = "form-horizontal ewForm ewAddForm";
	var $IsModal = FALSE;
	var $DbMasterFilter = "";
	var $DbDetailFilter = "";
	var $StartRec;
	var $Priv = 0;
	var $OldRecordset;
	var $CopyRecord;

	// 
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError;
		global $gbSkipHeaderFooter;

		// Check modal
		$this->IsModal = (@$_GET["modal"] == "1" || @$_POST["modal"] == "1");
		if ($this->IsModal)
			$gbSkipHeaderFooter = TRUE;

		// Set up master/detail parameters
		$this->SetUpMasterParms();

		// Process form if post back
		if (@$_POST["a_add"] <> "") {
			$this->CurrentAction = $_POST["a_add"]; // Get form action
			$this->CopyRecord = $this->LoadOldRecord(); // Load old recordset
			$this->LoadFormValues(); // Load form values
		} else { // Not post back

			// Load key values from QueryString
			$this->CopyRecord = TRUE;
			if (@$_GET["dbkey"] != "") {
				$this->dbkey->setQueryStringValue($_GET["dbkey"]);
				$this->setKey("dbkey", $this->dbkey->CurrentValue); // Set up key
			} else {
				$this->setKey("dbkey", ""); // Clear key
				$this->CopyRecord = FALSE;
			}
			if ($this->CopyRecord) {
				$this->CurrentAction = "C"; // Copy record
			} else {
				$this->CurrentAction = "I"; // Display blank record
			}
		}

		// Set up Breadcrumb
		$this->SetupBreadcrumb();

		// Validate form if post back
		if (@$_POST["a_add"] <> "") {
			if (!$this->ValidateForm()) {
				$this->CurrentAction = "I"; // Form error, reset action
				$this->EventCancelled = TRUE; // Event cancelled
				$this->RestoreFormValues(); // Restore form values
				$this->setFailureMessage($gsFormError);
			}
		} else {
			if ($this->CurrentAction == "I") // Load default values for blank record
				$this->LoadDefaultValues();
		}

		// Perform action based on action code
		switch ($this->CurrentAction) {
			case "I": // Blank record, no action required
				break;
			case "C": // Copy an existing record
				if (!$this->LoadRow()) { // Load record based on key
					if ($this->getFailureMessage() == "") $this->setFailureMessage($Language->Phrase("NoRecord")); // No record found
					$this->Page_Terminate("client_budgetlist.php"); // No matching record, return to list
				}
				break;
			case "A": // Add new record
				$this->SendEmail = TRUE; // Send email on add success
				if ($this->AddRow($this->OldRecordset)) { // Add successful
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage($Language->Phrase("AddSuccess")); // Set up success message
					$sReturnUrl = $this->getReturnUrl();
					if (ew_GetPageName($sReturnUrl) == "client_budgetlist.php")
						$sReturnUrl = $this->AddMasterUrl($sReturnUrl); // List page, return to list page with correct master key if necessary
					elseif (ew_GetPageName($sReturnUrl) == "client_budgetview.php")
						$sReturnUrl = $this->GetViewUrl(); // View page, return to view page with keyurl directly
					$this->Page_Terminate($sReturnUrl); // Clean up and return
				} else {
					$this->EventCancelled = TRUE; // Event cancelled
					$this->RestoreFormValues(); // Add failed, restore form values
				}
		}

		// Render row based on row type
		$this->RowType = EW_ROWTYPE_ADD; // Render add type

		// Render row
		$this->ResetAttrs();
		$this->RenderRow();
	}

	// Get upload files
	function GetUploadFiles() {
		global $objForm, $Language;

		// Get upload data
	}

	// Load default values
	function LoadDefaultValues() {
		$this->dbkey_client->CurrentValue = NULL;
		$this->dbkey_client->OldValue = $this->dbkey_client->CurrentValue;
		$this->dbkey_activity->CurrentValue = NULL;
		$this->dbkey_activity->OldValue = $this->dbkey_activity->CurrentValue;
		$this->budget->CurrentValue = NULL;
		$this->budget->OldValue = $this->budget->CurrentValue;
		$this->from->CurrentValue = NULL;
		$this->from->OldValue = $this->from->CurrentValue;
		$this->through->CurrentValue = NULL;
		$this->through->OldValue = $this->through->CurrentValue;
		$this->contractid->CurrentValue = NULL;
		$this->contractid->OldValue = $this->contractid->CurrentValue;
		$this->rate->CurrentValue = 0;
	}

	// Load form values
	function LoadFormValues() {

		// Load from form
		global $objForm;
		if (!$this->dbkey_client->FldIsDetailKey) {
			$this->dbkey_client->setFormValue($objForm->GetValue("x_dbkey_client"));
		}
		if (!$this->dbkey_activity->FldIsDetailKey) {
			$this->dbkey_activity->setFormValue($objForm->GetValue("x_dbkey_activity"));
		}
		if (!$this->budget->FldIsDetailKey) {
			$this->budget->setFormValue($objForm->GetValue("x_budget"));
		}
		if (!$this->from->FldIsDetailKey) {
			$this->from->setFormValue($objForm->GetValue("x_from"));
			$this->from->CurrentValue = ew_UnFormatDateTime($this->from->CurrentValue, 0);
		}
		if (!$this->through->FldIsDetailKey) {
			$this->through->setFormValue($objForm->GetValue("x_through"));
			$this->through->CurrentValue = ew_UnFormatDateTime($this->through->CurrentValue, 0);
		}
		if (!$this->contractid->FldIsDetailKey) {
			$this->contractid->setFormValue($objForm->GetValue("x_contractid"));
		}
		if (!$this->rate->FldIsDetailKey) {
			$this->rate->setFormValue($objForm->GetValue("x_rate"));
		}
	}

	// Restore form values
	function RestoreFormValues() {
		global $objForm;
		$this->LoadOldRecord();
		$this->dbkey_client->CurrentValue = $this->dbkey_client->FormValue;
		$this->dbkey_activity->CurrentValue = $this->dbkey_activity->FormValue;
		$this->budget->CurrentValue = $this->budget->FormValue;
		$this->from->CurrentValue = $this->from->FormValue;
		$this->from->CurrentValue = ew_UnFormatDateTime($this->from->CurrentValue, 0);
		$this->through->CurrentValue = $this->through->FormValue;
		$this->through->CurrentValue = ew_UnFormatDateTime($this->through->CurrentValue, 0);
		$this->contractid->CurrentValue = $this->contractid->FormValue;
		$this->rate->CurrentValue = $this->rate->FormValue;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey_client->setDbValue($rs->fields('dbkey_client'));
		if (array_key_exists('EV__dbkey_client', $rs->fields)) {
			$this->dbkey_client->VirtualValue = $rs->fields('EV__dbkey_client'); // Set up virtual field value
		} else {
			$this->dbkey_client->VirtualValue = ""; // Clear value
		}
		$this->Client_Name->setDbValue($rs->fields('Client_Name'));
		$this->Activity_Code->setDbValue($rs->fields('Activity_Code'));
		$this->dbkey_activity->setDbValue($rs->fields('dbkey_activity'));
		$this->budget->setDbValue($rs->fields('budget'));
		$this->from->setDbValue($rs->fields('from'));
		$this->through->setDbValue($rs->fields('through'));
		$this->contractid->setDbValue($rs->fields('contractid'));
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->rate->setDbValue($rs->fields('rate'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey_client->DbValue = $row['dbkey_client'];
		$this->Client_Name->DbValue = $row['Client_Name'];
		$this->Activity_Code->DbValue = $row['Activity_Code'];
		$this->dbkey_activity->DbValue = $row['dbkey_activity'];
		$this->budget->DbValue = $row['budget'];
		$this->from->DbValue = $row['from'];
		$this->through->DbValue = $row['through'];
		$this->contractid->DbValue = $row['contractid'];
		$this->dbkey->DbValue = $row['dbkey'];
		$this->rate->DbValue = $row['rate'];
	}

	// Load old record
	function LoadOldRecord() {

		// Load key values from Session
		$bValidKey = TRUE;
		if (strval($this->getKey("dbkey")) <> "")
			$this->dbkey->CurrentValue = $this->getKey("dbkey"); // dbkey
		else
			$bValidKey = FALSE;

		// Load old recordset
		if ($bValidKey) {
			$this->CurrentFilter = $this->KeyFilter();
			$sSql = $this->SQL();
			$conn = &$this->Connection();
			$this->OldRecordset = ew_LoadRecordset($sSql, $conn);
			$this->LoadRowValues($this->OldRecordset); // Load row values
		} else {
			$this->OldRecordset = NULL;
		}
		return $bValidKey;
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Convert decimal values if posted back

		if ($this->budget->FormValue == $this->budget->CurrentValue && is_numeric(ew_StrToFloat($this->budget->CurrentValue)))
			$this->budget->CurrentValue = ew_StrToFloat($this->budget->CurrentValue);

		// Convert decimal values if posted back
		if ($this->rate->FormValue == $this->rate->CurrentValue && is_numeric(ew_StrToFloat($this->rate->CurrentValue)))
			$this->rate->CurrentValue = ew_StrToFloat($this->rate->CurrentValue);

		// Call Row_Rendering event
		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey_client
		// Client_Name
		// Activity_Code
		// dbkey_activity
		// budget
		// from
		// through
		// contractid
		// dbkey
		// rate

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// dbkey_client
		if ($this->dbkey_client->VirtualValue <> "") {
			$this->dbkey_client->ViewValue = $this->dbkey_client->VirtualValue;
		} else {
		if (strval($this->dbkey_client->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		$this->dbkey_client->LookupFilters = array();
		$lookuptblfilter = "`active` = 1 and `dbkey` in(select dbkey_client from client_to_activity_code where client.`dbkey` = dbkey_client)";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_client->ViewValue = $this->dbkey_client->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_client->ViewValue = $this->dbkey_client->CurrentValue;
			}
		} else {
			$this->dbkey_client->ViewValue = NULL;
		}
		}
		$this->dbkey_client->ViewCustomAttributes = "";

		// Client_Name
		if (strval($this->Client_Name->CurrentValue) <> "") {
			$sFilterWrk = "(select concat(concat(last,' , '),first) from client where client.dbkey = client_budget.dbkey_client)" . ew_SearchString("=", $this->Client_Name->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT (select concat(concat(last,' , '),first) from client where client.dbkey = client_budget.dbkey_client), (select concat(concat(last,' , '),first) from client where client.dbkey = client_budget.dbkey_client) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client_budget`";
		$sWhereWrk = "";
		$this->Client_Name->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->Client_Name, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `Client_Name`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->Client_Name->ViewValue = $this->Client_Name->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->Client_Name->ViewValue = $this->Client_Name->CurrentValue;
			}
		} else {
			$this->Client_Name->ViewValue = NULL;
		}
		$this->Client_Name->ViewCustomAttributes = "";

		// Activity_Code
		$this->Activity_Code->ViewValue = $this->Activity_Code->CurrentValue;
		$this->Activity_Code->ViewCustomAttributes = "";

		// dbkey_activity
		if (strval($this->dbkey_activity->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey_activity`" . ew_SearchString("=", $this->dbkey_activity->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey_activity`, (select activity.description from activity where activity.dbkey = dbkey_activity) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client_to_activity_code`";
		$sWhereWrk = "";
		$this->dbkey_activity->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->CurrentValue;
			}
		} else {
			$this->dbkey_activity->ViewValue = NULL;
		}
		$this->dbkey_activity->ViewCustomAttributes = "";

		// budget
		$this->budget->ViewValue = $this->budget->CurrentValue;
		$this->budget->ViewCustomAttributes = "";

		// from
		$this->from->ViewValue = $this->from->CurrentValue;
		$this->from->ViewValue = ew_FormatDateTime($this->from->ViewValue, 0);
		$this->from->ViewCustomAttributes = "";

		// through
		$this->through->ViewValue = $this->through->CurrentValue;
		$this->through->ViewValue = ew_FormatDateTime($this->through->ViewValue, 0);
		$this->through->ViewCustomAttributes = "";

		// contractid
		$this->contractid->ViewValue = $this->contractid->CurrentValue;
		$this->contractid->ViewValue = ew_FormatNumber($this->contractid->ViewValue, 0, 0, 0, 0);
		$this->contractid->ViewCustomAttributes = "";

		// rate
		$this->rate->ViewValue = $this->rate->CurrentValue;
		$this->rate->ViewValue = ew_FormatNumber($this->rate->ViewValue, 3, -2, -2, -2);
		$this->rate->ViewCustomAttributes = "";

			// dbkey_client
			$this->dbkey_client->LinkCustomAttributes = "";
			$this->dbkey_client->HrefValue = "";
			$this->dbkey_client->TooltipValue = "";

			// dbkey_activity
			$this->dbkey_activity->LinkCustomAttributes = "";
			$this->dbkey_activity->HrefValue = "";
			$this->dbkey_activity->TooltipValue = "";

			// budget
			$this->budget->LinkCustomAttributes = "";
			$this->budget->HrefValue = "";
			$this->budget->TooltipValue = "";

			// from
			$this->from->LinkCustomAttributes = "";
			$this->from->HrefValue = "";
			$this->from->TooltipValue = "";

			// through
			$this->through->LinkCustomAttributes = "";
			$this->through->HrefValue = "";
			$this->through->TooltipValue = "";

			// contractid
			$this->contractid->LinkCustomAttributes = "";
			$this->contractid->HrefValue = "";
			$this->contractid->TooltipValue = "";

			// rate
			$this->rate->LinkCustomAttributes = "";
			$this->rate->HrefValue = "";
			$this->rate->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_ADD) { // Add row

			// dbkey_client
			$this->dbkey_client->EditAttrs["class"] = "form-control";
			$this->dbkey_client->EditCustomAttributes = "";
			if ($this->dbkey_client->getSessionValue() <> "") {
				$this->dbkey_client->CurrentValue = $this->dbkey_client->getSessionValue();
			if ($this->dbkey_client->VirtualValue <> "") {
				$this->dbkey_client->ViewValue = $this->dbkey_client->VirtualValue;
			} else {
			if (strval($this->dbkey_client->CurrentValue) <> "") {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
			$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
			$sWhereWrk = "";
			$this->dbkey_client->LookupFilters = array();
			$lookuptblfilter = "`active` = 1 and `dbkey` in(select dbkey_client from client_to_activity_code where client.`dbkey` = dbkey_client)";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last` ASC";
				$rswrk = Conn()->Execute($sSqlWrk);
				if ($rswrk && !$rswrk->EOF) { // Lookup values found
					$arwrk = array();
					$arwrk[1] = $rswrk->fields('DispFld');
					$arwrk[2] = $rswrk->fields('Disp2Fld');
					$this->dbkey_client->ViewValue = $this->dbkey_client->DisplayValue($arwrk);
					$rswrk->Close();
				} else {
					$this->dbkey_client->ViewValue = $this->dbkey_client->CurrentValue;
				}
			} else {
				$this->dbkey_client->ViewValue = NULL;
			}
			}
			$this->dbkey_client->ViewCustomAttributes = "";
			} else {
			if (trim(strval($this->dbkey_client->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `client`";
			$sWhereWrk = "";
			$this->dbkey_client->LookupFilters = array();
			$lookuptblfilter = "`active` = 1 and `dbkey` in(select dbkey_client from client_to_activity_code where client.`dbkey` = dbkey_client)";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->dbkey_client->EditValue = $arwrk;
			}

			// dbkey_activity
			$this->dbkey_activity->EditAttrs["class"] = "form-control";
			$this->dbkey_activity->EditCustomAttributes = "";
			if (trim(strval($this->dbkey_activity->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey_activity`" . ew_SearchString("=", $this->dbkey_activity->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT `dbkey_activity`, (select activity.description from activity where activity.dbkey = dbkey_activity) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, `dbkey_client` AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `client_to_activity_code`";
			$sWhereWrk = "";
			$this->dbkey_activity->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->dbkey_activity->EditValue = $arwrk;

			// budget
			$this->budget->EditAttrs["class"] = "form-control";
			$this->budget->EditCustomAttributes = "";
			$this->budget->EditValue = ew_HtmlEncode($this->budget->CurrentValue);
			$this->budget->PlaceHolder = ew_RemoveHtml($this->budget->FldCaption());
			if (strval($this->budget->EditValue) <> "" && is_numeric($this->budget->EditValue)) $this->budget->EditValue = ew_FormatNumber($this->budget->EditValue, -2, -1, -2, 0);

			// from
			$this->from->EditAttrs["class"] = "form-control";
			$this->from->EditCustomAttributes = "";
			$this->from->EditValue = ew_HtmlEncode(ew_FormatDateTime($this->from->CurrentValue, 8));
			$this->from->PlaceHolder = ew_RemoveHtml($this->from->FldCaption());

			// through
			$this->through->EditAttrs["class"] = "form-control";
			$this->through->EditCustomAttributes = "";
			$this->through->EditValue = ew_HtmlEncode(ew_FormatDateTime($this->through->CurrentValue, 8));
			$this->through->PlaceHolder = ew_RemoveHtml($this->through->FldCaption());

			// contractid
			$this->contractid->EditAttrs["class"] = "form-control";
			$this->contractid->EditCustomAttributes = "";
			$this->contractid->EditValue = ew_HtmlEncode($this->contractid->CurrentValue);
			$this->contractid->PlaceHolder = ew_RemoveHtml($this->contractid->FldCaption());

			// rate
			$this->rate->EditAttrs["class"] = "form-control";
			$this->rate->EditCustomAttributes = "";
			$this->rate->EditValue = ew_HtmlEncode($this->rate->CurrentValue);
			$this->rate->PlaceHolder = ew_RemoveHtml($this->rate->FldCaption());
			if (strval($this->rate->EditValue) <> "" && is_numeric($this->rate->EditValue)) $this->rate->EditValue = ew_FormatNumber($this->rate->EditValue, -2, -2, -2, -2);

			// Add refer script
			// dbkey_client

			$this->dbkey_client->LinkCustomAttributes = "";
			$this->dbkey_client->HrefValue = "";

			// dbkey_activity
			$this->dbkey_activity->LinkCustomAttributes = "";
			$this->dbkey_activity->HrefValue = "";

			// budget
			$this->budget->LinkCustomAttributes = "";
			$this->budget->HrefValue = "";

			// from
			$this->from->LinkCustomAttributes = "";
			$this->from->HrefValue = "";

			// through
			$this->through->LinkCustomAttributes = "";
			$this->through->HrefValue = "";

			// contractid
			$this->contractid->LinkCustomAttributes = "";
			$this->contractid->HrefValue = "";

			// rate
			$this->rate->LinkCustomAttributes = "";
			$this->rate->HrefValue = "";
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate form
	function ValidateForm() {
		global $Language, $gsFormError;

		// Initialize form error message
		$gsFormError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return ($gsFormError == "");
		if (!$this->dbkey_client->FldIsDetailKey && !is_null($this->dbkey_client->FormValue) && $this->dbkey_client->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->dbkey_client->FldCaption(), $this->dbkey_client->ReqErrMsg));
		}
		if (!$this->dbkey_activity->FldIsDetailKey && !is_null($this->dbkey_activity->FormValue) && $this->dbkey_activity->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->dbkey_activity->FldCaption(), $this->dbkey_activity->ReqErrMsg));
		}
		if (!$this->budget->FldIsDetailKey && !is_null($this->budget->FormValue) && $this->budget->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->budget->FldCaption(), $this->budget->ReqErrMsg));
		}
		if (!ew_CheckNumber($this->budget->FormValue)) {
			ew_AddMessage($gsFormError, $this->budget->FldErrMsg());
		}
		if (!$this->from->FldIsDetailKey && !is_null($this->from->FormValue) && $this->from->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->from->FldCaption(), $this->from->ReqErrMsg));
		}
		if (!ew_CheckDateDef($this->from->FormValue)) {
			ew_AddMessage($gsFormError, $this->from->FldErrMsg());
		}
		if (!$this->through->FldIsDetailKey && !is_null($this->through->FormValue) && $this->through->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->through->FldCaption(), $this->through->ReqErrMsg));
		}
		if (!ew_CheckDateDef($this->through->FormValue)) {
			ew_AddMessage($gsFormError, $this->through->FldErrMsg());
		}
		if (!$this->contractid->FldIsDetailKey && !is_null($this->contractid->FormValue) && $this->contractid->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->contractid->FldCaption(), $this->contractid->ReqErrMsg));
		}
		if (!ew_CheckNumber($this->rate->FormValue)) {
			ew_AddMessage($gsFormError, $this->rate->FldErrMsg());
		}

		// Return validate result
		$ValidateForm = ($gsFormError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateForm = $ValidateForm && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsFormError, $sFormCustomError);
		}
		return $ValidateForm;
	}

	// Add record
	function AddRow($rsold = NULL) {
		global $Language, $Security;
		$conn = &$this->Connection();

		// Load db values from rsold
		if ($rsold) {
			$this->LoadDbValues($rsold);
		}
		$rsnew = array();

		// dbkey_client
		$this->dbkey_client->SetDbValueDef($rsnew, $this->dbkey_client->CurrentValue, 0, FALSE);

		// dbkey_activity
		$this->dbkey_activity->SetDbValueDef($rsnew, $this->dbkey_activity->CurrentValue, NULL, FALSE);

		// budget
		$this->budget->SetDbValueDef($rsnew, $this->budget->CurrentValue, 0, FALSE);

		// from
		$this->from->SetDbValueDef($rsnew, ew_UnFormatDateTime($this->from->CurrentValue, 0), ew_CurrentDate(), FALSE);

		// through
		$this->through->SetDbValueDef($rsnew, ew_UnFormatDateTime($this->through->CurrentValue, 0), ew_CurrentDate(), FALSE);

		// contractid
		$this->contractid->SetDbValueDef($rsnew, $this->contractid->CurrentValue, "", FALSE);

		// rate
		$this->rate->SetDbValueDef($rsnew, $this->rate->CurrentValue, NULL, FALSE);

		// Activity_Code
		if ($this->Activity_Code->getSessionValue() <> "") {
			$rsnew['Activity_Code'] = $this->Activity_Code->getSessionValue();
		}

		// Call Row Inserting event
		$rs = ($rsold == NULL) ? NULL : $rsold->fields;
		$bInsertRow = $this->Row_Inserting($rs, $rsnew);
		if ($bInsertRow) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			$AddRow = $this->Insert($rsnew);
			$conn->raiseErrorFn = '';
			if ($AddRow) {

				// Get insert id if necessary
				$this->dbkey->setDbValue($conn->Insert_ID());
				$rsnew['dbkey'] = $this->dbkey->DbValue;
			}
		} else {
			if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

				// Use the message, do nothing
			} elseif ($this->CancelMessage <> "") {
				$this->setFailureMessage($this->CancelMessage);
				$this->CancelMessage = "";
			} else {
				$this->setFailureMessage($Language->Phrase("InsertCancelled"));
			}
			$AddRow = FALSE;
		}
		if ($AddRow) {

			// Call Row Inserted event
			$rs = ($rsold == NULL) ? NULL : $rsold->fields;
			$this->Row_Inserted($rs, $rsnew);
			$this->WriteAuditTrailOnAdd($rsnew);
		}
		return $AddRow;
	}

	// Set up master/detail based on QueryString
	function SetUpMasterParms() {
		$bValidMaster = FALSE;

		// Get the keys for master table
		if (isset($_GET[EW_TABLE_SHOW_MASTER])) {
			$sMasterTblVar = $_GET[EW_TABLE_SHOW_MASTER];
			if ($sMasterTblVar == "") {
				$bValidMaster = TRUE;
				$this->DbMasterFilter = "";
				$this->DbDetailFilter = "";
			}
			if ($sMasterTblVar == "activity") {
				$bValidMaster = TRUE;
				if (@$_GET["fk_dbkey"] <> "") {
					$GLOBALS["activity"]->dbkey->setQueryStringValue($_GET["fk_dbkey"]);
					$this->Activity_Code->setQueryStringValue($GLOBALS["activity"]->dbkey->QueryStringValue);
					$this->Activity_Code->setSessionValue($this->Activity_Code->QueryStringValue);
					if (!is_numeric($GLOBALS["activity"]->dbkey->QueryStringValue)) $bValidMaster = FALSE;
				} else {
					$bValidMaster = FALSE;
				}
			}
			if ($sMasterTblVar == "client") {
				$bValidMaster = TRUE;
				if (@$_GET["fk_dbkey"] <> "") {
					$GLOBALS["client"]->dbkey->setQueryStringValue($_GET["fk_dbkey"]);
					$this->dbkey_client->setQueryStringValue($GLOBALS["client"]->dbkey->QueryStringValue);
					$this->dbkey_client->setSessionValue($this->dbkey_client->QueryStringValue);
					if (!is_numeric($GLOBALS["client"]->dbkey->QueryStringValue)) $bValidMaster = FALSE;
				} else {
					$bValidMaster = FALSE;
				}
			}
		} elseif (isset($_POST[EW_TABLE_SHOW_MASTER])) {
			$sMasterTblVar = $_POST[EW_TABLE_SHOW_MASTER];
			if ($sMasterTblVar == "") {
				$bValidMaster = TRUE;
				$this->DbMasterFilter = "";
				$this->DbDetailFilter = "";
			}
			if ($sMasterTblVar == "activity") {
				$bValidMaster = TRUE;
				if (@$_POST["fk_dbkey"] <> "") {
					$GLOBALS["activity"]->dbkey->setFormValue($_POST["fk_dbkey"]);
					$this->Activity_Code->setFormValue($GLOBALS["activity"]->dbkey->FormValue);
					$this->Activity_Code->setSessionValue($this->Activity_Code->FormValue);
					if (!is_numeric($GLOBALS["activity"]->dbkey->FormValue)) $bValidMaster = FALSE;
				} else {
					$bValidMaster = FALSE;
				}
			}
			if ($sMasterTblVar == "client") {
				$bValidMaster = TRUE;
				if (@$_POST["fk_dbkey"] <> "") {
					$GLOBALS["client"]->dbkey->setFormValue($_POST["fk_dbkey"]);
					$this->dbkey_client->setFormValue($GLOBALS["client"]->dbkey->FormValue);
					$this->dbkey_client->setSessionValue($this->dbkey_client->FormValue);
					if (!is_numeric($GLOBALS["client"]->dbkey->FormValue)) $bValidMaster = FALSE;
				} else {
					$bValidMaster = FALSE;
				}
			}
		}
		if ($bValidMaster) {

			// Save current master table
			$this->setCurrentMasterTable($sMasterTblVar);

			// Reset start record counter (new master key)
			$this->StartRec = 1;
			$this->setStartRecordNumber($this->StartRec);

			// Clear previous master key from Session
			if ($sMasterTblVar <> "activity") {
				if ($this->Activity_Code->CurrentValue == "") $this->Activity_Code->setSessionValue("");
			}
			if ($sMasterTblVar <> "client") {
				if ($this->dbkey_client->CurrentValue == "") $this->dbkey_client->setSessionValue("");
			}
		}
		$this->DbMasterFilter = $this->GetMasterFilter(); // Get master filter
		$this->DbDetailFilter = $this->GetDetailFilter(); // Get detail filter
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, $this->AddMasterUrl("client_budgetlist.php"), "", $this->TableVar, TRUE);
		$PageId = ($this->CurrentAction == "C") ? "Copy" : "Add";
		$Breadcrumb->Add("add", $PageId, $url);
	}

	// Setup lookup filters of a field
	function SetupLookupFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		case "x_dbkey_client":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT DISTINCT `dbkey` AS `LinkFld`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
			$sWhereWrk = "";
			$this->dbkey_client->LookupFilters = array();
			$lookuptblfilter = "`active` = 1 and `dbkey` in(select dbkey_client from client_to_activity_code where client.`dbkey` = dbkey_client)";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey` = {filter_value}', "t0" => "3", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last` ASC";
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		case "x_dbkey_activity":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT `dbkey_activity` AS `LinkFld`, (select activity.description from activity where activity.dbkey = dbkey_activity) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client_to_activity_code`";
			$sWhereWrk = "{filter}";
			$this->dbkey_activity->LookupFilters = array();
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey_activity` = {filter_value}', "t0" => "3", "fn0" => "", "f1" => '`dbkey_client` IN ({filter_value})', "t1" => "3", "fn1" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		}
	}

	// Setup AutoSuggest filters of a field
	function SetupAutoSuggestFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Write Audit Trail start/end for grid update
	function WriteAuditTrailDummy($typ) {
		$table = 'client_budget';
		$usr = CurrentUserID();
		ew_WriteAuditTrail("log", ew_StdCurrentDateTime(), ew_ScriptName(), $usr, $typ, $table, "", "", "", "");
	}

	// Write Audit Trail (add page)
	function WriteAuditTrailOnAdd(&$rs) {
		global $Language;
		if (!$this->AuditTrailOnAdd) return;
		$table = 'client_budget';

		// Get key value
		$key = "";
		if ($key <> "") $key .= $GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"];
		$key .= $rs['dbkey'];

		// Write Audit Trail
		$dt = ew_StdCurrentDateTime();
		$id = ew_ScriptName();
		$usr = CurrentUserID();
		foreach (array_keys($rs) as $fldname) {
			if ($this->fields[$fldname]->FldDataType <> EW_DATATYPE_BLOB) { // Ignore BLOB fields
				if ($this->fields[$fldname]->FldHtmlTag == "PASSWORD") {
					$newvalue = $Language->Phrase("PasswordMask"); // Password Field
				} elseif ($this->fields[$fldname]->FldDataType == EW_DATATYPE_MEMO) {
					if (EW_AUDIT_TRAIL_TO_DATABASE)
						$newvalue = $rs[$fldname];
					else
						$newvalue = "[MEMO]"; // Memo Field
				} elseif ($this->fields[$fldname]->FldDataType == EW_DATATYPE_XML) {
					$newvalue = "[XML]"; // XML Field
				} else {
					$newvalue = $rs[$fldname];
				}
				ew_WriteAuditTrail("log", $dt, $id, $usr, "A", $table, $fldname, $key, "", $newvalue);
			}
		}
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {      
	echo "<h3 style='position:absolute;top:110px;left:192px;'> Welcome " . CurrentUserName() . "</h3>";   
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($client_budget_add)) $client_budget_add = new cclient_budget_add();

// Page init
$client_budget_add->Page_Init();

// Page main
$client_budget_add->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$client_budget_add->Page_Render();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "add";
var CurrentForm = fclient_budgetadd = new ew_Form("fclient_budgetadd", "add");

// Validate form
fclient_budgetadd.Validate = function() {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	var $ = jQuery, fobj = this.GetForm(), $fobj = $(fobj);
	if ($fobj.find("#a_confirm").val() == "F")
		return true;
	var elm, felm, uelm, addcnt = 0;
	var $k = $fobj.find("#" + this.FormKeyCountName); // Get key_count
	var rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1;
	var startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
	var gridinsert = $fobj.find("#a_list").val() == "gridinsert";
	for (var i = startcnt; i <= rowcnt; i++) {
		var infix = ($k[0]) ? String(i) : "";
		$fobj.data("rowindex", infix);
			elm = this.GetElements("x" + infix + "_dbkey_client");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_budget->dbkey_client->FldCaption(), $client_budget->dbkey_client->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_dbkey_activity");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_budget->dbkey_activity->FldCaption(), $client_budget->dbkey_activity->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_budget");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_budget->budget->FldCaption(), $client_budget->budget->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_budget");
			if (elm && !ew_CheckNumber(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($client_budget->budget->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_from");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_budget->from->FldCaption(), $client_budget->from->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_from");
			if (elm && !ew_CheckDateDef(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($client_budget->from->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_through");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_budget->through->FldCaption(), $client_budget->through->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_through");
			if (elm && !ew_CheckDateDef(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($client_budget->through->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_contractid");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_budget->contractid->FldCaption(), $client_budget->contractid->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_rate");
			if (elm && !ew_CheckNumber(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($client_budget->rate->FldErrMsg()) ?>");

			// Fire Form_CustomValidate event
			if (!this.Form_CustomValidate(fobj))
				return false;
	}

	// Process detail forms
	var dfs = $fobj.find("input[name='detailpage']").get();
	for (var i = 0; i < dfs.length; i++) {
		var df = dfs[i], val = df.value;
		if (val && ewForms[val])
			if (!ewForms[val].Validate())
				return false;
	}
	return true;
}

// Form_CustomValidate event
fclient_budgetadd.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fclient_budgetadd.ValidateRequired = true;
<?php } else { ?>
fclient_budgetadd.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fclient_budgetadd.Lists["x_dbkey_client"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_last","x_first","",""],"ParentFields":[],"ChildFields":["x_dbkey_activity"],"FilterFields":[],"Options":[],"Template":"","LinkTable":"client"};
fclient_budgetadd.Lists["x_dbkey_activity"] = {"LinkField":"x_dbkey_activity","Ajax":true,"AutoFill":false,"DisplayFields":["x_activity_description","","",""],"ParentFields":["x_dbkey_client"],"ChildFields":[],"FilterFields":["x_dbkey_client"],"Options":[],"Template":"","LinkTable":"client_to_activity_code"};

// Form object for search
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php if (!$client_budget_add->IsModal) { ?>
<div class="ewToolbar">
<?php $Breadcrumb->Render(); ?>
<?php echo $Language->SelectionForm(); ?>
<div class="clearfix"></div>
</div>
<?php } ?>
<?php $client_budget_add->ShowPageHeader(); ?>
<?php
$client_budget_add->ShowMessage();
?>
<form name="fclient_budgetadd" id="fclient_budgetadd" class="<?php echo $client_budget_add->FormClassName ?>" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($client_budget_add->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $client_budget_add->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="client_budget">
<input type="hidden" name="a_add" id="a_add" value="A">
<?php if ($client_budget_add->IsModal) { ?>
<input type="hidden" name="modal" value="1">
<?php } ?>
<?php if ($client_budget->getCurrentMasterTable() == "activity") { ?>
<input type="hidden" name="<?php echo EW_TABLE_SHOW_MASTER ?>" value="activity">
<input type="hidden" name="fk_dbkey" value="<?php echo $client_budget->Activity_Code->getSessionValue() ?>">
<?php } ?>
<?php if ($client_budget->getCurrentMasterTable() == "client") { ?>
<input type="hidden" name="<?php echo EW_TABLE_SHOW_MASTER ?>" value="client">
<input type="hidden" name="fk_dbkey" value="<?php echo $client_budget->dbkey_client->getSessionValue() ?>">
<?php } ?>
<div>
<?php if ($client_budget->dbkey_client->Visible) { // dbkey_client ?>
	<div id="r_dbkey_client" class="form-group">
		<label id="elh_client_budget_dbkey_client" for="x_dbkey_client" class="col-sm-2 control-label ewLabel"><?php echo $client_budget->dbkey_client->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $client_budget->dbkey_client->CellAttributes() ?>>
<?php if ($client_budget->dbkey_client->getSessionValue() <> "") { ?>
<span id="el_client_budget_dbkey_client">
<span<?php echo $client_budget->dbkey_client->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client_budget->dbkey_client->ViewValue ?></p></span>
</span>
<input type="hidden" id="x_dbkey_client" name="x_dbkey_client" value="<?php echo ew_HtmlEncode($client_budget->dbkey_client->CurrentValue) ?>">
<?php } else { ?>
<span id="el_client_budget_dbkey_client">
<?php $client_budget->dbkey_client->EditAttrs["onchange"] = "ew_UpdateOpt.call(this); " . @$client_budget->dbkey_client->EditAttrs["onchange"]; ?>
<select data-table="client_budget" data-field="x_dbkey_client" data-value-separator="<?php echo $client_budget->dbkey_client->DisplayValueSeparatorAttribute() ?>" id="x_dbkey_client" name="x_dbkey_client"<?php echo $client_budget->dbkey_client->EditAttributes() ?>>
<?php echo $client_budget->dbkey_client->SelectOptionListHtml("x_dbkey_client") ?>
</select>
<input type="hidden" name="s_x_dbkey_client" id="s_x_dbkey_client" value="<?php echo $client_budget->dbkey_client->LookupFilterQuery() ?>">
</span>
<?php } ?>
<?php echo $client_budget->dbkey_client->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($client_budget->dbkey_activity->Visible) { // dbkey_activity ?>
	<div id="r_dbkey_activity" class="form-group">
		<label id="elh_client_budget_dbkey_activity" for="x_dbkey_activity" class="col-sm-2 control-label ewLabel"><?php echo $client_budget->dbkey_activity->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $client_budget->dbkey_activity->CellAttributes() ?>>
<span id="el_client_budget_dbkey_activity">
<select data-table="client_budget" data-field="x_dbkey_activity" data-value-separator="<?php echo $client_budget->dbkey_activity->DisplayValueSeparatorAttribute() ?>" id="x_dbkey_activity" name="x_dbkey_activity"<?php echo $client_budget->dbkey_activity->EditAttributes() ?>>
<?php echo $client_budget->dbkey_activity->SelectOptionListHtml("x_dbkey_activity") ?>
</select>
<input type="hidden" name="s_x_dbkey_activity" id="s_x_dbkey_activity" value="<?php echo $client_budget->dbkey_activity->LookupFilterQuery() ?>">
</span>
<?php echo $client_budget->dbkey_activity->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($client_budget->budget->Visible) { // budget ?>
	<div id="r_budget" class="form-group">
		<label id="elh_client_budget_budget" for="x_budget" class="col-sm-2 control-label ewLabel"><?php echo $client_budget->budget->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $client_budget->budget->CellAttributes() ?>>
<span id="el_client_budget_budget">
<input type="text" data-table="client_budget" data-field="x_budget" name="x_budget" id="x_budget" size="30" placeholder="<?php echo ew_HtmlEncode($client_budget->budget->getPlaceHolder()) ?>" value="<?php echo $client_budget->budget->EditValue ?>"<?php echo $client_budget->budget->EditAttributes() ?>>
</span>
<?php echo $client_budget->budget->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($client_budget->from->Visible) { // from ?>
	<div id="r_from" class="form-group">
		<label id="elh_client_budget_from" for="x_from" class="col-sm-2 control-label ewLabel"><?php echo $client_budget->from->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $client_budget->from->CellAttributes() ?>>
<span id="el_client_budget_from">
<input type="text" data-table="client_budget" data-field="x_from" name="x_from" id="x_from" placeholder="<?php echo ew_HtmlEncode($client_budget->from->getPlaceHolder()) ?>" value="<?php echo $client_budget->from->EditValue ?>"<?php echo $client_budget->from->EditAttributes() ?>>
<?php if (!$client_budget->from->ReadOnly && !$client_budget->from->Disabled && !isset($client_budget->from->EditAttrs["readonly"]) && !isset($client_budget->from->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fclient_budgetadd", "x_from", 0);
</script>
<?php } ?>
</span>
<?php echo $client_budget->from->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($client_budget->through->Visible) { // through ?>
	<div id="r_through" class="form-group">
		<label id="elh_client_budget_through" for="x_through" class="col-sm-2 control-label ewLabel"><?php echo $client_budget->through->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $client_budget->through->CellAttributes() ?>>
<span id="el_client_budget_through">
<input type="text" data-table="client_budget" data-field="x_through" name="x_through" id="x_through" placeholder="<?php echo ew_HtmlEncode($client_budget->through->getPlaceHolder()) ?>" value="<?php echo $client_budget->through->EditValue ?>"<?php echo $client_budget->through->EditAttributes() ?>>
<?php if (!$client_budget->through->ReadOnly && !$client_budget->through->Disabled && !isset($client_budget->through->EditAttrs["readonly"]) && !isset($client_budget->through->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fclient_budgetadd", "x_through", 0);
</script>
<?php } ?>
</span>
<?php echo $client_budget->through->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($client_budget->contractid->Visible) { // contractid ?>
	<div id="r_contractid" class="form-group">
		<label id="elh_client_budget_contractid" for="x_contractid" class="col-sm-2 control-label ewLabel"><?php echo $client_budget->contractid->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $client_budget->contractid->CellAttributes() ?>>
<span id="el_client_budget_contractid">
<input type="text" data-table="client_budget" data-field="x_contractid" name="x_contractid" id="x_contractid" size="30" maxlength="50" placeholder="<?php echo ew_HtmlEncode($client_budget->contractid->getPlaceHolder()) ?>" value="<?php echo $client_budget->contractid->EditValue ?>"<?php echo $client_budget->contractid->EditAttributes() ?>>
</span>
<?php echo $client_budget->contractid->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($client_budget->rate->Visible) { // rate ?>
	<div id="r_rate" class="form-group">
		<label id="elh_client_budget_rate" for="x_rate" class="col-sm-2 control-label ewLabel"><?php echo $client_budget->rate->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $client_budget->rate->CellAttributes() ?>>
<span id="el_client_budget_rate">
<input type="text" data-table="client_budget" data-field="x_rate" name="x_rate" id="x_rate" size="30" placeholder="<?php echo ew_HtmlEncode($client_budget->rate->getPlaceHolder()) ?>" value="<?php echo $client_budget->rate->EditValue ?>"<?php echo $client_budget->rate->EditAttributes() ?>>
</span>
<?php echo $client_budget->rate->CustomMsg ?></div></div>
	</div>
<?php } ?>
</div>
<?php if (strval($client_budget->Activity_Code->getSessionValue()) <> "") { ?>
<input type="hidden" name="x_Activity_Code" id="x_Activity_Code" value="<?php echo ew_HtmlEncode(strval($client_budget->Activity_Code->getSessionValue())) ?>">
<?php } ?>
<?php if (!$client_budget_add->IsModal) { ?>
<div class="form-group">
	<div class="col-sm-offset-2 col-sm-10">
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit"><?php echo $Language->Phrase("AddBtn") ?></button>
<button class="btn btn-default ewButton" name="btnCancel" id="btnCancel" type="button" data-href="<?php echo $client_budget_add->getReturnUrl() ?>"><?php echo $Language->Phrase("CancelBtn") ?></button>
	</div>
</div>
<?php } ?>
</form>
<script type="text/javascript">
fclient_budgetadd.Init();
</script>
<?php
$client_budget_add->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$client_budget_add->Page_Terminate();
?>
