<?php include_once "counselorinfo.php" ?>
<?php

// Create page object
if (!isset($client_budget_grid)) $client_budget_grid = new cclient_budget_grid();

// Page init
$client_budget_grid->Page_Init();

// Page main
$client_budget_grid->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$client_budget_grid->Page_Render();
?>
<?php if ($client_budget->Export == "") { ?>
<script type="text/javascript">

// Form object
var fclient_budgetgrid = new ew_Form("fclient_budgetgrid", "grid");
fclient_budgetgrid.FormKeyCountName = '<?php echo $client_budget_grid->FormKeyCountName ?>';

// Validate form
fclient_budgetgrid.Validate = function() {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	var $ = jQuery, fobj = this.GetForm(), $fobj = $(fobj);
	if ($fobj.find("#a_confirm").val() == "F")
		return true;
	var elm, felm, uelm, addcnt = 0;
	var $k = $fobj.find("#" + this.FormKeyCountName); // Get key_count
	var rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1;
	var startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
	var gridinsert = $fobj.find("#a_list").val() == "gridinsert";
	for (var i = startcnt; i <= rowcnt; i++) {
		var infix = ($k[0]) ? String(i) : "";
		$fobj.data("rowindex", infix);
		var checkrow = (gridinsert) ? !this.EmptyRow(infix) : true;
		if (checkrow) {
			addcnt++;
			elm = this.GetElements("x" + infix + "_dbkey_client");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_budget->dbkey_client->FldCaption(), $client_budget->dbkey_client->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_budget");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_budget->budget->FldCaption(), $client_budget->budget->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_budget");
			if (elm && !ew_CheckNumber(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($client_budget->budget->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_from");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_budget->from->FldCaption(), $client_budget->from->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_from");
			if (elm && !ew_CheckDateDef(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($client_budget->from->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_through");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_budget->through->FldCaption(), $client_budget->through->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_through");
			if (elm && !ew_CheckDateDef(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($client_budget->through->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_contractid");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_budget->contractid->FldCaption(), $client_budget->contractid->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_rate");
			if (elm && !ew_CheckNumber(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($client_budget->rate->FldErrMsg()) ?>");

			// Fire Form_CustomValidate event
			if (!this.Form_CustomValidate(fobj))
				return false;
		} // End Grid Add checking
	}
	return true;
}

// Check empty row
fclient_budgetgrid.EmptyRow = function(infix) {
	var fobj = this.Form;
	if (ew_ValueChanged(fobj, infix, "dbkey_client", false)) return false;
	if (ew_ValueChanged(fobj, infix, "Client_Name", false)) return false;
	if (ew_ValueChanged(fobj, infix, "Activity_Code", false)) return false;
	if (ew_ValueChanged(fobj, infix, "budget", false)) return false;
	if (ew_ValueChanged(fobj, infix, "from", false)) return false;
	if (ew_ValueChanged(fobj, infix, "through", false)) return false;
	if (ew_ValueChanged(fobj, infix, "contractid", false)) return false;
	if (ew_ValueChanged(fobj, infix, "rate", false)) return false;
	return true;
}

// Form_CustomValidate event
fclient_budgetgrid.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fclient_budgetgrid.ValidateRequired = true;
<?php } else { ?>
fclient_budgetgrid.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fclient_budgetgrid.Lists["x_dbkey_client"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_last","x_first","",""],"ParentFields":[],"ChildFields":["x_dbkey_activity"],"FilterFields":[],"Options":[],"Template":"","LinkTable":"client"};
fclient_budgetgrid.Lists["x_Client_Name"] = {"LinkField":"x_Client_Name","Ajax":true,"AutoFill":false,"DisplayFields":["x_Client_Name","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"client_budget"};

// Form object for search
</script>
<?php } ?>
<?php
if ($client_budget->CurrentAction == "gridadd") {
	if ($client_budget->CurrentMode == "copy") {
		$bSelectLimit = $client_budget_grid->UseSelectLimit;
		if ($bSelectLimit) {
			$client_budget_grid->TotalRecs = $client_budget->SelectRecordCount();
			$client_budget_grid->Recordset = $client_budget_grid->LoadRecordset($client_budget_grid->StartRec-1, $client_budget_grid->DisplayRecs);
		} else {
			if ($client_budget_grid->Recordset = $client_budget_grid->LoadRecordset())
				$client_budget_grid->TotalRecs = $client_budget_grid->Recordset->RecordCount();
		}
		$client_budget_grid->StartRec = 1;
		$client_budget_grid->DisplayRecs = $client_budget_grid->TotalRecs;
	} else {
		$client_budget->CurrentFilter = "0=1";
		$client_budget_grid->StartRec = 1;
		$client_budget_grid->DisplayRecs = $client_budget->GridAddRowCount;
	}
	$client_budget_grid->TotalRecs = $client_budget_grid->DisplayRecs;
	$client_budget_grid->StopRec = $client_budget_grid->DisplayRecs;
} else {
	$bSelectLimit = $client_budget_grid->UseSelectLimit;
	if ($bSelectLimit) {
		if ($client_budget_grid->TotalRecs <= 0)
			$client_budget_grid->TotalRecs = $client_budget->SelectRecordCount();
	} else {
		if (!$client_budget_grid->Recordset && ($client_budget_grid->Recordset = $client_budget_grid->LoadRecordset()))
			$client_budget_grid->TotalRecs = $client_budget_grid->Recordset->RecordCount();
	}
	$client_budget_grid->StartRec = 1;
	$client_budget_grid->DisplayRecs = $client_budget_grid->TotalRecs; // Display all records
	if ($bSelectLimit)
		$client_budget_grid->Recordset = $client_budget_grid->LoadRecordset($client_budget_grid->StartRec-1, $client_budget_grid->DisplayRecs);

	// Set no record found message
	if ($client_budget->CurrentAction == "" && $client_budget_grid->TotalRecs == 0) {
		if (!$Security->CanList())
			$client_budget_grid->setWarningMessage(ew_DeniedMsg());
		if ($client_budget_grid->SearchWhere == "0=101")
			$client_budget_grid->setWarningMessage($Language->Phrase("EnterSearchCriteria"));
		else
			$client_budget_grid->setWarningMessage($Language->Phrase("NoRecord"));
	}
}
$client_budget_grid->RenderOtherOptions();
?>
<?php $client_budget_grid->ShowPageHeader(); ?>
<?php
$client_budget_grid->ShowMessage();
?>
<?php if ($client_budget_grid->TotalRecs > 0 || $client_budget->CurrentAction <> "") { ?>
<div class="panel panel-default ewGrid client_budget">
<div id="fclient_budgetgrid" class="ewForm form-inline">
<?php if ($client_budget_grid->ShowOtherOptions) { ?>
<div class="panel-heading ewGridUpperPanel">
<?php
	foreach ($client_budget_grid->OtherOptions as &$option)
		$option->Render("body");
?>
</div>
<div class="clearfix"></div>
<?php } ?>
<div id="gmp_client_budget" class="<?php if (ew_IsResponsiveLayout()) { echo "table-responsive "; } ?>ewGridMiddlePanel">
<table id="tbl_client_budgetgrid" class="table ewTable">
<?php echo $client_budget->TableCustomInnerHtml ?>
<thead><!-- Table header -->
	<tr class="ewTableHeader">
<?php

// Header row
$client_budget_grid->RowType = EW_ROWTYPE_HEADER;

// Render list options
$client_budget_grid->RenderListOptions();

// Render list options (header, left)
$client_budget_grid->ListOptions->Render("header", "left");
?>
<?php if ($client_budget->dbkey_client->Visible) { // dbkey_client ?>
	<?php if ($client_budget->SortUrl($client_budget->dbkey_client) == "") { ?>
		<th data-name="dbkey_client"><div id="elh_client_budget_dbkey_client" class="client_budget_dbkey_client"><div class="ewTableHeaderCaption" style="white-space: nowrap;"><?php echo $client_budget->dbkey_client->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="dbkey_client"><div><div id="elh_client_budget_dbkey_client" class="client_budget_dbkey_client">
			<div class="ewTableHeaderBtn" style="white-space: nowrap;"><span class="ewTableHeaderCaption"><?php echo $client_budget->dbkey_client->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client_budget->dbkey_client->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client_budget->dbkey_client->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client_budget->Client_Name->Visible) { // Client_Name ?>
	<?php if ($client_budget->SortUrl($client_budget->Client_Name) == "") { ?>
		<th data-name="Client_Name"><div id="elh_client_budget_Client_Name" class="client_budget_Client_Name"><div class="ewTableHeaderCaption"><?php echo $client_budget->Client_Name->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Client_Name"><div><div id="elh_client_budget_Client_Name" class="client_budget_Client_Name">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $client_budget->Client_Name->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client_budget->Client_Name->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client_budget->Client_Name->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client_budget->Activity_Code->Visible) { // Activity_Code ?>
	<?php if ($client_budget->SortUrl($client_budget->Activity_Code) == "") { ?>
		<th data-name="Activity_Code"><div id="elh_client_budget_Activity_Code" class="client_budget_Activity_Code"><div class="ewTableHeaderCaption"><?php echo $client_budget->Activity_Code->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Activity_Code"><div><div id="elh_client_budget_Activity_Code" class="client_budget_Activity_Code">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $client_budget->Activity_Code->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client_budget->Activity_Code->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client_budget->Activity_Code->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client_budget->budget->Visible) { // budget ?>
	<?php if ($client_budget->SortUrl($client_budget->budget) == "") { ?>
		<th data-name="budget"><div id="elh_client_budget_budget" class="client_budget_budget"><div class="ewTableHeaderCaption" style="white-space: nowrap;"><?php echo $client_budget->budget->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="budget"><div><div id="elh_client_budget_budget" class="client_budget_budget">
			<div class="ewTableHeaderBtn" style="white-space: nowrap;"><span class="ewTableHeaderCaption"><?php echo $client_budget->budget->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client_budget->budget->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client_budget->budget->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client_budget->from->Visible) { // from ?>
	<?php if ($client_budget->SortUrl($client_budget->from) == "") { ?>
		<th data-name="from"><div id="elh_client_budget_from" class="client_budget_from"><div class="ewTableHeaderCaption"><?php echo $client_budget->from->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="from"><div><div id="elh_client_budget_from" class="client_budget_from">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $client_budget->from->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client_budget->from->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client_budget->from->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client_budget->through->Visible) { // through ?>
	<?php if ($client_budget->SortUrl($client_budget->through) == "") { ?>
		<th data-name="through"><div id="elh_client_budget_through" class="client_budget_through"><div class="ewTableHeaderCaption"><?php echo $client_budget->through->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="through"><div><div id="elh_client_budget_through" class="client_budget_through">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $client_budget->through->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client_budget->through->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client_budget->through->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client_budget->contractid->Visible) { // contractid ?>
	<?php if ($client_budget->SortUrl($client_budget->contractid) == "") { ?>
		<th data-name="contractid"><div id="elh_client_budget_contractid" class="client_budget_contractid"><div class="ewTableHeaderCaption"><?php echo $client_budget->contractid->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="contractid"><div><div id="elh_client_budget_contractid" class="client_budget_contractid">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $client_budget->contractid->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client_budget->contractid->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client_budget->contractid->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client_budget->rate->Visible) { // rate ?>
	<?php if ($client_budget->SortUrl($client_budget->rate) == "") { ?>
		<th data-name="rate"><div id="elh_client_budget_rate" class="client_budget_rate"><div class="ewTableHeaderCaption"><?php echo $client_budget->rate->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="rate"><div><div id="elh_client_budget_rate" class="client_budget_rate">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $client_budget->rate->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client_budget->rate->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client_budget->rate->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php

// Render list options (header, right)
$client_budget_grid->ListOptions->Render("header", "right");
?>
	</tr>
</thead>
<tbody>
<?php
$client_budget_grid->StartRec = 1;
$client_budget_grid->StopRec = $client_budget_grid->TotalRecs; // Show all records

// Restore number of post back records
if ($objForm) {
	$objForm->Index = -1;
	if ($objForm->HasValue($client_budget_grid->FormKeyCountName) && ($client_budget->CurrentAction == "gridadd" || $client_budget->CurrentAction == "gridedit" || $client_budget->CurrentAction == "F")) {
		$client_budget_grid->KeyCount = $objForm->GetValue($client_budget_grid->FormKeyCountName);
		$client_budget_grid->StopRec = $client_budget_grid->StartRec + $client_budget_grid->KeyCount - 1;
	}
}
$client_budget_grid->RecCnt = $client_budget_grid->StartRec - 1;
if ($client_budget_grid->Recordset && !$client_budget_grid->Recordset->EOF) {
	$client_budget_grid->Recordset->MoveFirst();
	$bSelectLimit = $client_budget_grid->UseSelectLimit;
	if (!$bSelectLimit && $client_budget_grid->StartRec > 1)
		$client_budget_grid->Recordset->Move($client_budget_grid->StartRec - 1);
} elseif (!$client_budget->AllowAddDeleteRow && $client_budget_grid->StopRec == 0) {
	$client_budget_grid->StopRec = $client_budget->GridAddRowCount;
}

// Initialize aggregate
$client_budget->RowType = EW_ROWTYPE_AGGREGATEINIT;
$client_budget->ResetAttrs();
$client_budget_grid->RenderRow();
if ($client_budget->CurrentAction == "gridadd")
	$client_budget_grid->RowIndex = 0;
if ($client_budget->CurrentAction == "gridedit")
	$client_budget_grid->RowIndex = 0;
while ($client_budget_grid->RecCnt < $client_budget_grid->StopRec) {
	$client_budget_grid->RecCnt++;
	if (intval($client_budget_grid->RecCnt) >= intval($client_budget_grid->StartRec)) {
		$client_budget_grid->RowCnt++;
		if ($client_budget->CurrentAction == "gridadd" || $client_budget->CurrentAction == "gridedit" || $client_budget->CurrentAction == "F") {
			$client_budget_grid->RowIndex++;
			$objForm->Index = $client_budget_grid->RowIndex;
			if ($objForm->HasValue($client_budget_grid->FormActionName))
				$client_budget_grid->RowAction = strval($objForm->GetValue($client_budget_grid->FormActionName));
			elseif ($client_budget->CurrentAction == "gridadd")
				$client_budget_grid->RowAction = "insert";
			else
				$client_budget_grid->RowAction = "";
		}

		// Set up key count
		$client_budget_grid->KeyCount = $client_budget_grid->RowIndex;

		// Init row class and style
		$client_budget->ResetAttrs();
		$client_budget->CssClass = "";
		if ($client_budget->CurrentAction == "gridadd") {
			if ($client_budget->CurrentMode == "copy") {
				$client_budget_grid->LoadRowValues($client_budget_grid->Recordset); // Load row values
				$client_budget_grid->SetRecordKey($client_budget_grid->RowOldKey, $client_budget_grid->Recordset); // Set old record key
			} else {
				$client_budget_grid->LoadDefaultValues(); // Load default values
				$client_budget_grid->RowOldKey = ""; // Clear old key value
			}
		} else {
			$client_budget_grid->LoadRowValues($client_budget_grid->Recordset); // Load row values
		}
		$client_budget->RowType = EW_ROWTYPE_VIEW; // Render view
		if ($client_budget->CurrentAction == "gridadd") // Grid add
			$client_budget->RowType = EW_ROWTYPE_ADD; // Render add
		if ($client_budget->CurrentAction == "gridadd" && $client_budget->EventCancelled && !$objForm->HasValue("k_blankrow")) // Insert failed
			$client_budget_grid->RestoreCurrentRowFormValues($client_budget_grid->RowIndex); // Restore form values
		if ($client_budget->CurrentAction == "gridedit") { // Grid edit
			if ($client_budget->EventCancelled) {
				$client_budget_grid->RestoreCurrentRowFormValues($client_budget_grid->RowIndex); // Restore form values
			}
			if ($client_budget_grid->RowAction == "insert")
				$client_budget->RowType = EW_ROWTYPE_ADD; // Render add
			else
				$client_budget->RowType = EW_ROWTYPE_EDIT; // Render edit
		}
		if ($client_budget->CurrentAction == "gridedit" && ($client_budget->RowType == EW_ROWTYPE_EDIT || $client_budget->RowType == EW_ROWTYPE_ADD) && $client_budget->EventCancelled) // Update failed
			$client_budget_grid->RestoreCurrentRowFormValues($client_budget_grid->RowIndex); // Restore form values
		if ($client_budget->RowType == EW_ROWTYPE_EDIT) // Edit row
			$client_budget_grid->EditRowCnt++;
		if ($client_budget->CurrentAction == "F") // Confirm row
			$client_budget_grid->RestoreCurrentRowFormValues($client_budget_grid->RowIndex); // Restore form values

		// Set up row id / data-rowindex
		$client_budget->RowAttrs = array_merge($client_budget->RowAttrs, array('data-rowindex'=>$client_budget_grid->RowCnt, 'id'=>'r' . $client_budget_grid->RowCnt . '_client_budget', 'data-rowtype'=>$client_budget->RowType));

		// Render row
		$client_budget_grid->RenderRow();

		// Render list options
		$client_budget_grid->RenderListOptions();

		// Skip delete row / empty row for confirm page
		if ($client_budget_grid->RowAction <> "delete" && $client_budget_grid->RowAction <> "insertdelete" && !($client_budget_grid->RowAction == "insert" && $client_budget->CurrentAction == "F" && $client_budget_grid->EmptyRow())) {
?>
	<tr<?php echo $client_budget->RowAttributes() ?>>
<?php

// Render list options (body, left)
$client_budget_grid->ListOptions->Render("body", "left", $client_budget_grid->RowCnt);
?>
	<?php if ($client_budget->dbkey_client->Visible) { // dbkey_client ?>
		<td data-name="dbkey_client"<?php echo $client_budget->dbkey_client->CellAttributes() ?>>
<?php if ($client_budget->RowType == EW_ROWTYPE_ADD) { // Add record ?>
<?php if ($client_budget->dbkey_client->getSessionValue() <> "") { ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_dbkey_client" class="form-group client_budget_dbkey_client">
<span<?php echo $client_budget->dbkey_client->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client_budget->dbkey_client->ViewValue ?></p></span>
</span>
<input type="hidden" id="x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" name="x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" value="<?php echo ew_HtmlEncode($client_budget->dbkey_client->CurrentValue) ?>">
<?php } else { ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_dbkey_client" class="form-group client_budget_dbkey_client">
<select data-table="client_budget" data-field="x_dbkey_client" data-value-separator="<?php echo $client_budget->dbkey_client->DisplayValueSeparatorAttribute() ?>" id="x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" name="x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client"<?php echo $client_budget->dbkey_client->EditAttributes() ?>>
<?php echo $client_budget->dbkey_client->SelectOptionListHtml("x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client") ?>
</select>
<input type="hidden" name="s_x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" id="s_x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" value="<?php echo $client_budget->dbkey_client->LookupFilterQuery() ?>">
</span>
<?php } ?>
<input type="hidden" data-table="client_budget" data-field="x_dbkey_client" name="o<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" id="o<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" value="<?php echo ew_HtmlEncode($client_budget->dbkey_client->OldValue) ?>">
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_EDIT) { // Edit record ?>
<?php if ($client_budget->dbkey_client->getSessionValue() <> "") { ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_dbkey_client" class="form-group client_budget_dbkey_client">
<span<?php echo $client_budget->dbkey_client->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client_budget->dbkey_client->ViewValue ?></p></span>
</span>
<input type="hidden" id="x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" name="x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" value="<?php echo ew_HtmlEncode($client_budget->dbkey_client->CurrentValue) ?>">
<?php } else { ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_dbkey_client" class="form-group client_budget_dbkey_client">
<select data-table="client_budget" data-field="x_dbkey_client" data-value-separator="<?php echo $client_budget->dbkey_client->DisplayValueSeparatorAttribute() ?>" id="x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" name="x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client"<?php echo $client_budget->dbkey_client->EditAttributes() ?>>
<?php echo $client_budget->dbkey_client->SelectOptionListHtml("x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client") ?>
</select>
<input type="hidden" name="s_x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" id="s_x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" value="<?php echo $client_budget->dbkey_client->LookupFilterQuery() ?>">
</span>
<?php } ?>
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_VIEW) { // View record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_dbkey_client" class="client_budget_dbkey_client">
<span<?php echo $client_budget->dbkey_client->ViewAttributes() ?>>
<?php echo $client_budget->dbkey_client->ListViewValue() ?></span>
</span>
<?php if ($client_budget->CurrentAction <> "F") { ?>
<input type="hidden" data-table="client_budget" data-field="x_dbkey_client" name="x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" id="x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" value="<?php echo ew_HtmlEncode($client_budget->dbkey_client->FormValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_dbkey_client" name="o<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" id="o<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" value="<?php echo ew_HtmlEncode($client_budget->dbkey_client->OldValue) ?>">
<?php } else { ?>
<input type="hidden" data-table="client_budget" data-field="x_dbkey_client" name="fclient_budgetgrid$x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" id="fclient_budgetgrid$x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" value="<?php echo ew_HtmlEncode($client_budget->dbkey_client->FormValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_dbkey_client" name="fclient_budgetgrid$o<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" id="fclient_budgetgrid$o<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" value="<?php echo ew_HtmlEncode($client_budget->dbkey_client->OldValue) ?>">
<?php } ?>
<?php } ?>
<a id="<?php echo $client_budget_grid->PageObjName . "_row_" . $client_budget_grid->RowCnt ?>"></a></td>
	<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_ADD) { // Add record ?>
<input type="hidden" data-table="client_budget" data-field="x_dbkey" name="x<?php echo $client_budget_grid->RowIndex ?>_dbkey" id="x<?php echo $client_budget_grid->RowIndex ?>_dbkey" value="<?php echo ew_HtmlEncode($client_budget->dbkey->CurrentValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_dbkey" name="o<?php echo $client_budget_grid->RowIndex ?>_dbkey" id="o<?php echo $client_budget_grid->RowIndex ?>_dbkey" value="<?php echo ew_HtmlEncode($client_budget->dbkey->OldValue) ?>">
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_EDIT || $client_budget->CurrentMode == "edit") { ?>
<input type="hidden" data-table="client_budget" data-field="x_dbkey" name="x<?php echo $client_budget_grid->RowIndex ?>_dbkey" id="x<?php echo $client_budget_grid->RowIndex ?>_dbkey" value="<?php echo ew_HtmlEncode($client_budget->dbkey->CurrentValue) ?>">
<?php } ?>
	<?php if ($client_budget->Client_Name->Visible) { // Client_Name ?>
		<td data-name="Client_Name"<?php echo $client_budget->Client_Name->CellAttributes() ?>>
<?php if ($client_budget->RowType == EW_ROWTYPE_ADD) { // Add record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_Client_Name" class="form-group client_budget_Client_Name">
<select data-table="client_budget" data-field="x_Client_Name" data-value-separator="<?php echo $client_budget->Client_Name->DisplayValueSeparatorAttribute() ?>" id="x<?php echo $client_budget_grid->RowIndex ?>_Client_Name" name="x<?php echo $client_budget_grid->RowIndex ?>_Client_Name"<?php echo $client_budget->Client_Name->EditAttributes() ?>>
<?php echo $client_budget->Client_Name->SelectOptionListHtml("x<?php echo $client_budget_grid->RowIndex ?>_Client_Name") ?>
</select>
<input type="hidden" name="s_x<?php echo $client_budget_grid->RowIndex ?>_Client_Name" id="s_x<?php echo $client_budget_grid->RowIndex ?>_Client_Name" value="<?php echo $client_budget->Client_Name->LookupFilterQuery() ?>">
</span>
<input type="hidden" data-table="client_budget" data-field="x_Client_Name" name="o<?php echo $client_budget_grid->RowIndex ?>_Client_Name" id="o<?php echo $client_budget_grid->RowIndex ?>_Client_Name" value="<?php echo ew_HtmlEncode($client_budget->Client_Name->OldValue) ?>">
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_EDIT) { // Edit record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_Client_Name" class="form-group client_budget_Client_Name">
<select data-table="client_budget" data-field="x_Client_Name" data-value-separator="<?php echo $client_budget->Client_Name->DisplayValueSeparatorAttribute() ?>" id="x<?php echo $client_budget_grid->RowIndex ?>_Client_Name" name="x<?php echo $client_budget_grid->RowIndex ?>_Client_Name"<?php echo $client_budget->Client_Name->EditAttributes() ?>>
<?php echo $client_budget->Client_Name->SelectOptionListHtml("x<?php echo $client_budget_grid->RowIndex ?>_Client_Name") ?>
</select>
<input type="hidden" name="s_x<?php echo $client_budget_grid->RowIndex ?>_Client_Name" id="s_x<?php echo $client_budget_grid->RowIndex ?>_Client_Name" value="<?php echo $client_budget->Client_Name->LookupFilterQuery() ?>">
</span>
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_VIEW) { // View record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_Client_Name" class="client_budget_Client_Name">
<span<?php echo $client_budget->Client_Name->ViewAttributes() ?>>
<?php echo $client_budget->Client_Name->ListViewValue() ?></span>
</span>
<?php if ($client_budget->CurrentAction <> "F") { ?>
<input type="hidden" data-table="client_budget" data-field="x_Client_Name" name="x<?php echo $client_budget_grid->RowIndex ?>_Client_Name" id="x<?php echo $client_budget_grid->RowIndex ?>_Client_Name" value="<?php echo ew_HtmlEncode($client_budget->Client_Name->FormValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_Client_Name" name="o<?php echo $client_budget_grid->RowIndex ?>_Client_Name" id="o<?php echo $client_budget_grid->RowIndex ?>_Client_Name" value="<?php echo ew_HtmlEncode($client_budget->Client_Name->OldValue) ?>">
<?php } else { ?>
<input type="hidden" data-table="client_budget" data-field="x_Client_Name" name="fclient_budgetgrid$x<?php echo $client_budget_grid->RowIndex ?>_Client_Name" id="fclient_budgetgrid$x<?php echo $client_budget_grid->RowIndex ?>_Client_Name" value="<?php echo ew_HtmlEncode($client_budget->Client_Name->FormValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_Client_Name" name="fclient_budgetgrid$o<?php echo $client_budget_grid->RowIndex ?>_Client_Name" id="fclient_budgetgrid$o<?php echo $client_budget_grid->RowIndex ?>_Client_Name" value="<?php echo ew_HtmlEncode($client_budget->Client_Name->OldValue) ?>">
<?php } ?>
<?php } ?>
</td>
	<?php } ?>
	<?php if ($client_budget->Activity_Code->Visible) { // Activity_Code ?>
		<td data-name="Activity_Code"<?php echo $client_budget->Activity_Code->CellAttributes() ?>>
<?php if ($client_budget->RowType == EW_ROWTYPE_ADD) { // Add record ?>
<?php if ($client_budget->Activity_Code->getSessionValue() <> "") { ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_Activity_Code" class="form-group client_budget_Activity_Code">
<span<?php echo $client_budget->Activity_Code->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client_budget->Activity_Code->ViewValue ?></p></span>
</span>
<input type="hidden" id="x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" name="x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" value="<?php echo ew_HtmlEncode($client_budget->Activity_Code->CurrentValue) ?>">
<?php } else { ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_Activity_Code" class="form-group client_budget_Activity_Code">
<input type="text" data-table="client_budget" data-field="x_Activity_Code" name="x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" id="x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" size="30" maxlength="50" placeholder="<?php echo ew_HtmlEncode($client_budget->Activity_Code->getPlaceHolder()) ?>" value="<?php echo $client_budget->Activity_Code->EditValue ?>"<?php echo $client_budget->Activity_Code->EditAttributes() ?>>
</span>
<?php } ?>
<input type="hidden" data-table="client_budget" data-field="x_Activity_Code" name="o<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" id="o<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" value="<?php echo ew_HtmlEncode($client_budget->Activity_Code->OldValue) ?>">
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_EDIT) { // Edit record ?>
<?php if ($client_budget->Activity_Code->getSessionValue() <> "") { ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_Activity_Code" class="form-group client_budget_Activity_Code">
<span<?php echo $client_budget->Activity_Code->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client_budget->Activity_Code->ViewValue ?></p></span>
</span>
<input type="hidden" id="x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" name="x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" value="<?php echo ew_HtmlEncode($client_budget->Activity_Code->CurrentValue) ?>">
<?php } else { ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_Activity_Code" class="form-group client_budget_Activity_Code">
<input type="text" data-table="client_budget" data-field="x_Activity_Code" name="x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" id="x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" size="30" maxlength="50" placeholder="<?php echo ew_HtmlEncode($client_budget->Activity_Code->getPlaceHolder()) ?>" value="<?php echo $client_budget->Activity_Code->EditValue ?>"<?php echo $client_budget->Activity_Code->EditAttributes() ?>>
</span>
<?php } ?>
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_VIEW) { // View record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_Activity_Code" class="client_budget_Activity_Code">
<span<?php echo $client_budget->Activity_Code->ViewAttributes() ?>>
<?php echo $client_budget->Activity_Code->ListViewValue() ?></span>
</span>
<?php if ($client_budget->CurrentAction <> "F") { ?>
<input type="hidden" data-table="client_budget" data-field="x_Activity_Code" name="x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" id="x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" value="<?php echo ew_HtmlEncode($client_budget->Activity_Code->FormValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_Activity_Code" name="o<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" id="o<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" value="<?php echo ew_HtmlEncode($client_budget->Activity_Code->OldValue) ?>">
<?php } else { ?>
<input type="hidden" data-table="client_budget" data-field="x_Activity_Code" name="fclient_budgetgrid$x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" id="fclient_budgetgrid$x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" value="<?php echo ew_HtmlEncode($client_budget->Activity_Code->FormValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_Activity_Code" name="fclient_budgetgrid$o<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" id="fclient_budgetgrid$o<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" value="<?php echo ew_HtmlEncode($client_budget->Activity_Code->OldValue) ?>">
<?php } ?>
<?php } ?>
</td>
	<?php } ?>
	<?php if ($client_budget->budget->Visible) { // budget ?>
		<td data-name="budget"<?php echo $client_budget->budget->CellAttributes() ?>>
<?php if ($client_budget->RowType == EW_ROWTYPE_ADD) { // Add record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_budget" class="form-group client_budget_budget">
<input type="text" data-table="client_budget" data-field="x_budget" name="x<?php echo $client_budget_grid->RowIndex ?>_budget" id="x<?php echo $client_budget_grid->RowIndex ?>_budget" size="30" placeholder="<?php echo ew_HtmlEncode($client_budget->budget->getPlaceHolder()) ?>" value="<?php echo $client_budget->budget->EditValue ?>"<?php echo $client_budget->budget->EditAttributes() ?>>
</span>
<input type="hidden" data-table="client_budget" data-field="x_budget" name="o<?php echo $client_budget_grid->RowIndex ?>_budget" id="o<?php echo $client_budget_grid->RowIndex ?>_budget" value="<?php echo ew_HtmlEncode($client_budget->budget->OldValue) ?>">
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_EDIT) { // Edit record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_budget" class="form-group client_budget_budget">
<input type="text" data-table="client_budget" data-field="x_budget" name="x<?php echo $client_budget_grid->RowIndex ?>_budget" id="x<?php echo $client_budget_grid->RowIndex ?>_budget" size="30" placeholder="<?php echo ew_HtmlEncode($client_budget->budget->getPlaceHolder()) ?>" value="<?php echo $client_budget->budget->EditValue ?>"<?php echo $client_budget->budget->EditAttributes() ?>>
</span>
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_VIEW) { // View record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_budget" class="client_budget_budget">
<span<?php echo $client_budget->budget->ViewAttributes() ?>>
<?php echo $client_budget->budget->ListViewValue() ?></span>
</span>
<?php if ($client_budget->CurrentAction <> "F") { ?>
<input type="hidden" data-table="client_budget" data-field="x_budget" name="x<?php echo $client_budget_grid->RowIndex ?>_budget" id="x<?php echo $client_budget_grid->RowIndex ?>_budget" value="<?php echo ew_HtmlEncode($client_budget->budget->FormValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_budget" name="o<?php echo $client_budget_grid->RowIndex ?>_budget" id="o<?php echo $client_budget_grid->RowIndex ?>_budget" value="<?php echo ew_HtmlEncode($client_budget->budget->OldValue) ?>">
<?php } else { ?>
<input type="hidden" data-table="client_budget" data-field="x_budget" name="fclient_budgetgrid$x<?php echo $client_budget_grid->RowIndex ?>_budget" id="fclient_budgetgrid$x<?php echo $client_budget_grid->RowIndex ?>_budget" value="<?php echo ew_HtmlEncode($client_budget->budget->FormValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_budget" name="fclient_budgetgrid$o<?php echo $client_budget_grid->RowIndex ?>_budget" id="fclient_budgetgrid$o<?php echo $client_budget_grid->RowIndex ?>_budget" value="<?php echo ew_HtmlEncode($client_budget->budget->OldValue) ?>">
<?php } ?>
<?php } ?>
</td>
	<?php } ?>
	<?php if ($client_budget->from->Visible) { // from ?>
		<td data-name="from"<?php echo $client_budget->from->CellAttributes() ?>>
<?php if ($client_budget->RowType == EW_ROWTYPE_ADD) { // Add record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_from" class="form-group client_budget_from">
<input type="text" data-table="client_budget" data-field="x_from" name="x<?php echo $client_budget_grid->RowIndex ?>_from" id="x<?php echo $client_budget_grid->RowIndex ?>_from" placeholder="<?php echo ew_HtmlEncode($client_budget->from->getPlaceHolder()) ?>" value="<?php echo $client_budget->from->EditValue ?>"<?php echo $client_budget->from->EditAttributes() ?>>
<?php if (!$client_budget->from->ReadOnly && !$client_budget->from->Disabled && !isset($client_budget->from->EditAttrs["readonly"]) && !isset($client_budget->from->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fclient_budgetgrid", "x<?php echo $client_budget_grid->RowIndex ?>_from", 0);
</script>
<?php } ?>
</span>
<input type="hidden" data-table="client_budget" data-field="x_from" name="o<?php echo $client_budget_grid->RowIndex ?>_from" id="o<?php echo $client_budget_grid->RowIndex ?>_from" value="<?php echo ew_HtmlEncode($client_budget->from->OldValue) ?>">
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_EDIT) { // Edit record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_from" class="form-group client_budget_from">
<input type="text" data-table="client_budget" data-field="x_from" name="x<?php echo $client_budget_grid->RowIndex ?>_from" id="x<?php echo $client_budget_grid->RowIndex ?>_from" placeholder="<?php echo ew_HtmlEncode($client_budget->from->getPlaceHolder()) ?>" value="<?php echo $client_budget->from->EditValue ?>"<?php echo $client_budget->from->EditAttributes() ?>>
<?php if (!$client_budget->from->ReadOnly && !$client_budget->from->Disabled && !isset($client_budget->from->EditAttrs["readonly"]) && !isset($client_budget->from->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fclient_budgetgrid", "x<?php echo $client_budget_grid->RowIndex ?>_from", 0);
</script>
<?php } ?>
</span>
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_VIEW) { // View record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_from" class="client_budget_from">
<span<?php echo $client_budget->from->ViewAttributes() ?>>
<?php echo $client_budget->from->ListViewValue() ?></span>
</span>
<?php if ($client_budget->CurrentAction <> "F") { ?>
<input type="hidden" data-table="client_budget" data-field="x_from" name="x<?php echo $client_budget_grid->RowIndex ?>_from" id="x<?php echo $client_budget_grid->RowIndex ?>_from" value="<?php echo ew_HtmlEncode($client_budget->from->FormValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_from" name="o<?php echo $client_budget_grid->RowIndex ?>_from" id="o<?php echo $client_budget_grid->RowIndex ?>_from" value="<?php echo ew_HtmlEncode($client_budget->from->OldValue) ?>">
<?php } else { ?>
<input type="hidden" data-table="client_budget" data-field="x_from" name="fclient_budgetgrid$x<?php echo $client_budget_grid->RowIndex ?>_from" id="fclient_budgetgrid$x<?php echo $client_budget_grid->RowIndex ?>_from" value="<?php echo ew_HtmlEncode($client_budget->from->FormValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_from" name="fclient_budgetgrid$o<?php echo $client_budget_grid->RowIndex ?>_from" id="fclient_budgetgrid$o<?php echo $client_budget_grid->RowIndex ?>_from" value="<?php echo ew_HtmlEncode($client_budget->from->OldValue) ?>">
<?php } ?>
<?php } ?>
</td>
	<?php } ?>
	<?php if ($client_budget->through->Visible) { // through ?>
		<td data-name="through"<?php echo $client_budget->through->CellAttributes() ?>>
<?php if ($client_budget->RowType == EW_ROWTYPE_ADD) { // Add record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_through" class="form-group client_budget_through">
<input type="text" data-table="client_budget" data-field="x_through" name="x<?php echo $client_budget_grid->RowIndex ?>_through" id="x<?php echo $client_budget_grid->RowIndex ?>_through" placeholder="<?php echo ew_HtmlEncode($client_budget->through->getPlaceHolder()) ?>" value="<?php echo $client_budget->through->EditValue ?>"<?php echo $client_budget->through->EditAttributes() ?>>
<?php if (!$client_budget->through->ReadOnly && !$client_budget->through->Disabled && !isset($client_budget->through->EditAttrs["readonly"]) && !isset($client_budget->through->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fclient_budgetgrid", "x<?php echo $client_budget_grid->RowIndex ?>_through", 0);
</script>
<?php } ?>
</span>
<input type="hidden" data-table="client_budget" data-field="x_through" name="o<?php echo $client_budget_grid->RowIndex ?>_through" id="o<?php echo $client_budget_grid->RowIndex ?>_through" value="<?php echo ew_HtmlEncode($client_budget->through->OldValue) ?>">
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_EDIT) { // Edit record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_through" class="form-group client_budget_through">
<input type="text" data-table="client_budget" data-field="x_through" name="x<?php echo $client_budget_grid->RowIndex ?>_through" id="x<?php echo $client_budget_grid->RowIndex ?>_through" placeholder="<?php echo ew_HtmlEncode($client_budget->through->getPlaceHolder()) ?>" value="<?php echo $client_budget->through->EditValue ?>"<?php echo $client_budget->through->EditAttributes() ?>>
<?php if (!$client_budget->through->ReadOnly && !$client_budget->through->Disabled && !isset($client_budget->through->EditAttrs["readonly"]) && !isset($client_budget->through->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fclient_budgetgrid", "x<?php echo $client_budget_grid->RowIndex ?>_through", 0);
</script>
<?php } ?>
</span>
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_VIEW) { // View record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_through" class="client_budget_through">
<span<?php echo $client_budget->through->ViewAttributes() ?>>
<?php echo $client_budget->through->ListViewValue() ?></span>
</span>
<?php if ($client_budget->CurrentAction <> "F") { ?>
<input type="hidden" data-table="client_budget" data-field="x_through" name="x<?php echo $client_budget_grid->RowIndex ?>_through" id="x<?php echo $client_budget_grid->RowIndex ?>_through" value="<?php echo ew_HtmlEncode($client_budget->through->FormValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_through" name="o<?php echo $client_budget_grid->RowIndex ?>_through" id="o<?php echo $client_budget_grid->RowIndex ?>_through" value="<?php echo ew_HtmlEncode($client_budget->through->OldValue) ?>">
<?php } else { ?>
<input type="hidden" data-table="client_budget" data-field="x_through" name="fclient_budgetgrid$x<?php echo $client_budget_grid->RowIndex ?>_through" id="fclient_budgetgrid$x<?php echo $client_budget_grid->RowIndex ?>_through" value="<?php echo ew_HtmlEncode($client_budget->through->FormValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_through" name="fclient_budgetgrid$o<?php echo $client_budget_grid->RowIndex ?>_through" id="fclient_budgetgrid$o<?php echo $client_budget_grid->RowIndex ?>_through" value="<?php echo ew_HtmlEncode($client_budget->through->OldValue) ?>">
<?php } ?>
<?php } ?>
</td>
	<?php } ?>
	<?php if ($client_budget->contractid->Visible) { // contractid ?>
		<td data-name="contractid"<?php echo $client_budget->contractid->CellAttributes() ?>>
<?php if ($client_budget->RowType == EW_ROWTYPE_ADD) { // Add record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_contractid" class="form-group client_budget_contractid">
<input type="text" data-table="client_budget" data-field="x_contractid" name="x<?php echo $client_budget_grid->RowIndex ?>_contractid" id="x<?php echo $client_budget_grid->RowIndex ?>_contractid" size="30" maxlength="50" placeholder="<?php echo ew_HtmlEncode($client_budget->contractid->getPlaceHolder()) ?>" value="<?php echo $client_budget->contractid->EditValue ?>"<?php echo $client_budget->contractid->EditAttributes() ?>>
</span>
<input type="hidden" data-table="client_budget" data-field="x_contractid" name="o<?php echo $client_budget_grid->RowIndex ?>_contractid" id="o<?php echo $client_budget_grid->RowIndex ?>_contractid" value="<?php echo ew_HtmlEncode($client_budget->contractid->OldValue) ?>">
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_EDIT) { // Edit record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_contractid" class="form-group client_budget_contractid">
<input type="text" data-table="client_budget" data-field="x_contractid" name="x<?php echo $client_budget_grid->RowIndex ?>_contractid" id="x<?php echo $client_budget_grid->RowIndex ?>_contractid" size="30" maxlength="50" placeholder="<?php echo ew_HtmlEncode($client_budget->contractid->getPlaceHolder()) ?>" value="<?php echo $client_budget->contractid->EditValue ?>"<?php echo $client_budget->contractid->EditAttributes() ?>>
</span>
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_VIEW) { // View record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_contractid" class="client_budget_contractid">
<span<?php echo $client_budget->contractid->ViewAttributes() ?>>
<?php echo $client_budget->contractid->ListViewValue() ?></span>
</span>
<?php if ($client_budget->CurrentAction <> "F") { ?>
<input type="hidden" data-table="client_budget" data-field="x_contractid" name="x<?php echo $client_budget_grid->RowIndex ?>_contractid" id="x<?php echo $client_budget_grid->RowIndex ?>_contractid" value="<?php echo ew_HtmlEncode($client_budget->contractid->FormValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_contractid" name="o<?php echo $client_budget_grid->RowIndex ?>_contractid" id="o<?php echo $client_budget_grid->RowIndex ?>_contractid" value="<?php echo ew_HtmlEncode($client_budget->contractid->OldValue) ?>">
<?php } else { ?>
<input type="hidden" data-table="client_budget" data-field="x_contractid" name="fclient_budgetgrid$x<?php echo $client_budget_grid->RowIndex ?>_contractid" id="fclient_budgetgrid$x<?php echo $client_budget_grid->RowIndex ?>_contractid" value="<?php echo ew_HtmlEncode($client_budget->contractid->FormValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_contractid" name="fclient_budgetgrid$o<?php echo $client_budget_grid->RowIndex ?>_contractid" id="fclient_budgetgrid$o<?php echo $client_budget_grid->RowIndex ?>_contractid" value="<?php echo ew_HtmlEncode($client_budget->contractid->OldValue) ?>">
<?php } ?>
<?php } ?>
</td>
	<?php } ?>
	<?php if ($client_budget->rate->Visible) { // rate ?>
		<td data-name="rate"<?php echo $client_budget->rate->CellAttributes() ?>>
<?php if ($client_budget->RowType == EW_ROWTYPE_ADD) { // Add record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_rate" class="form-group client_budget_rate">
<input type="text" data-table="client_budget" data-field="x_rate" name="x<?php echo $client_budget_grid->RowIndex ?>_rate" id="x<?php echo $client_budget_grid->RowIndex ?>_rate" size="30" placeholder="<?php echo ew_HtmlEncode($client_budget->rate->getPlaceHolder()) ?>" value="<?php echo $client_budget->rate->EditValue ?>"<?php echo $client_budget->rate->EditAttributes() ?>>
</span>
<input type="hidden" data-table="client_budget" data-field="x_rate" name="o<?php echo $client_budget_grid->RowIndex ?>_rate" id="o<?php echo $client_budget_grid->RowIndex ?>_rate" value="<?php echo ew_HtmlEncode($client_budget->rate->OldValue) ?>">
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_EDIT) { // Edit record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_rate" class="form-group client_budget_rate">
<input type="text" data-table="client_budget" data-field="x_rate" name="x<?php echo $client_budget_grid->RowIndex ?>_rate" id="x<?php echo $client_budget_grid->RowIndex ?>_rate" size="30" placeholder="<?php echo ew_HtmlEncode($client_budget->rate->getPlaceHolder()) ?>" value="<?php echo $client_budget->rate->EditValue ?>"<?php echo $client_budget->rate->EditAttributes() ?>>
</span>
<?php } ?>
<?php if ($client_budget->RowType == EW_ROWTYPE_VIEW) { // View record ?>
<span id="el<?php echo $client_budget_grid->RowCnt ?>_client_budget_rate" class="client_budget_rate">
<span<?php echo $client_budget->rate->ViewAttributes() ?>>
<?php echo $client_budget->rate->ListViewValue() ?></span>
</span>
<?php if ($client_budget->CurrentAction <> "F") { ?>
<input type="hidden" data-table="client_budget" data-field="x_rate" name="x<?php echo $client_budget_grid->RowIndex ?>_rate" id="x<?php echo $client_budget_grid->RowIndex ?>_rate" value="<?php echo ew_HtmlEncode($client_budget->rate->FormValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_rate" name="o<?php echo $client_budget_grid->RowIndex ?>_rate" id="o<?php echo $client_budget_grid->RowIndex ?>_rate" value="<?php echo ew_HtmlEncode($client_budget->rate->OldValue) ?>">
<?php } else { ?>
<input type="hidden" data-table="client_budget" data-field="x_rate" name="fclient_budgetgrid$x<?php echo $client_budget_grid->RowIndex ?>_rate" id="fclient_budgetgrid$x<?php echo $client_budget_grid->RowIndex ?>_rate" value="<?php echo ew_HtmlEncode($client_budget->rate->FormValue) ?>">
<input type="hidden" data-table="client_budget" data-field="x_rate" name="fclient_budgetgrid$o<?php echo $client_budget_grid->RowIndex ?>_rate" id="fclient_budgetgrid$o<?php echo $client_budget_grid->RowIndex ?>_rate" value="<?php echo ew_HtmlEncode($client_budget->rate->OldValue) ?>">
<?php } ?>
<?php } ?>
</td>
	<?php } ?>
<?php

// Render list options (body, right)
$client_budget_grid->ListOptions->Render("body", "right", $client_budget_grid->RowCnt);
?>
	</tr>
<?php if ($client_budget->RowType == EW_ROWTYPE_ADD || $client_budget->RowType == EW_ROWTYPE_EDIT) { ?>
<script type="text/javascript">
fclient_budgetgrid.UpdateOpts(<?php echo $client_budget_grid->RowIndex ?>);
</script>
<?php } ?>
<?php
	}
	} // End delete row checking
	if ($client_budget->CurrentAction <> "gridadd" || $client_budget->CurrentMode == "copy")
		if (!$client_budget_grid->Recordset->EOF) $client_budget_grid->Recordset->MoveNext();
}
?>
<?php
	if ($client_budget->CurrentMode == "add" || $client_budget->CurrentMode == "copy" || $client_budget->CurrentMode == "edit") {
		$client_budget_grid->RowIndex = '$rowindex$';
		$client_budget_grid->LoadDefaultValues();

		// Set row properties
		$client_budget->ResetAttrs();
		$client_budget->RowAttrs = array_merge($client_budget->RowAttrs, array('data-rowindex'=>$client_budget_grid->RowIndex, 'id'=>'r0_client_budget', 'data-rowtype'=>EW_ROWTYPE_ADD));
		ew_AppendClass($client_budget->RowAttrs["class"], "ewTemplate");
		$client_budget->RowType = EW_ROWTYPE_ADD;

		// Render row
		$client_budget_grid->RenderRow();

		// Render list options
		$client_budget_grid->RenderListOptions();
		$client_budget_grid->StartRowCnt = 0;
?>
	<tr<?php echo $client_budget->RowAttributes() ?>>
<?php

// Render list options (body, left)
$client_budget_grid->ListOptions->Render("body", "left", $client_budget_grid->RowIndex);
?>
	<?php if ($client_budget->dbkey_client->Visible) { // dbkey_client ?>
		<td data-name="dbkey_client">
<?php if ($client_budget->CurrentAction <> "F") { ?>
<?php if ($client_budget->dbkey_client->getSessionValue() <> "") { ?>
<span id="el$rowindex$_client_budget_dbkey_client" class="form-group client_budget_dbkey_client">
<span<?php echo $client_budget->dbkey_client->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client_budget->dbkey_client->ViewValue ?></p></span>
</span>
<input type="hidden" id="x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" name="x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" value="<?php echo ew_HtmlEncode($client_budget->dbkey_client->CurrentValue) ?>">
<?php } else { ?>
<span id="el$rowindex$_client_budget_dbkey_client" class="form-group client_budget_dbkey_client">
<select data-table="client_budget" data-field="x_dbkey_client" data-value-separator="<?php echo $client_budget->dbkey_client->DisplayValueSeparatorAttribute() ?>" id="x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" name="x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client"<?php echo $client_budget->dbkey_client->EditAttributes() ?>>
<?php echo $client_budget->dbkey_client->SelectOptionListHtml("x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client") ?>
</select>
<input type="hidden" name="s_x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" id="s_x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" value="<?php echo $client_budget->dbkey_client->LookupFilterQuery() ?>">
</span>
<?php } ?>
<?php } else { ?>
<span id="el$rowindex$_client_budget_dbkey_client" class="form-group client_budget_dbkey_client">
<span<?php echo $client_budget->dbkey_client->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client_budget->dbkey_client->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client_budget" data-field="x_dbkey_client" name="x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" id="x<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" value="<?php echo ew_HtmlEncode($client_budget->dbkey_client->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="client_budget" data-field="x_dbkey_client" name="o<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" id="o<?php echo $client_budget_grid->RowIndex ?>_dbkey_client" value="<?php echo ew_HtmlEncode($client_budget->dbkey_client->OldValue) ?>">
</td>
	<?php } ?>
	<?php if ($client_budget->Client_Name->Visible) { // Client_Name ?>
		<td data-name="Client_Name">
<?php if ($client_budget->CurrentAction <> "F") { ?>
<span id="el$rowindex$_client_budget_Client_Name" class="form-group client_budget_Client_Name">
<select data-table="client_budget" data-field="x_Client_Name" data-value-separator="<?php echo $client_budget->Client_Name->DisplayValueSeparatorAttribute() ?>" id="x<?php echo $client_budget_grid->RowIndex ?>_Client_Name" name="x<?php echo $client_budget_grid->RowIndex ?>_Client_Name"<?php echo $client_budget->Client_Name->EditAttributes() ?>>
<?php echo $client_budget->Client_Name->SelectOptionListHtml("x<?php echo $client_budget_grid->RowIndex ?>_Client_Name") ?>
</select>
<input type="hidden" name="s_x<?php echo $client_budget_grid->RowIndex ?>_Client_Name" id="s_x<?php echo $client_budget_grid->RowIndex ?>_Client_Name" value="<?php echo $client_budget->Client_Name->LookupFilterQuery() ?>">
</span>
<?php } else { ?>
<span id="el$rowindex$_client_budget_Client_Name" class="form-group client_budget_Client_Name">
<span<?php echo $client_budget->Client_Name->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client_budget->Client_Name->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client_budget" data-field="x_Client_Name" name="x<?php echo $client_budget_grid->RowIndex ?>_Client_Name" id="x<?php echo $client_budget_grid->RowIndex ?>_Client_Name" value="<?php echo ew_HtmlEncode($client_budget->Client_Name->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="client_budget" data-field="x_Client_Name" name="o<?php echo $client_budget_grid->RowIndex ?>_Client_Name" id="o<?php echo $client_budget_grid->RowIndex ?>_Client_Name" value="<?php echo ew_HtmlEncode($client_budget->Client_Name->OldValue) ?>">
</td>
	<?php } ?>
	<?php if ($client_budget->Activity_Code->Visible) { // Activity_Code ?>
		<td data-name="Activity_Code">
<?php if ($client_budget->CurrentAction <> "F") { ?>
<?php if ($client_budget->Activity_Code->getSessionValue() <> "") { ?>
<span id="el$rowindex$_client_budget_Activity_Code" class="form-group client_budget_Activity_Code">
<span<?php echo $client_budget->Activity_Code->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client_budget->Activity_Code->ViewValue ?></p></span>
</span>
<input type="hidden" id="x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" name="x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" value="<?php echo ew_HtmlEncode($client_budget->Activity_Code->CurrentValue) ?>">
<?php } else { ?>
<span id="el$rowindex$_client_budget_Activity_Code" class="form-group client_budget_Activity_Code">
<input type="text" data-table="client_budget" data-field="x_Activity_Code" name="x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" id="x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" size="30" maxlength="50" placeholder="<?php echo ew_HtmlEncode($client_budget->Activity_Code->getPlaceHolder()) ?>" value="<?php echo $client_budget->Activity_Code->EditValue ?>"<?php echo $client_budget->Activity_Code->EditAttributes() ?>>
</span>
<?php } ?>
<?php } else { ?>
<span id="el$rowindex$_client_budget_Activity_Code" class="form-group client_budget_Activity_Code">
<span<?php echo $client_budget->Activity_Code->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client_budget->Activity_Code->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client_budget" data-field="x_Activity_Code" name="x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" id="x<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" value="<?php echo ew_HtmlEncode($client_budget->Activity_Code->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="client_budget" data-field="x_Activity_Code" name="o<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" id="o<?php echo $client_budget_grid->RowIndex ?>_Activity_Code" value="<?php echo ew_HtmlEncode($client_budget->Activity_Code->OldValue) ?>">
</td>
	<?php } ?>
	<?php if ($client_budget->budget->Visible) { // budget ?>
		<td data-name="budget">
<?php if ($client_budget->CurrentAction <> "F") { ?>
<span id="el$rowindex$_client_budget_budget" class="form-group client_budget_budget">
<input type="text" data-table="client_budget" data-field="x_budget" name="x<?php echo $client_budget_grid->RowIndex ?>_budget" id="x<?php echo $client_budget_grid->RowIndex ?>_budget" size="30" placeholder="<?php echo ew_HtmlEncode($client_budget->budget->getPlaceHolder()) ?>" value="<?php echo $client_budget->budget->EditValue ?>"<?php echo $client_budget->budget->EditAttributes() ?>>
</span>
<?php } else { ?>
<span id="el$rowindex$_client_budget_budget" class="form-group client_budget_budget">
<span<?php echo $client_budget->budget->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client_budget->budget->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client_budget" data-field="x_budget" name="x<?php echo $client_budget_grid->RowIndex ?>_budget" id="x<?php echo $client_budget_grid->RowIndex ?>_budget" value="<?php echo ew_HtmlEncode($client_budget->budget->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="client_budget" data-field="x_budget" name="o<?php echo $client_budget_grid->RowIndex ?>_budget" id="o<?php echo $client_budget_grid->RowIndex ?>_budget" value="<?php echo ew_HtmlEncode($client_budget->budget->OldValue) ?>">
</td>
	<?php } ?>
	<?php if ($client_budget->from->Visible) { // from ?>
		<td data-name="from">
<?php if ($client_budget->CurrentAction <> "F") { ?>
<span id="el$rowindex$_client_budget_from" class="form-group client_budget_from">
<input type="text" data-table="client_budget" data-field="x_from" name="x<?php echo $client_budget_grid->RowIndex ?>_from" id="x<?php echo $client_budget_grid->RowIndex ?>_from" placeholder="<?php echo ew_HtmlEncode($client_budget->from->getPlaceHolder()) ?>" value="<?php echo $client_budget->from->EditValue ?>"<?php echo $client_budget->from->EditAttributes() ?>>
<?php if (!$client_budget->from->ReadOnly && !$client_budget->from->Disabled && !isset($client_budget->from->EditAttrs["readonly"]) && !isset($client_budget->from->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fclient_budgetgrid", "x<?php echo $client_budget_grid->RowIndex ?>_from", 0);
</script>
<?php } ?>
</span>
<?php } else { ?>
<span id="el$rowindex$_client_budget_from" class="form-group client_budget_from">
<span<?php echo $client_budget->from->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client_budget->from->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client_budget" data-field="x_from" name="x<?php echo $client_budget_grid->RowIndex ?>_from" id="x<?php echo $client_budget_grid->RowIndex ?>_from" value="<?php echo ew_HtmlEncode($client_budget->from->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="client_budget" data-field="x_from" name="o<?php echo $client_budget_grid->RowIndex ?>_from" id="o<?php echo $client_budget_grid->RowIndex ?>_from" value="<?php echo ew_HtmlEncode($client_budget->from->OldValue) ?>">
</td>
	<?php } ?>
	<?php if ($client_budget->through->Visible) { // through ?>
		<td data-name="through">
<?php if ($client_budget->CurrentAction <> "F") { ?>
<span id="el$rowindex$_client_budget_through" class="form-group client_budget_through">
<input type="text" data-table="client_budget" data-field="x_through" name="x<?php echo $client_budget_grid->RowIndex ?>_through" id="x<?php echo $client_budget_grid->RowIndex ?>_through" placeholder="<?php echo ew_HtmlEncode($client_budget->through->getPlaceHolder()) ?>" value="<?php echo $client_budget->through->EditValue ?>"<?php echo $client_budget->through->EditAttributes() ?>>
<?php if (!$client_budget->through->ReadOnly && !$client_budget->through->Disabled && !isset($client_budget->through->EditAttrs["readonly"]) && !isset($client_budget->through->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fclient_budgetgrid", "x<?php echo $client_budget_grid->RowIndex ?>_through", 0);
</script>
<?php } ?>
</span>
<?php } else { ?>
<span id="el$rowindex$_client_budget_through" class="form-group client_budget_through">
<span<?php echo $client_budget->through->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client_budget->through->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client_budget" data-field="x_through" name="x<?php echo $client_budget_grid->RowIndex ?>_through" id="x<?php echo $client_budget_grid->RowIndex ?>_through" value="<?php echo ew_HtmlEncode($client_budget->through->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="client_budget" data-field="x_through" name="o<?php echo $client_budget_grid->RowIndex ?>_through" id="o<?php echo $client_budget_grid->RowIndex ?>_through" value="<?php echo ew_HtmlEncode($client_budget->through->OldValue) ?>">
</td>
	<?php } ?>
	<?php if ($client_budget->contractid->Visible) { // contractid ?>
		<td data-name="contractid">
<?php if ($client_budget->CurrentAction <> "F") { ?>
<span id="el$rowindex$_client_budget_contractid" class="form-group client_budget_contractid">
<input type="text" data-table="client_budget" data-field="x_contractid" name="x<?php echo $client_budget_grid->RowIndex ?>_contractid" id="x<?php echo $client_budget_grid->RowIndex ?>_contractid" size="30" maxlength="50" placeholder="<?php echo ew_HtmlEncode($client_budget->contractid->getPlaceHolder()) ?>" value="<?php echo $client_budget->contractid->EditValue ?>"<?php echo $client_budget->contractid->EditAttributes() ?>>
</span>
<?php } else { ?>
<span id="el$rowindex$_client_budget_contractid" class="form-group client_budget_contractid">
<span<?php echo $client_budget->contractid->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client_budget->contractid->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client_budget" data-field="x_contractid" name="x<?php echo $client_budget_grid->RowIndex ?>_contractid" id="x<?php echo $client_budget_grid->RowIndex ?>_contractid" value="<?php echo ew_HtmlEncode($client_budget->contractid->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="client_budget" data-field="x_contractid" name="o<?php echo $client_budget_grid->RowIndex ?>_contractid" id="o<?php echo $client_budget_grid->RowIndex ?>_contractid" value="<?php echo ew_HtmlEncode($client_budget->contractid->OldValue) ?>">
</td>
	<?php } ?>
	<?php if ($client_budget->rate->Visible) { // rate ?>
		<td data-name="rate">
<?php if ($client_budget->CurrentAction <> "F") { ?>
<span id="el$rowindex$_client_budget_rate" class="form-group client_budget_rate">
<input type="text" data-table="client_budget" data-field="x_rate" name="x<?php echo $client_budget_grid->RowIndex ?>_rate" id="x<?php echo $client_budget_grid->RowIndex ?>_rate" size="30" placeholder="<?php echo ew_HtmlEncode($client_budget->rate->getPlaceHolder()) ?>" value="<?php echo $client_budget->rate->EditValue ?>"<?php echo $client_budget->rate->EditAttributes() ?>>
</span>
<?php } else { ?>
<span id="el$rowindex$_client_budget_rate" class="form-group client_budget_rate">
<span<?php echo $client_budget->rate->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client_budget->rate->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client_budget" data-field="x_rate" name="x<?php echo $client_budget_grid->RowIndex ?>_rate" id="x<?php echo $client_budget_grid->RowIndex ?>_rate" value="<?php echo ew_HtmlEncode($client_budget->rate->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="client_budget" data-field="x_rate" name="o<?php echo $client_budget_grid->RowIndex ?>_rate" id="o<?php echo $client_budget_grid->RowIndex ?>_rate" value="<?php echo ew_HtmlEncode($client_budget->rate->OldValue) ?>">
</td>
	<?php } ?>
<?php

// Render list options (body, right)
$client_budget_grid->ListOptions->Render("body", "right", $client_budget_grid->RowCnt);
?>
<script type="text/javascript">
fclient_budgetgrid.UpdateOpts(<?php echo $client_budget_grid->RowIndex ?>);
</script>
	</tr>
<?php
}
?>
</tbody>
</table>
<?php if ($client_budget->CurrentMode == "add" || $client_budget->CurrentMode == "copy") { ?>
<input type="hidden" name="a_list" id="a_list" value="gridinsert">
<input type="hidden" name="<?php echo $client_budget_grid->FormKeyCountName ?>" id="<?php echo $client_budget_grid->FormKeyCountName ?>" value="<?php echo $client_budget_grid->KeyCount ?>">
<?php echo $client_budget_grid->MultiSelectKey ?>
<?php } ?>
<?php if ($client_budget->CurrentMode == "edit") { ?>
<input type="hidden" name="a_list" id="a_list" value="gridupdate">
<input type="hidden" name="<?php echo $client_budget_grid->FormKeyCountName ?>" id="<?php echo $client_budget_grid->FormKeyCountName ?>" value="<?php echo $client_budget_grid->KeyCount ?>">
<?php echo $client_budget_grid->MultiSelectKey ?>
<?php } ?>
<?php if ($client_budget->CurrentMode == "") { ?>
<input type="hidden" name="a_list" id="a_list" value="">
<?php } ?>
<input type="hidden" name="detailpage" value="fclient_budgetgrid">
</div>
<?php

// Close recordset
if ($client_budget_grid->Recordset)
	$client_budget_grid->Recordset->Close();
?>
</div>
</div>
<?php } ?>
<?php if ($client_budget_grid->TotalRecs == 0 && $client_budget->CurrentAction == "") { // Show other options ?>
<div class="ewListOtherOptions">
<?php
	foreach ($client_budget_grid->OtherOptions as &$option) {
		$option->ButtonClass = "";
		$option->Render("body", "");
	}
?>
</div>
<div class="clearfix"></div>
<?php } ?>
<?php if ($client_budget->Export == "") { ?>
<script type="text/javascript">
fclient_budgetgrid.Init();
</script>
<?php } ?>
<?php
$client_budget_grid->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<?php
$client_budget_grid->Page_Terminate();
?>
