<?php
if (session_id() == "") session_start(); // Init session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg13.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql13.php") ?>
<?php include_once "phpfn13.php" ?>
<?php include_once "client_budgetinfo.php" ?>
<?php include_once "activityinfo.php" ?>
<?php include_once "clientinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn13.php" ?>
<?php

//
// Page class
//

$client_budget_list = NULL; // Initialize page object first

class cclient_budget_list extends cclient_budget {

	// Page ID
	var $PageID = 'list';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'client_budget';

	// Page object name
	var $PageObjName = 'client_budget_list';

	// Grid form hidden field names
	var $FormName = 'fclient_budgetlist';
	var $FormActionName = 'k_action';
	var $FormKeyName = 'k_key';
	var $FormOldKeyName = 'k_oldkey';
	var $FormBlankRowName = 'k_blankrow';
	var $FormKeyCountName = 'key_count';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Page URLs
	var $AddUrl;
	var $EditUrl;
	var $CopyUrl;
	var $DeleteUrl;
	var $ViewUrl;
	var $ListUrl;

	// Export URLs
	var $ExportPrintUrl;
	var $ExportHtmlUrl;
	var $ExportExcelUrl;
	var $ExportWordUrl;
	var $ExportXmlUrl;
	var $ExportCsvUrl;
	var $ExportPdfUrl;

	// Custom export
	var $ExportExcelCustom = FALSE;
	var $ExportWordCustom = FALSE;
	var $ExportPdfCustom = FALSE;
	var $ExportEmailCustom = FALSE;

	// Update URLs
	var $InlineAddUrl;
	var $InlineCopyUrl;
	var $InlineEditUrl;
	var $GridAddUrl;
	var $GridEditUrl;
	var $MultiDeleteUrl;
	var $MultiUpdateUrl;
	var $AuditTrailOnAdd = FALSE;
	var $AuditTrailOnEdit = FALSE;
	var $AuditTrailOnDelete = FALSE;
	var $AuditTrailOnView = FALSE;
	var $AuditTrailOnViewData = FALSE;
	var $AuditTrailOnSearch = FALSE;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (client_budget)
		if (!isset($GLOBALS["client_budget"]) || get_class($GLOBALS["client_budget"]) == "cclient_budget") {
			$GLOBALS["client_budget"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["client_budget"];
		}

		// Initialize URLs
		$this->ExportPrintUrl = $this->PageUrl() . "export=print";
		$this->ExportExcelUrl = $this->PageUrl() . "export=excel";
		$this->ExportWordUrl = $this->PageUrl() . "export=word";
		$this->ExportHtmlUrl = $this->PageUrl() . "export=html";
		$this->ExportXmlUrl = $this->PageUrl() . "export=xml";
		$this->ExportCsvUrl = $this->PageUrl() . "export=csv";
		$this->ExportPdfUrl = $this->PageUrl() . "export=pdf";
		$this->AddUrl = "client_budgetadd.php";
		$this->InlineAddUrl = $this->PageUrl() . "a=add";
		$this->GridAddUrl = $this->PageUrl() . "a=gridadd";
		$this->GridEditUrl = $this->PageUrl() . "a=gridedit";
		$this->MultiDeleteUrl = "client_budgetdelete.php";
		$this->MultiUpdateUrl = "client_budgetupdate.php";

		// Table object (activity)
		if (!isset($GLOBALS['activity'])) $GLOBALS['activity'] = new cactivity();

		// Table object (client)
		if (!isset($GLOBALS['client'])) $GLOBALS['client'] = new cclient();

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'list', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'client_budget', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}

		// List options
		$this->ListOptions = new cListOptions();
		$this->ListOptions->TableVar = $this->TableVar;

		// Export options
		$this->ExportOptions = new cListOptions();
		$this->ExportOptions->Tag = "div";
		$this->ExportOptions->TagClassName = "ewExportOption";

		// Other options
		$this->OtherOptions['addedit'] = new cListOptions();
		$this->OtherOptions['addedit']->Tag = "div";
		$this->OtherOptions['addedit']->TagClassName = "ewAddEditOption";
		$this->OtherOptions['detail'] = new cListOptions();
		$this->OtherOptions['detail']->Tag = "div";
		$this->OtherOptions['detail']->TagClassName = "ewDetailOption";
		$this->OtherOptions['action'] = new cListOptions();
		$this->OtherOptions['action']->Tag = "div";
		$this->OtherOptions['action']->TagClassName = "ewActionOption";

		// Filter options
		$this->FilterOptions = new cListOptions();
		$this->FilterOptions->Tag = "div";
		$this->FilterOptions->TagClassName = "ewFilterOption fclient_budgetlistsrch";

		// List actions
		$this->ListActions = new cListActions();
	}

	//
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanList()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			$this->Page_Terminate(ew_GetUrl("index.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Get export parameters
		$custom = "";
		if (@$_GET["export"] <> "") {
			$this->Export = $_GET["export"];
			$custom = @$_GET["custom"];
		} elseif (@$_POST["export"] <> "") {
			$this->Export = $_POST["export"];
			$custom = @$_POST["custom"];
		} elseif (ew_IsHttpPost()) {
			if (@$_POST["exporttype"] <> "")
				$this->Export = $_POST["exporttype"];
			$custom = @$_POST["custom"];
		} else {
			$this->setExportReturnUrl(ew_CurrentUrl());
		}
		$gsExportFile = $this->TableVar; // Get export file, used in header

		// Get custom export parameters
		if ($this->Export <> "" && $custom <> "") {
			$this->CustomExport = $this->Export;
			$this->Export = "print";
		}
		$gsCustomExport = $this->CustomExport;
		$gsExport = $this->Export; // Get export parameter, used in header

		// Update Export URLs
		if (defined("EW_USE_PHPEXCEL"))
			$this->ExportExcelCustom = FALSE;
		if ($this->ExportExcelCustom)
			$this->ExportExcelUrl .= "&amp;custom=1";
		if (defined("EW_USE_PHPWORD"))
			$this->ExportWordCustom = FALSE;
		if ($this->ExportWordCustom)
			$this->ExportWordUrl .= "&amp;custom=1";
		if ($this->ExportPdfCustom)
			$this->ExportPdfUrl .= "&amp;custom=1";
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action

		// Get grid add count
		$gridaddcnt = @$_GET[EW_TABLE_GRID_ADD_ROW_COUNT];
		if (is_numeric($gridaddcnt) && $gridaddcnt > 0)
			$this->GridAddRowCount = $gridaddcnt;

		// Set up list options
		$this->SetupListOptions();

		// Setup export options
		$this->SetupExportOptions();
		$this->dbkey_client->SetVisibility();
		$this->Client_Name->SetVisibility();
		$this->Activity_Code->SetVisibility();
		$this->budget->SetVisibility();
		$this->from->SetVisibility();
		$this->through->SetVisibility();
		$this->contractid->SetVisibility();
		$this->rate->SetVisibility();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();

		// Set up master detail parameters
		$this->SetUpMasterParms();

		// Setup other options
		$this->SetupOtherOptions();

		// Set up custom action (compatible with old version)
		foreach ($this->CustomActions as $name => $action)
			$this->ListActions->Add($name, $action);

		// Show checkbox column if multiple action
		foreach ($this->ListActions->Items as $listaction) {
			if ($listaction->Select == EW_ACTION_MULTIPLE && $listaction->Allow) {
				$this->ListOptions->Items["checkbox"]->Visible = TRUE;
				break;
			}
		}
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $client_budget;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($client_budget);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}

	// Class variables
	var $ListOptions; // List options
	var $ExportOptions; // Export options
	var $SearchOptions; // Search options
	var $OtherOptions = array(); // Other options
	var $FilterOptions; // Filter options
	var $ListActions; // List actions
	var $SelectedCount = 0;
	var $SelectedIndex = 0;
	var $DisplayRecs = 20;
	var $StartRec;
	var $StopRec;
	var $TotalRecs = 0;
	var $RecRange = 10;
	var $Pager;
	var $DefaultSearchWhere = ""; // Default search WHERE clause
	var $SearchWhere = ""; // Search WHERE clause
	var $RecCnt = 0; // Record count
	var $EditRowCnt;
	var $StartRowCnt = 1;
	var $RowCnt = 0;
	var $Attrs = array(); // Row attributes and cell attributes
	var $RowIndex = 0; // Row index
	var $KeyCount = 0; // Key count
	var $RowAction = ""; // Row action
	var $RowOldKey = ""; // Row old key (for copy)
	var $RecPerRow = 0;
	var $MultiColumnClass;
	var $MultiColumnEditClass = "col-sm-12";
	var $MultiColumnCnt = 12;
	var $MultiColumnEditCnt = 12;
	var $GridCnt = 0;
	var $ColCnt = 0;
	var $DbMasterFilter = ""; // Master filter
	var $DbDetailFilter = ""; // Detail filter
	var $MasterRecordExists;	
	var $MultiSelectKey;
	var $Command;
	var $RestoreSearch = FALSE;
	var $DetailPages;
	var $Recordset;
	var $OldRecordset;

	//
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError, $gsSearchError, $Security;

		// Search filters
		$sSrchAdvanced = ""; // Advanced search filter
		$sSrchBasic = ""; // Basic search filter
		$sFilter = "";

		// Get command
		$this->Command = strtolower(@$_GET["cmd"]);
		if ($this->IsPageRequest()) { // Validate request

			// Process list action first
			if ($this->ProcessListAction()) // Ajax request
				$this->Page_Terminate();

			// Handle reset command
			$this->ResetCmd();

			// Set up Breadcrumb
			if ($this->Export == "")
				$this->SetupBreadcrumb();

			// Hide list options
			if ($this->Export <> "") {
				$this->ListOptions->HideAllOptions(array("sequence"));
				$this->ListOptions->UseDropDownButton = FALSE; // Disable drop down button
				$this->ListOptions->UseButtonGroup = FALSE; // Disable button group
			} elseif ($this->CurrentAction == "gridadd" || $this->CurrentAction == "gridedit") {
				$this->ListOptions->HideAllOptions();
				$this->ListOptions->UseDropDownButton = FALSE; // Disable drop down button
				$this->ListOptions->UseButtonGroup = FALSE; // Disable button group
			}

			// Hide options
			if ($this->Export <> "" || $this->CurrentAction <> "") {
				$this->ExportOptions->HideAllOptions();
				$this->FilterOptions->HideAllOptions();
			}

			// Hide other options
			if ($this->Export <> "") {
				foreach ($this->OtherOptions as &$option)
					$option->HideAllOptions();
			}

			// Get default search criteria
			ew_AddFilter($this->DefaultSearchWhere, $this->AdvancedSearchWhere(TRUE));

			// Get and validate search values for advanced search
			$this->LoadSearchValues(); // Get search values

			// Process filter list
			$this->ProcessFilterList();
			if (!$this->ValidateSearch())
				$this->setFailureMessage($gsSearchError);

			// Restore search parms from Session if not searching / reset / export
			if (($this->Export <> "" || $this->Command <> "search" && $this->Command <> "reset" && $this->Command <> "resetall") && $this->CheckSearchParms())
				$this->RestoreSearchParms();

			// Call Recordset SearchValidated event
			$this->Recordset_SearchValidated();

			// Set up sorting order
			$this->SetUpSortOrder();

			// Get search criteria for advanced search
			if ($gsSearchError == "")
				$sSrchAdvanced = $this->AdvancedSearchWhere();
		}

		// Restore display records
		if ($this->getRecordsPerPage() <> "") {
			$this->DisplayRecs = $this->getRecordsPerPage(); // Restore from Session
		} else {
			$this->DisplayRecs = 20; // Load default
		}

		// Load Sorting Order
		$this->LoadSortOrder();

		// Load search default if no existing search criteria
		if (!$this->CheckSearchParms()) {

			// Load advanced search from default
			if ($this->LoadAdvancedSearchDefault()) {
				$sSrchAdvanced = $this->AdvancedSearchWhere();
			}
		}

		// Build search criteria
		ew_AddFilter($this->SearchWhere, $sSrchAdvanced);
		ew_AddFilter($this->SearchWhere, $sSrchBasic);

		// Call Recordset_Searching event
		$this->Recordset_Searching($this->SearchWhere);

		// Save search criteria
		if ($this->Command == "search" && !$this->RestoreSearch) {
			$this->setSearchWhere($this->SearchWhere); // Save to Session
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} else {
			$this->SearchWhere = $this->getSearchWhere();
		}

		// Build filter
		$sFilter = "";
		if (!$Security->CanList())
			$sFilter = "(0=1)"; // Filter all records

		// Restore master/detail filter
		$this->DbMasterFilter = $this->GetMasterFilter(); // Restore master filter
		$this->DbDetailFilter = $this->GetDetailFilter(); // Restore detail filter
		ew_AddFilter($sFilter, $this->DbDetailFilter);
		ew_AddFilter($sFilter, $this->SearchWhere);

		// Load master record
		if ($this->CurrentMode <> "add" && $this->GetMasterFilter() <> "" && $this->getCurrentMasterTable() == "activity") {
			global $activity;
			$rsmaster = $activity->LoadRs($this->DbMasterFilter);
			$this->MasterRecordExists = ($rsmaster && !$rsmaster->EOF);
			if (!$this->MasterRecordExists) {
				$this->setFailureMessage($Language->Phrase("NoRecord")); // Set no record found
				$this->Page_Terminate("activitylist.php"); // Return to master page
			} else {
				$activity->LoadListRowValues($rsmaster);
				$activity->RowType = EW_ROWTYPE_MASTER; // Master row
				$activity->RenderListRow();
				$rsmaster->Close();
			}
		}

		// Load master record
		if ($this->CurrentMode <> "add" && $this->GetMasterFilter() <> "" && $this->getCurrentMasterTable() == "client") {
			global $client;
			$rsmaster = $client->LoadRs($this->DbMasterFilter);
			$this->MasterRecordExists = ($rsmaster && !$rsmaster->EOF);
			if (!$this->MasterRecordExists) {
				$this->setFailureMessage($Language->Phrase("NoRecord")); // Set no record found
				$this->Page_Terminate("clientlist.php"); // Return to master page
			} else {
				$client->LoadListRowValues($rsmaster);
				$client->RowType = EW_ROWTYPE_MASTER; // Master row
				$client->RenderListRow();
				$rsmaster->Close();
			}
		}

		// Set up filter in session
		$this->setSessionWhere($sFilter);
		$this->CurrentFilter = "";

		// Export data only
		if ($this->CustomExport == "" && in_array($this->Export, array("html","word","excel","xml","csv","email","pdf"))) {
			$this->ExportData();
			$this->Page_Terminate(); // Terminate response
			exit();
		}

		// Load record count first
		if (!$this->IsAddOrEdit()) {
			$bSelectLimit = $this->UseSelectLimit;
			if ($bSelectLimit) {
				$this->TotalRecs = $this->SelectRecordCount();
			} else {
				if ($this->Recordset = $this->LoadRecordset())
					$this->TotalRecs = $this->Recordset->RecordCount();
			}
		}

		// Search options
		$this->SetupSearchOptions();
	}

	// Build filter for all keys
	function BuildKeyFilter() {
		global $objForm;
		$sWrkFilter = "";

		// Update row index and get row key
		$rowindex = 1;
		$objForm->Index = $rowindex;
		$sThisKey = strval($objForm->GetValue($this->FormKeyName));
		while ($sThisKey <> "") {
			if ($this->SetupKeyValues($sThisKey)) {
				$sFilter = $this->KeyFilter();
				if ($sWrkFilter <> "") $sWrkFilter .= " OR ";
				$sWrkFilter .= $sFilter;
			} else {
				$sWrkFilter = "0=1";
				break;
			}

			// Update row index and get row key
			$rowindex++; // Next row
			$objForm->Index = $rowindex;
			$sThisKey = strval($objForm->GetValue($this->FormKeyName));
		}
		return $sWrkFilter;
	}

	// Set up key values
	function SetupKeyValues($key) {
		$arrKeyFlds = explode($GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"], $key);
		if (count($arrKeyFlds) >= 1) {
			$this->dbkey->setFormValue($arrKeyFlds[0]);
			if (!is_numeric($this->dbkey->FormValue))
				return FALSE;
		}
		return TRUE;
	}

	// Get list of filters
	function GetFilterList() {
		global $UserProfile;

		// Load server side filters
		if (EW_SEARCH_FILTER_OPTION == "Server") {
			$sSavedFilterList = $UserProfile->GetSearchFilters(CurrentUserName(), "fclient_budgetlistsrch");
		} else {
			$sSavedFilterList = "";
		}

		// Initialize
		$sFilterList = "";
		$sFilterList = ew_Concat($sFilterList, $this->dbkey_client->AdvancedSearch->ToJSON(), ","); // Field dbkey_client
		$sFilterList = ew_Concat($sFilterList, $this->Client_Name->AdvancedSearch->ToJSON(), ","); // Field Client_Name
		$sFilterList = ew_Concat($sFilterList, $this->Activity_Code->AdvancedSearch->ToJSON(), ","); // Field Activity_Code
		$sFilterList = ew_Concat($sFilterList, $this->dbkey_activity->AdvancedSearch->ToJSON(), ","); // Field dbkey_activity
		$sFilterList = ew_Concat($sFilterList, $this->from->AdvancedSearch->ToJSON(), ","); // Field from
		$sFilterList = ew_Concat($sFilterList, $this->through->AdvancedSearch->ToJSON(), ","); // Field through
		$sFilterList = ew_Concat($sFilterList, $this->contractid->AdvancedSearch->ToJSON(), ","); // Field contractid
		$sFilterList = ew_Concat($sFilterList, $this->rate->AdvancedSearch->ToJSON(), ","); // Field rate
		$sFilterList = preg_replace('/,$/', "", $sFilterList);

		// Return filter list in json
		if ($sFilterList <> "")
			$sFilterList = "\"data\":{" . $sFilterList . "}";
		if ($sSavedFilterList <> "") {
			if ($sFilterList <> "")
				$sFilterList .= ",";
			$sFilterList .= "\"filters\":" . $sSavedFilterList;
		}
		return ($sFilterList <> "") ? "{" . $sFilterList . "}" : "null";
	}

	// Process filter list
	function ProcessFilterList() {
		global $UserProfile;
		if (@$_POST["ajax"] == "savefilters") { // Save filter request (Ajax)
			$filters = ew_StripSlashes(@$_POST["filters"]);
			$UserProfile->SetSearchFilters(CurrentUserName(), "fclient_budgetlistsrch", $filters);

			// Clean output buffer
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			echo ew_ArrayToJson(array(array("success" => TRUE))); // Success
			$this->Page_Terminate();
			exit();
		} elseif (@$_POST["cmd"] == "resetfilter") {
			$this->RestoreFilterList();
		}
	}

	// Restore list of filters
	function RestoreFilterList() {

		// Return if not reset filter
		if (@$_POST["cmd"] <> "resetfilter")
			return FALSE;
		$filter = json_decode(ew_StripSlashes(@$_POST["filter"]), TRUE);
		$this->Command = "search";

		// Field dbkey_client
		$this->dbkey_client->AdvancedSearch->SearchValue = @$filter["x_dbkey_client"];
		$this->dbkey_client->AdvancedSearch->SearchOperator = @$filter["z_dbkey_client"];
		$this->dbkey_client->AdvancedSearch->SearchCondition = @$filter["v_dbkey_client"];
		$this->dbkey_client->AdvancedSearch->SearchValue2 = @$filter["y_dbkey_client"];
		$this->dbkey_client->AdvancedSearch->SearchOperator2 = @$filter["w_dbkey_client"];
		$this->dbkey_client->AdvancedSearch->Save();

		// Field Client_Name
		$this->Client_Name->AdvancedSearch->SearchValue = @$filter["x_Client_Name"];
		$this->Client_Name->AdvancedSearch->SearchOperator = @$filter["z_Client_Name"];
		$this->Client_Name->AdvancedSearch->SearchCondition = @$filter["v_Client_Name"];
		$this->Client_Name->AdvancedSearch->SearchValue2 = @$filter["y_Client_Name"];
		$this->Client_Name->AdvancedSearch->SearchOperator2 = @$filter["w_Client_Name"];
		$this->Client_Name->AdvancedSearch->Save();

		// Field Activity_Code
		$this->Activity_Code->AdvancedSearch->SearchValue = @$filter["x_Activity_Code"];
		$this->Activity_Code->AdvancedSearch->SearchOperator = @$filter["z_Activity_Code"];
		$this->Activity_Code->AdvancedSearch->SearchCondition = @$filter["v_Activity_Code"];
		$this->Activity_Code->AdvancedSearch->SearchValue2 = @$filter["y_Activity_Code"];
		$this->Activity_Code->AdvancedSearch->SearchOperator2 = @$filter["w_Activity_Code"];
		$this->Activity_Code->AdvancedSearch->Save();

		// Field dbkey_activity
		$this->dbkey_activity->AdvancedSearch->SearchValue = @$filter["x_dbkey_activity"];
		$this->dbkey_activity->AdvancedSearch->SearchOperator = @$filter["z_dbkey_activity"];
		$this->dbkey_activity->AdvancedSearch->SearchCondition = @$filter["v_dbkey_activity"];
		$this->dbkey_activity->AdvancedSearch->SearchValue2 = @$filter["y_dbkey_activity"];
		$this->dbkey_activity->AdvancedSearch->SearchOperator2 = @$filter["w_dbkey_activity"];
		$this->dbkey_activity->AdvancedSearch->Save();

		// Field from
		$this->from->AdvancedSearch->SearchValue = @$filter["x_from"];
		$this->from->AdvancedSearch->SearchOperator = @$filter["z_from"];
		$this->from->AdvancedSearch->SearchCondition = @$filter["v_from"];
		$this->from->AdvancedSearch->SearchValue2 = @$filter["y_from"];
		$this->from->AdvancedSearch->SearchOperator2 = @$filter["w_from"];
		$this->from->AdvancedSearch->Save();

		// Field through
		$this->through->AdvancedSearch->SearchValue = @$filter["x_through"];
		$this->through->AdvancedSearch->SearchOperator = @$filter["z_through"];
		$this->through->AdvancedSearch->SearchCondition = @$filter["v_through"];
		$this->through->AdvancedSearch->SearchValue2 = @$filter["y_through"];
		$this->through->AdvancedSearch->SearchOperator2 = @$filter["w_through"];
		$this->through->AdvancedSearch->Save();

		// Field contractid
		$this->contractid->AdvancedSearch->SearchValue = @$filter["x_contractid"];
		$this->contractid->AdvancedSearch->SearchOperator = @$filter["z_contractid"];
		$this->contractid->AdvancedSearch->SearchCondition = @$filter["v_contractid"];
		$this->contractid->AdvancedSearch->SearchValue2 = @$filter["y_contractid"];
		$this->contractid->AdvancedSearch->SearchOperator2 = @$filter["w_contractid"];
		$this->contractid->AdvancedSearch->Save();

		// Field rate
		$this->rate->AdvancedSearch->SearchValue = @$filter["x_rate"];
		$this->rate->AdvancedSearch->SearchOperator = @$filter["z_rate"];
		$this->rate->AdvancedSearch->SearchCondition = @$filter["v_rate"];
		$this->rate->AdvancedSearch->SearchValue2 = @$filter["y_rate"];
		$this->rate->AdvancedSearch->SearchOperator2 = @$filter["w_rate"];
		$this->rate->AdvancedSearch->Save();
	}

	// Advanced search WHERE clause based on QueryString
	function AdvancedSearchWhere($Default = FALSE) {
		global $Security;
		$sWhere = "";
		if (!$Security->CanSearch()) return "";
		$this->BuildSearchSql($sWhere, $this->dbkey_client, $Default, FALSE); // dbkey_client
		$this->BuildSearchSql($sWhere, $this->Client_Name, $Default, FALSE); // Client_Name
		$this->BuildSearchSql($sWhere, $this->Activity_Code, $Default, FALSE); // Activity_Code
		$this->BuildSearchSql($sWhere, $this->dbkey_activity, $Default, FALSE); // dbkey_activity
		$this->BuildSearchSql($sWhere, $this->from, $Default, FALSE); // from
		$this->BuildSearchSql($sWhere, $this->through, $Default, FALSE); // through
		$this->BuildSearchSql($sWhere, $this->contractid, $Default, FALSE); // contractid
		$this->BuildSearchSql($sWhere, $this->rate, $Default, FALSE); // rate

		// Set up search parm
		if (!$Default && $sWhere <> "") {
			$this->Command = "search";
		}
		if (!$Default && $this->Command == "search") {
			$this->dbkey_client->AdvancedSearch->Save(); // dbkey_client
			$this->Client_Name->AdvancedSearch->Save(); // Client_Name
			$this->Activity_Code->AdvancedSearch->Save(); // Activity_Code
			$this->dbkey_activity->AdvancedSearch->Save(); // dbkey_activity
			$this->from->AdvancedSearch->Save(); // from
			$this->through->AdvancedSearch->Save(); // through
			$this->contractid->AdvancedSearch->Save(); // contractid
			$this->rate->AdvancedSearch->Save(); // rate
		}
		return $sWhere;
	}

	// Build search SQL
	function BuildSearchSql(&$Where, &$Fld, $Default, $MultiValue) {
		$FldParm = substr($Fld->FldVar, 2);
		$FldVal = ($Default) ? $Fld->AdvancedSearch->SearchValueDefault : $Fld->AdvancedSearch->SearchValue; // @$_GET["x_$FldParm"]
		$FldOpr = ($Default) ? $Fld->AdvancedSearch->SearchOperatorDefault : $Fld->AdvancedSearch->SearchOperator; // @$_GET["z_$FldParm"]
		$FldCond = ($Default) ? $Fld->AdvancedSearch->SearchConditionDefault : $Fld->AdvancedSearch->SearchCondition; // @$_GET["v_$FldParm"]
		$FldVal2 = ($Default) ? $Fld->AdvancedSearch->SearchValue2Default : $Fld->AdvancedSearch->SearchValue2; // @$_GET["y_$FldParm"]
		$FldOpr2 = ($Default) ? $Fld->AdvancedSearch->SearchOperator2Default : $Fld->AdvancedSearch->SearchOperator2; // @$_GET["w_$FldParm"]
		$sWrk = "";

		//$FldVal = ew_StripSlashes($FldVal);
		if (is_array($FldVal)) $FldVal = implode(",", $FldVal);

		//$FldVal2 = ew_StripSlashes($FldVal2);
		if (is_array($FldVal2)) $FldVal2 = implode(",", $FldVal2);
		$FldOpr = strtoupper(trim($FldOpr));
		if ($FldOpr == "") $FldOpr = "=";
		$FldOpr2 = strtoupper(trim($FldOpr2));
		if ($FldOpr2 == "") $FldOpr2 = "=";
		if (EW_SEARCH_MULTI_VALUE_OPTION == 1)
			$MultiValue = FALSE;
		if ($MultiValue) {
			$sWrk1 = ($FldVal <> "") ? ew_GetMultiSearchSql($Fld, $FldOpr, $FldVal, $this->DBID) : ""; // Field value 1
			$sWrk2 = ($FldVal2 <> "") ? ew_GetMultiSearchSql($Fld, $FldOpr2, $FldVal2, $this->DBID) : ""; // Field value 2
			$sWrk = $sWrk1; // Build final SQL
			if ($sWrk2 <> "")
				$sWrk = ($sWrk <> "") ? "($sWrk) $FldCond ($sWrk2)" : $sWrk2;
		} else {
			$FldVal = $this->ConvertSearchValue($Fld, $FldVal);
			$FldVal2 = $this->ConvertSearchValue($Fld, $FldVal2);
			$sWrk = ew_GetSearchSql($Fld, $FldVal, $FldOpr, $FldCond, $FldVal2, $FldOpr2, $this->DBID);
		}
		ew_AddFilter($Where, $sWrk);
	}

	// Convert search value
	function ConvertSearchValue(&$Fld, $FldVal) {
		if ($FldVal == EW_NULL_VALUE || $FldVal == EW_NOT_NULL_VALUE)
			return $FldVal;
		$Value = $FldVal;
		if ($Fld->FldDataType == EW_DATATYPE_BOOLEAN) {
			if ($FldVal <> "") $Value = ($FldVal == "1" || strtolower(strval($FldVal)) == "y" || strtolower(strval($FldVal)) == "t") ? $Fld->TrueValue : $Fld->FalseValue;
		} elseif ($Fld->FldDataType == EW_DATATYPE_DATE || $Fld->FldDataType == EW_DATATYPE_TIME) {
			if ($FldVal <> "") $Value = ew_UnFormatDateTime($FldVal, $Fld->FldDateTimeFormat);
		}
		return $Value;
	}

	// Check if search parm exists
	function CheckSearchParms() {
		if ($this->dbkey_client->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->Client_Name->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->Activity_Code->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->dbkey_activity->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->from->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->through->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->contractid->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->rate->AdvancedSearch->IssetSession())
			return TRUE;
		return FALSE;
	}

	// Clear all search parameters
	function ResetSearchParms() {

		// Clear search WHERE clause
		$this->SearchWhere = "";
		$this->setSearchWhere($this->SearchWhere);

		// Clear advanced search parameters
		$this->ResetAdvancedSearchParms();
	}

	// Load advanced search default values
	function LoadAdvancedSearchDefault() {
		return FALSE;
	}

	// Clear all advanced search parameters
	function ResetAdvancedSearchParms() {
		$this->dbkey_client->AdvancedSearch->UnsetSession();
		$this->Client_Name->AdvancedSearch->UnsetSession();
		$this->Activity_Code->AdvancedSearch->UnsetSession();
		$this->dbkey_activity->AdvancedSearch->UnsetSession();
		$this->from->AdvancedSearch->UnsetSession();
		$this->through->AdvancedSearch->UnsetSession();
		$this->contractid->AdvancedSearch->UnsetSession();
		$this->rate->AdvancedSearch->UnsetSession();
	}

	// Restore all search parameters
	function RestoreSearchParms() {
		$this->RestoreSearch = TRUE;

		// Restore advanced search values
		$this->dbkey_client->AdvancedSearch->Load();
		$this->Client_Name->AdvancedSearch->Load();
		$this->Activity_Code->AdvancedSearch->Load();
		$this->dbkey_activity->AdvancedSearch->Load();
		$this->from->AdvancedSearch->Load();
		$this->through->AdvancedSearch->Load();
		$this->contractid->AdvancedSearch->Load();
		$this->rate->AdvancedSearch->Load();
	}

	// Set up sort parameters
	function SetUpSortOrder() {

		// Check for "order" parameter
		if (@$_GET["order"] <> "") {
			$this->CurrentOrder = ew_StripSlashes(@$_GET["order"]);
			$this->CurrentOrderType = @$_GET["ordertype"];
			$this->UpdateSort($this->dbkey_client); // dbkey_client
			$this->UpdateSort($this->Client_Name); // Client_Name
			$this->UpdateSort($this->Activity_Code); // Activity_Code
			$this->UpdateSort($this->budget); // budget
			$this->UpdateSort($this->from); // from
			$this->UpdateSort($this->through); // through
			$this->UpdateSort($this->contractid); // contractid
			$this->UpdateSort($this->rate); // rate
			$this->setStartRecordNumber(1); // Reset start position
		}
	}

	// Load sort order parameters
	function LoadSortOrder() {
		$sOrderBy = $this->getSessionOrderBy(); // Get ORDER BY from Session
		if ($sOrderBy == "") {
			if ($this->getSqlOrderBy() <> "") {
				$sOrderBy = $this->getSqlOrderBy();
				$this->setSessionOrderBy($sOrderBy);
			}
		}
	}

	// Reset command
	// - cmd=reset (Reset search parameters)
	// - cmd=resetall (Reset search and master/detail parameters)
	// - cmd=resetsort (Reset sort parameters)
	function ResetCmd() {

		// Check if reset command
		if (substr($this->Command,0,5) == "reset") {

			// Reset search criteria
			if ($this->Command == "reset" || $this->Command == "resetall")
				$this->ResetSearchParms();

			// Reset master/detail keys
			if ($this->Command == "resetall") {
				$this->setCurrentMasterTable(""); // Clear master table
				$this->DbMasterFilter = "";
				$this->DbDetailFilter = "";
				$this->Activity_Code->setSessionValue("");
				$this->dbkey_client->setSessionValue("");
			}

			// Reset sorting order
			if ($this->Command == "resetsort") {
				$sOrderBy = "";
				$this->setSessionOrderBy($sOrderBy);
				$this->setSessionOrderByList($sOrderBy);
				$this->dbkey_client->setSort("");
				$this->Client_Name->setSort("");
				$this->Activity_Code->setSort("");
				$this->budget->setSort("");
				$this->from->setSort("");
				$this->through->setSort("");
				$this->contractid->setSort("");
				$this->rate->setSort("");
			}

			// Reset start position
			$this->StartRec = 1;
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Set up list options
	function SetupListOptions() {
		global $Security, $Language;

		// Add group option item
		$item = &$this->ListOptions->Add($this->ListOptions->GroupOptionName);
		$item->Body = "";
		$item->OnLeft = FALSE;
		$item->Visible = FALSE;

		// "view"
		$item = &$this->ListOptions->Add("view");
		$item->CssStyle = "white-space: nowrap;";
		$item->Visible = $Security->CanView();
		$item->OnLeft = FALSE;

		// "edit"
		$item = &$this->ListOptions->Add("edit");
		$item->CssStyle = "white-space: nowrap;";
		$item->Visible = $Security->CanEdit();
		$item->OnLeft = FALSE;

		// "copy"
		$item = &$this->ListOptions->Add("copy");
		$item->CssStyle = "white-space: nowrap;";
		$item->Visible = $Security->CanAdd();
		$item->OnLeft = FALSE;

		// "delete"
		$item = &$this->ListOptions->Add("delete");
		$item->CssStyle = "white-space: nowrap;";
		$item->Visible = $Security->CanDelete();
		$item->OnLeft = FALSE;

		// List actions
		$item = &$this->ListOptions->Add("listactions");
		$item->CssStyle = "white-space: nowrap;";
		$item->OnLeft = FALSE;
		$item->Visible = FALSE;
		$item->ShowInButtonGroup = FALSE;
		$item->ShowInDropDown = FALSE;

		// "checkbox"
		$item = &$this->ListOptions->Add("checkbox");
		$item->Visible = FALSE;
		$item->OnLeft = FALSE;
		$item->Header = "<input type=\"checkbox\" name=\"key\" id=\"key\" onclick=\"ew_SelectAllKey(this);\">";
		$item->ShowInDropDown = FALSE;
		$item->ShowInButtonGroup = FALSE;

		// Drop down button for ListOptions
		$this->ListOptions->UseImageAndText = TRUE;
		$this->ListOptions->UseDropDownButton = FALSE;
		$this->ListOptions->DropDownButtonPhrase = $Language->Phrase("ButtonListOptions");
		$this->ListOptions->UseButtonGroup = FALSE;
		if ($this->ListOptions->UseButtonGroup && ew_IsMobile())
			$this->ListOptions->UseDropDownButton = TRUE;
		$this->ListOptions->ButtonClass = "btn-sm"; // Class for button group

		// Call ListOptions_Load event
		$this->ListOptions_Load();
		$this->SetupListOptionsExt();
		$item = &$this->ListOptions->GetItem($this->ListOptions->GroupOptionName);
		$item->Visible = $this->ListOptions->GroupOptionVisible();
	}

	// Render list options
	function RenderListOptions() {
		global $Security, $Language, $objForm;
		$this->ListOptions->LoadDefault();

		// "view"
		$oListOpt = &$this->ListOptions->Items["view"];
		$viewcaption = ew_HtmlTitle($Language->Phrase("ViewLink"));
		if ($Security->CanView()) {
			$oListOpt->Body = "<a class=\"ewRowLink ewView\" title=\"" . $viewcaption . "\" data-caption=\"" . $viewcaption . "\" href=\"" . ew_HtmlEncode($this->ViewUrl) . "\">" . $Language->Phrase("ViewLink") . "</a>";
		} else {
			$oListOpt->Body = "";
		}

		// "edit"
		$oListOpt = &$this->ListOptions->Items["edit"];
		$editcaption = ew_HtmlTitle($Language->Phrase("EditLink"));
		if ($Security->CanEdit()) {
			$oListOpt->Body = "<a class=\"ewRowLink ewEdit\" title=\"" . ew_HtmlTitle($Language->Phrase("EditLink")) . "\" data-caption=\"" . ew_HtmlTitle($Language->Phrase("EditLink")) . "\" href=\"" . ew_HtmlEncode($this->EditUrl) . "\">" . $Language->Phrase("EditLink") . "</a>";
		} else {
			$oListOpt->Body = "";
		}

		// "copy"
		$oListOpt = &$this->ListOptions->Items["copy"];
		$copycaption = ew_HtmlTitle($Language->Phrase("CopyLink"));
		if ($Security->CanAdd()) {
			$oListOpt->Body = "<a class=\"ewRowLink ewCopy\" title=\"" . $copycaption . "\" data-caption=\"" . $copycaption . "\" href=\"" . ew_HtmlEncode($this->CopyUrl) . "\">" . $Language->Phrase("CopyLink") . "</a>";
		} else {
			$oListOpt->Body = "";
		}

		// "delete"
		$oListOpt = &$this->ListOptions->Items["delete"];
		if ($Security->CanDelete())
			$oListOpt->Body = "<a class=\"ewRowLink ewDelete\"" . "" . " title=\"" . ew_HtmlTitle($Language->Phrase("DeleteLink")) . "\" data-caption=\"" . ew_HtmlTitle($Language->Phrase("DeleteLink")) . "\" href=\"" . ew_HtmlEncode($this->DeleteUrl) . "\">" . $Language->Phrase("DeleteLink") . "</a>";
		else
			$oListOpt->Body = "";

		// Set up list action buttons
		$oListOpt = &$this->ListOptions->GetItem("listactions");
		if ($oListOpt && $this->Export == "" && $this->CurrentAction == "") {
			$body = "";
			$links = array();
			foreach ($this->ListActions->Items as $listaction) {
				if ($listaction->Select == EW_ACTION_SINGLE && $listaction->Allow) {
					$action = $listaction->Action;
					$caption = $listaction->Caption;
					$icon = ($listaction->Icon <> "") ? "<span class=\"" . ew_HtmlEncode(str_replace(" ewIcon", "", $listaction->Icon)) . "\" data-caption=\"" . ew_HtmlTitle($caption) . "\"></span> " : "";
					$links[] = "<li><a class=\"ewAction ewListAction\" data-action=\"" . ew_HtmlEncode($action) . "\" data-caption=\"" . ew_HtmlTitle($caption) . "\" href=\"\" onclick=\"ew_SubmitAction(event,jQuery.extend({key:" . $this->KeyToJson() . "}," . $listaction->ToJson(TRUE) . "));return false;\">" . $icon . $listaction->Caption . "</a></li>";
					if (count($links) == 1) // Single button
						$body = "<a class=\"ewAction ewListAction\" data-action=\"" . ew_HtmlEncode($action) . "\" title=\"" . ew_HtmlTitle($caption) . "\" data-caption=\"" . ew_HtmlTitle($caption) . "\" href=\"\" onclick=\"ew_SubmitAction(event,jQuery.extend({key:" . $this->KeyToJson() . "}," . $listaction->ToJson(TRUE) . "));return false;\">" . $Language->Phrase("ListActionButton") . "</a>";
				}
			}
			if (count($links) > 1) { // More than one buttons, use dropdown
				$body = "<button class=\"dropdown-toggle btn btn-default btn-sm ewActions\" title=\"" . ew_HtmlTitle($Language->Phrase("ListActionButton")) . "\" data-toggle=\"dropdown\">" . $Language->Phrase("ListActionButton") . "<b class=\"caret\"></b></button>";
				$content = "";
				foreach ($links as $link)
					$content .= "<li>" . $link . "</li>";
				$body .= "<ul class=\"dropdown-menu" . ($oListOpt->OnLeft ? "" : " dropdown-menu-right") . "\">". $content . "</ul>";
				$body = "<div class=\"btn-group\">" . $body . "</div>";
			}
			if (count($links) > 0) {
				$oListOpt->Body = $body;
				$oListOpt->Visible = TRUE;
			}
		}

		// "checkbox"
		$oListOpt = &$this->ListOptions->Items["checkbox"];
		$oListOpt->Body = "<input type=\"checkbox\" name=\"key_m[]\" value=\"" . ew_HtmlEncode($this->dbkey->CurrentValue) . "\" onclick='ew_ClickMultiCheckbox(event);'>";
		$this->RenderListOptionsExt();

		// Call ListOptions_Rendered event
		$this->ListOptions_Rendered();
	}

	// Set up other options
	function SetupOtherOptions() {
		global $Language, $Security;
		$options = &$this->OtherOptions;
		$option = $options["addedit"];

		// Add
		$item = &$option->Add("add");
		$addcaption = ew_HtmlTitle($Language->Phrase("AddLink"));
		$item->Body = "<a class=\"ewAddEdit ewAdd\" title=\"" . $addcaption . "\" data-caption=\"" . $addcaption . "\" href=\"" . ew_HtmlEncode($this->AddUrl) . "\">" . $Language->Phrase("AddLink") . "</a>";
		$item->Visible = ($this->AddUrl <> "" && $Security->CanAdd());
		$option = $options["action"];

		// Set up options default
		foreach ($options as &$option) {
			$option->UseImageAndText = TRUE;
			$option->UseDropDownButton = FALSE;
			$option->UseButtonGroup = TRUE;
			$option->ButtonClass = "btn-sm"; // Class for button group
			$item = &$option->Add($option->GroupOptionName);
			$item->Body = "";
			$item->Visible = FALSE;
		}
		$options["addedit"]->DropDownButtonPhrase = $Language->Phrase("ButtonAddEdit");
		$options["detail"]->DropDownButtonPhrase = $Language->Phrase("ButtonDetails");
		$options["action"]->DropDownButtonPhrase = $Language->Phrase("ButtonActions");

		// Filter button
		$item = &$this->FilterOptions->Add("savecurrentfilter");
		$item->Body = "<a class=\"ewSaveFilter\" data-form=\"fclient_budgetlistsrch\" href=\"#\">" . $Language->Phrase("SaveCurrentFilter") . "</a>";
		$item->Visible = TRUE;
		$item = &$this->FilterOptions->Add("deletefilter");
		$item->Body = "<a class=\"ewDeleteFilter\" data-form=\"fclient_budgetlistsrch\" href=\"#\">" . $Language->Phrase("DeleteFilter") . "</a>";
		$item->Visible = TRUE;
		$this->FilterOptions->UseDropDownButton = TRUE;
		$this->FilterOptions->UseButtonGroup = !$this->FilterOptions->UseDropDownButton;
		$this->FilterOptions->DropDownButtonPhrase = $Language->Phrase("Filters");

		// Add group option item
		$item = &$this->FilterOptions->Add($this->FilterOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;
	}

	// Render other options
	function RenderOtherOptions() {
		global $Language, $Security;
		$options = &$this->OtherOptions;
			$option = &$options["action"];

			// Set up list action buttons
			foreach ($this->ListActions->Items as $listaction) {
				if ($listaction->Select == EW_ACTION_MULTIPLE) {
					$item = &$option->Add("custom_" . $listaction->Action);
					$caption = $listaction->Caption;
					$icon = ($listaction->Icon <> "") ? "<span class=\"" . ew_HtmlEncode($listaction->Icon) . "\" data-caption=\"" . ew_HtmlEncode($caption) . "\"></span> " : $caption;
					$item->Body = "<a class=\"ewAction ewListAction\" title=\"" . ew_HtmlEncode($caption) . "\" data-caption=\"" . ew_HtmlEncode($caption) . "\" href=\"\" onclick=\"ew_SubmitAction(event,jQuery.extend({f:document.fclient_budgetlist}," . $listaction->ToJson(TRUE) . "));return false;\">" . $icon . "</a>";
					$item->Visible = $listaction->Allow;
				}
			}

			// Hide grid edit and other options
			if ($this->TotalRecs <= 0) {
				$option = &$options["addedit"];
				$item = &$option->GetItem("gridedit");
				if ($item) $item->Visible = FALSE;
				$option = &$options["action"];
				$option->HideAllOptions();
			}
	}

	// Process list action
	function ProcessListAction() {
		global $Language, $Security;
		$userlist = "";
		$user = "";
		$sFilter = $this->GetKeyFilter();
		$UserAction = @$_POST["useraction"];
		if ($sFilter <> "" && $UserAction <> "") {

			// Check permission first
			$ActionCaption = $UserAction;
			if (array_key_exists($UserAction, $this->ListActions->Items)) {
				$ActionCaption = $this->ListActions->Items[$UserAction]->Caption;
				if (!$this->ListActions->Items[$UserAction]->Allow) {
					$errmsg = str_replace('%s', $ActionCaption, $Language->Phrase("CustomActionNotAllowed"));
					if (@$_POST["ajax"] == $UserAction) // Ajax
						echo "<p class=\"text-danger\">" . $errmsg . "</p>";
					else
						$this->setFailureMessage($errmsg);
					return FALSE;
				}
			}
			$this->CurrentFilter = $sFilter;
			$sSql = $this->SQL();
			$conn = &$this->Connection();
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			$rs = $conn->Execute($sSql);
			$conn->raiseErrorFn = '';
			$this->CurrentAction = $UserAction;

			// Call row action event
			if ($rs && !$rs->EOF) {
				$conn->BeginTrans();
				$this->SelectedCount = $rs->RecordCount();
				$this->SelectedIndex = 0;
				while (!$rs->EOF) {
					$this->SelectedIndex++;
					$row = $rs->fields;
					$Processed = $this->Row_CustomAction($UserAction, $row);
					if (!$Processed) break;
					$rs->MoveNext();
				}
				if ($Processed) {
					$conn->CommitTrans(); // Commit the changes
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage(str_replace('%s', $ActionCaption, $Language->Phrase("CustomActionCompleted"))); // Set up success message
				} else {
					$conn->RollbackTrans(); // Rollback changes

					// Set up error message
					if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

						// Use the message, do nothing
					} elseif ($this->CancelMessage <> "") {
						$this->setFailureMessage($this->CancelMessage);
						$this->CancelMessage = "";
					} else {
						$this->setFailureMessage(str_replace('%s', $ActionCaption, $Language->Phrase("CustomActionFailed")));
					}
				}
			}
			if ($rs)
				$rs->Close();
			$this->CurrentAction = ""; // Clear action
			if (@$_POST["ajax"] == $UserAction) { // Ajax
				if ($this->getSuccessMessage() <> "") {
					echo "<p class=\"text-success\">" . $this->getSuccessMessage() . "</p>";
					$this->ClearSuccessMessage(); // Clear message
				}
				if ($this->getFailureMessage() <> "") {
					echo "<p class=\"text-danger\">" . $this->getFailureMessage() . "</p>";
					$this->ClearFailureMessage(); // Clear message
				}
				return TRUE;
			}
		}
		return FALSE; // Not ajax request
	}

	// Set up search options
	function SetupSearchOptions() {
		global $Language;
		$this->SearchOptions = new cListOptions();
		$this->SearchOptions->Tag = "div";
		$this->SearchOptions->TagClassName = "ewSearchOption";

		// Search button
		$item = &$this->SearchOptions->Add("searchtoggle");
		$SearchToggleClass = ($this->SearchWhere <> "") ? " active" : " active";
		$item->Body = "<button type=\"button\" class=\"btn btn-default ewSearchToggle" . $SearchToggleClass . "\" title=\"" . $Language->Phrase("SearchPanel") . "\" data-caption=\"" . $Language->Phrase("SearchPanel") . "\" data-toggle=\"button\" data-form=\"fclient_budgetlistsrch\">" . $Language->Phrase("SearchBtn") . "</button>";
		$item->Visible = TRUE;

		// Show all button
		$item = &$this->SearchOptions->Add("showall");
		$item->Body = "<a class=\"btn btn-default ewShowAll\" title=\"" . $Language->Phrase("ShowAll") . "\" data-caption=\"" . $Language->Phrase("ShowAll") . "\" href=\"" . $this->PageUrl() . "cmd=reset\">" . $Language->Phrase("ShowAllBtn") . "</a>";
		$item->Visible = ($this->SearchWhere <> $this->DefaultSearchWhere && $this->SearchWhere <> "0=101");

		// Advanced search button
		$item = &$this->SearchOptions->Add("advancedsearch");
		$item->Body = "<a class=\"btn btn-default ewAdvancedSearch\" title=\"" . $Language->Phrase("AdvancedSearch") . "\" data-caption=\"" . $Language->Phrase("AdvancedSearch") . "\" href=\"client_budgetsrch.php\">" . $Language->Phrase("AdvancedSearchBtn") . "</a>";
		$item->Visible = TRUE;

		// Search highlight button
		$item = &$this->SearchOptions->Add("searchhighlight");
		$item->Body = "<button type=\"button\" class=\"btn btn-default ewHighlight active\" title=\"" . $Language->Phrase("Highlight") . "\" data-caption=\"" . $Language->Phrase("Highlight") . "\" data-toggle=\"button\" data-form=\"fclient_budgetlistsrch\" data-name=\"" . $this->HighlightName() . "\">" . $Language->Phrase("HighlightBtn") . "</button>";
		$item->Visible = ($this->SearchWhere <> "" && $this->TotalRecs > 0);

		// Button group for search
		$this->SearchOptions->UseDropDownButton = FALSE;
		$this->SearchOptions->UseImageAndText = TRUE;
		$this->SearchOptions->UseButtonGroup = TRUE;
		$this->SearchOptions->DropDownButtonPhrase = $Language->Phrase("ButtonSearch");

		// Add group option item
		$item = &$this->SearchOptions->Add($this->SearchOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;

		// Hide search options
		if ($this->Export <> "" || $this->CurrentAction <> "")
			$this->SearchOptions->HideAllOptions();
		global $Security;
		if (!$Security->CanSearch()) {
			$this->SearchOptions->HideAllOptions();
			$this->FilterOptions->HideAllOptions();
		}
	}

	function SetupListOptionsExt() {
		global $Security, $Language;
	}

	function RenderListOptionsExt() {
		global $Security, $Language;
	}

	// Set up starting record parameters
	function SetUpStartRec() {
		if ($this->DisplayRecs == 0)
			return;
		if ($this->IsPageRequest()) { // Validate request
			if (@$_GET[EW_TABLE_START_REC] <> "") { // Check for "start" parameter
				$this->StartRec = $_GET[EW_TABLE_START_REC];
				$this->setStartRecordNumber($this->StartRec);
			} elseif (@$_GET[EW_TABLE_PAGE_NO] <> "") {
				$PageNo = $_GET[EW_TABLE_PAGE_NO];
				if (is_numeric($PageNo)) {
					$this->StartRec = ($PageNo-1)*$this->DisplayRecs+1;
					if ($this->StartRec <= 0) {
						$this->StartRec = 1;
					} elseif ($this->StartRec >= intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1) {
						$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1;
					}
					$this->setStartRecordNumber($this->StartRec);
				}
			}
		}
		$this->StartRec = $this->getStartRecordNumber();

		// Check if correct start record counter
		if (!is_numeric($this->StartRec) || $this->StartRec == "") { // Avoid invalid start record counter
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} elseif (intval($this->StartRec) > intval($this->TotalRecs)) { // Avoid starting record > total records
			$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to last page first record
			$this->setStartRecordNumber($this->StartRec);
		} elseif (($this->StartRec-1) % $this->DisplayRecs <> 0) {
			$this->StartRec = intval(($this->StartRec-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to page boundary
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Load search values for validation
	function LoadSearchValues() {
		global $objForm;

		// Load search values
		// dbkey_client

		$this->dbkey_client->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_dbkey_client"]);
		if ($this->dbkey_client->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->dbkey_client->AdvancedSearch->SearchOperator = @$_GET["z_dbkey_client"];

		// Client_Name
		$this->Client_Name->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_Client_Name"]);
		if ($this->Client_Name->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->Client_Name->AdvancedSearch->SearchOperator = @$_GET["z_Client_Name"];

		// Activity_Code
		$this->Activity_Code->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_Activity_Code"]);
		if ($this->Activity_Code->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->Activity_Code->AdvancedSearch->SearchOperator = @$_GET["z_Activity_Code"];

		// dbkey_activity
		$this->dbkey_activity->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_dbkey_activity"]);
		if ($this->dbkey_activity->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->dbkey_activity->AdvancedSearch->SearchOperator = @$_GET["z_dbkey_activity"];

		// from
		$this->from->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_from"]);
		if ($this->from->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->from->AdvancedSearch->SearchOperator = @$_GET["z_from"];

		// through
		$this->through->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_through"]);
		if ($this->through->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->through->AdvancedSearch->SearchOperator = @$_GET["z_through"];

		// contractid
		$this->contractid->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_contractid"]);
		if ($this->contractid->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->contractid->AdvancedSearch->SearchOperator = @$_GET["z_contractid"];

		// rate
		$this->rate->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_rate"]);
		if ($this->rate->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->rate->AdvancedSearch->SearchOperator = @$_GET["z_rate"];
	}

	// Load recordset
	function LoadRecordset($offset = -1, $rowcnt = -1) {

		// Load List page SQL
		$sSql = $this->SelectSQL();
		$conn = &$this->Connection();

		// Load recordset
		$dbtype = ew_GetConnectionType($this->DBID);
		if ($this->UseSelectLimit) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			if ($dbtype == "MSSQL") {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset, array("_hasOrderBy" => trim($this->getOrderBy()) || trim($this->getSessionOrderByList())));
			} else {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset);
			}
			$conn->raiseErrorFn = '';
		} else {
			$rs = ew_LoadRecordset($sSql, $conn);
		}

		// Call Recordset Selected event
		$this->Recordset_Selected($rs);
		return $rs;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey_client->setDbValue($rs->fields('dbkey_client'));
		if (array_key_exists('EV__dbkey_client', $rs->fields)) {
			$this->dbkey_client->VirtualValue = $rs->fields('EV__dbkey_client'); // Set up virtual field value
		} else {
			$this->dbkey_client->VirtualValue = ""; // Clear value
		}
		$this->Client_Name->setDbValue($rs->fields('Client_Name'));
		$this->Activity_Code->setDbValue($rs->fields('Activity_Code'));
		$this->dbkey_activity->setDbValue($rs->fields('dbkey_activity'));
		$this->budget->setDbValue($rs->fields('budget'));
		$this->from->setDbValue($rs->fields('from'));
		$this->through->setDbValue($rs->fields('through'));
		$this->contractid->setDbValue($rs->fields('contractid'));
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->rate->setDbValue($rs->fields('rate'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey_client->DbValue = $row['dbkey_client'];
		$this->Client_Name->DbValue = $row['Client_Name'];
		$this->Activity_Code->DbValue = $row['Activity_Code'];
		$this->dbkey_activity->DbValue = $row['dbkey_activity'];
		$this->budget->DbValue = $row['budget'];
		$this->from->DbValue = $row['from'];
		$this->through->DbValue = $row['through'];
		$this->contractid->DbValue = $row['contractid'];
		$this->dbkey->DbValue = $row['dbkey'];
		$this->rate->DbValue = $row['rate'];
	}

	// Load old record
	function LoadOldRecord() {

		// Load key values from Session
		$bValidKey = TRUE;
		if (strval($this->getKey("dbkey")) <> "")
			$this->dbkey->CurrentValue = $this->getKey("dbkey"); // dbkey
		else
			$bValidKey = FALSE;

		// Load old recordset
		if ($bValidKey) {
			$this->CurrentFilter = $this->KeyFilter();
			$sSql = $this->SQL();
			$conn = &$this->Connection();
			$this->OldRecordset = ew_LoadRecordset($sSql, $conn);
			$this->LoadRowValues($this->OldRecordset); // Load row values
		} else {
			$this->OldRecordset = NULL;
		}
		return $bValidKey;
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		$this->ViewUrl = $this->GetViewUrl();
		$this->EditUrl = $this->GetEditUrl();
		$this->InlineEditUrl = $this->GetInlineEditUrl();
		$this->CopyUrl = $this->GetCopyUrl();
		$this->InlineCopyUrl = $this->GetInlineCopyUrl();
		$this->DeleteUrl = $this->GetDeleteUrl();

		// Convert decimal values if posted back
		if ($this->budget->FormValue == $this->budget->CurrentValue && is_numeric(ew_StrToFloat($this->budget->CurrentValue)))
			$this->budget->CurrentValue = ew_StrToFloat($this->budget->CurrentValue);

		// Convert decimal values if posted back
		if ($this->rate->FormValue == $this->rate->CurrentValue && is_numeric(ew_StrToFloat($this->rate->CurrentValue)))
			$this->rate->CurrentValue = ew_StrToFloat($this->rate->CurrentValue);

		// Call Row_Rendering event
		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey_client

		$this->dbkey_client->CellCssStyle = "white-space: nowrap;";

		// Client_Name
		// Activity_Code
		// dbkey_activity
		// budget

		$this->budget->CellCssStyle = "white-space: nowrap;";

		// from
		// through
		// contractid
		// dbkey

		$this->dbkey->CellCssStyle = "white-space: nowrap;";

		// rate
		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// dbkey_client
		if ($this->dbkey_client->VirtualValue <> "") {
			$this->dbkey_client->ViewValue = $this->dbkey_client->VirtualValue;
		} else {
		if (strval($this->dbkey_client->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		$this->dbkey_client->LookupFilters = array();
		$lookuptblfilter = "`active` = 1 and `dbkey` in(select dbkey_client from client_to_activity_code where client.`dbkey` = dbkey_client)";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_client->ViewValue = $this->dbkey_client->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_client->ViewValue = $this->dbkey_client->CurrentValue;
			}
		} else {
			$this->dbkey_client->ViewValue = NULL;
		}
		}
		$this->dbkey_client->ViewCustomAttributes = "";

		// Client_Name
		if (strval($this->Client_Name->CurrentValue) <> "") {
			$sFilterWrk = "(select concat(concat(last,' , '),first) from client where client.dbkey = client_budget.dbkey_client)" . ew_SearchString("=", $this->Client_Name->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT (select concat(concat(last,' , '),first) from client where client.dbkey = client_budget.dbkey_client), (select concat(concat(last,' , '),first) from client where client.dbkey = client_budget.dbkey_client) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client_budget`";
		$sWhereWrk = "";
		$this->Client_Name->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->Client_Name, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `Client_Name`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->Client_Name->ViewValue = $this->Client_Name->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->Client_Name->ViewValue = $this->Client_Name->CurrentValue;
			}
		} else {
			$this->Client_Name->ViewValue = NULL;
		}
		$this->Client_Name->ViewCustomAttributes = "";

		// Activity_Code
		$this->Activity_Code->ViewValue = $this->Activity_Code->CurrentValue;
		$this->Activity_Code->ViewCustomAttributes = "";

		// budget
		$this->budget->ViewValue = $this->budget->CurrentValue;
		$this->budget->ViewCustomAttributes = "";

		// from
		$this->from->ViewValue = $this->from->CurrentValue;
		$this->from->ViewValue = ew_FormatDateTime($this->from->ViewValue, 0);
		$this->from->ViewCustomAttributes = "";

		// through
		$this->through->ViewValue = $this->through->CurrentValue;
		$this->through->ViewValue = ew_FormatDateTime($this->through->ViewValue, 0);
		$this->through->ViewCustomAttributes = "";

		// contractid
		$this->contractid->ViewValue = $this->contractid->CurrentValue;
		$this->contractid->ViewValue = ew_FormatNumber($this->contractid->ViewValue, 0, 0, 0, 0);
		$this->contractid->ViewCustomAttributes = "";

		// rate
		$this->rate->ViewValue = $this->rate->CurrentValue;
		$this->rate->ViewValue = ew_FormatNumber($this->rate->ViewValue, 3, -2, -2, -2);
		$this->rate->ViewCustomAttributes = "";

			// dbkey_client
			$this->dbkey_client->LinkCustomAttributes = "";
			$this->dbkey_client->HrefValue = "";
			$this->dbkey_client->TooltipValue = "";

			// Client_Name
			$this->Client_Name->LinkCustomAttributes = "";
			$this->Client_Name->HrefValue = "";
			$this->Client_Name->TooltipValue = "";

			// Activity_Code
			$this->Activity_Code->LinkCustomAttributes = "";
			$this->Activity_Code->HrefValue = "";
			$this->Activity_Code->TooltipValue = "";
			if ($this->Export == "")
				$this->Activity_Code->ViewValue = ew_Highlight($this->HighlightName(), $this->Activity_Code->ViewValue, "", "", $this->Activity_Code->AdvancedSearch->getValue("x"), "");

			// budget
			$this->budget->LinkCustomAttributes = "";
			$this->budget->HrefValue = "";
			$this->budget->TooltipValue = "";

			// from
			$this->from->LinkCustomAttributes = "";
			$this->from->HrefValue = "";
			$this->from->TooltipValue = "";

			// through
			$this->through->LinkCustomAttributes = "";
			$this->through->HrefValue = "";
			$this->through->TooltipValue = "";

			// contractid
			$this->contractid->LinkCustomAttributes = "";
			$this->contractid->HrefValue = "";
			$this->contractid->TooltipValue = "";

			// rate
			$this->rate->LinkCustomAttributes = "";
			$this->rate->HrefValue = "";
			$this->rate->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_SEARCH) { // Search row

			// dbkey_client
			$this->dbkey_client->EditAttrs["class"] = "form-control";
			$this->dbkey_client->EditCustomAttributes = "";
			if (trim(strval($this->dbkey_client->AdvancedSearch->SearchValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->AdvancedSearch->SearchValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `client`";
			$sWhereWrk = "";
			$this->dbkey_client->LookupFilters = array();
			$lookuptblfilter = "`active` = 1 and `dbkey` in(select dbkey_client from client_to_activity_code where client.`dbkey` = dbkey_client)";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->dbkey_client->EditValue = $arwrk;

			// Client_Name
			$this->Client_Name->EditAttrs["class"] = "form-control";
			$this->Client_Name->EditCustomAttributes = "";

			// Activity_Code
			$this->Activity_Code->EditAttrs["class"] = "form-control";
			$this->Activity_Code->EditCustomAttributes = "";
			$this->Activity_Code->EditValue = ew_HtmlEncode($this->Activity_Code->AdvancedSearch->SearchValue);
			$this->Activity_Code->PlaceHolder = ew_RemoveHtml($this->Activity_Code->FldCaption());

			// budget
			$this->budget->EditAttrs["class"] = "form-control";
			$this->budget->EditCustomAttributes = "";
			$this->budget->EditValue = ew_HtmlEncode($this->budget->AdvancedSearch->SearchValue);
			$this->budget->PlaceHolder = ew_RemoveHtml($this->budget->FldCaption());

			// from
			$this->from->EditAttrs["class"] = "form-control";
			$this->from->EditCustomAttributes = "";
			$this->from->EditValue = ew_HtmlEncode(ew_FormatDateTime(ew_UnFormatDateTime($this->from->AdvancedSearch->SearchValue, 0), 8));
			$this->from->PlaceHolder = ew_RemoveHtml($this->from->FldCaption());

			// through
			$this->through->EditAttrs["class"] = "form-control";
			$this->through->EditCustomAttributes = "";
			$this->through->EditValue = ew_HtmlEncode(ew_FormatDateTime(ew_UnFormatDateTime($this->through->AdvancedSearch->SearchValue, 0), 8));
			$this->through->PlaceHolder = ew_RemoveHtml($this->through->FldCaption());

			// contractid
			$this->contractid->EditAttrs["class"] = "form-control";
			$this->contractid->EditCustomAttributes = "";
			$this->contractid->EditValue = ew_HtmlEncode($this->contractid->AdvancedSearch->SearchValue);
			$this->contractid->PlaceHolder = ew_RemoveHtml($this->contractid->FldCaption());

			// rate
			$this->rate->EditAttrs["class"] = "form-control";
			$this->rate->EditCustomAttributes = "";
			$this->rate->EditValue = ew_HtmlEncode($this->rate->AdvancedSearch->SearchValue);
			$this->rate->PlaceHolder = ew_RemoveHtml($this->rate->FldCaption());
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate search
	function ValidateSearch() {
		global $gsSearchError;

		// Initialize
		$gsSearchError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return TRUE;
		if (!ew_CheckDateDef($this->from->AdvancedSearch->SearchValue)) {
			ew_AddMessage($gsSearchError, $this->from->FldErrMsg());
		}
		if (!ew_CheckDateDef($this->through->AdvancedSearch->SearchValue)) {
			ew_AddMessage($gsSearchError, $this->through->FldErrMsg());
		}

		// Return validate result
		$ValidateSearch = ($gsSearchError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateSearch = $ValidateSearch && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsSearchError, $sFormCustomError);
		}
		return $ValidateSearch;
	}

	// Load advanced search
	function LoadAdvancedSearch() {
		$this->dbkey_client->AdvancedSearch->Load();
		$this->Client_Name->AdvancedSearch->Load();
		$this->Activity_Code->AdvancedSearch->Load();
		$this->dbkey_activity->AdvancedSearch->Load();
		$this->from->AdvancedSearch->Load();
		$this->through->AdvancedSearch->Load();
		$this->contractid->AdvancedSearch->Load();
		$this->rate->AdvancedSearch->Load();
	}

	// Set up export options
	function SetupExportOptions() {
		global $Language;

		// Printer friendly
		$item = &$this->ExportOptions->Add("print");
		$item->Body = "<a href=\"" . $this->ExportPrintUrl . "\" class=\"ewExportLink ewPrint\" title=\"" . ew_HtmlEncode($Language->Phrase("PrinterFriendlyText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("PrinterFriendlyText")) . "\">" . $Language->Phrase("PrinterFriendly") . "</a>";
		$item->Visible = TRUE;

		// Export to Excel
		$item = &$this->ExportOptions->Add("excel");
		$item->Body = "<a href=\"" . $this->ExportExcelUrl . "\" class=\"ewExportLink ewExcel\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToExcelText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToExcelText")) . "\">" . $Language->Phrase("ExportToExcel") . "</a>";
		$item->Visible = TRUE;

		// Export to Word
		$item = &$this->ExportOptions->Add("word");
		$item->Body = "<a href=\"" . $this->ExportWordUrl . "\" class=\"ewExportLink ewWord\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToWordText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToWordText")) . "\">" . $Language->Phrase("ExportToWord") . "</a>";
		$item->Visible = TRUE;

		// Export to Html
		$item = &$this->ExportOptions->Add("html");
		$item->Body = "<a href=\"" . $this->ExportHtmlUrl . "\" class=\"ewExportLink ewHtml\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToHtmlText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToHtmlText")) . "\">" . $Language->Phrase("ExportToHtml") . "</a>";
		$item->Visible = TRUE;

		// Export to Xml
		$item = &$this->ExportOptions->Add("xml");
		$item->Body = "<a href=\"" . $this->ExportXmlUrl . "\" class=\"ewExportLink ewXml\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToXmlText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToXmlText")) . "\">" . $Language->Phrase("ExportToXml") . "</a>";
		$item->Visible = FALSE;

		// Export to Csv
		$item = &$this->ExportOptions->Add("csv");
		$item->Body = "<a href=\"" . $this->ExportCsvUrl . "\" class=\"ewExportLink ewCsv\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToCsvText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToCsvText")) . "\">" . $Language->Phrase("ExportToCsv") . "</a>";
		$item->Visible = TRUE;

		// Export to Pdf
		$item = &$this->ExportOptions->Add("pdf");
		$item->Body = "<a href=\"" . $this->ExportPdfUrl . "\" class=\"ewExportLink ewPdf\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToPDFText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToPDFText")) . "\">" . $Language->Phrase("ExportToPDF") . "</a>";
		$item->Visible = FALSE;

		// Export to Email
		$item = &$this->ExportOptions->Add("email");
		$url = "";
		$item->Body = "<button id=\"emf_client_budget\" class=\"ewExportLink ewEmail\" title=\"" . $Language->Phrase("ExportToEmailText") . "\" data-caption=\"" . $Language->Phrase("ExportToEmailText") . "\" onclick=\"ew_EmailDialogShow({lnk:'emf_client_budget',hdr:ewLanguage.Phrase('ExportToEmailText'),f:document.fclient_budgetlist,sel:false" . $url . "});\">" . $Language->Phrase("ExportToEmail") . "</button>";
		$item->Visible = TRUE;

		// Drop down button for export
		$this->ExportOptions->UseButtonGroup = TRUE;
		$this->ExportOptions->UseImageAndText = TRUE;
		$this->ExportOptions->UseDropDownButton = FALSE;
		if ($this->ExportOptions->UseButtonGroup && ew_IsMobile())
			$this->ExportOptions->UseDropDownButton = TRUE;
		$this->ExportOptions->DropDownButtonPhrase = $Language->Phrase("ButtonExport");

		// Add group option item
		$item = &$this->ExportOptions->Add($this->ExportOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;
	}

	// Export data in HTML/CSV/Word/Excel/XML/Email/PDF format
	function ExportData() {
		$utf8 = (strtolower(EW_CHARSET) == "utf-8");
		$bSelectLimit = $this->UseSelectLimit;

		// Load recordset
		if ($bSelectLimit) {
			$this->TotalRecs = $this->SelectRecordCount();
		} else {
			if (!$this->Recordset)
				$this->Recordset = $this->LoadRecordset();
			$rs = &$this->Recordset;
			if ($rs)
				$this->TotalRecs = $rs->RecordCount();
		}
		$this->StartRec = 1;

		// Export all
		if ($this->ExportAll) {
			set_time_limit(EW_EXPORT_ALL_TIME_LIMIT);
			$this->DisplayRecs = $this->TotalRecs;
			$this->StopRec = $this->TotalRecs;
		} else { // Export one page only
			$this->SetUpStartRec(); // Set up start record position

			// Set the last record to display
			if ($this->DisplayRecs <= 0) {
				$this->StopRec = $this->TotalRecs;
			} else {
				$this->StopRec = $this->StartRec + $this->DisplayRecs - 1;
			}
		}
		if ($bSelectLimit)
			$rs = $this->LoadRecordset($this->StartRec-1, $this->DisplayRecs <= 0 ? $this->TotalRecs : $this->DisplayRecs);
		if (!$rs) {
			header("Content-Type:"); // Remove header
			header("Content-Disposition:");
			$this->ShowMessage();
			return;
		}
		$this->ExportDoc = ew_ExportDocument($this, "h");
		$Doc = &$this->ExportDoc;
		if ($bSelectLimit) {
			$this->StartRec = 1;
			$this->StopRec = $this->DisplayRecs <= 0 ? $this->TotalRecs : $this->DisplayRecs;
		} else {

			//$this->StartRec = $this->StartRec;
			//$this->StopRec = $this->StopRec;

		}

		// Call Page Exporting server event
		$this->ExportDoc->ExportCustom = !$this->Page_Exporting();
		$ParentTable = "";

		// Export master record
		if (EW_EXPORT_MASTER_RECORD && $this->GetMasterFilter() <> "" && $this->getCurrentMasterTable() == "activity") {
			global $activity;
			if (!isset($activity)) $activity = new cactivity;
			$rsmaster = $activity->LoadRs($this->DbMasterFilter); // Load master record
			if ($rsmaster && !$rsmaster->EOF) {
				$ExportStyle = $Doc->Style;
				$Doc->SetStyle("v"); // Change to vertical
				if ($this->Export <> "csv" || EW_EXPORT_MASTER_RECORD_FOR_CSV) {
					$Doc->Table = &$activity;
					$activity->ExportDocument($Doc, $rsmaster, 1, 1);
					$Doc->ExportEmptyRow();
					$Doc->Table = &$this;
				}
				$Doc->SetStyle($ExportStyle); // Restore
				$rsmaster->Close();
			}
		}

		// Export master record
		if (EW_EXPORT_MASTER_RECORD && $this->GetMasterFilter() <> "" && $this->getCurrentMasterTable() == "client") {
			global $client;
			if (!isset($client)) $client = new cclient;
			$rsmaster = $client->LoadRs($this->DbMasterFilter); // Load master record
			if ($rsmaster && !$rsmaster->EOF) {
				$ExportStyle = $Doc->Style;
				$Doc->SetStyle("v"); // Change to vertical
				if ($this->Export <> "csv" || EW_EXPORT_MASTER_RECORD_FOR_CSV) {
					$Doc->Table = &$client;
					$client->ExportDocument($Doc, $rsmaster, 1, 1);
					$Doc->ExportEmptyRow();
					$Doc->Table = &$this;
				}
				$Doc->SetStyle($ExportStyle); // Restore
				$rsmaster->Close();
			}
		}
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		$Doc->Text .= $sHeader;
		$this->ExportDocument($Doc, $rs, $this->StartRec, $this->StopRec, "");
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		$Doc->Text .= $sFooter;

		// Close recordset
		$rs->Close();

		// Call Page Exported server event
		$this->Page_Exported();

		// Export header and footer
		$Doc->ExportHeaderAndFooter();

		// Clean output buffer
		if (!EW_DEBUG_ENABLED && ob_get_length())
			ob_end_clean();

		// Write debug message if enabled
		if (EW_DEBUG_ENABLED && $this->Export <> "pdf")
			echo ew_DebugMsg();

		// Output data
		if ($this->Export == "email") {
			echo $this->ExportEmail($Doc->Text);
		} else {
			$Doc->Export();
		}
	}

	// Export email
	function ExportEmail($EmailContent) {
		global $gTmpImages, $Language;
		$sSender = @$_POST["sender"];
		$sRecipient = @$_POST["recipient"];
		$sCc = @$_POST["cc"];
		$sBcc = @$_POST["bcc"];
		$sContentType = @$_POST["contenttype"];

		// Subject
		$sSubject = ew_StripSlashes(@$_POST["subject"]);
		$sEmailSubject = $sSubject;

		// Message
		$sContent = ew_StripSlashes(@$_POST["message"]);
		$sEmailMessage = $sContent;

		// Check sender
		if ($sSender == "") {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterSenderEmail") . "</p>";
		}
		if (!ew_CheckEmail($sSender)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperSenderEmail") . "</p>";
		}

		// Check recipient
		if (!ew_CheckEmailList($sRecipient, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperRecipientEmail") . "</p>";
		}

		// Check cc
		if (!ew_CheckEmailList($sCc, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperCcEmail") . "</p>";
		}

		// Check bcc
		if (!ew_CheckEmailList($sBcc, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperBccEmail") . "</p>";
		}

		// Check email sent count
		if (!isset($_SESSION[EW_EXPORT_EMAIL_COUNTER]))
			$_SESSION[EW_EXPORT_EMAIL_COUNTER] = 0;
		if (intval($_SESSION[EW_EXPORT_EMAIL_COUNTER]) > EW_MAX_EMAIL_SENT_COUNT) {
			return "<p class=\"text-danger\">" . $Language->Phrase("ExceedMaxEmailExport") . "</p>";
		}

		// Send email
		$Email = new cEmail();
		$Email->Sender = $sSender; // Sender
		$Email->Recipient = $sRecipient; // Recipient
		$Email->Cc = $sCc; // Cc
		$Email->Bcc = $sBcc; // Bcc
		$Email->Subject = $sEmailSubject; // Subject
		$Email->Format = ($sContentType == "url") ? "text" : "html";
		if ($sEmailMessage <> "") {
			$sEmailMessage = ew_RemoveXSS($sEmailMessage);
			$sEmailMessage .= ($sContentType == "url") ? "\r\n\r\n" : "<br><br>";
		}
		if ($sContentType == "url") {
			$sUrl = ew_ConvertFullUrl(ew_CurrentPage() . "?" . $this->ExportQueryString());
			$sEmailMessage .= $sUrl; // Send URL only
		} else {
			foreach ($gTmpImages as $tmpimage)
				$Email->AddEmbeddedImage($tmpimage);
			$sEmailMessage .= ew_CleanEmailContent($EmailContent); // Send HTML
		}
		$Email->Content = $sEmailMessage; // Content
		$EventArgs = array();
		if ($this->Recordset) {
			$this->RecCnt = $this->StartRec - 1;
			$this->Recordset->MoveFirst();
			if ($this->StartRec > 1)
				$this->Recordset->Move($this->StartRec - 1);
			$EventArgs["rs"] = &$this->Recordset;
		}
		$bEmailSent = FALSE;
		if ($this->Email_Sending($Email, $EventArgs))
			$bEmailSent = $Email->Send();

		// Check email sent status
		if ($bEmailSent) {

			// Update email sent count
			$_SESSION[EW_EXPORT_EMAIL_COUNTER]++;

			// Sent email success
			return "<p class=\"text-success\">" . $Language->Phrase("SendEmailSuccess") . "</p>"; // Set up success message
		} else {

			// Sent email failure
			return "<p class=\"text-danger\">" . $Email->SendErrDescription . "</p>";
		}
	}

	// Export QueryString
	function ExportQueryString() {

		// Initialize
		$sQry = "export=html";

		// Build QueryString for search
		$this->AddSearchQueryString($sQry, $this->dbkey_client); // dbkey_client
		$this->AddSearchQueryString($sQry, $this->Client_Name); // Client_Name
		$this->AddSearchQueryString($sQry, $this->Activity_Code); // Activity_Code
		$this->AddSearchQueryString($sQry, $this->dbkey_activity); // dbkey_activity
		$this->AddSearchQueryString($sQry, $this->from); // from
		$this->AddSearchQueryString($sQry, $this->through); // through
		$this->AddSearchQueryString($sQry, $this->contractid); // contractid
		$this->AddSearchQueryString($sQry, $this->rate); // rate

		// Build QueryString for pager
		$sQry .= "&" . EW_TABLE_REC_PER_PAGE . "=" . urlencode($this->getRecordsPerPage()) . "&" . EW_TABLE_START_REC . "=" . urlencode($this->getStartRecordNumber());
		return $sQry;
	}

	// Add search QueryString
	function AddSearchQueryString(&$Qry, &$Fld) {
		$FldSearchValue = $Fld->AdvancedSearch->getValue("x");
		$FldParm = substr($Fld->FldVar,2);
		if (strval($FldSearchValue) <> "") {
			$Qry .= "&x_" . $FldParm . "=" . urlencode($FldSearchValue) .
				"&z_" . $FldParm . "=" . urlencode($Fld->AdvancedSearch->getValue("z"));
		}
		$FldSearchValue2 = $Fld->AdvancedSearch->getValue("y");
		if (strval($FldSearchValue2) <> "") {
			$Qry .= "&v_" . $FldParm . "=" . urlencode($Fld->AdvancedSearch->getValue("v")) .
				"&y_" . $FldParm . "=" . urlencode($FldSearchValue2) .
				"&w_" . $FldParm . "=" . urlencode($Fld->AdvancedSearch->getValue("w"));
		}
	}

	// Set up master/detail based on QueryString
	function SetUpMasterParms() {
		$bValidMaster = FALSE;

		// Get the keys for master table
		if (isset($_GET[EW_TABLE_SHOW_MASTER])) {
			$sMasterTblVar = $_GET[EW_TABLE_SHOW_MASTER];
			if ($sMasterTblVar == "") {
				$bValidMaster = TRUE;
				$this->DbMasterFilter = "";
				$this->DbDetailFilter = "";
			}
			if ($sMasterTblVar == "activity") {
				$bValidMaster = TRUE;
				if (@$_GET["fk_dbkey"] <> "") {
					$GLOBALS["activity"]->dbkey->setQueryStringValue($_GET["fk_dbkey"]);
					$this->Activity_Code->setQueryStringValue($GLOBALS["activity"]->dbkey->QueryStringValue);
					$this->Activity_Code->setSessionValue($this->Activity_Code->QueryStringValue);
					if (!is_numeric($GLOBALS["activity"]->dbkey->QueryStringValue)) $bValidMaster = FALSE;
				} else {
					$bValidMaster = FALSE;
				}
			}
			if ($sMasterTblVar == "client") {
				$bValidMaster = TRUE;
				if (@$_GET["fk_dbkey"] <> "") {
					$GLOBALS["client"]->dbkey->setQueryStringValue($_GET["fk_dbkey"]);
					$this->dbkey_client->setQueryStringValue($GLOBALS["client"]->dbkey->QueryStringValue);
					$this->dbkey_client->setSessionValue($this->dbkey_client->QueryStringValue);
					if (!is_numeric($GLOBALS["client"]->dbkey->QueryStringValue)) $bValidMaster = FALSE;
				} else {
					$bValidMaster = FALSE;
				}
			}
		} elseif (isset($_POST[EW_TABLE_SHOW_MASTER])) {
			$sMasterTblVar = $_POST[EW_TABLE_SHOW_MASTER];
			if ($sMasterTblVar == "") {
				$bValidMaster = TRUE;
				$this->DbMasterFilter = "";
				$this->DbDetailFilter = "";
			}
			if ($sMasterTblVar == "activity") {
				$bValidMaster = TRUE;
				if (@$_POST["fk_dbkey"] <> "") {
					$GLOBALS["activity"]->dbkey->setFormValue($_POST["fk_dbkey"]);
					$this->Activity_Code->setFormValue($GLOBALS["activity"]->dbkey->FormValue);
					$this->Activity_Code->setSessionValue($this->Activity_Code->FormValue);
					if (!is_numeric($GLOBALS["activity"]->dbkey->FormValue)) $bValidMaster = FALSE;
				} else {
					$bValidMaster = FALSE;
				}
			}
			if ($sMasterTblVar == "client") {
				$bValidMaster = TRUE;
				if (@$_POST["fk_dbkey"] <> "") {
					$GLOBALS["client"]->dbkey->setFormValue($_POST["fk_dbkey"]);
					$this->dbkey_client->setFormValue($GLOBALS["client"]->dbkey->FormValue);
					$this->dbkey_client->setSessionValue($this->dbkey_client->FormValue);
					if (!is_numeric($GLOBALS["client"]->dbkey->FormValue)) $bValidMaster = FALSE;
				} else {
					$bValidMaster = FALSE;
				}
			}
		}
		if ($bValidMaster) {

			// Update URL
			$this->AddUrl = $this->AddMasterUrl($this->AddUrl);
			$this->InlineAddUrl = $this->AddMasterUrl($this->InlineAddUrl);
			$this->GridAddUrl = $this->AddMasterUrl($this->GridAddUrl);
			$this->GridEditUrl = $this->AddMasterUrl($this->GridEditUrl);

			// Save current master table
			$this->setCurrentMasterTable($sMasterTblVar);

			// Reset start record counter (new master key)
			$this->StartRec = 1;
			$this->setStartRecordNumber($this->StartRec);

			// Clear previous master key from Session
			if ($sMasterTblVar <> "activity") {
				if ($this->Activity_Code->CurrentValue == "") $this->Activity_Code->setSessionValue("");
			}
			if ($sMasterTblVar <> "client") {
				if ($this->dbkey_client->CurrentValue == "") $this->dbkey_client->setSessionValue("");
			}
		}
		$this->DbMasterFilter = $this->GetMasterFilter(); // Get master filter
		$this->DbDetailFilter = $this->GetDetailFilter(); // Get detail filter
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$url = preg_replace('/\?cmd=reset(all){0,1}$/i', '', $url); // Remove cmd=reset / cmd=resetall
		$Breadcrumb->Add("list", $this->TableVar, $url, "", $this->TableVar, TRUE);
	}

	// Setup lookup filters of a field
	function SetupLookupFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		if ($pageId == "list") {
			switch ($fld->FldVar) {
			}
		} elseif ($pageId == "extbs") {
			switch ($fld->FldVar) {
		case "x_dbkey_client":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT DISTINCT `dbkey` AS `LinkFld`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
			$sWhereWrk = "";
			$this->dbkey_client->LookupFilters = array();
			$lookuptblfilter = "`active` = 1 and `dbkey` in(select dbkey_client from client_to_activity_code where client.`dbkey` = dbkey_client)";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey` = {filter_value}', "t0" => "3", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last` ASC";
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
			}
		} 
	}

	// Setup AutoSuggest filters of a field
	function SetupAutoSuggestFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		if ($pageId == "list") {
			switch ($fld->FldVar) {
			}
		} elseif ($pageId == "extbs") {
			switch ($fld->FldVar) {
			}
		} 
	}

	// Write Audit Trail start/end for grid update
	function WriteAuditTrailDummy($typ) {
		$table = 'client_budget';
		$usr = CurrentUserID();
		ew_WriteAuditTrail("log", ew_StdCurrentDateTime(), ew_ScriptName(), $usr, $typ, $table, "", "", "", "");
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}

	// ListOptions Load event
	function ListOptions_Load() {

		// Example:
		//$opt = &$this->ListOptions->Add("new");
		//$opt->Header = "xxx";
		//$opt->OnLeft = TRUE; // Link on left
		//$opt->MoveTo(0); // Move to first column

	}

	// ListOptions Rendered event
	function ListOptions_Rendered() {

		// Example: 
		//$this->ListOptions->Items["new"]->Body = "xxx";

			if (CurrentPageID() == "list" and $other_page <> "gridadd")
		{
			$this->dbkey_client->Visible = FALSE;
		}
	}

	// Row Custom Action event
	function Row_CustomAction($action, $row) {

		// Return FALSE to abort
		return TRUE;
	}

	// Page Exporting event
	// $this->ExportDoc = export document object
	function Page_Exporting() {

		//$this->ExportDoc->Text = "my header"; // Export header
		//return FALSE; // Return FALSE to skip default export and use Row_Export event

		return TRUE; // Return TRUE to use default export and skip Row_Export event
	}

	// Row Export event
	// $this->ExportDoc = export document object
	function Row_Export($rs) {

		//$this->ExportDoc->Text .= "my content"; // Build HTML with field value: $rs["MyField"] or $this->MyField->ViewValue
	}

	// Page Exported event
	// $this->ExportDoc = export document object
	function Page_Exported() {

		//$this->ExportDoc->Text .= "my footer"; // Export footer
		//echo $this->ExportDoc->Text;

	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($client_budget_list)) $client_budget_list = new cclient_budget_list();

// Page init
$client_budget_list->Page_Init();

// Page main
$client_budget_list->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$client_budget_list->Page_Render();
?>
<?php include_once "header.php" ?>
<?php if ($client_budget->Export == "") { ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "list";
var CurrentForm = fclient_budgetlist = new ew_Form("fclient_budgetlist", "list");
fclient_budgetlist.FormKeyCountName = '<?php echo $client_budget_list->FormKeyCountName ?>';

// Form_CustomValidate event
fclient_budgetlist.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fclient_budgetlist.ValidateRequired = true;
<?php } else { ?>
fclient_budgetlist.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fclient_budgetlist.Lists["x_dbkey_client"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_last","x_first","",""],"ParentFields":[],"ChildFields":["x_dbkey_activity"],"FilterFields":[],"Options":[],"Template":"","LinkTable":"client"};
fclient_budgetlist.Lists["x_Client_Name"] = {"LinkField":"x_Client_Name","Ajax":true,"AutoFill":false,"DisplayFields":["x_Client_Name","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"client_budget"};

// Form object for search
var CurrentSearchForm = fclient_budgetlistsrch = new ew_Form("fclient_budgetlistsrch");

// Validate function for search
fclient_budgetlistsrch.Validate = function(fobj) {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	fobj = fobj || this.Form;
	var infix = "";
	elm = this.GetElements("x" + infix + "_from");
	if (elm && !ew_CheckDateDef(elm.value))
		return this.OnError(elm, "<?php echo ew_JsEncode2($client_budget->from->FldErrMsg()) ?>");
	elm = this.GetElements("x" + infix + "_through");
	if (elm && !ew_CheckDateDef(elm.value))
		return this.OnError(elm, "<?php echo ew_JsEncode2($client_budget->through->FldErrMsg()) ?>");

	// Fire Form_CustomValidate event
	if (!this.Form_CustomValidate(fobj))
		return false;
	return true;
}

// Form_CustomValidate event
fclient_budgetlistsrch.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fclient_budgetlistsrch.ValidateRequired = true; // Use JavaScript validation
<?php } else { ?>
fclient_budgetlistsrch.ValidateRequired = false; // No JavaScript validation
<?php } ?>

// Dynamic selection lists
fclient_budgetlistsrch.Lists["x_dbkey_client"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_last","x_first","",""],"ParentFields":[],"ChildFields":["x_dbkey_activity"],"FilterFields":[],"Options":[],"Template":"","LinkTable":"client"};
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php } ?>
<?php if ($client_budget->Export == "") { ?>
<div class="ewToolbar">
<?php if ($client_budget->Export == "") { ?>
<?php $Breadcrumb->Render(); ?>
<?php } ?>
<?php if ($client_budget_list->TotalRecs > 0 && $client_budget_list->ExportOptions->Visible()) { ?>
<?php $client_budget_list->ExportOptions->Render("body") ?>
<?php } ?>
<?php if ($client_budget_list->SearchOptions->Visible()) { ?>
<?php $client_budget_list->SearchOptions->Render("body") ?>
<?php } ?>
<?php if ($client_budget_list->FilterOptions->Visible()) { ?>
<?php $client_budget_list->FilterOptions->Render("body") ?>
<?php } ?>
<?php if ($client_budget->Export == "") { ?>
<?php echo $Language->SelectionForm(); ?>
<?php } ?>
<div class="clearfix"></div>
</div>
<?php } ?>
<?php if (($client_budget->Export == "") || (EW_EXPORT_MASTER_RECORD && $client_budget->Export == "print")) { ?>
<?php
if ($client_budget_list->DbMasterFilter <> "" && $client_budget->getCurrentMasterTable() == "activity") {
	if ($client_budget_list->MasterRecordExists) {
?>
<?php include_once "activitymaster.php" ?>
<?php
	}
}
?>
<?php
if ($client_budget_list->DbMasterFilter <> "" && $client_budget->getCurrentMasterTable() == "client") {
	if ($client_budget_list->MasterRecordExists) {
?>
<?php include_once "clientmaster.php" ?>
<?php
	}
}
?>
<?php } ?>
<?php
	$bSelectLimit = $client_budget_list->UseSelectLimit;
	if ($bSelectLimit) {
		if ($client_budget_list->TotalRecs <= 0)
			$client_budget_list->TotalRecs = $client_budget->SelectRecordCount();
	} else {
		if (!$client_budget_list->Recordset && ($client_budget_list->Recordset = $client_budget_list->LoadRecordset()))
			$client_budget_list->TotalRecs = $client_budget_list->Recordset->RecordCount();
	}
	$client_budget_list->StartRec = 1;
	if ($client_budget_list->DisplayRecs <= 0 || ($client_budget->Export <> "" && $client_budget->ExportAll)) // Display all records
		$client_budget_list->DisplayRecs = $client_budget_list->TotalRecs;
	if (!($client_budget->Export <> "" && $client_budget->ExportAll))
		$client_budget_list->SetUpStartRec(); // Set up start record position
	if ($bSelectLimit)
		$client_budget_list->Recordset = $client_budget_list->LoadRecordset($client_budget_list->StartRec-1, $client_budget_list->DisplayRecs);

	// Set no record found message
	if ($client_budget->CurrentAction == "" && $client_budget_list->TotalRecs == 0) {
		if (!$Security->CanList())
			$client_budget_list->setWarningMessage(ew_DeniedMsg());
		if ($client_budget_list->SearchWhere == "0=101")
			$client_budget_list->setWarningMessage($Language->Phrase("EnterSearchCriteria"));
		else
			$client_budget_list->setWarningMessage($Language->Phrase("NoRecord"));
	}

	// Audit trail on search
	if ($client_budget_list->AuditTrailOnSearch && $client_budget_list->Command == "search" && !$client_budget_list->RestoreSearch) {
		$searchparm = ew_ServerVar("QUERY_STRING");
		$searchsql = $client_budget_list->getSessionWhere();
		$client_budget_list->WriteAuditTrailOnSearch($searchparm, $searchsql);
	}
$client_budget_list->RenderOtherOptions();
?>
<?php if ($Security->CanSearch()) { ?>
<?php if ($client_budget->Export == "" && $client_budget->CurrentAction == "") { ?>
<form name="fclient_budgetlistsrch" id="fclient_budgetlistsrch" class="form-inline ewForm" action="<?php echo ew_CurrentPage() ?>">
<?php $SearchPanelClass = ($client_budget_list->SearchWhere <> "") ? " in" : " in"; ?>
<div id="fclient_budgetlistsrch_SearchPanel" class="ewSearchPanel collapse<?php echo $SearchPanelClass ?>">
<input type="hidden" name="cmd" value="search">
<input type="hidden" name="t" value="client_budget">
	<div class="ewBasicSearch">
<?php
if ($gsSearchError == "")
	$client_budget_list->LoadAdvancedSearch(); // Load advanced search

// Render for search
$client_budget->RowType = EW_ROWTYPE_SEARCH;

// Render row
$client_budget->ResetAttrs();
$client_budget_list->RenderRow();
?>
<div id="xsr_1" class="ewRow">
<?php if ($client_budget->dbkey_client->Visible) { // dbkey_client ?>
	<div id="xsc_dbkey_client" class="ewCell form-group">
		<label for="x_dbkey_client" class="ewSearchCaption ewLabel"><?php echo $client_budget->dbkey_client->FldCaption() ?></label>
		<span class="ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_dbkey_client" id="z_dbkey_client" value="="></span>
		<span class="ewSearchField">
<select data-table="client_budget" data-field="x_dbkey_client" data-value-separator="<?php echo $client_budget->dbkey_client->DisplayValueSeparatorAttribute() ?>" id="x_dbkey_client" name="x_dbkey_client"<?php echo $client_budget->dbkey_client->EditAttributes() ?>>
<?php echo $client_budget->dbkey_client->SelectOptionListHtml("x_dbkey_client") ?>
</select>
<input type="hidden" name="s_x_dbkey_client" id="s_x_dbkey_client" value="<?php echo $client_budget->dbkey_client->LookupFilterQuery(false, "extbs") ?>">
</span>
	</div>
<?php } ?>
</div>
<div id="xsr_2" class="ewRow">
<?php if ($client_budget->from->Visible) { // from ?>
	<div id="xsc_from" class="ewCell form-group">
		<label for="x_from" class="ewSearchCaption ewLabel"><?php echo $client_budget->from->FldCaption() ?></label>
		<span class="ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_from" id="z_from" value="="></span>
		<span class="ewSearchField">
<input type="text" data-table="client_budget" data-field="x_from" name="x_from" id="x_from" placeholder="<?php echo ew_HtmlEncode($client_budget->from->getPlaceHolder()) ?>" value="<?php echo $client_budget->from->EditValue ?>"<?php echo $client_budget->from->EditAttributes() ?>>
<?php if (!$client_budget->from->ReadOnly && !$client_budget->from->Disabled && !isset($client_budget->from->EditAttrs["readonly"]) && !isset($client_budget->from->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fclient_budgetlistsrch", "x_from", 0);
</script>
<?php } ?>
</span>
	</div>
<?php } ?>
</div>
<div id="xsr_3" class="ewRow">
<?php if ($client_budget->through->Visible) { // through ?>
	<div id="xsc_through" class="ewCell form-group">
		<label for="x_through" class="ewSearchCaption ewLabel"><?php echo $client_budget->through->FldCaption() ?></label>
		<span class="ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_through" id="z_through" value="="></span>
		<span class="ewSearchField">
<input type="text" data-table="client_budget" data-field="x_through" name="x_through" id="x_through" placeholder="<?php echo ew_HtmlEncode($client_budget->through->getPlaceHolder()) ?>" value="<?php echo $client_budget->through->EditValue ?>"<?php echo $client_budget->through->EditAttributes() ?>>
<?php if (!$client_budget->through->ReadOnly && !$client_budget->through->Disabled && !isset($client_budget->through->EditAttrs["readonly"]) && !isset($client_budget->through->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fclient_budgetlistsrch", "x_through", 0);
</script>
<?php } ?>
</span>
	</div>
<?php } ?>
</div>
<div id="xsr_4" class="ewRow">
<?php if ($client_budget->contractid->Visible) { // contractid ?>
	<div id="xsc_contractid" class="ewCell form-group">
		<label for="x_contractid" class="ewSearchCaption ewLabel"><?php echo $client_budget->contractid->FldCaption() ?></label>
		<span class="ewSearchOperator"><?php echo $Language->Phrase("LIKE") ?><input type="hidden" name="z_contractid" id="z_contractid" value="LIKE"></span>
		<span class="ewSearchField">
<input type="text" data-table="client_budget" data-field="x_contractid" name="x_contractid" id="x_contractid" size="30" maxlength="50" placeholder="<?php echo ew_HtmlEncode($client_budget->contractid->getPlaceHolder()) ?>" value="<?php echo $client_budget->contractid->EditValue ?>"<?php echo $client_budget->contractid->EditAttributes() ?>>
</span>
	</div>
<?php } ?>
</div>
<div id="xsr_5" class="ewRow">
	<button class="btn btn-primary ewButton" name="btnsubmit" id="btnsubmit" type="submit"><?php echo $Language->Phrase("QuickSearchBtn") ?></button>
</div>
	</div>
</div>
</form>
<?php } ?>
<?php } ?>
<?php $client_budget_list->ShowPageHeader(); ?>
<?php
$client_budget_list->ShowMessage();
?>
<?php if ($client_budget_list->TotalRecs > 0 || $client_budget->CurrentAction <> "") { ?>
<div class="panel panel-default ewGrid client_budget">
<?php if ($client_budget->Export == "") { ?>
<div class="panel-heading ewGridUpperPanel">
<?php if ($client_budget->CurrentAction <> "gridadd" && $client_budget->CurrentAction <> "gridedit") { ?>
<form name="ewPagerForm" class="form-inline ewForm ewPagerForm" action="<?php echo ew_CurrentPage() ?>">
<?php if (!isset($client_budget_list->Pager)) $client_budget_list->Pager = new cPrevNextPager($client_budget_list->StartRec, $client_budget_list->DisplayRecs, $client_budget_list->TotalRecs) ?>
<?php if ($client_budget_list->Pager->RecordCount > 0 && $client_budget_list->Pager->Visible) { ?>
<div class="ewPager">
<span><?php echo $Language->Phrase("Page") ?>&nbsp;</span>
<div class="ewPrevNext"><div class="input-group">
<div class="input-group-btn">
<!--first page button-->
	<?php if ($client_budget_list->Pager->FirstButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerFirst") ?>" href="<?php echo $client_budget_list->PageUrl() ?>start=<?php echo $client_budget_list->Pager->FirstButton->Start ?>"><span class="icon-first ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerFirst") ?>"><span class="icon-first ewIcon"></span></a>
	<?php } ?>
<!--previous page button-->
	<?php if ($client_budget_list->Pager->PrevButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerPrevious") ?>" href="<?php echo $client_budget_list->PageUrl() ?>start=<?php echo $client_budget_list->Pager->PrevButton->Start ?>"><span class="icon-prev ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerPrevious") ?>"><span class="icon-prev ewIcon"></span></a>
	<?php } ?>
</div>
<!--current page number-->
	<input class="form-control input-sm" type="text" name="<?php echo EW_TABLE_PAGE_NO ?>" value="<?php echo $client_budget_list->Pager->CurrentPage ?>">
<div class="input-group-btn">
<!--next page button-->
	<?php if ($client_budget_list->Pager->NextButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerNext") ?>" href="<?php echo $client_budget_list->PageUrl() ?>start=<?php echo $client_budget_list->Pager->NextButton->Start ?>"><span class="icon-next ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerNext") ?>"><span class="icon-next ewIcon"></span></a>
	<?php } ?>
<!--last page button-->
	<?php if ($client_budget_list->Pager->LastButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerLast") ?>" href="<?php echo $client_budget_list->PageUrl() ?>start=<?php echo $client_budget_list->Pager->LastButton->Start ?>"><span class="icon-last ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerLast") ?>"><span class="icon-last ewIcon"></span></a>
	<?php } ?>
</div>
</div>
</div>
<span>&nbsp;<?php echo $Language->Phrase("of") ?>&nbsp;<?php echo $client_budget_list->Pager->PageCount ?></span>
</div>
<div class="ewPager ewRec">
	<span><?php echo $Language->Phrase("Record") ?>&nbsp;<?php echo $client_budget_list->Pager->FromIndex ?>&nbsp;<?php echo $Language->Phrase("To") ?>&nbsp;<?php echo $client_budget_list->Pager->ToIndex ?>&nbsp;<?php echo $Language->Phrase("Of") ?>&nbsp;<?php echo $client_budget_list->Pager->RecordCount ?></span>
</div>
<?php } ?>
</form>
<?php } ?>
<div class="ewListOtherOptions">
<?php
	foreach ($client_budget_list->OtherOptions as &$option)
		$option->Render("body");
?>
</div>
<div class="clearfix"></div>
</div>
<?php } ?>
<form name="fclient_budgetlist" id="fclient_budgetlist" class="form-inline ewForm ewListForm" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($client_budget_list->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $client_budget_list->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="client_budget">
<?php if ($client_budget->getCurrentMasterTable() == "activity" && $client_budget->CurrentAction <> "") { ?>
<input type="hidden" name="<?php echo EW_TABLE_SHOW_MASTER ?>" value="activity">
<input type="hidden" name="fk_dbkey" value="<?php echo $client_budget->Activity_Code->getSessionValue() ?>">
<?php } ?>
<?php if ($client_budget->getCurrentMasterTable() == "client" && $client_budget->CurrentAction <> "") { ?>
<input type="hidden" name="<?php echo EW_TABLE_SHOW_MASTER ?>" value="client">
<input type="hidden" name="fk_dbkey" value="<?php echo $client_budget->dbkey_client->getSessionValue() ?>">
<?php } ?>
<div id="gmp_client_budget" class="<?php if (ew_IsResponsiveLayout()) { echo "table-responsive "; } ?>ewGridMiddlePanel">
<?php if ($client_budget_list->TotalRecs > 0 || $client_budget->CurrentAction == "gridedit") { ?>
<table id="tbl_client_budgetlist" class="table ewTable">
<?php echo $client_budget->TableCustomInnerHtml ?>
<thead><!-- Table header -->
	<tr class="ewTableHeader">
<?php

// Header row
$client_budget_list->RowType = EW_ROWTYPE_HEADER;

// Render list options
$client_budget_list->RenderListOptions();

// Render list options (header, left)
$client_budget_list->ListOptions->Render("header", "left");
?>
<?php if ($client_budget->dbkey_client->Visible) { // dbkey_client ?>
	<?php if ($client_budget->SortUrl($client_budget->dbkey_client) == "") { ?>
		<th data-name="dbkey_client"><div id="elh_client_budget_dbkey_client" class="client_budget_dbkey_client"><div class="ewTableHeaderCaption" style="white-space: nowrap;"><?php echo $client_budget->dbkey_client->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="dbkey_client"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $client_budget->SortUrl($client_budget->dbkey_client) ?>',1);"><div id="elh_client_budget_dbkey_client" class="client_budget_dbkey_client">
			<div class="ewTableHeaderBtn" style="white-space: nowrap;"><span class="ewTableHeaderCaption"><?php echo $client_budget->dbkey_client->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client_budget->dbkey_client->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client_budget->dbkey_client->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client_budget->Client_Name->Visible) { // Client_Name ?>
	<?php if ($client_budget->SortUrl($client_budget->Client_Name) == "") { ?>
		<th data-name="Client_Name"><div id="elh_client_budget_Client_Name" class="client_budget_Client_Name"><div class="ewTableHeaderCaption"><?php echo $client_budget->Client_Name->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Client_Name"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $client_budget->SortUrl($client_budget->Client_Name) ?>',1);"><div id="elh_client_budget_Client_Name" class="client_budget_Client_Name">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $client_budget->Client_Name->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client_budget->Client_Name->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client_budget->Client_Name->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client_budget->Activity_Code->Visible) { // Activity_Code ?>
	<?php if ($client_budget->SortUrl($client_budget->Activity_Code) == "") { ?>
		<th data-name="Activity_Code"><div id="elh_client_budget_Activity_Code" class="client_budget_Activity_Code"><div class="ewTableHeaderCaption"><?php echo $client_budget->Activity_Code->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Activity_Code"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $client_budget->SortUrl($client_budget->Activity_Code) ?>',1);"><div id="elh_client_budget_Activity_Code" class="client_budget_Activity_Code">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $client_budget->Activity_Code->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client_budget->Activity_Code->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client_budget->Activity_Code->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client_budget->budget->Visible) { // budget ?>
	<?php if ($client_budget->SortUrl($client_budget->budget) == "") { ?>
		<th data-name="budget"><div id="elh_client_budget_budget" class="client_budget_budget"><div class="ewTableHeaderCaption" style="white-space: nowrap;"><?php echo $client_budget->budget->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="budget"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $client_budget->SortUrl($client_budget->budget) ?>',1);"><div id="elh_client_budget_budget" class="client_budget_budget">
			<div class="ewTableHeaderBtn" style="white-space: nowrap;"><span class="ewTableHeaderCaption"><?php echo $client_budget->budget->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client_budget->budget->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client_budget->budget->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client_budget->from->Visible) { // from ?>
	<?php if ($client_budget->SortUrl($client_budget->from) == "") { ?>
		<th data-name="from"><div id="elh_client_budget_from" class="client_budget_from"><div class="ewTableHeaderCaption"><?php echo $client_budget->from->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="from"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $client_budget->SortUrl($client_budget->from) ?>',1);"><div id="elh_client_budget_from" class="client_budget_from">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $client_budget->from->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client_budget->from->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client_budget->from->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client_budget->through->Visible) { // through ?>
	<?php if ($client_budget->SortUrl($client_budget->through) == "") { ?>
		<th data-name="through"><div id="elh_client_budget_through" class="client_budget_through"><div class="ewTableHeaderCaption"><?php echo $client_budget->through->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="through"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $client_budget->SortUrl($client_budget->through) ?>',1);"><div id="elh_client_budget_through" class="client_budget_through">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $client_budget->through->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client_budget->through->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client_budget->through->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client_budget->contractid->Visible) { // contractid ?>
	<?php if ($client_budget->SortUrl($client_budget->contractid) == "") { ?>
		<th data-name="contractid"><div id="elh_client_budget_contractid" class="client_budget_contractid"><div class="ewTableHeaderCaption"><?php echo $client_budget->contractid->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="contractid"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $client_budget->SortUrl($client_budget->contractid) ?>',1);"><div id="elh_client_budget_contractid" class="client_budget_contractid">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $client_budget->contractid->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client_budget->contractid->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client_budget->contractid->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client_budget->rate->Visible) { // rate ?>
	<?php if ($client_budget->SortUrl($client_budget->rate) == "") { ?>
		<th data-name="rate"><div id="elh_client_budget_rate" class="client_budget_rate"><div class="ewTableHeaderCaption"><?php echo $client_budget->rate->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="rate"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $client_budget->SortUrl($client_budget->rate) ?>',1);"><div id="elh_client_budget_rate" class="client_budget_rate">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $client_budget->rate->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client_budget->rate->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client_budget->rate->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php

// Render list options (header, right)
$client_budget_list->ListOptions->Render("header", "right");
?>
	</tr>
</thead>
<tbody>
<?php
if ($client_budget->ExportAll && $client_budget->Export <> "") {
	$client_budget_list->StopRec = $client_budget_list->TotalRecs;
} else {

	// Set the last record to display
	if ($client_budget_list->TotalRecs > $client_budget_list->StartRec + $client_budget_list->DisplayRecs - 1)
		$client_budget_list->StopRec = $client_budget_list->StartRec + $client_budget_list->DisplayRecs - 1;
	else
		$client_budget_list->StopRec = $client_budget_list->TotalRecs;
}
$client_budget_list->RecCnt = $client_budget_list->StartRec - 1;
if ($client_budget_list->Recordset && !$client_budget_list->Recordset->EOF) {
	$client_budget_list->Recordset->MoveFirst();
	$bSelectLimit = $client_budget_list->UseSelectLimit;
	if (!$bSelectLimit && $client_budget_list->StartRec > 1)
		$client_budget_list->Recordset->Move($client_budget_list->StartRec - 1);
} elseif (!$client_budget->AllowAddDeleteRow && $client_budget_list->StopRec == 0) {
	$client_budget_list->StopRec = $client_budget->GridAddRowCount;
}

// Initialize aggregate
$client_budget->RowType = EW_ROWTYPE_AGGREGATEINIT;
$client_budget->ResetAttrs();
$client_budget_list->RenderRow();
while ($client_budget_list->RecCnt < $client_budget_list->StopRec) {
	$client_budget_list->RecCnt++;
	if (intval($client_budget_list->RecCnt) >= intval($client_budget_list->StartRec)) {
		$client_budget_list->RowCnt++;

		// Set up key count
		$client_budget_list->KeyCount = $client_budget_list->RowIndex;

		// Init row class and style
		$client_budget->ResetAttrs();
		$client_budget->CssClass = "";
		if ($client_budget->CurrentAction == "gridadd") {
		} else {
			$client_budget_list->LoadRowValues($client_budget_list->Recordset); // Load row values
		}
		$client_budget->RowType = EW_ROWTYPE_VIEW; // Render view

		// Set up row id / data-rowindex
		$client_budget->RowAttrs = array_merge($client_budget->RowAttrs, array('data-rowindex'=>$client_budget_list->RowCnt, 'id'=>'r' . $client_budget_list->RowCnt . '_client_budget', 'data-rowtype'=>$client_budget->RowType));

		// Render row
		$client_budget_list->RenderRow();

		// Render list options
		$client_budget_list->RenderListOptions();
?>
	<tr<?php echo $client_budget->RowAttributes() ?>>
<?php

// Render list options (body, left)
$client_budget_list->ListOptions->Render("body", "left", $client_budget_list->RowCnt);
?>
	<?php if ($client_budget->dbkey_client->Visible) { // dbkey_client ?>
		<td data-name="dbkey_client"<?php echo $client_budget->dbkey_client->CellAttributes() ?>>
<span id="el<?php echo $client_budget_list->RowCnt ?>_client_budget_dbkey_client" class="client_budget_dbkey_client">
<span<?php echo $client_budget->dbkey_client->ViewAttributes() ?>>
<?php echo $client_budget->dbkey_client->ListViewValue() ?></span>
</span>
<a id="<?php echo $client_budget_list->PageObjName . "_row_" . $client_budget_list->RowCnt ?>"></a></td>
	<?php } ?>
	<?php if ($client_budget->Client_Name->Visible) { // Client_Name ?>
		<td data-name="Client_Name"<?php echo $client_budget->Client_Name->CellAttributes() ?>>
<span id="el<?php echo $client_budget_list->RowCnt ?>_client_budget_Client_Name" class="client_budget_Client_Name">
<span<?php echo $client_budget->Client_Name->ViewAttributes() ?>>
<?php echo $client_budget->Client_Name->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($client_budget->Activity_Code->Visible) { // Activity_Code ?>
		<td data-name="Activity_Code"<?php echo $client_budget->Activity_Code->CellAttributes() ?>>
<span id="el<?php echo $client_budget_list->RowCnt ?>_client_budget_Activity_Code" class="client_budget_Activity_Code">
<span<?php echo $client_budget->Activity_Code->ViewAttributes() ?>>
<?php echo $client_budget->Activity_Code->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($client_budget->budget->Visible) { // budget ?>
		<td data-name="budget"<?php echo $client_budget->budget->CellAttributes() ?>>
<span id="el<?php echo $client_budget_list->RowCnt ?>_client_budget_budget" class="client_budget_budget">
<span<?php echo $client_budget->budget->ViewAttributes() ?>>
<?php echo $client_budget->budget->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($client_budget->from->Visible) { // from ?>
		<td data-name="from"<?php echo $client_budget->from->CellAttributes() ?>>
<span id="el<?php echo $client_budget_list->RowCnt ?>_client_budget_from" class="client_budget_from">
<span<?php echo $client_budget->from->ViewAttributes() ?>>
<?php echo $client_budget->from->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($client_budget->through->Visible) { // through ?>
		<td data-name="through"<?php echo $client_budget->through->CellAttributes() ?>>
<span id="el<?php echo $client_budget_list->RowCnt ?>_client_budget_through" class="client_budget_through">
<span<?php echo $client_budget->through->ViewAttributes() ?>>
<?php echo $client_budget->through->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($client_budget->contractid->Visible) { // contractid ?>
		<td data-name="contractid"<?php echo $client_budget->contractid->CellAttributes() ?>>
<span id="el<?php echo $client_budget_list->RowCnt ?>_client_budget_contractid" class="client_budget_contractid">
<span<?php echo $client_budget->contractid->ViewAttributes() ?>>
<?php echo $client_budget->contractid->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($client_budget->rate->Visible) { // rate ?>
		<td data-name="rate"<?php echo $client_budget->rate->CellAttributes() ?>>
<span id="el<?php echo $client_budget_list->RowCnt ?>_client_budget_rate" class="client_budget_rate">
<span<?php echo $client_budget->rate->ViewAttributes() ?>>
<?php echo $client_budget->rate->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
<?php

// Render list options (body, right)
$client_budget_list->ListOptions->Render("body", "right", $client_budget_list->RowCnt);
?>
	</tr>
<?php
	}
	if ($client_budget->CurrentAction <> "gridadd")
		$client_budget_list->Recordset->MoveNext();
}
?>
</tbody>
</table>
<?php } ?>
<?php if ($client_budget->CurrentAction == "") { ?>
<input type="hidden" name="a_list" id="a_list" value="">
<?php } ?>
</div>
</form>
<?php

// Close recordset
if ($client_budget_list->Recordset)
	$client_budget_list->Recordset->Close();
?>
</div>
<?php } ?>
<?php if ($client_budget_list->TotalRecs == 0 && $client_budget->CurrentAction == "") { // Show other options ?>
<div class="ewListOtherOptions">
<?php
	foreach ($client_budget_list->OtherOptions as &$option) {
		$option->ButtonClass = "";
		$option->Render("body", "");
	}
?>
</div>
<div class="clearfix"></div>
<?php } ?>
<?php if ($client_budget->Export == "") { ?>
<script type="text/javascript">
fclient_budgetlistsrch.FilterList = <?php echo $client_budget_list->GetFilterList() ?>;
fclient_budgetlistsrch.Init();
fclient_budgetlist.Init();
</script>
<?php } ?>
<?php
$client_budget_list->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<?php if ($client_budget->Export == "") { ?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php } ?>
<?php include_once "footer.php" ?>
<?php
$client_budget_list->Page_Terminate();
?>
