<?php
if (session_id() == "") session_start(); // Init session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg13.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql13.php") ?>
<?php include_once "phpfn13.php" ?>
<?php include_once "client_budgetinfo.php" ?>
<?php include_once "activityinfo.php" ?>
<?php include_once "clientinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn13.php" ?>
<?php

//
// Page class
//

$client_budget_search = NULL; // Initialize page object first

class cclient_budget_search extends cclient_budget {

	// Page ID
	var $PageID = 'search';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'client_budget';

	// Page object name
	var $PageObjName = 'client_budget_search';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}
	var $AuditTrailOnAdd = FALSE;
	var $AuditTrailOnEdit = FALSE;
	var $AuditTrailOnDelete = FALSE;
	var $AuditTrailOnView = FALSE;
	var $AuditTrailOnViewData = FALSE;
	var $AuditTrailOnSearch = FALSE;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (client_budget)
		if (!isset($GLOBALS["client_budget"]) || get_class($GLOBALS["client_budget"]) == "cclient_budget") {
			$GLOBALS["client_budget"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["client_budget"];
		}

		// Table object (activity)
		if (!isset($GLOBALS['activity'])) $GLOBALS['activity'] = new cactivity();

		// Table object (client)
		if (!isset($GLOBALS['client'])) $GLOBALS['client'] = new cclient();

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'search', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'client_budget', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	//
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanSearch()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("client_budgetlist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Create form object
		$objForm = new cFormObj();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action
		$this->dbkey_client->SetVisibility();
		$this->Client_Name->SetVisibility();
		$this->Activity_Code->SetVisibility();
		$this->dbkey_activity->SetVisibility();
		$this->from->SetVisibility();
		$this->through->SetVisibility();
		$this->contractid->SetVisibility();
		$this->rate->SetVisibility();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $client_budget;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($client_budget);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();

			// Handle modal response
			if ($this->IsModal) {
				$row = array();
				$row["url"] = $url;
				echo ew_ArrayToJson(array($row));
			} else {
				header("Location: " . $url);
			}
		}
		exit();
	}
	var $FormClassName = "form-horizontal ewForm ewSearchForm";
	var $IsModal = FALSE;
	var $SearchLabelClass = "col-sm-3 control-label ewLabel";
	var $SearchRightColumnClass = "col-sm-9";

	//
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsSearchError;
		global $gbSkipHeaderFooter;

		// Set up Breadcrumb
		$this->SetupBreadcrumb();

		// Check modal
		$this->IsModal = (@$_GET["modal"] == "1" || @$_POST["modal"] == "1");
		if ($this->IsModal)
			$gbSkipHeaderFooter = TRUE;
		if ($this->IsPageRequest()) { // Validate request

			// Get action
			$this->CurrentAction = $objForm->GetValue("a_search");
			switch ($this->CurrentAction) {
				case "S": // Get search criteria

					// Build search string for advanced search, remove blank field
					$this->LoadSearchValues(); // Get search values
					if ($this->ValidateSearch()) {
						$sSrchStr = $this->BuildAdvancedSearch();
					} else {
						$sSrchStr = "";
						$this->setFailureMessage($gsSearchError);
					}
					if ($sSrchStr <> "") {
						$sSrchStr = $this->UrlParm($sSrchStr);
						$sSrchStr = "client_budgetlist.php" . "?" . $sSrchStr;
						$this->Page_Terminate($sSrchStr); // Go to list page
					}
			}
		}

		// Restore search settings from Session
		if ($gsSearchError == "")
			$this->LoadAdvancedSearch();

		// Render row for search
		$this->RowType = EW_ROWTYPE_SEARCH;
		$this->ResetAttrs();
		$this->RenderRow();
	}

	// Build advanced search
	function BuildAdvancedSearch() {
		$sSrchUrl = "";
		$this->BuildSearchUrl($sSrchUrl, $this->dbkey_client); // dbkey_client
		$this->BuildSearchUrl($sSrchUrl, $this->Client_Name); // Client_Name
		$this->BuildSearchUrl($sSrchUrl, $this->Activity_Code); // Activity_Code
		$this->BuildSearchUrl($sSrchUrl, $this->dbkey_activity); // dbkey_activity
		$this->BuildSearchUrl($sSrchUrl, $this->from); // from
		$this->BuildSearchUrl($sSrchUrl, $this->through); // through
		$this->BuildSearchUrl($sSrchUrl, $this->contractid); // contractid
		$this->BuildSearchUrl($sSrchUrl, $this->rate); // rate
		if ($sSrchUrl <> "") $sSrchUrl .= "&";
		$sSrchUrl .= "cmd=search";
		return $sSrchUrl;
	}

	// Build search URL
	function BuildSearchUrl(&$Url, &$Fld, $OprOnly=FALSE) {
		global $objForm;
		$sWrk = "";
		$FldParm = substr($Fld->FldVar, 2);
		$FldVal = $objForm->GetValue("x_$FldParm");
		$FldOpr = $objForm->GetValue("z_$FldParm");
		$FldCond = $objForm->GetValue("v_$FldParm");
		$FldVal2 = $objForm->GetValue("y_$FldParm");
		$FldOpr2 = $objForm->GetValue("w_$FldParm");
		$FldVal = ew_StripSlashes($FldVal);
		if (is_array($FldVal)) $FldVal = implode(",", $FldVal);
		$FldVal2 = ew_StripSlashes($FldVal2);
		if (is_array($FldVal2)) $FldVal2 = implode(",", $FldVal2);
		$FldOpr = strtoupper(trim($FldOpr));
		$lFldDataType = ($Fld->FldIsVirtual) ? EW_DATATYPE_STRING : $Fld->FldDataType;
		if ($FldOpr == "BETWEEN") {
			$IsValidValue = ($lFldDataType <> EW_DATATYPE_NUMBER) ||
				($lFldDataType == EW_DATATYPE_NUMBER && $this->SearchValueIsNumeric($Fld, $FldVal) && $this->SearchValueIsNumeric($Fld, $FldVal2));
			if ($FldVal <> "" && $FldVal2 <> "" && $IsValidValue) {
				$sWrk = "x_" . $FldParm . "=" . urlencode($FldVal) .
					"&y_" . $FldParm . "=" . urlencode($FldVal2) .
					"&z_" . $FldParm . "=" . urlencode($FldOpr);
			}
		} else {
			$IsValidValue = ($lFldDataType <> EW_DATATYPE_NUMBER) ||
				($lFldDataType == EW_DATATYPE_NUMBER && $this->SearchValueIsNumeric($Fld, $FldVal));
			if ($FldVal <> "" && $IsValidValue && ew_IsValidOpr($FldOpr, $lFldDataType)) {
				$sWrk = "x_" . $FldParm . "=" . urlencode($FldVal) .
					"&z_" . $FldParm . "=" . urlencode($FldOpr);
			} elseif ($FldOpr == "IS NULL" || $FldOpr == "IS NOT NULL" || ($FldOpr <> "" && $OprOnly && ew_IsValidOpr($FldOpr, $lFldDataType))) {
				$sWrk = "z_" . $FldParm . "=" . urlencode($FldOpr);
			}
			$IsValidValue = ($lFldDataType <> EW_DATATYPE_NUMBER) ||
				($lFldDataType == EW_DATATYPE_NUMBER && $this->SearchValueIsNumeric($Fld, $FldVal2));
			if ($FldVal2 <> "" && $IsValidValue && ew_IsValidOpr($FldOpr2, $lFldDataType)) {
				if ($sWrk <> "") $sWrk .= "&v_" . $FldParm . "=" . urlencode($FldCond) . "&";
				$sWrk .= "y_" . $FldParm . "=" . urlencode($FldVal2) .
					"&w_" . $FldParm . "=" . urlencode($FldOpr2);
			} elseif ($FldOpr2 == "IS NULL" || $FldOpr2 == "IS NOT NULL" || ($FldOpr2 <> "" && $OprOnly && ew_IsValidOpr($FldOpr2, $lFldDataType))) {
				if ($sWrk <> "") $sWrk .= "&v_" . $FldParm . "=" . urlencode($FldCond) . "&";
				$sWrk .= "w_" . $FldParm . "=" . urlencode($FldOpr2);
			}
		}
		if ($sWrk <> "") {
			if ($Url <> "") $Url .= "&";
			$Url .= $sWrk;
		}
	}

	function SearchValueIsNumeric($Fld, $Value) {
		if (ew_IsFloatFormat($Fld->FldType)) $Value = ew_StrToFloat($Value);
		return is_numeric($Value);
	}

	// Load search values for validation
	function LoadSearchValues() {
		global $objForm;

		// Load search values
		// dbkey_client

		$this->dbkey_client->AdvancedSearch->SearchValue = ew_StripSlashes($objForm->GetValue("x_dbkey_client"));
		$this->dbkey_client->AdvancedSearch->SearchOperator = $objForm->GetValue("z_dbkey_client");

		// Client_Name
		$this->Client_Name->AdvancedSearch->SearchValue = ew_StripSlashes($objForm->GetValue("x_Client_Name"));
		$this->Client_Name->AdvancedSearch->SearchOperator = $objForm->GetValue("z_Client_Name");

		// Activity_Code
		$this->Activity_Code->AdvancedSearch->SearchValue = ew_StripSlashes($objForm->GetValue("x_Activity_Code"));
		$this->Activity_Code->AdvancedSearch->SearchOperator = $objForm->GetValue("z_Activity_Code");

		// dbkey_activity
		$this->dbkey_activity->AdvancedSearch->SearchValue = ew_StripSlashes($objForm->GetValue("x_dbkey_activity"));
		$this->dbkey_activity->AdvancedSearch->SearchOperator = $objForm->GetValue("z_dbkey_activity");

		// from
		$this->from->AdvancedSearch->SearchValue = ew_StripSlashes($objForm->GetValue("x_from"));
		$this->from->AdvancedSearch->SearchOperator = $objForm->GetValue("z_from");

		// through
		$this->through->AdvancedSearch->SearchValue = ew_StripSlashes($objForm->GetValue("x_through"));
		$this->through->AdvancedSearch->SearchOperator = $objForm->GetValue("z_through");

		// contractid
		$this->contractid->AdvancedSearch->SearchValue = ew_StripSlashes($objForm->GetValue("x_contractid"));
		$this->contractid->AdvancedSearch->SearchOperator = $objForm->GetValue("z_contractid");

		// rate
		$this->rate->AdvancedSearch->SearchValue = ew_StripSlashes($objForm->GetValue("x_rate"));
		$this->rate->AdvancedSearch->SearchOperator = $objForm->GetValue("z_rate");
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Convert decimal values if posted back

		if ($this->rate->FormValue == $this->rate->CurrentValue && is_numeric(ew_StrToFloat($this->rate->CurrentValue)))
			$this->rate->CurrentValue = ew_StrToFloat($this->rate->CurrentValue);

		// Call Row_Rendering event
		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey_client
		// Client_Name
		// Activity_Code
		// dbkey_activity
		// budget
		// from
		// through
		// contractid
		// dbkey
		// rate

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// dbkey_client
		if ($this->dbkey_client->VirtualValue <> "") {
			$this->dbkey_client->ViewValue = $this->dbkey_client->VirtualValue;
		} else {
		if (strval($this->dbkey_client->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		$this->dbkey_client->LookupFilters = array();
		$lookuptblfilter = "`active` = 1 and `dbkey` in(select dbkey_client from client_to_activity_code where client.`dbkey` = dbkey_client)";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_client->ViewValue = $this->dbkey_client->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_client->ViewValue = $this->dbkey_client->CurrentValue;
			}
		} else {
			$this->dbkey_client->ViewValue = NULL;
		}
		}
		$this->dbkey_client->ViewCustomAttributes = "";

		// Client_Name
		if (strval($this->Client_Name->CurrentValue) <> "") {
			$sFilterWrk = "(select concat(concat(last,' , '),first) from client where client.dbkey = client_budget.dbkey_client)" . ew_SearchString("=", $this->Client_Name->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT (select concat(concat(last,' , '),first) from client where client.dbkey = client_budget.dbkey_client), (select concat(concat(last,' , '),first) from client where client.dbkey = client_budget.dbkey_client) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client_budget`";
		$sWhereWrk = "";
		$this->Client_Name->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->Client_Name, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `Client_Name`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->Client_Name->ViewValue = $this->Client_Name->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->Client_Name->ViewValue = $this->Client_Name->CurrentValue;
			}
		} else {
			$this->Client_Name->ViewValue = NULL;
		}
		$this->Client_Name->ViewCustomAttributes = "";

		// Activity_Code
		$this->Activity_Code->ViewValue = $this->Activity_Code->CurrentValue;
		$this->Activity_Code->ViewCustomAttributes = "";

		// dbkey_activity
		if (strval($this->dbkey_activity->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey_activity`" . ew_SearchString("=", $this->dbkey_activity->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey_activity`, (select activity.description from activity where activity.dbkey = dbkey_activity) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client_to_activity_code`";
		$sWhereWrk = "";
		$this->dbkey_activity->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->CurrentValue;
			}
		} else {
			$this->dbkey_activity->ViewValue = NULL;
		}
		$this->dbkey_activity->ViewCustomAttributes = "";

		// budget
		$this->budget->ViewValue = $this->budget->CurrentValue;
		$this->budget->ViewCustomAttributes = "";

		// from
		$this->from->ViewValue = $this->from->CurrentValue;
		$this->from->ViewValue = ew_FormatDateTime($this->from->ViewValue, 0);
		$this->from->ViewCustomAttributes = "";

		// through
		$this->through->ViewValue = $this->through->CurrentValue;
		$this->through->ViewValue = ew_FormatDateTime($this->through->ViewValue, 0);
		$this->through->ViewCustomAttributes = "";

		// contractid
		$this->contractid->ViewValue = $this->contractid->CurrentValue;
		$this->contractid->ViewValue = ew_FormatNumber($this->contractid->ViewValue, 0, 0, 0, 0);
		$this->contractid->ViewCustomAttributes = "";

		// rate
		$this->rate->ViewValue = $this->rate->CurrentValue;
		$this->rate->ViewValue = ew_FormatNumber($this->rate->ViewValue, 3, -2, -2, -2);
		$this->rate->ViewCustomAttributes = "";

			// dbkey_client
			$this->dbkey_client->LinkCustomAttributes = "";
			$this->dbkey_client->HrefValue = "";
			$this->dbkey_client->TooltipValue = "";

			// Client_Name
			$this->Client_Name->LinkCustomAttributes = "";
			$this->Client_Name->HrefValue = "";
			$this->Client_Name->TooltipValue = "";

			// Activity_Code
			$this->Activity_Code->LinkCustomAttributes = "";
			$this->Activity_Code->HrefValue = "";
			$this->Activity_Code->TooltipValue = "";

			// dbkey_activity
			$this->dbkey_activity->LinkCustomAttributes = "";
			$this->dbkey_activity->HrefValue = "";
			$this->dbkey_activity->TooltipValue = "";

			// from
			$this->from->LinkCustomAttributes = "";
			$this->from->HrefValue = "";
			$this->from->TooltipValue = "";

			// through
			$this->through->LinkCustomAttributes = "";
			$this->through->HrefValue = "";
			$this->through->TooltipValue = "";

			// contractid
			$this->contractid->LinkCustomAttributes = "";
			$this->contractid->HrefValue = "";
			$this->contractid->TooltipValue = "";

			// rate
			$this->rate->LinkCustomAttributes = "";
			$this->rate->HrefValue = "";
			$this->rate->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_SEARCH) { // Search row

			// dbkey_client
			$this->dbkey_client->EditAttrs["class"] = "form-control";
			$this->dbkey_client->EditCustomAttributes = "";
			if (trim(strval($this->dbkey_client->AdvancedSearch->SearchValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->AdvancedSearch->SearchValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `client`";
			$sWhereWrk = "";
			$this->dbkey_client->LookupFilters = array();
			$lookuptblfilter = "`active` = 1 and `dbkey` in(select dbkey_client from client_to_activity_code where client.`dbkey` = dbkey_client)";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->dbkey_client->EditValue = $arwrk;

			// Client_Name
			$this->Client_Name->EditAttrs["class"] = "form-control";
			$this->Client_Name->EditCustomAttributes = "";
			if (trim(strval($this->Client_Name->AdvancedSearch->SearchValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "(select concat(concat(last,' , '),first) from client where client.dbkey = client_budget.dbkey_client)" . ew_SearchString("=", $this->Client_Name->AdvancedSearch->SearchValue, EW_DATATYPE_STRING, "");
			}
			$sSqlWrk = "SELECT DISTINCT (select concat(concat(last,' , '),first) from client where client.dbkey = client_budget.dbkey_client), (select concat(concat(last,' , '),first) from client where client.dbkey = client_budget.dbkey_client) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `client_budget`";
			$sWhereWrk = "";
			$this->Client_Name->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->Client_Name, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `Client_Name`";
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->Client_Name->EditValue = $arwrk;

			// Activity_Code
			$this->Activity_Code->EditAttrs["class"] = "form-control";
			$this->Activity_Code->EditCustomAttributes = "";
			$this->Activity_Code->EditValue = ew_HtmlEncode($this->Activity_Code->AdvancedSearch->SearchValue);
			$this->Activity_Code->PlaceHolder = ew_RemoveHtml($this->Activity_Code->FldCaption());

			// dbkey_activity
			$this->dbkey_activity->EditAttrs["class"] = "form-control";
			$this->dbkey_activity->EditCustomAttributes = "";
			if (trim(strval($this->dbkey_activity->AdvancedSearch->SearchValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey_activity`" . ew_SearchString("=", $this->dbkey_activity->AdvancedSearch->SearchValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT `dbkey_activity`, (select activity.description from activity where activity.dbkey = dbkey_activity) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, `dbkey_client` AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `client_to_activity_code`";
			$sWhereWrk = "";
			$this->dbkey_activity->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->dbkey_activity->EditValue = $arwrk;

			// from
			$this->from->EditAttrs["class"] = "form-control";
			$this->from->EditCustomAttributes = "";
			$this->from->EditValue = ew_HtmlEncode(ew_FormatDateTime(ew_UnFormatDateTime($this->from->AdvancedSearch->SearchValue, 0), 8));
			$this->from->PlaceHolder = ew_RemoveHtml($this->from->FldCaption());

			// through
			$this->through->EditAttrs["class"] = "form-control";
			$this->through->EditCustomAttributes = "";
			$this->through->EditValue = ew_HtmlEncode(ew_FormatDateTime(ew_UnFormatDateTime($this->through->AdvancedSearch->SearchValue, 0), 8));
			$this->through->PlaceHolder = ew_RemoveHtml($this->through->FldCaption());

			// contractid
			$this->contractid->EditAttrs["class"] = "form-control";
			$this->contractid->EditCustomAttributes = "";
			$this->contractid->EditValue = ew_HtmlEncode($this->contractid->AdvancedSearch->SearchValue);
			$this->contractid->PlaceHolder = ew_RemoveHtml($this->contractid->FldCaption());

			// rate
			$this->rate->EditAttrs["class"] = "form-control";
			$this->rate->EditCustomAttributes = "";
			$this->rate->EditValue = ew_HtmlEncode($this->rate->AdvancedSearch->SearchValue);
			$this->rate->PlaceHolder = ew_RemoveHtml($this->rate->FldCaption());
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate search
	function ValidateSearch() {
		global $gsSearchError;

		// Initialize
		$gsSearchError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return TRUE;
		if (!ew_CheckDateDef($this->from->AdvancedSearch->SearchValue)) {
			ew_AddMessage($gsSearchError, $this->from->FldErrMsg());
		}
		if (!ew_CheckDateDef($this->through->AdvancedSearch->SearchValue)) {
			ew_AddMessage($gsSearchError, $this->through->FldErrMsg());
		}
		if (!ew_CheckNumber($this->rate->AdvancedSearch->SearchValue)) {
			ew_AddMessage($gsSearchError, $this->rate->FldErrMsg());
		}

		// Return validate result
		$ValidateSearch = ($gsSearchError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateSearch = $ValidateSearch && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsSearchError, $sFormCustomError);
		}
		return $ValidateSearch;
	}

	// Load advanced search
	function LoadAdvancedSearch() {
		$this->dbkey_client->AdvancedSearch->Load();
		$this->Client_Name->AdvancedSearch->Load();
		$this->Activity_Code->AdvancedSearch->Load();
		$this->dbkey_activity->AdvancedSearch->Load();
		$this->from->AdvancedSearch->Load();
		$this->through->AdvancedSearch->Load();
		$this->contractid->AdvancedSearch->Load();
		$this->rate->AdvancedSearch->Load();
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, $this->AddMasterUrl("client_budgetlist.php"), "", $this->TableVar, TRUE);
		$PageId = "search";
		$Breadcrumb->Add("search", $PageId, $url);
	}

	// Setup lookup filters of a field
	function SetupLookupFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		case "x_dbkey_client":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT DISTINCT `dbkey` AS `LinkFld`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
			$sWhereWrk = "";
			$this->dbkey_client->LookupFilters = array();
			$lookuptblfilter = "`active` = 1 and `dbkey` in(select dbkey_client from client_to_activity_code where client.`dbkey` = dbkey_client)";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey` = {filter_value}', "t0" => "3", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last` ASC";
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		case "x_Client_Name":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT DISTINCT (select concat(concat(last,' , '),first) from client where client.dbkey = client_budget.dbkey_client) AS `LinkFld`, (select concat(concat(last,' , '),first) from client where client.dbkey = client_budget.dbkey_client) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client_budget`";
			$sWhereWrk = "";
			$this->Client_Name->LookupFilters = array();
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '(select concat(concat(last,\' , \'),first) from client where client.dbkey = client_budget.dbkey_client) = {filter_value}', "t0" => "200", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->Client_Name, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `Client_Name`";
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		case "x_dbkey_activity":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT `dbkey_activity` AS `LinkFld`, (select activity.description from activity where activity.dbkey = dbkey_activity) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client_to_activity_code`";
			$sWhereWrk = "{filter}";
			$this->dbkey_activity->LookupFilters = array();
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey_activity` = {filter_value}', "t0" => "3", "fn0" => "", "f1" => '`dbkey_client` IN ({filter_value})', "t1" => "3", "fn1" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		}
	}

	// Setup AutoSuggest filters of a field
	function SetupAutoSuggestFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($client_budget_search)) $client_budget_search = new cclient_budget_search();

// Page init
$client_budget_search->Page_Init();

// Page main
$client_budget_search->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$client_budget_search->Page_Render();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "search";
<?php if ($client_budget_search->IsModal) { ?>
var CurrentAdvancedSearchForm = fclient_budgetsearch = new ew_Form("fclient_budgetsearch", "search");
<?php } else { ?>
var CurrentForm = fclient_budgetsearch = new ew_Form("fclient_budgetsearch", "search");
<?php } ?>

// Form_CustomValidate event
fclient_budgetsearch.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fclient_budgetsearch.ValidateRequired = true;
<?php } else { ?>
fclient_budgetsearch.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fclient_budgetsearch.Lists["x_dbkey_client"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_last","x_first","",""],"ParentFields":[],"ChildFields":["x_dbkey_activity"],"FilterFields":[],"Options":[],"Template":"","LinkTable":"client"};
fclient_budgetsearch.Lists["x_Client_Name"] = {"LinkField":"x_Client_Name","Ajax":true,"AutoFill":false,"DisplayFields":["x_Client_Name","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"client_budget"};
fclient_budgetsearch.Lists["x_dbkey_activity"] = {"LinkField":"x_dbkey_activity","Ajax":true,"AutoFill":false,"DisplayFields":["x_activity_description","","",""],"ParentFields":["x_dbkey_client"],"ChildFields":[],"FilterFields":["x_dbkey_client"],"Options":[],"Template":"","LinkTable":"client_to_activity_code"};

// Form object for search
// Validate function for search

fclient_budgetsearch.Validate = function(fobj) {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	fobj = fobj || this.Form;
	var infix = "";
	elm = this.GetElements("x" + infix + "_from");
	if (elm && !ew_CheckDateDef(elm.value))
		return this.OnError(elm, "<?php echo ew_JsEncode2($client_budget->from->FldErrMsg()) ?>");
	elm = this.GetElements("x" + infix + "_through");
	if (elm && !ew_CheckDateDef(elm.value))
		return this.OnError(elm, "<?php echo ew_JsEncode2($client_budget->through->FldErrMsg()) ?>");
	elm = this.GetElements("x" + infix + "_rate");
	if (elm && !ew_CheckNumber(elm.value))
		return this.OnError(elm, "<?php echo ew_JsEncode2($client_budget->rate->FldErrMsg()) ?>");

	// Fire Form_CustomValidate event
	if (!this.Form_CustomValidate(fobj))
		return false;
	return true;
}
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php if (!$client_budget_search->IsModal) { ?>
<div class="ewToolbar">
<?php $Breadcrumb->Render(); ?>
<?php echo $Language->SelectionForm(); ?>
<div class="clearfix"></div>
</div>
<?php } ?>
<?php $client_budget_search->ShowPageHeader(); ?>
<?php
$client_budget_search->ShowMessage();
?>
<form name="fclient_budgetsearch" id="fclient_budgetsearch" class="<?php echo $client_budget_search->FormClassName ?>" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($client_budget_search->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $client_budget_search->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="client_budget">
<input type="hidden" name="a_search" id="a_search" value="S">
<?php if ($client_budget_search->IsModal) { ?>
<input type="hidden" name="modal" value="1">
<?php } ?>
<div>
<?php if ($client_budget->dbkey_client->Visible) { // dbkey_client ?>
	<div id="r_dbkey_client" class="form-group">
		<label for="x_dbkey_client" class="<?php echo $client_budget_search->SearchLabelClass ?>"><span id="elh_client_budget_dbkey_client"><?php echo $client_budget->dbkey_client->FldCaption() ?></span>	
		<p class="form-control-static ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_dbkey_client" id="z_dbkey_client" value="="></p>
		</label>
		<div class="<?php echo $client_budget_search->SearchRightColumnClass ?>"><div<?php echo $client_budget->dbkey_client->CellAttributes() ?>>
			<span id="el_client_budget_dbkey_client">
<?php $client_budget->dbkey_client->EditAttrs["onchange"] = "ew_UpdateOpt.call(this); " . @$client_budget->dbkey_client->EditAttrs["onchange"]; ?>
<select data-table="client_budget" data-field="x_dbkey_client" data-value-separator="<?php echo $client_budget->dbkey_client->DisplayValueSeparatorAttribute() ?>" id="x_dbkey_client" name="x_dbkey_client"<?php echo $client_budget->dbkey_client->EditAttributes() ?>>
<?php echo $client_budget->dbkey_client->SelectOptionListHtml("x_dbkey_client") ?>
</select>
<input type="hidden" name="s_x_dbkey_client" id="s_x_dbkey_client" value="<?php echo $client_budget->dbkey_client->LookupFilterQuery() ?>">
</span>
		</div></div>
	</div>
<?php } ?>
<?php if ($client_budget->Client_Name->Visible) { // Client_Name ?>
	<div id="r_Client_Name" class="form-group">
		<label for="x_Client_Name" class="<?php echo $client_budget_search->SearchLabelClass ?>"><span id="elh_client_budget_Client_Name"><?php echo $client_budget->Client_Name->FldCaption() ?></span>	
		<p class="form-control-static ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_Client_Name" id="z_Client_Name" value="="></p>
		</label>
		<div class="<?php echo $client_budget_search->SearchRightColumnClass ?>"><div<?php echo $client_budget->Client_Name->CellAttributes() ?>>
			<span id="el_client_budget_Client_Name">
<select data-table="client_budget" data-field="x_Client_Name" data-value-separator="<?php echo $client_budget->Client_Name->DisplayValueSeparatorAttribute() ?>" id="x_Client_Name" name="x_Client_Name"<?php echo $client_budget->Client_Name->EditAttributes() ?>>
<?php echo $client_budget->Client_Name->SelectOptionListHtml("x_Client_Name") ?>
</select>
<input type="hidden" name="s_x_Client_Name" id="s_x_Client_Name" value="<?php echo $client_budget->Client_Name->LookupFilterQuery() ?>">
</span>
		</div></div>
	</div>
<?php } ?>
<?php if ($client_budget->Activity_Code->Visible) { // Activity_Code ?>
	<div id="r_Activity_Code" class="form-group">
		<label for="x_Activity_Code" class="<?php echo $client_budget_search->SearchLabelClass ?>"><span id="elh_client_budget_Activity_Code"><?php echo $client_budget->Activity_Code->FldCaption() ?></span>	
		<p class="form-control-static ewSearchOperator"><?php echo $Language->Phrase("LIKE") ?><input type="hidden" name="z_Activity_Code" id="z_Activity_Code" value="LIKE"></p>
		</label>
		<div class="<?php echo $client_budget_search->SearchRightColumnClass ?>"><div<?php echo $client_budget->Activity_Code->CellAttributes() ?>>
			<span id="el_client_budget_Activity_Code">
<input type="text" data-table="client_budget" data-field="x_Activity_Code" name="x_Activity_Code" id="x_Activity_Code" size="30" maxlength="50" placeholder="<?php echo ew_HtmlEncode($client_budget->Activity_Code->getPlaceHolder()) ?>" value="<?php echo $client_budget->Activity_Code->EditValue ?>"<?php echo $client_budget->Activity_Code->EditAttributes() ?>>
</span>
		</div></div>
	</div>
<?php } ?>
<?php if ($client_budget->dbkey_activity->Visible) { // dbkey_activity ?>
	<div id="r_dbkey_activity" class="form-group">
		<label for="x_dbkey_activity" class="<?php echo $client_budget_search->SearchLabelClass ?>"><span id="elh_client_budget_dbkey_activity"><?php echo $client_budget->dbkey_activity->FldCaption() ?></span>	
		<p class="form-control-static ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_dbkey_activity" id="z_dbkey_activity" value="="></p>
		</label>
		<div class="<?php echo $client_budget_search->SearchRightColumnClass ?>"><div<?php echo $client_budget->dbkey_activity->CellAttributes() ?>>
			<span id="el_client_budget_dbkey_activity">
<select data-table="client_budget" data-field="x_dbkey_activity" data-value-separator="<?php echo $client_budget->dbkey_activity->DisplayValueSeparatorAttribute() ?>" id="x_dbkey_activity" name="x_dbkey_activity"<?php echo $client_budget->dbkey_activity->EditAttributes() ?>>
<?php echo $client_budget->dbkey_activity->SelectOptionListHtml("x_dbkey_activity") ?>
</select>
<input type="hidden" name="s_x_dbkey_activity" id="s_x_dbkey_activity" value="<?php echo $client_budget->dbkey_activity->LookupFilterQuery() ?>">
</span>
		</div></div>
	</div>
<?php } ?>
<?php if ($client_budget->from->Visible) { // from ?>
	<div id="r_from" class="form-group">
		<label for="x_from" class="<?php echo $client_budget_search->SearchLabelClass ?>"><span id="elh_client_budget_from"><?php echo $client_budget->from->FldCaption() ?></span>	
		<p class="form-control-static ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_from" id="z_from" value="="></p>
		</label>
		<div class="<?php echo $client_budget_search->SearchRightColumnClass ?>"><div<?php echo $client_budget->from->CellAttributes() ?>>
			<span id="el_client_budget_from">
<input type="text" data-table="client_budget" data-field="x_from" name="x_from" id="x_from" placeholder="<?php echo ew_HtmlEncode($client_budget->from->getPlaceHolder()) ?>" value="<?php echo $client_budget->from->EditValue ?>"<?php echo $client_budget->from->EditAttributes() ?>>
<?php if (!$client_budget->from->ReadOnly && !$client_budget->from->Disabled && !isset($client_budget->from->EditAttrs["readonly"]) && !isset($client_budget->from->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fclient_budgetsearch", "x_from", 0);
</script>
<?php } ?>
</span>
		</div></div>
	</div>
<?php } ?>
<?php if ($client_budget->through->Visible) { // through ?>
	<div id="r_through" class="form-group">
		<label for="x_through" class="<?php echo $client_budget_search->SearchLabelClass ?>"><span id="elh_client_budget_through"><?php echo $client_budget->through->FldCaption() ?></span>	
		<p class="form-control-static ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_through" id="z_through" value="="></p>
		</label>
		<div class="<?php echo $client_budget_search->SearchRightColumnClass ?>"><div<?php echo $client_budget->through->CellAttributes() ?>>
			<span id="el_client_budget_through">
<input type="text" data-table="client_budget" data-field="x_through" name="x_through" id="x_through" placeholder="<?php echo ew_HtmlEncode($client_budget->through->getPlaceHolder()) ?>" value="<?php echo $client_budget->through->EditValue ?>"<?php echo $client_budget->through->EditAttributes() ?>>
<?php if (!$client_budget->through->ReadOnly && !$client_budget->through->Disabled && !isset($client_budget->through->EditAttrs["readonly"]) && !isset($client_budget->through->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fclient_budgetsearch", "x_through", 0);
</script>
<?php } ?>
</span>
		</div></div>
	</div>
<?php } ?>
<?php if ($client_budget->contractid->Visible) { // contractid ?>
	<div id="r_contractid" class="form-group">
		<label for="x_contractid" class="<?php echo $client_budget_search->SearchLabelClass ?>"><span id="elh_client_budget_contractid"><?php echo $client_budget->contractid->FldCaption() ?></span>	
		<p class="form-control-static ewSearchOperator"><?php echo $Language->Phrase("LIKE") ?><input type="hidden" name="z_contractid" id="z_contractid" value="LIKE"></p>
		</label>
		<div class="<?php echo $client_budget_search->SearchRightColumnClass ?>"><div<?php echo $client_budget->contractid->CellAttributes() ?>>
			<span id="el_client_budget_contractid">
<input type="text" data-table="client_budget" data-field="x_contractid" name="x_contractid" id="x_contractid" size="30" maxlength="50" placeholder="<?php echo ew_HtmlEncode($client_budget->contractid->getPlaceHolder()) ?>" value="<?php echo $client_budget->contractid->EditValue ?>"<?php echo $client_budget->contractid->EditAttributes() ?>>
</span>
		</div></div>
	</div>
<?php } ?>
<?php if ($client_budget->rate->Visible) { // rate ?>
	<div id="r_rate" class="form-group">
		<label for="x_rate" class="<?php echo $client_budget_search->SearchLabelClass ?>"><span id="elh_client_budget_rate"><?php echo $client_budget->rate->FldCaption() ?></span>	
		<p class="form-control-static ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_rate" id="z_rate" value="="></p>
		</label>
		<div class="<?php echo $client_budget_search->SearchRightColumnClass ?>"><div<?php echo $client_budget->rate->CellAttributes() ?>>
			<span id="el_client_budget_rate">
<input type="text" data-table="client_budget" data-field="x_rate" name="x_rate" id="x_rate" size="30" placeholder="<?php echo ew_HtmlEncode($client_budget->rate->getPlaceHolder()) ?>" value="<?php echo $client_budget->rate->EditValue ?>"<?php echo $client_budget->rate->EditAttributes() ?>>
</span>
		</div></div>
	</div>
<?php } ?>
</div>
<?php if (!$client_budget_search->IsModal) { ?>
<div class="form-group">
	<div class="col-sm-offset-3 col-sm-9">
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit"><?php echo $Language->Phrase("Search") ?></button>
<button class="btn btn-default ewButton" name="btnReset" id="btnReset" type="button" onclick="ew_ClearForm(this.form);"><?php echo $Language->Phrase("Reset") ?></button>
	</div>
</div>
<?php } ?>
</form>
<script type="text/javascript">
fclient_budgetsearch.Init();
</script>
<?php
$client_budget_search->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$client_budget_search->Page_Terminate();
?>
