<?php
if (session_id() == "") session_start(); // Init session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg13.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql13.php") ?>
<?php include_once "phpfn13.php" ?>
<?php include_once "clientinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "client_budgetgridcls.php" ?>
<?php include_once "client_to_activity_codegridcls.php" ?>
<?php include_once "userfn13.php" ?>
<?php

//
// Page class
//

$client_add = NULL; // Initialize page object first

class cclient_add extends cclient {

	// Page ID
	var $PageID = 'add';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'client';

	// Page object name
	var $PageObjName = 'client_add';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}
	var $AuditTrailOnAdd = TRUE;
	var $AuditTrailOnEdit = FALSE;
	var $AuditTrailOnDelete = FALSE;
	var $AuditTrailOnView = FALSE;
	var $AuditTrailOnViewData = FALSE;
	var $AuditTrailOnSearch = FALSE;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (client)
		if (!isset($GLOBALS["client"]) || get_class($GLOBALS["client"]) == "cclient") {
			$GLOBALS["client"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["client"];
		}

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'add', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'client', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	//
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanAdd()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("clientlist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Create form object
		$objForm = new cFormObj();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action
		$this->first->SetVisibility();
		$this->last->SetVisibility();
		$this->waived->SetVisibility();
		$this->active->SetVisibility();
		$this->service_month->SetVisibility();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {

			// Process auto fill for detail table 'client_budget'
			if (@$_POST["grid"] == "fclient_budgetgrid") {
				if (!isset($GLOBALS["client_budget_grid"])) $GLOBALS["client_budget_grid"] = new cclient_budget_grid;
				$GLOBALS["client_budget_grid"]->Page_Init();
				$this->Page_Terminate();
				exit();
			}

			// Process auto fill for detail table 'client_to_activity_code'
			if (@$_POST["grid"] == "fclient_to_activity_codegrid") {
				if (!isset($GLOBALS["client_to_activity_code_grid"])) $GLOBALS["client_to_activity_code_grid"] = new cclient_to_activity_code_grid;
				$GLOBALS["client_to_activity_code_grid"]->Page_Init();
				$this->Page_Terminate();
				exit();
			}
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $client;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($client);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();

			// Handle modal response
			if ($this->IsModal) {
				$row = array();
				$row["url"] = $url;
				echo ew_ArrayToJson(array($row));
			} else {
				header("Location: " . $url);
			}
		}
		exit();
	}
	var $FormClassName = "form-horizontal ewForm ewAddForm";
	var $IsModal = FALSE;
	var $DbMasterFilter = "";
	var $DbDetailFilter = "";
	var $StartRec;
	var $Priv = 0;
	var $OldRecordset;
	var $CopyRecord;

	// 
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError;
		global $gbSkipHeaderFooter;

		// Check modal
		$this->IsModal = (@$_GET["modal"] == "1" || @$_POST["modal"] == "1");
		if ($this->IsModal)
			$gbSkipHeaderFooter = TRUE;

		// Process form if post back
		if (@$_POST["a_add"] <> "") {
			$this->CurrentAction = $_POST["a_add"]; // Get form action
			$this->CopyRecord = $this->LoadOldRecord(); // Load old recordset
			$this->LoadFormValues(); // Load form values
		} else { // Not post back

			// Load key values from QueryString
			$this->CopyRecord = TRUE;
			if (@$_GET["dbkey"] != "") {
				$this->dbkey->setQueryStringValue($_GET["dbkey"]);
				$this->setKey("dbkey", $this->dbkey->CurrentValue); // Set up key
			} else {
				$this->setKey("dbkey", ""); // Clear key
				$this->CopyRecord = FALSE;
			}
			if ($this->CopyRecord) {
				$this->CurrentAction = "C"; // Copy record
			} else {
				$this->CurrentAction = "I"; // Display blank record
			}
		}

		// Set up Breadcrumb
		$this->SetupBreadcrumb();

		// Set up detail parameters
		$this->SetUpDetailParms();

		// Validate form if post back
		if (@$_POST["a_add"] <> "") {
			if (!$this->ValidateForm()) {
				$this->CurrentAction = "I"; // Form error, reset action
				$this->EventCancelled = TRUE; // Event cancelled
				$this->RestoreFormValues(); // Restore form values
				$this->setFailureMessage($gsFormError);
			}
		} else {
			if ($this->CurrentAction == "I") // Load default values for blank record
				$this->LoadDefaultValues();
		}

		// Perform action based on action code
		switch ($this->CurrentAction) {
			case "I": // Blank record, no action required
				break;
			case "C": // Copy an existing record
				if (!$this->LoadRow()) { // Load record based on key
					if ($this->getFailureMessage() == "") $this->setFailureMessage($Language->Phrase("NoRecord")); // No record found
					$this->Page_Terminate("clientlist.php"); // No matching record, return to list
				}

				// Set up detail parameters
				$this->SetUpDetailParms();
				break;
			case "A": // Add new record
				$this->SendEmail = TRUE; // Send email on add success
				if ($this->AddRow($this->OldRecordset)) { // Add successful
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage($Language->Phrase("AddSuccess")); // Set up success message
					if ($this->getCurrentDetailTable() <> "") // Master/detail add
						$sReturnUrl = $this->GetDetailUrl();
					else
						$sReturnUrl = $this->getReturnUrl();
					if (ew_GetPageName($sReturnUrl) == "clientlist.php")
						$sReturnUrl = $this->AddMasterUrl($sReturnUrl); // List page, return to list page with correct master key if necessary
					elseif (ew_GetPageName($sReturnUrl) == "clientview.php")
						$sReturnUrl = $this->GetViewUrl(); // View page, return to view page with keyurl directly
					$this->Page_Terminate($sReturnUrl); // Clean up and return
				} else {
					$this->EventCancelled = TRUE; // Event cancelled
					$this->RestoreFormValues(); // Add failed, restore form values

					// Set up detail parameters
					$this->SetUpDetailParms();
				}
		}

		// Render row based on row type
		if ($this->CurrentAction == "F") { // Confirm page
			$this->RowType = EW_ROWTYPE_VIEW; // Render view type
		} else {
			$this->RowType = EW_ROWTYPE_ADD; // Render add type
		}

		// Render row
		$this->ResetAttrs();
		$this->RenderRow();
	}

	// Get upload files
	function GetUploadFiles() {
		global $objForm, $Language;

		// Get upload data
	}

	// Load default values
	function LoadDefaultValues() {
		$this->first->CurrentValue = NULL;
		$this->first->OldValue = $this->first->CurrentValue;
		$this->last->CurrentValue = NULL;
		$this->last->OldValue = $this->last->CurrentValue;
		$this->waived->CurrentValue = NULL;
		$this->waived->OldValue = $this->waived->CurrentValue;
		$this->active->CurrentValue = 1;
		$this->service_month->CurrentValue = NULL;
		$this->service_month->OldValue = $this->service_month->CurrentValue;
	}

	// Load form values
	function LoadFormValues() {

		// Load from form
		global $objForm;
		if (!$this->first->FldIsDetailKey) {
			$this->first->setFormValue($objForm->GetValue("x_first"));
		}
		if (!$this->last->FldIsDetailKey) {
			$this->last->setFormValue($objForm->GetValue("x_last"));
		}
		if (!$this->waived->FldIsDetailKey) {
			$this->waived->setFormValue($objForm->GetValue("x_waived"));
		}
		if (!$this->active->FldIsDetailKey) {
			$this->active->setFormValue($objForm->GetValue("x_active"));
		}
		if (!$this->service_month->FldIsDetailKey) {
			$this->service_month->setFormValue($objForm->GetValue("x_service_month"));
		}
	}

	// Restore form values
	function RestoreFormValues() {
		global $objForm;
		$this->LoadOldRecord();
		$this->first->CurrentValue = $this->first->FormValue;
		$this->last->CurrentValue = $this->last->FormValue;
		$this->waived->CurrentValue = $this->waived->FormValue;
		$this->active->CurrentValue = $this->active->FormValue;
		$this->service_month->CurrentValue = $this->service_month->FormValue;
		$this->ResetDetailParms();
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->first->setDbValue($rs->fields('first'));
		$this->last->setDbValue($rs->fields('last'));
		$this->waived->setDbValue($rs->fields('waived'));
		$this->active->setDbValue($rs->fields('active'));
		$this->service_month->setDbValue($rs->fields('service_month'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey->DbValue = $row['dbkey'];
		$this->first->DbValue = $row['first'];
		$this->last->DbValue = $row['last'];
		$this->waived->DbValue = $row['waived'];
		$this->active->DbValue = $row['active'];
		$this->service_month->DbValue = $row['service_month'];
	}

	// Load old record
	function LoadOldRecord() {

		// Load key values from Session
		$bValidKey = TRUE;
		if (strval($this->getKey("dbkey")) <> "")
			$this->dbkey->CurrentValue = $this->getKey("dbkey"); // dbkey
		else
			$bValidKey = FALSE;

		// Load old recordset
		if ($bValidKey) {
			$this->CurrentFilter = $this->KeyFilter();
			$sSql = $this->SQL();
			$conn = &$this->Connection();
			$this->OldRecordset = ew_LoadRecordset($sSql, $conn);
			$this->LoadRowValues($this->OldRecordset); // Load row values
		} else {
			$this->OldRecordset = NULL;
		}
		return $bValidKey;
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Call Row_Rendering event

		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey
		// first
		// last
		// waived
		// active
		// service_month

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// dbkey
		$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
		if (strval($this->dbkey->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		$this->dbkey->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey->ViewValue = $this->dbkey->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
			}
		} else {
			$this->dbkey->ViewValue = NULL;
		}
		$this->dbkey->ViewCustomAttributes = "";

		// first
		$this->first->ViewValue = $this->first->CurrentValue;
		$this->first->ViewCustomAttributes = "";

		// last
		$this->last->ViewValue = $this->last->CurrentValue;
		$this->last->ViewCustomAttributes = "";

		// waived
		if (strval($this->waived->CurrentValue) <> "") {
			$sFilterWrk = "`code`" . ew_SearchString("=", $this->waived->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT `code`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `waivered`";
		$sWhereWrk = "";
		$this->waived->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->waived, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->waived->ViewValue = $this->waived->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->waived->ViewValue = $this->waived->CurrentValue;
			}
		} else {
			$this->waived->ViewValue = NULL;
		}
		$this->waived->ViewCustomAttributes = "";

		// active
		if (strval($this->active->CurrentValue) <> "") {
			$this->active->ViewValue = $this->active->OptionCaption($this->active->CurrentValue);
		} else {
			$this->active->ViewValue = NULL;
		}
		$this->active->ViewCustomAttributes = "";

		// service_month
		if (strval($this->service_month->CurrentValue) <> "") {
			$sFilterWrk = "Cast(tables_data.dbkey As Decimal)" . ew_SearchString("=", $this->service_month->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM tables_data";
		$sWhereWrk = "(tables_data.dbkey_tables = 'month')";
		$this->service_month->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->service_month, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->service_month->ViewValue = $this->service_month->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->service_month->ViewValue = $this->service_month->CurrentValue;
			}
		} else {
			$this->service_month->ViewValue = NULL;
		}
		$this->service_month->ViewCustomAttributes = "";

			// first
			$this->first->LinkCustomAttributes = "";
			$this->first->HrefValue = "";
			$this->first->TooltipValue = "";

			// last
			$this->last->LinkCustomAttributes = "";
			$this->last->HrefValue = "";
			$this->last->TooltipValue = "";

			// waived
			$this->waived->LinkCustomAttributes = "";
			$this->waived->HrefValue = "";
			$this->waived->TooltipValue = "";

			// active
			$this->active->LinkCustomAttributes = "";
			$this->active->HrefValue = "";
			$this->active->TooltipValue = "";

			// service_month
			$this->service_month->LinkCustomAttributes = "";
			$this->service_month->HrefValue = "";
			$this->service_month->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_ADD) { // Add row

			// first
			$this->first->EditAttrs["class"] = "form-control";
			$this->first->EditCustomAttributes = "";
			$this->first->EditValue = ew_HtmlEncode($this->first->CurrentValue);
			$this->first->PlaceHolder = ew_RemoveHtml($this->first->FldCaption());

			// last
			$this->last->EditAttrs["class"] = "form-control";
			$this->last->EditCustomAttributes = "";
			$this->last->EditValue = ew_HtmlEncode($this->last->CurrentValue);
			$this->last->PlaceHolder = ew_RemoveHtml($this->last->FldCaption());

			// waived
			$this->waived->EditAttrs["class"] = "form-control";
			$this->waived->EditCustomAttributes = "";
			if (trim(strval($this->waived->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`code`" . ew_SearchString("=", $this->waived->CurrentValue, EW_DATATYPE_STRING, "");
			}
			$sSqlWrk = "SELECT `code`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `waivered`";
			$sWhereWrk = "";
			$this->waived->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->waived, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->waived->EditValue = $arwrk;

			// active
			$this->active->EditAttrs["class"] = "form-control";
			$this->active->EditCustomAttributes = "";
			$this->active->EditValue = $this->active->Options(TRUE);

			// service_month
			$this->service_month->EditAttrs["class"] = "form-control";
			$this->service_month->EditCustomAttributes = "";
			if (trim(strval($this->service_month->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "Cast(tables_data.dbkey As Decimal)" . ew_SearchString("=", $this->service_month->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM tables_data";
			$sWhereWrk = "(tables_data.dbkey_tables = 'month')";
			$this->service_month->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->service_month, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->service_month->EditValue = $arwrk;

			// Add refer script
			// first

			$this->first->LinkCustomAttributes = "";
			$this->first->HrefValue = "";

			// last
			$this->last->LinkCustomAttributes = "";
			$this->last->HrefValue = "";

			// waived
			$this->waived->LinkCustomAttributes = "";
			$this->waived->HrefValue = "";

			// active
			$this->active->LinkCustomAttributes = "";
			$this->active->HrefValue = "";

			// service_month
			$this->service_month->LinkCustomAttributes = "";
			$this->service_month->HrefValue = "";
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate form
	function ValidateForm() {
		global $Language, $gsFormError;

		// Initialize form error message
		$gsFormError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return ($gsFormError == "");
		if (!$this->first->FldIsDetailKey && !is_null($this->first->FormValue) && $this->first->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->first->FldCaption(), $this->first->ReqErrMsg));
		}
		if (!$this->last->FldIsDetailKey && !is_null($this->last->FormValue) && $this->last->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->last->FldCaption(), $this->last->ReqErrMsg));
		}
		if (!$this->waived->FldIsDetailKey && !is_null($this->waived->FormValue) && $this->waived->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->waived->FldCaption(), $this->waived->ReqErrMsg));
		}
		if (!$this->active->FldIsDetailKey && !is_null($this->active->FormValue) && $this->active->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->active->FldCaption(), $this->active->ReqErrMsg));
		}

		// Validate detail grid
		$DetailTblVar = explode(",", $this->getCurrentDetailTable());
		if (in_array("client_budget", $DetailTblVar) && $GLOBALS["client_budget"]->DetailAdd) {
			if (!isset($GLOBALS["client_budget_grid"])) $GLOBALS["client_budget_grid"] = new cclient_budget_grid(); // get detail page object
			$GLOBALS["client_budget_grid"]->ValidateGridForm();
		}
		if (in_array("client_to_activity_code", $DetailTblVar) && $GLOBALS["client_to_activity_code"]->DetailAdd) {
			if (!isset($GLOBALS["client_to_activity_code_grid"])) $GLOBALS["client_to_activity_code_grid"] = new cclient_to_activity_code_grid(); // get detail page object
			$GLOBALS["client_to_activity_code_grid"]->ValidateGridForm();
		}

		// Return validate result
		$ValidateForm = ($gsFormError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateForm = $ValidateForm && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsFormError, $sFormCustomError);
		}
		return $ValidateForm;
	}

	// Add record
	function AddRow($rsold = NULL) {
		global $Language, $Security;
		$conn = &$this->Connection();

		// Begin transaction
		if ($this->getCurrentDetailTable() <> "")
			$conn->BeginTrans();

		// Load db values from rsold
		if ($rsold) {
			$this->LoadDbValues($rsold);
		}
		$rsnew = array();

		// first
		$this->first->SetDbValueDef($rsnew, $this->first->CurrentValue, "", FALSE);

		// last
		$this->last->SetDbValueDef($rsnew, $this->last->CurrentValue, "", FALSE);

		// waived
		$this->waived->SetDbValueDef($rsnew, $this->waived->CurrentValue, "", FALSE);

		// active
		$this->active->SetDbValueDef($rsnew, $this->active->CurrentValue, 0, strval($this->active->CurrentValue) == "");

		// service_month
		$this->service_month->SetDbValueDef($rsnew, $this->service_month->CurrentValue, NULL, FALSE);

		// Call Row Inserting event
		$rs = ($rsold == NULL) ? NULL : $rsold->fields;
		$bInsertRow = $this->Row_Inserting($rs, $rsnew);
		if ($bInsertRow) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			$AddRow = $this->Insert($rsnew);
			$conn->raiseErrorFn = '';
			if ($AddRow) {

				// Get insert id if necessary
				$this->dbkey->setDbValue($conn->Insert_ID());
				$rsnew['dbkey'] = $this->dbkey->DbValue;
			}
		} else {
			if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

				// Use the message, do nothing
			} elseif ($this->CancelMessage <> "") {
				$this->setFailureMessage($this->CancelMessage);
				$this->CancelMessage = "";
			} else {
				$this->setFailureMessage($Language->Phrase("InsertCancelled"));
			}
			$AddRow = FALSE;
		}

		// Add detail records
		if ($AddRow) {
			$DetailTblVar = explode(",", $this->getCurrentDetailTable());
			if (in_array("client_budget", $DetailTblVar) && $GLOBALS["client_budget"]->DetailAdd) {
				$GLOBALS["client_budget"]->dbkey_client->setSessionValue($this->dbkey->CurrentValue); // Set master key
				if (!isset($GLOBALS["client_budget_grid"])) $GLOBALS["client_budget_grid"] = new cclient_budget_grid(); // Get detail page object
				$Security->LoadCurrentUserLevel($this->ProjectID . "client_budget"); // Load user level of detail table
				$AddRow = $GLOBALS["client_budget_grid"]->GridInsert();
				$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName); // Restore user level of master table
				if (!$AddRow)
					$GLOBALS["client_budget"]->dbkey_client->setSessionValue(""); // Clear master key if insert failed
			}
			if (in_array("client_to_activity_code", $DetailTblVar) && $GLOBALS["client_to_activity_code"]->DetailAdd) {
				$GLOBALS["client_to_activity_code"]->dbkey_client->setSessionValue($this->dbkey->CurrentValue); // Set master key
				if (!isset($GLOBALS["client_to_activity_code_grid"])) $GLOBALS["client_to_activity_code_grid"] = new cclient_to_activity_code_grid(); // Get detail page object
				$Security->LoadCurrentUserLevel($this->ProjectID . "client_to_activity_code"); // Load user level of detail table
				$AddRow = $GLOBALS["client_to_activity_code_grid"]->GridInsert();
				$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName); // Restore user level of master table
				if (!$AddRow)
					$GLOBALS["client_to_activity_code"]->dbkey_client->setSessionValue(""); // Clear master key if insert failed
			}
		}

		// Commit/Rollback transaction
		if ($this->getCurrentDetailTable() <> "") {
			if ($AddRow) {
				$conn->CommitTrans(); // Commit transaction
			} else {
				$conn->RollbackTrans(); // Rollback transaction
			}
		}
		if ($AddRow) {

			// Call Row Inserted event
			$rs = ($rsold == NULL) ? NULL : $rsold->fields;
			$this->Row_Inserted($rs, $rsnew);
			$this->WriteAuditTrailOnAdd($rsnew);
		}
		return $AddRow;
	}

	// Set up detail parms based on QueryString
	function SetUpDetailParms() {

		// Get the keys for master table
		if (isset($_GET[EW_TABLE_SHOW_DETAIL])) {
			$sDetailTblVar = $_GET[EW_TABLE_SHOW_DETAIL];
			$this->setCurrentDetailTable($sDetailTblVar);
		} else {
			$sDetailTblVar = $this->getCurrentDetailTable();
		}
		if ($sDetailTblVar <> "") {
			$DetailTblVar = explode(",", $sDetailTblVar);
			if (in_array("client_budget", $DetailTblVar)) {
				if (!isset($GLOBALS["client_budget_grid"]))
					$GLOBALS["client_budget_grid"] = new cclient_budget_grid;
				if ($GLOBALS["client_budget_grid"]->DetailAdd) {
					if ($this->CopyRecord)
						$GLOBALS["client_budget_grid"]->CurrentMode = "copy";
					else
						$GLOBALS["client_budget_grid"]->CurrentMode = "add";
					if ($this->CurrentAction == "F")
						$GLOBALS["client_budget_grid"]->CurrentAction = "F";
					else
						$GLOBALS["client_budget_grid"]->CurrentAction = "gridadd";
					if ($this->CurrentAction == "X")
						$GLOBALS["client_budget_grid"]->EventCancelled = TRUE;

					// Save current master table to detail table
					$GLOBALS["client_budget_grid"]->setCurrentMasterTable($this->TableVar);
					$GLOBALS["client_budget_grid"]->setStartRecordNumber(1);
					$GLOBALS["client_budget_grid"]->dbkey_client->FldIsDetailKey = TRUE;
					$GLOBALS["client_budget_grid"]->dbkey_client->CurrentValue = $this->dbkey->CurrentValue;
					$GLOBALS["client_budget_grid"]->dbkey_client->setSessionValue($GLOBALS["client_budget_grid"]->dbkey_client->CurrentValue);
				}
			}
			if (in_array("client_to_activity_code", $DetailTblVar)) {
				if (!isset($GLOBALS["client_to_activity_code_grid"]))
					$GLOBALS["client_to_activity_code_grid"] = new cclient_to_activity_code_grid;
				if ($GLOBALS["client_to_activity_code_grid"]->DetailAdd) {
					if ($this->CopyRecord)
						$GLOBALS["client_to_activity_code_grid"]->CurrentMode = "copy";
					else
						$GLOBALS["client_to_activity_code_grid"]->CurrentMode = "add";
					if ($this->CurrentAction == "F")
						$GLOBALS["client_to_activity_code_grid"]->CurrentAction = "F";
					else
						$GLOBALS["client_to_activity_code_grid"]->CurrentAction = "gridadd";
					if ($this->CurrentAction == "X")
						$GLOBALS["client_to_activity_code_grid"]->EventCancelled = TRUE;

					// Save current master table to detail table
					$GLOBALS["client_to_activity_code_grid"]->setCurrentMasterTable($this->TableVar);
					$GLOBALS["client_to_activity_code_grid"]->setStartRecordNumber(1);
					$GLOBALS["client_to_activity_code_grid"]->dbkey_client->FldIsDetailKey = TRUE;
					$GLOBALS["client_to_activity_code_grid"]->dbkey_client->CurrentValue = $this->dbkey->CurrentValue;
					$GLOBALS["client_to_activity_code_grid"]->dbkey_client->setSessionValue($GLOBALS["client_to_activity_code_grid"]->dbkey_client->CurrentValue);
				}
			}
		}
	}

	// Reset detail parms
	function ResetDetailParms() {

		// Get the keys for master table
		if (isset($_GET[EW_TABLE_SHOW_DETAIL])) {
			$sDetailTblVar = $_GET[EW_TABLE_SHOW_DETAIL];
			$this->setCurrentDetailTable($sDetailTblVar);
		} else {
			$sDetailTblVar = $this->getCurrentDetailTable();
		}
		if ($sDetailTblVar <> "") {
			$DetailTblVar = explode(",", $sDetailTblVar);
			if (in_array("client_budget", $DetailTblVar)) {
				if (!isset($GLOBALS["client_budget_grid"]))
					$GLOBALS["client_budget_grid"] = new cclient_budget_grid;
				if ($GLOBALS["client_budget_grid"]->DetailAdd) {
					$GLOBALS["client_budget_grid"]->CurrentAction = "gridadd";
				}
			}
			if (in_array("client_to_activity_code", $DetailTblVar)) {
				if (!isset($GLOBALS["client_to_activity_code_grid"]))
					$GLOBALS["client_to_activity_code_grid"] = new cclient_to_activity_code_grid;
				if ($GLOBALS["client_to_activity_code_grid"]->DetailAdd) {
					$GLOBALS["client_to_activity_code_grid"]->CurrentAction = "gridadd";
				}
			}
		}
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, $this->AddMasterUrl("clientlist.php"), "", $this->TableVar, TRUE);
		$PageId = ($this->CurrentAction == "C") ? "Copy" : "Add";
		$Breadcrumb->Add("add", $PageId, $url);
	}

	// Setup lookup filters of a field
	function SetupLookupFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		case "x_waived":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT `code` AS `LinkFld`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `waivered`";
			$sWhereWrk = "";
			$this->waived->LookupFilters = array();
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`code` = {filter_value}', "t0" => "200", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->waived, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		case "x_service_month":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT `dbkey` AS `LinkFld`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM tables_data";
			$sWhereWrk = "(tables_data.dbkey_tables = 'month')";
			$this->service_month->LookupFilters = array();
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => 'Cast(tables_data.dbkey As Decimal) = {filter_value}', "t0" => "131", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->service_month, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		}
	}

	// Setup AutoSuggest filters of a field
	function SetupAutoSuggestFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Write Audit Trail start/end for grid update
	function WriteAuditTrailDummy($typ) {
		$table = 'client';
		$usr = CurrentUserID();
		ew_WriteAuditTrail("log", ew_StdCurrentDateTime(), ew_ScriptName(), $usr, $typ, $table, "", "", "", "");
	}

	// Write Audit Trail (add page)
	function WriteAuditTrailOnAdd(&$rs) {
		global $Language;
		if (!$this->AuditTrailOnAdd) return;
		$table = 'client';

		// Get key value
		$key = "";
		if ($key <> "") $key .= $GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"];
		$key .= $rs['dbkey'];

		// Write Audit Trail
		$dt = ew_StdCurrentDateTime();
		$id = ew_ScriptName();
		$usr = CurrentUserID();
		foreach (array_keys($rs) as $fldname) {
			if ($this->fields[$fldname]->FldDataType <> EW_DATATYPE_BLOB) { // Ignore BLOB fields
				if ($this->fields[$fldname]->FldHtmlTag == "PASSWORD") {
					$newvalue = $Language->Phrase("PasswordMask"); // Password Field
				} elseif ($this->fields[$fldname]->FldDataType == EW_DATATYPE_MEMO) {
					if (EW_AUDIT_TRAIL_TO_DATABASE)
						$newvalue = $rs[$fldname];
					else
						$newvalue = "[MEMO]"; // Memo Field
				} elseif ($this->fields[$fldname]->FldDataType == EW_DATATYPE_XML) {
					$newvalue = "[XML]"; // XML Field
				} else {
					$newvalue = $rs[$fldname];
				}
				ew_WriteAuditTrail("log", $dt, $id, $usr, "A", $table, $fldname, $key, "", $newvalue);
			}
		}
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($client_add)) $client_add = new cclient_add();

// Page init
$client_add->Page_Init();

// Page main
$client_add->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$client_add->Page_Render();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "add";
var CurrentForm = fclientadd = new ew_Form("fclientadd", "add");

// Validate form
fclientadd.Validate = function() {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	var $ = jQuery, fobj = this.GetForm(), $fobj = $(fobj);
	if ($fobj.find("#a_confirm").val() == "F")
		return true;
	var elm, felm, uelm, addcnt = 0;
	var $k = $fobj.find("#" + this.FormKeyCountName); // Get key_count
	var rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1;
	var startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
	var gridinsert = $fobj.find("#a_list").val() == "gridinsert";
	for (var i = startcnt; i <= rowcnt; i++) {
		var infix = ($k[0]) ? String(i) : "";
		$fobj.data("rowindex", infix);
			elm = this.GetElements("x" + infix + "_first");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client->first->FldCaption(), $client->first->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_last");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client->last->FldCaption(), $client->last->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_waived");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client->waived->FldCaption(), $client->waived->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_active");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client->active->FldCaption(), $client->active->ReqErrMsg)) ?>");

			// Fire Form_CustomValidate event
			if (!this.Form_CustomValidate(fobj))
				return false;
	}

	// Process detail forms
	var dfs = $fobj.find("input[name='detailpage']").get();
	for (var i = 0; i < dfs.length; i++) {
		var df = dfs[i], val = df.value;
		if (val && ewForms[val])
			if (!ewForms[val].Validate())
				return false;
	}
	return true;
}

// Form_CustomValidate event
fclientadd.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fclientadd.ValidateRequired = true;
<?php } else { ?>
fclientadd.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fclientadd.Lists["x_waived"] = {"LinkField":"x_code","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"waivered"};
fclientadd.Lists["x_active"] = {"LinkField":"","Ajax":null,"AutoFill":false,"DisplayFields":["","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
fclientadd.Lists["x_active"].Options = <?php echo json_encode($client->active->Options()) ?>;
fclientadd.Lists["x_service_month"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"Cust_Month"};

// Form object for search
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php if (!$client_add->IsModal) { ?>
<div class="ewToolbar">
<?php $Breadcrumb->Render(); ?>
<?php echo $Language->SelectionForm(); ?>
<div class="clearfix"></div>
</div>
<?php } ?>
<?php $client_add->ShowPageHeader(); ?>
<?php
$client_add->ShowMessage();
?>
<form name="fclientadd" id="fclientadd" class="<?php echo $client_add->FormClassName ?>" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($client_add->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $client_add->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="client">
<?php if ($client->CurrentAction == "F") { // Confirm page ?>
<input type="hidden" name="a_add" id="a_add" value="A">
<input type="hidden" name="a_confirm" id="a_confirm" value="F">
<?php } else { ?>
<input type="hidden" name="a_add" id="a_add" value="F">
<?php } ?>
<?php if ($client_add->IsModal) { ?>
<input type="hidden" name="modal" value="1">
<?php } ?>
<div>
<?php if ($client->first->Visible) { // first ?>
	<div id="r_first" class="form-group">
		<label id="elh_client_first" for="x_first" class="col-sm-2 control-label ewLabel"><?php echo $client->first->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $client->first->CellAttributes() ?>>
<?php if ($client->CurrentAction <> "F") { ?>
<span id="el_client_first">
<input type="text" data-table="client" data-field="x_first" name="x_first" id="x_first" size="30" maxlength="30" placeholder="<?php echo ew_HtmlEncode($client->first->getPlaceHolder()) ?>" value="<?php echo $client->first->EditValue ?>"<?php echo $client->first->EditAttributes() ?>>
</span>
<?php } else { ?>
<span id="el_client_first">
<span<?php echo $client->first->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client->first->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client" data-field="x_first" name="x_first" id="x_first" value="<?php echo ew_HtmlEncode($client->first->FormValue) ?>">
<?php } ?>
<?php echo $client->first->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($client->last->Visible) { // last ?>
	<div id="r_last" class="form-group">
		<label id="elh_client_last" for="x_last" class="col-sm-2 control-label ewLabel"><?php echo $client->last->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $client->last->CellAttributes() ?>>
<?php if ($client->CurrentAction <> "F") { ?>
<span id="el_client_last">
<input type="text" data-table="client" data-field="x_last" name="x_last" id="x_last" size="30" maxlength="30" placeholder="<?php echo ew_HtmlEncode($client->last->getPlaceHolder()) ?>" value="<?php echo $client->last->EditValue ?>"<?php echo $client->last->EditAttributes() ?>>
</span>
<?php } else { ?>
<span id="el_client_last">
<span<?php echo $client->last->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client->last->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client" data-field="x_last" name="x_last" id="x_last" value="<?php echo ew_HtmlEncode($client->last->FormValue) ?>">
<?php } ?>
<?php echo $client->last->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($client->waived->Visible) { // waived ?>
	<div id="r_waived" class="form-group">
		<label id="elh_client_waived" for="x_waived" class="col-sm-2 control-label ewLabel"><?php echo $client->waived->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $client->waived->CellAttributes() ?>>
<?php if ($client->CurrentAction <> "F") { ?>
<span id="el_client_waived">
<select data-table="client" data-field="x_waived" data-value-separator="<?php echo $client->waived->DisplayValueSeparatorAttribute() ?>" id="x_waived" name="x_waived"<?php echo $client->waived->EditAttributes() ?>>
<?php echo $client->waived->SelectOptionListHtml("x_waived") ?>
</select>
<input type="hidden" name="s_x_waived" id="s_x_waived" value="<?php echo $client->waived->LookupFilterQuery() ?>">
</span>
<?php } else { ?>
<span id="el_client_waived">
<span<?php echo $client->waived->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client->waived->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client" data-field="x_waived" name="x_waived" id="x_waived" value="<?php echo ew_HtmlEncode($client->waived->FormValue) ?>">
<?php } ?>
<?php echo $client->waived->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($client->active->Visible) { // active ?>
	<div id="r_active" class="form-group">
		<label id="elh_client_active" for="x_active" class="col-sm-2 control-label ewLabel"><?php echo $client->active->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $client->active->CellAttributes() ?>>
<?php if ($client->CurrentAction <> "F") { ?>
<span id="el_client_active">
<select data-table="client" data-field="x_active" data-value-separator="<?php echo $client->active->DisplayValueSeparatorAttribute() ?>" id="x_active" name="x_active"<?php echo $client->active->EditAttributes() ?>>
<?php echo $client->active->SelectOptionListHtml("x_active") ?>
</select>
</span>
<?php } else { ?>
<span id="el_client_active">
<span<?php echo $client->active->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client->active->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client" data-field="x_active" name="x_active" id="x_active" value="<?php echo ew_HtmlEncode($client->active->FormValue) ?>">
<?php } ?>
<?php echo $client->active->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($client->service_month->Visible) { // service_month ?>
	<div id="r_service_month" class="form-group">
		<label id="elh_client_service_month" for="x_service_month" class="col-sm-2 control-label ewLabel"><?php echo $client->service_month->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $client->service_month->CellAttributes() ?>>
<?php if ($client->CurrentAction <> "F") { ?>
<span id="el_client_service_month">
<select data-table="client" data-field="x_service_month" data-value-separator="<?php echo $client->service_month->DisplayValueSeparatorAttribute() ?>" id="x_service_month" name="x_service_month"<?php echo $client->service_month->EditAttributes() ?>>
<?php echo $client->service_month->SelectOptionListHtml("x_service_month") ?>
</select>
<input type="hidden" name="s_x_service_month" id="s_x_service_month" value="<?php echo $client->service_month->LookupFilterQuery() ?>">
</span>
<?php } else { ?>
<span id="el_client_service_month">
<span<?php echo $client->service_month->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client->service_month->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client" data-field="x_service_month" name="x_service_month" id="x_service_month" value="<?php echo ew_HtmlEncode($client->service_month->FormValue) ?>">
<?php } ?>
<?php echo $client->service_month->CustomMsg ?></div></div>
	</div>
<?php } ?>
</div>
<?php
	if (in_array("client_budget", explode(",", $client->getCurrentDetailTable())) && $client_budget->DetailAdd) {
?>
<?php if ($client->getCurrentDetailTable() <> "") { ?>
<h4 class="ewDetailCaption"><?php echo $Language->TablePhrase("client_budget", "TblCaption") ?></h4>
<?php } ?>
<?php include_once "client_budgetgrid.php" ?>
<?php } ?>
<?php
	if (in_array("client_to_activity_code", explode(",", $client->getCurrentDetailTable())) && $client_to_activity_code->DetailAdd) {
?>
<?php if ($client->getCurrentDetailTable() <> "") { ?>
<h4 class="ewDetailCaption"><?php echo $Language->TablePhrase("client_to_activity_code", "TblCaption") ?></h4>
<?php } ?>
<?php include_once "client_to_activity_codegrid.php" ?>
<?php } ?>
<?php if (!$client_add->IsModal) { ?>
<div class="form-group">
	<div class="col-sm-offset-2 col-sm-10">
<?php if ($client->CurrentAction <> "F") { // Confirm page ?>
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit" onclick="this.form.a_add.value='F';"><?php echo $Language->Phrase("AddBtn") ?></button>
<button class="btn btn-default ewButton" name="btnCancel" id="btnCancel" type="button" data-href="<?php echo $client_add->getReturnUrl() ?>"><?php echo $Language->Phrase("CancelBtn") ?></button>
<?php } else { ?>
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit"><?php echo $Language->Phrase("ConfirmBtn") ?></button>
<button class="btn btn-default ewButton" name="btnCancel" id="btnCancel" type="submit" onclick="this.form.a_add.value='X';"><?php echo $Language->Phrase("CancelBtn") ?></button>
<?php } ?>
	</div>
</div>
<?php } ?>
</form>
<script type="text/javascript">
fclientadd.Init();
</script>
<?php
$client_add->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$client_add->Page_Terminate();
?>
