<?php
if (session_id() == "") session_start(); // Init session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg13.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql13.php") ?>
<?php include_once "phpfn13.php" ?>
<?php include_once "daily_acknowledgmentsinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn13.php" ?>
<?php

//
// Page class
//

$daily_acknowledgments_add = NULL; // Initialize page object first

class cdaily_acknowledgments_add extends cdaily_acknowledgments {

	// Page ID
	var $PageID = 'add';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'daily_acknowledgments';

	// Page object name
	var $PageObjName = 'daily_acknowledgments_add';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (daily_acknowledgments)
		if (!isset($GLOBALS["daily_acknowledgments"]) || get_class($GLOBALS["daily_acknowledgments"]) == "cdaily_acknowledgments") {
			$GLOBALS["daily_acknowledgments"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["daily_acknowledgments"];
		}

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'add', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'daily_acknowledgments', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	//
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanAdd()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("daily_acknowledgmentslist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Create form object
		$objForm = new cFormObj();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action
		$this->userlevel->SetVisibility();
		$this->date_from->SetVisibility();
		$this->date_through->SetVisibility();
		$this->message->SetVisibility();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $daily_acknowledgments;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($daily_acknowledgments);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();

			// Handle modal response
			if ($this->IsModal) {
				$row = array();
				$row["url"] = $url;
				echo ew_ArrayToJson(array($row));
			} else {
				header("Location: " . $url);
			}
		}
		exit();
	}
	var $FormClassName = "form-horizontal ewForm ewAddForm";
	var $IsModal = FALSE;
	var $DbMasterFilter = "";
	var $DbDetailFilter = "";
	var $StartRec;
	var $Priv = 0;
	var $OldRecordset;
	var $CopyRecord;

	// 
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError;
		global $gbSkipHeaderFooter;

		// Check modal
		$this->IsModal = (@$_GET["modal"] == "1" || @$_POST["modal"] == "1");
		if ($this->IsModal)
			$gbSkipHeaderFooter = TRUE;

		// Process form if post back
		if (@$_POST["a_add"] <> "") {
			$this->CurrentAction = $_POST["a_add"]; // Get form action
			$this->CopyRecord = FALSE;
			$this->LoadFormValues(); // Load form values
		} else { // Not post back
			$this->CopyRecord = FALSE;
			if ($this->CopyRecord) {
				$this->CurrentAction = "C"; // Copy record
			} else {
				$this->CurrentAction = "I"; // Display blank record
			}
		}

		// Set up Breadcrumb
		$this->SetupBreadcrumb();

		// Validate form if post back
		if (@$_POST["a_add"] <> "") {
			if (!$this->ValidateForm()) {
				$this->CurrentAction = "I"; // Form error, reset action
				$this->EventCancelled = TRUE; // Event cancelled
				$this->RestoreFormValues(); // Restore form values
				$this->setFailureMessage($gsFormError);
			}
		} else {
			if ($this->CurrentAction == "I") // Load default values for blank record
				$this->LoadDefaultValues();
		}

		// Perform action based on action code
		switch ($this->CurrentAction) {
			case "I": // Blank record, no action required
				break;
			case "C": // Copy an existing record
				if (!$this->LoadRow()) { // Load record based on key
					if ($this->getFailureMessage() == "") $this->setFailureMessage($Language->Phrase("NoRecord")); // No record found
					$this->Page_Terminate("daily_acknowledgmentslist.php"); // No matching record, return to list
				}
				break;
			case "A": // Add new record
				$this->SendEmail = TRUE; // Send email on add success
				if ($this->AddRow($this->OldRecordset)) { // Add successful
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage($Language->Phrase("AddSuccess")); // Set up success message
					$sReturnUrl = $this->getReturnUrl();
					if (ew_GetPageName($sReturnUrl) == "daily_acknowledgmentslist.php")
						$sReturnUrl = $this->AddMasterUrl($sReturnUrl); // List page, return to list page with correct master key if necessary
					elseif (ew_GetPageName($sReturnUrl) == "daily_acknowledgmentsview.php")
						$sReturnUrl = $this->GetViewUrl(); // View page, return to view page with keyurl directly
					$this->Page_Terminate($sReturnUrl); // Clean up and return
				} else {
					$this->EventCancelled = TRUE; // Event cancelled
					$this->RestoreFormValues(); // Add failed, restore form values
				}
		}

		// Render row based on row type
		$this->RowType = EW_ROWTYPE_ADD; // Render add type

		// Render row
		$this->ResetAttrs();
		$this->RenderRow();
	}

	// Get upload files
	function GetUploadFiles() {
		global $objForm, $Language;

		// Get upload data
	}

	// Load default values
	function LoadDefaultValues() {
		$this->userlevel->CurrentValue = NULL;
		$this->userlevel->OldValue = $this->userlevel->CurrentValue;
		$this->date_from->CurrentValue = NULL;
		$this->date_from->OldValue = $this->date_from->CurrentValue;
		$this->date_through->CurrentValue = NULL;
		$this->date_through->OldValue = $this->date_through->CurrentValue;
		$this->message->CurrentValue = NULL;
		$this->message->OldValue = $this->message->CurrentValue;
	}

	// Load form values
	function LoadFormValues() {

		// Load from form
		global $objForm;
		if (!$this->userlevel->FldIsDetailKey) {
			$this->userlevel->setFormValue($objForm->GetValue("x_userlevel"));
		}
		if (!$this->date_from->FldIsDetailKey) {
			$this->date_from->setFormValue($objForm->GetValue("x_date_from"));
			$this->date_from->CurrentValue = ew_UnFormatDateTime($this->date_from->CurrentValue, 0);
		}
		if (!$this->date_through->FldIsDetailKey) {
			$this->date_through->setFormValue($objForm->GetValue("x_date_through"));
			$this->date_through->CurrentValue = ew_UnFormatDateTime($this->date_through->CurrentValue, 0);
		}
		if (!$this->message->FldIsDetailKey) {
			$this->message->setFormValue($objForm->GetValue("x_message"));
		}
	}

	// Restore form values
	function RestoreFormValues() {
		global $objForm;
		$this->LoadOldRecord();
		$this->userlevel->CurrentValue = $this->userlevel->FormValue;
		$this->date_from->CurrentValue = $this->date_from->FormValue;
		$this->date_from->CurrentValue = ew_UnFormatDateTime($this->date_from->CurrentValue, 0);
		$this->date_through->CurrentValue = $this->date_through->FormValue;
		$this->date_through->CurrentValue = ew_UnFormatDateTime($this->date_through->CurrentValue, 0);
		$this->message->CurrentValue = $this->message->FormValue;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->userlevel->setDbValue($rs->fields('userlevel'));
		$this->date_from->setDbValue($rs->fields('date_from'));
		$this->date_through->setDbValue($rs->fields('date_through'));
		$this->message->setDbValue($rs->fields('message'));
		$this->updated_on->setDbValue($rs->fields('updated_on'));
		$this->updated_by->setDbValue($rs->fields('updated_by'));
		$this->added_on->setDbValue($rs->fields('added_on'));
		$this->added_by->setDbValue($rs->fields('added_by'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey->DbValue = $row['dbkey'];
		$this->userlevel->DbValue = $row['userlevel'];
		$this->date_from->DbValue = $row['date_from'];
		$this->date_through->DbValue = $row['date_through'];
		$this->message->DbValue = $row['message'];
		$this->updated_on->DbValue = $row['updated_on'];
		$this->updated_by->DbValue = $row['updated_by'];
		$this->added_on->DbValue = $row['added_on'];
		$this->added_by->DbValue = $row['added_by'];
	}

	// Load old record
	function LoadOldRecord() {

		// Load key values from Session
		$bValidKey = TRUE;

		// Load old recordset
		if ($bValidKey) {
			$this->CurrentFilter = $this->KeyFilter();
			$sSql = $this->SQL();
			$conn = &$this->Connection();
			$this->OldRecordset = ew_LoadRecordset($sSql, $conn);
			$this->LoadRowValues($this->OldRecordset); // Load row values
		} else {
			$this->OldRecordset = NULL;
		}
		return $bValidKey;
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Call Row_Rendering event

		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey
		// userlevel
		// date_from
		// date_through
		// message
		// updated_on
		// updated_by
		// added_on
		// added_by

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// userlevel
		if (strval($this->userlevel->CurrentValue) <> "") {
			$sFilterWrk = "`userlevelid`" . ew_SearchString("=", $this->userlevel->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `userlevelid`, `userlevelname` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `userlevels`";
		$sWhereWrk = "";
		$this->userlevel->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->userlevel, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->userlevel->ViewValue = $this->userlevel->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->userlevel->ViewValue = $this->userlevel->CurrentValue;
			}
		} else {
			$this->userlevel->ViewValue = NULL;
		}
		$this->userlevel->ViewCustomAttributes = "";

		// date_from
		$this->date_from->ViewValue = $this->date_from->CurrentValue;
		$this->date_from->ViewValue = ew_FormatDateTime($this->date_from->ViewValue, 0);
		$this->date_from->ViewCustomAttributes = "";

		// date_through
		$this->date_through->ViewValue = $this->date_through->CurrentValue;
		$this->date_through->ViewValue = ew_FormatDateTime($this->date_through->ViewValue, 0);
		$this->date_through->ViewCustomAttributes = "";

		// message
		$this->message->ViewValue = $this->message->CurrentValue;
		$this->message->ViewCustomAttributes = "";

		// updated_on
		$this->updated_on->ViewValue = $this->updated_on->CurrentValue;
		$this->updated_on->ViewValue = ew_FormatDateTime($this->updated_on->ViewValue, 0);
		$this->updated_on->ViewCustomAttributes = "";

		// updated_by
		if (strval($this->updated_by->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->updated_by->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->updated_by->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->updated_by, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->updated_by->ViewValue = $this->updated_by->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->updated_by->ViewValue = $this->updated_by->CurrentValue;
			}
		} else {
			$this->updated_by->ViewValue = NULL;
		}
		$this->updated_by->ViewCustomAttributes = "";

		// added_on
		$this->added_on->ViewValue = $this->added_on->CurrentValue;
		$this->added_on->ViewValue = ew_FormatDateTime($this->added_on->ViewValue, 0);
		$this->added_on->ViewCustomAttributes = "";

		// added_by
		if (strval($this->added_by->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->added_by->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->added_by->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->added_by, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->added_by->ViewValue = $this->added_by->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->added_by->ViewValue = $this->added_by->CurrentValue;
			}
		} else {
			$this->added_by->ViewValue = NULL;
		}
		$this->added_by->ViewCustomAttributes = "";

			// userlevel
			$this->userlevel->LinkCustomAttributes = "";
			$this->userlevel->HrefValue = "";
			$this->userlevel->TooltipValue = "";

			// date_from
			$this->date_from->LinkCustomAttributes = "";
			$this->date_from->HrefValue = "";
			$this->date_from->TooltipValue = "";

			// date_through
			$this->date_through->LinkCustomAttributes = "";
			$this->date_through->HrefValue = "";
			$this->date_through->TooltipValue = "";

			// message
			$this->message->LinkCustomAttributes = "";
			$this->message->HrefValue = "";
			$this->message->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_ADD) { // Add row

			// userlevel
			$this->userlevel->EditAttrs["class"] = "form-control";
			$this->userlevel->EditCustomAttributes = "";
			if (trim(strval($this->userlevel->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`userlevelid`" . ew_SearchString("=", $this->userlevel->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT `userlevelid`, `userlevelname` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `userlevels`";
			$sWhereWrk = "";
			$this->userlevel->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->userlevel, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->userlevel->EditValue = $arwrk;

			// date_from
			$this->date_from->EditAttrs["class"] = "form-control";
			$this->date_from->EditCustomAttributes = "";
			$this->date_from->EditValue = ew_HtmlEncode(ew_FormatDateTime($this->date_from->CurrentValue, 8));
			$this->date_from->PlaceHolder = ew_RemoveHtml($this->date_from->FldCaption());

			// date_through
			$this->date_through->EditAttrs["class"] = "form-control";
			$this->date_through->EditCustomAttributes = "";
			$this->date_through->EditValue = ew_HtmlEncode(ew_FormatDateTime($this->date_through->CurrentValue, 8));
			$this->date_through->PlaceHolder = ew_RemoveHtml($this->date_through->FldCaption());

			// message
			$this->message->EditAttrs["class"] = "form-control";
			$this->message->EditCustomAttributes = "";
			$this->message->EditValue = ew_HtmlEncode($this->message->CurrentValue);
			$this->message->PlaceHolder = ew_RemoveHtml($this->message->FldCaption());

			// Add refer script
			// userlevel

			$this->userlevel->LinkCustomAttributes = "";
			$this->userlevel->HrefValue = "";

			// date_from
			$this->date_from->LinkCustomAttributes = "";
			$this->date_from->HrefValue = "";

			// date_through
			$this->date_through->LinkCustomAttributes = "";
			$this->date_through->HrefValue = "";

			// message
			$this->message->LinkCustomAttributes = "";
			$this->message->HrefValue = "";
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate form
	function ValidateForm() {
		global $Language, $gsFormError;

		// Initialize form error message
		$gsFormError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return ($gsFormError == "");
		if (!$this->userlevel->FldIsDetailKey && !is_null($this->userlevel->FormValue) && $this->userlevel->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->userlevel->FldCaption(), $this->userlevel->ReqErrMsg));
		}
		if (!$this->date_from->FldIsDetailKey && !is_null($this->date_from->FormValue) && $this->date_from->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->date_from->FldCaption(), $this->date_from->ReqErrMsg));
		}
		if (!ew_CheckDateDef($this->date_from->FormValue)) {
			ew_AddMessage($gsFormError, $this->date_from->FldErrMsg());
		}
		if (!$this->date_through->FldIsDetailKey && !is_null($this->date_through->FormValue) && $this->date_through->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->date_through->FldCaption(), $this->date_through->ReqErrMsg));
		}
		if (!ew_CheckDateDef($this->date_through->FormValue)) {
			ew_AddMessage($gsFormError, $this->date_through->FldErrMsg());
		}
		if (!$this->message->FldIsDetailKey && !is_null($this->message->FormValue) && $this->message->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->message->FldCaption(), $this->message->ReqErrMsg));
		}

		// Return validate result
		$ValidateForm = ($gsFormError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateForm = $ValidateForm && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsFormError, $sFormCustomError);
		}
		return $ValidateForm;
	}

	// Add record
	function AddRow($rsold = NULL) {
		global $Language, $Security;
		$conn = &$this->Connection();

		// Load db values from rsold
		if ($rsold) {
			$this->LoadDbValues($rsold);
		}
		$rsnew = array();

		// userlevel
		$this->userlevel->SetDbValueDef($rsnew, $this->userlevel->CurrentValue, NULL, FALSE);

		// date_from
		$this->date_from->SetDbValueDef($rsnew, ew_UnFormatDateTime($this->date_from->CurrentValue, 0), NULL, FALSE);

		// date_through
		$this->date_through->SetDbValueDef($rsnew, ew_UnFormatDateTime($this->date_through->CurrentValue, 0), NULL, FALSE);

		// message
		$this->message->SetDbValueDef($rsnew, $this->message->CurrentValue, NULL, FALSE);

		// Call Row Inserting event
		$rs = ($rsold == NULL) ? NULL : $rsold->fields;
		$bInsertRow = $this->Row_Inserting($rs, $rsnew);
		if ($bInsertRow) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			$AddRow = $this->Insert($rsnew);
			$conn->raiseErrorFn = '';
			if ($AddRow) {

				// Get insert id if necessary
				$this->dbkey->setDbValue($conn->Insert_ID());
				$rsnew['dbkey'] = $this->dbkey->DbValue;
			}
		} else {
			if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

				// Use the message, do nothing
			} elseif ($this->CancelMessage <> "") {
				$this->setFailureMessage($this->CancelMessage);
				$this->CancelMessage = "";
			} else {
				$this->setFailureMessage($Language->Phrase("InsertCancelled"));
			}
			$AddRow = FALSE;
		}
		if ($AddRow) {

			// Call Row Inserted event
			$rs = ($rsold == NULL) ? NULL : $rsold->fields;
			$this->Row_Inserted($rs, $rsnew);
		}
		return $AddRow;
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, $this->AddMasterUrl("daily_acknowledgmentslist.php"), "", $this->TableVar, TRUE);
		$PageId = ($this->CurrentAction == "C") ? "Copy" : "Add";
		$Breadcrumb->Add("add", $PageId, $url);
	}

	// Setup lookup filters of a field
	function SetupLookupFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		case "x_userlevel":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT `userlevelid` AS `LinkFld`, `userlevelname` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `userlevels`";
			$sWhereWrk = "";
			$this->userlevel->LookupFilters = array();
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`userlevelid` = {filter_value}', "t0" => "3", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->userlevel, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		}
	}

	// Setup AutoSuggest filters of a field
	function SetupAutoSuggestFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($daily_acknowledgments_add)) $daily_acknowledgments_add = new cdaily_acknowledgments_add();

// Page init
$daily_acknowledgments_add->Page_Init();

// Page main
$daily_acknowledgments_add->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$daily_acknowledgments_add->Page_Render();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "add";
var CurrentForm = fdaily_acknowledgmentsadd = new ew_Form("fdaily_acknowledgmentsadd", "add");

// Validate form
fdaily_acknowledgmentsadd.Validate = function() {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	var $ = jQuery, fobj = this.GetForm(), $fobj = $(fobj);
	if ($fobj.find("#a_confirm").val() == "F")
		return true;
	var elm, felm, uelm, addcnt = 0;
	var $k = $fobj.find("#" + this.FormKeyCountName); // Get key_count
	var rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1;
	var startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
	var gridinsert = $fobj.find("#a_list").val() == "gridinsert";
	for (var i = startcnt; i <= rowcnt; i++) {
		var infix = ($k[0]) ? String(i) : "";
		$fobj.data("rowindex", infix);
			elm = this.GetElements("x" + infix + "_userlevel");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $daily_acknowledgments->userlevel->FldCaption(), $daily_acknowledgments->userlevel->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_date_from");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $daily_acknowledgments->date_from->FldCaption(), $daily_acknowledgments->date_from->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_date_from");
			if (elm && !ew_CheckDateDef(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($daily_acknowledgments->date_from->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_date_through");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $daily_acknowledgments->date_through->FldCaption(), $daily_acknowledgments->date_through->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_date_through");
			if (elm && !ew_CheckDateDef(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($daily_acknowledgments->date_through->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_message");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $daily_acknowledgments->message->FldCaption(), $daily_acknowledgments->message->ReqErrMsg)) ?>");

			// Fire Form_CustomValidate event
			if (!this.Form_CustomValidate(fobj))
				return false;
	}

	// Process detail forms
	var dfs = $fobj.find("input[name='detailpage']").get();
	for (var i = 0; i < dfs.length; i++) {
		var df = dfs[i], val = df.value;
		if (val && ewForms[val])
			if (!ewForms[val].Validate())
				return false;
	}
	return true;
}

// Form_CustomValidate event
fdaily_acknowledgmentsadd.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fdaily_acknowledgmentsadd.ValidateRequired = true;
<?php } else { ?>
fdaily_acknowledgmentsadd.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fdaily_acknowledgmentsadd.Lists["x_userlevel"] = {"LinkField":"x_userlevelid","Ajax":true,"AutoFill":false,"DisplayFields":["x_userlevelname","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"userlevels"};

// Form object for search
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php if (!$daily_acknowledgments_add->IsModal) { ?>
<div class="ewToolbar">
<?php $Breadcrumb->Render(); ?>
<?php echo $Language->SelectionForm(); ?>
<div class="clearfix"></div>
</div>
<?php } ?>
<?php $daily_acknowledgments_add->ShowPageHeader(); ?>
<?php
$daily_acknowledgments_add->ShowMessage();
?>
<form name="fdaily_acknowledgmentsadd" id="fdaily_acknowledgmentsadd" class="<?php echo $daily_acknowledgments_add->FormClassName ?>" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($daily_acknowledgments_add->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $daily_acknowledgments_add->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="daily_acknowledgments">
<input type="hidden" name="a_add" id="a_add" value="A">
<?php if ($daily_acknowledgments_add->IsModal) { ?>
<input type="hidden" name="modal" value="1">
<?php } ?>
<div>
<?php if ($daily_acknowledgments->userlevel->Visible) { // userlevel ?>
	<div id="r_userlevel" class="form-group">
		<label id="elh_daily_acknowledgments_userlevel" for="x_userlevel" class="col-sm-2 control-label ewLabel"><?php echo $daily_acknowledgments->userlevel->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $daily_acknowledgments->userlevel->CellAttributes() ?>>
<span id="el_daily_acknowledgments_userlevel">
<select data-table="daily_acknowledgments" data-field="x_userlevel" data-value-separator="<?php echo $daily_acknowledgments->userlevel->DisplayValueSeparatorAttribute() ?>" id="x_userlevel" name="x_userlevel"<?php echo $daily_acknowledgments->userlevel->EditAttributes() ?>>
<?php echo $daily_acknowledgments->userlevel->SelectOptionListHtml("x_userlevel") ?>
</select>
<input type="hidden" name="s_x_userlevel" id="s_x_userlevel" value="<?php echo $daily_acknowledgments->userlevel->LookupFilterQuery() ?>">
</span>
<?php echo $daily_acknowledgments->userlevel->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($daily_acknowledgments->date_from->Visible) { // date_from ?>
	<div id="r_date_from" class="form-group">
		<label id="elh_daily_acknowledgments_date_from" for="x_date_from" class="col-sm-2 control-label ewLabel"><?php echo $daily_acknowledgments->date_from->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $daily_acknowledgments->date_from->CellAttributes() ?>>
<span id="el_daily_acknowledgments_date_from">
<input type="text" data-table="daily_acknowledgments" data-field="x_date_from" name="x_date_from" id="x_date_from" placeholder="<?php echo ew_HtmlEncode($daily_acknowledgments->date_from->getPlaceHolder()) ?>" value="<?php echo $daily_acknowledgments->date_from->EditValue ?>"<?php echo $daily_acknowledgments->date_from->EditAttributes() ?>>
<?php if (!$daily_acknowledgments->date_from->ReadOnly && !$daily_acknowledgments->date_from->Disabled && !isset($daily_acknowledgments->date_from->EditAttrs["readonly"]) && !isset($daily_acknowledgments->date_from->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fdaily_acknowledgmentsadd", "x_date_from", 0);
</script>
<?php } ?>
</span>
<?php echo $daily_acknowledgments->date_from->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($daily_acknowledgments->date_through->Visible) { // date_through ?>
	<div id="r_date_through" class="form-group">
		<label id="elh_daily_acknowledgments_date_through" for="x_date_through" class="col-sm-2 control-label ewLabel"><?php echo $daily_acknowledgments->date_through->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $daily_acknowledgments->date_through->CellAttributes() ?>>
<span id="el_daily_acknowledgments_date_through">
<input type="text" data-table="daily_acknowledgments" data-field="x_date_through" name="x_date_through" id="x_date_through" placeholder="<?php echo ew_HtmlEncode($daily_acknowledgments->date_through->getPlaceHolder()) ?>" value="<?php echo $daily_acknowledgments->date_through->EditValue ?>"<?php echo $daily_acknowledgments->date_through->EditAttributes() ?>>
<?php if (!$daily_acknowledgments->date_through->ReadOnly && !$daily_acknowledgments->date_through->Disabled && !isset($daily_acknowledgments->date_through->EditAttrs["readonly"]) && !isset($daily_acknowledgments->date_through->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fdaily_acknowledgmentsadd", "x_date_through", 0);
</script>
<?php } ?>
</span>
<?php echo $daily_acknowledgments->date_through->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($daily_acknowledgments->message->Visible) { // message ?>
	<div id="r_message" class="form-group">
		<label id="elh_daily_acknowledgments_message" class="col-sm-2 control-label ewLabel"><?php echo $daily_acknowledgments->message->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $daily_acknowledgments->message->CellAttributes() ?>>
<span id="el_daily_acknowledgments_message">
<?php ew_AppendClass($daily_acknowledgments->message->EditAttrs["class"], "editor"); ?>
<textarea data-table="daily_acknowledgments" data-field="x_message" name="x_message" id="x_message" cols="35" rows="4" placeholder="<?php echo ew_HtmlEncode($daily_acknowledgments->message->getPlaceHolder()) ?>"<?php echo $daily_acknowledgments->message->EditAttributes() ?>><?php echo $daily_acknowledgments->message->EditValue ?></textarea>
<script type="text/javascript">
ew_CreateEditor("fdaily_acknowledgmentsadd", "x_message", 35, 4, <?php echo ($daily_acknowledgments->message->ReadOnly || FALSE) ? "true" : "false" ?>);
</script>
</span>
<?php echo $daily_acknowledgments->message->CustomMsg ?></div></div>
	</div>
<?php } ?>
</div>
<?php if (!$daily_acknowledgments_add->IsModal) { ?>
<div class="form-group">
	<div class="col-sm-offset-2 col-sm-10">
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit"><?php echo $Language->Phrase("AddBtn") ?></button>
<button class="btn btn-default ewButton" name="btnCancel" id="btnCancel" type="button" data-href="<?php echo $daily_acknowledgments_add->getReturnUrl() ?>"><?php echo $Language->Phrase("CancelBtn") ?></button>
	</div>
</div>
<?php } ?>
</form>
<script type="text/javascript">
fdaily_acknowledgmentsadd.Init();
</script>
<?php
$daily_acknowledgments_add->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$daily_acknowledgments_add->Page_Terminate();
?>
