<?php
class form {

	var $_code = array();
	var $_desc = array();
	var $_input = '';
	var $default_text = '';

	function form() {
		$this->_code = array();
		$this->_desc = array();
		$this->default_text = "Select a value";
	}

	/**
	* Display Errors on a page...
	*
	* @param unknown_type $code
	* @param unknown_type $error_code
	* @param unknown_type $error_desc
	* @param unknown_type $columns
	*/
	function _errors($code,$columns=1) {
		$elem=0;
		while ($elem <= (count($this->_code)) ) {
			if (trim($this->_code[$elem]) == trim($code)) { ?>
      <tr>
        <td colspan=<?php echo"$columns";?>>
        	&nbsp;&nbsp;<i><font size="4" color="#250517"><error>
						<?php	echo $this->_desc[$elem];?>
          </error></font></i>
        </td>
      </tr><?php
			}
			$elem++;
		}
	}
	
	function _set_default_text($temp) {
		$this->default_text = $temp;
		$this->default_set = true;
		return true;
	}
	
	function _set_input($input) {
		$this->_input = $input;
		return true;
	}
	
	function _table_description($key,$value) {
		$db = new database();
		$db->_connect();
		$sql = "SELECT `description` FROM `" . $_SESSION[FILE_PREFIX] . "tables_data` WHERE `dbkey_tables` = '$key' AND `dbkey` = '$value' LIMIT 1";
		if ($db->_query($sql)) {
			while ($data=$db->_fetch()) {
				return $data[description];
			}
		}
		return FALSE;
	}

	
	function _tables($table,$value,$name="") {
	if($name=="") {
		$name=$table;
	}
	
	$db = new database();
	$db->_connect(); ?>
  <select <?php echo $this->_input; ?> name="<?php echo $name ?>">
  
  <?php if (trim($this->default_text) <> '') { ?> <option value=""><?php echo $this->default_text; ?></option> <?php  }  ?>
  <?php $sql = "SELECT dbkey, description FROM " . $_SESSION[FILE_PREFIX] . "tables_data WHERE dbkey_tables='".$table."'";
		
		if ($db->_query($sql)) {
			while ($data=$db->_fetch()) {
				$selected = "";
				//new debug(false,$data[dbkey]);
				if($data[dbkey] == $value) {
					$selected = " selected=selected";
				} ?>
       <option value="<?php echo $data[dbkey];?>"<?php echo $selected;?>><?php echo $data[description];?></option> <?php	
			} 
		} ?>
    </select> <?php 	
	//new debug(true,$sql);
	}
	
	/**
	* Show Primary File Names drop downs 
	*
	*/
	function _key_file($file,$value,$name="",$player_dbkey=0) {
			if($name=="") {
				$name=$file;
			}
			$db = new database();
			$db->_connect(); 
			switch ($file) {
				
				case "user":
					$sql = "SELECT dbkey AS value, CONCAT(email, ' - ',first, ' ', last) AS name
									  FROM " . $_SESSION[FILE_PREFIX] . "site_admin";		  
					break;
				case "authority":
					$sql = "SELECT type AS value, description AS name
									  FROM " . $_SESSION[FILE_PREFIX] . "site_admin_authority";		  
					break;
				
			}
			?>
		<select name="<?php echo $name ?>" id="<?php echo $name ?>">
		<?php
				if ($db->_query($sql)) {
					while ($data=$db->_fetch()) {
						$selected = "";
						if($data[value] == $value) {
							$selected = " selected=selected";
						} ?>
	  <option value="<?php echo $data[value];?>"<?php echo $selected;?>><?php echo $data[name];?></option>
	  <?php	
					} 
				} ?>
	</select><?php
	}
	
	function _add_code($code, $description,$parent) {
			$error = array();
			// check access type and validate this user has access to it. Return true or false based on that. 
			$db = new database();
			$db->_connect();
			
			// Verify no active users are using this group.
			$sql = "SELECT * from `vss_tables_data` where `dbkey_tables` = '" . $parent . "' and (`dbkey` = '" . $code . "' or `description` = '" . $description . "')";
			if ($db->_query($sql))  
				if ($data=$db->_fetch())
				{
						$error2 .= "code " . $code .  " or description " . $description . " already exists. Please choose a code and description that does not exist.</br> ";
				}
			if ($code == '') $error2 .= "Invalid code entered.</br> ";
			if ($description == '') $error2 .= "Invalid description entered.</br> ";
					
			if($error2){
				$error['code'] = $error2;
			}
			else 
			{
				//echo "<h1> $access_type,$auth_status </h1>";
				$sql = "insert into `vss_tables_data` set `dbkey_tables` = '". $parent . "', dbkey = '" . $code . "', `description` = '" . $description . "'"; 
					
				$db->_query($sql);
			}
			return $error;
	}
	
	function _delete_code($code, $parent) {
			$error = array();
			
			// check access type and validate this user has access to it. Return true or false based on that. 
			$db = new database();
			$db->_connect();
			
			// Verify no active users are using this group.
					
		
			if($error2){
				$error['code'] = $error2;
			}
			
			else
			 {
				//echo "<h1> $access_type,$auth_status </h1>";
				$sql = "delete from `vss_tables_data` where `dbkey_tables` = '" . $parent . "' and dbkey = '" . $code . "'"; 	
				
				$db->_query($sql);
			 }
			return $error;		
	}
	
	function _update_code($parent,$code, $active) {
			$error = array();
			
			// check access type and validate this user has access to it. Return true or false based on that. 
			$db = new database();
			$db->_connect();
			
			// Verify no active users are using this group.
					
		
			if($error2){
				$error['code'] = $error2;
			}
			
			else
			 {
				//echo "<h1> $access_type,$auth_status </h1>";
				$sql = "update `vss_tables_data` set `status` = '". $active . " ' where `dbkey_tables` = '" . $parent . "' and dbkey = '" . $code . "'"; 	
				//new debug(true,$sql);
				$db->_query($sql);
			 }
			return $error;		
	}
	
	
	//------------------------------------
	// Return information 
	//------------------------------------
	function _return_all_codes($parent) {
		$db = new database();
		$db->_connect();
		$index = 0;
		$sql = "SELECT `dbkey`,`description`,`status` FROM `" . $_SESSION[FILE_PREFIX] . "tables_data` WHERE `dbkey_tables` = '". $parent . "' order by `status` asc";
		//echo "<h1>Made IT $sql</h1>";
		if ($db->_query($sql)) {
				while ($data=$db->_fetch()) {
					$all_users[$index +=1] = $data;
				}
				return $all_users;
			}
		return FALSE;
	}
}