<?php
// Class meta
// Use: used to build meta information for sites. Just pass in site id and code where the code indicates a reference to a specific page. If the table is set up this will load meta data to send to that page. 
class meta {
// Class variables
var $code = '';
var $siteid = '';
var $default = TRUE;
var $common = TRUE;
var $meta_list_info = array();

	function __construct() {
		$this->code = substr($_SERVER["SCRIPT_NAME"],strrpos($_SERVER["SCRIPT_NAME"],"/")+1);
			$this->siteid = SITE_ID;
			$this->default = TRUE;
			$this->common = TRUE;
			$a = func_get_args(); 
			$i = func_num_args(); 
			if (method_exists($this,$f='__construct'.$i)) { 
				call_user_func_array(array($this,$f),$a); 
			} 
	}
			
	// if only code is passed in then use current site id will be used.
	function __construct1($code) {
			$this->default = TRUE;
			$this->common = TRUE;
			$this->code = $code;
			$this->siteid = SITE_ID;
			// If the correct type was passed in then load the pdf location.
			if ($this->valid_code()) {
				return true;
			}
			else {
				return false;
			}
	}

	// standard call, pass in siteid and code 
	function __construct2($siteid, $code) { 	
		$this->default = TRUE;
		$this->common = TRUE;
	 	$this->code = $code;
		$this->siteid = $siteid;
		// If the correct type was passed in then load the pdf location.
		if ($this->valid_type()) {
			return true;
		}
		else return false;
	}

	// Validate type field
	function valid_code() {
		$db = new database();
		$db->_connect();
		$sql = "select * from schf_meta where `code` = '". $this->code ."' and `siteid` = '".$this->siteid."'";
		if ($db->_query($sql)) {
				if ($data=$db->_fetch()) {
					return true;                             
				}
		}
		return FALSE;
	}
	
	// Turn off default meta
	function _term_default() {
	 $this->default = FALSE;
	 return true;
	}
	// Turn off default meta
	function _term_common() {
	 $this->common = FALSE;
	 return true;
	}
	
	 
	// Turn off common meta
	
	// _load_meta_list: loads array of all meta based on input. 
	function _load_meta_list_info() {
		$db = new database();
		$db->_connect();
		
		$select_add1 = "`dbkey`,`sequence`, concat(concat('<meta ',`meta_text`),' >') as meta_text";
		
		// Set common meta if true first
		$additional_where = '';
		if ($this->common == TRUE) {
		
			$where_add1 = "`code` = 'common' and `siteid` = '".$this->siteid."'";
			$order_add1 = "`sequence`";
			$sql = "SELECT " . $select_add1 . " FROM schf_meta where " . $where_add1 . " order by " . $order_add1;
			//echo $sql;
				if ($db->_query($sql)) {
					while ($data=$db->_fetch()) {
						$this->meta_list_info[$data[dbkey]] = $data;
					}
					
				}
		}
			
		// Set common meta if true
		$select_add1 = "`dbkey`,`sequence`, concat(concat('<meta ',`meta_text`),' >') as meta_text";
		$where_add1 = "`code` = '".$this->code."' and `siteid` = '".$this->siteid."'";
		$order_add1 = "`sequence`";
		$sql = "SELECT " . $select_add1 . " FROM schf_meta where " . $where_add1 . " order by " . $order_add1;
		//echo $sql;
			if ($db->_query($sql)) {
				while ($data=$db->_fetch()) {
					$this->meta_list_info[$data[dbkey]] = $data;
				}
			}
			else
			{
				// Check for defult
				if ($this->defult == TRUE) {
					$where_add1 = "`code` = 'default' and `siteid` = '".$this->siteid."'";
					$order_add1 = "`sequence`";
					$sql = "SELECT " . $select_add1 . " FROM schf_meta where " . $where_add1 . " order by " . $order_add1;
					//echo $sql;
					if ($db->_query($sql)) {
						while ($data=$db->_fetch()) {
							$this->meta_list_info[$data[dbkey]] = $data;
						}
					}
				}
				
			}
		return $this->meta_list_info;
	}

// Based on dbkey (usually from load_list array) this will load all values for a given event into this class
function _load_meta($meta_data) {
	// Connect to db
	// run through all records based off event_dbkey
	// load fields
		$this->meta_text = $meta_data[meta_text];
		return true;
}

function _display_all_meta() {
		$count = 0;
		if ($this->_load_meta_list_info()) {
			foreach ($this->meta_list_info as $data) {
				$this->_load_meta($data);
				echo $this->meta_text;
				$count += 1;
			}
		}
		if ($count > 0) return true; else return false;
}

}
?>