<?php
require('includes/fpdf/fpdf.php');
class my_pdf extends FPDF {

var $dbkey_quote;
var $path_file; 


	function my_pdf() {
		
	}
	
	function __construct() {
		parent::FPDF();

		$a = func_get_args(); 
      $i = func_num_args(); 
      if (method_exists($this,$f='__construct'.$i)) { 
          call_user_func_array(array($this,$f),$a); 
      } 
	}
	
	// default constructor.
	function __construct0() {
			
			parent::FPDF();
		
			// Create user
			$user = new user();
			$this->dbkey_user = $_SESSION[admin_dbkey];
			
			// Other defaults
			$this->path = NULL;
			
			return true;
	}	
		
	// constructor with on var. Will not use but have it here for later use.  
	function __construct1($dbkey) {
				// Set quote
				$this->_set_quote($dbkey);
							
				// Create user
				$user = new user();
				$this->dbkey_user = $_SESSION[admin_dbkey];
			
				// Other defaults
				$this->path = NULL;
				
				return true;	
	}

	//------------------------------------------------------------------------------
	// Set Functions here	
	//------------------------------------------------------------------------------
	function _set_quote($temp) {
		$this->dbkey_quote = $temp;
		return true;	
	}
	
	function _set_path_file($temp) {
		$this->path_file = $temp;
		return true;	
	}
	
	//******************************************************************
	// Validation functions 
	//******************************************************************
	function _validate_dbkey_quote() {
		$error = array();
		//if (trim($this->subject) == '') $error2 .= "Subject required.";
		if($error2){
			$error['dbkey_quote'] = $error2;
		}
		return $error;	
	}
	
	function _validate_path() {
		$error = array();
		//if (trim($this->subject) == '') $error2 .= "Subject required.";
		if($error2){
			$error['path'] = $error2;
		}
		return $error;	
	}
	
	function _validate_name() {
		$error = array();
		//if (trim($this->subject) == '') $error2 .= "Subject required.";
		if($error2){
			$error['name'] = $error2;
		}
		return $error;	
	}

//	
// This is the template for quotes	
//
function _create_pdf() {
	$quote = new quote($this->dbkey_quote);
	$quote_info = $quote->_load_info();
	
	// Create Headers
	$width_quantity = 15;
	$width_part_number = 44;
	$width_description = 97;
	$width_unit_price = 20;
	$width_extended = 22;
	
	$total_width = $width_quantity + $width_part_number + $width_description + $width_unit_price + $width_extended;

	// Standard
	$standard_font = 'Arial';
	$standard_font_size = 10;
	$cell_height = 4;
	
	//PDF Defaults and attributes
	$this->AddPage();
	$this->SetFont($standard_font,'',$standard_font_size);	
	$this->SetLineWidth(1);
	$this->SetLeftMargin(5);
	$this->SetTopMargin(20);
	$user = new user;
	$user_info = $user->_load_info();
	$name = $user_info['first'] . " " . $user_info['last'];
	$this->SetAuthor($name);
	$this->SetCreator($name);
	$this->SetSubject("NBS Quotation");
 	$this->SetTitle("NBS Quote " . $quote_info['quote_number'] ); 
	$this->SetTextColor(0);	
	
   
   	$this->Image('images/nbslogo.png',5,13,30,30);
   //Heading text 
    
	$widthc1 = 30;
	$widthc2 = 85;
	$this->Ln(5);
   	// Load bill to and ship to
	$this->SetFont($standard_font,'B',$standard_font_size);	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"NBS Calibrations",'',0,'L',$fill);
	$this->SetFont($standard_font,'B',20);
	$this->Cell($total_width - $widthc2 - $widthc1,$cell_height,"Quotation",'',0,'R',$fill);  $this->SetFont($standard_font,'',$standard_font_size);	
	$this->SetFont($standard_font,'',$standard_font_size);
	$this->Ln();
   	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"9556 West Bloomington Freeway",'',0,'L',$fill);$this->Ln();
   	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"Bloomington, MN 55431",'',0,'L',$fill);$this->Ln();
	$this->Cell($total_width,$cell_height,"Quotation Number " . $quote_info['quote_number'],'',0,'R',$fill); $this->Ln();
	
	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"800.722.5398 Toll Free",'',0,'L',$fill);$this->Ln();
	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"952.881.7716 Local",'',0,'L',$fill);$this->Ln();
	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"952.881.7309 Fax",'',0,'L',$fill);$this->Ln();
	$date = substr($quote_info['quote_date'],5,2) . "/" . substr($quote_info['quote_date'],8,2) . "/" . substr($quote_info['quote_date'],2,2); 
	$this->Cell($total_width,$cell_height,"Date: " . $date,'',0,'R',$fill); $this->Ln();
	
   	//$this->Image('../images/logo.png',10,20,33,0,' ','http://www.northernbalance.com/');
    $this->Ln();
	$widthc1 = 20;
	$widthc2 = 80;
	$widthc3 = 20;
	$widthc4 = 80;
	// Load Bill to
	$CSZ = $quote_info['sold_to_city'] . "," . $quote_info['sold_to_state'] . " " . $quote_info['sold_to_zip'];
	if (substr(trim($CSZ),0,1) == ",") $CSZ = substr(trim($CSZ),1,100);
	$t[0] = $quote_info['sold_to_customer_name']; 
	$t[1] = $quote_info['sold_to_adr1'];
	$t[2] = $quote_info['sold_to_adr2'];
	$t[3] = $CSZ;
	
	$b[0] = ''; 
	$b[1] = '';
	$b[2] = '';
	$b[3] = '';
	
	$x = 0;
	for ($i=0; $i <= 3;) {
		if (trim($t[$i]) <> '') {
			$b[$x] = $t[$i];
			$x += 1;
		}
		$i += 1;
	}
	
	
	
	
	
	
	
	// Load ship to
	$CSZ = $quote_info['ship_to_city'] . "," . $quote_info['ship_to_state'] . " " . $quote_info['ship_to_zip'];
	if (substr(trim($CSZ),0,1) == ",") $CSZ = substr(trim($CSZ),1,100);


	$t[0] = $quote_info['customer_name']; 
	$t[1] = $quote_info['ship_to_adr1'];
	$t[2] = $quote_info['ship_to_adr2'];
	$t[3] = $CSZ;
	$t[4] = 'Attn:' . $quote_info['attention'];;
	
	
	$s[0] = ''; 
	$s[1] = '';
	$s[2] = '';
	$s[3] = '';
	$s[4] = '';
	
	$x = 0;
	for ($i=0; $i <= 4;) {
		if (trim($t[$i]) <> '') {
			$s[$x] = $t[$i];
			$x += 1;
		}
		$i += 1;
	}
	
	
	
   	// Load bill to and ship to
	$this->Cell($widthc1,$cell_height,"Ship To:",'',0,'L',$fill); $this->Cell($widthc2,$cell_height,$s[0],'',0,'L',$fill); $this->Cell($widthc3,$cell_height,"Bill To:",'',0,'L',$fill); $this->Cell($widthc4,$cell_height,$b[0],'',0,'L',$fill);$this->Ln();
   	
	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,$s[1],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc4,$cell_height,$b[1],'',0,'L',$fill); $this->Ln();
	
	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,$s[2],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,"",'',0,'L',$fill); 
	$this->Cell($widthc4,$cell_height,$b[2],'',0,'L',$fill); $this->Ln();
	
   	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,$s[3],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc4,$cell_height,$b[3],'',0,'L',$fill); $this->Ln();
		$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,$s[4],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc4,$cell_height,$b[4],'',0,'L',$fill); $this->Ln();

	
	$this->Ln();
	
	// set phone fax
	$width1 = 90;
	$this->Cell(17,$cell_height,'Phone:','',0,'L',$fill);$this->Cell($width1,$cell_height,$quote_info['phone'],'',0,'L',$fill);$this->Cell(15,$cell_height,'E-mail:','',0,'R',$fill);$this->Cell(15,$cell_height,$quote_info['email'],'',0,'L',$fill);$this->Ln();
	$this->Cell(17,$cell_height,'Cust ID:','',0,'L',$fill);$this->Cell($width1 + 5,$cell_height,trim($quote_info['id'] . " " ),'',0,'L',$fill);$this->Cell(15,$cell_height,'','',0,'R',$fill);$this->Cell(15,$cell_height,'',0,'L',$fill); $this->Ln();
	
	
	
	// Colors, line width and bold font
    $this->SetAutoPageBreak(true,10); 
	$this->SetFillColor(224,224,224);
    $this->SetDrawColor(0,0,0);
    $this->SetLineWidth(.3);
	  
	
	$this->Ln();    	
   
   
    // Data
    $fill = false;
	
	
	
	
	$this->Cell($width_quantity,$cell_height,'Quantity','LTB',0,'L',$fill);
    $this->Cell($width_part_number,$cell_height,'Part Number','TB',0,'L',$fill);
    $this->Cell($width_description,$cell_height,'Description','TB',0,'L',$fill);
    $this->Cell($width_unit_price,$cell_height,'Unit Price','TB',0,'L',$fill);
	$this->Cell($width_extended,$cell_height,'Extended','TBR',0,'L',$fill);
	
	$x = 1;
	if ($end = count($quote->quote_info_dtl) ){
		foreach ($quote->quote_info_dtl as $key => $val) {
			// Determin dynamic height of each row
			$w1 = $this->GetStringWidth($val['description']);
			$w2 = $this->GetStringWidth($val['part_number']);
			$border = 'LR';
			// Calc multiplier for height
			if ($w1 / $width_description > $w2 / $width_part_number) $hmultiplier = ceil($w1 / $width_description); else  $hmultiplier = ceil($w2 / $width_part_number);
			$hmultiplier = 1;
			//echo "w1 is " . $w1 . "description " . $width_description . " mul is " . $hmultiplier . "<br>";
			
			$this->Ln();
			
			
			//if ($val['calculate'] == 1) $calc = "*"; else $calc = ""; 
			if ($val['quantity'] <> 0) $this->Cell($width_quantity,$cell_height * $hmultiplier ,number_format($val['quantity'],1),$border,0,'C',$fill); else
			$this->Cell($width_quantity,$cell_height * $hmultiplier ,'',$border,0,'C',$fill);
			
        	$this->Cell($width_part_number,$cell_height * $hmultiplier,substr($val['part_number'],0,$quote->part_max_length),$border,0,'L',$fill);
        	$this->Cell($width_description,$cell_height * $hmultiplier,substr($val['description'],0,$quote->description_max_length),$border,0,'L',$fill);
        	
			if ($val['unit_price'] <> 0)
			$this->Cell($width_unit_price,$cell_height * $hmultiplier,'$' . number_format($val['unit_price'], 2, '.', ','),$border,0,'R',$fill);
			else
			$this->Cell($width_unit_price,$cell_height * $hmultiplier ,'',$border,0,'C',$fill);
			
			if ($val['extended'] <> 0)
			$this->Cell($width_extended,$cell_height * $hmultiplier,'$' . number_format($val['extended'], 2, '.', ',') . " " . $calc,$border,0,'R',$fill);
			else
			$this->Cell($width_extended,$cell_height * $hmultiplier,'' . " " . $calc,$border,0,'R',$fill);
			
        	$fill = !$fill;
			$x += 1;
		}
		
		// Add X more blank lines
		
		$number_of_blank_lines = $quote->max_number_of_lines - $x + 1;
		for($i=1; $i <= $number_of_blank_lines; $i++) {
			$this->Ln();
			if ($number_of_blank_lines == $i) $border = "LRB"; else $border = 'LR';
			$this->Cell($width_quantity,$cell_height ,"",$border,0,'L',$fill);
        	$this->Cell($width_part_number,$cell_height,"",$border,0,'L',$fill);
        	$this->Cell($width_description,$cell_height ,"",$border,0,'L',$fill);
        	$this->Cell($width_unit_price,$cell_height,"",$border,0,'L',$fill);
			$this->Cell($width_extended,$cell_height,"",$border,0,'L',$fill);
        	$fill = !$fill;
		}
		
    }
	$this->Ln();
	
	$widthc1 = 20;
	$widthc2 = 114;
	$widthc3 = 42;
	$widthc4 = $width_extended;
	
	$fill = FALSE;
	$this->Cell($widthc1,$cell_height,'Sales Rep:','',0,'R',$fill);$this->Cell($widthc2,$cell_height,$quote_info['sales_rep'],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,'Sub Total:','',0,'R',$fill);$this->Cell($widthc4,$cell_height,'$' . number_format($quote_info['subtotal'], 2, '.', ','),'LRB',0,'R',$fill);$this->Ln();
	$this->Cell($widthc1,$cell_height,'Terms:','',0,'R',$fill);$this->Cell($widthc2,$cell_height,$quote_info['terms'],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,'Sales Tax:','',0,'R',$fill);$this->Cell($widthc4,$cell_height,'$' . number_format($quote_info['tax'], 2, '.', ','),'LRB',0,'R',$fill);$this->Ln();
	$this->Cell($widthc1,$cell_height,'Delivery:','',0,'R',$fill);$this->Cell($widthc2,$cell_height,$quote_info['delivery'],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,'Ship/Handling:','',0,'R',$fill);$this->Cell($widthc4,$cell_height,'$' . number_format($quote_info['ship_handle'], 2, '.', ','),'LRB',0,'R',$fill);$this->Ln();
	$this->Cell($widthc1,$cell_height,'FOB Point:','',0,'R',$fill);$this->Cell($widthc2,$cell_height,$quote_info['fob'],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,'Total:','',0,'R',$fill);$this->Cell($widthc4,$cell_height,'$' . number_format($quote_info['total'], 2, '.', ','),'LRB',0,'R',$fill);$this->Ln();	
	$this->Cell($widthc1,$cell_height,'Valid for:','',0,'R',$fill);$this->Cell($widthc2,$cell_height,$quote_info['valid_for'],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,'','',0,'R',$fill);$this->Cell($widthc4,$cell_height,'','',0,'L',$fill);$this->Ln();$this->Ln();

$width = $width_quantity + $width_part_number + $width_description + $width_unit_price + $width_extended;

$this->MultiCell($width,$cell_height,'If you have any questions regarding this quotation, please call your Sales Representative or Inside Sales at one of the above telephone numbers.','0','L',FALSE);
$this->Ln();$this->Ln();
$this->Cell($width,$cell_height,'THANK YOU FOR THIS OPPORTUNITY!','',0,'C',$fill);$this->Ln();$this->Ln();
$this->Cell($width,$cell_height,'Please visit our website at www.northernbalance.com','',0,'C',$fill,'www.northernbalance.com');

		
		
		// If path was not set then output to screen else send file to path
		if ($this->path_file == NULL) {
			$this->Output();	
		}
		else {
			// Send output to server 
			$this->Output($this->path_file, 'F');
			
		}
		
		
		return true;
	}
	
// 
// This is the templare for orders
//	
function _create_order_pdf() {
			$quote = new quote($this->dbkey_quote);
			$quote_info = $quote->_load_info();
			
			// Create Headers
			$width_quantity = 15;
			$width_part_number = 44;
			$width_description = 97;
			$width_unit_price = 20;
			$width_extended = 22;
			
			$total_width = $width_quantity + $width_part_number + $width_description + $width_unit_price + $width_extended;
		
			// Standard
			$standard_font = 'Arial';
			$standard_font_size = 10;
			$cell_height = 4;
			
			//PDF Defaults and attributes
			$this->AddPage();
			$this->SetFont($standard_font,'',$standard_font_size);	
			$this->SetLineWidth(1);
			$this->SetLeftMargin(5);
			$this->SetTopMargin(20);
			$user = new user;
			$user_info = $user->_load_info();
			$name = $user_info['first'] . " " . $user_info['last'];
			$this->SetAuthor($name);
			$this->SetCreator($name);
			$this->SetSubject("NBS Order");
			$this->SetTitle("NBS Order " . $quote_info['quote_number'] ); 
			$this->SetTextColor(0);	
			
		   
			$this->Image('images/nbslogo.png',5,13,30,30);
		   //Heading text 
			
			$widthc1 = 30;
			$widthc2 = 85;
			$this->Ln(5);
			// Load bill to and ship to
			$this->SetFont($standard_font,'B',$standard_font_size);	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"NBS Calibrations",'',0,'L',$fill);
			$this->SetFont($standard_font,'B',20);
			$this->Cell($total_width - $widthc2 - $widthc1,$cell_height,"Sales Order Form",'',0,'R',$fill);  $this->SetFont($standard_font,'',$standard_font_size);	$this->Ln();
			$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"9556 West Bloomington Freeway",'',0,'L',$fill);$this->Ln();
			$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"Bloomington, MN 55431",'',0,'L',$fill);$this->Ln();
			$this->SetFont($standard_font,'B',15);
			$this->Cell($total_width,$cell_height,"Cust. P.O " . $quote_info['quote_number'],'',0,'R',$fill); $this->SetFont($standard_font,'',$standard_font_size);
			$this->Ln();
			
			$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"800.722.5398 Toll Free",'',0,'L',$fill);$this->Ln();
			$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"952.881.7716 Local",'',0,'L',$fill);$this->Ln();
			$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"952.881.7309 Fax",'',0,'L',$fill);$this->Ln();
			$date = substr($quote_info['quote_date'],5,2) . "/" . substr($quote_info['quote_date'],8,2) . "/" . substr($quote_info['quote_date'],2,2); 
			$this->Cell($total_width,$cell_height,"Date: " . $date,'',0,'R',$fill); $this->Ln();
			
			//$this->Image('../images/logo.png',10,20,33,0,' ','http://www.northernbalance.com/');
			$this->Ln();
			$widthc1 = 20;
			$widthc2 = 80;
			$widthc3 = 20;
			$widthc4 = 80;
			// Load Bill to
			$CSZ = $quote_info['sold_to_city'] . "," . $quote_info['sold_to_state'] . " " . $quote_info['sold_to_zip'];
			if (substr(trim($CSZ),0,1) == ",") $CSZ = substr(trim($CSZ),1,100);
			$t[0] = $quote_info['sold_to_customer_name']; 
			$t[1] = $quote_info['sold_to_adr1'];
			$t[2] = $quote_info['sold_to_adr2'];
			$t[3] = $CSZ;
			
			$b[0] = ''; 
			$b[1] = '';
			$b[2] = '';
			$b[3] = '';
			
			$x = 0;
			for ($i=0; $i <= 3;) {
				if (trim($t[$i]) <> '') {
					$b[$x] = $t[$i];
					$x += 1;
				}
				$i += 1;
			}
			
			
			
			
			
			
			
			// Load ship to
			$CSZ = $quote_info['ship_to_city'] . "," . $quote_info['ship_to_state'] . " " . $quote_info['ship_to_zip'];
			if (substr(trim($CSZ),0,1) == ",") $CSZ = substr(trim($CSZ),1,100);
		
		
			$t[0] = $quote_info['customer_name']; 
			$t[1] = $quote_info['ship_to_adr1'];
			$t[2] = $quote_info['ship_to_adr2'];
			$t[3] = $CSZ;
			$t[4] = 'Attn:' . $quote_info['attention'];;
			
			
			$s[0] = ''; 
			$s[1] = '';
			$s[2] = '';
			$s[3] = '';
			$s[4] = '';
			
			$x = 0;
			for ($i=0; $i <= 4;) {
				if (trim($t[$i]) <> '') {
					$s[$x] = $t[$i];
					$x += 1;
				}
				$i += 1;
			}
			
			
			
			// Load bill to and ship to
			$this->Cell($widthc1,$cell_height,"Ship To:",'',0,'L',$fill); $this->Cell($widthc2,$cell_height,$s[0],'',0,'L',$fill); $this->Cell($widthc3,$cell_height,"Bill To:",'',0,'L',$fill); $this->Cell($widthc4,$cell_height,$b[0],'',0,'L',$fill);$this->Ln();
			
			$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,$s[1],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc4,$cell_height,$b[1],'',0,'L',$fill); $this->Ln();
			
			$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,$s[2],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,"",'',0,'L',$fill); 
			$this->Cell($widthc4,$cell_height,$b[2],'',0,'L',$fill); $this->Ln();
			
			$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,$s[3],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc4,$cell_height,$b[3],'',0,'L',$fill); $this->Ln();
				$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,$s[4],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc4,$cell_height,$b[4],'',0,'L',$fill); $this->Ln();
		
			
			$this->Ln();
			
			// set phone fax
			$width1 = 90;
			$this->Cell(17,$cell_height,'Phone:','',0,'L',$fill);$this->Cell($width1,$cell_height,$quote_info['phone'],'',0,'L',$fill);$this->Cell(15,$cell_height,'E-mail:','',0,'R',$fill);$this->Cell(15,$cell_height,$quote_info['email'],'',0,'L',$fill);$this->Ln();
			$this->Cell(17,$cell_height,'Cust ID:','',0,'L',$fill);$this->Cell($width1 + 5,$cell_height,trim($quote_info['id'] . " " ),'',0,'L',$fill);$this->Cell(15,$cell_height,'','',0,'R',$fill);$this->Cell(15,$cell_height,'',0,'L',$fill); $this->Ln();
			
			
			
			// Colors, line width and bold font
			$this->SetAutoPageBreak(true,10); 
			$this->SetFillColor(224,224,224);
			$this->SetDrawColor(0,0,0);
			$this->SetLineWidth(.3);
			  
			
			$this->Ln();    	
		   
		   
			// Data
			$fill = false;
			
			
			
			
			$this->Cell($width_quantity,$cell_height,'Quantity','LTB',0,'L',$fill);
			$this->Cell($width_part_number,$cell_height,'Part Number','TB',0,'L',$fill);
			$this->Cell($width_description,$cell_height,'Description','TB',0,'L',$fill);
			$this->Cell($width_unit_price,$cell_height,'Unit Price','TB',0,'L',$fill);
			$this->Cell($width_extended,$cell_height,'Extended','TBR',0,'L',$fill);
			
			$x = 1;
			if ($end = count($quote->quote_info_dtl) ){
				foreach ($quote->quote_info_dtl as $key => $val) {
					// Determin dynamic height of each row
					$w1 = $this->GetStringWidth($val['description']);
					$w2 = $this->GetStringWidth($val['part_number']);
					$border = 'LR';
					// Calc multiplier for height
					if ($w1 / $width_description > $w2 / $width_part_number) $hmultiplier = ceil($w1 / $width_description); else  $hmultiplier = ceil($w2 / $width_part_number);
					$hmultiplier = 1;
					//echo "w1 is " . $w1 . "description " . $width_description . " mul is " . $hmultiplier . "<br>";
					
					$this->Ln();
					
					
					//if ($val['calculate'] == 1) $calc = "*"; else $calc = ""; 
					if ($val['quantity'] <> 0) $this->Cell($width_quantity,$cell_height * $hmultiplier ,number_format($val['quantity'],1),$border,0,'C',$fill); else
					$this->Cell($width_quantity,$cell_height * $hmultiplier ,'',$border,0,'C',$fill);
					
					$this->Cell($width_part_number,$cell_height * $hmultiplier,substr($val['part_number'],0,$quote->part_max_length),$border,0,'L',$fill);
					$this->Cell($width_description,$cell_height * $hmultiplier,substr($val['description'],0,$quote->description_max_length),$border,0,'L',$fill);
					
					if ($val['unit_price'] <> 0)
					$this->Cell($width_unit_price,$cell_height * $hmultiplier,'$' . number_format($val['unit_price'], 2, '.', ','),$border,0,'R',$fill);
					else
					$this->Cell($width_unit_price,$cell_height * $hmultiplier ,'',$border,0,'C',$fill);
					
					if ($val['extended'] <> 0)
					$this->Cell($width_extended,$cell_height * $hmultiplier,'$' . number_format($val['extended'], 2, '.', ',') . " " . $calc,$border,0,'R',$fill);
					else
					$this->Cell($width_extended,$cell_height * $hmultiplier,'' . " " . $calc,$border,0,'R',$fill);
					
					$fill = !$fill;
					$x += 1;
				}
				
				// Add X more blank lines
				
				$number_of_blank_lines = $quote->max_number_of_lines - $x + 1;
				for($i=1; $i <= $number_of_blank_lines; $i++) {
					$this->Ln();
					if ($number_of_blank_lines == $i) $border = "LRB"; else $border = 'LR';
					$this->Cell($width_quantity,$cell_height ,"",$border,0,'L',$fill);
					$this->Cell($width_part_number,$cell_height,"",$border,0,'L',$fill);
					$this->Cell($width_description,$cell_height ,"",$border,0,'L',$fill);
					$this->Cell($width_unit_price,$cell_height,"",$border,0,'L',$fill);
					$this->Cell($width_extended,$cell_height,"",$border,0,'L',$fill);
					$fill = !$fill;
				}
				
			}
			$this->Ln();
			
			$widthc1 = 20;
			$widthc2 = 114;
			$widthc3 = 42;
			$widthc4 = $width_extended;
			
			$fill = FALSE;
			
			// Get Author of Sales Order
			$user2 = new user();
			$user2->_set_dbkey($quote_info['order_rep']);
			$array_temp = $user2->_load_info();
			$author_name = $array_temp['first'] . " " . $array_temp['last'];
			
			// Get Sales Rep
			$user3 = new user();
			$user3->_set_dbkey($quote_info['dbkey_sales_rep']);
			$array_temp = $user3->_load_info();
			$sales_rep_name = $array_temp['first'] . " " . $array_temp['last'];
			
			//echo "Sales Rep is " . $sales_rep_name ;
					
			$this->Cell($widthc1,$cell_height,'Sales Rep:','',0,'R',$fill);$this->Cell($widthc2,$cell_height,$sales_rep_name,'',0,'L',$fill);$this->Cell($widthc3,$cell_height,'Sub Total:','',0,'R',$fill);$this->Cell($widthc4,$cell_height,'$' . number_format($quote_info['subtotal'], 2, '.', ','),'LRB',0,'R',$fill);$this->Ln();
			$this->Cell($widthc1,$cell_height,'Terms:','',0,'R',$fill);$this->Cell($widthc2,$cell_height,$quote_info['terms'],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,'Sales Tax:','',0,'R',$fill);$this->Cell($widthc4,$cell_height,'$' . number_format($quote_info['tax'], 2, '.', ','),'LRB',0,'R',$fill);$this->Ln();
			$this->Cell($widthc1,$cell_height,'Delivery:','',0,'R',$fill);$this->Cell($widthc2,$cell_height,$quote_info['delivery'],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,'Ship/Handling:','',0,'R',$fill);$this->Cell($widthc4,$cell_height,'$' . number_format($quote_info['ship_handle'], 2, '.', ','),'LRB',0,'R',$fill);$this->Ln();
			$this->Cell($widthc1,$cell_height,'FOB Point:','',0,'R',$fill);$this->Cell($widthc2,$cell_height,$quote_info['fob'],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,'Total:','',0,'R',$fill);$this->Cell($widthc4,$cell_height,'$' . number_format($quote_info['total'], 2, '.', ','),'LRB',0,'R',$fill);$this->Ln();	
			$this->Cell($widthc1,$cell_height,'Valid for:','',0,'R',$fill);$this->Cell($widthc2,$cell_height,$quote_info['valid_for'],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,'','',0,'R',$fill);$this->Cell($widthc4,$cell_height,'','',0,'L',$fill);$this->Ln();
		$form = new form();
		$ship_method_desctiption = $form->_table_description('ship_method',$quote_info['ship_method']);
		$this->Cell($widthc1,$cell_height,'Deliver to:','',0,'R',$fill);$this->Cell($widthc2,$cell_height,$ship_method_desctiption,'',0,'L',$fill);$this->Cell($widthc3,$cell_height,'','',0,'R',$fill);$this->Cell($widthc4,$cell_height,'','',0,'L',$fill);$this->Ln();
			
		$this->Ln();
		
		$width = $width_quantity + $width_part_number + $width_description + $width_unit_price + $width_extended;
		
		// Write or P.O's 
		if (trim($quote_info['po1']) <> '')
		{
			//$this->SetFont('','BU');
			$this->Write(2,'PO: ' . $quote_info['po1'] . '   ');
		}
		
		// Write or P.O's 
		if (trim($quote_info['po2']) <> '')
		{
			//$this->SetFont('','BU');
			$this->Write(2,'PO: ' . $quote_info['po2'] . '   ');
		}
		
		// Write or P.O's 
		if (trim($quote_info['po3']) <> '')
		{
			//$this->SetFont('','BU');
			$this->Write(2,'PO: ' . $quote_info['po3'] . '   ');
		}
		
		// Write or P.O's 
		if (trim($quote_info['po4']) <> '')
		{
			//$this->SetFont('','BU');
			$this->Write(2,'PO: ' . $quote_info['po4'] . '   ');
		}
		
		
		
		// Notes - Only write out if they are there.
		if (trim($quote_info['order_notes']) <> '')
		{
			$this->SetFont('','BU');
			$this->Ln(5);
			$this->Write(2,'Order Notes:');
			$this->Ln(2);
			$this->SetFont('','');
			$this->Write($quote->order_notes_max_number_of_lines,trim($quote_info['order_notes']));
			$this->Ln();
		}
				
				// If path was not set then output to screen else send file to path
				if ($this->path_file == NULL) {
					$this->Output();	
				}
				else {
					// Send output to server 
					$this->Output($this->path_file, 'F');
					
					
					
				}
				
				
				return true;
	}	
	




	
// 
// This is the templare for orders
//	
function _create_packing_slip_pdf() {
	$quote = new quote($this->dbkey_quote);
	$quote_info = $quote->_load_info();
	
	// Create Headers
	$width_quantity_s = 17;
	$width_quantity = 17;
	$width_part_number = 50;
	$width_description = 117;
	$width_unit_price = 0;
	$width_extended = 0;
	
	$total_width = $width_quantity_s + $width_quantity + $width_part_number + $width_description + $width_unit_price + $width_extended;

	// Standard
	$standard_font = 'Arial';
	$standard_font_size = 10;
	$cell_height = 4;
	
	//PDF Defaults and attributes
	$this->AddPage();
	$this->SetFont($standard_font,'',$standard_font_size);	
	$this->SetLineWidth(1);
	$this->SetLeftMargin(5);
	$this->SetTopMargin(20);
	$user = new user;
	$user_info = $user->_load_info();
	$name = $user_info['first'] . " " . $user_info['last'];
	$this->SetAuthor($name);
	$this->SetCreator($name);
	$this->SetSubject("NBS Order");
 	$this->SetTitle("NBS Order " . $quote_info['quote_number'] ); 
	$this->SetTextColor(0);	
	
   
   	$this->Image('images/nbslogo.png',5,13,30,30);
   //Heading text 
    
	$widthc1 = 30;
	$widthc2 = 85;
	$this->Ln(5);
   	// Load bill to and ship to
	$this->SetFont($standard_font,'B',$standard_font_size);	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"NBS Calibrations",'',0,'L',$fill);
	$this->SetFont($standard_font,'B',20);
	$this->Cell($total_width - $widthc2 - $widthc1,$cell_height,"Packing Slip",'',0,'R',$fill);  $this->SetFont($standard_font,'',$standard_font_size);	$this->Ln();
   	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"9556 West Bloomington Freeway",'',0,'L',$fill);$this->Ln();
   	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"Bloomington, MN 55431",'',0,'L',$fill);$this->Ln();
	$this->SetFont($standard_font,'B',15);
	
	$this->Cell($total_width,$cell_height,"Cust. P.O " . $quote_info['quote_number'],'',0,'R',$fill); $this->SetFont($standard_font,'',$standard_font_size);
	$this->Ln();
	
	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"800.722.5398 Toll Free",'',0,'L',$fill);$this->Ln();
	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"952.881.7716 Local",'',0,'L',$fill);$this->Ln();
	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,"952.881.7309 Fax",'',0,'L',$fill);$this->Ln();
	$date = substr($quote_info['quote_date'],5,2) . "/" . substr($quote_info['quote_date'],8,2) . "/" . substr($quote_info['quote_date'],2,2); 
	$this->Cell($total_width,$cell_height,"Date: " . $date,'',0,'R',$fill); $this->Ln();
	
   	//$this->Image('../images/logo.png',10,20,33,0,' ','http://www.northernbalance.com/');
    $this->Ln();
	$widthc1 = 20;
	$widthc2 = 80;
	$widthc3 = 20;
	$widthc4 = 80;
	// Load Bill to
	$CSZ = $quote_info['sold_to_city'] . "," . $quote_info['sold_to_state'] . " " . $quote_info['sold_to_zip'];
	if (substr(trim($CSZ),0,1) == ",") $CSZ = substr(trim($CSZ),1,100);
	$t[0] = $quote_info['sold_to_customer_name']; 
	$t[1] = $quote_info['sold_to_adr1'];
	$t[2] = $quote_info['sold_to_adr2'];
	$t[3] = $CSZ;
	
	$b[0] = ''; 
	$b[1] = '';
	$b[2] = '';
	$b[3] = '';
	
	$x = 0;
	for ($i=0; $i <= 3;) {
		if (trim($t[$i]) <> '') {
			$b[$x] = $t[$i];
			$x += 1;
		}
		$i += 1;
	}
	
	
	
	
	
	
	
	// Load ship to
	$CSZ = $quote_info['ship_to_city'] . "," . $quote_info['ship_to_state'] . " " . $quote_info['ship_to_zip'];
	if (substr(trim($CSZ),0,1) == ",") $CSZ = substr(trim($CSZ),1,100);


	$t[0] = $quote_info['customer_name']; 
	$t[1] = $quote_info['ship_to_adr1'];
	$t[2] = $quote_info['ship_to_adr2'];
	$t[3] = $CSZ;
	$t[4] = 'Attn:' . $quote_info['attention'];
	
	
	$s[0] = ''; 
	$s[1] = '';
	$s[2] = '';
	$s[3] = '';
	$s[4] = '';
	
	$x = 0;
	for ($i=0; $i <= 4;) {
		if (trim($t[$i]) <> '') {
			$s[$x] = $t[$i];
			$x += 1;
		}
		$i += 1;
	}
	
	
	
   	// Load bill to and ship to
	$this->Cell($widthc1,$cell_height,"Ship To:",'',0,'L',$fill); $this->Cell($widthc2,$cell_height,$s[0],'',0,'L',$fill); $this->Cell($widthc3,$cell_height,"Bill To:",'',0,'L',$fill); $this->Cell($widthc4,$cell_height,$b[0],'',0,'L',$fill);$this->Ln();
   	
	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,$s[1],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc4,$cell_height,$b[1],'',0,'L',$fill); $this->Ln();
	
	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,$s[2],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,"",'',0,'L',$fill); 
	$this->Cell($widthc4,$cell_height,$b[2],'',0,'L',$fill); $this->Ln();
	
   	$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,$s[3],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc4,$cell_height,$b[3],'',0,'L',$fill); $this->Ln();
		$this->Cell($widthc1,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc2,$cell_height,$s[4],'',0,'L',$fill);$this->Cell($widthc3,$cell_height,"",'',0,'L',$fill);$this->Cell($widthc4,$cell_height,$b[4],'',0,'L',$fill); $this->Ln();

	
	$this->Ln();
	
	// set phone fax
	$width1 = 90;
	$this->Cell(17,$cell_height,'Phone:','',0,'L',$fill);$this->Cell($width1,$cell_height,$quote_info['phone'],'',0,'L',$fill);$this->Cell(15,$cell_height,'E-mail:','',0,'R',$fill);$this->Cell(15,$cell_height,$quote_info['email'],'',0,'L',$fill);$this->Ln();
	$this->Cell(17,$cell_height,'Cust ID:','',0,'L',$fill);$this->Cell($width1 + 5,$cell_height,trim($quote_info['id'] . " " ),'',0,'L',$fill);$this->Cell(15,$cell_height,'','',0,'R',$fill);$this->Cell(15,$cell_height,'',0,'L',$fill); $this->Ln();
	
	
	
	// Colors, line width and bold font
    $this->SetAutoPageBreak(true,10); 
	$this->SetFillColor(224,224,224);
    $this->SetDrawColor(0,0,0);
    $this->SetLineWidth(.3);
	  
	
	$this->Ln();    	
   
   
    // Data
    $fill = false;
	
	
	
	$this->Cell($width_quantity,$cell_height,'Order Qty','TB',0,'L',$fill);
    $this->Cell($width_quantity_s,$cell_height,'Ship Qty','LTB',0,'L',$fill);
	$this->Cell($width_part_number,$cell_height,'Part Number','TB',0,'L',$fill);
    $this->Cell($width_description,$cell_height,'Description','TBR',0,'L',$fill);
   
	
	$x = 1;
	if ($end = count($quote->quote_info_dtl) ){
		foreach ($quote->quote_info_dtl as $key => $val) {
			// Determin dynamic height of each row
			$w1 = $this->GetStringWidth($val['description']);
			$w2 = $this->GetStringWidth($val['part_number']);
			$border = 'LR';
			// Calc multiplier for height
			if ($w1 / $width_description > $w2 / $width_part_number) $hmultiplier = ceil($w1 / $width_description); else  $hmultiplier = ceil($w2 / $width_part_number);
			$hmultiplier = 1;
			//echo "w1 is " . $w1 . "description " . $width_description . " mul is " . $hmultiplier . "<br>";
			
			$this->Ln();
			
			
			//if ($val['calculate'] == 1) $calc = "*"; else $calc = ""; 
			if ($val['quantity'] <> 0) $this->Cell($width_quantity,$cell_height * $hmultiplier ,number_format($val['quantity'],1),$border,0,'L',$fill); else
			$this->Cell($width_quantity,$cell_height * $hmultiplier ,'',$border,0,'C',$fill);
			$this->Cell($width_quantity_s,$cell_height * $hmultiplier ,' ',$border,0,'L',$fill);
			
        	$this->Cell($width_part_number,$cell_height * $hmultiplier,substr($val['part_number'],0,$quote->part_max_length),$border,0,'L',$fill);
        	$this->Cell($width_description,$cell_height * $hmultiplier,substr($val['description'],0,$quote->description_max_length),$border,0,'L',$fill);
        	
			
			
        	$fill = !$fill;
			$x += 1;
		}
		
		// Add X more blank lines
		
		$number_of_blank_lines = $quote->max_number_of_lines - $x + 1;
		for($i=1; $i <= $number_of_blank_lines; $i++) {
			$this->Ln();
			if ($number_of_blank_lines == $i) $border = "LRB"; else $border = 'LR';
			$this->Cell($width_quantity_s,$cell_height ,"",$border,0,'L',$fill);
			$this->Cell($width_quantity,$cell_height ,"",$border,0,'L',$fill);
        	$this->Cell($width_part_number,$cell_height,"",$border,0,'L',$fill);
        	$this->Cell($width_description,$cell_height ,"",$border,0,'L',$fill);
        	
        	$fill = !$fill;
		}
		
    }
	$this->Ln();
	
	$widthc1 = 20;
	$widthc2 = 114;
	$widthc3 = 42;
	$widthc4 = $width_extended;
	
	$fill = FALSE;
	
	// Get Author of Sales Order
			$user2 = new user();
			$user2->_set_dbkey($quote_info['order_rep']);
			$array_temp = $user2->_load_info();
			$author_name = $array_temp['first'] . " " . $array_temp['last'];
			
			// Get Sales Rep
			$user3 = new user();
			$user3->_set_dbkey($quote_info['dbkey_sales_rep']);
			$array_temp = $user3->_load_info();
			$sales_rep_name = $array_temp['first'] . " " . $array_temp['last'];
	
	$this->Cell($widthc1,$cell_height,'Sales Rep:','',0,'R',$fill);$this->Cell($widthc2,$cell_height,$sales_rep_name,'',0,'L',$fill);
	//$this->Cell($widthc3,$cell_height,'Sub Total:','',0,'R',$fill);
	//$this->Cell($widthc4,$cell_height,'$' . number_format($quote_info['subtotal'], 2, '.', ','),'LRB',0,'R',$fill);
	
		
		// If path was not set then output to screen else send file to path
		if ($this->path_file == NULL) {
			$this->Output();	
		}
		else {
			// Send output to server 
			$this->Output($this->path_file, 'F');
			
			
			
		}
			$this->_create_order_pdf();
		
		return true;
	}	
	
function _route_to_pdf($type, $dbkey) 
{
	
	?>
		<script> 
			var windowName = 'userConsole'; 
			var popUp = window.open(
			'processing_pdf.php?pdf=on&dbkey_quote_b=<?php echo $dbkey;?>&sendq=Y&order_type=<?php echo $type;?>',"<?php echo $type;?>","width=800,height=900");
			if (popUp == null || typeof(popUp)=='undefined') { 	
				alert('Please disable your pop-up blocker and click the "Open" link again.'); 
			} 
			else { 	
					popUp.focus();
			}
		</script>
	
	<?php
}
}
?>