<?php
function _load_sessions() {
	$_SESSION[FILE_PREFIX] = 'vss_';
	$_SESSION[BASE_PATH] = "documents/docs_pub/";
	$_SESSION[INCLUDE_PATH] = "/includes/";
	
}

function _header($code) {
	session_start();
	_load_sessions();
	
	include ($_SESSION[INCLUDE_PATH] . "class/EmailAddressValidator.php");
	include ($_SESSION[INCLUDE_PATH] . "class/user_cls.php");
	include ($_SESSION[INCLUDE_PATH] . "class/client_cls.php");
	include ($_SESSION[INCLUDE_PATH] . "class/database_cls.php");
	include ($_SESSION[INCLUDE_PATH] . "class/form_cls.php"); 
	 
	include ($_SESSION[INCLUDE_PATH] . "class/access_cls.php");
	include ($_SESSION[INCLUDE_PATH] . "class/meta_cls.php");
	require_once($_SESSION[INCLUDE_PATH] . 'class/site_cls.php');
  	require_once($_SESSION[INCLUDE_PATH] . 'swift/lib/swift_required.php');
   	require_once($_SESSION[INCLUDE_PATH] . 'fpdf/fpdf.php');
	include ($_SESSION[INCLUDE_PATH] . "class/debug_cls.php");

// If user not logge in route to login page. 
$user = new user();
if (!$user->_is_active_login() and ($code <> 'common')) {
?>
			<p style="text-align:center;"> User not logged in. redirecting to login. If you are not redirected in 5 seconds <a href='../login_common.php'>click here.</a> </p>
			 <meta HTTP-EQUIV="REFRESH" content="2; url=login_common.php"> 
<?php
			exit;
}

  
  
	$site = new site('vsso');
	if ( !$site->_valid() ) {
		echo "Site under construction"; exit;
		return false;
	}
	
		$class = "";
		
		
	?>
		<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
		<html  xmlns="http://www.w3.org/1999/xhtml">
		<head>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
		<?php 
			// Load Meta Data
			$meta = new meta($code);
			$meta->_display_all_meta();
		?>
  			<meta http-equiv="Content-Type" content="text/html; charset=windows-1251"/>
        	<title>Welcome to NBS Online. Your One Stop Portal</title>
        	
        	<link href="includes/css/style.css" rel="stylesheet" type="text/css"/>
            <link href="includes/css/menu.css" rel="stylesheet" type="text/css"/>
           
		</head>
        
       

			
		<body>
			           
				<?php  $access2 = new access();
						$user2 = new user(); ?>
<div class = 'full_wrap'>
 <div class="header_wrap">
		<div class="header" > 
                <?php //_social_media(); ?>
                  
                    <div class = 'css3menu'>
                    	<div style="float:left; margin:0px; margin-top: 5px; width:180px;" > <a  style=" text-decoration:none; border:none;" href="index.php" name ='3S'> <img  src="images/nbs_onlinedata_logo.png"   style="border:none;z-index:0" alt="NBS Online" width="180" height="80" /> </a></div>
                   		<ul id="css3menu1" class="topmenu" style="height:0px; margin-top:10px; width:500px; margin-right:135px; float:right; ">
                         <?php if ($user2->_is_active_login()) { ?>
                       		<li class="topfirst"><a href="#" style=" margin-top: 10px; height:16px;line-height:16px;margin-right: 10px;">Tools</a>
                      			<ul>
									<li><a href="index.php">Home</a></li>
                                    <li><a href="clientactivity.php">Client Activity</a></li>
                                    	
								</ul>
                           	</li>
                            <?php if ($access2->_access_allowed('admin')) { ?>
                            <li class="topfirst"><a href="#" style=" margin-top: 10px; 	margin-right: 10px; height:16px;line-height:16px;">Administration</a>
                            	<ul>
                                	<li><a href="clientadmin.php">Client Admin</a></li>
									<li><a href="useradmn.php">User Admin</a></li>
                                    <li><a href="client_assignment.php">Client Assignments</a></li>
                                    <li><a href="privileges.php">Privileges</a></li>	
                                    <li><a href="groups.php">Groups</a></li>
                                    <li><a href="activity_codes.php">Activity Codes</a></li>	
								</ul>
                            </li>
                            <?php } ?>
							<li class="topfirst"><a href="useredt.php?dbkey=<?php echo $_SESSION[admin_dbkey]; ?>" style="height:18px;line-height:18px;  margin-top: 10px; ">User Profile</a></li>
                           <?php  } ?>
						</ul>
				</div>
			</div>
		</div>


<?php 

}


function _footer() {
	?>
</div>
	<div class = "footerbox" style="margin-top:0px; margin-bottom: 130px;">
			<div class="footerbox1"><p style="margin-top:25px;"><a  style=" font-size:20px; color:  #33A074;" href="index.php"> Home</a></p></div>
            <div class="footerbox1 footerbox2"><p style="margin-top:35px;"><a   style=" font-size:20px; color:  #33A074;"  href="logout.php"> Logout</a></p></div>
            <div class="footerbox1 footerbox3"><p style="margin-top:25px;"><a  style=" font-size:20px; color:  #33A074;" href='useredt.php?dbkey=<?php echo $_SESSION[admin_dbkey]; ?>'> User Profile</a></p></div>		
    </div>
  
   
    <div class = "footerbox" style="margin-top:10px;">
     <?php _footer_menu(); ?>
     </div>
	

</body>
</html>
	
	<?php
}

function _footer_second() {
	
	?> <div class = "footer">
	<?php 
    _footer_menu();
	
	?> 
    </div>
</body>
</html>
	
	
    <?php 
	}
	
function _footer_menu(){
	?>
    
       <ul id="css3menu1" class=" topmenu " style="width:900px;background:transparent;">
       						<li class="topfirst" style="float:left;background-color:none;"><span style="background-color:none;color: #F90;height:23px;line-height:16px; font-weight:bold;"></span></li>
                            <li class="topfirst" style="float:right;background-color:none;"><a href="index.php" title = "Home" style="height:18px;line-height:18px; color: #F90;background-color:none;"></a></li>
                            <li class="topfirst" style="float:right;background-color:none;"><a href="index.php" title = "Logout" style="height:18px;line-height:18px;color: #F90;"></a></li>
                            <li class="topfirst" style="float:right;background-color:none;"><a href="##.php" title="Extra" style="height:18px;line-height:18px;color: #F90;"></a></li>
                            <li class="topfirst" style="float:right;background-color:none;"><a href="##.php" title="Extra" style="height:18px;line-height:18px;color: #F90;"></a></li>
				    			
		</ul>
    
    
<?php 
}

function _social_media() {
?>

<div style=" float:right; margin-right:30px; margin-top: 5px;" >
                	<div style="float:left"><a href="mailing.php" target="_parent" title="Sign up for our Mailing List" name="Sign up for our Mailing List"><img  width="25px" height="25px;" src="images/news.png" alt="News Letter"/></a> </div>
                    <div style="float:left"><a href="https://www.facebook.com/ThreeSdesign" target="_blank" title="3S Design Face Book"  name="3S Design Face Book"><img  width="25px" height="25px;" src="images/fb-icon.png" alt="Face Book"/></a> </div>
                    
                </div>
<?php

}

function show_calandar()
{
	?> 
    <SCRIPT src="http://www.localendar.com/public/vssonline?include=Y&dynamic=Y&style=M0"></SCRIPT>
    <<!-- iframe src="https://www.google.com/calendar/embed?src=schajx%40gmail.com&ctz=America/Chicago " style="border: 0" width="800" height="600" frameborder="0" scrolling="no"></iframe>-->
    <?php 
}