<?php
if (session_id() == "") session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg9.php" ?>
<?php include_once "ewmysql9.php" ?>
<?php include_once "phpfn9.php" ?>
<?php include_once "site_admininfo.php" ?>
<?php include_once "userfn9.php" ?>
<?php

//
// Page class
//

$site_admin_edit = NULL; // Initialize page object first

class csite_admin_edit extends csite_admin {

	// Page ID
	var $PageID = 'edit';

	// Project ID
	var $ProjectID = "{095601E1-93A8-4664-8CCA-D6A58AA0A39D}";

	// Table name
	var $TableName = 'site_admin';

	// Page object name
	var $PageObjName = 'site_admin_edit';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			$html .= "<p class=\"ewMessage\">" . $sMessage . "</p>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			$html .= "<table class=\"ewMessageTable\"><tr><td class=\"ewWarningIcon\"></td><td class=\"ewWarningMessage\">" . $sWarningMessage . "</td></tr></table>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			$html .= "<table class=\"ewMessageTable\"><tr><td class=\"ewSuccessIcon\"></td><td class=\"ewSuccessMessage\">" . $sSuccessMessage . "</td></tr></table>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			$html .= "<table class=\"ewMessageTable\"><tr><td class=\"ewErrorIcon\"></td><td class=\"ewErrorMessage\">" . $sErrorMessage . "</td></tr></table>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p class=\"phpmaker\">" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Fotoer exists, display
			echo "<p class=\"phpmaker\">" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language, $UserAgent;

		// User agent
		$UserAgent = ew_UserAgent();
		$GLOBALS["Page"] = &$this;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (site_admin)
		if (!isset($GLOBALS["site_admin"])) {
			$GLOBALS["site_admin"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["site_admin"];
		}

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'edit', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'site_admin', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect();
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// Create form object
		$objForm = new cFormObj();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"];
		$this->dbkey->Visible = !$this->IsAdd() && !$this->IsCopy() && !$this->IsGridAdd();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $conn;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();
		$this->Page_Redirecting($url);

		 // Close connection
		$conn->Close();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}
	var $DbMasterFilter;
	var $DbDetailFilter;

	// 
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError;

		// Load key from QueryString
		if (@$_GET["dbkey"] <> "")
			$this->dbkey->setQueryStringValue($_GET["dbkey"]);
		if (@$_GET["auth_status"] <> "")
			$this->auth_status->setQueryStringValue($_GET["auth_status"]);

		// Process form if post back
		if (@$_POST["a_edit"] <> "") {
			$this->CurrentAction = $_POST["a_edit"]; // Get action code
			$this->LoadFormValues(); // Get form values
		} else {
			$this->CurrentAction = "I"; // Default action is display
		}

		// Check if valid key
		if ($this->dbkey->CurrentValue == "")
			$this->Page_Terminate("site_adminlist.php"); // Invalid key, return to list
		if ($this->auth_status->CurrentValue == "")
			$this->Page_Terminate("site_adminlist.php"); // Invalid key, return to list

		// Validate form if post back
		if (@$_POST["a_edit"] <> "") {
			if (!$this->ValidateForm()) {
				$this->CurrentAction = ""; // Form error, reset action
				$this->setFailureMessage($gsFormError);
				$this->EventCancelled = TRUE; // Event cancelled
				$this->RestoreFormValues();
			}
		}
		switch ($this->CurrentAction) {
			case "I": // Get a record to display
				if (!$this->LoadRow()) { // Load record based on key
					if ($this->getFailureMessage() == "") $this->setFailureMessage($Language->Phrase("NoRecord")); // No record found
					$this->Page_Terminate("site_adminlist.php"); // No matching record, return to list
				}
				break;
			Case "U": // Update
				$this->SendEmail = TRUE; // Send email on update success
				if ($this->EditRow()) { // Update record based on key
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage($Language->Phrase("UpdateSuccess")); // Update success
					$sReturnUrl = $this->getReturnUrl();
					$this->Page_Terminate($sReturnUrl); // Return to caller
				} else {
					$this->EventCancelled = TRUE; // Event cancelled
					$this->RestoreFormValues(); // Restore form values if update failed
				}
		}

		// Render the record
		$this->RowType = EW_ROWTYPE_EDIT; // Render as Edit
		$this->ResetAttrs();
		$this->RenderRow();
	}

	// Get upload files
	function GetUploadFiles() {
		global $objForm;

		// Get upload data
		$index = $objForm->Index; // Save form index
		$objForm->Index = -1;
		$confirmPage = (strval($objForm->GetValue("a_confirm")) <> "");
		$objForm->Index = $index; // Restore form index
	}

	// Load form values
	function LoadFormValues() {

		// Load from form
		global $objForm;
		if (!$this->dbkey->FldIsDetailKey)
			$this->dbkey->setFormValue($objForm->GetValue("x_dbkey"));
		if (!$this->auth_status->FldIsDetailKey) {
			$this->auth_status->setFormValue($objForm->GetValue("x_auth_status"));
		}
		if (!$this->_email->FldIsDetailKey) {
			$this->_email->setFormValue($objForm->GetValue("x__email"));
		}
		if (!$this->user->FldIsDetailKey) {
			$this->user->setFormValue($objForm->GetValue("x_user"));
		}
		if (!$this->pwd->FldIsDetailKey) {
			$this->pwd->setFormValue($objForm->GetValue("x_pwd"));
		}
		if (!$this->first->FldIsDetailKey) {
			$this->first->setFormValue($objForm->GetValue("x_first"));
		}
		if (!$this->last->FldIsDetailKey) {
			$this->last->setFormValue($objForm->GetValue("x_last"));
		}
		if (!$this->status->FldIsDetailKey) {
			$this->status->setFormValue($objForm->GetValue("x_status"));
		}
		if (!$this->signature->FldIsDetailKey) {
			$this->signature->setFormValue($objForm->GetValue("x_signature"));
		}
		if (!$this->quote_prefix->FldIsDetailKey) {
			$this->quote_prefix->setFormValue($objForm->GetValue("x_quote_prefix"));
		}
	}

	// Restore form values
	function RestoreFormValues() {
		global $objForm;
		$this->LoadRow();
		$this->dbkey->CurrentValue = $this->dbkey->FormValue;
		$this->auth_status->CurrentValue = $this->auth_status->FormValue;
		$this->_email->CurrentValue = $this->_email->FormValue;
		$this->user->CurrentValue = $this->user->FormValue;
		$this->pwd->CurrentValue = $this->pwd->FormValue;
		$this->first->CurrentValue = $this->first->FormValue;
		$this->last->CurrentValue = $this->last->FormValue;
		$this->status->CurrentValue = $this->status->FormValue;
		$this->signature->CurrentValue = $this->signature->FormValue;
		$this->quote_prefix->CurrentValue = $this->quote_prefix->FormValue;
	}

	// Load row based on key values
	function LoadRow() {
		global $conn, $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		global $conn;
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->auth_status->setDbValue($rs->fields('auth_status'));
		$this->_email->setDbValue($rs->fields('email'));
		$this->user->setDbValue($rs->fields('user'));
		$this->pwd->setDbValue($rs->fields('pwd'));
		$this->first->setDbValue($rs->fields('first'));
		$this->last->setDbValue($rs->fields('last'));
		$this->status->setDbValue($rs->fields('status'));
		$this->signature->setDbValue($rs->fields('signature'));
		$this->quote_prefix->setDbValue($rs->fields('quote_prefix'));
	}

	// Render row values based on field settings
	function RenderRow() {
		global $conn, $Security, $Language;
		global $gsLanguage;

		// Initialize URLs
		// Call Row_Rendering event

		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey
		// auth_status
		// email
		// user
		// pwd
		// first
		// last
		// status
		// signature
		// quote_prefix

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

			// dbkey
			$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
			$this->dbkey->ViewCustomAttributes = "";

			// auth_status
			$this->auth_status->ViewValue = $this->auth_status->CurrentValue;
			$this->auth_status->ViewCustomAttributes = "";

			// email
			$this->_email->ViewValue = $this->_email->CurrentValue;
			$this->_email->ViewCustomAttributes = "";

			// user
			$this->user->ViewValue = $this->user->CurrentValue;
			$this->user->ViewCustomAttributes = "";

			// pwd
			$this->pwd->ViewValue = $this->pwd->CurrentValue;
			$this->pwd->ViewCustomAttributes = "";

			// first
			$this->first->ViewValue = $this->first->CurrentValue;
			$this->first->ViewCustomAttributes = "";

			// last
			$this->last->ViewValue = $this->last->CurrentValue;
			$this->last->ViewCustomAttributes = "";

			// status
			$this->status->ViewValue = $this->status->CurrentValue;
			$this->status->ViewCustomAttributes = "";

			// signature
			$this->signature->ViewValue = $this->signature->CurrentValue;
			$this->signature->ViewCustomAttributes = "";

			// quote_prefix
			$this->quote_prefix->ViewValue = $this->quote_prefix->CurrentValue;
			$this->quote_prefix->ViewCustomAttributes = "";

			// dbkey
			$this->dbkey->LinkCustomAttributes = "";
			$this->dbkey->HrefValue = "";
			$this->dbkey->TooltipValue = "";

			// auth_status
			$this->auth_status->LinkCustomAttributes = "";
			$this->auth_status->HrefValue = "";
			$this->auth_status->TooltipValue = "";

			// email
			$this->_email->LinkCustomAttributes = "";
			$this->_email->HrefValue = "";
			$this->_email->TooltipValue = "";

			// user
			$this->user->LinkCustomAttributes = "";
			$this->user->HrefValue = "";
			$this->user->TooltipValue = "";

			// pwd
			$this->pwd->LinkCustomAttributes = "";
			$this->pwd->HrefValue = "";
			$this->pwd->TooltipValue = "";

			// first
			$this->first->LinkCustomAttributes = "";
			$this->first->HrefValue = "";
			$this->first->TooltipValue = "";

			// last
			$this->last->LinkCustomAttributes = "";
			$this->last->HrefValue = "";
			$this->last->TooltipValue = "";

			// status
			$this->status->LinkCustomAttributes = "";
			$this->status->HrefValue = "";
			$this->status->TooltipValue = "";

			// signature
			$this->signature->LinkCustomAttributes = "";
			$this->signature->HrefValue = "";
			$this->signature->TooltipValue = "";

			// quote_prefix
			$this->quote_prefix->LinkCustomAttributes = "";
			$this->quote_prefix->HrefValue = "";
			$this->quote_prefix->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_EDIT) { // Edit row

			// dbkey
			$this->dbkey->EditCustomAttributes = "";
			$this->dbkey->EditValue = $this->dbkey->CurrentValue;
			$this->dbkey->ViewCustomAttributes = "";

			// auth_status
			$this->auth_status->EditCustomAttributes = "";
			$this->auth_status->EditValue = $this->auth_status->CurrentValue;
			$this->auth_status->ViewCustomAttributes = "";

			// email
			$this->_email->EditCustomAttributes = "";
			$this->_email->EditValue = ew_HtmlEncode($this->_email->CurrentValue);

			// user
			$this->user->EditCustomAttributes = "";
			$this->user->EditValue = ew_HtmlEncode($this->user->CurrentValue);

			// pwd
			$this->pwd->EditCustomAttributes = "";
			$this->pwd->EditValue = ew_HtmlEncode($this->pwd->CurrentValue);

			// first
			$this->first->EditCustomAttributes = "";
			$this->first->EditValue = ew_HtmlEncode($this->first->CurrentValue);

			// last
			$this->last->EditCustomAttributes = "";
			$this->last->EditValue = ew_HtmlEncode($this->last->CurrentValue);

			// status
			$this->status->EditCustomAttributes = "";
			$this->status->EditValue = ew_HtmlEncode($this->status->CurrentValue);

			// signature
			$this->signature->EditCustomAttributes = "";
			$this->signature->EditValue = ew_HtmlEncode($this->signature->CurrentValue);

			// quote_prefix
			$this->quote_prefix->EditCustomAttributes = "";
			$this->quote_prefix->EditValue = ew_HtmlEncode($this->quote_prefix->CurrentValue);

			// Edit refer script
			// dbkey

			$this->dbkey->HrefValue = "";

			// auth_status
			$this->auth_status->HrefValue = "";

			// email
			$this->_email->HrefValue = "";

			// user
			$this->user->HrefValue = "";

			// pwd
			$this->pwd->HrefValue = "";

			// first
			$this->first->HrefValue = "";

			// last
			$this->last->HrefValue = "";

			// status
			$this->status->HrefValue = "";

			// signature
			$this->signature->HrefValue = "";

			// quote_prefix
			$this->quote_prefix->HrefValue = "";
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate form
	function ValidateForm() {
		global $Language, $gsFormError;

		// Initialize form error message
		$gsFormError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return ($gsFormError == "");
		if (!is_null($this->auth_status->FormValue) && $this->auth_status->FormValue == "") {
			ew_AddMessage($gsFormError, $Language->Phrase("EnterRequiredField") . " - " . $this->auth_status->FldCaption());
		}
		if (!is_null($this->_email->FormValue) && $this->_email->FormValue == "") {
			ew_AddMessage($gsFormError, $Language->Phrase("EnterRequiredField") . " - " . $this->_email->FldCaption());
		}
		if (!is_null($this->user->FormValue) && $this->user->FormValue == "") {
			ew_AddMessage($gsFormError, $Language->Phrase("EnterRequiredField") . " - " . $this->user->FldCaption());
		}
		if (!is_null($this->pwd->FormValue) && $this->pwd->FormValue == "") {
			ew_AddMessage($gsFormError, $Language->Phrase("EnterRequiredField") . " - " . $this->pwd->FldCaption());
		}
		if (!is_null($this->first->FormValue) && $this->first->FormValue == "") {
			ew_AddMessage($gsFormError, $Language->Phrase("EnterRequiredField") . " - " . $this->first->FldCaption());
		}
		if (!is_null($this->last->FormValue) && $this->last->FormValue == "") {
			ew_AddMessage($gsFormError, $Language->Phrase("EnterRequiredField") . " - " . $this->last->FldCaption());
		}

		// Return validate result
		$ValidateForm = ($gsFormError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateForm = $ValidateForm && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsFormError, $sFormCustomError);
		}
		return $ValidateForm;
	}

	// Update record based on key values
	function EditRow() {
		global $conn, $Security, $Language;
		$sFilter = $this->KeyFilter();
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn->raiseErrorFn = 'ew_ErrorFn';
		$rs = $conn->Execute($sSql);
		$conn->raiseErrorFn = '';
		if ($rs === FALSE)
			return FALSE;
		if ($rs->EOF) {
			$EditRow = FALSE; // Update Failed
		} else {

			// Save old values
			$rsold = &$rs->fields;
			$rsnew = array();

			// auth_status
			// email

			$this->_email->SetDbValueDef($rsnew, $this->_email->CurrentValue, "", $this->_email->ReadOnly);

			// user
			$this->user->SetDbValueDef($rsnew, $this->user->CurrentValue, "", $this->user->ReadOnly);

			// pwd
			$this->pwd->SetDbValueDef($rsnew, $this->pwd->CurrentValue, "", $this->pwd->ReadOnly);

			// first
			$this->first->SetDbValueDef($rsnew, $this->first->CurrentValue, "", $this->first->ReadOnly);

			// last
			$this->last->SetDbValueDef($rsnew, $this->last->CurrentValue, "", $this->last->ReadOnly);

			// status
			$this->status->SetDbValueDef($rsnew, $this->status->CurrentValue, NULL, $this->status->ReadOnly);

			// signature
			$this->signature->SetDbValueDef($rsnew, $this->signature->CurrentValue, NULL, $this->signature->ReadOnly);

			// quote_prefix
			$this->quote_prefix->SetDbValueDef($rsnew, $this->quote_prefix->CurrentValue, NULL, $this->quote_prefix->ReadOnly);

			// Call Row Updating event
			$bUpdateRow = $this->Row_Updating($rsold, $rsnew);
			if ($bUpdateRow) {
				$conn->raiseErrorFn = 'ew_ErrorFn';
				if (count($rsnew) > 0)
					$EditRow = $this->Update($rsnew);
				else
					$EditRow = TRUE; // No field to update
				$conn->raiseErrorFn = '';
			} else {
				if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

					// Use the message, do nothing
				} elseif ($this->CancelMessage <> "") {
					$this->setFailureMessage($this->CancelMessage);
					$this->CancelMessage = "";
				} else {
					$this->setFailureMessage($Language->Phrase("UpdateCancelled"));
				}
				$EditRow = FALSE;
			}
		}

		// Call Row_Updated event
		if ($EditRow)
			$this->Row_Updated($rsold, $rsnew);
		$rs->Close();
		return $EditRow;
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($site_admin_edit)) $site_admin_edit = new csite_admin_edit();

// Page init
$site_admin_edit->Page_Init();

// Page main
$site_admin_edit->Page_Main();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Page object
var site_admin_edit = new ew_Page("site_admin_edit");
site_admin_edit.PageID = "edit"; // Page ID
var EW_PAGE_ID = site_admin_edit.PageID; // For backward compatibility

// Form object
var fsite_adminedit = new ew_Form("fsite_adminedit");

// Validate form
fsite_adminedit.Validate = function(fobj) {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	fobj = fobj || this.Form;
	this.PostAutoSuggest();	
	if (fobj.a_confirm && fobj.a_confirm.value == "F")
		return true;
	var elm, aelm;
	var rowcnt = 1;
	var startcnt = (rowcnt == 0) ? 0 : 1; // rowcnt == 0 => Inline-Add
	for (var i = startcnt; i <= rowcnt; i++) {
		var infix = "";
		elm = fobj.elements["x" + infix + "_auth_status"];
		if (elm && !ew_HasValue(elm))
			return ew_OnError(this, elm, ewLanguage.Phrase("EnterRequiredField") + " - <?php echo ew_JsEncode2($site_admin->auth_status->FldCaption()) ?>");
		elm = fobj.elements["x" + infix + "__email"];
		if (elm && !ew_HasValue(elm))
			return ew_OnError(this, elm, ewLanguage.Phrase("EnterRequiredField") + " - <?php echo ew_JsEncode2($site_admin->_email->FldCaption()) ?>");
		elm = fobj.elements["x" + infix + "_user"];
		if (elm && !ew_HasValue(elm))
			return ew_OnError(this, elm, ewLanguage.Phrase("EnterRequiredField") + " - <?php echo ew_JsEncode2($site_admin->user->FldCaption()) ?>");
		elm = fobj.elements["x" + infix + "_pwd"];
		if (elm && !ew_HasValue(elm))
			return ew_OnError(this, elm, ewLanguage.Phrase("EnterRequiredField") + " - <?php echo ew_JsEncode2($site_admin->pwd->FldCaption()) ?>");
		elm = fobj.elements["x" + infix + "_first"];
		if (elm && !ew_HasValue(elm))
			return ew_OnError(this, elm, ewLanguage.Phrase("EnterRequiredField") + " - <?php echo ew_JsEncode2($site_admin->first->FldCaption()) ?>");
		elm = fobj.elements["x" + infix + "_last"];
		if (elm && !ew_HasValue(elm))
			return ew_OnError(this, elm, ewLanguage.Phrase("EnterRequiredField") + " - <?php echo ew_JsEncode2($site_admin->last->FldCaption()) ?>");

		// Set up row object
		ew_ElementsToRow(fobj, infix);

		// Fire Form_CustomValidate event
		if (!this.Form_CustomValidate(fobj))
			return false;
	}

	// Process detail page
	if (fobj.detailpage && fobj.detailpage.value && ewForms[fobj.detailpage.value])
		return ewForms[fobj.detailpage.value].Validate(fobj);
	return true;
}

// Form_CustomValidate event
fsite_adminedit.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fsite_adminedit.ValidateRequired = true;
<?php } else { ?>
fsite_adminedit.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
// Form object for search

</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<p><span id="ewPageCaption" class="ewTitle ewTableTitle"><?php echo $Language->Phrase("Edit") ?>&nbsp;<?php echo $Language->Phrase("TblTypeTABLE") ?><?php echo $site_admin->TableCaption() ?></span></p>
<p class="phpmaker"><a href="<?php echo $site_admin->getReturnUrl() ?>" id="a_GoBack" class="ewLink"><?php echo $Language->Phrase("GoBack") ?></a></p>
<?php $site_admin_edit->ShowPageHeader(); ?>
<?php
$site_admin_edit->ShowMessage();
?>
<form name="fsite_adminedit" id="fsite_adminedit" class="ewForm" action="<?php echo ew_CurrentPage() ?>" method="post" onsubmit="return ewForms[this.id].Submit();">
<br>
<input type="hidden" name="t" value="site_admin">
<input type="hidden" name="a_edit" id="a_edit" value="U">
<table cellspacing="0" class="ewGrid"><tr><td class="ewGridContent">
<div class="ewGridMiddlePanel">
<table id="tbl_site_adminedit" class="ewTable">
<?php if ($site_admin->dbkey->Visible) { // dbkey ?>
	<tr id="r_dbkey"<?php echo $site_admin->RowAttributes() ?>>
		<td class="ewTableHeader"><span id="elh_site_admin_dbkey"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->dbkey->FldCaption() ?></td></tr></table></span></td>
		<td<?php echo $site_admin->dbkey->CellAttributes() ?>><span id="el_site_admin_dbkey">
<span<?php echo $site_admin->dbkey->ViewAttributes() ?>>
<?php echo $site_admin->dbkey->EditValue ?></span>
<input type="hidden" name="x_dbkey" id="x_dbkey" value="<?php echo ew_HtmlEncode($site_admin->dbkey->CurrentValue) ?>">
</span><?php echo $site_admin->dbkey->CustomMsg ?></td>
	</tr>
<?php } ?>
<?php if ($site_admin->auth_status->Visible) { // auth_status ?>
	<tr id="r_auth_status"<?php echo $site_admin->RowAttributes() ?>>
		<td class="ewTableHeader"><span id="elh_site_admin_auth_status"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->auth_status->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></td></tr></table></span></td>
		<td<?php echo $site_admin->auth_status->CellAttributes() ?>><span id="el_site_admin_auth_status">
<span<?php echo $site_admin->auth_status->ViewAttributes() ?>>
<?php echo $site_admin->auth_status->EditValue ?></span>
<input type="hidden" name="x_auth_status" id="x_auth_status" value="<?php echo ew_HtmlEncode($site_admin->auth_status->CurrentValue) ?>">
</span><?php echo $site_admin->auth_status->CustomMsg ?></td>
	</tr>
<?php } ?>
<?php if ($site_admin->_email->Visible) { // email ?>
	<tr id="r__email"<?php echo $site_admin->RowAttributes() ?>>
		<td class="ewTableHeader"><span id="elh_site_admin__email"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->_email->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></td></tr></table></span></td>
		<td<?php echo $site_admin->_email->CellAttributes() ?>><span id="el_site_admin__email">
<input type="text" name="x__email" id="x__email" size="30" maxlength="50" value="<?php echo $site_admin->_email->EditValue ?>"<?php echo $site_admin->_email->EditAttributes() ?>>
</span><?php echo $site_admin->_email->CustomMsg ?></td>
	</tr>
<?php } ?>
<?php if ($site_admin->user->Visible) { // user ?>
	<tr id="r_user"<?php echo $site_admin->RowAttributes() ?>>
		<td class="ewTableHeader"><span id="elh_site_admin_user"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->user->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></td></tr></table></span></td>
		<td<?php echo $site_admin->user->CellAttributes() ?>><span id="el_site_admin_user">
<input type="text" name="x_user" id="x_user" size="30" maxlength="30" value="<?php echo $site_admin->user->EditValue ?>"<?php echo $site_admin->user->EditAttributes() ?>>
</span><?php echo $site_admin->user->CustomMsg ?></td>
	</tr>
<?php } ?>
<?php if ($site_admin->pwd->Visible) { // pwd ?>
	<tr id="r_pwd"<?php echo $site_admin->RowAttributes() ?>>
		<td class="ewTableHeader"><span id="elh_site_admin_pwd"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->pwd->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></td></tr></table></span></td>
		<td<?php echo $site_admin->pwd->CellAttributes() ?>><span id="el_site_admin_pwd">
<input type="text" name="x_pwd" id="x_pwd" size="30" maxlength="32" value="<?php echo $site_admin->pwd->EditValue ?>"<?php echo $site_admin->pwd->EditAttributes() ?>>
</span><?php echo $site_admin->pwd->CustomMsg ?></td>
	</tr>
<?php } ?>
<?php if ($site_admin->first->Visible) { // first ?>
	<tr id="r_first"<?php echo $site_admin->RowAttributes() ?>>
		<td class="ewTableHeader"><span id="elh_site_admin_first"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->first->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></td></tr></table></span></td>
		<td<?php echo $site_admin->first->CellAttributes() ?>><span id="el_site_admin_first">
<input type="text" name="x_first" id="x_first" size="30" maxlength="30" value="<?php echo $site_admin->first->EditValue ?>"<?php echo $site_admin->first->EditAttributes() ?>>
</span><?php echo $site_admin->first->CustomMsg ?></td>
	</tr>
<?php } ?>
<?php if ($site_admin->last->Visible) { // last ?>
	<tr id="r_last"<?php echo $site_admin->RowAttributes() ?>>
		<td class="ewTableHeader"><span id="elh_site_admin_last"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->last->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></td></tr></table></span></td>
		<td<?php echo $site_admin->last->CellAttributes() ?>><span id="el_site_admin_last">
<input type="text" name="x_last" id="x_last" size="30" maxlength="30" value="<?php echo $site_admin->last->EditValue ?>"<?php echo $site_admin->last->EditAttributes() ?>>
</span><?php echo $site_admin->last->CustomMsg ?></td>
	</tr>
<?php } ?>
<?php if ($site_admin->status->Visible) { // status ?>
	<tr id="r_status"<?php echo $site_admin->RowAttributes() ?>>
		<td class="ewTableHeader"><span id="elh_site_admin_status"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->status->FldCaption() ?></td></tr></table></span></td>
		<td<?php echo $site_admin->status->CellAttributes() ?>><span id="el_site_admin_status">
<input type="text" name="x_status" id="x_status" size="30" maxlength="1" value="<?php echo $site_admin->status->EditValue ?>"<?php echo $site_admin->status->EditAttributes() ?>>
</span><?php echo $site_admin->status->CustomMsg ?></td>
	</tr>
<?php } ?>
<?php if ($site_admin->signature->Visible) { // signature ?>
	<tr id="r_signature"<?php echo $site_admin->RowAttributes() ?>>
		<td class="ewTableHeader"><span id="elh_site_admin_signature"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->signature->FldCaption() ?></td></tr></table></span></td>
		<td<?php echo $site_admin->signature->CellAttributes() ?>><span id="el_site_admin_signature">
<textarea name="x_signature" id="x_signature" cols="35" rows="4"<?php echo $site_admin->signature->EditAttributes() ?>><?php echo $site_admin->signature->EditValue ?></textarea>
</span><?php echo $site_admin->signature->CustomMsg ?></td>
	</tr>
<?php } ?>
<?php if ($site_admin->quote_prefix->Visible) { // quote_prefix ?>
	<tr id="r_quote_prefix"<?php echo $site_admin->RowAttributes() ?>>
		<td class="ewTableHeader"><span id="elh_site_admin_quote_prefix"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->quote_prefix->FldCaption() ?></td></tr></table></span></td>
		<td<?php echo $site_admin->quote_prefix->CellAttributes() ?>><span id="el_site_admin_quote_prefix">
<input type="text" name="x_quote_prefix" id="x_quote_prefix" size="30" maxlength="4" value="<?php echo $site_admin->quote_prefix->EditValue ?>"<?php echo $site_admin->quote_prefix->EditAttributes() ?>>
</span><?php echo $site_admin->quote_prefix->CustomMsg ?></td>
	</tr>
<?php } ?>
</table>
</div>
</td></tr></table>
<br>
<input type="submit" name="btnAction" id="btnAction" value="<?php echo ew_BtnCaption($Language->Phrase("EditBtn")) ?>">
</form>
<script type="text/javascript">
fsite_adminedit.Init();
</script>
<?php
$site_admin_edit->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$site_admin_edit->Page_Terminate();
?>
