<?php
if (session_id() == "") session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg9.php" ?>
<?php include_once "ewmysql9.php" ?>
<?php include_once "phpfn9.php" ?>
<?php include_once "site_admininfo.php" ?>
<?php include_once "userfn9.php" ?>
<?php

//
// Page class
//

$site_admin_list = NULL; // Initialize page object first

class csite_admin_list extends csite_admin {

	// Page ID
	var $PageID = 'list';

	// Project ID
	var $ProjectID = "{095601E1-93A8-4664-8CCA-D6A58AA0A39D}";

	// Table name
	var $TableName = 'site_admin';

	// Page object name
	var $PageObjName = 'site_admin_list';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Page URLs
	var $AddUrl;
	var $EditUrl;
	var $CopyUrl;
	var $DeleteUrl;
	var $ViewUrl;
	var $ListUrl;

	// Export URLs
	var $ExportPrintUrl;
	var $ExportHtmlUrl;
	var $ExportExcelUrl;
	var $ExportWordUrl;
	var $ExportXmlUrl;
	var $ExportCsvUrl;
	var $ExportPdfUrl;

	// Update URLs
	var $InlineAddUrl;
	var $InlineCopyUrl;
	var $InlineEditUrl;
	var $GridAddUrl;
	var $GridEditUrl;
	var $MultiDeleteUrl;
	var $MultiUpdateUrl;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			$html .= "<p class=\"ewMessage\">" . $sMessage . "</p>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			$html .= "<table class=\"ewMessageTable\"><tr><td class=\"ewWarningIcon\"></td><td class=\"ewWarningMessage\">" . $sWarningMessage . "</td></tr></table>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			$html .= "<table class=\"ewMessageTable\"><tr><td class=\"ewSuccessIcon\"></td><td class=\"ewSuccessMessage\">" . $sSuccessMessage . "</td></tr></table>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			$html .= "<table class=\"ewMessageTable\"><tr><td class=\"ewErrorIcon\"></td><td class=\"ewErrorMessage\">" . $sErrorMessage . "</td></tr></table>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p class=\"phpmaker\">" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Fotoer exists, display
			echo "<p class=\"phpmaker\">" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language, $UserAgent;

		// User agent
		$UserAgent = ew_UserAgent();
		$GLOBALS["Page"] = &$this;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (site_admin)
		if (!isset($GLOBALS["site_admin"])) {
			$GLOBALS["site_admin"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["site_admin"];
		}

		// Initialize URLs
		$this->ExportPrintUrl = $this->PageUrl() . "export=print";
		$this->ExportExcelUrl = $this->PageUrl() . "export=excel";
		$this->ExportWordUrl = $this->PageUrl() . "export=word";
		$this->ExportHtmlUrl = $this->PageUrl() . "export=html";
		$this->ExportXmlUrl = $this->PageUrl() . "export=xml";
		$this->ExportCsvUrl = $this->PageUrl() . "export=csv";
		$this->ExportPdfUrl = $this->PageUrl() . "export=pdf";
		$this->AddUrl = "site_adminadd.php";
		$this->InlineAddUrl = $this->PageUrl() . "a=add";
		$this->GridAddUrl = $this->PageUrl() . "a=gridadd";
		$this->GridEditUrl = $this->PageUrl() . "a=gridedit";
		$this->MultiDeleteUrl = "site_admindelete.php";
		$this->MultiUpdateUrl = "site_adminupdate.php";

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'list', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'site_admin', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect();

		// List options
		$this->ListOptions = new cListOptions();
		$this->ListOptions->TableVar = $this->TableVar;

		// Export options
		$this->ExportOptions = new cListOptions();
		$this->ExportOptions->Tag = "span";
		$this->ExportOptions->TagClassName = "ewExportOption";
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// Get grid add count
		$gridaddcnt = @$_GET[EW_TABLE_GRID_ADD_ROW_COUNT];
		if (is_numeric($gridaddcnt) && $gridaddcnt > 0)
			$this->GridAddRowCount = $gridaddcnt;

		// Set up list options
		$this->SetupListOptions();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"];
		$this->dbkey->Visible = !$this->IsAdd() && !$this->IsCopy() && !$this->IsGridAdd();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $conn;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();
		$this->Page_Redirecting($url);

		 // Close connection
		$conn->Close();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}

	// Class variables
	var $ListOptions; // List options
	var $ExportOptions; // Export options
	var $DisplayRecs = 20;
	var $StartRec;
	var $StopRec;
	var $TotalRecs = 0;
	var $RecRange = 10;
	var $Pager;
	var $SearchWhere = ""; // Search WHERE clause
	var $RecCnt = 0; // Record count
	var $EditRowCnt;
	var $StartRowCnt = 1;
	var $RowCnt = 0;
	var $Attrs = array(); // Row attributes and cell attributes
	var $RowIndex = 0; // Row index
	var $KeyCount = 0; // Key count
	var $RowAction = ""; // Row action
	var $RowOldKey = ""; // Row old key (for copy)
	var $RecPerRow = 0;
	var $ColCnt = 0;
	var $DbMasterFilter = ""; // Master filter
	var $DbDetailFilter = ""; // Detail filter
	var $MasterRecordExists;	
	var $MultiSelectKey;
	var $Command;
	var $Recordset;
	var $OldRecordset;

	//
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError, $gsSearchError, $Security;

		// Search filters
		$sSrchAdvanced = ""; // Advanced search filter
		$sSrchBasic = ""; // Basic search filter
		$sFilter = "";

		// Get command
		$this->Command = strtolower(@$_GET["cmd"]);
		if ($this->IsPageRequest()) { // Validate request

			// Handle reset command
			$this->ResetCmd();

			// Hide all options
			if ($this->Export <> "" ||
				$this->CurrentAction == "gridadd" ||
				$this->CurrentAction == "gridedit") {
				$this->ListOptions->HideAllOptions();
				$this->ExportOptions->HideAllOptions();
			}

			// Get basic search values
			$this->LoadBasicSearchValues();

			// Restore search parms from Session if not searching / reset
			if ($this->Command <> "search" && $this->Command <> "reset" && $this->Command <> "resetall")
				$this->RestoreSearchParms();

			// Call Recordset SearchValidated event
			$this->Recordset_SearchValidated();

			// Set up sorting order
			$this->SetUpSortOrder();

			// Get basic search criteria
			if ($gsSearchError == "")
				$sSrchBasic = $this->BasicSearchWhere();
		}

		// Restore display records
		if ($this->getRecordsPerPage() <> "") {
			$this->DisplayRecs = $this->getRecordsPerPage(); // Restore from Session
		} else {
			$this->DisplayRecs = 20; // Load default
		}

		// Load Sorting Order
		$this->LoadSortOrder();

		// Load search default if no existing search criteria
		if (!$this->CheckSearchParms()) {

			// Load basic search from default
			$this->BasicSearch->LoadDefault();
			if ($this->BasicSearch->Keyword != "")
				$sSrchBasic = $this->BasicSearchWhere();
		}

		// Build search criteria
		ew_AddFilter($this->SearchWhere, $sSrchAdvanced);
		ew_AddFilter($this->SearchWhere, $sSrchBasic);

		// Call Recordset_Searching event
		$this->Recordset_Searching($this->SearchWhere);

		// Save search criteria
		if ($this->Command == "search") {
			$this->setSearchWhere($this->SearchWhere); // Save to Session
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} else {
			$this->SearchWhere = $this->getSearchWhere();
		}

		// Build filter
		$sFilter = "";
		ew_AddFilter($sFilter, $this->DbDetailFilter);
		ew_AddFilter($sFilter, $this->SearchWhere);

		// Set up filter in session
		$this->setSessionWhere($sFilter);
		$this->CurrentFilter = "";
	}

	// Build filter for all keys
	function BuildKeyFilter() {
		global $objForm;
		$sWrkFilter = "";

		// Update row index and get row key
		$rowindex = 1;
		$objForm->Index = $rowindex;
		$sThisKey = strval($objForm->GetValue("k_key"));
		while ($sThisKey <> "") {
			if ($this->SetupKeyValues($sThisKey)) {
				$sFilter = $this->KeyFilter();
				if ($sWrkFilter <> "") $sWrkFilter .= " OR ";
				$sWrkFilter .= $sFilter;
			} else {
				$sWrkFilter = "0=1";
				break;
			}

			// Update row index and get row key
			$rowindex++; // next row
			$objForm->Index = $rowindex;
			$sThisKey = strval($objForm->GetValue("k_key"));
		}
		return $sWrkFilter;
	}

	// Set up key values
	function SetupKeyValues($key) {
		$arrKeyFlds = explode($GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"], $key);
		if (count($arrKeyFlds) >= 2) {
			$this->dbkey->setFormValue($arrKeyFlds[0]);
			if (!is_numeric($this->dbkey->FormValue))
				return FALSE;
			$this->auth_status->setFormValue($arrKeyFlds[1]);
		}
		return TRUE;
	}

	// Return basic search SQL
	function BasicSearchSQL($Keyword) {
		$sKeyword = ew_AdjustSql($Keyword);
		$sWhere = "";
		$this->BuildBasicSearchSQL($sWhere, $this->auth_status, $Keyword);
		$this->BuildBasicSearchSQL($sWhere, $this->_email, $Keyword);
		$this->BuildBasicSearchSQL($sWhere, $this->user, $Keyword);
		$this->BuildBasicSearchSQL($sWhere, $this->pwd, $Keyword);
		$this->BuildBasicSearchSQL($sWhere, $this->first, $Keyword);
		$this->BuildBasicSearchSQL($sWhere, $this->last, $Keyword);
		$this->BuildBasicSearchSQL($sWhere, $this->status, $Keyword);
		$this->BuildBasicSearchSQL($sWhere, $this->signature, $Keyword);
		$this->BuildBasicSearchSQL($sWhere, $this->quote_prefix, $Keyword);
		return $sWhere;
	}

	// Build basic search SQL
	function BuildBasicSearchSql(&$Where, &$Fld, $Keyword) {
		if ($Keyword == EW_NULL_VALUE) {
			$sWrk = $Fld->FldExpression . " IS NULL";
		} elseif ($Keyword == EW_NOT_NULL_VALUE) {
			$sWrk = $Fld->FldExpression . " IS NOT NULL";
		} else {
			$sFldExpression = ($Fld->FldVirtualExpression <> $Fld->FldExpression) ? $Fld->FldVirtualExpression : $Fld->FldBasicSearchExpression;
			$sWrk = $sFldExpression . ew_Like(ew_QuotedValue("%" . $Keyword . "%", EW_DATATYPE_STRING));
		}
		if ($Where <> "") $Where .= " OR ";
		$Where .= $sWrk;
	}

	// Return basic search WHERE clause based on search keyword and type
	function BasicSearchWhere() {
		global $Security;
		$sSearchStr = "";
		$sSearchKeyword = $this->BasicSearch->Keyword;
		$sSearchType = $this->BasicSearch->Type;
		if ($sSearchKeyword <> "") {
			$sSearch = trim($sSearchKeyword);
			if ($sSearchType <> "=") {
				while (strpos($sSearch, "  ") !== FALSE)
					$sSearch = str_replace("  ", " ", $sSearch);
				$arKeyword = explode(" ", trim($sSearch));
				foreach ($arKeyword as $sKeyword) {
					if ($sSearchStr <> "") $sSearchStr .= " " . $sSearchType . " ";
					$sSearchStr .= "(" . $this->BasicSearchSQL($sKeyword) . ")";
				}
			} else {
				$sSearchStr = $this->BasicSearchSQL($sSearch);
			}
			$this->Command = "search";
		}
		if ($this->Command == "search") {
			$this->BasicSearch->setKeyword($sSearchKeyword);
			$this->BasicSearch->setType($sSearchType);
		}
		return $sSearchStr;
	}

	// Check if search parm exists
	function CheckSearchParms() {

		// Check basic search
		if ($this->BasicSearch->IssetSession())
			return TRUE;
		return FALSE;
	}

	// Clear all search parameters
	function ResetSearchParms() {

		// Clear search WHERE clause
		$this->SearchWhere = "";
		$this->setSearchWhere($this->SearchWhere);

		// Clear basic search parameters
		$this->ResetBasicSearchParms();
	}

	// Load advanced search default values
	function LoadAdvancedSearchDefault() {
		return FALSE;
	}

	// Clear all basic search parameters
	function ResetBasicSearchParms() {
		$this->BasicSearch->UnsetSession();
	}

	// Restore all search parameters
	function RestoreSearchParms() {

		// Restore basic search values
		$this->BasicSearch->Load();
	}

	// Set up sort parameters
	function SetUpSortOrder() {

		// Check for "order" parameter
		if (@$_GET["order"] <> "") {
			$this->CurrentOrder = ew_StripSlashes(@$_GET["order"]);
			$this->CurrentOrderType = @$_GET["ordertype"];
			$this->UpdateSort($this->dbkey); // dbkey
			$this->UpdateSort($this->auth_status); // auth_status
			$this->UpdateSort($this->_email); // email
			$this->UpdateSort($this->user); // user
			$this->UpdateSort($this->pwd); // pwd
			$this->UpdateSort($this->first); // first
			$this->UpdateSort($this->last); // last
			$this->UpdateSort($this->status); // status
			$this->UpdateSort($this->quote_prefix); // quote_prefix
			$this->setStartRecordNumber(1); // Reset start position
		}
	}

	// Load sort order parameters
	function LoadSortOrder() {
		$sOrderBy = $this->getSessionOrderBy(); // Get ORDER BY from Session
		if ($sOrderBy == "") {
			if ($this->SqlOrderBy() <> "") {
				$sOrderBy = $this->SqlOrderBy();
				$this->setSessionOrderBy($sOrderBy);
			}
		}
	}

	// Reset command
	// cmd=reset (Reset search parameters)
	// cmd=resetall (Reset search and master/detail parameters)
	// cmd=resetsort (Reset sort parameters)
	function ResetCmd() {

		// Check if reset command
		if (substr($this->Command,0,5) == "reset") {

			// Reset search criteria
			if ($this->Command == "reset" || $this->Command == "resetall")
				$this->ResetSearchParms();

			// Reset sorting order
			if ($this->Command == "resetsort") {
				$sOrderBy = "";
				$this->setSessionOrderBy($sOrderBy);
				$this->dbkey->setSort("");
				$this->auth_status->setSort("");
				$this->_email->setSort("");
				$this->user->setSort("");
				$this->pwd->setSort("");
				$this->first->setSort("");
				$this->last->setSort("");
				$this->status->setSort("");
				$this->quote_prefix->setSort("");
			}

			// Reset start position
			$this->StartRec = 1;
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Set up list options
	function SetupListOptions() {
		global $Security, $Language;

		// "view"
		$item = &$this->ListOptions->Add("view");
		$item->CssStyle = "white-space: nowrap;";
		$item->Visible = TRUE;
		$item->OnLeft = FALSE;

		// "edit"
		$item = &$this->ListOptions->Add("edit");
		$item->CssStyle = "white-space: nowrap;";
		$item->Visible = TRUE;
		$item->OnLeft = FALSE;

		// "copy"
		$item = &$this->ListOptions->Add("copy");
		$item->CssStyle = "white-space: nowrap;";
		$item->Visible = TRUE;
		$item->OnLeft = FALSE;

		// "delete"
		$item = &$this->ListOptions->Add("delete");
		$item->CssStyle = "white-space: nowrap;";
		$item->Visible = TRUE;
		$item->OnLeft = FALSE;

		// Call ListOptions_Load event
		$this->ListOptions_Load();
	}

	// Render list options
	function RenderListOptions() {
		global $Security, $Language, $objForm;
		$this->ListOptions->LoadDefault();

		// "view"
		$oListOpt = &$this->ListOptions->Items["view"];
		if (TRUE)
			$oListOpt->Body = "<a class=\"ewRowLink\" href=\"" . $this->ViewUrl . "\">" . $Language->Phrase("ViewLink") . "</a>";

		// "edit"
		$oListOpt = &$this->ListOptions->Items["edit"];
		if (TRUE) {
			$oListOpt->Body = "<a class=\"ewRowLink\" href=\"" . $this->EditUrl . "\">" . $Language->Phrase("EditLink") . "</a>";
		}

		// "copy"
		$oListOpt = &$this->ListOptions->Items["copy"];
		if (TRUE) {
			$oListOpt->Body = "<a class=\"ewRowLink\" href=\"" . $this->CopyUrl . "\">" . $Language->Phrase("CopyLink") . "</a>";
		}

		// "delete"
		$oListOpt = &$this->ListOptions->Items["delete"];
		if (TRUE)
			$oListOpt->Body = "<a class=\"ewRowLink\"" . "" . " href=\"" . $this->DeleteUrl . "\">" . $Language->Phrase("DeleteLink") . "</a>";
		$this->RenderListOptionsExt();

		// Call ListOptions_Rendered event
		$this->ListOptions_Rendered();
	}

	function RenderListOptionsExt() {
		global $Security, $Language;
	}

	// Set up starting record parameters
	function SetUpStartRec() {
		if ($this->DisplayRecs == 0)
			return;
		if ($this->IsPageRequest()) { // Validate request
			if (@$_GET[EW_TABLE_START_REC] <> "") { // Check for "start" parameter
				$this->StartRec = $_GET[EW_TABLE_START_REC];
				$this->setStartRecordNumber($this->StartRec);
			} elseif (@$_GET[EW_TABLE_PAGE_NO] <> "") {
				$PageNo = $_GET[EW_TABLE_PAGE_NO];
				if (is_numeric($PageNo)) {
					$this->StartRec = ($PageNo-1)*$this->DisplayRecs+1;
					if ($this->StartRec <= 0) {
						$this->StartRec = 1;
					} elseif ($this->StartRec >= intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1) {
						$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1;
					}
					$this->setStartRecordNumber($this->StartRec);
				}
			}
		}
		$this->StartRec = $this->getStartRecordNumber();

		// Check if correct start record counter
		if (!is_numeric($this->StartRec) || $this->StartRec == "") { // Avoid invalid start record counter
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} elseif (intval($this->StartRec) > intval($this->TotalRecs)) { // Avoid starting record > total records
			$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to last page first record
			$this->setStartRecordNumber($this->StartRec);
		} elseif (($this->StartRec-1) % $this->DisplayRecs <> 0) {
			$this->StartRec = intval(($this->StartRec-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to page boundary
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Load basic search values
	function LoadBasicSearchValues() {
		$this->BasicSearch->Keyword = @$_GET[EW_TABLE_BASIC_SEARCH];
		if ($this->BasicSearch->Keyword <> "") $this->Command = "search";
		$this->BasicSearch->Type = @$_GET[EW_TABLE_BASIC_SEARCH_TYPE];
	}

	// Load recordset
	function LoadRecordset($offset = -1, $rowcnt = -1) {
		global $conn;

		// Call Recordset Selecting event
		$this->Recordset_Selecting($this->CurrentFilter);

		// Load List page SQL
		$sSql = $this->SelectSQL();
		if ($offset > -1 && $rowcnt > -1)
			$sSql .= " LIMIT $rowcnt OFFSET $offset";

		// Load recordset
		$rs = ew_LoadRecordset($sSql);

		// Call Recordset Selected event
		$this->Recordset_Selected($rs);
		return $rs;
	}

	// Load row based on key values
	function LoadRow() {
		global $conn, $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		global $conn;
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->auth_status->setDbValue($rs->fields('auth_status'));
		$this->_email->setDbValue($rs->fields('email'));
		$this->user->setDbValue($rs->fields('user'));
		$this->pwd->setDbValue($rs->fields('pwd'));
		$this->first->setDbValue($rs->fields('first'));
		$this->last->setDbValue($rs->fields('last'));
		$this->status->setDbValue($rs->fields('status'));
		$this->signature->setDbValue($rs->fields('signature'));
		$this->quote_prefix->setDbValue($rs->fields('quote_prefix'));
	}

	// Load old record
	function LoadOldRecord() {

		// Load key values from Session
		$bValidKey = TRUE;
		if (strval($this->getKey("dbkey")) <> "")
			$this->dbkey->CurrentValue = $this->getKey("dbkey"); // dbkey
		else
			$bValidKey = FALSE;
		if (strval($this->getKey("auth_status")) <> "")
			$this->auth_status->CurrentValue = $this->getKey("auth_status"); // auth_status
		else
			$bValidKey = FALSE;

		// Load old recordset
		if ($bValidKey) {
			$this->CurrentFilter = $this->KeyFilter();
			$sSql = $this->SQL();
			$this->OldRecordset = ew_LoadRecordset($sSql);
			$this->LoadRowValues($this->OldRecordset); // Load row values
		} else {
			$this->OldRecordset = NULL;
		}
		return $bValidKey;
	}

	// Render row values based on field settings
	function RenderRow() {
		global $conn, $Security, $Language;
		global $gsLanguage;

		// Initialize URLs
		$this->ViewUrl = $this->GetViewUrl();
		$this->EditUrl = $this->GetEditUrl();
		$this->InlineEditUrl = $this->GetInlineEditUrl();
		$this->CopyUrl = $this->GetCopyUrl();
		$this->InlineCopyUrl = $this->GetInlineCopyUrl();
		$this->DeleteUrl = $this->GetDeleteUrl();

		// Call Row_Rendering event
		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey
		// auth_status
		// email
		// user
		// pwd
		// first
		// last
		// status
		// signature
		// quote_prefix

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

			// dbkey
			$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
			$this->dbkey->ViewCustomAttributes = "";

			// auth_status
			$this->auth_status->ViewValue = $this->auth_status->CurrentValue;
			$this->auth_status->ViewCustomAttributes = "";

			// email
			$this->_email->ViewValue = $this->_email->CurrentValue;
			$this->_email->ViewCustomAttributes = "";

			// user
			$this->user->ViewValue = $this->user->CurrentValue;
			$this->user->ViewCustomAttributes = "";

			// pwd
			$this->pwd->ViewValue = $this->pwd->CurrentValue;
			$this->pwd->ViewCustomAttributes = "";

			// first
			$this->first->ViewValue = $this->first->CurrentValue;
			$this->first->ViewCustomAttributes = "";

			// last
			$this->last->ViewValue = $this->last->CurrentValue;
			$this->last->ViewCustomAttributes = "";

			// status
			$this->status->ViewValue = $this->status->CurrentValue;
			$this->status->ViewCustomAttributes = "";

			// quote_prefix
			$this->quote_prefix->ViewValue = $this->quote_prefix->CurrentValue;
			$this->quote_prefix->ViewCustomAttributes = "";

			// dbkey
			$this->dbkey->LinkCustomAttributes = "";
			$this->dbkey->HrefValue = "";
			$this->dbkey->TooltipValue = "";

			// auth_status
			$this->auth_status->LinkCustomAttributes = "";
			$this->auth_status->HrefValue = "";
			$this->auth_status->TooltipValue = "";

			// email
			$this->_email->LinkCustomAttributes = "";
			$this->_email->HrefValue = "";
			$this->_email->TooltipValue = "";

			// user
			$this->user->LinkCustomAttributes = "";
			$this->user->HrefValue = "";
			$this->user->TooltipValue = "";

			// pwd
			$this->pwd->LinkCustomAttributes = "";
			$this->pwd->HrefValue = "";
			$this->pwd->TooltipValue = "";

			// first
			$this->first->LinkCustomAttributes = "";
			$this->first->HrefValue = "";
			$this->first->TooltipValue = "";

			// last
			$this->last->LinkCustomAttributes = "";
			$this->last->HrefValue = "";
			$this->last->TooltipValue = "";

			// status
			$this->status->LinkCustomAttributes = "";
			$this->status->HrefValue = "";
			$this->status->TooltipValue = "";

			// quote_prefix
			$this->quote_prefix->LinkCustomAttributes = "";
			$this->quote_prefix->HrefValue = "";
			$this->quote_prefix->TooltipValue = "";
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}

	// ListOptions Load event
	function ListOptions_Load() {

		// Example:
		//$opt = &$this->ListOptions->Add("new");
		//$opt->Header = "xxx";
		//$opt->OnLeft = TRUE; // Link on left
		//$opt->MoveTo(0); // Move to first column

	}

	// ListOptions Rendered event
	function ListOptions_Rendered() {

		// Example: 
		//$this->ListOptions->Items["new"]->Body = "xxx";

	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($site_admin_list)) $site_admin_list = new csite_admin_list();

// Page init
$site_admin_list->Page_Init();

// Page main
$site_admin_list->Page_Main();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Page object
var site_admin_list = new ew_Page("site_admin_list");
site_admin_list.PageID = "list"; // Page ID
var EW_PAGE_ID = site_admin_list.PageID; // For backward compatibility

// Form object
var fsite_adminlist = new ew_Form("fsite_adminlist");

// Form_CustomValidate event
fsite_adminlist.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fsite_adminlist.ValidateRequired = true;
<?php } else { ?>
fsite_adminlist.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
// Form object for search

var fsite_adminlistsrch = new ew_Form("fsite_adminlistsrch");
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php
	$bSelectLimit = EW_SELECT_LIMIT;
	if ($bSelectLimit) {
		$site_admin_list->TotalRecs = $site_admin->SelectRecordCount();
	} else {
		if ($site_admin_list->Recordset = $site_admin_list->LoadRecordset())
			$site_admin_list->TotalRecs = $site_admin_list->Recordset->RecordCount();
	}
	$site_admin_list->StartRec = 1;
	if ($site_admin_list->DisplayRecs <= 0 || ($site_admin->Export <> "" && $site_admin->ExportAll)) // Display all records
		$site_admin_list->DisplayRecs = $site_admin_list->TotalRecs;
	if (!($site_admin->Export <> "" && $site_admin->ExportAll))
		$site_admin_list->SetUpStartRec(); // Set up start record position
	if ($bSelectLimit)
		$site_admin_list->Recordset = $site_admin_list->LoadRecordset($site_admin_list->StartRec-1, $site_admin_list->DisplayRecs);
?>
<p style="white-space: nowrap;"><span id="ewPageCaption" class="ewTitle ewTableTitle"><?php echo $Language->Phrase("TblTypeTABLE") ?><?php echo $site_admin->TableCaption() ?>&nbsp;&nbsp;</span>
<?php $site_admin_list->ExportOptions->Render("body"); ?>
</p>
<?php if ($site_admin->Export == "" && $site_admin->CurrentAction == "") { ?>
<form name="fsite_adminlistsrch" id="fsite_adminlistsrch" class="ewForm" action="<?php echo ew_CurrentPage() ?>">
<a href="javascript:fsite_adminlistsrch.ToggleSearchPanel();" style="text-decoration: none;"><img id="fsite_adminlistsrch_SearchImage" src="phpimages/collapse.gif" alt="" width="9" height="9" style="border: 0;"></a><span class="phpmaker">&nbsp;<?php echo $Language->Phrase("Search") ?></span><br>
<div id="fsite_adminlistsrch_SearchPanel">
<input type="hidden" name="cmd" value="search">
<input type="hidden" name="t" value="site_admin">
<div class="ewBasicSearch">
<div id="xsr_1" class="ewRow">
	<input type="text" name="<?php echo EW_TABLE_BASIC_SEARCH ?>" id="<?php echo EW_TABLE_BASIC_SEARCH ?>" size="20" value="<?php echo ew_HtmlEncode($site_admin_list->BasicSearch->getKeyword()) ?>">
	<input type="submit" name="btnsubmit" id="btnsubmit" value="<?php echo ew_BtnCaption($Language->Phrase("QuickSearchBtn")) ?>">&nbsp;
	<a href="<?php echo $site_admin_list->PageUrl() ?>cmd=reset" id="a_ShowAll" class="ewLink"><?php echo $Language->Phrase("ShowAll") ?></a>&nbsp;
</div>
<div id="xsr_2" class="ewRow">
	<label><input type="radio" name="<?php echo EW_TABLE_BASIC_SEARCH_TYPE ?>" value="="<?php if ($site_admin_list->BasicSearch->getType() == "=") { ?> checked="checked"<?php } ?>><?php echo $Language->Phrase("ExactPhrase") ?></label>&nbsp;&nbsp;<label><input type="radio" name="<?php echo EW_TABLE_BASIC_SEARCH_TYPE ?>" value="AND"<?php if ($site_admin_list->BasicSearch->getType() == "AND") { ?> checked="checked"<?php } ?>><?php echo $Language->Phrase("AllWord") ?></label>&nbsp;&nbsp;<label><input type="radio" name="<?php echo EW_TABLE_BASIC_SEARCH_TYPE ?>" value="OR"<?php if ($site_admin_list->BasicSearch->getType() == "OR") { ?> checked="checked"<?php } ?>><?php echo $Language->Phrase("AnyWord") ?></label>
</div>
</div>
</div>
</form>
<?php } ?>
<?php $site_admin_list->ShowPageHeader(); ?>
<?php
$site_admin_list->ShowMessage();
?>
<br>
<table cellspacing="0" class="ewGrid"><tr><td class="ewGridContent">
<form name="fsite_adminlist" id="fsite_adminlist" class="ewForm" action="" method="post">
<input type="hidden" name="t" value="site_admin">
<div id="gmp_site_admin" class="ewGridMiddlePanel">
<?php if ($site_admin_list->TotalRecs > 0) { ?>
<table id="tbl_site_adminlist" class="ewTable ewTableSeparate">
<?php echo $site_admin->TableCustomInnerHtml ?>
<thead><!-- Table header -->
	<tr class="ewTableHeader">
<?php

// Render list options
$site_admin_list->RenderListOptions();

// Render list options (header, left)
$site_admin_list->ListOptions->Render("header", "left");
?>
<?php if ($site_admin->dbkey->Visible) { // dbkey ?>
	<?php if ($site_admin->SortUrl($site_admin->dbkey) == "") { ?>
		<td><span id="elh_site_admin_dbkey" class="site_admin_dbkey"><table class="ewTableHeaderBtn"><thead><tr><td><?php echo $site_admin->dbkey->FldCaption() ?></td></tr></thead></table></span></td>
	<?php } else { ?>
		<td><div onmousedown="ew_Sort(event,'<?php echo $site_admin->SortUrl($site_admin->dbkey) ?>',1);"><span id="elh_site_admin_dbkey" class="site_admin_dbkey">
			<table class="ewTableHeaderBtn"><thead><tr><td class="ewTableHeaderCaption"><?php echo $site_admin->dbkey->FldCaption() ?></td><td class="ewTableHeaderSort"><?php if ($site_admin->dbkey->getSort() == "ASC") { ?><img src="phpimages/sortup.gif" width="10" height="9" alt="" style="border: 0;"><?php } elseif ($site_admin->dbkey->getSort() == "DESC") { ?><img src="phpimages/sortdown.gif" width="10" height="9" alt="" style="border: 0;"><?php } ?></td></tr></thead></table>
		</span></div></td>		
	<?php } ?>
<?php } ?>		
<?php if ($site_admin->auth_status->Visible) { // auth_status ?>
	<?php if ($site_admin->SortUrl($site_admin->auth_status) == "") { ?>
		<td><span id="elh_site_admin_auth_status" class="site_admin_auth_status"><table class="ewTableHeaderBtn"><thead><tr><td><?php echo $site_admin->auth_status->FldCaption() ?></td></tr></thead></table></span></td>
	<?php } else { ?>
		<td><div onmousedown="ew_Sort(event,'<?php echo $site_admin->SortUrl($site_admin->auth_status) ?>',1);"><span id="elh_site_admin_auth_status" class="site_admin_auth_status">
			<table class="ewTableHeaderBtn"><thead><tr><td class="ewTableHeaderCaption"><?php echo $site_admin->auth_status->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></td><td class="ewTableHeaderSort"><?php if ($site_admin->auth_status->getSort() == "ASC") { ?><img src="phpimages/sortup.gif" width="10" height="9" alt="" style="border: 0;"><?php } elseif ($site_admin->auth_status->getSort() == "DESC") { ?><img src="phpimages/sortdown.gif" width="10" height="9" alt="" style="border: 0;"><?php } ?></td></tr></thead></table>
		</span></div></td>		
	<?php } ?>
<?php } ?>		
<?php if ($site_admin->_email->Visible) { // email ?>
	<?php if ($site_admin->SortUrl($site_admin->_email) == "") { ?>
		<td><span id="elh_site_admin__email" class="site_admin__email"><table class="ewTableHeaderBtn"><thead><tr><td><?php echo $site_admin->_email->FldCaption() ?></td></tr></thead></table></span></td>
	<?php } else { ?>
		<td><div onmousedown="ew_Sort(event,'<?php echo $site_admin->SortUrl($site_admin->_email) ?>',1);"><span id="elh_site_admin__email" class="site_admin__email">
			<table class="ewTableHeaderBtn"><thead><tr><td class="ewTableHeaderCaption"><?php echo $site_admin->_email->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></td><td class="ewTableHeaderSort"><?php if ($site_admin->_email->getSort() == "ASC") { ?><img src="phpimages/sortup.gif" width="10" height="9" alt="" style="border: 0;"><?php } elseif ($site_admin->_email->getSort() == "DESC") { ?><img src="phpimages/sortdown.gif" width="10" height="9" alt="" style="border: 0;"><?php } ?></td></tr></thead></table>
		</span></div></td>		
	<?php } ?>
<?php } ?>		
<?php if ($site_admin->user->Visible) { // user ?>
	<?php if ($site_admin->SortUrl($site_admin->user) == "") { ?>
		<td><span id="elh_site_admin_user" class="site_admin_user"><table class="ewTableHeaderBtn"><thead><tr><td><?php echo $site_admin->user->FldCaption() ?></td></tr></thead></table></span></td>
	<?php } else { ?>
		<td><div onmousedown="ew_Sort(event,'<?php echo $site_admin->SortUrl($site_admin->user) ?>',1);"><span id="elh_site_admin_user" class="site_admin_user">
			<table class="ewTableHeaderBtn"><thead><tr><td class="ewTableHeaderCaption"><?php echo $site_admin->user->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></td><td class="ewTableHeaderSort"><?php if ($site_admin->user->getSort() == "ASC") { ?><img src="phpimages/sortup.gif" width="10" height="9" alt="" style="border: 0;"><?php } elseif ($site_admin->user->getSort() == "DESC") { ?><img src="phpimages/sortdown.gif" width="10" height="9" alt="" style="border: 0;"><?php } ?></td></tr></thead></table>
		</span></div></td>		
	<?php } ?>
<?php } ?>		
<?php if ($site_admin->pwd->Visible) { // pwd ?>
	<?php if ($site_admin->SortUrl($site_admin->pwd) == "") { ?>
		<td><span id="elh_site_admin_pwd" class="site_admin_pwd"><table class="ewTableHeaderBtn"><thead><tr><td><?php echo $site_admin->pwd->FldCaption() ?></td></tr></thead></table></span></td>
	<?php } else { ?>
		<td><div onmousedown="ew_Sort(event,'<?php echo $site_admin->SortUrl($site_admin->pwd) ?>',1);"><span id="elh_site_admin_pwd" class="site_admin_pwd">
			<table class="ewTableHeaderBtn"><thead><tr><td class="ewTableHeaderCaption"><?php echo $site_admin->pwd->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></td><td class="ewTableHeaderSort"><?php if ($site_admin->pwd->getSort() == "ASC") { ?><img src="phpimages/sortup.gif" width="10" height="9" alt="" style="border: 0;"><?php } elseif ($site_admin->pwd->getSort() == "DESC") { ?><img src="phpimages/sortdown.gif" width="10" height="9" alt="" style="border: 0;"><?php } ?></td></tr></thead></table>
		</span></div></td>		
	<?php } ?>
<?php } ?>		
<?php if ($site_admin->first->Visible) { // first ?>
	<?php if ($site_admin->SortUrl($site_admin->first) == "") { ?>
		<td><span id="elh_site_admin_first" class="site_admin_first"><table class="ewTableHeaderBtn"><thead><tr><td><?php echo $site_admin->first->FldCaption() ?></td></tr></thead></table></span></td>
	<?php } else { ?>
		<td><div onmousedown="ew_Sort(event,'<?php echo $site_admin->SortUrl($site_admin->first) ?>',1);"><span id="elh_site_admin_first" class="site_admin_first">
			<table class="ewTableHeaderBtn"><thead><tr><td class="ewTableHeaderCaption"><?php echo $site_admin->first->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></td><td class="ewTableHeaderSort"><?php if ($site_admin->first->getSort() == "ASC") { ?><img src="phpimages/sortup.gif" width="10" height="9" alt="" style="border: 0;"><?php } elseif ($site_admin->first->getSort() == "DESC") { ?><img src="phpimages/sortdown.gif" width="10" height="9" alt="" style="border: 0;"><?php } ?></td></tr></thead></table>
		</span></div></td>		
	<?php } ?>
<?php } ?>		
<?php if ($site_admin->last->Visible) { // last ?>
	<?php if ($site_admin->SortUrl($site_admin->last) == "") { ?>
		<td><span id="elh_site_admin_last" class="site_admin_last"><table class="ewTableHeaderBtn"><thead><tr><td><?php echo $site_admin->last->FldCaption() ?></td></tr></thead></table></span></td>
	<?php } else { ?>
		<td><div onmousedown="ew_Sort(event,'<?php echo $site_admin->SortUrl($site_admin->last) ?>',1);"><span id="elh_site_admin_last" class="site_admin_last">
			<table class="ewTableHeaderBtn"><thead><tr><td class="ewTableHeaderCaption"><?php echo $site_admin->last->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></td><td class="ewTableHeaderSort"><?php if ($site_admin->last->getSort() == "ASC") { ?><img src="phpimages/sortup.gif" width="10" height="9" alt="" style="border: 0;"><?php } elseif ($site_admin->last->getSort() == "DESC") { ?><img src="phpimages/sortdown.gif" width="10" height="9" alt="" style="border: 0;"><?php } ?></td></tr></thead></table>
		</span></div></td>		
	<?php } ?>
<?php } ?>		
<?php if ($site_admin->status->Visible) { // status ?>
	<?php if ($site_admin->SortUrl($site_admin->status) == "") { ?>
		<td><span id="elh_site_admin_status" class="site_admin_status"><table class="ewTableHeaderBtn"><thead><tr><td><?php echo $site_admin->status->FldCaption() ?></td></tr></thead></table></span></td>
	<?php } else { ?>
		<td><div onmousedown="ew_Sort(event,'<?php echo $site_admin->SortUrl($site_admin->status) ?>',1);"><span id="elh_site_admin_status" class="site_admin_status">
			<table class="ewTableHeaderBtn"><thead><tr><td class="ewTableHeaderCaption"><?php echo $site_admin->status->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></td><td class="ewTableHeaderSort"><?php if ($site_admin->status->getSort() == "ASC") { ?><img src="phpimages/sortup.gif" width="10" height="9" alt="" style="border: 0;"><?php } elseif ($site_admin->status->getSort() == "DESC") { ?><img src="phpimages/sortdown.gif" width="10" height="9" alt="" style="border: 0;"><?php } ?></td></tr></thead></table>
		</span></div></td>		
	<?php } ?>
<?php } ?>		
<?php if ($site_admin->quote_prefix->Visible) { // quote_prefix ?>
	<?php if ($site_admin->SortUrl($site_admin->quote_prefix) == "") { ?>
		<td><span id="elh_site_admin_quote_prefix" class="site_admin_quote_prefix"><table class="ewTableHeaderBtn"><thead><tr><td><?php echo $site_admin->quote_prefix->FldCaption() ?></td></tr></thead></table></span></td>
	<?php } else { ?>
		<td><div onmousedown="ew_Sort(event,'<?php echo $site_admin->SortUrl($site_admin->quote_prefix) ?>',1);"><span id="elh_site_admin_quote_prefix" class="site_admin_quote_prefix">
			<table class="ewTableHeaderBtn"><thead><tr><td class="ewTableHeaderCaption"><?php echo $site_admin->quote_prefix->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></td><td class="ewTableHeaderSort"><?php if ($site_admin->quote_prefix->getSort() == "ASC") { ?><img src="phpimages/sortup.gif" width="10" height="9" alt="" style="border: 0;"><?php } elseif ($site_admin->quote_prefix->getSort() == "DESC") { ?><img src="phpimages/sortdown.gif" width="10" height="9" alt="" style="border: 0;"><?php } ?></td></tr></thead></table>
		</span></div></td>		
	<?php } ?>
<?php } ?>		
<?php

// Render list options (header, right)
$site_admin_list->ListOptions->Render("header", "right");
?>
	</tr>
</thead>
<tbody>
<?php
if ($site_admin->ExportAll && $site_admin->Export <> "") {
	$site_admin_list->StopRec = $site_admin_list->TotalRecs;
} else {

	// Set the last record to display
	if ($site_admin_list->TotalRecs > $site_admin_list->StartRec + $site_admin_list->DisplayRecs - 1)
		$site_admin_list->StopRec = $site_admin_list->StartRec + $site_admin_list->DisplayRecs - 1;
	else
		$site_admin_list->StopRec = $site_admin_list->TotalRecs;
}
$site_admin_list->RecCnt = $site_admin_list->StartRec - 1;
if ($site_admin_list->Recordset && !$site_admin_list->Recordset->EOF) {
	$site_admin_list->Recordset->MoveFirst();
	if (!$bSelectLimit && $site_admin_list->StartRec > 1)
		$site_admin_list->Recordset->Move($site_admin_list->StartRec - 1);
} elseif (!$site_admin->AllowAddDeleteRow && $site_admin_list->StopRec == 0) {
	$site_admin_list->StopRec = $site_admin->GridAddRowCount;
}

// Initialize aggregate
$site_admin->RowType = EW_ROWTYPE_AGGREGATEINIT;
$site_admin->ResetAttrs();
$site_admin_list->RenderRow();
while ($site_admin_list->RecCnt < $site_admin_list->StopRec) {
	$site_admin_list->RecCnt++;
	if (intval($site_admin_list->RecCnt) >= intval($site_admin_list->StartRec)) {
		$site_admin_list->RowCnt++;

		// Set up key count
		$site_admin_list->KeyCount = $site_admin_list->RowIndex;

		// Init row class and style
		$site_admin->ResetAttrs();
		$site_admin->CssClass = "";
		if ($site_admin->CurrentAction == "gridadd") {
		} else {
			$site_admin_list->LoadRowValues($site_admin_list->Recordset); // Load row values
		}
		$site_admin->RowType = EW_ROWTYPE_VIEW; // Render view

		// Set up row id / data-rowindex
		$site_admin->RowAttrs = array_merge($site_admin->RowAttrs, array('data-rowindex'=>$site_admin_list->RowCnt, 'id'=>'r' . $site_admin_list->RowCnt . '_site_admin', 'data-rowtype'=>$site_admin->RowType));

		// Render row
		$site_admin_list->RenderRow();

		// Render list options
		$site_admin_list->RenderListOptions();
?>
	<tr<?php echo $site_admin->RowAttributes() ?>>
<?php

// Render list options (body, left)
$site_admin_list->ListOptions->Render("body", "left", $site_admin_list->RowCnt);
?>
	<?php if ($site_admin->dbkey->Visible) { // dbkey ?>
		<td<?php echo $site_admin->dbkey->CellAttributes() ?>><span id="el<?php echo $site_admin_list->RowCnt ?>_site_admin_dbkey" class="site_admin_dbkey">
<span<?php echo $site_admin->dbkey->ViewAttributes() ?>>
<?php echo $site_admin->dbkey->ListViewValue() ?></span>
</span><a id="<?php echo $site_admin_list->PageObjName . "_row_" . $site_admin_list->RowCnt ?>"></a></td>
	<?php } ?>
	<?php if ($site_admin->auth_status->Visible) { // auth_status ?>
		<td<?php echo $site_admin->auth_status->CellAttributes() ?>><span id="el<?php echo $site_admin_list->RowCnt ?>_site_admin_auth_status" class="site_admin_auth_status">
<span<?php echo $site_admin->auth_status->ViewAttributes() ?>>
<?php echo $site_admin->auth_status->ListViewValue() ?></span>
</span><a id="<?php echo $site_admin_list->PageObjName . "_row_" . $site_admin_list->RowCnt ?>"></a></td>
	<?php } ?>
	<?php if ($site_admin->_email->Visible) { // email ?>
		<td<?php echo $site_admin->_email->CellAttributes() ?>><span id="el<?php echo $site_admin_list->RowCnt ?>_site_admin__email" class="site_admin__email">
<span<?php echo $site_admin->_email->ViewAttributes() ?>>
<?php echo $site_admin->_email->ListViewValue() ?></span>
</span><a id="<?php echo $site_admin_list->PageObjName . "_row_" . $site_admin_list->RowCnt ?>"></a></td>
	<?php } ?>
	<?php if ($site_admin->user->Visible) { // user ?>
		<td<?php echo $site_admin->user->CellAttributes() ?>><span id="el<?php echo $site_admin_list->RowCnt ?>_site_admin_user" class="site_admin_user">
<span<?php echo $site_admin->user->ViewAttributes() ?>>
<?php echo $site_admin->user->ListViewValue() ?></span>
</span><a id="<?php echo $site_admin_list->PageObjName . "_row_" . $site_admin_list->RowCnt ?>"></a></td>
	<?php } ?>
	<?php if ($site_admin->pwd->Visible) { // pwd ?>
		<td<?php echo $site_admin->pwd->CellAttributes() ?>><span id="el<?php echo $site_admin_list->RowCnt ?>_site_admin_pwd" class="site_admin_pwd">
<span<?php echo $site_admin->pwd->ViewAttributes() ?>>
<?php echo $site_admin->pwd->ListViewValue() ?></span>
</span><a id="<?php echo $site_admin_list->PageObjName . "_row_" . $site_admin_list->RowCnt ?>"></a></td>
	<?php } ?>
	<?php if ($site_admin->first->Visible) { // first ?>
		<td<?php echo $site_admin->first->CellAttributes() ?>><span id="el<?php echo $site_admin_list->RowCnt ?>_site_admin_first" class="site_admin_first">
<span<?php echo $site_admin->first->ViewAttributes() ?>>
<?php echo $site_admin->first->ListViewValue() ?></span>
</span><a id="<?php echo $site_admin_list->PageObjName . "_row_" . $site_admin_list->RowCnt ?>"></a></td>
	<?php } ?>
	<?php if ($site_admin->last->Visible) { // last ?>
		<td<?php echo $site_admin->last->CellAttributes() ?>><span id="el<?php echo $site_admin_list->RowCnt ?>_site_admin_last" class="site_admin_last">
<span<?php echo $site_admin->last->ViewAttributes() ?>>
<?php echo $site_admin->last->ListViewValue() ?></span>
</span><a id="<?php echo $site_admin_list->PageObjName . "_row_" . $site_admin_list->RowCnt ?>"></a></td>
	<?php } ?>
	<?php if ($site_admin->status->Visible) { // status ?>
		<td<?php echo $site_admin->status->CellAttributes() ?>><span id="el<?php echo $site_admin_list->RowCnt ?>_site_admin_status" class="site_admin_status">
<span<?php echo $site_admin->status->ViewAttributes() ?>>
<?php echo $site_admin->status->ListViewValue() ?></span>
</span><a id="<?php echo $site_admin_list->PageObjName . "_row_" . $site_admin_list->RowCnt ?>"></a></td>
	<?php } ?>
	<?php if ($site_admin->quote_prefix->Visible) { // quote_prefix ?>
		<td<?php echo $site_admin->quote_prefix->CellAttributes() ?>><span id="el<?php echo $site_admin_list->RowCnt ?>_site_admin_quote_prefix" class="site_admin_quote_prefix">
<span<?php echo $site_admin->quote_prefix->ViewAttributes() ?>>
<?php echo $site_admin->quote_prefix->ListViewValue() ?></span>
</span><a id="<?php echo $site_admin_list->PageObjName . "_row_" . $site_admin_list->RowCnt ?>"></a></td>
	<?php } ?>
<?php

// Render list options (body, right)
$site_admin_list->ListOptions->Render("body", "right", $site_admin_list->RowCnt);
?>
	</tr>
<?php
	}
	if ($site_admin->CurrentAction <> "gridadd")
		$site_admin_list->Recordset->MoveNext();
}
?>
</tbody>
</table>
<?php } ?>
<?php if ($site_admin->CurrentAction == "") { ?>
<input type="hidden" name="a_list" id="a_list" value="">
<?php } ?>
</div>
</form>
<?php

// Close recordset
if ($site_admin_list->Recordset)
	$site_admin_list->Recordset->Close();
?>
<div class="ewGridLowerPanel">
<?php if ($site_admin->CurrentAction <> "gridadd" && $site_admin->CurrentAction <> "gridedit") { ?>
<form name="ewpagerform" id="ewpagerform" class="ewForm" action="<?php echo ew_CurrentPage() ?>">
<table class="ewPager"><tr><td>
<?php if (!isset($site_admin_list->Pager)) $site_admin_list->Pager = new cPrevNextPager($site_admin_list->StartRec, $site_admin_list->DisplayRecs, $site_admin_list->TotalRecs) ?>
<?php if ($site_admin_list->Pager->RecordCount > 0) { ?>
	<table cellspacing="0" class="ewStdTable"><tbody><tr><td><span class="phpmaker"><?php echo $Language->Phrase("Page") ?>&nbsp;</span></td>
<!--first page button-->
	<?php if ($site_admin_list->Pager->FirstButton->Enabled) { ?>
	<td><a href="<?php echo $site_admin_list->PageUrl() ?>start=<?php echo $site_admin_list->Pager->FirstButton->Start ?>"><img src="phpimages/first.gif" alt="<?php echo $Language->Phrase("PagerFirst") ?>" width="16" height="16" style="border: 0;"></a></td>
	<?php } else { ?>
	<td><img src="phpimages/firstdisab.gif" alt="<?php echo $Language->Phrase("PagerFirst") ?>" width="16" height="16" style="border: 0;"></td>
	<?php } ?>
<!--previous page button-->
	<?php if ($site_admin_list->Pager->PrevButton->Enabled) { ?>
	<td><a href="<?php echo $site_admin_list->PageUrl() ?>start=<?php echo $site_admin_list->Pager->PrevButton->Start ?>"><img src="phpimages/prev.gif" alt="<?php echo $Language->Phrase("PagerPrevious") ?>" width="16" height="16" style="border: 0;"></a></td>
	<?php } else { ?>
	<td><img src="phpimages/prevdisab.gif" alt="<?php echo $Language->Phrase("PagerPrevious") ?>" width="16" height="16" style="border: 0;"></td>
	<?php } ?>
<!--current page number-->
	<td><input type="text" name="<?php echo EW_TABLE_PAGE_NO ?>" id="<?php echo EW_TABLE_PAGE_NO ?>" value="<?php echo $site_admin_list->Pager->CurrentPage ?>" size="4"></td>
<!--next page button-->
	<?php if ($site_admin_list->Pager->NextButton->Enabled) { ?>
	<td><a href="<?php echo $site_admin_list->PageUrl() ?>start=<?php echo $site_admin_list->Pager->NextButton->Start ?>"><img src="phpimages/next.gif" alt="<?php echo $Language->Phrase("PagerNext") ?>" width="16" height="16" style="border: 0;"></a></td>	
	<?php } else { ?>
	<td><img src="phpimages/nextdisab.gif" alt="<?php echo $Language->Phrase("PagerNext") ?>" width="16" height="16" style="border: 0;"></td>
	<?php } ?>
<!--last page button-->
	<?php if ($site_admin_list->Pager->LastButton->Enabled) { ?>
	<td><a href="<?php echo $site_admin_list->PageUrl() ?>start=<?php echo $site_admin_list->Pager->LastButton->Start ?>"><img src="phpimages/last.gif" alt="<?php echo $Language->Phrase("PagerLast") ?>" width="16" height="16" style="border: 0;"></a></td>	
	<?php } else { ?>
	<td><img src="phpimages/lastdisab.gif" alt="<?php echo $Language->Phrase("PagerLast") ?>" width="16" height="16" style="border: 0;"></td>
	<?php } ?>
	<td><span class="phpmaker">&nbsp;<?php echo $Language->Phrase("of") ?>&nbsp;<?php echo $site_admin_list->Pager->PageCount ?></span></td>
	</tr></tbody></table>
	</td>	
	<td>&nbsp;&nbsp;&nbsp;&nbsp;</td>
	<td>
	<span class="phpmaker"><?php echo $Language->Phrase("Record") ?>&nbsp;<?php echo $site_admin_list->Pager->FromIndex ?>&nbsp;<?php echo $Language->Phrase("To") ?>&nbsp;<?php echo $site_admin_list->Pager->ToIndex ?>&nbsp;<?php echo $Language->Phrase("Of") ?>&nbsp;<?php echo $site_admin_list->Pager->RecordCount ?></span>
<?php } else { ?>
	<?php if ($site_admin_list->SearchWhere == "0=101") { ?>
	<span class="phpmaker"><?php echo $Language->Phrase("EnterSearchCriteria") ?></span>
	<?php } else { ?>
	<span class="phpmaker"><?php echo $Language->Phrase("NoRecord") ?></span>
	<?php } ?>
<?php } ?>
	</td>
</tr></table>
</form>
<?php } ?>
<span class="phpmaker">
<?php if ($site_admin_list->AddUrl <> "") { ?>
<a class="ewGridLink" href="<?php echo $site_admin_list->AddUrl ?>"><?php echo $Language->Phrase("AddLink") ?></a>&nbsp;&nbsp;
<?php } ?>
</span>
</div>
</td></tr></table>
<script type="text/javascript">
fsite_adminlistsrch.Init();
fsite_adminlist.Init();
</script>
<?php
$site_admin_list->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$site_admin_list->Page_Terminate();
?>
