<?php
if (session_id() == "") session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg12.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql12.php") ?>
<?php include_once "phpfn12.php" ?>
<?php include_once "task_counselorinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn12.php" ?>
<?php

//
// Page class
//

$task_counselor_delete = NULL; // Initialize page object first

class ctask_counselor_delete extends ctask_counselor {

	// Page ID
	var $PageID = 'delete';

	// Project ID
	var $ProjectID = "{B45169E1-BF97-4482-BB55-A18B04F32D02}";

	// Table name
	var $TableName = 'task_counselor';

	// Page object name
	var $PageObjName = 'task_counselor_delete';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (task_counselor)
		if (!isset($GLOBALS["task_counselor"]) || get_class($GLOBALS["task_counselor"]) == "ctask_counselor") {
			$GLOBALS["task_counselor"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["task_counselor"];
		}

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'delete', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'task_counselor', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanDelete()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage($Language->Phrase("NoPermission")); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("task_counselorlist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $task_counselor;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($task_counselor);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}
	var $DbMasterFilter = "";
	var $DbDetailFilter = "";
	var $StartRec;
	var $TotalRecs = 0;
	var $RecCnt;
	var $RecKeys = array();
	var $Recordset;
	var $StartRowCnt = 1;
	var $RowCnt = 0;

	//
	// Page main
	//
	function Page_Main() {
		global $Language;

		// Set up Breadcrumb
		$this->SetupBreadcrumb();

		// Load key parameters
		$this->RecKeys = $this->GetRecordKeys(); // Load record keys
		$sFilter = $this->GetKeyFilter();
		if ($sFilter == "")
			$this->Page_Terminate("task_counselorlist.php"); // Prevent SQL injection, return to list

		// Set up filter (SQL WHHERE clause) and get return SQL
		// SQL constructor in task_counselor class, task_counselorinfo.php

		$this->CurrentFilter = $sFilter;

		// Get action
		if (@$_POST["a_delete"] <> "") {
			$this->CurrentAction = $_POST["a_delete"];
		} else {
			$this->CurrentAction = "I"; // Display record
		}
		switch ($this->CurrentAction) {
			case "D": // Delete
				$this->SendEmail = TRUE; // Send email on delete success
				if ($this->DeleteRows()) { // Delete rows
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage($Language->Phrase("DeleteSuccess")); // Set up success message
					$this->Page_Terminate($this->getReturnUrl()); // Return to caller
				}
		}
	}

	// Load recordset
	function LoadRecordset($offset = -1, $rowcnt = -1) {

		// Load List page SQL
		$sSql = $this->SelectSQL();
		$conn = &$this->Connection();

		// Load recordset
		$dbtype = ew_GetConnectionType($this->DBID);
		if ($this->UseSelectLimit) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			if ($dbtype == "MSSQL") {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset, array("_hasOrderBy" => trim($this->getOrderBy()) || trim($this->getSessionOrderBy())));
			} else {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset);
			}
			$conn->raiseErrorFn = '';
		} else {
			$rs = ew_LoadRecordset($sSql, $conn);
		}

		// Call Recordset Selected event
		$this->Recordset_Selected($rs);
		return $rs;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->dbkey_counciler_to->setDbValue($rs->fields('dbkey_counciler_to'));
		$this->dbkey_counciler_from->setDbValue($rs->fields('dbkey_counciler_from'));
		$this->task_description->setDbValue($rs->fields('task_description'));
		$this->task_response->setDbValue($rs->fields('task_response'));
		$this->date_approved->setDbValue($rs->fields('date_approved'));
		$this->date_requested->setDbValue($rs->fields('date_requested'));
		$this->approved_by->setDbValue($rs->fields('approved_by'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey->DbValue = $row['dbkey'];
		$this->dbkey_counciler_to->DbValue = $row['dbkey_counciler_to'];
		$this->dbkey_counciler_from->DbValue = $row['dbkey_counciler_from'];
		$this->task_description->DbValue = $row['task_description'];
		$this->task_response->DbValue = $row['task_response'];
		$this->date_approved->DbValue = $row['date_approved'];
		$this->date_requested->DbValue = $row['date_requested'];
		$this->approved_by->DbValue = $row['approved_by'];
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Call Row_Rendering event

		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey

		$this->dbkey->CellCssStyle = "white-space: nowrap;";

		// dbkey_counciler_to
		// dbkey_counciler_from
		// task_description
		// task_response
		// date_approved
		// date_requested
		// approved_by

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// dbkey_counciler_to
		if (strval($this->dbkey_counciler_to->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_counciler_to->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_counciler_to, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_counciler_to->ViewValue = $this->dbkey_counciler_to->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_counciler_to->ViewValue = $this->dbkey_counciler_to->CurrentValue;
			}
		} else {
			$this->dbkey_counciler_to->ViewValue = NULL;
		}
		$this->dbkey_counciler_to->ViewCustomAttributes = "";

		// dbkey_counciler_from
		if (strval($this->dbkey_counciler_from->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_counciler_from->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_counciler_from, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_counciler_from->ViewValue = $this->dbkey_counciler_from->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_counciler_from->ViewValue = $this->dbkey_counciler_from->CurrentValue;
			}
		} else {
			$this->dbkey_counciler_from->ViewValue = NULL;
		}
		$this->dbkey_counciler_from->ViewCustomAttributes = "";

		// task_description
		$this->task_description->ViewValue = $this->task_description->CurrentValue;
		$this->task_description->ViewCustomAttributes = "";

		// task_response
		$this->task_response->ViewValue = $this->task_response->CurrentValue;
		$this->task_response->ViewCustomAttributes = "";

		// date_approved
		$this->date_approved->ViewValue = $this->date_approved->CurrentValue;
		$this->date_approved->ViewCustomAttributes = "";

		// date_requested
		$this->date_requested->ViewValue = $this->date_requested->CurrentValue;
		$this->date_requested->ViewCustomAttributes = "";

		// approved_by
		if (strval($this->approved_by->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->approved_by->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->approved_by, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->approved_by->ViewValue = $this->approved_by->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->approved_by->ViewValue = $this->approved_by->CurrentValue;
			}
		} else {
			$this->approved_by->ViewValue = NULL;
		}
		$this->approved_by->ViewCustomAttributes = "";

			// dbkey_counciler_to
			$this->dbkey_counciler_to->LinkCustomAttributes = "";
			$this->dbkey_counciler_to->HrefValue = "";
			$this->dbkey_counciler_to->TooltipValue = "";

			// dbkey_counciler_from
			$this->dbkey_counciler_from->LinkCustomAttributes = "";
			$this->dbkey_counciler_from->HrefValue = "";
			$this->dbkey_counciler_from->TooltipValue = "";

			// task_description
			$this->task_description->LinkCustomAttributes = "";
			$this->task_description->HrefValue = "";
			$this->task_description->TooltipValue = "";

			// task_response
			$this->task_response->LinkCustomAttributes = "";
			$this->task_response->HrefValue = "";
			$this->task_response->TooltipValue = "";

			// date_approved
			$this->date_approved->LinkCustomAttributes = "";
			$this->date_approved->HrefValue = "";
			$this->date_approved->TooltipValue = "";

			// date_requested
			$this->date_requested->LinkCustomAttributes = "";
			$this->date_requested->HrefValue = "";
			$this->date_requested->TooltipValue = "";

			// approved_by
			$this->approved_by->LinkCustomAttributes = "";
			$this->approved_by->HrefValue = "";
			$this->approved_by->TooltipValue = "";
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	//
	// Delete records based on current filter
	//
	function DeleteRows() {
		global $Language, $Security;
		if (!$Security->CanDelete()) {
			$this->setFailureMessage($Language->Phrase("NoDeletePermission")); // No delete permission
			return FALSE;
		}
		$DeleteRows = TRUE;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
		$rs = $conn->Execute($sSql);
		$conn->raiseErrorFn = '';
		if ($rs === FALSE) {
			return FALSE;
		} elseif ($rs->EOF) {
			$this->setFailureMessage($Language->Phrase("NoRecord")); // No record found
			$rs->Close();
			return FALSE;

		//} else {
		//	$this->LoadRowValues($rs); // Load row values

		}
		$rows = ($rs) ? $rs->GetRows() : array();
		$conn->BeginTrans();

		// Clone old rows
		$rsold = $rows;
		if ($rs)
			$rs->Close();

		// Call row deleting event
		if ($DeleteRows) {
			foreach ($rsold as $row) {
				$DeleteRows = $this->Row_Deleting($row);
				if (!$DeleteRows) break;
			}
		}
		if ($DeleteRows) {
			$sKey = "";
			foreach ($rsold as $row) {
				$sThisKey = "";
				if ($sThisKey <> "") $sThisKey .= $GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"];
				$sThisKey .= $row['dbkey'];
				$this->LoadDbValues($row);
				$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
				$DeleteRows = $this->Delete($row); // Delete
				$conn->raiseErrorFn = '';
				if ($DeleteRows === FALSE)
					break;
				if ($sKey <> "") $sKey .= ", ";
				$sKey .= $sThisKey;
			}
		} else {

			// Set up error message
			if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

				// Use the message, do nothing
			} elseif ($this->CancelMessage <> "") {
				$this->setFailureMessage($this->CancelMessage);
				$this->CancelMessage = "";
			} else {
				$this->setFailureMessage($Language->Phrase("DeleteCancelled"));
			}
		}
		if ($DeleteRows) {
			$conn->CommitTrans(); // Commit the changes
		} else {
			$conn->RollbackTrans(); // Rollback changes
		}

		// Call Row Deleted event
		if ($DeleteRows) {
			foreach ($rsold as $row) {
				$this->Row_Deleted($row);
			}
		}
		return $DeleteRows;
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, "task_counselorlist.php", "", $this->TableVar, TRUE);
		$PageId = "delete";
		$Breadcrumb->Add("delete", $PageId, $url);
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($task_counselor_delete)) $task_counselor_delete = new ctask_counselor_delete();

// Page init
$task_counselor_delete->Page_Init();

// Page main
$task_counselor_delete->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$task_counselor_delete->Page_Render();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "delete";
var CurrentForm = ftask_counselordelete = new ew_Form("ftask_counselordelete", "delete");

// Form_CustomValidate event
ftask_counselordelete.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
ftask_counselordelete.ValidateRequired = true;
<?php } else { ?>
ftask_counselordelete.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
ftask_counselordelete.Lists["x_dbkey_counciler_to"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftask_counselordelete.Lists["x_dbkey_counciler_from"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftask_counselordelete.Lists["x_approved_by"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};

// Form object for search
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php

// Load records for display
if ($task_counselor_delete->Recordset = $task_counselor_delete->LoadRecordset())
	$task_counselor_deleteTotalRecs = $task_counselor_delete->Recordset->RecordCount(); // Get record count
if ($task_counselor_deleteTotalRecs <= 0) { // No record found, exit
	if ($task_counselor_delete->Recordset)
		$task_counselor_delete->Recordset->Close();
	$task_counselor_delete->Page_Terminate("task_counselorlist.php"); // Return to list
}
?>
<div class="ewToolbar">
<?php $Breadcrumb->Render(); ?>
<?php echo $Language->SelectionForm(); ?>
<div class="clearfix"></div>
</div>
<?php $task_counselor_delete->ShowPageHeader(); ?>
<?php
$task_counselor_delete->ShowMessage();
?>
<form name="ftask_counselordelete" id="ftask_counselordelete" class="form-inline ewForm ewDeleteForm" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($task_counselor_delete->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $task_counselor_delete->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="task_counselor">
<input type="hidden" name="a_delete" id="a_delete" value="D">
<?php foreach ($task_counselor_delete->RecKeys as $key) { ?>
<?php $keyvalue = is_array($key) ? implode($EW_COMPOSITE_KEY_SEPARATOR, $key) : $key; ?>
<input type="hidden" name="key_m[]" value="<?php echo ew_HtmlEncode($keyvalue) ?>">
<?php } ?>
<div class="ewGrid">
<div class="<?php if (ew_IsResponsiveLayout()) { echo "table-responsive "; } ?>ewGridMiddlePanel">
<table class="table ewTable">
<?php echo $task_counselor->TableCustomInnerHtml ?>
	<thead>
	<tr class="ewTableHeader">
<?php if ($task_counselor->dbkey_counciler_to->Visible) { // dbkey_counciler_to ?>
		<th><span id="elh_task_counselor_dbkey_counciler_to" class="task_counselor_dbkey_counciler_to"><?php echo $task_counselor->dbkey_counciler_to->FldCaption() ?></span></th>
<?php } ?>
<?php if ($task_counselor->dbkey_counciler_from->Visible) { // dbkey_counciler_from ?>
		<th><span id="elh_task_counselor_dbkey_counciler_from" class="task_counselor_dbkey_counciler_from"><?php echo $task_counselor->dbkey_counciler_from->FldCaption() ?></span></th>
<?php } ?>
<?php if ($task_counselor->task_description->Visible) { // task_description ?>
		<th><span id="elh_task_counselor_task_description" class="task_counselor_task_description"><?php echo $task_counselor->task_description->FldCaption() ?></span></th>
<?php } ?>
<?php if ($task_counselor->task_response->Visible) { // task_response ?>
		<th><span id="elh_task_counselor_task_response" class="task_counselor_task_response"><?php echo $task_counselor->task_response->FldCaption() ?></span></th>
<?php } ?>
<?php if ($task_counselor->date_approved->Visible) { // date_approved ?>
		<th><span id="elh_task_counselor_date_approved" class="task_counselor_date_approved"><?php echo $task_counselor->date_approved->FldCaption() ?></span></th>
<?php } ?>
<?php if ($task_counselor->date_requested->Visible) { // date_requested ?>
		<th><span id="elh_task_counselor_date_requested" class="task_counselor_date_requested"><?php echo $task_counselor->date_requested->FldCaption() ?></span></th>
<?php } ?>
<?php if ($task_counselor->approved_by->Visible) { // approved_by ?>
		<th><span id="elh_task_counselor_approved_by" class="task_counselor_approved_by"><?php echo $task_counselor->approved_by->FldCaption() ?></span></th>
<?php } ?>
	</tr>
	</thead>
	<tbody>
<?php
$task_counselor_delete->RecCnt = 0;
$i = 0;
while (!$task_counselor_delete->Recordset->EOF) {
	$task_counselor_delete->RecCnt++;
	$task_counselor_delete->RowCnt++;

	// Set row properties
	$task_counselor->ResetAttrs();
	$task_counselor->RowType = EW_ROWTYPE_VIEW; // View

	// Get the field contents
	$task_counselor_delete->LoadRowValues($task_counselor_delete->Recordset);

	// Render row
	$task_counselor_delete->RenderRow();
?>
	<tr<?php echo $task_counselor->RowAttributes() ?>>
<?php if ($task_counselor->dbkey_counciler_to->Visible) { // dbkey_counciler_to ?>
		<td<?php echo $task_counselor->dbkey_counciler_to->CellAttributes() ?>>
<span id="el<?php echo $task_counselor_delete->RowCnt ?>_task_counselor_dbkey_counciler_to" class="task_counselor_dbkey_counciler_to">
<span<?php echo $task_counselor->dbkey_counciler_to->ViewAttributes() ?>>
<?php echo $task_counselor->dbkey_counciler_to->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($task_counselor->dbkey_counciler_from->Visible) { // dbkey_counciler_from ?>
		<td<?php echo $task_counselor->dbkey_counciler_from->CellAttributes() ?>>
<span id="el<?php echo $task_counselor_delete->RowCnt ?>_task_counselor_dbkey_counciler_from" class="task_counselor_dbkey_counciler_from">
<span<?php echo $task_counselor->dbkey_counciler_from->ViewAttributes() ?>>
<?php echo $task_counselor->dbkey_counciler_from->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($task_counselor->task_description->Visible) { // task_description ?>
		<td<?php echo $task_counselor->task_description->CellAttributes() ?>>
<span id="el<?php echo $task_counselor_delete->RowCnt ?>_task_counselor_task_description" class="task_counselor_task_description">
<span<?php echo $task_counselor->task_description->ViewAttributes() ?>>
<?php echo $task_counselor->task_description->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($task_counselor->task_response->Visible) { // task_response ?>
		<td<?php echo $task_counselor->task_response->CellAttributes() ?>>
<span id="el<?php echo $task_counselor_delete->RowCnt ?>_task_counselor_task_response" class="task_counselor_task_response">
<span<?php echo $task_counselor->task_response->ViewAttributes() ?>>
<?php echo $task_counselor->task_response->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($task_counselor->date_approved->Visible) { // date_approved ?>
		<td<?php echo $task_counselor->date_approved->CellAttributes() ?>>
<span id="el<?php echo $task_counselor_delete->RowCnt ?>_task_counselor_date_approved" class="task_counselor_date_approved">
<span<?php echo $task_counselor->date_approved->ViewAttributes() ?>>
<?php echo $task_counselor->date_approved->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($task_counselor->date_requested->Visible) { // date_requested ?>
		<td<?php echo $task_counselor->date_requested->CellAttributes() ?>>
<span id="el<?php echo $task_counselor_delete->RowCnt ?>_task_counselor_date_requested" class="task_counselor_date_requested">
<span<?php echo $task_counselor->date_requested->ViewAttributes() ?>>
<?php echo $task_counselor->date_requested->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($task_counselor->approved_by->Visible) { // approved_by ?>
		<td<?php echo $task_counselor->approved_by->CellAttributes() ?>>
<span id="el<?php echo $task_counselor_delete->RowCnt ?>_task_counselor_approved_by" class="task_counselor_approved_by">
<span<?php echo $task_counselor->approved_by->ViewAttributes() ?>>
<?php echo $task_counselor->approved_by->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
	</tr>
<?php
	$task_counselor_delete->Recordset->MoveNext();
}
$task_counselor_delete->Recordset->Close();
?>
</tbody>
</table>
</div>
</div>
<div>
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit"><?php echo $Language->Phrase("DeleteBtn") ?></button>
<button class="btn btn-default ewButton" name="btnCancel" id="btnCancel" type="button" data-href="<?php echo $task_counselor_delete->getReturnUrl() ?>"><?php echo $Language->Phrase("CancelBtn") ?></button>
</div>
</form>
<script type="text/javascript">
ftask_counselordelete.Init();
</script>
<?php
$task_counselor_delete->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$task_counselor_delete->Page_Terminate();
?>
