<?php

// Global variable for table object
$test = NULL;

//
// Table class for test
//
class ctest extends cTable {
	var $dbkey;
	var $allocated;
	var $description;
	var $First;
	var $Last;
	var $Total_Hours;
	var $Year;
	var $Week_23;
	var $From_Date;
	var $Through_Date;
	var $Monday;

	//
	// Table class constructor
	//
	function __construct() {
		global $Language;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();
		$this->TableVar = 'test';
		$this->TableName = 'test';
		$this->TableType = 'CUSTOMVIEW';

		// Update Table
		$this->UpdateTable = "client_activity, counselor, tables_data, tables_data b";
		$this->DBID = 'DB';
		$this->ExportAll = TRUE;
		$this->ExportPageBreakCount = 0; // Page break per every n record (PDF only)
		$this->ExportPageOrientation = "portrait"; // Page orientation (PDF only)
		$this->ExportPageSize = "a4"; // Page size (PDF only)
		$this->ExportExcelPageOrientation = ""; // Page orientation (PHPExcel only)
		$this->ExportExcelPageSize = ""; // Page size (PHPExcel only)
		$this->DetailAdd = FALSE; // Allow detail add
		$this->DetailEdit = FALSE; // Allow detail edit
		$this->DetailView = FALSE; // Allow detail view
		$this->ShowMultipleDetails = FALSE; // Show multiple details
		$this->GridAddRowCount = 5;
		$this->AllowAddDeleteRow = ew_AllowAddDeleteRow(); // Allow add/delete row
		$this->UserIDAllowSecurity = 0; // User ID Allow
		$this->BasicSearch = new cBasicSearch($this->TableVar);

		// dbkey
		$this->dbkey = new cField('test', 'test', 'x_dbkey', 'dbkey', 'tables_data.dbkey', 'tables_data.dbkey', 200, -1, FALSE, 'tables_data.dbkey', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->fields['dbkey'] = &$this->dbkey;

		// allocated
		$this->allocated = new cField('test', 'test', 'x_allocated', 'allocated', '(SELECT sum(IfNull(b.time, 0)) FROM client_activity b where client_activity.dbkey_client = b.dbkey_client AND Year(client_activity.date) = Year(b.date) AND Month(client_activity.date) = Month(b.date))', '(SELECT sum(IfNull(b.time, 0)) FROM client_activity b where client_activity.dbkey_client = b.dbkey_client AND Year(client_activity.date) = Year(b.date) AND Month(client_activity.date) = Month(b.date))', 131, -1, FALSE, '(SELECT sum(IfNull(b.time, 0)) FROM client_activity b where client_activity.dbkey_client = b.dbkey_client AND Year(client_activity.date) = Year(b.date) AND Month(client_activity.date) = Month(b.date))', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->allocated->FldIsCustom = TRUE; // Custom field
		$this->allocated->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['allocated'] = &$this->allocated;

		// description
		$this->description = new cField('test', 'test', 'x_description', 'description', 'b.description', 'b.description', 200, -1, FALSE, 'b.description', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->fields['description'] = &$this->description;

		// First
		$this->First = new cField('test', 'test', 'x_First', 'First', '`First`', '`First`', 200, -1, FALSE, '`First`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->fields['First'] = &$this->First;

		// Last
		$this->Last = new cField('test', 'test', 'x_Last', 'Last', '`Last`', '`Last`', 200, -1, FALSE, '`Last`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->fields['Last'] = &$this->Last;

		// Total Hours
		$this->Total_Hours = new cField('test', 'test', 'x_Total_Hours', 'Total Hours', '`Total Hours`', '`Total Hours`', 131, -1, FALSE, '`Total Hours`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Total_Hours->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Total Hours'] = &$this->Total_Hours;

		// Year
		$this->Year = new cField('test', 'test', 'x_Year', 'Year', '`Year`', '`Year`', 20, -1, FALSE, '`Year`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->Year->OptionCount = 3;
		$this->Year->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['Year'] = &$this->Year;

		// Week #
		$this->Week_23 = new cField('test', 'test', 'x_Week_23', 'Week #', '`Week #`', '`Week #`', 20, -1, FALSE, '`Week #`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Week_23->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['Week #'] = &$this->Week_23;

		// From Date
		$this->From_Date = new cField('test', 'test', 'x_From_Date', 'From Date', '`From Date`', 'DATE_FORMAT(`From Date`, \'%Y/%m/%d\')', 133, 5, FALSE, '`From Date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->From_Date->FldDefaultErrMsg = str_replace("%s", "/", $Language->Phrase("IncorrectDateYMD"));
		$this->fields['From Date'] = &$this->From_Date;

		// Through Date
		$this->Through_Date = new cField('test', 'test', 'x_Through_Date', 'Through Date', '`Through Date`', 'DATE_FORMAT(`Through Date`, \'%Y/%m/%d\')', 135, 5, FALSE, '`Through Date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Through_Date->FldDefaultErrMsg = str_replace("%s", "/", $Language->Phrase("IncorrectDateYMD"));
		$this->fields['Through Date'] = &$this->Through_Date;

		// Monday
		$this->Monday = new cField('test', 'test', 'x_Monday', 'Monday', '\'\'', '\'\'', 131, -1, FALSE, '\'\'', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Monday->FldIsCustom = TRUE; // Custom field
		$this->Monday->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['Monday'] = &$this->Monday;
	}

	// Single column sort
	function UpdateSort(&$ofld) {
		if ($this->CurrentOrder == $ofld->FldName) {
			$sSortField = $ofld->FldExpression;
			$sLastSort = $ofld->getSort();
			if ($this->CurrentOrderType == "ASC" || $this->CurrentOrderType == "DESC") {
				$sThisSort = $this->CurrentOrderType;
			} else {
				$sThisSort = ($sLastSort == "ASC") ? "DESC" : "ASC";
			}
			$ofld->setSort($sThisSort);
			$this->setSessionOrderBy($sSortField . " " . $sThisSort); // Save to Session
		} else {
			$ofld->setSort("");
		}
	}

	// Table level SQL
	var $_SqlFrom = "";

	function getSqlFrom() { // From
		return ($this->_SqlFrom <> "") ? $this->_SqlFrom : "client_activity, counselor, tables_data, tables_data b";
	}

	function SqlFrom() { // For backward compatibility
    	return $this->getSqlFrom();
	}

	function setSqlFrom($v) {
    	$this->_SqlFrom = $v;
	}
	var $_SqlSelect = "";

	function getSqlSelect() { // Select
		return ($this->_SqlSelect <> "") ? $this->_SqlSelect : "SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE DayName(friday.date) = 'Monday' AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT sum(IfNull(b.time, 0)) FROM client_activity b where client_activity.dbkey_client = b.dbkey_client AND Year(client_activity.date) = Year(b.date) AND Month(client_activity.date) = Month(b.date)) AS `allocated`, '' AS `Monday` FROM " . $this->getSqlFrom();
	}

	function SqlSelect() { // For backward compatibility
    	return $this->getSqlSelect();
	}

	function setSqlSelect($v) {
    	$this->_SqlSelect = $v;
	}
	var $_SqlWhere = "";

	function getSqlWhere() { // Where
		$sWhere = ($this->_SqlWhere <> "") ? $this->_SqlWhere : "client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR'";
		$this->TableFilter = "";
		ew_AddFilter($sWhere, $this->TableFilter);
		return $sWhere;
	}

	function SqlWhere() { // For backward compatibility
    	return $this->getSqlWhere();
	}

	function setSqlWhere($v) {
    	$this->_SqlWhere = $v;
	}
	var $_SqlGroupBy = "";

	function getSqlGroupBy() { // Group By
		return ($this->_SqlGroupBy <> "") ? $this->_SqlGroupBy : "Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor";
	}

	function SqlGroupBy() { // For backward compatibility
    	return $this->getSqlGroupBy();
	}

	function setSqlGroupBy($v) {
    	$this->_SqlGroupBy = $v;
	}
	var $_SqlHaving = "";

	function getSqlHaving() { // Having
		return ($this->_SqlHaving <> "") ? $this->_SqlHaving : "";
	}

	function SqlHaving() { // For backward compatibility
    	return $this->getSqlHaving();
	}

	function setSqlHaving($v) {
    	$this->_SqlHaving = $v;
	}
	var $_SqlOrderBy = "";

	function getSqlOrderBy() { // Order By
		return ($this->_SqlOrderBy <> "") ? $this->_SqlOrderBy : "b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor";
	}

	function SqlOrderBy() { // For backward compatibility
    	return $this->getSqlOrderBy();
	}

	function setSqlOrderBy($v) {
    	$this->_SqlOrderBy = $v;
	}

	// Apply User ID filters
	function ApplyUserIDFilters($sFilter) {
		return $sFilter;
	}

	// Check if User ID security allows view all
	function UserIDAllow($id = "") {
		$allow = EW_USER_ID_ALLOW;
		switch ($id) {
			case "add":
			case "copy":
			case "gridadd":
			case "register":
			case "addopt":
				return (($allow & 1) == 1);
			case "edit":
			case "gridedit":
			case "update":
			case "changepwd":
			case "forgotpwd":
				return (($allow & 4) == 4);
			case "delete":
				return (($allow & 2) == 2);
			case "view":
				return (($allow & 32) == 32);
			case "search":
				return (($allow & 64) == 64);
			default:
				return (($allow & 8) == 8);
		}
	}

	// Get SQL
	function GetSQL($where, $orderby) {
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$where, $orderby);
	}

	// Table SQL
	function SQL() {
		$sFilter = $this->CurrentFilter;
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$sFilter, $sSort);
	}

	// Table SQL with List page filter
	function SelectSQL() {
		$sFilter = $this->getSessionWhere();
		ew_AddFilter($sFilter, $this->CurrentFilter);
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$this->Recordset_Selecting($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(), $this->getSqlGroupBy(),
			$this->getSqlHaving(), $this->getSqlOrderBy(), $sFilter, $sSort);
	}

	// Get ORDER BY clause
	function GetOrderBy() {
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql("", "", "", "", $this->getSqlOrderBy(), "", $sSort);
	}

	// Try to get record count
	function TryGetRecordCount($sSql) {
		$cnt = -1;
		if (($this->TableType == 'TABLE' || $this->TableType == 'VIEW' || $this->TableType == 'LINKTABLE') && preg_match("/^SELECT \* FROM/i", $sSql)) {
			$sSql = "SELECT COUNT(*) FROM" . preg_replace('/^SELECT\s([\s\S]+)?\*\sFROM/i', "", $sSql);
			$sOrderBy = $this->GetOrderBy();
			if (substr($sSql, strlen($sOrderBy) * -1) == $sOrderBy)
				$sSql = substr($sSql, 0, strlen($sSql) - strlen($sOrderBy)); // Remove ORDER BY clause
		} else {
			$sSql = "SELECT COUNT(*) FROM (" . $sSql . ") EW_COUNT_TABLE";
		}
		$conn = &$this->Connection();
		if ($rs = $conn->Execute($sSql)) {
			if (!$rs->EOF && $rs->FieldCount() > 0) {
				$cnt = $rs->fields[0];
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// Get record count based on filter (for detail record count in master table pages)
	function LoadRecordCount($sFilter) {
		$origFilter = $this->CurrentFilter;
		$this->CurrentFilter = $sFilter;
		$this->Recordset_Selecting($this->CurrentFilter);

		//$sSql = $this->SQL();
		$sSql = $this->GetSQL($this->CurrentFilter, "");
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			if ($rs = $this->LoadRs($this->CurrentFilter)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		$this->CurrentFilter = $origFilter;
		return intval($cnt);
	}

	// Get record count (for current List page)
	function SelectRecordCount() {
		$sSql = $this->SelectSQL();
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			$conn = &$this->Connection();
			if ($rs = $conn->Execute($sSql)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// INSERT statement
	function InsertSQL(&$rs) {
		$names = "";
		$values = "";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$names .= $this->fields[$name]->FldExpression . ",";
			$values .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($names, -1) == ",")
			$names = substr($names, 0, -1);
		while (substr($values, -1) == ",")
			$values = substr($values, 0, -1);
		return "INSERT INTO " . $this->UpdateTable . " ($names) VALUES ($values)";
	}

	// Insert
	function Insert(&$rs) {
		$conn = &$this->Connection();
		return $conn->Execute($this->InsertSQL($rs));
	}

	// UPDATE statement
	function UpdateSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "UPDATE " . $this->UpdateTable . " SET ";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$sql .= $this->fields[$name]->FldExpression . "=";
			$sql .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($sql, -1) == ",")
			$sql = substr($sql, 0, -1);
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		ew_AddFilter($filter, $where);
		if ($filter <> "")	$sql .= " WHERE " . $filter;
		return $sql;
	}

	// Update
	function Update(&$rs, $where = "", $rsold = NULL, $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->UpdateSQL($rs, $where, $curfilter));
	}

	// DELETE statement
	function DeleteSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "DELETE FROM " . $this->UpdateTable . " WHERE ";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		if ($rs) {
		}
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		ew_AddFilter($filter, $where);
		if ($filter <> "")
			$sql .= $filter;
		else
			$sql .= "0=1"; // Avoid delete
		return $sql;
	}

	// Delete
	function Delete(&$rs, $where = "", $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->DeleteSQL($rs, $where, $curfilter));
	}

	// Key filter WHERE clause
	function SqlKeyFilter() {
		return "";
	}

	// Key filter
	function KeyFilter() {
		$sKeyFilter = $this->SqlKeyFilter();
		return $sKeyFilter;
	}

	// Return page URL
	function getReturnUrl() {
		$name = EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL;

		// Get referer URL automatically
		if (ew_ServerVar("HTTP_REFERER") <> "" && ew_ReferPage() <> ew_CurrentPage() && ew_ReferPage() <> "login.php") // Referer not same page or login page
			$_SESSION[$name] = ew_ServerVar("HTTP_REFERER"); // Save to Session
		if (@$_SESSION[$name] <> "") {
			return $_SESSION[$name];
		} else {
			return "testlist.php";
		}
	}

	function setReturnUrl($v) {
		$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL] = $v;
	}

	// List URL
	function GetListUrl() {
		return "testlist.php";
	}

	// View URL
	function GetViewUrl($parm = "") {
		if ($parm <> "")
			$url = $this->KeyUrl("testview.php", $this->UrlParm($parm));
		else
			$url = $this->KeyUrl("testview.php", $this->UrlParm(EW_TABLE_SHOW_DETAIL . "="));
		return $this->AddMasterUrl($url);
	}

	// Add URL
	function GetAddUrl($parm = "") {
		if ($parm <> "")
			$url = "testadd.php?" . $this->UrlParm($parm);
		else
			$url = "testadd.php";
		return $this->AddMasterUrl($url);
	}

	// Edit URL
	function GetEditUrl($parm = "") {
		$url = $this->KeyUrl("testedit.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline edit URL
	function GetInlineEditUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=edit"));
		return $this->AddMasterUrl($url);
	}

	// Copy URL
	function GetCopyUrl($parm = "") {
		$url = $this->KeyUrl("testadd.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline copy URL
	function GetInlineCopyUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=copy"));
		return $this->AddMasterUrl($url);
	}

	// Delete URL
	function GetDeleteUrl() {
		return $this->KeyUrl("testdelete.php", $this->UrlParm());
	}

	// Add master url
	function AddMasterUrl($url) {
		return $url;
	}

	function KeyToJson() {
		$json = "";
		return "{" . $json . "}";
	}

	// Add key value to URL
	function KeyUrl($url, $parm = "") {
		$sUrl = $url . "?";
		if ($parm <> "") $sUrl .= $parm . "&";
		return $sUrl;
	}

	// Sort URL
	function SortUrl(&$fld) {
		if ($this->CurrentAction <> "" || $this->Export <> "" ||
			in_array($fld->FldType, array(128, 204, 205))) { // Unsortable data type
				return "";
		} elseif ($fld->Sortable) {
			$sUrlParm = $this->UrlParm("order=" . urlencode($fld->FldName) . "&amp;ordertype=" . $fld->ReverseSort());
			return ew_CurrentPage() . "?" . $sUrlParm;
		} else {
			return "";
		}
	}

	// Get record keys from $_POST/$_GET/$_SESSION
	function GetRecordKeys() {
		global $EW_COMPOSITE_KEY_SEPARATOR;
		$arKeys = array();
		$arKey = array();
		if (isset($_POST["key_m"])) {
			$arKeys = ew_StripSlashes($_POST["key_m"]);
			$cnt = count($arKeys);
		} elseif (isset($_GET["key_m"])) {
			$arKeys = ew_StripSlashes($_GET["key_m"]);
			$cnt = count($arKeys);
		} elseif (!empty($_GET) || !empty($_POST)) {
			$isPost = ew_IsHttpPost();

			//return $arKeys; // Do not return yet, so the values will also be checked by the following code
		}

		// Check keys
		$ar = array();
		if (is_array($arKeys)) {
			foreach ($arKeys as $key) {
				$ar[] = $key;
			}
		}
		return $ar;
	}

	// Get key filter
	function GetKeyFilter() {
		$arKeys = $this->GetRecordKeys();
		$sKeyFilter = "";
		foreach ($arKeys as $key) {
			if ($sKeyFilter <> "") $sKeyFilter .= " OR ";
			$sKeyFilter .= "(" . $this->KeyFilter() . ")";
		}
		return $sKeyFilter;
	}

	// Load rows based on filter
	function &LoadRs($sFilter) {

		// Set up filter (SQL WHERE clause) and get return SQL
		//$this->CurrentFilter = $sFilter;
		//$sSql = $this->SQL();

		$sSql = $this->GetSQL($sFilter, "");
		$conn = &$this->Connection();
		$rs = $conn->Execute($sSql);
		return $rs;
	}

	// Load row values from recordset
	function LoadListRowValues(&$rs) {
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->allocated->setDbValue($rs->fields('allocated'));
		$this->description->setDbValue($rs->fields('description'));
		$this->First->setDbValue($rs->fields('First'));
		$this->Last->setDbValue($rs->fields('Last'));
		$this->Total_Hours->setDbValue($rs->fields('Total Hours'));
		$this->Year->setDbValue($rs->fields('Year'));
		$this->Week_23->setDbValue($rs->fields('Week #'));
		$this->From_Date->setDbValue($rs->fields('From Date'));
		$this->Through_Date->setDbValue($rs->fields('Through Date'));
		$this->Monday->setDbValue($rs->fields('Monday'));
	}

	// Render list row values
	function RenderListRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

   // Common render codes
		// dbkey
		// allocated

		$this->allocated->CellCssStyle = "white-space: nowrap;";

		// description
		// First
		// Last
		// Total Hours
		// Year

		$this->Year->CellCssStyle = "white-space: nowrap;";

		// Week #
		$this->Week_23->CellCssStyle = "white-space: nowrap;";

		// From Date
		// Through Date
		// Monday
		// dbkey

		if (strval($this->dbkey->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey" . ew_SearchString("=", $this->dbkey->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.dbkey, `EW_TMP_LOOKUPTABLE`.`From Date` AS `DispFld`, `EW_TMP_LOOKUPTABLE`.`Through Date` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = ew_FormatDateTime($rswrk->fields('DispFld'), 5);
				$arwrk[2] = ew_FormatDateTime($rswrk->fields('Disp2Fld'), 5);
				$this->dbkey->ViewValue = $this->dbkey->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
			}
		} else {
			$this->dbkey->ViewValue = NULL;
		}
		$this->dbkey->ViewCustomAttributes = "";

		// allocated
		$this->allocated->ViewValue = $this->allocated->CurrentValue;
		$this->allocated->ViewValue = ew_FormatNumber($this->allocated->ViewValue, 0, -2, -2, -2);
		$this->allocated->ViewCustomAttributes = "";

		// description
		if (strval($this->description->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.description" . ew_SearchString("=", $this->description->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.description, `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->description, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->description->ViewValue = $this->description->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->description->ViewValue = $this->description->CurrentValue;
			}
		} else {
			$this->description->ViewValue = NULL;
		}
		$this->description->ViewCustomAttributes = "";

		// First
		if (strval($this->First->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.`First`" . ew_SearchString("=", $this->First->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`First`, `EW_TMP_LOOKUPTABLE`.`First` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->First, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->First->ViewValue = $this->First->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->First->ViewValue = $this->First->CurrentValue;
			}
		} else {
			$this->First->ViewValue = NULL;
		}
		$this->First->ViewCustomAttributes = "";

		// Last
		if (strval($this->Last->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.`Last`" . ew_SearchString("=", $this->Last->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`Last`, `EW_TMP_LOOKUPTABLE`.`Last` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->Last, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->Last->ViewValue = $this->Last->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->Last->ViewValue = $this->Last->CurrentValue;
			}
		} else {
			$this->Last->ViewValue = NULL;
		}
		$this->Last->ViewCustomAttributes = "";

		// Total Hours
		$this->Total_Hours->ViewValue = $this->Total_Hours->CurrentValue;
		$this->Total_Hours->ViewCustomAttributes = "";

		// Year
		if (strval($this->Year->CurrentValue) <> "") {
			$this->Year->ViewValue = $this->Year->OptionCaption($this->Year->CurrentValue);
		} else {
			$this->Year->ViewValue = NULL;
		}
		$this->Year->ViewCustomAttributes = "";

		// Week #
		$this->Week_23->ViewValue = $this->Week_23->CurrentValue;
		if (strval($this->Week_23->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.`Week #`" . ew_SearchString("=", $this->Week_23->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.`Week #`, `EW_TMP_LOOKUPTABLE`.`From Date` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->Week_23, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = ew_FormatDateTime($rswrk->fields('DispFld'), 5);
				$this->Week_23->ViewValue = $this->Week_23->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->Week_23->ViewValue = $this->Week_23->CurrentValue;
			}
		} else {
			$this->Week_23->ViewValue = NULL;
		}
		$this->Week_23->ViewValue = ew_FormatNumber($this->Week_23->ViewValue, 0, -2, -2, -2);
		$this->Week_23->ViewCustomAttributes = "";

		// From Date
		if (strval($this->From_Date->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.`From Date`" . ew_SearchString("=", $this->From_Date->CurrentValue, EW_DATATYPE_DATE, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.`From Date`, `EW_TMP_LOOKUPTABLE`.`From Date` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->From_Date, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = ew_FormatDateTime($rswrk->fields('DispFld'), 5);
				$this->From_Date->ViewValue = $this->From_Date->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->From_Date->ViewValue = $this->From_Date->CurrentValue;
			}
		} else {
			$this->From_Date->ViewValue = NULL;
		}
		$this->From_Date->ViewValue = ew_FormatDateTime($this->From_Date->ViewValue, 5);
		$this->From_Date->ViewCustomAttributes = "";

		// Through Date
		$this->Through_Date->ViewValue = $this->Through_Date->CurrentValue;
		$this->Through_Date->ViewValue = ew_FormatDateTime($this->Through_Date->ViewValue, 5);
		$this->Through_Date->ViewCustomAttributes = "";

		// Monday
		$this->Monday->ViewValue = $this->Monday->CurrentValue;
		$this->Monday->ViewCustomAttributes = "";

		// dbkey
		$this->dbkey->LinkCustomAttributes = "";
		$this->dbkey->HrefValue = "";
		$this->dbkey->TooltipValue = "";

		// allocated
		$this->allocated->LinkCustomAttributes = "";
		$this->allocated->HrefValue = "";
		$this->allocated->TooltipValue = "";

		// description
		$this->description->LinkCustomAttributes = "";
		$this->description->HrefValue = "";
		$this->description->TooltipValue = "";

		// First
		$this->First->LinkCustomAttributes = "";
		$this->First->HrefValue = "";
		$this->First->TooltipValue = "";

		// Last
		$this->Last->LinkCustomAttributes = "";
		$this->Last->HrefValue = "";
		$this->Last->TooltipValue = "";

		// Total Hours
		$this->Total_Hours->LinkCustomAttributes = "";
		$this->Total_Hours->HrefValue = "";
		$this->Total_Hours->TooltipValue = "";

		// Year
		$this->Year->LinkCustomAttributes = "";
		$this->Year->HrefValue = "";
		$this->Year->TooltipValue = "";

		// Week #
		$this->Week_23->LinkCustomAttributes = "";
		$this->Week_23->HrefValue = "";
		$this->Week_23->TooltipValue = "";

		// From Date
		$this->From_Date->LinkCustomAttributes = "";
		$this->From_Date->HrefValue = "";
		$this->From_Date->TooltipValue = "";

		// Through Date
		$this->Through_Date->LinkCustomAttributes = "";
		$this->Through_Date->HrefValue = "";
		$this->Through_Date->TooltipValue = "";

		// Monday
		$this->Monday->LinkCustomAttributes = "";
		$this->Monday->HrefValue = "";
		$this->Monday->TooltipValue = "";

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Render edit row values
	function RenderEditRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

		// dbkey
		$this->dbkey->EditAttrs["class"] = "form-control";
		$this->dbkey->EditCustomAttributes = "";

		// allocated
		$this->allocated->EditAttrs["class"] = "form-control";
		$this->allocated->EditCustomAttributes = "";
		$this->allocated->EditValue = $this->allocated->CurrentValue;
		$this->allocated->PlaceHolder = ew_RemoveHtml($this->allocated->FldCaption());
		if (strval($this->allocated->EditValue) <> "" && is_numeric($this->allocated->EditValue)) $this->allocated->EditValue = ew_FormatNumber($this->allocated->EditValue, -2, -2, -2, -2);

		// description
		$this->description->EditAttrs["class"] = "form-control";
		$this->description->EditCustomAttributes = "";

		// First
		$this->First->EditAttrs["class"] = "form-control";
		$this->First->EditCustomAttributes = "";

		// Last
		$this->Last->EditAttrs["class"] = "form-control";
		$this->Last->EditCustomAttributes = "";

		// Total Hours
		$this->Total_Hours->EditAttrs["class"] = "form-control";
		$this->Total_Hours->EditCustomAttributes = "";
		$this->Total_Hours->EditValue = $this->Total_Hours->CurrentValue;
		$this->Total_Hours->PlaceHolder = ew_RemoveHtml($this->Total_Hours->FldCaption());
		if (strval($this->Total_Hours->EditValue) <> "" && is_numeric($this->Total_Hours->EditValue)) $this->Total_Hours->EditValue = ew_FormatNumber($this->Total_Hours->EditValue, -2, -1, -2, 0);

		// Year
		$this->Year->EditAttrs["class"] = "form-control";
		$this->Year->EditCustomAttributes = "";
		$this->Year->EditValue = $this->Year->Options(TRUE);

		// Week #
		$this->Week_23->EditAttrs["class"] = "form-control";
		$this->Week_23->EditCustomAttributes = "";
		$this->Week_23->EditValue = $this->Week_23->CurrentValue;
		$this->Week_23->PlaceHolder = ew_RemoveHtml($this->Week_23->FldCaption());

		// From Date
		$this->From_Date->EditAttrs["class"] = "form-control";
		$this->From_Date->EditCustomAttributes = "";

		// Through Date
		$this->Through_Date->EditAttrs["class"] = "form-control";
		$this->Through_Date->EditCustomAttributes = "";
		$this->Through_Date->EditValue = ew_FormatDateTime($this->Through_Date->CurrentValue, 5);
		$this->Through_Date->PlaceHolder = ew_RemoveHtml($this->Through_Date->FldCaption());

		// Monday
		$this->Monday->EditAttrs["class"] = "form-control";
		$this->Monday->EditCustomAttributes = "";
		$this->Monday->EditValue = $this->Monday->CurrentValue;
		$this->Monday->PlaceHolder = ew_RemoveHtml($this->Monday->FldCaption());
		if (strval($this->Monday->EditValue) <> "" && is_numeric($this->Monday->EditValue)) $this->Monday->EditValue = ew_FormatNumber($this->Monday->EditValue, -2, -1, -2, 0);

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Aggregate list row values
	function AggregateListRowValues() {
	}

	// Aggregate list row (for rendering)
	function AggregateListRow() {

		// Call Row Rendered event
		$this->Row_Rendered();
	}
	var $ExportDoc;

	// Export data in HTML/CSV/Word/Excel/Email/PDF format
	function ExportDocument(&$Doc, &$Recordset, $StartRec, $StopRec, $ExportPageType = "") {
		if (!$Recordset || !$Doc)
			return;
		if (!$Doc->ExportCustom) {

			// Write header
			$Doc->ExportTableHeader();
			if ($Doc->Horizontal) { // Horizontal format, write header
				$Doc->BeginExportRow();
				if ($ExportPageType == "view") {
					if ($this->First->Exportable) $Doc->ExportCaption($this->First);
					if ($this->Last->Exportable) $Doc->ExportCaption($this->Last);
				} else {
					if ($this->First->Exportable) $Doc->ExportCaption($this->First);
					if ($this->Last->Exportable) $Doc->ExportCaption($this->Last);
					if ($this->Total_Hours->Exportable) $Doc->ExportCaption($this->Total_Hours);
					if ($this->Year->Exportable) $Doc->ExportCaption($this->Year);
					if ($this->From_Date->Exportable) $Doc->ExportCaption($this->From_Date);
					if ($this->Through_Date->Exportable) $Doc->ExportCaption($this->Through_Date);
					if ($this->Monday->Exportable) $Doc->ExportCaption($this->Monday);
				}
				$Doc->EndExportRow();
			}
		}

		// Move to first record
		$RecCnt = $StartRec - 1;
		if (!$Recordset->EOF) {
			$Recordset->MoveFirst();
			if ($StartRec > 1)
				$Recordset->Move($StartRec - 1);
		}
		while (!$Recordset->EOF && $RecCnt < $StopRec) {
			$RecCnt++;
			if (intval($RecCnt) >= intval($StartRec)) {
				$RowCnt = intval($RecCnt) - intval($StartRec) + 1;

				// Page break
				if ($this->ExportPageBreakCount > 0) {
					if ($RowCnt > 1 && ($RowCnt - 1) % $this->ExportPageBreakCount == 0)
						$Doc->ExportPageBreak();
				}
				$this->LoadListRowValues($Recordset);

				// Render row
				$this->RowType = EW_ROWTYPE_VIEW; // Render view
				$this->ResetAttrs();
				$this->RenderListRow();
				if (!$Doc->ExportCustom) {
					$Doc->BeginExportRow($RowCnt); // Allow CSS styles if enabled
					if ($ExportPageType == "view") {
						if ($this->First->Exportable) $Doc->ExportField($this->First);
						if ($this->Last->Exportable) $Doc->ExportField($this->Last);
					} else {
						if ($this->First->Exportable) $Doc->ExportField($this->First);
						if ($this->Last->Exportable) $Doc->ExportField($this->Last);
						if ($this->Total_Hours->Exportable) $Doc->ExportField($this->Total_Hours);
						if ($this->Year->Exportable) $Doc->ExportField($this->Year);
						if ($this->From_Date->Exportable) $Doc->ExportField($this->From_Date);
						if ($this->Through_Date->Exportable) $Doc->ExportField($this->Through_Date);
						if ($this->Monday->Exportable) $Doc->ExportField($this->Monday);
					}
					$Doc->EndExportRow();
				}
			}

			// Call Row Export server event
			if ($Doc->ExportCustom)
				$this->Row_Export($Recordset->fields);
			$Recordset->MoveNext();
		}
		if (!$Doc->ExportCustom) {
			$Doc->ExportTableFooter();
		}
	}

	// Get auto fill value
	function GetAutoFill($id, $val) {
		$rsarr = array();
		$rowcnt = 0;

		// Output
		if (is_array($rsarr) && $rowcnt > 0) {
			$fldcnt = count($rsarr[0]);
			for ($i = 0; $i < $rowcnt; $i++) {
				for ($j = 0; $j < $fldcnt; $j++) {
					$str = strval($rsarr[$i][$j]);
					$str = ew_ConvertToUtf8($str);
					if (isset($post["keepCRLF"])) {
						$str = str_replace(array("\r", "\n"), array("\\r", "\\n"), $str);
					} else {
						$str = str_replace(array("\r", "\n"), array(" ", " "), $str);
					}
					$rsarr[$i][$j] = $str;
				}
			}
			return ew_ArrayToJson($rsarr);
		} else {
			return FALSE;
		}
	}

	// Table level events
	// Recordset Selecting event
	function Recordset_Selecting(&$filter) {

		// Enter your code here	
	}

	// Recordset Selected event
	function Recordset_Selected(&$rs) {

		//echo "Recordset Selected";
	}

	// Recordset Search Validated event
	function Recordset_SearchValidated() {

		// Example:
		//$this->MyField1->AdvancedSearch->SearchValue = "your search criteria"; // Search value

	}

	// Recordset Searching event
	function Recordset_Searching(&$filter) {

		// Enter your code here	
	}

	// Row_Selecting event
	function Row_Selecting(&$filter) {

		// Enter your code here	
	}

	// Row Selected event
	function Row_Selected(&$rs) {

		//echo "Row Selected";
	}

	// Row Inserting event
	function Row_Inserting($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Inserted event
	function Row_Inserted($rsold, &$rsnew) {

		//echo "Row Inserted"
	}

	// Row Updating event
	function Row_Updating($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Updated event
	function Row_Updated($rsold, &$rsnew) {

		//echo "Row Updated";
	}

	// Row Update Conflict event
	function Row_UpdateConflict($rsold, &$rsnew) {

		// Enter your code here
		// To ignore conflict, set return value to FALSE

		return TRUE;
	}

	// Grid Inserting event
	function Grid_Inserting() {

		// Enter your code here
		// To reject grid insert, set return value to FALSE

		return TRUE;
	}

	// Grid Inserted event
	function Grid_Inserted($rsnew) {

		//echo "Grid Inserted";
	}

	// Grid Updating event
	function Grid_Updating($rsold) {

		// Enter your code here
		// To reject grid update, set return value to FALSE

		return TRUE;
	}

	// Grid Updated event
	function Grid_Updated($rsold, $rsnew) {

		//echo "Grid Updated";
	}

	// Row Deleting event
	function Row_Deleting(&$rs) {

		// Enter your code here
		// To cancel, set return value to False

		return TRUE;
	}

	// Row Deleted event
	function Row_Deleted(&$rs) {

		//echo "Row Deleted";
	}

	// Email Sending event
	function Email_Sending(&$Email, &$Args) {

		//var_dump($Email); var_dump($Args); exit();
		return TRUE;
	}

	// Lookup Selecting event
	function Lookup_Selecting($fld, &$filter) {

		//var_dump($fld->FldName, $fld->LookupFilters, $filter); // Uncomment to view the filter
		// Enter your code here

	}

	// Row Rendering event
	function Row_Rendering() {

		// Enter your code here	
	}

	// Row Rendered event
	function Row_Rendered() {

		// To view properties of field class, use:
		//var_dump($this-><FieldName>); 

	}

	// User ID Filtering event
	function UserID_Filtering(&$filter) {

		// Enter your code here
	}
}
?>
