<?php
if (session_id() == "") session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg12.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql12.php") ?>
<?php include_once "phpfn12.php" ?>
<?php include_once "testinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn12.php" ?>
<?php

//
// Page class
//

$test_search = NULL; // Initialize page object first

class ctest_search extends ctest {

	// Page ID
	var $PageID = 'search';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'test';

	// Page object name
	var $PageObjName = 'test_search';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}
    var $AuditTrailOnAdd = FALSE;
    var $AuditTrailOnEdit = FALSE;
    var $AuditTrailOnDelete = FALSE;
    var $AuditTrailOnView = FALSE;
    var $AuditTrailOnViewData = FALSE;
    var $AuditTrailOnSearch = FALSE;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (test)
		if (!isset($GLOBALS["test"]) || get_class($GLOBALS["test"]) == "ctest") {
			$GLOBALS["test"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["test"];
		}

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'search', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'test', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanSearch()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("testlist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Create form object
		$objForm = new cFormObj();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action
		$this->First->Visible = !$this->IsAddOrEdit();
		$this->Last->Visible = !$this->IsAddOrEdit();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $test;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($test);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}
	var $FormClassName = "form-horizontal ewForm ewSearchForm";
	var $IsModal = FALSE;
	var $SearchLabelClass = "col-sm-3 control-label ewLabel";
	var $SearchRightColumnClass = "col-sm-9";

	//
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsSearchError;
		global $gbSkipHeaderFooter;

		// Set up Breadcrumb
		$this->SetupBreadcrumb();

		// Check modal
		$this->IsModal = (@$_GET["modal"] == "1" || @$_POST["modal"] == "1");
		if ($this->IsModal)
			$gbSkipHeaderFooter = TRUE;
		if ($this->IsPageRequest()) { // Validate request

			// Get action
			$this->CurrentAction = $objForm->GetValue("a_search");
			switch ($this->CurrentAction) {
				case "S": // Get search criteria

					// Build search string for advanced search, remove blank field
					$this->LoadSearchValues(); // Get search values
					if ($this->ValidateSearch()) {
						$sSrchStr = $this->BuildAdvancedSearch();
					} else {
						$sSrchStr = "";
						$this->setFailureMessage($gsSearchError);
					}
					if ($sSrchStr <> "") {
						$sSrchStr = $this->UrlParm($sSrchStr);
						$sSrchStr = "testlist.php" . "?" . $sSrchStr;
						if ($this->IsModal) {
							$row = array();
							$row["url"] = $sSrchStr;
							echo ew_ArrayToJson(array($row));
							$this->Page_Terminate();
							exit();
						} else {
							$this->Page_Terminate($sSrchStr); // Go to list page
						}
					}
			}
		}

		// Restore search settings from Session
		if ($gsSearchError == "")
			$this->LoadAdvancedSearch();

		// Render row for search
		$this->RowType = EW_ROWTYPE_SEARCH;
		$this->ResetAttrs();
		$this->RenderRow();
	}

	// Build advanced search
	function BuildAdvancedSearch() {
		$sSrchUrl = "";
		$this->BuildSearchUrl($sSrchUrl, $this->dbkey); // dbkey
		$this->BuildSearchUrl($sSrchUrl, $this->description); // description
		$this->BuildSearchUrl($sSrchUrl, $this->First); // First
		$this->BuildSearchUrl($sSrchUrl, $this->Last); // Last
		if ($sSrchUrl <> "") $sSrchUrl .= "&";
		$sSrchUrl .= "cmd=search";
		return $sSrchUrl;
	}

	// Build search URL
	function BuildSearchUrl(&$Url, &$Fld, $OprOnly=FALSE) {
		global $objForm;
		$sWrk = "";
		$FldParm = substr($Fld->FldVar, 2);
		$FldVal = $objForm->GetValue("x_$FldParm");
		$FldOpr = $objForm->GetValue("z_$FldParm");
		$FldCond = $objForm->GetValue("v_$FldParm");
		$FldVal2 = $objForm->GetValue("y_$FldParm");
		$FldOpr2 = $objForm->GetValue("w_$FldParm");
		$FldVal = ew_StripSlashes($FldVal);
		if (is_array($FldVal)) $FldVal = implode(",", $FldVal);
		$FldVal2 = ew_StripSlashes($FldVal2);
		if (is_array($FldVal2)) $FldVal2 = implode(",", $FldVal2);
		$FldOpr = strtoupper(trim($FldOpr));
		$lFldDataType = ($Fld->FldIsVirtual) ? EW_DATATYPE_STRING : $Fld->FldDataType;
		if ($FldOpr == "BETWEEN") {
			$IsValidValue = ($lFldDataType <> EW_DATATYPE_NUMBER) ||
				($lFldDataType == EW_DATATYPE_NUMBER && $this->SearchValueIsNumeric($Fld, $FldVal) && $this->SearchValueIsNumeric($Fld, $FldVal2));
			if ($FldVal <> "" && $FldVal2 <> "" && $IsValidValue) {
				$sWrk = "x_" . $FldParm . "=" . urlencode($FldVal) .
					"&y_" . $FldParm . "=" . urlencode($FldVal2) .
					"&z_" . $FldParm . "=" . urlencode($FldOpr);
			}
		} else {
			$IsValidValue = ($lFldDataType <> EW_DATATYPE_NUMBER) ||
				($lFldDataType == EW_DATATYPE_NUMBER && $this->SearchValueIsNumeric($Fld, $FldVal));
			if ($FldVal <> "" && $IsValidValue && ew_IsValidOpr($FldOpr, $lFldDataType)) {
				$sWrk = "x_" . $FldParm . "=" . urlencode($FldVal) .
					"&z_" . $FldParm . "=" . urlencode($FldOpr);
			} elseif ($FldOpr == "IS NULL" || $FldOpr == "IS NOT NULL" || ($FldOpr <> "" && $OprOnly && ew_IsValidOpr($FldOpr, $lFldDataType))) {
				$sWrk = "z_" . $FldParm . "=" . urlencode($FldOpr);
			}
			$IsValidValue = ($lFldDataType <> EW_DATATYPE_NUMBER) ||
				($lFldDataType == EW_DATATYPE_NUMBER && $this->SearchValueIsNumeric($Fld, $FldVal2));
			if ($FldVal2 <> "" && $IsValidValue && ew_IsValidOpr($FldOpr2, $lFldDataType)) {
				if ($sWrk <> "") $sWrk .= "&v_" . $FldParm . "=" . urlencode($FldCond) . "&";
				$sWrk .= "y_" . $FldParm . "=" . urlencode($FldVal2) .
					"&w_" . $FldParm . "=" . urlencode($FldOpr2);
			} elseif ($FldOpr2 == "IS NULL" || $FldOpr2 == "IS NOT NULL" || ($FldOpr2 <> "" && $OprOnly && ew_IsValidOpr($FldOpr2, $lFldDataType))) {
				if ($sWrk <> "") $sWrk .= "&v_" . $FldParm . "=" . urlencode($FldCond) . "&";
				$sWrk .= "w_" . $FldParm . "=" . urlencode($FldOpr2);
			}
		}
		if ($sWrk <> "") {
			if ($Url <> "") $Url .= "&";
			$Url .= $sWrk;
		}
	}

	function SearchValueIsNumeric($Fld, $Value) {
		if (ew_IsFloatFormat($Fld->FldType)) $Value = ew_StrToFloat($Value);
		return is_numeric($Value);
	}

	// Load search values for validation
	function LoadSearchValues() {
		global $objForm;

		// Load search values
		// dbkey

		$this->dbkey->AdvancedSearch->SearchValue = ew_StripSlashes($objForm->GetValue("x_dbkey"));
		$this->dbkey->AdvancedSearch->SearchOperator = $objForm->GetValue("z_dbkey");

		// description
		$this->description->AdvancedSearch->SearchValue = ew_StripSlashes($objForm->GetValue("x_description"));
		$this->description->AdvancedSearch->SearchOperator = $objForm->GetValue("z_description");

		// First
		$this->First->AdvancedSearch->SearchValue = ew_StripSlashes($objForm->GetValue("x_First"));
		$this->First->AdvancedSearch->SearchOperator = $objForm->GetValue("z_First");

		// Last
		$this->Last->AdvancedSearch->SearchValue = ew_StripSlashes($objForm->GetValue("x_Last"));
		$this->Last->AdvancedSearch->SearchOperator = $objForm->GetValue("z_Last");
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Call Row_Rendering event

		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey
		// allocated
		// description
		// First
		// Last
		// Total Hours
		// Year
		// Week #
		// From Date
		// Through Date
		// Monday

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// dbkey
		if (strval($this->dbkey->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey" . ew_SearchString("=", $this->dbkey->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.dbkey, `EW_TMP_LOOKUPTABLE`.`From Date` AS `DispFld`, `EW_TMP_LOOKUPTABLE`.`Through Date` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = ew_FormatDateTime($rswrk->fields('DispFld'), 5);
				$arwrk[2] = ew_FormatDateTime($rswrk->fields('Disp2Fld'), 5);
				$this->dbkey->ViewValue = $this->dbkey->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
			}
		} else {
			$this->dbkey->ViewValue = NULL;
		}
		$this->dbkey->ViewCustomAttributes = "";

		// description
		if (strval($this->description->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.description" . ew_SearchString("=", $this->description->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.description, `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->description, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->description->ViewValue = $this->description->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->description->ViewValue = $this->description->CurrentValue;
			}
		} else {
			$this->description->ViewValue = NULL;
		}
		$this->description->ViewCustomAttributes = "";

		// First
		if (strval($this->First->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.`First`" . ew_SearchString("=", $this->First->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`First`, `EW_TMP_LOOKUPTABLE`.`First` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->First, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->First->ViewValue = $this->First->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->First->ViewValue = $this->First->CurrentValue;
			}
		} else {
			$this->First->ViewValue = NULL;
		}
		$this->First->ViewCustomAttributes = "";

		// Last
		if (strval($this->Last->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.`Last`" . ew_SearchString("=", $this->Last->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`Last`, `EW_TMP_LOOKUPTABLE`.`Last` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->Last, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->Last->ViewValue = $this->Last->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->Last->ViewValue = $this->Last->CurrentValue;
			}
		} else {
			$this->Last->ViewValue = NULL;
		}
		$this->Last->ViewCustomAttributes = "";

		// Total Hours
		$this->Total_Hours->ViewValue = $this->Total_Hours->CurrentValue;
		$this->Total_Hours->ViewCustomAttributes = "";

		// Year
		if (strval($this->Year->CurrentValue) <> "") {
			$this->Year->ViewValue = $this->Year->OptionCaption($this->Year->CurrentValue);
		} else {
			$this->Year->ViewValue = NULL;
		}
		$this->Year->ViewCustomAttributes = "";

		// From Date
		if (strval($this->From_Date->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.`From Date`" . ew_SearchString("=", $this->From_Date->CurrentValue, EW_DATATYPE_DATE, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.`From Date`, `EW_TMP_LOOKUPTABLE`.`From Date` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->From_Date, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = ew_FormatDateTime($rswrk->fields('DispFld'), 5);
				$this->From_Date->ViewValue = $this->From_Date->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->From_Date->ViewValue = $this->From_Date->CurrentValue;
			}
		} else {
			$this->From_Date->ViewValue = NULL;
		}
		$this->From_Date->ViewValue = ew_FormatDateTime($this->From_Date->ViewValue, 5);
		$this->From_Date->ViewCustomAttributes = "";

		// Through Date
		$this->Through_Date->ViewValue = $this->Through_Date->CurrentValue;
		$this->Through_Date->ViewValue = ew_FormatDateTime($this->Through_Date->ViewValue, 5);
		$this->Through_Date->ViewCustomAttributes = "";

		// Monday
		$this->Monday->ViewValue = $this->Monday->CurrentValue;
		$this->Monday->ViewCustomAttributes = "";

			// dbkey
			$this->dbkey->LinkCustomAttributes = "";
			$this->dbkey->HrefValue = "";
			$this->dbkey->TooltipValue = "";

			// description
			$this->description->LinkCustomAttributes = "";
			$this->description->HrefValue = "";
			$this->description->TooltipValue = "";

			// First
			$this->First->LinkCustomAttributes = "";
			$this->First->HrefValue = "";
			$this->First->TooltipValue = "";

			// Last
			$this->Last->LinkCustomAttributes = "";
			$this->Last->HrefValue = "";
			$this->Last->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_SEARCH) { // Search row

			// dbkey
			$this->dbkey->EditAttrs["class"] = "form-control";
			$this->dbkey->EditCustomAttributes = "";
			if (trim(strval($this->dbkey->AdvancedSearch->SearchValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "tables_data.dbkey" . ew_SearchString("=", $this->dbkey->AdvancedSearch->SearchValue, EW_DATATYPE_STRING, "");
			}
			$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.dbkey, `EW_TMP_LOOKUPTABLE`.`From Date` AS `DispFld`, `EW_TMP_LOOKUPTABLE`.`Through Date` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
			$sWhereWrk = "";
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$rowswrk = count($arwrk);
			for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
				$arwrk[$rowcntwrk][1] = ew_FormatDateTime($arwrk[$rowcntwrk][1], 5);
				$arwrk[$rowcntwrk][2] = ew_FormatDateTime($arwrk[$rowcntwrk][2], 5);
			}
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect"), "", "", "", "", "", "", ""));
			$this->dbkey->EditValue = $arwrk;

			// description
			$this->description->EditAttrs["class"] = "form-control";
			$this->description->EditCustomAttributes = "";
			if (trim(strval($this->description->AdvancedSearch->SearchValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "b.description" . ew_SearchString("=", $this->description->AdvancedSearch->SearchValue, EW_DATATYPE_STRING, "");
			}
			$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.description, `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
			$sWhereWrk = "";
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->description, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect"), "", "", "", "", "", "", ""));
			$this->description->EditValue = $arwrk;

			// First
			$this->First->EditAttrs["class"] = "form-control";
			$this->First->EditCustomAttributes = "";
			if (trim(strval($this->First->AdvancedSearch->SearchValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`First`" . ew_SearchString("=", $this->First->AdvancedSearch->SearchValue, EW_DATATYPE_STRING, "");
			}
			$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`First`, `EW_TMP_LOOKUPTABLE`.`First` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
			$sWhereWrk = "";
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->First, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect"), "", "", "", "", "", "", ""));
			$this->First->EditValue = $arwrk;

			// Last
			$this->Last->EditAttrs["class"] = "form-control";
			$this->Last->EditCustomAttributes = "";
			if (trim(strval($this->Last->AdvancedSearch->SearchValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`Last`" . ew_SearchString("=", $this->Last->AdvancedSearch->SearchValue, EW_DATATYPE_STRING, "");
			}
			$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`Last`, `EW_TMP_LOOKUPTABLE`.`Last` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
			$sWhereWrk = "";
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->Last, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect"), "", "", "", "", "", "", ""));
			$this->Last->EditValue = $arwrk;
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate search
	function ValidateSearch() {
		global $gsSearchError;

		// Initialize
		$gsSearchError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return TRUE;

		// Return validate result
		$ValidateSearch = ($gsSearchError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateSearch = $ValidateSearch && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsSearchError, $sFormCustomError);
		}
		return $ValidateSearch;
	}

	// Load advanced search
	function LoadAdvancedSearch() {
		$this->dbkey->AdvancedSearch->Load();
		$this->description->AdvancedSearch->Load();
		$this->First->AdvancedSearch->Load();
		$this->Last->AdvancedSearch->Load();
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, $this->AddMasterUrl("testlist.php"), "", $this->TableVar, TRUE);
		$PageId = "search";
		$Breadcrumb->Add("search", $PageId, $url);
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($test_search)) $test_search = new ctest_search();

// Page init
$test_search->Page_Init();

// Page main
$test_search->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$test_search->Page_Render();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "search";
<?php if ($test_search->IsModal) { ?>
var CurrentAdvancedSearchForm = ftestsearch = new ew_Form("ftestsearch", "search");
<?php } else { ?>
var CurrentForm = ftestsearch = new ew_Form("ftestsearch", "search");
<?php } ?>

// Form_CustomValidate event
ftestsearch.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
ftestsearch.ValidateRequired = true;
<?php } else { ?>
ftestsearch.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
ftestsearch.Lists["x_dbkey"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_From_Date","x_Through_Date","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftestsearch.Lists["x_description"] = {"LinkField":"x_description","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftestsearch.Lists["x_First"] = {"LinkField":"x_First","Ajax":true,"AutoFill":false,"DisplayFields":["x_First","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftestsearch.Lists["x_Last"] = {"LinkField":"x_Last","Ajax":true,"AutoFill":false,"DisplayFields":["x_Last","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};

// Form object for search
// Validate function for search

ftestsearch.Validate = function(fobj) {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	fobj = fobj || this.Form;
	var infix = "";

	// Fire Form_CustomValidate event
	if (!this.Form_CustomValidate(fobj))
		return false;
	return true;
}
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php if (!$test_search->IsModal) { ?>
<div class="ewToolbar">
<?php $Breadcrumb->Render(); ?>
<?php echo $Language->SelectionForm(); ?>
<div class="clearfix"></div>
</div>
<?php } ?>
<?php $test_search->ShowPageHeader(); ?>
<?php
$test_search->ShowMessage();
?>
<form name="ftestsearch" id="ftestsearch" class="<?php echo $test_search->FormClassName ?>" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($test_search->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $test_search->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="test">
<input type="hidden" name="a_search" id="a_search" value="S">
<?php if ($test_search->IsModal) { ?>
<input type="hidden" name="modal" value="1">
<?php } ?>
<div>
<?php if ($test->dbkey->Visible) { // dbkey ?>
	<div id="r_dbkey" class="form-group">
		<label for="x_dbkey" class="<?php echo $test_search->SearchLabelClass ?>"><span id="elh_test_dbkey"><?php echo $test->dbkey->FldCaption() ?></span>	
		<p class="form-control-static ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_dbkey" id="z_dbkey" value="="></p>
		</label>
		<div class="<?php echo $test_search->SearchRightColumnClass ?>"><div<?php echo $test->dbkey->CellAttributes() ?>>
			<span id="el_test_dbkey">
<select data-table="test" data-field="x_dbkey" data-value-separator="<?php echo ew_HtmlEncode(is_array($test->dbkey->DisplayValueSeparator) ? json_encode($test->dbkey->DisplayValueSeparator) : $test->dbkey->DisplayValueSeparator) ?>" id="x_dbkey" name="x_dbkey"<?php echo $test->dbkey->EditAttributes() ?>>
<?php
if (is_array($test->dbkey->EditValue)) {
	$arwrk = $test->dbkey->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = ew_SameStr($test->dbkey->AdvancedSearch->SearchValue, $arwrk[$rowcntwrk][0]) ? " selected" : "";
		if ($selwrk <> "") $emptywrk = FALSE;		
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $test->dbkey->DisplayValue($arwrk[$rowcntwrk]) ?>
</option>
<?php
	}
	if ($emptywrk && strval($test->dbkey->CurrentValue) <> "") {
?>
<option value="<?php echo ew_HtmlEncode($test->dbkey->CurrentValue) ?>" selected><?php echo $test->dbkey->CurrentValue ?></option>
<?php
    }
}
?>
</select>
<?php
$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.dbkey, `EW_TMP_LOOKUPTABLE`.`From Date` AS `DispFld`, `EW_TMP_LOOKUPTABLE`.`Through Date` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
$sWhereWrk = "";
$test->dbkey->LookupFilters = array("s" => $sSqlWrk, "d" => "");
$test->dbkey->LookupFilters += array("f0" => "tables_data.dbkey = {filter_value}", "t0" => "200", "fn0" => "");
$test->dbkey->LookupFilters += array("df1" => 5);
$test->dbkey->LookupFilters += array("df2" => 5);
$sSqlWrk = "";
$test->Lookup_Selecting($test->dbkey, $sWhereWrk); // Call Lookup selecting
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
if ($sSqlWrk <> "") $test->dbkey->LookupFilters["s"] .= $sSqlWrk;
?>
<input type="hidden" name="s_x_dbkey" id="s_x_dbkey" value="<?php echo $test->dbkey->LookupFilterQuery() ?>">
</span>
		</div></div>
	</div>
<?php } ?>
<?php if ($test->description->Visible) { // description ?>
	<div id="r_description" class="form-group">
		<label for="x_description" class="<?php echo $test_search->SearchLabelClass ?>"><span id="elh_test_description"><?php echo $test->description->FldCaption() ?></span>	
		<p class="form-control-static ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_description" id="z_description" value="="></p>
		</label>
		<div class="<?php echo $test_search->SearchRightColumnClass ?>"><div<?php echo $test->description->CellAttributes() ?>>
			<span id="el_test_description">
<select data-table="test" data-field="x_description" data-value-separator="<?php echo ew_HtmlEncode(is_array($test->description->DisplayValueSeparator) ? json_encode($test->description->DisplayValueSeparator) : $test->description->DisplayValueSeparator) ?>" id="x_description" name="x_description"<?php echo $test->description->EditAttributes() ?>>
<?php
if (is_array($test->description->EditValue)) {
	$arwrk = $test->description->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = ew_SameStr($test->description->AdvancedSearch->SearchValue, $arwrk[$rowcntwrk][0]) ? " selected" : "";
		if ($selwrk <> "") $emptywrk = FALSE;		
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $test->description->DisplayValue($arwrk[$rowcntwrk]) ?>
</option>
<?php
	}
	if ($emptywrk && strval($test->description->CurrentValue) <> "") {
?>
<option value="<?php echo ew_HtmlEncode($test->description->CurrentValue) ?>" selected><?php echo $test->description->CurrentValue ?></option>
<?php
    }
}
?>
</select>
<?php
$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.description, `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
$sWhereWrk = "";
$test->description->LookupFilters = array("s" => $sSqlWrk, "d" => "");
$test->description->LookupFilters += array("f0" => "b.description = {filter_value}", "t0" => "200", "fn0" => "");
$sSqlWrk = "";
$test->Lookup_Selecting($test->description, $sWhereWrk); // Call Lookup selecting
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
if ($sSqlWrk <> "") $test->description->LookupFilters["s"] .= $sSqlWrk;
?>
<input type="hidden" name="s_x_description" id="s_x_description" value="<?php echo $test->description->LookupFilterQuery() ?>">
</span>
		</div></div>
	</div>
<?php } ?>
<?php if ($test->First->Visible) { // First ?>
	<div id="r_First" class="form-group">
		<label for="x_First" class="<?php echo $test_search->SearchLabelClass ?>"><span id="elh_test_First"><?php echo $test->First->FldCaption() ?></span>	
		<p class="form-control-static ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_First" id="z_First" value="="></p>
		</label>
		<div class="<?php echo $test_search->SearchRightColumnClass ?>"><div<?php echo $test->First->CellAttributes() ?>>
			<span id="el_test_First">
<select data-table="test" data-field="x_First" data-value-separator="<?php echo ew_HtmlEncode(is_array($test->First->DisplayValueSeparator) ? json_encode($test->First->DisplayValueSeparator) : $test->First->DisplayValueSeparator) ?>" id="x_First" name="x_First"<?php echo $test->First->EditAttributes() ?>>
<?php
if (is_array($test->First->EditValue)) {
	$arwrk = $test->First->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = ew_SameStr($test->First->AdvancedSearch->SearchValue, $arwrk[$rowcntwrk][0]) ? " selected" : "";
		if ($selwrk <> "") $emptywrk = FALSE;		
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $test->First->DisplayValue($arwrk[$rowcntwrk]) ?>
</option>
<?php
	}
	if ($emptywrk && strval($test->First->CurrentValue) <> "") {
?>
<option value="<?php echo ew_HtmlEncode($test->First->CurrentValue) ?>" selected><?php echo $test->First->CurrentValue ?></option>
<?php
    }
}
?>
</select>
<?php
$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`First`, `EW_TMP_LOOKUPTABLE`.`First` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
$sWhereWrk = "";
$test->First->LookupFilters = array("s" => $sSqlWrk, "d" => "");
$test->First->LookupFilters += array("f0" => "`First` = {filter_value}", "t0" => "200", "fn0" => "");
$sSqlWrk = "";
$test->Lookup_Selecting($test->First, $sWhereWrk); // Call Lookup selecting
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
if ($sSqlWrk <> "") $test->First->LookupFilters["s"] .= $sSqlWrk;
?>
<input type="hidden" name="s_x_First" id="s_x_First" value="<?php echo $test->First->LookupFilterQuery() ?>">
</span>
		</div></div>
	</div>
<?php } ?>
<?php if ($test->Last->Visible) { // Last ?>
	<div id="r_Last" class="form-group">
		<label for="x_Last" class="<?php echo $test_search->SearchLabelClass ?>"><span id="elh_test_Last"><?php echo $test->Last->FldCaption() ?></span>	
		<p class="form-control-static ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_Last" id="z_Last" value="="></p>
		</label>
		<div class="<?php echo $test_search->SearchRightColumnClass ?>"><div<?php echo $test->Last->CellAttributes() ?>>
			<span id="el_test_Last">
<select data-table="test" data-field="x_Last" data-value-separator="<?php echo ew_HtmlEncode(is_array($test->Last->DisplayValueSeparator) ? json_encode($test->Last->DisplayValueSeparator) : $test->Last->DisplayValueSeparator) ?>" id="x_Last" name="x_Last"<?php echo $test->Last->EditAttributes() ?>>
<?php
if (is_array($test->Last->EditValue)) {
	$arwrk = $test->Last->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = ew_SameStr($test->Last->AdvancedSearch->SearchValue, $arwrk[$rowcntwrk][0]) ? " selected" : "";
		if ($selwrk <> "") $emptywrk = FALSE;		
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $test->Last->DisplayValue($arwrk[$rowcntwrk]) ?>
</option>
<?php
	}
	if ($emptywrk && strval($test->Last->CurrentValue) <> "") {
?>
<option value="<?php echo ew_HtmlEncode($test->Last->CurrentValue) ?>" selected><?php echo $test->Last->CurrentValue ?></option>
<?php
    }
}
?>
</select>
<?php
$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`Last`, `EW_TMP_LOOKUPTABLE`.`Last` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
$sWhereWrk = "";
$test->Last->LookupFilters = array("s" => $sSqlWrk, "d" => "");
$test->Last->LookupFilters += array("f0" => "`Last` = {filter_value}", "t0" => "200", "fn0" => "");
$sSqlWrk = "";
$test->Lookup_Selecting($test->Last, $sWhereWrk); // Call Lookup selecting
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
if ($sSqlWrk <> "") $test->Last->LookupFilters["s"] .= $sSqlWrk;
?>
<input type="hidden" name="s_x_Last" id="s_x_Last" value="<?php echo $test->Last->LookupFilterQuery() ?>">
</span>
		</div></div>
	</div>
<?php } ?>
</div>
<?php if (!$test_search->IsModal) { ?>
<div class="form-group">
	<div class="col-sm-offset-3 col-sm-9">
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit"><?php echo $Language->Phrase("Search") ?></button>
<button class="btn btn-default ewButton" name="btnReset" id="btnReset" type="button" onclick="ew_ClearForm(this.form);"><?php echo $Language->Phrase("Reset") ?></button>
	</div>
</div>
<?php } ?>
</form>
<script type="text/javascript">
ftestsearch.Init();
</script>
<?php
$test_search->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$test_search->Page_Terminate();
?>
