<?php
if (session_id() == "") session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg12.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql12.php") ?>
<?php include_once "phpfn12.php" ?>
<?php include_once "time_entryinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn12.php" ?>
<?php

//
// Page class
//

$time_entry_delete = NULL; // Initialize page object first

class ctime_entry_delete extends ctime_entry {

	// Page ID
	var $PageID = 'delete';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'time_entry';

	// Page object name
	var $PageObjName = 'time_entry_delete';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (time_entry)
		if (!isset($GLOBALS["time_entry"]) || get_class($GLOBALS["time_entry"]) == "ctime_entry") {
			$GLOBALS["time_entry"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["time_entry"];
		}

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'delete', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'time_entry', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanDelete()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage($Language->Phrase("NoPermission")); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("time_entrylist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
			if (strval($Security->CurrentUserID()) == "") {
				$this->setFailureMessage($Language->Phrase("NoPermission")); // Set no permission
				$this->Page_Terminate(ew_GetUrl("time_entrylist.php"));
			}
		}
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $time_entry;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($time_entry);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}
	var $DbMasterFilter = "";
	var $DbDetailFilter = "";
	var $StartRec;
	var $TotalRecs = 0;
	var $RecCnt;
	var $RecKeys = array();
	var $Recordset;
	var $StartRowCnt = 1;
	var $RowCnt = 0;

	//
	// Page main
	//
	function Page_Main() {
		global $Language;

		// Set up Breadcrumb
		$this->SetupBreadcrumb();

		// Load key parameters
		$this->RecKeys = $this->GetRecordKeys(); // Load record keys
		$sFilter = $this->GetKeyFilter();
		if ($sFilter == "")
			$this->Page_Terminate("time_entrylist.php"); // Prevent SQL injection, return to list

		// Set up filter (SQL WHHERE clause) and get return SQL
		// SQL constructor in time_entry class, time_entryinfo.php

		$this->CurrentFilter = $sFilter;

		// Check if valid user id
		$conn = &$this->Connection();
		$sql = $this->GetSQL($this->CurrentFilter, "");
		if ($this->Recordset = ew_LoadRecordset($sql, $conn)) {
			$res = TRUE;
			while (!$this->Recordset->EOF) {
				$this->LoadRowValues($this->Recordset);
				if (!$this->ShowOptionLink('delete')) {
					$sUserIdMsg = $Language->Phrase("NoDeletePermission");
					$this->setFailureMessage($sUserIdMsg);
					$res = FALSE;
					break;
				}
				$this->Recordset->MoveNext();
			}
			$this->Recordset->Close();
			if (!$res) $this->Page_Terminate("time_entrylist.php"); // Return to list
		}

		// Get action
		if (@$_POST["a_delete"] <> "") {
			$this->CurrentAction = $_POST["a_delete"];
		} else {
			$this->CurrentAction = "I"; // Display record
		}
		switch ($this->CurrentAction) {
			case "D": // Delete
				$this->SendEmail = TRUE; // Send email on delete success
				if ($this->DeleteRows()) { // Delete rows
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage($Language->Phrase("DeleteSuccess")); // Set up success message
					$this->Page_Terminate($this->getReturnUrl()); // Return to caller
				}
		}
	}

	// Load recordset
	function LoadRecordset($offset = -1, $rowcnt = -1) {

		// Load List page SQL
		$sSql = $this->SelectSQL();
		$conn = &$this->Connection();

		// Load recordset
		$dbtype = ew_GetConnectionType($this->DBID);
		if ($this->UseSelectLimit) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			if ($dbtype == "MSSQL") {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset, array("_hasOrderBy" => trim($this->getOrderBy()) || trim($this->getSessionOrderBy())));
			} else {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset);
			}
			$conn->raiseErrorFn = '';
		} else {
			$rs = ew_LoadRecordset($sSql, $conn);
		}

		// Call Recordset Selected event
		$this->Recordset_Selected($rs);
		return $rs;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->dbkey_counselor->setDbValue($rs->fields('dbkey_counselor'));
		$this->create_date->setDbValue($rs->fields('create_date'));
		$this->time_in->setDbValue($rs->fields('time_in'));
		$this->time_out->setDbValue($rs->fields('time_out'));
		$this->over_time->setDbValue($rs->fields('over_time'));
		$this->dbkey_time_entry_code->setDbValue($rs->fields('dbkey_time_entry_code'));
		$this->notes->setDbValue($rs->fields('notes'));
		$this->dbkey_hr_approver->setDbValue($rs->fields('dbkey_hr_approver'));
		$this->hr_approved->setDbValue($rs->fields('hr_approved'));
		$this->hr_approved_date->setDbValue($rs->fields('hr_approved_date'));
		$this->date_time_created->setDbValue($rs->fields('date_time_created'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey->DbValue = $row['dbkey'];
		$this->dbkey_counselor->DbValue = $row['dbkey_counselor'];
		$this->create_date->DbValue = $row['create_date'];
		$this->time_in->DbValue = $row['time_in'];
		$this->time_out->DbValue = $row['time_out'];
		$this->over_time->DbValue = $row['over_time'];
		$this->dbkey_time_entry_code->DbValue = $row['dbkey_time_entry_code'];
		$this->notes->DbValue = $row['notes'];
		$this->dbkey_hr_approver->DbValue = $row['dbkey_hr_approver'];
		$this->hr_approved->DbValue = $row['hr_approved'];
		$this->hr_approved_date->DbValue = $row['hr_approved_date'];
		$this->date_time_created->DbValue = $row['date_time_created'];
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Call Row_Rendering event

		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey
		// dbkey_counselor
		// create_date
		// time_in
		// time_out
		// over_time
		// dbkey_time_entry_code
		// notes
		// dbkey_hr_approver
		// hr_approved
		// hr_approved_date
		// date_time_created

		$this->date_time_created->CellCssStyle = "white-space: nowrap;";
		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// dbkey_counselor
		if (strval($this->dbkey_counselor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_counselor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_counselor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_counselor->ViewValue = $this->dbkey_counselor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_counselor->ViewValue = $this->dbkey_counselor->CurrentValue;
			}
		} else {
			$this->dbkey_counselor->ViewValue = NULL;
		}
		$this->dbkey_counselor->ViewCustomAttributes = "";

		// create_date
		$this->create_date->ViewValue = $this->create_date->CurrentValue;
		$this->create_date->ViewValue = ew_FormatDateTime($this->create_date->ViewValue, 5);
		$this->create_date->ViewCustomAttributes = "";

		// time_in
		if (strval($this->time_in->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->time_in->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `tables_data`";
		$sWhereWrk = "";
		$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->time_in, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `dbkey` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->time_in->ViewValue = $this->time_in->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->time_in->ViewValue = $this->time_in->CurrentValue;
			}
		} else {
			$this->time_in->ViewValue = NULL;
		}
		$this->time_in->ViewValue = ew_FormatDateTime($this->time_in->ViewValue, 4);
		$this->time_in->ViewCustomAttributes = "";

		// time_out
		if (strval($this->time_out->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->time_out->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `tables_data`";
		$sWhereWrk = "";
		$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->time_out, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `dbkey` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->time_out->ViewValue = $this->time_out->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->time_out->ViewValue = $this->time_out->CurrentValue;
			}
		} else {
			$this->time_out->ViewValue = NULL;
		}
		$this->time_out->ViewValue = ew_FormatDateTime($this->time_out->ViewValue, 4);
		$this->time_out->ViewCustomAttributes = "";

		// over_time
		if (strval($this->over_time->CurrentValue) <> "") {
			$this->over_time->ViewValue = $this->over_time->OptionCaption($this->over_time->CurrentValue);
		} else {
			$this->over_time->ViewValue = NULL;
		}
		$this->over_time->ViewCustomAttributes = "";

		// dbkey_time_entry_code
		if (strval($this->dbkey_time_entry_code->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_time_entry_code->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `time_entry_code`";
		$sWhereWrk = "";
		$lookuptblfilter = "`active` = 1";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_time_entry_code, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_time_entry_code->ViewValue = $this->dbkey_time_entry_code->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_time_entry_code->ViewValue = $this->dbkey_time_entry_code->CurrentValue;
			}
		} else {
			$this->dbkey_time_entry_code->ViewValue = NULL;
		}
		$this->dbkey_time_entry_code->ViewCustomAttributes = "";

		// notes
		$this->notes->ViewValue = $this->notes->CurrentValue;
		$this->notes->ViewCustomAttributes = "";

		// dbkey_hr_approver
		$this->dbkey_hr_approver->ViewValue = $this->dbkey_hr_approver->CurrentValue;
		$this->dbkey_hr_approver->ViewCustomAttributes = "";

		// hr_approved_date
		$this->hr_approved_date->ViewValue = $this->hr_approved_date->CurrentValue;
		$this->hr_approved_date->ViewValue = ew_FormatDateTime($this->hr_approved_date->ViewValue, 5);
		$this->hr_approved_date->ViewCustomAttributes = "";

		// date_time_created
		$this->date_time_created->ViewValue = $this->date_time_created->CurrentValue;
		$this->date_time_created->ViewValue = ew_FormatDateTime($this->date_time_created->ViewValue, 5);
		$this->date_time_created->ViewCustomAttributes = "";

			// dbkey_counselor
			$this->dbkey_counselor->LinkCustomAttributes = "";
			$this->dbkey_counselor->HrefValue = "";
			$this->dbkey_counselor->TooltipValue = "";

			// create_date
			$this->create_date->LinkCustomAttributes = "";
			$this->create_date->HrefValue = "";
			$this->create_date->TooltipValue = "";

			// time_in
			$this->time_in->LinkCustomAttributes = "";
			$this->time_in->HrefValue = "";
			$this->time_in->TooltipValue = "";

			// time_out
			$this->time_out->LinkCustomAttributes = "";
			$this->time_out->HrefValue = "";
			$this->time_out->TooltipValue = "";

			// over_time
			$this->over_time->LinkCustomAttributes = "";
			$this->over_time->HrefValue = "";
			$this->over_time->TooltipValue = "";

			// dbkey_time_entry_code
			$this->dbkey_time_entry_code->LinkCustomAttributes = "";
			$this->dbkey_time_entry_code->HrefValue = "";
			$this->dbkey_time_entry_code->TooltipValue = "";

			// dbkey_hr_approver
			$this->dbkey_hr_approver->LinkCustomAttributes = "";
			$this->dbkey_hr_approver->HrefValue = "";
			$this->dbkey_hr_approver->TooltipValue = "";

			// hr_approved_date
			$this->hr_approved_date->LinkCustomAttributes = "";
			$this->hr_approved_date->HrefValue = "";
			$this->hr_approved_date->TooltipValue = "";

			// date_time_created
			$this->date_time_created->LinkCustomAttributes = "";
			$this->date_time_created->HrefValue = "";
			$this->date_time_created->TooltipValue = "";
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	//
	// Delete records based on current filter
	//
	function DeleteRows() {
		global $Language, $Security;
		if (!$Security->CanDelete()) {
			$this->setFailureMessage($Language->Phrase("NoDeletePermission")); // No delete permission
			return FALSE;
		}
		$DeleteRows = TRUE;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
		$rs = $conn->Execute($sSql);
		$conn->raiseErrorFn = '';
		if ($rs === FALSE) {
			return FALSE;
		} elseif ($rs->EOF) {
			$this->setFailureMessage($Language->Phrase("NoRecord")); // No record found
			$rs->Close();
			return FALSE;

		//} else {
		//	$this->LoadRowValues($rs); // Load row values

		}
		$rows = ($rs) ? $rs->GetRows() : array();
		$conn->BeginTrans();

		// Clone old rows
		$rsold = $rows;
		if ($rs)
			$rs->Close();

		// Call row deleting event
		if ($DeleteRows) {
			foreach ($rsold as $row) {
				$DeleteRows = $this->Row_Deleting($row);
				if (!$DeleteRows) break;
			}
		}
		if ($DeleteRows) {
			$sKey = "";
			foreach ($rsold as $row) {
				$sThisKey = "";
				if ($sThisKey <> "") $sThisKey .= $GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"];
				$sThisKey .= $row['dbkey'];
				$this->LoadDbValues($row);
				$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
				$DeleteRows = $this->Delete($row); // Delete
				$conn->raiseErrorFn = '';
				if ($DeleteRows === FALSE)
					break;
				if ($sKey <> "") $sKey .= ", ";
				$sKey .= $sThisKey;
			}
		} else {

			// Set up error message
			if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

				// Use the message, do nothing
			} elseif ($this->CancelMessage <> "") {
				$this->setFailureMessage($this->CancelMessage);
				$this->CancelMessage = "";
			} else {
				$this->setFailureMessage($Language->Phrase("DeleteCancelled"));
			}
		}
		if ($DeleteRows) {
			$conn->CommitTrans(); // Commit the changes
		} else {
			$conn->RollbackTrans(); // Rollback changes
		}

		// Call Row Deleted event
		if ($DeleteRows) {
			foreach ($rsold as $row) {
				$this->Row_Deleted($row);
			}
		}
		return $DeleteRows;
	}

	// Show link optionally based on User ID
	function ShowOptionLink($id = "") {
		global $Security;
		if ($Security->IsLoggedIn() && !$Security->IsAdmin() && !$this->UserIDAllow($id))
			return $Security->IsValidUserID($this->dbkey_counselor->CurrentValue);
		return TRUE;
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, "time_entrylist.php", "", $this->TableVar, TRUE);
		$PageId = "delete";
		$Breadcrumb->Add("delete", $PageId, $url);
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($time_entry_delete)) $time_entry_delete = new ctime_entry_delete();

// Page init
$time_entry_delete->Page_Init();

// Page main
$time_entry_delete->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$time_entry_delete->Page_Render();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "delete";
var CurrentForm = ftime_entrydelete = new ew_Form("ftime_entrydelete", "delete");

// Form_CustomValidate event
ftime_entrydelete.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
ftime_entrydelete.ValidateRequired = true;
<?php } else { ?>
ftime_entrydelete.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
ftime_entrydelete.Lists["x_dbkey_counselor"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftime_entrydelete.Lists["x_time_in"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftime_entrydelete.Lists["x_time_out"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftime_entrydelete.Lists["x_over_time"] = {"LinkField":"","Ajax":false,"AutoFill":false,"DisplayFields":["","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftime_entrydelete.Lists["x_over_time"].Options = <?php echo json_encode($time_entry->over_time->Options()) ?>;
ftime_entrydelete.Lists["x_dbkey_time_entry_code"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};

// Form object for search
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php

// Load records for display
if ($time_entry_delete->Recordset = $time_entry_delete->LoadRecordset())
	$time_entry_deleteTotalRecs = $time_entry_delete->Recordset->RecordCount(); // Get record count
if ($time_entry_deleteTotalRecs <= 0) { // No record found, exit
	if ($time_entry_delete->Recordset)
		$time_entry_delete->Recordset->Close();
	$time_entry_delete->Page_Terminate("time_entrylist.php"); // Return to list
}
?>
<div class="ewToolbar">
<?php $Breadcrumb->Render(); ?>
<?php echo $Language->SelectionForm(); ?>
<div class="clearfix"></div>
</div>
<?php $time_entry_delete->ShowPageHeader(); ?>
<?php
$time_entry_delete->ShowMessage();
?>
<form name="ftime_entrydelete" id="ftime_entrydelete" class="form-inline ewForm ewDeleteForm" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($time_entry_delete->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $time_entry_delete->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="time_entry">
<input type="hidden" name="a_delete" id="a_delete" value="D">
<?php foreach ($time_entry_delete->RecKeys as $key) { ?>
<?php $keyvalue = is_array($key) ? implode($EW_COMPOSITE_KEY_SEPARATOR, $key) : $key; ?>
<input type="hidden" name="key_m[]" value="<?php echo ew_HtmlEncode($keyvalue) ?>">
<?php } ?>
<div class="ewGrid">
<div class="<?php if (ew_IsResponsiveLayout()) { echo "table-responsive "; } ?>ewGridMiddlePanel">
<table class="table ewTable">
<?php echo $time_entry->TableCustomInnerHtml ?>
	<thead>
	<tr class="ewTableHeader">
<?php if ($time_entry->dbkey_counselor->Visible) { // dbkey_counselor ?>
		<th><span id="elh_time_entry_dbkey_counselor" class="time_entry_dbkey_counselor"><?php echo $time_entry->dbkey_counselor->FldCaption() ?></span></th>
<?php } ?>
<?php if ($time_entry->create_date->Visible) { // create_date ?>
		<th><span id="elh_time_entry_create_date" class="time_entry_create_date"><?php echo $time_entry->create_date->FldCaption() ?></span></th>
<?php } ?>
<?php if ($time_entry->time_in->Visible) { // time_in ?>
		<th><span id="elh_time_entry_time_in" class="time_entry_time_in"><?php echo $time_entry->time_in->FldCaption() ?></span></th>
<?php } ?>
<?php if ($time_entry->time_out->Visible) { // time_out ?>
		<th><span id="elh_time_entry_time_out" class="time_entry_time_out"><?php echo $time_entry->time_out->FldCaption() ?></span></th>
<?php } ?>
<?php if ($time_entry->over_time->Visible) { // over_time ?>
		<th><span id="elh_time_entry_over_time" class="time_entry_over_time"><?php echo $time_entry->over_time->FldCaption() ?></span></th>
<?php } ?>
<?php if ($time_entry->dbkey_time_entry_code->Visible) { // dbkey_time_entry_code ?>
		<th><span id="elh_time_entry_dbkey_time_entry_code" class="time_entry_dbkey_time_entry_code"><?php echo $time_entry->dbkey_time_entry_code->FldCaption() ?></span></th>
<?php } ?>
<?php if ($time_entry->dbkey_hr_approver->Visible) { // dbkey_hr_approver ?>
		<th><span id="elh_time_entry_dbkey_hr_approver" class="time_entry_dbkey_hr_approver"><?php echo $time_entry->dbkey_hr_approver->FldCaption() ?></span></th>
<?php } ?>
<?php if ($time_entry->hr_approved_date->Visible) { // hr_approved_date ?>
		<th><span id="elh_time_entry_hr_approved_date" class="time_entry_hr_approved_date"><?php echo $time_entry->hr_approved_date->FldCaption() ?></span></th>
<?php } ?>
<?php if ($time_entry->date_time_created->Visible) { // date_time_created ?>
		<th><span id="elh_time_entry_date_time_created" class="time_entry_date_time_created"><?php echo $time_entry->date_time_created->FldCaption() ?></span></th>
<?php } ?>
	</tr>
	</thead>
	<tbody>
<?php
$time_entry_delete->RecCnt = 0;
$i = 0;
while (!$time_entry_delete->Recordset->EOF) {
	$time_entry_delete->RecCnt++;
	$time_entry_delete->RowCnt++;

	// Set row properties
	$time_entry->ResetAttrs();
	$time_entry->RowType = EW_ROWTYPE_VIEW; // View

	// Get the field contents
	$time_entry_delete->LoadRowValues($time_entry_delete->Recordset);

	// Render row
	$time_entry_delete->RenderRow();
?>
	<tr<?php echo $time_entry->RowAttributes() ?>>
<?php if ($time_entry->dbkey_counselor->Visible) { // dbkey_counselor ?>
		<td<?php echo $time_entry->dbkey_counselor->CellAttributes() ?>>
<span id="el<?php echo $time_entry_delete->RowCnt ?>_time_entry_dbkey_counselor" class="time_entry_dbkey_counselor">
<span<?php echo $time_entry->dbkey_counselor->ViewAttributes() ?>>
<?php echo $time_entry->dbkey_counselor->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($time_entry->create_date->Visible) { // create_date ?>
		<td<?php echo $time_entry->create_date->CellAttributes() ?>>
<span id="el<?php echo $time_entry_delete->RowCnt ?>_time_entry_create_date" class="time_entry_create_date">
<span<?php echo $time_entry->create_date->ViewAttributes() ?>>
<?php echo $time_entry->create_date->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($time_entry->time_in->Visible) { // time_in ?>
		<td<?php echo $time_entry->time_in->CellAttributes() ?>>
<span id="el<?php echo $time_entry_delete->RowCnt ?>_time_entry_time_in" class="time_entry_time_in">
<span<?php echo $time_entry->time_in->ViewAttributes() ?>>
<?php echo $time_entry->time_in->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($time_entry->time_out->Visible) { // time_out ?>
		<td<?php echo $time_entry->time_out->CellAttributes() ?>>
<span id="el<?php echo $time_entry_delete->RowCnt ?>_time_entry_time_out" class="time_entry_time_out">
<span<?php echo $time_entry->time_out->ViewAttributes() ?>>
<?php echo $time_entry->time_out->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($time_entry->over_time->Visible) { // over_time ?>
		<td<?php echo $time_entry->over_time->CellAttributes() ?>>
<span id="el<?php echo $time_entry_delete->RowCnt ?>_time_entry_over_time" class="time_entry_over_time">
<span<?php echo $time_entry->over_time->ViewAttributes() ?>>
<?php echo $time_entry->over_time->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($time_entry->dbkey_time_entry_code->Visible) { // dbkey_time_entry_code ?>
		<td<?php echo $time_entry->dbkey_time_entry_code->CellAttributes() ?>>
<span id="el<?php echo $time_entry_delete->RowCnt ?>_time_entry_dbkey_time_entry_code" class="time_entry_dbkey_time_entry_code">
<span<?php echo $time_entry->dbkey_time_entry_code->ViewAttributes() ?>>
<?php echo $time_entry->dbkey_time_entry_code->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($time_entry->dbkey_hr_approver->Visible) { // dbkey_hr_approver ?>
		<td<?php echo $time_entry->dbkey_hr_approver->CellAttributes() ?>>
<span id="el<?php echo $time_entry_delete->RowCnt ?>_time_entry_dbkey_hr_approver" class="time_entry_dbkey_hr_approver">
<span<?php echo $time_entry->dbkey_hr_approver->ViewAttributes() ?>>
<?php echo $time_entry->dbkey_hr_approver->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($time_entry->hr_approved_date->Visible) { // hr_approved_date ?>
		<td<?php echo $time_entry->hr_approved_date->CellAttributes() ?>>
<span id="el<?php echo $time_entry_delete->RowCnt ?>_time_entry_hr_approved_date" class="time_entry_hr_approved_date">
<span<?php echo $time_entry->hr_approved_date->ViewAttributes() ?>>
<?php echo $time_entry->hr_approved_date->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($time_entry->date_time_created->Visible) { // date_time_created ?>
		<td<?php echo $time_entry->date_time_created->CellAttributes() ?>>
<span id="el<?php echo $time_entry_delete->RowCnt ?>_time_entry_date_time_created" class="time_entry_date_time_created">
<span<?php echo $time_entry->date_time_created->ViewAttributes() ?>>
<?php echo $time_entry->date_time_created->ListViewValue() ?></span>
</span>
</td>
<?php } ?>
	</tr>
<?php
	$time_entry_delete->Recordset->MoveNext();
}
$time_entry_delete->Recordset->Close();
?>
</tbody>
</table>
</div>
</div>
<div>
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit"><?php echo $Language->Phrase("DeleteBtn") ?></button>
<button class="btn btn-default ewButton" name="btnCancel" id="btnCancel" type="button" data-href="<?php echo $time_entry_delete->getReturnUrl() ?>"><?php echo $Language->Phrase("CancelBtn") ?></button>
</div>
</form>
<script type="text/javascript">
ftime_entrydelete.Init();
</script>
<?php
$time_entry_delete->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$time_entry_delete->Page_Terminate();
?>
