<?php
if (session_id() == "") session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg12.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql12.php") ?>
<?php include_once "phpfn12.php" ?>
<?php include_once "time_entryinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn12.php" ?>
<?php

//
// Page class
//

$time_entry_edit = NULL; // Initialize page object first

class ctime_entry_edit extends ctime_entry {

	// Page ID
	var $PageID = 'edit';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'time_entry';

	// Page object name
	var $PageObjName = 'time_entry_edit';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (time_entry)
		if (!isset($GLOBALS["time_entry"]) || get_class($GLOBALS["time_entry"]) == "ctime_entry") {
			$GLOBALS["time_entry"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["time_entry"];
		}

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'edit', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'time_entry', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanEdit()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage($Language->Phrase("NoPermission")); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("time_entrylist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
			if (strval($Security->CurrentUserID()) == "") {
				$this->setFailureMessage($Language->Phrase("NoPermission")); // Set no permission
				$this->Page_Terminate(ew_GetUrl("time_entrylist.php"));
			}
		}

		// Create form object
		$objForm = new cFormObj();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $time_entry;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($time_entry);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}
	var $FormClassName = "form-horizontal ewForm ewEditForm";
	var $DbMasterFilter;
	var $DbDetailFilter;

	// 
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError;

		// Load key from QueryString
		if (@$_GET["dbkey"] <> "") {
			$this->dbkey->setQueryStringValue($_GET["dbkey"]);
		}

		// Set up Breadcrumb
		$this->SetupBreadcrumb();

		// Process form if post back
		if (@$_POST["a_edit"] <> "") {
			$this->CurrentAction = $_POST["a_edit"]; // Get action code
			$this->LoadFormValues(); // Get form values
		} else {
			$this->CurrentAction = "I"; // Default action is display
		}

		// Check if valid key
		if ($this->dbkey->CurrentValue == "")
			$this->Page_Terminate("time_entrylist.php"); // Invalid key, return to list

		// Validate form if post back
		if (@$_POST["a_edit"] <> "") {
			if (!$this->ValidateForm()) {
				$this->CurrentAction = ""; // Form error, reset action
				$this->setFailureMessage($gsFormError);
				$this->EventCancelled = TRUE; // Event cancelled
				$this->RestoreFormValues();
			}
		}
		switch ($this->CurrentAction) {
			case "I": // Get a record to display
				if (!$this->LoadRow()) { // Load record based on key
					if ($this->getFailureMessage() == "") $this->setFailureMessage($Language->Phrase("NoRecord")); // No record found
					$this->Page_Terminate("time_entrylist.php"); // No matching record, return to list
				}
				break;
			Case "U": // Update
				$sReturnUrl = $this->getReturnUrl();
				$this->SendEmail = TRUE; // Send email on update success
				if ($this->EditRow()) { // Update record based on key
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage($Language->Phrase("UpdateSuccess")); // Update success
					$this->Page_Terminate($sReturnUrl); // Return to caller
				} elseif ($this->getFailureMessage() == $Language->Phrase("NoRecord")) {
					$this->Page_Terminate($sReturnUrl); // Return to caller
				} else {
					$this->EventCancelled = TRUE; // Event cancelled
					$this->RestoreFormValues(); // Restore form values if update failed
				}
		}

		// Render the record
		$this->RowType = EW_ROWTYPE_EDIT; // Render as Edit
		$this->ResetAttrs();
		$this->RenderRow();
	}

	// Set up starting record parameters
	function SetUpStartRec() {
		if ($this->DisplayRecs == 0)
			return;
		if ($this->IsPageRequest()) { // Validate request
			if (@$_GET[EW_TABLE_START_REC] <> "") { // Check for "start" parameter
				$this->StartRec = $_GET[EW_TABLE_START_REC];
				$this->setStartRecordNumber($this->StartRec);
			} elseif (@$_GET[EW_TABLE_PAGE_NO] <> "") {
				$PageNo = $_GET[EW_TABLE_PAGE_NO];
				if (is_numeric($PageNo)) {
					$this->StartRec = ($PageNo-1)*$this->DisplayRecs+1;
					if ($this->StartRec <= 0) {
						$this->StartRec = 1;
					} elseif ($this->StartRec >= intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1) {
						$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1;
					}
					$this->setStartRecordNumber($this->StartRec);
				}
			}
		}
		$this->StartRec = $this->getStartRecordNumber();

		// Check if correct start record counter
		if (!is_numeric($this->StartRec) || $this->StartRec == "") { // Avoid invalid start record counter
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} elseif (intval($this->StartRec) > intval($this->TotalRecs)) { // Avoid starting record > total records
			$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to last page first record
			$this->setStartRecordNumber($this->StartRec);
		} elseif (($this->StartRec-1) % $this->DisplayRecs <> 0) {
			$this->StartRec = intval(($this->StartRec-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to page boundary
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Get upload files
	function GetUploadFiles() {
		global $objForm, $Language;

		// Get upload data
	}

	// Load form values
	function LoadFormValues() {

		// Load from form
		global $objForm;
		if (!$this->dbkey_counselor->FldIsDetailKey) {
			$this->dbkey_counselor->setFormValue($objForm->GetValue("x_dbkey_counselor"));
		}
		if (!$this->create_date->FldIsDetailKey) {
			$this->create_date->setFormValue($objForm->GetValue("x_create_date"));
			$this->create_date->CurrentValue = ew_UnFormatDateTime($this->create_date->CurrentValue, 5);
		}
		if (!$this->time_in->FldIsDetailKey) {
			$this->time_in->setFormValue($objForm->GetValue("x_time_in"));
		}
		if (!$this->time_out->FldIsDetailKey) {
			$this->time_out->setFormValue($objForm->GetValue("x_time_out"));
		}
		if (!$this->over_time->FldIsDetailKey) {
			$this->over_time->setFormValue($objForm->GetValue("x_over_time"));
		}
		if (!$this->dbkey_time_entry_code->FldIsDetailKey) {
			$this->dbkey_time_entry_code->setFormValue($objForm->GetValue("x_dbkey_time_entry_code"));
		}
		if (!$this->notes->FldIsDetailKey) {
			$this->notes->setFormValue($objForm->GetValue("x_notes"));
		}
		if (!$this->dbkey->FldIsDetailKey)
			$this->dbkey->setFormValue($objForm->GetValue("x_dbkey"));
	}

	// Restore form values
	function RestoreFormValues() {
		global $objForm;
		$this->LoadRow();
		$this->dbkey->CurrentValue = $this->dbkey->FormValue;
		$this->dbkey_counselor->CurrentValue = $this->dbkey_counselor->FormValue;
		$this->create_date->CurrentValue = $this->create_date->FormValue;
		$this->create_date->CurrentValue = ew_UnFormatDateTime($this->create_date->CurrentValue, 5);
		$this->time_in->CurrentValue = $this->time_in->FormValue;
		$this->time_out->CurrentValue = $this->time_out->FormValue;
		$this->over_time->CurrentValue = $this->over_time->FormValue;
		$this->dbkey_time_entry_code->CurrentValue = $this->dbkey_time_entry_code->FormValue;
		$this->notes->CurrentValue = $this->notes->FormValue;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}

		// Check if valid user id
		if ($res) {
			$res = $this->ShowOptionLink('edit');
			if (!$res) {
				$sUserIdMsg = $Language->Phrase("NoPermission");
				$this->setFailureMessage($sUserIdMsg);
			}
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->dbkey_counselor->setDbValue($rs->fields('dbkey_counselor'));
		$this->create_date->setDbValue($rs->fields('create_date'));
		$this->time_in->setDbValue($rs->fields('time_in'));
		$this->time_out->setDbValue($rs->fields('time_out'));
		$this->over_time->setDbValue($rs->fields('over_time'));
		$this->dbkey_time_entry_code->setDbValue($rs->fields('dbkey_time_entry_code'));
		$this->notes->setDbValue($rs->fields('notes'));
		$this->dbkey_hr_approver->setDbValue($rs->fields('dbkey_hr_approver'));
		$this->hr_approved->setDbValue($rs->fields('hr_approved'));
		$this->hr_approved_date->setDbValue($rs->fields('hr_approved_date'));
		$this->date_time_created->setDbValue($rs->fields('date_time_created'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey->DbValue = $row['dbkey'];
		$this->dbkey_counselor->DbValue = $row['dbkey_counselor'];
		$this->create_date->DbValue = $row['create_date'];
		$this->time_in->DbValue = $row['time_in'];
		$this->time_out->DbValue = $row['time_out'];
		$this->over_time->DbValue = $row['over_time'];
		$this->dbkey_time_entry_code->DbValue = $row['dbkey_time_entry_code'];
		$this->notes->DbValue = $row['notes'];
		$this->dbkey_hr_approver->DbValue = $row['dbkey_hr_approver'];
		$this->hr_approved->DbValue = $row['hr_approved'];
		$this->hr_approved_date->DbValue = $row['hr_approved_date'];
		$this->date_time_created->DbValue = $row['date_time_created'];
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Call Row_Rendering event

		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey
		// dbkey_counselor
		// create_date
		// time_in
		// time_out
		// over_time
		// dbkey_time_entry_code
		// notes
		// dbkey_hr_approver
		// hr_approved
		// hr_approved_date
		// date_time_created

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// dbkey_counselor
		if (strval($this->dbkey_counselor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_counselor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_counselor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_counselor->ViewValue = $this->dbkey_counselor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_counselor->ViewValue = $this->dbkey_counselor->CurrentValue;
			}
		} else {
			$this->dbkey_counselor->ViewValue = NULL;
		}
		$this->dbkey_counselor->ViewCustomAttributes = "";

		// create_date
		$this->create_date->ViewValue = $this->create_date->CurrentValue;
		$this->create_date->ViewValue = ew_FormatDateTime($this->create_date->ViewValue, 5);
		$this->create_date->ViewCustomAttributes = "";

		// time_in
		if (strval($this->time_in->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->time_in->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `tables_data`";
		$sWhereWrk = "";
		$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->time_in, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `dbkey` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->time_in->ViewValue = $this->time_in->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->time_in->ViewValue = $this->time_in->CurrentValue;
			}
		} else {
			$this->time_in->ViewValue = NULL;
		}
		$this->time_in->ViewValue = ew_FormatDateTime($this->time_in->ViewValue, 4);
		$this->time_in->ViewCustomAttributes = "";

		// time_out
		if (strval($this->time_out->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->time_out->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `tables_data`";
		$sWhereWrk = "";
		$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->time_out, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `dbkey` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->time_out->ViewValue = $this->time_out->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->time_out->ViewValue = $this->time_out->CurrentValue;
			}
		} else {
			$this->time_out->ViewValue = NULL;
		}
		$this->time_out->ViewValue = ew_FormatDateTime($this->time_out->ViewValue, 4);
		$this->time_out->ViewCustomAttributes = "";

		// over_time
		if (strval($this->over_time->CurrentValue) <> "") {
			$this->over_time->ViewValue = $this->over_time->OptionCaption($this->over_time->CurrentValue);
		} else {
			$this->over_time->ViewValue = NULL;
		}
		$this->over_time->ViewCustomAttributes = "";

		// dbkey_time_entry_code
		if (strval($this->dbkey_time_entry_code->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_time_entry_code->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `time_entry_code`";
		$sWhereWrk = "";
		$lookuptblfilter = "`active` = 1";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_time_entry_code, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_time_entry_code->ViewValue = $this->dbkey_time_entry_code->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_time_entry_code->ViewValue = $this->dbkey_time_entry_code->CurrentValue;
			}
		} else {
			$this->dbkey_time_entry_code->ViewValue = NULL;
		}
		$this->dbkey_time_entry_code->ViewCustomAttributes = "";

		// notes
		$this->notes->ViewValue = $this->notes->CurrentValue;
		$this->notes->ViewCustomAttributes = "";

		// dbkey_hr_approver
		$this->dbkey_hr_approver->ViewValue = $this->dbkey_hr_approver->CurrentValue;
		$this->dbkey_hr_approver->ViewCustomAttributes = "";

		// hr_approved_date
		$this->hr_approved_date->ViewValue = $this->hr_approved_date->CurrentValue;
		$this->hr_approved_date->ViewValue = ew_FormatDateTime($this->hr_approved_date->ViewValue, 5);
		$this->hr_approved_date->ViewCustomAttributes = "";

		// date_time_created
		$this->date_time_created->ViewValue = $this->date_time_created->CurrentValue;
		$this->date_time_created->ViewValue = ew_FormatDateTime($this->date_time_created->ViewValue, 5);
		$this->date_time_created->ViewCustomAttributes = "";

			// dbkey_counselor
			$this->dbkey_counselor->LinkCustomAttributes = "";
			$this->dbkey_counselor->HrefValue = "";
			$this->dbkey_counselor->TooltipValue = "";

			// create_date
			$this->create_date->LinkCustomAttributes = "";
			$this->create_date->HrefValue = "";
			$this->create_date->TooltipValue = "";

			// time_in
			$this->time_in->LinkCustomAttributes = "";
			$this->time_in->HrefValue = "";
			$this->time_in->TooltipValue = "";

			// time_out
			$this->time_out->LinkCustomAttributes = "";
			$this->time_out->HrefValue = "";
			$this->time_out->TooltipValue = "";

			// over_time
			$this->over_time->LinkCustomAttributes = "";
			$this->over_time->HrefValue = "";
			$this->over_time->TooltipValue = "";

			// dbkey_time_entry_code
			$this->dbkey_time_entry_code->LinkCustomAttributes = "";
			$this->dbkey_time_entry_code->HrefValue = "";
			$this->dbkey_time_entry_code->TooltipValue = "";

			// notes
			$this->notes->LinkCustomAttributes = "";
			$this->notes->HrefValue = "";
			$this->notes->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_EDIT) { // Edit row

			// dbkey_counselor
			$this->dbkey_counselor->EditAttrs["class"] = "form-control";
			$this->dbkey_counselor->EditCustomAttributes = "";
			if (!$Security->IsAdmin() && $Security->IsLoggedIn() && !$this->UserIDAllow("edit")) { // Non system admin
			$sFilterWrk = "";
			$sFilterWrk = $GLOBALS["counselor"]->AddUserIDFilter("");
			$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `counselor`";
			$sWhereWrk = "";
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_counselor, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect"), "", "", "", "", "", "", ""));
			$this->dbkey_counselor->EditValue = $arwrk;
			} else {
			if (trim(strval($this->dbkey_counselor->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_counselor->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `counselor`";
			$sWhereWrk = "";
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			if (!$GLOBALS["time_entry"]->UserIDAllow("edit")) $sWhereWrk = $GLOBALS["counselor"]->AddUserIDFilter($sWhereWrk);
			$this->Lookup_Selecting($this->dbkey_counselor, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect"), "", "", "", "", "", "", ""));
			$this->dbkey_counselor->EditValue = $arwrk;
			}

			// create_date
			$this->create_date->EditAttrs["class"] = "form-control";
			$this->create_date->EditCustomAttributes = "";
			$this->create_date->EditValue = ew_HtmlEncode(ew_FormatDateTime($this->create_date->CurrentValue, 5));
			$this->create_date->PlaceHolder = ew_RemoveHtml($this->create_date->FldCaption());

			// time_in
			$this->time_in->EditAttrs["class"] = "form-control";
			$this->time_in->EditCustomAttributes = "";
			if (trim(strval($this->time_in->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->time_in->CurrentValue, EW_DATATYPE_STRING, "");
			}
			$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `tables_data`";
			$sWhereWrk = "";
			$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->time_in, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `dbkey` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect"), "", "", "", "", "", "", ""));
			$this->time_in->EditValue = $arwrk;

			// time_out
			$this->time_out->EditAttrs["class"] = "form-control";
			$this->time_out->EditCustomAttributes = "";
			if (trim(strval($this->time_out->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->time_out->CurrentValue, EW_DATATYPE_STRING, "");
			}
			$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `tables_data`";
			$sWhereWrk = "";
			$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->time_out, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `dbkey` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect"), "", "", "", "", "", "", ""));
			$this->time_out->EditValue = $arwrk;

			// over_time
			$this->over_time->EditAttrs["class"] = "form-control";
			$this->over_time->EditCustomAttributes = "";
			$this->over_time->EditValue = $this->over_time->Options(TRUE);

			// dbkey_time_entry_code
			$this->dbkey_time_entry_code->EditAttrs["class"] = "form-control";
			$this->dbkey_time_entry_code->EditCustomAttributes = "";
			if (trim(strval($this->dbkey_time_entry_code->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_time_entry_code->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT DISTINCT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `time_entry_code`";
			$sWhereWrk = "";
			$lookuptblfilter = "`active` = 1";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_time_entry_code, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect"), "", "", "", "", "", "", ""));
			$this->dbkey_time_entry_code->EditValue = $arwrk;

			// notes
			$this->notes->EditAttrs["class"] = "form-control";
			$this->notes->EditCustomAttributes = "";
			$this->notes->EditValue = ew_HtmlEncode($this->notes->CurrentValue);
			$this->notes->PlaceHolder = ew_RemoveHtml($this->notes->FldCaption());

			// Edit refer script
			// dbkey_counselor

			$this->dbkey_counselor->HrefValue = "";

			// create_date
			$this->create_date->HrefValue = "";

			// time_in
			$this->time_in->HrefValue = "";

			// time_out
			$this->time_out->HrefValue = "";

			// over_time
			$this->over_time->HrefValue = "";

			// dbkey_time_entry_code
			$this->dbkey_time_entry_code->HrefValue = "";

			// notes
			$this->notes->HrefValue = "";
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate form
	function ValidateForm() {
		global $Language, $gsFormError;

		// Initialize form error message
		$gsFormError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return ($gsFormError == "");
		if (!$this->dbkey_counselor->FldIsDetailKey && !is_null($this->dbkey_counselor->FormValue) && $this->dbkey_counselor->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->dbkey_counselor->FldCaption(), $this->dbkey_counselor->ReqErrMsg));
		}
		if (!$this->create_date->FldIsDetailKey && !is_null($this->create_date->FormValue) && $this->create_date->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->create_date->FldCaption(), $this->create_date->ReqErrMsg));
		}
		if (!ew_CheckDate($this->create_date->FormValue)) {
			ew_AddMessage($gsFormError, $this->create_date->FldErrMsg());
		}
		if (!$this->time_in->FldIsDetailKey && !is_null($this->time_in->FormValue) && $this->time_in->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->time_in->FldCaption(), $this->time_in->ReqErrMsg));
		}
		if (!$this->time_out->FldIsDetailKey && !is_null($this->time_out->FormValue) && $this->time_out->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->time_out->FldCaption(), $this->time_out->ReqErrMsg));
		}
		if (!$this->over_time->FldIsDetailKey && !is_null($this->over_time->FormValue) && $this->over_time->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->over_time->FldCaption(), $this->over_time->ReqErrMsg));
		}

		// Return validate result
		$ValidateForm = ($gsFormError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateForm = $ValidateForm && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsFormError, $sFormCustomError);
		}
		return $ValidateForm;
	}

	// Update record based on key values
	function EditRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$conn = &$this->Connection();
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
		$rs = $conn->Execute($sSql);
		$conn->raiseErrorFn = '';
		if ($rs === FALSE)
			return FALSE;
		if ($rs->EOF) {
			$this->setFailureMessage($Language->Phrase("NoRecord")); // Set no record message
			$EditRow = FALSE; // Update Failed
		} else {

			// Save old values
			$rsold = &$rs->fields;
			$this->LoadDbValues($rsold);
			$rsnew = array();

			// dbkey_counselor
			$this->dbkey_counselor->SetDbValueDef($rsnew, $this->dbkey_counselor->CurrentValue, NULL, $this->dbkey_counselor->ReadOnly);

			// create_date
			$this->create_date->SetDbValueDef($rsnew, ew_UnFormatDateTime($this->create_date->CurrentValue, 5), NULL, $this->create_date->ReadOnly);

			// time_in
			$this->time_in->SetDbValueDef($rsnew, $this->time_in->CurrentValue, NULL, $this->time_in->ReadOnly);

			// time_out
			$this->time_out->SetDbValueDef($rsnew, $this->time_out->CurrentValue, NULL, $this->time_out->ReadOnly);

			// over_time
			$this->over_time->SetDbValueDef($rsnew, $this->over_time->CurrentValue, NULL, $this->over_time->ReadOnly);

			// dbkey_time_entry_code
			$this->dbkey_time_entry_code->SetDbValueDef($rsnew, $this->dbkey_time_entry_code->CurrentValue, NULL, $this->dbkey_time_entry_code->ReadOnly);

			// notes
			$this->notes->SetDbValueDef($rsnew, $this->notes->CurrentValue, NULL, $this->notes->ReadOnly);

			// Call Row Updating event
			$bUpdateRow = $this->Row_Updating($rsold, $rsnew);
			if ($bUpdateRow) {
				$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
				if (count($rsnew) > 0)
					$EditRow = $this->Update($rsnew, "", $rsold);
				else
					$EditRow = TRUE; // No field to update
				$conn->raiseErrorFn = '';
				if ($EditRow) {
				}
			} else {
				if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

					// Use the message, do nothing
				} elseif ($this->CancelMessage <> "") {
					$this->setFailureMessage($this->CancelMessage);
					$this->CancelMessage = "";
				} else {
					$this->setFailureMessage($Language->Phrase("UpdateCancelled"));
				}
				$EditRow = FALSE;
			}
		}

		// Call Row_Updated event
		if ($EditRow)
			$this->Row_Updated($rsold, $rsnew);
		$rs->Close();
		return $EditRow;
	}

	// Show link optionally based on User ID
	function ShowOptionLink($id = "") {
		global $Security;
		if ($Security->IsLoggedIn() && !$Security->IsAdmin() && !$this->UserIDAllow($id))
			return $Security->IsValidUserID($this->dbkey_counselor->CurrentValue);
		return TRUE;
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, "time_entrylist.php", "", $this->TableVar, TRUE);
		$PageId = "edit";
		$Breadcrumb->Add("edit", $PageId, $url);
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";
		// If over budget red.

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($time_entry_edit)) $time_entry_edit = new ctime_entry_edit();

// Page init
$time_entry_edit->Page_Init();

// Page main
$time_entry_edit->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$time_entry_edit->Page_Render();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "edit";
var CurrentForm = ftime_entryedit = new ew_Form("ftime_entryedit", "edit");

// Validate form
ftime_entryedit.Validate = function() {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	var $ = jQuery, fobj = this.GetForm(), $fobj = $(fobj);
	if ($fobj.find("#a_confirm").val() == "F")
		return true;
	var elm, felm, uelm, addcnt = 0;
	var $k = $fobj.find("#" + this.FormKeyCountName); // Get key_count
	var rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1;
	var startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
	var gridinsert = $fobj.find("#a_list").val() == "gridinsert";
	for (var i = startcnt; i <= rowcnt; i++) {
		var infix = ($k[0]) ? String(i) : "";
		$fobj.data("rowindex", infix);
			elm = this.GetElements("x" + infix + "_dbkey_counselor");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $time_entry->dbkey_counselor->FldCaption(), $time_entry->dbkey_counselor->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_create_date");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $time_entry->create_date->FldCaption(), $time_entry->create_date->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_create_date");
			if (elm && !ew_CheckDate(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($time_entry->create_date->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_time_in");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $time_entry->time_in->FldCaption(), $time_entry->time_in->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_time_out");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $time_entry->time_out->FldCaption(), $time_entry->time_out->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_over_time");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $time_entry->over_time->FldCaption(), $time_entry->over_time->ReqErrMsg)) ?>");

			// Fire Form_CustomValidate event
			if (!this.Form_CustomValidate(fobj))
				return false;
	}

	// Process detail forms
	var dfs = $fobj.find("input[name='detailpage']").get();
	for (var i = 0; i < dfs.length; i++) {
		var df = dfs[i], val = df.value;
		if (val && ewForms[val])
			if (!ewForms[val].Validate())
				return false;
	}
	return true;
}

// Form_CustomValidate event
ftime_entryedit.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
ftime_entryedit.ValidateRequired = true;
<?php } else { ?>
ftime_entryedit.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
ftime_entryedit.Lists["x_dbkey_counselor"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftime_entryedit.Lists["x_time_in"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftime_entryedit.Lists["x_time_out"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftime_entryedit.Lists["x_over_time"] = {"LinkField":"","Ajax":false,"AutoFill":false,"DisplayFields":["","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftime_entryedit.Lists["x_over_time"].Options = <?php echo json_encode($time_entry->over_time->Options()) ?>;
ftime_entryedit.Lists["x_dbkey_time_entry_code"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};

// Form object for search
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<div class="ewToolbar">
<?php $Breadcrumb->Render(); ?>
<?php echo $Language->SelectionForm(); ?>
<div class="clearfix"></div>
</div>
<?php $time_entry_edit->ShowPageHeader(); ?>
<?php
$time_entry_edit->ShowMessage();
?>
<form name="ftime_entryedit" id="ftime_entryedit" class="<?php echo $time_entry_edit->FormClassName ?>" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($time_entry_edit->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $time_entry_edit->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="time_entry">
<input type="hidden" name="a_edit" id="a_edit" value="U">
<div>
<?php if ($time_entry->dbkey_counselor->Visible) { // dbkey_counselor ?>
	<div id="r_dbkey_counselor" class="form-group">
		<label id="elh_time_entry_dbkey_counselor" for="x_dbkey_counselor" class="col-sm-2 control-label ewLabel"><?php echo $time_entry->dbkey_counselor->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $time_entry->dbkey_counselor->CellAttributes() ?>>
<?php if (!$Security->IsAdmin() && $Security->IsLoggedIn() && !$time_entry->UserIDAllow("edit")) { // Non system admin ?>
<span id="el_time_entry_dbkey_counselor">
<select data-table="time_entry" data-field="x_dbkey_counselor" data-value-separator="<?php echo ew_HtmlEncode(is_array($time_entry->dbkey_counselor->DisplayValueSeparator) ? json_encode($time_entry->dbkey_counselor->DisplayValueSeparator) : $time_entry->dbkey_counselor->DisplayValueSeparator) ?>" id="x_dbkey_counselor" name="x_dbkey_counselor"<?php echo $time_entry->dbkey_counselor->EditAttributes() ?>>
<?php
if (is_array($time_entry->dbkey_counselor->EditValue)) {
	$arwrk = $time_entry->dbkey_counselor->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = ew_SameStr($time_entry->dbkey_counselor->CurrentValue, $arwrk[$rowcntwrk][0]) ? " selected" : "";
		if ($selwrk <> "") $emptywrk = FALSE;		
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $time_entry->dbkey_counselor->DisplayValue($arwrk[$rowcntwrk]) ?>
</option>
<?php
	}
	if ($emptywrk && strval($time_entry->dbkey_counselor->CurrentValue) <> "") {
?>
<option value="<?php echo ew_HtmlEncode($time_entry->dbkey_counselor->CurrentValue) ?>" selected><?php echo $time_entry->dbkey_counselor->CurrentValue ?></option>
<?php
    }
}
?>
</select>
<?php
$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
$sWhereWrk = "";
if (!$GLOBALS["time_entry"]->UserIDAllow("edit")) $sWhereWrk = $GLOBALS["counselor"]->AddUserIDFilter($sWhereWrk);
$time_entry->dbkey_counselor->LookupFilters = array("s" => $sSqlWrk, "d" => "");
$time_entry->dbkey_counselor->LookupFilters += array("f0" => "`dbkey` = {filter_value}", "t0" => "3", "fn0" => "");
$sSqlWrk = "";
$time_entry->Lookup_Selecting($time_entry->dbkey_counselor, $sWhereWrk); // Call Lookup selecting
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
if ($sSqlWrk <> "") $time_entry->dbkey_counselor->LookupFilters["s"] .= $sSqlWrk;
?>
<input type="hidden" name="s_x_dbkey_counselor" id="s_x_dbkey_counselor" value="<?php echo $time_entry->dbkey_counselor->LookupFilterQuery() ?>">
</span>
<?php } else { ?>
<span id="el_time_entry_dbkey_counselor">
<select data-table="time_entry" data-field="x_dbkey_counselor" data-value-separator="<?php echo ew_HtmlEncode(is_array($time_entry->dbkey_counselor->DisplayValueSeparator) ? json_encode($time_entry->dbkey_counselor->DisplayValueSeparator) : $time_entry->dbkey_counselor->DisplayValueSeparator) ?>" id="x_dbkey_counselor" name="x_dbkey_counselor"<?php echo $time_entry->dbkey_counselor->EditAttributes() ?>>
<?php
if (is_array($time_entry->dbkey_counselor->EditValue)) {
	$arwrk = $time_entry->dbkey_counselor->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = ew_SameStr($time_entry->dbkey_counselor->CurrentValue, $arwrk[$rowcntwrk][0]) ? " selected" : "";
		if ($selwrk <> "") $emptywrk = FALSE;		
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $time_entry->dbkey_counselor->DisplayValue($arwrk[$rowcntwrk]) ?>
</option>
<?php
	}
	if ($emptywrk && strval($time_entry->dbkey_counselor->CurrentValue) <> "") {
?>
<option value="<?php echo ew_HtmlEncode($time_entry->dbkey_counselor->CurrentValue) ?>" selected><?php echo $time_entry->dbkey_counselor->CurrentValue ?></option>
<?php
    }
}
?>
</select>
<?php
$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
$sWhereWrk = "";
if (!$GLOBALS["time_entry"]->UserIDAllow("edit")) $sWhereWrk = $GLOBALS["counselor"]->AddUserIDFilter($sWhereWrk);
$time_entry->dbkey_counselor->LookupFilters = array("s" => $sSqlWrk, "d" => "");
$time_entry->dbkey_counselor->LookupFilters += array("f0" => "`dbkey` = {filter_value}", "t0" => "3", "fn0" => "");
$sSqlWrk = "";
$time_entry->Lookup_Selecting($time_entry->dbkey_counselor, $sWhereWrk); // Call Lookup selecting
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
if ($sSqlWrk <> "") $time_entry->dbkey_counselor->LookupFilters["s"] .= $sSqlWrk;
?>
<input type="hidden" name="s_x_dbkey_counselor" id="s_x_dbkey_counselor" value="<?php echo $time_entry->dbkey_counselor->LookupFilterQuery() ?>">
</span>
<?php } ?>
<?php echo $time_entry->dbkey_counselor->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($time_entry->create_date->Visible) { // create_date ?>
	<div id="r_create_date" class="form-group">
		<label id="elh_time_entry_create_date" for="x_create_date" class="col-sm-2 control-label ewLabel"><?php echo $time_entry->create_date->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $time_entry->create_date->CellAttributes() ?>>
<span id="el_time_entry_create_date">
<input type="text" data-table="time_entry" data-field="x_create_date" data-format="5" name="x_create_date" id="x_create_date" placeholder="<?php echo ew_HtmlEncode($time_entry->create_date->getPlaceHolder()) ?>" value="<?php echo $time_entry->create_date->EditValue ?>"<?php echo $time_entry->create_date->EditAttributes() ?>>
<?php if (!$time_entry->create_date->ReadOnly && !$time_entry->create_date->Disabled && !isset($time_entry->create_date->EditAttrs["readonly"]) && !isset($time_entry->create_date->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("ftime_entryedit", "x_create_date", "%Y/%m/%d");
</script>
<?php } ?>
</span>
<?php echo $time_entry->create_date->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($time_entry->time_in->Visible) { // time_in ?>
	<div id="r_time_in" class="form-group">
		<label id="elh_time_entry_time_in" for="x_time_in" class="col-sm-2 control-label ewLabel"><?php echo $time_entry->time_in->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $time_entry->time_in->CellAttributes() ?>>
<span id="el_time_entry_time_in">
<select data-table="time_entry" data-field="x_time_in" data-value-separator="<?php echo ew_HtmlEncode(is_array($time_entry->time_in->DisplayValueSeparator) ? json_encode($time_entry->time_in->DisplayValueSeparator) : $time_entry->time_in->DisplayValueSeparator) ?>" id="x_time_in" name="x_time_in"<?php echo $time_entry->time_in->EditAttributes() ?>>
<?php
if (is_array($time_entry->time_in->EditValue)) {
	$arwrk = $time_entry->time_in->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = ew_SameStr($time_entry->time_in->CurrentValue, $arwrk[$rowcntwrk][0]) ? " selected" : "";
		if ($selwrk <> "") $emptywrk = FALSE;		
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $time_entry->time_in->DisplayValue($arwrk[$rowcntwrk]) ?>
</option>
<?php
	}
	if ($emptywrk && strval($time_entry->time_in->CurrentValue) <> "") {
?>
<option value="<?php echo ew_HtmlEncode($time_entry->time_in->CurrentValue) ?>" selected><?php echo $time_entry->time_in->CurrentValue ?></option>
<?php
    }
}
?>
</select>
<?php
$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `tables_data`";
$sWhereWrk = "";
$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
ew_AddFilter($sWhereWrk, $lookuptblfilter);
$time_entry->time_in->LookupFilters = array("s" => $sSqlWrk, "d" => "");
$time_entry->time_in->LookupFilters += array("f0" => "`dbkey` = {filter_value}", "t0" => "200", "fn0" => "");
$sSqlWrk = "";
$time_entry->Lookup_Selecting($time_entry->time_in, $sWhereWrk); // Call Lookup selecting
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
$sSqlWrk .= " ORDER BY `dbkey` ASC";
if ($sSqlWrk <> "") $time_entry->time_in->LookupFilters["s"] .= $sSqlWrk;
?>
<input type="hidden" name="s_x_time_in" id="s_x_time_in" value="<?php echo $time_entry->time_in->LookupFilterQuery() ?>">
</span>
<?php echo $time_entry->time_in->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($time_entry->time_out->Visible) { // time_out ?>
	<div id="r_time_out" class="form-group">
		<label id="elh_time_entry_time_out" for="x_time_out" class="col-sm-2 control-label ewLabel"><?php echo $time_entry->time_out->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $time_entry->time_out->CellAttributes() ?>>
<span id="el_time_entry_time_out">
<select data-table="time_entry" data-field="x_time_out" data-value-separator="<?php echo ew_HtmlEncode(is_array($time_entry->time_out->DisplayValueSeparator) ? json_encode($time_entry->time_out->DisplayValueSeparator) : $time_entry->time_out->DisplayValueSeparator) ?>" id="x_time_out" name="x_time_out"<?php echo $time_entry->time_out->EditAttributes() ?>>
<?php
if (is_array($time_entry->time_out->EditValue)) {
	$arwrk = $time_entry->time_out->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = ew_SameStr($time_entry->time_out->CurrentValue, $arwrk[$rowcntwrk][0]) ? " selected" : "";
		if ($selwrk <> "") $emptywrk = FALSE;		
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $time_entry->time_out->DisplayValue($arwrk[$rowcntwrk]) ?>
</option>
<?php
	}
	if ($emptywrk && strval($time_entry->time_out->CurrentValue) <> "") {
?>
<option value="<?php echo ew_HtmlEncode($time_entry->time_out->CurrentValue) ?>" selected><?php echo $time_entry->time_out->CurrentValue ?></option>
<?php
    }
}
?>
</select>
<?php
$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `tables_data`";
$sWhereWrk = "";
$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
ew_AddFilter($sWhereWrk, $lookuptblfilter);
$time_entry->time_out->LookupFilters = array("s" => $sSqlWrk, "d" => "");
$time_entry->time_out->LookupFilters += array("f0" => "`dbkey` = {filter_value}", "t0" => "200", "fn0" => "");
$sSqlWrk = "";
$time_entry->Lookup_Selecting($time_entry->time_out, $sWhereWrk); // Call Lookup selecting
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
$sSqlWrk .= " ORDER BY `dbkey` ASC";
if ($sSqlWrk <> "") $time_entry->time_out->LookupFilters["s"] .= $sSqlWrk;
?>
<input type="hidden" name="s_x_time_out" id="s_x_time_out" value="<?php echo $time_entry->time_out->LookupFilterQuery() ?>">
</span>
<?php echo $time_entry->time_out->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($time_entry->over_time->Visible) { // over_time ?>
	<div id="r_over_time" class="form-group">
		<label id="elh_time_entry_over_time" for="x_over_time" class="col-sm-2 control-label ewLabel"><?php echo $time_entry->over_time->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $time_entry->over_time->CellAttributes() ?>>
<span id="el_time_entry_over_time">
<select data-table="time_entry" data-field="x_over_time" data-value-separator="<?php echo ew_HtmlEncode(is_array($time_entry->over_time->DisplayValueSeparator) ? json_encode($time_entry->over_time->DisplayValueSeparator) : $time_entry->over_time->DisplayValueSeparator) ?>" id="x_over_time" name="x_over_time"<?php echo $time_entry->over_time->EditAttributes() ?>>
<?php
if (is_array($time_entry->over_time->EditValue)) {
	$arwrk = $time_entry->over_time->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = ew_SameStr($time_entry->over_time->CurrentValue, $arwrk[$rowcntwrk][0]) ? " selected" : "";
		if ($selwrk <> "") $emptywrk = FALSE;		
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $time_entry->over_time->DisplayValue($arwrk[$rowcntwrk]) ?>
</option>
<?php
	}
	if ($emptywrk && strval($time_entry->over_time->CurrentValue) <> "") {
?>
<option value="<?php echo ew_HtmlEncode($time_entry->over_time->CurrentValue) ?>" selected><?php echo $time_entry->over_time->CurrentValue ?></option>
<?php
    }
}
?>
</select>
</span>
<?php echo $time_entry->over_time->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($time_entry->dbkey_time_entry_code->Visible) { // dbkey_time_entry_code ?>
	<div id="r_dbkey_time_entry_code" class="form-group">
		<label id="elh_time_entry_dbkey_time_entry_code" for="x_dbkey_time_entry_code" class="col-sm-2 control-label ewLabel"><?php echo $time_entry->dbkey_time_entry_code->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $time_entry->dbkey_time_entry_code->CellAttributes() ?>>
<span id="el_time_entry_dbkey_time_entry_code">
<select data-table="time_entry" data-field="x_dbkey_time_entry_code" data-value-separator="<?php echo ew_HtmlEncode(is_array($time_entry->dbkey_time_entry_code->DisplayValueSeparator) ? json_encode($time_entry->dbkey_time_entry_code->DisplayValueSeparator) : $time_entry->dbkey_time_entry_code->DisplayValueSeparator) ?>" id="x_dbkey_time_entry_code" name="x_dbkey_time_entry_code"<?php echo $time_entry->dbkey_time_entry_code->EditAttributes() ?>>
<?php
if (is_array($time_entry->dbkey_time_entry_code->EditValue)) {
	$arwrk = $time_entry->dbkey_time_entry_code->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = ew_SameStr($time_entry->dbkey_time_entry_code->CurrentValue, $arwrk[$rowcntwrk][0]) ? " selected" : "";
		if ($selwrk <> "") $emptywrk = FALSE;		
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $time_entry->dbkey_time_entry_code->DisplayValue($arwrk[$rowcntwrk]) ?>
</option>
<?php
	}
	if ($emptywrk && strval($time_entry->dbkey_time_entry_code->CurrentValue) <> "") {
?>
<option value="<?php echo ew_HtmlEncode($time_entry->dbkey_time_entry_code->CurrentValue) ?>" selected><?php echo $time_entry->dbkey_time_entry_code->CurrentValue ?></option>
<?php
    }
}
?>
</select>
<?php
$sSqlWrk = "SELECT DISTINCT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `time_entry_code`";
$sWhereWrk = "";
$lookuptblfilter = "`active` = 1";
ew_AddFilter($sWhereWrk, $lookuptblfilter);
$time_entry->dbkey_time_entry_code->LookupFilters = array("s" => $sSqlWrk, "d" => "");
$time_entry->dbkey_time_entry_code->LookupFilters += array("f0" => "`dbkey` = {filter_value}", "t0" => "3", "fn0" => "");
$sSqlWrk = "";
$time_entry->Lookup_Selecting($time_entry->dbkey_time_entry_code, $sWhereWrk); // Call Lookup selecting
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
if ($sSqlWrk <> "") $time_entry->dbkey_time_entry_code->LookupFilters["s"] .= $sSqlWrk;
?>
<input type="hidden" name="s_x_dbkey_time_entry_code" id="s_x_dbkey_time_entry_code" value="<?php echo $time_entry->dbkey_time_entry_code->LookupFilterQuery() ?>">
</span>
<?php echo $time_entry->dbkey_time_entry_code->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($time_entry->notes->Visible) { // notes ?>
	<div id="r_notes" class="form-group">
		<label id="elh_time_entry_notes" class="col-sm-2 control-label ewLabel"><?php echo $time_entry->notes->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $time_entry->notes->CellAttributes() ?>>
<span id="el_time_entry_notes">
<?php ew_AppendClass($time_entry->notes->EditAttrs["class"], "editor"); ?>
<textarea data-table="time_entry" data-field="x_notes" name="x_notes" id="x_notes" cols="35" rows="4" placeholder="<?php echo ew_HtmlEncode($time_entry->notes->getPlaceHolder()) ?>"<?php echo $time_entry->notes->EditAttributes() ?>><?php echo $time_entry->notes->EditValue ?></textarea>
<script type="text/javascript">
ew_CreateEditor("ftime_entryedit", "x_notes", 35, 4, <?php echo ($time_entry->notes->ReadOnly || FALSE) ? "true" : "false" ?>);
</script>
</span>
<?php echo $time_entry->notes->CustomMsg ?></div></div>
	</div>
<?php } ?>
</div>
<input type="hidden" data-table="time_entry" data-field="x_dbkey" name="x_dbkey" id="x_dbkey" value="<?php echo ew_HtmlEncode($time_entry->dbkey->CurrentValue) ?>">
<div class="form-group">
	<div class="col-sm-offset-2 col-sm-10">
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit"><?php echo $Language->Phrase("SaveBtn") ?></button>
<button class="btn btn-default ewButton" name="btnCancel" id="btnCancel" type="button" data-href="<?php echo $time_entry_edit->getReturnUrl() ?>"><?php echo $Language->Phrase("CancelBtn") ?></button>
	</div>
</div>
</form>
<script type="text/javascript">
ftime_entryedit.Init();
</script>
<?php
$time_entry_edit->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$time_entry_edit->Page_Terminate();
?>
