<?php

// Global variable for table object
$Cust_Client_Activity2 = NULL;

//
// Table class for Cust_Client_Activity2
//
class cCust_Client_Activity2 extends cTable {
	var $dbkey;
	var $dbkey_councilor;
	var $dbkey_client;
	var $date;
	var $time;
	var $comment;
	var $dbkey_activity;
	var $attachment;
	var $counselor;
	var $budget;
	var $allocated;
	var $remain;
	var $total_allocated;
	var $total_remain;

	//
	// Table class constructor
	//
	function __construct() {
		global $Language;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();
		$this->TableVar = 'Cust_Client_Activity2';
		$this->TableName = 'Cust_Client_Activity2';
		$this->TableType = 'CUSTOMVIEW';

		// Update Table
		$this->UpdateTable = "client_activity";
		$this->DBID = 'DB';
		$this->ExportAll = TRUE;
		$this->ExportPageBreakCount = 0; // Page break per every n record (PDF only)
		$this->ExportPageOrientation = "portrait"; // Page orientation (PDF only)
		$this->ExportPageSize = "a4"; // Page size (PDF only)
		$this->ExportExcelPageOrientation = ""; // Page orientation (PHPExcel only)
		$this->ExportExcelPageSize = ""; // Page size (PHPExcel only)
		$this->DetailAdd = FALSE; // Allow detail add
		$this->DetailEdit = FALSE; // Allow detail edit
		$this->DetailView = FALSE; // Allow detail view
		$this->ShowMultipleDetails = FALSE; // Show multiple details
		$this->GridAddRowCount = 5;
		$this->AllowAddDeleteRow = ew_AllowAddDeleteRow(); // Allow add/delete row
		$this->UserIDAllowSecurity = 0; // User ID Allow
		$this->BasicSearch = new cBasicSearch($this->TableVar);

		// dbkey
		$this->dbkey = new cField('Cust_Client_Activity2', 'Cust_Client_Activity2', 'x_dbkey', 'dbkey', '`dbkey`', '`dbkey`', 3, -1, FALSE, '`dbkey`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'NO');
		$this->dbkey->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey'] = &$this->dbkey;

		// dbkey_councilor
		$this->dbkey_councilor = new cField('Cust_Client_Activity2', 'Cust_Client_Activity2', 'x_dbkey_councilor', 'dbkey_councilor', '`dbkey_councilor`', '`dbkey_councilor`', 3, -1, FALSE, '`EV__dbkey_councilor`', TRUE, TRUE, TRUE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_councilor->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_councilor'] = &$this->dbkey_councilor;

		// dbkey_client
		$this->dbkey_client = new cField('Cust_Client_Activity2', 'Cust_Client_Activity2', 'x_dbkey_client', 'dbkey_client', '`dbkey_client`', '`dbkey_client`', 3, -1, FALSE, '`EV__dbkey_client`', TRUE, TRUE, TRUE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_client->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_client'] = &$this->dbkey_client;

		// date
		$this->date = new cField('Cust_Client_Activity2', 'Cust_Client_Activity2', 'x_date', 'date', '`date`', 'DATE_FORMAT(`date`, \'%Y/%m/%d\')', 135, 9, FALSE, '`date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->date->FldDefaultErrMsg = str_replace("%s", "/", $Language->Phrase("IncorrectDateYMD"));
		$this->fields['date'] = &$this->date;

		// time
		$this->time = new cField('Cust_Client_Activity2', 'Cust_Client_Activity2', 'x_time', 'time', '`time`', '`time`', 131, -1, FALSE, '`time`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->time->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['time'] = &$this->time;

		// comment
		$this->comment = new cField('Cust_Client_Activity2', 'Cust_Client_Activity2', 'x_comment', 'comment', '`comment`', '`comment`', 201, -1, FALSE, '`comment`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXTAREA');
		$this->fields['comment'] = &$this->comment;

		// dbkey_activity
		$this->dbkey_activity = new cField('Cust_Client_Activity2', 'Cust_Client_Activity2', 'x_dbkey_activity', 'dbkey_activity', '`dbkey_activity`', '`dbkey_activity`', 3, -1, FALSE, '`EV__dbkey_activity`', TRUE, TRUE, TRUE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_activity->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_activity'] = &$this->dbkey_activity;

		// attachment
		$this->attachment = new cField('Cust_Client_Activity2', 'Cust_Client_Activity2', 'x_attachment', 'attachment', '`attachment`', '`attachment`', 201, -1, TRUE, '`attachment`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'FILE');
		$this->attachment->UploadMultiple = TRUE;
		$this->attachment->Upload->UploadMultiple = TRUE;
		$this->fields['attachment'] = &$this->attachment;

		// counselor
		$this->counselor = new cField('Cust_Client_Activity2', 'Cust_Client_Activity2', 'x_counselor', 'counselor', '(SELECT Concat(Concat(counselor.first, \' , \'), counselor.last) FROM counselor WHERE counselor.dbkey = client_activity.dbkey_councilor)', '(SELECT Concat(Concat(counselor.first, \' , \'), counselor.last) FROM counselor WHERE counselor.dbkey = client_activity.dbkey_councilor)', 200, -1, FALSE, '(SELECT Concat(Concat(counselor.first, \' , \'), counselor.last) FROM counselor WHERE counselor.dbkey = client_activity.dbkey_councilor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->counselor->FldIsCustom = TRUE; // Custom field
		$this->fields['counselor'] = &$this->counselor;

		// budget
		$this->budget = new cField('Cust_Client_Activity2', 'Cust_Client_Activity2', 'x_budget', 'budget', '(SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )', '(SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )', 131, -1, FALSE, '(SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->budget->FldIsCustom = TRUE; // Custom field
		$this->budget->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['budget'] = &$this->budget;

		// allocated
		$this->allocated = new cField('Cust_Client_Activity2', 'Cust_Client_Activity2', 'x_allocated', 'allocated', '(SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client AND client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) and b.date <= client_activity.date )', '(SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client AND client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) and b.date <= client_activity.date )', 131, -1, FALSE, '(SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client AND client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) and b.date <= client_activity.date )', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->allocated->FldIsCustom = TRUE; // Custom field
		$this->allocated->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['allocated'] = &$this->allocated;

		// remain
		$this->remain = new cField('Cust_Client_Activity2', 'Cust_Client_Activity2', 'x_remain', 'remain', '((0 + (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )) - (0 + (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) and b.date <= client_activity.date )))', '((0 + (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )) - (0 + (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) and b.date <= client_activity.date )))', 131, -1, FALSE, '((0 + (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )) - (0 + (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) and b.date <= client_activity.date )))', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->remain->FldIsCustom = TRUE; // Custom field
		$this->remain->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['remain'] = &$this->remain;

		// total_allocated
		$this->total_allocated = new cField('Cust_Client_Activity2', 'Cust_Client_Activity2', 'x_total_allocated', 'total_allocated', '(SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) )', '(SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) )', 131, -1, FALSE, '(SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) )', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->total_allocated->FldIsCustom = TRUE; // Custom field
		$this->total_allocated->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['total_allocated'] = &$this->total_allocated;

		// total_remain
		$this->total_remain = new cField('Cust_Client_Activity2', 'Cust_Client_Activity2', 'x_total_remain', 'total_remain', '((0 + (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )) - (0 + (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) )))', '((0 + (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )) - (0 + (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) )))', 131, -1, FALSE, '((0 + (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )) - (0 + (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) )))', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->total_remain->FldIsCustom = TRUE; // Custom field
		$this->total_remain->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['total_remain'] = &$this->total_remain;
	}

	// Single column sort
	function UpdateSort(&$ofld) {
		if ($this->CurrentOrder == $ofld->FldName) {
			$sSortField = $ofld->FldExpression;
			$sLastSort = $ofld->getSort();
			if ($this->CurrentOrderType == "ASC" || $this->CurrentOrderType == "DESC") {
				$sThisSort = $this->CurrentOrderType;
			} else {
				$sThisSort = ($sLastSort == "ASC") ? "DESC" : "ASC";
			}
			$ofld->setSort($sThisSort);
			$this->setSessionOrderBy($sSortField . " " . $sThisSort); // Save to Session
			$sSortFieldList = ($ofld->FldVirtualExpression <> "") ? $ofld->FldVirtualExpression : $sSortField;
			$this->setSessionOrderByList($sSortFieldList . " " . $sThisSort); // Save to Session
		} else {
			$ofld->setSort("");
		}
	}

	// Session ORDER BY for List page
	function getSessionOrderByList() {
		return @$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_ORDER_BY_LIST];
	}

	function setSessionOrderByList($v) {
		$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_ORDER_BY_LIST] = $v;
	}

	// Table level SQL
	var $_SqlFrom = "";

	function getSqlFrom() { // From
		return ($this->_SqlFrom <> "") ? $this->_SqlFrom : "client_activity";
	}

	function SqlFrom() { // For backward compatibility
    	return $this->getSqlFrom();
	}

	function setSqlFrom($v) {
    	$this->_SqlFrom = $v;
	}
	var $_SqlSelect = "";

	function getSqlSelect() { // Select
		return ($this->_SqlSelect <> "") ? $this->_SqlSelect : "SELECT client_activity.dbkey, client_activity.dbkey_councilor, client_activity.dbkey_client, client_activity.date, client_activity.time, client_activity.comment, client_activity.dbkey_activity, client_activity.attachment, (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = client_activity.dbkey_councilor) AS counselor, (SELECT Sum(IfNull(client_budget.budget, 0)) FROM client_budget WHERE client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) ) AS budget,(SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) and b.date <= client_activity.date ) as allocated , ((0 + (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )) - (0 + (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) and b.date <= client_activity.date ))) as remain,(SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) ) as total_allocated , ((0 + (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )) - (0 + (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) ))) as total_remain, (SELECT Concat(Concat(counselor.first, ' , '), counselor.last) FROM counselor WHERE counselor.dbkey = client_activity.dbkey_councilor) AS `counselor`, (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) ) AS `budget`, (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client AND client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) and b.date <= client_activity.date ) AS `allocated`, ((0 + (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )) - (0 + (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) and b.date <= client_activity.date ))) AS `remain`, (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) ) AS `total_allocated`, ((0 + (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )) - (0 + (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) ))) AS `total_remain` FROM " . $this->getSqlFrom();
	}

	function SqlSelect() { // For backward compatibility
    	return $this->getSqlSelect();
	}

	function setSqlSelect($v) {
    	$this->_SqlSelect = $v;
	}
	var $_SqlSelectList = "";

	function getSqlSelectList() { // Select for List page
		$select = "";
		$select = "SELECT * FROM (" .
			"SELECT client_activity.dbkey, client_activity.dbkey_councilor, client_activity.dbkey_client, client_activity.date, client_activity.time, client_activity.comment, client_activity.dbkey_activity, client_activity.attachment, (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = client_activity.dbkey_councilor) AS counselor, (SELECT Sum(IfNull(client_budget.budget, 0)) FROM client_budget WHERE client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) ) AS budget,(SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) and b.date <= client_activity.date ) as allocated , ((0 + (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )) - (0 + (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) and b.date <= client_activity.date ))) as remain,(SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) ) as total_allocated , ((0 + (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )) - (0 + (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) ))) as total_remain, (SELECT Concat(Concat(counselor.first, ' , '), counselor.last) FROM counselor WHERE counselor.dbkey = client_activity.dbkey_councilor) AS `counselor`, (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) ) AS `budget`, (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client AND client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) and b.date <= client_activity.date ) AS `allocated`, ((0 + (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )) - (0 + (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) and b.date <= client_activity.date ))) AS `remain`, (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) ) AS `total_allocated`, ((0 + (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )) - (0 + (SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_activity.dbkey_client = client_budget.dbkey_client and client_activity.dbkey_client = b.dbkey_client AND date(b.date) >= date(client_budget.from) and date(b.date) <= date(client_budget.through) ))) AS `total_remain`, (SELECT CONCAT(`last`,'" . ew_ValueSeparator(1, $this->dbkey_councilor) . "',`first`) FROM `counselor` `EW_TMP_LOOKUPTABLE` WHERE `EW_TMP_LOOKUPTABLE`.`dbkey` = `dbkey_councilor` LIMIT 1) AS `EV__dbkey_councilor`, (SELECT DISTINCT CONCAT(`last`,'" . ew_ValueSeparator(1, $this->dbkey_client) . "',`first`) FROM `client` `EW_TMP_LOOKUPTABLE` WHERE `EW_TMP_LOOKUPTABLE`.`dbkey` = `dbkey_client` LIMIT 1) AS `EV__dbkey_client`, (SELECT DISTINCT `description` FROM `activity` `EW_TMP_LOOKUPTABLE` WHERE `EW_TMP_LOOKUPTABLE`.`dbkey` = `dbkey_activity` LIMIT 1) AS `EV__dbkey_activity` FROM client_activity" .
			") `EW_TMP_TABLE`";
		return ($this->_SqlSelectList <> "") ? $this->_SqlSelectList : $select;
	}

	function SqlSelectList() { // For backward compatibility
    	return $this->getSqlSelectList();
	}

	function setSqlSelectList($v) {
    	$this->_SqlSelectList = $v;
	}
	var $_SqlWhere = "";

	function getSqlWhere() { // Where
		$sWhere = ($this->_SqlWhere <> "") ? $this->_SqlWhere : "";
		$this->TableFilter = "";
		ew_AddFilter($sWhere, $this->TableFilter);
		return $sWhere;
	}

	function SqlWhere() { // For backward compatibility
    	return $this->getSqlWhere();
	}

	function setSqlWhere($v) {
    	$this->_SqlWhere = $v;
	}
	var $_SqlGroupBy = "";

	function getSqlGroupBy() { // Group By
		return ($this->_SqlGroupBy <> "") ? $this->_SqlGroupBy : "";
	}

	function SqlGroupBy() { // For backward compatibility
    	return $this->getSqlGroupBy();
	}

	function setSqlGroupBy($v) {
    	$this->_SqlGroupBy = $v;
	}
	var $_SqlHaving = "";

	function getSqlHaving() { // Having
		return ($this->_SqlHaving <> "") ? $this->_SqlHaving : "";
	}

	function SqlHaving() { // For backward compatibility
    	return $this->getSqlHaving();
	}

	function setSqlHaving($v) {
    	$this->_SqlHaving = $v;
	}
	var $_SqlOrderBy = "";

	function getSqlOrderBy() { // Order By
		return ($this->_SqlOrderBy <> "") ? $this->_SqlOrderBy : "client_activity.dbkey_client, client_activity.date DESC";
	}

	function SqlOrderBy() { // For backward compatibility
    	return $this->getSqlOrderBy();
	}

	function setSqlOrderBy($v) {
    	$this->_SqlOrderBy = $v;
	}

	// Apply User ID filters
	function ApplyUserIDFilters($sFilter) {
		return $sFilter;
	}

	// Check if User ID security allows view all
	function UserIDAllow($id = "") {
		$allow = EW_USER_ID_ALLOW;
		switch ($id) {
			case "add":
			case "copy":
			case "gridadd":
			case "register":
			case "addopt":
				return (($allow & 1) == 1);
			case "edit":
			case "gridedit":
			case "update":
			case "changepwd":
			case "forgotpwd":
				return (($allow & 4) == 4);
			case "delete":
				return (($allow & 2) == 2);
			case "view":
				return (($allow & 32) == 32);
			case "search":
				return (($allow & 64) == 64);
			default:
				return (($allow & 8) == 8);
		}
	}

	// Get SQL
	function GetSQL($where, $orderby) {
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$where, $orderby);
	}

	// Table SQL
	function SQL() {
		$sFilter = $this->CurrentFilter;
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$sFilter, $sSort);
	}

	// Table SQL with List page filter
	function SelectSQL() {
		$sFilter = $this->getSessionWhere();
		ew_AddFilter($sFilter, $this->CurrentFilter);
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$this->Recordset_Selecting($sFilter);
		if ($this->UseVirtualFields()) {
			$sSort = $this->getSessionOrderByList();
			return ew_BuildSelectSql($this->getSqlSelectList(), $this->getSqlWhere(), $this->getSqlGroupBy(),
				$this->getSqlHaving(), $this->getSqlOrderBy(), $sFilter, $sSort);
		} else {
			$sSort = $this->getSessionOrderBy();
			return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(), $this->getSqlGroupBy(),
				$this->getSqlHaving(), $this->getSqlOrderBy(), $sFilter, $sSort);
		}
	}

	// Get ORDER BY clause
	function GetOrderBy() {
		$sSort = ($this->UseVirtualFields()) ? $this->getSessionOrderByList() : $this->getSessionOrderBy();
		return ew_BuildSelectSql("", "", "", "", $this->getSqlOrderBy(), "", $sSort);
	}

	// Check if virtual fields is used in SQL
	function UseVirtualFields() {
		$sWhere = $this->getSessionWhere();
		$sOrderBy = $this->getSessionOrderByList();
		if ($sWhere <> "")
			$sWhere = " " . str_replace(array("(",")"), array("",""), $sWhere) . " ";
		if ($sOrderBy <> "")
			$sOrderBy = " " . str_replace(array("(",")"), array("",""), $sOrderBy) . " ";
		if ($this->dbkey_councilor->AdvancedSearch->SearchValue <> "" ||
			$this->dbkey_councilor->AdvancedSearch->SearchValue2 <> "" ||
			strpos($sWhere, " " . $this->dbkey_councilor->FldVirtualExpression . " ") !== FALSE)
			return TRUE;
		if (strpos($sOrderBy, " " . $this->dbkey_councilor->FldVirtualExpression . " ") !== FALSE)
			return TRUE;
		if ($this->dbkey_client->AdvancedSearch->SearchValue <> "" ||
			$this->dbkey_client->AdvancedSearch->SearchValue2 <> "" ||
			strpos($sWhere, " " . $this->dbkey_client->FldVirtualExpression . " ") !== FALSE)
			return TRUE;
		if (strpos($sOrderBy, " " . $this->dbkey_client->FldVirtualExpression . " ") !== FALSE)
			return TRUE;
		if ($this->dbkey_activity->AdvancedSearch->SearchValue <> "" ||
			$this->dbkey_activity->AdvancedSearch->SearchValue2 <> "" ||
			strpos($sWhere, " " . $this->dbkey_activity->FldVirtualExpression . " ") !== FALSE)
			return TRUE;
		if (strpos($sOrderBy, " " . $this->dbkey_activity->FldVirtualExpression . " ") !== FALSE)
			return TRUE;
		return FALSE;
	}

	// Try to get record count
	function TryGetRecordCount($sSql) {
		$cnt = -1;
		if (($this->TableType == 'TABLE' || $this->TableType == 'VIEW' || $this->TableType == 'LINKTABLE') && preg_match("/^SELECT \* FROM/i", $sSql)) {
			$sSql = "SELECT COUNT(*) FROM" . preg_replace('/^SELECT\s([\s\S]+)?\*\sFROM/i', "", $sSql);
			$sOrderBy = $this->GetOrderBy();
			if (substr($sSql, strlen($sOrderBy) * -1) == $sOrderBy)
				$sSql = substr($sSql, 0, strlen($sSql) - strlen($sOrderBy)); // Remove ORDER BY clause
		} else {
			$sSql = "SELECT COUNT(*) FROM (" . $sSql . ") EW_COUNT_TABLE";
		}
		$conn = &$this->Connection();
		if ($rs = $conn->Execute($sSql)) {
			if (!$rs->EOF && $rs->FieldCount() > 0) {
				$cnt = $rs->fields[0];
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// Get record count based on filter (for detail record count in master table pages)
	function LoadRecordCount($sFilter) {
		$origFilter = $this->CurrentFilter;
		$this->CurrentFilter = $sFilter;
		$this->Recordset_Selecting($this->CurrentFilter);

		//$sSql = $this->SQL();
		$sSql = $this->GetSQL($this->CurrentFilter, "");
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			if ($rs = $this->LoadRs($this->CurrentFilter)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		$this->CurrentFilter = $origFilter;
		return intval($cnt);
	}

	// Get record count (for current List page)
	function SelectRecordCount() {
		$sSql = $this->SelectSQL();
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			$conn = &$this->Connection();
			if ($rs = $conn->Execute($sSql)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// INSERT statement
	function InsertSQL(&$rs) {
		$names = "";
		$values = "";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$names .= $this->fields[$name]->FldExpression . ",";
			$values .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($names, -1) == ",")
			$names = substr($names, 0, -1);
		while (substr($values, -1) == ",")
			$values = substr($values, 0, -1);
		return "INSERT INTO " . $this->UpdateTable . " ($names) VALUES ($values)";
	}

	// Insert
	function Insert(&$rs) {
		$conn = &$this->Connection();
		return $conn->Execute($this->InsertSQL($rs));
	}

	// UPDATE statement
	function UpdateSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "UPDATE " . $this->UpdateTable . " SET ";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$sql .= $this->fields[$name]->FldExpression . "=";
			$sql .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($sql, -1) == ",")
			$sql = substr($sql, 0, -1);
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		ew_AddFilter($filter, $where);
		if ($filter <> "")	$sql .= " WHERE " . $filter;
		return $sql;
	}

	// Update
	function Update(&$rs, $where = "", $rsold = NULL, $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->UpdateSQL($rs, $where, $curfilter));
	}

	// DELETE statement
	function DeleteSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "DELETE FROM " . $this->UpdateTable . " WHERE ";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		if ($rs) {
		}
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		ew_AddFilter($filter, $where);
		if ($filter <> "")
			$sql .= $filter;
		else
			$sql .= "0=1"; // Avoid delete
		return $sql;
	}

	// Delete
	function Delete(&$rs, $where = "", $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->DeleteSQL($rs, $where, $curfilter));
	}

	// Key filter WHERE clause
	function SqlKeyFilter() {
		return "";
	}

	// Key filter
	function KeyFilter() {
		$sKeyFilter = $this->SqlKeyFilter();
		return $sKeyFilter;
	}

	// Return page URL
	function getReturnUrl() {
		$name = EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL;

		// Get referer URL automatically
		if (ew_ServerVar("HTTP_REFERER") <> "" && ew_ReferPage() <> ew_CurrentPage() && ew_ReferPage() <> "login.php") // Referer not same page or login page
			$_SESSION[$name] = ew_ServerVar("HTTP_REFERER"); // Save to Session
		if (@$_SESSION[$name] <> "") {
			return $_SESSION[$name];
		} else {
			return "Cust_Client_Activity2list.php";
		}
	}

	function setReturnUrl($v) {
		$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL] = $v;
	}

	// List URL
	function GetListUrl() {
		return "Cust_Client_Activity2list.php";
	}

	// View URL
	function GetViewUrl($parm = "") {
		if ($parm <> "")
			$url = $this->KeyUrl("Cust_Client_Activity2view.php", $this->UrlParm($parm));
		else
			$url = $this->KeyUrl("Cust_Client_Activity2view.php", $this->UrlParm(EW_TABLE_SHOW_DETAIL . "="));
		return $this->AddMasterUrl($url);
	}

	// Add URL
	function GetAddUrl($parm = "") {
		if ($parm <> "")
			$url = "Cust_Client_Activity2add.php?" . $this->UrlParm($parm);
		else
			$url = "Cust_Client_Activity2add.php";
		return $this->AddMasterUrl($url);
	}

	// Edit URL
	function GetEditUrl($parm = "") {
		$url = $this->KeyUrl("Cust_Client_Activity2edit.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline edit URL
	function GetInlineEditUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=edit"));
		return $this->AddMasterUrl($url);
	}

	// Copy URL
	function GetCopyUrl($parm = "") {
		$url = $this->KeyUrl("Cust_Client_Activity2add.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline copy URL
	function GetInlineCopyUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=copy"));
		return $this->AddMasterUrl($url);
	}

	// Delete URL
	function GetDeleteUrl() {
		return $this->KeyUrl("Cust_Client_Activity2delete.php", $this->UrlParm());
	}

	// Add master url
	function AddMasterUrl($url) {
		return $url;
	}

	function KeyToJson() {
		$json = "";
		return "{" . $json . "}";
	}

	// Add key value to URL
	function KeyUrl($url, $parm = "") {
		$sUrl = $url . "?";
		if ($parm <> "") $sUrl .= $parm . "&";
		return $sUrl;
	}

	// Sort URL
	function SortUrl(&$fld) {
		if ($this->CurrentAction <> "" || $this->Export <> "" ||
			in_array($fld->FldType, array(128, 204, 205))) { // Unsortable data type
				return "";
		} elseif ($fld->Sortable) {
			$sUrlParm = $this->UrlParm("order=" . urlencode($fld->FldName) . "&amp;ordertype=" . $fld->ReverseSort());
			return ew_CurrentPage() . "?" . $sUrlParm;
		} else {
			return "";
		}
	}

	// Get record keys from $_POST/$_GET/$_SESSION
	function GetRecordKeys() {
		global $EW_COMPOSITE_KEY_SEPARATOR;
		$arKeys = array();
		$arKey = array();
		if (isset($_POST["key_m"])) {
			$arKeys = ew_StripSlashes($_POST["key_m"]);
			$cnt = count($arKeys);
		} elseif (isset($_GET["key_m"])) {
			$arKeys = ew_StripSlashes($_GET["key_m"]);
			$cnt = count($arKeys);
		} elseif (!empty($_GET) || !empty($_POST)) {
			$isPost = ew_IsHttpPost();

			//return $arKeys; // Do not return yet, so the values will also be checked by the following code
		}

		// Check keys
		$ar = array();
		if (is_array($arKeys)) {
			foreach ($arKeys as $key) {
				$ar[] = $key;
			}
		}
		return $ar;
	}

	// Get key filter
	function GetKeyFilter() {
		$arKeys = $this->GetRecordKeys();
		$sKeyFilter = "";
		foreach ($arKeys as $key) {
			if ($sKeyFilter <> "") $sKeyFilter .= " OR ";
			$sKeyFilter .= "(" . $this->KeyFilter() . ")";
		}
		return $sKeyFilter;
	}

	// Load rows based on filter
	function &LoadRs($sFilter) {

		// Set up filter (SQL WHERE clause) and get return SQL
		//$this->CurrentFilter = $sFilter;
		//$sSql = $this->SQL();

		$sSql = $this->GetSQL($sFilter, "");
		$conn = &$this->Connection();
		$rs = $conn->Execute($sSql);
		return $rs;
	}

	// Load row values from recordset
	function LoadListRowValues(&$rs) {
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->dbkey_councilor->setDbValue($rs->fields('dbkey_councilor'));
		$this->dbkey_client->setDbValue($rs->fields('dbkey_client'));
		$this->date->setDbValue($rs->fields('date'));
		$this->time->setDbValue($rs->fields('time'));
		$this->comment->setDbValue($rs->fields('comment'));
		$this->dbkey_activity->setDbValue($rs->fields('dbkey_activity'));
		$this->attachment->Upload->DbValue = $rs->fields('attachment');
		$this->counselor->setDbValue($rs->fields('counselor'));
		$this->budget->setDbValue($rs->fields('budget'));
		$this->allocated->setDbValue($rs->fields('allocated'));
		$this->remain->setDbValue($rs->fields('remain'));
		$this->total_allocated->setDbValue($rs->fields('total_allocated'));
		$this->total_remain->setDbValue($rs->fields('total_remain'));
	}

	// Render list row values
	function RenderListRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

   // Common render codes
		// dbkey

		$this->dbkey->CellCssStyle = "white-space: nowrap;";

		// dbkey_councilor
		$this->dbkey_councilor->CellCssStyle = "white-space: nowrap;";

		// dbkey_client
		$this->dbkey_client->CellCssStyle = "white-space: nowrap;";

		// date
		// time
		// comment
		// dbkey_activity
		// attachment

		$this->attachment->CellCssStyle = "white-space: nowrap;";

		// counselor
		$this->counselor->CellCssStyle = "white-space: nowrap;";

		// budget
		// allocated
		// remain
		// total_allocated
		// total_remain
		// dbkey

		$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// dbkey_councilor
		if ($this->dbkey_councilor->VirtualValue <> "") {
			$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->VirtualValue;
		} else {
		if (strval($this->dbkey_councilor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_councilor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->CurrentValue;
			}
		} else {
			$this->dbkey_councilor->ViewValue = NULL;
		}
		}
		$this->dbkey_councilor->ViewCustomAttributes = "";

		// dbkey_client
		if ($this->dbkey_client->VirtualValue <> "") {
			$this->dbkey_client->ViewValue = $this->dbkey_client->VirtualValue;
		} else {
		if (strval($this->dbkey_client->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		$lookuptblfilter = "`active` = 1";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_client->ViewValue = $this->dbkey_client->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_client->ViewValue = $this->dbkey_client->CurrentValue;
			}
		} else {
			$this->dbkey_client->ViewValue = NULL;
		}
		}
		$this->dbkey_client->ViewCustomAttributes = "";

		// date
		$this->date->ViewValue = $this->date->CurrentValue;
		$this->date->ViewValue = ew_FormatDateTime($this->date->ViewValue, 9);
		$this->date->ViewCustomAttributes = "";

		// time
		$this->time->ViewValue = $this->time->CurrentValue;
		$this->time->ViewCustomAttributes = "";

		// comment
		$this->comment->ViewValue = $this->comment->CurrentValue;
		$this->comment->ViewCustomAttributes = "";

		// dbkey_activity
		if ($this->dbkey_activity->VirtualValue <> "") {
			$this->dbkey_activity->ViewValue = $this->dbkey_activity->VirtualValue;
		} else {
		if (strval($this->dbkey_activity->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_activity->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `activity`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `description`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->CurrentValue;
			}
		} else {
			$this->dbkey_activity->ViewValue = NULL;
		}
		}
		$this->dbkey_activity->ViewCustomAttributes = "";

		// attachment
		if (!ew_Empty($this->attachment->Upload->DbValue)) {
			$this->attachment->ViewValue = $this->attachment->Upload->DbValue;
		} else {
			$this->attachment->ViewValue = "";
		}
		$this->attachment->ViewCustomAttributes = "";

		// counselor
		$this->counselor->ViewValue = $this->counselor->CurrentValue;
		$this->counselor->ViewCustomAttributes = "";

		// budget
		$this->budget->ViewValue = $this->budget->CurrentValue;
		$this->budget->ViewCustomAttributes = "";

		// allocated
		$this->allocated->ViewValue = $this->allocated->CurrentValue;
		$this->allocated->ViewCustomAttributes = "";

		// remain
		$this->remain->ViewValue = $this->remain->CurrentValue;
		$this->remain->CellCssStyle .= "text-align: left;";
		$this->remain->ViewCustomAttributes = "";

		// total_allocated
		$this->total_allocated->ViewValue = $this->total_allocated->CurrentValue;
		$this->total_allocated->ViewCustomAttributes = "";

		// total_remain
		$this->total_remain->ViewValue = $this->total_remain->CurrentValue;
		$this->total_remain->ViewCustomAttributes = "";

		// dbkey
		$this->dbkey->LinkCustomAttributes = "";
		$this->dbkey->HrefValue = "";
		$this->dbkey->TooltipValue = "";

		// dbkey_councilor
		$this->dbkey_councilor->LinkCustomAttributes = "";
		$this->dbkey_councilor->HrefValue = "";
		$this->dbkey_councilor->TooltipValue = "";

		// dbkey_client
		$this->dbkey_client->LinkCustomAttributes = "";
		$this->dbkey_client->HrefValue = "";
		$this->dbkey_client->TooltipValue = "";

		// date
		$this->date->LinkCustomAttributes = "";
		$this->date->HrefValue = "";
		$this->date->TooltipValue = "";

		// time
		$this->time->LinkCustomAttributes = "";
		$this->time->HrefValue = "";
		$this->time->TooltipValue = "";

		// comment
		$this->comment->LinkCustomAttributes = "";
		$this->comment->HrefValue = "";
		$this->comment->TooltipValue = "";

		// dbkey_activity
		$this->dbkey_activity->LinkCustomAttributes = "";
		$this->dbkey_activity->HrefValue = "";
		$this->dbkey_activity->TooltipValue = "";

		// attachment
		$this->attachment->LinkCustomAttributes = "";
		$this->attachment->HrefValue = "";
		$this->attachment->HrefValue2 = $this->attachment->UploadPath . $this->attachment->Upload->DbValue;
		$this->attachment->TooltipValue = "";

		// counselor
		$this->counselor->LinkCustomAttributes = "";
		$this->counselor->HrefValue = "";
		$this->counselor->TooltipValue = "";

		// budget
		$this->budget->LinkCustomAttributes = "";
		$this->budget->HrefValue = "";
		$this->budget->TooltipValue = "";

		// allocated
		$this->allocated->LinkCustomAttributes = "";
		$this->allocated->HrefValue = "";
		$this->allocated->TooltipValue = "";

		// remain
		$this->remain->LinkCustomAttributes = "";
		$this->remain->HrefValue = "";
		$this->remain->TooltipValue = "";

		// total_allocated
		$this->total_allocated->LinkCustomAttributes = "";
		$this->total_allocated->HrefValue = "";
		$this->total_allocated->TooltipValue = "";

		// total_remain
		$this->total_remain->LinkCustomAttributes = "";
		$this->total_remain->HrefValue = "";
		$this->total_remain->TooltipValue = "";

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Render edit row values
	function RenderEditRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

		// dbkey
		$this->dbkey->EditAttrs["class"] = "form-control";
		$this->dbkey->EditCustomAttributes = "";
		$this->dbkey->EditValue = $this->dbkey->CurrentValue;
		$this->dbkey->PlaceHolder = ew_RemoveHtml($this->dbkey->FldCaption());

		// dbkey_councilor
		$this->dbkey_councilor->EditAttrs["class"] = "form-control";
		$this->dbkey_councilor->EditCustomAttributes = "";
		if ($this->dbkey_councilor->VirtualValue <> "") {
			$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->VirtualValue;
		} else {
		if (strval($this->dbkey_councilor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_councilor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_councilor->EditValue = $this->dbkey_councilor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_councilor->EditValue = $this->dbkey_councilor->CurrentValue;
			}
		} else {
			$this->dbkey_councilor->EditValue = NULL;
		}
		}
		$this->dbkey_councilor->ViewCustomAttributes = "";

		// dbkey_client
		$this->dbkey_client->EditAttrs["class"] = "form-control";
		$this->dbkey_client->EditCustomAttributes = "";

		// date
		$this->date->EditAttrs["class"] = "form-control";
		$this->date->EditCustomAttributes = "";
		$this->date->EditValue = ew_FormatDateTime($this->date->CurrentValue, 9);
		$this->date->PlaceHolder = ew_RemoveHtml($this->date->FldCaption());

		// time
		$this->time->EditAttrs["class"] = "form-control";
		$this->time->EditCustomAttributes = "";
		$this->time->EditValue = $this->time->CurrentValue;
		$this->time->PlaceHolder = ew_RemoveHtml($this->time->FldCaption());
		if (strval($this->time->EditValue) <> "" && is_numeric($this->time->EditValue)) $this->time->EditValue = ew_FormatNumber($this->time->EditValue, -2, -1, -2, 0);

		// comment
		$this->comment->EditAttrs["class"] = "form-control";
		$this->comment->EditCustomAttributes = "";
		$this->comment->EditValue = $this->comment->CurrentValue;
		$this->comment->PlaceHolder = ew_RemoveHtml($this->comment->FldCaption());

		// dbkey_activity
		$this->dbkey_activity->EditAttrs["class"] = "form-control";
		$this->dbkey_activity->EditCustomAttributes = "";

		// attachment
		$this->attachment->EditAttrs["class"] = "form-control";
		$this->attachment->EditCustomAttributes = "";
		if (!ew_Empty($this->attachment->Upload->DbValue)) {
			$this->attachment->EditValue = $this->attachment->Upload->DbValue;
		} else {
			$this->attachment->EditValue = "";
		}
		if (!ew_Empty($this->attachment->CurrentValue))
			$this->attachment->Upload->FileName = $this->attachment->CurrentValue;

		// counselor
		$this->counselor->EditAttrs["class"] = "form-control";
		$this->counselor->EditCustomAttributes = "";
		$this->counselor->EditValue = $this->counselor->CurrentValue;
		$this->counselor->PlaceHolder = ew_RemoveHtml($this->counselor->FldCaption());

		// budget
		$this->budget->EditAttrs["class"] = "form-control";
		$this->budget->EditCustomAttributes = "";
		$this->budget->EditValue = $this->budget->CurrentValue;
		$this->budget->PlaceHolder = ew_RemoveHtml($this->budget->FldCaption());
		if (strval($this->budget->EditValue) <> "" && is_numeric($this->budget->EditValue)) $this->budget->EditValue = ew_FormatNumber($this->budget->EditValue, -2, -1, -2, 0);

		// allocated
		$this->allocated->EditAttrs["class"] = "form-control";
		$this->allocated->EditCustomAttributes = "";
		$this->allocated->EditValue = $this->allocated->CurrentValue;
		$this->allocated->PlaceHolder = ew_RemoveHtml($this->allocated->FldCaption());
		if (strval($this->allocated->EditValue) <> "" && is_numeric($this->allocated->EditValue)) $this->allocated->EditValue = ew_FormatNumber($this->allocated->EditValue, -2, -1, -2, 0);

		// remain
		$this->remain->EditAttrs["class"] = "form-control";
		$this->remain->EditCustomAttributes = "";
		$this->remain->EditValue = $this->remain->CurrentValue;
		$this->remain->PlaceHolder = ew_RemoveHtml($this->remain->FldCaption());
		if (strval($this->remain->EditValue) <> "" && is_numeric($this->remain->EditValue)) $this->remain->EditValue = ew_FormatNumber($this->remain->EditValue, -2, -1, -2, 0);

		// total_allocated
		$this->total_allocated->EditAttrs["class"] = "form-control";
		$this->total_allocated->EditCustomAttributes = "";
		$this->total_allocated->EditValue = $this->total_allocated->CurrentValue;
		$this->total_allocated->PlaceHolder = ew_RemoveHtml($this->total_allocated->FldCaption());
		if (strval($this->total_allocated->EditValue) <> "" && is_numeric($this->total_allocated->EditValue)) $this->total_allocated->EditValue = ew_FormatNumber($this->total_allocated->EditValue, -2, -1, -2, 0);

		// total_remain
		$this->total_remain->EditAttrs["class"] = "form-control";
		$this->total_remain->EditCustomAttributes = "";
		$this->total_remain->EditValue = $this->total_remain->CurrentValue;
		$this->total_remain->PlaceHolder = ew_RemoveHtml($this->total_remain->FldCaption());
		if (strval($this->total_remain->EditValue) <> "" && is_numeric($this->total_remain->EditValue)) $this->total_remain->EditValue = ew_FormatNumber($this->total_remain->EditValue, -2, -1, -2, 0);

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Aggregate list row values
	function AggregateListRowValues() {
			if (is_numeric($this->time->CurrentValue))
				$this->time->Total += $this->time->CurrentValue; // Accumulate total
	}

	// Aggregate list row (for rendering)
	function AggregateListRow() {
			$this->time->CurrentValue = $this->time->Total;
			$this->time->ViewValue = $this->time->CurrentValue;
			$this->time->ViewCustomAttributes = "";
			$this->time->HrefValue = ""; // Clear href value

		// Call Row Rendered event
		$this->Row_Rendered();
	}
	var $ExportDoc;

	// Export data in HTML/CSV/Word/Excel/Email/PDF format
	function ExportDocument(&$Doc, &$Recordset, $StartRec, $StopRec, $ExportPageType = "") {
		if (!$Recordset || !$Doc)
			return;
		if (!$Doc->ExportCustom) {

			// Write header
			$Doc->ExportTableHeader();
			if ($Doc->Horizontal) { // Horizontal format, write header
				$Doc->BeginExportRow();
				if ($ExportPageType == "view") {
					if ($this->dbkey_councilor->Exportable) $Doc->ExportCaption($this->dbkey_councilor);
					if ($this->dbkey_client->Exportable) $Doc->ExportCaption($this->dbkey_client);
					if ($this->date->Exportable) $Doc->ExportCaption($this->date);
					if ($this->time->Exportable) $Doc->ExportCaption($this->time);
					if ($this->comment->Exportable) $Doc->ExportCaption($this->comment);
					if ($this->dbkey_activity->Exportable) $Doc->ExportCaption($this->dbkey_activity);
					if ($this->attachment->Exportable) $Doc->ExportCaption($this->attachment);
					if ($this->budget->Exportable) $Doc->ExportCaption($this->budget);
					if ($this->allocated->Exportable) $Doc->ExportCaption($this->allocated);
					if ($this->remain->Exportable) $Doc->ExportCaption($this->remain);
					if ($this->total_allocated->Exportable) $Doc->ExportCaption($this->total_allocated);
					if ($this->total_remain->Exportable) $Doc->ExportCaption($this->total_remain);
				} else {
					if ($this->dbkey->Exportable) $Doc->ExportCaption($this->dbkey);
					if ($this->dbkey_councilor->Exportable) $Doc->ExportCaption($this->dbkey_councilor);
					if ($this->dbkey_client->Exportable) $Doc->ExportCaption($this->dbkey_client);
					if ($this->date->Exportable) $Doc->ExportCaption($this->date);
					if ($this->time->Exportable) $Doc->ExportCaption($this->time);
					if ($this->comment->Exportable) $Doc->ExportCaption($this->comment);
					if ($this->dbkey_activity->Exportable) $Doc->ExportCaption($this->dbkey_activity);
					if ($this->attachment->Exportable) $Doc->ExportCaption($this->attachment);
					if ($this->budget->Exportable) $Doc->ExportCaption($this->budget);
					if ($this->allocated->Exportable) $Doc->ExportCaption($this->allocated);
					if ($this->remain->Exportable) $Doc->ExportCaption($this->remain);
					if ($this->total_allocated->Exportable) $Doc->ExportCaption($this->total_allocated);
					if ($this->total_remain->Exportable) $Doc->ExportCaption($this->total_remain);
				}
				$Doc->EndExportRow();
			}
		}

		// Move to first record
		$RecCnt = $StartRec - 1;
		if (!$Recordset->EOF) {
			$Recordset->MoveFirst();
			if ($StartRec > 1)
				$Recordset->Move($StartRec - 1);
		}
		while (!$Recordset->EOF && $RecCnt < $StopRec) {
			$RecCnt++;
			if (intval($RecCnt) >= intval($StartRec)) {
				$RowCnt = intval($RecCnt) - intval($StartRec) + 1;

				// Page break
				if ($this->ExportPageBreakCount > 0) {
					if ($RowCnt > 1 && ($RowCnt - 1) % $this->ExportPageBreakCount == 0)
						$Doc->ExportPageBreak();
				}
				$this->LoadListRowValues($Recordset);
				$this->AggregateListRowValues(); // Aggregate row values

				// Render row
				$this->RowType = EW_ROWTYPE_VIEW; // Render view
				$this->ResetAttrs();
				$this->RenderListRow();
				if (!$Doc->ExportCustom) {
					$Doc->BeginExportRow($RowCnt); // Allow CSS styles if enabled
					if ($ExportPageType == "view") {
						if ($this->dbkey_councilor->Exportable) $Doc->ExportField($this->dbkey_councilor);
						if ($this->dbkey_client->Exportable) $Doc->ExportField($this->dbkey_client);
						if ($this->date->Exportable) $Doc->ExportField($this->date);
						if ($this->time->Exportable) $Doc->ExportField($this->time);
						if ($this->comment->Exportable) $Doc->ExportField($this->comment);
						if ($this->dbkey_activity->Exportable) $Doc->ExportField($this->dbkey_activity);
						if ($this->attachment->Exportable) $Doc->ExportField($this->attachment);
						if ($this->budget->Exportable) $Doc->ExportField($this->budget);
						if ($this->allocated->Exportable) $Doc->ExportField($this->allocated);
						if ($this->remain->Exportable) $Doc->ExportField($this->remain);
						if ($this->total_allocated->Exportable) $Doc->ExportField($this->total_allocated);
						if ($this->total_remain->Exportable) $Doc->ExportField($this->total_remain);
					} else {
						if ($this->dbkey->Exportable) $Doc->ExportField($this->dbkey);
						if ($this->dbkey_councilor->Exportable) $Doc->ExportField($this->dbkey_councilor);
						if ($this->dbkey_client->Exportable) $Doc->ExportField($this->dbkey_client);
						if ($this->date->Exportable) $Doc->ExportField($this->date);
						if ($this->time->Exportable) $Doc->ExportField($this->time);
						if ($this->comment->Exportable) $Doc->ExportField($this->comment);
						if ($this->dbkey_activity->Exportable) $Doc->ExportField($this->dbkey_activity);
						if ($this->attachment->Exportable) $Doc->ExportField($this->attachment);
						if ($this->budget->Exportable) $Doc->ExportField($this->budget);
						if ($this->allocated->Exportable) $Doc->ExportField($this->allocated);
						if ($this->remain->Exportable) $Doc->ExportField($this->remain);
						if ($this->total_allocated->Exportable) $Doc->ExportField($this->total_allocated);
						if ($this->total_remain->Exportable) $Doc->ExportField($this->total_remain);
					}
					$Doc->EndExportRow();
				}
			}

			// Call Row Export server event
			if ($Doc->ExportCustom)
				$this->Row_Export($Recordset->fields);
			$Recordset->MoveNext();
		}

		// Export aggregates (horizontal format only)
		if ($Doc->Horizontal) {
			$this->RowType = EW_ROWTYPE_AGGREGATE;
			$this->ResetAttrs();
			$this->AggregateListRow();
			if (!$Doc->ExportCustom) {
				$Doc->BeginExportRow(-1);
				$Doc->ExportAggregate($this->dbkey, '');
				$Doc->ExportAggregate($this->dbkey_councilor, '');
				$Doc->ExportAggregate($this->dbkey_client, '');
				$Doc->ExportAggregate($this->date, '');
				$Doc->ExportAggregate($this->time, 'TOTAL');
				$Doc->ExportAggregate($this->comment, '');
				$Doc->ExportAggregate($this->dbkey_activity, '');
				$Doc->ExportAggregate($this->attachment, '');
				$Doc->ExportAggregate($this->budget, '');
				$Doc->ExportAggregate($this->allocated, '');
				$Doc->ExportAggregate($this->remain, '');
				$Doc->ExportAggregate($this->total_allocated, '');
				$Doc->ExportAggregate($this->total_remain, '');
				$Doc->EndExportRow();
			}
		}
		if (!$Doc->ExportCustom) {
			$Doc->ExportTableFooter();
		}
	}

	// Get auto fill value
	function GetAutoFill($id, $val) {
		$rsarr = array();
		$rowcnt = 0;

		// Output
		if (is_array($rsarr) && $rowcnt > 0) {
			$fldcnt = count($rsarr[0]);
			for ($i = 0; $i < $rowcnt; $i++) {
				for ($j = 0; $j < $fldcnt; $j++) {
					$str = strval($rsarr[$i][$j]);
					$str = ew_ConvertToUtf8($str);
					if (isset($post["keepCRLF"])) {
						$str = str_replace(array("\r", "\n"), array("\\r", "\\n"), $str);
					} else {
						$str = str_replace(array("\r", "\n"), array(" ", " "), $str);
					}
					$rsarr[$i][$j] = $str;
				}
			}
			return ew_ArrayToJson($rsarr);
		} else {
			return FALSE;
		}
	}

	// Table level events
	// Recordset Selecting event
	function Recordset_Selecting(&$filter) {

		// Enter your code here	
	}

	// Recordset Selected event
	function Recordset_Selected(&$rs) {

		//echo "Recordset Selected";
	}

	// Recordset Search Validated event
	function Recordset_SearchValidated() {

		// Example:
		//$this->MyField1->AdvancedSearch->SearchValue = "your search criteria"; // Search value

	}

	// Recordset Searching event
	function Recordset_Searching(&$filter) {

		// Enter your code here	
	}

	// Row_Selecting event
	function Row_Selecting(&$filter) {

		// Enter your code here	
	}

	// Row Selected event
	function Row_Selected(&$rs) {

		//echo "Row Selected";
	}

	// Row Inserting event
	function Row_Inserting($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Inserted event
	function Row_Inserted($rsold, &$rsnew) {

		//echo "Row Inserted"
	}

	// Row Updating event
	function Row_Updating($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Updated event
	function Row_Updated($rsold, &$rsnew) {

		//echo "Row Updated";
	}

	// Row Update Conflict event
	function Row_UpdateConflict($rsold, &$rsnew) {

		// Enter your code here
		// To ignore conflict, set return value to FALSE

		return TRUE;
	}

	// Grid Inserting event
	function Grid_Inserting() {

		// Enter your code here
		// To reject grid insert, set return value to FALSE

		return TRUE;
	}

	// Grid Inserted event
	function Grid_Inserted($rsnew) {

		//echo "Grid Inserted";
	}

	// Grid Updating event
	function Grid_Updating($rsold) {

		// Enter your code here
		// To reject grid update, set return value to FALSE

		return TRUE;
	}

	// Grid Updated event
	function Grid_Updated($rsold, $rsnew) {

		//echo "Grid Updated";
	}

	// Row Deleting event
	function Row_Deleting(&$rs) {

		// Enter your code here
		// To cancel, set return value to False

		return TRUE;
	}

	// Row Deleted event
	function Row_Deleted(&$rs) {

		//echo "Row Deleted";
	}

	// Email Sending event
	function Email_Sending(&$Email, &$Args) {

		//var_dump($Email); var_dump($Args); exit();
		return TRUE;
	}

	// Lookup Selecting event
	function Lookup_Selecting($fld, &$filter) {

		//var_dump($fld->FldName, $fld->LookupFilters, $filter); // Uncomment to view the filter
		// Enter your code here

	}

	// Row Rendering event
	function Row_Rendering() {

		// Enter your code here	
	}

	// Row Rendered event
	function Row_Rendered() {

		// To view properties of field class, use:
		//var_dump($this-><FieldName>); 

	}

	// User ID Filtering event
	function UserID_Filtering(&$filter) {

		// Enter your code here
	}
}
?>
