<?php
if (session_id() == "") session_start(); // Init session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg13.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql13.php") ?>
<?php include_once "phpfn13.php" ?>
<?php include_once "Cust_Rpt_Client_Activity_Weekinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn13.php" ?>
<?php

//
// Page class
//

$Cust_Rpt_Client_Activity_Week_list = NULL; // Initialize page object first

class cCust_Rpt_Client_Activity_Week_list extends cCust_Rpt_Client_Activity_Week {

	// Page ID
	var $PageID = 'list';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'Cust_Rpt_Client_Activity_Week';

	// Page object name
	var $PageObjName = 'Cust_Rpt_Client_Activity_Week_list';

	// Grid form hidden field names
	var $FormName = 'fCust_Rpt_Client_Activity_Weeklist';
	var $FormActionName = 'k_action';
	var $FormKeyName = 'k_key';
	var $FormOldKeyName = 'k_oldkey';
	var $FormBlankRowName = 'k_blankrow';
	var $FormKeyCountName = 'key_count';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Page URLs
	var $AddUrl;
	var $EditUrl;
	var $CopyUrl;
	var $DeleteUrl;
	var $ViewUrl;
	var $ListUrl;

	// Export URLs
	var $ExportPrintUrl;
	var $ExportHtmlUrl;
	var $ExportExcelUrl;
	var $ExportWordUrl;
	var $ExportXmlUrl;
	var $ExportCsvUrl;
	var $ExportPdfUrl;

	// Custom export
	var $ExportExcelCustom = FALSE;
	var $ExportWordCustom = FALSE;
	var $ExportPdfCustom = FALSE;
	var $ExportEmailCustom = FALSE;

	// Update URLs
	var $InlineAddUrl;
	var $InlineCopyUrl;
	var $InlineEditUrl;
	var $GridAddUrl;
	var $GridEditUrl;
	var $MultiDeleteUrl;
	var $MultiUpdateUrl;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (Cust_Rpt_Client_Activity_Week)
		if (!isset($GLOBALS["Cust_Rpt_Client_Activity_Week"]) || get_class($GLOBALS["Cust_Rpt_Client_Activity_Week"]) == "cCust_Rpt_Client_Activity_Week") {
			$GLOBALS["Cust_Rpt_Client_Activity_Week"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["Cust_Rpt_Client_Activity_Week"];
		}

		// Initialize URLs
		$this->ExportPrintUrl = $this->PageUrl() . "export=print";
		$this->ExportExcelUrl = $this->PageUrl() . "export=excel";
		$this->ExportWordUrl = $this->PageUrl() . "export=word";
		$this->ExportHtmlUrl = $this->PageUrl() . "export=html";
		$this->ExportXmlUrl = $this->PageUrl() . "export=xml";
		$this->ExportCsvUrl = $this->PageUrl() . "export=csv";
		$this->ExportPdfUrl = $this->PageUrl() . "export=pdf";
		$this->AddUrl = "Cust_Rpt_Client_Activity_Weekadd.php";
		$this->InlineAddUrl = $this->PageUrl() . "a=add";
		$this->GridAddUrl = $this->PageUrl() . "a=gridadd";
		$this->GridEditUrl = $this->PageUrl() . "a=gridedit";
		$this->MultiDeleteUrl = "Cust_Rpt_Client_Activity_Weekdelete.php";
		$this->MultiUpdateUrl = "Cust_Rpt_Client_Activity_Weekupdate.php";

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'list', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'Cust_Rpt_Client_Activity_Week', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}

		// List options
		$this->ListOptions = new cListOptions();
		$this->ListOptions->TableVar = $this->TableVar;

		// Export options
		$this->ExportOptions = new cListOptions();
		$this->ExportOptions->Tag = "div";
		$this->ExportOptions->TagClassName = "ewExportOption";

		// Other options
		$this->OtherOptions['addedit'] = new cListOptions();
		$this->OtherOptions['addedit']->Tag = "div";
		$this->OtherOptions['addedit']->TagClassName = "ewAddEditOption";
		$this->OtherOptions['detail'] = new cListOptions();
		$this->OtherOptions['detail']->Tag = "div";
		$this->OtherOptions['detail']->TagClassName = "ewDetailOption";
		$this->OtherOptions['action'] = new cListOptions();
		$this->OtherOptions['action']->Tag = "div";
		$this->OtherOptions['action']->TagClassName = "ewActionOption";

		// Filter options
		$this->FilterOptions = new cListOptions();
		$this->FilterOptions->Tag = "div";
		$this->FilterOptions->TagClassName = "ewFilterOption fCust_Rpt_Client_Activity_Weeklistsrch";

		// List actions
		$this->ListActions = new cListActions();
	}

	//
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanList()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			$this->Page_Terminate(ew_GetUrl("index.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Get export parameters
		$custom = "";
		if (@$_GET["export"] <> "") {
			$this->Export = $_GET["export"];
			$custom = @$_GET["custom"];
		} elseif (@$_POST["export"] <> "") {
			$this->Export = $_POST["export"];
			$custom = @$_POST["custom"];
		} elseif (ew_IsHttpPost()) {
			if (@$_POST["exporttype"] <> "")
				$this->Export = $_POST["exporttype"];
			$custom = @$_POST["custom"];
		} else {
			$this->setExportReturnUrl(ew_CurrentUrl());
		}
		$gsExportFile = $this->TableVar; // Get export file, used in header

		// Get custom export parameters
		if ($this->Export <> "" && $custom <> "") {
			$this->CustomExport = $this->Export;
			$this->Export = "print";
		}
		$gsCustomExport = $this->CustomExport;
		$gsExport = $this->Export; // Get export parameter, used in header

		// Update Export URLs
		if (defined("EW_USE_PHPEXCEL"))
			$this->ExportExcelCustom = FALSE;
		if ($this->ExportExcelCustom)
			$this->ExportExcelUrl .= "&amp;custom=1";
		if (defined("EW_USE_PHPWORD"))
			$this->ExportWordCustom = FALSE;
		if ($this->ExportWordCustom)
			$this->ExportWordUrl .= "&amp;custom=1";
		if ($this->ExportPdfCustom)
			$this->ExportPdfUrl .= "&amp;custom=1";
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action

		// Get grid add count
		$gridaddcnt = @$_GET[EW_TABLE_GRID_ADD_ROW_COUNT];
		if (is_numeric($gridaddcnt) && $gridaddcnt > 0)
			$this->GridAddRowCount = $gridaddcnt;

		// Set up list options
		$this->SetupListOptions();

		// Setup export options
		$this->SetupExportOptions();
		$this->description->SetVisibility();
		$this->dbkey->SetVisibility();
		$this->First->SetVisibility();
		$this->First->Visible = !$this->IsAddOrEdit();
		$this->Last->SetVisibility();
		$this->Last->Visible = !$this->IsAddOrEdit();
		$this->Total_Hours->SetVisibility();
		$this->Total_Hours->Visible = !$this->IsAddOrEdit();
		$this->Week_23->SetVisibility();
		$this->Week_23->Visible = !$this->IsAddOrEdit();
		$this->From_Date->SetVisibility();
		$this->From_Date->Visible = !$this->IsAddOrEdit();
		$this->Through_Date->SetVisibility();
		$this->Through_Date->Visible = !$this->IsAddOrEdit();
		$this->Sunday->SetVisibility();
		$this->Sunday->Visible = !$this->IsAddOrEdit();
		$this->Monday->SetVisibility();
		$this->Monday->Visible = !$this->IsAddOrEdit();
		$this->Tuesday->SetVisibility();
		$this->Tuesday->Visible = !$this->IsAddOrEdit();
		$this->Wednesday->SetVisibility();
		$this->Wednesday->Visible = !$this->IsAddOrEdit();
		$this->Thursday->SetVisibility();
		$this->Thursday->Visible = !$this->IsAddOrEdit();
		$this->Friday->SetVisibility();
		$this->Friday->Visible = !$this->IsAddOrEdit();
		$this->Saturday->SetVisibility();
		$this->Saturday->Visible = !$this->IsAddOrEdit();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();

		// Setup other options
		$this->SetupOtherOptions();

		// Set up custom action (compatible with old version)
		foreach ($this->CustomActions as $name => $action)
			$this->ListActions->Add($name, $action);

		// Show checkbox column if multiple action
		foreach ($this->ListActions->Items as $listaction) {
			if ($listaction->Select == EW_ACTION_MULTIPLE && $listaction->Allow) {
				$this->ListOptions->Items["checkbox"]->Visible = TRUE;
				break;
			}
		}
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $Cust_Rpt_Client_Activity_Week;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($Cust_Rpt_Client_Activity_Week);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}

	// Class variables
	var $ListOptions; // List options
	var $ExportOptions; // Export options
	var $SearchOptions; // Search options
	var $OtherOptions = array(); // Other options
	var $FilterOptions; // Filter options
	var $ListActions; // List actions
	var $SelectedCount = 0;
	var $SelectedIndex = 0;
	var $DisplayRecs = 20;
	var $StartRec;
	var $StopRec;
	var $TotalRecs = 0;
	var $RecRange = 10;
	var $Pager;
	var $DefaultSearchWhere = ""; // Default search WHERE clause
	var $SearchWhere = ""; // Search WHERE clause
	var $RecCnt = 0; // Record count
	var $EditRowCnt;
	var $StartRowCnt = 1;
	var $RowCnt = 0;
	var $Attrs = array(); // Row attributes and cell attributes
	var $RowIndex = 0; // Row index
	var $KeyCount = 0; // Key count
	var $RowAction = ""; // Row action
	var $RowOldKey = ""; // Row old key (for copy)
	var $RecPerRow = 0;
	var $MultiColumnClass;
	var $MultiColumnEditClass = "col-sm-12";
	var $MultiColumnCnt = 12;
	var $MultiColumnEditCnt = 12;
	var $GridCnt = 0;
	var $ColCnt = 0;
	var $DbMasterFilter = ""; // Master filter
	var $DbDetailFilter = ""; // Detail filter
	var $MasterRecordExists;	
	var $MultiSelectKey;
	var $Command;
	var $RestoreSearch = FALSE;
	var $DetailPages;
	var $Recordset;
	var $OldRecordset;

	//
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError, $gsSearchError, $Security;

		// Search filters
		$sSrchAdvanced = ""; // Advanced search filter
		$sSrchBasic = ""; // Basic search filter
		$sFilter = "";

		// Get command
		$this->Command = strtolower(@$_GET["cmd"]);
		if ($this->IsPageRequest()) { // Validate request

			// Process list action first
			if ($this->ProcessListAction()) // Ajax request
				$this->Page_Terminate();

			// Handle reset command
			$this->ResetCmd();

			// Set up Breadcrumb
			if ($this->Export == "")
				$this->SetupBreadcrumb();

			// Hide list options
			if ($this->Export <> "") {
				$this->ListOptions->HideAllOptions(array("sequence"));
				$this->ListOptions->UseDropDownButton = FALSE; // Disable drop down button
				$this->ListOptions->UseButtonGroup = FALSE; // Disable button group
			} elseif ($this->CurrentAction == "gridadd" || $this->CurrentAction == "gridedit") {
				$this->ListOptions->HideAllOptions();
				$this->ListOptions->UseDropDownButton = FALSE; // Disable drop down button
				$this->ListOptions->UseButtonGroup = FALSE; // Disable button group
			}

			// Hide options
			if ($this->Export <> "" || $this->CurrentAction <> "") {
				$this->ExportOptions->HideAllOptions();
				$this->FilterOptions->HideAllOptions();
			}

			// Hide other options
			if ($this->Export <> "") {
				foreach ($this->OtherOptions as &$option)
					$option->HideAllOptions();
			}

			// Get default search criteria
			ew_AddFilter($this->DefaultSearchWhere, $this->BasicSearchWhere(TRUE));
			ew_AddFilter($this->DefaultSearchWhere, $this->AdvancedSearchWhere(TRUE));

			// Get basic search values
			$this->LoadBasicSearchValues();

			// Get and validate search values for advanced search
			$this->LoadSearchValues(); // Get search values

			// Process filter list
			$this->ProcessFilterList();
			if (!$this->ValidateSearch())
				$this->setFailureMessage($gsSearchError);

			// Restore search parms from Session if not searching / reset / export
			if (($this->Export <> "" || $this->Command <> "search" && $this->Command <> "reset" && $this->Command <> "resetall") && $this->CheckSearchParms())
				$this->RestoreSearchParms();

			// Call Recordset SearchValidated event
			$this->Recordset_SearchValidated();

			// Set up sorting order
			$this->SetUpSortOrder();

			// Get basic search criteria
			if ($gsSearchError == "")
				$sSrchBasic = $this->BasicSearchWhere();

			// Get search criteria for advanced search
			if ($gsSearchError == "")
				$sSrchAdvanced = $this->AdvancedSearchWhere();
		}

		// Restore display records
		if ($this->getRecordsPerPage() <> "") {
			$this->DisplayRecs = $this->getRecordsPerPage(); // Restore from Session
		} else {
			$this->DisplayRecs = 20; // Load default
		}

		// Load Sorting Order
		$this->LoadSortOrder();

		// Load search default if no existing search criteria
		if (!$this->CheckSearchParms()) {

			// Load basic search from default
			$this->BasicSearch->LoadDefault();
			if ($this->BasicSearch->Keyword != "")
				$sSrchBasic = $this->BasicSearchWhere();

			// Load advanced search from default
			if ($this->LoadAdvancedSearchDefault()) {
				$sSrchAdvanced = $this->AdvancedSearchWhere();
			}
		}

		// Build search criteria
		ew_AddFilter($this->SearchWhere, $sSrchAdvanced);
		ew_AddFilter($this->SearchWhere, $sSrchBasic);

		// Call Recordset_Searching event
		$this->Recordset_Searching($this->SearchWhere);

		// Save search criteria
		if ($this->Command == "search" && !$this->RestoreSearch) {
			$this->setSearchWhere($this->SearchWhere); // Save to Session
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} else {
			$this->SearchWhere = $this->getSearchWhere();
		}

		// Build filter
		$sFilter = "";
		if (!$Security->CanList())
			$sFilter = "(0=1)"; // Filter all records
		ew_AddFilter($sFilter, $this->DbDetailFilter);
		ew_AddFilter($sFilter, $this->SearchWhere);

		// Set up filter in session
		$this->setSessionWhere($sFilter);
		$this->CurrentFilter = "";

		// Export data only
		if ($this->CustomExport == "" && in_array($this->Export, array("html","word","excel","xml","csv","email","pdf"))) {
			$this->ExportData();
			$this->Page_Terminate(); // Terminate response
			exit();
		}

		// Load record count first
		if (!$this->IsAddOrEdit()) {
			$bSelectLimit = $this->UseSelectLimit;
			if ($bSelectLimit) {
				$this->TotalRecs = $this->SelectRecordCount();
			} else {
				if ($this->Recordset = $this->LoadRecordset())
					$this->TotalRecs = $this->Recordset->RecordCount();
			}
		}

		// Search options
		$this->SetupSearchOptions();
	}

	// Build filter for all keys
	function BuildKeyFilter() {
		global $objForm;
		$sWrkFilter = "";

		// Update row index and get row key
		$rowindex = 1;
		$objForm->Index = $rowindex;
		$sThisKey = strval($objForm->GetValue($this->FormKeyName));
		while ($sThisKey <> "") {
			if ($this->SetupKeyValues($sThisKey)) {
				$sFilter = $this->KeyFilter();
				if ($sWrkFilter <> "") $sWrkFilter .= " OR ";
				$sWrkFilter .= $sFilter;
			} else {
				$sWrkFilter = "0=1";
				break;
			}

			// Update row index and get row key
			$rowindex++; // Next row
			$objForm->Index = $rowindex;
			$sThisKey = strval($objForm->GetValue($this->FormKeyName));
		}
		return $sWrkFilter;
	}

	// Set up key values
	function SetupKeyValues($key) {
		$arrKeyFlds = explode($GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"], $key);
		if (count($arrKeyFlds) >= 0) {
		}
		return TRUE;
	}

	// Get list of filters
	function GetFilterList() {
		global $UserProfile;

		// Load server side filters
		if (EW_SEARCH_FILTER_OPTION == "Server") {
			$sSavedFilterList = $UserProfile->GetSearchFilters(CurrentUserName(), "fCust_Rpt_Client_Activity_Weeklistsrch");
		} else {
			$sSavedFilterList = "";
		}

		// Initialize
		$sFilterList = "";
		$sFilterList = ew_Concat($sFilterList, $this->description->AdvancedSearch->ToJSON(), ","); // Field description
		$sFilterList = ew_Concat($sFilterList, $this->dbkey->AdvancedSearch->ToJSON(), ","); // Field dbkey
		$sFilterList = ew_Concat($sFilterList, $this->First->AdvancedSearch->ToJSON(), ","); // Field First
		$sFilterList = ew_Concat($sFilterList, $this->Last->AdvancedSearch->ToJSON(), ","); // Field Last
		$sFilterList = ew_Concat($sFilterList, $this->Total_Hours->AdvancedSearch->ToJSON(), ","); // Field Total Hours
		$sFilterList = ew_Concat($sFilterList, $this->Week_23->AdvancedSearch->ToJSON(), ","); // Field Week #
		$sFilterList = ew_Concat($sFilterList, $this->From_Date->AdvancedSearch->ToJSON(), ","); // Field From Date
		$sFilterList = ew_Concat($sFilterList, $this->Through_Date->AdvancedSearch->ToJSON(), ","); // Field Through Date
		$sFilterList = ew_Concat($sFilterList, $this->Sunday->AdvancedSearch->ToJSON(), ","); // Field Sunday
		$sFilterList = ew_Concat($sFilterList, $this->Monday->AdvancedSearch->ToJSON(), ","); // Field Monday
		$sFilterList = ew_Concat($sFilterList, $this->Tuesday->AdvancedSearch->ToJSON(), ","); // Field Tuesday
		$sFilterList = ew_Concat($sFilterList, $this->Wednesday->AdvancedSearch->ToJSON(), ","); // Field Wednesday
		$sFilterList = ew_Concat($sFilterList, $this->Thursday->AdvancedSearch->ToJSON(), ","); // Field Thursday
		$sFilterList = ew_Concat($sFilterList, $this->Friday->AdvancedSearch->ToJSON(), ","); // Field Friday
		$sFilterList = ew_Concat($sFilterList, $this->Saturday->AdvancedSearch->ToJSON(), ","); // Field Saturday
		if ($this->BasicSearch->Keyword <> "") {
			$sWrk = "\"" . EW_TABLE_BASIC_SEARCH . "\":\"" . ew_JsEncode2($this->BasicSearch->Keyword) . "\",\"" . EW_TABLE_BASIC_SEARCH_TYPE . "\":\"" . ew_JsEncode2($this->BasicSearch->Type) . "\"";
			$sFilterList = ew_Concat($sFilterList, $sWrk, ",");
		}
		$sFilterList = preg_replace('/,$/', "", $sFilterList);

		// Return filter list in json
		if ($sFilterList <> "")
			$sFilterList = "\"data\":{" . $sFilterList . "}";
		if ($sSavedFilterList <> "") {
			if ($sFilterList <> "")
				$sFilterList .= ",";
			$sFilterList .= "\"filters\":" . $sSavedFilterList;
		}
		return ($sFilterList <> "") ? "{" . $sFilterList . "}" : "null";
	}

	// Process filter list
	function ProcessFilterList() {
		global $UserProfile;
		if (@$_POST["ajax"] == "savefilters") { // Save filter request (Ajax)
			$filters = ew_StripSlashes(@$_POST["filters"]);
			$UserProfile->SetSearchFilters(CurrentUserName(), "fCust_Rpt_Client_Activity_Weeklistsrch", $filters);

			// Clean output buffer
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			echo ew_ArrayToJson(array(array("success" => TRUE))); // Success
			$this->Page_Terminate();
			exit();
		} elseif (@$_POST["cmd"] == "resetfilter") {
			$this->RestoreFilterList();
		}
	}

	// Restore list of filters
	function RestoreFilterList() {

		// Return if not reset filter
		if (@$_POST["cmd"] <> "resetfilter")
			return FALSE;
		$filter = json_decode(ew_StripSlashes(@$_POST["filter"]), TRUE);
		$this->Command = "search";

		// Field description
		$this->description->AdvancedSearch->SearchValue = @$filter["x_description"];
		$this->description->AdvancedSearch->SearchOperator = @$filter["z_description"];
		$this->description->AdvancedSearch->SearchCondition = @$filter["v_description"];
		$this->description->AdvancedSearch->SearchValue2 = @$filter["y_description"];
		$this->description->AdvancedSearch->SearchOperator2 = @$filter["w_description"];
		$this->description->AdvancedSearch->Save();

		// Field dbkey
		$this->dbkey->AdvancedSearch->SearchValue = @$filter["x_dbkey"];
		$this->dbkey->AdvancedSearch->SearchOperator = @$filter["z_dbkey"];
		$this->dbkey->AdvancedSearch->SearchCondition = @$filter["v_dbkey"];
		$this->dbkey->AdvancedSearch->SearchValue2 = @$filter["y_dbkey"];
		$this->dbkey->AdvancedSearch->SearchOperator2 = @$filter["w_dbkey"];
		$this->dbkey->AdvancedSearch->Save();

		// Field First
		$this->First->AdvancedSearch->SearchValue = @$filter["x_First"];
		$this->First->AdvancedSearch->SearchOperator = @$filter["z_First"];
		$this->First->AdvancedSearch->SearchCondition = @$filter["v_First"];
		$this->First->AdvancedSearch->SearchValue2 = @$filter["y_First"];
		$this->First->AdvancedSearch->SearchOperator2 = @$filter["w_First"];
		$this->First->AdvancedSearch->Save();

		// Field Last
		$this->Last->AdvancedSearch->SearchValue = @$filter["x_Last"];
		$this->Last->AdvancedSearch->SearchOperator = @$filter["z_Last"];
		$this->Last->AdvancedSearch->SearchCondition = @$filter["v_Last"];
		$this->Last->AdvancedSearch->SearchValue2 = @$filter["y_Last"];
		$this->Last->AdvancedSearch->SearchOperator2 = @$filter["w_Last"];
		$this->Last->AdvancedSearch->Save();

		// Field Total Hours
		$this->Total_Hours->AdvancedSearch->SearchValue = @$filter["x_Total_Hours"];
		$this->Total_Hours->AdvancedSearch->SearchOperator = @$filter["z_Total_Hours"];
		$this->Total_Hours->AdvancedSearch->SearchCondition = @$filter["v_Total_Hours"];
		$this->Total_Hours->AdvancedSearch->SearchValue2 = @$filter["y_Total_Hours"];
		$this->Total_Hours->AdvancedSearch->SearchOperator2 = @$filter["w_Total_Hours"];
		$this->Total_Hours->AdvancedSearch->Save();

		// Field Week #
		$this->Week_23->AdvancedSearch->SearchValue = @$filter["x_Week_23"];
		$this->Week_23->AdvancedSearch->SearchOperator = @$filter["z_Week_23"];
		$this->Week_23->AdvancedSearch->SearchCondition = @$filter["v_Week_23"];
		$this->Week_23->AdvancedSearch->SearchValue2 = @$filter["y_Week_23"];
		$this->Week_23->AdvancedSearch->SearchOperator2 = @$filter["w_Week_23"];
		$this->Week_23->AdvancedSearch->Save();

		// Field From Date
		$this->From_Date->AdvancedSearch->SearchValue = @$filter["x_From_Date"];
		$this->From_Date->AdvancedSearch->SearchOperator = @$filter["z_From_Date"];
		$this->From_Date->AdvancedSearch->SearchCondition = @$filter["v_From_Date"];
		$this->From_Date->AdvancedSearch->SearchValue2 = @$filter["y_From_Date"];
		$this->From_Date->AdvancedSearch->SearchOperator2 = @$filter["w_From_Date"];
		$this->From_Date->AdvancedSearch->Save();

		// Field Through Date
		$this->Through_Date->AdvancedSearch->SearchValue = @$filter["x_Through_Date"];
		$this->Through_Date->AdvancedSearch->SearchOperator = @$filter["z_Through_Date"];
		$this->Through_Date->AdvancedSearch->SearchCondition = @$filter["v_Through_Date"];
		$this->Through_Date->AdvancedSearch->SearchValue2 = @$filter["y_Through_Date"];
		$this->Through_Date->AdvancedSearch->SearchOperator2 = @$filter["w_Through_Date"];
		$this->Through_Date->AdvancedSearch->Save();

		// Field Sunday
		$this->Sunday->AdvancedSearch->SearchValue = @$filter["x_Sunday"];
		$this->Sunday->AdvancedSearch->SearchOperator = @$filter["z_Sunday"];
		$this->Sunday->AdvancedSearch->SearchCondition = @$filter["v_Sunday"];
		$this->Sunday->AdvancedSearch->SearchValue2 = @$filter["y_Sunday"];
		$this->Sunday->AdvancedSearch->SearchOperator2 = @$filter["w_Sunday"];
		$this->Sunday->AdvancedSearch->Save();

		// Field Monday
		$this->Monday->AdvancedSearch->SearchValue = @$filter["x_Monday"];
		$this->Monday->AdvancedSearch->SearchOperator = @$filter["z_Monday"];
		$this->Monday->AdvancedSearch->SearchCondition = @$filter["v_Monday"];
		$this->Monday->AdvancedSearch->SearchValue2 = @$filter["y_Monday"];
		$this->Monday->AdvancedSearch->SearchOperator2 = @$filter["w_Monday"];
		$this->Monday->AdvancedSearch->Save();

		// Field Tuesday
		$this->Tuesday->AdvancedSearch->SearchValue = @$filter["x_Tuesday"];
		$this->Tuesday->AdvancedSearch->SearchOperator = @$filter["z_Tuesday"];
		$this->Tuesday->AdvancedSearch->SearchCondition = @$filter["v_Tuesday"];
		$this->Tuesday->AdvancedSearch->SearchValue2 = @$filter["y_Tuesday"];
		$this->Tuesday->AdvancedSearch->SearchOperator2 = @$filter["w_Tuesday"];
		$this->Tuesday->AdvancedSearch->Save();

		// Field Wednesday
		$this->Wednesday->AdvancedSearch->SearchValue = @$filter["x_Wednesday"];
		$this->Wednesday->AdvancedSearch->SearchOperator = @$filter["z_Wednesday"];
		$this->Wednesday->AdvancedSearch->SearchCondition = @$filter["v_Wednesday"];
		$this->Wednesday->AdvancedSearch->SearchValue2 = @$filter["y_Wednesday"];
		$this->Wednesday->AdvancedSearch->SearchOperator2 = @$filter["w_Wednesday"];
		$this->Wednesday->AdvancedSearch->Save();

		// Field Thursday
		$this->Thursday->AdvancedSearch->SearchValue = @$filter["x_Thursday"];
		$this->Thursday->AdvancedSearch->SearchOperator = @$filter["z_Thursday"];
		$this->Thursday->AdvancedSearch->SearchCondition = @$filter["v_Thursday"];
		$this->Thursday->AdvancedSearch->SearchValue2 = @$filter["y_Thursday"];
		$this->Thursday->AdvancedSearch->SearchOperator2 = @$filter["w_Thursday"];
		$this->Thursday->AdvancedSearch->Save();

		// Field Friday
		$this->Friday->AdvancedSearch->SearchValue = @$filter["x_Friday"];
		$this->Friday->AdvancedSearch->SearchOperator = @$filter["z_Friday"];
		$this->Friday->AdvancedSearch->SearchCondition = @$filter["v_Friday"];
		$this->Friday->AdvancedSearch->SearchValue2 = @$filter["y_Friday"];
		$this->Friday->AdvancedSearch->SearchOperator2 = @$filter["w_Friday"];
		$this->Friday->AdvancedSearch->Save();

		// Field Saturday
		$this->Saturday->AdvancedSearch->SearchValue = @$filter["x_Saturday"];
		$this->Saturday->AdvancedSearch->SearchOperator = @$filter["z_Saturday"];
		$this->Saturday->AdvancedSearch->SearchCondition = @$filter["v_Saturday"];
		$this->Saturday->AdvancedSearch->SearchValue2 = @$filter["y_Saturday"];
		$this->Saturday->AdvancedSearch->SearchOperator2 = @$filter["w_Saturday"];
		$this->Saturday->AdvancedSearch->Save();
		$this->BasicSearch->setKeyword(@$filter[EW_TABLE_BASIC_SEARCH]);
		$this->BasicSearch->setType(@$filter[EW_TABLE_BASIC_SEARCH_TYPE]);
	}

	// Advanced search WHERE clause based on QueryString
	function AdvancedSearchWhere($Default = FALSE) {
		global $Security;
		$sWhere = "";
		if (!$Security->CanSearch()) return "";
		$this->BuildSearchSql($sWhere, $this->description, $Default, FALSE); // description
		$this->BuildSearchSql($sWhere, $this->dbkey, $Default, FALSE); // dbkey
		$this->BuildSearchSql($sWhere, $this->First, $Default, FALSE); // First
		$this->BuildSearchSql($sWhere, $this->Last, $Default, FALSE); // Last
		$this->BuildSearchSql($sWhere, $this->Total_Hours, $Default, FALSE); // Total Hours
		$this->BuildSearchSql($sWhere, $this->Week_23, $Default, FALSE); // Week #
		$this->BuildSearchSql($sWhere, $this->From_Date, $Default, FALSE); // From Date
		$this->BuildSearchSql($sWhere, $this->Through_Date, $Default, FALSE); // Through Date
		$this->BuildSearchSql($sWhere, $this->Sunday, $Default, FALSE); // Sunday
		$this->BuildSearchSql($sWhere, $this->Monday, $Default, FALSE); // Monday
		$this->BuildSearchSql($sWhere, $this->Tuesday, $Default, FALSE); // Tuesday
		$this->BuildSearchSql($sWhere, $this->Wednesday, $Default, FALSE); // Wednesday
		$this->BuildSearchSql($sWhere, $this->Thursday, $Default, FALSE); // Thursday
		$this->BuildSearchSql($sWhere, $this->Friday, $Default, FALSE); // Friday
		$this->BuildSearchSql($sWhere, $this->Saturday, $Default, FALSE); // Saturday

		// Set up search parm
		if (!$Default && $sWhere <> "") {
			$this->Command = "search";
		}
		if (!$Default && $this->Command == "search") {
			$this->description->AdvancedSearch->Save(); // description
			$this->dbkey->AdvancedSearch->Save(); // dbkey
			$this->First->AdvancedSearch->Save(); // First
			$this->Last->AdvancedSearch->Save(); // Last
			$this->Total_Hours->AdvancedSearch->Save(); // Total Hours
			$this->Week_23->AdvancedSearch->Save(); // Week #
			$this->From_Date->AdvancedSearch->Save(); // From Date
			$this->Through_Date->AdvancedSearch->Save(); // Through Date
			$this->Sunday->AdvancedSearch->Save(); // Sunday
			$this->Monday->AdvancedSearch->Save(); // Monday
			$this->Tuesday->AdvancedSearch->Save(); // Tuesday
			$this->Wednesday->AdvancedSearch->Save(); // Wednesday
			$this->Thursday->AdvancedSearch->Save(); // Thursday
			$this->Friday->AdvancedSearch->Save(); // Friday
			$this->Saturday->AdvancedSearch->Save(); // Saturday
		}
		return $sWhere;
	}

	// Build search SQL
	function BuildSearchSql(&$Where, &$Fld, $Default, $MultiValue) {
		$FldParm = substr($Fld->FldVar, 2);
		$FldVal = ($Default) ? $Fld->AdvancedSearch->SearchValueDefault : $Fld->AdvancedSearch->SearchValue; // @$_GET["x_$FldParm"]
		$FldOpr = ($Default) ? $Fld->AdvancedSearch->SearchOperatorDefault : $Fld->AdvancedSearch->SearchOperator; // @$_GET["z_$FldParm"]
		$FldCond = ($Default) ? $Fld->AdvancedSearch->SearchConditionDefault : $Fld->AdvancedSearch->SearchCondition; // @$_GET["v_$FldParm"]
		$FldVal2 = ($Default) ? $Fld->AdvancedSearch->SearchValue2Default : $Fld->AdvancedSearch->SearchValue2; // @$_GET["y_$FldParm"]
		$FldOpr2 = ($Default) ? $Fld->AdvancedSearch->SearchOperator2Default : $Fld->AdvancedSearch->SearchOperator2; // @$_GET["w_$FldParm"]
		$sWrk = "";

		//$FldVal = ew_StripSlashes($FldVal);
		if (is_array($FldVal)) $FldVal = implode(",", $FldVal);

		//$FldVal2 = ew_StripSlashes($FldVal2);
		if (is_array($FldVal2)) $FldVal2 = implode(",", $FldVal2);
		$FldOpr = strtoupper(trim($FldOpr));
		if ($FldOpr == "") $FldOpr = "=";
		$FldOpr2 = strtoupper(trim($FldOpr2));
		if ($FldOpr2 == "") $FldOpr2 = "=";
		if (EW_SEARCH_MULTI_VALUE_OPTION == 1)
			$MultiValue = FALSE;
		if ($MultiValue) {
			$sWrk1 = ($FldVal <> "") ? ew_GetMultiSearchSql($Fld, $FldOpr, $FldVal, $this->DBID) : ""; // Field value 1
			$sWrk2 = ($FldVal2 <> "") ? ew_GetMultiSearchSql($Fld, $FldOpr2, $FldVal2, $this->DBID) : ""; // Field value 2
			$sWrk = $sWrk1; // Build final SQL
			if ($sWrk2 <> "")
				$sWrk = ($sWrk <> "") ? "($sWrk) $FldCond ($sWrk2)" : $sWrk2;
		} else {
			$FldVal = $this->ConvertSearchValue($Fld, $FldVal);
			$FldVal2 = $this->ConvertSearchValue($Fld, $FldVal2);
			$sWrk = ew_GetSearchSql($Fld, $FldVal, $FldOpr, $FldCond, $FldVal2, $FldOpr2, $this->DBID);
		}
		ew_AddFilter($Where, $sWrk);
	}

	// Convert search value
	function ConvertSearchValue(&$Fld, $FldVal) {
		if ($FldVal == EW_NULL_VALUE || $FldVal == EW_NOT_NULL_VALUE)
			return $FldVal;
		$Value = $FldVal;
		if ($Fld->FldDataType == EW_DATATYPE_BOOLEAN) {
			if ($FldVal <> "") $Value = ($FldVal == "1" || strtolower(strval($FldVal)) == "y" || strtolower(strval($FldVal)) == "t") ? $Fld->TrueValue : $Fld->FalseValue;
		} elseif ($Fld->FldDataType == EW_DATATYPE_DATE || $Fld->FldDataType == EW_DATATYPE_TIME) {
			if ($FldVal <> "") $Value = ew_UnFormatDateTime($FldVal, $Fld->FldDateTimeFormat);
		}
		return $Value;
	}

	// Return basic search SQL
	function BasicSearchSQL($arKeywords, $type) {
		$sWhere = "";
		$this->BuildBasicSearchSQL($sWhere, $this->description, $arKeywords, $type);
		$this->BuildBasicSearchSQL($sWhere, $this->dbkey, $arKeywords, $type);
		$this->BuildBasicSearchSQL($sWhere, $this->First, $arKeywords, $type);
		$this->BuildBasicSearchSQL($sWhere, $this->Last, $arKeywords, $type);
		return $sWhere;
	}

	// Build basic search SQL
	function BuildBasicSearchSQL(&$Where, &$Fld, $arKeywords, $type) {
		global $EW_BASIC_SEARCH_IGNORE_PATTERN;
		$sDefCond = ($type == "OR") ? "OR" : "AND";
		$arSQL = array(); // Array for SQL parts
		$arCond = array(); // Array for search conditions
		$cnt = count($arKeywords);
		$j = 0; // Number of SQL parts
		for ($i = 0; $i < $cnt; $i++) {
			$Keyword = $arKeywords[$i];
			$Keyword = trim($Keyword);
			if ($EW_BASIC_SEARCH_IGNORE_PATTERN <> "") {
				$Keyword = preg_replace($EW_BASIC_SEARCH_IGNORE_PATTERN, "\\", $Keyword);
				$ar = explode("\\", $Keyword);
			} else {
				$ar = array($Keyword);
			}
			foreach ($ar as $Keyword) {
				if ($Keyword <> "") {
					$sWrk = "";
					if ($Keyword == "OR" && $type == "") {
						if ($j > 0)
							$arCond[$j-1] = "OR";
					} elseif ($Keyword == EW_NULL_VALUE) {
						$sWrk = $Fld->FldExpression . " IS NULL";
					} elseif ($Keyword == EW_NOT_NULL_VALUE) {
						$sWrk = $Fld->FldExpression . " IS NOT NULL";
					} elseif ($Fld->FldIsVirtual) {
						$sWrk = $Fld->FldVirtualExpression . ew_Like(ew_QuotedValue("%" . $Keyword . "%", EW_DATATYPE_STRING, $this->DBID), $this->DBID);
					} elseif ($Fld->FldDataType != EW_DATATYPE_NUMBER || is_numeric($Keyword)) {
						$sWrk = $Fld->FldBasicSearchExpression . ew_Like(ew_QuotedValue("%" . $Keyword . "%", EW_DATATYPE_STRING, $this->DBID), $this->DBID);
					}
					if ($sWrk <> "") {
						$arSQL[$j] = $sWrk;
						$arCond[$j] = $sDefCond;
						$j += 1;
					}
				}
			}
		}
		$cnt = count($arSQL);
		$bQuoted = FALSE;
		$sSql = "";
		if ($cnt > 0) {
			for ($i = 0; $i < $cnt-1; $i++) {
				if ($arCond[$i] == "OR") {
					if (!$bQuoted) $sSql .= "(";
					$bQuoted = TRUE;
				}
				$sSql .= $arSQL[$i];
				if ($bQuoted && $arCond[$i] <> "OR") {
					$sSql .= ")";
					$bQuoted = FALSE;
				}
				$sSql .= " " . $arCond[$i] . " ";
			}
			$sSql .= $arSQL[$cnt-1];
			if ($bQuoted)
				$sSql .= ")";
		}
		if ($sSql <> "") {
			if ($Where <> "") $Where .= " OR ";
			$Where .=  "(" . $sSql . ")";
		}
	}

	// Return basic search WHERE clause based on search keyword and type
	function BasicSearchWhere($Default = FALSE) {
		global $Security;
		$sSearchStr = "";
		if (!$Security->CanSearch()) return "";
		$sSearchKeyword = ($Default) ? $this->BasicSearch->KeywordDefault : $this->BasicSearch->Keyword;
		$sSearchType = ($Default) ? $this->BasicSearch->TypeDefault : $this->BasicSearch->Type;
		if ($sSearchKeyword <> "") {
			$sSearch = trim($sSearchKeyword);
			if ($sSearchType <> "=") {
				$ar = array();

				// Match quoted keywords (i.e.: "...")
				if (preg_match_all('/"([^"]*)"/i', $sSearch, $matches, PREG_SET_ORDER)) {
					foreach ($matches as $match) {
						$p = strpos($sSearch, $match[0]);
						$str = substr($sSearch, 0, $p);
						$sSearch = substr($sSearch, $p + strlen($match[0]));
						if (strlen(trim($str)) > 0)
							$ar = array_merge($ar, explode(" ", trim($str)));
						$ar[] = $match[1]; // Save quoted keyword
					}
				}

				// Match individual keywords
				if (strlen(trim($sSearch)) > 0)
					$ar = array_merge($ar, explode(" ", trim($sSearch)));

				// Search keyword in any fields
				if (($sSearchType == "OR" || $sSearchType == "AND") && $this->BasicSearch->BasicSearchAnyFields) {
					foreach ($ar as $sKeyword) {
						if ($sKeyword <> "") {
							if ($sSearchStr <> "") $sSearchStr .= " " . $sSearchType . " ";
							$sSearchStr .= "(" . $this->BasicSearchSQL(array($sKeyword), $sSearchType) . ")";
						}
					}
				} else {
					$sSearchStr = $this->BasicSearchSQL($ar, $sSearchType);
				}
			} else {
				$sSearchStr = $this->BasicSearchSQL(array($sSearch), $sSearchType);
			}
			if (!$Default) $this->Command = "search";
		}
		if (!$Default && $this->Command == "search") {
			$this->BasicSearch->setKeyword($sSearchKeyword);
			$this->BasicSearch->setType($sSearchType);
		}
		return $sSearchStr;
	}

	// Check if search parm exists
	function CheckSearchParms() {

		// Check basic search
		if ($this->BasicSearch->IssetSession())
			return TRUE;
		if ($this->description->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->dbkey->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->First->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->Last->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->Total_Hours->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->Week_23->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->From_Date->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->Through_Date->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->Sunday->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->Monday->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->Tuesday->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->Wednesday->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->Thursday->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->Friday->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->Saturday->AdvancedSearch->IssetSession())
			return TRUE;
		return FALSE;
	}

	// Clear all search parameters
	function ResetSearchParms() {

		// Clear search WHERE clause
		$this->SearchWhere = "";
		$this->setSearchWhere($this->SearchWhere);

		// Clear basic search parameters
		$this->ResetBasicSearchParms();

		// Clear advanced search parameters
		$this->ResetAdvancedSearchParms();
	}

	// Load advanced search default values
	function LoadAdvancedSearchDefault() {
		return FALSE;
	}

	// Clear all basic search parameters
	function ResetBasicSearchParms() {
		$this->BasicSearch->UnsetSession();
	}

	// Clear all advanced search parameters
	function ResetAdvancedSearchParms() {
		$this->description->AdvancedSearch->UnsetSession();
		$this->dbkey->AdvancedSearch->UnsetSession();
		$this->First->AdvancedSearch->UnsetSession();
		$this->Last->AdvancedSearch->UnsetSession();
		$this->Total_Hours->AdvancedSearch->UnsetSession();
		$this->Week_23->AdvancedSearch->UnsetSession();
		$this->From_Date->AdvancedSearch->UnsetSession();
		$this->Through_Date->AdvancedSearch->UnsetSession();
		$this->Sunday->AdvancedSearch->UnsetSession();
		$this->Monday->AdvancedSearch->UnsetSession();
		$this->Tuesday->AdvancedSearch->UnsetSession();
		$this->Wednesday->AdvancedSearch->UnsetSession();
		$this->Thursday->AdvancedSearch->UnsetSession();
		$this->Friday->AdvancedSearch->UnsetSession();
		$this->Saturday->AdvancedSearch->UnsetSession();
	}

	// Restore all search parameters
	function RestoreSearchParms() {
		$this->RestoreSearch = TRUE;

		// Restore basic search values
		$this->BasicSearch->Load();

		// Restore advanced search values
		$this->description->AdvancedSearch->Load();
		$this->dbkey->AdvancedSearch->Load();
		$this->First->AdvancedSearch->Load();
		$this->Last->AdvancedSearch->Load();
		$this->Total_Hours->AdvancedSearch->Load();
		$this->Week_23->AdvancedSearch->Load();
		$this->From_Date->AdvancedSearch->Load();
		$this->Through_Date->AdvancedSearch->Load();
		$this->Sunday->AdvancedSearch->Load();
		$this->Monday->AdvancedSearch->Load();
		$this->Tuesday->AdvancedSearch->Load();
		$this->Wednesday->AdvancedSearch->Load();
		$this->Thursday->AdvancedSearch->Load();
		$this->Friday->AdvancedSearch->Load();
		$this->Saturday->AdvancedSearch->Load();
	}

	// Set up sort parameters
	function SetUpSortOrder() {

		// Check for "order" parameter
		if (@$_GET["order"] <> "") {
			$this->CurrentOrder = ew_StripSlashes(@$_GET["order"]);
			$this->CurrentOrderType = @$_GET["ordertype"];
			$this->UpdateSort($this->description); // description
			$this->UpdateSort($this->dbkey); // dbkey
			$this->UpdateSort($this->First); // First
			$this->UpdateSort($this->Last); // Last
			$this->UpdateSort($this->Total_Hours); // Total Hours
			$this->UpdateSort($this->Week_23); // Week #
			$this->UpdateSort($this->From_Date); // From Date
			$this->UpdateSort($this->Through_Date); // Through Date
			$this->UpdateSort($this->Sunday); // Sunday
			$this->UpdateSort($this->Monday); // Monday
			$this->UpdateSort($this->Tuesday); // Tuesday
			$this->UpdateSort($this->Wednesday); // Wednesday
			$this->UpdateSort($this->Thursday); // Thursday
			$this->UpdateSort($this->Friday); // Friday
			$this->UpdateSort($this->Saturday); // Saturday
			$this->setStartRecordNumber(1); // Reset start position
		}
	}

	// Load sort order parameters
	function LoadSortOrder() {
		$sOrderBy = $this->getSessionOrderBy(); // Get ORDER BY from Session
		if ($sOrderBy == "") {
			if ($this->getSqlOrderBy() <> "") {
				$sOrderBy = $this->getSqlOrderBy();
				$this->setSessionOrderBy($sOrderBy);
				$this->description->setSort("DESC");
				$this->dbkey->setSort("DESC");
			}
		}
	}

	// Reset command
	// - cmd=reset (Reset search parameters)
	// - cmd=resetall (Reset search and master/detail parameters)
	// - cmd=resetsort (Reset sort parameters)
	function ResetCmd() {

		// Check if reset command
		if (substr($this->Command,0,5) == "reset") {

			// Reset search criteria
			if ($this->Command == "reset" || $this->Command == "resetall")
				$this->ResetSearchParms();

			// Reset sorting order
			if ($this->Command == "resetsort") {
				$sOrderBy = "";
				$this->setSessionOrderBy($sOrderBy);
				$this->description->setSort("");
				$this->dbkey->setSort("");
				$this->First->setSort("");
				$this->Last->setSort("");
				$this->Total_Hours->setSort("");
				$this->Week_23->setSort("");
				$this->From_Date->setSort("");
				$this->Through_Date->setSort("");
				$this->Sunday->setSort("");
				$this->Monday->setSort("");
				$this->Tuesday->setSort("");
				$this->Wednesday->setSort("");
				$this->Thursday->setSort("");
				$this->Friday->setSort("");
				$this->Saturday->setSort("");
			}

			// Reset start position
			$this->StartRec = 1;
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Set up list options
	function SetupListOptions() {
		global $Security, $Language;

		// Add group option item
		$item = &$this->ListOptions->Add($this->ListOptions->GroupOptionName);
		$item->Body = "";
		$item->OnLeft = FALSE;
		$item->Visible = FALSE;

		// List actions
		$item = &$this->ListOptions->Add("listactions");
		$item->CssStyle = "white-space: nowrap;";
		$item->OnLeft = FALSE;
		$item->Visible = FALSE;
		$item->ShowInButtonGroup = FALSE;
		$item->ShowInDropDown = FALSE;

		// "checkbox"
		$item = &$this->ListOptions->Add("checkbox");
		$item->Visible = FALSE;
		$item->OnLeft = FALSE;
		$item->Header = "<input type=\"checkbox\" name=\"key\" id=\"key\" onclick=\"ew_SelectAllKey(this);\">";
		$item->ShowInDropDown = FALSE;
		$item->ShowInButtonGroup = FALSE;

		// Drop down button for ListOptions
		$this->ListOptions->UseImageAndText = TRUE;
		$this->ListOptions->UseDropDownButton = FALSE;
		$this->ListOptions->DropDownButtonPhrase = $Language->Phrase("ButtonListOptions");
		$this->ListOptions->UseButtonGroup = FALSE;
		if ($this->ListOptions->UseButtonGroup && ew_IsMobile())
			$this->ListOptions->UseDropDownButton = TRUE;
		$this->ListOptions->ButtonClass = "btn-sm"; // Class for button group

		// Call ListOptions_Load event
		$this->ListOptions_Load();
		$this->SetupListOptionsExt();
		$item = &$this->ListOptions->GetItem($this->ListOptions->GroupOptionName);
		$item->Visible = $this->ListOptions->GroupOptionVisible();
	}

	// Render list options
	function RenderListOptions() {
		global $Security, $Language, $objForm;
		$this->ListOptions->LoadDefault();

		// Set up list action buttons
		$oListOpt = &$this->ListOptions->GetItem("listactions");
		if ($oListOpt && $this->Export == "" && $this->CurrentAction == "") {
			$body = "";
			$links = array();
			foreach ($this->ListActions->Items as $listaction) {
				if ($listaction->Select == EW_ACTION_SINGLE && $listaction->Allow) {
					$action = $listaction->Action;
					$caption = $listaction->Caption;
					$icon = ($listaction->Icon <> "") ? "<span class=\"" . ew_HtmlEncode(str_replace(" ewIcon", "", $listaction->Icon)) . "\" data-caption=\"" . ew_HtmlTitle($caption) . "\"></span> " : "";
					$links[] = "<li><a class=\"ewAction ewListAction\" data-action=\"" . ew_HtmlEncode($action) . "\" data-caption=\"" . ew_HtmlTitle($caption) . "\" href=\"\" onclick=\"ew_SubmitAction(event,jQuery.extend({key:" . $this->KeyToJson() . "}," . $listaction->ToJson(TRUE) . "));return false;\">" . $icon . $listaction->Caption . "</a></li>";
					if (count($links) == 1) // Single button
						$body = "<a class=\"ewAction ewListAction\" data-action=\"" . ew_HtmlEncode($action) . "\" title=\"" . ew_HtmlTitle($caption) . "\" data-caption=\"" . ew_HtmlTitle($caption) . "\" href=\"\" onclick=\"ew_SubmitAction(event,jQuery.extend({key:" . $this->KeyToJson() . "}," . $listaction->ToJson(TRUE) . "));return false;\">" . $Language->Phrase("ListActionButton") . "</a>";
				}
			}
			if (count($links) > 1) { // More than one buttons, use dropdown
				$body = "<button class=\"dropdown-toggle btn btn-default btn-sm ewActions\" title=\"" . ew_HtmlTitle($Language->Phrase("ListActionButton")) . "\" data-toggle=\"dropdown\">" . $Language->Phrase("ListActionButton") . "<b class=\"caret\"></b></button>";
				$content = "";
				foreach ($links as $link)
					$content .= "<li>" . $link . "</li>";
				$body .= "<ul class=\"dropdown-menu" . ($oListOpt->OnLeft ? "" : " dropdown-menu-right") . "\">". $content . "</ul>";
				$body = "<div class=\"btn-group\">" . $body . "</div>";
			}
			if (count($links) > 0) {
				$oListOpt->Body = $body;
				$oListOpt->Visible = TRUE;
			}
		}

		// "checkbox"
		$oListOpt = &$this->ListOptions->Items["checkbox"];
		$this->RenderListOptionsExt();

		// Call ListOptions_Rendered event
		$this->ListOptions_Rendered();
	}

	// Set up other options
	function SetupOtherOptions() {
		global $Language, $Security;
		$options = &$this->OtherOptions;
		$option = $options["action"];

		// Set up options default
		foreach ($options as &$option) {
			$option->UseImageAndText = TRUE;
			$option->UseDropDownButton = FALSE;
			$option->UseButtonGroup = TRUE;
			$option->ButtonClass = "btn-sm"; // Class for button group
			$item = &$option->Add($option->GroupOptionName);
			$item->Body = "";
			$item->Visible = FALSE;
		}
		$options["addedit"]->DropDownButtonPhrase = $Language->Phrase("ButtonAddEdit");
		$options["detail"]->DropDownButtonPhrase = $Language->Phrase("ButtonDetails");
		$options["action"]->DropDownButtonPhrase = $Language->Phrase("ButtonActions");

		// Filter button
		$item = &$this->FilterOptions->Add("savecurrentfilter");
		$item->Body = "<a class=\"ewSaveFilter\" data-form=\"fCust_Rpt_Client_Activity_Weeklistsrch\" href=\"#\">" . $Language->Phrase("SaveCurrentFilter") . "</a>";
		$item->Visible = TRUE;
		$item = &$this->FilterOptions->Add("deletefilter");
		$item->Body = "<a class=\"ewDeleteFilter\" data-form=\"fCust_Rpt_Client_Activity_Weeklistsrch\" href=\"#\">" . $Language->Phrase("DeleteFilter") . "</a>";
		$item->Visible = TRUE;
		$this->FilterOptions->UseDropDownButton = TRUE;
		$this->FilterOptions->UseButtonGroup = !$this->FilterOptions->UseDropDownButton;
		$this->FilterOptions->DropDownButtonPhrase = $Language->Phrase("Filters");

		// Add group option item
		$item = &$this->FilterOptions->Add($this->FilterOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;
	}

	// Render other options
	function RenderOtherOptions() {
		global $Language, $Security;
		$options = &$this->OtherOptions;
			$option = &$options["action"];

			// Set up list action buttons
			foreach ($this->ListActions->Items as $listaction) {
				if ($listaction->Select == EW_ACTION_MULTIPLE) {
					$item = &$option->Add("custom_" . $listaction->Action);
					$caption = $listaction->Caption;
					$icon = ($listaction->Icon <> "") ? "<span class=\"" . ew_HtmlEncode($listaction->Icon) . "\" data-caption=\"" . ew_HtmlEncode($caption) . "\"></span> " : $caption;
					$item->Body = "<a class=\"ewAction ewListAction\" title=\"" . ew_HtmlEncode($caption) . "\" data-caption=\"" . ew_HtmlEncode($caption) . "\" href=\"\" onclick=\"ew_SubmitAction(event,jQuery.extend({f:document.fCust_Rpt_Client_Activity_Weeklist}," . $listaction->ToJson(TRUE) . "));return false;\">" . $icon . "</a>";
					$item->Visible = $listaction->Allow;
				}
			}

			// Hide grid edit and other options
			if ($this->TotalRecs <= 0) {
				$option = &$options["addedit"];
				$item = &$option->GetItem("gridedit");
				if ($item) $item->Visible = FALSE;
				$option = &$options["action"];
				$option->HideAllOptions();
			}
	}

	// Process list action
	function ProcessListAction() {
		global $Language, $Security;
		$userlist = "";
		$user = "";
		$sFilter = $this->GetKeyFilter();
		$UserAction = @$_POST["useraction"];
		if ($sFilter <> "" && $UserAction <> "") {

			// Check permission first
			$ActionCaption = $UserAction;
			if (array_key_exists($UserAction, $this->ListActions->Items)) {
				$ActionCaption = $this->ListActions->Items[$UserAction]->Caption;
				if (!$this->ListActions->Items[$UserAction]->Allow) {
					$errmsg = str_replace('%s', $ActionCaption, $Language->Phrase("CustomActionNotAllowed"));
					if (@$_POST["ajax"] == $UserAction) // Ajax
						echo "<p class=\"text-danger\">" . $errmsg . "</p>";
					else
						$this->setFailureMessage($errmsg);
					return FALSE;
				}
			}
			$this->CurrentFilter = $sFilter;
			$sSql = $this->SQL();
			$conn = &$this->Connection();
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			$rs = $conn->Execute($sSql);
			$conn->raiseErrorFn = '';
			$this->CurrentAction = $UserAction;

			// Call row action event
			if ($rs && !$rs->EOF) {
				$conn->BeginTrans();
				$this->SelectedCount = $rs->RecordCount();
				$this->SelectedIndex = 0;
				while (!$rs->EOF) {
					$this->SelectedIndex++;
					$row = $rs->fields;
					$Processed = $this->Row_CustomAction($UserAction, $row);
					if (!$Processed) break;
					$rs->MoveNext();
				}
				if ($Processed) {
					$conn->CommitTrans(); // Commit the changes
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage(str_replace('%s', $ActionCaption, $Language->Phrase("CustomActionCompleted"))); // Set up success message
				} else {
					$conn->RollbackTrans(); // Rollback changes

					// Set up error message
					if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

						// Use the message, do nothing
					} elseif ($this->CancelMessage <> "") {
						$this->setFailureMessage($this->CancelMessage);
						$this->CancelMessage = "";
					} else {
						$this->setFailureMessage(str_replace('%s', $ActionCaption, $Language->Phrase("CustomActionFailed")));
					}
				}
			}
			if ($rs)
				$rs->Close();
			$this->CurrentAction = ""; // Clear action
			if (@$_POST["ajax"] == $UserAction) { // Ajax
				if ($this->getSuccessMessage() <> "") {
					echo "<p class=\"text-success\">" . $this->getSuccessMessage() . "</p>";
					$this->ClearSuccessMessage(); // Clear message
				}
				if ($this->getFailureMessage() <> "") {
					echo "<p class=\"text-danger\">" . $this->getFailureMessage() . "</p>";
					$this->ClearFailureMessage(); // Clear message
				}
				return TRUE;
			}
		}
		return FALSE; // Not ajax request
	}

	// Set up search options
	function SetupSearchOptions() {
		global $Language;
		$this->SearchOptions = new cListOptions();
		$this->SearchOptions->Tag = "div";
		$this->SearchOptions->TagClassName = "ewSearchOption";

		// Search button
		$item = &$this->SearchOptions->Add("searchtoggle");
		$SearchToggleClass = ($this->SearchWhere <> "") ? " active" : " active";
		$item->Body = "<button type=\"button\" class=\"btn btn-default ewSearchToggle" . $SearchToggleClass . "\" title=\"" . $Language->Phrase("SearchPanel") . "\" data-caption=\"" . $Language->Phrase("SearchPanel") . "\" data-toggle=\"button\" data-form=\"fCust_Rpt_Client_Activity_Weeklistsrch\">" . $Language->Phrase("SearchBtn") . "</button>";
		$item->Visible = TRUE;

		// Show all button
		$item = &$this->SearchOptions->Add("showall");
		$item->Body = "<a class=\"btn btn-default ewShowAll\" title=\"" . $Language->Phrase("ShowAll") . "\" data-caption=\"" . $Language->Phrase("ShowAll") . "\" href=\"" . $this->PageUrl() . "cmd=reset\">" . $Language->Phrase("ShowAllBtn") . "</a>";
		$item->Visible = ($this->SearchWhere <> $this->DefaultSearchWhere && $this->SearchWhere <> "0=101");

		// Advanced search button
		$item = &$this->SearchOptions->Add("advancedsearch");
		$item->Body = "<a class=\"btn btn-default ewAdvancedSearch\" title=\"" . $Language->Phrase("AdvancedSearch") . "\" data-caption=\"" . $Language->Phrase("AdvancedSearch") . "\" href=\"Cust_Rpt_Client_Activity_Weeksrch.php\">" . $Language->Phrase("AdvancedSearchBtn") . "</a>";
		$item->Visible = TRUE;

		// Button group for search
		$this->SearchOptions->UseDropDownButton = FALSE;
		$this->SearchOptions->UseImageAndText = TRUE;
		$this->SearchOptions->UseButtonGroup = TRUE;
		$this->SearchOptions->DropDownButtonPhrase = $Language->Phrase("ButtonSearch");

		// Add group option item
		$item = &$this->SearchOptions->Add($this->SearchOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;

		// Hide search options
		if ($this->Export <> "" || $this->CurrentAction <> "")
			$this->SearchOptions->HideAllOptions();
		global $Security;
		if (!$Security->CanSearch()) {
			$this->SearchOptions->HideAllOptions();
			$this->FilterOptions->HideAllOptions();
		}
	}

	function SetupListOptionsExt() {
		global $Security, $Language;
	}

	function RenderListOptionsExt() {
		global $Security, $Language;
	}

	// Set up starting record parameters
	function SetUpStartRec() {
		if ($this->DisplayRecs == 0)
			return;
		if ($this->IsPageRequest()) { // Validate request
			if (@$_GET[EW_TABLE_START_REC] <> "") { // Check for "start" parameter
				$this->StartRec = $_GET[EW_TABLE_START_REC];
				$this->setStartRecordNumber($this->StartRec);
			} elseif (@$_GET[EW_TABLE_PAGE_NO] <> "") {
				$PageNo = $_GET[EW_TABLE_PAGE_NO];
				if (is_numeric($PageNo)) {
					$this->StartRec = ($PageNo-1)*$this->DisplayRecs+1;
					if ($this->StartRec <= 0) {
						$this->StartRec = 1;
					} elseif ($this->StartRec >= intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1) {
						$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1;
					}
					$this->setStartRecordNumber($this->StartRec);
				}
			}
		}
		$this->StartRec = $this->getStartRecordNumber();

		// Check if correct start record counter
		if (!is_numeric($this->StartRec) || $this->StartRec == "") { // Avoid invalid start record counter
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} elseif (intval($this->StartRec) > intval($this->TotalRecs)) { // Avoid starting record > total records
			$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to last page first record
			$this->setStartRecordNumber($this->StartRec);
		} elseif (($this->StartRec-1) % $this->DisplayRecs <> 0) {
			$this->StartRec = intval(($this->StartRec-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to page boundary
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Load basic search values
	function LoadBasicSearchValues() {
		$this->BasicSearch->Keyword = @$_GET[EW_TABLE_BASIC_SEARCH];
		if ($this->BasicSearch->Keyword <> "") $this->Command = "search";
		$this->BasicSearch->Type = @$_GET[EW_TABLE_BASIC_SEARCH_TYPE];
	}

	// Load search values for validation
	function LoadSearchValues() {
		global $objForm;

		// Load search values
		// description

		$this->description->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_description"]);
		if ($this->description->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->description->AdvancedSearch->SearchOperator = @$_GET["z_description"];

		// dbkey
		$this->dbkey->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_dbkey"]);
		if ($this->dbkey->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->dbkey->AdvancedSearch->SearchOperator = @$_GET["z_dbkey"];

		// First
		$this->First->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_First"]);
		if ($this->First->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->First->AdvancedSearch->SearchOperator = @$_GET["z_First"];

		// Last
		$this->Last->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_Last"]);
		if ($this->Last->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->Last->AdvancedSearch->SearchOperator = @$_GET["z_Last"];

		// Total Hours
		$this->Total_Hours->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_Total_Hours"]);
		if ($this->Total_Hours->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->Total_Hours->AdvancedSearch->SearchOperator = @$_GET["z_Total_Hours"];

		// Week #
		$this->Week_23->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_Week_23"]);
		if ($this->Week_23->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->Week_23->AdvancedSearch->SearchOperator = @$_GET["z_Week_23"];

		// From Date
		$this->From_Date->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_From_Date"]);
		if ($this->From_Date->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->From_Date->AdvancedSearch->SearchOperator = @$_GET["z_From_Date"];

		// Through Date
		$this->Through_Date->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_Through_Date"]);
		if ($this->Through_Date->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->Through_Date->AdvancedSearch->SearchOperator = @$_GET["z_Through_Date"];

		// Sunday
		$this->Sunday->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_Sunday"]);
		if ($this->Sunday->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->Sunday->AdvancedSearch->SearchOperator = @$_GET["z_Sunday"];

		// Monday
		$this->Monday->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_Monday"]);
		if ($this->Monday->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->Monday->AdvancedSearch->SearchOperator = @$_GET["z_Monday"];

		// Tuesday
		$this->Tuesday->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_Tuesday"]);
		if ($this->Tuesday->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->Tuesday->AdvancedSearch->SearchOperator = @$_GET["z_Tuesday"];

		// Wednesday
		$this->Wednesday->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_Wednesday"]);
		if ($this->Wednesday->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->Wednesday->AdvancedSearch->SearchOperator = @$_GET["z_Wednesday"];

		// Thursday
		$this->Thursday->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_Thursday"]);
		if ($this->Thursday->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->Thursday->AdvancedSearch->SearchOperator = @$_GET["z_Thursday"];

		// Friday
		$this->Friday->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_Friday"]);
		if ($this->Friday->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->Friday->AdvancedSearch->SearchOperator = @$_GET["z_Friday"];

		// Saturday
		$this->Saturday->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_Saturday"]);
		if ($this->Saturday->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->Saturday->AdvancedSearch->SearchOperator = @$_GET["z_Saturday"];
	}

	// Load recordset
	function LoadRecordset($offset = -1, $rowcnt = -1) {

		// Load List page SQL
		$sSql = $this->SelectSQL();
		$conn = &$this->Connection();

		// Load recordset
		$dbtype = ew_GetConnectionType($this->DBID);
		if ($this->UseSelectLimit) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			if ($dbtype == "MSSQL") {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset, array("_hasOrderBy" => trim($this->getOrderBy()) || trim($this->getSessionOrderBy())));
			} else {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset);
			}
			$conn->raiseErrorFn = '';
		} else {
			$rs = ew_LoadRecordset($sSql, $conn);
		}

		// Call Recordset Selected event
		$this->Recordset_Selected($rs);
		return $rs;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->description->setDbValue($rs->fields('description'));
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->First->setDbValue($rs->fields('First'));
		$this->Last->setDbValue($rs->fields('Last'));
		$this->Total_Hours->setDbValue($rs->fields('Total Hours'));
		$this->Week_23->setDbValue($rs->fields('Week #'));
		$this->From_Date->setDbValue($rs->fields('From Date'));
		$this->Through_Date->setDbValue($rs->fields('Through Date'));
		$this->Sunday->setDbValue($rs->fields('Sunday'));
		$this->Monday->setDbValue($rs->fields('Monday'));
		$this->Tuesday->setDbValue($rs->fields('Tuesday'));
		$this->Wednesday->setDbValue($rs->fields('Wednesday'));
		$this->Thursday->setDbValue($rs->fields('Thursday'));
		$this->Friday->setDbValue($rs->fields('Friday'));
		$this->Saturday->setDbValue($rs->fields('Saturday'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->description->DbValue = $row['description'];
		$this->dbkey->DbValue = $row['dbkey'];
		$this->First->DbValue = $row['First'];
		$this->Last->DbValue = $row['Last'];
		$this->Total_Hours->DbValue = $row['Total Hours'];
		$this->Week_23->DbValue = $row['Week #'];
		$this->From_Date->DbValue = $row['From Date'];
		$this->Through_Date->DbValue = $row['Through Date'];
		$this->Sunday->DbValue = $row['Sunday'];
		$this->Monday->DbValue = $row['Monday'];
		$this->Tuesday->DbValue = $row['Tuesday'];
		$this->Wednesday->DbValue = $row['Wednesday'];
		$this->Thursday->DbValue = $row['Thursday'];
		$this->Friday->DbValue = $row['Friday'];
		$this->Saturday->DbValue = $row['Saturday'];
	}

	// Load old record
	function LoadOldRecord() {

		// Load key values from Session
		$bValidKey = TRUE;

		// Load old recordset
		if ($bValidKey) {
			$this->CurrentFilter = $this->KeyFilter();
			$sSql = $this->SQL();
			$conn = &$this->Connection();
			$this->OldRecordset = ew_LoadRecordset($sSql, $conn);
			$this->LoadRowValues($this->OldRecordset); // Load row values
		} else {
			$this->OldRecordset = NULL;
		}
		return $bValidKey;
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		$this->ViewUrl = $this->GetViewUrl();
		$this->EditUrl = $this->GetEditUrl();
		$this->InlineEditUrl = $this->GetInlineEditUrl();
		$this->CopyUrl = $this->GetCopyUrl();
		$this->InlineCopyUrl = $this->GetInlineCopyUrl();
		$this->DeleteUrl = $this->GetDeleteUrl();

		// Convert decimal values if posted back
		if ($this->Total_Hours->FormValue == $this->Total_Hours->CurrentValue && is_numeric(ew_StrToFloat($this->Total_Hours->CurrentValue)))
			$this->Total_Hours->CurrentValue = ew_StrToFloat($this->Total_Hours->CurrentValue);

		// Convert decimal values if posted back
		if ($this->Sunday->FormValue == $this->Sunday->CurrentValue && is_numeric(ew_StrToFloat($this->Sunday->CurrentValue)))
			$this->Sunday->CurrentValue = ew_StrToFloat($this->Sunday->CurrentValue);

		// Convert decimal values if posted back
		if ($this->Monday->FormValue == $this->Monday->CurrentValue && is_numeric(ew_StrToFloat($this->Monday->CurrentValue)))
			$this->Monday->CurrentValue = ew_StrToFloat($this->Monday->CurrentValue);

		// Convert decimal values if posted back
		if ($this->Tuesday->FormValue == $this->Tuesday->CurrentValue && is_numeric(ew_StrToFloat($this->Tuesday->CurrentValue)))
			$this->Tuesday->CurrentValue = ew_StrToFloat($this->Tuesday->CurrentValue);

		// Convert decimal values if posted back
		if ($this->Wednesday->FormValue == $this->Wednesday->CurrentValue && is_numeric(ew_StrToFloat($this->Wednesday->CurrentValue)))
			$this->Wednesday->CurrentValue = ew_StrToFloat($this->Wednesday->CurrentValue);

		// Convert decimal values if posted back
		if ($this->Thursday->FormValue == $this->Thursday->CurrentValue && is_numeric(ew_StrToFloat($this->Thursday->CurrentValue)))
			$this->Thursday->CurrentValue = ew_StrToFloat($this->Thursday->CurrentValue);

		// Convert decimal values if posted back
		if ($this->Friday->FormValue == $this->Friday->CurrentValue && is_numeric(ew_StrToFloat($this->Friday->CurrentValue)))
			$this->Friday->CurrentValue = ew_StrToFloat($this->Friday->CurrentValue);

		// Convert decimal values if posted back
		if ($this->Saturday->FormValue == $this->Saturday->CurrentValue && is_numeric(ew_StrToFloat($this->Saturday->CurrentValue)))
			$this->Saturday->CurrentValue = ew_StrToFloat($this->Saturday->CurrentValue);

		// Call Row_Rendering event
		$this->Row_Rendering();

		// Common render codes for all row types
		// description
		// dbkey
		// First
		// Last
		// Total Hours
		// Week #
		// From Date
		// Through Date
		// Sunday
		// Monday
		// Tuesday
		// Wednesday
		// Thursday
		// Friday
		// Saturday

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// description
		$this->description->ViewValue = $this->description->CurrentValue;
		$this->description->ViewCustomAttributes = "";

		// dbkey
		$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// First
		$this->First->ViewValue = $this->First->CurrentValue;
		$this->First->ViewCustomAttributes = "";

		// Last
		$this->Last->ViewValue = $this->Last->CurrentValue;
		$this->Last->ViewCustomAttributes = "";

		// Total Hours
		$this->Total_Hours->ViewValue = $this->Total_Hours->CurrentValue;
		$this->Total_Hours->ViewCustomAttributes = "";

		// Week #
		$this->Week_23->ViewValue = $this->Week_23->CurrentValue;
		$this->Week_23->ViewCustomAttributes = "";

		// From Date
		$this->From_Date->ViewValue = $this->From_Date->CurrentValue;
		$this->From_Date->ViewValue = ew_FormatDateTime($this->From_Date->ViewValue, 0);
		$this->From_Date->ViewCustomAttributes = "";

		// Through Date
		$this->Through_Date->ViewValue = $this->Through_Date->CurrentValue;
		$this->Through_Date->ViewValue = ew_FormatDateTime($this->Through_Date->ViewValue, 0);
		$this->Through_Date->ViewCustomAttributes = "";

		// Sunday
		$this->Sunday->ViewValue = $this->Sunday->CurrentValue;
		$this->Sunday->ViewCustomAttributes = "";

		// Monday
		$this->Monday->ViewValue = $this->Monday->CurrentValue;
		$this->Monday->ViewCustomAttributes = "";

		// Tuesday
		$this->Tuesday->ViewValue = $this->Tuesday->CurrentValue;
		$this->Tuesday->ViewCustomAttributes = "";

		// Wednesday
		$this->Wednesday->ViewValue = $this->Wednesday->CurrentValue;
		$this->Wednesday->ViewCustomAttributes = "";

		// Thursday
		$this->Thursday->ViewValue = $this->Thursday->CurrentValue;
		$this->Thursday->ViewCustomAttributes = "";

		// Friday
		$this->Friday->ViewValue = $this->Friday->CurrentValue;
		$this->Friday->ViewCustomAttributes = "";

		// Saturday
		$this->Saturday->ViewValue = $this->Saturday->CurrentValue;
		$this->Saturday->ViewCustomAttributes = "";

			// description
			$this->description->LinkCustomAttributes = "";
			$this->description->HrefValue = "";
			$this->description->TooltipValue = "";

			// dbkey
			$this->dbkey->LinkCustomAttributes = "";
			$this->dbkey->HrefValue = "";
			$this->dbkey->TooltipValue = "";

			// First
			$this->First->LinkCustomAttributes = "";
			$this->First->HrefValue = "";
			$this->First->TooltipValue = "";

			// Last
			$this->Last->LinkCustomAttributes = "";
			$this->Last->HrefValue = "";
			$this->Last->TooltipValue = "";

			// Total Hours
			$this->Total_Hours->LinkCustomAttributes = "";
			$this->Total_Hours->HrefValue = "";
			$this->Total_Hours->TooltipValue = "";

			// Week #
			$this->Week_23->LinkCustomAttributes = "";
			$this->Week_23->HrefValue = "";
			$this->Week_23->TooltipValue = "";

			// From Date
			$this->From_Date->LinkCustomAttributes = "";
			$this->From_Date->HrefValue = "";
			$this->From_Date->TooltipValue = "";

			// Through Date
			$this->Through_Date->LinkCustomAttributes = "";
			$this->Through_Date->HrefValue = "";
			$this->Through_Date->TooltipValue = "";

			// Sunday
			$this->Sunday->LinkCustomAttributes = "";
			$this->Sunday->HrefValue = "";
			$this->Sunday->TooltipValue = "";

			// Monday
			$this->Monday->LinkCustomAttributes = "";
			$this->Monday->HrefValue = "";
			$this->Monday->TooltipValue = "";

			// Tuesday
			$this->Tuesday->LinkCustomAttributes = "";
			$this->Tuesday->HrefValue = "";
			$this->Tuesday->TooltipValue = "";

			// Wednesday
			$this->Wednesday->LinkCustomAttributes = "";
			$this->Wednesday->HrefValue = "";
			$this->Wednesday->TooltipValue = "";

			// Thursday
			$this->Thursday->LinkCustomAttributes = "";
			$this->Thursday->HrefValue = "";
			$this->Thursday->TooltipValue = "";

			// Friday
			$this->Friday->LinkCustomAttributes = "";
			$this->Friday->HrefValue = "";
			$this->Friday->TooltipValue = "";

			// Saturday
			$this->Saturday->LinkCustomAttributes = "";
			$this->Saturday->HrefValue = "";
			$this->Saturday->TooltipValue = "";
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate search
	function ValidateSearch() {
		global $gsSearchError;

		// Initialize
		$gsSearchError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return TRUE;

		// Return validate result
		$ValidateSearch = ($gsSearchError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateSearch = $ValidateSearch && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsSearchError, $sFormCustomError);
		}
		return $ValidateSearch;
	}

	// Load advanced search
	function LoadAdvancedSearch() {
		$this->description->AdvancedSearch->Load();
		$this->dbkey->AdvancedSearch->Load();
		$this->First->AdvancedSearch->Load();
		$this->Last->AdvancedSearch->Load();
		$this->Total_Hours->AdvancedSearch->Load();
		$this->Week_23->AdvancedSearch->Load();
		$this->From_Date->AdvancedSearch->Load();
		$this->Through_Date->AdvancedSearch->Load();
		$this->Sunday->AdvancedSearch->Load();
		$this->Monday->AdvancedSearch->Load();
		$this->Tuesday->AdvancedSearch->Load();
		$this->Wednesday->AdvancedSearch->Load();
		$this->Thursday->AdvancedSearch->Load();
		$this->Friday->AdvancedSearch->Load();
		$this->Saturday->AdvancedSearch->Load();
	}

	// Set up export options
	function SetupExportOptions() {
		global $Language;

		// Printer friendly
		$item = &$this->ExportOptions->Add("print");
		$item->Body = "<a href=\"" . $this->ExportPrintUrl . "\" class=\"ewExportLink ewPrint\" title=\"" . ew_HtmlEncode($Language->Phrase("PrinterFriendlyText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("PrinterFriendlyText")) . "\">" . $Language->Phrase("PrinterFriendly") . "</a>";
		$item->Visible = TRUE;

		// Export to Excel
		$item = &$this->ExportOptions->Add("excel");
		$item->Body = "<a href=\"" . $this->ExportExcelUrl . "\" class=\"ewExportLink ewExcel\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToExcelText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToExcelText")) . "\">" . $Language->Phrase("ExportToExcel") . "</a>";
		$item->Visible = TRUE;

		// Export to Word
		$item = &$this->ExportOptions->Add("word");
		$item->Body = "<a href=\"" . $this->ExportWordUrl . "\" class=\"ewExportLink ewWord\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToWordText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToWordText")) . "\">" . $Language->Phrase("ExportToWord") . "</a>";
		$item->Visible = TRUE;

		// Export to Html
		$item = &$this->ExportOptions->Add("html");
		$item->Body = "<a href=\"" . $this->ExportHtmlUrl . "\" class=\"ewExportLink ewHtml\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToHtmlText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToHtmlText")) . "\">" . $Language->Phrase("ExportToHtml") . "</a>";
		$item->Visible = TRUE;

		// Export to Xml
		$item = &$this->ExportOptions->Add("xml");
		$item->Body = "<a href=\"" . $this->ExportXmlUrl . "\" class=\"ewExportLink ewXml\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToXmlText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToXmlText")) . "\">" . $Language->Phrase("ExportToXml") . "</a>";
		$item->Visible = FALSE;

		// Export to Csv
		$item = &$this->ExportOptions->Add("csv");
		$item->Body = "<a href=\"" . $this->ExportCsvUrl . "\" class=\"ewExportLink ewCsv\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToCsvText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToCsvText")) . "\">" . $Language->Phrase("ExportToCsv") . "</a>";
		$item->Visible = TRUE;

		// Export to Pdf
		$item = &$this->ExportOptions->Add("pdf");
		$item->Body = "<a href=\"" . $this->ExportPdfUrl . "\" class=\"ewExportLink ewPdf\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToPDFText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToPDFText")) . "\">" . $Language->Phrase("ExportToPDF") . "</a>";
		$item->Visible = TRUE;

		// Export to Email
		$item = &$this->ExportOptions->Add("email");
		$url = "";
		$item->Body = "<button id=\"emf_Cust_Rpt_Client_Activity_Week\" class=\"ewExportLink ewEmail\" title=\"" . $Language->Phrase("ExportToEmailText") . "\" data-caption=\"" . $Language->Phrase("ExportToEmailText") . "\" onclick=\"ew_EmailDialogShow({lnk:'emf_Cust_Rpt_Client_Activity_Week',hdr:ewLanguage.Phrase('ExportToEmailText'),f:document.fCust_Rpt_Client_Activity_Weeklist,sel:false" . $url . "});\">" . $Language->Phrase("ExportToEmail") . "</button>";
		$item->Visible = TRUE;

		// Drop down button for export
		$this->ExportOptions->UseButtonGroup = TRUE;
		$this->ExportOptions->UseImageAndText = TRUE;
		$this->ExportOptions->UseDropDownButton = FALSE;
		if ($this->ExportOptions->UseButtonGroup && ew_IsMobile())
			$this->ExportOptions->UseDropDownButton = TRUE;
		$this->ExportOptions->DropDownButtonPhrase = $Language->Phrase("ButtonExport");

		// Add group option item
		$item = &$this->ExportOptions->Add($this->ExportOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;
	}

	// Export data in HTML/CSV/Word/Excel/XML/Email/PDF format
	function ExportData() {
		$utf8 = (strtolower(EW_CHARSET) == "utf-8");
		$bSelectLimit = $this->UseSelectLimit;

		// Load recordset
		if ($bSelectLimit) {
			$this->TotalRecs = $this->SelectRecordCount();
		} else {
			if (!$this->Recordset)
				$this->Recordset = $this->LoadRecordset();
			$rs = &$this->Recordset;
			if ($rs)
				$this->TotalRecs = $rs->RecordCount();
		}
		$this->StartRec = 1;

		// Export all
		if ($this->ExportAll) {
			set_time_limit(EW_EXPORT_ALL_TIME_LIMIT);
			$this->DisplayRecs = $this->TotalRecs;
			$this->StopRec = $this->TotalRecs;
		} else { // Export one page only
			$this->SetUpStartRec(); // Set up start record position

			// Set the last record to display
			if ($this->DisplayRecs <= 0) {
				$this->StopRec = $this->TotalRecs;
			} else {
				$this->StopRec = $this->StartRec + $this->DisplayRecs - 1;
			}
		}
		if ($bSelectLimit)
			$rs = $this->LoadRecordset($this->StartRec-1, $this->DisplayRecs <= 0 ? $this->TotalRecs : $this->DisplayRecs);
		if (!$rs) {
			header("Content-Type:"); // Remove header
			header("Content-Disposition:");
			$this->ShowMessage();
			return;
		}
		$this->ExportDoc = ew_ExportDocument($this, "h");
		$Doc = &$this->ExportDoc;
		if ($bSelectLimit) {
			$this->StartRec = 1;
			$this->StopRec = $this->DisplayRecs <= 0 ? $this->TotalRecs : $this->DisplayRecs;
		} else {

			//$this->StartRec = $this->StartRec;
			//$this->StopRec = $this->StopRec;

		}

		// Call Page Exporting server event
		$this->ExportDoc->ExportCustom = !$this->Page_Exporting();
		$ParentTable = "";
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		$Doc->Text .= $sHeader;
		$this->ExportDocument($Doc, $rs, $this->StartRec, $this->StopRec, "");
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		$Doc->Text .= $sFooter;

		// Close recordset
		$rs->Close();

		// Call Page Exported server event
		$this->Page_Exported();

		// Export header and footer
		$Doc->ExportHeaderAndFooter();

		// Clean output buffer
		if (!EW_DEBUG_ENABLED && ob_get_length())
			ob_end_clean();

		// Write debug message if enabled
		if (EW_DEBUG_ENABLED && $this->Export <> "pdf")
			echo ew_DebugMsg();

		// Output data
		if ($this->Export == "email") {
			echo $this->ExportEmail($Doc->Text);
		} else {
			$Doc->Export();
		}
	}

	// Export email
	function ExportEmail($EmailContent) {
		global $gTmpImages, $Language;
		$sSender = @$_POST["sender"];
		$sRecipient = @$_POST["recipient"];
		$sCc = @$_POST["cc"];
		$sBcc = @$_POST["bcc"];
		$sContentType = @$_POST["contenttype"];

		// Subject
		$sSubject = ew_StripSlashes(@$_POST["subject"]);
		$sEmailSubject = $sSubject;

		// Message
		$sContent = ew_StripSlashes(@$_POST["message"]);
		$sEmailMessage = $sContent;

		// Check sender
		if ($sSender == "") {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterSenderEmail") . "</p>";
		}
		if (!ew_CheckEmail($sSender)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperSenderEmail") . "</p>";
		}

		// Check recipient
		if (!ew_CheckEmailList($sRecipient, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperRecipientEmail") . "</p>";
		}

		// Check cc
		if (!ew_CheckEmailList($sCc, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperCcEmail") . "</p>";
		}

		// Check bcc
		if (!ew_CheckEmailList($sBcc, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperBccEmail") . "</p>";
		}

		// Check email sent count
		if (!isset($_SESSION[EW_EXPORT_EMAIL_COUNTER]))
			$_SESSION[EW_EXPORT_EMAIL_COUNTER] = 0;
		if (intval($_SESSION[EW_EXPORT_EMAIL_COUNTER]) > EW_MAX_EMAIL_SENT_COUNT) {
			return "<p class=\"text-danger\">" . $Language->Phrase("ExceedMaxEmailExport") . "</p>";
		}

		// Send email
		$Email = new cEmail();
		$Email->Sender = $sSender; // Sender
		$Email->Recipient = $sRecipient; // Recipient
		$Email->Cc = $sCc; // Cc
		$Email->Bcc = $sBcc; // Bcc
		$Email->Subject = $sEmailSubject; // Subject
		$Email->Format = ($sContentType == "url") ? "text" : "html";
		if ($sEmailMessage <> "") {
			$sEmailMessage = ew_RemoveXSS($sEmailMessage);
			$sEmailMessage .= ($sContentType == "url") ? "\r\n\r\n" : "<br><br>";
		}
		if ($sContentType == "url") {
			$sUrl = ew_ConvertFullUrl(ew_CurrentPage() . "?" . $this->ExportQueryString());
			$sEmailMessage .= $sUrl; // Send URL only
		} else {
			foreach ($gTmpImages as $tmpimage)
				$Email->AddEmbeddedImage($tmpimage);
			$sEmailMessage .= ew_CleanEmailContent($EmailContent); // Send HTML
		}
		$Email->Content = $sEmailMessage; // Content
		$EventArgs = array();
		if ($this->Recordset) {
			$this->RecCnt = $this->StartRec - 1;
			$this->Recordset->MoveFirst();
			if ($this->StartRec > 1)
				$this->Recordset->Move($this->StartRec - 1);
			$EventArgs["rs"] = &$this->Recordset;
		}
		$bEmailSent = FALSE;
		if ($this->Email_Sending($Email, $EventArgs))
			$bEmailSent = $Email->Send();

		// Check email sent status
		if ($bEmailSent) {

			// Update email sent count
			$_SESSION[EW_EXPORT_EMAIL_COUNTER]++;

			// Sent email success
			return "<p class=\"text-success\">" . $Language->Phrase("SendEmailSuccess") . "</p>"; // Set up success message
		} else {

			// Sent email failure
			return "<p class=\"text-danger\">" . $Email->SendErrDescription . "</p>";
		}
	}

	// Export QueryString
	function ExportQueryString() {

		// Initialize
		$sQry = "export=html";

		// Build QueryString for search
		if ($this->BasicSearch->getKeyword() <> "") {
			$sQry .= "&" . EW_TABLE_BASIC_SEARCH . "=" . urlencode($this->BasicSearch->getKeyword()) . "&" . EW_TABLE_BASIC_SEARCH_TYPE . "=" . urlencode($this->BasicSearch->getType());
		}
		$this->AddSearchQueryString($sQry, $this->description); // description
		$this->AddSearchQueryString($sQry, $this->dbkey); // dbkey
		$this->AddSearchQueryString($sQry, $this->First); // First
		$this->AddSearchQueryString($sQry, $this->Last); // Last
		$this->AddSearchQueryString($sQry, $this->Total_Hours); // Total Hours
		$this->AddSearchQueryString($sQry, $this->Week_23); // Week #
		$this->AddSearchQueryString($sQry, $this->From_Date); // From Date
		$this->AddSearchQueryString($sQry, $this->Through_Date); // Through Date
		$this->AddSearchQueryString($sQry, $this->Sunday); // Sunday
		$this->AddSearchQueryString($sQry, $this->Monday); // Monday
		$this->AddSearchQueryString($sQry, $this->Tuesday); // Tuesday
		$this->AddSearchQueryString($sQry, $this->Wednesday); // Wednesday
		$this->AddSearchQueryString($sQry, $this->Thursday); // Thursday
		$this->AddSearchQueryString($sQry, $this->Friday); // Friday
		$this->AddSearchQueryString($sQry, $this->Saturday); // Saturday

		// Build QueryString for pager
		$sQry .= "&" . EW_TABLE_REC_PER_PAGE . "=" . urlencode($this->getRecordsPerPage()) . "&" . EW_TABLE_START_REC . "=" . urlencode($this->getStartRecordNumber());
		return $sQry;
	}

	// Add search QueryString
	function AddSearchQueryString(&$Qry, &$Fld) {
		$FldSearchValue = $Fld->AdvancedSearch->getValue("x");
		$FldParm = substr($Fld->FldVar,2);
		if (strval($FldSearchValue) <> "") {
			$Qry .= "&x_" . $FldParm . "=" . urlencode($FldSearchValue) .
				"&z_" . $FldParm . "=" . urlencode($Fld->AdvancedSearch->getValue("z"));
		}
		$FldSearchValue2 = $Fld->AdvancedSearch->getValue("y");
		if (strval($FldSearchValue2) <> "") {
			$Qry .= "&v_" . $FldParm . "=" . urlencode($Fld->AdvancedSearch->getValue("v")) .
				"&y_" . $FldParm . "=" . urlencode($FldSearchValue2) .
				"&w_" . $FldParm . "=" . urlencode($Fld->AdvancedSearch->getValue("w"));
		}
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$url = preg_replace('/\?cmd=reset(all){0,1}$/i', '', $url); // Remove cmd=reset / cmd=resetall
		$Breadcrumb->Add("list", $this->TableVar, $url, "", $this->TableVar, TRUE);
	}

	// Setup lookup filters of a field
	function SetupLookupFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Setup AutoSuggest filters of a field
	function SetupAutoSuggestFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}

	// ListOptions Load event
	function ListOptions_Load() {

		// Example:
		//$opt = &$this->ListOptions->Add("new");
		//$opt->Header = "xxx";
		//$opt->OnLeft = TRUE; // Link on left
		//$opt->MoveTo(0); // Move to first column

	}

	// ListOptions Rendered event
	function ListOptions_Rendered() {

		// Example: 
		//$this->ListOptions->Items["new"]->Body = "xxx";

	}

	// Row Custom Action event
	function Row_CustomAction($action, $row) {

		// Return FALSE to abort
		return TRUE;
	}

	// Page Exporting event
	// $this->ExportDoc = export document object
	function Page_Exporting() {

		//$this->ExportDoc->Text = "my header"; // Export header
		//return FALSE; // Return FALSE to skip default export and use Row_Export event

		return TRUE; // Return TRUE to use default export and skip Row_Export event
	}

	// Row Export event
	// $this->ExportDoc = export document object
	function Row_Export($rs) {

		//$this->ExportDoc->Text .= "my content"; // Build HTML with field value: $rs["MyField"] or $this->MyField->ViewValue
	}

	// Page Exported event
	// $this->ExportDoc = export document object
	function Page_Exported() {

		//$this->ExportDoc->Text .= "my footer"; // Export footer
		//echo $this->ExportDoc->Text;

	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($Cust_Rpt_Client_Activity_Week_list)) $Cust_Rpt_Client_Activity_Week_list = new cCust_Rpt_Client_Activity_Week_list();

// Page init
$Cust_Rpt_Client_Activity_Week_list->Page_Init();

// Page main
$Cust_Rpt_Client_Activity_Week_list->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$Cust_Rpt_Client_Activity_Week_list->Page_Render();
?>
<?php include_once "header.php" ?>
<?php if ($Cust_Rpt_Client_Activity_Week->Export == "") { ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "list";
var CurrentForm = fCust_Rpt_Client_Activity_Weeklist = new ew_Form("fCust_Rpt_Client_Activity_Weeklist", "list");
fCust_Rpt_Client_Activity_Weeklist.FormKeyCountName = '<?php echo $Cust_Rpt_Client_Activity_Week_list->FormKeyCountName ?>';

// Form_CustomValidate event
fCust_Rpt_Client_Activity_Weeklist.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fCust_Rpt_Client_Activity_Weeklist.ValidateRequired = true;
<?php } else { ?>
fCust_Rpt_Client_Activity_Weeklist.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
// Form object for search

var CurrentSearchForm = fCust_Rpt_Client_Activity_Weeklistsrch = new ew_Form("fCust_Rpt_Client_Activity_Weeklistsrch");
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php } ?>
<?php if ($Cust_Rpt_Client_Activity_Week->Export == "") { ?>
<div class="ewToolbar">
<?php if ($Cust_Rpt_Client_Activity_Week->Export == "") { ?>
<?php $Breadcrumb->Render(); ?>
<?php } ?>
<?php if ($Cust_Rpt_Client_Activity_Week_list->TotalRecs > 0 && $Cust_Rpt_Client_Activity_Week_list->ExportOptions->Visible()) { ?>
<?php $Cust_Rpt_Client_Activity_Week_list->ExportOptions->Render("body") ?>
<?php } ?>
<?php if ($Cust_Rpt_Client_Activity_Week_list->SearchOptions->Visible()) { ?>
<?php $Cust_Rpt_Client_Activity_Week_list->SearchOptions->Render("body") ?>
<?php } ?>
<?php if ($Cust_Rpt_Client_Activity_Week_list->FilterOptions->Visible()) { ?>
<?php $Cust_Rpt_Client_Activity_Week_list->FilterOptions->Render("body") ?>
<?php } ?>
<?php if ($Cust_Rpt_Client_Activity_Week->Export == "") { ?>
<?php echo $Language->SelectionForm(); ?>
<?php } ?>
<div class="clearfix"></div>
</div>
<?php } ?>
<?php
	$bSelectLimit = $Cust_Rpt_Client_Activity_Week_list->UseSelectLimit;
	if ($bSelectLimit) {
		if ($Cust_Rpt_Client_Activity_Week_list->TotalRecs <= 0)
			$Cust_Rpt_Client_Activity_Week_list->TotalRecs = $Cust_Rpt_Client_Activity_Week->SelectRecordCount();
	} else {
		if (!$Cust_Rpt_Client_Activity_Week_list->Recordset && ($Cust_Rpt_Client_Activity_Week_list->Recordset = $Cust_Rpt_Client_Activity_Week_list->LoadRecordset()))
			$Cust_Rpt_Client_Activity_Week_list->TotalRecs = $Cust_Rpt_Client_Activity_Week_list->Recordset->RecordCount();
	}
	$Cust_Rpt_Client_Activity_Week_list->StartRec = 1;
	if ($Cust_Rpt_Client_Activity_Week_list->DisplayRecs <= 0 || ($Cust_Rpt_Client_Activity_Week->Export <> "" && $Cust_Rpt_Client_Activity_Week->ExportAll)) // Display all records
		$Cust_Rpt_Client_Activity_Week_list->DisplayRecs = $Cust_Rpt_Client_Activity_Week_list->TotalRecs;
	if (!($Cust_Rpt_Client_Activity_Week->Export <> "" && $Cust_Rpt_Client_Activity_Week->ExportAll))
		$Cust_Rpt_Client_Activity_Week_list->SetUpStartRec(); // Set up start record position
	if ($bSelectLimit)
		$Cust_Rpt_Client_Activity_Week_list->Recordset = $Cust_Rpt_Client_Activity_Week_list->LoadRecordset($Cust_Rpt_Client_Activity_Week_list->StartRec-1, $Cust_Rpt_Client_Activity_Week_list->DisplayRecs);

	// Set no record found message
	if ($Cust_Rpt_Client_Activity_Week->CurrentAction == "" && $Cust_Rpt_Client_Activity_Week_list->TotalRecs == 0) {
		if (!$Security->CanList())
			$Cust_Rpt_Client_Activity_Week_list->setWarningMessage(ew_DeniedMsg());
		if ($Cust_Rpt_Client_Activity_Week_list->SearchWhere == "0=101")
			$Cust_Rpt_Client_Activity_Week_list->setWarningMessage($Language->Phrase("EnterSearchCriteria"));
		else
			$Cust_Rpt_Client_Activity_Week_list->setWarningMessage($Language->Phrase("NoRecord"));
	}
$Cust_Rpt_Client_Activity_Week_list->RenderOtherOptions();
?>
<?php if ($Security->CanSearch()) { ?>
<?php if ($Cust_Rpt_Client_Activity_Week->Export == "" && $Cust_Rpt_Client_Activity_Week->CurrentAction == "") { ?>
<form name="fCust_Rpt_Client_Activity_Weeklistsrch" id="fCust_Rpt_Client_Activity_Weeklistsrch" class="form-inline ewForm" action="<?php echo ew_CurrentPage() ?>">
<?php $SearchPanelClass = ($Cust_Rpt_Client_Activity_Week_list->SearchWhere <> "") ? " in" : " in"; ?>
<div id="fCust_Rpt_Client_Activity_Weeklistsrch_SearchPanel" class="ewSearchPanel collapse<?php echo $SearchPanelClass ?>">
<input type="hidden" name="cmd" value="search">
<input type="hidden" name="t" value="Cust_Rpt_Client_Activity_Week">
	<div class="ewBasicSearch">
<div id="xsr_1" class="ewRow">
	<div class="ewQuickSearch input-group">
	<input type="text" name="<?php echo EW_TABLE_BASIC_SEARCH ?>" id="<?php echo EW_TABLE_BASIC_SEARCH ?>" class="form-control" value="<?php echo ew_HtmlEncode($Cust_Rpt_Client_Activity_Week_list->BasicSearch->getKeyword()) ?>" placeholder="<?php echo ew_HtmlEncode($Language->Phrase("Search")) ?>">
	<input type="hidden" name="<?php echo EW_TABLE_BASIC_SEARCH_TYPE ?>" id="<?php echo EW_TABLE_BASIC_SEARCH_TYPE ?>" value="<?php echo ew_HtmlEncode($Cust_Rpt_Client_Activity_Week_list->BasicSearch->getType()) ?>">
	<div class="input-group-btn">
		<button type="button" data-toggle="dropdown" class="btn btn-default"><span id="searchtype"><?php echo $Cust_Rpt_Client_Activity_Week_list->BasicSearch->getTypeNameShort() ?></span><span class="caret"></span></button>
		<ul class="dropdown-menu pull-right" role="menu">
			<li<?php if ($Cust_Rpt_Client_Activity_Week_list->BasicSearch->getType() == "") echo " class=\"active\""; ?>><a href="javascript:void(0);" onclick="ew_SetSearchType(this)"><?php echo $Language->Phrase("QuickSearchAuto") ?></a></li>
			<li<?php if ($Cust_Rpt_Client_Activity_Week_list->BasicSearch->getType() == "=") echo " class=\"active\""; ?>><a href="javascript:void(0);" onclick="ew_SetSearchType(this,'=')"><?php echo $Language->Phrase("QuickSearchExact") ?></a></li>
			<li<?php if ($Cust_Rpt_Client_Activity_Week_list->BasicSearch->getType() == "AND") echo " class=\"active\""; ?>><a href="javascript:void(0);" onclick="ew_SetSearchType(this,'AND')"><?php echo $Language->Phrase("QuickSearchAll") ?></a></li>
			<li<?php if ($Cust_Rpt_Client_Activity_Week_list->BasicSearch->getType() == "OR") echo " class=\"active\""; ?>><a href="javascript:void(0);" onclick="ew_SetSearchType(this,'OR')"><?php echo $Language->Phrase("QuickSearchAny") ?></a></li>
		</ul>
	<button class="btn btn-primary ewButton" name="btnsubmit" id="btnsubmit" type="submit"><?php echo $Language->Phrase("QuickSearchBtn") ?></button>
	</div>
	</div>
</div>
	</div>
</div>
</form>
<?php } ?>
<?php } ?>
<?php $Cust_Rpt_Client_Activity_Week_list->ShowPageHeader(); ?>
<?php
$Cust_Rpt_Client_Activity_Week_list->ShowMessage();
?>
<?php if ($Cust_Rpt_Client_Activity_Week_list->TotalRecs > 0 || $Cust_Rpt_Client_Activity_Week->CurrentAction <> "") { ?>
<div class="panel panel-default ewGrid Cust_Rpt_Client_Activity_Week">
<?php if ($Cust_Rpt_Client_Activity_Week->Export == "") { ?>
<div class="panel-heading ewGridUpperPanel">
<?php if ($Cust_Rpt_Client_Activity_Week->CurrentAction <> "gridadd" && $Cust_Rpt_Client_Activity_Week->CurrentAction <> "gridedit") { ?>
<form name="ewPagerForm" class="form-inline ewForm ewPagerForm" action="<?php echo ew_CurrentPage() ?>">
<?php if (!isset($Cust_Rpt_Client_Activity_Week_list->Pager)) $Cust_Rpt_Client_Activity_Week_list->Pager = new cPrevNextPager($Cust_Rpt_Client_Activity_Week_list->StartRec, $Cust_Rpt_Client_Activity_Week_list->DisplayRecs, $Cust_Rpt_Client_Activity_Week_list->TotalRecs) ?>
<?php if ($Cust_Rpt_Client_Activity_Week_list->Pager->RecordCount > 0 && $Cust_Rpt_Client_Activity_Week_list->Pager->Visible) { ?>
<div class="ewPager">
<span><?php echo $Language->Phrase("Page") ?>&nbsp;</span>
<div class="ewPrevNext"><div class="input-group">
<div class="input-group-btn">
<!--first page button-->
	<?php if ($Cust_Rpt_Client_Activity_Week_list->Pager->FirstButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerFirst") ?>" href="<?php echo $Cust_Rpt_Client_Activity_Week_list->PageUrl() ?>start=<?php echo $Cust_Rpt_Client_Activity_Week_list->Pager->FirstButton->Start ?>"><span class="icon-first ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerFirst") ?>"><span class="icon-first ewIcon"></span></a>
	<?php } ?>
<!--previous page button-->
	<?php if ($Cust_Rpt_Client_Activity_Week_list->Pager->PrevButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerPrevious") ?>" href="<?php echo $Cust_Rpt_Client_Activity_Week_list->PageUrl() ?>start=<?php echo $Cust_Rpt_Client_Activity_Week_list->Pager->PrevButton->Start ?>"><span class="icon-prev ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerPrevious") ?>"><span class="icon-prev ewIcon"></span></a>
	<?php } ?>
</div>
<!--current page number-->
	<input class="form-control input-sm" type="text" name="<?php echo EW_TABLE_PAGE_NO ?>" value="<?php echo $Cust_Rpt_Client_Activity_Week_list->Pager->CurrentPage ?>">
<div class="input-group-btn">
<!--next page button-->
	<?php if ($Cust_Rpt_Client_Activity_Week_list->Pager->NextButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerNext") ?>" href="<?php echo $Cust_Rpt_Client_Activity_Week_list->PageUrl() ?>start=<?php echo $Cust_Rpt_Client_Activity_Week_list->Pager->NextButton->Start ?>"><span class="icon-next ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerNext") ?>"><span class="icon-next ewIcon"></span></a>
	<?php } ?>
<!--last page button-->
	<?php if ($Cust_Rpt_Client_Activity_Week_list->Pager->LastButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerLast") ?>" href="<?php echo $Cust_Rpt_Client_Activity_Week_list->PageUrl() ?>start=<?php echo $Cust_Rpt_Client_Activity_Week_list->Pager->LastButton->Start ?>"><span class="icon-last ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerLast") ?>"><span class="icon-last ewIcon"></span></a>
	<?php } ?>
</div>
</div>
</div>
<span>&nbsp;<?php echo $Language->Phrase("of") ?>&nbsp;<?php echo $Cust_Rpt_Client_Activity_Week_list->Pager->PageCount ?></span>
</div>
<div class="ewPager ewRec">
	<span><?php echo $Language->Phrase("Record") ?>&nbsp;<?php echo $Cust_Rpt_Client_Activity_Week_list->Pager->FromIndex ?>&nbsp;<?php echo $Language->Phrase("To") ?>&nbsp;<?php echo $Cust_Rpt_Client_Activity_Week_list->Pager->ToIndex ?>&nbsp;<?php echo $Language->Phrase("Of") ?>&nbsp;<?php echo $Cust_Rpt_Client_Activity_Week_list->Pager->RecordCount ?></span>
</div>
<?php } ?>
</form>
<?php } ?>
<div class="ewListOtherOptions">
<?php
	foreach ($Cust_Rpt_Client_Activity_Week_list->OtherOptions as &$option)
		$option->Render("body");
?>
</div>
<div class="clearfix"></div>
</div>
<?php } ?>
<form name="fCust_Rpt_Client_Activity_Weeklist" id="fCust_Rpt_Client_Activity_Weeklist" class="form-inline ewForm ewListForm" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($Cust_Rpt_Client_Activity_Week_list->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $Cust_Rpt_Client_Activity_Week_list->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="Cust_Rpt_Client_Activity_Week">
<div id="gmp_Cust_Rpt_Client_Activity_Week" class="<?php if (ew_IsResponsiveLayout()) { echo "table-responsive "; } ?>ewGridMiddlePanel">
<?php if ($Cust_Rpt_Client_Activity_Week_list->TotalRecs > 0 || $Cust_Rpt_Client_Activity_Week->CurrentAction == "gridedit") { ?>
<table id="tbl_Cust_Rpt_Client_Activity_Weeklist" class="table ewTable">
<?php echo $Cust_Rpt_Client_Activity_Week->TableCustomInnerHtml ?>
<thead><!-- Table header -->
	<tr class="ewTableHeader">
<?php

// Header row
$Cust_Rpt_Client_Activity_Week_list->RowType = EW_ROWTYPE_HEADER;

// Render list options
$Cust_Rpt_Client_Activity_Week_list->RenderListOptions();

// Render list options (header, left)
$Cust_Rpt_Client_Activity_Week_list->ListOptions->Render("header", "left");
?>
<?php if ($Cust_Rpt_Client_Activity_Week->description->Visible) { // description ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->description) == "") { ?>
		<th data-name="description"><div id="elh_Cust_Rpt_Client_Activity_Week_description" class="Cust_Rpt_Client_Activity_Week_description"><div class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->description->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="description"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->description) ?>',1);"><div id="elh_Cust_Rpt_Client_Activity_Week_description" class="Cust_Rpt_Client_Activity_Week_description">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->description->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Rpt_Client_Activity_Week->description->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Rpt_Client_Activity_Week->description->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Rpt_Client_Activity_Week->dbkey->Visible) { // dbkey ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->dbkey) == "") { ?>
		<th data-name="dbkey"><div id="elh_Cust_Rpt_Client_Activity_Week_dbkey" class="Cust_Rpt_Client_Activity_Week_dbkey"><div class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->dbkey->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="dbkey"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->dbkey) ?>',1);"><div id="elh_Cust_Rpt_Client_Activity_Week_dbkey" class="Cust_Rpt_Client_Activity_Week_dbkey">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->dbkey->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Rpt_Client_Activity_Week->dbkey->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Rpt_Client_Activity_Week->dbkey->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Rpt_Client_Activity_Week->First->Visible) { // First ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->First) == "") { ?>
		<th data-name="First"><div id="elh_Cust_Rpt_Client_Activity_Week_First" class="Cust_Rpt_Client_Activity_Week_First"><div class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->First->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="First"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->First) ?>',1);"><div id="elh_Cust_Rpt_Client_Activity_Week_First" class="Cust_Rpt_Client_Activity_Week_First">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->First->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Rpt_Client_Activity_Week->First->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Rpt_Client_Activity_Week->First->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Rpt_Client_Activity_Week->Last->Visible) { // Last ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Last) == "") { ?>
		<th data-name="Last"><div id="elh_Cust_Rpt_Client_Activity_Week_Last" class="Cust_Rpt_Client_Activity_Week_Last"><div class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Last->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Last"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Last) ?>',1);"><div id="elh_Cust_Rpt_Client_Activity_Week_Last" class="Cust_Rpt_Client_Activity_Week_Last">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Last->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Rpt_Client_Activity_Week->Last->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Rpt_Client_Activity_Week->Last->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Rpt_Client_Activity_Week->Total_Hours->Visible) { // Total Hours ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Total_Hours) == "") { ?>
		<th data-name="Total_Hours"><div id="elh_Cust_Rpt_Client_Activity_Week_Total_Hours" class="Cust_Rpt_Client_Activity_Week_Total_Hours"><div class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Total_Hours->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Total_Hours"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Total_Hours) ?>',1);"><div id="elh_Cust_Rpt_Client_Activity_Week_Total_Hours" class="Cust_Rpt_Client_Activity_Week_Total_Hours">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Total_Hours->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Rpt_Client_Activity_Week->Total_Hours->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Rpt_Client_Activity_Week->Total_Hours->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Rpt_Client_Activity_Week->Week_23->Visible) { // Week # ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Week_23) == "") { ?>
		<th data-name="Week_23"><div id="elh_Cust_Rpt_Client_Activity_Week_Week_23" class="Cust_Rpt_Client_Activity_Week_Week_23"><div class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Week_23->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Week_23"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Week_23) ?>',1);"><div id="elh_Cust_Rpt_Client_Activity_Week_Week_23" class="Cust_Rpt_Client_Activity_Week_Week_23">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Week_23->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Rpt_Client_Activity_Week->Week_23->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Rpt_Client_Activity_Week->Week_23->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Rpt_Client_Activity_Week->From_Date->Visible) { // From Date ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->From_Date) == "") { ?>
		<th data-name="From_Date"><div id="elh_Cust_Rpt_Client_Activity_Week_From_Date" class="Cust_Rpt_Client_Activity_Week_From_Date"><div class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->From_Date->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="From_Date"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->From_Date) ?>',1);"><div id="elh_Cust_Rpt_Client_Activity_Week_From_Date" class="Cust_Rpt_Client_Activity_Week_From_Date">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->From_Date->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Rpt_Client_Activity_Week->From_Date->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Rpt_Client_Activity_Week->From_Date->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Rpt_Client_Activity_Week->Through_Date->Visible) { // Through Date ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Through_Date) == "") { ?>
		<th data-name="Through_Date"><div id="elh_Cust_Rpt_Client_Activity_Week_Through_Date" class="Cust_Rpt_Client_Activity_Week_Through_Date"><div class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Through_Date->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Through_Date"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Through_Date) ?>',1);"><div id="elh_Cust_Rpt_Client_Activity_Week_Through_Date" class="Cust_Rpt_Client_Activity_Week_Through_Date">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Through_Date->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Rpt_Client_Activity_Week->Through_Date->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Rpt_Client_Activity_Week->Through_Date->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Rpt_Client_Activity_Week->Sunday->Visible) { // Sunday ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Sunday) == "") { ?>
		<th data-name="Sunday"><div id="elh_Cust_Rpt_Client_Activity_Week_Sunday" class="Cust_Rpt_Client_Activity_Week_Sunday"><div class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Sunday->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Sunday"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Sunday) ?>',1);"><div id="elh_Cust_Rpt_Client_Activity_Week_Sunday" class="Cust_Rpt_Client_Activity_Week_Sunday">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Sunday->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Rpt_Client_Activity_Week->Sunday->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Rpt_Client_Activity_Week->Sunday->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Rpt_Client_Activity_Week->Monday->Visible) { // Monday ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Monday) == "") { ?>
		<th data-name="Monday"><div id="elh_Cust_Rpt_Client_Activity_Week_Monday" class="Cust_Rpt_Client_Activity_Week_Monday"><div class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Monday->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Monday"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Monday) ?>',1);"><div id="elh_Cust_Rpt_Client_Activity_Week_Monday" class="Cust_Rpt_Client_Activity_Week_Monday">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Monday->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Rpt_Client_Activity_Week->Monday->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Rpt_Client_Activity_Week->Monday->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Rpt_Client_Activity_Week->Tuesday->Visible) { // Tuesday ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Tuesday) == "") { ?>
		<th data-name="Tuesday"><div id="elh_Cust_Rpt_Client_Activity_Week_Tuesday" class="Cust_Rpt_Client_Activity_Week_Tuesday"><div class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Tuesday->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Tuesday"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Tuesday) ?>',1);"><div id="elh_Cust_Rpt_Client_Activity_Week_Tuesday" class="Cust_Rpt_Client_Activity_Week_Tuesday">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Tuesday->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Rpt_Client_Activity_Week->Tuesday->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Rpt_Client_Activity_Week->Tuesday->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Rpt_Client_Activity_Week->Wednesday->Visible) { // Wednesday ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Wednesday) == "") { ?>
		<th data-name="Wednesday"><div id="elh_Cust_Rpt_Client_Activity_Week_Wednesday" class="Cust_Rpt_Client_Activity_Week_Wednesday"><div class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Wednesday->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Wednesday"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Wednesday) ?>',1);"><div id="elh_Cust_Rpt_Client_Activity_Week_Wednesday" class="Cust_Rpt_Client_Activity_Week_Wednesday">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Wednesday->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Rpt_Client_Activity_Week->Wednesday->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Rpt_Client_Activity_Week->Wednesday->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Rpt_Client_Activity_Week->Thursday->Visible) { // Thursday ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Thursday) == "") { ?>
		<th data-name="Thursday"><div id="elh_Cust_Rpt_Client_Activity_Week_Thursday" class="Cust_Rpt_Client_Activity_Week_Thursday"><div class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Thursday->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Thursday"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Thursday) ?>',1);"><div id="elh_Cust_Rpt_Client_Activity_Week_Thursday" class="Cust_Rpt_Client_Activity_Week_Thursday">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Thursday->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Rpt_Client_Activity_Week->Thursday->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Rpt_Client_Activity_Week->Thursday->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Rpt_Client_Activity_Week->Friday->Visible) { // Friday ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Friday) == "") { ?>
		<th data-name="Friday"><div id="elh_Cust_Rpt_Client_Activity_Week_Friday" class="Cust_Rpt_Client_Activity_Week_Friday"><div class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Friday->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Friday"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Friday) ?>',1);"><div id="elh_Cust_Rpt_Client_Activity_Week_Friday" class="Cust_Rpt_Client_Activity_Week_Friday">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Friday->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Rpt_Client_Activity_Week->Friday->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Rpt_Client_Activity_Week->Friday->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($Cust_Rpt_Client_Activity_Week->Saturday->Visible) { // Saturday ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Saturday) == "") { ?>
		<th data-name="Saturday"><div id="elh_Cust_Rpt_Client_Activity_Week_Saturday" class="Cust_Rpt_Client_Activity_Week_Saturday"><div class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Saturday->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Saturday"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $Cust_Rpt_Client_Activity_Week->SortUrl($Cust_Rpt_Client_Activity_Week->Saturday) ?>',1);"><div id="elh_Cust_Rpt_Client_Activity_Week_Saturday" class="Cust_Rpt_Client_Activity_Week_Saturday">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $Cust_Rpt_Client_Activity_Week->Saturday->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($Cust_Rpt_Client_Activity_Week->Saturday->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($Cust_Rpt_Client_Activity_Week->Saturday->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php

// Render list options (header, right)
$Cust_Rpt_Client_Activity_Week_list->ListOptions->Render("header", "right");
?>
	</tr>
</thead>
<tbody>
<?php
if ($Cust_Rpt_Client_Activity_Week->ExportAll && $Cust_Rpt_Client_Activity_Week->Export <> "") {
	$Cust_Rpt_Client_Activity_Week_list->StopRec = $Cust_Rpt_Client_Activity_Week_list->TotalRecs;
} else {

	// Set the last record to display
	if ($Cust_Rpt_Client_Activity_Week_list->TotalRecs > $Cust_Rpt_Client_Activity_Week_list->StartRec + $Cust_Rpt_Client_Activity_Week_list->DisplayRecs - 1)
		$Cust_Rpt_Client_Activity_Week_list->StopRec = $Cust_Rpt_Client_Activity_Week_list->StartRec + $Cust_Rpt_Client_Activity_Week_list->DisplayRecs - 1;
	else
		$Cust_Rpt_Client_Activity_Week_list->StopRec = $Cust_Rpt_Client_Activity_Week_list->TotalRecs;
}
$Cust_Rpt_Client_Activity_Week_list->RecCnt = $Cust_Rpt_Client_Activity_Week_list->StartRec - 1;
if ($Cust_Rpt_Client_Activity_Week_list->Recordset && !$Cust_Rpt_Client_Activity_Week_list->Recordset->EOF) {
	$Cust_Rpt_Client_Activity_Week_list->Recordset->MoveFirst();
	$bSelectLimit = $Cust_Rpt_Client_Activity_Week_list->UseSelectLimit;
	if (!$bSelectLimit && $Cust_Rpt_Client_Activity_Week_list->StartRec > 1)
		$Cust_Rpt_Client_Activity_Week_list->Recordset->Move($Cust_Rpt_Client_Activity_Week_list->StartRec - 1);
} elseif (!$Cust_Rpt_Client_Activity_Week->AllowAddDeleteRow && $Cust_Rpt_Client_Activity_Week_list->StopRec == 0) {
	$Cust_Rpt_Client_Activity_Week_list->StopRec = $Cust_Rpt_Client_Activity_Week->GridAddRowCount;
}

// Initialize aggregate
$Cust_Rpt_Client_Activity_Week->RowType = EW_ROWTYPE_AGGREGATEINIT;
$Cust_Rpt_Client_Activity_Week->ResetAttrs();
$Cust_Rpt_Client_Activity_Week_list->RenderRow();
while ($Cust_Rpt_Client_Activity_Week_list->RecCnt < $Cust_Rpt_Client_Activity_Week_list->StopRec) {
	$Cust_Rpt_Client_Activity_Week_list->RecCnt++;
	if (intval($Cust_Rpt_Client_Activity_Week_list->RecCnt) >= intval($Cust_Rpt_Client_Activity_Week_list->StartRec)) {
		$Cust_Rpt_Client_Activity_Week_list->RowCnt++;

		// Set up key count
		$Cust_Rpt_Client_Activity_Week_list->KeyCount = $Cust_Rpt_Client_Activity_Week_list->RowIndex;

		// Init row class and style
		$Cust_Rpt_Client_Activity_Week->ResetAttrs();
		$Cust_Rpt_Client_Activity_Week->CssClass = "";
		if ($Cust_Rpt_Client_Activity_Week->CurrentAction == "gridadd") {
		} else {
			$Cust_Rpt_Client_Activity_Week_list->LoadRowValues($Cust_Rpt_Client_Activity_Week_list->Recordset); // Load row values
		}
		$Cust_Rpt_Client_Activity_Week->RowType = EW_ROWTYPE_VIEW; // Render view

		// Set up row id / data-rowindex
		$Cust_Rpt_Client_Activity_Week->RowAttrs = array_merge($Cust_Rpt_Client_Activity_Week->RowAttrs, array('data-rowindex'=>$Cust_Rpt_Client_Activity_Week_list->RowCnt, 'id'=>'r' . $Cust_Rpt_Client_Activity_Week_list->RowCnt . '_Cust_Rpt_Client_Activity_Week', 'data-rowtype'=>$Cust_Rpt_Client_Activity_Week->RowType));

		// Render row
		$Cust_Rpt_Client_Activity_Week_list->RenderRow();

		// Render list options
		$Cust_Rpt_Client_Activity_Week_list->RenderListOptions();
?>
	<tr<?php echo $Cust_Rpt_Client_Activity_Week->RowAttributes() ?>>
<?php

// Render list options (body, left)
$Cust_Rpt_Client_Activity_Week_list->ListOptions->Render("body", "left", $Cust_Rpt_Client_Activity_Week_list->RowCnt);
?>
	<?php if ($Cust_Rpt_Client_Activity_Week->description->Visible) { // description ?>
		<td data-name="description"<?php echo $Cust_Rpt_Client_Activity_Week->description->CellAttributes() ?>>
<span id="el<?php echo $Cust_Rpt_Client_Activity_Week_list->RowCnt ?>_Cust_Rpt_Client_Activity_Week_description" class="Cust_Rpt_Client_Activity_Week_description">
<span<?php echo $Cust_Rpt_Client_Activity_Week->description->ViewAttributes() ?>>
<?php echo $Cust_Rpt_Client_Activity_Week->description->ListViewValue() ?></span>
</span>
<a id="<?php echo $Cust_Rpt_Client_Activity_Week_list->PageObjName . "_row_" . $Cust_Rpt_Client_Activity_Week_list->RowCnt ?>"></a></td>
	<?php } ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->dbkey->Visible) { // dbkey ?>
		<td data-name="dbkey"<?php echo $Cust_Rpt_Client_Activity_Week->dbkey->CellAttributes() ?>>
<span id="el<?php echo $Cust_Rpt_Client_Activity_Week_list->RowCnt ?>_Cust_Rpt_Client_Activity_Week_dbkey" class="Cust_Rpt_Client_Activity_Week_dbkey">
<span<?php echo $Cust_Rpt_Client_Activity_Week->dbkey->ViewAttributes() ?>>
<?php echo $Cust_Rpt_Client_Activity_Week->dbkey->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->First->Visible) { // First ?>
		<td data-name="First"<?php echo $Cust_Rpt_Client_Activity_Week->First->CellAttributes() ?>>
<span id="el<?php echo $Cust_Rpt_Client_Activity_Week_list->RowCnt ?>_Cust_Rpt_Client_Activity_Week_First" class="Cust_Rpt_Client_Activity_Week_First">
<span<?php echo $Cust_Rpt_Client_Activity_Week->First->ViewAttributes() ?>>
<?php echo $Cust_Rpt_Client_Activity_Week->First->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->Last->Visible) { // Last ?>
		<td data-name="Last"<?php echo $Cust_Rpt_Client_Activity_Week->Last->CellAttributes() ?>>
<span id="el<?php echo $Cust_Rpt_Client_Activity_Week_list->RowCnt ?>_Cust_Rpt_Client_Activity_Week_Last" class="Cust_Rpt_Client_Activity_Week_Last">
<span<?php echo $Cust_Rpt_Client_Activity_Week->Last->ViewAttributes() ?>>
<?php echo $Cust_Rpt_Client_Activity_Week->Last->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->Total_Hours->Visible) { // Total Hours ?>
		<td data-name="Total_Hours"<?php echo $Cust_Rpt_Client_Activity_Week->Total_Hours->CellAttributes() ?>>
<span id="el<?php echo $Cust_Rpt_Client_Activity_Week_list->RowCnt ?>_Cust_Rpt_Client_Activity_Week_Total_Hours" class="Cust_Rpt_Client_Activity_Week_Total_Hours">
<span<?php echo $Cust_Rpt_Client_Activity_Week->Total_Hours->ViewAttributes() ?>>
<?php echo $Cust_Rpt_Client_Activity_Week->Total_Hours->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->Week_23->Visible) { // Week # ?>
		<td data-name="Week_23"<?php echo $Cust_Rpt_Client_Activity_Week->Week_23->CellAttributes() ?>>
<span id="el<?php echo $Cust_Rpt_Client_Activity_Week_list->RowCnt ?>_Cust_Rpt_Client_Activity_Week_Week_23" class="Cust_Rpt_Client_Activity_Week_Week_23">
<span<?php echo $Cust_Rpt_Client_Activity_Week->Week_23->ViewAttributes() ?>>
<?php echo $Cust_Rpt_Client_Activity_Week->Week_23->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->From_Date->Visible) { // From Date ?>
		<td data-name="From_Date"<?php echo $Cust_Rpt_Client_Activity_Week->From_Date->CellAttributes() ?>>
<span id="el<?php echo $Cust_Rpt_Client_Activity_Week_list->RowCnt ?>_Cust_Rpt_Client_Activity_Week_From_Date" class="Cust_Rpt_Client_Activity_Week_From_Date">
<span<?php echo $Cust_Rpt_Client_Activity_Week->From_Date->ViewAttributes() ?>>
<?php echo $Cust_Rpt_Client_Activity_Week->From_Date->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->Through_Date->Visible) { // Through Date ?>
		<td data-name="Through_Date"<?php echo $Cust_Rpt_Client_Activity_Week->Through_Date->CellAttributes() ?>>
<span id="el<?php echo $Cust_Rpt_Client_Activity_Week_list->RowCnt ?>_Cust_Rpt_Client_Activity_Week_Through_Date" class="Cust_Rpt_Client_Activity_Week_Through_Date">
<span<?php echo $Cust_Rpt_Client_Activity_Week->Through_Date->ViewAttributes() ?>>
<?php echo $Cust_Rpt_Client_Activity_Week->Through_Date->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->Sunday->Visible) { // Sunday ?>
		<td data-name="Sunday"<?php echo $Cust_Rpt_Client_Activity_Week->Sunday->CellAttributes() ?>>
<span id="el<?php echo $Cust_Rpt_Client_Activity_Week_list->RowCnt ?>_Cust_Rpt_Client_Activity_Week_Sunday" class="Cust_Rpt_Client_Activity_Week_Sunday">
<span<?php echo $Cust_Rpt_Client_Activity_Week->Sunday->ViewAttributes() ?>>
<?php echo $Cust_Rpt_Client_Activity_Week->Sunday->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->Monday->Visible) { // Monday ?>
		<td data-name="Monday"<?php echo $Cust_Rpt_Client_Activity_Week->Monday->CellAttributes() ?>>
<span id="el<?php echo $Cust_Rpt_Client_Activity_Week_list->RowCnt ?>_Cust_Rpt_Client_Activity_Week_Monday" class="Cust_Rpt_Client_Activity_Week_Monday">
<span<?php echo $Cust_Rpt_Client_Activity_Week->Monday->ViewAttributes() ?>>
<?php echo $Cust_Rpt_Client_Activity_Week->Monday->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->Tuesday->Visible) { // Tuesday ?>
		<td data-name="Tuesday"<?php echo $Cust_Rpt_Client_Activity_Week->Tuesday->CellAttributes() ?>>
<span id="el<?php echo $Cust_Rpt_Client_Activity_Week_list->RowCnt ?>_Cust_Rpt_Client_Activity_Week_Tuesday" class="Cust_Rpt_Client_Activity_Week_Tuesday">
<span<?php echo $Cust_Rpt_Client_Activity_Week->Tuesday->ViewAttributes() ?>>
<?php echo $Cust_Rpt_Client_Activity_Week->Tuesday->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->Wednesday->Visible) { // Wednesday ?>
		<td data-name="Wednesday"<?php echo $Cust_Rpt_Client_Activity_Week->Wednesday->CellAttributes() ?>>
<span id="el<?php echo $Cust_Rpt_Client_Activity_Week_list->RowCnt ?>_Cust_Rpt_Client_Activity_Week_Wednesday" class="Cust_Rpt_Client_Activity_Week_Wednesday">
<span<?php echo $Cust_Rpt_Client_Activity_Week->Wednesday->ViewAttributes() ?>>
<?php echo $Cust_Rpt_Client_Activity_Week->Wednesday->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->Thursday->Visible) { // Thursday ?>
		<td data-name="Thursday"<?php echo $Cust_Rpt_Client_Activity_Week->Thursday->CellAttributes() ?>>
<span id="el<?php echo $Cust_Rpt_Client_Activity_Week_list->RowCnt ?>_Cust_Rpt_Client_Activity_Week_Thursday" class="Cust_Rpt_Client_Activity_Week_Thursday">
<span<?php echo $Cust_Rpt_Client_Activity_Week->Thursday->ViewAttributes() ?>>
<?php echo $Cust_Rpt_Client_Activity_Week->Thursday->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->Friday->Visible) { // Friday ?>
		<td data-name="Friday"<?php echo $Cust_Rpt_Client_Activity_Week->Friday->CellAttributes() ?>>
<span id="el<?php echo $Cust_Rpt_Client_Activity_Week_list->RowCnt ?>_Cust_Rpt_Client_Activity_Week_Friday" class="Cust_Rpt_Client_Activity_Week_Friday">
<span<?php echo $Cust_Rpt_Client_Activity_Week->Friday->ViewAttributes() ?>>
<?php echo $Cust_Rpt_Client_Activity_Week->Friday->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($Cust_Rpt_Client_Activity_Week->Saturday->Visible) { // Saturday ?>
		<td data-name="Saturday"<?php echo $Cust_Rpt_Client_Activity_Week->Saturday->CellAttributes() ?>>
<span id="el<?php echo $Cust_Rpt_Client_Activity_Week_list->RowCnt ?>_Cust_Rpt_Client_Activity_Week_Saturday" class="Cust_Rpt_Client_Activity_Week_Saturday">
<span<?php echo $Cust_Rpt_Client_Activity_Week->Saturday->ViewAttributes() ?>>
<?php echo $Cust_Rpt_Client_Activity_Week->Saturday->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
<?php

// Render list options (body, right)
$Cust_Rpt_Client_Activity_Week_list->ListOptions->Render("body", "right", $Cust_Rpt_Client_Activity_Week_list->RowCnt);
?>
	</tr>
<?php
	}
	if ($Cust_Rpt_Client_Activity_Week->CurrentAction <> "gridadd")
		$Cust_Rpt_Client_Activity_Week_list->Recordset->MoveNext();
}
?>
</tbody>
</table>
<?php } ?>
<?php if ($Cust_Rpt_Client_Activity_Week->CurrentAction == "") { ?>
<input type="hidden" name="a_list" id="a_list" value="">
<?php } ?>
</div>
</form>
<?php

// Close recordset
if ($Cust_Rpt_Client_Activity_Week_list->Recordset)
	$Cust_Rpt_Client_Activity_Week_list->Recordset->Close();
?>
</div>
<?php } ?>
<?php if ($Cust_Rpt_Client_Activity_Week_list->TotalRecs == 0 && $Cust_Rpt_Client_Activity_Week->CurrentAction == "") { // Show other options ?>
<div class="ewListOtherOptions">
<?php
	foreach ($Cust_Rpt_Client_Activity_Week_list->OtherOptions as &$option) {
		$option->ButtonClass = "";
		$option->Render("body", "");
	}
?>
</div>
<div class="clearfix"></div>
<?php } ?>
<?php if ($Cust_Rpt_Client_Activity_Week->Export == "") { ?>
<script type="text/javascript">
fCust_Rpt_Client_Activity_Weeklistsrch.FilterList = <?php echo $Cust_Rpt_Client_Activity_Week_list->GetFilterList() ?>;
fCust_Rpt_Client_Activity_Weeklistsrch.Init();
fCust_Rpt_Client_Activity_Weeklist.Init();
</script>
<?php } ?>
<?php
$Cust_Rpt_Client_Activity_Week_list->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<?php if ($Cust_Rpt_Client_Activity_Week->Export == "") { ?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php } ?>
<?php include_once "footer.php" ?>
<?php
$Cust_Rpt_Client_Activity_Week_list->Page_Terminate();
?>
