<?php

// Global variable for table object
$Cust_timecards_admin = NULL;

//
// Table class for Cust_timecards_admin
//
class cCust_timecards_admin extends cTable {
	var $dbkey;
	var $weeknumber;
	var $start;
	var $end;
	var $dbkey_councilor;
	var $date;
	var $in;
	var $out;
	var $approved_by;
	var $approved_on;
	var $created_on;
	var $updated_on;
	var $created_by;
	var $updated_by;
	var $approved;
	var $regular;
	var $overtime;
	var $total;

	//
	// Table class constructor
	//
	function __construct() {
		global $Language;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();
		$this->TableVar = 'Cust_timecards_admin';
		$this->TableName = 'Cust_timecards_admin';
		$this->TableType = 'CUSTOMVIEW';

		// Update Table
		$this->UpdateTable = "timecards";
		$this->DBID = 'DB';
		$this->ExportAll = TRUE;
		$this->ExportPageBreakCount = 0; // Page break per every n record (PDF only)
		$this->ExportPageOrientation = "portrait"; // Page orientation (PDF only)
		$this->ExportPageSize = "a4"; // Page size (PDF only)
		$this->ExportExcelPageOrientation = ""; // Page orientation (PHPExcel only)
		$this->ExportExcelPageSize = ""; // Page size (PHPExcel only)
		$this->DetailAdd = FALSE; // Allow detail add
		$this->DetailEdit = FALSE; // Allow detail edit
		$this->DetailView = FALSE; // Allow detail view
		$this->ShowMultipleDetails = FALSE; // Show multiple details
		$this->GridAddRowCount = 1;
		$this->AllowAddDeleteRow = ew_AllowAddDeleteRow(); // Allow add/delete row
		$this->UserIDAllowSecurity = 0; // User ID Allow
		$this->BasicSearch = new cBasicSearch($this->TableVar);

		// dbkey
		$this->dbkey = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_dbkey', 'dbkey', '`dbkey`', '`dbkey`', 3, -1, FALSE, '`dbkey`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'NO');
		$this->dbkey->Sortable = FALSE; // Allow sort
		$this->dbkey->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey'] = &$this->dbkey;

		// weeknumber
		$this->weeknumber = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_weeknumber', 'weeknumber', 'WEEKOFYEAR(timecards.date)', 'WEEKOFYEAR(timecards.date)', 20, -1, FALSE, 'WEEKOFYEAR(timecards.date)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->weeknumber->FldIsCustom = TRUE; // Custom field
		$this->weeknumber->Sortable = FALSE; // Allow sort
		$this->weeknumber->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->weeknumber->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->weeknumber->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['weeknumber'] = &$this->weeknumber;

		// start
		$this->start = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_start', 'start', 'STR_TO_DATE(concat(substr(timecards.date,1,4),WEEKOFYEAR(timecards.date),\' Sunday\'), \'%X%V %W\')', ew_CastDateFieldForLike('STR_TO_DATE(concat(substr(timecards.date,1,4),WEEKOFYEAR(timecards.date),\' Sunday\'), \'%X%V %W\')', 0, "DB"), 133, 0, FALSE, 'STR_TO_DATE(concat(substr(timecards.date,1,4),WEEKOFYEAR(timecards.date),\' Sunday\'), \'%X%V %W\')', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->start->FldIsCustom = TRUE; // Custom field
		$this->start->Sortable = FALSE; // Allow sort
		$this->start->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->start->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->start->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['start'] = &$this->start;

		// end
		$this->end = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_end', 'end', 'STR_TO_DATE(concat(substr(timecards.date,1,4),WEEKOFYEAR(timecards.date),\' Saturday\'), \'%X%V %W\')', ew_CastDateFieldForLike('STR_TO_DATE(concat(substr(timecards.date,1,4),WEEKOFYEAR(timecards.date),\' Saturday\'), \'%X%V %W\')', 0, "DB"), 133, 0, FALSE, 'STR_TO_DATE(concat(substr(timecards.date,1,4),WEEKOFYEAR(timecards.date),\' Saturday\'), \'%X%V %W\')', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->end->FldIsCustom = TRUE; // Custom field
		$this->end->Sortable = FALSE; // Allow sort
		$this->end->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['end'] = &$this->end;

		// dbkey_councilor
		$this->dbkey_councilor = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_dbkey_councilor', 'dbkey_councilor', '`dbkey_councilor`', '`dbkey_councilor`', 3, -1, FALSE, '`dbkey_councilor`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_councilor->Sortable = TRUE; // Allow sort
		$this->dbkey_councilor->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->dbkey_councilor->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->dbkey_councilor->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_councilor'] = &$this->dbkey_councilor;

		// date
		$this->date = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_date', 'date', '`date`', ew_CastDateFieldForLike('`date`', 0, "DB"), 133, 0, FALSE, '`date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->date->Sortable = FALSE; // Allow sort
		$this->date->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['date'] = &$this->date;

		// in
		$this->in = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_in', 'in', '`in`', '`in`', 200, -1, FALSE, '`in`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->in->Sortable = FALSE; // Allow sort
		$this->in->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->in->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->in->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['in'] = &$this->in;

		// out
		$this->out = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_out', 'out', '`out`', '`out`', 200, -1, FALSE, '`out`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->out->Sortable = FALSE; // Allow sort
		$this->out->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->out->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->out->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['out'] = &$this->out;

		// approved_by
		$this->approved_by = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_approved_by', 'approved_by', '`approved_by`', '`approved_by`', 3, -1, FALSE, '`approved_by`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->approved_by->Sortable = FALSE; // Allow sort
		$this->approved_by->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['approved_by'] = &$this->approved_by;

		// approved_on
		$this->approved_on = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_approved_on', 'approved_on', '`approved_on`', ew_CastDateFieldForLike('`approved_on`', 0, "DB"), 135, 0, FALSE, '`approved_on`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->approved_on->Sortable = FALSE; // Allow sort
		$this->approved_on->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['approved_on'] = &$this->approved_on;

		// created_on
		$this->created_on = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_created_on', 'created_on', '`created_on`', ew_CastDateFieldForLike('`created_on`', 0, "DB"), 135, 0, FALSE, '`created_on`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->created_on->Sortable = FALSE; // Allow sort
		$this->created_on->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['created_on'] = &$this->created_on;

		// updated_on
		$this->updated_on = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_updated_on', 'updated_on', '`updated_on`', ew_CastDateFieldForLike('`updated_on`', 0, "DB"), 135, 0, FALSE, '`updated_on`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->updated_on->Sortable = FALSE; // Allow sort
		$this->updated_on->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['updated_on'] = &$this->updated_on;

		// created_by
		$this->created_by = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_created_by', 'created_by', '`created_by`', '`created_by`', 3, -1, FALSE, '`created_by`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->created_by->Sortable = FALSE; // Allow sort
		$this->created_by->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['created_by'] = &$this->created_by;

		// updated_by
		$this->updated_by = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_updated_by', 'updated_by', '`updated_by`', '`updated_by`', 3, -1, FALSE, '`updated_by`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->updated_by->Sortable = FALSE; // Allow sort
		$this->updated_by->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['updated_by'] = &$this->updated_by;

		// approved
		$this->approved = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_approved', 'approved', '`approved`', '`approved`', 16, -1, FALSE, '`approved`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'CHECKBOX');
		$this->approved->Sortable = FALSE; // Allow sort
		$this->approved->OptionCount = 2;
		$this->approved->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['approved'] = &$this->approved;

		// regular
		$this->regular = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_regular', 'regular', '00.01', '00.01', 131, -1, FALSE, '00.01', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->regular->FldIsCustom = TRUE; // Custom field
		$this->regular->Sortable = FALSE; // Allow sort
		$this->regular->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['regular'] = &$this->regular;

		// overtime
		$this->overtime = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_overtime', 'overtime', '00.01', '00.01', 131, -1, FALSE, '00.01', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->overtime->FldIsCustom = TRUE; // Custom field
		$this->overtime->Sortable = FALSE; // Allow sort
		$this->overtime->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['overtime'] = &$this->overtime;

		// total
		$this->total = new cField('Cust_timecards_admin', 'Cust_timecards_admin', 'x_total', 'total', '00.01', '00.01', 131, -1, FALSE, '00.01', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->total->FldIsCustom = TRUE; // Custom field
		$this->total->Sortable = FALSE; // Allow sort
		$this->total->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['total'] = &$this->total;
	}

	// Set Field Visibility
	function SetFieldVisibility($fldparm) {
		global $Security;
		return $this->$fldparm->Visible; // Returns original value
	}

	// Single column sort
	function UpdateSort(&$ofld) {
		if ($this->CurrentOrder == $ofld->FldName) {
			$sSortField = $ofld->FldExpression;
			$sLastSort = $ofld->getSort();
			if ($this->CurrentOrderType == "ASC" || $this->CurrentOrderType == "DESC") {
				$sThisSort = $this->CurrentOrderType;
			} else {
				$sThisSort = ($sLastSort == "ASC") ? "DESC" : "ASC";
			}
			$ofld->setSort($sThisSort);
			$this->setSessionOrderBy($sSortField . " " . $sThisSort); // Save to Session
		} else {
			$ofld->setSort("");
		}
	}

	// Table level SQL
	var $_SqlFrom = "";

	function getSqlFrom() { // From
		return ($this->_SqlFrom <> "") ? $this->_SqlFrom : "timecards";
	}

	function SqlFrom() { // For backward compatibility
		return $this->getSqlFrom();
	}

	function setSqlFrom($v) {
		$this->_SqlFrom = $v;
	}
	var $_SqlSelect = "";

	function getSqlSelect() { // Select
		return ($this->_SqlSelect <> "") ? $this->_SqlSelect : "SELECT timecards.dbkey, timecards.dbkey_councilor, timecards.date, timecards.`in`, timecards.`out`, timecards.approved_by, timecards.approved_on, timecards.created_on, timecards.updated_on, timecards.created_by, timecards.updated_by, timecards.approved , adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY) as start, adddate(timecards.date, INTERVAL 7-DAYOFWEEK(timecards.date) DAY) as end,WEEKOFYEAR(adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY)) as weeknumber,00.0 as regular, 00.0 as overtime, 00.0 as total, WEEKOFYEAR(timecards.date) AS `weeknumber`, STR_TO_DATE(concat(substr(timecards.date,1,4),WEEKOFYEAR(timecards.date),' Sunday'), '%X%V %W') AS `start`, STR_TO_DATE(concat(substr(timecards.date,1,4),WEEKOFYEAR(timecards.date),' Saturday'), '%X%V %W') AS `end`, 00.01 AS `regular`, 00.01 AS `overtime`, 00.01 AS `total` FROM " . $this->getSqlFrom();
	}

	function SqlSelect() { // For backward compatibility
		return $this->getSqlSelect();
	}

	function setSqlSelect($v) {
		$this->_SqlSelect = $v;
	}
	var $_SqlWhere = "";

	function getSqlWhere() { // Where
		$sWhere = ($this->_SqlWhere <> "") ? $this->_SqlWhere : "";
		$this->TableFilter = "";
		ew_AddFilter($sWhere, $this->TableFilter);
		return $sWhere;
	}

	function SqlWhere() { // For backward compatibility
		return $this->getSqlWhere();
	}

	function setSqlWhere($v) {
		$this->_SqlWhere = $v;
	}
	var $_SqlGroupBy = "";

	function getSqlGroupBy() { // Group By
		return ($this->_SqlGroupBy <> "") ? $this->_SqlGroupBy : "";
	}

	function SqlGroupBy() { // For backward compatibility
		return $this->getSqlGroupBy();
	}

	function setSqlGroupBy($v) {
		$this->_SqlGroupBy = $v;
	}
	var $_SqlHaving = "";

	function getSqlHaving() { // Having
		return ($this->_SqlHaving <> "") ? $this->_SqlHaving : "";
	}

	function SqlHaving() { // For backward compatibility
		return $this->getSqlHaving();
	}

	function setSqlHaving($v) {
		$this->_SqlHaving = $v;
	}
	var $_SqlOrderBy = "";

	function getSqlOrderBy() { // Order By
		return ($this->_SqlOrderBy <> "") ? $this->_SqlOrderBy : "timecards.`date` DESC, timecards.`in` DESC";
	}

	function SqlOrderBy() { // For backward compatibility
		return $this->getSqlOrderBy();
	}

	function setSqlOrderBy($v) {
		$this->_SqlOrderBy = $v;
	}

	// Apply User ID filters
	function ApplyUserIDFilters($sFilter) {
		return $sFilter;
	}

	// Check if User ID security allows view all
	function UserIDAllow($id = "") {
		$allow = EW_USER_ID_ALLOW;
		switch ($id) {
			case "add":
			case "copy":
			case "gridadd":
			case "register":
			case "addopt":
				return (($allow & 1) == 1);
			case "edit":
			case "gridedit":
			case "update":
			case "changepwd":
			case "forgotpwd":
				return (($allow & 4) == 4);
			case "delete":
				return (($allow & 2) == 2);
			case "view":
				return (($allow & 32) == 32);
			case "search":
				return (($allow & 64) == 64);
			default:
				return (($allow & 8) == 8);
		}
	}

	// Get SQL
	function GetSQL($where, $orderby) {
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$where, $orderby);
	}

	// Table SQL
	function SQL() {
		$sFilter = $this->CurrentFilter;
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$sFilter, $sSort);
	}

	// Table SQL with List page filter
	function SelectSQL() {
		$sFilter = $this->getSessionWhere();
		ew_AddFilter($sFilter, $this->CurrentFilter);
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$this->Recordset_Selecting($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(), $this->getSqlGroupBy(),
			$this->getSqlHaving(), $this->getSqlOrderBy(), $sFilter, $sSort);
	}

	// Get ORDER BY clause
	function GetOrderBy() {
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql("", "", "", "", $this->getSqlOrderBy(), "", $sSort);
	}

	// Try to get record count
	function TryGetRecordCount($sSql) {
		$cnt = -1;
		if (($this->TableType == 'TABLE' || $this->TableType == 'VIEW' || $this->TableType == 'LINKTABLE') && preg_match("/^SELECT \* FROM/i", $sSql)) {
			$sSql = "SELECT COUNT(*) FROM" . preg_replace('/^SELECT\s([\s\S]+)?\*\sFROM/i', "", $sSql);
			$sOrderBy = $this->GetOrderBy();
			if (substr($sSql, strlen($sOrderBy) * -1) == $sOrderBy)
				$sSql = substr($sSql, 0, strlen($sSql) - strlen($sOrderBy)); // Remove ORDER BY clause
		} else {
			$sSql = "SELECT COUNT(*) FROM (" . $sSql . ") EW_COUNT_TABLE";
		}
		$conn = &$this->Connection();
		if ($rs = $conn->Execute($sSql)) {
			if (!$rs->EOF && $rs->FieldCount() > 0) {
				$cnt = $rs->fields[0];
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// Get record count based on filter (for detail record count in master table pages)
	function LoadRecordCount($sFilter) {
		$origFilter = $this->CurrentFilter;
		$this->CurrentFilter = $sFilter;
		$this->Recordset_Selecting($this->CurrentFilter);

		//$sSql = $this->SQL();
		$sSql = $this->GetSQL($this->CurrentFilter, "");
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			if ($rs = $this->LoadRs($this->CurrentFilter)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		$this->CurrentFilter = $origFilter;
		return intval($cnt);
	}

	// Get record count (for current List page)
	function SelectRecordCount() {
		$sSql = $this->SelectSQL();
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			$conn = &$this->Connection();
			if ($rs = $conn->Execute($sSql)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// INSERT statement
	function InsertSQL(&$rs) {
		$names = "";
		$values = "";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$names .= $this->fields[$name]->FldExpression . ",";
			$values .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($names, -1) == ",")
			$names = substr($names, 0, -1);
		while (substr($values, -1) == ",")
			$values = substr($values, 0, -1);
		return "INSERT INTO " . $this->UpdateTable . " ($names) VALUES ($values)";
	}

	// Insert
	function Insert(&$rs) {
		$conn = &$this->Connection();
		return $conn->Execute($this->InsertSQL($rs));
	}

	// UPDATE statement
	function UpdateSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "UPDATE " . $this->UpdateTable . " SET ";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$sql .= $this->fields[$name]->FldExpression . "=";
			$sql .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($sql, -1) == ",")
			$sql = substr($sql, 0, -1);
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		ew_AddFilter($filter, $where);
		if ($filter <> "")	$sql .= " WHERE " . $filter;
		return $sql;
	}

	// Update
	function Update(&$rs, $where = "", $rsold = NULL, $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->UpdateSQL($rs, $where, $curfilter));
	}

	// DELETE statement
	function DeleteSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "DELETE FROM " . $this->UpdateTable . " WHERE ";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		if ($rs) {
			if (array_key_exists('dbkey', $rs))
				ew_AddFilter($where, ew_QuotedName('dbkey', $this->DBID) . '=' . ew_QuotedValue($rs['dbkey'], $this->dbkey->FldDataType, $this->DBID));
		}
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		ew_AddFilter($filter, $where);
		if ($filter <> "")
			$sql .= $filter;
		else
			$sql .= "0=1"; // Avoid delete
		return $sql;
	}

	// Delete
	function Delete(&$rs, $where = "", $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->DeleteSQL($rs, $where, $curfilter));
	}

	// Key filter WHERE clause
	function SqlKeyFilter() {
		return "`dbkey` = @dbkey@";
	}

	// Key filter
	function KeyFilter() {
		$sKeyFilter = $this->SqlKeyFilter();
		if (!is_numeric($this->dbkey->CurrentValue))
			$sKeyFilter = "0=1"; // Invalid key
		$sKeyFilter = str_replace("@dbkey@", ew_AdjustSql($this->dbkey->CurrentValue, $this->DBID), $sKeyFilter); // Replace key value
		return $sKeyFilter;
	}

	// Return page URL
	function getReturnUrl() {
		$name = EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL;

		// Get referer URL automatically
		if (ew_ServerVar("HTTP_REFERER") <> "" && ew_ReferPage() <> ew_CurrentPage() && ew_ReferPage() <> "login.php") // Referer not same page or login page
			$_SESSION[$name] = ew_ServerVar("HTTP_REFERER"); // Save to Session
		if (@$_SESSION[$name] <> "") {
			return $_SESSION[$name];
		} else {
			return "Cust_timecards_adminlist.php";
		}
	}

	function setReturnUrl($v) {
		$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL] = $v;
	}

	// List URL
	function GetListUrl() {
		return "Cust_timecards_adminlist.php";
	}

	// View URL
	function GetViewUrl($parm = "") {
		if ($parm <> "")
			$url = $this->KeyUrl("Cust_timecards_adminview.php", $this->UrlParm($parm));
		else
			$url = $this->KeyUrl("Cust_timecards_adminview.php", $this->UrlParm(EW_TABLE_SHOW_DETAIL . "="));
		return $this->AddMasterUrl($url);
	}

	// Add URL
	function GetAddUrl($parm = "") {
		if ($parm <> "")
			$url = "Cust_timecards_adminadd.php?" . $this->UrlParm($parm);
		else
			$url = "Cust_timecards_adminadd.php";
		return $this->AddMasterUrl($url);
	}

	// Edit URL
	function GetEditUrl($parm = "") {
		$url = $this->KeyUrl("Cust_timecards_adminedit.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline edit URL
	function GetInlineEditUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=edit"));
		return $this->AddMasterUrl($url);
	}

	// Copy URL
	function GetCopyUrl($parm = "") {
		$url = $this->KeyUrl("Cust_timecards_adminadd.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline copy URL
	function GetInlineCopyUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=copy"));
		return $this->AddMasterUrl($url);
	}

	// Delete URL
	function GetDeleteUrl() {
		return $this->KeyUrl("Cust_timecards_admindelete.php", $this->UrlParm());
	}

	// Add master url
	function AddMasterUrl($url) {
		return $url;
	}

	function KeyToJson() {
		$json = "";
		$json .= "dbkey:" . ew_VarToJson($this->dbkey->CurrentValue, "number", "'");
		return "{" . $json . "}";
	}

	// Add key value to URL
	function KeyUrl($url, $parm = "") {
		$sUrl = $url . "?";
		if ($parm <> "") $sUrl .= $parm . "&";
		if (!is_null($this->dbkey->CurrentValue)) {
			$sUrl .= "dbkey=" . urlencode($this->dbkey->CurrentValue);
		} else {
			return "javascript:ew_Alert(ewLanguage.Phrase('InvalidRecord'));";
		}
		return $sUrl;
	}

	// Sort URL
	function SortUrl(&$fld) {
		if ($this->CurrentAction <> "" || $this->Export <> "" ||
			in_array($fld->FldType, array(128, 204, 205))) { // Unsortable data type
				return "";
		} elseif ($fld->Sortable) {
			$sUrlParm = $this->UrlParm("order=" . urlencode($fld->FldName) . "&amp;ordertype=" . $fld->ReverseSort());
			return $this->AddMasterUrl(ew_CurrentPage() . "?" . $sUrlParm);
		} else {
			return "";
		}
	}

	// Get record keys from $_POST/$_GET/$_SESSION
	function GetRecordKeys() {
		global $EW_COMPOSITE_KEY_SEPARATOR;
		$arKeys = array();
		$arKey = array();
		if (isset($_POST["key_m"])) {
			$arKeys = ew_StripSlashes($_POST["key_m"]);
			$cnt = count($arKeys);
		} elseif (isset($_GET["key_m"])) {
			$arKeys = ew_StripSlashes($_GET["key_m"]);
			$cnt = count($arKeys);
		} elseif (!empty($_GET) || !empty($_POST)) {
			$isPost = ew_IsHttpPost();
			if ($isPost && isset($_POST["dbkey"]))
				$arKeys[] = ew_StripSlashes($_POST["dbkey"]);
			elseif (isset($_GET["dbkey"]))
				$arKeys[] = ew_StripSlashes($_GET["dbkey"]);
			else
				$arKeys = NULL; // Do not setup

			//return $arKeys; // Do not return yet, so the values will also be checked by the following code
		}

		// Check keys
		$ar = array();
		if (is_array($arKeys)) {
			foreach ($arKeys as $key) {
				if (!is_numeric($key))
					continue;
				$ar[] = $key;
			}
		}
		return $ar;
	}

	// Get key filter
	function GetKeyFilter() {
		$arKeys = $this->GetRecordKeys();
		$sKeyFilter = "";
		foreach ($arKeys as $key) {
			if ($sKeyFilter <> "") $sKeyFilter .= " OR ";
			$this->dbkey->CurrentValue = $key;
			$sKeyFilter .= "(" . $this->KeyFilter() . ")";
		}
		return $sKeyFilter;
	}

	// Load rows based on filter
	function &LoadRs($sFilter) {

		// Set up filter (SQL WHERE clause) and get return SQL
		//$this->CurrentFilter = $sFilter;
		//$sSql = $this->SQL();

		$sSql = $this->GetSQL($sFilter, "");
		$conn = &$this->Connection();
		$rs = $conn->Execute($sSql);
		return $rs;
	}

	// Load row values from recordset
	function LoadListRowValues(&$rs) {
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->weeknumber->setDbValue($rs->fields('weeknumber'));
		$this->start->setDbValue($rs->fields('start'));
		$this->end->setDbValue($rs->fields('end'));
		$this->dbkey_councilor->setDbValue($rs->fields('dbkey_councilor'));
		$this->date->setDbValue($rs->fields('date'));
		$this->in->setDbValue($rs->fields('in'));
		$this->out->setDbValue($rs->fields('out'));
		$this->approved_by->setDbValue($rs->fields('approved_by'));
		$this->approved_on->setDbValue($rs->fields('approved_on'));
		$this->created_on->setDbValue($rs->fields('created_on'));
		$this->updated_on->setDbValue($rs->fields('updated_on'));
		$this->created_by->setDbValue($rs->fields('created_by'));
		$this->updated_by->setDbValue($rs->fields('updated_by'));
		$this->approved->setDbValue($rs->fields('approved'));
		$this->regular->setDbValue($rs->fields('regular'));
		$this->overtime->setDbValue($rs->fields('overtime'));
		$this->total->setDbValue($rs->fields('total'));
	}

	// Render list row values
	function RenderListRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

   // Common render codes
		// dbkey

		$this->dbkey->CellCssStyle = "white-space: nowrap;";

		// weeknumber
		$this->weeknumber->CellCssStyle = "white-space: nowrap;";

		// start
		// end

		$this->end->CellCssStyle = "white-space: nowrap;";

		// dbkey_councilor
		// date
		// in
		// out
		// approved_by

		$this->approved_by->CellCssStyle = "white-space: nowrap;";

		// approved_on
		$this->approved_on->CellCssStyle = "white-space: nowrap;";

		// created_on
		$this->created_on->CellCssStyle = "white-space: nowrap;";

		// updated_on
		$this->updated_on->CellCssStyle = "white-space: nowrap;";

		// created_by
		$this->created_by->CellCssStyle = "white-space: nowrap;";

		// updated_by
		$this->updated_by->CellCssStyle = "white-space: nowrap;";

		// approved
		// regular
		// overtime
		// total
		// dbkey

		$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// weeknumber
		if (strval($this->weeknumber->CurrentValue) <> "") {
			$sFilterWrk = "WEEKOFYEAR(adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY))" . ew_SearchString("=", $this->weeknumber->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT WEEKOFYEAR(adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY)), adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY) AS `DispFld`, adddate(timecards.date, INTERVAL 7-DAYOFWEEK(timecards.date) DAY) AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `timecards`";
		$sWhereWrk = "";
		$this->weeknumber->LookupFilters = array("df1" => "0", "df2" => "0");
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->weeknumber, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = ew_FormatDateTime($rswrk->fields('DispFld'), 0);
				$arwrk[2] = ew_FormatDateTime($rswrk->fields('Disp2Fld'), 0);
				$this->weeknumber->ViewValue = $this->weeknumber->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->weeknumber->ViewValue = $this->weeknumber->CurrentValue;
			}
		} else {
			$this->weeknumber->ViewValue = NULL;
		}
		$this->weeknumber->ViewCustomAttributes = "";

		// start
		if (strval($this->start->CurrentValue) <> "") {
			$sFilterWrk = "adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY)" . ew_SearchString("=", $this->start->CurrentValue, EW_DATATYPE_DATE, "");
		$sSqlWrk = "SELECT DISTINCT adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY), adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY) AS `DispFld`, adddate(timecards.date, INTERVAL 7-DAYOFWEEK(timecards.date) DAY) AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `timecards`";
		$sWhereWrk = "";
		$this->start->LookupFilters = array("df1" => "0", "df2" => "0");
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->start, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = ew_FormatDateTime($rswrk->fields('DispFld'), 0);
				$arwrk[2] = ew_FormatDateTime($rswrk->fields('Disp2Fld'), 0);
				$this->start->ViewValue = $this->start->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->start->ViewValue = $this->start->CurrentValue;
			}
		} else {
			$this->start->ViewValue = NULL;
		}
		$this->start->ViewValue = ew_FormatDateTime($this->start->ViewValue, 0);
		$this->start->ViewCustomAttributes = "";

		// end
		$this->end->ViewValue = $this->end->CurrentValue;
		$this->end->ViewValue = ew_FormatDateTime($this->end->ViewValue, 0);
		$this->end->ViewCustomAttributes = "";

		// dbkey_councilor
		if (strval($this->dbkey_councilor->CurrentValue) <> "") {
			$sFilterWrk = "counselor.dbkey" . ew_SearchString("=", $this->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM counselor";
		$sWhereWrk = "(counselor.active = 1)";
		$this->dbkey_councilor->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_councilor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->CurrentValue;
			}
		} else {
			$this->dbkey_councilor->ViewValue = NULL;
		}
		$this->dbkey_councilor->ViewCustomAttributes = "";

		// date
		$this->date->ViewValue = $this->date->CurrentValue;
		$this->date->ViewValue = ew_FormatDateTime($this->date->ViewValue, 0);
		$this->date->ViewCustomAttributes = "";

		// in
		if (strval($this->in->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->in->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `tables_data`";
		$sWhereWrk = "";
		$this->in->LookupFilters = array();
		$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->in, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `dbkey`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->in->ViewValue = $this->in->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->in->ViewValue = $this->in->CurrentValue;
			}
		} else {
			$this->in->ViewValue = NULL;
		}
		$this->in->ViewCustomAttributes = "";

		// out
		if (strval($this->out->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->out->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `tables_data`";
		$sWhereWrk = "";
		$this->out->LookupFilters = array();
		$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->out, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->out->ViewValue = $this->out->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->out->ViewValue = $this->out->CurrentValue;
			}
		} else {
			$this->out->ViewValue = NULL;
		}
		$this->out->ViewCustomAttributes = "";

		// approved_by
		$this->approved_by->ViewValue = $this->approved_by->CurrentValue;
		$this->approved_by->ViewCustomAttributes = "";

		// approved_on
		$this->approved_on->ViewValue = $this->approved_on->CurrentValue;
		$this->approved_on->ViewValue = ew_FormatDateTime($this->approved_on->ViewValue, 0);
		$this->approved_on->ViewCustomAttributes = "";

		// created_on
		$this->created_on->ViewValue = $this->created_on->CurrentValue;
		$this->created_on->ViewValue = ew_FormatDateTime($this->created_on->ViewValue, 0);
		$this->created_on->ViewCustomAttributes = "";

		// updated_on
		$this->updated_on->ViewValue = $this->updated_on->CurrentValue;
		$this->updated_on->ViewValue = ew_FormatDateTime($this->updated_on->ViewValue, 0);
		$this->updated_on->ViewCustomAttributes = "";

		// created_by
		$this->created_by->ViewValue = $this->created_by->CurrentValue;
		$this->created_by->ViewCustomAttributes = "";

		// updated_by
		$this->updated_by->ViewValue = $this->updated_by->CurrentValue;
		$this->updated_by->ViewCustomAttributes = "";

		// approved
		if (strval($this->approved->CurrentValue) <> "") {
			$this->approved->ViewValue = "";
			$arwrk = explode(",", strval($this->approved->CurrentValue));
			$cnt = count($arwrk);
			for ($ari = 0; $ari < $cnt; $ari++) {
				$this->approved->ViewValue .= $this->approved->OptionCaption(trim($arwrk[$ari]));
				if ($ari < $cnt-1) $this->approved->ViewValue .= ew_ViewOptionSeparator($ari);
			}
		} else {
			$this->approved->ViewValue = NULL;
		}
		$this->approved->ViewCustomAttributes = "";

		// regular
		$this->regular->ViewValue = $this->regular->CurrentValue;
		$this->regular->ViewValue = ew_FormatNumber($this->regular->ViewValue, 2, -2, -2, -2);
		$this->regular->ViewCustomAttributes = "";

		// overtime
		$this->overtime->ViewValue = $this->overtime->CurrentValue;
		$this->overtime->ViewValue = ew_FormatNumber($this->overtime->ViewValue, 2, -2, -2, -2);
		$this->overtime->ViewCustomAttributes = "";

		// total
		$this->total->ViewValue = $this->total->CurrentValue;
		$this->total->ViewValue = ew_FormatNumber($this->total->ViewValue, 2, -1, -2, -2);
		$this->total->ViewCustomAttributes = "";

		// dbkey
		$this->dbkey->LinkCustomAttributes = "";
		$this->dbkey->HrefValue = "";
		$this->dbkey->TooltipValue = "";

		// weeknumber
		$this->weeknumber->LinkCustomAttributes = "";
		$this->weeknumber->HrefValue = "";
		$this->weeknumber->TooltipValue = "";

		// start
		$this->start->LinkCustomAttributes = "";
		$this->start->HrefValue = "";
		$this->start->TooltipValue = "";

		// end
		$this->end->LinkCustomAttributes = "";
		$this->end->HrefValue = "";
		$this->end->TooltipValue = "";

		// dbkey_councilor
		$this->dbkey_councilor->LinkCustomAttributes = "";
		$this->dbkey_councilor->HrefValue = "";
		$this->dbkey_councilor->TooltipValue = "";

		// date
		$this->date->LinkCustomAttributes = "";
		$this->date->HrefValue = "";
		$this->date->TooltipValue = "";

		// in
		$this->in->LinkCustomAttributes = "";
		$this->in->HrefValue = "";
		$this->in->TooltipValue = "";

		// out
		$this->out->LinkCustomAttributes = "";
		$this->out->HrefValue = "";
		$this->out->TooltipValue = "";

		// approved_by
		$this->approved_by->LinkCustomAttributes = "";
		$this->approved_by->HrefValue = "";
		$this->approved_by->TooltipValue = "";

		// approved_on
		$this->approved_on->LinkCustomAttributes = "";
		$this->approved_on->HrefValue = "";
		$this->approved_on->TooltipValue = "";

		// created_on
		$this->created_on->LinkCustomAttributes = "";
		$this->created_on->HrefValue = "";
		$this->created_on->TooltipValue = "";

		// updated_on
		$this->updated_on->LinkCustomAttributes = "";
		$this->updated_on->HrefValue = "";
		$this->updated_on->TooltipValue = "";

		// created_by
		$this->created_by->LinkCustomAttributes = "";
		$this->created_by->HrefValue = "";
		$this->created_by->TooltipValue = "";

		// updated_by
		$this->updated_by->LinkCustomAttributes = "";
		$this->updated_by->HrefValue = "";
		$this->updated_by->TooltipValue = "";

		// approved
		$this->approved->LinkCustomAttributes = "";
		$this->approved->HrefValue = "";
		$this->approved->TooltipValue = "";

		// regular
		$this->regular->LinkCustomAttributes = "";
		$this->regular->HrefValue = "";
		$this->regular->TooltipValue = "";

		// overtime
		$this->overtime->LinkCustomAttributes = "";
		$this->overtime->HrefValue = "";
		$this->overtime->TooltipValue = "";

		// total
		$this->total->LinkCustomAttributes = "";
		$this->total->HrefValue = "";
		$this->total->TooltipValue = "";

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Render edit row values
	function RenderEditRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

		// dbkey
		$this->dbkey->EditAttrs["class"] = "form-control";
		$this->dbkey->EditCustomAttributes = "";
		$this->dbkey->EditValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// weeknumber
		$this->weeknumber->EditAttrs["class"] = "form-control";
		$this->weeknumber->EditCustomAttributes = "";

		// start
		$this->start->EditAttrs["class"] = "form-control";
		$this->start->EditCustomAttributes = "";

		// end
		$this->end->EditAttrs["class"] = "form-control";
		$this->end->EditCustomAttributes = "";
		$this->end->EditValue = ew_FormatDateTime($this->end->CurrentValue, 8);
		$this->end->PlaceHolder = ew_RemoveHtml($this->end->FldCaption());

		// dbkey_councilor
		$this->dbkey_councilor->EditAttrs["class"] = "form-control";
		$this->dbkey_councilor->EditCustomAttributes = "";
		if (strval($this->dbkey_councilor->CurrentValue) <> "") {
			$sFilterWrk = "counselor.dbkey" . ew_SearchString("=", $this->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM counselor";
		$sWhereWrk = "(counselor.active = 1)";
		$this->dbkey_councilor->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_councilor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_councilor->EditValue = $this->dbkey_councilor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_councilor->EditValue = $this->dbkey_councilor->CurrentValue;
			}
		} else {
			$this->dbkey_councilor->EditValue = NULL;
		}
		$this->dbkey_councilor->ViewCustomAttributes = "";

		// date
		$this->date->EditAttrs["class"] = "form-control";
		$this->date->EditCustomAttributes = "";
		$this->date->EditValue = ew_FormatDateTime($this->date->CurrentValue, 8);
		$this->date->PlaceHolder = ew_RemoveHtml($this->date->FldCaption());

		// in
		$this->in->EditAttrs["class"] = "form-control";
		$this->in->EditCustomAttributes = "";

		// out
		$this->out->EditAttrs["class"] = "form-control";
		$this->out->EditCustomAttributes = "";

		// approved_by
		$this->approved_by->EditAttrs["class"] = "form-control";
		$this->approved_by->EditCustomAttributes = "";
		$this->approved_by->EditValue = $this->approved_by->CurrentValue;
		$this->approved_by->PlaceHolder = ew_RemoveHtml($this->approved_by->FldCaption());

		// approved_on
		$this->approved_on->EditAttrs["class"] = "form-control";
		$this->approved_on->EditCustomAttributes = "";
		$this->approved_on->EditValue = ew_FormatDateTime($this->approved_on->CurrentValue, 8);
		$this->approved_on->PlaceHolder = ew_RemoveHtml($this->approved_on->FldCaption());

		// created_on
		$this->created_on->EditAttrs["class"] = "form-control";
		$this->created_on->EditCustomAttributes = "";
		$this->created_on->EditValue = ew_FormatDateTime($this->created_on->CurrentValue, 8);
		$this->created_on->PlaceHolder = ew_RemoveHtml($this->created_on->FldCaption());

		// updated_on
		$this->updated_on->EditAttrs["class"] = "form-control";
		$this->updated_on->EditCustomAttributes = "";
		$this->updated_on->EditValue = ew_FormatDateTime($this->updated_on->CurrentValue, 8);
		$this->updated_on->PlaceHolder = ew_RemoveHtml($this->updated_on->FldCaption());

		// created_by
		$this->created_by->EditAttrs["class"] = "form-control";
		$this->created_by->EditCustomAttributes = "";
		$this->created_by->EditValue = $this->created_by->CurrentValue;
		$this->created_by->PlaceHolder = ew_RemoveHtml($this->created_by->FldCaption());

		// updated_by
		$this->updated_by->EditAttrs["class"] = "form-control";
		$this->updated_by->EditCustomAttributes = "";
		$this->updated_by->EditValue = $this->updated_by->CurrentValue;
		$this->updated_by->PlaceHolder = ew_RemoveHtml($this->updated_by->FldCaption());

		// approved
		$this->approved->EditCustomAttributes = "";
		$this->approved->EditValue = $this->approved->Options(FALSE);

		// regular
		$this->regular->EditAttrs["class"] = "form-control";
		$this->regular->EditCustomAttributes = "";
		$this->regular->EditValue = $this->regular->CurrentValue;
		$this->regular->PlaceHolder = ew_RemoveHtml($this->regular->FldCaption());
		if (strval($this->regular->EditValue) <> "" && is_numeric($this->regular->EditValue)) $this->regular->EditValue = ew_FormatNumber($this->regular->EditValue, -2, -2, -2, -2);

		// overtime
		$this->overtime->EditAttrs["class"] = "form-control";
		$this->overtime->EditCustomAttributes = "";
		$this->overtime->EditValue = $this->overtime->CurrentValue;
		$this->overtime->PlaceHolder = ew_RemoveHtml($this->overtime->FldCaption());
		if (strval($this->overtime->EditValue) <> "" && is_numeric($this->overtime->EditValue)) $this->overtime->EditValue = ew_FormatNumber($this->overtime->EditValue, -2, -2, -2, -2);

		// total
		$this->total->EditAttrs["class"] = "form-control";
		$this->total->EditCustomAttributes = "";
		$this->total->EditValue = $this->total->CurrentValue;
		$this->total->PlaceHolder = ew_RemoveHtml($this->total->FldCaption());
		if (strval($this->total->EditValue) <> "" && is_numeric($this->total->EditValue)) $this->total->EditValue = ew_FormatNumber($this->total->EditValue, -2, -1, -2, -2);

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Aggregate list row values
	function AggregateListRowValues() {
	}

	// Aggregate list row (for rendering)
	function AggregateListRow() {

		// Call Row Rendered event
		$this->Row_Rendered();
	}
	var $ExportDoc;

	// Export data in HTML/CSV/Word/Excel/Email/PDF format
	function ExportDocument(&$Doc, &$Recordset, $StartRec, $StopRec, $ExportPageType = "") {
		if (!$Recordset || !$Doc)
			return;
		if (!$Doc->ExportCustom) {

			// Write header
			$Doc->ExportTableHeader();
			if ($Doc->Horizontal) { // Horizontal format, write header
				$Doc->BeginExportRow();
				if ($ExportPageType == "view") {
					if ($this->start->Exportable) $Doc->ExportCaption($this->start);
					if ($this->end->Exportable) $Doc->ExportCaption($this->end);
					if ($this->dbkey_councilor->Exportable) $Doc->ExportCaption($this->dbkey_councilor);
					if ($this->date->Exportable) $Doc->ExportCaption($this->date);
					if ($this->in->Exportable) $Doc->ExportCaption($this->in);
					if ($this->out->Exportable) $Doc->ExportCaption($this->out);
					if ($this->approved_by->Exportable) $Doc->ExportCaption($this->approved_by);
					if ($this->approved_on->Exportable) $Doc->ExportCaption($this->approved_on);
					if ($this->created_on->Exportable) $Doc->ExportCaption($this->created_on);
					if ($this->updated_on->Exportable) $Doc->ExportCaption($this->updated_on);
					if ($this->created_by->Exportable) $Doc->ExportCaption($this->created_by);
					if ($this->updated_by->Exportable) $Doc->ExportCaption($this->updated_by);
					if ($this->approved->Exportable) $Doc->ExportCaption($this->approved);
					if ($this->regular->Exportable) $Doc->ExportCaption($this->regular);
					if ($this->overtime->Exportable) $Doc->ExportCaption($this->overtime);
					if ($this->total->Exportable) $Doc->ExportCaption($this->total);
				} else {
					if ($this->weeknumber->Exportable) $Doc->ExportCaption($this->weeknumber);
					if ($this->start->Exportable) $Doc->ExportCaption($this->start);
					if ($this->dbkey_councilor->Exportable) $Doc->ExportCaption($this->dbkey_councilor);
					if ($this->date->Exportable) $Doc->ExportCaption($this->date);
					if ($this->in->Exportable) $Doc->ExportCaption($this->in);
					if ($this->out->Exportable) $Doc->ExportCaption($this->out);
					if ($this->approved->Exportable) $Doc->ExportCaption($this->approved);
					if ($this->regular->Exportable) $Doc->ExportCaption($this->regular);
					if ($this->overtime->Exportable) $Doc->ExportCaption($this->overtime);
					if ($this->total->Exportable) $Doc->ExportCaption($this->total);
				}
				$Doc->EndExportRow();
			}
		}

		// Move to first record
		$RecCnt = $StartRec - 1;
		if (!$Recordset->EOF) {
			$Recordset->MoveFirst();
			if ($StartRec > 1)
				$Recordset->Move($StartRec - 1);
		}
		while (!$Recordset->EOF && $RecCnt < $StopRec) {
			$RecCnt++;
			if (intval($RecCnt) >= intval($StartRec)) {
				$RowCnt = intval($RecCnt) - intval($StartRec) + 1;

				// Page break
				if ($this->ExportPageBreakCount > 0) {
					if ($RowCnt > 1 && ($RowCnt - 1) % $this->ExportPageBreakCount == 0)
						$Doc->ExportPageBreak();
				}
				$this->LoadListRowValues($Recordset);

				// Render row
				$this->RowType = EW_ROWTYPE_VIEW; // Render view
				$this->ResetAttrs();
				$this->RenderListRow();
				if (!$Doc->ExportCustom) {
					$Doc->BeginExportRow($RowCnt); // Allow CSS styles if enabled
					if ($ExportPageType == "view") {
						if ($this->start->Exportable) $Doc->ExportField($this->start);
						if ($this->end->Exportable) $Doc->ExportField($this->end);
						if ($this->dbkey_councilor->Exportable) $Doc->ExportField($this->dbkey_councilor);
						if ($this->date->Exportable) $Doc->ExportField($this->date);
						if ($this->in->Exportable) $Doc->ExportField($this->in);
						if ($this->out->Exportable) $Doc->ExportField($this->out);
						if ($this->approved_by->Exportable) $Doc->ExportField($this->approved_by);
						if ($this->approved_on->Exportable) $Doc->ExportField($this->approved_on);
						if ($this->created_on->Exportable) $Doc->ExportField($this->created_on);
						if ($this->updated_on->Exportable) $Doc->ExportField($this->updated_on);
						if ($this->created_by->Exportable) $Doc->ExportField($this->created_by);
						if ($this->updated_by->Exportable) $Doc->ExportField($this->updated_by);
						if ($this->approved->Exportable) $Doc->ExportField($this->approved);
						if ($this->regular->Exportable) $Doc->ExportField($this->regular);
						if ($this->overtime->Exportable) $Doc->ExportField($this->overtime);
						if ($this->total->Exportable) $Doc->ExportField($this->total);
					} else {
						if ($this->weeknumber->Exportable) $Doc->ExportField($this->weeknumber);
						if ($this->start->Exportable) $Doc->ExportField($this->start);
						if ($this->dbkey_councilor->Exportable) $Doc->ExportField($this->dbkey_councilor);
						if ($this->date->Exportable) $Doc->ExportField($this->date);
						if ($this->in->Exportable) $Doc->ExportField($this->in);
						if ($this->out->Exportable) $Doc->ExportField($this->out);
						if ($this->approved->Exportable) $Doc->ExportField($this->approved);
						if ($this->regular->Exportable) $Doc->ExportField($this->regular);
						if ($this->overtime->Exportable) $Doc->ExportField($this->overtime);
						if ($this->total->Exportable) $Doc->ExportField($this->total);
					}
					$Doc->EndExportRow();
				}
			}

			// Call Row Export server event
			if ($Doc->ExportCustom)
				$this->Row_Export($Recordset->fields);
			$Recordset->MoveNext();
		}
		if (!$Doc->ExportCustom) {
			$Doc->ExportTableFooter();
		}
	}

	// Get auto fill value
	function GetAutoFill($id, $val) {
		$rsarr = array();
		$rowcnt = 0;

		// Output
		if (is_array($rsarr) && $rowcnt > 0) {
			$fldcnt = count($rsarr[0]);
			for ($i = 0; $i < $rowcnt; $i++) {
				for ($j = 0; $j < $fldcnt; $j++) {
					$str = strval($rsarr[$i][$j]);
					$str = ew_ConvertToUtf8($str);
					if (isset($post["keepCRLF"])) {
						$str = str_replace(array("\r", "\n"), array("\\r", "\\n"), $str);
					} else {
						$str = str_replace(array("\r", "\n"), array(" ", " "), $str);
					}
					$rsarr[$i][$j] = $str;
				}
			}
			return ew_ArrayToJson($rsarr);
		} else {
			return FALSE;
		}
	}

	// Table level events
	// Recordset Selecting event
	function Recordset_Selecting(&$filter) {

		// Enter your code here	
	}

	// Recordset Selected event
	function Recordset_Selected(&$rs) {

		//echo "Recordset Selected";
	}

	// Recordset Search Validated event
	function Recordset_SearchValidated() {

		// Example:
		//$this->MyField1->AdvancedSearch->SearchValue = "your search criteria"; // Search value

	}

	// Recordset Searching event
	function Recordset_Searching(&$filter) {

		// Enter your code here	
	}

	// Row_Selecting event
	function Row_Selecting(&$filter) {

		// Enter your code here	
	}

	// Row Selected event
	function Row_Selected(&$rs) {

		//echo "Row Selected";
	}

	// Row Inserting event
	function Row_Inserting($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE
		// Default to user and current time

		$this->updated_by->DbValue = CurrentUserID();
		$this->updated_on->DbValue = date('Y-m-d H:m:s');
		$time_in = $rsnew['in'];
		$time_out = $rsnew['out'];
		if ($time_in > $time_out) {
			$this->setWarningMessage("In time must be less then out time.");
			$this->in->CssStyle = "color:red;";
			$this->out->CssStyle = "color:red;";
			return FALSE;
		}

		// Check to make sure you do not over lap on dates. Big no no
		// Caluclate total weeks

			$sql = "SELECT `in`, `out` FROM timecards WHERE dbkey <> 0 and dbkey_councilor = " . $this->dbkey_councilor->DbValue . " and timecards.date = '" . $rsnew['date'] ."' and
			((`in` <= '" . $rsnew['in'] ."' and `out` >= '" . $rsnew['in'] ."') or (`in` >= '" . $rsnew['in'] ."' and `out` > '" . $rsnew['in'] ."') or (`in` >= '" . $rsnew['out'] ."' and `out` > '" . $rsnew['out'] ."'))";

			//echo $sql;
			//exit();

			$rsto = ew_Execute($sql);
			if ($rsto && $rsto->RecordCount() > 0) {
				$this->setWarningMessage("Date and time has already been entered.");
				$this->in->CssStyle = "color:red;";
				$this->out->CssStyle = "color:red;";
				return FALSE;
			}

			//$rsto->Close();
		return TRUE;
	}

	// Row Inserted event
	function Row_Inserted($rsold, &$rsnew) {

		//echo "Row Inserted"
	}

	// Row Updating event
	function Row_Updating($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE
		// Default to user and current time

		$this->updated_by->DbValue = CurrentUserID();
		$this->updated_on->DbValue = date('Y-m-d H:m:s');
		$time_in = $rsnew['in'];
		$time_out = $rsnew['out'];
		if ($time_in > $time_out) {
			$this->setWarningMessage("In time must be less then out time.");
			$this->in->CssStyle = "color:red;";
			$this->out->CssStyle = "color:red;";
			return FALSE;
		}

		// Check to make sure you do not over lap on dates. Big no no
		// Caluclate total weeks

			$sql = "SELECT `in`, `out` FROM timecards WHERE dbkey <> " . $this->dbkey->DbValue . " and dbkey_councilor = " . $this->dbkey_councilor->DbValue . " and timecards.date = '" . $this->date->DbValue ."' and
			((`in` <= '" . $this->in->DbValue ."' and `out` >= '" . $this->in->DbValue ."') or (`in` >= '" . $this->in->DbValue ."' and `out` > '" . $this->in->DbValue ."') or (`in` >= '" . $this->out->DbValue ."' and `out` > '" . $this->out->DbValue ."'))";

			//echo $sql;
			//exit();

			$rsto = ew_Execute($sql);
			if ($rsto && $rsto->RecordCount() > 0) {
				$this->setWarningMessage("Date and time has already been entered.");
				$this->in->CssStyle = "color:red;";
				$this->out->CssStyle = "color:red;";
				return FALSE;
			}
			$rsto->Close();
		return TRUE;
	}

	// Row Updated event
	function Row_Updated($rsold, &$rsnew) {

		//echo "Row Updated";
	}

	// Row Update Conflict event
	function Row_UpdateConflict($rsold, &$rsnew) {

		// Enter your code here
		// To ignore conflict, set return value to FALSE

		return TRUE;
	}

	// Grid Inserting event
	function Grid_Inserting() {

		// Enter your code here
		// To reject grid insert, set return value to FALSE

		return TRUE;
	}

	// Grid Inserted event
	function Grid_Inserted($rsnew) {

		//echo "Grid Inserted";
	}

	// Grid Updating event
	function Grid_Updating($rsold) {

		// Enter your code here
		// To reject grid update, set return value to FALSE

		return TRUE;
	}

	// Grid Updated event
	function Grid_Updated($rsold, $rsnew) {

		//echo "Grid Updated";
	}

	// Row Deleting event
	function Row_Deleting(&$rs) {

		// Enter your code here
		// To cancel, set return value to False

		return TRUE;
	}

	// Row Deleted event
	function Row_Deleted(&$rs) {

		//echo "Row Deleted";
	}

	// Email Sending event
	function Email_Sending(&$Email, &$Args) {

		//var_dump($Email); var_dump($Args); exit();
		return TRUE;
	}

	// Lookup Selecting event
	function Lookup_Selecting($fld, &$filter) {

		//var_dump($fld->FldName, $fld->LookupFilters, $filter); // Uncomment to view the filter
		// Enter your code here

	}

	// Row Rendered event
	function Row_Rendering() {
	}

	// Row Rendered event
	function Row_Rendered() {
			$this->RowAttrs["style"] = "background-color: white;";

		//if ($this->weeknumber->DbValue % 2 == 0) {
	//		$this->RowAttrs["style"] = "background-color: grey;";
	//	};
		//echo "<h1> SESSION IS " . $_SESSION["EVERYOTHER"] . "</h1>";

		if ($_SESSION['previousweeknumber'] <> $this->weeknumber->DbValue)
		{
			$this->RowAttrs["style"] = "background-color: white;";
			$_SESSION['previousweeknumber'] = $this->weeknumber->DbValue;
			$_SESSION['counter'] += 1;
		}
		if ($_SESSION['counter'] % 2 == 0) {
			$this->RowAttrs["style"] = "background-color: grey;";
		};

		// To view properties of field class, use:
		//var_dump($this-><FieldName>);

		$in_minutes = intval(substr($this->in->DbValue,0,2)) * 60 + intval(substr($this->in->DbValue,2,2));
		$out_minutes = intval(substr($this->out->DbValue,0,2)) * 60 + intval(substr($this->out->DbValue,2,2));	
		$diff_minutes = $out_minutes - $in_minutes;
		$diff_hours = $diff_minutes/60;
		$minutes =  $diff_minutes - intval($diff_hours) * 60;
		$display_hours = intval($diff_hours) . " Hours ";
		if (intval($diff_hours) == 0) $display_hours = '';
		$display_minutes = intval($minutes) . " Minutes";
		if ($minutes == 0) $display_minutes = '';
		$this->regular->DbValue = $display_hours . $display_minutes;
		$this->regular->CurrentValue = $display_hours . $display_minutes;
		$this->regular->ViewValue = $display_hours . $display_minutes;

		// Get Sunday's date
		$sunday_date = new DateTime(date($this->date->DbValue));
		$sunday_date->sub(new DateInterval('P' . date('w',strtotime($this->date->DbValue)) . 'D'));

		//$this->overtime->ViewValue = $sunday_date->format('m/d/Y');
		// Get following Monday's date

		$monday_date = new DateTime($sunday_date->format('m/d/Y'));
		$monday_date->add(new DateInterval('P' . 6 . 'D'));

		//$this->overtime->ViewValue = $monday_date->format('m/d/Y');
		// Get Saturdays Date

		if ($this->dbkey_councilor->DbValue <> NULL)
		{

			// Caluclate total weeks
			$sql = "SELECT `in`, `out` ,`date` FROM timecards WHERE dbkey_councilor = " . $this->dbkey_councilor->DbValue . " and timecards.date >= '" . $sunday_date->format('Y-m-d') . "' and timecards.date <= '" . $monday_date->format('Y-m-d') . "' and (timecards.date < '" . $this->date->DbValue ."' or (timecards.date = '" . $this->date->DbValue . "' and `out` <= '" . $this->out->DbValue ."')) order by `date` ASC, `in` ASC";

			//echo $sql;
			$rsto = ew_Execute($sql);
			$bucket_regular = 0;
			$bucket_overtime = 0;
			$bucket_total = 0;
			$regular_break_point = 40*60;
			$first = true;
			if ($rsto && $rsto->RecordCount() > 0) {
				while (!$rsto->EOF) {

					//echo $rsto->fields['in'];
					$in_minutes = intval(substr($rsto->fields['in'],0,2)) * 60 + intval(substr($rsto->fields['in'],2,2));
					$out_minutes = intval(substr($rsto->fields['out'],0,2)) * 60 + intval(substr($rsto->fields['out'],2,2));
					$diff_minutes = $out_minutes - $in_minutes;

					// Calculate total
					$bucket_total += $diff_minutes;

					// Apply overtime hoursand no hours in regular.
					if ($bucket_total > $regular_break_point) {
							if ($first) {
								$bucket_overtime = $bucket_total - $regular_break_point;
								$bucket_regular =  $regular_break_point;
								$first = false;
							}
							else {

								//$bucket_overtime = $bucket_total;
								//$bucket_regular = 0;

								$bucket_overtime = $bucket_total - $regular_break_point;
								$bucket_regular =  $regular_break_point;
							}
					}

					// Happen until we exceed into over time hours. 
					else if (($bucket_total) <= $regular_break_point)
						{
							$bucket_regular = $bucket_total;
							$bucket_overtime = 0;
						}
					$rsto->MoveNext();
				}

				// Set regular hours
				$diff_hours = $bucket_regular/60;
				$minutes =  $bucket_regular - intval($diff_hours) * 60;
				$display_hours = intval($diff_hours) . " Hours ";
				if (intval($diff_hours) == 0) $display_hours = '';
				$display_minutes = intval($minutes) . " Minutes";
				if ($minutes == 0) $display_minutes = '';
				$this->regular->DbValue = $display_hours . $display_minutes;
				$this->regular->CurrentValue = $display_hours . $display_minutes;
				$this->regular->ViewValue = $display_hours . $display_minutes;

				// Set overtime hours
				$diff_hours = $bucket_overtime/60;
				$minutes =  $bucket_overtime - intval($diff_hours) * 60;
				$display_hours = intval($diff_hours) . " Hours ";
				if (intval($diff_hours) == 0) $display_hours = '';
					$display_minutes = intval($minutes) . " Minutes";
				if ($minutes == 0) $display_minutes = '';
				$this->overtime->DbValue = $display_hours . $display_minutes;
				$this->overtime->CurrentValue = $display_hours . $display_minutes;
				$this->overtime->ViewValue = $display_hours . $display_minutes;

				// Set total hours
				$diff_hours = $bucket_total/60;
				$minutes =  $bucket_total - intval($diff_hours) * 60;
				$display_hours = intval($diff_hours) . " Hours ";
				if (intval($diff_hours) == 0) $display_hours = '';
				$display_minutes = intval($minutes) . " Minutes";
				if ($minutes == 0) $display_minutes = '';
				$this->total->DbValue = $display_hours . $display_minutes;
				$this->total->CurrentValue = $display_hours . $display_minutes;
				$this->total->ViewValue = $display_hours . $display_minutes;
				$rsto->Close();
			}
		}
	}

	// User ID Filtering event
	function UserID_Filtering(&$filter) {

		// Enter your code here
	}
}
?>
