<?php
if (session_id() == "") session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg12.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql12.php") ?>
<?php include_once "phpfn12.php" ?>
<?php

// Global variable for table object
$Weekly_Counselor_Activitys_Summary = NULL;

//
// Table class for Weekly Counselor Activitys Summary
//
class cWeekly_Counselor_Activitys_Summary extends cTableBase {
	var $dbkey_councilor;
	var $dbkey_client;
	var $date;
	var $time;
	var $dbkey;
	var $comment;
	var $dbkey_activity;
	var $attachment;
	var $budget;
	var $allocated;
	var $remain;

	//
	// Table class constructor
	//
	function __construct() {
		global $Language;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();
		$this->TableVar = 'Weekly_Counselor_Activitys_Summary';
		$this->TableName = 'Weekly Counselor Activitys Summary';
		$this->TableType = 'REPORT';

		// Update Table
		$this->UpdateTable = "`client_activity`";
		$this->DBID = 'DB';
		$this->ExportAll = TRUE;
		$this->ExportPageBreakCount = 0; // Page break per every n record (PDF only)
		$this->ExportPageOrientation = "portrait"; // Page orientation (PDF only)
		$this->ExportPageSize = "a4"; // Page size (PDF only)
		$this->ExportExcelPageOrientation = ""; // Page orientation (PHPExcel only)
		$this->ExportExcelPageSize = ""; // Page size (PHPExcel only)
		$this->UserIDAllowSecurity = 0; // User ID Allow

		// dbkey_councilor
		$this->dbkey_councilor = new cField('Weekly_Counselor_Activitys_Summary', 'Weekly Counselor Activitys Summary', 'x_dbkey_councilor', 'dbkey_councilor', '`dbkey_councilor`', '`dbkey_councilor`', 3, -1, FALSE, '`dbkey_councilor`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_councilor->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_councilor'] = &$this->dbkey_councilor;

		// dbkey_client
		$this->dbkey_client = new cField('Weekly_Counselor_Activitys_Summary', 'Weekly Counselor Activitys Summary', 'x_dbkey_client', 'dbkey_client', '`dbkey_client`', '`dbkey_client`', 3, -1, FALSE, '`dbkey_client`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_client->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_client'] = &$this->dbkey_client;

		// date
		$this->date = new cField('Weekly_Counselor_Activitys_Summary', 'Weekly Counselor Activitys Summary', 'x_date', 'date', '`date`', 'DATE_FORMAT(`date`, \'%Y/%m/%d\')', 135, 5, FALSE, '`date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->date->FldDefaultErrMsg = str_replace("%s", "/", $Language->Phrase("IncorrectDateYMD"));
		$this->fields['date'] = &$this->date;

		// time
		$this->time = new cField('Weekly_Counselor_Activitys_Summary', 'Weekly Counselor Activitys Summary', 'x_time', 'time', '`time`', '`time`', 3, -1, FALSE, '`time`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->time->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['time'] = &$this->time;

		// dbkey
		$this->dbkey = new cField('Weekly_Counselor_Activitys_Summary', 'Weekly Counselor Activitys Summary', 'x_dbkey', 'dbkey', '`dbkey`', '`dbkey`', 3, -1, FALSE, '`dbkey`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'NO');
		$this->dbkey->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey'] = &$this->dbkey;

		// comment
		$this->comment = new cField('Weekly_Counselor_Activitys_Summary', 'Weekly Counselor Activitys Summary', 'x_comment', 'comment', '`comment`', '`comment`', 201, -1, FALSE, '`comment`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXTAREA');
		$this->fields['comment'] = &$this->comment;

		// dbkey_activity
		$this->dbkey_activity = new cField('Weekly_Counselor_Activitys_Summary', 'Weekly Counselor Activitys Summary', 'x_dbkey_activity', 'dbkey_activity', '`dbkey_activity`', '`dbkey_activity`', 3, -1, FALSE, '`dbkey_activity`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_activity->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_activity'] = &$this->dbkey_activity;

		// attachment
		$this->attachment = new cField('Weekly_Counselor_Activitys_Summary', 'Weekly Counselor Activitys Summary', 'x_attachment', 'attachment', '`attachment`', '`attachment`', 201, -1, TRUE, '`attachment`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'FILE');
		$this->attachment->UploadMultiple = TRUE;
		$this->attachment->Upload->UploadMultiple = TRUE;
		$this->fields['attachment'] = &$this->attachment;

		// budget
		$this->budget = new cField('Weekly_Counselor_Activitys_Summary', 'Weekly Counselor Activitys Summary', 'x_budget', 'budget', '(SELECT sum(IfNull(client_budget.budget, 0)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND Year(client_activity.date) = client_budget.year AND Month(client_activity.date) = client_budget.month)', '(SELECT sum(IfNull(client_budget.budget, 0)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND Year(client_activity.date) = client_budget.year AND Month(client_activity.date) = client_budget.month)', 131, -1, FALSE, '(SELECT sum(IfNull(client_budget.budget, 0)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND Year(client_activity.date) = client_budget.year AND Month(client_activity.date) = client_budget.month)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->budget->FldIsCustom = TRUE; // Custom field
		$this->budget->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['budget'] = &$this->budget;

		// allocated
		$this->allocated = new cField('Weekly_Counselor_Activitys_Summary', 'Weekly Counselor Activitys Summary', 'x_allocated', 'allocated', '(SELECT sum(IfNull(b.time, 0)) FROM client_activity b where client_activity.dbkey_client = b.dbkey_client AND Year(client_activity.date) = Year(b.date) AND Month(client_activity.date) = Month(b.date))', '(SELECT sum(IfNull(b.time, 0)) FROM client_activity b where client_activity.dbkey_client = b.dbkey_client AND Year(client_activity.date) = Year(b.date) AND Month(client_activity.date) = Month(b.date))', 131, -1, FALSE, '(SELECT sum(IfNull(b.time, 0)) FROM client_activity b where client_activity.dbkey_client = b.dbkey_client AND Year(client_activity.date) = Year(b.date) AND Month(client_activity.date) = Month(b.date))', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->allocated->FldIsCustom = TRUE; // Custom field
		$this->allocated->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['allocated'] = &$this->allocated;

		// remain
		$this->remain = new cField('Weekly_Counselor_Activitys_Summary', 'Weekly Counselor Activitys Summary', 'x_remain', 'remain', '((0 +(SELECT sum(IfNull(client_budget.budget, 0)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND Year(client_activity.date) = client_budget.year AND Month(client_activity.date) = client_budget.month))- (0 + (SELECT sum(IfNull(b.time, 0)) FROM client_activity b where client_activity.dbkey_client = b.dbkey_client AND Year(client_activity.date) = Year(b.date) AND Month(client_activity.date) = Month(b.date))))', '((0 +(SELECT sum(IfNull(client_budget.budget, 0)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND Year(client_activity.date) = client_budget.year AND Month(client_activity.date) = client_budget.month))- (0 + (SELECT sum(IfNull(b.time, 0)) FROM client_activity b where client_activity.dbkey_client = b.dbkey_client AND Year(client_activity.date) = Year(b.date) AND Month(client_activity.date) = Month(b.date))))', 131, -1, FALSE, '((0 +(SELECT sum(IfNull(client_budget.budget, 0)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND Year(client_activity.date) = client_budget.year AND Month(client_activity.date) = client_budget.month))- (0 + (SELECT sum(IfNull(b.time, 0)) FROM client_activity b where client_activity.dbkey_client = b.dbkey_client AND Year(client_activity.date) = Year(b.date) AND Month(client_activity.date) = Month(b.date))))', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->remain->FldIsCustom = TRUE; // Custom field
		$this->remain->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['remain'] = &$this->remain;
	}

	// Report group level SQL
	var $_SqlGroupSelect = "";

	function getSqlGroupSelect() { // Select
		return ($this->_SqlGroupSelect <> "") ? $this->_SqlGroupSelect : "SELECT DISTINCT `dbkey_councilor` FROM `client_activity`";
	}

	function SqlGroupSelect() { // For backward compatibility
    	return $this->getSqlGroupSelect();
	}

	function setSqlGroupSelect($v) {
    	$this->_SqlGroupSelect = $v;
	}
	var $_SqlGroupWhere = "";

	function getSqlGroupWhere() { // Where
		return ($this->_SqlGroupWhere <> "") ? $this->_SqlGroupWhere : "";
	}

	function SqlGroupWhere() { // For backward compatibility
    	return $this->getSqlGroupWhere();
	}

	function setSqlGroupWhere($v) {
    	$this->_SqlGroupWhere = $v;
	}
	var $_SqlGroupGroupBy = "";

	function getSqlGroupGroupBy() { // Group By
		return ($this->_SqlGroupGroupBy <> "") ? $this->_SqlGroupGroupBy : "";
	}

	function SqlGroupGroupBy() { // For backward compatibility
    	return $this->getSqlGroupGroupBy();
	}

	function setSqlGroupGroupBy($v) {
    	$this->_SqlGroupGroupBy = $v;
	}
	var $_SqlGroupHaving = "";

	function getSqlGroupHaving() { // Having
		return ($this->_SqlGroupHaving <> "") ? $this->_SqlGroupHaving : "";
	}

	function SqlGroupHaving() { // For backward compatibility
    	return $this->getSqlGroupHaving();
	}

	function setSqlGroupHaving($v) {
    	$this->_SqlGroupHaving = $v;
	}
	var $_SqlGroupOrderBy = "";

	function getSqlGroupOrderBy() { // Order By
		return ($this->_SqlGroupOrderBy <> "") ? $this->_SqlGroupOrderBy : "`dbkey_councilor` ASC";
	}

	function SqlGroupOrderBy() { // For backward compatibility
    	return $this->getSqlGroupOrderBy();
	}

	function setSqlGroupOrderBy($v) {
    	$this->_SqlGroupOrderBy = $v;
	}

	// Report detail level SQL
	var $_SqlDetailSelect = "";

	function getSqlDetailSelect() { // Select
		return ($this->_SqlDetailSelect <> "") ? $this->_SqlDetailSelect : "SELECT *, (SELECT sum(IfNull(client_budget.budget, 0)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND Year(client_activity.date) = client_budget.year AND Month(client_activity.date) = client_budget.month) AS `budget`, (SELECT sum(IfNull(b.time, 0)) FROM client_activity b where client_activity.dbkey_client = b.dbkey_client AND Year(client_activity.date) = Year(b.date) AND Month(client_activity.date) = Month(b.date)) AS `allocated`, ((0 +(SELECT sum(IfNull(client_budget.budget, 0)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND Year(client_activity.date) = client_budget.year AND Month(client_activity.date) = client_budget.month))- (0 + (SELECT sum(IfNull(b.time, 0)) FROM client_activity b where client_activity.dbkey_client = b.dbkey_client AND Year(client_activity.date) = Year(b.date) AND Month(client_activity.date) = Month(b.date)))) AS `remain` FROM `client_activity`";
	}

	function SqlDetailSelect() { // For backward compatibility
    	return $this->getSqlDetailSelect();
	}

	function setSqlDetailSelect($v) {
    	$this->_SqlDetailSelect = $v;
	}
	var $_SqlDetailWhere = "";

	function getSqlDetailWhere() { // Where
		return ($this->_SqlDetailWhere <> "") ? $this->_SqlDetailWhere : "";
	}

	function SqlDetailWhere() { // For backward compatibility
    	return $this->getSqlDetailWhere();
	}

	function setSqlDetailWhere($v) {
    	$this->_SqlDetailWhere = $v;
	}
	var $_SqlDetailGroupBy = "";

	function getSqlDetailGroupBy() { // Group By
		return ($this->_SqlDetailGroupBy <> "") ? $this->_SqlDetailGroupBy : "";
	}

	function SqlDetailGroupBy() { // For backward compatibility
    	return $this->getSqlDetailGroupBy();
	}

	function setSqlDetailGroupBy($v) {
    	$this->_SqlDetailGroupBy = $v;
	}
	var $_SqlDetailHaving = "";

	function getSqlDetailHaving() { // Having
		return ($this->_SqlDetailHaving <> "") ? $this->_SqlDetailHaving : "";
	}

	function SqlDetailHaving() { // For backward compatibility
    	return $this->getSqlDetailHaving();
	}

	function setSqlDetailHaving($v) {
    	$this->_SqlDetailHaving = $v;
	}
	var $_SqlDetailOrderBy = "";

	function getSqlDetailOrderBy() { // Order By
		return ($this->_SqlDetailOrderBy <> "") ? $this->_SqlDetailOrderBy : "";
	}

	function SqlDetailOrderBy() { // For backward compatibility
    	return $this->getSqlDetailOrderBy();
	}

	function setSqlDetailOrderBy($v) {
    	$this->_SqlDetailOrderBy = $v;
	}

	// Apply User ID filters
	function ApplyUserIDFilters($sFilter) {
		global $Security;

		// Add User ID filter
		if ($Security->CurrentUserID() <> "" && !$Security->IsAdmin()) { // Non system admin
			$sFilter = $this->AddUserIDFilter($sFilter);
		}
		return $sFilter;
	}

	// Check if User ID security allows view all
	function UserIDAllow($id = "") {
		$allow = $this->UserIDAllowSecurity;
		switch ($id) {
			case "add":
			case "copy":
			case "gridadd":
			case "register":
			case "addopt":
				return (($allow & 1) == 1);
			case "edit":
			case "gridedit":
			case "update":
			case "changepwd":
			case "forgotpwd":
				return (($allow & 4) == 4);
			case "delete":
				return (($allow & 2) == 2);
			case "view":
				return (($allow & 32) == 32);
			case "search":
				return (($allow & 64) == 64);
			default:
				return (($allow & 8) == 8);
		}
	}

	// Report group SQL
	function GroupSQL() {
		$sFilter = $this->CurrentFilter;
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = "";
		return ew_BuildSelectSql($this->getSqlGroupSelect(), $this->getSqlGroupWhere(),
			 $this->getSqlGroupGroupBy(), $this->getSqlGroupHaving(),
			 $this->getSqlGroupOrderBy(), $sFilter, $sSort);
	}

	// Report detail SQL
	function DetailSQL() {
		$sFilter = $this->CurrentFilter;
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = "";
		return ew_BuildSelectSql($this->getSqlDetailSelect(), $this->getSqlDetailWhere(),
			$this->getSqlDetailGroupBy(), $this->getSqlDetailHaving(),
			$this->getSqlDetailOrderBy(), $sFilter, $sSort);
	}

	// Return page URL
	function getReturnUrl() {
		$name = EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL;

		// Get referer URL automatically
		if (ew_ServerVar("HTTP_REFERER") <> "" && ew_ReferPage() <> ew_CurrentPage() && ew_ReferPage() <> "login.php") // Referer not same page or login page
			$_SESSION[$name] = ew_ServerVar("HTTP_REFERER"); // Save to Session
		if (@$_SESSION[$name] <> "") {
			return $_SESSION[$name];
		} else {
			return "Weekly_Counselor_Activitys_Summaryreport.php";
		}
	}

	function setReturnUrl($v) {
		$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL] = $v;
	}

	// List URL
	function GetListUrl() {
		return "Weekly_Counselor_Activitys_Summaryreport.php";
	}

	// View URL
	function GetViewUrl($parm = "") {
		if ($parm <> "")
			$url = $this->KeyUrl("", $this->UrlParm($parm));
		else
			$url = $this->KeyUrl("", $this->UrlParm(EW_TABLE_SHOW_DETAIL . "="));
		return $this->AddMasterUrl($url);
	}

	// Add URL
	function GetAddUrl($parm = "") {
		if ($parm <> "")
			$url = "?" . $this->UrlParm($parm);
		else
			$url = "";
		return $this->AddMasterUrl($url);
	}

	// Edit URL
	function GetEditUrl($parm = "") {
		$url = $this->KeyUrl("", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline edit URL
	function GetInlineEditUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=edit"));
		return $this->AddMasterUrl($url);
	}

	// Copy URL
	function GetCopyUrl($parm = "") {
		$url = $this->KeyUrl("", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline copy URL
	function GetInlineCopyUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=copy"));
		return $this->AddMasterUrl($url);
	}

	// Delete URL
	function GetDeleteUrl() {
		return $this->KeyUrl("", $this->UrlParm());
	}

	// Add master url
	function AddMasterUrl($url) {
		return $url;
	}

	function KeyToJson() {
		$json = "";
		$json .= "dbkey:" . ew_VarToJson($this->dbkey->CurrentValue, "number", "'");
		return "{" . $json . "}";
	}

	// Add key value to URL
	function KeyUrl($url, $parm = "") {
		$sUrl = $url . "?";
		if ($parm <> "") $sUrl .= $parm . "&";
		if (!is_null($this->dbkey->CurrentValue)) {
			$sUrl .= "dbkey=" . urlencode($this->dbkey->CurrentValue);
		} else {
			return "javascript:ew_Alert(ewLanguage.Phrase('InvalidRecord'));";
		}
		return $sUrl;
	}

	// Sort URL
	function SortUrl(&$fld) {
		if ($this->CurrentAction <> "" || $this->Export <> "" ||
			in_array($fld->FldType, array(128, 204, 205))) { // Unsortable data type
				return "";
		} elseif ($fld->Sortable) {
			$sUrlParm = $this->UrlParm("order=" . urlencode($fld->FldName) . "&amp;ordertype=" . $fld->ReverseSort());
			return ew_CurrentPage() . "?" . $sUrlParm;
		} else {
			return "";
		}
	}

	// Get record keys from $_POST/$_GET/$_SESSION
	function GetRecordKeys() {
		global $EW_COMPOSITE_KEY_SEPARATOR;
		$arKeys = array();
		$arKey = array();
		if (isset($_POST["key_m"])) {
			$arKeys = ew_StripSlashes($_POST["key_m"]);
			$cnt = count($arKeys);
		} elseif (isset($_GET["key_m"])) {
			$arKeys = ew_StripSlashes($_GET["key_m"]);
			$cnt = count($arKeys);
		} elseif (!empty($_GET) || !empty($_POST)) {
			$isPost = ew_IsHttpPost();
			$arKeys[] = $isPost ? ew_StripSlashes(@$_POST["dbkey"]) : ew_StripSlashes(@$_GET["dbkey"]); // dbkey

			//return $arKeys; // Do not return yet, so the values will also be checked by the following code
		}

		// Check keys
		$ar = array();
		foreach ($arKeys as $key) {
			if (!is_numeric($key))
				continue;
			$ar[] = $key;
		}
		return $ar;
	}

	// Get key filter
	function GetKeyFilter() {
		$arKeys = $this->GetRecordKeys();
		$sKeyFilter = "";
		foreach ($arKeys as $key) {
			if ($sKeyFilter <> "") $sKeyFilter .= " OR ";
			$this->dbkey->CurrentValue = $key;
			$sKeyFilter .= "(" . $this->KeyFilter() . ")";
		}
		return $sKeyFilter;
	}

	// Load rows based on filter
	function &LoadRs($sFilter) {

		// Set up filter (SQL WHERE clause) and get return SQL
		//$this->CurrentFilter = $sFilter;
		//$sSql = $this->SQL();

		$sSql = $this->GetSQL($sFilter, "");
		$conn = &$this->Connection();
		$rs = $conn->Execute($sSql);
		return $rs;
	}

	// Add User ID filter
	function AddUserIDFilter($sFilter) {
		global $Security;
		$sFilterWrk = "";
		$id = (CurrentPageID() == "list") ? $this->CurrentAction : CurrentPageID();
		if (!$this->UserIDAllow($id) && !$Security->IsAdmin()) {
			$sFilterWrk = $Security->UserIDList();
			if ($sFilterWrk <> "")
				$sFilterWrk = '`dbkey_councilor` IN (' . $sFilterWrk . ')';
		}

		// Call User ID Filtering event
		$this->UserID_Filtering($sFilterWrk);
		ew_AddFilter($sFilter, $sFilterWrk);
		return $sFilter;
	}

	// User ID subquery
	function GetUserIDSubquery(&$fld, &$masterfld) {
		global $UserTableConn;
		$sWrk = "";
		$sSql = "SELECT " . $masterfld->FldExpression . " FROM `client_activity`";
		$sFilter = $this->AddUserIDFilter("");
		if ($sFilter <> "") $sSql .= " WHERE " . $sFilter;

		// Use subquery
		if (EW_USE_SUBQUERY_FOR_MASTER_USER_ID) {
			$sWrk = $sSql;
		} else {

			// List all values
			if ($rs = $UserTableConn->Execute($sSql)) {
				while (!$rs->EOF) {
					if ($sWrk <> "") $sWrk .= ",";
					$sWrk .= ew_QuotedValue($rs->fields[0], $masterfld->FldDataType, EW_USER_TABLE_DBID);
					$rs->MoveNext();
				}
				$rs->Close();
			}
		}
		if ($sWrk <> "") {
			$sWrk = $fld->FldExpression . " IN (" . $sWrk . ")";
		}
		return $sWrk;
	}

	// Row Rendering event
	function Row_Rendering() {

		// Enter your code here	
	}

	// Row Rendered event
	function Row_Rendered() {

		// To view properties of field class, use:
		//var_dump($this-><FieldName>); 

	}

	// User ID Filtering event
	function UserID_Filtering(&$filter) {

		// Enter your code here
	}
}
?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn12.php" ?>
<?php

//
// Page class
//

$Weekly_Counselor_Activitys_Summary_report = NULL; // Initialize page object first

class cWeekly_Counselor_Activitys_Summary_report extends cWeekly_Counselor_Activitys_Summary {

	// Page ID
	var $PageID = 'report';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'Weekly Counselor Activitys Summary';

	// Page object name
	var $PageObjName = 'Weekly_Counselor_Activitys_Summary_report';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		return $PageUrl;
	}

	// Page URLs
	var $AddUrl;
	var $EditUrl;
	var $CopyUrl;
	var $DeleteUrl;
	var $ViewUrl;
	var $ListUrl;

	// Export URLs
	var $ExportPrintUrl;
	var $ExportHtmlUrl;
	var $ExportExcelUrl;
	var $ExportWordUrl;
	var $ExportXmlUrl;
	var $ExportCsvUrl;
	var $ExportPdfUrl;

	// Custom export
	var $ExportExcelCustom = FALSE;
	var $ExportWordCustom = FALSE;
	var $ExportPdfCustom = FALSE;
	var $ExportEmailCustom = FALSE;

	// Update URLs
	var $InlineAddUrl;
	var $InlineCopyUrl;
	var $InlineEditUrl;
	var $GridAddUrl;
	var $GridEditUrl;
	var $MultiDeleteUrl;
	var $MultiUpdateUrl;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		return TRUE;
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (Weekly_Counselor_Activitys_Summary)
		if (!isset($GLOBALS["Weekly_Counselor_Activitys_Summary"]) || get_class($GLOBALS["Weekly_Counselor_Activitys_Summary"]) == "cWeekly_Counselor_Activitys_Summary") {
			$GLOBALS["Weekly_Counselor_Activitys_Summary"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["Weekly_Counselor_Activitys_Summary"];
		}

		// Initialize URLs
		$this->ExportPrintUrl = $this->PageUrl() . "export=print";
		$this->ExportExcelUrl = $this->PageUrl() . "export=excel";
		$this->ExportWordUrl = $this->PageUrl() . "export=word";

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'report', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'Weekly Counselor Activitys Summary', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}

		// Export options
		$this->ExportOptions = new cListOptions();
		$this->ExportOptions->Tag = "div";
		$this->ExportOptions->TagClassName = "ewExportOption";
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanReport()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage($Language->Phrase("NoPermission")); // Set no permission
			$this->Page_Terminate(ew_GetUrl("index.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
			if (strval($Security->CurrentUserID()) == "") {
				$this->setFailureMessage($Language->Phrase("NoPermission")); // Set no permission
				$this->Page_Terminate(ew_GetUrl("Weekly_Counselor_Activitys_Summarylist.php"));
			}
		}

		// Get export parameters
		$custom = "";
		if (@$_GET["export"] <> "") {
			$this->Export = $_GET["export"];
			$custom = @$_GET["custom"];
		} elseif (@$_POST["export"] <> "") {
			$this->Export = $_POST["export"];
			$custom = @$_POST["custom"];
		}
		$gsExportFile = $this->TableVar; // Get export file, used in header

		// Get custom export parameters
		if ($this->Export <> "" && $custom <> "") {
			$this->CustomExport = $this->Export;
			$this->Export = "print";
		}
		$gsCustomExport = $this->CustomExport;
		$gsExport = $this->Export; // Get export parameter, used in header

		// Update Export URLs
		if (defined("EW_USE_PHPEXCEL"))
			$this->ExportExcelCustom = FALSE;
		if ($this->ExportExcelCustom)
			$this->ExportExcelUrl .= "&amp;custom=1";
		if (defined("EW_USE_PHPWORD"))
			$this->ExportWordCustom = FALSE;
		if ($this->ExportWordCustom)
			$this->ExportWordUrl .= "&amp;custom=1";
		if ($this->ExportPdfCustom)
			$this->ExportPdfUrl .= "&amp;custom=1";
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action

		// Setup export options
		$this->SetupExportOptions();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT_REPORT;
		if ($this->Export <> "" && array_key_exists($this->Export, $EW_EXPORT_REPORT)) {
			$sContent = ob_get_contents();
			$fn = $EW_EXPORT_REPORT[$this->Export];
			$this->$fn($sContent);
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}
	var $ExportOptions; // Export options
	var $RecCnt = 0;
	var $RowCnt = 0; // For custom view tag
	var $ReportSql = "";
	var $ReportFilter = "";
	var $DefaultFilter = "";
	var $DbMasterFilter = "";
	var $DbDetailFilter = "";
	var $MasterRecordExists;
	var $Command;
	var $DtlRecordCount;
	var $ReportGroups;
	var $ReportCounts;
	var $LevelBreak;
	var $ReportTotals;
	var $ReportMaxs;
	var $ReportMins;
	var $Recordset;
	var $DetailRecordset;
	var $RecordExists;

	//
	// Page main
	//
	function Page_Main() {
		global $Language;
		$this->ReportGroups = &ew_InitArray(2, NULL);
		$this->ReportCounts = &ew_InitArray(2, 0);
		$this->LevelBreak = &ew_InitArray(2, FALSE);
		$this->ReportTotals = &ew_Init2DArray(2, 2, 0);
		$this->ReportMaxs = &ew_Init2DArray(2, 2, 0);
		$this->ReportMins = &ew_Init2DArray(2, 2, 0);

		// Set up Breadcrumb
		$this->SetupBreadcrumb();
	}

	// Check level break
	function ChkLvlBreak() {
		$this->LevelBreak[1] = FALSE;
		if ($this->RecCnt == 0) { // Start Or End of Recordset
			$this->LevelBreak[1] = TRUE;
		} else {
			if (!ew_CompareValue($this->dbkey_councilor->CurrentValue, $this->ReportGroups[0])) {
				$this->LevelBreak[1] = TRUE;
			}
		}
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Convert decimal values if posted back

		if ($this->allocated->FormValue == $this->allocated->CurrentValue && is_numeric(ew_StrToFloat($this->allocated->CurrentValue)))
			$this->allocated->CurrentValue = ew_StrToFloat($this->allocated->CurrentValue);

		// Call Row_Rendering event
		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey_councilor
		// dbkey_client
		// date
		// time
		// dbkey
		// comment
		// dbkey_activity
		// attachment
		// budget
		// allocated
		// remain

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// dbkey_councilor
		if (strval($this->dbkey_councilor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->CurrentValue;
			}
		} else {
			$this->dbkey_councilor->ViewValue = NULL;
		}
		$this->dbkey_councilor->ViewCustomAttributes = "";

		// dbkey_client
		if (strval($this->dbkey_client->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_client->ViewValue = $this->dbkey_client->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_client->ViewValue = $this->dbkey_client->CurrentValue;
			}
		} else {
			$this->dbkey_client->ViewValue = NULL;
		}
		$this->dbkey_client->ViewCustomAttributes = "";

		// date
		$this->date->ViewValue = $this->date->CurrentValue;
		$this->date->ViewValue = ew_FormatDateTime($this->date->ViewValue, 5);
		$this->date->ViewCustomAttributes = "";

		// time
		$this->time->ViewValue = $this->time->CurrentValue;
		$this->time->ViewCustomAttributes = "";

		// dbkey
		$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// comment
		$this->comment->ViewValue = $this->comment->CurrentValue;
		$this->comment->ViewCustomAttributes = "";

		// dbkey_activity
		if (strval($this->dbkey_activity->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_activity->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `activity`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->CurrentValue;
			}
		} else {
			$this->dbkey_activity->ViewValue = NULL;
		}
		$this->dbkey_activity->ViewCustomAttributes = "";

		// attachment
		if (!ew_Empty($this->attachment->Upload->DbValue)) {
			$this->attachment->ViewValue = $this->attachment->Upload->DbValue;
		} else {
			$this->attachment->ViewValue = "";
		}
		$this->attachment->ViewCustomAttributes = "";

		// budget
		$this->budget->ViewValue = $this->budget->CurrentValue;
		$this->budget->ViewValue = ew_FormatNumber($this->budget->ViewValue, 0, -2, -2, -2);
		$this->budget->ViewCustomAttributes = "";

		// allocated
		$this->allocated->ViewValue = $this->allocated->CurrentValue;
		$this->allocated->ViewValue = ew_FormatNumber($this->allocated->ViewValue, 0, -2, -2, -2);
		$this->allocated->ViewCustomAttributes = "";

		// remain
		$this->remain->ViewValue = $this->remain->CurrentValue;
		$this->remain->CellCssStyle .= "text-align: left;";
		$this->remain->ViewCustomAttributes = "";

			// dbkey_councilor
			$this->dbkey_councilor->LinkCustomAttributes = "";
			$this->dbkey_councilor->HrefValue = "";
			$this->dbkey_councilor->TooltipValue = "";

			// allocated
			$this->allocated->LinkCustomAttributes = "";
			$this->allocated->HrefValue = "";
			$this->allocated->TooltipValue = "";
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Set up export options
	function SetupExportOptions() {
		global $Language;

		// Printer friendly
		$item = &$this->ExportOptions->Add("print");
		$item->Body = "<a href=\"" . $this->ExportPrintUrl . "\" class=\"ewExportLink ewPrint\" title=\"" . ew_HtmlEncode($Language->Phrase("PrinterFriendlyText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("PrinterFriendlyText")) . "\">" . $Language->Phrase("PrinterFriendly") . "</a>";
		$item->Visible = TRUE;

		// Export to Excel
		$item = &$this->ExportOptions->Add("excel");
		$item->Body = "<a href=\"" . $this->ExportExcelUrl . "\" class=\"ewExportLink ewExcel\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToExcelText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToExcelText")) . "\">" . $Language->Phrase("ExportToExcel") . "</a>";
		$item->Visible = TRUE;

		// Export to Word
		$item = &$this->ExportOptions->Add("word");
		$item->Body = "<a href=\"" . $this->ExportWordUrl . "\" class=\"ewExportLink ewWord\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToWordText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToWordText")) . "\">" . $Language->Phrase("ExportToWord") . "</a>";
		$item->Visible = TRUE;

		// Drop down button for export
		$this->ExportOptions->UseButtonGroup = TRUE;
		$this->ExportOptions->UseImageAndText = TRUE;
		$this->ExportOptions->UseDropDownButton = FALSE;
		if ($this->ExportOptions->UseButtonGroup && ew_IsMobile())
			$this->ExportOptions->UseDropDownButton = TRUE;
		$this->ExportOptions->DropDownButtonPhrase = $Language->Phrase("ButtonExport");

		// Add group option item
		$item = &$this->ExportOptions->Add($this->ExportOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;

		// Hide options for export
		if ($this->Export <> "")
			$this->ExportOptions->HideAllOptions();
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$url = preg_replace('/\?cmd=reset(all){0,1}$/i', '', $url); // Remove cmd=reset / cmd=resetall
		$Breadcrumb->Add("report", $this->TableVar, $url, "", $this->TableVar, TRUE);
	}

	// Export report to HTML
	function ExportReportHtml($html) {

		//global $gsExportFile;
		//header('Content-Type: text/html' . (EW_CHARSET <> '' ? ';charset=' . EW_CHARSET : ''));
		//header('Content-Disposition: attachment; filename=' . $gsExportFile . '.html');
		//echo $html;

	}

	// Export report to WORD
	function ExportReportWord($html) {
		global $gsExportFile;
		header('Content-Type: application/vnd.ms-word' . (EW_CHARSET <> '' ? ';charset=' . EW_CHARSET : ''));
		header('Content-Disposition: attachment; filename=' . $gsExportFile . '.doc');
		echo $html;
	}

	// Export report to EXCEL
	function ExportReportExcel($html) {
		global $gsExportFile;
		header('Content-Type: application/vnd.ms-excel' . (EW_CHARSET <> '' ? ';charset=' . EW_CHARSET : ''));
		header('Content-Disposition: attachment; filename=' . $gsExportFile . '.xls');
		echo $html;
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($Weekly_Counselor_Activitys_Summary_report)) $Weekly_Counselor_Activitys_Summary_report = new cWeekly_Counselor_Activitys_Summary_report();

// Page init
$Weekly_Counselor_Activitys_Summary_report->Page_Init();

// Page main
$Weekly_Counselor_Activitys_Summary_report->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$Weekly_Counselor_Activitys_Summary_report->Page_Render();
?>
<?php include_once "header.php" ?>
<?php if ($Weekly_Counselor_Activitys_Summary->Export == "") { ?>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php } ?>
<div class="ewToolbar">
<?php if ($Weekly_Counselor_Activitys_Summary->Export == "") { ?>
<?php $Breadcrumb->Render(); ?>
<?php } ?>
<?php if ($Weekly_Counselor_Activitys_Summary->Export == "") { ?>
<?php echo $Language->SelectionForm(); ?>
<?php } ?>
<div class="clearfix"></div>
</div>
<?php
$Weekly_Counselor_Activitys_Summary_report->DefaultFilter = "";
$Weekly_Counselor_Activitys_Summary_report->ReportFilter = $Weekly_Counselor_Activitys_Summary_report->DefaultFilter;
if (!$Security->CanReport()) {
	if ($Weekly_Counselor_Activitys_Summary_report->ReportFilter <> "") $Weekly_Counselor_Activitys_Summary_report->ReportFilter .= " AND ";
	$Weekly_Counselor_Activitys_Summary_report->ReportFilter .= "(0=1)";
}
if ($Weekly_Counselor_Activitys_Summary_report->DbDetailFilter <> "") {
	if ($Weekly_Counselor_Activitys_Summary_report->ReportFilter <> "") $Weekly_Counselor_Activitys_Summary_report->ReportFilter .= " AND ";
	$Weekly_Counselor_Activitys_Summary_report->ReportFilter .= "(" . $Weekly_Counselor_Activitys_Summary_report->DbDetailFilter . ")";
}
$ReportConn = &$Weekly_Counselor_Activitys_Summary_report->Connection();

// Set up filter and load Group level sql
$Weekly_Counselor_Activitys_Summary->CurrentFilter = $Weekly_Counselor_Activitys_Summary_report->ReportFilter;
$Weekly_Counselor_Activitys_Summary_report->ReportSql = $Weekly_Counselor_Activitys_Summary->GroupSQL();

// Load recordset
$Weekly_Counselor_Activitys_Summary_report->Recordset = $ReportConn->Execute($Weekly_Counselor_Activitys_Summary_report->ReportSql);
$Weekly_Counselor_Activitys_Summary_report->RecordExists = !$Weekly_Counselor_Activitys_Summary_report->Recordset->EOF;
?>
<?php if ($Weekly_Counselor_Activitys_Summary->Export == "") { ?>
<?php if ($Weekly_Counselor_Activitys_Summary_report->RecordExists) { ?>
<div class="ewViewExportOptions"><?php $Weekly_Counselor_Activitys_Summary_report->ExportOptions->Render("body") ?></div>
<?php } ?>
<?php } ?>
<?php $Weekly_Counselor_Activitys_Summary_report->ShowPageHeader(); ?>
<table class="ewReportTable">
<?php

// Get First Row
if ($Weekly_Counselor_Activitys_Summary_report->RecordExists) {
	$Weekly_Counselor_Activitys_Summary->dbkey_councilor->setDbValue($Weekly_Counselor_Activitys_Summary_report->Recordset->fields('dbkey_councilor'));
	$Weekly_Counselor_Activitys_Summary_report->ReportGroups[0] = $Weekly_Counselor_Activitys_Summary->dbkey_councilor->DbValue;
}
$Weekly_Counselor_Activitys_Summary_report->RecCnt = 0;
$Weekly_Counselor_Activitys_Summary_report->ReportCounts[0] = 0;
$Weekly_Counselor_Activitys_Summary_report->ChkLvlBreak();
while (!$Weekly_Counselor_Activitys_Summary_report->Recordset->EOF) {

	// Render for view
	$Weekly_Counselor_Activitys_Summary->RowType = EW_ROWTYPE_VIEW;
	$Weekly_Counselor_Activitys_Summary->ResetAttrs();
	$Weekly_Counselor_Activitys_Summary_report->RenderRow();

	// Show group headers
	if ($Weekly_Counselor_Activitys_Summary_report->LevelBreak[1]) { // Reset counter and aggregation
?>
	<tr><td class="ewGroupField"><?php echo $Weekly_Counselor_Activitys_Summary->dbkey_councilor->FldCaption() ?></td>
	<td colspan=1 class="ewGroupName">
<span<?php echo $Weekly_Counselor_Activitys_Summary->dbkey_councilor->ViewAttributes() ?>>
<?php echo $Weekly_Counselor_Activitys_Summary->dbkey_councilor->ViewValue ?></span>
</td></tr>
<?php
	}

	// Get detail records
	$Weekly_Counselor_Activitys_Summary_report->ReportFilter = $Weekly_Counselor_Activitys_Summary_report->DefaultFilter;
	if ($Weekly_Counselor_Activitys_Summary_report->ReportFilter <> "") $Weekly_Counselor_Activitys_Summary_report->ReportFilter .= " AND ";
	if (is_null($Weekly_Counselor_Activitys_Summary->dbkey_councilor->CurrentValue)) {
		$Weekly_Counselor_Activitys_Summary_report->ReportFilter .= "(`dbkey_councilor` IS NULL)";
	} else {
		$Weekly_Counselor_Activitys_Summary_report->ReportFilter .= "(`dbkey_councilor` = " . ew_QuotedValue($Weekly_Counselor_Activitys_Summary->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, $Weekly_Counselor_Activitys_Summary_report->DBID) . ")";
	}
	if ($Weekly_Counselor_Activitys_Summary_report->DbDetailFilter <> "") {
		if ($Weekly_Counselor_Activitys_Summary_report->ReportFilter <> "")
			$Weekly_Counselor_Activitys_Summary_report->ReportFilter .= " AND ";
		$Weekly_Counselor_Activitys_Summary_report->ReportFilter .= "(" . $Weekly_Counselor_Activitys_Summary_report->DbDetailFilter . ")";
	}
	if (!$Security->CanReport()) {
		if ($sFilter <> "") $sFilter .= " AND ";
		$sFilter .= "(0=1)";
	}

	// Set up detail SQL
	$Weekly_Counselor_Activitys_Summary->CurrentFilter = $Weekly_Counselor_Activitys_Summary_report->ReportFilter;
	$Weekly_Counselor_Activitys_Summary_report->ReportSql = $Weekly_Counselor_Activitys_Summary->DetailSQL();

	// Load detail records
	$Weekly_Counselor_Activitys_Summary_report->DetailRecordset = $ReportConn->Execute($Weekly_Counselor_Activitys_Summary_report->ReportSql);
	$Weekly_Counselor_Activitys_Summary_report->DtlRecordCount = $Weekly_Counselor_Activitys_Summary_report->DetailRecordset->RecordCount();

	// Initialize aggregates
	if (!$Weekly_Counselor_Activitys_Summary_report->DetailRecordset->EOF) {
		$Weekly_Counselor_Activitys_Summary_report->RecCnt++;
		$Weekly_Counselor_Activitys_Summary->allocated->setDbValue($Weekly_Counselor_Activitys_Summary_report->DetailRecordset->fields('allocated'));
	}
	if ($Weekly_Counselor_Activitys_Summary_report->RecCnt == 1) {
		$Weekly_Counselor_Activitys_Summary_report->ReportCounts[0] = 0;
		$Weekly_Counselor_Activitys_Summary_report->ReportTotals[0][0] = 0;
	}
	for ($i = 1; $i <= 1; $i++) {
		if ($Weekly_Counselor_Activitys_Summary_report->LevelBreak[$i]) { // Reset counter and aggregation
			$Weekly_Counselor_Activitys_Summary_report->ReportCounts[$i] = 0;
			$Weekly_Counselor_Activitys_Summary_report->ReportTotals[$i][0] = 0;
		}
	}
	$Weekly_Counselor_Activitys_Summary_report->ReportCounts[0] += $Weekly_Counselor_Activitys_Summary_report->DtlRecordCount;
	$Weekly_Counselor_Activitys_Summary_report->ReportCounts[1] += $Weekly_Counselor_Activitys_Summary_report->DtlRecordCount;
	if ($Weekly_Counselor_Activitys_Summary_report->RecordExists) {
?>
	<tr>
		<td><div class="ewGroupIndent"></div></td>
		<td class="ewGroupHeader"><?php echo $Weekly_Counselor_Activitys_Summary->allocated->FldCaption() ?></td>
	</tr>
<?php
	}
	while (!$Weekly_Counselor_Activitys_Summary_report->DetailRecordset->EOF) {
		$Weekly_Counselor_Activitys_Summary_report->RowCnt++;
		$Weekly_Counselor_Activitys_Summary->allocated->setDbValue($Weekly_Counselor_Activitys_Summary_report->DetailRecordset->fields('allocated'));
		$Weekly_Counselor_Activitys_Summary_report->ReportTotals[0][0] += $Weekly_Counselor_Activitys_Summary->allocated->CurrentValue;
		$Weekly_Counselor_Activitys_Summary_report->ReportTotals[1][0] += $Weekly_Counselor_Activitys_Summary->allocated->CurrentValue;

		// Render for view
		$Weekly_Counselor_Activitys_Summary->RowType = EW_ROWTYPE_VIEW;
		$Weekly_Counselor_Activitys_Summary->ResetAttrs();
		$Weekly_Counselor_Activitys_Summary_report->RenderRow();
?>
	<tr>
		<td><div class="ewGroupIndent"></div></td>
		<td<?php echo $Weekly_Counselor_Activitys_Summary->allocated->CellAttributes() ?>>
<span<?php echo $Weekly_Counselor_Activitys_Summary->allocated->ViewAttributes() ?>>
<?php echo $Weekly_Counselor_Activitys_Summary->allocated->ViewValue ?></span>
</td>
	</tr>
<?php
		$Weekly_Counselor_Activitys_Summary_report->DetailRecordset->MoveNext();
	}
	$Weekly_Counselor_Activitys_Summary_report->DetailRecordset->Close();

	// Save old group data
	$Weekly_Counselor_Activitys_Summary_report->ReportGroups[0] = $Weekly_Counselor_Activitys_Summary->dbkey_councilor->CurrentValue;

	// Get next record
	$Weekly_Counselor_Activitys_Summary_report->Recordset->MoveNext();
	if ($Weekly_Counselor_Activitys_Summary_report->Recordset->EOF) {
		$Weekly_Counselor_Activitys_Summary_report->RecCnt = 0; // EOF, force all level breaks
	} else {
		$Weekly_Counselor_Activitys_Summary->dbkey_councilor->setDbValue($Weekly_Counselor_Activitys_Summary_report->Recordset->fields('dbkey_councilor'));
	}
	$Weekly_Counselor_Activitys_Summary_report->ChkLvlBreak();

	// Show footers
	if ($Weekly_Counselor_Activitys_Summary_report->LevelBreak[1]) {
		$Weekly_Counselor_Activitys_Summary->dbkey_councilor->CurrentValue = $Weekly_Counselor_Activitys_Summary_report->ReportGroups[0];

		// Render row for view
		$Weekly_Counselor_Activitys_Summary->RowType = EW_ROWTYPE_VIEW;
		$Weekly_Counselor_Activitys_Summary->ResetAttrs();
		$Weekly_Counselor_Activitys_Summary_report->RenderRow();
		$Weekly_Counselor_Activitys_Summary->dbkey_councilor->CurrentValue = $Weekly_Counselor_Activitys_Summary->dbkey_councilor->DbValue;
?>
	<tr><td colspan=2 class="ewGroupSummary"><?php echo $Language->Phrase("RptSumHead") ?>&nbsp;<?php echo $Weekly_Counselor_Activitys_Summary->dbkey_councilor->FldCaption() ?>:&nbsp;<?php echo $Weekly_Counselor_Activitys_Summary->dbkey_councilor->ViewValue ?> (<?php echo ew_FormatNumber($Weekly_Counselor_Activitys_Summary_report->ReportCounts[1],0) ?> <?php echo $Language->Phrase("RptDtlRec") ?>)</td></tr>
<?php
	$Weekly_Counselor_Activitys_Summary->allocated->CurrentValue = $Weekly_Counselor_Activitys_Summary_report->ReportTotals[1][0];

	// Render row for view
	$Weekly_Counselor_Activitys_Summary->RowType = EW_ROWTYPE_VIEW;
	$Weekly_Counselor_Activitys_Summary->ResetAttrs();
	$Weekly_Counselor_Activitys_Summary_report->RenderRow();
?>
	<tr>
		<td class="ewGroupAggregate"><?php echo $Language->Phrase("RptSum") ?></td>
		<td<?php echo $Weekly_Counselor_Activitys_Summary->allocated->CellAttributes() ?>>
<span<?php echo $Weekly_Counselor_Activitys_Summary->allocated->ViewAttributes() ?>>
<?php echo $Weekly_Counselor_Activitys_Summary->allocated->ViewValue ?></span>
</td>
	</tr>
	<tr><td colspan=2>&nbsp;<br></td></tr>
<?php
}
}

// Close recordset
$Weekly_Counselor_Activitys_Summary_report->Recordset->Close();
?>
<?php if ($Weekly_Counselor_Activitys_Summary_report->RecordExists) { ?>
	<tr><td colspan=2>&nbsp;<br></td></tr>
	<tr><td colspan=2 class="ewGrandSummary"><?php echo $Language->Phrase("RptGrandTotal") ?>&nbsp;(<?php echo ew_FormatNumber($Weekly_Counselor_Activitys_Summary_report->ReportCounts[0], 0) ?>&nbsp;<?php echo $Language->Phrase("RptDtlRec") ?>)</td></tr>
<?php
	$Weekly_Counselor_Activitys_Summary->allocated->CurrentValue = $Weekly_Counselor_Activitys_Summary_report->ReportTotals[0][0];

	// Render row for view
	$Weekly_Counselor_Activitys_Summary->RowType = EW_ROWTYPE_VIEW;
	$Weekly_Counselor_Activitys_Summary->ResetAttrs();
	$Weekly_Counselor_Activitys_Summary_report->RenderRow();
?>
	<tr>
		<td class="ewGroupAggregate"><?php echo $Language->Phrase("RptSum") ?></td>
		<td<?php echo $Weekly_Counselor_Activitys_Summary->allocated->CellAttributes() ?>>
<span<?php echo $Weekly_Counselor_Activitys_Summary->allocated->ViewAttributes() ?>>
<?php echo $Weekly_Counselor_Activitys_Summary->allocated->ViewValue ?></span>
</td>
	</tr>
<?php } ?>
<?php if ($Weekly_Counselor_Activitys_Summary_report->RecordExists) { ?>
	<tr><td colspan=2>&nbsp;<br></td></tr>
<?php } else { ?>
	<tr><td><?php echo $Language->Phrase("NoRecord") ?></td></tr>
<?php } ?>
</table>
<?php
$Weekly_Counselor_Activitys_Summary_report->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<?php if ($Weekly_Counselor_Activitys_Summary->Export == "") { ?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php } ?>
<?php include_once "footer.php" ?>
<?php
$Weekly_Counselor_Activitys_Summary_report->Page_Terminate();
?>
