<?php
if (session_id() == "") session_start(); // Init session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg13.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql13.php") ?>
<?php include_once "phpfn13.php" ?>
<?php include_once "case_notesinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn13.php" ?>
<?php

//
// Page class
//

$case_notes_add = NULL; // Initialize page object first

class ccase_notes_add extends ccase_notes {

	// Page ID
	var $PageID = 'add';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'case_notes';

	// Page object name
	var $PageObjName = 'case_notes_add';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}
	var $AuditTrailOnAdd = TRUE;
	var $AuditTrailOnEdit = FALSE;
	var $AuditTrailOnDelete = FALSE;
	var $AuditTrailOnView = FALSE;
	var $AuditTrailOnViewData = FALSE;
	var $AuditTrailOnSearch = FALSE;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (case_notes)
		if (!isset($GLOBALS["case_notes"]) || get_class($GLOBALS["case_notes"]) == "ccase_notes") {
			$GLOBALS["case_notes"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["case_notes"];
		}

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'add', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'case_notes', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	//
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanAdd()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("case_noteslist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
			if (strval($Security->CurrentUserID()) == "") {
				$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
				$this->Page_Terminate(ew_GetUrl("case_noteslist.php"));
			}
		}

		// Create form object
		$objForm = new cFormObj();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action
		$this->dbkey_counselor->SetVisibility();
		$this->date->SetVisibility();
		$this->dbkey_client->SetVisibility();
		$this->client_met_outcome->SetVisibility();
		$this->how_objective->SetVisibility();
		$this->case_notes->SetVisibility();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $case_notes;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($case_notes);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();

			// Handle modal response
			if ($this->IsModal) {
				$row = array();
				$row["url"] = $url;
				echo ew_ArrayToJson(array($row));
			} else {
				header("Location: " . $url);
			}
		}
		exit();
	}
	var $FormClassName = "form-horizontal ewForm ewAddForm";
	var $IsModal = FALSE;
	var $DbMasterFilter = "";
	var $DbDetailFilter = "";
	var $StartRec;
	var $Priv = 0;
	var $OldRecordset;
	var $CopyRecord;

	// 
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError;
		global $gbSkipHeaderFooter;

		// Check modal
		$this->IsModal = (@$_GET["modal"] == "1" || @$_POST["modal"] == "1");
		if ($this->IsModal)
			$gbSkipHeaderFooter = TRUE;

		// Process form if post back
		if (@$_POST["a_add"] <> "") {
			$this->CurrentAction = $_POST["a_add"]; // Get form action
			$this->CopyRecord = $this->LoadOldRecord(); // Load old recordset
			$this->LoadFormValues(); // Load form values
		} else { // Not post back

			// Load key values from QueryString
			$this->CopyRecord = TRUE;
			if (@$_GET["dbkey"] != "") {
				$this->dbkey->setQueryStringValue($_GET["dbkey"]);
				$this->setKey("dbkey", $this->dbkey->CurrentValue); // Set up key
			} else {
				$this->setKey("dbkey", ""); // Clear key
				$this->CopyRecord = FALSE;
			}
			if ($this->CopyRecord) {
				$this->CurrentAction = "C"; // Copy record
			} else {
				$this->CurrentAction = "I"; // Display blank record
			}
		}

		// Set up Breadcrumb
		$this->SetupBreadcrumb();

		// Validate form if post back
		if (@$_POST["a_add"] <> "") {
			if (!$this->ValidateForm()) {
				$this->CurrentAction = "I"; // Form error, reset action
				$this->EventCancelled = TRUE; // Event cancelled
				$this->RestoreFormValues(); // Restore form values
				$this->setFailureMessage($gsFormError);
			}
		} else {
			if ($this->CurrentAction == "I") // Load default values for blank record
				$this->LoadDefaultValues();
		}

		// Perform action based on action code
		switch ($this->CurrentAction) {
			case "I": // Blank record, no action required
				break;
			case "C": // Copy an existing record
				if (!$this->LoadRow()) { // Load record based on key
					if ($this->getFailureMessage() == "") $this->setFailureMessage($Language->Phrase("NoRecord")); // No record found
					$this->Page_Terminate("case_noteslist.php"); // No matching record, return to list
				}
				break;
			case "A": // Add new record
				$this->SendEmail = TRUE; // Send email on add success
				if ($this->AddRow($this->OldRecordset)) { // Add successful
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage($Language->Phrase("AddSuccess")); // Set up success message
					$sReturnUrl = $this->getReturnUrl();
					if (ew_GetPageName($sReturnUrl) == "case_noteslist.php")
						$sReturnUrl = $this->AddMasterUrl($sReturnUrl); // List page, return to list page with correct master key if necessary
					elseif (ew_GetPageName($sReturnUrl) == "case_notesview.php")
						$sReturnUrl = $this->GetViewUrl(); // View page, return to view page with keyurl directly
					$this->Page_Terminate($sReturnUrl); // Clean up and return
				} else {
					$this->EventCancelled = TRUE; // Event cancelled
					$this->RestoreFormValues(); // Add failed, restore form values
				}
		}

		// Render row based on row type
		$this->RowType = EW_ROWTYPE_ADD; // Render add type

		// Render row
		$this->ResetAttrs();
		$this->RenderRow();
	}

	// Get upload files
	function GetUploadFiles() {
		global $objForm, $Language;

		// Get upload data
	}

	// Load default values
	function LoadDefaultValues() {
		$this->dbkey_counselor->CurrentValue = CurrentUserID();
		$this->date->CurrentValue = date('Y-m-d');
		$this->dbkey_client->CurrentValue = NULL;
		$this->dbkey_client->OldValue = $this->dbkey_client->CurrentValue;
		$this->client_met_outcome->CurrentValue = NULL;
		$this->client_met_outcome->OldValue = $this->client_met_outcome->CurrentValue;
		$this->how_objective->CurrentValue = NULL;
		$this->how_objective->OldValue = $this->how_objective->CurrentValue;
		$this->case_notes->CurrentValue = NULL;
		$this->case_notes->OldValue = $this->case_notes->CurrentValue;
	}

	// Load form values
	function LoadFormValues() {

		// Load from form
		global $objForm;
		if (!$this->dbkey_counselor->FldIsDetailKey) {
			$this->dbkey_counselor->setFormValue($objForm->GetValue("x_dbkey_counselor"));
		}
		if (!$this->date->FldIsDetailKey) {
			$this->date->setFormValue($objForm->GetValue("x_date"));
			$this->date->CurrentValue = ew_UnFormatDateTime($this->date->CurrentValue, 0);
		}
		if (!$this->dbkey_client->FldIsDetailKey) {
			$this->dbkey_client->setFormValue($objForm->GetValue("x_dbkey_client"));
		}
		if (!$this->client_met_outcome->FldIsDetailKey) {
			$this->client_met_outcome->setFormValue($objForm->GetValue("x_client_met_outcome"));
		}
		if (!$this->how_objective->FldIsDetailKey) {
			$this->how_objective->setFormValue($objForm->GetValue("x_how_objective"));
		}
		if (!$this->case_notes->FldIsDetailKey) {
			$this->case_notes->setFormValue($objForm->GetValue("x_case_notes"));
		}
	}

	// Restore form values
	function RestoreFormValues() {
		global $objForm;
		$this->LoadOldRecord();
		$this->dbkey_counselor->CurrentValue = $this->dbkey_counselor->FormValue;
		$this->date->CurrentValue = $this->date->FormValue;
		$this->date->CurrentValue = ew_UnFormatDateTime($this->date->CurrentValue, 0);
		$this->dbkey_client->CurrentValue = $this->dbkey_client->FormValue;
		$this->client_met_outcome->CurrentValue = $this->client_met_outcome->FormValue;
		$this->how_objective->CurrentValue = $this->how_objective->FormValue;
		$this->case_notes->CurrentValue = $this->case_notes->FormValue;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}

		// Check if valid user id
		if ($res) {
			$res = $this->ShowOptionLink('add');
			if (!$res) {
				$sUserIdMsg = ew_DeniedMsg();
				$this->setFailureMessage($sUserIdMsg);
			}
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->start->setDbValue($rs->fields('start'));
		$this->end->setDbValue($rs->fields('end'));
		$this->weeknumber->setDbValue($rs->fields('weeknumber'));
		$this->counselor->setDbValue($rs->fields('counselor'));
		$this->dbkey_counselor->setDbValue($rs->fields('dbkey_counselor'));
		$this->date->setDbValue($rs->fields('date'));
		$this->client->setDbValue($rs->fields('client'));
		$this->dbkey_client->setDbValue($rs->fields('dbkey_client'));
		$this->outcome_note->setDbValue($rs->fields('outcome_note'));
		$this->outcome->setDbValue($rs->fields('outcome'));
		$this->client_met_outcome->setDbValue($rs->fields('client_met_outcome'));
		$this->how_objective->setDbValue($rs->fields('how_objective'));
		$this->case_notes->setDbValue($rs->fields('case_notes'));
		$this->create_date->setDbValue($rs->fields('create_date'));
		$this->update_date->setDbValue($rs->fields('update_date'));
		$this->updated_by->setDbValue($rs->fields('updated_by'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey->DbValue = $row['dbkey'];
		$this->start->DbValue = $row['start'];
		$this->end->DbValue = $row['end'];
		$this->weeknumber->DbValue = $row['weeknumber'];
		$this->counselor->DbValue = $row['counselor'];
		$this->dbkey_counselor->DbValue = $row['dbkey_counselor'];
		$this->date->DbValue = $row['date'];
		$this->client->DbValue = $row['client'];
		$this->dbkey_client->DbValue = $row['dbkey_client'];
		$this->outcome_note->DbValue = $row['outcome_note'];
		$this->outcome->DbValue = $row['outcome'];
		$this->client_met_outcome->DbValue = $row['client_met_outcome'];
		$this->how_objective->DbValue = $row['how_objective'];
		$this->case_notes->DbValue = $row['case_notes'];
		$this->create_date->DbValue = $row['create_date'];
		$this->update_date->DbValue = $row['update_date'];
		$this->updated_by->DbValue = $row['updated_by'];
	}

	// Load old record
	function LoadOldRecord() {

		// Load key values from Session
		$bValidKey = TRUE;
		if (strval($this->getKey("dbkey")) <> "")
			$this->dbkey->CurrentValue = $this->getKey("dbkey"); // dbkey
		else
			$bValidKey = FALSE;

		// Load old recordset
		if ($bValidKey) {
			$this->CurrentFilter = $this->KeyFilter();
			$sSql = $this->SQL();
			$conn = &$this->Connection();
			$this->OldRecordset = ew_LoadRecordset($sSql, $conn);
			$this->LoadRowValues($this->OldRecordset); // Load row values
		} else {
			$this->OldRecordset = NULL;
		}
		return $bValidKey;
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Call Row_Rendering event

		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey
		// start
		// end
		// weeknumber
		// counselor
		// dbkey_counselor
		// date
		// client
		// dbkey_client
		// outcome_note
		// outcome
		// client_met_outcome
		// how_objective
		// case_notes
		// create_date
		// update_date
		// updated_by

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// weeknumber
		if (strval($this->weeknumber->CurrentValue) <> "") {
			$sFilterWrk = "WEEKOFYEAR(adddate(case_notes.date, INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY))" . ew_SearchString("=", $this->weeknumber->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT WEEKOFYEAR(adddate(case_notes.date, INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY)), adddate(case_notes.date,  INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY) AS `DispFld`, adddate(case_notes.date, INTERVAL 8-DAYOFWEEK(case_notes.date) DAY) AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `case_notes`";
		$sWhereWrk = "";
		$this->weeknumber->LookupFilters = array("df1" => "0", "df2" => "0");
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->weeknumber, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = ew_FormatDateTime($rswrk->fields('DispFld'), 0);
				$arwrk[2] = ew_FormatDateTime($rswrk->fields('Disp2Fld'), 0);
				$this->weeknumber->ViewValue = $this->weeknumber->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->weeknumber->ViewValue = $this->weeknumber->CurrentValue;
			}
		} else {
			$this->weeknumber->ViewValue = NULL;
		}
		$this->weeknumber->ViewCustomAttributes = "";

		// counselor
		if (strval($this->counselor->CurrentValue) <> "") {
			$sFilterWrk = "(SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor)" . ew_SearchString("=", $this->counselor->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor), (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `case_notes`";
		$sWhereWrk = "";
		$this->counselor->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->counselor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->counselor->ViewValue = $this->counselor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->counselor->ViewValue = $this->counselor->CurrentValue;
			}
		} else {
			$this->counselor->ViewValue = NULL;
		}
		$this->counselor->ViewCustomAttributes = "";

		// dbkey_counselor
		if (strval($this->dbkey_counselor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_counselor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->dbkey_counselor->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_counselor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_counselor->ViewValue = $this->dbkey_counselor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_counselor->ViewValue = $this->dbkey_counselor->CurrentValue;
			}
		} else {
			$this->dbkey_counselor->ViewValue = NULL;
		}
		$this->dbkey_counselor->ViewCustomAttributes = "";

		// date
		$this->date->ViewValue = $this->date->CurrentValue;
		$this->date->ViewValue = ew_FormatDateTime($this->date->ViewValue, 0);
		$this->date->ViewCustomAttributes = "";

		// client
		$this->client->ViewValue = $this->client->CurrentValue;
		$this->client->ViewCustomAttributes = "";

		// dbkey_client
		if (strval($this->dbkey_client->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		$this->dbkey_client->LookupFilters = array();
		$lookuptblfilter = "`active` = 1";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_client->ViewValue = $this->dbkey_client->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_client->ViewValue = $this->dbkey_client->CurrentValue;
			}
		} else {
			$this->dbkey_client->ViewValue = NULL;
		}
		$this->dbkey_client->ViewCustomAttributes = "";

		// outcome_note
		$this->outcome_note->ViewValue = $this->outcome_note->CurrentValue;
		$this->outcome_note->ViewCustomAttributes = "";

		// client_met_outcome
		if (strval($this->client_met_outcome->CurrentValue) <> "") {
			$this->client_met_outcome->ViewValue = $this->client_met_outcome->OptionCaption($this->client_met_outcome->CurrentValue);
		} else {
			$this->client_met_outcome->ViewValue = NULL;
		}
		$this->client_met_outcome->ViewCustomAttributes = "";

		// how_objective
		$this->how_objective->ViewValue = $this->how_objective->CurrentValue;
		$this->how_objective->ViewCustomAttributes = "";

		// case_notes
		$this->case_notes->ViewValue = $this->case_notes->CurrentValue;
		$this->case_notes->ViewCustomAttributes = "";

			// dbkey_counselor
			$this->dbkey_counselor->LinkCustomAttributes = "";
			$this->dbkey_counselor->HrefValue = "";
			$this->dbkey_counselor->TooltipValue = "";

			// date
			$this->date->LinkCustomAttributes = "";
			$this->date->HrefValue = "";
			$this->date->TooltipValue = "";

			// dbkey_client
			$this->dbkey_client->LinkCustomAttributes = "";
			$this->dbkey_client->HrefValue = "";
			$this->dbkey_client->TooltipValue = "";

			// client_met_outcome
			$this->client_met_outcome->LinkCustomAttributes = "";
			$this->client_met_outcome->HrefValue = "";
			$this->client_met_outcome->TooltipValue = "";

			// how_objective
			$this->how_objective->LinkCustomAttributes = "";
			$this->how_objective->HrefValue = "";
			$this->how_objective->TooltipValue = "";

			// case_notes
			$this->case_notes->LinkCustomAttributes = "";
			$this->case_notes->HrefValue = "";
			$this->case_notes->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_ADD) { // Add row

			// dbkey_counselor
			$this->dbkey_counselor->EditAttrs["class"] = "form-control";
			$this->dbkey_counselor->EditCustomAttributes = "";
			if (!$Security->IsAdmin() && $Security->IsLoggedIn() && !$this->UserIDAllow("add")) { // Non system admin
			if (trim(strval($this->dbkey_counselor->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_counselor->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			ew_AddFilter($sFilterWrk, $GLOBALS["counselor"]->AddUserIDFilter(""));
			$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `counselor`";
			$sWhereWrk = "";
			$this->dbkey_counselor->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_counselor, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->dbkey_counselor->EditValue = $arwrk;
			} else {
			if (trim(strval($this->dbkey_counselor->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_counselor->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `counselor`";
			$sWhereWrk = "";
			$this->dbkey_counselor->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			if (!$GLOBALS["case_notes"]->UserIDAllow("add")) $sWhereWrk = $GLOBALS["counselor"]->AddUserIDFilter($sWhereWrk);
			$this->Lookup_Selecting($this->dbkey_counselor, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->dbkey_counselor->EditValue = $arwrk;
			}

			// date
			$this->date->EditAttrs["class"] = "form-control";
			$this->date->EditCustomAttributes = "";
			$this->date->EditValue = ew_HtmlEncode(ew_FormatDateTime($this->date->CurrentValue, 8));
			$this->date->PlaceHolder = ew_RemoveHtml($this->date->FldCaption());

			// dbkey_client
			$this->dbkey_client->EditAttrs["class"] = "form-control";
			$this->dbkey_client->EditCustomAttributes = "";
			if (trim(strval($this->dbkey_client->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `client`";
			$sWhereWrk = "";
			$this->dbkey_client->LookupFilters = array();
			$lookuptblfilter = "`active` = 1";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last`";
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->dbkey_client->EditValue = $arwrk;

			// client_met_outcome
			$this->client_met_outcome->EditCustomAttributes = "";
			$this->client_met_outcome->EditValue = $this->client_met_outcome->Options(TRUE);

			// how_objective
			$this->how_objective->EditAttrs["class"] = "form-control";
			$this->how_objective->EditCustomAttributes = "";
			$this->how_objective->EditValue = ew_HtmlEncode($this->how_objective->CurrentValue);
			$this->how_objective->PlaceHolder = ew_RemoveHtml($this->how_objective->FldCaption());

			// case_notes
			$this->case_notes->EditAttrs["class"] = "form-control";
			$this->case_notes->EditCustomAttributes = "";
			$this->case_notes->EditValue = ew_HtmlEncode($this->case_notes->CurrentValue);
			$this->case_notes->PlaceHolder = ew_RemoveHtml($this->case_notes->FldCaption());

			// Add refer script
			// dbkey_counselor

			$this->dbkey_counselor->LinkCustomAttributes = "";
			$this->dbkey_counselor->HrefValue = "";

			// date
			$this->date->LinkCustomAttributes = "";
			$this->date->HrefValue = "";

			// dbkey_client
			$this->dbkey_client->LinkCustomAttributes = "";
			$this->dbkey_client->HrefValue = "";

			// client_met_outcome
			$this->client_met_outcome->LinkCustomAttributes = "";
			$this->client_met_outcome->HrefValue = "";

			// how_objective
			$this->how_objective->LinkCustomAttributes = "";
			$this->how_objective->HrefValue = "";

			// case_notes
			$this->case_notes->LinkCustomAttributes = "";
			$this->case_notes->HrefValue = "";
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate form
	function ValidateForm() {
		global $Language, $gsFormError;

		// Initialize form error message
		$gsFormError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return ($gsFormError == "");
		if (!$this->dbkey_counselor->FldIsDetailKey && !is_null($this->dbkey_counselor->FormValue) && $this->dbkey_counselor->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->dbkey_counselor->FldCaption(), $this->dbkey_counselor->ReqErrMsg));
		}
		if (!$this->date->FldIsDetailKey && !is_null($this->date->FormValue) && $this->date->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->date->FldCaption(), $this->date->ReqErrMsg));
		}
		if (!ew_CheckDateDef($this->date->FormValue)) {
			ew_AddMessage($gsFormError, $this->date->FldErrMsg());
		}
		if (!$this->dbkey_client->FldIsDetailKey && !is_null($this->dbkey_client->FormValue) && $this->dbkey_client->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->dbkey_client->FldCaption(), $this->dbkey_client->ReqErrMsg));
		}
		if (!$this->client_met_outcome->FldIsDetailKey && !is_null($this->client_met_outcome->FormValue) && $this->client_met_outcome->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->client_met_outcome->FldCaption(), $this->client_met_outcome->ReqErrMsg));
		}
		if (!$this->how_objective->FldIsDetailKey && !is_null($this->how_objective->FormValue) && $this->how_objective->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->how_objective->FldCaption(), $this->how_objective->ReqErrMsg));
		}
		if (!$this->case_notes->FldIsDetailKey && !is_null($this->case_notes->FormValue) && $this->case_notes->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->case_notes->FldCaption(), $this->case_notes->ReqErrMsg));
		}

		// Return validate result
		$ValidateForm = ($gsFormError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateForm = $ValidateForm && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsFormError, $sFormCustomError);
		}
		return $ValidateForm;
	}

	// Add record
	function AddRow($rsold = NULL) {
		global $Language, $Security;

		// Check if valid User ID
		$bValidUser = FALSE;
		if ($Security->CurrentUserID() <> "" && !ew_Empty($this->dbkey_counselor->CurrentValue) && !$Security->IsAdmin()) { // Non system admin
			$bValidUser = $Security->IsValidUserID($this->dbkey_counselor->CurrentValue);
			if (!$bValidUser) {
				$sUserIdMsg = str_replace("%c", CurrentUserID(), $Language->Phrase("UnAuthorizedUserID"));
				$sUserIdMsg = str_replace("%u", $this->dbkey_counselor->CurrentValue, $sUserIdMsg);
				$this->setFailureMessage($sUserIdMsg);
				return FALSE;
			}
		}
		$conn = &$this->Connection();

		// Load db values from rsold
		if ($rsold) {
			$this->LoadDbValues($rsold);
		}
		$rsnew = array();

		// dbkey_counselor
		$this->dbkey_counselor->SetDbValueDef($rsnew, $this->dbkey_counselor->CurrentValue, NULL, FALSE);

		// date
		$this->date->SetDbValueDef($rsnew, ew_UnFormatDateTime($this->date->CurrentValue, 0), NULL, FALSE);

		// dbkey_client
		$this->dbkey_client->SetDbValueDef($rsnew, $this->dbkey_client->CurrentValue, NULL, FALSE);

		// client_met_outcome
		$this->client_met_outcome->SetDbValueDef($rsnew, $this->client_met_outcome->CurrentValue, NULL, FALSE);

		// how_objective
		$this->how_objective->SetDbValueDef($rsnew, $this->how_objective->CurrentValue, NULL, FALSE);

		// case_notes
		$this->case_notes->SetDbValueDef($rsnew, $this->case_notes->CurrentValue, NULL, FALSE);

		// Call Row Inserting event
		$rs = ($rsold == NULL) ? NULL : $rsold->fields;
		$bInsertRow = $this->Row_Inserting($rs, $rsnew);
		if ($bInsertRow) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			$AddRow = $this->Insert($rsnew);
			$conn->raiseErrorFn = '';
			if ($AddRow) {

				// Get insert id if necessary
				$this->dbkey->setDbValue($conn->Insert_ID());
				$rsnew['dbkey'] = $this->dbkey->DbValue;
			}
		} else {
			if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

				// Use the message, do nothing
			} elseif ($this->CancelMessage <> "") {
				$this->setFailureMessage($this->CancelMessage);
				$this->CancelMessage = "";
			} else {
				$this->setFailureMessage($Language->Phrase("InsertCancelled"));
			}
			$AddRow = FALSE;
		}
		if ($AddRow) {

			// Call Row Inserted event
			$rs = ($rsold == NULL) ? NULL : $rsold->fields;
			$this->Row_Inserted($rs, $rsnew);
			$this->WriteAuditTrailOnAdd($rsnew);
		}
		return $AddRow;
	}

	// Show link optionally based on User ID
	function ShowOptionLink($id = "") {
		global $Security;
		if ($Security->IsLoggedIn() && !$Security->IsAdmin() && !$this->UserIDAllow($id))
			return $Security->IsValidUserID($this->dbkey_counselor->CurrentValue);
		return TRUE;
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, $this->AddMasterUrl("case_noteslist.php"), "", $this->TableVar, TRUE);
		$PageId = ($this->CurrentAction == "C") ? "Copy" : "Add";
		$Breadcrumb->Add("add", $PageId, $url);
	}

	// Setup lookup filters of a field
	function SetupLookupFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		case "x_dbkey_counselor":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT `dbkey` AS `LinkFld`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
			$sWhereWrk = "";
			$this->dbkey_counselor->LookupFilters = array();
			if (!$GLOBALS["case_notes"]->UserIDAllow("add")) $sWhereWrk = $GLOBALS["counselor"]->AddUserIDFilter($sWhereWrk);
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey` = {filter_value}', "t0" => "3", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->dbkey_counselor, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		case "x_dbkey_client":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT `dbkey` AS `LinkFld`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
			$sWhereWrk = "";
			$this->dbkey_client->LookupFilters = array();
			$lookuptblfilter = "`active` = 1";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey` = {filter_value}', "t0" => "3", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last`";
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		}
	}

	// Setup AutoSuggest filters of a field
	function SetupAutoSuggestFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Write Audit Trail start/end for grid update
	function WriteAuditTrailDummy($typ) {
		$table = 'case_notes';
		$usr = CurrentUserID();
		ew_WriteAuditTrail("log", ew_StdCurrentDateTime(), ew_ScriptName(), $usr, $typ, $table, "", "", "", "");
	}

	// Write Audit Trail (add page)
	function WriteAuditTrailOnAdd(&$rs) {
		global $Language;
		if (!$this->AuditTrailOnAdd) return;
		$table = 'case_notes';

		// Get key value
		$key = "";
		if ($key <> "") $key .= $GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"];
		$key .= $rs['dbkey'];

		// Write Audit Trail
		$dt = ew_StdCurrentDateTime();
		$id = ew_ScriptName();
		$usr = CurrentUserID();
		foreach (array_keys($rs) as $fldname) {
			if ($this->fields[$fldname]->FldDataType <> EW_DATATYPE_BLOB) { // Ignore BLOB fields
				if ($this->fields[$fldname]->FldHtmlTag == "PASSWORD") {
					$newvalue = $Language->Phrase("PasswordMask"); // Password Field
				} elseif ($this->fields[$fldname]->FldDataType == EW_DATATYPE_MEMO) {
					if (EW_AUDIT_TRAIL_TO_DATABASE)
						$newvalue = $rs[$fldname];
					else
						$newvalue = "[MEMO]"; // Memo Field
				} elseif ($this->fields[$fldname]->FldDataType == EW_DATATYPE_XML) {
					$newvalue = "[XML]"; // XML Field
				} else {
					$newvalue = $rs[$fldname];
				}
				ew_WriteAuditTrail("log", $dt, $id, $usr, "A", $table, $fldname, $key, "", $newvalue);
			}
		}
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($case_notes_add)) $case_notes_add = new ccase_notes_add();

// Page init
$case_notes_add->Page_Init();

// Page main
$case_notes_add->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$case_notes_add->Page_Render();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "add";
var CurrentForm = fcase_notesadd = new ew_Form("fcase_notesadd", "add");

// Validate form
fcase_notesadd.Validate = function() {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	var $ = jQuery, fobj = this.GetForm(), $fobj = $(fobj);
	if ($fobj.find("#a_confirm").val() == "F")
		return true;
	var elm, felm, uelm, addcnt = 0;
	var $k = $fobj.find("#" + this.FormKeyCountName); // Get key_count
	var rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1;
	var startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
	var gridinsert = $fobj.find("#a_list").val() == "gridinsert";
	for (var i = startcnt; i <= rowcnt; i++) {
		var infix = ($k[0]) ? String(i) : "";
		$fobj.data("rowindex", infix);
			elm = this.GetElements("x" + infix + "_dbkey_counselor");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $case_notes->dbkey_counselor->FldCaption(), $case_notes->dbkey_counselor->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_date");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $case_notes->date->FldCaption(), $case_notes->date->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_date");
			if (elm && !ew_CheckDateDef(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($case_notes->date->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_dbkey_client");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $case_notes->dbkey_client->FldCaption(), $case_notes->dbkey_client->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_client_met_outcome");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $case_notes->client_met_outcome->FldCaption(), $case_notes->client_met_outcome->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_how_objective");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $case_notes->how_objective->FldCaption(), $case_notes->how_objective->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_case_notes");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $case_notes->case_notes->FldCaption(), $case_notes->case_notes->ReqErrMsg)) ?>");

			// Fire Form_CustomValidate event
			if (!this.Form_CustomValidate(fobj))
				return false;
	}

	// Process detail forms
	var dfs = $fobj.find("input[name='detailpage']").get();
	for (var i = 0; i < dfs.length; i++) {
		var df = dfs[i], val = df.value;
		if (val && ewForms[val])
			if (!ewForms[val].Validate())
				return false;
	}
	return true;
}

// Form_CustomValidate event
fcase_notesadd.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fcase_notesadd.ValidateRequired = true;
<?php } else { ?>
fcase_notesadd.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fcase_notesadd.Lists["x_dbkey_counselor"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_last","x_first","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"counselor"};
fcase_notesadd.Lists["x_dbkey_client"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_last","x_first","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"client"};
fcase_notesadd.Lists["x_client_met_outcome"] = {"LinkField":"","Ajax":null,"AutoFill":false,"DisplayFields":["","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
fcase_notesadd.Lists["x_client_met_outcome"].Options = <?php echo json_encode($case_notes->client_met_outcome->Options()) ?>;

// Form object for search
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php if (!$case_notes_add->IsModal) { ?>
<div class="ewToolbar">
<?php $Breadcrumb->Render(); ?>
<?php echo $Language->SelectionForm(); ?>
<div class="clearfix"></div>
</div>
<?php } ?>
<?php $case_notes_add->ShowPageHeader(); ?>
<?php
$case_notes_add->ShowMessage();
?>
<form name="fcase_notesadd" id="fcase_notesadd" class="<?php echo $case_notes_add->FormClassName ?>" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($case_notes_add->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $case_notes_add->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="case_notes">
<input type="hidden" name="a_add" id="a_add" value="A">
<?php if ($case_notes_add->IsModal) { ?>
<input type="hidden" name="modal" value="1">
<?php } ?>
<div>
<?php if ($case_notes->dbkey_counselor->Visible) { // dbkey_counselor ?>
	<div id="r_dbkey_counselor" class="form-group">
		<label id="elh_case_notes_dbkey_counselor" for="x_dbkey_counselor" class="col-sm-2 control-label ewLabel"><?php echo $case_notes->dbkey_counselor->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $case_notes->dbkey_counselor->CellAttributes() ?>>
<?php if (!$Security->IsAdmin() && $Security->IsLoggedIn() && !$case_notes->UserIDAllow("add")) { // Non system admin ?>
<span id="el_case_notes_dbkey_counselor">
<select data-table="case_notes" data-field="x_dbkey_counselor" data-value-separator="<?php echo $case_notes->dbkey_counselor->DisplayValueSeparatorAttribute() ?>" id="x_dbkey_counselor" name="x_dbkey_counselor"<?php echo $case_notes->dbkey_counselor->EditAttributes() ?>>
<?php echo $case_notes->dbkey_counselor->SelectOptionListHtml("x_dbkey_counselor") ?>
</select>
<input type="hidden" name="s_x_dbkey_counselor" id="s_x_dbkey_counselor" value="<?php echo $case_notes->dbkey_counselor->LookupFilterQuery() ?>">
</span>
<?php } else { ?>
<span id="el_case_notes_dbkey_counselor">
<select data-table="case_notes" data-field="x_dbkey_counselor" data-value-separator="<?php echo $case_notes->dbkey_counselor->DisplayValueSeparatorAttribute() ?>" id="x_dbkey_counselor" name="x_dbkey_counselor"<?php echo $case_notes->dbkey_counselor->EditAttributes() ?>>
<?php echo $case_notes->dbkey_counselor->SelectOptionListHtml("x_dbkey_counselor") ?>
</select>
<input type="hidden" name="s_x_dbkey_counselor" id="s_x_dbkey_counselor" value="<?php echo $case_notes->dbkey_counselor->LookupFilterQuery() ?>">
</span>
<?php } ?>
<?php echo $case_notes->dbkey_counselor->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($case_notes->date->Visible) { // date ?>
	<div id="r_date" class="form-group">
		<label id="elh_case_notes_date" for="x_date" class="col-sm-2 control-label ewLabel"><?php echo $case_notes->date->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $case_notes->date->CellAttributes() ?>>
<span id="el_case_notes_date">
<input type="text" data-table="case_notes" data-field="x_date" name="x_date" id="x_date" placeholder="<?php echo ew_HtmlEncode($case_notes->date->getPlaceHolder()) ?>" value="<?php echo $case_notes->date->EditValue ?>"<?php echo $case_notes->date->EditAttributes() ?>>
<?php if (!$case_notes->date->ReadOnly && !$case_notes->date->Disabled && !isset($case_notes->date->EditAttrs["readonly"]) && !isset($case_notes->date->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("fcase_notesadd", "x_date", 0);
</script>
<?php } ?>
</span>
<?php echo $case_notes->date->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($case_notes->dbkey_client->Visible) { // dbkey_client ?>
	<div id="r_dbkey_client" class="form-group">
		<label id="elh_case_notes_dbkey_client" for="x_dbkey_client" class="col-sm-2 control-label ewLabel"><?php echo $case_notes->dbkey_client->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $case_notes->dbkey_client->CellAttributes() ?>>
<span id="el_case_notes_dbkey_client">
<select data-table="case_notes" data-field="x_dbkey_client" data-value-separator="<?php echo $case_notes->dbkey_client->DisplayValueSeparatorAttribute() ?>" id="x_dbkey_client" name="x_dbkey_client"<?php echo $case_notes->dbkey_client->EditAttributes() ?>>
<?php echo $case_notes->dbkey_client->SelectOptionListHtml("x_dbkey_client") ?>
</select>
<input type="hidden" name="s_x_dbkey_client" id="s_x_dbkey_client" value="<?php echo $case_notes->dbkey_client->LookupFilterQuery() ?>">
</span>
<?php echo $case_notes->dbkey_client->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($case_notes->client_met_outcome->Visible) { // client_met_outcome ?>
	<div id="r_client_met_outcome" class="form-group">
		<label id="elh_case_notes_client_met_outcome" for="x_client_met_outcome" class="col-sm-2 control-label ewLabel"><?php echo $case_notes->client_met_outcome->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $case_notes->client_met_outcome->CellAttributes() ?>>
<span id="el_case_notes_client_met_outcome">
<div class="ewDropdownList has-feedback">
	<span onclick="" class="form-control dropdown-toggle" data-toggle="dropdown" aria-expanded="false">
		<?php echo $case_notes->client_met_outcome->ViewValue ?>
	</span>
	<span class="glyphicon glyphicon-remove form-control-feedback ewDropdownListClear"></span>
	<span class="form-control-feedback"><span class="caret"></span></span>
	<div id="dsl_x_client_met_outcome" data-repeatcolumn="1" class="dropdown-menu">
		<div class="ewItems" style="position: relative; overflow-x: hidden; min-width: 10px; max-height: 100px; overflow-y: auto;">
<?php echo $case_notes->client_met_outcome->RadioButtonListHtml(TRUE, "x_client_met_outcome") ?>
		</div>
	</div>
	<div id="tp_x_client_met_outcome" class="ewTemplate"><input type="radio" data-table="case_notes" data-field="x_client_met_outcome" data-value-separator="<?php echo $case_notes->client_met_outcome->DisplayValueSeparatorAttribute() ?>" name="x_client_met_outcome" id="x_client_met_outcome" value="{value}"<?php echo $case_notes->client_met_outcome->EditAttributes() ?>></div>
</div>
</span>
<?php echo $case_notes->client_met_outcome->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($case_notes->how_objective->Visible) { // how_objective ?>
	<div id="r_how_objective" class="form-group">
		<label id="elh_case_notes_how_objective" for="x_how_objective" class="col-sm-2 control-label ewLabel"><?php echo $case_notes->how_objective->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $case_notes->how_objective->CellAttributes() ?>>
<span id="el_case_notes_how_objective">
<textarea data-table="case_notes" data-field="x_how_objective" name="x_how_objective" id="x_how_objective" cols="35" rows="4" placeholder="<?php echo ew_HtmlEncode($case_notes->how_objective->getPlaceHolder()) ?>"<?php echo $case_notes->how_objective->EditAttributes() ?>><?php echo $case_notes->how_objective->EditValue ?></textarea>
</span>
<?php echo $case_notes->how_objective->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($case_notes->case_notes->Visible) { // case_notes ?>
	<div id="r_case_notes" class="form-group">
		<label id="elh_case_notes_case_notes" class="col-sm-2 control-label ewLabel"><?php echo $case_notes->case_notes->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-10"><div<?php echo $case_notes->case_notes->CellAttributes() ?>>
<span id="el_case_notes_case_notes">
<?php ew_AppendClass($case_notes->case_notes->EditAttrs["class"], "editor"); ?>
<textarea data-table="case_notes" data-field="x_case_notes" name="x_case_notes" id="x_case_notes" cols="35" rows="4" placeholder="<?php echo ew_HtmlEncode($case_notes->case_notes->getPlaceHolder()) ?>"<?php echo $case_notes->case_notes->EditAttributes() ?>><?php echo $case_notes->case_notes->EditValue ?></textarea>
<script type="text/javascript">
ew_CreateEditor("fcase_notesadd", "x_case_notes", 35, 4, <?php echo ($case_notes->case_notes->ReadOnly || FALSE) ? "true" : "false" ?>);
</script>
</span>
<?php echo $case_notes->case_notes->CustomMsg ?></div></div>
	</div>
<?php } ?>
</div>
<?php if (!$case_notes_add->IsModal) { ?>
<div class="form-group">
	<div class="col-sm-offset-2 col-sm-10">
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit"><?php echo $Language->Phrase("AddBtn") ?></button>
<button class="btn btn-default ewButton" name="btnCancel" id="btnCancel" type="button" data-href="<?php echo $case_notes_add->getReturnUrl() ?>"><?php echo $Language->Phrase("CancelBtn") ?></button>
	</div>
</div>
<?php } ?>
</form>
<script type="text/javascript">
fcase_notesadd.Init();
</script>
<?php
$case_notes_add->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$case_notes_add->Page_Terminate();
?>
