<?php

// Global variable for table object
$client_activity = NULL;

//
// Table class for client_activity
//
class cclient_activity extends cTable {
	var $dbkey_councilor;
	var $dbkey_client;
	var $first;
	var $waiverd;
	var $date;
	var $time;
	var $dbkey;
	var $comment;
	var $dbkey_activity_list;
	var $dbkey_activity;
	var $attachment;
	var $budget;
	var $total_remain;
	var $total_allocated;
	var $created_by;
	var $created_on;
	var $updated_by;
	var $updated_on;
	var $dbkey_client_budget;

	//
	// Table class constructor
	//
	function __construct() {
		global $Language;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();
		$this->TableVar = 'client_activity';
		$this->TableName = 'client_activity';
		$this->TableType = 'TABLE';

		// Update Table
		$this->UpdateTable = "`client_activity`";
		$this->DBID = 'DB';
		$this->ExportAll = TRUE;
		$this->ExportPageBreakCount = 0; // Page break per every n record (PDF only)
		$this->ExportPageOrientation = "portrait"; // Page orientation (PDF only)
		$this->ExportPageSize = "a4"; // Page size (PDF only)
		$this->ExportExcelPageOrientation = ""; // Page orientation (PHPExcel only)
		$this->ExportExcelPageSize = ""; // Page size (PHPExcel only)
		$this->DetailAdd = FALSE; // Allow detail add
		$this->DetailEdit = FALSE; // Allow detail edit
		$this->DetailView = FALSE; // Allow detail view
		$this->ShowMultipleDetails = FALSE; // Show multiple details
		$this->GridAddRowCount = 1;
		$this->AllowAddDeleteRow = ew_AllowAddDeleteRow(); // Allow add/delete row
		$this->UserIDAllowSecurity = 0; // User ID Allow
		$this->BasicSearch = new cBasicSearch($this->TableVar);

		// dbkey_councilor
		$this->dbkey_councilor = new cField('client_activity', 'client_activity', 'x_dbkey_councilor', 'dbkey_councilor', '`dbkey_councilor`', '`dbkey_councilor`', 3, -1, FALSE, '`dbkey_councilor`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_councilor->Sortable = TRUE; // Allow sort
		$this->dbkey_councilor->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->dbkey_councilor->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->dbkey_councilor->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_councilor'] = &$this->dbkey_councilor;

		// dbkey_client
		$this->dbkey_client = new cField('client_activity', 'client_activity', 'x_dbkey_client', 'dbkey_client', '`dbkey_client`', '`dbkey_client`', 3, -1, FALSE, '`dbkey_client`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_client->Sortable = FALSE; // Allow sort
		$this->dbkey_client->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->dbkey_client->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->dbkey_client->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_client'] = &$this->dbkey_client;

		// first
		$this->first = new cField('client_activity', 'client_activity', 'x_first', 'first', 'dbkey_client', 'dbkey_client', 3, -1, FALSE, 'dbkey_client', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->first->FldIsCustom = TRUE; // Custom field
		$this->first->Sortable = FALSE; // Allow sort
		$this->first->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->first->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->first->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['first'] = &$this->first;

		// waiverd
		$this->waiverd = new cField('client_activity', 'client_activity', 'x_waiverd', 'waiverd', '0', '0', 20, -1, FALSE, '0', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->waiverd->FldIsCustom = TRUE; // Custom field
		$this->waiverd->Sortable = TRUE; // Allow sort
		$this->waiverd->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['waiverd'] = &$this->waiverd;

		// date
		$this->date = new cField('client_activity', 'client_activity', 'x_date', 'date', '`date`', ew_CastDateFieldForLike('`date`', 1, "DB"), 135, 1, FALSE, '`date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->date->Sortable = TRUE; // Allow sort
		$this->date->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->date->AdvancedSearch->SearchValueDefault = date("Ymd", strtotime("-1 months"));
		$this->date->AdvancedSearch->SearchOperatorDefault = ">=";
		$this->date->AdvancedSearch->SearchOperatorDefault2 = "<=";
		$this->date->AdvancedSearch->SearchConditionDefault = "AND";
		$this->fields['date'] = &$this->date;

		// time
		$this->time = new cField('client_activity', 'client_activity', 'x_time', 'time', '`time`', '`time`', 131, -1, FALSE, '`time`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->time->Sortable = TRUE; // Allow sort
		$this->time->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['time'] = &$this->time;

		// dbkey
		$this->dbkey = new cField('client_activity', 'client_activity', 'x_dbkey', 'dbkey', '`dbkey`', '`dbkey`', 3, -1, FALSE, '`dbkey`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'NO');
		$this->dbkey->Sortable = TRUE; // Allow sort
		$this->dbkey->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey'] = &$this->dbkey;

		// comment
		$this->comment = new cField('client_activity', 'client_activity', 'x_comment', 'comment', '`comment`', '`comment`', 201, -1, FALSE, '`comment`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXTAREA');
		$this->comment->Sortable = TRUE; // Allow sort
		$this->fields['comment'] = &$this->comment;

		// dbkey_activity_list
		$this->dbkey_activity_list = new cField('client_activity', 'client_activity', 'x_dbkey_activity_list', 'dbkey_activity_list', 'dbkey_activity', 'dbkey_activity', 3, -1, FALSE, 'dbkey_activity', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_activity_list->FldIsCustom = TRUE; // Custom field
		$this->dbkey_activity_list->Sortable = TRUE; // Allow sort
		$this->dbkey_activity_list->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->dbkey_activity_list->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->dbkey_activity_list->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_activity_list'] = &$this->dbkey_activity_list;

		// dbkey_activity
		$this->dbkey_activity = new cField('client_activity', 'client_activity', 'x_dbkey_activity', 'dbkey_activity', '`dbkey_activity`', '`dbkey_activity`', 3, -1, FALSE, '`dbkey_activity`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_activity->Sortable = FALSE; // Allow sort
		$this->dbkey_activity->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->dbkey_activity->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->dbkey_activity->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_activity'] = &$this->dbkey_activity;

		// attachment
		$this->attachment = new cField('client_activity', 'client_activity', 'x_attachment', 'attachment', '`attachment`', '`attachment`', 201, -1, TRUE, '`attachment`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'FILE');
		$this->attachment->Sortable = FALSE; // Allow sort
		$this->attachment->UploadMultiple = TRUE;
		$this->attachment->Upload->UploadMultiple = TRUE;
		$this->attachment->UploadMaxFileCount = 0;
		$this->fields['attachment'] = &$this->attachment;

		// budget
		$this->budget = new cField('client_activity', 'client_activity', 'x_budget', 'budget', '(SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND client_activity.dbkey_activity = client_budget.dbkey_activity AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )', '(SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND client_activity.dbkey_activity = client_budget.dbkey_activity AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )', 131, -1, FALSE, '(SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND client_activity.dbkey_activity = client_budget.dbkey_activity AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->budget->FldIsCustom = TRUE; // Custom field
		$this->budget->Sortable = TRUE; // Allow sort
		$this->budget->FldDefaultErrMsg = $Language->Phrase("IncorrectFloat");
		$this->fields['budget'] = &$this->budget;

		// total_remain
		$this->total_remain = new cField('client_activity', 'client_activity', 'x_total_remain', 'total_remain', '0', '0', 20, -1, FALSE, '0', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->total_remain->FldIsCustom = TRUE; // Custom field
		$this->total_remain->Sortable = FALSE; // Allow sort
		$this->total_remain->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['total_remain'] = &$this->total_remain;

		// total_allocated
		$this->total_allocated = new cField('client_activity', 'client_activity', 'x_total_allocated', 'total_allocated', '0', '0', 20, -1, FALSE, '0', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->total_allocated->FldIsCustom = TRUE; // Custom field
		$this->total_allocated->Sortable = FALSE; // Allow sort
		$this->total_allocated->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['total_allocated'] = &$this->total_allocated;

		// created_by
		$this->created_by = new cField('client_activity', 'client_activity', 'x_created_by', 'created_by', '`created_by`', '`created_by`', 3, -1, FALSE, '`created_by`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->created_by->Sortable = FALSE; // Allow sort
		$this->created_by->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['created_by'] = &$this->created_by;

		// created_on
		$this->created_on = new cField('client_activity', 'client_activity', 'x_created_on', 'created_on', '`created_on`', ew_CastDateFieldForLike('`created_on`', 0, "DB"), 135, 0, FALSE, '`created_on`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->created_on->Sortable = FALSE; // Allow sort
		$this->created_on->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['created_on'] = &$this->created_on;

		// updated_by
		$this->updated_by = new cField('client_activity', 'client_activity', 'x_updated_by', 'updated_by', '`updated_by`', '`updated_by`', 3, -1, FALSE, '`updated_by`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->updated_by->Sortable = FALSE; // Allow sort
		$this->updated_by->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['updated_by'] = &$this->updated_by;

		// updated_on
		$this->updated_on = new cField('client_activity', 'client_activity', 'x_updated_on', 'updated_on', '`updated_on`', ew_CastDateFieldForLike('`updated_on`', 0, "DB"), 135, 0, FALSE, '`updated_on`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->updated_on->Sortable = FALSE; // Allow sort
		$this->updated_on->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['updated_on'] = &$this->updated_on;

		// dbkey_client_budget
		$this->dbkey_client_budget = new cField('client_activity', 'client_activity', 'x_dbkey_client_budget', 'dbkey_client_budget', '(SELECT dbkey FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND client_activity.dbkey_activity = client_budget.dbkey_activity AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )', '(SELECT dbkey FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND client_activity.dbkey_activity = client_budget.dbkey_activity AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )', 3, -1, FALSE, '(SELECT dbkey FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND client_activity.dbkey_activity = client_budget.dbkey_activity AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) )', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->dbkey_client_budget->FldIsCustom = TRUE; // Custom field
		$this->dbkey_client_budget->Sortable = FALSE; // Allow sort
		$this->dbkey_client_budget->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_client_budget'] = &$this->dbkey_client_budget;
	}

	// Set Field Visibility
	function SetFieldVisibility($fldparm) {
		global $Security;
		return $this->$fldparm->Visible; // Returns original value
	}

	// Single column sort
	function UpdateSort(&$ofld) {
		if ($this->CurrentOrder == $ofld->FldName) {
			$sSortField = $ofld->FldExpression;
			$sLastSort = $ofld->getSort();
			if ($this->CurrentOrderType == "ASC" || $this->CurrentOrderType == "DESC") {
				$sThisSort = $this->CurrentOrderType;
			} else {
				$sThisSort = ($sLastSort == "ASC") ? "DESC" : "ASC";
			}
			$ofld->setSort($sThisSort);
			$this->setSessionOrderBy($sSortField . " " . $sThisSort); // Save to Session
		} else {
			$ofld->setSort("");
		}
	}

	// Table level SQL
	var $_SqlFrom = "";

	function getSqlFrom() { // From
		return ($this->_SqlFrom <> "") ? $this->_SqlFrom : "`client_activity`";
	}

	function SqlFrom() { // For backward compatibility
		return $this->getSqlFrom();
	}

	function setSqlFrom($v) {
		$this->_SqlFrom = $v;
	}
	var $_SqlSelect = "";

	function getSqlSelect() { // Select
		return ($this->_SqlSelect <> "") ? $this->_SqlSelect : "SELECT *, dbkey_client AS `first`, 0 AS `waiverd`, dbkey_activity AS `dbkey_activity_list`, (SELECT CAST(sum(IfNull(client_budget.budget, 0)) AS DECIMAL(20,2)) FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND client_activity.dbkey_activity = client_budget.dbkey_activity AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) ) AS `budget`, 0 AS `total_remain`, 0 AS `total_allocated`, (SELECT dbkey FROM client_budget where client_activity.dbkey_client = client_budget.dbkey_client AND client_activity.dbkey_activity = client_budget.dbkey_activity AND date(client_activity.date) >= date(client_budget.from) and date(client_activity.date) <= date(client_budget.through) ) AS `dbkey_client_budget` FROM " . $this->getSqlFrom();
	}

	function SqlSelect() { // For backward compatibility
		return $this->getSqlSelect();
	}

	function setSqlSelect($v) {
		$this->_SqlSelect = $v;
	}
	var $_SqlWhere = "";

	function getSqlWhere() { // Where
		$sWhere = ($this->_SqlWhere <> "") ? $this->_SqlWhere : "";
		$this->TableFilter = "";
		ew_AddFilter($sWhere, $this->TableFilter);
		return $sWhere;
	}

	function SqlWhere() { // For backward compatibility
		return $this->getSqlWhere();
	}

	function setSqlWhere($v) {
		$this->_SqlWhere = $v;
	}
	var $_SqlGroupBy = "";

	function getSqlGroupBy() { // Group By
		return ($this->_SqlGroupBy <> "") ? $this->_SqlGroupBy : "";
	}

	function SqlGroupBy() { // For backward compatibility
		return $this->getSqlGroupBy();
	}

	function setSqlGroupBy($v) {
		$this->_SqlGroupBy = $v;
	}
	var $_SqlHaving = "";

	function getSqlHaving() { // Having
		return ($this->_SqlHaving <> "") ? $this->_SqlHaving : "";
	}

	function SqlHaving() { // For backward compatibility
		return $this->getSqlHaving();
	}

	function setSqlHaving($v) {
		$this->_SqlHaving = $v;
	}
	var $_SqlOrderBy = "";

	function getSqlOrderBy() { // Order By
		return ($this->_SqlOrderBy <> "") ? $this->_SqlOrderBy : "`date` DESC,`time` DESC";
	}

	function SqlOrderBy() { // For backward compatibility
		return $this->getSqlOrderBy();
	}

	function setSqlOrderBy($v) {
		$this->_SqlOrderBy = $v;
	}

	// Apply User ID filters
	function ApplyUserIDFilters($sFilter) {
		global $Security;

		// Add User ID filter
		if ($Security->CurrentUserID() <> "" && !$Security->IsAdmin()) { // Non system admin
			$sFilter = $this->AddUserIDFilter($sFilter);
		}
		return $sFilter;
	}

	// Check if User ID security allows view all
	function UserIDAllow($id = "") {
		$allow = $this->UserIDAllowSecurity;
		switch ($id) {
			case "add":
			case "copy":
			case "gridadd":
			case "register":
			case "addopt":
				return (($allow & 1) == 1);
			case "edit":
			case "gridedit":
			case "update":
			case "changepwd":
			case "forgotpwd":
				return (($allow & 4) == 4);
			case "delete":
				return (($allow & 2) == 2);
			case "view":
				return (($allow & 32) == 32);
			case "search":
				return (($allow & 64) == 64);
			default:
				return (($allow & 8) == 8);
		}
	}

	// Get SQL
	function GetSQL($where, $orderby) {
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$where, $orderby);
	}

	// Table SQL
	function SQL() {
		$sFilter = $this->CurrentFilter;
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$sFilter, $sSort);
	}

	// Table SQL with List page filter
	function SelectSQL() {
		$sFilter = $this->getSessionWhere();
		ew_AddFilter($sFilter, $this->CurrentFilter);
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$this->Recordset_Selecting($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(), $this->getSqlGroupBy(),
			$this->getSqlHaving(), $this->getSqlOrderBy(), $sFilter, $sSort);
	}

	// Get ORDER BY clause
	function GetOrderBy() {
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql("", "", "", "", $this->getSqlOrderBy(), "", $sSort);
	}

	// Try to get record count
	function TryGetRecordCount($sSql) {
		$cnt = -1;
		if (($this->TableType == 'TABLE' || $this->TableType == 'VIEW' || $this->TableType == 'LINKTABLE') && preg_match("/^SELECT \* FROM/i", $sSql)) {
			$sSql = "SELECT COUNT(*) FROM" . preg_replace('/^SELECT\s([\s\S]+)?\*\sFROM/i', "", $sSql);
			$sOrderBy = $this->GetOrderBy();
			if (substr($sSql, strlen($sOrderBy) * -1) == $sOrderBy)
				$sSql = substr($sSql, 0, strlen($sSql) - strlen($sOrderBy)); // Remove ORDER BY clause
		} else {
			$sSql = "SELECT COUNT(*) FROM (" . $sSql . ") EW_COUNT_TABLE";
		}
		$conn = &$this->Connection();
		if ($rs = $conn->Execute($sSql)) {
			if (!$rs->EOF && $rs->FieldCount() > 0) {
				$cnt = $rs->fields[0];
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// Get record count based on filter (for detail record count in master table pages)
	function LoadRecordCount($sFilter) {
		$origFilter = $this->CurrentFilter;
		$this->CurrentFilter = $sFilter;
		$this->Recordset_Selecting($this->CurrentFilter);

		//$sSql = $this->SQL();
		$sSql = $this->GetSQL($this->CurrentFilter, "");
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			if ($rs = $this->LoadRs($this->CurrentFilter)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		$this->CurrentFilter = $origFilter;
		return intval($cnt);
	}

	// Get record count (for current List page)
	function SelectRecordCount() {
		$sSql = $this->SelectSQL();
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			$conn = &$this->Connection();
			if ($rs = $conn->Execute($sSql)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// INSERT statement
	function InsertSQL(&$rs) {
		$names = "";
		$values = "";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$names .= $this->fields[$name]->FldExpression . ",";
			$values .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($names, -1) == ",")
			$names = substr($names, 0, -1);
		while (substr($values, -1) == ",")
			$values = substr($values, 0, -1);
		return "INSERT INTO " . $this->UpdateTable . " ($names) VALUES ($values)";
	}

	// Insert
	function Insert(&$rs) {
		$conn = &$this->Connection();
		return $conn->Execute($this->InsertSQL($rs));
	}

	// UPDATE statement
	function UpdateSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "UPDATE " . $this->UpdateTable . " SET ";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$sql .= $this->fields[$name]->FldExpression . "=";
			$sql .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($sql, -1) == ",")
			$sql = substr($sql, 0, -1);
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		ew_AddFilter($filter, $where);
		if ($filter <> "")	$sql .= " WHERE " . $filter;
		return $sql;
	}

	// Update
	function Update(&$rs, $where = "", $rsold = NULL, $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->UpdateSQL($rs, $where, $curfilter));
	}

	// DELETE statement
	function DeleteSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "DELETE FROM " . $this->UpdateTable . " WHERE ";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		if ($rs) {
			if (array_key_exists('dbkey_councilor', $rs))
				ew_AddFilter($where, ew_QuotedName('dbkey_councilor', $this->DBID) . '=' . ew_QuotedValue($rs['dbkey_councilor'], $this->dbkey_councilor->FldDataType, $this->DBID));
			if (array_key_exists('dbkey', $rs))
				ew_AddFilter($where, ew_QuotedName('dbkey', $this->DBID) . '=' . ew_QuotedValue($rs['dbkey'], $this->dbkey->FldDataType, $this->DBID));
		}
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		ew_AddFilter($filter, $where);
		if ($filter <> "")
			$sql .= $filter;
		else
			$sql .= "0=1"; // Avoid delete
		return $sql;
	}

	// Delete
	function Delete(&$rs, $where = "", $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->DeleteSQL($rs, $where, $curfilter));
	}

	// Key filter WHERE clause
	function SqlKeyFilter() {
		return "`dbkey_councilor` = @dbkey_councilor@ AND `dbkey` = @dbkey@";
	}

	// Key filter
	function KeyFilter() {
		$sKeyFilter = $this->SqlKeyFilter();
		if (!is_numeric($this->dbkey_councilor->CurrentValue))
			$sKeyFilter = "0=1"; // Invalid key
		$sKeyFilter = str_replace("@dbkey_councilor@", ew_AdjustSql($this->dbkey_councilor->CurrentValue, $this->DBID), $sKeyFilter); // Replace key value
		if (!is_numeric($this->dbkey->CurrentValue))
			$sKeyFilter = "0=1"; // Invalid key
		$sKeyFilter = str_replace("@dbkey@", ew_AdjustSql($this->dbkey->CurrentValue, $this->DBID), $sKeyFilter); // Replace key value
		return $sKeyFilter;
	}

	// Return page URL
	function getReturnUrl() {
		$name = EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL;

		// Get referer URL automatically
		if (ew_ServerVar("HTTP_REFERER") <> "" && ew_ReferPage() <> ew_CurrentPage() && ew_ReferPage() <> "login.php") // Referer not same page or login page
			$_SESSION[$name] = ew_ServerVar("HTTP_REFERER"); // Save to Session
		if (@$_SESSION[$name] <> "") {
			return $_SESSION[$name];
		} else {
			return "client_activitylist.php";
		}
	}

	function setReturnUrl($v) {
		$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL] = $v;
	}

	// List URL
	function GetListUrl() {
		return "client_activitylist.php";
	}

	// View URL
	function GetViewUrl($parm = "") {
		if ($parm <> "")
			$url = $this->KeyUrl("client_activityview.php", $this->UrlParm($parm));
		else
			$url = $this->KeyUrl("client_activityview.php", $this->UrlParm(EW_TABLE_SHOW_DETAIL . "="));
		return $this->AddMasterUrl($url);
	}

	// Add URL
	function GetAddUrl($parm = "") {
		if ($parm <> "")
			$url = "client_activityadd.php?" . $this->UrlParm($parm);
		else
			$url = "client_activityadd.php";
		return $this->AddMasterUrl($url);
	}

	// Edit URL
	function GetEditUrl($parm = "") {
		$url = $this->KeyUrl("client_activityedit.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline edit URL
	function GetInlineEditUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=edit"));
		return $this->AddMasterUrl($url);
	}

	// Copy URL
	function GetCopyUrl($parm = "") {
		$url = $this->KeyUrl("client_activityadd.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline copy URL
	function GetInlineCopyUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=copy"));
		return $this->AddMasterUrl($url);
	}

	// Delete URL
	function GetDeleteUrl() {
		return $this->KeyUrl("client_activitydelete.php", $this->UrlParm());
	}

	// Add master url
	function AddMasterUrl($url) {
		return $url;
	}

	function KeyToJson() {
		$json = "";
		$json .= "dbkey_councilor:" . ew_VarToJson($this->dbkey_councilor->CurrentValue, "number", "'");
		$json .= ",dbkey:" . ew_VarToJson($this->dbkey->CurrentValue, "number", "'");
		return "{" . $json . "}";
	}

	// Add key value to URL
	function KeyUrl($url, $parm = "") {
		$sUrl = $url . "?";
		if ($parm <> "") $sUrl .= $parm . "&";
		if (!is_null($this->dbkey_councilor->CurrentValue)) {
			$sUrl .= "dbkey_councilor=" . urlencode($this->dbkey_councilor->CurrentValue);
		} else {
			return "javascript:ew_Alert(ewLanguage.Phrase('InvalidRecord'));";
		}
		if (!is_null($this->dbkey->CurrentValue)) {
			$sUrl .= "&dbkey=" . urlencode($this->dbkey->CurrentValue);
		} else {
			return "javascript:ew_Alert(ewLanguage.Phrase('InvalidRecord'));";
		}
		return $sUrl;
	}

	// Sort URL
	function SortUrl(&$fld) {
		if ($this->CurrentAction <> "" || $this->Export <> "" ||
			in_array($fld->FldType, array(128, 204, 205))) { // Unsortable data type
				return "";
		} elseif ($fld->Sortable) {
			$sUrlParm = $this->UrlParm("order=" . urlencode($fld->FldName) . "&amp;ordertype=" . $fld->ReverseSort());
			return $this->AddMasterUrl(ew_CurrentPage() . "?" . $sUrlParm);
		} else {
			return "";
		}
	}

	// Get record keys from $_POST/$_GET/$_SESSION
	function GetRecordKeys() {
		global $EW_COMPOSITE_KEY_SEPARATOR;
		$arKeys = array();
		$arKey = array();
		if (isset($_POST["key_m"])) {
			$arKeys = ew_StripSlashes($_POST["key_m"]);
			$cnt = count($arKeys);
			for ($i = 0; $i < $cnt; $i++)
				$arKeys[$i] = explode($EW_COMPOSITE_KEY_SEPARATOR, $arKeys[$i]);
		} elseif (isset($_GET["key_m"])) {
			$arKeys = ew_StripSlashes($_GET["key_m"]);
			$cnt = count($arKeys);
			for ($i = 0; $i < $cnt; $i++)
				$arKeys[$i] = explode($EW_COMPOSITE_KEY_SEPARATOR, $arKeys[$i]);
		} elseif (!empty($_GET) || !empty($_POST)) {
			$isPost = ew_IsHttpPost();
			if ($isPost && isset($_POST["dbkey_councilor"]))
				$arKey[] = ew_StripSlashes($_POST["dbkey_councilor"]);
			elseif (isset($_GET["dbkey_councilor"]))
				$arKey[] = ew_StripSlashes($_GET["dbkey_councilor"]);
			else
				$arKeys = NULL; // Do not setup
			if ($isPost && isset($_POST["dbkey"]))
				$arKey[] = ew_StripSlashes($_POST["dbkey"]);
			elseif (isset($_GET["dbkey"]))
				$arKey[] = ew_StripSlashes($_GET["dbkey"]);
			else
				$arKeys = NULL; // Do not setup
			if (is_array($arKeys)) $arKeys[] = $arKey;

			//return $arKeys; // Do not return yet, so the values will also be checked by the following code
		}

		// Check keys
		$ar = array();
		if (is_array($arKeys)) {
			foreach ($arKeys as $key) {
				if (!is_array($key) || count($key) <> 2)
					continue; // Just skip so other keys will still work
				if (!is_numeric($key[0])) // dbkey_councilor
					continue;
				if (!is_numeric($key[1])) // dbkey
					continue;
				$ar[] = $key;
			}
		}
		return $ar;
	}

	// Get key filter
	function GetKeyFilter() {
		$arKeys = $this->GetRecordKeys();
		$sKeyFilter = "";
		foreach ($arKeys as $key) {
			if ($sKeyFilter <> "") $sKeyFilter .= " OR ";
			$this->dbkey_councilor->CurrentValue = $key[0];
			$this->dbkey->CurrentValue = $key[1];
			$sKeyFilter .= "(" . $this->KeyFilter() . ")";
		}
		return $sKeyFilter;
	}

	// Load rows based on filter
	function &LoadRs($sFilter) {

		// Set up filter (SQL WHERE clause) and get return SQL
		//$this->CurrentFilter = $sFilter;
		//$sSql = $this->SQL();

		$sSql = $this->GetSQL($sFilter, "");
		$conn = &$this->Connection();
		$rs = $conn->Execute($sSql);
		return $rs;
	}

	// Load row values from recordset
	function LoadListRowValues(&$rs) {
		$this->dbkey_councilor->setDbValue($rs->fields('dbkey_councilor'));
		$this->dbkey_client->setDbValue($rs->fields('dbkey_client'));
		$this->first->setDbValue($rs->fields('first'));
		$this->waiverd->setDbValue($rs->fields('waiverd'));
		$this->date->setDbValue($rs->fields('date'));
		$this->time->setDbValue($rs->fields('time'));
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->comment->setDbValue($rs->fields('comment'));
		$this->dbkey_activity_list->setDbValue($rs->fields('dbkey_activity_list'));
		$this->dbkey_activity->setDbValue($rs->fields('dbkey_activity'));
		$this->attachment->Upload->DbValue = $rs->fields('attachment');
		$this->budget->setDbValue($rs->fields('budget'));
		$this->total_remain->setDbValue($rs->fields('total_remain'));
		$this->total_allocated->setDbValue($rs->fields('total_allocated'));
		$this->created_by->setDbValue($rs->fields('created_by'));
		$this->created_on->setDbValue($rs->fields('created_on'));
		$this->updated_by->setDbValue($rs->fields('updated_by'));
		$this->updated_on->setDbValue($rs->fields('updated_on'));
		$this->dbkey_client_budget->setDbValue($rs->fields('dbkey_client_budget'));
	}

	// Render list row values
	function RenderListRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

   // Common render codes
		// dbkey_councilor

		$this->dbkey_councilor->CellCssStyle = "white-space: nowrap;";

		// dbkey_client
		$this->dbkey_client->CellCssStyle = "white-space: nowrap;";

		// first
		$this->first->CellCssStyle = "white-space: nowrap;";

		// waiverd
		// date
		// time
		// dbkey

		$this->dbkey->CellCssStyle = "white-space: nowrap;";

		// comment
		// dbkey_activity_list
		// dbkey_activity

		$this->dbkey_activity->CellCssStyle = "white-space: nowrap;";

		// attachment
		$this->attachment->CellCssStyle = "white-space: nowrap;";

		// budget
		// total_remain

		$this->total_remain->CellCssStyle = "white-space: nowrap;";

		// total_allocated
		$this->total_allocated->CellCssStyle = "white-space: nowrap;";

		// created_by
		$this->created_by->CellCssStyle = "white-space: nowrap;";

		// created_on
		$this->created_on->CellCssStyle = "white-space: nowrap;";

		// updated_by
		$this->updated_by->CellCssStyle = "white-space: nowrap;";

		// updated_on
		$this->updated_on->CellCssStyle = "white-space: nowrap;";

		// dbkey_client_budget
		$this->dbkey_client_budget->CellCssStyle = "white-space: nowrap;";

		// dbkey_councilor
		if (strval($this->dbkey_councilor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->dbkey_councilor->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_councilor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->CurrentValue;
			}
		} else {
			$this->dbkey_councilor->ViewValue = NULL;
		}
		$this->dbkey_councilor->ViewCustomAttributes = "";

		// dbkey_client
		if (strval($this->dbkey_client->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		$this->dbkey_client->LookupFilters = array();
		$lookuptblfilter = "`active` = 1";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last` ASC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_client->ViewValue = $this->dbkey_client->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_client->ViewValue = $this->dbkey_client->CurrentValue;
			}
		} else {
			$this->dbkey_client->ViewValue = NULL;
		}
		$this->dbkey_client->ViewCustomAttributes = "";

		// first
		if (strval($this->first->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->first->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		$this->first->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->first, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `first`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->first->ViewValue = $this->first->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->first->ViewValue = $this->first->CurrentValue;
			}
		} else {
			$this->first->ViewValue = NULL;
		}
		$this->first->ViewCustomAttributes = "";

		// waiverd
		$this->waiverd->ViewValue = $this->waiverd->CurrentValue;
		$this->waiverd->ViewCustomAttributes = "";

		// date
		$this->date->ViewValue = $this->date->CurrentValue;
		$this->date->ViewValue = ew_FormatDateTime($this->date->ViewValue, 1);
		$this->date->ViewCustomAttributes = "";

		// time
		$this->time->ViewValue = $this->time->CurrentValue;
		$this->time->ViewValue = ew_FormatNumber($this->time->ViewValue, 2, -2, -2, -2);
		$this->time->ViewCustomAttributes = "";

		// dbkey
		$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// comment
		$this->comment->ViewValue = $this->comment->CurrentValue;
		$this->comment->ViewCustomAttributes = "";

		// dbkey_activity_list
		if (strval($this->dbkey_activity_list->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_activity_list->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `activity`";
		$sWhereWrk = "";
		$this->dbkey_activity_list->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_activity_list, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_activity_list->ViewValue = $this->dbkey_activity_list->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_activity_list->ViewValue = $this->dbkey_activity_list->CurrentValue;
			}
		} else {
			$this->dbkey_activity_list->ViewValue = NULL;
		}
		$this->dbkey_activity_list->ViewCustomAttributes = "";

		// dbkey_activity
		if (strval($this->dbkey_activity->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey_activity`" . ew_SearchString("=", $this->dbkey_activity->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey_activity`, (select activity.description from activity where activity.dbkey = dbkey_activity) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client_to_activity_code`";
		$sWhereWrk = "";
		$this->dbkey_activity->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->CurrentValue;
			}
		} else {
			$this->dbkey_activity->ViewValue = NULL;
		}
		$this->dbkey_activity->ViewCustomAttributes = "";

		// attachment
		if (!ew_Empty($this->attachment->Upload->DbValue)) {
			$this->attachment->ViewValue = $this->attachment->Upload->DbValue;
		} else {
			$this->attachment->ViewValue = "";
		}
		$this->attachment->ViewCustomAttributes = "";

		// budget
		$this->budget->ViewValue = $this->budget->CurrentValue;
		$this->budget->ViewCustomAttributes = "";

		// total_remain
		$this->total_remain->ViewValue = $this->total_remain->CurrentValue;
		$this->total_remain->ViewCustomAttributes = "";

		// total_allocated
		$this->total_allocated->ViewValue = $this->total_allocated->CurrentValue;
		$this->total_allocated->ViewCustomAttributes = "";

		// created_by
		$this->created_by->ViewValue = $this->created_by->CurrentValue;
		$this->created_by->ViewCustomAttributes = "";

		// created_on
		$this->created_on->ViewValue = $this->created_on->CurrentValue;
		$this->created_on->ViewValue = ew_FormatDateTime($this->created_on->ViewValue, 0);
		$this->created_on->ViewCustomAttributes = "";

		// updated_by
		$this->updated_by->ViewValue = $this->updated_by->CurrentValue;
		$this->updated_by->ViewCustomAttributes = "";

		// updated_on
		$this->updated_on->ViewValue = $this->updated_on->CurrentValue;
		$this->updated_on->ViewValue = ew_FormatDateTime($this->updated_on->ViewValue, 0);
		$this->updated_on->ViewCustomAttributes = "";

		// dbkey_client_budget
		$this->dbkey_client_budget->ViewValue = $this->dbkey_client_budget->CurrentValue;
		$this->dbkey_client_budget->ViewCustomAttributes = "";

		// dbkey_councilor
		$this->dbkey_councilor->LinkCustomAttributes = "";
		$this->dbkey_councilor->HrefValue = "";
		$this->dbkey_councilor->TooltipValue = "";

		// dbkey_client
		$this->dbkey_client->LinkCustomAttributes = "";
		$this->dbkey_client->HrefValue = "";
		$this->dbkey_client->TooltipValue = "";

		// first
		$this->first->LinkCustomAttributes = "";
		$this->first->HrefValue = "";
		$this->first->TooltipValue = "";

		// waiverd
		$this->waiverd->LinkCustomAttributes = "";
		$this->waiverd->HrefValue = "";
		$this->waiverd->TooltipValue = "";

		// date
		$this->date->LinkCustomAttributes = "";
		$this->date->HrefValue = "";
		$this->date->TooltipValue = "";

		// time
		$this->time->LinkCustomAttributes = "";
		$this->time->HrefValue = "";
		$this->time->TooltipValue = "";

		// dbkey
		$this->dbkey->LinkCustomAttributes = "";
		$this->dbkey->HrefValue = "";
		$this->dbkey->TooltipValue = "";

		// comment
		$this->comment->LinkCustomAttributes = "";
		$this->comment->HrefValue = "";
		$this->comment->TooltipValue = "";

		// dbkey_activity_list
		$this->dbkey_activity_list->LinkCustomAttributes = "";
		$this->dbkey_activity_list->HrefValue = "";
		$this->dbkey_activity_list->TooltipValue = "";

		// dbkey_activity
		$this->dbkey_activity->LinkCustomAttributes = "";
		$this->dbkey_activity->HrefValue = "";
		$this->dbkey_activity->TooltipValue = "";

		// attachment
		$this->attachment->LinkCustomAttributes = "";
		$this->attachment->HrefValue = "";
		$this->attachment->HrefValue2 = $this->attachment->UploadPath . $this->attachment->Upload->DbValue;
		$this->attachment->TooltipValue = "";

		// budget
		$this->budget->LinkCustomAttributes = "";
		if (!ew_Empty($this->dbkey_client_budget->CurrentValue)) {
			$this->budget->HrefValue = "client_budgetview.php?showdetail=&dbkey=" . ((!empty($this->dbkey_client_budget->ViewValue)) ? ew_RemoveHtml($this->dbkey_client_budget->ViewValue) : $this->dbkey_client_budget->CurrentValue); // Add prefix/suffix
			$this->budget->LinkAttrs["target"] = "_blank"; // Add target
			if ($this->Export <> "") $this->budget->HrefValue = ew_ConvertFullUrl($this->budget->HrefValue);
		} else {
			$this->budget->HrefValue = "";
		}
		$this->budget->TooltipValue = "";

		// total_remain
		$this->total_remain->LinkCustomAttributes = "";
		$this->total_remain->HrefValue = "";
		$this->total_remain->TooltipValue = "";

		// total_allocated
		$this->total_allocated->LinkCustomAttributes = "";
		$this->total_allocated->HrefValue = "";
		$this->total_allocated->TooltipValue = "";

		// created_by
		$this->created_by->LinkCustomAttributes = "";
		$this->created_by->HrefValue = "";
		$this->created_by->TooltipValue = "";

		// created_on
		$this->created_on->LinkCustomAttributes = "";
		$this->created_on->HrefValue = "";
		$this->created_on->TooltipValue = "";

		// updated_by
		$this->updated_by->LinkCustomAttributes = "";
		$this->updated_by->HrefValue = "";
		$this->updated_by->TooltipValue = "";

		// updated_on
		$this->updated_on->LinkCustomAttributes = "";
		$this->updated_on->HrefValue = "";
		$this->updated_on->TooltipValue = "";

		// dbkey_client_budget
		$this->dbkey_client_budget->LinkCustomAttributes = "";
		$this->dbkey_client_budget->HrefValue = "";
		$this->dbkey_client_budget->TooltipValue = "";

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Render edit row values
	function RenderEditRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

		// dbkey_councilor
		$this->dbkey_councilor->EditAttrs["class"] = "form-control";
		$this->dbkey_councilor->EditCustomAttributes = "";
		if (strval($this->dbkey_councilor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->dbkey_councilor->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_councilor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_councilor->EditValue = $this->dbkey_councilor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_councilor->EditValue = $this->dbkey_councilor->CurrentValue;
			}
		} else {
			$this->dbkey_councilor->EditValue = NULL;
		}
		$this->dbkey_councilor->ViewCustomAttributes = "";

		// dbkey_client
		$this->dbkey_client->EditAttrs["class"] = "form-control";
		$this->dbkey_client->EditCustomAttributes = "";

		// first
		$this->first->EditAttrs["class"] = "form-control";
		$this->first->EditCustomAttributes = "";

		// waiverd
		$this->waiverd->EditAttrs["class"] = "form-control";
		$this->waiverd->EditCustomAttributes = "";
		$this->waiverd->EditValue = $this->waiverd->CurrentValue;
		$this->waiverd->ViewCustomAttributes = "";

		// date
		$this->date->EditAttrs["class"] = "form-control";
		$this->date->EditCustomAttributes = "";
		$this->date->EditValue = ew_FormatDateTime($this->date->CurrentValue, 8);
		$this->date->PlaceHolder = ew_RemoveHtml($this->date->FldCaption());

		// time
		$this->time->EditAttrs["class"] = "form-control";
		$this->time->EditCustomAttributes = "";
		$this->time->EditValue = $this->time->CurrentValue;
		$this->time->PlaceHolder = ew_RemoveHtml($this->time->FldCaption());
		if (strval($this->time->EditValue) <> "" && is_numeric($this->time->EditValue)) $this->time->EditValue = ew_FormatNumber($this->time->EditValue, -2, -2, -2, -2);

		// dbkey
		$this->dbkey->EditAttrs["class"] = "form-control";
		$this->dbkey->EditCustomAttributes = "";
		$this->dbkey->EditValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// comment
		$this->comment->EditAttrs["class"] = "form-control";
		$this->comment->EditCustomAttributes = "";
		$this->comment->EditValue = $this->comment->CurrentValue;
		$this->comment->PlaceHolder = ew_RemoveHtml($this->comment->FldCaption());

		// dbkey_activity_list
		$this->dbkey_activity_list->EditAttrs["class"] = "form-control";
		$this->dbkey_activity_list->EditCustomAttributes = "";

		// dbkey_activity
		$this->dbkey_activity->EditCustomAttributes = "";

		// attachment
		$this->attachment->EditAttrs["class"] = "form-control";
		$this->attachment->EditCustomAttributes = "";
		if (!ew_Empty($this->attachment->Upload->DbValue)) {
			$this->attachment->EditValue = $this->attachment->Upload->DbValue;
		} else {
			$this->attachment->EditValue = "";
		}
		if (!ew_Empty($this->attachment->CurrentValue))
			$this->attachment->Upload->FileName = $this->attachment->CurrentValue;

		// budget
		$this->budget->EditAttrs["class"] = "form-control";
		$this->budget->EditCustomAttributes = "";
		$this->budget->EditValue = $this->budget->CurrentValue;
		$this->budget->PlaceHolder = ew_RemoveHtml($this->budget->FldCaption());
		if (strval($this->budget->EditValue) <> "" && is_numeric($this->budget->EditValue)) $this->budget->EditValue = ew_FormatNumber($this->budget->EditValue, -2, -1, -2, 0);

		// total_remain
		$this->total_remain->EditAttrs["class"] = "form-control";
		$this->total_remain->EditCustomAttributes = "";
		$this->total_remain->EditValue = $this->total_remain->CurrentValue;
		$this->total_remain->PlaceHolder = ew_RemoveHtml($this->total_remain->FldCaption());

		// total_allocated
		$this->total_allocated->EditAttrs["class"] = "form-control";
		$this->total_allocated->EditCustomAttributes = "";
		$this->total_allocated->EditValue = $this->total_allocated->CurrentValue;
		$this->total_allocated->PlaceHolder = ew_RemoveHtml($this->total_allocated->FldCaption());

		// created_by
		$this->created_by->EditAttrs["class"] = "form-control";
		$this->created_by->EditCustomAttributes = "";
		$this->created_by->EditValue = $this->created_by->CurrentValue;
		$this->created_by->PlaceHolder = ew_RemoveHtml($this->created_by->FldCaption());

		// created_on
		$this->created_on->EditAttrs["class"] = "form-control";
		$this->created_on->EditCustomAttributes = "";
		$this->created_on->EditValue = ew_FormatDateTime($this->created_on->CurrentValue, 8);
		$this->created_on->PlaceHolder = ew_RemoveHtml($this->created_on->FldCaption());

		// updated_by
		$this->updated_by->EditAttrs["class"] = "form-control";
		$this->updated_by->EditCustomAttributes = "";
		$this->updated_by->EditValue = $this->updated_by->CurrentValue;
		$this->updated_by->PlaceHolder = ew_RemoveHtml($this->updated_by->FldCaption());

		// updated_on
		$this->updated_on->EditAttrs["class"] = "form-control";
		$this->updated_on->EditCustomAttributes = "";
		$this->updated_on->EditValue = ew_FormatDateTime($this->updated_on->CurrentValue, 8);
		$this->updated_on->PlaceHolder = ew_RemoveHtml($this->updated_on->FldCaption());

		// dbkey_client_budget
		$this->dbkey_client_budget->EditAttrs["class"] = "form-control";
		$this->dbkey_client_budget->EditCustomAttributes = "";
		$this->dbkey_client_budget->EditValue = $this->dbkey_client_budget->CurrentValue;
		$this->dbkey_client_budget->PlaceHolder = ew_RemoveHtml($this->dbkey_client_budget->FldCaption());

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Aggregate list row values
	function AggregateListRowValues() {
			if (is_numeric($this->time->CurrentValue))
				$this->time->Total += $this->time->CurrentValue; // Accumulate total
	}

	// Aggregate list row (for rendering)
	function AggregateListRow() {
			$this->time->CurrentValue = $this->time->Total;
			$this->time->ViewValue = $this->time->CurrentValue;
			$this->time->ViewValue = ew_FormatNumber($this->time->ViewValue, 2, -2, -2, -2);
			$this->time->ViewCustomAttributes = "";
			$this->time->HrefValue = ""; // Clear href value

		// Call Row Rendered event
		$this->Row_Rendered();
	}
	var $ExportDoc;

	// Export data in HTML/CSV/Word/Excel/Email/PDF format
	function ExportDocument(&$Doc, &$Recordset, $StartRec, $StopRec, $ExportPageType = "") {
		if (!$Recordset || !$Doc)
			return;
		if (!$Doc->ExportCustom) {

			// Write header
			$Doc->ExportTableHeader();
			if ($Doc->Horizontal) { // Horizontal format, write header
				$Doc->BeginExportRow();
				if ($ExportPageType == "view") {
					if ($this->dbkey_councilor->Exportable) $Doc->ExportCaption($this->dbkey_councilor);
					if ($this->first->Exportable) $Doc->ExportCaption($this->first);
					if ($this->waiverd->Exportable) $Doc->ExportCaption($this->waiverd);
					if ($this->date->Exportable) $Doc->ExportCaption($this->date);
					if ($this->time->Exportable) $Doc->ExportCaption($this->time);
					if ($this->comment->Exportable) $Doc->ExportCaption($this->comment);
					if ($this->dbkey_activity_list->Exportable) $Doc->ExportCaption($this->dbkey_activity_list);
					if ($this->attachment->Exportable) $Doc->ExportCaption($this->attachment);
					if ($this->budget->Exportable) $Doc->ExportCaption($this->budget);
					if ($this->total_remain->Exportable) $Doc->ExportCaption($this->total_remain);
					if ($this->total_allocated->Exportable) $Doc->ExportCaption($this->total_allocated);
					if ($this->dbkey_client_budget->Exportable) $Doc->ExportCaption($this->dbkey_client_budget);
				} else {
					if ($this->dbkey_councilor->Exportable) $Doc->ExportCaption($this->dbkey_councilor);
					if ($this->first->Exportable) $Doc->ExportCaption($this->first);
					if ($this->waiverd->Exportable) $Doc->ExportCaption($this->waiverd);
					if ($this->date->Exportable) $Doc->ExportCaption($this->date);
					if ($this->time->Exportable) $Doc->ExportCaption($this->time);
					if ($this->dbkey->Exportable) $Doc->ExportCaption($this->dbkey);
					if ($this->comment->Exportable) $Doc->ExportCaption($this->comment);
					if ($this->dbkey_activity_list->Exportable) $Doc->ExportCaption($this->dbkey_activity_list);
					if ($this->budget->Exportable) $Doc->ExportCaption($this->budget);
					if ($this->total_remain->Exportable) $Doc->ExportCaption($this->total_remain);
					if ($this->total_allocated->Exportable) $Doc->ExportCaption($this->total_allocated);
					if ($this->dbkey_client_budget->Exportable) $Doc->ExportCaption($this->dbkey_client_budget);
				}
				$Doc->EndExportRow();
			}
		}

		// Move to first record
		$RecCnt = $StartRec - 1;
		if (!$Recordset->EOF) {
			$Recordset->MoveFirst();
			if ($StartRec > 1)
				$Recordset->Move($StartRec - 1);
		}
		while (!$Recordset->EOF && $RecCnt < $StopRec) {
			$RecCnt++;
			if (intval($RecCnt) >= intval($StartRec)) {
				$RowCnt = intval($RecCnt) - intval($StartRec) + 1;

				// Page break
				if ($this->ExportPageBreakCount > 0) {
					if ($RowCnt > 1 && ($RowCnt - 1) % $this->ExportPageBreakCount == 0)
						$Doc->ExportPageBreak();
				}
				$this->LoadListRowValues($Recordset);
				$this->AggregateListRowValues(); // Aggregate row values

				// Render row
				$this->RowType = EW_ROWTYPE_VIEW; // Render view
				$this->ResetAttrs();
				$this->RenderListRow();
				if (!$Doc->ExportCustom) {
					$Doc->BeginExportRow($RowCnt); // Allow CSS styles if enabled
					if ($ExportPageType == "view") {
						if ($this->dbkey_councilor->Exportable) $Doc->ExportField($this->dbkey_councilor);
						if ($this->first->Exportable) $Doc->ExportField($this->first);
						if ($this->waiverd->Exportable) $Doc->ExportField($this->waiverd);
						if ($this->date->Exportable) $Doc->ExportField($this->date);
						if ($this->time->Exportable) $Doc->ExportField($this->time);
						if ($this->comment->Exportable) $Doc->ExportField($this->comment);
						if ($this->dbkey_activity_list->Exportable) $Doc->ExportField($this->dbkey_activity_list);
						if ($this->attachment->Exportable) $Doc->ExportField($this->attachment);
						if ($this->budget->Exportable) $Doc->ExportField($this->budget);
						if ($this->total_remain->Exportable) $Doc->ExportField($this->total_remain);
						if ($this->total_allocated->Exportable) $Doc->ExportField($this->total_allocated);
						if ($this->dbkey_client_budget->Exportable) $Doc->ExportField($this->dbkey_client_budget);
					} else {
						if ($this->dbkey_councilor->Exportable) $Doc->ExportField($this->dbkey_councilor);
						if ($this->first->Exportable) $Doc->ExportField($this->first);
						if ($this->waiverd->Exportable) $Doc->ExportField($this->waiverd);
						if ($this->date->Exportable) $Doc->ExportField($this->date);
						if ($this->time->Exportable) $Doc->ExportField($this->time);
						if ($this->dbkey->Exportable) $Doc->ExportField($this->dbkey);
						if ($this->comment->Exportable) $Doc->ExportField($this->comment);
						if ($this->dbkey_activity_list->Exportable) $Doc->ExportField($this->dbkey_activity_list);
						if ($this->budget->Exportable) $Doc->ExportField($this->budget);
						if ($this->total_remain->Exportable) $Doc->ExportField($this->total_remain);
						if ($this->total_allocated->Exportable) $Doc->ExportField($this->total_allocated);
						if ($this->dbkey_client_budget->Exportable) $Doc->ExportField($this->dbkey_client_budget);
					}
					$Doc->EndExportRow();
				}
			}

			// Call Row Export server event
			if ($Doc->ExportCustom)
				$this->Row_Export($Recordset->fields);
			$Recordset->MoveNext();
		}

		// Export aggregates (horizontal format only)
		if ($Doc->Horizontal) {
			$this->RowType = EW_ROWTYPE_AGGREGATE;
			$this->ResetAttrs();
			$this->AggregateListRow();
			if (!$Doc->ExportCustom) {
				$Doc->BeginExportRow(-1);
				if ($this->dbkey_councilor->Exportable) $Doc->ExportAggregate($this->dbkey_councilor, '');
				if ($this->first->Exportable) $Doc->ExportAggregate($this->first, '');
				if ($this->waiverd->Exportable) $Doc->ExportAggregate($this->waiverd, '');
				if ($this->date->Exportable) $Doc->ExportAggregate($this->date, '');
				if ($this->time->Exportable) $Doc->ExportAggregate($this->time, 'TOTAL');
				if ($this->dbkey->Exportable) $Doc->ExportAggregate($this->dbkey, '');
				if ($this->comment->Exportable) $Doc->ExportAggregate($this->comment, '');
				if ($this->dbkey_activity_list->Exportable) $Doc->ExportAggregate($this->dbkey_activity_list, '');
				if ($this->budget->Exportable) $Doc->ExportAggregate($this->budget, '');
				if ($this->total_remain->Exportable) $Doc->ExportAggregate($this->total_remain, '');
				if ($this->total_allocated->Exportable) $Doc->ExportAggregate($this->total_allocated, '');
				if ($this->dbkey_client_budget->Exportable) $Doc->ExportAggregate($this->dbkey_client_budget, '');
				$Doc->EndExportRow();
			}
		}
		if (!$Doc->ExportCustom) {
			$Doc->ExportTableFooter();
		}
	}

	// Add User ID filter
	function AddUserIDFilter($sFilter) {
		global $Security;
		$sFilterWrk = "";
		$id = (CurrentPageID() == "list") ? $this->CurrentAction : CurrentPageID();
		if (!$this->UserIDAllow($id) && !$Security->IsAdmin()) {
			$sFilterWrk = $Security->UserIDList();
			if ($sFilterWrk <> "")
				$sFilterWrk = '`dbkey_councilor` IN (' . $sFilterWrk . ')';
		}

		// Call User ID Filtering event
		$this->UserID_Filtering($sFilterWrk);
		ew_AddFilter($sFilter, $sFilterWrk);
		return $sFilter;
	}

	// User ID subquery
	function GetUserIDSubquery(&$fld, &$masterfld) {
		global $UserTableConn;
		$sWrk = "";
		$sSql = "SELECT " . $masterfld->FldExpression . " FROM `client_activity`";
		$sFilter = $this->AddUserIDFilter("");
		if ($sFilter <> "") $sSql .= " WHERE " . $sFilter;

		// Use subquery
		if (EW_USE_SUBQUERY_FOR_MASTER_USER_ID) {
			$sWrk = $sSql;
		} else {

			// List all values
			if ($rs = $UserTableConn->Execute($sSql)) {
				while (!$rs->EOF) {
					if ($sWrk <> "") $sWrk .= ",";
					$sWrk .= ew_QuotedValue($rs->fields[0], $masterfld->FldDataType, EW_USER_TABLE_DBID);
					$rs->MoveNext();
				}
				$rs->Close();
			}
		}
		if ($sWrk <> "") {
			$sWrk = $fld->FldExpression . " IN (" . $sWrk . ")";
		}
		return $sWrk;
	}

	// Get auto fill value
	function GetAutoFill($id, $val) {
		$rsarr = array();
		$rowcnt = 0;

		// Output
		if (is_array($rsarr) && $rowcnt > 0) {
			$fldcnt = count($rsarr[0]);
			for ($i = 0; $i < $rowcnt; $i++) {
				for ($j = 0; $j < $fldcnt; $j++) {
					$str = strval($rsarr[$i][$j]);
					$str = ew_ConvertToUtf8($str);
					if (isset($post["keepCRLF"])) {
						$str = str_replace(array("\r", "\n"), array("\\r", "\\n"), $str);
					} else {
						$str = str_replace(array("\r", "\n"), array(" ", " "), $str);
					}
					$rsarr[$i][$j] = $str;
				}
			}
			return ew_ArrayToJson($rsarr);
		} else {
			return FALSE;
		}
	}

	// Table level events
	// Recordset Selecting event
	function Recordset_Selecting(&$filter) {

		// Enter your code here	
	}

	// Recordset Selected event
	function Recordset_Selected(&$rs) {

		//echo "Recordset Selected";
	}

	// Recordset Search Validated event
	function Recordset_SearchValidated() {

		// Example:
		//$this->MyField1->AdvancedSearch->SearchValue = "your search criteria"; // Search value

	}

	// Recordset Searching event
	function Recordset_Searching(&$filter) {

		// Enter your code here	
	}

	// Row_Selecting event
	function Row_Selecting(&$filter) {

		// Enter your code here	
	}

	// Row Selected event
	function Row_Selected(&$rs) {

		//echo "Row Selected";
	}

	// Row Inserting event
	function Row_Inserting($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		$rsnew['updated_by'] = CurrentUserID();
		$rsnew['created_by'] = CurrentUserID();
		$rsnew['updated_on'] = date('Y-m-d H:i:s', time());
		$rsnew['created_on'] = date('Y-m-d H:i:s', time());
		return TRUE;
	}

	// Row Inserted event
	function Row_Inserted($rsold, &$rsnew) {

		//echo "Row Inserted"
	}

	// Row Updating event
	function Row_Updating($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		$rsnew['updated_by'] = CurrentUserID();
		$rsnew['updated_on'] = date('Y-m-d H:i:s', time());
		return TRUE;
	}

	// Row Updated event
	function Row_Updated($rsold, &$rsnew) {

		//echo "Row Updated";
	}

	// Row Update Conflict event
	function Row_UpdateConflict($rsold, &$rsnew) {

		// Enter your code here
		// To ignore conflict, set return value to FALSE

		return TRUE;
	}

	// Grid Inserting event
	function Grid_Inserting() {

		// Enter your code here
		// To reject grid insert, set return value to FALSE

		$rsnew['updated_by'] = CurrentUserID();
		$rsnew['created_by'] = CurrentUserID();
		$rsnew['updated_on'] = date('Y-m-d H:i:s', time());
		$rsnew['created_on'] = date('Y-m-d H:i:s', time());
		return TRUE;
	}

	// Grid Inserted event
	function Grid_Inserted($rsnew) {

		//echo "Grid Inserted";
	}

	// Grid Updating event
	function Grid_Updating($rsold) {

		// Enter your code here
		// To reject grid update, set return value to FALSE

		$rsnew['updated_by'] = $this->dbkey_counselor->CurrentValue;
		$rsnew['updated_on'] = date('m/d/Y h:i:s a', time());
		return TRUE;
	}

	// Grid Updated event
	function Grid_Updated($rsold, $rsnew) {

		//echo "Grid Updated";
	}

	// Row Deleting event
	function Row_Deleting(&$rs) {

		// Enter your code here
		// To cancel, set return value to False

		return TRUE;
	}

	// Row Deleted event
	function Row_Deleted(&$rs) {

		//echo "Row Deleted";
	}

	// Email Sending event
	function Email_Sending(&$Email, &$Args) {

		//var_dump($Email); var_dump($Args); exit();
		return TRUE;
	}

	// Lookup Selecting event
	function Lookup_Selecting($fld, &$filter) {

		//var_dump($fld->FldName, $fld->LookupFilters, $filter); // Uncomment to view the filter
		// Enter your code here

	if ($fld->FldName == "dbkey_client"){

		//if (CurrentPageID() == "add") AddFilter($filter, "active = 1");
		//if (CurrentPageID() == "edit") AddFilter($filter, "active = 1");
		//if (CurrentPageID() == "list")
		//{
		//	$temp = "client.dbkey IN (SELECT DISTINCT client_activity.dbkey_client FROM client_activity where dbkey_councilor = " . CurrentUserID();  
	//		AddFilter($filter, $temp);
	//	}
	//	echo "<p> $filter </p>";
	//	exit();

		if (CurrentPageID() == "list")
		{

			//if ($fld->FldName == "dbkey_client")
		//	{
		//	$temp = "client.dbkey IN (SELECT DISTINCT c.client_activity.dbkey_client FROM client_activity c where c.dbkey_councilor = " . CurrentUserID();  
		//	ew_AddFilter($filter, "dbkey_client = '$temp'"); 
		//	var_dump($this->LookupFilters['s']);
		//	exit();
		//	}

		}
	}
	}

	// Row Rendering event
	function Row_Rendering() {

		// Enter your code here
		// To view properties of field class, use:
		// If over budget red.

		if ($this->remain->DbValue < 0)
		{
			$this->remain->CssStyle = "color:red;";
		}
		if (isset($_GET['a'])) $other_page = trim($_GET['a']); else $other_page = "";
		if (CurrentPageID() == "list" and $other_page <> "gridadd" and $other_page <> "gridedit" )
		{
			$this->dbkey_client->Visible = FALSE;
			$this->dbkey_activity->Visible = FALSE;
		}
		if (CurrentPageID() == "add" or CurrentPageID() == 'edit' or $other_page == "gridadd" or $other_page == "gridedit" ) {
		$this->first->Visible = FALSE;
		$this->budget->Visible = FALSE;
		$this->allocated->Visible = FALSE;
		$this->remain->Visible = FALSE;
		$this->contract_id->Visible = FALSE;
		$this->total_remain->Visible = FALSE;
		$this->total_allocated->Visible = FALSE;
		$this->dbkey_budget->Visible = FALSE;
		$this->dbkey_activity_list->Visible = FALSE;

		//	echo "<h1> Page id is: " . CurrentPageID() . " and ". $other_page . "</h1>";
		//	var_dump($this->first);

		}
		if (CurrentPageID() == "add")
		{
			date_default_timezone_set("America/Chicago");

			//echo "<h1> TIME SET " . date('Y-m-d H:m:s') . "</h1>";
		}

	//	if (CurrentPageID() == "list" and trim($_GET['a']) == 'gridedit')
	//	{
	//		$this->first->Visible = FALSE;
	//		var_dump($this->first);
	//	}
		//
		// Udate budget fields for display only
		//

	}

	// Row Rendered event
	function Row_Rendered() {

		// To view properties of field class, use:
		// If over budget red.

		if ($this->remain->DbValue < 0)
		{
			$this->remain->CssStyle = "color:red;";
		}
		if (isset($_GET['a'])) $other_page = trim($_GET['a']); else $other_page = "";

	//	echo "<h1> Page id is: " . CurrentPageID() . $_GET['a'] . "</h1>";
		if (CurrentPageID() == "list" and $other_page <> "gridadd" and $other_page <> "gridedit" )
		{
			$this->dbkey_client->Visible = FALSE;
			$this->dbkey_activity->Visible = FALSE;
		}
		if (CurrentPageID() == "add" or CurrentPageID() == 'edit' or $other_page == "gridadd" or $other_page == "gridedit" ) {
		$this->first->Visible = FALSE;
		$this->budget->Visible = FALSE;
		$this->allocated->Visible = FALSE;
		$this->remain->Visible = FALSE;
		$this->contract_id->Visible = FALSE;
		$this->total_remain->Visible = FALSE;
		$this->total_allocated->Visible = FALSE;
	$this->total_allocated->ViewValue = FALSE;
		$this->dbkey_budget->Visible = FALSE;
		$this->dbkey_activity_list->Visible = FALSE;

		//var_dump($this->total_allocated);
		}

	//	if (CurrentPageID() == "list" and trim($_GET['a']) == 'gridedit')
	//	{
	//		$this->first->Visible = FALSE;
	//		var_dump($this->first);
	//	}
	//exit();
	// Set dbkey's 
		//var_dump($this->budget);
		//$sql = "SELECT a.dbkey, a.message FROM daily_acknowledgments a where a.dbkey not in(select c.dbkey_daily_acknowledgments from daily_acknowledgment_log c where c.dbkey_daily_acknowledgments = a.dbkey and c.dbkey_counselor = " . CurrentUserID() . " and DATE(c.added_on) = '" . date('Y-m-d') . "') and a.userlevel in(select b.userlevelid from counselor b where b.dbkey = " . CurrentUserID() . " and b.userlevelid = a.userlevel) and a.date_from <= '" . date('Y-m-d') . "' and a.date_through >= '" . date('Y-m-d')."'";

		if(trim($this->dbkey_client->DbValue) == '') $sql_dbkey_client = 0; else $sql_dbkey_client = $this->dbkey_client->DbValue;
		if(trim($this->dbkey_activity->DbValue) == '') $sql_dbkey_activity = 0; else $sql_dbkey_activity = $this->dbkey_activity->DbValue;

	// Get Client values
	//$this->first->ViewValue = ""; 

	$this->waiverd->ViewValue = "";
	if ($sql_dbkey_client <> 0)
	{
		$sql = "SELECT last, first, waived FROM client where client.dbkey = " . $sql_dbkey_client . "";	

		//echo "<h1> SQL: " . $sql . "</h1>";
		$rs = ew_Execute($sql);
		if ($rs && $rs->RecordCount() > 0)
		{

			//echo "<h1> FOUND IT " . $rs->fields[3] . " </h1>";
			//var_dump($rs);
			//$this->first->ViewValue = $rs->fields[0] . " " . $rs->fields[1];

			$this->waiverd->ViewValue = $rs->fields[2];
			$rs->Close();
		} else
		{

			//$this->first->ViewValue = ""; 
			$this->waiverd->ViewValue = "";
		}
	}

	// Get Total Allocated and Remain
		if ($sql_dbkey_activity <> 0)
		{
		$sql = "SELECT CAST(sum(IfNull(b.time, 0)) AS DECIMAL(20,2)) FROM client_budget, client_activity b where client_budget.dbkey_client = b.dbkey_client and client_budget.dbkey_activity = b.dbkey_activity and " . $sql_dbkey_client . " = client_budget.dbkey_client AND  " . $sql_dbkey_activity . " = client_budget.dbkey_activity AND date('" . $this->date->DbValue . "') >= date(client_budget.from) and date('" . $this->date->DbValue . "') <= date(client_budget.through) and " . $sql_dbkey_activity . " = b.dbkey_activity";	

		//echo "<h1> SQL: " . $sql . "</h1>";
		$rs = ew_Execute($sql);
		if ($rs && $rs->RecordCount() > 0)
		{

			//echo "<h1> FOUND IT " . $rs->fields[0] . " </h1>";
			//var_dump($rs);

			$this->total_allocated->ViewValue = $rs->fields[0];
			$this->total_remain->ViewValue = (float)$this->budget->DbValue - (float)$this->total_allocated->ViewValue;
			$rs->Close();
		} else $this->total_allocated->ViewValue = "0.00";
		}

		//$this->budget->viewValue = "<a href='client_budgetview.php?showdetail=&dbkey=105'> 111 </a>";
		// Format

		$this->total_allocated->ViewValue = number_format($this->total_allocated->ViewValue,2);
		$this->budget->ViewValue = number_format($this->budget->ViewValue,2);
		$this->total_remain->ViewValue = number_format($this->total_remain->ViewValue,2);
	}

	// User ID Filtering event
	function UserID_Filtering(&$filter) {

		// Enter your code here
	}
}
?>
