<?php
if (session_id() == "") session_start(); // Init session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg13.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql13.php") ?>
<?php include_once "phpfn13.php" ?>
<?php include_once "client_to_activity_codeinfo.php" ?>
<?php include_once "activityinfo.php" ?>
<?php include_once "clientinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn13.php" ?>
<?php

//
// Page class
//

$client_to_activity_code_addopt = NULL; // Initialize page object first

class cclient_to_activity_code_addopt extends cclient_to_activity_code {

	// Page ID
	var $PageID = 'addopt';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'client_to_activity_code';

	// Page object name
	var $PageObjName = 'client_to_activity_code_addopt';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (client_to_activity_code)
		if (!isset($GLOBALS["client_to_activity_code"]) || get_class($GLOBALS["client_to_activity_code"]) == "cclient_to_activity_code") {
			$GLOBALS["client_to_activity_code"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["client_to_activity_code"];
		}

		// Table object (activity)
		if (!isset($GLOBALS['activity'])) $GLOBALS['activity'] = new cactivity();

		// Table object (client)
		if (!isset($GLOBALS['client'])) $GLOBALS['client'] = new cclient();

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'addopt', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'client_to_activity_code', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	//
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanAdd()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("client_to_activity_codelist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Create form object
		$objForm = new cFormObj();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action
		$this->dbkey_client->SetVisibility();
		$this->dbkey_client_list->SetVisibility();
		$this->dbkey_activity_list->SetVisibility();
		$this->dbkey_activity->SetVisibility();
		$this->updated_by->SetVisibility();
		$this->updated_on->SetVisibility();
		$this->added_by->SetVisibility();
		$this->added_on->SetVisibility();
		$this->activity_description->SetVisibility();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $client_to_activity_code;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($client_to_activity_code);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}

	//
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError;
		set_error_handler("ew_ErrorHandler");

		// Set up Breadcrumb
		//$this->SetupBreadcrumb(); // Not used
		// Process form if post back

		if ($objForm->GetValue("a_addopt") <> "") {
			$this->CurrentAction = $objForm->GetValue("a_addopt"); // Get form action
			$this->LoadFormValues(); // Load form values

			// Validate form
			if (!$this->ValidateForm()) {
				$this->CurrentAction = "I"; // Form error, reset action
				$this->setFailureMessage($gsFormError);
			}
		} else { // Not post back
			$this->CurrentAction = "I"; // Display blank record
			$this->LoadDefaultValues(); // Load default values
		}

		// Perform action based on action code
		switch ($this->CurrentAction) {
			case "I": // Blank record, no action required
				break;
			case "A": // Add new record
				$this->SendEmail = TRUE; // Send email on add success
				if ($this->AddRow()) { // Add successful
					$row = array();
					$row["x_dbkey"] = $this->dbkey->DbValue;
					$row["x_dbkey_client"] = $this->dbkey_client->DbValue;
					$row["x_dbkey_client_list"] = $this->dbkey_client_list->DbValue;
					$row["x_dbkey_activity_list"] = $this->dbkey_activity_list->DbValue;
					$row["x_dbkey_activity"] = $this->dbkey_activity->DbValue;
					$row["x_updated_by"] = $this->updated_by->DbValue;
					$row["x_updated_on"] = $this->updated_on->DbValue;
					$row["x_added_by"] = $this->added_by->DbValue;
					$row["x_added_on"] = $this->added_on->DbValue;
					$row["x_activity_description"] = $this->activity_description->DbValue;
					if (!EW_DEBUG_ENABLED && ob_get_length())
						ob_end_clean();
					echo ew_ArrayToJson(array($row));
				} else {
					$this->ShowMessage();
				}
				$this->Page_Terminate();
				exit();
		}

		// Render row
		$this->RowType = EW_ROWTYPE_ADD; // Render add type
		$this->ResetAttrs();
		$this->RenderRow();
	}

	// Get upload files
	function GetUploadFiles() {
		global $objForm, $Language;

		// Get upload data
	}

	// Load default values
	function LoadDefaultValues() {
		$this->dbkey_client->CurrentValue = NULL;
		$this->dbkey_client->OldValue = $this->dbkey_client->CurrentValue;
		$this->dbkey_client_list->CurrentValue = NULL;
		$this->dbkey_client_list->OldValue = $this->dbkey_client_list->CurrentValue;
		$this->dbkey_activity_list->CurrentValue = NULL;
		$this->dbkey_activity_list->OldValue = $this->dbkey_activity_list->CurrentValue;
		$this->dbkey_activity->CurrentValue = NULL;
		$this->dbkey_activity->OldValue = $this->dbkey_activity->CurrentValue;
		$this->updated_by->CurrentValue = NULL;
		$this->updated_by->OldValue = $this->updated_by->CurrentValue;
		$this->updated_on->CurrentValue = NULL;
		$this->updated_on->OldValue = $this->updated_on->CurrentValue;
		$this->added_by->CurrentValue = NULL;
		$this->added_by->OldValue = $this->added_by->CurrentValue;
		$this->added_on->CurrentValue = NULL;
		$this->added_on->OldValue = $this->added_on->CurrentValue;
		$this->activity_description->CurrentValue = NULL;
		$this->activity_description->OldValue = $this->activity_description->CurrentValue;
	}

	// Load form values
	function LoadFormValues() {

		// Load from form
		global $objForm;
		if (!$this->dbkey_client->FldIsDetailKey) {
			$this->dbkey_client->setFormValue(ew_ConvertFromUtf8($objForm->GetValue("x_dbkey_client")));
		}
		if (!$this->dbkey_client_list->FldIsDetailKey) {
			$this->dbkey_client_list->setFormValue(ew_ConvertFromUtf8($objForm->GetValue("x_dbkey_client_list")));
		}
		if (!$this->dbkey_activity_list->FldIsDetailKey) {
			$this->dbkey_activity_list->setFormValue(ew_ConvertFromUtf8($objForm->GetValue("x_dbkey_activity_list")));
		}
		if (!$this->dbkey_activity->FldIsDetailKey) {
			$this->dbkey_activity->setFormValue(ew_ConvertFromUtf8($objForm->GetValue("x_dbkey_activity")));
		}
		if (!$this->updated_by->FldIsDetailKey) {
			$this->updated_by->setFormValue(ew_ConvertFromUtf8($objForm->GetValue("x_updated_by")));
		}
		if (!$this->updated_on->FldIsDetailKey) {
			$this->updated_on->setFormValue(ew_ConvertFromUtf8($objForm->GetValue("x_updated_on")));
			$this->updated_on->CurrentValue = ew_UnFormatDateTime($this->updated_on->CurrentValue, 0);
		}
		if (!$this->added_by->FldIsDetailKey) {
			$this->added_by->setFormValue(ew_ConvertFromUtf8($objForm->GetValue("x_added_by")));
		}
		if (!$this->added_on->FldIsDetailKey) {
			$this->added_on->setFormValue(ew_ConvertFromUtf8($objForm->GetValue("x_added_on")));
			$this->added_on->CurrentValue = ew_UnFormatDateTime($this->added_on->CurrentValue, 0);
		}
		if (!$this->activity_description->FldIsDetailKey) {
			$this->activity_description->setFormValue(ew_ConvertFromUtf8($objForm->GetValue("x_activity_description")));
		}
	}

	// Restore form values
	function RestoreFormValues() {
		global $objForm;
		$this->dbkey_client->CurrentValue = ew_ConvertToUtf8($this->dbkey_client->FormValue);
		$this->dbkey_client_list->CurrentValue = ew_ConvertToUtf8($this->dbkey_client_list->FormValue);
		$this->dbkey_activity_list->CurrentValue = ew_ConvertToUtf8($this->dbkey_activity_list->FormValue);
		$this->dbkey_activity->CurrentValue = ew_ConvertToUtf8($this->dbkey_activity->FormValue);
		$this->updated_by->CurrentValue = ew_ConvertToUtf8($this->updated_by->FormValue);
		$this->updated_on->CurrentValue = ew_ConvertToUtf8($this->updated_on->FormValue);
		$this->updated_on->CurrentValue = ew_UnFormatDateTime($this->updated_on->CurrentValue, 0);
		$this->added_by->CurrentValue = ew_ConvertToUtf8($this->added_by->FormValue);
		$this->added_on->CurrentValue = ew_ConvertToUtf8($this->added_on->FormValue);
		$this->added_on->CurrentValue = ew_UnFormatDateTime($this->added_on->CurrentValue, 0);
		$this->activity_description->CurrentValue = ew_ConvertToUtf8($this->activity_description->FormValue);
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->dbkey_client->setDbValue($rs->fields('dbkey_client'));
		$this->dbkey_client_list->setDbValue($rs->fields('dbkey_client_list'));
		$this->dbkey_activity_list->setDbValue($rs->fields('dbkey_activity_list'));
		$this->dbkey_activity->setDbValue($rs->fields('dbkey_activity'));
		$this->updated_by->setDbValue($rs->fields('updated_by'));
		$this->updated_on->setDbValue($rs->fields('updated_on'));
		$this->added_by->setDbValue($rs->fields('added_by'));
		$this->added_on->setDbValue($rs->fields('added_on'));
		$this->activity_description->setDbValue($rs->fields('activity_description'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey->DbValue = $row['dbkey'];
		$this->dbkey_client->DbValue = $row['dbkey_client'];
		$this->dbkey_client_list->DbValue = $row['dbkey_client_list'];
		$this->dbkey_activity_list->DbValue = $row['dbkey_activity_list'];
		$this->dbkey_activity->DbValue = $row['dbkey_activity'];
		$this->updated_by->DbValue = $row['updated_by'];
		$this->updated_on->DbValue = $row['updated_on'];
		$this->added_by->DbValue = $row['added_by'];
		$this->added_on->DbValue = $row['added_on'];
		$this->activity_description->DbValue = $row['activity_description'];
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Call Row_Rendering event

		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey
		// dbkey_client
		// dbkey_client_list
		// dbkey_activity_list
		// dbkey_activity
		// updated_by
		// updated_on
		// added_by
		// added_on
		// activity_description

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// dbkey_client
		if (strval($this->dbkey_client->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		$this->dbkey_client->LookupFilters = array();
		$lookuptblfilter = "`active` = 1";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_client->ViewValue = $this->dbkey_client->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_client->ViewValue = $this->dbkey_client->CurrentValue;
			}
		} else {
			$this->dbkey_client->ViewValue = NULL;
		}
		$this->dbkey_client->ViewCustomAttributes = "";

		// dbkey_client_list
		if (strval($this->dbkey_client_list->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client_list->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		$this->dbkey_client_list->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_client_list, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_client_list->ViewValue = $this->dbkey_client_list->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_client_list->ViewValue = $this->dbkey_client_list->CurrentValue;
			}
		} else {
			$this->dbkey_client_list->ViewValue = NULL;
		}
		$this->dbkey_client_list->ViewCustomAttributes = "";

		// dbkey_activity_list
		if (strval($this->dbkey_activity_list->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_activity_list->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `activity`";
		$sWhereWrk = "";
		$this->dbkey_activity_list->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_activity_list, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_activity_list->ViewValue = $this->dbkey_activity_list->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_activity_list->ViewValue = $this->dbkey_activity_list->CurrentValue;
			}
		} else {
			$this->dbkey_activity_list->ViewValue = NULL;
		}
		$this->dbkey_activity_list->ViewCustomAttributes = "";

		// dbkey_activity
		if (strval($this->dbkey_activity->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_activity->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `activity`";
		$sWhereWrk = "";
		$this->dbkey_activity->LookupFilters = array();
		$lookuptblfilter = "`active` = 1";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_activity->ViewValue = $this->dbkey_activity->CurrentValue;
			}
		} else {
			$this->dbkey_activity->ViewValue = NULL;
		}
		$this->dbkey_activity->ViewCustomAttributes = "";

		// updated_by
		if (strval($this->updated_by->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->updated_by->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->updated_by->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->updated_by, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->updated_by->ViewValue = $this->updated_by->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->updated_by->ViewValue = $this->updated_by->CurrentValue;
			}
		} else {
			$this->updated_by->ViewValue = NULL;
		}
		$this->updated_by->ViewCustomAttributes = "";

		// updated_on
		$this->updated_on->ViewValue = $this->updated_on->CurrentValue;
		$this->updated_on->ViewValue = ew_FormatDateTime($this->updated_on->ViewValue, 0);
		$this->updated_on->ViewCustomAttributes = "";

		// added_by
		if (strval($this->added_by->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->added_by->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->added_by->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->added_by, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->added_by->ViewValue = $this->added_by->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->added_by->ViewValue = $this->added_by->CurrentValue;
			}
		} else {
			$this->added_by->ViewValue = NULL;
		}
		$this->added_by->ViewCustomAttributes = "";

		// added_on
		$this->added_on->ViewValue = $this->added_on->CurrentValue;
		$this->added_on->ViewValue = ew_FormatDateTime($this->added_on->ViewValue, 0);
		$this->added_on->ViewCustomAttributes = "";

		// activity_description
		$this->activity_description->ViewValue = $this->activity_description->CurrentValue;
		$this->activity_description->ViewCustomAttributes = "";

			// dbkey_client
			$this->dbkey_client->LinkCustomAttributes = "";
			$this->dbkey_client->HrefValue = "";
			$this->dbkey_client->TooltipValue = "";

			// dbkey_client_list
			$this->dbkey_client_list->LinkCustomAttributes = "";
			$this->dbkey_client_list->HrefValue = "";
			$this->dbkey_client_list->TooltipValue = "";

			// dbkey_activity_list
			$this->dbkey_activity_list->LinkCustomAttributes = "";
			$this->dbkey_activity_list->HrefValue = "";
			$this->dbkey_activity_list->TooltipValue = "";

			// dbkey_activity
			$this->dbkey_activity->LinkCustomAttributes = "";
			$this->dbkey_activity->HrefValue = "";
			$this->dbkey_activity->TooltipValue = "";

			// updated_by
			$this->updated_by->LinkCustomAttributes = "";
			$this->updated_by->HrefValue = "";
			$this->updated_by->TooltipValue = "";

			// updated_on
			$this->updated_on->LinkCustomAttributes = "";
			$this->updated_on->HrefValue = "";
			$this->updated_on->TooltipValue = "";

			// added_by
			$this->added_by->LinkCustomAttributes = "";
			$this->added_by->HrefValue = "";
			$this->added_by->TooltipValue = "";

			// added_on
			$this->added_on->LinkCustomAttributes = "";
			$this->added_on->HrefValue = "";
			$this->added_on->TooltipValue = "";

			// activity_description
			$this->activity_description->LinkCustomAttributes = "";
			$this->activity_description->HrefValue = "";
			$this->activity_description->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_ADD) { // Add row

			// dbkey_client
			$this->dbkey_client->EditAttrs["class"] = "form-control";
			$this->dbkey_client->EditCustomAttributes = "";
			if (trim(strval($this->dbkey_client->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `client`";
			$sWhereWrk = "";
			$this->dbkey_client->LookupFilters = array();
			$lookuptblfilter = "`active` = 1";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last`";
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->dbkey_client->EditValue = $arwrk;

			// dbkey_client_list
			$this->dbkey_client_list->EditAttrs["class"] = "form-control";
			$this->dbkey_client_list->EditCustomAttributes = "";
			if (trim(strval($this->dbkey_client_list->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client_list->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `client`";
			$sWhereWrk = "";
			$this->dbkey_client_list->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_client_list, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last`";
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->dbkey_client_list->EditValue = $arwrk;

			// dbkey_activity_list
			$this->dbkey_activity_list->EditAttrs["class"] = "form-control";
			$this->dbkey_activity_list->EditCustomAttributes = "";
			if (trim(strval($this->dbkey_activity_list->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_activity_list->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `activity`";
			$sWhereWrk = "";
			$this->dbkey_activity_list->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_activity_list, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->dbkey_activity_list->EditValue = $arwrk;

			// dbkey_activity
			$this->dbkey_activity->EditAttrs["class"] = "form-control";
			$this->dbkey_activity->EditCustomAttributes = "";
			if (trim(strval($this->dbkey_activity->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_activity->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `activity`";
			$sWhereWrk = "";
			$this->dbkey_activity->LookupFilters = array();
			$lookuptblfilter = "`active` = 1";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->dbkey_activity->EditValue = $arwrk;

			// updated_by
			$this->updated_by->EditAttrs["class"] = "form-control";
			$this->updated_by->EditCustomAttributes = "";
			if (trim(strval($this->updated_by->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->updated_by->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `counselor`";
			$sWhereWrk = "";
			$this->updated_by->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			if (!$GLOBALS["client_to_activity_code"]->UserIDAllow("addopt")) $sWhereWrk = $GLOBALS["counselor"]->AddUserIDFilter($sWhereWrk);
			$this->Lookup_Selecting($this->updated_by, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last`";
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->updated_by->EditValue = $arwrk;

			// updated_on
			$this->updated_on->EditAttrs["class"] = "form-control";
			$this->updated_on->EditCustomAttributes = "";
			$this->updated_on->EditValue = ew_HtmlEncode(ew_FormatDateTime($this->updated_on->CurrentValue, 8));
			$this->updated_on->PlaceHolder = ew_RemoveHtml($this->updated_on->FldCaption());

			// added_by
			$this->added_by->EditAttrs["class"] = "form-control";
			$this->added_by->EditCustomAttributes = "";
			if (trim(strval($this->added_by->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->added_by->CurrentValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `counselor`";
			$sWhereWrk = "";
			$this->added_by->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			if (!$GLOBALS["client_to_activity_code"]->UserIDAllow("addopt")) $sWhereWrk = $GLOBALS["counselor"]->AddUserIDFilter($sWhereWrk);
			$this->Lookup_Selecting($this->added_by, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->added_by->EditValue = $arwrk;

			// added_on
			$this->added_on->EditAttrs["class"] = "form-control";
			$this->added_on->EditCustomAttributes = "";
			$this->added_on->EditValue = ew_HtmlEncode(ew_FormatDateTime($this->added_on->CurrentValue, 8));
			$this->added_on->PlaceHolder = ew_RemoveHtml($this->added_on->FldCaption());

			// activity_description
			$this->activity_description->EditAttrs["class"] = "form-control";
			$this->activity_description->EditCustomAttributes = "";
			$this->activity_description->EditValue = ew_HtmlEncode($this->activity_description->CurrentValue);
			$this->activity_description->PlaceHolder = ew_RemoveHtml($this->activity_description->FldCaption());

			// Add refer script
			// dbkey_client

			$this->dbkey_client->LinkCustomAttributes = "";
			$this->dbkey_client->HrefValue = "";

			// dbkey_client_list
			$this->dbkey_client_list->LinkCustomAttributes = "";
			$this->dbkey_client_list->HrefValue = "";

			// dbkey_activity_list
			$this->dbkey_activity_list->LinkCustomAttributes = "";
			$this->dbkey_activity_list->HrefValue = "";

			// dbkey_activity
			$this->dbkey_activity->LinkCustomAttributes = "";
			$this->dbkey_activity->HrefValue = "";

			// updated_by
			$this->updated_by->LinkCustomAttributes = "";
			$this->updated_by->HrefValue = "";

			// updated_on
			$this->updated_on->LinkCustomAttributes = "";
			$this->updated_on->HrefValue = "";

			// added_by
			$this->added_by->LinkCustomAttributes = "";
			$this->added_by->HrefValue = "";

			// added_on
			$this->added_on->LinkCustomAttributes = "";
			$this->added_on->HrefValue = "";

			// activity_description
			$this->activity_description->LinkCustomAttributes = "";
			$this->activity_description->HrefValue = "";
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate form
	function ValidateForm() {
		global $Language, $gsFormError;

		// Initialize form error message
		$gsFormError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return ($gsFormError == "");
		if (!$this->dbkey_client->FldIsDetailKey && !is_null($this->dbkey_client->FormValue) && $this->dbkey_client->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->dbkey_client->FldCaption(), $this->dbkey_client->ReqErrMsg));
		}
		if (!$this->dbkey_activity->FldIsDetailKey && !is_null($this->dbkey_activity->FormValue) && $this->dbkey_activity->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->dbkey_activity->FldCaption(), $this->dbkey_activity->ReqErrMsg));
		}
		if (!$this->updated_by->FldIsDetailKey && !is_null($this->updated_by->FormValue) && $this->updated_by->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->updated_by->FldCaption(), $this->updated_by->ReqErrMsg));
		}
		if (!$this->updated_on->FldIsDetailKey && !is_null($this->updated_on->FormValue) && $this->updated_on->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->updated_on->FldCaption(), $this->updated_on->ReqErrMsg));
		}
		if (!ew_CheckDateDef($this->updated_on->FormValue)) {
			ew_AddMessage($gsFormError, $this->updated_on->FldErrMsg());
		}
		if (!$this->added_by->FldIsDetailKey && !is_null($this->added_by->FormValue) && $this->added_by->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->added_by->FldCaption(), $this->added_by->ReqErrMsg));
		}
		if (!$this->added_on->FldIsDetailKey && !is_null($this->added_on->FormValue) && $this->added_on->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->added_on->FldCaption(), $this->added_on->ReqErrMsg));
		}
		if (!ew_CheckDateDef($this->added_on->FormValue)) {
			ew_AddMessage($gsFormError, $this->added_on->FldErrMsg());
		}

		// Return validate result
		$ValidateForm = ($gsFormError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateForm = $ValidateForm && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsFormError, $sFormCustomError);
		}
		return $ValidateForm;
	}

	// Add record
	function AddRow($rsold = NULL) {
		global $Language, $Security;
		$conn = &$this->Connection();

		// Load db values from rsold
		if ($rsold) {
			$this->LoadDbValues($rsold);
		}
		$rsnew = array();

		// dbkey_client
		$this->dbkey_client->SetDbValueDef($rsnew, $this->dbkey_client->CurrentValue, 0, FALSE);

		// dbkey_client_list
		$this->dbkey_client_list->SetDbValueDef($rsnew, $this->dbkey_client_list->CurrentValue, 0, FALSE);

		// dbkey_activity_list
		$this->dbkey_activity_list->SetDbValueDef($rsnew, $this->dbkey_activity_list->CurrentValue, 0, FALSE);

		// dbkey_activity
		$this->dbkey_activity->SetDbValueDef($rsnew, $this->dbkey_activity->CurrentValue, 0, FALSE);

		// updated_by
		$this->updated_by->SetDbValueDef($rsnew, $this->updated_by->CurrentValue, 0, FALSE);

		// updated_on
		$this->updated_on->SetDbValueDef($rsnew, ew_UnFormatDateTime($this->updated_on->CurrentValue, 0), ew_CurrentDate(), FALSE);

		// added_by
		$this->added_by->SetDbValueDef($rsnew, $this->added_by->CurrentValue, 0, FALSE);

		// added_on
		$this->added_on->SetDbValueDef($rsnew, ew_UnFormatDateTime($this->added_on->CurrentValue, 0), ew_CurrentDate(), FALSE);

		// activity_description
		$this->activity_description->SetDbValueDef($rsnew, $this->activity_description->CurrentValue, NULL, FALSE);

		// Call Row Inserting event
		$rs = ($rsold == NULL) ? NULL : $rsold->fields;
		$bInsertRow = $this->Row_Inserting($rs, $rsnew);
		if ($bInsertRow) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			$AddRow = $this->Insert($rsnew);
			$conn->raiseErrorFn = '';
			if ($AddRow) {

				// Get insert id if necessary
				$this->dbkey->setDbValue($conn->Insert_ID());
				$rsnew['dbkey'] = $this->dbkey->DbValue;
			}
		} else {
			if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

				// Use the message, do nothing
			} elseif ($this->CancelMessage <> "") {
				$this->setFailureMessage($this->CancelMessage);
				$this->CancelMessage = "";
			} else {
				$this->setFailureMessage($Language->Phrase("InsertCancelled"));
			}
			$AddRow = FALSE;
		}
		if ($AddRow) {

			// Call Row Inserted event
			$rs = ($rsold == NULL) ? NULL : $rsold->fields;
			$this->Row_Inserted($rs, $rsnew);
		}
		return $AddRow;
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, $this->AddMasterUrl("client_to_activity_codelist.php"), "", $this->TableVar, TRUE);
		$PageId = "addopt";
		$Breadcrumb->Add("addopt", $PageId, $url);
	}

	// Setup lookup filters of a field
	function SetupLookupFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		case "x_dbkey_client":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT `dbkey` AS `LinkFld`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
			$sWhereWrk = "";
			$this->dbkey_client->LookupFilters = array();
			$lookuptblfilter = "`active` = 1";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey` = {filter_value}', "t0" => "3", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last`";
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		case "x_dbkey_client_list":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT `dbkey` AS `LinkFld`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
			$sWhereWrk = "";
			$this->dbkey_client_list->LookupFilters = array();
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey` = {filter_value}', "t0" => "3", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->dbkey_client_list, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last`";
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		case "x_dbkey_activity_list":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT `dbkey` AS `LinkFld`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `activity`";
			$sWhereWrk = "";
			$this->dbkey_activity_list->LookupFilters = array();
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey` = {filter_value}', "t0" => "3", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->dbkey_activity_list, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		case "x_dbkey_activity":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT `dbkey` AS `LinkFld`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `activity`";
			$sWhereWrk = "";
			$this->dbkey_activity->LookupFilters = array();
			$lookuptblfilter = "`active` = 1";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey` = {filter_value}', "t0" => "3", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->dbkey_activity, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		case "x_updated_by":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT `dbkey` AS `LinkFld`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
			$sWhereWrk = "";
			$this->updated_by->LookupFilters = array();
			if (!$GLOBALS["client_to_activity_code"]->UserIDAllow("addopt")) $sWhereWrk = $GLOBALS["counselor"]->AddUserIDFilter($sWhereWrk);
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey` = {filter_value}', "t0" => "3", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->updated_by, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last`";
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		case "x_added_by":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT `dbkey` AS `LinkFld`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
			$sWhereWrk = "";
			$this->added_by->LookupFilters = array();
			if (!$GLOBALS["client_to_activity_code"]->UserIDAllow("addopt")) $sWhereWrk = $GLOBALS["counselor"]->AddUserIDFilter($sWhereWrk);
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey` = {filter_value}', "t0" => "3", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->added_by, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		}
	}

	// Setup AutoSuggest filters of a field
	function SetupAutoSuggestFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Custom validate event
	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($client_to_activity_code_addopt)) $client_to_activity_code_addopt = new cclient_to_activity_code_addopt();

// Page init
$client_to_activity_code_addopt->Page_Init();

// Page main
$client_to_activity_code_addopt->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$client_to_activity_code_addopt->Page_Render();
?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "addopt";
var CurrentForm = fclient_to_activity_codeaddopt = new ew_Form("fclient_to_activity_codeaddopt", "addopt");

// Validate form
fclient_to_activity_codeaddopt.Validate = function() {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	var $ = jQuery, fobj = this.GetForm(), $fobj = $(fobj);
	if ($fobj.find("#a_confirm").val() == "F")
		return true;
	var elm, felm, uelm, addcnt = 0;
	var $k = $fobj.find("#" + this.FormKeyCountName); // Get key_count
	var rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1;
	var startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
	var gridinsert = $fobj.find("#a_list").val() == "gridinsert";
	for (var i = startcnt; i <= rowcnt; i++) {
		var infix = ($k[0]) ? String(i) : "";
		$fobj.data("rowindex", infix);
			elm = this.GetElements("x" + infix + "_dbkey_client");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_to_activity_code->dbkey_client->FldCaption(), $client_to_activity_code->dbkey_client->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_dbkey_activity");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_to_activity_code->dbkey_activity->FldCaption(), $client_to_activity_code->dbkey_activity->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_updated_by");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_to_activity_code->updated_by->FldCaption(), $client_to_activity_code->updated_by->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_updated_on");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_to_activity_code->updated_on->FldCaption(), $client_to_activity_code->updated_on->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_updated_on");
			if (elm && !ew_CheckDateDef(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($client_to_activity_code->updated_on->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_added_by");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_to_activity_code->added_by->FldCaption(), $client_to_activity_code->added_by->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_added_on");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client_to_activity_code->added_on->FldCaption(), $client_to_activity_code->added_on->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_added_on");
			if (elm && !ew_CheckDateDef(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($client_to_activity_code->added_on->FldErrMsg()) ?>");

			// Fire Form_CustomValidate event
			if (!this.Form_CustomValidate(fobj))
				return false;
	}
	return true;
}

// Form_CustomValidate event
fclient_to_activity_codeaddopt.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fclient_to_activity_codeaddopt.ValidateRequired = true;
<?php } else { ?>
fclient_to_activity_codeaddopt.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fclient_to_activity_codeaddopt.Lists["x_dbkey_client"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_last","x_first","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"client"};
fclient_to_activity_codeaddopt.Lists["x_dbkey_client_list"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_last","x_first","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"client"};
fclient_to_activity_codeaddopt.Lists["x_dbkey_activity_list"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"activity"};
fclient_to_activity_codeaddopt.Lists["x_dbkey_activity"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"activity"};
fclient_to_activity_codeaddopt.Lists["x_updated_by"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"counselor"};
fclient_to_activity_codeaddopt.Lists["x_added_by"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"counselor"};

// Form object for search
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php
$client_to_activity_code_addopt->ShowMessage();
?>
<form name="fclient_to_activity_codeaddopt" id="fclient_to_activity_codeaddopt" class="ewForm form-horizontal" action="client_to_activity_codeaddopt.php" method="post">
<?php if ($client_to_activity_code_addopt->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $client_to_activity_code_addopt->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="client_to_activity_code">
<input type="hidden" name="a_addopt" id="a_addopt" value="A">
<?php if ($client_to_activity_code->dbkey_client->Visible) { // dbkey_client ?>
	<div class="form-group">
		<label class="col-sm-3 control-label ewLabel" for="x_dbkey_client"><?php echo $client_to_activity_code->dbkey_client->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-9">
<select data-table="client_to_activity_code" data-field="x_dbkey_client" data-value-separator="<?php echo $client_to_activity_code->dbkey_client->DisplayValueSeparatorAttribute() ?>" id="x_dbkey_client" name="x_dbkey_client"<?php echo $client_to_activity_code->dbkey_client->EditAttributes() ?>>
<?php echo $client_to_activity_code->dbkey_client->SelectOptionListHtml("x_dbkey_client") ?>
</select>
<input type="hidden" name="s_x_dbkey_client" id="s_x_dbkey_client" value="<?php echo $client_to_activity_code->dbkey_client->LookupFilterQuery() ?>">
</div>
	</div>
<?php } ?>	
<?php if ($client_to_activity_code->dbkey_client_list->Visible) { // dbkey_client_list ?>
	<div class="form-group">
		<label class="col-sm-3 control-label ewLabel" for="x_dbkey_client_list"><?php echo $client_to_activity_code->dbkey_client_list->FldCaption() ?></label>
		<div class="col-sm-9">
<select data-table="client_to_activity_code" data-field="x_dbkey_client_list" data-value-separator="<?php echo $client_to_activity_code->dbkey_client_list->DisplayValueSeparatorAttribute() ?>" id="x_dbkey_client_list" name="x_dbkey_client_list"<?php echo $client_to_activity_code->dbkey_client_list->EditAttributes() ?>>
<?php echo $client_to_activity_code->dbkey_client_list->SelectOptionListHtml("x_dbkey_client_list") ?>
</select>
<input type="hidden" name="s_x_dbkey_client_list" id="s_x_dbkey_client_list" value="<?php echo $client_to_activity_code->dbkey_client_list->LookupFilterQuery() ?>">
</div>
	</div>
<?php } ?>	
<?php if ($client_to_activity_code->dbkey_activity_list->Visible) { // dbkey_activity_list ?>
	<div class="form-group">
		<label class="col-sm-3 control-label ewLabel" for="x_dbkey_activity_list"><?php echo $client_to_activity_code->dbkey_activity_list->FldCaption() ?></label>
		<div class="col-sm-9">
<select data-table="client_to_activity_code" data-field="x_dbkey_activity_list" data-value-separator="<?php echo $client_to_activity_code->dbkey_activity_list->DisplayValueSeparatorAttribute() ?>" id="x_dbkey_activity_list" name="x_dbkey_activity_list"<?php echo $client_to_activity_code->dbkey_activity_list->EditAttributes() ?>>
<?php echo $client_to_activity_code->dbkey_activity_list->SelectOptionListHtml("x_dbkey_activity_list") ?>
</select>
<input type="hidden" name="s_x_dbkey_activity_list" id="s_x_dbkey_activity_list" value="<?php echo $client_to_activity_code->dbkey_activity_list->LookupFilterQuery() ?>">
</div>
	</div>
<?php } ?>	
<?php if ($client_to_activity_code->dbkey_activity->Visible) { // dbkey_activity ?>
	<div class="form-group">
		<label class="col-sm-3 control-label ewLabel" for="x_dbkey_activity"><?php echo $client_to_activity_code->dbkey_activity->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-9">
<select data-table="client_to_activity_code" data-field="x_dbkey_activity" data-value-separator="<?php echo $client_to_activity_code->dbkey_activity->DisplayValueSeparatorAttribute() ?>" id="x_dbkey_activity" name="x_dbkey_activity"<?php echo $client_to_activity_code->dbkey_activity->EditAttributes() ?>>
<?php echo $client_to_activity_code->dbkey_activity->SelectOptionListHtml("x_dbkey_activity") ?>
</select>
<input type="hidden" name="s_x_dbkey_activity" id="s_x_dbkey_activity" value="<?php echo $client_to_activity_code->dbkey_activity->LookupFilterQuery() ?>">
</div>
	</div>
<?php } ?>	
<?php if ($client_to_activity_code->updated_by->Visible) { // updated_by ?>
	<div class="form-group">
		<label class="col-sm-3 control-label ewLabel" for="x_updated_by"><?php echo $client_to_activity_code->updated_by->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-9">
<select data-table="client_to_activity_code" data-field="x_updated_by" data-value-separator="<?php echo $client_to_activity_code->updated_by->DisplayValueSeparatorAttribute() ?>" id="x_updated_by" name="x_updated_by"<?php echo $client_to_activity_code->updated_by->EditAttributes() ?>>
<?php echo $client_to_activity_code->updated_by->SelectOptionListHtml("x_updated_by") ?>
</select>
<input type="hidden" name="s_x_updated_by" id="s_x_updated_by" value="<?php echo $client_to_activity_code->updated_by->LookupFilterQuery() ?>">
</div>
	</div>
<?php } ?>	
<?php if ($client_to_activity_code->updated_on->Visible) { // updated_on ?>
	<div class="form-group">
		<label class="col-sm-3 control-label ewLabel" for="x_updated_on"><?php echo $client_to_activity_code->updated_on->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-9">
<input type="text" data-table="client_to_activity_code" data-field="x_updated_on" name="x_updated_on" id="x_updated_on" placeholder="<?php echo ew_HtmlEncode($client_to_activity_code->updated_on->getPlaceHolder()) ?>" value="<?php echo $client_to_activity_code->updated_on->EditValue ?>"<?php echo $client_to_activity_code->updated_on->EditAttributes() ?>>
</div>
	</div>
<?php } ?>	
<?php if ($client_to_activity_code->added_by->Visible) { // added_by ?>
	<div class="form-group">
		<label class="col-sm-3 control-label ewLabel" for="x_added_by"><?php echo $client_to_activity_code->added_by->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-9">
<select data-table="client_to_activity_code" data-field="x_added_by" data-value-separator="<?php echo $client_to_activity_code->added_by->DisplayValueSeparatorAttribute() ?>" id="x_added_by" name="x_added_by"<?php echo $client_to_activity_code->added_by->EditAttributes() ?>>
<?php echo $client_to_activity_code->added_by->SelectOptionListHtml("x_added_by") ?>
</select>
<input type="hidden" name="s_x_added_by" id="s_x_added_by" value="<?php echo $client_to_activity_code->added_by->LookupFilterQuery() ?>">
</div>
	</div>
<?php } ?>	
<?php if ($client_to_activity_code->added_on->Visible) { // added_on ?>
	<div class="form-group">
		<label class="col-sm-3 control-label ewLabel" for="x_added_on"><?php echo $client_to_activity_code->added_on->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></label>
		<div class="col-sm-9">
<input type="text" data-table="client_to_activity_code" data-field="x_added_on" name="x_added_on" id="x_added_on" placeholder="<?php echo ew_HtmlEncode($client_to_activity_code->added_on->getPlaceHolder()) ?>" value="<?php echo $client_to_activity_code->added_on->EditValue ?>"<?php echo $client_to_activity_code->added_on->EditAttributes() ?>>
</div>
	</div>
<?php } ?>	
<?php if ($client_to_activity_code->activity_description->Visible) { // activity_description ?>
	<div class="form-group">
		<label class="col-sm-3 control-label ewLabel" for="x_activity_description"><?php echo $client_to_activity_code->activity_description->FldCaption() ?></label>
		<div class="col-sm-9">
<input type="text" data-table="client_to_activity_code" data-field="x_activity_description" name="x_activity_description" id="x_activity_description" size="30" maxlength="50" placeholder="<?php echo ew_HtmlEncode($client_to_activity_code->activity_description->getPlaceHolder()) ?>" value="<?php echo $client_to_activity_code->activity_description->EditValue ?>"<?php echo $client_to_activity_code->activity_description->EditAttributes() ?>>
</div>
	</div>
<?php } ?>	
</form>
<script type="text/javascript">
fclient_to_activity_codeaddopt.Init();
</script>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php
$client_to_activity_code_addopt->Page_Terminate();
?>
