<?php include_once "counselorinfo.php" ?>
<?php

// Create page object
if (!isset($client_grid)) $client_grid = new cclient_grid();

// Page init
$client_grid->Page_Init();

// Page main
$client_grid->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$client_grid->Page_Render();
?>
<?php if ($client->Export == "") { ?>
<script type="text/javascript">

// Form object
var fclientgrid = new ew_Form("fclientgrid", "grid");
fclientgrid.FormKeyCountName = '<?php echo $client_grid->FormKeyCountName ?>';

// Validate form
fclientgrid.Validate = function() {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	var $ = jQuery, fobj = this.GetForm(), $fobj = $(fobj);
	if ($fobj.find("#a_confirm").val() == "F")
		return true;
	var elm, felm, uelm, addcnt = 0;
	var $k = $fobj.find("#" + this.FormKeyCountName); // Get key_count
	var rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1;
	var startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
	var gridinsert = $fobj.find("#a_list").val() == "gridinsert";
	for (var i = startcnt; i <= rowcnt; i++) {
		var infix = ($k[0]) ? String(i) : "";
		$fobj.data("rowindex", infix);
		var checkrow = (gridinsert) ? !this.EmptyRow(infix) : true;
		if (checkrow) {
			addcnt++;
			elm = this.GetElements("x" + infix + "_dbkey");
			if (elm && !ew_CheckInteger(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($client->dbkey->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_waived");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client->waived->FldCaption(), $client->waived->ReqErrMsg)) ?>");
			elm = this.GetElements("x" + infix + "_active");
			if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
				return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $client->active->FldCaption(), $client->active->ReqErrMsg)) ?>");

			// Fire Form_CustomValidate event
			if (!this.Form_CustomValidate(fobj))
				return false;
		} // End Grid Add checking
	}
	return true;
}

// Check empty row
fclientgrid.EmptyRow = function(infix) {
	var fobj = this.Form;
	if (ew_ValueChanged(fobj, infix, "waived", false)) return false;
	if (ew_ValueChanged(fobj, infix, "active", false)) return false;
	if (ew_ValueChanged(fobj, infix, "service_month", false)) return false;
	return true;
}

// Form_CustomValidate event
fclientgrid.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fclientgrid.ValidateRequired = true;
<?php } else { ?>
fclientgrid.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
fclientgrid.Lists["x_dbkey"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_last","x_first","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"client"};
fclientgrid.Lists["x_waived"] = {"LinkField":"x_code","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"waivered"};
fclientgrid.Lists["x_active"] = {"LinkField":"","Ajax":null,"AutoFill":false,"DisplayFields":["","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
fclientgrid.Lists["x_active"].Options = <?php echo json_encode($client->active->Options()) ?>;
fclientgrid.Lists["x_service_month"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"Cust_Month"};

// Form object for search
</script>
<?php } ?>
<?php
if ($client->CurrentAction == "gridadd") {
	if ($client->CurrentMode == "copy") {
		$bSelectLimit = $client_grid->UseSelectLimit;
		if ($bSelectLimit) {
			$client_grid->TotalRecs = $client->SelectRecordCount();
			$client_grid->Recordset = $client_grid->LoadRecordset($client_grid->StartRec-1, $client_grid->DisplayRecs);
		} else {
			if ($client_grid->Recordset = $client_grid->LoadRecordset())
				$client_grid->TotalRecs = $client_grid->Recordset->RecordCount();
		}
		$client_grid->StartRec = 1;
		$client_grid->DisplayRecs = $client_grid->TotalRecs;
	} else {
		$client->CurrentFilter = "0=1";
		$client_grid->StartRec = 1;
		$client_grid->DisplayRecs = $client->GridAddRowCount;
	}
	$client_grid->TotalRecs = $client_grid->DisplayRecs;
	$client_grid->StopRec = $client_grid->DisplayRecs;
} else {
	$bSelectLimit = $client_grid->UseSelectLimit;
	if ($bSelectLimit) {
		if ($client_grid->TotalRecs <= 0)
			$client_grid->TotalRecs = $client->SelectRecordCount();
	} else {
		if (!$client_grid->Recordset && ($client_grid->Recordset = $client_grid->LoadRecordset()))
			$client_grid->TotalRecs = $client_grid->Recordset->RecordCount();
	}
	$client_grid->StartRec = 1;
	$client_grid->DisplayRecs = $client_grid->TotalRecs; // Display all records
	if ($bSelectLimit)
		$client_grid->Recordset = $client_grid->LoadRecordset($client_grid->StartRec-1, $client_grid->DisplayRecs);

	// Set no record found message
	if ($client->CurrentAction == "" && $client_grid->TotalRecs == 0) {
		if (!$Security->CanList())
			$client_grid->setWarningMessage(ew_DeniedMsg());
		if ($client_grid->SearchWhere == "0=101")
			$client_grid->setWarningMessage($Language->Phrase("EnterSearchCriteria"));
		else
			$client_grid->setWarningMessage($Language->Phrase("NoRecord"));
	}
}
$client_grid->RenderOtherOptions();
?>
<?php $client_grid->ShowPageHeader(); ?>
<?php
$client_grid->ShowMessage();
?>
<?php if ($client_grid->TotalRecs > 0 || $client->CurrentAction <> "") { ?>
<div class="panel panel-default ewGrid client">
<div id="fclientgrid" class="ewForm form-inline">
<?php if ($client_grid->ShowOtherOptions) { ?>
<div class="panel-heading ewGridUpperPanel">
<?php
	foreach ($client_grid->OtherOptions as &$option)
		$option->Render("body");
?>
</div>
<div class="clearfix"></div>
<?php } ?>
<div id="gmp_client" class="<?php if (ew_IsResponsiveLayout()) { echo "table-responsive "; } ?>ewGridMiddlePanel">
<table id="tbl_clientgrid" class="table ewTable">
<?php echo $client->TableCustomInnerHtml ?>
<thead><!-- Table header -->
	<tr class="ewTableHeader">
<?php

// Header row
$client_grid->RowType = EW_ROWTYPE_HEADER;

// Render list options
$client_grid->RenderListOptions();

// Render list options (header, left)
$client_grid->ListOptions->Render("header", "left");
?>
<?php if ($client->dbkey->Visible) { // dbkey ?>
	<?php if ($client->SortUrl($client->dbkey) == "") { ?>
		<th data-name="dbkey"><div id="elh_client_dbkey" class="client_dbkey"><div class="ewTableHeaderCaption"><?php echo $client->dbkey->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="dbkey"><div><div id="elh_client_dbkey" class="client_dbkey">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $client->dbkey->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client->dbkey->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client->dbkey->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client->waived->Visible) { // waived ?>
	<?php if ($client->SortUrl($client->waived) == "") { ?>
		<th data-name="waived"><div id="elh_client_waived" class="client_waived"><div class="ewTableHeaderCaption"><?php echo $client->waived->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="waived"><div><div id="elh_client_waived" class="client_waived">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $client->waived->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client->waived->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client->waived->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client->active->Visible) { // active ?>
	<?php if ($client->SortUrl($client->active) == "") { ?>
		<th data-name="active"><div id="elh_client_active" class="client_active"><div class="ewTableHeaderCaption"><?php echo $client->active->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="active"><div><div id="elh_client_active" class="client_active">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $client->active->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client->active->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client->active->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($client->service_month->Visible) { // service_month ?>
	<?php if ($client->SortUrl($client->service_month) == "") { ?>
		<th data-name="service_month"><div id="elh_client_service_month" class="client_service_month"><div class="ewTableHeaderCaption"><?php echo $client->service_month->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="service_month"><div><div id="elh_client_service_month" class="client_service_month">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $client->service_month->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($client->service_month->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($client->service_month->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php

// Render list options (header, right)
$client_grid->ListOptions->Render("header", "right");
?>
	</tr>
</thead>
<tbody>
<?php
$client_grid->StartRec = 1;
$client_grid->StopRec = $client_grid->TotalRecs; // Show all records

// Restore number of post back records
if ($objForm) {
	$objForm->Index = -1;
	if ($objForm->HasValue($client_grid->FormKeyCountName) && ($client->CurrentAction == "gridadd" || $client->CurrentAction == "gridedit" || $client->CurrentAction == "F")) {
		$client_grid->KeyCount = $objForm->GetValue($client_grid->FormKeyCountName);
		$client_grid->StopRec = $client_grid->StartRec + $client_grid->KeyCount - 1;
	}
}
$client_grid->RecCnt = $client_grid->StartRec - 1;
if ($client_grid->Recordset && !$client_grid->Recordset->EOF) {
	$client_grid->Recordset->MoveFirst();
	$bSelectLimit = $client_grid->UseSelectLimit;
	if (!$bSelectLimit && $client_grid->StartRec > 1)
		$client_grid->Recordset->Move($client_grid->StartRec - 1);
} elseif (!$client->AllowAddDeleteRow && $client_grid->StopRec == 0) {
	$client_grid->StopRec = $client->GridAddRowCount;
}

// Initialize aggregate
$client->RowType = EW_ROWTYPE_AGGREGATEINIT;
$client->ResetAttrs();
$client_grid->RenderRow();
if ($client->CurrentAction == "gridadd")
	$client_grid->RowIndex = 0;
if ($client->CurrentAction == "gridedit")
	$client_grid->RowIndex = 0;
while ($client_grid->RecCnt < $client_grid->StopRec) {
	$client_grid->RecCnt++;
	if (intval($client_grid->RecCnt) >= intval($client_grid->StartRec)) {
		$client_grid->RowCnt++;
		if ($client->CurrentAction == "gridadd" || $client->CurrentAction == "gridedit" || $client->CurrentAction == "F") {
			$client_grid->RowIndex++;
			$objForm->Index = $client_grid->RowIndex;
			if ($objForm->HasValue($client_grid->FormActionName))
				$client_grid->RowAction = strval($objForm->GetValue($client_grid->FormActionName));
			elseif ($client->CurrentAction == "gridadd")
				$client_grid->RowAction = "insert";
			else
				$client_grid->RowAction = "";
		}

		// Set up key count
		$client_grid->KeyCount = $client_grid->RowIndex;

		// Init row class and style
		$client->ResetAttrs();
		$client->CssClass = "";
		if ($client->CurrentAction == "gridadd") {
			if ($client->CurrentMode == "copy") {
				$client_grid->LoadRowValues($client_grid->Recordset); // Load row values
				$client_grid->SetRecordKey($client_grid->RowOldKey, $client_grid->Recordset); // Set old record key
			} else {
				$client_grid->LoadDefaultValues(); // Load default values
				$client_grid->RowOldKey = ""; // Clear old key value
			}
		} else {
			$client_grid->LoadRowValues($client_grid->Recordset); // Load row values
		}
		$client->RowType = EW_ROWTYPE_VIEW; // Render view
		if ($client->CurrentAction == "gridadd") // Grid add
			$client->RowType = EW_ROWTYPE_ADD; // Render add
		if ($client->CurrentAction == "gridadd" && $client->EventCancelled && !$objForm->HasValue("k_blankrow")) // Insert failed
			$client_grid->RestoreCurrentRowFormValues($client_grid->RowIndex); // Restore form values
		if ($client->CurrentAction == "gridedit") { // Grid edit
			if ($client->EventCancelled) {
				$client_grid->RestoreCurrentRowFormValues($client_grid->RowIndex); // Restore form values
			}
			if ($client_grid->RowAction == "insert")
				$client->RowType = EW_ROWTYPE_ADD; // Render add
			else
				$client->RowType = EW_ROWTYPE_EDIT; // Render edit
			if (!$client->EventCancelled)
				$client_grid->HashValue = $client_grid->GetRowHash($client_grid->Recordset); // Get hash value for record
		}
		if ($client->CurrentAction == "gridedit" && ($client->RowType == EW_ROWTYPE_EDIT || $client->RowType == EW_ROWTYPE_ADD) && $client->EventCancelled) // Update failed
			$client_grid->RestoreCurrentRowFormValues($client_grid->RowIndex); // Restore form values
		if ($client->RowType == EW_ROWTYPE_EDIT) // Edit row
			$client_grid->EditRowCnt++;
		if ($client->CurrentAction == "F") // Confirm row
			$client_grid->RestoreCurrentRowFormValues($client_grid->RowIndex); // Restore form values

		// Set up row id / data-rowindex
		$client->RowAttrs = array_merge($client->RowAttrs, array('data-rowindex'=>$client_grid->RowCnt, 'id'=>'r' . $client_grid->RowCnt . '_client', 'data-rowtype'=>$client->RowType));

		// Render row
		$client_grid->RenderRow();

		// Render list options
		$client_grid->RenderListOptions();

		// Skip delete row / empty row for confirm page
		if ($client_grid->RowAction <> "delete" && $client_grid->RowAction <> "insertdelete" && !($client_grid->RowAction == "insert" && $client->CurrentAction == "F" && $client_grid->EmptyRow())) {
?>
	<tr<?php echo $client->RowAttributes() ?>>
<?php

// Render list options (body, left)
$client_grid->ListOptions->Render("body", "left", $client_grid->RowCnt);
?>
	<?php if ($client->dbkey->Visible) { // dbkey ?>
		<td data-name="dbkey"<?php echo $client->dbkey->CellAttributes() ?>>
<?php if ($client->RowType == EW_ROWTYPE_ADD) { // Add record ?>
<input type="hidden" data-table="client" data-field="x_dbkey" name="o<?php echo $client_grid->RowIndex ?>_dbkey" id="o<?php echo $client_grid->RowIndex ?>_dbkey" value="<?php echo ew_HtmlEncode($client->dbkey->OldValue) ?>">
<?php } ?>
<?php if ($client->RowType == EW_ROWTYPE_EDIT) { // Edit record ?>
<span id="el<?php echo $client_grid->RowCnt ?>_client_dbkey" class="form-group client_dbkey">
<span<?php echo $client->dbkey->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client->dbkey->EditValue ?></p></span>
</span>
<input type="hidden" data-table="client" data-field="x_dbkey" name="x<?php echo $client_grid->RowIndex ?>_dbkey" id="x<?php echo $client_grid->RowIndex ?>_dbkey" value="<?php echo ew_HtmlEncode($client->dbkey->CurrentValue) ?>">
<?php } ?>
<?php if ($client->RowType == EW_ROWTYPE_VIEW) { // View record ?>
<span id="el<?php echo $client_grid->RowCnt ?>_client_dbkey" class="client_dbkey">
<span<?php echo $client->dbkey->ViewAttributes() ?>>
<?php echo $client->dbkey->ListViewValue() ?></span>
</span>
<?php if ($client->CurrentAction <> "F") { ?>
<input type="hidden" data-table="client" data-field="x_dbkey" name="x<?php echo $client_grid->RowIndex ?>_dbkey" id="x<?php echo $client_grid->RowIndex ?>_dbkey" value="<?php echo ew_HtmlEncode($client->dbkey->FormValue) ?>">
<input type="hidden" data-table="client" data-field="x_dbkey" name="o<?php echo $client_grid->RowIndex ?>_dbkey" id="o<?php echo $client_grid->RowIndex ?>_dbkey" value="<?php echo ew_HtmlEncode($client->dbkey->OldValue) ?>">
<?php } else { ?>
<input type="hidden" data-table="client" data-field="x_dbkey" name="fclientgrid$x<?php echo $client_grid->RowIndex ?>_dbkey" id="fclientgrid$x<?php echo $client_grid->RowIndex ?>_dbkey" value="<?php echo ew_HtmlEncode($client->dbkey->FormValue) ?>">
<input type="hidden" data-table="client" data-field="x_dbkey" name="fclientgrid$o<?php echo $client_grid->RowIndex ?>_dbkey" id="fclientgrid$o<?php echo $client_grid->RowIndex ?>_dbkey" value="<?php echo ew_HtmlEncode($client->dbkey->OldValue) ?>">
<?php } ?>
<?php } ?>
<a id="<?php echo $client_grid->PageObjName . "_row_" . $client_grid->RowCnt ?>"></a></td>
	<?php } ?>
	<?php if ($client->waived->Visible) { // waived ?>
		<td data-name="waived"<?php echo $client->waived->CellAttributes() ?>>
<?php if ($client->RowType == EW_ROWTYPE_ADD) { // Add record ?>
<span id="el<?php echo $client_grid->RowCnt ?>_client_waived" class="form-group client_waived">
<select data-table="client" data-field="x_waived" data-value-separator="<?php echo $client->waived->DisplayValueSeparatorAttribute() ?>" id="x<?php echo $client_grid->RowIndex ?>_waived" name="x<?php echo $client_grid->RowIndex ?>_waived"<?php echo $client->waived->EditAttributes() ?>>
<?php echo $client->waived->SelectOptionListHtml("x<?php echo $client_grid->RowIndex ?>_waived") ?>
</select>
<input type="hidden" name="s_x<?php echo $client_grid->RowIndex ?>_waived" id="s_x<?php echo $client_grid->RowIndex ?>_waived" value="<?php echo $client->waived->LookupFilterQuery() ?>">
</span>
<input type="hidden" data-table="client" data-field="x_waived" name="o<?php echo $client_grid->RowIndex ?>_waived" id="o<?php echo $client_grid->RowIndex ?>_waived" value="<?php echo ew_HtmlEncode($client->waived->OldValue) ?>">
<?php } ?>
<?php if ($client->RowType == EW_ROWTYPE_EDIT) { // Edit record ?>
<span id="el<?php echo $client_grid->RowCnt ?>_client_waived" class="form-group client_waived">
<select data-table="client" data-field="x_waived" data-value-separator="<?php echo $client->waived->DisplayValueSeparatorAttribute() ?>" id="x<?php echo $client_grid->RowIndex ?>_waived" name="x<?php echo $client_grid->RowIndex ?>_waived"<?php echo $client->waived->EditAttributes() ?>>
<?php echo $client->waived->SelectOptionListHtml("x<?php echo $client_grid->RowIndex ?>_waived") ?>
</select>
<input type="hidden" name="s_x<?php echo $client_grid->RowIndex ?>_waived" id="s_x<?php echo $client_grid->RowIndex ?>_waived" value="<?php echo $client->waived->LookupFilterQuery() ?>">
</span>
<?php } ?>
<?php if ($client->RowType == EW_ROWTYPE_VIEW) { // View record ?>
<span id="el<?php echo $client_grid->RowCnt ?>_client_waived" class="client_waived">
<span<?php echo $client->waived->ViewAttributes() ?>>
<?php echo $client->waived->ListViewValue() ?></span>
</span>
<?php if ($client->CurrentAction <> "F") { ?>
<input type="hidden" data-table="client" data-field="x_waived" name="x<?php echo $client_grid->RowIndex ?>_waived" id="x<?php echo $client_grid->RowIndex ?>_waived" value="<?php echo ew_HtmlEncode($client->waived->FormValue) ?>">
<input type="hidden" data-table="client" data-field="x_waived" name="o<?php echo $client_grid->RowIndex ?>_waived" id="o<?php echo $client_grid->RowIndex ?>_waived" value="<?php echo ew_HtmlEncode($client->waived->OldValue) ?>">
<?php } else { ?>
<input type="hidden" data-table="client" data-field="x_waived" name="fclientgrid$x<?php echo $client_grid->RowIndex ?>_waived" id="fclientgrid$x<?php echo $client_grid->RowIndex ?>_waived" value="<?php echo ew_HtmlEncode($client->waived->FormValue) ?>">
<input type="hidden" data-table="client" data-field="x_waived" name="fclientgrid$o<?php echo $client_grid->RowIndex ?>_waived" id="fclientgrid$o<?php echo $client_grid->RowIndex ?>_waived" value="<?php echo ew_HtmlEncode($client->waived->OldValue) ?>">
<?php } ?>
<?php } ?>
</td>
	<?php } ?>
	<?php if ($client->active->Visible) { // active ?>
		<td data-name="active"<?php echo $client->active->CellAttributes() ?>>
<?php if ($client->RowType == EW_ROWTYPE_ADD) { // Add record ?>
<span id="el<?php echo $client_grid->RowCnt ?>_client_active" class="form-group client_active">
<select data-table="client" data-field="x_active" data-value-separator="<?php echo $client->active->DisplayValueSeparatorAttribute() ?>" id="x<?php echo $client_grid->RowIndex ?>_active" name="x<?php echo $client_grid->RowIndex ?>_active"<?php echo $client->active->EditAttributes() ?>>
<?php echo $client->active->SelectOptionListHtml("x<?php echo $client_grid->RowIndex ?>_active") ?>
</select>
</span>
<input type="hidden" data-table="client" data-field="x_active" name="o<?php echo $client_grid->RowIndex ?>_active" id="o<?php echo $client_grid->RowIndex ?>_active" value="<?php echo ew_HtmlEncode($client->active->OldValue) ?>">
<?php } ?>
<?php if ($client->RowType == EW_ROWTYPE_EDIT) { // Edit record ?>
<span id="el<?php echo $client_grid->RowCnt ?>_client_active" class="form-group client_active">
<select data-table="client" data-field="x_active" data-value-separator="<?php echo $client->active->DisplayValueSeparatorAttribute() ?>" id="x<?php echo $client_grid->RowIndex ?>_active" name="x<?php echo $client_grid->RowIndex ?>_active"<?php echo $client->active->EditAttributes() ?>>
<?php echo $client->active->SelectOptionListHtml("x<?php echo $client_grid->RowIndex ?>_active") ?>
</select>
</span>
<?php } ?>
<?php if ($client->RowType == EW_ROWTYPE_VIEW) { // View record ?>
<span id="el<?php echo $client_grid->RowCnt ?>_client_active" class="client_active">
<span<?php echo $client->active->ViewAttributes() ?>>
<?php echo $client->active->ListViewValue() ?></span>
</span>
<?php if ($client->CurrentAction <> "F") { ?>
<input type="hidden" data-table="client" data-field="x_active" name="x<?php echo $client_grid->RowIndex ?>_active" id="x<?php echo $client_grid->RowIndex ?>_active" value="<?php echo ew_HtmlEncode($client->active->FormValue) ?>">
<input type="hidden" data-table="client" data-field="x_active" name="o<?php echo $client_grid->RowIndex ?>_active" id="o<?php echo $client_grid->RowIndex ?>_active" value="<?php echo ew_HtmlEncode($client->active->OldValue) ?>">
<?php } else { ?>
<input type="hidden" data-table="client" data-field="x_active" name="fclientgrid$x<?php echo $client_grid->RowIndex ?>_active" id="fclientgrid$x<?php echo $client_grid->RowIndex ?>_active" value="<?php echo ew_HtmlEncode($client->active->FormValue) ?>">
<input type="hidden" data-table="client" data-field="x_active" name="fclientgrid$o<?php echo $client_grid->RowIndex ?>_active" id="fclientgrid$o<?php echo $client_grid->RowIndex ?>_active" value="<?php echo ew_HtmlEncode($client->active->OldValue) ?>">
<?php } ?>
<?php } ?>
</td>
	<?php } ?>
	<?php if ($client->service_month->Visible) { // service_month ?>
		<td data-name="service_month"<?php echo $client->service_month->CellAttributes() ?>>
<?php if ($client->RowType == EW_ROWTYPE_ADD) { // Add record ?>
<span id="el<?php echo $client_grid->RowCnt ?>_client_service_month" class="form-group client_service_month">
<select data-table="client" data-field="x_service_month" data-value-separator="<?php echo $client->service_month->DisplayValueSeparatorAttribute() ?>" id="x<?php echo $client_grid->RowIndex ?>_service_month" name="x<?php echo $client_grid->RowIndex ?>_service_month"<?php echo $client->service_month->EditAttributes() ?>>
<?php echo $client->service_month->SelectOptionListHtml("x<?php echo $client_grid->RowIndex ?>_service_month") ?>
</select>
<input type="hidden" name="s_x<?php echo $client_grid->RowIndex ?>_service_month" id="s_x<?php echo $client_grid->RowIndex ?>_service_month" value="<?php echo $client->service_month->LookupFilterQuery() ?>">
</span>
<input type="hidden" data-table="client" data-field="x_service_month" name="o<?php echo $client_grid->RowIndex ?>_service_month" id="o<?php echo $client_grid->RowIndex ?>_service_month" value="<?php echo ew_HtmlEncode($client->service_month->OldValue) ?>">
<?php } ?>
<?php if ($client->RowType == EW_ROWTYPE_EDIT) { // Edit record ?>
<span id="el<?php echo $client_grid->RowCnt ?>_client_service_month" class="form-group client_service_month">
<select data-table="client" data-field="x_service_month" data-value-separator="<?php echo $client->service_month->DisplayValueSeparatorAttribute() ?>" id="x<?php echo $client_grid->RowIndex ?>_service_month" name="x<?php echo $client_grid->RowIndex ?>_service_month"<?php echo $client->service_month->EditAttributes() ?>>
<?php echo $client->service_month->SelectOptionListHtml("x<?php echo $client_grid->RowIndex ?>_service_month") ?>
</select>
<input type="hidden" name="s_x<?php echo $client_grid->RowIndex ?>_service_month" id="s_x<?php echo $client_grid->RowIndex ?>_service_month" value="<?php echo $client->service_month->LookupFilterQuery() ?>">
</span>
<?php } ?>
<?php if ($client->RowType == EW_ROWTYPE_VIEW) { // View record ?>
<span id="el<?php echo $client_grid->RowCnt ?>_client_service_month" class="client_service_month">
<span<?php echo $client->service_month->ViewAttributes() ?>>
<?php echo $client->service_month->ListViewValue() ?></span>
</span>
<?php if ($client->CurrentAction <> "F") { ?>
<input type="hidden" data-table="client" data-field="x_service_month" name="x<?php echo $client_grid->RowIndex ?>_service_month" id="x<?php echo $client_grid->RowIndex ?>_service_month" value="<?php echo ew_HtmlEncode($client->service_month->FormValue) ?>">
<input type="hidden" data-table="client" data-field="x_service_month" name="o<?php echo $client_grid->RowIndex ?>_service_month" id="o<?php echo $client_grid->RowIndex ?>_service_month" value="<?php echo ew_HtmlEncode($client->service_month->OldValue) ?>">
<?php } else { ?>
<input type="hidden" data-table="client" data-field="x_service_month" name="fclientgrid$x<?php echo $client_grid->RowIndex ?>_service_month" id="fclientgrid$x<?php echo $client_grid->RowIndex ?>_service_month" value="<?php echo ew_HtmlEncode($client->service_month->FormValue) ?>">
<input type="hidden" data-table="client" data-field="x_service_month" name="fclientgrid$o<?php echo $client_grid->RowIndex ?>_service_month" id="fclientgrid$o<?php echo $client_grid->RowIndex ?>_service_month" value="<?php echo ew_HtmlEncode($client->service_month->OldValue) ?>">
<?php } ?>
<?php } ?>
</td>
	<?php } ?>
<?php

// Render list options (body, right)
$client_grid->ListOptions->Render("body", "right", $client_grid->RowCnt);
?>
	</tr>
<?php if ($client->RowType == EW_ROWTYPE_ADD || $client->RowType == EW_ROWTYPE_EDIT) { ?>
<script type="text/javascript">
fclientgrid.UpdateOpts(<?php echo $client_grid->RowIndex ?>);
</script>
<?php } ?>
<?php
	}
	} // End delete row checking
	if ($client->CurrentAction <> "gridadd" || $client->CurrentMode == "copy")
		if (!$client_grid->Recordset->EOF) $client_grid->Recordset->MoveNext();
}
?>
<?php
	if ($client->CurrentMode == "add" || $client->CurrentMode == "copy" || $client->CurrentMode == "edit") {
		$client_grid->RowIndex = '$rowindex$';
		$client_grid->LoadDefaultValues();

		// Set row properties
		$client->ResetAttrs();
		$client->RowAttrs = array_merge($client->RowAttrs, array('data-rowindex'=>$client_grid->RowIndex, 'id'=>'r0_client', 'data-rowtype'=>EW_ROWTYPE_ADD));
		ew_AppendClass($client->RowAttrs["class"], "ewTemplate");
		$client->RowType = EW_ROWTYPE_ADD;

		// Render row
		$client_grid->RenderRow();

		// Render list options
		$client_grid->RenderListOptions();
		$client_grid->StartRowCnt = 0;
?>
	<tr<?php echo $client->RowAttributes() ?>>
<?php

// Render list options (body, left)
$client_grid->ListOptions->Render("body", "left", $client_grid->RowIndex);
?>
	<?php if ($client->dbkey->Visible) { // dbkey ?>
		<td data-name="dbkey">
<?php if ($client->CurrentAction <> "F") { ?>
<?php } else { ?>
<span id="el$rowindex$_client_dbkey" class="form-group client_dbkey">
<span<?php echo $client->dbkey->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client->dbkey->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client" data-field="x_dbkey" name="x<?php echo $client_grid->RowIndex ?>_dbkey" id="x<?php echo $client_grid->RowIndex ?>_dbkey" value="<?php echo ew_HtmlEncode($client->dbkey->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="client" data-field="x_dbkey" name="o<?php echo $client_grid->RowIndex ?>_dbkey" id="o<?php echo $client_grid->RowIndex ?>_dbkey" value="<?php echo ew_HtmlEncode($client->dbkey->OldValue) ?>">
</td>
	<?php } ?>
	<?php if ($client->waived->Visible) { // waived ?>
		<td data-name="waived">
<?php if ($client->CurrentAction <> "F") { ?>
<span id="el$rowindex$_client_waived" class="form-group client_waived">
<select data-table="client" data-field="x_waived" data-value-separator="<?php echo $client->waived->DisplayValueSeparatorAttribute() ?>" id="x<?php echo $client_grid->RowIndex ?>_waived" name="x<?php echo $client_grid->RowIndex ?>_waived"<?php echo $client->waived->EditAttributes() ?>>
<?php echo $client->waived->SelectOptionListHtml("x<?php echo $client_grid->RowIndex ?>_waived") ?>
</select>
<input type="hidden" name="s_x<?php echo $client_grid->RowIndex ?>_waived" id="s_x<?php echo $client_grid->RowIndex ?>_waived" value="<?php echo $client->waived->LookupFilterQuery() ?>">
</span>
<?php } else { ?>
<span id="el$rowindex$_client_waived" class="form-group client_waived">
<span<?php echo $client->waived->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client->waived->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client" data-field="x_waived" name="x<?php echo $client_grid->RowIndex ?>_waived" id="x<?php echo $client_grid->RowIndex ?>_waived" value="<?php echo ew_HtmlEncode($client->waived->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="client" data-field="x_waived" name="o<?php echo $client_grid->RowIndex ?>_waived" id="o<?php echo $client_grid->RowIndex ?>_waived" value="<?php echo ew_HtmlEncode($client->waived->OldValue) ?>">
</td>
	<?php } ?>
	<?php if ($client->active->Visible) { // active ?>
		<td data-name="active">
<?php if ($client->CurrentAction <> "F") { ?>
<span id="el$rowindex$_client_active" class="form-group client_active">
<select data-table="client" data-field="x_active" data-value-separator="<?php echo $client->active->DisplayValueSeparatorAttribute() ?>" id="x<?php echo $client_grid->RowIndex ?>_active" name="x<?php echo $client_grid->RowIndex ?>_active"<?php echo $client->active->EditAttributes() ?>>
<?php echo $client->active->SelectOptionListHtml("x<?php echo $client_grid->RowIndex ?>_active") ?>
</select>
</span>
<?php } else { ?>
<span id="el$rowindex$_client_active" class="form-group client_active">
<span<?php echo $client->active->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client->active->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client" data-field="x_active" name="x<?php echo $client_grid->RowIndex ?>_active" id="x<?php echo $client_grid->RowIndex ?>_active" value="<?php echo ew_HtmlEncode($client->active->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="client" data-field="x_active" name="o<?php echo $client_grid->RowIndex ?>_active" id="o<?php echo $client_grid->RowIndex ?>_active" value="<?php echo ew_HtmlEncode($client->active->OldValue) ?>">
</td>
	<?php } ?>
	<?php if ($client->service_month->Visible) { // service_month ?>
		<td data-name="service_month">
<?php if ($client->CurrentAction <> "F") { ?>
<span id="el$rowindex$_client_service_month" class="form-group client_service_month">
<select data-table="client" data-field="x_service_month" data-value-separator="<?php echo $client->service_month->DisplayValueSeparatorAttribute() ?>" id="x<?php echo $client_grid->RowIndex ?>_service_month" name="x<?php echo $client_grid->RowIndex ?>_service_month"<?php echo $client->service_month->EditAttributes() ?>>
<?php echo $client->service_month->SelectOptionListHtml("x<?php echo $client_grid->RowIndex ?>_service_month") ?>
</select>
<input type="hidden" name="s_x<?php echo $client_grid->RowIndex ?>_service_month" id="s_x<?php echo $client_grid->RowIndex ?>_service_month" value="<?php echo $client->service_month->LookupFilterQuery() ?>">
</span>
<?php } else { ?>
<span id="el$rowindex$_client_service_month" class="form-group client_service_month">
<span<?php echo $client->service_month->ViewAttributes() ?>>
<p class="form-control-static"><?php echo $client->service_month->ViewValue ?></p></span>
</span>
<input type="hidden" data-table="client" data-field="x_service_month" name="x<?php echo $client_grid->RowIndex ?>_service_month" id="x<?php echo $client_grid->RowIndex ?>_service_month" value="<?php echo ew_HtmlEncode($client->service_month->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="client" data-field="x_service_month" name="o<?php echo $client_grid->RowIndex ?>_service_month" id="o<?php echo $client_grid->RowIndex ?>_service_month" value="<?php echo ew_HtmlEncode($client->service_month->OldValue) ?>">
</td>
	<?php } ?>
<?php

// Render list options (body, right)
$client_grid->ListOptions->Render("body", "right", $client_grid->RowCnt);
?>
<script type="text/javascript">
fclientgrid.UpdateOpts(<?php echo $client_grid->RowIndex ?>);
</script>
	</tr>
<?php
}
?>
</tbody>
</table>
<?php if ($client->CurrentMode == "add" || $client->CurrentMode == "copy") { ?>
<input type="hidden" name="a_list" id="a_list" value="gridinsert">
<input type="hidden" name="<?php echo $client_grid->FormKeyCountName ?>" id="<?php echo $client_grid->FormKeyCountName ?>" value="<?php echo $client_grid->KeyCount ?>">
<?php echo $client_grid->MultiSelectKey ?>
<?php } ?>
<?php if ($client->CurrentMode == "edit") { ?>
<?php if ($client->UpdateConflict == "U") { // Record already updated by other user ?>
<input type="hidden" name="a_list" id="a_list" value="gridoverwrite">
<?php } else { ?>
<input type="hidden" name="a_list" id="a_list" value="gridupdate">
<?php } ?>
<input type="hidden" name="<?php echo $client_grid->FormKeyCountName ?>" id="<?php echo $client_grid->FormKeyCountName ?>" value="<?php echo $client_grid->KeyCount ?>">
<?php echo $client_grid->MultiSelectKey ?>
<?php } ?>
<?php if ($client->CurrentMode == "") { ?>
<input type="hidden" name="a_list" id="a_list" value="">
<?php } ?>
<input type="hidden" name="detailpage" value="fclientgrid">
</div>
<?php

// Close recordset
if ($client_grid->Recordset)
	$client_grid->Recordset->Close();
?>
</div>
</div>
<?php } ?>
<?php if ($client_grid->TotalRecs == 0 && $client->CurrentAction == "") { // Show other options ?>
<div class="ewListOtherOptions">
<?php
	foreach ($client_grid->OtherOptions as &$option) {
		$option->ButtonClass = "";
		$option->Render("body", "");
	}
?>
</div>
<div class="clearfix"></div>
<?php } ?>
<?php if ($client->Export == "") { ?>
<script type="text/javascript">
fclientgrid.Init();
</script>
<?php } ?>
<?php
$client_grid->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<?php
$client_grid->Page_Terminate();
?>
