<?php
if (session_id() == "") session_start(); // Init session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg13.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql13.php") ?>
<?php include_once "phpfn13.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn13.php" ?>
<?php

//
// Page class
//

$default = NULL; // Initialize page object first

class cdefault {

	// Page ID
	var $PageID = 'default';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Page object name
	var $PageObjName = 'default';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		return $PageUrl;
	}

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'default', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect();

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	//
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		global $gbOldSkipHeaderFooter, $gbSkipHeaderFooter;
		$gbOldSkipHeaderFooter = $gbSkipHeaderFooter;
		$gbSkipHeaderFooter = TRUE;

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;
		global $gbOldSkipHeaderFooter, $gbSkipHeaderFooter;
		$gbSkipHeaderFooter = $gbOldSkipHeaderFooter;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
	}

	//
	// Page main
	//
	function Page_Main() {
		global $Security, $Language;

		// If session expired, show session expired message
		if (@$_GET["expired"] == "1")
			$this->setFailureMessage($Language->Phrase("SessionExpired"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		$Security->LoadUserLevel(); // Load User Level
		if ($Security->AllowList(CurrentProjectID() . 'client_activity'))
		$this->Page_Terminate("client_activitylist.php"); // Exit and go to default page
		if ($Security->AllowList(CurrentProjectID() . 'activity'))
			$this->Page_Terminate("activitylist.php");
		if ($Security->AllowList(CurrentProjectID() . 'client'))
			$this->Page_Terminate("clientlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'client_budget'))
			$this->Page_Terminate("client_budgetlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'userlevelpermissions'))
			$this->Page_Terminate("userlevelpermissionslist.php");
		if ($Security->AllowList(CurrentProjectID() . 'userlevels'))
			$this->Page_Terminate("userlevelslist.php");
		if ($Security->AllowList(CurrentProjectID() . 'audittrail'))
			$this->Page_Terminate("audittraillist.php");
		if ($Security->AllowList(CurrentProjectID() . 'waivered'))
			$this->Page_Terminate("waiveredlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'councilor_to_client'))
			$this->Page_Terminate("councilor_to_clientlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'tables'))
			$this->Page_Terminate("tableslist.php");
		if ($Security->AllowList(CurrentProjectID() . 'tables_data'))
			$this->Page_Terminate("tables_datalist.php");
		if ($Security->AllowList(CurrentProjectID() . 'counselor'))
			$this->Page_Terminate("counselorlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'task'))
			$this->Page_Terminate("tasklist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_Client_Counselor_Drop_Down'))
			$this->Page_Terminate("Cust_Client_Counselor_Drop_Downlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_User_Admin'))
			$this->Page_Terminate("Cust_User_Adminlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_Client_Activity_Admins'))
			$this->Page_Terminate("Cust_Client_Activity_Adminslist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_Rpt_Client_Activity_Week'))
			$this->Page_Terminate("Cust_Rpt_Client_Activity_Weeklist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_Rpt_Client_Activity_Monthly'))
			$this->Page_Terminate("Cust_Rpt_Client_Activity_Monthlylist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_Year'))
			$this->Page_Terminate("Cust_Yearlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_Rpt_Client_Budget_Summary'))
			$this->Page_Terminate("Cust_Rpt_Client_Budget_Summarylist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_task_counselor'))
			$this->Page_Terminate("Cust_task_counselorlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_Client_Admin'))
			$this->Page_Terminate("Cust_Client_Adminlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'file_manager'))
			$this->Page_Terminate("file_managerlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_active_counselor'))
			$this->Page_Terminate("Cust_active_counselorlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_active_client'))
			$this->Page_Terminate("Cust_active_clientlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_Active_Counselors'))
			$this->Page_Terminate("Cust_Active_Counselorslist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_Rpt_Login_Logout'))
			$this->Page_Terminate("Cust_Rpt_Login_Logoutlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'case_notes'))
			$this->Page_Terminate("case_noteslist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_case_notes_admin'))
			$this->Page_Terminate("Cust_case_notes_adminlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_first_last_day_of_week'))
			$this->Page_Terminate("Cust_first_last_day_of_weeklist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_time_interval'))
			$this->Page_Terminate("Cust_time_intervallist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_admin_alerts'))
			$this->Page_Terminate("Cust_admin_alertslist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_Month'))
			$this->Page_Terminate("Cust_Monthlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'timecards'))
			$this->Page_Terminate("timecardslist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_timecards_admin'))
			$this->Page_Terminate("Cust_timecards_adminlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'client_outcome'))
			$this->Page_Terminate("client_outcomelist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Client_Couns'))
			$this->Page_Terminate("Client_Counslist.php");
		if ($Security->AllowList(CurrentProjectID() . 'Cust_Client_Client_budget'))
			$this->Page_Terminate("Cust_Client_Client_budgetlist.php");
		if ($Security->AllowList(CurrentProjectID() . 'daily_acknowledgments'))
			$this->Page_Terminate("daily_acknowledgmentslist.php");
		if ($Security->AllowList(CurrentProjectID() . 'client_to_activity_code'))
			$this->Page_Terminate("client_to_activity_codelist.php");
		if ($Security->AllowList(CurrentProjectID() . 'daily_acknowledgment_log'))
			$this->Page_Terminate("daily_acknowledgment_loglist.php");
		if ($Security->AllowList(CurrentProjectID() . 'cust_daily_Acknowledgment_log_required'))
			$this->Page_Terminate("cust_daily_Acknowledgment_log_requiredlist.php");
		if ($Security->IsLoggedIn()) {
			$this->setFailureMessage(ew_DeniedMsg() . "<br><br><a href=\"logout.php\">" . $Language->Phrase("BackToLogin") . "</a>");
		} else {
			$this->Page_Terminate("login.php"); // Exit and go to login page
		}
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'
	function Message_Showing(&$msg, $type) {

		// Example:
		//if ($type == 'success') $msg = "your success message";

	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($default)) $default = new cdefault();

// Page init
$default->Page_Init();

// Page main
$default->Page_Main();
?>
<?php include_once "header.php" ?>
<?php
$default->ShowMessage();
?>
<?php include_once "footer.php" ?>
<?php
$default->Page_Terminate();
?>
