<?php
if (session_id() == "") session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg9.php" ?>
<?php include_once "ewmysql9.php" ?>
<?php include_once "phpfn9.php" ?>
<?php include_once "site_admininfo.php" ?>
<?php include_once "userfn9.php" ?>
<?php

//
// Page class
//

$site_admin_delete = NULL; // Initialize page object first

class csite_admin_delete extends csite_admin {

	// Page ID
	var $PageID = 'delete';

	// Project ID
	var $ProjectID = "{095601E1-93A8-4664-8CCA-D6A58AA0A39D}";

	// Table name
	var $TableName = 'site_admin';

	// Page object name
	var $PageObjName = 'site_admin_delete';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			$html .= "<p class=\"ewMessage\">" . $sMessage . "</p>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			$html .= "<table class=\"ewMessageTable\"><tr><td class=\"ewWarningIcon\"></td><td class=\"ewWarningMessage\">" . $sWarningMessage . "</td></tr></table>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			$html .= "<table class=\"ewMessageTable\"><tr><td class=\"ewSuccessIcon\"></td><td class=\"ewSuccessMessage\">" . $sSuccessMessage . "</td></tr></table>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			$html .= "<table class=\"ewMessageTable\"><tr><td class=\"ewErrorIcon\"></td><td class=\"ewErrorMessage\">" . $sErrorMessage . "</td></tr></table>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p class=\"phpmaker\">" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Fotoer exists, display
			echo "<p class=\"phpmaker\">" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language, $UserAgent;

		// User agent
		$UserAgent = ew_UserAgent();
		$GLOBALS["Page"] = &$this;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (site_admin)
		if (!isset($GLOBALS["site_admin"])) {
			$GLOBALS["site_admin"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["site_admin"];
		}

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'delete', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'site_admin', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect();
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"];
		$this->dbkey->Visible = !$this->IsAdd() && !$this->IsCopy() && !$this->IsGridAdd();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $conn;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();
		$this->Page_Redirecting($url);

		 // Close connection
		$conn->Close();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}
	var $TotalRecs = 0;
	var $RecCnt;
	var $RecKeys = array();
	var $Recordset;
	var $StartRowCnt = 1;
	var $RowCnt = 0;

	//
	// Page main
	//
	function Page_Main() {
		global $Language;

		// Load key parameters
		$this->RecKeys = $this->GetRecordKeys(); // Load record keys
		$sFilter = $this->GetKeyFilter();
		if ($sFilter == "")
			$this->Page_Terminate("site_adminlist.php"); // Prevent SQL injection, return to list

		// Set up filter (SQL WHHERE clause) and get return SQL
		// SQL constructor in site_admin class, site_admininfo.php

		$this->CurrentFilter = $sFilter;

		// Get action
		if (@$_POST["a_delete"] <> "") {
			$this->CurrentAction = $_POST["a_delete"];
		} else {
			$this->CurrentAction = "I"; // Display record
		}
		switch ($this->CurrentAction) {
			case "D": // Delete
				$this->SendEmail = TRUE; // Send email on delete success
				if ($this->DeleteRows()) { // delete rows
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage($Language->Phrase("DeleteSuccess")); // Set up success message
					$this->Page_Terminate($this->getReturnUrl()); // Return to caller
				}
		}
	}

// No functions
	// Load recordset
	function LoadRecordset($offset = -1, $rowcnt = -1) {
		global $conn;

		// Call Recordset Selecting event
		$this->Recordset_Selecting($this->CurrentFilter);

		// Load List page SQL
		$sSql = $this->SelectSQL();
		if ($offset > -1 && $rowcnt > -1)
			$sSql .= " LIMIT $rowcnt OFFSET $offset";

		// Load recordset
		$rs = ew_LoadRecordset($sSql);

		// Call Recordset Selected event
		$this->Recordset_Selected($rs);
		return $rs;
	}

	// Load row based on key values
	function LoadRow() {
		global $conn, $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		global $conn;
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->auth_status->setDbValue($rs->fields('auth_status'));
		$this->_email->setDbValue($rs->fields('email'));
		$this->user->setDbValue($rs->fields('user'));
		$this->pwd->setDbValue($rs->fields('pwd'));
		$this->first->setDbValue($rs->fields('first'));
		$this->last->setDbValue($rs->fields('last'));
		$this->status->setDbValue($rs->fields('status'));
		$this->signature->setDbValue($rs->fields('signature'));
		$this->quote_prefix->setDbValue($rs->fields('quote_prefix'));
	}

	// Render row values based on field settings
	function RenderRow() {
		global $conn, $Security, $Language;
		global $gsLanguage;

		// Initialize URLs
		// Call Row_Rendering event

		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey
		// auth_status
		// email
		// user
		// pwd
		// first
		// last
		// status
		// signature
		// quote_prefix

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

			// dbkey
			$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
			$this->dbkey->ViewCustomAttributes = "";

			// auth_status
			$this->auth_status->ViewValue = $this->auth_status->CurrentValue;
			$this->auth_status->ViewCustomAttributes = "";

			// email
			$this->_email->ViewValue = $this->_email->CurrentValue;
			$this->_email->ViewCustomAttributes = "";

			// user
			$this->user->ViewValue = $this->user->CurrentValue;
			$this->user->ViewCustomAttributes = "";

			// pwd
			$this->pwd->ViewValue = $this->pwd->CurrentValue;
			$this->pwd->ViewCustomAttributes = "";

			// first
			$this->first->ViewValue = $this->first->CurrentValue;
			$this->first->ViewCustomAttributes = "";

			// last
			$this->last->ViewValue = $this->last->CurrentValue;
			$this->last->ViewCustomAttributes = "";

			// status
			$this->status->ViewValue = $this->status->CurrentValue;
			$this->status->ViewCustomAttributes = "";

			// quote_prefix
			$this->quote_prefix->ViewValue = $this->quote_prefix->CurrentValue;
			$this->quote_prefix->ViewCustomAttributes = "";

			// dbkey
			$this->dbkey->LinkCustomAttributes = "";
			$this->dbkey->HrefValue = "";
			$this->dbkey->TooltipValue = "";

			// auth_status
			$this->auth_status->LinkCustomAttributes = "";
			$this->auth_status->HrefValue = "";
			$this->auth_status->TooltipValue = "";

			// email
			$this->_email->LinkCustomAttributes = "";
			$this->_email->HrefValue = "";
			$this->_email->TooltipValue = "";

			// user
			$this->user->LinkCustomAttributes = "";
			$this->user->HrefValue = "";
			$this->user->TooltipValue = "";

			// pwd
			$this->pwd->LinkCustomAttributes = "";
			$this->pwd->HrefValue = "";
			$this->pwd->TooltipValue = "";

			// first
			$this->first->LinkCustomAttributes = "";
			$this->first->HrefValue = "";
			$this->first->TooltipValue = "";

			// last
			$this->last->LinkCustomAttributes = "";
			$this->last->HrefValue = "";
			$this->last->TooltipValue = "";

			// status
			$this->status->LinkCustomAttributes = "";
			$this->status->HrefValue = "";
			$this->status->TooltipValue = "";

			// quote_prefix
			$this->quote_prefix->LinkCustomAttributes = "";
			$this->quote_prefix->HrefValue = "";
			$this->quote_prefix->TooltipValue = "";
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	//
	// Delete records based on current filter
	//
	function DeleteRows() {
		global $conn, $Language, $Security;
		$DeleteRows = TRUE;
		$sSql = $this->SQL();
		$conn->raiseErrorFn = 'ew_ErrorFn';
		$rs = $conn->Execute($sSql);
		$conn->raiseErrorFn = '';
		if ($rs === FALSE) {
			return FALSE;
		} elseif ($rs->EOF) {
			$this->setFailureMessage($Language->Phrase("NoRecord")); // No record found
			$rs->Close();
			return FALSE;
		} else {
			$this->LoadRowValues($rs); // Load row values
		}
		$conn->BeginTrans();

		// Clone old rows
		$rsold = ($rs) ? $rs->GetRows() : array();
		if ($rs)
			$rs->Close();

		// Call row deleting event
		if ($DeleteRows) {
			foreach ($rsold as $row) {
				$DeleteRows = $this->Row_Deleting($row);
				if (!$DeleteRows) break;
			}
		}
		if ($DeleteRows) {
			$sKey = "";
			foreach ($rsold as $row) {
				$sThisKey = "";
				if ($sThisKey <> "") $sThisKey .= $GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"];
				$sThisKey .= $row['dbkey'];
				if ($sThisKey <> "") $sThisKey .= $GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"];
				$sThisKey .= $row['auth_status'];
				$conn->raiseErrorFn = 'ew_ErrorFn';
				$DeleteRows = $this->Delete($row); // Delete
				$conn->raiseErrorFn = '';
				if ($DeleteRows === FALSE)
					break;
				if ($sKey <> "") $sKey .= ", ";
				$sKey .= $sThisKey;
			}
		} else {

			// Set up error message
			if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

				// Use the message, do nothing
			} elseif ($this->CancelMessage <> "") {
				$this->setFailureMessage($this->CancelMessage);
				$this->CancelMessage = "";
			} else {
				$this->setFailureMessage($Language->Phrase("DeleteCancelled"));
			}
		}
		if ($DeleteRows) {
			$conn->CommitTrans(); // Commit the changes
		} else {
			$conn->RollbackTrans(); // Rollback changes
		}

		// Call Row Deleted event
		if ($DeleteRows) {
			foreach ($rsold as $row) {
				$this->Row_Deleted($row);
			}
		}
		return $DeleteRows;
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($site_admin_delete)) $site_admin_delete = new csite_admin_delete();

// Page init
$site_admin_delete->Page_Init();

// Page main
$site_admin_delete->Page_Main();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Page object
var site_admin_delete = new ew_Page("site_admin_delete");
site_admin_delete.PageID = "delete"; // Page ID
var EW_PAGE_ID = site_admin_delete.PageID; // For backward compatibility

// Form object
var fsite_admindelete = new ew_Form("fsite_admindelete");

// Form_CustomValidate event
fsite_admindelete.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
fsite_admindelete.ValidateRequired = true;
<?php } else { ?>
fsite_admindelete.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
// Form object for search

</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php

// Load records for display
if ($site_admin_delete->Recordset = $site_admin_delete->LoadRecordset())
	$site_admin_deleteTotalRecs = $site_admin_delete->Recordset->RecordCount(); // Get record count
if ($site_admin_deleteTotalRecs <= 0) { // No record found, exit
	if ($site_admin_delete->Recordset)
		$site_admin_delete->Recordset->Close();
	$site_admin_delete->Page_Terminate("site_adminlist.php"); // Return to list
}
?>
<p><span id="ewPageCaption" class="ewTitle ewTableTitle"><?php echo $Language->Phrase("Delete") ?>&nbsp;<?php echo $Language->Phrase("TblTypeTABLE") ?><?php echo $site_admin->TableCaption() ?></span></p>
<p class="phpmaker"><a href="<?php echo $site_admin->getReturnUrl() ?>" id="a_GoBack" class="ewLink"><?php echo $Language->Phrase("GoBack") ?></a></p>
<?php $site_admin_delete->ShowPageHeader(); ?>
<?php
$site_admin_delete->ShowMessage();
?>
<form name="fsite_admindelete" id="fsite_admindelete" class="ewForm" action="<?php echo ew_CurrentPage() ?>" method="post">
<br>
<input type="hidden" name="t" value="site_admin">
<input type="hidden" name="a_delete" id="a_delete" value="D">
<?php foreach ($site_admin_delete->RecKeys as $key) { ?>
<?php $keyvalue = is_array($key) ? implode($EW_COMPOSITE_KEY_SEPARATOR, $key) : $key; ?>
<input type="hidden" name="key_m[]" value="<?php echo ew_HtmlEncode($keyvalue) ?>">
<?php } ?>
<table cellspacing="0" class="ewGrid"><tr><td class="ewGridContent">
<div class="ewGridMiddlePanel">
<table id="tbl_site_admindelete" class="ewTable ewTableSeparate">
<?php echo $site_admin->TableCustomInnerHtml ?>
	<thead>
	<tr class="ewTableHeader">
		<td><span id="elh_site_admin_dbkey" class="site_admin_dbkey"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->dbkey->FldCaption() ?></td></tr></table></span></td>
		<td><span id="elh_site_admin_auth_status" class="site_admin_auth_status"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->auth_status->FldCaption() ?></td></tr></table></span></td>
		<td><span id="elh_site_admin__email" class="site_admin__email"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->_email->FldCaption() ?></td></tr></table></span></td>
		<td><span id="elh_site_admin_user" class="site_admin_user"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->user->FldCaption() ?></td></tr></table></span></td>
		<td><span id="elh_site_admin_pwd" class="site_admin_pwd"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->pwd->FldCaption() ?></td></tr></table></span></td>
		<td><span id="elh_site_admin_first" class="site_admin_first"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->first->FldCaption() ?></td></tr></table></span></td>
		<td><span id="elh_site_admin_last" class="site_admin_last"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->last->FldCaption() ?></td></tr></table></span></td>
		<td><span id="elh_site_admin_status" class="site_admin_status"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->status->FldCaption() ?></td></tr></table></span></td>
		<td><span id="elh_site_admin_quote_prefix" class="site_admin_quote_prefix"><table class="ewTableHeaderBtn"><tr><td><?php echo $site_admin->quote_prefix->FldCaption() ?></td></tr></table></span></td>
	</tr>
	</thead>
	<tbody>
<?php
$site_admin_delete->RecCnt = 0;
$i = 0;
while (!$site_admin_delete->Recordset->EOF) {
	$site_admin_delete->RecCnt++;
	$site_admin_delete->RowCnt++;

	// Set row properties
	$site_admin->ResetAttrs();
	$site_admin->RowType = EW_ROWTYPE_VIEW; // View

	// Get the field contents
	$site_admin_delete->LoadRowValues($site_admin_delete->Recordset);

	// Render row
	$site_admin_delete->RenderRow();
?>
	<tr<?php echo $site_admin->RowAttributes() ?>>
		<td<?php echo $site_admin->dbkey->CellAttributes() ?>><span id="el<?php echo $site_admin_delete->RowCnt ?>_site_admin_dbkey" class="site_admin_dbkey">
<span<?php echo $site_admin->dbkey->ViewAttributes() ?>>
<?php echo $site_admin->dbkey->ListViewValue() ?></span>
</span></td>
		<td<?php echo $site_admin->auth_status->CellAttributes() ?>><span id="el<?php echo $site_admin_delete->RowCnt ?>_site_admin_auth_status" class="site_admin_auth_status">
<span<?php echo $site_admin->auth_status->ViewAttributes() ?>>
<?php echo $site_admin->auth_status->ListViewValue() ?></span>
</span></td>
		<td<?php echo $site_admin->_email->CellAttributes() ?>><span id="el<?php echo $site_admin_delete->RowCnt ?>_site_admin__email" class="site_admin__email">
<span<?php echo $site_admin->_email->ViewAttributes() ?>>
<?php echo $site_admin->_email->ListViewValue() ?></span>
</span></td>
		<td<?php echo $site_admin->user->CellAttributes() ?>><span id="el<?php echo $site_admin_delete->RowCnt ?>_site_admin_user" class="site_admin_user">
<span<?php echo $site_admin->user->ViewAttributes() ?>>
<?php echo $site_admin->user->ListViewValue() ?></span>
</span></td>
		<td<?php echo $site_admin->pwd->CellAttributes() ?>><span id="el<?php echo $site_admin_delete->RowCnt ?>_site_admin_pwd" class="site_admin_pwd">
<span<?php echo $site_admin->pwd->ViewAttributes() ?>>
<?php echo $site_admin->pwd->ListViewValue() ?></span>
</span></td>
		<td<?php echo $site_admin->first->CellAttributes() ?>><span id="el<?php echo $site_admin_delete->RowCnt ?>_site_admin_first" class="site_admin_first">
<span<?php echo $site_admin->first->ViewAttributes() ?>>
<?php echo $site_admin->first->ListViewValue() ?></span>
</span></td>
		<td<?php echo $site_admin->last->CellAttributes() ?>><span id="el<?php echo $site_admin_delete->RowCnt ?>_site_admin_last" class="site_admin_last">
<span<?php echo $site_admin->last->ViewAttributes() ?>>
<?php echo $site_admin->last->ListViewValue() ?></span>
</span></td>
		<td<?php echo $site_admin->status->CellAttributes() ?>><span id="el<?php echo $site_admin_delete->RowCnt ?>_site_admin_status" class="site_admin_status">
<span<?php echo $site_admin->status->ViewAttributes() ?>>
<?php echo $site_admin->status->ListViewValue() ?></span>
</span></td>
		<td<?php echo $site_admin->quote_prefix->CellAttributes() ?>><span id="el<?php echo $site_admin_delete->RowCnt ?>_site_admin_quote_prefix" class="site_admin_quote_prefix">
<span<?php echo $site_admin->quote_prefix->ViewAttributes() ?>>
<?php echo $site_admin->quote_prefix->ListViewValue() ?></span>
</span></td>
	</tr>
<?php
	$site_admin_delete->Recordset->MoveNext();
}
$site_admin_delete->Recordset->Close();
?>
</tbody>
</table>
</div>
</td></tr></table>
<br>
<input type="submit" name="Action" value="<?php echo ew_BtnCaption($Language->Phrase("DeleteBtn")) ?>">
</form>
<script type="text/javascript">
fsite_admindelete.Init();
</script>
<?php
$site_admin_delete->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$site_admin_delete->Page_Terminate();
?>
