<?php
if (session_id() == "") session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg12.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql12.php") ?>
<?php include_once "phpfn12.php" ?>
<?php include_once "testinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn12.php" ?>
<?php

//
// Page class
//

$test_list = NULL; // Initialize page object first

class ctest_list extends ctest {

	// Page ID
	var $PageID = 'list';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'test';

	// Page object name
	var $PageObjName = 'test_list';

	// Grid form hidden field names
	var $FormName = 'ftestlist';
	var $FormActionName = 'k_action';
	var $FormKeyName = 'k_key';
	var $FormOldKeyName = 'k_oldkey';
	var $FormBlankRowName = 'k_blankrow';
	var $FormKeyCountName = 'key_count';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Page URLs
	var $AddUrl;
	var $EditUrl;
	var $CopyUrl;
	var $DeleteUrl;
	var $ViewUrl;
	var $ListUrl;

	// Export URLs
	var $ExportPrintUrl;
	var $ExportHtmlUrl;
	var $ExportExcelUrl;
	var $ExportWordUrl;
	var $ExportXmlUrl;
	var $ExportCsvUrl;
	var $ExportPdfUrl;

	// Custom export
	var $ExportExcelCustom = FALSE;
	var $ExportWordCustom = FALSE;
	var $ExportPdfCustom = FALSE;
	var $ExportEmailCustom = FALSE;

	// Update URLs
	var $InlineAddUrl;
	var $InlineCopyUrl;
	var $InlineEditUrl;
	var $GridAddUrl;
	var $GridEditUrl;
	var $MultiDeleteUrl;
	var $MultiUpdateUrl;
    var $AuditTrailOnAdd = FALSE;
    var $AuditTrailOnEdit = FALSE;
    var $AuditTrailOnDelete = FALSE;
    var $AuditTrailOnView = FALSE;
    var $AuditTrailOnViewData = FALSE;
    var $AuditTrailOnSearch = FALSE;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (test)
		if (!isset($GLOBALS["test"]) || get_class($GLOBALS["test"]) == "ctest") {
			$GLOBALS["test"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["test"];
		}

		// Initialize URLs
		$this->ExportPrintUrl = $this->PageUrl() . "export=print";
		$this->ExportExcelUrl = $this->PageUrl() . "export=excel";
		$this->ExportWordUrl = $this->PageUrl() . "export=word";
		$this->ExportHtmlUrl = $this->PageUrl() . "export=html";
		$this->ExportXmlUrl = $this->PageUrl() . "export=xml";
		$this->ExportCsvUrl = $this->PageUrl() . "export=csv";
		$this->ExportPdfUrl = $this->PageUrl() . "export=pdf";
		$this->AddUrl = "testadd.php";
		$this->InlineAddUrl = $this->PageUrl() . "a=add";
		$this->GridAddUrl = $this->PageUrl() . "a=gridadd";
		$this->GridEditUrl = $this->PageUrl() . "a=gridedit";
		$this->MultiDeleteUrl = "testdelete.php";
		$this->MultiUpdateUrl = "testupdate.php";

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'list', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'test', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}

		// List options
		$this->ListOptions = new cListOptions();
		$this->ListOptions->TableVar = $this->TableVar;

		// Export options
		$this->ExportOptions = new cListOptions();
		$this->ExportOptions->Tag = "div";
		$this->ExportOptions->TagClassName = "ewExportOption";

		// Other options
		$this->OtherOptions['addedit'] = new cListOptions();
		$this->OtherOptions['addedit']->Tag = "div";
		$this->OtherOptions['addedit']->TagClassName = "ewAddEditOption";
		$this->OtherOptions['detail'] = new cListOptions();
		$this->OtherOptions['detail']->Tag = "div";
		$this->OtherOptions['detail']->TagClassName = "ewDetailOption";
		$this->OtherOptions['action'] = new cListOptions();
		$this->OtherOptions['action']->Tag = "div";
		$this->OtherOptions['action']->TagClassName = "ewActionOption";

		// Filter options
		$this->FilterOptions = new cListOptions();
		$this->FilterOptions->Tag = "div";
		$this->FilterOptions->TagClassName = "ewFilterOption ftestlistsrch";

		// List actions
		$this->ListActions = new cListActions();
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanList()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			$this->Page_Terminate(ew_GetUrl("index.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Get export parameters
		$custom = "";
		if (@$_GET["export"] <> "") {
			$this->Export = $_GET["export"];
			$custom = @$_GET["custom"];
		} elseif (@$_POST["export"] <> "") {
			$this->Export = $_POST["export"];
			$custom = @$_POST["custom"];
		} elseif (ew_IsHttpPost()) {
			if (@$_POST["exporttype"] <> "")
				$this->Export = $_POST["exporttype"];
			$custom = @$_POST["custom"];
		} else {
			$this->setExportReturnUrl(ew_CurrentUrl());
		}
		$gsExportFile = $this->TableVar; // Get export file, used in header

		// Get custom export parameters
		if ($this->Export <> "" && $custom <> "") {
			$this->CustomExport = $this->Export;
			$this->Export = "print";
		}
		$gsCustomExport = $this->CustomExport;
		$gsExport = $this->Export; // Get export parameter, used in header

		// Update Export URLs
		if (defined("EW_USE_PHPEXCEL"))
			$this->ExportExcelCustom = FALSE;
		if ($this->ExportExcelCustom)
			$this->ExportExcelUrl .= "&amp;custom=1";
		if (defined("EW_USE_PHPWORD"))
			$this->ExportWordCustom = FALSE;
		if ($this->ExportWordCustom)
			$this->ExportWordUrl .= "&amp;custom=1";
		if ($this->ExportPdfCustom)
			$this->ExportPdfUrl .= "&amp;custom=1";
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action

		// Get grid add count
		$gridaddcnt = @$_GET[EW_TABLE_GRID_ADD_ROW_COUNT];
		if (is_numeric($gridaddcnt) && $gridaddcnt > 0)
			$this->GridAddRowCount = $gridaddcnt;

		// Set up list options
		$this->SetupListOptions();

		// Setup export options
		$this->SetupExportOptions();
		$this->First->Visible = !$this->IsAddOrEdit();
		$this->Last->Visible = !$this->IsAddOrEdit();
		$this->Total_Hours->Visible = !$this->IsAddOrEdit();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();

		// Setup other options
		$this->SetupOtherOptions();

		// Set up custom action (compatible with old version)
		foreach ($this->CustomActions as $name => $action)
			$this->ListActions->Add($name, $action);

		// Show checkbox column if multiple action
		foreach ($this->ListActions->Items as $listaction) {
			if ($listaction->Select == EW_ACTION_MULTIPLE && $listaction->Allow) {
				$this->ListOptions->Items["checkbox"]->Visible = TRUE;
				break;
			}
		}
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $test;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($test);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}

	// Class variables
	var $ListOptions; // List options
	var $ExportOptions; // Export options
	var $SearchOptions; // Search options
	var $OtherOptions = array(); // Other options
	var $FilterOptions; // Filter options
	var $ListActions; // List actions
	var $SelectedCount = 0;
	var $SelectedIndex = 0;
	var $DisplayRecs = 20;
	var $StartRec;
	var $StopRec;
	var $TotalRecs = 0;
	var $RecRange = 10;
	var $Pager;
	var $DefaultSearchWhere = ""; // Default search WHERE clause
	var $SearchWhere = ""; // Search WHERE clause
	var $RecCnt = 0; // Record count
	var $EditRowCnt;
	var $StartRowCnt = 1;
	var $RowCnt = 0;
	var $Attrs = array(); // Row attributes and cell attributes
	var $RowIndex = 0; // Row index
	var $KeyCount = 0; // Key count
	var $RowAction = ""; // Row action
	var $RowOldKey = ""; // Row old key (for copy)
	var $RecPerRow = 0;
	var $MultiColumnClass;
	var $MultiColumnEditClass = "col-sm-12";
	var $MultiColumnCnt = 12;
	var $MultiColumnEditCnt = 12;
	var $GridCnt = 0;
	var $ColCnt = 0;
	var $DbMasterFilter = ""; // Master filter
	var $DbDetailFilter = ""; // Detail filter
	var $MasterRecordExists;	
	var $MultiSelectKey;
	var $Command;
	var $RestoreSearch = FALSE;
	var $DetailPages;
	var $Recordset;
	var $OldRecordset;

	//
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError, $gsSearchError, $Security;

		// Search filters
		$sSrchAdvanced = ""; // Advanced search filter
		$sSrchBasic = ""; // Basic search filter
		$sFilter = "";

		// Get command
		$this->Command = strtolower(@$_GET["cmd"]);
		if ($this->IsPageRequest()) { // Validate request

			// Process list action first
			if ($this->ProcessListAction()) // Ajax request
				$this->Page_Terminate();

			// Handle reset command
			$this->ResetCmd();

			// Set up Breadcrumb
			if ($this->Export == "")
				$this->SetupBreadcrumb();

			// Hide list options
			if ($this->Export <> "") {
				$this->ListOptions->HideAllOptions(array("sequence"));
				$this->ListOptions->UseDropDownButton = FALSE; // Disable drop down button
				$this->ListOptions->UseButtonGroup = FALSE; // Disable button group
			} elseif ($this->CurrentAction == "gridadd" || $this->CurrentAction == "gridedit") {
				$this->ListOptions->HideAllOptions();
				$this->ListOptions->UseDropDownButton = FALSE; // Disable drop down button
				$this->ListOptions->UseButtonGroup = FALSE; // Disable button group
			}

			// Hide options
			if ($this->Export <> "" || $this->CurrentAction <> "") {
				$this->ExportOptions->HideAllOptions();
				$this->FilterOptions->HideAllOptions();
			}

			// Hide other options
			if ($this->Export <> "") {
				foreach ($this->OtherOptions as &$option)
					$option->HideAllOptions();
			}

			// Get default search criteria
			ew_AddFilter($this->DefaultSearchWhere, $this->AdvancedSearchWhere(TRUE));

			// Get and validate search values for advanced search
			$this->LoadSearchValues(); // Get search values

			// Restore filter list
			$this->RestoreFilterList();
			if (!$this->ValidateSearch())
				$this->setFailureMessage($gsSearchError);

			// Restore search parms from Session if not searching / reset / export
			if (($this->Export <> "" || $this->Command <> "search" && $this->Command <> "reset" && $this->Command <> "resetall") && $this->CheckSearchParms())
				$this->RestoreSearchParms();

			// Call Recordset SearchValidated event
			$this->Recordset_SearchValidated();

			// Set up sorting order
			$this->SetUpSortOrder();

			// Get search criteria for advanced search
			if ($gsSearchError == "")
				$sSrchAdvanced = $this->AdvancedSearchWhere();
		}

		// Restore display records
		if ($this->getRecordsPerPage() <> "") {
			$this->DisplayRecs = $this->getRecordsPerPage(); // Restore from Session
		} else {
			$this->DisplayRecs = 20; // Load default
		}

		// Load Sorting Order
		$this->LoadSortOrder();

		// Load search default if no existing search criteria
		if (!$this->CheckSearchParms()) {

			// Load advanced search from default
			if ($this->LoadAdvancedSearchDefault()) {
				$sSrchAdvanced = $this->AdvancedSearchWhere();
			}
		}

		// Build search criteria
		ew_AddFilter($this->SearchWhere, $sSrchAdvanced);
		ew_AddFilter($this->SearchWhere, $sSrchBasic);

		// Call Recordset_Searching event
		$this->Recordset_Searching($this->SearchWhere);

		// Save search criteria
		if ($this->Command == "search" && !$this->RestoreSearch) {
			$this->setSearchWhere($this->SearchWhere); // Save to Session
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} else {
			$this->SearchWhere = $this->getSearchWhere();
		}

		// Build filter
		$sFilter = "";
		if (!$Security->CanList())
			$sFilter = "(0=1)"; // Filter all records
		ew_AddFilter($sFilter, $this->DbDetailFilter);
		ew_AddFilter($sFilter, $this->SearchWhere);

		// Set up filter in session
		$this->setSessionWhere($sFilter);
		$this->CurrentFilter = "";

		// Export data only
		if ($this->CustomExport == "" && in_array($this->Export, array("html","word","excel","xml","csv","email","pdf"))) {
			$this->ExportData();
			$this->Page_Terminate(); // Terminate response
			exit();
		}

		// Load record count first
		if (!$this->IsAddOrEdit()) {
			$bSelectLimit = $this->UseSelectLimit;
			if ($bSelectLimit) {
				$this->TotalRecs = $this->SelectRecordCount();
			} else {
				if ($this->Recordset = $this->LoadRecordset())
					$this->TotalRecs = $this->Recordset->RecordCount();
			}
		}

		// Search options
		$this->SetupSearchOptions();
	}

	// Build filter for all keys
	function BuildKeyFilter() {
		global $objForm;
		$sWrkFilter = "";

		// Update row index and get row key
		$rowindex = 1;
		$objForm->Index = $rowindex;
		$sThisKey = strval($objForm->GetValue($this->FormKeyName));
		while ($sThisKey <> "") {
			if ($this->SetupKeyValues($sThisKey)) {
				$sFilter = $this->KeyFilter();
				if ($sWrkFilter <> "") $sWrkFilter .= " OR ";
				$sWrkFilter .= $sFilter;
			} else {
				$sWrkFilter = "0=1";
				break;
			}

			// Update row index and get row key
			$rowindex++; // Next row
			$objForm->Index = $rowindex;
			$sThisKey = strval($objForm->GetValue($this->FormKeyName));
		}
		return $sWrkFilter;
	}

	// Set up key values
	function SetupKeyValues($key) {
		$arrKeyFlds = explode($GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"], $key);
		if (count($arrKeyFlds) >= 0) {
		}
		return TRUE;
	}

	// Get list of filters
	function GetFilterList() {

		// Initialize
		$sFilterList = "";
		$sFilterList = ew_Concat($sFilterList, $this->dbkey->AdvancedSearch->ToJSON(), ","); // Field dbkey
		$sFilterList = ew_Concat($sFilterList, $this->description->AdvancedSearch->ToJSON(), ","); // Field description
		$sFilterList = ew_Concat($sFilterList, $this->First->AdvancedSearch->ToJSON(), ","); // Field First
		$sFilterList = ew_Concat($sFilterList, $this->Last->AdvancedSearch->ToJSON(), ","); // Field Last

		// Return filter list in json
		return ($sFilterList <> "") ? "{" . $sFilterList . "}" : "null";
	}

	// Restore list of filters
	function RestoreFilterList() {

		// Return if not reset filter
		if (@$_POST["cmd"] <> "resetfilter")
			return FALSE;
		$filter = json_decode(ew_StripSlashes(@$_POST["filter"]), TRUE);
		$this->Command = "search";

		// Field dbkey
		$this->dbkey->AdvancedSearch->SearchValue = @$filter["x_dbkey"];
		$this->dbkey->AdvancedSearch->SearchOperator = @$filter["z_dbkey"];
		$this->dbkey->AdvancedSearch->SearchCondition = @$filter["v_dbkey"];
		$this->dbkey->AdvancedSearch->SearchValue2 = @$filter["y_dbkey"];
		$this->dbkey->AdvancedSearch->SearchOperator2 = @$filter["w_dbkey"];
		$this->dbkey->AdvancedSearch->Save();

		// Field description
		$this->description->AdvancedSearch->SearchValue = @$filter["x_description"];
		$this->description->AdvancedSearch->SearchOperator = @$filter["z_description"];
		$this->description->AdvancedSearch->SearchCondition = @$filter["v_description"];
		$this->description->AdvancedSearch->SearchValue2 = @$filter["y_description"];
		$this->description->AdvancedSearch->SearchOperator2 = @$filter["w_description"];
		$this->description->AdvancedSearch->Save();

		// Field First
		$this->First->AdvancedSearch->SearchValue = @$filter["x_First"];
		$this->First->AdvancedSearch->SearchOperator = @$filter["z_First"];
		$this->First->AdvancedSearch->SearchCondition = @$filter["v_First"];
		$this->First->AdvancedSearch->SearchValue2 = @$filter["y_First"];
		$this->First->AdvancedSearch->SearchOperator2 = @$filter["w_First"];
		$this->First->AdvancedSearch->Save();

		// Field Last
		$this->Last->AdvancedSearch->SearchValue = @$filter["x_Last"];
		$this->Last->AdvancedSearch->SearchOperator = @$filter["z_Last"];
		$this->Last->AdvancedSearch->SearchCondition = @$filter["v_Last"];
		$this->Last->AdvancedSearch->SearchValue2 = @$filter["y_Last"];
		$this->Last->AdvancedSearch->SearchOperator2 = @$filter["w_Last"];
		$this->Last->AdvancedSearch->Save();
	}

	// Advanced search WHERE clause based on QueryString
	function AdvancedSearchWhere($Default = FALSE) {
		global $Security;
		$sWhere = "";
		if (!$Security->CanSearch()) return "";
		$this->BuildSearchSql($sWhere, $this->dbkey, $Default, FALSE); // dbkey
		$this->BuildSearchSql($sWhere, $this->description, $Default, FALSE); // description
		$this->BuildSearchSql($sWhere, $this->First, $Default, FALSE); // First
		$this->BuildSearchSql($sWhere, $this->Last, $Default, FALSE); // Last

		// Set up search parm
		if (!$Default && $sWhere <> "") {
			$this->Command = "search";
		}
		if (!$Default && $this->Command == "search") {
			$this->dbkey->AdvancedSearch->Save(); // dbkey
			$this->description->AdvancedSearch->Save(); // description
			$this->First->AdvancedSearch->Save(); // First
			$this->Last->AdvancedSearch->Save(); // Last
		}
		return $sWhere;
	}

	// Build search SQL
	function BuildSearchSql(&$Where, &$Fld, $Default, $MultiValue) {
		$FldParm = substr($Fld->FldVar, 2);
		$FldVal = ($Default) ? $Fld->AdvancedSearch->SearchValueDefault : $Fld->AdvancedSearch->SearchValue; // @$_GET["x_$FldParm"]
		$FldOpr = ($Default) ? $Fld->AdvancedSearch->SearchOperatorDefault : $Fld->AdvancedSearch->SearchOperator; // @$_GET["z_$FldParm"]
		$FldCond = ($Default) ? $Fld->AdvancedSearch->SearchConditionDefault : $Fld->AdvancedSearch->SearchCondition; // @$_GET["v_$FldParm"]
		$FldVal2 = ($Default) ? $Fld->AdvancedSearch->SearchValue2Default : $Fld->AdvancedSearch->SearchValue2; // @$_GET["y_$FldParm"]
		$FldOpr2 = ($Default) ? $Fld->AdvancedSearch->SearchOperator2Default : $Fld->AdvancedSearch->SearchOperator2; // @$_GET["w_$FldParm"]
		$sWrk = "";

		//$FldVal = ew_StripSlashes($FldVal);
		if (is_array($FldVal)) $FldVal = implode(",", $FldVal);

		//$FldVal2 = ew_StripSlashes($FldVal2);
		if (is_array($FldVal2)) $FldVal2 = implode(",", $FldVal2);
		$FldOpr = strtoupper(trim($FldOpr));
		if ($FldOpr == "") $FldOpr = "=";
		$FldOpr2 = strtoupper(trim($FldOpr2));
		if ($FldOpr2 == "") $FldOpr2 = "=";
		if (EW_SEARCH_MULTI_VALUE_OPTION == 1 || $FldOpr <> "LIKE" ||
			($FldOpr2 <> "LIKE" && $FldVal2 <> ""))
			$MultiValue = FALSE;
		if ($MultiValue) {
			$sWrk1 = ($FldVal <> "") ? ew_GetMultiSearchSql($Fld, $FldOpr, $FldVal, $this->DBID) : ""; // Field value 1
			$sWrk2 = ($FldVal2 <> "") ? ew_GetMultiSearchSql($Fld, $FldOpr2, $FldVal2, $this->DBID) : ""; // Field value 2
			$sWrk = $sWrk1; // Build final SQL
			if ($sWrk2 <> "")
				$sWrk = ($sWrk <> "") ? "($sWrk) $FldCond ($sWrk2)" : $sWrk2;
		} else {
			$FldVal = $this->ConvertSearchValue($Fld, $FldVal);
			$FldVal2 = $this->ConvertSearchValue($Fld, $FldVal2);
			$sWrk = ew_GetSearchSql($Fld, $FldVal, $FldOpr, $FldCond, $FldVal2, $FldOpr2, $this->DBID);
		}
		ew_AddFilter($Where, $sWrk);
	}

	// Convert search value
	function ConvertSearchValue(&$Fld, $FldVal) {
		if ($FldVal == EW_NULL_VALUE || $FldVal == EW_NOT_NULL_VALUE)
			return $FldVal;
		$Value = $FldVal;
		if ($Fld->FldDataType == EW_DATATYPE_BOOLEAN) {
			if ($FldVal <> "") $Value = ($FldVal == "1" || strtolower(strval($FldVal)) == "y" || strtolower(strval($FldVal)) == "t") ? $Fld->TrueValue : $Fld->FalseValue;
		} elseif ($Fld->FldDataType == EW_DATATYPE_DATE) {
			if ($FldVal <> "") $Value = ew_UnFormatDateTime($FldVal, $Fld->FldDateTimeFormat);
		}
		return $Value;
	}

	// Check if search parm exists
	function CheckSearchParms() {
		if ($this->dbkey->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->description->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->First->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->Last->AdvancedSearch->IssetSession())
			return TRUE;
		return FALSE;
	}

	// Clear all search parameters
	function ResetSearchParms() {

		// Clear search WHERE clause
		$this->SearchWhere = "";
		$this->setSearchWhere($this->SearchWhere);

		// Clear advanced search parameters
		$this->ResetAdvancedSearchParms();
	}

	// Load advanced search default values
	function LoadAdvancedSearchDefault() {
		return FALSE;
	}

	// Clear all advanced search parameters
	function ResetAdvancedSearchParms() {
		$this->dbkey->AdvancedSearch->UnsetSession();
		$this->description->AdvancedSearch->UnsetSession();
		$this->First->AdvancedSearch->UnsetSession();
		$this->Last->AdvancedSearch->UnsetSession();
	}

	// Restore all search parameters
	function RestoreSearchParms() {
		$this->RestoreSearch = TRUE;

		// Restore advanced search values
		$this->dbkey->AdvancedSearch->Load();
		$this->description->AdvancedSearch->Load();
		$this->First->AdvancedSearch->Load();
		$this->Last->AdvancedSearch->Load();
	}

	// Set up sort parameters
	function SetUpSortOrder() {

		// Check for "order" parameter
		if (@$_GET["order"] <> "") {
			$this->CurrentOrder = ew_StripSlashes(@$_GET["order"]);
			$this->CurrentOrderType = @$_GET["ordertype"];
			$this->UpdateSort($this->dbkey); // dbkey
			$this->UpdateSort($this->description); // description
			$this->UpdateSort($this->First); // First
			$this->UpdateSort($this->Last); // Last
			$this->UpdateSort($this->Total_Hours); // Total Hours
			$this->UpdateSort($this->Monday); // Monday
			$this->setStartRecordNumber(1); // Reset start position
		}
	}

	// Load sort order parameters
	function LoadSortOrder() {
		$sOrderBy = $this->getSessionOrderBy(); // Get ORDER BY from Session
		if ($sOrderBy == "") {
			if ($this->getSqlOrderBy() <> "") {
				$sOrderBy = $this->getSqlOrderBy();
				$this->setSessionOrderBy($sOrderBy);
				$this->description->setSort("DESC");
				$this->dbkey->setSort("DESC");
			}
		}
	}

	// Reset command
	// - cmd=reset (Reset search parameters)
	// - cmd=resetall (Reset search and master/detail parameters)
	// - cmd=resetsort (Reset sort parameters)
	function ResetCmd() {

		// Check if reset command
		if (substr($this->Command,0,5) == "reset") {

			// Reset search criteria
			if ($this->Command == "reset" || $this->Command == "resetall")
				$this->ResetSearchParms();

			// Reset sorting order
			if ($this->Command == "resetsort") {
				$sOrderBy = "";
				$this->setSessionOrderBy($sOrderBy);
				$this->dbkey->setSort("");
				$this->description->setSort("");
				$this->First->setSort("");
				$this->Last->setSort("");
				$this->Total_Hours->setSort("");
				$this->Monday->setSort("");
			}

			// Reset start position
			$this->StartRec = 1;
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Set up list options
	function SetupListOptions() {
		global $Security, $Language;

		// Add group option item
		$item = &$this->ListOptions->Add($this->ListOptions->GroupOptionName);
		$item->Body = "";
		$item->OnLeft = FALSE;
		$item->Visible = FALSE;

		// List actions
		$item = &$this->ListOptions->Add("listactions");
		$item->CssStyle = "white-space: nowrap;";
		$item->OnLeft = FALSE;
		$item->Visible = FALSE;
		$item->ShowInButtonGroup = FALSE;
		$item->ShowInDropDown = FALSE;

		// "checkbox"
		$item = &$this->ListOptions->Add("checkbox");
		$item->Visible = FALSE;
		$item->OnLeft = FALSE;
		$item->Header = "<input type=\"checkbox\" name=\"key\" id=\"key\" onclick=\"ew_SelectAllKey(this);\">";
		$item->ShowInDropDown = FALSE;
		$item->ShowInButtonGroup = FALSE;

		// Drop down button for ListOptions
		$this->ListOptions->UseImageAndText = TRUE;
		$this->ListOptions->UseDropDownButton = FALSE;
		$this->ListOptions->DropDownButtonPhrase = $Language->Phrase("ButtonListOptions");
		$this->ListOptions->UseButtonGroup = FALSE;
		if ($this->ListOptions->UseButtonGroup && ew_IsMobile())
			$this->ListOptions->UseDropDownButton = TRUE;
		$this->ListOptions->ButtonClass = "btn-sm"; // Class for button group

		// Call ListOptions_Load event
		$this->ListOptions_Load();
		$this->SetupListOptionsExt();
		$item = &$this->ListOptions->GetItem($this->ListOptions->GroupOptionName);
		$item->Visible = $this->ListOptions->GroupOptionVisible();
	}

	// Render list options
	function RenderListOptions() {
		global $Security, $Language, $objForm;
		$this->ListOptions->LoadDefault();

		// Set up list action buttons
		$oListOpt = &$this->ListOptions->GetItem("listactions");
		if ($oListOpt && $this->Export == "" && $this->CurrentAction == "") {
			$body = "";
			$links = array();
			foreach ($this->ListActions->Items as $listaction) {
				if ($listaction->Select == EW_ACTION_SINGLE && $listaction->Allow) {
					$action = $listaction->Action;
					$caption = $listaction->Caption;
					$icon = ($listaction->Icon <> "") ? "<span class=\"" . ew_HtmlEncode(str_replace(" ewIcon", "", $listaction->Icon)) . "\" data-caption=\"" . ew_HtmlTitle($caption) . "\"></span> " : "";
					$links[] = "<li><a class=\"ewAction ewListAction\" data-action=\"" . ew_HtmlEncode($action) . "\" data-caption=\"" . ew_HtmlTitle($caption) . "\" href=\"\" onclick=\"ew_SubmitAction(event,jQuery.extend({key:" . $this->KeyToJson() . "}," . $listaction->ToJson(TRUE) . "));return false;\">" . $icon . $listaction->Caption . "</a></li>";
					if (count($links) == 1) // Single button
						$body = "<a class=\"ewAction ewListAction\" data-action=\"" . ew_HtmlEncode($action) . "\" title=\"" . ew_HtmlTitle($caption) . "\" data-caption=\"" . ew_HtmlTitle($caption) . "\" href=\"\" onclick=\"ew_SubmitAction(event,jQuery.extend({key:" . $this->KeyToJson() . "}," . $listaction->ToJson(TRUE) . "));return false;\">" . $Language->Phrase("ListActionButton") . "</a>";
				}
			}
			if (count($links) > 1) { // More than one buttons, use dropdown
				$body = "<button class=\"dropdown-toggle btn btn-default btn-sm ewActions\" title=\"" . ew_HtmlTitle($Language->Phrase("ListActionButton")) . "\" data-toggle=\"dropdown\">" . $Language->Phrase("ListActionButton") . "<b class=\"caret\"></b></button>";
				$content = "";
				foreach ($links as $link)
					$content .= "<li>" . $link . "</li>";
				$body .= "<ul class=\"dropdown-menu" . ($oListOpt->OnLeft ? "" : " dropdown-menu-right") . "\">". $content . "</ul>";
				$body = "<div class=\"btn-group\">" . $body . "</div>";
			}
			if (count($links) > 0) {
				$oListOpt->Body = $body;
				$oListOpt->Visible = TRUE;
			}
		}

		// "checkbox"
		$oListOpt = &$this->ListOptions->Items["checkbox"];
		$this->RenderListOptionsExt();

		// Call ListOptions_Rendered event
		$this->ListOptions_Rendered();
	}

	// Set up other options
	function SetupOtherOptions() {
		global $Language, $Security;
		$options = &$this->OtherOptions;
		$option = $options["action"];

		// Set up options default
		foreach ($options as &$option) {
			$option->UseImageAndText = TRUE;
			$option->UseDropDownButton = FALSE;
			$option->UseButtonGroup = TRUE;
			$option->ButtonClass = "btn-sm"; // Class for button group
			$item = &$option->Add($option->GroupOptionName);
			$item->Body = "";
			$item->Visible = FALSE;
		}
		$options["addedit"]->DropDownButtonPhrase = $Language->Phrase("ButtonAddEdit");
		$options["detail"]->DropDownButtonPhrase = $Language->Phrase("ButtonDetails");
		$options["action"]->DropDownButtonPhrase = $Language->Phrase("ButtonActions");

		// Filter button
		$item = &$this->FilterOptions->Add("savecurrentfilter");
		$item->Body = "<a class=\"ewSaveFilter\" data-form=\"ftestlistsrch\" href=\"#\">" . $Language->Phrase("SaveCurrentFilter") . "</a>";
		$item->Visible = TRUE;
		$item = &$this->FilterOptions->Add("deletefilter");
		$item->Body = "<a class=\"ewDeleteFilter\" data-form=\"ftestlistsrch\" href=\"#\">" . $Language->Phrase("DeleteFilter") . "</a>";
		$item->Visible = TRUE;
		$this->FilterOptions->UseDropDownButton = TRUE;
		$this->FilterOptions->UseButtonGroup = !$this->FilterOptions->UseDropDownButton;
		$this->FilterOptions->DropDownButtonPhrase = $Language->Phrase("Filters");

		// Add group option item
		$item = &$this->FilterOptions->Add($this->FilterOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;
	}

	// Render other options
	function RenderOtherOptions() {
		global $Language, $Security;
		$options = &$this->OtherOptions;
			$option = &$options["action"];

			// Set up list action buttons
			foreach ($this->ListActions->Items as $listaction) {
				if ($listaction->Select == EW_ACTION_MULTIPLE) {
					$item = &$option->Add("custom_" . $listaction->Action);
					$caption = $listaction->Caption;
					$icon = ($listaction->Icon <> "") ? "<span class=\"" . ew_HtmlEncode($listaction->Icon) . "\" data-caption=\"" . ew_HtmlEncode($caption) . "\"></span> " : $caption;
					$item->Body = "<a class=\"ewAction ewListAction\" title=\"" . ew_HtmlEncode($caption) . "\" data-caption=\"" . ew_HtmlEncode($caption) . "\" href=\"\" onclick=\"ew_SubmitAction(event,jQuery.extend({f:document.ftestlist}," . $listaction->ToJson(TRUE) . "));return false;\">" . $icon . "</a>";
					$item->Visible = $listaction->Allow;
				}
			}

			// Hide grid edit and other options
			if ($this->TotalRecs <= 0) {
				$option = &$options["addedit"];
				$item = &$option->GetItem("gridedit");
				if ($item) $item->Visible = FALSE;
				$option = &$options["action"];
				$option->HideAllOptions();
			}
	}

	// Process list action
	function ProcessListAction() {
		global $Language, $Security;
		$userlist = "";
		$user = "";
		$sFilter = $this->GetKeyFilter();
		$UserAction = @$_POST["useraction"];
		if ($sFilter <> "" && $UserAction <> "") {

			// Check permission first
			$ActionCaption = $UserAction;
			if (array_key_exists($UserAction, $this->ListActions->Items)) {
				$ActionCaption = $this->ListActions->Items[$UserAction]->Caption;
				if (!$this->ListActions->Items[$UserAction]->Allow) {
					$errmsg = str_replace('%s', $ActionCaption, $Language->Phrase("CustomActionNotAllowed"));
					if (@$_POST["ajax"] == $UserAction) // Ajax
						echo "<p class=\"text-danger\">" . $errmsg . "</p>";
					else
						$this->setFailureMessage($errmsg);
					return FALSE;
				}
			}
			$this->CurrentFilter = $sFilter;
			$sSql = $this->SQL();
			$conn = &$this->Connection();
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			$rs = $conn->Execute($sSql);
			$conn->raiseErrorFn = '';
			$this->CurrentAction = $UserAction;

			// Call row action event
			if ($rs && !$rs->EOF) {
				$conn->BeginTrans();
				$this->SelectedCount = $rs->RecordCount();
				$this->SelectedIndex = 0;
				while (!$rs->EOF) {
					$this->SelectedIndex++;
					$row = $rs->fields;
					$Processed = $this->Row_CustomAction($UserAction, $row);
					if (!$Processed) break;
					$rs->MoveNext();
				}
				if ($Processed) {
					$conn->CommitTrans(); // Commit the changes
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage(str_replace('%s', $ActionCaption, $Language->Phrase("CustomActionCompleted"))); // Set up success message
				} else {
					$conn->RollbackTrans(); // Rollback changes

					// Set up error message
					if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

						// Use the message, do nothing
					} elseif ($this->CancelMessage <> "") {
						$this->setFailureMessage($this->CancelMessage);
						$this->CancelMessage = "";
					} else {
						$this->setFailureMessage(str_replace('%s', $ActionCaption, $Language->Phrase("CustomActionFailed")));
					}
				}
			}
			if ($rs)
				$rs->Close();
			$this->CurrentAction = ""; // Clear action
			if (@$_POST["ajax"] == $UserAction) { // Ajax
				if ($this->getSuccessMessage() <> "") {
					echo "<p class=\"text-success\">" . $this->getSuccessMessage() . "</p>";
					$this->ClearSuccessMessage(); // Clear message
				}
				if ($this->getFailureMessage() <> "") {
					echo "<p class=\"text-danger\">" . $this->getFailureMessage() . "</p>";
					$this->ClearFailureMessage(); // Clear message
				}
				return TRUE;
			}
		}
		return FALSE; // Not ajax request
	}

	// Set up search options
	function SetupSearchOptions() {
		global $Language;
		$this->SearchOptions = new cListOptions();
		$this->SearchOptions->Tag = "div";
		$this->SearchOptions->TagClassName = "ewSearchOption";

		// Search button
		$item = &$this->SearchOptions->Add("searchtoggle");
		$SearchToggleClass = ($this->SearchWhere <> "") ? " active" : " active";
		$item->Body = "<button type=\"button\" class=\"btn btn-default ewSearchToggle" . $SearchToggleClass . "\" title=\"" . $Language->Phrase("SearchPanel") . "\" data-caption=\"" . $Language->Phrase("SearchPanel") . "\" data-toggle=\"button\" data-form=\"ftestlistsrch\">" . $Language->Phrase("SearchBtn") . "</button>";
		$item->Visible = TRUE;

		// Show all button
		$item = &$this->SearchOptions->Add("showall");
		$item->Body = "<a class=\"btn btn-default ewShowAll\" title=\"" . $Language->Phrase("ShowAll") . "\" data-caption=\"" . $Language->Phrase("ShowAll") . "\" href=\"" . $this->PageUrl() . "cmd=reset\">" . $Language->Phrase("ShowAllBtn") . "</a>";
		$item->Visible = ($this->SearchWhere <> $this->DefaultSearchWhere && $this->SearchWhere <> "0=101");

		// Advanced search button
		$item = &$this->SearchOptions->Add("advancedsearch");
		$item->Body = "<a class=\"btn btn-default ewAdvancedSearch\" title=\"" . $Language->Phrase("AdvancedSearch") . "\" data-caption=\"" . $Language->Phrase("AdvancedSearch") . "\" href=\"testsrch.php\">" . $Language->Phrase("AdvancedSearchBtn") . "</a>";
		$item->Visible = TRUE;

		// Button group for search
		$this->SearchOptions->UseDropDownButton = FALSE;
		$this->SearchOptions->UseImageAndText = TRUE;
		$this->SearchOptions->UseButtonGroup = TRUE;
		$this->SearchOptions->DropDownButtonPhrase = $Language->Phrase("ButtonSearch");

		// Add group option item
		$item = &$this->SearchOptions->Add($this->SearchOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;

		// Hide search options
		if ($this->Export <> "" || $this->CurrentAction <> "")
			$this->SearchOptions->HideAllOptions();
		global $Security;
		if (!$Security->CanSearch()) {
			$this->SearchOptions->HideAllOptions();
			$this->FilterOptions->HideAllOptions();
		}
	}

	function SetupListOptionsExt() {
		global $Security, $Language;
	}

	function RenderListOptionsExt() {
		global $Security, $Language;
	}

	// Set up starting record parameters
	function SetUpStartRec() {
		if ($this->DisplayRecs == 0)
			return;
		if ($this->IsPageRequest()) { // Validate request
			if (@$_GET[EW_TABLE_START_REC] <> "") { // Check for "start" parameter
				$this->StartRec = $_GET[EW_TABLE_START_REC];
				$this->setStartRecordNumber($this->StartRec);
			} elseif (@$_GET[EW_TABLE_PAGE_NO] <> "") {
				$PageNo = $_GET[EW_TABLE_PAGE_NO];
				if (is_numeric($PageNo)) {
					$this->StartRec = ($PageNo-1)*$this->DisplayRecs+1;
					if ($this->StartRec <= 0) {
						$this->StartRec = 1;
					} elseif ($this->StartRec >= intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1) {
						$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1;
					}
					$this->setStartRecordNumber($this->StartRec);
				}
			}
		}
		$this->StartRec = $this->getStartRecordNumber();

		// Check if correct start record counter
		if (!is_numeric($this->StartRec) || $this->StartRec == "") { // Avoid invalid start record counter
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} elseif (intval($this->StartRec) > intval($this->TotalRecs)) { // Avoid starting record > total records
			$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to last page first record
			$this->setStartRecordNumber($this->StartRec);
		} elseif (($this->StartRec-1) % $this->DisplayRecs <> 0) {
			$this->StartRec = intval(($this->StartRec-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to page boundary
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Load search values for validation
	function LoadSearchValues() {
		global $objForm;

		// Load search values
		// dbkey

		$this->dbkey->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_dbkey"]);
		if ($this->dbkey->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->dbkey->AdvancedSearch->SearchOperator = @$_GET["z_dbkey"];

		// description
		$this->description->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_description"]);
		if ($this->description->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->description->AdvancedSearch->SearchOperator = @$_GET["z_description"];

		// First
		$this->First->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_First"]);
		if ($this->First->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->First->AdvancedSearch->SearchOperator = @$_GET["z_First"];

		// Last
		$this->Last->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_Last"]);
		if ($this->Last->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->Last->AdvancedSearch->SearchOperator = @$_GET["z_Last"];
	}

	// Load recordset
	function LoadRecordset($offset = -1, $rowcnt = -1) {

		// Load List page SQL
		$sSql = $this->SelectSQL();
		$conn = &$this->Connection();

		// Load recordset
		$dbtype = ew_GetConnectionType($this->DBID);
		if ($this->UseSelectLimit) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			if ($dbtype == "MSSQL") {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset, array("_hasOrderBy" => trim($this->getOrderBy()) || trim($this->getSessionOrderBy())));
			} else {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset);
			}
			$conn->raiseErrorFn = '';
		} else {
			$rs = ew_LoadRecordset($sSql, $conn);
		}

		// Call Recordset Selected event
		$this->Recordset_Selected($rs);
		return $rs;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->allocated->setDbValue($rs->fields('allocated'));
		$this->description->setDbValue($rs->fields('description'));
		$this->First->setDbValue($rs->fields('First'));
		$this->Last->setDbValue($rs->fields('Last'));
		$this->Total_Hours->setDbValue($rs->fields('Total Hours'));
		$this->Year->setDbValue($rs->fields('Year'));
		$this->Week_23->setDbValue($rs->fields('Week #'));
		$this->From_Date->setDbValue($rs->fields('From Date'));
		$this->Through_Date->setDbValue($rs->fields('Through Date'));
		$this->Monday->setDbValue($rs->fields('Monday'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey->DbValue = $row['dbkey'];
		$this->allocated->DbValue = $row['allocated'];
		$this->description->DbValue = $row['description'];
		$this->First->DbValue = $row['First'];
		$this->Last->DbValue = $row['Last'];
		$this->Total_Hours->DbValue = $row['Total Hours'];
		$this->Year->DbValue = $row['Year'];
		$this->Week_23->DbValue = $row['Week #'];
		$this->From_Date->DbValue = $row['From Date'];
		$this->Through_Date->DbValue = $row['Through Date'];
		$this->Monday->DbValue = $row['Monday'];
	}

	// Load old record
	function LoadOldRecord() {

		// Load key values from Session
		$bValidKey = TRUE;

		// Load old recordset
		if ($bValidKey) {
			$this->CurrentFilter = $this->KeyFilter();
			$sSql = $this->SQL();
			$conn = &$this->Connection();
			$this->OldRecordset = ew_LoadRecordset($sSql, $conn);
			$this->LoadRowValues($this->OldRecordset); // Load row values
		} else {
			$this->OldRecordset = NULL;
		}
		return $bValidKey;
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		$this->ViewUrl = $this->GetViewUrl();
		$this->EditUrl = $this->GetEditUrl();
		$this->InlineEditUrl = $this->GetInlineEditUrl();
		$this->CopyUrl = $this->GetCopyUrl();
		$this->InlineCopyUrl = $this->GetInlineCopyUrl();
		$this->DeleteUrl = $this->GetDeleteUrl();

		// Convert decimal values if posted back
		if ($this->Total_Hours->FormValue == $this->Total_Hours->CurrentValue && is_numeric(ew_StrToFloat($this->Total_Hours->CurrentValue)))
			$this->Total_Hours->CurrentValue = ew_StrToFloat($this->Total_Hours->CurrentValue);

		// Convert decimal values if posted back
		if ($this->Monday->FormValue == $this->Monday->CurrentValue && is_numeric(ew_StrToFloat($this->Monday->CurrentValue)))
			$this->Monday->CurrentValue = ew_StrToFloat($this->Monday->CurrentValue);

		// Call Row_Rendering event
		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey
		// allocated

		$this->allocated->CellCssStyle = "white-space: nowrap;";

		// description
		// First
		// Last
		// Total Hours
		// Year

		$this->Year->CellCssStyle = "white-space: nowrap;";

		// Week #
		$this->Week_23->CellCssStyle = "white-space: nowrap;";

		// From Date
		// Through Date
		// Monday

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// dbkey
		if (strval($this->dbkey->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey" . ew_SearchString("=", $this->dbkey->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.dbkey, `EW_TMP_LOOKUPTABLE`.`From Date` AS `DispFld`, `EW_TMP_LOOKUPTABLE`.`Through Date` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = ew_FormatDateTime($rswrk->fields('DispFld'), 5);
				$arwrk[2] = ew_FormatDateTime($rswrk->fields('Disp2Fld'), 5);
				$this->dbkey->ViewValue = $this->dbkey->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
			}
		} else {
			$this->dbkey->ViewValue = NULL;
		}
		$this->dbkey->ViewCustomAttributes = "";

		// description
		if (strval($this->description->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.description" . ew_SearchString("=", $this->description->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.description, `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->description, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->description->ViewValue = $this->description->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->description->ViewValue = $this->description->CurrentValue;
			}
		} else {
			$this->description->ViewValue = NULL;
		}
		$this->description->ViewCustomAttributes = "";

		// First
		if (strval($this->First->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.`First`" . ew_SearchString("=", $this->First->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`First`, `EW_TMP_LOOKUPTABLE`.`First` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->First, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->First->ViewValue = $this->First->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->First->ViewValue = $this->First->CurrentValue;
			}
		} else {
			$this->First->ViewValue = NULL;
		}
		$this->First->ViewCustomAttributes = "";

		// Last
		if (strval($this->Last->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.`Last`" . ew_SearchString("=", $this->Last->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`Last`, `EW_TMP_LOOKUPTABLE`.`Last` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->Last, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->Last->ViewValue = $this->Last->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->Last->ViewValue = $this->Last->CurrentValue;
			}
		} else {
			$this->Last->ViewValue = NULL;
		}
		$this->Last->ViewCustomAttributes = "";

		// Total Hours
		$this->Total_Hours->ViewValue = $this->Total_Hours->CurrentValue;
		$this->Total_Hours->ViewCustomAttributes = "";

		// Year
		if (strval($this->Year->CurrentValue) <> "") {
			$this->Year->ViewValue = $this->Year->OptionCaption($this->Year->CurrentValue);
		} else {
			$this->Year->ViewValue = NULL;
		}
		$this->Year->ViewCustomAttributes = "";

		// From Date
		if (strval($this->From_Date->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.`From Date`" . ew_SearchString("=", $this->From_Date->CurrentValue, EW_DATATYPE_DATE, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.`From Date`, `EW_TMP_LOOKUPTABLE`.`From Date` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->From_Date, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = ew_FormatDateTime($rswrk->fields('DispFld'), 5);
				$this->From_Date->ViewValue = $this->From_Date->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->From_Date->ViewValue = $this->From_Date->CurrentValue;
			}
		} else {
			$this->From_Date->ViewValue = NULL;
		}
		$this->From_Date->ViewValue = ew_FormatDateTime($this->From_Date->ViewValue, 5);
		$this->From_Date->ViewCustomAttributes = "";

		// Through Date
		$this->Through_Date->ViewValue = $this->Through_Date->CurrentValue;
		$this->Through_Date->ViewValue = ew_FormatDateTime($this->Through_Date->ViewValue, 5);
		$this->Through_Date->ViewCustomAttributes = "";

		// Monday
		$this->Monday->ViewValue = $this->Monday->CurrentValue;
		$this->Monday->ViewCustomAttributes = "";

			// dbkey
			$this->dbkey->LinkCustomAttributes = "";
			$this->dbkey->HrefValue = "";
			$this->dbkey->TooltipValue = "";

			// description
			$this->description->LinkCustomAttributes = "";
			$this->description->HrefValue = "";
			$this->description->TooltipValue = "";

			// First
			$this->First->LinkCustomAttributes = "";
			$this->First->HrefValue = "";
			$this->First->TooltipValue = "";

			// Last
			$this->Last->LinkCustomAttributes = "";
			$this->Last->HrefValue = "";
			$this->Last->TooltipValue = "";

			// Total Hours
			$this->Total_Hours->LinkCustomAttributes = "";
			$this->Total_Hours->HrefValue = "";
			$this->Total_Hours->TooltipValue = "";

			// Monday
			$this->Monday->LinkCustomAttributes = "";
			$this->Monday->HrefValue = "";
			$this->Monday->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_SEARCH) { // Search row

			// dbkey
			$this->dbkey->EditAttrs["class"] = "form-control";
			$this->dbkey->EditCustomAttributes = "";
			if (trim(strval($this->dbkey->AdvancedSearch->SearchValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "tables_data.dbkey" . ew_SearchString("=", $this->dbkey->AdvancedSearch->SearchValue, EW_DATATYPE_STRING, "");
			}
			$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.dbkey, `EW_TMP_LOOKUPTABLE`.`From Date` AS `DispFld`, `EW_TMP_LOOKUPTABLE`.`Through Date` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
			$sWhereWrk = "";
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$rowswrk = count($arwrk);
			for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
				$arwrk[$rowcntwrk][1] = ew_FormatDateTime($arwrk[$rowcntwrk][1], 5);
				$arwrk[$rowcntwrk][2] = ew_FormatDateTime($arwrk[$rowcntwrk][2], 5);
			}
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect"), "", "", "", "", "", "", ""));
			$this->dbkey->EditValue = $arwrk;

			// description
			$this->description->EditAttrs["class"] = "form-control";
			$this->description->EditCustomAttributes = "";
			if (trim(strval($this->description->AdvancedSearch->SearchValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "b.description" . ew_SearchString("=", $this->description->AdvancedSearch->SearchValue, EW_DATATYPE_STRING, "");
			}
			$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.description, `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
			$sWhereWrk = "";
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->description, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect"), "", "", "", "", "", "", ""));
			$this->description->EditValue = $arwrk;

			// First
			$this->First->EditAttrs["class"] = "form-control";
			$this->First->EditCustomAttributes = "";
			if (trim(strval($this->First->AdvancedSearch->SearchValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`First`" . ew_SearchString("=", $this->First->AdvancedSearch->SearchValue, EW_DATATYPE_STRING, "");
			}
			$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`First`, `EW_TMP_LOOKUPTABLE`.`First` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
			$sWhereWrk = "";
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->First, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect"), "", "", "", "", "", "", ""));
			$this->First->EditValue = $arwrk;

			// Last
			$this->Last->EditAttrs["class"] = "form-control";
			$this->Last->EditCustomAttributes = "";
			if (trim(strval($this->Last->AdvancedSearch->SearchValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`Last`" . ew_SearchString("=", $this->Last->AdvancedSearch->SearchValue, EW_DATATYPE_STRING, "");
			}
			$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`Last`, `EW_TMP_LOOKUPTABLE`.`Last` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
			$sWhereWrk = "";
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->Last, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect"), "", "", "", "", "", "", ""));
			$this->Last->EditValue = $arwrk;

			// Total Hours
			$this->Total_Hours->EditAttrs["class"] = "form-control";
			$this->Total_Hours->EditCustomAttributes = "";
			$this->Total_Hours->EditValue = ew_HtmlEncode($this->Total_Hours->AdvancedSearch->SearchValue);
			$this->Total_Hours->PlaceHolder = ew_RemoveHtml($this->Total_Hours->FldCaption());

			// Monday
			$this->Monday->EditAttrs["class"] = "form-control";
			$this->Monday->EditCustomAttributes = "";
			$this->Monday->EditValue = ew_HtmlEncode($this->Monday->AdvancedSearch->SearchValue);
			$this->Monday->PlaceHolder = ew_RemoveHtml($this->Monday->FldCaption());
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate search
	function ValidateSearch() {
		global $gsSearchError;

		// Initialize
		$gsSearchError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return TRUE;

		// Return validate result
		$ValidateSearch = ($gsSearchError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateSearch = $ValidateSearch && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsSearchError, $sFormCustomError);
		}
		return $ValidateSearch;
	}

	// Load advanced search
	function LoadAdvancedSearch() {
		$this->dbkey->AdvancedSearch->Load();
		$this->description->AdvancedSearch->Load();
		$this->First->AdvancedSearch->Load();
		$this->Last->AdvancedSearch->Load();
	}

	// Set up export options
	function SetupExportOptions() {
		global $Language;

		// Printer friendly
		$item = &$this->ExportOptions->Add("print");
		$item->Body = "<a href=\"" . $this->ExportPrintUrl . "\" class=\"ewExportLink ewPrint\" title=\"" . ew_HtmlEncode($Language->Phrase("PrinterFriendlyText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("PrinterFriendlyText")) . "\">" . $Language->Phrase("PrinterFriendly") . "</a>";
		$item->Visible = TRUE;

		// Export to Excel
		$item = &$this->ExportOptions->Add("excel");
		$item->Body = "<a href=\"" . $this->ExportExcelUrl . "\" class=\"ewExportLink ewExcel\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToExcelText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToExcelText")) . "\">" . $Language->Phrase("ExportToExcel") . "</a>";
		$item->Visible = TRUE;

		// Export to Word
		$item = &$this->ExportOptions->Add("word");
		$item->Body = "<a href=\"" . $this->ExportWordUrl . "\" class=\"ewExportLink ewWord\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToWordText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToWordText")) . "\">" . $Language->Phrase("ExportToWord") . "</a>";
		$item->Visible = TRUE;

		// Export to Html
		$item = &$this->ExportOptions->Add("html");
		$item->Body = "<a href=\"" . $this->ExportHtmlUrl . "\" class=\"ewExportLink ewHtml\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToHtmlText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToHtmlText")) . "\">" . $Language->Phrase("ExportToHtml") . "</a>";
		$item->Visible = TRUE;

		// Export to Xml
		$item = &$this->ExportOptions->Add("xml");
		$item->Body = "<a href=\"" . $this->ExportXmlUrl . "\" class=\"ewExportLink ewXml\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToXmlText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToXmlText")) . "\">" . $Language->Phrase("ExportToXml") . "</a>";
		$item->Visible = FALSE;

		// Export to Csv
		$item = &$this->ExportOptions->Add("csv");
		$item->Body = "<a href=\"" . $this->ExportCsvUrl . "\" class=\"ewExportLink ewCsv\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToCsvText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToCsvText")) . "\">" . $Language->Phrase("ExportToCsv") . "</a>";
		$item->Visible = TRUE;

		// Export to Pdf
		$item = &$this->ExportOptions->Add("pdf");
		$item->Body = "<a href=\"" . $this->ExportPdfUrl . "\" class=\"ewExportLink ewPdf\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToPDFText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToPDFText")) . "\">" . $Language->Phrase("ExportToPDF") . "</a>";
		$item->Visible = FALSE;

		// Export to Email
		$item = &$this->ExportOptions->Add("email");
		$url = "";
		$item->Body = "<button id=\"emf_test\" class=\"ewExportLink ewEmail\" title=\"" . $Language->Phrase("ExportToEmailText") . "\" data-caption=\"" . $Language->Phrase("ExportToEmailText") . "\" onclick=\"ew_EmailDialogShow({lnk:'emf_test',hdr:ewLanguage.Phrase('ExportToEmailText'),f:document.ftestlist,sel:false" . $url . "});\">" . $Language->Phrase("ExportToEmail") . "</button>";
		$item->Visible = TRUE;

		// Drop down button for export
		$this->ExportOptions->UseButtonGroup = TRUE;
		$this->ExportOptions->UseImageAndText = TRUE;
		$this->ExportOptions->UseDropDownButton = FALSE;
		if ($this->ExportOptions->UseButtonGroup && ew_IsMobile())
			$this->ExportOptions->UseDropDownButton = TRUE;
		$this->ExportOptions->DropDownButtonPhrase = $Language->Phrase("ButtonExport");

		// Add group option item
		$item = &$this->ExportOptions->Add($this->ExportOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;
	}

	// Export data in HTML/CSV/Word/Excel/XML/Email/PDF format
	function ExportData() {
		$utf8 = (strtolower(EW_CHARSET) == "utf-8");
		$bSelectLimit = $this->UseSelectLimit;

		// Load recordset
		if ($bSelectLimit) {
			$this->TotalRecs = $this->SelectRecordCount();
		} else {
			if (!$this->Recordset)
				$this->Recordset = $this->LoadRecordset();
			$rs = &$this->Recordset;
			if ($rs)
				$this->TotalRecs = $rs->RecordCount();
		}
		$this->StartRec = 1;

		// Export all
		if ($this->ExportAll) {
			set_time_limit(EW_EXPORT_ALL_TIME_LIMIT);
			$this->DisplayRecs = $this->TotalRecs;
			$this->StopRec = $this->TotalRecs;
		} else { // Export one page only
			$this->SetUpStartRec(); // Set up start record position

			// Set the last record to display
			if ($this->DisplayRecs <= 0) {
				$this->StopRec = $this->TotalRecs;
			} else {
				$this->StopRec = $this->StartRec + $this->DisplayRecs - 1;
			}
		}
		if ($bSelectLimit)
			$rs = $this->LoadRecordset($this->StartRec-1, $this->DisplayRecs <= 0 ? $this->TotalRecs : $this->DisplayRecs);
		if (!$rs) {
			header("Content-Type:"); // Remove header
			header("Content-Disposition:");
			$this->ShowMessage();
			return;
		}
		$this->ExportDoc = ew_ExportDocument($this, "h");
		$Doc = &$this->ExportDoc;
		if ($bSelectLimit) {
			$this->StartRec = 1;
			$this->StopRec = $this->DisplayRecs <= 0 ? $this->TotalRecs : $this->DisplayRecs;
		} else {

			//$this->StartRec = $this->StartRec;
			//$this->StopRec = $this->StopRec;

		}

		// Call Page Exporting server event
		$this->ExportDoc->ExportCustom = !$this->Page_Exporting();
		$ParentTable = "";
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		$Doc->Text .= $sHeader;
		$this->ExportDocument($Doc, $rs, $this->StartRec, $this->StopRec, "");
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		$Doc->Text .= $sFooter;

		// Close recordset
		$rs->Close();

		// Call Page Exported server event
		$this->Page_Exported();

		// Export header and footer
		$Doc->ExportHeaderAndFooter();

		// Clean output buffer
		if (!EW_DEBUG_ENABLED && ob_get_length())
			ob_end_clean();

		// Write debug message if enabled
		if (EW_DEBUG_ENABLED && $this->Export <> "pdf")
			echo ew_DebugMsg();

		// Output data
		if ($this->Export == "email") {
			echo $this->ExportEmail($Doc->Text);
		} else {
			$Doc->Export();
		}
	}

	// Export email
	function ExportEmail($EmailContent) {
		global $gTmpImages, $Language;
		$sSender = @$_POST["sender"];
		$sRecipient = @$_POST["recipient"];
		$sCc = @$_POST["cc"];
		$sBcc = @$_POST["bcc"];
		$sContentType = @$_POST["contenttype"];

		// Subject
		$sSubject = ew_StripSlashes(@$_POST["subject"]);
		$sEmailSubject = $sSubject;

		// Message
		$sContent = ew_StripSlashes(@$_POST["message"]);
		$sEmailMessage = $sContent;

		// Check sender
		if ($sSender == "") {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterSenderEmail") . "</p>";
		}
		if (!ew_CheckEmail($sSender)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperSenderEmail") . "</p>";
		}

		// Check recipient
		if (!ew_CheckEmailList($sRecipient, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperRecipientEmail") . "</p>";
		}

		// Check cc
		if (!ew_CheckEmailList($sCc, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperCcEmail") . "</p>";
		}

		// Check bcc
		if (!ew_CheckEmailList($sBcc, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperBccEmail") . "</p>";
		}

		// Check email sent count
		if (!isset($_SESSION[EW_EXPORT_EMAIL_COUNTER]))
			$_SESSION[EW_EXPORT_EMAIL_COUNTER] = 0;
		if (intval($_SESSION[EW_EXPORT_EMAIL_COUNTER]) > EW_MAX_EMAIL_SENT_COUNT) {
			return "<p class=\"text-danger\">" . $Language->Phrase("ExceedMaxEmailExport") . "</p>";
		}

		// Send email
		$Email = new cEmail();
		$Email->Sender = $sSender; // Sender
		$Email->Recipient = $sRecipient; // Recipient
		$Email->Cc = $sCc; // Cc
		$Email->Bcc = $sBcc; // Bcc
		$Email->Subject = $sEmailSubject; // Subject
		$Email->Format = ($sContentType == "url") ? "text" : "html";
		if ($sEmailMessage <> "") {
			$sEmailMessage = ew_RemoveXSS($sEmailMessage);
			$sEmailMessage .= ($sContentType == "url") ? "\r\n\r\n" : "<br><br>";
		}
		if ($sContentType == "url") {
			$sUrl = ew_ConvertFullUrl(ew_CurrentPage() . "?" . $this->ExportQueryString());
			$sEmailMessage .= $sUrl; // Send URL only
		} else {
			foreach ($gTmpImages as $tmpimage)
				$Email->AddEmbeddedImage($tmpimage);
			$sEmailMessage .= ew_CleanEmailContent($EmailContent); // Send HTML
		}
		$Email->Content = $sEmailMessage; // Content
		$EventArgs = array();
		if ($this->Recordset) {
			$this->RecCnt = $this->StartRec - 1;
			$this->Recordset->MoveFirst();
			if ($this->StartRec > 1)
				$this->Recordset->Move($this->StartRec - 1);
			$EventArgs["rs"] = &$this->Recordset;
		}
		$bEmailSent = FALSE;
		if ($this->Email_Sending($Email, $EventArgs))
			$bEmailSent = $Email->Send();

		// Check email sent status
		if ($bEmailSent) {

			// Update email sent count
			$_SESSION[EW_EXPORT_EMAIL_COUNTER]++;

			// Sent email success
			return "<p class=\"text-success\">" . $Language->Phrase("SendEmailSuccess") . "</p>"; // Set up success message
		} else {

			// Sent email failure
			return "<p class=\"text-danger\">" . $Email->SendErrDescription . "</p>";
		}
	}

	// Export QueryString
	function ExportQueryString() {

		// Initialize
		$sQry = "export=html";

		// Build QueryString for search
		$this->AddSearchQueryString($sQry, $this->dbkey); // dbkey
		$this->AddSearchQueryString($sQry, $this->description); // description
		$this->AddSearchQueryString($sQry, $this->First); // First
		$this->AddSearchQueryString($sQry, $this->Last); // Last

		// Build QueryString for pager
		$sQry .= "&" . EW_TABLE_REC_PER_PAGE . "=" . urlencode($this->getRecordsPerPage()) . "&" . EW_TABLE_START_REC . "=" . urlencode($this->getStartRecordNumber());
		return $sQry;
	}

	// Add search QueryString
	function AddSearchQueryString(&$Qry, &$Fld) {
		$FldSearchValue = $Fld->AdvancedSearch->getValue("x");
		$FldParm = substr($Fld->FldVar,2);
		if (strval($FldSearchValue) <> "") {
			$Qry .= "&x_" . $FldParm . "=" . urlencode($FldSearchValue) .
				"&z_" . $FldParm . "=" . urlencode($Fld->AdvancedSearch->getValue("z"));
		}
		$FldSearchValue2 = $Fld->AdvancedSearch->getValue("y");
		if (strval($FldSearchValue2) <> "") {
			$Qry .= "&v_" . $FldParm . "=" . urlencode($Fld->AdvancedSearch->getValue("v")) .
				"&y_" . $FldParm . "=" . urlencode($FldSearchValue2) .
				"&w_" . $FldParm . "=" . urlencode($Fld->AdvancedSearch->getValue("w"));
		}
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$url = preg_replace('/\?cmd=reset(all){0,1}$/i', '', $url); // Remove cmd=reset / cmd=resetall
		$Breadcrumb->Add("list", $this->TableVar, $url, "", $this->TableVar, TRUE);
	}

	// Write Audit Trail start/end for grid update
	function WriteAuditTrailDummy($typ) {
		$table = 'test';
		$usr = CurrentUserID();
		ew_WriteAuditTrail("log", ew_StdCurrentDateTime(), ew_ScriptName(), $usr, $typ, $table, "", "", "", "");
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}

	// ListOptions Load event
	function ListOptions_Load() {

		// Example:
		//$opt = &$this->ListOptions->Add("new");
		//$opt->Header = "xxx";
		//$opt->OnLeft = TRUE; // Link on left
		//$opt->MoveTo(0); // Move to first column

	}

	// ListOptions Rendered event
	function ListOptions_Rendered() {

		// Example: 
		//$this->ListOptions->Items["new"]->Body = "xxx";

	}

	// Row Custom Action event
	function Row_CustomAction($action, $row) {

		// Return FALSE to abort
		return TRUE;
	}

	// Page Exporting event
	// $this->ExportDoc = export document object
	function Page_Exporting() {

		//$this->ExportDoc->Text = "my header"; // Export header
		//return FALSE; // Return FALSE to skip default export and use Row_Export event

		return TRUE; // Return TRUE to use default export and skip Row_Export event
	}

	// Row Export event
	// $this->ExportDoc = export document object
	function Row_Export($rs) {

	    //$this->ExportDoc->Text .= "my content"; // Build HTML with field value: $rs["MyField"] or $this->MyField->ViewValue
	}

	// Page Exported event
	// $this->ExportDoc = export document object
	function Page_Exported() {

		//$this->ExportDoc->Text .= "my footer"; // Export footer
		//echo $this->ExportDoc->Text;

	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($test_list)) $test_list = new ctest_list();

// Page init
$test_list->Page_Init();

// Page main
$test_list->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$test_list->Page_Render();
?>
<?php include_once "header.php" ?>
<?php if ($test->Export == "") { ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "list";
var CurrentForm = ftestlist = new ew_Form("ftestlist", "list");
ftestlist.FormKeyCountName = '<?php echo $test_list->FormKeyCountName ?>';

// Form_CustomValidate event
ftestlist.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
ftestlist.ValidateRequired = true;
<?php } else { ?>
ftestlist.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
ftestlist.Lists["x_dbkey"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_From_Date","x_Through_Date","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftestlist.Lists["x_description"] = {"LinkField":"x_description","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftestlist.Lists["x_First"] = {"LinkField":"x_First","Ajax":true,"AutoFill":false,"DisplayFields":["x_First","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftestlist.Lists["x_Last"] = {"LinkField":"x_Last","Ajax":true,"AutoFill":false,"DisplayFields":["x_Last","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};

// Form object for search
var CurrentSearchForm = ftestlistsrch = new ew_Form("ftestlistsrch");

// Validate function for search
ftestlistsrch.Validate = function(fobj) {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	fobj = fobj || this.Form;
	var infix = "";

	// Fire Form_CustomValidate event
	if (!this.Form_CustomValidate(fobj))
		return false;
	return true;
}

// Form_CustomValidate event
ftestlistsrch.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
ftestlistsrch.ValidateRequired = true; // Use JavaScript validation
<?php } else { ?>
ftestlistsrch.ValidateRequired = false; // No JavaScript validation
<?php } ?>

// Dynamic selection lists
ftestlistsrch.Lists["x_dbkey"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_From_Date","x_Through_Date","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftestlistsrch.Lists["x_description"] = {"LinkField":"x_description","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftestlistsrch.Lists["x_First"] = {"LinkField":"x_First","Ajax":true,"AutoFill":false,"DisplayFields":["x_First","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftestlistsrch.Lists["x_Last"] = {"LinkField":"x_Last","Ajax":true,"AutoFill":false,"DisplayFields":["x_Last","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php } ?>
<?php if ($test->Export == "") { ?>
<div class="ewToolbar">
<?php if ($test->Export == "") { ?>
<?php $Breadcrumb->Render(); ?>
<?php } ?>
<?php if ($test_list->TotalRecs > 0 && $test_list->ExportOptions->Visible()) { ?>
<?php $test_list->ExportOptions->Render("body") ?>
<?php } ?>
<?php if ($test_list->SearchOptions->Visible()) { ?>
<?php $test_list->SearchOptions->Render("body") ?>
<?php } ?>
<?php if ($test_list->FilterOptions->Visible()) { ?>
<?php $test_list->FilterOptions->Render("body") ?>
<?php } ?>
<?php if ($test->Export == "") { ?>
<?php echo $Language->SelectionForm(); ?>
<?php } ?>
<div class="clearfix"></div>
</div>
<?php } ?>
<?php
	$bSelectLimit = $test_list->UseSelectLimit;
	if ($bSelectLimit) {
		if ($test_list->TotalRecs <= 0)
			$test_list->TotalRecs = $test->SelectRecordCount();
	} else {
		if (!$test_list->Recordset && ($test_list->Recordset = $test_list->LoadRecordset()))
			$test_list->TotalRecs = $test_list->Recordset->RecordCount();
	}
	$test_list->StartRec = 1;
	if ($test_list->DisplayRecs <= 0 || ($test->Export <> "" && $test->ExportAll)) // Display all records
		$test_list->DisplayRecs = $test_list->TotalRecs;
	if (!($test->Export <> "" && $test->ExportAll))
		$test_list->SetUpStartRec(); // Set up start record position
	if ($bSelectLimit)
		$test_list->Recordset = $test_list->LoadRecordset($test_list->StartRec-1, $test_list->DisplayRecs);

	// Set no record found message
	if ($test->CurrentAction == "" && $test_list->TotalRecs == 0) {
		if (!$Security->CanList())
			$test_list->setWarningMessage(ew_DeniedMsg());
		if ($test_list->SearchWhere == "0=101")
			$test_list->setWarningMessage($Language->Phrase("EnterSearchCriteria"));
		else
			$test_list->setWarningMessage($Language->Phrase("NoRecord"));
	}

	// Audit trail on search
	if ($test_list->AuditTrailOnSearch && $test_list->Command == "search" && !$test_list->RestoreSearch) {
		$searchparm = ew_ServerVar("QUERY_STRING");
		$searchsql = $test_list->getSessionWhere();
		$test_list->WriteAuditTrailOnSearch($searchparm, $searchsql);
	}
$test_list->RenderOtherOptions();
?>
<?php if ($Security->CanSearch()) { ?>
<?php if ($test->Export == "" && $test->CurrentAction == "") { ?>
<form name="ftestlistsrch" id="ftestlistsrch" class="form-inline ewForm" action="<?php echo ew_CurrentPage() ?>">
<?php $SearchPanelClass = ($test_list->SearchWhere <> "") ? " in" : " in"; ?>
<div id="ftestlistsrch_SearchPanel" class="ewSearchPanel collapse<?php echo $SearchPanelClass ?>">
<input type="hidden" name="cmd" value="search">
<input type="hidden" name="t" value="test">
	<div class="ewBasicSearch">
<?php
if ($gsSearchError == "")
	$test_list->LoadAdvancedSearch(); // Load advanced search

// Render for search
$test->RowType = EW_ROWTYPE_SEARCH;

// Render row
$test->ResetAttrs();
$test_list->RenderRow();
?>
<div id="xsr_1" class="ewRow">
<?php if ($test->dbkey->Visible) { // dbkey ?>
	<div id="xsc_dbkey" class="ewCell form-group">
		<label for="x_dbkey" class="ewSearchCaption ewLabel"><?php echo $test->dbkey->FldCaption() ?></label>
		<span class="ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_dbkey" id="z_dbkey" value="="></span>
		<span class="ewSearchField">
<select data-table="test" data-field="x_dbkey" data-value-separator="<?php echo ew_HtmlEncode(is_array($test->dbkey->DisplayValueSeparator) ? json_encode($test->dbkey->DisplayValueSeparator) : $test->dbkey->DisplayValueSeparator) ?>" id="x_dbkey" name="x_dbkey"<?php echo $test->dbkey->EditAttributes() ?>>
<?php
if (is_array($test->dbkey->EditValue)) {
	$arwrk = $test->dbkey->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = ew_SameStr($test->dbkey->AdvancedSearch->SearchValue, $arwrk[$rowcntwrk][0]) ? " selected" : "";
		if ($selwrk <> "") $emptywrk = FALSE;		
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $test->dbkey->DisplayValue($arwrk[$rowcntwrk]) ?>
</option>
<?php
	}
	if ($emptywrk && strval($test->dbkey->CurrentValue) <> "") {
?>
<option value="<?php echo ew_HtmlEncode($test->dbkey->CurrentValue) ?>" selected><?php echo $test->dbkey->CurrentValue ?></option>
<?php
    }
}
?>
</select>
<?php
$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.dbkey, `EW_TMP_LOOKUPTABLE`.`From Date` AS `DispFld`, `EW_TMP_LOOKUPTABLE`.`Through Date` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
$sWhereWrk = "";
$test->dbkey->LookupFilters = array("s" => $sSqlWrk, "d" => "");
$test->dbkey->LookupFilters += array("f0" => "tables_data.dbkey = {filter_value}", "t0" => "200", "fn0" => "");
$test->dbkey->LookupFilters += array("df1" => 5);
$test->dbkey->LookupFilters += array("df2" => 5);
$sSqlWrk = "";
$test->Lookup_Selecting($test->dbkey, $sWhereWrk); // Call Lookup selecting
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
if ($sSqlWrk <> "") $test->dbkey->LookupFilters["s"] .= $sSqlWrk;
?>
<input type="hidden" name="s_x_dbkey" id="s_x_dbkey" value="<?php echo $test->dbkey->LookupFilterQuery() ?>">
</span>
	</div>
<?php } ?>
</div>
<div id="xsr_2" class="ewRow">
<?php if ($test->description->Visible) { // description ?>
	<div id="xsc_description" class="ewCell form-group">
		<label for="x_description" class="ewSearchCaption ewLabel"><?php echo $test->description->FldCaption() ?></label>
		<span class="ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_description" id="z_description" value="="></span>
		<span class="ewSearchField">
<select data-table="test" data-field="x_description" data-value-separator="<?php echo ew_HtmlEncode(is_array($test->description->DisplayValueSeparator) ? json_encode($test->description->DisplayValueSeparator) : $test->description->DisplayValueSeparator) ?>" id="x_description" name="x_description"<?php echo $test->description->EditAttributes() ?>>
<?php
if (is_array($test->description->EditValue)) {
	$arwrk = $test->description->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = ew_SameStr($test->description->AdvancedSearch->SearchValue, $arwrk[$rowcntwrk][0]) ? " selected" : "";
		if ($selwrk <> "") $emptywrk = FALSE;		
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $test->description->DisplayValue($arwrk[$rowcntwrk]) ?>
</option>
<?php
	}
	if ($emptywrk && strval($test->description->CurrentValue) <> "") {
?>
<option value="<?php echo ew_HtmlEncode($test->description->CurrentValue) ?>" selected><?php echo $test->description->CurrentValue ?></option>
<?php
    }
}
?>
</select>
<?php
$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.description, `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
$sWhereWrk = "";
$test->description->LookupFilters = array("s" => $sSqlWrk, "d" => "");
$test->description->LookupFilters += array("f0" => "b.description = {filter_value}", "t0" => "200", "fn0" => "");
$sSqlWrk = "";
$test->Lookup_Selecting($test->description, $sWhereWrk); // Call Lookup selecting
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
if ($sSqlWrk <> "") $test->description->LookupFilters["s"] .= $sSqlWrk;
?>
<input type="hidden" name="s_x_description" id="s_x_description" value="<?php echo $test->description->LookupFilterQuery() ?>">
</span>
	</div>
<?php } ?>
</div>
<div id="xsr_3" class="ewRow">
<?php if ($test->First->Visible) { // First ?>
	<div id="xsc_First" class="ewCell form-group">
		<label for="x_First" class="ewSearchCaption ewLabel"><?php echo $test->First->FldCaption() ?></label>
		<span class="ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_First" id="z_First" value="="></span>
		<span class="ewSearchField">
<select data-table="test" data-field="x_First" data-value-separator="<?php echo ew_HtmlEncode(is_array($test->First->DisplayValueSeparator) ? json_encode($test->First->DisplayValueSeparator) : $test->First->DisplayValueSeparator) ?>" id="x_First" name="x_First"<?php echo $test->First->EditAttributes() ?>>
<?php
if (is_array($test->First->EditValue)) {
	$arwrk = $test->First->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = ew_SameStr($test->First->AdvancedSearch->SearchValue, $arwrk[$rowcntwrk][0]) ? " selected" : "";
		if ($selwrk <> "") $emptywrk = FALSE;		
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $test->First->DisplayValue($arwrk[$rowcntwrk]) ?>
</option>
<?php
	}
	if ($emptywrk && strval($test->First->CurrentValue) <> "") {
?>
<option value="<?php echo ew_HtmlEncode($test->First->CurrentValue) ?>" selected><?php echo $test->First->CurrentValue ?></option>
<?php
    }
}
?>
</select>
<?php
$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`First`, `EW_TMP_LOOKUPTABLE`.`First` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
$sWhereWrk = "";
$test->First->LookupFilters = array("s" => $sSqlWrk, "d" => "");
$test->First->LookupFilters += array("f0" => "`First` = {filter_value}", "t0" => "200", "fn0" => "");
$sSqlWrk = "";
$test->Lookup_Selecting($test->First, $sWhereWrk); // Call Lookup selecting
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
if ($sSqlWrk <> "") $test->First->LookupFilters["s"] .= $sSqlWrk;
?>
<input type="hidden" name="s_x_First" id="s_x_First" value="<?php echo $test->First->LookupFilterQuery() ?>">
</span>
	</div>
<?php } ?>
</div>
<div id="xsr_4" class="ewRow">
<?php if ($test->Last->Visible) { // Last ?>
	<div id="xsc_Last" class="ewCell form-group">
		<label for="x_Last" class="ewSearchCaption ewLabel"><?php echo $test->Last->FldCaption() ?></label>
		<span class="ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_Last" id="z_Last" value="="></span>
		<span class="ewSearchField">
<select data-table="test" data-field="x_Last" data-value-separator="<?php echo ew_HtmlEncode(is_array($test->Last->DisplayValueSeparator) ? json_encode($test->Last->DisplayValueSeparator) : $test->Last->DisplayValueSeparator) ?>" id="x_Last" name="x_Last"<?php echo $test->Last->EditAttributes() ?>>
<?php
if (is_array($test->Last->EditValue)) {
	$arwrk = $test->Last->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = ew_SameStr($test->Last->AdvancedSearch->SearchValue, $arwrk[$rowcntwrk][0]) ? " selected" : "";
		if ($selwrk <> "") $emptywrk = FALSE;		
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $test->Last->DisplayValue($arwrk[$rowcntwrk]) ?>
</option>
<?php
	}
	if ($emptywrk && strval($test->Last->CurrentValue) <> "") {
?>
<option value="<?php echo ew_HtmlEncode($test->Last->CurrentValue) ?>" selected><?php echo $test->Last->CurrentValue ?></option>
<?php
    }
}
?>
</select>
<?php
$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`Last`, `EW_TMP_LOOKUPTABLE`.`Last` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT b.description, tables_data.dbkey, counselor.first AS \"First\", counselor.last AS \"Last\", Sum(client_activity.time) AS \"Total Hours\", Year(client_activity.date) AS \"Year\", Week(client_activity.date) AS \"Week #\", Date(Date_Add(client_activity.date, INTERVAL (1 - DayOfWeek(client_activity.date)) DAY)) AS \"From Date\", Date_Add(client_activity.date, INTERVAL (7 - DayOfWeek(client_activity.date)) DAY) AS \"Through Date\", (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 6 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Sunday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 1 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Monday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 2 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Tuesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 3 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Wednesday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Thursday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 4 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Friday, (SELECT Sum(friday.time) FROM client_activity friday WHERE WEEKDAY(friday.date) = 5 AND friday.dbkey_councilor = client_activity.dbkey_councilor AND friday.date >= Min(client_activity.date) AND friday.date <= Max(client_activity.date) GROUP BY friday.dbkey_councilor) AS Saturday FROM client_activity, counselor, tables_data, tables_data b WHERE client_activity.dbkey_councilor = counselor.dbkey AND CAST(tables_data.dbkey AS CHAR) = CAST(Week(client_activity.date) AS CHAR) AND CAST(b.dbkey AS UNSIGNED) = CAST(Year(client_activity.date) AS UNSIGNED) AND tables_data.dbkey_tables = 'WEEK' AND b.dbkey_tables = 'YEAR' GROUP BY Year(client_activity.date), Week(client_activity.date), client_activity.dbkey_councilor ORDER BY b.description DESC, tables_data.dbkey DESC, client_activity.dbkey_councilor) AS `EW_TMP_LOOKUPTABLE`";
$sWhereWrk = "";
$test->Last->LookupFilters = array("s" => $sSqlWrk, "d" => "");
$test->Last->LookupFilters += array("f0" => "`Last` = {filter_value}", "t0" => "200", "fn0" => "");
$sSqlWrk = "";
$test->Lookup_Selecting($test->Last, $sWhereWrk); // Call Lookup selecting
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
if ($sSqlWrk <> "") $test->Last->LookupFilters["s"] .= $sSqlWrk;
?>
<input type="hidden" name="s_x_Last" id="s_x_Last" value="<?php echo $test->Last->LookupFilterQuery() ?>">
</span>
	</div>
<?php } ?>
</div>
<div id="xsr_5" class="ewRow">
	<button class="btn btn-primary ewButton" name="btnsubmit" id="btnsubmit" type="submit"><?php echo $Language->Phrase("QuickSearchBtn") ?></button>
</div>
	</div>
</div>
</form>
<?php } ?>
<?php } ?>
<?php $test_list->ShowPageHeader(); ?>
<?php
$test_list->ShowMessage();
?>
<?php if ($test_list->TotalRecs > 0 || $test->CurrentAction <> "") { ?>
<div class="panel panel-default ewGrid">
<form name="ftestlist" id="ftestlist" class="form-inline ewForm ewListForm" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($test_list->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $test_list->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="test">
<div id="gmp_test" class="<?php if (ew_IsResponsiveLayout()) { echo "table-responsive "; } ?>ewGridMiddlePanel">
<?php if ($test_list->TotalRecs > 0) { ?>
<table id="tbl_testlist" class="table ewTable">
<?php echo $test->TableCustomInnerHtml ?>
<thead><!-- Table header -->
	<tr class="ewTableHeader">
<?php

// Header row
$test_list->RowType = EW_ROWTYPE_HEADER;

// Render list options
$test_list->RenderListOptions();

// Render list options (header, left)
$test_list->ListOptions->Render("header", "left");
?>
<?php if ($test->dbkey->Visible) { // dbkey ?>
	<?php if ($test->SortUrl($test->dbkey) == "") { ?>
		<th data-name="dbkey"><div id="elh_test_dbkey" class="test_dbkey"><div class="ewTableHeaderCaption"><?php echo $test->dbkey->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="dbkey"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $test->SortUrl($test->dbkey) ?>',1);"><div id="elh_test_dbkey" class="test_dbkey">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $test->dbkey->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($test->dbkey->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($test->dbkey->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($test->description->Visible) { // description ?>
	<?php if ($test->SortUrl($test->description) == "") { ?>
		<th data-name="description"><div id="elh_test_description" class="test_description"><div class="ewTableHeaderCaption"><?php echo $test->description->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="description"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $test->SortUrl($test->description) ?>',1);"><div id="elh_test_description" class="test_description">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $test->description->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($test->description->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($test->description->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($test->First->Visible) { // First ?>
	<?php if ($test->SortUrl($test->First) == "") { ?>
		<th data-name="First"><div id="elh_test_First" class="test_First"><div class="ewTableHeaderCaption"><?php echo $test->First->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="First"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $test->SortUrl($test->First) ?>',1);"><div id="elh_test_First" class="test_First">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $test->First->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($test->First->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($test->First->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($test->Last->Visible) { // Last ?>
	<?php if ($test->SortUrl($test->Last) == "") { ?>
		<th data-name="Last"><div id="elh_test_Last" class="test_Last"><div class="ewTableHeaderCaption"><?php echo $test->Last->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Last"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $test->SortUrl($test->Last) ?>',1);"><div id="elh_test_Last" class="test_Last">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $test->Last->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($test->Last->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($test->Last->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($test->Total_Hours->Visible) { // Total Hours ?>
	<?php if ($test->SortUrl($test->Total_Hours) == "") { ?>
		<th data-name="Total_Hours"><div id="elh_test_Total_Hours" class="test_Total_Hours"><div class="ewTableHeaderCaption"><?php echo $test->Total_Hours->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Total_Hours"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $test->SortUrl($test->Total_Hours) ?>',1);"><div id="elh_test_Total_Hours" class="test_Total_Hours">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $test->Total_Hours->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($test->Total_Hours->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($test->Total_Hours->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($test->Monday->Visible) { // Monday ?>
	<?php if ($test->SortUrl($test->Monday) == "") { ?>
		<th data-name="Monday"><div id="elh_test_Monday" class="test_Monday"><div class="ewTableHeaderCaption"><?php echo $test->Monday->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="Monday"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $test->SortUrl($test->Monday) ?>',1);"><div id="elh_test_Monday" class="test_Monday">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $test->Monday->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($test->Monday->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($test->Monday->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php

// Render list options (header, right)
$test_list->ListOptions->Render("header", "right");
?>
	</tr>
</thead>
<tbody>
<?php
if ($test->ExportAll && $test->Export <> "") {
	$test_list->StopRec = $test_list->TotalRecs;
} else {

	// Set the last record to display
	if ($test_list->TotalRecs > $test_list->StartRec + $test_list->DisplayRecs - 1)
		$test_list->StopRec = $test_list->StartRec + $test_list->DisplayRecs - 1;
	else
		$test_list->StopRec = $test_list->TotalRecs;
}
$test_list->RecCnt = $test_list->StartRec - 1;
if ($test_list->Recordset && !$test_list->Recordset->EOF) {
	$test_list->Recordset->MoveFirst();
	$bSelectLimit = $test_list->UseSelectLimit;
	if (!$bSelectLimit && $test_list->StartRec > 1)
		$test_list->Recordset->Move($test_list->StartRec - 1);
} elseif (!$test->AllowAddDeleteRow && $test_list->StopRec == 0) {
	$test_list->StopRec = $test->GridAddRowCount;
}

// Initialize aggregate
$test->RowType = EW_ROWTYPE_AGGREGATEINIT;
$test->ResetAttrs();
$test_list->RenderRow();
while ($test_list->RecCnt < $test_list->StopRec) {
	$test_list->RecCnt++;
	if (intval($test_list->RecCnt) >= intval($test_list->StartRec)) {
		$test_list->RowCnt++;

		// Set up key count
		$test_list->KeyCount = $test_list->RowIndex;

		// Init row class and style
		$test->ResetAttrs();
		$test->CssClass = "";
		if ($test->CurrentAction == "gridadd") {
		} else {
			$test_list->LoadRowValues($test_list->Recordset); // Load row values
		}
		$test->RowType = EW_ROWTYPE_VIEW; // Render view

		// Set up row id / data-rowindex
		$test->RowAttrs = array_merge($test->RowAttrs, array('data-rowindex'=>$test_list->RowCnt, 'id'=>'r' . $test_list->RowCnt . '_test', 'data-rowtype'=>$test->RowType));

		// Render row
		$test_list->RenderRow();

		// Render list options
		$test_list->RenderListOptions();
?>
	<tr<?php echo $test->RowAttributes() ?>>
<?php

// Render list options (body, left)
$test_list->ListOptions->Render("body", "left", $test_list->RowCnt);
?>
	<?php if ($test->dbkey->Visible) { // dbkey ?>
		<td data-name="dbkey"<?php echo $test->dbkey->CellAttributes() ?>>
<span id="el<?php echo $test_list->RowCnt ?>_test_dbkey" class="test_dbkey">
<span<?php echo $test->dbkey->ViewAttributes() ?>>
<?php echo $test->dbkey->ListViewValue() ?></span>
</span>
<a id="<?php echo $test_list->PageObjName . "_row_" . $test_list->RowCnt ?>"></a></td>
	<?php } ?>
	<?php if ($test->description->Visible) { // description ?>
		<td data-name="description"<?php echo $test->description->CellAttributes() ?>>
<span id="el<?php echo $test_list->RowCnt ?>_test_description" class="test_description">
<span<?php echo $test->description->ViewAttributes() ?>>
<?php echo $test->description->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($test->First->Visible) { // First ?>
		<td data-name="First"<?php echo $test->First->CellAttributes() ?>>
<span id="el<?php echo $test_list->RowCnt ?>_test_First" class="test_First">
<span<?php echo $test->First->ViewAttributes() ?>>
<?php echo $test->First->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($test->Last->Visible) { // Last ?>
		<td data-name="Last"<?php echo $test->Last->CellAttributes() ?>>
<span id="el<?php echo $test_list->RowCnt ?>_test_Last" class="test_Last">
<span<?php echo $test->Last->ViewAttributes() ?>>
<?php echo $test->Last->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($test->Total_Hours->Visible) { // Total Hours ?>
		<td data-name="Total_Hours"<?php echo $test->Total_Hours->CellAttributes() ?>>
<span id="el<?php echo $test_list->RowCnt ?>_test_Total_Hours" class="test_Total_Hours">
<span<?php echo $test->Total_Hours->ViewAttributes() ?>>
<?php echo $test->Total_Hours->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($test->Monday->Visible) { // Monday ?>
		<td data-name="Monday"<?php echo $test->Monday->CellAttributes() ?>>
<span id="el<?php echo $test_list->RowCnt ?>_test_Monday" class="test_Monday">
<span<?php echo $test->Monday->ViewAttributes() ?>>
<?php echo $test->Monday->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
<?php

// Render list options (body, right)
$test_list->ListOptions->Render("body", "right", $test_list->RowCnt);
?>
	</tr>
<?php
	}
	if ($test->CurrentAction <> "gridadd")
		$test_list->Recordset->MoveNext();
}
?>
</tbody>
</table>
<?php } ?>
<?php if ($test->CurrentAction == "") { ?>
<input type="hidden" name="a_list" id="a_list" value="">
<?php } ?>
</div>
</form>
<?php

// Close recordset
if ($test_list->Recordset)
	$test_list->Recordset->Close();
?>
<?php if ($test->Export == "") { ?>
<div class="panel-footer ewGridLowerPanel">
<?php if ($test->CurrentAction <> "gridadd" && $test->CurrentAction <> "gridedit") { ?>
<form name="ewPagerForm" class="ewForm form-inline ewPagerForm" action="<?php echo ew_CurrentPage() ?>">
<?php if (!isset($test_list->Pager)) $test_list->Pager = new cPrevNextPager($test_list->StartRec, $test_list->DisplayRecs, $test_list->TotalRecs) ?>
<?php if ($test_list->Pager->RecordCount > 0) { ?>
<div class="ewPager">
<span><?php echo $Language->Phrase("Page") ?>&nbsp;</span>
<div class="ewPrevNext"><div class="input-group">
<div class="input-group-btn">
<!--first page button-->
	<?php if ($test_list->Pager->FirstButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerFirst") ?>" href="<?php echo $test_list->PageUrl() ?>start=<?php echo $test_list->Pager->FirstButton->Start ?>"><span class="icon-first ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerFirst") ?>"><span class="icon-first ewIcon"></span></a>
	<?php } ?>
<!--previous page button-->
	<?php if ($test_list->Pager->PrevButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerPrevious") ?>" href="<?php echo $test_list->PageUrl() ?>start=<?php echo $test_list->Pager->PrevButton->Start ?>"><span class="icon-prev ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerPrevious") ?>"><span class="icon-prev ewIcon"></span></a>
	<?php } ?>
</div>
<!--current page number-->
	<input class="form-control input-sm" type="text" name="<?php echo EW_TABLE_PAGE_NO ?>" value="<?php echo $test_list->Pager->CurrentPage ?>">
<div class="input-group-btn">
<!--next page button-->
	<?php if ($test_list->Pager->NextButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerNext") ?>" href="<?php echo $test_list->PageUrl() ?>start=<?php echo $test_list->Pager->NextButton->Start ?>"><span class="icon-next ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerNext") ?>"><span class="icon-next ewIcon"></span></a>
	<?php } ?>
<!--last page button-->
	<?php if ($test_list->Pager->LastButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerLast") ?>" href="<?php echo $test_list->PageUrl() ?>start=<?php echo $test_list->Pager->LastButton->Start ?>"><span class="icon-last ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerLast") ?>"><span class="icon-last ewIcon"></span></a>
	<?php } ?>
</div>
</div>
</div>
<span>&nbsp;<?php echo $Language->Phrase("of") ?>&nbsp;<?php echo $test_list->Pager->PageCount ?></span>
</div>
<div class="ewPager ewRec">
	<span><?php echo $Language->Phrase("Record") ?>&nbsp;<?php echo $test_list->Pager->FromIndex ?>&nbsp;<?php echo $Language->Phrase("To") ?>&nbsp;<?php echo $test_list->Pager->ToIndex ?>&nbsp;<?php echo $Language->Phrase("Of") ?>&nbsp;<?php echo $test_list->Pager->RecordCount ?></span>
</div>
<?php } ?>
</form>
<?php } ?>
<div class="ewListOtherOptions">
<?php
	foreach ($test_list->OtherOptions as &$option)
		$option->Render("body", "bottom");
?>
</div>
<div class="clearfix"></div>
</div>
<?php } ?>
</div>
<?php } ?>
<?php if ($test_list->TotalRecs == 0 && $test->CurrentAction == "") { // Show other options ?>
<div class="ewListOtherOptions">
<?php
	foreach ($test_list->OtherOptions as &$option) {
		$option->ButtonClass = "";
		$option->Render("body", "");
	}
?>
</div>
<div class="clearfix"></div>
<?php } ?>
<?php if ($test->Export == "") { ?>
<script type="text/javascript">
ftestlistsrch.Init();
ftestlistsrch.FilterList = <?php echo $test_list->GetFilterList() ?>;
ftestlist.Init();
</script>
<?php } ?>
<?php
$test_list->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<?php if ($test->Export == "") { ?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php } ?>
<?php include_once "footer.php" ?>
<?php
$test_list->Page_Terminate();
?>
