<?php

// Global variable for table object
$time_entry_2 = NULL;

//
// Table class for time_entry_2
//
class ctime_entry_2 extends cTable {
	var $dbkey;
	var $dbkey_counselor;
	var $week_range;
	var $create_date;
	var $over_time;
	var $sunday_time_in;
	var $sunday_time_out;
	var $monday_time_in;
	var $monday_time_out;
	var $tuesday_time_in;
	var $tuesday_time_out;
	var $wednesday_time_in;
	var $wednesday_time_out;
	var $thursday_time_in;
	var $thursday_time_out;
	var $friday_time_in;
	var $friday_time_out;
	var $saturday_time_in;
	var $saturday_time_out;
	var $dbkey_hr_approver;
	var $hr_approved;
	var $hr_approved_date;
	var $date_time_created;

	//
	// Table class constructor
	//
	function __construct() {
		global $Language;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();
		$this->TableVar = 'time_entry_2';
		$this->TableName = 'time_entry_2';
		$this->TableType = 'TABLE';

		// Update Table
		$this->UpdateTable = "`time_entry_2`";
		$this->DBID = 'DB';
		$this->ExportAll = TRUE;
		$this->ExportPageBreakCount = 0; // Page break per every n record (PDF only)
		$this->ExportPageOrientation = "portrait"; // Page orientation (PDF only)
		$this->ExportPageSize = "a4"; // Page size (PDF only)
		$this->ExportExcelPageOrientation = ""; // Page orientation (PHPExcel only)
		$this->ExportExcelPageSize = ""; // Page size (PHPExcel only)
		$this->DetailAdd = FALSE; // Allow detail add
		$this->DetailEdit = FALSE; // Allow detail edit
		$this->DetailView = FALSE; // Allow detail view
		$this->ShowMultipleDetails = FALSE; // Show multiple details
		$this->GridAddRowCount = 5;
		$this->AllowAddDeleteRow = ew_AllowAddDeleteRow(); // Allow add/delete row
		$this->UserIDAllowSecurity = 0; // User ID Allow
		$this->BasicSearch = new cBasicSearch($this->TableVar);

		// dbkey
		$this->dbkey = new cField('time_entry_2', 'time_entry_2', 'x_dbkey', 'dbkey', '`dbkey`', '`dbkey`', 3, -1, FALSE, '`dbkey`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'NO');
		$this->dbkey->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey'] = &$this->dbkey;

		// dbkey_counselor
		$this->dbkey_counselor = new cField('time_entry_2', 'time_entry_2', 'x_dbkey_counselor', 'dbkey_counselor', '`dbkey_counselor`', '`dbkey_counselor`', 3, -1, FALSE, '`dbkey_counselor`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_counselor->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_counselor'] = &$this->dbkey_counselor;

		// week_range
		$this->week_range = new cField('time_entry_2', 'time_entry_2', 'x_week_range', 'week_range', 'concat(create_date,\',\',Date_Add(create_date, INTERVAL 6 DAY))', 'concat(create_date,\',\',Date_Add(create_date, INTERVAL 6 DAY))', 200, -1, FALSE, 'concat(create_date,\',\',Date_Add(create_date, INTERVAL 6 DAY))', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->week_range->FldIsCustom = TRUE; // Custom field
		$this->week_range->FldDefaultErrMsg = str_replace("%s", "/", $Language->Phrase("IncorrectDateYMD"));
		$this->fields['week_range'] = &$this->week_range;

		// create_date
		$this->create_date = new cField('time_entry_2', 'time_entry_2', 'x_create_date', 'create_date', '`create_date`', 'DATE_FORMAT(`create_date`, \'%Y/%m/%d\')', 133, 5, FALSE, '`create_date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->create_date->FldDefaultErrMsg = str_replace("%s", "/", $Language->Phrase("IncorrectDateYMD"));
		$this->fields['create_date'] = &$this->create_date;

		// over_time
		$this->over_time = new cField('time_entry_2', 'time_entry_2', 'x_over_time', 'over_time', '`over_time`', '`over_time`', 16, -1, FALSE, '`over_time`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->over_time->OptionCount = 2;
		$this->fields['over_time'] = &$this->over_time;

		// sunday_time_in
		$this->sunday_time_in = new cField('time_entry_2', 'time_entry_2', 'x_sunday_time_in', 'sunday_time_in', '`sunday_time_in`', 'DATE_FORMAT(`sunday_time_in`, \'%Y/%m/%d\')', 134, 4, FALSE, '`sunday_time_in`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->sunday_time_in->FldDefaultErrMsg = $Language->Phrase("IncorrectTime");
		$this->fields['sunday_time_in'] = &$this->sunday_time_in;

		// sunday_time_out
		$this->sunday_time_out = new cField('time_entry_2', 'time_entry_2', 'x_sunday_time_out', 'sunday_time_out', '`sunday_time_out`', 'DATE_FORMAT(`sunday_time_out`, \'%Y/%m/%d\')', 134, -1, FALSE, '`sunday_time_out`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->sunday_time_out->FldDefaultErrMsg = $Language->Phrase("IncorrectTime");
		$this->fields['sunday_time_out'] = &$this->sunday_time_out;

		// monday_time_in
		$this->monday_time_in = new cField('time_entry_2', 'time_entry_2', 'x_monday_time_in', 'monday_time_in', '`monday_time_in`', 'DATE_FORMAT(`monday_time_in`, \'%Y/%m/%d\')', 134, -1, FALSE, '`monday_time_in`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->monday_time_in->FldDefaultErrMsg = $Language->Phrase("IncorrectTime");
		$this->fields['monday_time_in'] = &$this->monday_time_in;

		// monday_time_out
		$this->monday_time_out = new cField('time_entry_2', 'time_entry_2', 'x_monday_time_out', 'monday_time_out', '`monday_time_out`', 'DATE_FORMAT(`monday_time_out`, \'%Y/%m/%d\')', 134, -1, FALSE, '`monday_time_out`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->monday_time_out->FldDefaultErrMsg = $Language->Phrase("IncorrectTime");
		$this->fields['monday_time_out'] = &$this->monday_time_out;

		// tuesday_time_in
		$this->tuesday_time_in = new cField('time_entry_2', 'time_entry_2', 'x_tuesday_time_in', 'tuesday_time_in', '`tuesday_time_in`', 'DATE_FORMAT(`tuesday_time_in`, \'%Y/%m/%d\')', 134, -1, FALSE, '`tuesday_time_in`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->tuesday_time_in->FldDefaultErrMsg = $Language->Phrase("IncorrectTime");
		$this->fields['tuesday_time_in'] = &$this->tuesday_time_in;

		// tuesday_time_out
		$this->tuesday_time_out = new cField('time_entry_2', 'time_entry_2', 'x_tuesday_time_out', 'tuesday_time_out', '`tuesday_time_out`', 'DATE_FORMAT(`tuesday_time_out`, \'%Y/%m/%d\')', 134, -1, FALSE, '`tuesday_time_out`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->tuesday_time_out->FldDefaultErrMsg = $Language->Phrase("IncorrectTime");
		$this->fields['tuesday_time_out'] = &$this->tuesday_time_out;

		// wednesday_time_in
		$this->wednesday_time_in = new cField('time_entry_2', 'time_entry_2', 'x_wednesday_time_in', 'wednesday_time_in', '`wednesday_time_in`', 'DATE_FORMAT(`wednesday_time_in`, \'%Y/%m/%d\')', 134, -1, FALSE, '`wednesday_time_in`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->wednesday_time_in->FldDefaultErrMsg = $Language->Phrase("IncorrectTime");
		$this->fields['wednesday_time_in'] = &$this->wednesday_time_in;

		// wednesday_time_out
		$this->wednesday_time_out = new cField('time_entry_2', 'time_entry_2', 'x_wednesday_time_out', 'wednesday_time_out', '`wednesday_time_out`', 'DATE_FORMAT(`wednesday_time_out`, \'%Y/%m/%d\')', 134, -1, FALSE, '`wednesday_time_out`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->wednesday_time_out->FldDefaultErrMsg = $Language->Phrase("IncorrectTime");
		$this->fields['wednesday_time_out'] = &$this->wednesday_time_out;

		// thursday_time_in
		$this->thursday_time_in = new cField('time_entry_2', 'time_entry_2', 'x_thursday_time_in', 'thursday_time_in', '`thursday_time_in`', 'DATE_FORMAT(`thursday_time_in`, \'%Y/%m/%d\')', 134, -1, FALSE, '`thursday_time_in`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->thursday_time_in->FldDefaultErrMsg = $Language->Phrase("IncorrectTime");
		$this->fields['thursday_time_in'] = &$this->thursday_time_in;

		// thursday_time_out
		$this->thursday_time_out = new cField('time_entry_2', 'time_entry_2', 'x_thursday_time_out', 'thursday_time_out', '`thursday_time_out`', 'DATE_FORMAT(`thursday_time_out`, \'%Y/%m/%d\')', 134, -1, FALSE, '`thursday_time_out`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->thursday_time_out->FldDefaultErrMsg = $Language->Phrase("IncorrectTime");
		$this->fields['thursday_time_out'] = &$this->thursday_time_out;

		// friday_time_in
		$this->friday_time_in = new cField('time_entry_2', 'time_entry_2', 'x_friday_time_in', 'friday_time_in', '`friday_time_in`', 'DATE_FORMAT(`friday_time_in`, \'%Y/%m/%d\')', 134, -1, FALSE, '`friday_time_in`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->friday_time_in->FldDefaultErrMsg = $Language->Phrase("IncorrectTime");
		$this->fields['friday_time_in'] = &$this->friday_time_in;

		// friday_time_out
		$this->friday_time_out = new cField('time_entry_2', 'time_entry_2', 'x_friday_time_out', 'friday_time_out', '`friday_time_out`', 'DATE_FORMAT(`friday_time_out`, \'%Y/%m/%d\')', 134, -1, FALSE, '`friday_time_out`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->friday_time_out->FldDefaultErrMsg = $Language->Phrase("IncorrectTime");
		$this->fields['friday_time_out'] = &$this->friday_time_out;

		// saturday_time_in
		$this->saturday_time_in = new cField('time_entry_2', 'time_entry_2', 'x_saturday_time_in', 'saturday_time_in', '`saturday_time_in`', 'DATE_FORMAT(`saturday_time_in`, \'%Y/%m/%d\')', 134, -1, FALSE, '`saturday_time_in`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->saturday_time_in->FldDefaultErrMsg = $Language->Phrase("IncorrectTime");
		$this->fields['saturday_time_in'] = &$this->saturday_time_in;

		// saturday_time_out
		$this->saturday_time_out = new cField('time_entry_2', 'time_entry_2', 'x_saturday_time_out', 'saturday_time_out', '`saturday_time_out`', 'DATE_FORMAT(`saturday_time_out`, \'%Y/%m/%d\')', 134, -1, FALSE, '`saturday_time_out`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->saturday_time_out->FldDefaultErrMsg = $Language->Phrase("IncorrectTime");
		$this->fields['saturday_time_out'] = &$this->saturday_time_out;

		// dbkey_hr_approver
		$this->dbkey_hr_approver = new cField('time_entry_2', 'time_entry_2', 'x_dbkey_hr_approver', 'dbkey_hr_approver', '`dbkey_hr_approver`', '`dbkey_hr_approver`', 3, -1, FALSE, '`dbkey_hr_approver`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'HIDDEN');
		$this->dbkey_hr_approver->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_hr_approver'] = &$this->dbkey_hr_approver;

		// hr_approved
		$this->hr_approved = new cField('time_entry_2', 'time_entry_2', 'x_hr_approved', 'hr_approved', '`hr_approved`', '`hr_approved`', 16, -1, FALSE, '`hr_approved`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->hr_approved->OptionCount = 2;
		$this->hr_approved->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['hr_approved'] = &$this->hr_approved;

		// hr_approved_date
		$this->hr_approved_date = new cField('time_entry_2', 'time_entry_2', 'x_hr_approved_date', 'hr_approved_date', '`hr_approved_date`', 'DATE_FORMAT(`hr_approved_date`, \'%Y/%m/%d\')', 135, 5, FALSE, '`hr_approved_date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'HIDDEN');
		$this->hr_approved_date->FldDefaultErrMsg = str_replace("%s", "/", $Language->Phrase("IncorrectDateYMD"));
		$this->fields['hr_approved_date'] = &$this->hr_approved_date;

		// date_time_created
		$this->date_time_created = new cField('time_entry_2', 'time_entry_2', 'x_date_time_created', 'date_time_created', '`date_time_created`', 'DATE_FORMAT(`date_time_created`, \'%Y/%m/%d\')', 135, 5, FALSE, '`date_time_created`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'HIDDEN');
		$this->date_time_created->FldDefaultErrMsg = str_replace("%s", "/", $Language->Phrase("IncorrectDateYMD"));
		$this->fields['date_time_created'] = &$this->date_time_created;
	}

	// Single column sort
	function UpdateSort(&$ofld) {
		if ($this->CurrentOrder == $ofld->FldName) {
			$sSortField = $ofld->FldExpression;
			$sLastSort = $ofld->getSort();
			if ($this->CurrentOrderType == "ASC" || $this->CurrentOrderType == "DESC") {
				$sThisSort = $this->CurrentOrderType;
			} else {
				$sThisSort = ($sLastSort == "ASC") ? "DESC" : "ASC";
			}
			$ofld->setSort($sThisSort);
			$this->setSessionOrderBy($sSortField . " " . $sThisSort); // Save to Session
		} else {
			$ofld->setSort("");
		}
	}

	// Table level SQL
	var $_SqlFrom = "";

	function getSqlFrom() { // From
		return ($this->_SqlFrom <> "") ? $this->_SqlFrom : "`time_entry_2`";
	}

	function SqlFrom() { // For backward compatibility
    	return $this->getSqlFrom();
	}

	function setSqlFrom($v) {
    	$this->_SqlFrom = $v;
	}
	var $_SqlSelect = "";

	function getSqlSelect() { // Select
		return ($this->_SqlSelect <> "") ? $this->_SqlSelect : "SELECT *, concat(create_date,',',Date_Add(create_date, INTERVAL 6 DAY)) AS `week_range` FROM " . $this->getSqlFrom();
	}

	function SqlSelect() { // For backward compatibility
    	return $this->getSqlSelect();
	}

	function setSqlSelect($v) {
    	$this->_SqlSelect = $v;
	}
	var $_SqlWhere = "";

	function getSqlWhere() { // Where
		$sWhere = ($this->_SqlWhere <> "") ? $this->_SqlWhere : "";
		$this->TableFilter = "";
		ew_AddFilter($sWhere, $this->TableFilter);
		return $sWhere;
	}

	function SqlWhere() { // For backward compatibility
    	return $this->getSqlWhere();
	}

	function setSqlWhere($v) {
    	$this->_SqlWhere = $v;
	}
	var $_SqlGroupBy = "";

	function getSqlGroupBy() { // Group By
		return ($this->_SqlGroupBy <> "") ? $this->_SqlGroupBy : "";
	}

	function SqlGroupBy() { // For backward compatibility
    	return $this->getSqlGroupBy();
	}

	function setSqlGroupBy($v) {
    	$this->_SqlGroupBy = $v;
	}
	var $_SqlHaving = "";

	function getSqlHaving() { // Having
		return ($this->_SqlHaving <> "") ? $this->_SqlHaving : "";
	}

	function SqlHaving() { // For backward compatibility
    	return $this->getSqlHaving();
	}

	function setSqlHaving($v) {
    	$this->_SqlHaving = $v;
	}
	var $_SqlOrderBy = "";

	function getSqlOrderBy() { // Order By
		return ($this->_SqlOrderBy <> "") ? $this->_SqlOrderBy : "";
	}

	function SqlOrderBy() { // For backward compatibility
    	return $this->getSqlOrderBy();
	}

	function setSqlOrderBy($v) {
    	$this->_SqlOrderBy = $v;
	}

	// Apply User ID filters
	function ApplyUserIDFilters($sFilter) {
		global $Security;

		// Add User ID filter
		if ($Security->CurrentUserID() <> "" && !$Security->IsAdmin()) { // Non system admin
			$sFilter = $this->AddUserIDFilter($sFilter);
		}
		return $sFilter;
	}

	// Check if User ID security allows view all
	function UserIDAllow($id = "") {
		$allow = $this->UserIDAllowSecurity;
		switch ($id) {
			case "add":
			case "copy":
			case "gridadd":
			case "register":
			case "addopt":
				return (($allow & 1) == 1);
			case "edit":
			case "gridedit":
			case "update":
			case "changepwd":
			case "forgotpwd":
				return (($allow & 4) == 4);
			case "delete":
				return (($allow & 2) == 2);
			case "view":
				return (($allow & 32) == 32);
			case "search":
				return (($allow & 64) == 64);
			default:
				return (($allow & 8) == 8);
		}
	}

	// Get SQL
	function GetSQL($where, $orderby) {
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$where, $orderby);
	}

	// Table SQL
	function SQL() {
		$sFilter = $this->CurrentFilter;
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$sFilter, $sSort);
	}

	// Table SQL with List page filter
	function SelectSQL() {
		$sFilter = $this->getSessionWhere();
		ew_AddFilter($sFilter, $this->CurrentFilter);
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$this->Recordset_Selecting($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(), $this->getSqlGroupBy(),
			$this->getSqlHaving(), $this->getSqlOrderBy(), $sFilter, $sSort);
	}

	// Get ORDER BY clause
	function GetOrderBy() {
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql("", "", "", "", $this->getSqlOrderBy(), "", $sSort);
	}

	// Try to get record count
	function TryGetRecordCount($sSql) {
		$cnt = -1;
		if (($this->TableType == 'TABLE' || $this->TableType == 'VIEW' || $this->TableType == 'LINKTABLE') && preg_match("/^SELECT \* FROM/i", $sSql)) {
			$sSql = "SELECT COUNT(*) FROM" . preg_replace('/^SELECT\s([\s\S]+)?\*\sFROM/i', "", $sSql);
			$sOrderBy = $this->GetOrderBy();
			if (substr($sSql, strlen($sOrderBy) * -1) == $sOrderBy)
				$sSql = substr($sSql, 0, strlen($sSql) - strlen($sOrderBy)); // Remove ORDER BY clause
		} else {
			$sSql = "SELECT COUNT(*) FROM (" . $sSql . ") EW_COUNT_TABLE";
		}
		$conn = &$this->Connection();
		if ($rs = $conn->Execute($sSql)) {
			if (!$rs->EOF && $rs->FieldCount() > 0) {
				$cnt = $rs->fields[0];
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// Get record count based on filter (for detail record count in master table pages)
	function LoadRecordCount($sFilter) {
		$origFilter = $this->CurrentFilter;
		$this->CurrentFilter = $sFilter;
		$this->Recordset_Selecting($this->CurrentFilter);

		//$sSql = $this->SQL();
		$sSql = $this->GetSQL($this->CurrentFilter, "");
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			if ($rs = $this->LoadRs($this->CurrentFilter)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		$this->CurrentFilter = $origFilter;
		return intval($cnt);
	}

	// Get record count (for current List page)
	function SelectRecordCount() {
		$sSql = $this->SelectSQL();
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			$conn = &$this->Connection();
			if ($rs = $conn->Execute($sSql)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// INSERT statement
	function InsertSQL(&$rs) {
		$names = "";
		$values = "";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$names .= $this->fields[$name]->FldExpression . ",";
			$values .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($names, -1) == ",")
			$names = substr($names, 0, -1);
		while (substr($values, -1) == ",")
			$values = substr($values, 0, -1);
		return "INSERT INTO " . $this->UpdateTable . " ($names) VALUES ($values)";
	}

	// Insert
	function Insert(&$rs) {
		$conn = &$this->Connection();
		return $conn->Execute($this->InsertSQL($rs));
	}

	// UPDATE statement
	function UpdateSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "UPDATE " . $this->UpdateTable . " SET ";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$sql .= $this->fields[$name]->FldExpression . "=";
			$sql .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($sql, -1) == ",")
			$sql = substr($sql, 0, -1);
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		ew_AddFilter($filter, $where);
		if ($filter <> "")	$sql .= " WHERE " . $filter;
		return $sql;
	}

	// Update
	function Update(&$rs, $where = "", $rsold = NULL, $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->UpdateSQL($rs, $where, $curfilter));
	}

	// DELETE statement
	function DeleteSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "DELETE FROM " . $this->UpdateTable . " WHERE ";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		if ($rs) {
			if (array_key_exists('dbkey', $rs))
				ew_AddFilter($where, ew_QuotedName('dbkey', $this->DBID) . '=' . ew_QuotedValue($rs['dbkey'], $this->dbkey->FldDataType, $this->DBID));
		}
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		ew_AddFilter($filter, $where);
		if ($filter <> "")
			$sql .= $filter;
		else
			$sql .= "0=1"; // Avoid delete
		return $sql;
	}

	// Delete
	function Delete(&$rs, $where = "", $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->DeleteSQL($rs, $where, $curfilter));
	}

	// Key filter WHERE clause
	function SqlKeyFilter() {
		return "`dbkey` = @dbkey@";
	}

	// Key filter
	function KeyFilter() {
		$sKeyFilter = $this->SqlKeyFilter();
		if (!is_numeric($this->dbkey->CurrentValue))
			$sKeyFilter = "0=1"; // Invalid key
		$sKeyFilter = str_replace("@dbkey@", ew_AdjustSql($this->dbkey->CurrentValue, $this->DBID), $sKeyFilter); // Replace key value
		return $sKeyFilter;
	}

	// Return page URL
	function getReturnUrl() {
		$name = EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL;

		// Get referer URL automatically
		if (ew_ServerVar("HTTP_REFERER") <> "" && ew_ReferPage() <> ew_CurrentPage() && ew_ReferPage() <> "login.php") // Referer not same page or login page
			$_SESSION[$name] = ew_ServerVar("HTTP_REFERER"); // Save to Session
		if (@$_SESSION[$name] <> "") {
			return $_SESSION[$name];
		} else {
			return "time_entry_2list.php";
		}
	}

	function setReturnUrl($v) {
		$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL] = $v;
	}

	// List URL
	function GetListUrl() {
		return "time_entry_2list.php";
	}

	// View URL
	function GetViewUrl($parm = "") {
		if ($parm <> "")
			$url = $this->KeyUrl("time_entry_2view.php", $this->UrlParm($parm));
		else
			$url = $this->KeyUrl("time_entry_2view.php", $this->UrlParm(EW_TABLE_SHOW_DETAIL . "="));
		return $this->AddMasterUrl($url);
	}

	// Add URL
	function GetAddUrl($parm = "") {
		if ($parm <> "")
			$url = "time_entry_2add.php?" . $this->UrlParm($parm);
		else
			$url = "time_entry_2add.php";
		return $this->AddMasterUrl($url);
	}

	// Edit URL
	function GetEditUrl($parm = "") {
		$url = $this->KeyUrl("time_entry_2edit.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline edit URL
	function GetInlineEditUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=edit"));
		return $this->AddMasterUrl($url);
	}

	// Copy URL
	function GetCopyUrl($parm = "") {
		$url = $this->KeyUrl("time_entry_2add.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline copy URL
	function GetInlineCopyUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=copy"));
		return $this->AddMasterUrl($url);
	}

	// Delete URL
	function GetDeleteUrl() {
		return $this->KeyUrl("time_entry_2delete.php", $this->UrlParm());
	}

	// Add master url
	function AddMasterUrl($url) {
		return $url;
	}

	function KeyToJson() {
		$json = "";
		$json .= "dbkey:" . ew_VarToJson($this->dbkey->CurrentValue, "number", "'");
		return "{" . $json . "}";
	}

	// Add key value to URL
	function KeyUrl($url, $parm = "") {
		$sUrl = $url . "?";
		if ($parm <> "") $sUrl .= $parm . "&";
		if (!is_null($this->dbkey->CurrentValue)) {
			$sUrl .= "dbkey=" . urlencode($this->dbkey->CurrentValue);
		} else {
			return "javascript:ew_Alert(ewLanguage.Phrase('InvalidRecord'));";
		}
		return $sUrl;
	}

	// Sort URL
	function SortUrl(&$fld) {
		if ($this->CurrentAction <> "" || $this->Export <> "" ||
			in_array($fld->FldType, array(128, 204, 205))) { // Unsortable data type
				return "";
		} elseif ($fld->Sortable) {
			$sUrlParm = $this->UrlParm("order=" . urlencode($fld->FldName) . "&amp;ordertype=" . $fld->ReverseSort());
			return ew_CurrentPage() . "?" . $sUrlParm;
		} else {
			return "";
		}
	}

	// Get record keys from $_POST/$_GET/$_SESSION
	function GetRecordKeys() {
		global $EW_COMPOSITE_KEY_SEPARATOR;
		$arKeys = array();
		$arKey = array();
		if (isset($_POST["key_m"])) {
			$arKeys = ew_StripSlashes($_POST["key_m"]);
			$cnt = count($arKeys);
		} elseif (isset($_GET["key_m"])) {
			$arKeys = ew_StripSlashes($_GET["key_m"]);
			$cnt = count($arKeys);
		} elseif (!empty($_GET) || !empty($_POST)) {
			$isPost = ew_IsHttpPost();
			if ($isPost && isset($_POST["dbkey"]))
				$arKeys[] = ew_StripSlashes($_POST["dbkey"]);
			elseif (isset($_GET["dbkey"]))
				$arKeys[] = ew_StripSlashes($_GET["dbkey"]);
			else
				$arKeys = NULL; // Do not setup

			//return $arKeys; // Do not return yet, so the values will also be checked by the following code
		}

		// Check keys
		$ar = array();
		if (is_array($arKeys)) {
			foreach ($arKeys as $key) {
				if (!is_numeric($key))
					continue;
				$ar[] = $key;
			}
		}
		return $ar;
	}

	// Get key filter
	function GetKeyFilter() {
		$arKeys = $this->GetRecordKeys();
		$sKeyFilter = "";
		foreach ($arKeys as $key) {
			if ($sKeyFilter <> "") $sKeyFilter .= " OR ";
			$this->dbkey->CurrentValue = $key;
			$sKeyFilter .= "(" . $this->KeyFilter() . ")";
		}
		return $sKeyFilter;
	}

	// Load rows based on filter
	function &LoadRs($sFilter) {

		// Set up filter (SQL WHERE clause) and get return SQL
		//$this->CurrentFilter = $sFilter;
		//$sSql = $this->SQL();

		$sSql = $this->GetSQL($sFilter, "");
		$conn = &$this->Connection();
		$rs = $conn->Execute($sSql);
		return $rs;
	}

	// Load row values from recordset
	function LoadListRowValues(&$rs) {
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->dbkey_counselor->setDbValue($rs->fields('dbkey_counselor'));
		$this->week_range->setDbValue($rs->fields('week_range'));
		$this->create_date->setDbValue($rs->fields('create_date'));
		$this->over_time->setDbValue($rs->fields('over_time'));
		$this->sunday_time_in->setDbValue($rs->fields('sunday_time_in'));
		$this->sunday_time_out->setDbValue($rs->fields('sunday_time_out'));
		$this->monday_time_in->setDbValue($rs->fields('monday_time_in'));
		$this->monday_time_out->setDbValue($rs->fields('monday_time_out'));
		$this->tuesday_time_in->setDbValue($rs->fields('tuesday_time_in'));
		$this->tuesday_time_out->setDbValue($rs->fields('tuesday_time_out'));
		$this->wednesday_time_in->setDbValue($rs->fields('wednesday_time_in'));
		$this->wednesday_time_out->setDbValue($rs->fields('wednesday_time_out'));
		$this->thursday_time_in->setDbValue($rs->fields('thursday_time_in'));
		$this->thursday_time_out->setDbValue($rs->fields('thursday_time_out'));
		$this->friday_time_in->setDbValue($rs->fields('friday_time_in'));
		$this->friday_time_out->setDbValue($rs->fields('friday_time_out'));
		$this->saturday_time_in->setDbValue($rs->fields('saturday_time_in'));
		$this->saturday_time_out->setDbValue($rs->fields('saturday_time_out'));
		$this->dbkey_hr_approver->setDbValue($rs->fields('dbkey_hr_approver'));
		$this->hr_approved->setDbValue($rs->fields('hr_approved'));
		$this->hr_approved_date->setDbValue($rs->fields('hr_approved_date'));
		$this->date_time_created->setDbValue($rs->fields('date_time_created'));
	}

	// Render list row values
	function RenderListRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

   // Common render codes
		// dbkey

		$this->dbkey->CellCssStyle = "white-space: nowrap;";

		// dbkey_counselor
		$this->dbkey_counselor->CellCssStyle = "white-space: nowrap;";

		// week_range
		// create_date

		$this->create_date->CellCssStyle = "white-space: nowrap;";

		// over_time
		// sunday_time_in
		// sunday_time_out
		// monday_time_in
		// monday_time_out
		// tuesday_time_in
		// tuesday_time_out
		// wednesday_time_in
		// wednesday_time_out
		// thursday_time_in
		// thursday_time_out
		// friday_time_in
		// friday_time_out
		// saturday_time_in
		// saturday_time_out
		// dbkey_hr_approver
		// hr_approved
		// hr_approved_date
		// date_time_created

		$this->date_time_created->CellCssStyle = "white-space: nowrap;";

		// dbkey
		$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// dbkey_counselor
		if (strval($this->dbkey_counselor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_counselor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_counselor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_counselor->ViewValue = $this->dbkey_counselor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_counselor->ViewValue = $this->dbkey_counselor->CurrentValue;
			}
		} else {
			$this->dbkey_counselor->ViewValue = NULL;
		}
		$this->dbkey_counselor->ViewCustomAttributes = "";

		// week_range
		if (strval($this->week_range->CurrentValue) <> "") {
			$sFilterWrk = "concat(create_date,',',Date_Add(create_date, INTERVAL 6 DAY))" . ew_SearchString("=", $this->week_range->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT concat(create_date,',',Date_Add(create_date, INTERVAL 6 DAY)), concat(create_date,',',Date_Add(create_date, INTERVAL 6 DAY)) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `time_entry_2`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->week_range, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `create_date` DESC";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->week_range->ViewValue = $this->week_range->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->week_range->ViewValue = $this->week_range->CurrentValue;
			}
		} else {
			$this->week_range->ViewValue = NULL;
		}
		$this->week_range->ViewCustomAttributes = "";

		// create_date
		if (strval($this->create_date->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.`first_day_of_week`" . ew_SearchString("=", $this->create_date->CurrentValue, EW_DATATYPE_DATE, "");
		$sSqlWrk = "SELECT DISTINCT `EW_TMP_LOOKUPTABLE`.`first_day_of_week`, `EW_TMP_LOOKUPTABLE`.`first_day_of_week` AS `DispFld`, `EW_TMP_LOOKUPTABLE`.`last_day_of_week` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT Year(Date_Add(CurDate(), INTERVAL -1 YEAR)) AS year, tables_data.dbkey AS week, Str_To_Date(Concat(Year(Date_Add(CurDate(), INTERVAL -1 YEAR)), tables_data.dbkey, ' Sunday'), '%X%V %W') AS first_day_of_week, Date_Add(Str_To_Date(Concat(Year(Date_Add(CurDate(), INTERVAL -1 YEAR)), tables_data.dbkey, ' Sunday'), '%X%V %W'), INTERVAL 6 DAY) AS last_day_of_week FROM tables_data WHERE tables_data.dbkey_tables = 'WEEK' AND Year(Str_To_Date(Concat(Year(Date_Add(CurDate(), INTERVAL -1 YEAR)), tables_data.dbkey, ' Sunday'), '%X%V %W')) = Year(Date_Add(CurDate(), INTERVAL -1 YEAR)) AND DayOfYear(Str_To_Date(Concat(Year(Date_Add(CurDate(), INTERVAL -1 YEAR)), tables_data.dbkey, ' Sunday'), '%X%V %W')) > 300 UNION SELECT Year(CurDate()) AS year, tables_data.dbkey AS week, Str_To_Date(Concat(Year(CurDate()), tables_data.dbkey, ' Sunday'), '%X%V %W') AS first_day_of_week, Date_Add(Str_To_Date(Concat(Year(CurDate()), tables_data.dbkey, ' Sunday'), '%X%V %W'), INTERVAL 6 DAY) AS last_day_of_week FROM tables_data WHERE tables_data.dbkey_tables = 'WEEK' AND Year(Str_To_Date(Concat(Year(CurDate()), tables_data.dbkey, ' Sunday'), '%X%V %W')) = Year(CurDate()) UNION SELECT Year(Date_Add(CurDate(), INTERVAL 1 YEAR)) AS year, tables_data.dbkey AS week, Str_To_Date(Concat(Year(Date_Add(CurDate(), INTERVAL 1 YEAR)), tables_data.dbkey, ' Sunday'), '%X%V %W') AS first_day_of_week, Date_Add(Str_To_Date(Concat(Year(Date_Add(CurDate(), INTERVAL 1 YEAR)), tables_data.dbkey, ' Sunday'), '%X%V %W'), INTERVAL 6 DAY) AS last_day_of_week FROM tables_data WHERE tables_data.dbkey_tables = 'WEEK' AND Year(Str_To_Date(Concat(Year(Date_Add(CurDate(), INTERVAL 1 YEAR)), tables_data.dbkey, ' Sunday'), '%X%V %W')) = Year(Date_Add(CurDate(), INTERVAL 1 YEAR)) AND DayOfYear(Str_To_Date(Concat(Year(Date_Add(CurDate(), INTERVAL 1 YEAR)), tables_data.dbkey, ' Sunday'), '%X%V %W')) <= 60 ORDER BY first_day_of_week) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->create_date, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = ew_FormatDateTime($rswrk->fields('DispFld'), 5);
				$arwrk[2] = ew_FormatDateTime($rswrk->fields('Disp2Fld'), 5);
				$this->create_date->ViewValue = $this->create_date->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->create_date->ViewValue = $this->create_date->CurrentValue;
			}
		} else {
			$this->create_date->ViewValue = NULL;
		}
		$this->create_date->ViewValue = ew_FormatDateTime($this->create_date->ViewValue, 5);
		$this->create_date->ViewCustomAttributes = "";

		// over_time
		if (strval($this->over_time->CurrentValue) <> "") {
			$this->over_time->ViewValue = $this->over_time->OptionCaption($this->over_time->CurrentValue);
		} else {
			$this->over_time->ViewValue = NULL;
		}
		$this->over_time->ViewCustomAttributes = "";

		// sunday_time_in
		if (strval($this->sunday_time_in->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey)" . ew_SearchString("=", $this->sunday_time_in->CurrentValue, EW_DATATYPE_TIME, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.dbkey), `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT tables_data.dbkey_tables, Time(tables_data.dbkey) AS time, tables_data.description FROM tables_data WHERE tables_data.dbkey_tables = 'time_interval' ORDER BY time) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->sunday_time_in, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->sunday_time_in->ViewValue = $this->sunday_time_in->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->sunday_time_in->ViewValue = $this->sunday_time_in->CurrentValue;
			}
		} else {
			$this->sunday_time_in->ViewValue = NULL;
		}
		$this->sunday_time_in->ViewValue = ew_FormatDateTime($this->sunday_time_in->ViewValue, 4);
		$this->sunday_time_in->ViewCustomAttributes = "";

		// sunday_time_out
		if (strval($this->sunday_time_out->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey)" . ew_SearchString("=", $this->sunday_time_out->CurrentValue, EW_DATATYPE_TIME, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.dbkey), `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT tables_data.dbkey_tables, Time(tables_data.dbkey) AS time, tables_data.description FROM tables_data WHERE tables_data.dbkey_tables = 'time_interval' ORDER BY time) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->sunday_time_out, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->sunday_time_out->ViewValue = $this->sunday_time_out->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->sunday_time_out->ViewValue = $this->sunday_time_out->CurrentValue;
			}
		} else {
			$this->sunday_time_out->ViewValue = NULL;
		}
		$this->sunday_time_out->ViewCustomAttributes = "";

		// monday_time_in
		if (strval($this->monday_time_in->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey)" . ew_SearchString("=", $this->monday_time_in->CurrentValue, EW_DATATYPE_TIME, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.dbkey), `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT tables_data.dbkey_tables, Time(tables_data.dbkey) AS time, tables_data.description FROM tables_data WHERE tables_data.dbkey_tables = 'time_interval' ORDER BY time) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->monday_time_in, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->monday_time_in->ViewValue = $this->monday_time_in->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->monday_time_in->ViewValue = $this->monday_time_in->CurrentValue;
			}
		} else {
			$this->monday_time_in->ViewValue = NULL;
		}
		$this->monday_time_in->ViewCustomAttributes = "";

		// monday_time_out
		if (strval($this->monday_time_out->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey)" . ew_SearchString("=", $this->monday_time_out->CurrentValue, EW_DATATYPE_TIME, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.dbkey), `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT tables_data.dbkey_tables, Time(tables_data.dbkey) AS time, tables_data.description FROM tables_data WHERE tables_data.dbkey_tables = 'time_interval' ORDER BY time) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->monday_time_out, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->monday_time_out->ViewValue = $this->monday_time_out->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->monday_time_out->ViewValue = $this->monday_time_out->CurrentValue;
			}
		} else {
			$this->monday_time_out->ViewValue = NULL;
		}
		$this->monday_time_out->ViewCustomAttributes = "";

		// tuesday_time_in
		if (strval($this->tuesday_time_in->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey)" . ew_SearchString("=", $this->tuesday_time_in->CurrentValue, EW_DATATYPE_TIME, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.dbkey), `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT tables_data.dbkey_tables, Time(tables_data.dbkey) AS time, tables_data.description FROM tables_data WHERE tables_data.dbkey_tables = 'time_interval' ORDER BY time) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->tuesday_time_in, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->tuesday_time_in->ViewValue = $this->tuesday_time_in->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->tuesday_time_in->ViewValue = $this->tuesday_time_in->CurrentValue;
			}
		} else {
			$this->tuesday_time_in->ViewValue = NULL;
		}
		$this->tuesday_time_in->ViewCustomAttributes = "";

		// tuesday_time_out
		if (strval($this->tuesday_time_out->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey)" . ew_SearchString("=", $this->tuesday_time_out->CurrentValue, EW_DATATYPE_TIME, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.dbkey), `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT tables_data.dbkey_tables, Time(tables_data.dbkey) AS time, tables_data.description FROM tables_data WHERE tables_data.dbkey_tables = 'time_interval' ORDER BY time) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->tuesday_time_out, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->tuesday_time_out->ViewValue = $this->tuesday_time_out->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->tuesday_time_out->ViewValue = $this->tuesday_time_out->CurrentValue;
			}
		} else {
			$this->tuesday_time_out->ViewValue = NULL;
		}
		$this->tuesday_time_out->ViewCustomAttributes = "";

		// wednesday_time_in
		if (strval($this->wednesday_time_in->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey)" . ew_SearchString("=", $this->wednesday_time_in->CurrentValue, EW_DATATYPE_TIME, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.dbkey), `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT tables_data.dbkey_tables, Time(tables_data.dbkey) AS time, tables_data.description FROM tables_data WHERE tables_data.dbkey_tables = 'time_interval' ORDER BY time) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->wednesday_time_in, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->wednesday_time_in->ViewValue = $this->wednesday_time_in->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->wednesday_time_in->ViewValue = $this->wednesday_time_in->CurrentValue;
			}
		} else {
			$this->wednesday_time_in->ViewValue = NULL;
		}
		$this->wednesday_time_in->ViewCustomAttributes = "";

		// wednesday_time_out
		if (strval($this->wednesday_time_out->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey)" . ew_SearchString("=", $this->wednesday_time_out->CurrentValue, EW_DATATYPE_TIME, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.dbkey), `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT tables_data.dbkey_tables, Time(tables_data.dbkey) AS time, tables_data.description FROM tables_data WHERE tables_data.dbkey_tables = 'time_interval' ORDER BY time) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->wednesday_time_out, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->wednesday_time_out->ViewValue = $this->wednesday_time_out->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->wednesday_time_out->ViewValue = $this->wednesday_time_out->CurrentValue;
			}
		} else {
			$this->wednesday_time_out->ViewValue = NULL;
		}
		$this->wednesday_time_out->ViewCustomAttributes = "";

		// thursday_time_in
		if (strval($this->thursday_time_in->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey)" . ew_SearchString("=", $this->thursday_time_in->CurrentValue, EW_DATATYPE_TIME, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.dbkey), `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT tables_data.dbkey_tables, Time(tables_data.dbkey) AS time, tables_data.description FROM tables_data WHERE tables_data.dbkey_tables = 'time_interval' ORDER BY time) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->thursday_time_in, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->thursday_time_in->ViewValue = $this->thursday_time_in->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->thursday_time_in->ViewValue = $this->thursday_time_in->CurrentValue;
			}
		} else {
			$this->thursday_time_in->ViewValue = NULL;
		}
		$this->thursday_time_in->ViewCustomAttributes = "";

		// thursday_time_out
		if (strval($this->thursday_time_out->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey)" . ew_SearchString("=", $this->thursday_time_out->CurrentValue, EW_DATATYPE_TIME, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.dbkey), `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT tables_data.dbkey_tables, Time(tables_data.dbkey) AS time, tables_data.description FROM tables_data WHERE tables_data.dbkey_tables = 'time_interval' ORDER BY time) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->thursday_time_out, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->thursday_time_out->ViewValue = $this->thursday_time_out->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->thursday_time_out->ViewValue = $this->thursday_time_out->CurrentValue;
			}
		} else {
			$this->thursday_time_out->ViewValue = NULL;
		}
		$this->thursday_time_out->ViewCustomAttributes = "";

		// friday_time_in
		if (strval($this->friday_time_in->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey)" . ew_SearchString("=", $this->friday_time_in->CurrentValue, EW_DATATYPE_TIME, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.dbkey), `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT tables_data.dbkey_tables, Time(tables_data.dbkey) AS time, tables_data.description FROM tables_data WHERE tables_data.dbkey_tables = 'time_interval' ORDER BY time) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->friday_time_in, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->friday_time_in->ViewValue = $this->friday_time_in->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->friday_time_in->ViewValue = $this->friday_time_in->CurrentValue;
			}
		} else {
			$this->friday_time_in->ViewValue = NULL;
		}
		$this->friday_time_in->ViewCustomAttributes = "";

		// friday_time_out
		if (strval($this->friday_time_out->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey)" . ew_SearchString("=", $this->friday_time_out->CurrentValue, EW_DATATYPE_TIME, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.dbkey), `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT tables_data.dbkey_tables, Time(tables_data.dbkey) AS time, tables_data.description FROM tables_data WHERE tables_data.dbkey_tables = 'time_interval' ORDER BY time) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->friday_time_out, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->friday_time_out->ViewValue = $this->friday_time_out->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->friday_time_out->ViewValue = $this->friday_time_out->CurrentValue;
			}
		} else {
			$this->friday_time_out->ViewValue = NULL;
		}
		$this->friday_time_out->ViewCustomAttributes = "";

		// saturday_time_in
		if (strval($this->saturday_time_in->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey)" . ew_SearchString("=", $this->saturday_time_in->CurrentValue, EW_DATATYPE_TIME, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.dbkey), `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT tables_data.dbkey_tables, Time(tables_data.dbkey) AS time, tables_data.description FROM tables_data WHERE tables_data.dbkey_tables = 'time_interval' ORDER BY time) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->saturday_time_in, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->saturday_time_in->ViewValue = $this->saturday_time_in->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->saturday_time_in->ViewValue = $this->saturday_time_in->CurrentValue;
			}
		} else {
			$this->saturday_time_in->ViewValue = NULL;
		}
		$this->saturday_time_in->ViewCustomAttributes = "";

		// saturday_time_out
		if (strval($this->saturday_time_out->CurrentValue) <> "") {
			$sFilterWrk = "`EW_TMP_LOOKUPTABLE`.dbkey)" . ew_SearchString("=", $this->saturday_time_out->CurrentValue, EW_DATATYPE_TIME, "");
		$sSqlWrk = "SELECT `EW_TMP_LOOKUPTABLE`.dbkey), `EW_TMP_LOOKUPTABLE`.description AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM (SELECT tables_data.dbkey_tables, Time(tables_data.dbkey) AS time, tables_data.description FROM tables_data WHERE tables_data.dbkey_tables = 'time_interval' ORDER BY time) AS `EW_TMP_LOOKUPTABLE`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->saturday_time_out, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->saturday_time_out->ViewValue = $this->saturday_time_out->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->saturday_time_out->ViewValue = $this->saturday_time_out->CurrentValue;
			}
		} else {
			$this->saturday_time_out->ViewValue = NULL;
		}
		$this->saturday_time_out->ViewCustomAttributes = "";

		// dbkey_hr_approver
		$this->dbkey_hr_approver->ViewValue = $this->dbkey_hr_approver->CurrentValue;
		$this->dbkey_hr_approver->ViewCustomAttributes = "";

		// hr_approved
		if (strval($this->hr_approved->CurrentValue) <> "") {
			$this->hr_approved->ViewValue = $this->hr_approved->OptionCaption($this->hr_approved->CurrentValue);
		} else {
			$this->hr_approved->ViewValue = NULL;
		}
		$this->hr_approved->ViewCustomAttributes = "";

		// hr_approved_date
		$this->hr_approved_date->ViewValue = $this->hr_approved_date->CurrentValue;
		$this->hr_approved_date->ViewValue = ew_FormatDateTime($this->hr_approved_date->ViewValue, 5);
		$this->hr_approved_date->ViewCustomAttributes = "";

		// date_time_created
		$this->date_time_created->ViewValue = $this->date_time_created->CurrentValue;
		$this->date_time_created->ViewValue = ew_FormatDateTime($this->date_time_created->ViewValue, 5);
		$this->date_time_created->ViewCustomAttributes = "";

		// dbkey
		$this->dbkey->LinkCustomAttributes = "";
		$this->dbkey->HrefValue = "";
		$this->dbkey->TooltipValue = "";

		// dbkey_counselor
		$this->dbkey_counselor->LinkCustomAttributes = "";
		$this->dbkey_counselor->HrefValue = "";
		$this->dbkey_counselor->TooltipValue = "";

		// week_range
		$this->week_range->LinkCustomAttributes = "";
		$this->week_range->HrefValue = "";
		$this->week_range->TooltipValue = "";

		// create_date
		$this->create_date->LinkCustomAttributes = "";
		$this->create_date->HrefValue = "";
		$this->create_date->TooltipValue = "";

		// over_time
		$this->over_time->LinkCustomAttributes = "";
		$this->over_time->HrefValue = "";
		$this->over_time->TooltipValue = "";

		// sunday_time_in
		$this->sunday_time_in->LinkCustomAttributes = "";
		$this->sunday_time_in->HrefValue = "";
		$this->sunday_time_in->TooltipValue = "";

		// sunday_time_out
		$this->sunday_time_out->LinkCustomAttributes = "";
		$this->sunday_time_out->HrefValue = "";
		$this->sunday_time_out->TooltipValue = "";

		// monday_time_in
		$this->monday_time_in->LinkCustomAttributes = "";
		$this->monday_time_in->HrefValue = "";
		$this->monday_time_in->TooltipValue = "";

		// monday_time_out
		$this->monday_time_out->LinkCustomAttributes = "";
		$this->monday_time_out->HrefValue = "";
		$this->monday_time_out->TooltipValue = "";

		// tuesday_time_in
		$this->tuesday_time_in->LinkCustomAttributes = "";
		$this->tuesday_time_in->HrefValue = "";
		$this->tuesday_time_in->TooltipValue = "";

		// tuesday_time_out
		$this->tuesday_time_out->LinkCustomAttributes = "";
		$this->tuesday_time_out->HrefValue = "";
		$this->tuesday_time_out->TooltipValue = "";

		// wednesday_time_in
		$this->wednesday_time_in->LinkCustomAttributes = "";
		$this->wednesday_time_in->HrefValue = "";
		$this->wednesday_time_in->TooltipValue = "";

		// wednesday_time_out
		$this->wednesday_time_out->LinkCustomAttributes = "";
		$this->wednesday_time_out->HrefValue = "";
		$this->wednesday_time_out->TooltipValue = "";

		// thursday_time_in
		$this->thursday_time_in->LinkCustomAttributes = "";
		$this->thursday_time_in->HrefValue = "";
		$this->thursday_time_in->TooltipValue = "";

		// thursday_time_out
		$this->thursday_time_out->LinkCustomAttributes = "";
		$this->thursday_time_out->HrefValue = "";
		$this->thursday_time_out->TooltipValue = "";

		// friday_time_in
		$this->friday_time_in->LinkCustomAttributes = "";
		$this->friday_time_in->HrefValue = "";
		$this->friday_time_in->TooltipValue = "";

		// friday_time_out
		$this->friday_time_out->LinkCustomAttributes = "";
		$this->friday_time_out->HrefValue = "";
		$this->friday_time_out->TooltipValue = "";

		// saturday_time_in
		$this->saturday_time_in->LinkCustomAttributes = "";
		$this->saturday_time_in->HrefValue = "";
		$this->saturday_time_in->TooltipValue = "";

		// saturday_time_out
		$this->saturday_time_out->LinkCustomAttributes = "";
		$this->saturday_time_out->HrefValue = "";
		$this->saturday_time_out->TooltipValue = "";

		// dbkey_hr_approver
		$this->dbkey_hr_approver->LinkCustomAttributes = "";
		$this->dbkey_hr_approver->HrefValue = "";
		$this->dbkey_hr_approver->TooltipValue = "";

		// hr_approved
		$this->hr_approved->LinkCustomAttributes = "";
		$this->hr_approved->HrefValue = "";
		$this->hr_approved->TooltipValue = "";

		// hr_approved_date
		$this->hr_approved_date->LinkCustomAttributes = "";
		$this->hr_approved_date->HrefValue = "";
		$this->hr_approved_date->TooltipValue = "";

		// date_time_created
		$this->date_time_created->LinkCustomAttributes = "";
		$this->date_time_created->HrefValue = "";
		$this->date_time_created->TooltipValue = "";

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Render edit row values
	function RenderEditRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

		// dbkey
		$this->dbkey->EditAttrs["class"] = "form-control";
		$this->dbkey->EditCustomAttributes = "";
		$this->dbkey->EditValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// dbkey_counselor
		$this->dbkey_counselor->EditAttrs["class"] = "form-control";
		$this->dbkey_counselor->EditCustomAttributes = "";
		if (!$Security->IsAdmin() && $Security->IsLoggedIn() && !$this->UserIDAllow("info")) { // Non system admin
		$sFilterWrk = "";
		$sFilterWrk = $GLOBALS["counselor"]->AddUserIDFilter("");
		$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `counselor`";
		$sWhereWrk = "";
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_counselor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$rswrk = Conn()->Execute($sSqlWrk);
		$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
		if ($rswrk) $rswrk->Close();
		array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect"), "", "", "", "", "", "", ""));
		$this->dbkey_counselor->EditValue = $arwrk;
		} else {
		}

		// week_range
		$this->week_range->EditAttrs["class"] = "form-control";
		$this->week_range->EditCustomAttributes = "";

		// create_date
		$this->create_date->EditAttrs["class"] = "form-control";
		$this->create_date->EditCustomAttributes = "";

		// over_time
		$this->over_time->EditAttrs["class"] = "form-control";
		$this->over_time->EditCustomAttributes = "";
		$this->over_time->EditValue = $this->over_time->Options(TRUE);

		// sunday_time_in
		$this->sunday_time_in->EditAttrs["class"] = "form-control";
		$this->sunday_time_in->EditCustomAttributes = "";

		// sunday_time_out
		$this->sunday_time_out->EditAttrs["class"] = "form-control";
		$this->sunday_time_out->EditCustomAttributes = "";

		// monday_time_in
		$this->monday_time_in->EditAttrs["class"] = "form-control";
		$this->monday_time_in->EditCustomAttributes = "";

		// monday_time_out
		$this->monday_time_out->EditAttrs["class"] = "form-control";
		$this->monday_time_out->EditCustomAttributes = "";

		// tuesday_time_in
		$this->tuesday_time_in->EditAttrs["class"] = "form-control";
		$this->tuesday_time_in->EditCustomAttributes = "";

		// tuesday_time_out
		$this->tuesday_time_out->EditAttrs["class"] = "form-control";
		$this->tuesday_time_out->EditCustomAttributes = "";

		// wednesday_time_in
		$this->wednesday_time_in->EditAttrs["class"] = "form-control";
		$this->wednesday_time_in->EditCustomAttributes = "";

		// wednesday_time_out
		$this->wednesday_time_out->EditAttrs["class"] = "form-control";
		$this->wednesday_time_out->EditCustomAttributes = "";

		// thursday_time_in
		$this->thursday_time_in->EditAttrs["class"] = "form-control";
		$this->thursday_time_in->EditCustomAttributes = "";

		// thursday_time_out
		$this->thursday_time_out->EditAttrs["class"] = "form-control";
		$this->thursday_time_out->EditCustomAttributes = "";

		// friday_time_in
		$this->friday_time_in->EditAttrs["class"] = "form-control";
		$this->friday_time_in->EditCustomAttributes = "";

		// friday_time_out
		$this->friday_time_out->EditAttrs["class"] = "form-control";
		$this->friday_time_out->EditCustomAttributes = "";

		// saturday_time_in
		$this->saturday_time_in->EditAttrs["class"] = "form-control";
		$this->saturday_time_in->EditCustomAttributes = "";

		// saturday_time_out
		$this->saturday_time_out->EditAttrs["class"] = "form-control";
		$this->saturday_time_out->EditCustomAttributes = "";

		// dbkey_hr_approver
		$this->dbkey_hr_approver->EditAttrs["class"] = "form-control";
		$this->dbkey_hr_approver->EditCustomAttributes = "";

		// hr_approved
		$this->hr_approved->EditAttrs["class"] = "form-control";
		$this->hr_approved->EditCustomAttributes = "";
		$this->hr_approved->EditValue = $this->hr_approved->Options(TRUE);

		// hr_approved_date
		$this->hr_approved_date->EditAttrs["class"] = "form-control";
		$this->hr_approved_date->EditCustomAttributes = "";
		$this->hr_approved_date->CurrentValue = ew_FormatDateTime($this->hr_approved_date->CurrentValue, 5);

		// date_time_created
		$this->date_time_created->EditAttrs["class"] = "form-control";
		$this->date_time_created->EditCustomAttributes = "";
		$this->date_time_created->CurrentValue = ew_FormatDateTime($this->date_time_created->CurrentValue, 5);

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Aggregate list row values
	function AggregateListRowValues() {
	}

	// Aggregate list row (for rendering)
	function AggregateListRow() {

		// Call Row Rendered event
		$this->Row_Rendered();
	}
	var $ExportDoc;

	// Export data in HTML/CSV/Word/Excel/Email/PDF format
	function ExportDocument(&$Doc, &$Recordset, $StartRec, $StopRec, $ExportPageType = "") {
		if (!$Recordset || !$Doc)
			return;
		if (!$Doc->ExportCustom) {

			// Write header
			$Doc->ExportTableHeader();
			if ($Doc->Horizontal) { // Horizontal format, write header
				$Doc->BeginExportRow();
				if ($ExportPageType == "view") {
					if ($this->dbkey_counselor->Exportable) $Doc->ExportCaption($this->dbkey_counselor);
					if ($this->week_range->Exportable) $Doc->ExportCaption($this->week_range);
					if ($this->over_time->Exportable) $Doc->ExportCaption($this->over_time);
					if ($this->sunday_time_in->Exportable) $Doc->ExportCaption($this->sunday_time_in);
					if ($this->sunday_time_out->Exportable) $Doc->ExportCaption($this->sunday_time_out);
					if ($this->monday_time_in->Exportable) $Doc->ExportCaption($this->monday_time_in);
					if ($this->monday_time_out->Exportable) $Doc->ExportCaption($this->monday_time_out);
					if ($this->tuesday_time_in->Exportable) $Doc->ExportCaption($this->tuesday_time_in);
					if ($this->tuesday_time_out->Exportable) $Doc->ExportCaption($this->tuesday_time_out);
					if ($this->wednesday_time_in->Exportable) $Doc->ExportCaption($this->wednesday_time_in);
					if ($this->wednesday_time_out->Exportable) $Doc->ExportCaption($this->wednesday_time_out);
					if ($this->thursday_time_in->Exportable) $Doc->ExportCaption($this->thursday_time_in);
					if ($this->thursday_time_out->Exportable) $Doc->ExportCaption($this->thursday_time_out);
					if ($this->friday_time_in->Exportable) $Doc->ExportCaption($this->friday_time_in);
					if ($this->friday_time_out->Exportable) $Doc->ExportCaption($this->friday_time_out);
					if ($this->saturday_time_in->Exportable) $Doc->ExportCaption($this->saturday_time_in);
					if ($this->saturday_time_out->Exportable) $Doc->ExportCaption($this->saturday_time_out);
					if ($this->dbkey_hr_approver->Exportable) $Doc->ExportCaption($this->dbkey_hr_approver);
					if ($this->hr_approved->Exportable) $Doc->ExportCaption($this->hr_approved);
					if ($this->hr_approved_date->Exportable) $Doc->ExportCaption($this->hr_approved_date);
				} else {
					if ($this->dbkey_counselor->Exportable) $Doc->ExportCaption($this->dbkey_counselor);
					if ($this->week_range->Exportable) $Doc->ExportCaption($this->week_range);
					if ($this->over_time->Exportable) $Doc->ExportCaption($this->over_time);
					if ($this->sunday_time_in->Exportable) $Doc->ExportCaption($this->sunday_time_in);
					if ($this->sunday_time_out->Exportable) $Doc->ExportCaption($this->sunday_time_out);
					if ($this->monday_time_in->Exportable) $Doc->ExportCaption($this->monday_time_in);
					if ($this->monday_time_out->Exportable) $Doc->ExportCaption($this->monday_time_out);
					if ($this->tuesday_time_in->Exportable) $Doc->ExportCaption($this->tuesday_time_in);
					if ($this->tuesday_time_out->Exportable) $Doc->ExportCaption($this->tuesday_time_out);
					if ($this->wednesday_time_in->Exportable) $Doc->ExportCaption($this->wednesday_time_in);
					if ($this->wednesday_time_out->Exportable) $Doc->ExportCaption($this->wednesday_time_out);
					if ($this->thursday_time_in->Exportable) $Doc->ExportCaption($this->thursday_time_in);
					if ($this->thursday_time_out->Exportable) $Doc->ExportCaption($this->thursday_time_out);
					if ($this->friday_time_in->Exportable) $Doc->ExportCaption($this->friday_time_in);
					if ($this->friday_time_out->Exportable) $Doc->ExportCaption($this->friday_time_out);
					if ($this->saturday_time_in->Exportable) $Doc->ExportCaption($this->saturday_time_in);
					if ($this->saturday_time_out->Exportable) $Doc->ExportCaption($this->saturday_time_out);
					if ($this->dbkey_hr_approver->Exportable) $Doc->ExportCaption($this->dbkey_hr_approver);
					if ($this->hr_approved->Exportable) $Doc->ExportCaption($this->hr_approved);
					if ($this->hr_approved_date->Exportable) $Doc->ExportCaption($this->hr_approved_date);
					if ($this->date_time_created->Exportable) $Doc->ExportCaption($this->date_time_created);
				}
				$Doc->EndExportRow();
			}
		}

		// Move to first record
		$RecCnt = $StartRec - 1;
		if (!$Recordset->EOF) {
			$Recordset->MoveFirst();
			if ($StartRec > 1)
				$Recordset->Move($StartRec - 1);
		}
		while (!$Recordset->EOF && $RecCnt < $StopRec) {
			$RecCnt++;
			if (intval($RecCnt) >= intval($StartRec)) {
				$RowCnt = intval($RecCnt) - intval($StartRec) + 1;

				// Page break
				if ($this->ExportPageBreakCount > 0) {
					if ($RowCnt > 1 && ($RowCnt - 1) % $this->ExportPageBreakCount == 0)
						$Doc->ExportPageBreak();
				}
				$this->LoadListRowValues($Recordset);

				// Render row
				$this->RowType = EW_ROWTYPE_VIEW; // Render view
				$this->ResetAttrs();
				$this->RenderListRow();
				if (!$Doc->ExportCustom) {
					$Doc->BeginExportRow($RowCnt); // Allow CSS styles if enabled
					if ($ExportPageType == "view") {
						if ($this->dbkey_counselor->Exportable) $Doc->ExportField($this->dbkey_counselor);
						if ($this->week_range->Exportable) $Doc->ExportField($this->week_range);
						if ($this->over_time->Exportable) $Doc->ExportField($this->over_time);
						if ($this->sunday_time_in->Exportable) $Doc->ExportField($this->sunday_time_in);
						if ($this->sunday_time_out->Exportable) $Doc->ExportField($this->sunday_time_out);
						if ($this->monday_time_in->Exportable) $Doc->ExportField($this->monday_time_in);
						if ($this->monday_time_out->Exportable) $Doc->ExportField($this->monday_time_out);
						if ($this->tuesday_time_in->Exportable) $Doc->ExportField($this->tuesday_time_in);
						if ($this->tuesday_time_out->Exportable) $Doc->ExportField($this->tuesday_time_out);
						if ($this->wednesday_time_in->Exportable) $Doc->ExportField($this->wednesday_time_in);
						if ($this->wednesday_time_out->Exportable) $Doc->ExportField($this->wednesday_time_out);
						if ($this->thursday_time_in->Exportable) $Doc->ExportField($this->thursday_time_in);
						if ($this->thursday_time_out->Exportable) $Doc->ExportField($this->thursday_time_out);
						if ($this->friday_time_in->Exportable) $Doc->ExportField($this->friday_time_in);
						if ($this->friday_time_out->Exportable) $Doc->ExportField($this->friday_time_out);
						if ($this->saturday_time_in->Exportable) $Doc->ExportField($this->saturday_time_in);
						if ($this->saturday_time_out->Exportable) $Doc->ExportField($this->saturday_time_out);
						if ($this->dbkey_hr_approver->Exportable) $Doc->ExportField($this->dbkey_hr_approver);
						if ($this->hr_approved->Exportable) $Doc->ExportField($this->hr_approved);
						if ($this->hr_approved_date->Exportable) $Doc->ExportField($this->hr_approved_date);
					} else {
						if ($this->dbkey_counselor->Exportable) $Doc->ExportField($this->dbkey_counselor);
						if ($this->week_range->Exportable) $Doc->ExportField($this->week_range);
						if ($this->over_time->Exportable) $Doc->ExportField($this->over_time);
						if ($this->sunday_time_in->Exportable) $Doc->ExportField($this->sunday_time_in);
						if ($this->sunday_time_out->Exportable) $Doc->ExportField($this->sunday_time_out);
						if ($this->monday_time_in->Exportable) $Doc->ExportField($this->monday_time_in);
						if ($this->monday_time_out->Exportable) $Doc->ExportField($this->monday_time_out);
						if ($this->tuesday_time_in->Exportable) $Doc->ExportField($this->tuesday_time_in);
						if ($this->tuesday_time_out->Exportable) $Doc->ExportField($this->tuesday_time_out);
						if ($this->wednesday_time_in->Exportable) $Doc->ExportField($this->wednesday_time_in);
						if ($this->wednesday_time_out->Exportable) $Doc->ExportField($this->wednesday_time_out);
						if ($this->thursday_time_in->Exportable) $Doc->ExportField($this->thursday_time_in);
						if ($this->thursday_time_out->Exportable) $Doc->ExportField($this->thursday_time_out);
						if ($this->friday_time_in->Exportable) $Doc->ExportField($this->friday_time_in);
						if ($this->friday_time_out->Exportable) $Doc->ExportField($this->friday_time_out);
						if ($this->saturday_time_in->Exportable) $Doc->ExportField($this->saturday_time_in);
						if ($this->saturday_time_out->Exportable) $Doc->ExportField($this->saturday_time_out);
						if ($this->dbkey_hr_approver->Exportable) $Doc->ExportField($this->dbkey_hr_approver);
						if ($this->hr_approved->Exportable) $Doc->ExportField($this->hr_approved);
						if ($this->hr_approved_date->Exportable) $Doc->ExportField($this->hr_approved_date);
						if ($this->date_time_created->Exportable) $Doc->ExportField($this->date_time_created);
					}
					$Doc->EndExportRow();
				}
			}

			// Call Row Export server event
			if ($Doc->ExportCustom)
				$this->Row_Export($Recordset->fields);
			$Recordset->MoveNext();
		}
		if (!$Doc->ExportCustom) {
			$Doc->ExportTableFooter();
		}
	}

	// Add User ID filter
	function AddUserIDFilter($sFilter) {
		global $Security;
		$sFilterWrk = "";
		$id = (CurrentPageID() == "list") ? $this->CurrentAction : CurrentPageID();
		if (!$this->UserIDAllow($id) && !$Security->IsAdmin()) {
			$sFilterWrk = $Security->UserIDList();
			if ($sFilterWrk <> "")
				$sFilterWrk = '`dbkey_counselor` IN (' . $sFilterWrk . ')';
		}

		// Call User ID Filtering event
		$this->UserID_Filtering($sFilterWrk);
		ew_AddFilter($sFilter, $sFilterWrk);
		return $sFilter;
	}

	// User ID subquery
	function GetUserIDSubquery(&$fld, &$masterfld) {
		global $UserTableConn;
		$sWrk = "";
		$sSql = "SELECT " . $masterfld->FldExpression . " FROM `time_entry_2`";
		$sFilter = $this->AddUserIDFilter("");
		if ($sFilter <> "") $sSql .= " WHERE " . $sFilter;

		// Use subquery
		if (EW_USE_SUBQUERY_FOR_MASTER_USER_ID) {
			$sWrk = $sSql;
		} else {

			// List all values
			if ($rs = $UserTableConn->Execute($sSql)) {
				while (!$rs->EOF) {
					if ($sWrk <> "") $sWrk .= ",";
					$sWrk .= ew_QuotedValue($rs->fields[0], $masterfld->FldDataType, EW_USER_TABLE_DBID);
					$rs->MoveNext();
				}
				$rs->Close();
			}
		}
		if ($sWrk <> "") {
			$sWrk = $fld->FldExpression . " IN (" . $sWrk . ")";
		}
		return $sWrk;
	}

	// Get auto fill value
	function GetAutoFill($id, $val) {
		$rsarr = array();
		$rowcnt = 0;

		// Output
		if (is_array($rsarr) && $rowcnt > 0) {
			$fldcnt = count($rsarr[0]);
			for ($i = 0; $i < $rowcnt; $i++) {
				for ($j = 0; $j < $fldcnt; $j++) {
					$str = strval($rsarr[$i][$j]);
					$str = ew_ConvertToUtf8($str);
					if (isset($post["keepCRLF"])) {
						$str = str_replace(array("\r", "\n"), array("\\r", "\\n"), $str);
					} else {
						$str = str_replace(array("\r", "\n"), array(" ", " "), $str);
					}
					$rsarr[$i][$j] = $str;
				}
			}
			return ew_ArrayToJson($rsarr);
		} else {
			return FALSE;
		}
	}

	// Table level events
	// Recordset Selecting event
	function Recordset_Selecting(&$filter) {

		// Enter your code here	
	}

	// Recordset Selected event
	function Recordset_Selected(&$rs) {

		//echo "Recordset Selected";
	}

	// Recordset Search Validated event
	function Recordset_SearchValidated() {

		// Example:
		//$this->MyField1->AdvancedSearch->SearchValue = "your search criteria"; // Search value

	}

	// Recordset Searching event
	function Recordset_Searching(&$filter) {

		// Enter your code here	
	}

	// Row_Selecting event
	function Row_Selecting(&$filter) {

		// Enter your code here	
	}

	// Row Selected event
	function Row_Selected(&$rs) {

		//echo "Row Selected";
	}

	// Row Inserting event
	function Row_Inserting($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Inserted event
	function Row_Inserted($rsold, &$rsnew) {

		//echo "Row Inserted"
	}

	// Row Updating event
	function Row_Updating($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Updated event
	function Row_Updated($rsold, &$rsnew) {

		//echo "Row Updated";
	}

	// Row Update Conflict event
	function Row_UpdateConflict($rsold, &$rsnew) {

		// Enter your code here
		// To ignore conflict, set return value to FALSE

		return TRUE;
	}

	// Grid Inserting event
	function Grid_Inserting() {

		// Enter your code here
		// To reject grid insert, set return value to FALSE

		return TRUE;
	}

	// Grid Inserted event
	function Grid_Inserted($rsnew) {

		//echo "Grid Inserted";
	}

	// Grid Updating event
	function Grid_Updating($rsold) {

		// Enter your code here
		// To reject grid update, set return value to FALSE

		return TRUE;
	}

	// Grid Updated event
	function Grid_Updated($rsold, $rsnew) {

		//echo "Grid Updated";
	}

	// Row Deleting event
	function Row_Deleting(&$rs) {

		// Enter your code here
		// To cancel, set return value to False

		return TRUE;
	}

	// Row Deleted event
	function Row_Deleted(&$rs) {

		//echo "Row Deleted";
	}

	// Email Sending event
	function Email_Sending(&$Email, &$Args) {
		 return TRUE;
	}

	// Lookup Selecting event
	function Lookup_Selecting($fld, &$filter) {

		//var_dump($fld->FldName, $fld->LookupFilters, $filter); // Uncomment to view the filter
		// Enter your code here

	}

	// Row Rendering event
	function Row_Rendering() {

		// Enter your code here	
	}

	// Row Rendered event
	function Row_Rendered() {

		// To view properties of field class, use:
		//var_dump($this-><FieldName>);
		//	if (CurrentPageID() == "add" or CurrentPageID() == 'edit') {
		//		$this->dbkey_hr_approver->Visible = FALSE;
		//		$this->dbkey_hr_approver->Visible = FALSE;
		//		$this->hr_approved->Visible = FALSE;
		//		$this->hr_approved_date->Visible = FALSE;
		//		$this->date_time_created->Visible = FALSE;
		//		$this->week_range->Visible = FALSE;
		//}

	}

	// User ID Filtering event
	function UserID_Filtering(&$filter) {

		// Enter your code here
	}
}
?>
