<?php
if (session_id() == "") session_start(); // Init session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg13.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql13.php") ?>
<?php include_once "phpfn13.php" ?>
<?php include_once "timecardsinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn13.php" ?>
<?php

//
// Page class
//

$timecards_list = NULL; // Initialize page object first

class ctimecards_list extends ctimecards {

	// Page ID
	var $PageID = 'list';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'timecards';

	// Page object name
	var $PageObjName = 'timecards_list';

	// Grid form hidden field names
	var $FormName = 'ftimecardslist';
	var $FormActionName = 'k_action';
	var $FormKeyName = 'k_key';
	var $FormOldKeyName = 'k_oldkey';
	var $FormBlankRowName = 'k_blankrow';
	var $FormKeyCountName = 'key_count';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Page URLs
	var $AddUrl;
	var $EditUrl;
	var $CopyUrl;
	var $DeleteUrl;
	var $ViewUrl;
	var $ListUrl;

	// Export URLs
	var $ExportPrintUrl;
	var $ExportHtmlUrl;
	var $ExportExcelUrl;
	var $ExportWordUrl;
	var $ExportXmlUrl;
	var $ExportCsvUrl;
	var $ExportPdfUrl;

	// Custom export
	var $ExportExcelCustom = FALSE;
	var $ExportWordCustom = FALSE;
	var $ExportPdfCustom = FALSE;
	var $ExportEmailCustom = FALSE;

	// Update URLs
	var $InlineAddUrl;
	var $InlineCopyUrl;
	var $InlineEditUrl;
	var $GridAddUrl;
	var $GridEditUrl;
	var $MultiDeleteUrl;
	var $MultiUpdateUrl;
	var $AuditTrailOnAdd = FALSE;
	var $AuditTrailOnEdit = FALSE;
	var $AuditTrailOnDelete = FALSE;
	var $AuditTrailOnView = FALSE;
	var $AuditTrailOnViewData = FALSE;
	var $AuditTrailOnSearch = FALSE;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (timecards)
		if (!isset($GLOBALS["timecards"]) || get_class($GLOBALS["timecards"]) == "ctimecards") {
			$GLOBALS["timecards"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["timecards"];
		}

		// Initialize URLs
		$this->ExportPrintUrl = $this->PageUrl() . "export=print";
		$this->ExportExcelUrl = $this->PageUrl() . "export=excel";
		$this->ExportWordUrl = $this->PageUrl() . "export=word";
		$this->ExportHtmlUrl = $this->PageUrl() . "export=html";
		$this->ExportXmlUrl = $this->PageUrl() . "export=xml";
		$this->ExportCsvUrl = $this->PageUrl() . "export=csv";
		$this->ExportPdfUrl = $this->PageUrl() . "export=pdf";
		$this->AddUrl = "timecardsadd.php";
		$this->InlineAddUrl = $this->PageUrl() . "a=add";
		$this->GridAddUrl = $this->PageUrl() . "a=gridadd";
		$this->GridEditUrl = $this->PageUrl() . "a=gridedit";
		$this->MultiDeleteUrl = "timecardsdelete.php";
		$this->MultiUpdateUrl = "timecardsupdate.php";

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'list', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'timecards', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}

		// List options
		$this->ListOptions = new cListOptions();
		$this->ListOptions->TableVar = $this->TableVar;

		// Export options
		$this->ExportOptions = new cListOptions();
		$this->ExportOptions->Tag = "div";
		$this->ExportOptions->TagClassName = "ewExportOption";

		// Other options
		$this->OtherOptions['addedit'] = new cListOptions();
		$this->OtherOptions['addedit']->Tag = "div";
		$this->OtherOptions['addedit']->TagClassName = "ewAddEditOption";
		$this->OtherOptions['detail'] = new cListOptions();
		$this->OtherOptions['detail']->Tag = "div";
		$this->OtherOptions['detail']->TagClassName = "ewDetailOption";
		$this->OtherOptions['action'] = new cListOptions();
		$this->OtherOptions['action']->Tag = "div";
		$this->OtherOptions['action']->TagClassName = "ewActionOption";

		// Filter options
		$this->FilterOptions = new cListOptions();
		$this->FilterOptions->Tag = "div";
		$this->FilterOptions->TagClassName = "ewFilterOption ftimecardslistsrch";

		// List actions
		$this->ListActions = new cListActions();
	}

	//
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanList()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			$this->Page_Terminate(ew_GetUrl("index.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Get export parameters
		$custom = "";
		if (@$_GET["export"] <> "") {
			$this->Export = $_GET["export"];
			$custom = @$_GET["custom"];
		} elseif (@$_POST["export"] <> "") {
			$this->Export = $_POST["export"];
			$custom = @$_POST["custom"];
		} elseif (ew_IsHttpPost()) {
			if (@$_POST["exporttype"] <> "")
				$this->Export = $_POST["exporttype"];
			$custom = @$_POST["custom"];
		} else {
			$this->setExportReturnUrl(ew_CurrentUrl());
		}
		$gsExportFile = $this->TableVar; // Get export file, used in header

		// Get custom export parameters
		if ($this->Export <> "" && $custom <> "") {
			$this->CustomExport = $this->Export;
			$this->Export = "print";
		}
		$gsCustomExport = $this->CustomExport;
		$gsExport = $this->Export; // Get export parameter, used in header

		// Update Export URLs
		if (defined("EW_USE_PHPEXCEL"))
			$this->ExportExcelCustom = FALSE;
		if ($this->ExportExcelCustom)
			$this->ExportExcelUrl .= "&amp;custom=1";
		if (defined("EW_USE_PHPWORD"))
			$this->ExportWordCustom = FALSE;
		if ($this->ExportWordCustom)
			$this->ExportWordUrl .= "&amp;custom=1";
		if ($this->ExportPdfCustom)
			$this->ExportPdfUrl .= "&amp;custom=1";
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action

		// Get grid add count
		$gridaddcnt = @$_GET[EW_TABLE_GRID_ADD_ROW_COUNT];
		if (is_numeric($gridaddcnt) && $gridaddcnt > 0)
			$this->GridAddRowCount = $gridaddcnt;

		// Set up list options
		$this->SetupListOptions();

		// Setup export options
		$this->SetupExportOptions();
		$this->weeknumber->SetVisibility();
		$this->dbkey_councilor->SetVisibility();
		$this->date->SetVisibility();
		$this->in->SetVisibility();
		$this->out->SetVisibility();
		$this->regular->SetVisibility();
		$this->overtime->SetVisibility();
		$this->total->SetVisibility();
		$this->approved->SetVisibility();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();

		// Setup other options
		$this->SetupOtherOptions();

		// Set up custom action (compatible with old version)
		foreach ($this->CustomActions as $name => $action)
			$this->ListActions->Add($name, $action);

		// Show checkbox column if multiple action
		foreach ($this->ListActions->Items as $listaction) {
			if ($listaction->Select == EW_ACTION_MULTIPLE && $listaction->Allow) {
				$this->ListOptions->Items["checkbox"]->Visible = TRUE;
				break;
			}
		}
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $timecards;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($timecards);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}

	// Class variables
	var $ListOptions; // List options
	var $ExportOptions; // Export options
	var $SearchOptions; // Search options
	var $OtherOptions = array(); // Other options
	var $FilterOptions; // Filter options
	var $ListActions; // List actions
	var $SelectedCount = 0;
	var $SelectedIndex = 0;
	var $DisplayRecs = 20;
	var $StartRec;
	var $StopRec;
	var $TotalRecs = 0;
	var $RecRange = 10;
	var $Pager;
	var $DefaultSearchWhere = ""; // Default search WHERE clause
	var $SearchWhere = ""; // Search WHERE clause
	var $RecCnt = 0; // Record count
	var $EditRowCnt;
	var $StartRowCnt = 1;
	var $RowCnt = 0;
	var $Attrs = array(); // Row attributes and cell attributes
	var $RowIndex = 0; // Row index
	var $KeyCount = 0; // Key count
	var $RowAction = ""; // Row action
	var $RowOldKey = ""; // Row old key (for copy)
	var $RecPerRow = 0;
	var $MultiColumnClass;
	var $MultiColumnEditClass = "col-sm-12";
	var $MultiColumnCnt = 12;
	var $MultiColumnEditCnt = 12;
	var $GridCnt = 0;
	var $ColCnt = 0;
	var $DbMasterFilter = ""; // Master filter
	var $DbDetailFilter = ""; // Detail filter
	var $MasterRecordExists;	
	var $MultiSelectKey;
	var $Command;
	var $RestoreSearch = FALSE;
	var $DetailPages;
	var $Recordset;
	var $OldRecordset;

	//
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError, $gsSearchError, $Security;

		// Search filters
		$sSrchAdvanced = ""; // Advanced search filter
		$sSrchBasic = ""; // Basic search filter
		$sFilter = "";

		// Get command
		$this->Command = strtolower(@$_GET["cmd"]);
		if ($this->IsPageRequest()) { // Validate request

			// Process list action first
			if ($this->ProcessListAction()) // Ajax request
				$this->Page_Terminate();

			// Handle reset command
			$this->ResetCmd();

			// Set up Breadcrumb
			if ($this->Export == "")
				$this->SetupBreadcrumb();

			// Hide list options
			if ($this->Export <> "") {
				$this->ListOptions->HideAllOptions(array("sequence"));
				$this->ListOptions->UseDropDownButton = FALSE; // Disable drop down button
				$this->ListOptions->UseButtonGroup = FALSE; // Disable button group
			} elseif ($this->CurrentAction == "gridadd" || $this->CurrentAction == "gridedit") {
				$this->ListOptions->HideAllOptions();
				$this->ListOptions->UseDropDownButton = FALSE; // Disable drop down button
				$this->ListOptions->UseButtonGroup = FALSE; // Disable button group
			}

			// Hide options
			if ($this->Export <> "" || $this->CurrentAction <> "") {
				$this->ExportOptions->HideAllOptions();
				$this->FilterOptions->HideAllOptions();
			}

			// Hide other options
			if ($this->Export <> "") {
				foreach ($this->OtherOptions as &$option)
					$option->HideAllOptions();
			}

			// Get default search criteria
			ew_AddFilter($this->DefaultSearchWhere, $this->AdvancedSearchWhere(TRUE));

			// Get and validate search values for advanced search
			$this->LoadSearchValues(); // Get search values

			// Process filter list
			$this->ProcessFilterList();
			if (!$this->ValidateSearch())
				$this->setFailureMessage($gsSearchError);

			// Restore search parms from Session if not searching / reset / export
			if (($this->Export <> "" || $this->Command <> "search" && $this->Command <> "reset" && $this->Command <> "resetall") && $this->CheckSearchParms())
				$this->RestoreSearchParms();

			// Call Recordset SearchValidated event
			$this->Recordset_SearchValidated();

			// Set up sorting order
			$this->SetUpSortOrder();

			// Get search criteria for advanced search
			if ($gsSearchError == "")
				$sSrchAdvanced = $this->AdvancedSearchWhere();
		}

		// Restore display records
		if ($this->getRecordsPerPage() <> "") {
			$this->DisplayRecs = $this->getRecordsPerPage(); // Restore from Session
		} else {
			$this->DisplayRecs = 20; // Load default
		}

		// Load Sorting Order
		$this->LoadSortOrder();

		// Load search default if no existing search criteria
		if (!$this->CheckSearchParms()) {

			// Load advanced search from default
			if ($this->LoadAdvancedSearchDefault()) {
				$sSrchAdvanced = $this->AdvancedSearchWhere();
			}
		}

		// Build search criteria
		ew_AddFilter($this->SearchWhere, $sSrchAdvanced);
		ew_AddFilter($this->SearchWhere, $sSrchBasic);

		// Call Recordset_Searching event
		$this->Recordset_Searching($this->SearchWhere);

		// Save search criteria
		if ($this->Command == "search" && !$this->RestoreSearch) {
			$this->setSearchWhere($this->SearchWhere); // Save to Session
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} else {
			$this->SearchWhere = $this->getSearchWhere();
		}

		// Build filter
		$sFilter = "";
		if (!$Security->CanList())
			$sFilter = "(0=1)"; // Filter all records
		ew_AddFilter($sFilter, $this->DbDetailFilter);
		ew_AddFilter($sFilter, $this->SearchWhere);

		// Set up filter in session
		$this->setSessionWhere($sFilter);
		$this->CurrentFilter = "";

		// Export data only
		if ($this->CustomExport == "" && in_array($this->Export, array("html","word","excel","xml","csv","email","pdf"))) {
			$this->ExportData();
			$this->Page_Terminate(); // Terminate response
			exit();
		}

		// Load record count first
		if (!$this->IsAddOrEdit()) {
			$bSelectLimit = $this->UseSelectLimit;
			if ($bSelectLimit) {
				$this->TotalRecs = $this->SelectRecordCount();
			} else {
				if ($this->Recordset = $this->LoadRecordset())
					$this->TotalRecs = $this->Recordset->RecordCount();
			}
		}

		// Search options
		$this->SetupSearchOptions();
	}

	// Build filter for all keys
	function BuildKeyFilter() {
		global $objForm;
		$sWrkFilter = "";

		// Update row index and get row key
		$rowindex = 1;
		$objForm->Index = $rowindex;
		$sThisKey = strval($objForm->GetValue($this->FormKeyName));
		while ($sThisKey <> "") {
			if ($this->SetupKeyValues($sThisKey)) {
				$sFilter = $this->KeyFilter();
				if ($sWrkFilter <> "") $sWrkFilter .= " OR ";
				$sWrkFilter .= $sFilter;
			} else {
				$sWrkFilter = "0=1";
				break;
			}

			// Update row index and get row key
			$rowindex++; // Next row
			$objForm->Index = $rowindex;
			$sThisKey = strval($objForm->GetValue($this->FormKeyName));
		}
		return $sWrkFilter;
	}

	// Set up key values
	function SetupKeyValues($key) {
		$arrKeyFlds = explode($GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"], $key);
		if (count($arrKeyFlds) >= 0) {
		}
		return TRUE;
	}

	// Get list of filters
	function GetFilterList() {
		global $UserProfile;

		// Load server side filters
		if (EW_SEARCH_FILTER_OPTION == "Server") {
			$sSavedFilterList = $UserProfile->GetSearchFilters(CurrentUserName(), "ftimecardslistsrch");
		} else {
			$sSavedFilterList = "";
		}

		// Initialize
		$sFilterList = "";
		$sFilterList = ew_Concat($sFilterList, $this->weeknumber->AdvancedSearch->ToJSON(), ","); // Field weeknumber
		$sFilterList = ew_Concat($sFilterList, $this->dbkey_councilor->AdvancedSearch->ToJSON(), ","); // Field dbkey_councilor
		$sFilterList = ew_Concat($sFilterList, $this->date->AdvancedSearch->ToJSON(), ","); // Field date
		$sFilterList = ew_Concat($sFilterList, $this->in->AdvancedSearch->ToJSON(), ","); // Field in
		$sFilterList = ew_Concat($sFilterList, $this->out->AdvancedSearch->ToJSON(), ","); // Field out
		$sFilterList = ew_Concat($sFilterList, $this->approved_by->AdvancedSearch->ToJSON(), ","); // Field approved_by
		$sFilterList = ew_Concat($sFilterList, $this->approved_on->AdvancedSearch->ToJSON(), ","); // Field approved_on
		$sFilterList = ew_Concat($sFilterList, $this->created_on->AdvancedSearch->ToJSON(), ","); // Field created_on
		$sFilterList = ew_Concat($sFilterList, $this->updated_on->AdvancedSearch->ToJSON(), ","); // Field updated_on
		$sFilterList = ew_Concat($sFilterList, $this->created_by->AdvancedSearch->ToJSON(), ","); // Field created_by
		$sFilterList = ew_Concat($sFilterList, $this->updated_by->AdvancedSearch->ToJSON(), ","); // Field updated_by
		$sFilterList = ew_Concat($sFilterList, $this->regular->AdvancedSearch->ToJSON(), ","); // Field regular
		$sFilterList = ew_Concat($sFilterList, $this->overtime->AdvancedSearch->ToJSON(), ","); // Field overtime
		$sFilterList = ew_Concat($sFilterList, $this->total->AdvancedSearch->ToJSON(), ","); // Field total
		$sFilterList = ew_Concat($sFilterList, $this->approved->AdvancedSearch->ToJSON(), ","); // Field approved
		$sFilterList = preg_replace('/,$/', "", $sFilterList);

		// Return filter list in json
		if ($sFilterList <> "")
			$sFilterList = "\"data\":{" . $sFilterList . "}";
		if ($sSavedFilterList <> "") {
			if ($sFilterList <> "")
				$sFilterList .= ",";
			$sFilterList .= "\"filters\":" . $sSavedFilterList;
		}
		return ($sFilterList <> "") ? "{" . $sFilterList . "}" : "null";
	}

	// Process filter list
	function ProcessFilterList() {
		global $UserProfile;
		if (@$_POST["ajax"] == "savefilters") { // Save filter request (Ajax)
			$filters = ew_StripSlashes(@$_POST["filters"]);
			$UserProfile->SetSearchFilters(CurrentUserName(), "ftimecardslistsrch", $filters);

			// Clean output buffer
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			echo ew_ArrayToJson(array(array("success" => TRUE))); // Success
			$this->Page_Terminate();
			exit();
		} elseif (@$_POST["cmd"] == "resetfilter") {
			$this->RestoreFilterList();
		}
	}

	// Restore list of filters
	function RestoreFilterList() {

		// Return if not reset filter
		if (@$_POST["cmd"] <> "resetfilter")
			return FALSE;
		$filter = json_decode(ew_StripSlashes(@$_POST["filter"]), TRUE);
		$this->Command = "search";

		// Field weeknumber
		$this->weeknumber->AdvancedSearch->SearchValue = @$filter["x_weeknumber"];
		$this->weeknumber->AdvancedSearch->SearchOperator = @$filter["z_weeknumber"];
		$this->weeknumber->AdvancedSearch->SearchCondition = @$filter["v_weeknumber"];
		$this->weeknumber->AdvancedSearch->SearchValue2 = @$filter["y_weeknumber"];
		$this->weeknumber->AdvancedSearch->SearchOperator2 = @$filter["w_weeknumber"];
		$this->weeknumber->AdvancedSearch->Save();

		// Field dbkey_councilor
		$this->dbkey_councilor->AdvancedSearch->SearchValue = @$filter["x_dbkey_councilor"];
		$this->dbkey_councilor->AdvancedSearch->SearchOperator = @$filter["z_dbkey_councilor"];
		$this->dbkey_councilor->AdvancedSearch->SearchCondition = @$filter["v_dbkey_councilor"];
		$this->dbkey_councilor->AdvancedSearch->SearchValue2 = @$filter["y_dbkey_councilor"];
		$this->dbkey_councilor->AdvancedSearch->SearchOperator2 = @$filter["w_dbkey_councilor"];
		$this->dbkey_councilor->AdvancedSearch->Save();

		// Field date
		$this->date->AdvancedSearch->SearchValue = @$filter["x_date"];
		$this->date->AdvancedSearch->SearchOperator = @$filter["z_date"];
		$this->date->AdvancedSearch->SearchCondition = @$filter["v_date"];
		$this->date->AdvancedSearch->SearchValue2 = @$filter["y_date"];
		$this->date->AdvancedSearch->SearchOperator2 = @$filter["w_date"];
		$this->date->AdvancedSearch->Save();

		// Field in
		$this->in->AdvancedSearch->SearchValue = @$filter["x_in"];
		$this->in->AdvancedSearch->SearchOperator = @$filter["z_in"];
		$this->in->AdvancedSearch->SearchCondition = @$filter["v_in"];
		$this->in->AdvancedSearch->SearchValue2 = @$filter["y_in"];
		$this->in->AdvancedSearch->SearchOperator2 = @$filter["w_in"];
		$this->in->AdvancedSearch->Save();

		// Field out
		$this->out->AdvancedSearch->SearchValue = @$filter["x_out"];
		$this->out->AdvancedSearch->SearchOperator = @$filter["z_out"];
		$this->out->AdvancedSearch->SearchCondition = @$filter["v_out"];
		$this->out->AdvancedSearch->SearchValue2 = @$filter["y_out"];
		$this->out->AdvancedSearch->SearchOperator2 = @$filter["w_out"];
		$this->out->AdvancedSearch->Save();

		// Field approved_by
		$this->approved_by->AdvancedSearch->SearchValue = @$filter["x_approved_by"];
		$this->approved_by->AdvancedSearch->SearchOperator = @$filter["z_approved_by"];
		$this->approved_by->AdvancedSearch->SearchCondition = @$filter["v_approved_by"];
		$this->approved_by->AdvancedSearch->SearchValue2 = @$filter["y_approved_by"];
		$this->approved_by->AdvancedSearch->SearchOperator2 = @$filter["w_approved_by"];
		$this->approved_by->AdvancedSearch->Save();

		// Field approved_on
		$this->approved_on->AdvancedSearch->SearchValue = @$filter["x_approved_on"];
		$this->approved_on->AdvancedSearch->SearchOperator = @$filter["z_approved_on"];
		$this->approved_on->AdvancedSearch->SearchCondition = @$filter["v_approved_on"];
		$this->approved_on->AdvancedSearch->SearchValue2 = @$filter["y_approved_on"];
		$this->approved_on->AdvancedSearch->SearchOperator2 = @$filter["w_approved_on"];
		$this->approved_on->AdvancedSearch->Save();

		// Field created_on
		$this->created_on->AdvancedSearch->SearchValue = @$filter["x_created_on"];
		$this->created_on->AdvancedSearch->SearchOperator = @$filter["z_created_on"];
		$this->created_on->AdvancedSearch->SearchCondition = @$filter["v_created_on"];
		$this->created_on->AdvancedSearch->SearchValue2 = @$filter["y_created_on"];
		$this->created_on->AdvancedSearch->SearchOperator2 = @$filter["w_created_on"];
		$this->created_on->AdvancedSearch->Save();

		// Field updated_on
		$this->updated_on->AdvancedSearch->SearchValue = @$filter["x_updated_on"];
		$this->updated_on->AdvancedSearch->SearchOperator = @$filter["z_updated_on"];
		$this->updated_on->AdvancedSearch->SearchCondition = @$filter["v_updated_on"];
		$this->updated_on->AdvancedSearch->SearchValue2 = @$filter["y_updated_on"];
		$this->updated_on->AdvancedSearch->SearchOperator2 = @$filter["w_updated_on"];
		$this->updated_on->AdvancedSearch->Save();

		// Field created_by
		$this->created_by->AdvancedSearch->SearchValue = @$filter["x_created_by"];
		$this->created_by->AdvancedSearch->SearchOperator = @$filter["z_created_by"];
		$this->created_by->AdvancedSearch->SearchCondition = @$filter["v_created_by"];
		$this->created_by->AdvancedSearch->SearchValue2 = @$filter["y_created_by"];
		$this->created_by->AdvancedSearch->SearchOperator2 = @$filter["w_created_by"];
		$this->created_by->AdvancedSearch->Save();

		// Field updated_by
		$this->updated_by->AdvancedSearch->SearchValue = @$filter["x_updated_by"];
		$this->updated_by->AdvancedSearch->SearchOperator = @$filter["z_updated_by"];
		$this->updated_by->AdvancedSearch->SearchCondition = @$filter["v_updated_by"];
		$this->updated_by->AdvancedSearch->SearchValue2 = @$filter["y_updated_by"];
		$this->updated_by->AdvancedSearch->SearchOperator2 = @$filter["w_updated_by"];
		$this->updated_by->AdvancedSearch->Save();

		// Field regular
		$this->regular->AdvancedSearch->SearchValue = @$filter["x_regular"];
		$this->regular->AdvancedSearch->SearchOperator = @$filter["z_regular"];
		$this->regular->AdvancedSearch->SearchCondition = @$filter["v_regular"];
		$this->regular->AdvancedSearch->SearchValue2 = @$filter["y_regular"];
		$this->regular->AdvancedSearch->SearchOperator2 = @$filter["w_regular"];
		$this->regular->AdvancedSearch->Save();

		// Field overtime
		$this->overtime->AdvancedSearch->SearchValue = @$filter["x_overtime"];
		$this->overtime->AdvancedSearch->SearchOperator = @$filter["z_overtime"];
		$this->overtime->AdvancedSearch->SearchCondition = @$filter["v_overtime"];
		$this->overtime->AdvancedSearch->SearchValue2 = @$filter["y_overtime"];
		$this->overtime->AdvancedSearch->SearchOperator2 = @$filter["w_overtime"];
		$this->overtime->AdvancedSearch->Save();

		// Field total
		$this->total->AdvancedSearch->SearchValue = @$filter["x_total"];
		$this->total->AdvancedSearch->SearchOperator = @$filter["z_total"];
		$this->total->AdvancedSearch->SearchCondition = @$filter["v_total"];
		$this->total->AdvancedSearch->SearchValue2 = @$filter["y_total"];
		$this->total->AdvancedSearch->SearchOperator2 = @$filter["w_total"];
		$this->total->AdvancedSearch->Save();

		// Field approved
		$this->approved->AdvancedSearch->SearchValue = @$filter["x_approved"];
		$this->approved->AdvancedSearch->SearchOperator = @$filter["z_approved"];
		$this->approved->AdvancedSearch->SearchCondition = @$filter["v_approved"];
		$this->approved->AdvancedSearch->SearchValue2 = @$filter["y_approved"];
		$this->approved->AdvancedSearch->SearchOperator2 = @$filter["w_approved"];
		$this->approved->AdvancedSearch->Save();
	}

	// Advanced search WHERE clause based on QueryString
	function AdvancedSearchWhere($Default = FALSE) {
		global $Security;
		$sWhere = "";
		if (!$Security->CanSearch()) return "";
		$this->BuildSearchSql($sWhere, $this->weeknumber, $Default, FALSE); // weeknumber
		$this->BuildSearchSql($sWhere, $this->dbkey_councilor, $Default, FALSE); // dbkey_councilor
		$this->BuildSearchSql($sWhere, $this->date, $Default, FALSE); // date
		$this->BuildSearchSql($sWhere, $this->in, $Default, FALSE); // in
		$this->BuildSearchSql($sWhere, $this->out, $Default, FALSE); // out
		$this->BuildSearchSql($sWhere, $this->approved_by, $Default, FALSE); // approved_by
		$this->BuildSearchSql($sWhere, $this->approved_on, $Default, FALSE); // approved_on
		$this->BuildSearchSql($sWhere, $this->created_on, $Default, FALSE); // created_on
		$this->BuildSearchSql($sWhere, $this->updated_on, $Default, FALSE); // updated_on
		$this->BuildSearchSql($sWhere, $this->created_by, $Default, FALSE); // created_by
		$this->BuildSearchSql($sWhere, $this->updated_by, $Default, FALSE); // updated_by
		$this->BuildSearchSql($sWhere, $this->regular, $Default, FALSE); // regular
		$this->BuildSearchSql($sWhere, $this->overtime, $Default, FALSE); // overtime
		$this->BuildSearchSql($sWhere, $this->total, $Default, FALSE); // total
		$this->BuildSearchSql($sWhere, $this->approved, $Default, FALSE); // approved

		// Set up search parm
		if (!$Default && $sWhere <> "") {
			$this->Command = "search";
		}
		if (!$Default && $this->Command == "search") {
			$this->weeknumber->AdvancedSearch->Save(); // weeknumber
			$this->dbkey_councilor->AdvancedSearch->Save(); // dbkey_councilor
			$this->date->AdvancedSearch->Save(); // date
			$this->in->AdvancedSearch->Save(); // in
			$this->out->AdvancedSearch->Save(); // out
			$this->approved_by->AdvancedSearch->Save(); // approved_by
			$this->approved_on->AdvancedSearch->Save(); // approved_on
			$this->created_on->AdvancedSearch->Save(); // created_on
			$this->updated_on->AdvancedSearch->Save(); // updated_on
			$this->created_by->AdvancedSearch->Save(); // created_by
			$this->updated_by->AdvancedSearch->Save(); // updated_by
			$this->regular->AdvancedSearch->Save(); // regular
			$this->overtime->AdvancedSearch->Save(); // overtime
			$this->total->AdvancedSearch->Save(); // total
			$this->approved->AdvancedSearch->Save(); // approved
		}
		return $sWhere;
	}

	// Build search SQL
	function BuildSearchSql(&$Where, &$Fld, $Default, $MultiValue) {
		$FldParm = substr($Fld->FldVar, 2);
		$FldVal = ($Default) ? $Fld->AdvancedSearch->SearchValueDefault : $Fld->AdvancedSearch->SearchValue; // @$_GET["x_$FldParm"]
		$FldOpr = ($Default) ? $Fld->AdvancedSearch->SearchOperatorDefault : $Fld->AdvancedSearch->SearchOperator; // @$_GET["z_$FldParm"]
		$FldCond = ($Default) ? $Fld->AdvancedSearch->SearchConditionDefault : $Fld->AdvancedSearch->SearchCondition; // @$_GET["v_$FldParm"]
		$FldVal2 = ($Default) ? $Fld->AdvancedSearch->SearchValue2Default : $Fld->AdvancedSearch->SearchValue2; // @$_GET["y_$FldParm"]
		$FldOpr2 = ($Default) ? $Fld->AdvancedSearch->SearchOperator2Default : $Fld->AdvancedSearch->SearchOperator2; // @$_GET["w_$FldParm"]
		$sWrk = "";

		//$FldVal = ew_StripSlashes($FldVal);
		if (is_array($FldVal)) $FldVal = implode(",", $FldVal);

		//$FldVal2 = ew_StripSlashes($FldVal2);
		if (is_array($FldVal2)) $FldVal2 = implode(",", $FldVal2);
		$FldOpr = strtoupper(trim($FldOpr));
		if ($FldOpr == "") $FldOpr = "=";
		$FldOpr2 = strtoupper(trim($FldOpr2));
		if ($FldOpr2 == "") $FldOpr2 = "=";
		if (EW_SEARCH_MULTI_VALUE_OPTION == 1)
			$MultiValue = FALSE;
		if ($MultiValue) {
			$sWrk1 = ($FldVal <> "") ? ew_GetMultiSearchSql($Fld, $FldOpr, $FldVal, $this->DBID) : ""; // Field value 1
			$sWrk2 = ($FldVal2 <> "") ? ew_GetMultiSearchSql($Fld, $FldOpr2, $FldVal2, $this->DBID) : ""; // Field value 2
			$sWrk = $sWrk1; // Build final SQL
			if ($sWrk2 <> "")
				$sWrk = ($sWrk <> "") ? "($sWrk) $FldCond ($sWrk2)" : $sWrk2;
		} else {
			$FldVal = $this->ConvertSearchValue($Fld, $FldVal);
			$FldVal2 = $this->ConvertSearchValue($Fld, $FldVal2);
			$sWrk = ew_GetSearchSql($Fld, $FldVal, $FldOpr, $FldCond, $FldVal2, $FldOpr2, $this->DBID);
		}
		ew_AddFilter($Where, $sWrk);
	}

	// Convert search value
	function ConvertSearchValue(&$Fld, $FldVal) {
		if ($FldVal == EW_NULL_VALUE || $FldVal == EW_NOT_NULL_VALUE)
			return $FldVal;
		$Value = $FldVal;
		if ($Fld->FldDataType == EW_DATATYPE_BOOLEAN) {
			if ($FldVal <> "") $Value = ($FldVal == "1" || strtolower(strval($FldVal)) == "y" || strtolower(strval($FldVal)) == "t") ? $Fld->TrueValue : $Fld->FalseValue;
		} elseif ($Fld->FldDataType == EW_DATATYPE_DATE || $Fld->FldDataType == EW_DATATYPE_TIME) {
			if ($FldVal <> "") $Value = ew_UnFormatDateTime($FldVal, $Fld->FldDateTimeFormat);
		}
		return $Value;
	}

	// Check if search parm exists
	function CheckSearchParms() {
		if ($this->weeknumber->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->dbkey_councilor->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->date->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->in->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->out->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->approved_by->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->approved_on->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->created_on->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->updated_on->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->created_by->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->updated_by->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->regular->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->overtime->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->total->AdvancedSearch->IssetSession())
			return TRUE;
		if ($this->approved->AdvancedSearch->IssetSession())
			return TRUE;
		return FALSE;
	}

	// Clear all search parameters
	function ResetSearchParms() {

		// Clear search WHERE clause
		$this->SearchWhere = "";
		$this->setSearchWhere($this->SearchWhere);

		// Clear advanced search parameters
		$this->ResetAdvancedSearchParms();
	}

	// Load advanced search default values
	function LoadAdvancedSearchDefault() {
		return FALSE;
	}

	// Clear all advanced search parameters
	function ResetAdvancedSearchParms() {
		$this->weeknumber->AdvancedSearch->UnsetSession();
		$this->dbkey_councilor->AdvancedSearch->UnsetSession();
		$this->date->AdvancedSearch->UnsetSession();
		$this->in->AdvancedSearch->UnsetSession();
		$this->out->AdvancedSearch->UnsetSession();
		$this->approved_by->AdvancedSearch->UnsetSession();
		$this->approved_on->AdvancedSearch->UnsetSession();
		$this->created_on->AdvancedSearch->UnsetSession();
		$this->updated_on->AdvancedSearch->UnsetSession();
		$this->created_by->AdvancedSearch->UnsetSession();
		$this->updated_by->AdvancedSearch->UnsetSession();
		$this->regular->AdvancedSearch->UnsetSession();
		$this->overtime->AdvancedSearch->UnsetSession();
		$this->total->AdvancedSearch->UnsetSession();
		$this->approved->AdvancedSearch->UnsetSession();
	}

	// Restore all search parameters
	function RestoreSearchParms() {
		$this->RestoreSearch = TRUE;

		// Restore advanced search values
		$this->weeknumber->AdvancedSearch->Load();
		$this->dbkey_councilor->AdvancedSearch->Load();
		$this->date->AdvancedSearch->Load();
		$this->in->AdvancedSearch->Load();
		$this->out->AdvancedSearch->Load();
		$this->approved_by->AdvancedSearch->Load();
		$this->approved_on->AdvancedSearch->Load();
		$this->created_on->AdvancedSearch->Load();
		$this->updated_on->AdvancedSearch->Load();
		$this->created_by->AdvancedSearch->Load();
		$this->updated_by->AdvancedSearch->Load();
		$this->regular->AdvancedSearch->Load();
		$this->overtime->AdvancedSearch->Load();
		$this->total->AdvancedSearch->Load();
		$this->approved->AdvancedSearch->Load();
	}

	// Set up sort parameters
	function SetUpSortOrder() {

		// Check for "order" parameter
		if (@$_GET["order"] <> "") {
			$this->CurrentOrder = ew_StripSlashes(@$_GET["order"]);
			$this->CurrentOrderType = @$_GET["ordertype"];
			$this->UpdateSort($this->weeknumber); // weeknumber
			$this->UpdateSort($this->dbkey_councilor); // dbkey_councilor
			$this->UpdateSort($this->date); // date
			$this->UpdateSort($this->in); // in
			$this->UpdateSort($this->out); // out
			$this->UpdateSort($this->regular); // regular
			$this->UpdateSort($this->overtime); // overtime
			$this->UpdateSort($this->total); // total
			$this->UpdateSort($this->approved); // approved
			$this->setStartRecordNumber(1); // Reset start position
		}
	}

	// Load sort order parameters
	function LoadSortOrder() {
		$sOrderBy = $this->getSessionOrderBy(); // Get ORDER BY from Session
		if ($sOrderBy == "") {
			if ($this->getSqlOrderBy() <> "") {
				$sOrderBy = $this->getSqlOrderBy();
				$this->setSessionOrderBy($sOrderBy);
				$this->dbkey_councilor->setSort("ASC");
				$this->date->setSort("DESC");
				$this->in->setSort("DESC");
			}
		}
	}

	// Reset command
	// - cmd=reset (Reset search parameters)
	// - cmd=resetall (Reset search and master/detail parameters)
	// - cmd=resetsort (Reset sort parameters)
	function ResetCmd() {

		// Check if reset command
		if (substr($this->Command,0,5) == "reset") {

			// Reset search criteria
			if ($this->Command == "reset" || $this->Command == "resetall")
				$this->ResetSearchParms();

			// Reset sorting order
			if ($this->Command == "resetsort") {
				$sOrderBy = "";
				$this->setSessionOrderBy($sOrderBy);
				$this->weeknumber->setSort("");
				$this->dbkey_councilor->setSort("");
				$this->date->setSort("");
				$this->in->setSort("");
				$this->out->setSort("");
				$this->regular->setSort("");
				$this->overtime->setSort("");
				$this->total->setSort("");
				$this->approved->setSort("");
			}

			// Reset start position
			$this->StartRec = 1;
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Set up list options
	function SetupListOptions() {
		global $Security, $Language;

		// Add group option item
		$item = &$this->ListOptions->Add($this->ListOptions->GroupOptionName);
		$item->Body = "";
		$item->OnLeft = FALSE;
		$item->Visible = FALSE;

		// List actions
		$item = &$this->ListOptions->Add("listactions");
		$item->CssStyle = "white-space: nowrap;";
		$item->OnLeft = FALSE;
		$item->Visible = FALSE;
		$item->ShowInButtonGroup = FALSE;
		$item->ShowInDropDown = FALSE;

		// "checkbox"
		$item = &$this->ListOptions->Add("checkbox");
		$item->Visible = FALSE;
		$item->OnLeft = FALSE;
		$item->Header = "<input type=\"checkbox\" name=\"key\" id=\"key\" onclick=\"ew_SelectAllKey(this);\">";
		$item->ShowInDropDown = FALSE;
		$item->ShowInButtonGroup = FALSE;

		// Drop down button for ListOptions
		$this->ListOptions->UseImageAndText = TRUE;
		$this->ListOptions->UseDropDownButton = FALSE;
		$this->ListOptions->DropDownButtonPhrase = $Language->Phrase("ButtonListOptions");
		$this->ListOptions->UseButtonGroup = FALSE;
		if ($this->ListOptions->UseButtonGroup && ew_IsMobile())
			$this->ListOptions->UseDropDownButton = TRUE;
		$this->ListOptions->ButtonClass = "btn-sm"; // Class for button group

		// Call ListOptions_Load event
		$this->ListOptions_Load();
		$this->SetupListOptionsExt();
		$item = &$this->ListOptions->GetItem($this->ListOptions->GroupOptionName);
		$item->Visible = $this->ListOptions->GroupOptionVisible();
	}

	// Render list options
	function RenderListOptions() {
		global $Security, $Language, $objForm;
		$this->ListOptions->LoadDefault();

		// Set up list action buttons
		$oListOpt = &$this->ListOptions->GetItem("listactions");
		if ($oListOpt && $this->Export == "" && $this->CurrentAction == "") {
			$body = "";
			$links = array();
			foreach ($this->ListActions->Items as $listaction) {
				if ($listaction->Select == EW_ACTION_SINGLE && $listaction->Allow) {
					$action = $listaction->Action;
					$caption = $listaction->Caption;
					$icon = ($listaction->Icon <> "") ? "<span class=\"" . ew_HtmlEncode(str_replace(" ewIcon", "", $listaction->Icon)) . "\" data-caption=\"" . ew_HtmlTitle($caption) . "\"></span> " : "";
					$links[] = "<li><a class=\"ewAction ewListAction\" data-action=\"" . ew_HtmlEncode($action) . "\" data-caption=\"" . ew_HtmlTitle($caption) . "\" href=\"\" onclick=\"ew_SubmitAction(event,jQuery.extend({key:" . $this->KeyToJson() . "}," . $listaction->ToJson(TRUE) . "));return false;\">" . $icon . $listaction->Caption . "</a></li>";
					if (count($links) == 1) // Single button
						$body = "<a class=\"ewAction ewListAction\" data-action=\"" . ew_HtmlEncode($action) . "\" title=\"" . ew_HtmlTitle($caption) . "\" data-caption=\"" . ew_HtmlTitle($caption) . "\" href=\"\" onclick=\"ew_SubmitAction(event,jQuery.extend({key:" . $this->KeyToJson() . "}," . $listaction->ToJson(TRUE) . "));return false;\">" . $Language->Phrase("ListActionButton") . "</a>";
				}
			}
			if (count($links) > 1) { // More than one buttons, use dropdown
				$body = "<button class=\"dropdown-toggle btn btn-default btn-sm ewActions\" title=\"" . ew_HtmlTitle($Language->Phrase("ListActionButton")) . "\" data-toggle=\"dropdown\">" . $Language->Phrase("ListActionButton") . "<b class=\"caret\"></b></button>";
				$content = "";
				foreach ($links as $link)
					$content .= "<li>" . $link . "</li>";
				$body .= "<ul class=\"dropdown-menu" . ($oListOpt->OnLeft ? "" : " dropdown-menu-right") . "\">". $content . "</ul>";
				$body = "<div class=\"btn-group\">" . $body . "</div>";
			}
			if (count($links) > 0) {
				$oListOpt->Body = $body;
				$oListOpt->Visible = TRUE;
			}
		}

		// "checkbox"
		$oListOpt = &$this->ListOptions->Items["checkbox"];
		$this->RenderListOptionsExt();

		// Call ListOptions_Rendered event
		$this->ListOptions_Rendered();
	}

	// Set up other options
	function SetupOtherOptions() {
		global $Language, $Security;
		$options = &$this->OtherOptions;
		$option = $options["addedit"];

		// Add
		$item = &$option->Add("add");
		$addcaption = ew_HtmlTitle($Language->Phrase("AddLink"));
		$item->Body = "<a class=\"ewAddEdit ewAdd\" title=\"" . $addcaption . "\" data-caption=\"" . $addcaption . "\" href=\"" . ew_HtmlEncode($this->AddUrl) . "\">" . $Language->Phrase("AddLink") . "</a>";
		$item->Visible = ($this->AddUrl <> "" && $Security->CanAdd());
		$option = $options["action"];

		// Set up options default
		foreach ($options as &$option) {
			$option->UseImageAndText = TRUE;
			$option->UseDropDownButton = FALSE;
			$option->UseButtonGroup = TRUE;
			$option->ButtonClass = "btn-sm"; // Class for button group
			$item = &$option->Add($option->GroupOptionName);
			$item->Body = "";
			$item->Visible = FALSE;
		}
		$options["addedit"]->DropDownButtonPhrase = $Language->Phrase("ButtonAddEdit");
		$options["detail"]->DropDownButtonPhrase = $Language->Phrase("ButtonDetails");
		$options["action"]->DropDownButtonPhrase = $Language->Phrase("ButtonActions");

		// Filter button
		$item = &$this->FilterOptions->Add("savecurrentfilter");
		$item->Body = "<a class=\"ewSaveFilter\" data-form=\"ftimecardslistsrch\" href=\"#\">" . $Language->Phrase("SaveCurrentFilter") . "</a>";
		$item->Visible = TRUE;
		$item = &$this->FilterOptions->Add("deletefilter");
		$item->Body = "<a class=\"ewDeleteFilter\" data-form=\"ftimecardslistsrch\" href=\"#\">" . $Language->Phrase("DeleteFilter") . "</a>";
		$item->Visible = TRUE;
		$this->FilterOptions->UseDropDownButton = TRUE;
		$this->FilterOptions->UseButtonGroup = !$this->FilterOptions->UseDropDownButton;
		$this->FilterOptions->DropDownButtonPhrase = $Language->Phrase("Filters");

		// Add group option item
		$item = &$this->FilterOptions->Add($this->FilterOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;
	}

	// Render other options
	function RenderOtherOptions() {
		global $Language, $Security;
		$options = &$this->OtherOptions;
			$option = &$options["action"];

			// Set up list action buttons
			foreach ($this->ListActions->Items as $listaction) {
				if ($listaction->Select == EW_ACTION_MULTIPLE) {
					$item = &$option->Add("custom_" . $listaction->Action);
					$caption = $listaction->Caption;
					$icon = ($listaction->Icon <> "") ? "<span class=\"" . ew_HtmlEncode($listaction->Icon) . "\" data-caption=\"" . ew_HtmlEncode($caption) . "\"></span> " : $caption;
					$item->Body = "<a class=\"ewAction ewListAction\" title=\"" . ew_HtmlEncode($caption) . "\" data-caption=\"" . ew_HtmlEncode($caption) . "\" href=\"\" onclick=\"ew_SubmitAction(event,jQuery.extend({f:document.ftimecardslist}," . $listaction->ToJson(TRUE) . "));return false;\">" . $icon . "</a>";
					$item->Visible = $listaction->Allow;
				}
			}

			// Hide grid edit and other options
			if ($this->TotalRecs <= 0) {
				$option = &$options["addedit"];
				$item = &$option->GetItem("gridedit");
				if ($item) $item->Visible = FALSE;
				$option = &$options["action"];
				$option->HideAllOptions();
			}
	}

	// Process list action
	function ProcessListAction() {
		global $Language, $Security;
		$userlist = "";
		$user = "";
		$sFilter = $this->GetKeyFilter();
		$UserAction = @$_POST["useraction"];
		if ($sFilter <> "" && $UserAction <> "") {

			// Check permission first
			$ActionCaption = $UserAction;
			if (array_key_exists($UserAction, $this->ListActions->Items)) {
				$ActionCaption = $this->ListActions->Items[$UserAction]->Caption;
				if (!$this->ListActions->Items[$UserAction]->Allow) {
					$errmsg = str_replace('%s', $ActionCaption, $Language->Phrase("CustomActionNotAllowed"));
					if (@$_POST["ajax"] == $UserAction) // Ajax
						echo "<p class=\"text-danger\">" . $errmsg . "</p>";
					else
						$this->setFailureMessage($errmsg);
					return FALSE;
				}
			}
			$this->CurrentFilter = $sFilter;
			$sSql = $this->SQL();
			$conn = &$this->Connection();
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			$rs = $conn->Execute($sSql);
			$conn->raiseErrorFn = '';
			$this->CurrentAction = $UserAction;

			// Call row action event
			if ($rs && !$rs->EOF) {
				$conn->BeginTrans();
				$this->SelectedCount = $rs->RecordCount();
				$this->SelectedIndex = 0;
				while (!$rs->EOF) {
					$this->SelectedIndex++;
					$row = $rs->fields;
					$Processed = $this->Row_CustomAction($UserAction, $row);
					if (!$Processed) break;
					$rs->MoveNext();
				}
				if ($Processed) {
					$conn->CommitTrans(); // Commit the changes
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage(str_replace('%s', $ActionCaption, $Language->Phrase("CustomActionCompleted"))); // Set up success message
				} else {
					$conn->RollbackTrans(); // Rollback changes

					// Set up error message
					if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

						// Use the message, do nothing
					} elseif ($this->CancelMessage <> "") {
						$this->setFailureMessage($this->CancelMessage);
						$this->CancelMessage = "";
					} else {
						$this->setFailureMessage(str_replace('%s', $ActionCaption, $Language->Phrase("CustomActionFailed")));
					}
				}
			}
			if ($rs)
				$rs->Close();
			$this->CurrentAction = ""; // Clear action
			if (@$_POST["ajax"] == $UserAction) { // Ajax
				if ($this->getSuccessMessage() <> "") {
					echo "<p class=\"text-success\">" . $this->getSuccessMessage() . "</p>";
					$this->ClearSuccessMessage(); // Clear message
				}
				if ($this->getFailureMessage() <> "") {
					echo "<p class=\"text-danger\">" . $this->getFailureMessage() . "</p>";
					$this->ClearFailureMessage(); // Clear message
				}
				return TRUE;
			}
		}
		return FALSE; // Not ajax request
	}

	// Set up search options
	function SetupSearchOptions() {
		global $Language;
		$this->SearchOptions = new cListOptions();
		$this->SearchOptions->Tag = "div";
		$this->SearchOptions->TagClassName = "ewSearchOption";

		// Search button
		$item = &$this->SearchOptions->Add("searchtoggle");
		$SearchToggleClass = ($this->SearchWhere <> "") ? " active" : " active";
		$item->Body = "<button type=\"button\" class=\"btn btn-default ewSearchToggle" . $SearchToggleClass . "\" title=\"" . $Language->Phrase("SearchPanel") . "\" data-caption=\"" . $Language->Phrase("SearchPanel") . "\" data-toggle=\"button\" data-form=\"ftimecardslistsrch\">" . $Language->Phrase("SearchBtn") . "</button>";
		$item->Visible = TRUE;

		// Show all button
		$item = &$this->SearchOptions->Add("showall");
		$item->Body = "<a class=\"btn btn-default ewShowAll\" title=\"" . $Language->Phrase("ShowAll") . "\" data-caption=\"" . $Language->Phrase("ShowAll") . "\" href=\"" . $this->PageUrl() . "cmd=reset\">" . $Language->Phrase("ShowAllBtn") . "</a>";
		$item->Visible = ($this->SearchWhere <> $this->DefaultSearchWhere && $this->SearchWhere <> "0=101");

		// Button group for search
		$this->SearchOptions->UseDropDownButton = FALSE;
		$this->SearchOptions->UseImageAndText = TRUE;
		$this->SearchOptions->UseButtonGroup = TRUE;
		$this->SearchOptions->DropDownButtonPhrase = $Language->Phrase("ButtonSearch");

		// Add group option item
		$item = &$this->SearchOptions->Add($this->SearchOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;

		// Hide search options
		if ($this->Export <> "" || $this->CurrentAction <> "")
			$this->SearchOptions->HideAllOptions();
		global $Security;
		if (!$Security->CanSearch()) {
			$this->SearchOptions->HideAllOptions();
			$this->FilterOptions->HideAllOptions();
		}
	}

	function SetupListOptionsExt() {
		global $Security, $Language;
	}

	function RenderListOptionsExt() {
		global $Security, $Language;
	}

	// Set up starting record parameters
	function SetUpStartRec() {
		if ($this->DisplayRecs == 0)
			return;
		if ($this->IsPageRequest()) { // Validate request
			if (@$_GET[EW_TABLE_START_REC] <> "") { // Check for "start" parameter
				$this->StartRec = $_GET[EW_TABLE_START_REC];
				$this->setStartRecordNumber($this->StartRec);
			} elseif (@$_GET[EW_TABLE_PAGE_NO] <> "") {
				$PageNo = $_GET[EW_TABLE_PAGE_NO];
				if (is_numeric($PageNo)) {
					$this->StartRec = ($PageNo-1)*$this->DisplayRecs+1;
					if ($this->StartRec <= 0) {
						$this->StartRec = 1;
					} elseif ($this->StartRec >= intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1) {
						$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1;
					}
					$this->setStartRecordNumber($this->StartRec);
				}
			}
		}
		$this->StartRec = $this->getStartRecordNumber();

		// Check if correct start record counter
		if (!is_numeric($this->StartRec) || $this->StartRec == "") { // Avoid invalid start record counter
			$this->StartRec = 1; // Reset start record counter
			$this->setStartRecordNumber($this->StartRec);
		} elseif (intval($this->StartRec) > intval($this->TotalRecs)) { // Avoid starting record > total records
			$this->StartRec = intval(($this->TotalRecs-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to last page first record
			$this->setStartRecordNumber($this->StartRec);
		} elseif (($this->StartRec-1) % $this->DisplayRecs <> 0) {
			$this->StartRec = intval(($this->StartRec-1)/$this->DisplayRecs)*$this->DisplayRecs+1; // Point to page boundary
			$this->setStartRecordNumber($this->StartRec);
		}
	}

	// Load search values for validation
	function LoadSearchValues() {
		global $objForm;

		// Load search values
		// weeknumber

		$this->weeknumber->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_weeknumber"]);
		if ($this->weeknumber->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->weeknumber->AdvancedSearch->SearchOperator = @$_GET["z_weeknumber"];

		// dbkey_councilor
		$this->dbkey_councilor->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_dbkey_councilor"]);
		if ($this->dbkey_councilor->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->dbkey_councilor->AdvancedSearch->SearchOperator = @$_GET["z_dbkey_councilor"];

		// date
		$this->date->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_date"]);
		if ($this->date->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->date->AdvancedSearch->SearchOperator = @$_GET["z_date"];
		$this->date->AdvancedSearch->SearchCondition = @$_GET["v_date"];
		$this->date->AdvancedSearch->SearchValue2 = ew_StripSlashes(@$_GET["y_date"]);
		if ($this->date->AdvancedSearch->SearchValue2 <> "") $this->Command = "search";
		$this->date->AdvancedSearch->SearchOperator2 = @$_GET["w_date"];

		// in
		$this->in->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_in"]);
		if ($this->in->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->in->AdvancedSearch->SearchOperator = @$_GET["z_in"];

		// out
		$this->out->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_out"]);
		if ($this->out->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->out->AdvancedSearch->SearchOperator = @$_GET["z_out"];

		// approved_by
		$this->approved_by->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_approved_by"]);
		if ($this->approved_by->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->approved_by->AdvancedSearch->SearchOperator = @$_GET["z_approved_by"];

		// approved_on
		$this->approved_on->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_approved_on"]);
		if ($this->approved_on->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->approved_on->AdvancedSearch->SearchOperator = @$_GET["z_approved_on"];

		// created_on
		$this->created_on->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_created_on"]);
		if ($this->created_on->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->created_on->AdvancedSearch->SearchOperator = @$_GET["z_created_on"];

		// updated_on
		$this->updated_on->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_updated_on"]);
		if ($this->updated_on->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->updated_on->AdvancedSearch->SearchOperator = @$_GET["z_updated_on"];

		// created_by
		$this->created_by->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_created_by"]);
		if ($this->created_by->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->created_by->AdvancedSearch->SearchOperator = @$_GET["z_created_by"];

		// updated_by
		$this->updated_by->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_updated_by"]);
		if ($this->updated_by->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->updated_by->AdvancedSearch->SearchOperator = @$_GET["z_updated_by"];

		// regular
		$this->regular->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_regular"]);
		if ($this->regular->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->regular->AdvancedSearch->SearchOperator = @$_GET["z_regular"];

		// overtime
		$this->overtime->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_overtime"]);
		if ($this->overtime->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->overtime->AdvancedSearch->SearchOperator = @$_GET["z_overtime"];

		// total
		$this->total->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_total"]);
		if ($this->total->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->total->AdvancedSearch->SearchOperator = @$_GET["z_total"];

		// approved
		$this->approved->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_approved"]);
		if ($this->approved->AdvancedSearch->SearchValue <> "") $this->Command = "search";
		$this->approved->AdvancedSearch->SearchOperator = @$_GET["z_approved"];
		if (is_array($this->approved->AdvancedSearch->SearchValue)) $this->approved->AdvancedSearch->SearchValue = implode(",", $this->approved->AdvancedSearch->SearchValue);
		if (is_array($this->approved->AdvancedSearch->SearchValue2)) $this->approved->AdvancedSearch->SearchValue2 = implode(",", $this->approved->AdvancedSearch->SearchValue2);
	}

	// Load recordset
	function LoadRecordset($offset = -1, $rowcnt = -1) {

		// Load List page SQL
		$sSql = $this->SelectSQL();
		$conn = &$this->Connection();

		// Load recordset
		$dbtype = ew_GetConnectionType($this->DBID);
		if ($this->UseSelectLimit) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			if ($dbtype == "MSSQL") {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset, array("_hasOrderBy" => trim($this->getOrderBy()) || trim($this->getSessionOrderBy())));
			} else {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset);
			}
			$conn->raiseErrorFn = '';
		} else {
			$rs = ew_LoadRecordset($sSql, $conn);
		}

		// Call Recordset Selected event
		$this->Recordset_Selected($rs);
		return $rs;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->start->setDbValue($rs->fields('start'));
		$this->end->setDbValue($rs->fields('end'));
		$this->weeknumber->setDbValue($rs->fields('weeknumber'));
		$this->dbkey_councilor->setDbValue($rs->fields('dbkey_councilor'));
		$this->date->setDbValue($rs->fields('date'));
		$this->in->setDbValue($rs->fields('in'));
		$this->out->setDbValue($rs->fields('out'));
		$this->approved_by->setDbValue($rs->fields('approved_by'));
		$this->approved_on->setDbValue($rs->fields('approved_on'));
		$this->created_on->setDbValue($rs->fields('created_on'));
		$this->updated_on->setDbValue($rs->fields('updated_on'));
		$this->created_by->setDbValue($rs->fields('created_by'));
		$this->updated_by->setDbValue($rs->fields('updated_by'));
		$this->regular->setDbValue($rs->fields('regular'));
		$this->overtime->setDbValue($rs->fields('overtime'));
		$this->total->setDbValue($rs->fields('total'));
		$this->approved->setDbValue($rs->fields('approved'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey->DbValue = $row['dbkey'];
		$this->start->DbValue = $row['start'];
		$this->end->DbValue = $row['end'];
		$this->weeknumber->DbValue = $row['weeknumber'];
		$this->dbkey_councilor->DbValue = $row['dbkey_councilor'];
		$this->date->DbValue = $row['date'];
		$this->in->DbValue = $row['in'];
		$this->out->DbValue = $row['out'];
		$this->approved_by->DbValue = $row['approved_by'];
		$this->approved_on->DbValue = $row['approved_on'];
		$this->created_on->DbValue = $row['created_on'];
		$this->updated_on->DbValue = $row['updated_on'];
		$this->created_by->DbValue = $row['created_by'];
		$this->updated_by->DbValue = $row['updated_by'];
		$this->regular->DbValue = $row['regular'];
		$this->overtime->DbValue = $row['overtime'];
		$this->total->DbValue = $row['total'];
		$this->approved->DbValue = $row['approved'];
	}

	// Load old record
	function LoadOldRecord() {

		// Load key values from Session
		$bValidKey = TRUE;

		// Load old recordset
		if ($bValidKey) {
			$this->CurrentFilter = $this->KeyFilter();
			$sSql = $this->SQL();
			$conn = &$this->Connection();
			$this->OldRecordset = ew_LoadRecordset($sSql, $conn);
			$this->LoadRowValues($this->OldRecordset); // Load row values
		} else {
			$this->OldRecordset = NULL;
		}
		return $bValidKey;
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		$this->ViewUrl = $this->GetViewUrl();
		$this->EditUrl = $this->GetEditUrl();
		$this->InlineEditUrl = $this->GetInlineEditUrl();
		$this->CopyUrl = $this->GetCopyUrl();
		$this->InlineCopyUrl = $this->GetInlineCopyUrl();
		$this->DeleteUrl = $this->GetDeleteUrl();

		// Convert decimal values if posted back
		if ($this->regular->FormValue == $this->regular->CurrentValue && is_numeric(ew_StrToFloat($this->regular->CurrentValue)))
			$this->regular->CurrentValue = ew_StrToFloat($this->regular->CurrentValue);

		// Convert decimal values if posted back
		if ($this->overtime->FormValue == $this->overtime->CurrentValue && is_numeric(ew_StrToFloat($this->overtime->CurrentValue)))
			$this->overtime->CurrentValue = ew_StrToFloat($this->overtime->CurrentValue);

		// Convert decimal values if posted back
		if ($this->total->FormValue == $this->total->CurrentValue && is_numeric(ew_StrToFloat($this->total->CurrentValue)))
			$this->total->CurrentValue = ew_StrToFloat($this->total->CurrentValue);

		// Call Row_Rendering event
		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey

		$this->dbkey->CellCssStyle = "white-space: nowrap;";

		// start
		// end

		$this->end->CellCssStyle = "white-space: nowrap;";

		// weeknumber
		$this->weeknumber->CellCssStyle = "white-space: nowrap;";

		// dbkey_councilor
		// date
		// in
		// out
		// approved_by

		$this->approved_by->CellCssStyle = "white-space: nowrap;";

		// approved_on
		$this->approved_on->CellCssStyle = "white-space: nowrap;";

		// created_on
		$this->created_on->CellCssStyle = "white-space: nowrap;";

		// updated_on
		$this->updated_on->CellCssStyle = "white-space: nowrap;";

		// created_by
		$this->created_by->CellCssStyle = "white-space: nowrap;";

		// updated_by
		$this->updated_by->CellCssStyle = "white-space: nowrap;";

		// regular
		// overtime
		// total
		// approved

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// weeknumber
		if (strval($this->weeknumber->CurrentValue) <> "") {
			$sFilterWrk = "WEEKOFYEAR(adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY))" . ew_SearchString("=", $this->weeknumber->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT WEEKOFYEAR(adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY)), adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY) AS `DispFld`, adddate(timecards.date, INTERVAL 7-DAYOFWEEK(timecards.date) DAY) AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `timecards`";
		$sWhereWrk = "";
		$this->weeknumber->LookupFilters = array("df1" => "0", "df2" => "0");
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->weeknumber, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = ew_FormatDateTime($rswrk->fields('DispFld'), 0);
				$arwrk[2] = ew_FormatDateTime($rswrk->fields('Disp2Fld'), 0);
				$this->weeknumber->ViewValue = $this->weeknumber->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->weeknumber->ViewValue = $this->weeknumber->CurrentValue;
			}
		} else {
			$this->weeknumber->ViewValue = NULL;
		}
		$this->weeknumber->ViewCustomAttributes = "";

		// dbkey_councilor
		if (strval($this->dbkey_councilor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->dbkey_councilor->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_councilor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->CurrentValue;
			}
		} else {
			$this->dbkey_councilor->ViewValue = NULL;
		}
		$this->dbkey_councilor->ViewCustomAttributes = "";

		// date
		$this->date->ViewValue = $this->date->CurrentValue;
		$this->date->ViewValue = ew_FormatDateTime($this->date->ViewValue, 0);
		$this->date->ViewCustomAttributes = "";

		// in
		if (strval($this->in->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->in->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `tables_data`";
		$sWhereWrk = "";
		$this->in->LookupFilters = array();
		$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->in, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `dbkey`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->in->ViewValue = $this->in->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->in->ViewValue = $this->in->CurrentValue;
			}
		} else {
			$this->in->ViewValue = NULL;
		}
		$this->in->ViewCustomAttributes = "";

		// out
		if (strval($this->out->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->out->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `tables_data`";
		$sWhereWrk = "";
		$this->out->LookupFilters = array();
		$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->out, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->out->ViewValue = $this->out->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->out->ViewValue = $this->out->CurrentValue;
			}
		} else {
			$this->out->ViewValue = NULL;
		}
		$this->out->ViewCustomAttributes = "";

		// regular
		$this->regular->ViewValue = $this->regular->CurrentValue;
		$this->regular->ViewValue = ew_FormatNumber($this->regular->ViewValue, 2, -2, -2, -2);
		$this->regular->ViewCustomAttributes = "";

		// overtime
		$this->overtime->ViewValue = $this->overtime->CurrentValue;
		$this->overtime->ViewValue = ew_FormatNumber($this->overtime->ViewValue, 2, -2, -2, -2);
		$this->overtime->ViewCustomAttributes = "";

		// total
		$this->total->ViewValue = $this->total->CurrentValue;
		$this->total->ViewValue = ew_FormatNumber($this->total->ViewValue, 2, -1, -2, -2);
		$this->total->ViewCustomAttributes = "";

		// approved
		if (strval($this->approved->CurrentValue) <> "") {
			$this->approved->ViewValue = "";
			$arwrk = explode(",", strval($this->approved->CurrentValue));
			$cnt = count($arwrk);
			for ($ari = 0; $ari < $cnt; $ari++) {
				$this->approved->ViewValue .= $this->approved->OptionCaption(trim($arwrk[$ari]));
				if ($ari < $cnt-1) $this->approved->ViewValue .= ew_ViewOptionSeparator($ari);
			}
		} else {
			$this->approved->ViewValue = NULL;
		}
		$this->approved->ViewCustomAttributes = "";

			// weeknumber
			$this->weeknumber->LinkCustomAttributes = "";
			$this->weeknumber->HrefValue = "";
			$this->weeknumber->TooltipValue = "";

			// dbkey_councilor
			$this->dbkey_councilor->LinkCustomAttributes = "";
			$this->dbkey_councilor->HrefValue = "";
			$this->dbkey_councilor->TooltipValue = "";

			// date
			$this->date->LinkCustomAttributes = "";
			$this->date->HrefValue = "";
			$this->date->TooltipValue = "";

			// in
			$this->in->LinkCustomAttributes = "";
			$this->in->HrefValue = "";
			$this->in->TooltipValue = "";

			// out
			$this->out->LinkCustomAttributes = "";
			$this->out->HrefValue = "";
			$this->out->TooltipValue = "";

			// regular
			$this->regular->LinkCustomAttributes = "";
			$this->regular->HrefValue = "";
			$this->regular->TooltipValue = "";

			// overtime
			$this->overtime->LinkCustomAttributes = "";
			$this->overtime->HrefValue = "";
			$this->overtime->TooltipValue = "";

			// total
			$this->total->LinkCustomAttributes = "";
			$this->total->HrefValue = "";
			$this->total->TooltipValue = "";

			// approved
			$this->approved->LinkCustomAttributes = "";
			$this->approved->HrefValue = "";
			$this->approved->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_SEARCH) { // Search row

			// weeknumber
			$this->weeknumber->EditAttrs["class"] = "form-control";
			$this->weeknumber->EditCustomAttributes = "";
			if (trim(strval($this->weeknumber->AdvancedSearch->SearchValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "WEEKOFYEAR(adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY))" . ew_SearchString("=", $this->weeknumber->AdvancedSearch->SearchValue, EW_DATATYPE_NUMBER, "");
			}
			$sSqlWrk = "SELECT DISTINCT WEEKOFYEAR(adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY)), adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY) AS `DispFld`, adddate(timecards.date, INTERVAL 7-DAYOFWEEK(timecards.date) DAY) AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `timecards`";
			$sWhereWrk = "";
			$this->weeknumber->LookupFilters = array("df1" => "0", "df2" => "0");
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->weeknumber, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$rowswrk = count($arwrk);
			for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
				$arwrk[$rowcntwrk][1] = ew_FormatDateTime($arwrk[$rowcntwrk][1], 0);
				$arwrk[$rowcntwrk][2] = ew_FormatDateTime($arwrk[$rowcntwrk][2], 0);
			}
			$this->weeknumber->EditValue = $arwrk;

			// dbkey_councilor
			$this->dbkey_councilor->EditAttrs["class"] = "form-control";
			$this->dbkey_councilor->EditCustomAttributes = "";

			// date
			$this->date->EditAttrs["class"] = "form-control";
			$this->date->EditCustomAttributes = "";
			$this->date->EditValue = ew_HtmlEncode(ew_FormatDateTime(ew_UnFormatDateTime($this->date->AdvancedSearch->SearchValue, 0), 8));
			$this->date->PlaceHolder = ew_RemoveHtml($this->date->FldCaption());
			$this->date->EditAttrs["class"] = "form-control";
			$this->date->EditCustomAttributes = "";
			$this->date->EditValue2 = ew_HtmlEncode(ew_FormatDateTime(ew_UnFormatDateTime($this->date->AdvancedSearch->SearchValue2, 0), 8));
			$this->date->PlaceHolder = ew_RemoveHtml($this->date->FldCaption());

			// in
			$this->in->EditAttrs["class"] = "form-control";
			$this->in->EditCustomAttributes = "";

			// out
			$this->out->EditAttrs["class"] = "form-control";
			$this->out->EditCustomAttributes = "";

			// regular
			$this->regular->EditAttrs["class"] = "form-control";
			$this->regular->EditCustomAttributes = "";
			$this->regular->EditValue = ew_HtmlEncode($this->regular->AdvancedSearch->SearchValue);
			$this->regular->PlaceHolder = ew_RemoveHtml($this->regular->FldCaption());

			// overtime
			$this->overtime->EditAttrs["class"] = "form-control";
			$this->overtime->EditCustomAttributes = "";
			$this->overtime->EditValue = ew_HtmlEncode($this->overtime->AdvancedSearch->SearchValue);
			$this->overtime->PlaceHolder = ew_RemoveHtml($this->overtime->FldCaption());

			// total
			$this->total->EditAttrs["class"] = "form-control";
			$this->total->EditCustomAttributes = "";
			$this->total->EditValue = ew_HtmlEncode($this->total->AdvancedSearch->SearchValue);
			$this->total->PlaceHolder = ew_RemoveHtml($this->total->FldCaption());

			// approved
			$this->approved->EditCustomAttributes = "";
			$this->approved->EditValue = $this->approved->Options(FALSE);
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate search
	function ValidateSearch() {
		global $gsSearchError;

		// Initialize
		$gsSearchError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return TRUE;
		if (!ew_CheckDateDef($this->date->AdvancedSearch->SearchValue)) {
			ew_AddMessage($gsSearchError, $this->date->FldErrMsg());
		}
		if (!ew_CheckDateDef($this->date->AdvancedSearch->SearchValue2)) {
			ew_AddMessage($gsSearchError, $this->date->FldErrMsg());
		}

		// Return validate result
		$ValidateSearch = ($gsSearchError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateSearch = $ValidateSearch && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsSearchError, $sFormCustomError);
		}
		return $ValidateSearch;
	}

	// Load advanced search
	function LoadAdvancedSearch() {
		$this->weeknumber->AdvancedSearch->Load();
		$this->dbkey_councilor->AdvancedSearch->Load();
		$this->date->AdvancedSearch->Load();
		$this->in->AdvancedSearch->Load();
		$this->out->AdvancedSearch->Load();
		$this->approved_by->AdvancedSearch->Load();
		$this->approved_on->AdvancedSearch->Load();
		$this->created_on->AdvancedSearch->Load();
		$this->updated_on->AdvancedSearch->Load();
		$this->created_by->AdvancedSearch->Load();
		$this->updated_by->AdvancedSearch->Load();
		$this->regular->AdvancedSearch->Load();
		$this->overtime->AdvancedSearch->Load();
		$this->total->AdvancedSearch->Load();
		$this->approved->AdvancedSearch->Load();
	}

	// Set up export options
	function SetupExportOptions() {
		global $Language;

		// Printer friendly
		$item = &$this->ExportOptions->Add("print");
		$item->Body = "<a href=\"" . $this->ExportPrintUrl . "\" class=\"ewExportLink ewPrint\" title=\"" . ew_HtmlEncode($Language->Phrase("PrinterFriendlyText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("PrinterFriendlyText")) . "\">" . $Language->Phrase("PrinterFriendly") . "</a>";
		$item->Visible = TRUE;

		// Export to Excel
		$item = &$this->ExportOptions->Add("excel");
		$item->Body = "<a href=\"" . $this->ExportExcelUrl . "\" class=\"ewExportLink ewExcel\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToExcelText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToExcelText")) . "\">" . $Language->Phrase("ExportToExcel") . "</a>";
		$item->Visible = TRUE;

		// Export to Word
		$item = &$this->ExportOptions->Add("word");
		$item->Body = "<a href=\"" . $this->ExportWordUrl . "\" class=\"ewExportLink ewWord\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToWordText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToWordText")) . "\">" . $Language->Phrase("ExportToWord") . "</a>";
		$item->Visible = TRUE;

		// Export to Html
		$item = &$this->ExportOptions->Add("html");
		$item->Body = "<a href=\"" . $this->ExportHtmlUrl . "\" class=\"ewExportLink ewHtml\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToHtmlText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToHtmlText")) . "\">" . $Language->Phrase("ExportToHtml") . "</a>";
		$item->Visible = TRUE;

		// Export to Xml
		$item = &$this->ExportOptions->Add("xml");
		$item->Body = "<a href=\"" . $this->ExportXmlUrl . "\" class=\"ewExportLink ewXml\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToXmlText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToXmlText")) . "\">" . $Language->Phrase("ExportToXml") . "</a>";
		$item->Visible = FALSE;

		// Export to Csv
		$item = &$this->ExportOptions->Add("csv");
		$item->Body = "<a href=\"" . $this->ExportCsvUrl . "\" class=\"ewExportLink ewCsv\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToCsvText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToCsvText")) . "\">" . $Language->Phrase("ExportToCsv") . "</a>";
		$item->Visible = TRUE;

		// Export to Pdf
		$item = &$this->ExportOptions->Add("pdf");
		$item->Body = "<a href=\"" . $this->ExportPdfUrl . "\" class=\"ewExportLink ewPdf\" title=\"" . ew_HtmlEncode($Language->Phrase("ExportToPDFText")) . "\" data-caption=\"" . ew_HtmlEncode($Language->Phrase("ExportToPDFText")) . "\">" . $Language->Phrase("ExportToPDF") . "</a>";
		$item->Visible = FALSE;

		// Export to Email
		$item = &$this->ExportOptions->Add("email");
		$url = "";
		$item->Body = "<button id=\"emf_timecards\" class=\"ewExportLink ewEmail\" title=\"" . $Language->Phrase("ExportToEmailText") . "\" data-caption=\"" . $Language->Phrase("ExportToEmailText") . "\" onclick=\"ew_EmailDialogShow({lnk:'emf_timecards',hdr:ewLanguage.Phrase('ExportToEmailText'),f:document.ftimecardslist,sel:false" . $url . "});\">" . $Language->Phrase("ExportToEmail") . "</button>";
		$item->Visible = TRUE;

		// Drop down button for export
		$this->ExportOptions->UseButtonGroup = TRUE;
		$this->ExportOptions->UseImageAndText = TRUE;
		$this->ExportOptions->UseDropDownButton = FALSE;
		if ($this->ExportOptions->UseButtonGroup && ew_IsMobile())
			$this->ExportOptions->UseDropDownButton = TRUE;
		$this->ExportOptions->DropDownButtonPhrase = $Language->Phrase("ButtonExport");

		// Add group option item
		$item = &$this->ExportOptions->Add($this->ExportOptions->GroupOptionName);
		$item->Body = "";
		$item->Visible = FALSE;
	}

	// Export data in HTML/CSV/Word/Excel/XML/Email/PDF format
	function ExportData() {
		$utf8 = (strtolower(EW_CHARSET) == "utf-8");
		$bSelectLimit = $this->UseSelectLimit;

		// Load recordset
		if ($bSelectLimit) {
			$this->TotalRecs = $this->SelectRecordCount();
		} else {
			if (!$this->Recordset)
				$this->Recordset = $this->LoadRecordset();
			$rs = &$this->Recordset;
			if ($rs)
				$this->TotalRecs = $rs->RecordCount();
		}
		$this->StartRec = 1;

		// Export all
		if ($this->ExportAll) {
			set_time_limit(EW_EXPORT_ALL_TIME_LIMIT);
			$this->DisplayRecs = $this->TotalRecs;
			$this->StopRec = $this->TotalRecs;
		} else { // Export one page only
			$this->SetUpStartRec(); // Set up start record position

			// Set the last record to display
			if ($this->DisplayRecs <= 0) {
				$this->StopRec = $this->TotalRecs;
			} else {
				$this->StopRec = $this->StartRec + $this->DisplayRecs - 1;
			}
		}
		if ($bSelectLimit)
			$rs = $this->LoadRecordset($this->StartRec-1, $this->DisplayRecs <= 0 ? $this->TotalRecs : $this->DisplayRecs);
		if (!$rs) {
			header("Content-Type:"); // Remove header
			header("Content-Disposition:");
			$this->ShowMessage();
			return;
		}
		$this->ExportDoc = ew_ExportDocument($this, "h");
		$Doc = &$this->ExportDoc;
		if ($bSelectLimit) {
			$this->StartRec = 1;
			$this->StopRec = $this->DisplayRecs <= 0 ? $this->TotalRecs : $this->DisplayRecs;
		} else {

			//$this->StartRec = $this->StartRec;
			//$this->StopRec = $this->StopRec;

		}

		// Call Page Exporting server event
		$this->ExportDoc->ExportCustom = !$this->Page_Exporting();
		$ParentTable = "";
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		$Doc->Text .= $sHeader;
		$this->ExportDocument($Doc, $rs, $this->StartRec, $this->StopRec, "");
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		$Doc->Text .= $sFooter;

		// Close recordset
		$rs->Close();

		// Call Page Exported server event
		$this->Page_Exported();

		// Export header and footer
		$Doc->ExportHeaderAndFooter();

		// Clean output buffer
		if (!EW_DEBUG_ENABLED && ob_get_length())
			ob_end_clean();

		// Write debug message if enabled
		if (EW_DEBUG_ENABLED && $this->Export <> "pdf")
			echo ew_DebugMsg();

		// Output data
		if ($this->Export == "email") {
			echo $this->ExportEmail($Doc->Text);
		} else {
			$Doc->Export();
		}
	}

	// Export email
	function ExportEmail($EmailContent) {
		global $gTmpImages, $Language;
		$sSender = @$_POST["sender"];
		$sRecipient = @$_POST["recipient"];
		$sCc = @$_POST["cc"];
		$sBcc = @$_POST["bcc"];
		$sContentType = @$_POST["contenttype"];

		// Subject
		$sSubject = ew_StripSlashes(@$_POST["subject"]);
		$sEmailSubject = $sSubject;

		// Message
		$sContent = ew_StripSlashes(@$_POST["message"]);
		$sEmailMessage = $sContent;

		// Check sender
		if ($sSender == "") {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterSenderEmail") . "</p>";
		}
		if (!ew_CheckEmail($sSender)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperSenderEmail") . "</p>";
		}

		// Check recipient
		if (!ew_CheckEmailList($sRecipient, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperRecipientEmail") . "</p>";
		}

		// Check cc
		if (!ew_CheckEmailList($sCc, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperCcEmail") . "</p>";
		}

		// Check bcc
		if (!ew_CheckEmailList($sBcc, EW_MAX_EMAIL_RECIPIENT)) {
			return "<p class=\"text-danger\">" . $Language->Phrase("EnterProperBccEmail") . "</p>";
		}

		// Check email sent count
		if (!isset($_SESSION[EW_EXPORT_EMAIL_COUNTER]))
			$_SESSION[EW_EXPORT_EMAIL_COUNTER] = 0;
		if (intval($_SESSION[EW_EXPORT_EMAIL_COUNTER]) > EW_MAX_EMAIL_SENT_COUNT) {
			return "<p class=\"text-danger\">" . $Language->Phrase("ExceedMaxEmailExport") . "</p>";
		}

		// Send email
		$Email = new cEmail();
		$Email->Sender = $sSender; // Sender
		$Email->Recipient = $sRecipient; // Recipient
		$Email->Cc = $sCc; // Cc
		$Email->Bcc = $sBcc; // Bcc
		$Email->Subject = $sEmailSubject; // Subject
		$Email->Format = ($sContentType == "url") ? "text" : "html";
		if ($sEmailMessage <> "") {
			$sEmailMessage = ew_RemoveXSS($sEmailMessage);
			$sEmailMessage .= ($sContentType == "url") ? "\r\n\r\n" : "<br><br>";
		}
		if ($sContentType == "url") {
			$sUrl = ew_ConvertFullUrl(ew_CurrentPage() . "?" . $this->ExportQueryString());
			$sEmailMessage .= $sUrl; // Send URL only
		} else {
			foreach ($gTmpImages as $tmpimage)
				$Email->AddEmbeddedImage($tmpimage);
			$sEmailMessage .= ew_CleanEmailContent($EmailContent); // Send HTML
		}
		$Email->Content = $sEmailMessage; // Content
		$EventArgs = array();
		if ($this->Recordset) {
			$this->RecCnt = $this->StartRec - 1;
			$this->Recordset->MoveFirst();
			if ($this->StartRec > 1)
				$this->Recordset->Move($this->StartRec - 1);
			$EventArgs["rs"] = &$this->Recordset;
		}
		$bEmailSent = FALSE;
		if ($this->Email_Sending($Email, $EventArgs))
			$bEmailSent = $Email->Send();

		// Check email sent status
		if ($bEmailSent) {

			// Update email sent count
			$_SESSION[EW_EXPORT_EMAIL_COUNTER]++;

			// Sent email success
			return "<p class=\"text-success\">" . $Language->Phrase("SendEmailSuccess") . "</p>"; // Set up success message
		} else {

			// Sent email failure
			return "<p class=\"text-danger\">" . $Email->SendErrDescription . "</p>";
		}
	}

	// Export QueryString
	function ExportQueryString() {

		// Initialize
		$sQry = "export=html";

		// Build QueryString for search
		$this->AddSearchQueryString($sQry, $this->weeknumber); // weeknumber
		$this->AddSearchQueryString($sQry, $this->dbkey_councilor); // dbkey_councilor
		$this->AddSearchQueryString($sQry, $this->date); // date
		$this->AddSearchQueryString($sQry, $this->in); // in
		$this->AddSearchQueryString($sQry, $this->out); // out
		$this->AddSearchQueryString($sQry, $this->approved_by); // approved_by
		$this->AddSearchQueryString($sQry, $this->approved_on); // approved_on
		$this->AddSearchQueryString($sQry, $this->created_on); // created_on
		$this->AddSearchQueryString($sQry, $this->updated_on); // updated_on
		$this->AddSearchQueryString($sQry, $this->created_by); // created_by
		$this->AddSearchQueryString($sQry, $this->updated_by); // updated_by
		$this->AddSearchQueryString($sQry, $this->regular); // regular
		$this->AddSearchQueryString($sQry, $this->overtime); // overtime
		$this->AddSearchQueryString($sQry, $this->total); // total
		$this->AddSearchQueryString($sQry, $this->approved); // approved

		// Build QueryString for pager
		$sQry .= "&" . EW_TABLE_REC_PER_PAGE . "=" . urlencode($this->getRecordsPerPage()) . "&" . EW_TABLE_START_REC . "=" . urlencode($this->getStartRecordNumber());
		return $sQry;
	}

	// Add search QueryString
	function AddSearchQueryString(&$Qry, &$Fld) {
		$FldSearchValue = $Fld->AdvancedSearch->getValue("x");
		$FldParm = substr($Fld->FldVar,2);
		if (strval($FldSearchValue) <> "") {
			$Qry .= "&x_" . $FldParm . "=" . urlencode($FldSearchValue) .
				"&z_" . $FldParm . "=" . urlencode($Fld->AdvancedSearch->getValue("z"));
		}
		$FldSearchValue2 = $Fld->AdvancedSearch->getValue("y");
		if (strval($FldSearchValue2) <> "") {
			$Qry .= "&v_" . $FldParm . "=" . urlencode($Fld->AdvancedSearch->getValue("v")) .
				"&y_" . $FldParm . "=" . urlencode($FldSearchValue2) .
				"&w_" . $FldParm . "=" . urlencode($Fld->AdvancedSearch->getValue("w"));
		}
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$url = preg_replace('/\?cmd=reset(all){0,1}$/i', '', $url); // Remove cmd=reset / cmd=resetall
		$Breadcrumb->Add("list", $this->TableVar, $url, "", $this->TableVar, TRUE);
	}

	// Setup lookup filters of a field
	function SetupLookupFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		if ($pageId == "list") {
			switch ($fld->FldVar) {
			}
		} elseif ($pageId == "extbs") {
			switch ($fld->FldVar) {
		case "x_weeknumber":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT DISTINCT WEEKOFYEAR(adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY)) AS `LinkFld`, adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY) AS `DispFld`, adddate(timecards.date, INTERVAL 7-DAYOFWEEK(timecards.date) DAY) AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `timecards`";
			$sWhereWrk = "";
			$this->weeknumber->LookupFilters = array("df1" => "0", "df2" => "0");
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => 'WEEKOFYEAR(adddate(timecards.date, INTERVAL 1-DAYOFWEEK(timecards.date) DAY)) = {filter_value}', "t0" => "20", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->weeknumber, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
			}
		} 
	}

	// Setup AutoSuggest filters of a field
	function SetupAutoSuggestFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		if ($pageId == "list") {
			switch ($fld->FldVar) {
			}
		} elseif ($pageId == "extbs") {
			switch ($fld->FldVar) {
			}
		} 
	}

	// Write Audit Trail start/end for grid update
	function WriteAuditTrailDummy($typ) {
		$table = 'timecards';
		$usr = CurrentUserID();
		ew_WriteAuditTrail("log", ew_StdCurrentDateTime(), ew_ScriptName(), $usr, $typ, $table, "", "", "", "");
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}

	// ListOptions Load event
	function ListOptions_Load() {

		// Example:
		//$opt = &$this->ListOptions->Add("new");
		//$opt->Header = "xxx";
		//$opt->OnLeft = TRUE; // Link on left
		//$opt->MoveTo(0); // Move to first column

	}

	// ListOptions Rendered event
	function ListOptions_Rendered() {

		// Example: 
		//$this->ListOptions->Items["new"]->Body = "xxx";

		if ($this->approved->CurrentValue == 1) {
			$this->ListOptions->Items["edit"]->Body = "";
			$this->ListOptions->Items["delete"]->Body = "";
		}
	}

	// Row Custom Action event
	function Row_CustomAction($action, $row) {

		// Return FALSE to abort
		return TRUE;
	}

	// Page Exporting event
	// $this->ExportDoc = export document object
	function Page_Exporting() {

		//$this->ExportDoc->Text = "my header"; // Export header
		//return FALSE; // Return FALSE to skip default export and use Row_Export event

		return TRUE; // Return TRUE to use default export and skip Row_Export event
	}

	// Row Export event
	// $this->ExportDoc = export document object
	function Row_Export($rs) {

		//$this->ExportDoc->Text .= "my content"; // Build HTML with field value: $rs["MyField"] or $this->MyField->ViewValue
	}

	// Page Exported event
	// $this->ExportDoc = export document object
	function Page_Exported() {

		//$this->ExportDoc->Text .= "my footer"; // Export footer
		//echo $this->ExportDoc->Text;

	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($timecards_list)) $timecards_list = new ctimecards_list();

// Page init
$timecards_list->Page_Init();

// Page main
$timecards_list->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$timecards_list->Page_Render();
?>
<?php include_once "header.php" ?>
<?php if ($timecards->Export == "") { ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "list";
var CurrentForm = ftimecardslist = new ew_Form("ftimecardslist", "list");
ftimecardslist.FormKeyCountName = '<?php echo $timecards_list->FormKeyCountName ?>';

// Form_CustomValidate event
ftimecardslist.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
ftimecardslist.ValidateRequired = true;
<?php } else { ?>
ftimecardslist.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
ftimecardslist.Lists["x_weeknumber"] = {"LinkField":"x_weeknumber","Ajax":true,"AutoFill":false,"DisplayFields":["x_start","x_end","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"timecards"};
ftimecardslist.Lists["x_dbkey_councilor"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"counselor"};
ftimecardslist.Lists["x_in"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"tables_data"};
ftimecardslist.Lists["x_out"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"tables_data"};
ftimecardslist.Lists["x_approved[]"] = {"LinkField":"","Ajax":null,"AutoFill":false,"DisplayFields":["","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftimecardslist.Lists["x_approved[]"].Options = <?php echo json_encode($timecards->approved->Options()) ?>;

// Form object for search
var CurrentSearchForm = ftimecardslistsrch = new ew_Form("ftimecardslistsrch");

// Validate function for search
ftimecardslistsrch.Validate = function(fobj) {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	fobj = fobj || this.Form;
	var infix = "";
	elm = this.GetElements("x" + infix + "_date");
	if (elm && !ew_CheckDateDef(elm.value))
		return this.OnError(elm, "<?php echo ew_JsEncode2($timecards->date->FldErrMsg()) ?>");

	// Fire Form_CustomValidate event
	if (!this.Form_CustomValidate(fobj))
		return false;
	return true;
}

// Form_CustomValidate event
ftimecardslistsrch.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
ftimecardslistsrch.ValidateRequired = true; // Use JavaScript validation
<?php } else { ?>
ftimecardslistsrch.ValidateRequired = false; // No JavaScript validation
<?php } ?>

// Dynamic selection lists
ftimecardslistsrch.Lists["x_weeknumber"] = {"LinkField":"x_weeknumber","Ajax":true,"AutoFill":false,"DisplayFields":["x_start","x_end","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"timecards"};
ftimecardslistsrch.Lists["x_approved[]"] = {"LinkField":"","Ajax":null,"AutoFill":false,"DisplayFields":["","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":""};
ftimecardslistsrch.Lists["x_approved[]"].Options = <?php echo json_encode($timecards->approved->Options()) ?>;
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php } ?>
<?php if ($timecards->Export == "") { ?>
<div class="ewToolbar">
<?php if ($timecards->Export == "") { ?>
<?php $Breadcrumb->Render(); ?>
<?php } ?>
<?php if ($timecards_list->TotalRecs > 0 && $timecards_list->ExportOptions->Visible()) { ?>
<?php $timecards_list->ExportOptions->Render("body") ?>
<?php } ?>
<?php if ($timecards_list->SearchOptions->Visible()) { ?>
<?php $timecards_list->SearchOptions->Render("body") ?>
<?php } ?>
<?php if ($timecards_list->FilterOptions->Visible()) { ?>
<?php $timecards_list->FilterOptions->Render("body") ?>
<?php } ?>
<?php if ($timecards->Export == "") { ?>
<?php echo $Language->SelectionForm(); ?>
<?php } ?>
<div class="clearfix"></div>
</div>
<?php } ?>
<?php
	$bSelectLimit = $timecards_list->UseSelectLimit;
	if ($bSelectLimit) {
		if ($timecards_list->TotalRecs <= 0)
			$timecards_list->TotalRecs = $timecards->SelectRecordCount();
	} else {
		if (!$timecards_list->Recordset && ($timecards_list->Recordset = $timecards_list->LoadRecordset()))
			$timecards_list->TotalRecs = $timecards_list->Recordset->RecordCount();
	}
	$timecards_list->StartRec = 1;
	if ($timecards_list->DisplayRecs <= 0 || ($timecards->Export <> "" && $timecards->ExportAll)) // Display all records
		$timecards_list->DisplayRecs = $timecards_list->TotalRecs;
	if (!($timecards->Export <> "" && $timecards->ExportAll))
		$timecards_list->SetUpStartRec(); // Set up start record position
	if ($bSelectLimit)
		$timecards_list->Recordset = $timecards_list->LoadRecordset($timecards_list->StartRec-1, $timecards_list->DisplayRecs);

	// Set no record found message
	if ($timecards->CurrentAction == "" && $timecards_list->TotalRecs == 0) {
		if (!$Security->CanList())
			$timecards_list->setWarningMessage(ew_DeniedMsg());
		if ($timecards_list->SearchWhere == "0=101")
			$timecards_list->setWarningMessage($Language->Phrase("EnterSearchCriteria"));
		else
			$timecards_list->setWarningMessage($Language->Phrase("NoRecord"));
	}

	// Audit trail on search
	if ($timecards_list->AuditTrailOnSearch && $timecards_list->Command == "search" && !$timecards_list->RestoreSearch) {
		$searchparm = ew_ServerVar("QUERY_STRING");
		$searchsql = $timecards_list->getSessionWhere();
		$timecards_list->WriteAuditTrailOnSearch($searchparm, $searchsql);
	}
$timecards_list->RenderOtherOptions();
?>
<?php if ($Security->CanSearch()) { ?>
<?php if ($timecards->Export == "" && $timecards->CurrentAction == "") { ?>
<form name="ftimecardslistsrch" id="ftimecardslistsrch" class="form-inline ewForm" action="<?php echo ew_CurrentPage() ?>">
<?php $SearchPanelClass = ($timecards_list->SearchWhere <> "") ? " in" : " in"; ?>
<div id="ftimecardslistsrch_SearchPanel" class="ewSearchPanel collapse<?php echo $SearchPanelClass ?>">
<input type="hidden" name="cmd" value="search">
<input type="hidden" name="t" value="timecards">
	<div class="ewBasicSearch">
<?php
if ($gsSearchError == "")
	$timecards_list->LoadAdvancedSearch(); // Load advanced search

// Render for search
$timecards->RowType = EW_ROWTYPE_SEARCH;

// Render row
$timecards->ResetAttrs();
$timecards_list->RenderRow();
?>
<div id="xsr_1" class="ewRow">
<?php if ($timecards->weeknumber->Visible) { // weeknumber ?>
	<div id="xsc_weeknumber" class="ewCell form-group">
		<label for="x_weeknumber" class="ewSearchCaption ewLabel"><?php echo $timecards->weeknumber->FldCaption() ?></label>
		<span class="ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_weeknumber" id="z_weeknumber" value="="></span>
		<span class="ewSearchField">
<select data-table="timecards" data-field="x_weeknumber" data-value-separator="<?php echo $timecards->weeknumber->DisplayValueSeparatorAttribute() ?>" id="x_weeknumber" name="x_weeknumber"<?php echo $timecards->weeknumber->EditAttributes() ?>>
<?php echo $timecards->weeknumber->SelectOptionListHtml("x_weeknumber") ?>
</select>
<input type="hidden" name="s_x_weeknumber" id="s_x_weeknumber" value="<?php echo $timecards->weeknumber->LookupFilterQuery(false, "extbs") ?>">
</span>
	</div>
<?php } ?>
</div>
<div id="xsr_2" class="ewRow">
<?php if ($timecards->date->Visible) { // date ?>
	<div id="xsc_date" class="ewCell form-group">
		<label for="x_date" class="ewSearchCaption ewLabel"><?php echo $timecards->date->FldCaption() ?></label>
		<span class="ewSearchOperator"><?php echo $Language->Phrase("BETWEEN") ?><input type="hidden" name="z_date" id="z_date" value="BETWEEN"></span>
		<span class="ewSearchField">
<input type="text" data-table="timecards" data-field="x_date" name="x_date" id="x_date" placeholder="<?php echo ew_HtmlEncode($timecards->date->getPlaceHolder()) ?>" value="<?php echo $timecards->date->EditValue ?>"<?php echo $timecards->date->EditAttributes() ?>>
<?php if (!$timecards->date->ReadOnly && !$timecards->date->Disabled && !isset($timecards->date->EditAttrs["readonly"]) && !isset($timecards->date->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("ftimecardslistsrch", "x_date", 0);
</script>
<?php } ?>
</span>
		<span class="ewSearchCond btw1_date">&nbsp;<?php echo $Language->Phrase("AND") ?>&nbsp;</span>
		<span class="ewSearchField btw1_date">
<input type="text" data-table="timecards" data-field="x_date" name="y_date" id="y_date" placeholder="<?php echo ew_HtmlEncode($timecards->date->getPlaceHolder()) ?>" value="<?php echo $timecards->date->EditValue2 ?>"<?php echo $timecards->date->EditAttributes() ?>>
<?php if (!$timecards->date->ReadOnly && !$timecards->date->Disabled && !isset($timecards->date->EditAttrs["readonly"]) && !isset($timecards->date->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("ftimecardslistsrch", "y_date", 0);
</script>
<?php } ?>
</span>
	</div>
<?php } ?>
</div>
<div id="xsr_3" class="ewRow">
<?php if ($timecards->approved->Visible) { // approved ?>
	<div id="xsc_approved" class="ewCell form-group">
		<label class="ewSearchCaption ewLabel"><?php echo $timecards->approved->FldCaption() ?></label>
		<span class="ewSearchOperator"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_approved" id="z_approved" value="="></span>
		<span class="ewSearchField">
<div id="tp_x_approved" class="ewTemplate"><input type="checkbox" data-table="timecards" data-field="x_approved" data-value-separator="<?php echo $timecards->approved->DisplayValueSeparatorAttribute() ?>" name="x_approved[]" id="x_approved[]" value="{value}"<?php echo $timecards->approved->EditAttributes() ?>></div>
<div id="dsl_x_approved" data-repeatcolumn="5" class="ewItemList" style="display: none;"><div>
<?php echo $timecards->approved->CheckBoxListHtml(FALSE, "x_approved[]") ?>
</div></div>
</span>
	</div>
<?php } ?>
</div>
<div id="xsr_4" class="ewRow">
	<button class="btn btn-primary ewButton" name="btnsubmit" id="btnsubmit" type="submit"><?php echo $Language->Phrase("QuickSearchBtn") ?></button>
</div>
	</div>
</div>
</form>
<?php } ?>
<?php } ?>
<?php $timecards_list->ShowPageHeader(); ?>
<?php
$timecards_list->ShowMessage();
?>
<?php if ($timecards_list->TotalRecs > 0 || $timecards->CurrentAction <> "") { ?>
<div class="panel panel-default ewGrid timecards">
<?php if ($timecards->Export == "") { ?>
<div class="panel-heading ewGridUpperPanel">
<?php if ($timecards->CurrentAction <> "gridadd" && $timecards->CurrentAction <> "gridedit") { ?>
<form name="ewPagerForm" class="form-inline ewForm ewPagerForm" action="<?php echo ew_CurrentPage() ?>">
<?php if (!isset($timecards_list->Pager)) $timecards_list->Pager = new cPrevNextPager($timecards_list->StartRec, $timecards_list->DisplayRecs, $timecards_list->TotalRecs) ?>
<?php if ($timecards_list->Pager->RecordCount > 0 && $timecards_list->Pager->Visible) { ?>
<div class="ewPager">
<span><?php echo $Language->Phrase("Page") ?>&nbsp;</span>
<div class="ewPrevNext"><div class="input-group">
<div class="input-group-btn">
<!--first page button-->
	<?php if ($timecards_list->Pager->FirstButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerFirst") ?>" href="<?php echo $timecards_list->PageUrl() ?>start=<?php echo $timecards_list->Pager->FirstButton->Start ?>"><span class="icon-first ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerFirst") ?>"><span class="icon-first ewIcon"></span></a>
	<?php } ?>
<!--previous page button-->
	<?php if ($timecards_list->Pager->PrevButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerPrevious") ?>" href="<?php echo $timecards_list->PageUrl() ?>start=<?php echo $timecards_list->Pager->PrevButton->Start ?>"><span class="icon-prev ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerPrevious") ?>"><span class="icon-prev ewIcon"></span></a>
	<?php } ?>
</div>
<!--current page number-->
	<input class="form-control input-sm" type="text" name="<?php echo EW_TABLE_PAGE_NO ?>" value="<?php echo $timecards_list->Pager->CurrentPage ?>">
<div class="input-group-btn">
<!--next page button-->
	<?php if ($timecards_list->Pager->NextButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerNext") ?>" href="<?php echo $timecards_list->PageUrl() ?>start=<?php echo $timecards_list->Pager->NextButton->Start ?>"><span class="icon-next ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerNext") ?>"><span class="icon-next ewIcon"></span></a>
	<?php } ?>
<!--last page button-->
	<?php if ($timecards_list->Pager->LastButton->Enabled) { ?>
	<a class="btn btn-default btn-sm" title="<?php echo $Language->Phrase("PagerLast") ?>" href="<?php echo $timecards_list->PageUrl() ?>start=<?php echo $timecards_list->Pager->LastButton->Start ?>"><span class="icon-last ewIcon"></span></a>
	<?php } else { ?>
	<a class="btn btn-default btn-sm disabled" title="<?php echo $Language->Phrase("PagerLast") ?>"><span class="icon-last ewIcon"></span></a>
	<?php } ?>
</div>
</div>
</div>
<span>&nbsp;<?php echo $Language->Phrase("of") ?>&nbsp;<?php echo $timecards_list->Pager->PageCount ?></span>
</div>
<div class="ewPager ewRec">
	<span><?php echo $Language->Phrase("Record") ?>&nbsp;<?php echo $timecards_list->Pager->FromIndex ?>&nbsp;<?php echo $Language->Phrase("To") ?>&nbsp;<?php echo $timecards_list->Pager->ToIndex ?>&nbsp;<?php echo $Language->Phrase("Of") ?>&nbsp;<?php echo $timecards_list->Pager->RecordCount ?></span>
</div>
<?php } ?>
</form>
<?php } ?>
<div class="ewListOtherOptions">
<?php
	foreach ($timecards_list->OtherOptions as &$option)
		$option->Render("body");
?>
</div>
<div class="clearfix"></div>
</div>
<?php } ?>
<form name="ftimecardslist" id="ftimecardslist" class="form-inline ewForm ewListForm" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($timecards_list->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $timecards_list->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="timecards">
<div id="gmp_timecards" class="<?php if (ew_IsResponsiveLayout()) { echo "table-responsive "; } ?>ewGridMiddlePanel">
<?php if ($timecards_list->TotalRecs > 0 || $timecards->CurrentAction == "gridedit") { ?>
<table id="tbl_timecardslist" class="table ewTable">
<?php echo $timecards->TableCustomInnerHtml ?>
<thead><!-- Table header -->
	<tr class="ewTableHeader">
<?php

// Header row
$timecards_list->RowType = EW_ROWTYPE_HEADER;

// Render list options
$timecards_list->RenderListOptions();

// Render list options (header, left)
$timecards_list->ListOptions->Render("header", "left");
?>
<?php if ($timecards->weeknumber->Visible) { // weeknumber ?>
	<?php if ($timecards->SortUrl($timecards->weeknumber) == "") { ?>
		<th data-name="weeknumber"><div id="elh_timecards_weeknumber" class="timecards_weeknumber"><div class="ewTableHeaderCaption" style="white-space: nowrap;"><?php echo $timecards->weeknumber->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="weeknumber"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $timecards->SortUrl($timecards->weeknumber) ?>',1);"><div id="elh_timecards_weeknumber" class="timecards_weeknumber">
			<div class="ewTableHeaderBtn" style="white-space: nowrap;"><span class="ewTableHeaderCaption"><?php echo $timecards->weeknumber->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($timecards->weeknumber->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($timecards->weeknumber->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($timecards->dbkey_councilor->Visible) { // dbkey_councilor ?>
	<?php if ($timecards->SortUrl($timecards->dbkey_councilor) == "") { ?>
		<th data-name="dbkey_councilor"><div id="elh_timecards_dbkey_councilor" class="timecards_dbkey_councilor"><div class="ewTableHeaderCaption"><?php echo $timecards->dbkey_councilor->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="dbkey_councilor"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $timecards->SortUrl($timecards->dbkey_councilor) ?>',1);"><div id="elh_timecards_dbkey_councilor" class="timecards_dbkey_councilor">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $timecards->dbkey_councilor->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($timecards->dbkey_councilor->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($timecards->dbkey_councilor->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($timecards->date->Visible) { // date ?>
	<?php if ($timecards->SortUrl($timecards->date) == "") { ?>
		<th data-name="date"><div id="elh_timecards_date" class="timecards_date"><div class="ewTableHeaderCaption"><?php echo $timecards->date->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="date"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $timecards->SortUrl($timecards->date) ?>',1);"><div id="elh_timecards_date" class="timecards_date">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $timecards->date->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($timecards->date->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($timecards->date->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($timecards->in->Visible) { // in ?>
	<?php if ($timecards->SortUrl($timecards->in) == "") { ?>
		<th data-name="in"><div id="elh_timecards_in" class="timecards_in"><div class="ewTableHeaderCaption"><?php echo $timecards->in->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="in"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $timecards->SortUrl($timecards->in) ?>',1);"><div id="elh_timecards_in" class="timecards_in">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $timecards->in->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($timecards->in->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($timecards->in->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($timecards->out->Visible) { // out ?>
	<?php if ($timecards->SortUrl($timecards->out) == "") { ?>
		<th data-name="out"><div id="elh_timecards_out" class="timecards_out"><div class="ewTableHeaderCaption"><?php echo $timecards->out->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="out"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $timecards->SortUrl($timecards->out) ?>',1);"><div id="elh_timecards_out" class="timecards_out">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $timecards->out->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($timecards->out->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($timecards->out->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($timecards->regular->Visible) { // regular ?>
	<?php if ($timecards->SortUrl($timecards->regular) == "") { ?>
		<th data-name="regular"><div id="elh_timecards_regular" class="timecards_regular"><div class="ewTableHeaderCaption"><?php echo $timecards->regular->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="regular"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $timecards->SortUrl($timecards->regular) ?>',1);"><div id="elh_timecards_regular" class="timecards_regular">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $timecards->regular->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($timecards->regular->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($timecards->regular->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($timecards->overtime->Visible) { // overtime ?>
	<?php if ($timecards->SortUrl($timecards->overtime) == "") { ?>
		<th data-name="overtime"><div id="elh_timecards_overtime" class="timecards_overtime"><div class="ewTableHeaderCaption"><?php echo $timecards->overtime->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="overtime"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $timecards->SortUrl($timecards->overtime) ?>',1);"><div id="elh_timecards_overtime" class="timecards_overtime">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $timecards->overtime->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($timecards->overtime->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($timecards->overtime->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($timecards->total->Visible) { // total ?>
	<?php if ($timecards->SortUrl($timecards->total) == "") { ?>
		<th data-name="total"><div id="elh_timecards_total" class="timecards_total"><div class="ewTableHeaderCaption"><?php echo $timecards->total->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="total"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $timecards->SortUrl($timecards->total) ?>',1);"><div id="elh_timecards_total" class="timecards_total">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $timecards->total->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($timecards->total->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($timecards->total->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php if ($timecards->approved->Visible) { // approved ?>
	<?php if ($timecards->SortUrl($timecards->approved) == "") { ?>
		<th data-name="approved"><div id="elh_timecards_approved" class="timecards_approved"><div class="ewTableHeaderCaption"><?php echo $timecards->approved->FldCaption() ?></div></div></th>
	<?php } else { ?>
		<th data-name="approved"><div class="ewPointer" onclick="ew_Sort(event,'<?php echo $timecards->SortUrl($timecards->approved) ?>',1);"><div id="elh_timecards_approved" class="timecards_approved">
			<div class="ewTableHeaderBtn"><span class="ewTableHeaderCaption"><?php echo $timecards->approved->FldCaption() ?></span><span class="ewTableHeaderSort"><?php if ($timecards->approved->getSort() == "ASC") { ?><span class="caret ewSortUp"></span><?php } elseif ($timecards->approved->getSort() == "DESC") { ?><span class="caret"></span><?php } ?></span></div>
        </div></div></th>
	<?php } ?>
<?php } ?>		
<?php

// Render list options (header, right)
$timecards_list->ListOptions->Render("header", "right");
?>
	</tr>
</thead>
<tbody>
<?php
if ($timecards->ExportAll && $timecards->Export <> "") {
	$timecards_list->StopRec = $timecards_list->TotalRecs;
} else {

	// Set the last record to display
	if ($timecards_list->TotalRecs > $timecards_list->StartRec + $timecards_list->DisplayRecs - 1)
		$timecards_list->StopRec = $timecards_list->StartRec + $timecards_list->DisplayRecs - 1;
	else
		$timecards_list->StopRec = $timecards_list->TotalRecs;
}
$timecards_list->RecCnt = $timecards_list->StartRec - 1;
if ($timecards_list->Recordset && !$timecards_list->Recordset->EOF) {
	$timecards_list->Recordset->MoveFirst();
	$bSelectLimit = $timecards_list->UseSelectLimit;
	if (!$bSelectLimit && $timecards_list->StartRec > 1)
		$timecards_list->Recordset->Move($timecards_list->StartRec - 1);
} elseif (!$timecards->AllowAddDeleteRow && $timecards_list->StopRec == 0) {
	$timecards_list->StopRec = $timecards->GridAddRowCount;
}

// Initialize aggregate
$timecards->RowType = EW_ROWTYPE_AGGREGATEINIT;
$timecards->ResetAttrs();
$timecards_list->RenderRow();
while ($timecards_list->RecCnt < $timecards_list->StopRec) {
	$timecards_list->RecCnt++;
	if (intval($timecards_list->RecCnt) >= intval($timecards_list->StartRec)) {
		$timecards_list->RowCnt++;

		// Set up key count
		$timecards_list->KeyCount = $timecards_list->RowIndex;

		// Init row class and style
		$timecards->ResetAttrs();
		$timecards->CssClass = "";
		if ($timecards->CurrentAction == "gridadd") {
		} else {
			$timecards_list->LoadRowValues($timecards_list->Recordset); // Load row values
		}
		$timecards->RowType = EW_ROWTYPE_VIEW; // Render view

		// Set up row id / data-rowindex
		$timecards->RowAttrs = array_merge($timecards->RowAttrs, array('data-rowindex'=>$timecards_list->RowCnt, 'id'=>'r' . $timecards_list->RowCnt . '_timecards', 'data-rowtype'=>$timecards->RowType));

		// Render row
		$timecards_list->RenderRow();

		// Render list options
		$timecards_list->RenderListOptions();
?>
	<tr<?php echo $timecards->RowAttributes() ?>>
<?php

// Render list options (body, left)
$timecards_list->ListOptions->Render("body", "left", $timecards_list->RowCnt);
?>
	<?php if ($timecards->weeknumber->Visible) { // weeknumber ?>
		<td data-name="weeknumber"<?php echo $timecards->weeknumber->CellAttributes() ?>>
<span id="el<?php echo $timecards_list->RowCnt ?>_timecards_weeknumber" class="timecards_weeknumber">
<span<?php echo $timecards->weeknumber->ViewAttributes() ?>>
<?php echo $timecards->weeknumber->ListViewValue() ?></span>
</span>
<a id="<?php echo $timecards_list->PageObjName . "_row_" . $timecards_list->RowCnt ?>"></a></td>
	<?php } ?>
	<?php if ($timecards->dbkey_councilor->Visible) { // dbkey_councilor ?>
		<td data-name="dbkey_councilor"<?php echo $timecards->dbkey_councilor->CellAttributes() ?>>
<span id="el<?php echo $timecards_list->RowCnt ?>_timecards_dbkey_councilor" class="timecards_dbkey_councilor">
<span<?php echo $timecards->dbkey_councilor->ViewAttributes() ?>>
<?php echo $timecards->dbkey_councilor->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($timecards->date->Visible) { // date ?>
		<td data-name="date"<?php echo $timecards->date->CellAttributes() ?>>
<span id="el<?php echo $timecards_list->RowCnt ?>_timecards_date" class="timecards_date">
<span<?php echo $timecards->date->ViewAttributes() ?>>
<?php echo $timecards->date->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($timecards->in->Visible) { // in ?>
		<td data-name="in"<?php echo $timecards->in->CellAttributes() ?>>
<span id="el<?php echo $timecards_list->RowCnt ?>_timecards_in" class="timecards_in">
<span<?php echo $timecards->in->ViewAttributes() ?>>
<?php echo $timecards->in->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($timecards->out->Visible) { // out ?>
		<td data-name="out"<?php echo $timecards->out->CellAttributes() ?>>
<span id="el<?php echo $timecards_list->RowCnt ?>_timecards_out" class="timecards_out">
<span<?php echo $timecards->out->ViewAttributes() ?>>
<?php echo $timecards->out->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($timecards->regular->Visible) { // regular ?>
		<td data-name="regular"<?php echo $timecards->regular->CellAttributes() ?>>
<span id="el<?php echo $timecards_list->RowCnt ?>_timecards_regular" class="timecards_regular">
<span<?php echo $timecards->regular->ViewAttributes() ?>>
<?php echo $timecards->regular->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($timecards->overtime->Visible) { // overtime ?>
		<td data-name="overtime"<?php echo $timecards->overtime->CellAttributes() ?>>
<span id="el<?php echo $timecards_list->RowCnt ?>_timecards_overtime" class="timecards_overtime">
<span<?php echo $timecards->overtime->ViewAttributes() ?>>
<?php echo $timecards->overtime->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($timecards->total->Visible) { // total ?>
		<td data-name="total"<?php echo $timecards->total->CellAttributes() ?>>
<span id="el<?php echo $timecards_list->RowCnt ?>_timecards_total" class="timecards_total">
<span<?php echo $timecards->total->ViewAttributes() ?>>
<?php echo $timecards->total->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
	<?php if ($timecards->approved->Visible) { // approved ?>
		<td data-name="approved"<?php echo $timecards->approved->CellAttributes() ?>>
<span id="el<?php echo $timecards_list->RowCnt ?>_timecards_approved" class="timecards_approved">
<span<?php echo $timecards->approved->ViewAttributes() ?>>
<?php echo $timecards->approved->ListViewValue() ?></span>
</span>
</td>
	<?php } ?>
<?php

// Render list options (body, right)
$timecards_list->ListOptions->Render("body", "right", $timecards_list->RowCnt);
?>
	</tr>
<?php
	}
	if ($timecards->CurrentAction <> "gridadd")
		$timecards_list->Recordset->MoveNext();
}
?>
</tbody>
</table>
<?php } ?>
<?php if ($timecards->CurrentAction == "") { ?>
<input type="hidden" name="a_list" id="a_list" value="">
<?php } ?>
</div>
</form>
<?php

// Close recordset
if ($timecards_list->Recordset)
	$timecards_list->Recordset->Close();
?>
</div>
<?php } ?>
<?php if ($timecards_list->TotalRecs == 0 && $timecards->CurrentAction == "") { // Show other options ?>
<div class="ewListOtherOptions">
<?php
	foreach ($timecards_list->OtherOptions as &$option) {
		$option->ButtonClass = "";
		$option->Render("body", "");
	}
?>
</div>
<div class="clearfix"></div>
<?php } ?>
<?php if ($timecards->Export == "") { ?>
<script type="text/javascript">
ftimecardslistsrch.FilterList = <?php echo $timecards_list->GetFilterList() ?>;
ftimecardslistsrch.Init();
ftimecardslist.Init();
</script>
<?php } ?>
<?php
$timecards_list->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<?php if ($timecards->Export == "") { ?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php } ?>
<?php include_once "footer.php" ?>
<?php
$timecards_list->Page_Terminate();
?>
