<?php
if (session_id() == "") session_start(); // Init session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg13.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql13.php") ?>
<?php include_once "phpfn13.php" ?>
<?php include_once "timecardsinfo.php" ?>
<?php include_once "counselorinfo.php" ?>
<?php include_once "userfn13.php" ?>
<?php

//
// Page class
//

$timecards_update = NULL; // Initialize page object first

class ctimecards_update extends ctimecards {

	// Page ID
	var $PageID = 'update';

	// Project ID
	var $ProjectID = "{8B25299E-AC9F-4627-87FB-92054E887668}";

	// Table name
	var $TableName = 'timecards';

	// Page object name
	var $PageObjName = 'timecards_update';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}
	var $AuditTrailOnAdd = FALSE;
	var $AuditTrailOnEdit = TRUE;
	var $AuditTrailOnDelete = FALSE;
	var $AuditTrailOnView = FALSE;
	var $AuditTrailOnViewData = FALSE;
	var $AuditTrailOnSearch = FALSE;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsHttpPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (timecards)
		if (!isset($GLOBALS["timecards"]) || get_class($GLOBALS["timecards"]) == "ctimecards") {
			$GLOBALS["timecards"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["timecards"];
		}

		// Table object (counselor)
		if (!isset($GLOBALS['counselor'])) $GLOBALS['counselor'] = new ccounselor();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'update', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'timecards', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"])) $GLOBALS["gTimer"] = new cTimer();

		// Open connection
		if (!isset($conn)) $conn = ew_Connect($this->DBID);

		// User table object (counselor)
		if (!isset($UserTable)) {
			$UserTable = new ccounselor();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	//
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (IsPasswordExpired())
			$this->Page_Terminate(ew_GetUrl("changepwd.php"));
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanEdit()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("timecardslist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}
		if ($Security->IsLoggedIn()) {
			$Security->UserID_Loading();
			$Security->LoadUserID();
			$Security->UserID_Loaded();
		}

		// Create form object
		$objForm = new cFormObj();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action
		$this->dbkey_councilor->SetVisibility();
		$this->date->SetVisibility();
		$this->in->SetVisibility();
		$this->out->SetVisibility();
		$this->regular->SetVisibility();
		$this->overtime->SetVisibility();
		$this->total->SetVisibility();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $timecards;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($timecards);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		 // Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();

			// Handle modal response
			if ($this->IsModal) {
				$row = array();
				$row["url"] = $url;
				echo ew_ArrayToJson(array($row));
			} else {
				header("Location: " . $url);
			}
		}
		exit();
	}
	var $FormClassName = "form-horizontal ewForm ewUpdateForm";
	var $IsModal = FALSE;
	var $RecKeys;
	var $Disabled;
	var $Recordset;
	var $UpdateCount = 0;

	//
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError;
		global $gbSkipHeaderFooter;

		// Check modal
		$this->IsModal = (@$_GET["modal"] == "1" || @$_POST["modal"] == "1");
		if ($this->IsModal)
			$gbSkipHeaderFooter = TRUE;

		// Set up Breadcrumb
		$this->SetupBreadcrumb();

		// Try to load keys from list form
		$this->RecKeys = $this->GetRecordKeys(); // Load record keys
		if (@$_POST["a_update"] <> "") {

			// Get action
			$this->CurrentAction = $_POST["a_update"];
			$this->LoadFormValues(); // Get form values

			// Validate form
			if (!$this->ValidateForm()) {
				$this->CurrentAction = "I"; // Form error, reset action
				$this->setFailureMessage($gsFormError);
			}
		} else {
			$this->LoadMultiUpdateValues(); // Load initial values to form
		}
		if (count($this->RecKeys) <= 0)
			$this->Page_Terminate("timecardslist.php"); // No records selected, return to list
		switch ($this->CurrentAction) {
			case "U": // Update
				if ($this->UpdateRows()) { // Update Records based on key
					if ($this->getSuccessMessage() == "")
						$this->setSuccessMessage($Language->Phrase("UpdateSuccess")); // Set up update success message
					$this->Page_Terminate($this->getReturnUrl()); // Return to caller
				} else {
					$this->RestoreFormValues(); // Restore form values
				}
		}

		// Render row
		$this->RowType = EW_ROWTYPE_EDIT; // Render edit
		$this->ResetAttrs();
		$this->RenderRow();
	}

	// Load initial values to form if field values are identical in all selected records
	function LoadMultiUpdateValues() {
		$this->CurrentFilter = $this->GetKeyFilter();

		// Load recordset
		if ($this->Recordset = $this->LoadRecordset()) {
			$i = 1;
			while (!$this->Recordset->EOF) {
				if ($i == 1) {
					$this->dbkey_councilor->setDbValue($this->Recordset->fields('dbkey_councilor'));
					$this->date->setDbValue($this->Recordset->fields('date'));
					$this->in->setDbValue($this->Recordset->fields('in'));
					$this->out->setDbValue($this->Recordset->fields('out'));
					$this->regular->setDbValue($this->Recordset->fields('regular'));
					$this->overtime->setDbValue($this->Recordset->fields('overtime'));
					$this->total->setDbValue($this->Recordset->fields('total'));
				} else {
					if (!ew_CompareValue($this->dbkey_councilor->DbValue, $this->Recordset->fields('dbkey_councilor')))
						$this->dbkey_councilor->CurrentValue = NULL;
					if (!ew_CompareValue($this->date->DbValue, $this->Recordset->fields('date')))
						$this->date->CurrentValue = NULL;
					if (!ew_CompareValue($this->in->DbValue, $this->Recordset->fields('in')))
						$this->in->CurrentValue = NULL;
					if (!ew_CompareValue($this->out->DbValue, $this->Recordset->fields('out')))
						$this->out->CurrentValue = NULL;
					if (!ew_CompareValue($this->regular->DbValue, $this->Recordset->fields('regular')))
						$this->regular->CurrentValue = NULL;
					if (!ew_CompareValue($this->overtime->DbValue, $this->Recordset->fields('overtime')))
						$this->overtime->CurrentValue = NULL;
					if (!ew_CompareValue($this->total->DbValue, $this->Recordset->fields('total')))
						$this->total->CurrentValue = NULL;
				}
				$i++;
				$this->Recordset->MoveNext();
			}
			$this->Recordset->Close();
		}
	}

	// Set up key value
	function SetupKeyValues($key) {
		$sKeyFld = $key;
		if (!is_numeric($sKeyFld))
			return FALSE;
		$this->dbkey->CurrentValue = $sKeyFld;
		return TRUE;
	}

	// Update all selected rows
	function UpdateRows() {
		global $Language;
		$conn = &$this->Connection();
		$conn->BeginTrans();
		if ($this->AuditTrailOnEdit) $this->WriteAuditTrailDummy($Language->Phrase("BatchUpdateBegin")); // Batch update begin

		// Get old recordset
		$this->CurrentFilter = $this->GetKeyFilter();
		$sSql = $this->SQL();
		$rsold = $conn->Execute($sSql);

		// Update all rows
		$sKey = "";
		foreach ($this->RecKeys as $key) {
			if ($this->SetupKeyValues($key)) {
				$sThisKey = $key;
				$this->SendEmail = FALSE; // Do not send email on update success
				$this->UpdateCount += 1; // Update record count for records being updated
				$UpdateRows = $this->EditRow(); // Update this row
			} else {
				$UpdateRows = FALSE;
			}
			if (!$UpdateRows)
				break; // Update failed
			if ($sKey <> "") $sKey .= ", ";
			$sKey .= $sThisKey;
		}

		// Check if all rows updated
		if ($UpdateRows) {
			$conn->CommitTrans(); // Commit transaction

			// Get new recordset
			$rsnew = $conn->Execute($sSql);
			if ($this->AuditTrailOnEdit) $this->WriteAuditTrailDummy($Language->Phrase("BatchUpdateSuccess")); // Batch update success
		} else {
			$conn->RollbackTrans(); // Rollback transaction
			if ($this->AuditTrailOnEdit) $this->WriteAuditTrailDummy($Language->Phrase("BatchUpdateRollback")); // Batch update rollback
		}
		return $UpdateRows;
	}

	// Get upload files
	function GetUploadFiles() {
		global $objForm, $Language;

		// Get upload data
	}

	// Load form values
	function LoadFormValues() {

		// Load from form
		global $objForm;
		if (!$this->dbkey_councilor->FldIsDetailKey) {
			$this->dbkey_councilor->setFormValue($objForm->GetValue("x_dbkey_councilor"));
		}
		$this->dbkey_councilor->MultiUpdate = $objForm->GetValue("u_dbkey_councilor");
		if (!$this->date->FldIsDetailKey) {
			$this->date->setFormValue($objForm->GetValue("x_date"));
			$this->date->CurrentValue = ew_UnFormatDateTime($this->date->CurrentValue, 0);
		}
		$this->date->MultiUpdate = $objForm->GetValue("u_date");
		if (!$this->in->FldIsDetailKey) {
			$this->in->setFormValue($objForm->GetValue("x_in"));
		}
		$this->in->MultiUpdate = $objForm->GetValue("u_in");
		if (!$this->out->FldIsDetailKey) {
			$this->out->setFormValue($objForm->GetValue("x_out"));
		}
		$this->out->MultiUpdate = $objForm->GetValue("u_out");
		if (!$this->regular->FldIsDetailKey) {
			$this->regular->setFormValue($objForm->GetValue("x_regular"));
		}
		$this->regular->MultiUpdate = $objForm->GetValue("u_regular");
		if (!$this->overtime->FldIsDetailKey) {
			$this->overtime->setFormValue($objForm->GetValue("x_overtime"));
		}
		$this->overtime->MultiUpdate = $objForm->GetValue("u_overtime");
		if (!$this->total->FldIsDetailKey) {
			$this->total->setFormValue($objForm->GetValue("x_total"));
		}
		$this->total->MultiUpdate = $objForm->GetValue("u_total");
		if (!$this->dbkey->FldIsDetailKey)
			$this->dbkey->setFormValue($objForm->GetValue("x_dbkey"));
	}

	// Restore form values
	function RestoreFormValues() {
		global $objForm;
		$this->dbkey->CurrentValue = $this->dbkey->FormValue;
		$this->dbkey_councilor->CurrentValue = $this->dbkey_councilor->FormValue;
		$this->date->CurrentValue = $this->date->FormValue;
		$this->date->CurrentValue = ew_UnFormatDateTime($this->date->CurrentValue, 0);
		$this->in->CurrentValue = $this->in->FormValue;
		$this->out->CurrentValue = $this->out->FormValue;
		$this->regular->CurrentValue = $this->regular->FormValue;
		$this->overtime->CurrentValue = $this->overtime->FormValue;
		$this->total->CurrentValue = $this->total->FormValue;
	}

	// Load recordset
	function LoadRecordset($offset = -1, $rowcnt = -1) {

		// Load List page SQL
		$sSql = $this->SelectSQL();
		$conn = &$this->Connection();

		// Load recordset
		$dbtype = ew_GetConnectionType($this->DBID);
		if ($this->UseSelectLimit) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			if ($dbtype == "MSSQL") {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset, array("_hasOrderBy" => trim($this->getOrderBy()) || trim($this->getSessionOrderBy())));
			} else {
				$rs = $conn->SelectLimit($sSql, $rowcnt, $offset);
			}
			$conn->raiseErrorFn = '';
		} else {
			$rs = ew_LoadRecordset($sSql, $conn);
		}

		// Call Recordset Selected event
		$this->Recordset_Selected($rs);
		return $rs;
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		if (!$rs || $rs->EOF) return;

		// Call Row Selected event
		$row = &$rs->fields;
		$this->Row_Selected($row);
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->start->setDbValue($rs->fields('start'));
		$this->end->setDbValue($rs->fields('end'));
		$this->dbkey_councilor->setDbValue($rs->fields('dbkey_councilor'));
		$this->date->setDbValue($rs->fields('date'));
		$this->in->setDbValue($rs->fields('in'));
		$this->out->setDbValue($rs->fields('out'));
		$this->approved_by->setDbValue($rs->fields('approved_by'));
		$this->approved_on->setDbValue($rs->fields('approved_on'));
		$this->created_on->setDbValue($rs->fields('created_on'));
		$this->updated_on->setDbValue($rs->fields('updated_on'));
		$this->created_by->setDbValue($rs->fields('created_by'));
		$this->updated_by->setDbValue($rs->fields('updated_by'));
		$this->regular->setDbValue($rs->fields('regular'));
		$this->overtime->setDbValue($rs->fields('overtime'));
		$this->total->setDbValue($rs->fields('total'));
		$this->approved->setDbValue($rs->fields('approved'));
		$this->weeknumber->setDbValue($rs->fields('weeknumber'));
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF) return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->dbkey->DbValue = $row['dbkey'];
		$this->start->DbValue = $row['start'];
		$this->end->DbValue = $row['end'];
		$this->dbkey_councilor->DbValue = $row['dbkey_councilor'];
		$this->date->DbValue = $row['date'];
		$this->in->DbValue = $row['in'];
		$this->out->DbValue = $row['out'];
		$this->approved_by->DbValue = $row['approved_by'];
		$this->approved_on->DbValue = $row['approved_on'];
		$this->created_on->DbValue = $row['created_on'];
		$this->updated_on->DbValue = $row['updated_on'];
		$this->created_by->DbValue = $row['created_by'];
		$this->updated_by->DbValue = $row['updated_by'];
		$this->regular->DbValue = $row['regular'];
		$this->overtime->DbValue = $row['overtime'];
		$this->total->DbValue = $row['total'];
		$this->approved->DbValue = $row['approved'];
		$this->weeknumber->DbValue = $row['weeknumber'];
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Convert decimal values if posted back

		if ($this->regular->FormValue == $this->regular->CurrentValue && is_numeric(ew_StrToFloat($this->regular->CurrentValue)))
			$this->regular->CurrentValue = ew_StrToFloat($this->regular->CurrentValue);

		// Convert decimal values if posted back
		if ($this->overtime->FormValue == $this->overtime->CurrentValue && is_numeric(ew_StrToFloat($this->overtime->CurrentValue)))
			$this->overtime->CurrentValue = ew_StrToFloat($this->overtime->CurrentValue);

		// Convert decimal values if posted back
		if ($this->total->FormValue == $this->total->CurrentValue && is_numeric(ew_StrToFloat($this->total->CurrentValue)))
			$this->total->CurrentValue = ew_StrToFloat($this->total->CurrentValue);

		// Call Row_Rendering event
		$this->Row_Rendering();

		// Common render codes for all row types
		// dbkey
		// start
		// end
		// dbkey_councilor
		// date
		// in
		// out
		// approved_by
		// approved_on
		// created_on
		// updated_on
		// created_by
		// updated_by
		// regular
		// overtime
		// total
		// approved
		// weeknumber

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// start
		if (strval($this->start->CurrentValue) <> "") {
			$sFilterWrk = "STR_TO_DATE(concat(substr(timecards.date,1,4),WEEKOFYEAR(timecards.date),' Sunday'), '%X%V %W')" . ew_SearchString("=", $this->start->CurrentValue, EW_DATATYPE_DATE, "");
		$sSqlWrk = "SELECT DISTINCT STR_TO_DATE(concat(substr(timecards.date,1,4),WEEKOFYEAR(timecards.date),' Sunday'), '%X%V %W'), STR_TO_DATE(concat(substr(timecards.date,1,4),WEEKOFYEAR(timecards.date),' Sunday'), '%X%V %W') AS `DispFld`, STR_TO_DATE(concat(substr(timecards.date,1,4),WEEKOFYEAR(timecards.date),' Saturday'), '%X%V %W') AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `timecards`";
		$sWhereWrk = "";
		$this->start->LookupFilters = array("df1" => "0", "df2" => "0");
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->start, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = ew_FormatDateTime($rswrk->fields('DispFld'), 0);
				$arwrk[2] = ew_FormatDateTime($rswrk->fields('Disp2Fld'), 0);
				$this->start->ViewValue = $this->start->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->start->ViewValue = $this->start->CurrentValue;
			}
		} else {
			$this->start->ViewValue = NULL;
		}
		$this->start->ViewValue = ew_FormatDateTime($this->start->ViewValue, 0);
		$this->start->ViewCustomAttributes = "";

		// dbkey_councilor
		if (strval($this->dbkey_councilor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->dbkey_councilor->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_councilor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_councilor->ViewValue = $this->dbkey_councilor->CurrentValue;
			}
		} else {
			$this->dbkey_councilor->ViewValue = NULL;
		}
		$this->dbkey_councilor->ViewCustomAttributes = "";

		// date
		$this->date->ViewValue = $this->date->CurrentValue;
		$this->date->ViewValue = ew_FormatDateTime($this->date->ViewValue, 0);
		$this->date->ViewCustomAttributes = "";

		// in
		if (strval($this->in->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->in->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `tables_data`";
		$sWhereWrk = "";
		$this->in->LookupFilters = array();
		$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->in, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `dbkey`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->in->ViewValue = $this->in->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->in->ViewValue = $this->in->CurrentValue;
			}
		} else {
			$this->in->ViewValue = NULL;
		}
		$this->in->ViewCustomAttributes = "";

		// out
		if (strval($this->out->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->out->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `tables_data`";
		$sWhereWrk = "";
		$this->out->LookupFilters = array();
		$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->out, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->out->ViewValue = $this->out->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->out->ViewValue = $this->out->CurrentValue;
			}
		} else {
			$this->out->ViewValue = NULL;
		}
		$this->out->ViewCustomAttributes = "";

		// regular
		$this->regular->ViewValue = $this->regular->CurrentValue;
		$this->regular->ViewValue = ew_FormatNumber($this->regular->ViewValue, 2, -2, -2, -2);
		$this->regular->ViewCustomAttributes = "";

		// overtime
		$this->overtime->ViewValue = $this->overtime->CurrentValue;
		$this->overtime->ViewValue = ew_FormatNumber($this->overtime->ViewValue, 2, -2, -2, -2);
		$this->overtime->ViewCustomAttributes = "";

		// total
		$this->total->ViewValue = $this->total->CurrentValue;
		$this->total->ViewValue = ew_FormatNumber($this->total->ViewValue, 2, -1, -2, -2);
		$this->total->ViewCustomAttributes = "";

		// approved
		if (strval($this->approved->CurrentValue) <> "") {
			$this->approved->ViewValue = "";
			$arwrk = explode(",", strval($this->approved->CurrentValue));
			$cnt = count($arwrk);
			for ($ari = 0; $ari < $cnt; $ari++) {
				$this->approved->ViewValue .= $this->approved->OptionCaption(trim($arwrk[$ari]));
				if ($ari < $cnt-1) $this->approved->ViewValue .= ew_ViewOptionSeparator($ari);
			}
		} else {
			$this->approved->ViewValue = NULL;
		}
		$this->approved->ViewCustomAttributes = "";

			// dbkey_councilor
			$this->dbkey_councilor->LinkCustomAttributes = "";
			$this->dbkey_councilor->HrefValue = "";
			$this->dbkey_councilor->TooltipValue = "";

			// date
			$this->date->LinkCustomAttributes = "";
			$this->date->HrefValue = "";
			$this->date->TooltipValue = "";

			// in
			$this->in->LinkCustomAttributes = "";
			$this->in->HrefValue = "";
			$this->in->TooltipValue = "";

			// out
			$this->out->LinkCustomAttributes = "";
			$this->out->HrefValue = "";
			$this->out->TooltipValue = "";

			// regular
			$this->regular->LinkCustomAttributes = "";
			$this->regular->HrefValue = "";
			$this->regular->TooltipValue = "";

			// overtime
			$this->overtime->LinkCustomAttributes = "";
			$this->overtime->HrefValue = "";
			$this->overtime->TooltipValue = "";

			// total
			$this->total->LinkCustomAttributes = "";
			$this->total->HrefValue = "";
			$this->total->TooltipValue = "";
		} elseif ($this->RowType == EW_ROWTYPE_EDIT) { // Edit row

			// dbkey_councilor
			$this->dbkey_councilor->EditAttrs["class"] = "form-control";
			$this->dbkey_councilor->EditCustomAttributes = "";
			if (strval($this->dbkey_councilor->CurrentValue) <> "") {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_councilor->CurrentValue, EW_DATATYPE_NUMBER, "");
			$sSqlWrk = "SELECT `dbkey`, `first` AS `DispFld`, `last` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
			$sWhereWrk = "";
			$this->dbkey_councilor->LookupFilters = array();
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->dbkey_councilor, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `last`";
				$rswrk = Conn()->Execute($sSqlWrk);
				if ($rswrk && !$rswrk->EOF) { // Lookup values found
					$arwrk = array();
					$arwrk[1] = $rswrk->fields('DispFld');
					$arwrk[2] = $rswrk->fields('Disp2Fld');
					$this->dbkey_councilor->EditValue = $this->dbkey_councilor->DisplayValue($arwrk);
					$rswrk->Close();
				} else {
					$this->dbkey_councilor->EditValue = $this->dbkey_councilor->CurrentValue;
				}
			} else {
				$this->dbkey_councilor->EditValue = NULL;
			}
			$this->dbkey_councilor->ViewCustomAttributes = "";

			// date
			$this->date->EditAttrs["class"] = "form-control";
			$this->date->EditCustomAttributes = "";
			$this->date->EditValue = ew_HtmlEncode(ew_FormatDateTime($this->date->CurrentValue, 8));
			$this->date->PlaceHolder = ew_RemoveHtml($this->date->FldCaption());

			// in
			$this->in->EditAttrs["class"] = "form-control";
			$this->in->EditCustomAttributes = "";
			if (trim(strval($this->in->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->in->CurrentValue, EW_DATATYPE_STRING, "");
			}
			$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `tables_data`";
			$sWhereWrk = "";
			$this->in->LookupFilters = array();
			$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->in, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `dbkey`";
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->in->EditValue = $arwrk;

			// out
			$this->out->EditAttrs["class"] = "form-control";
			$this->out->EditCustomAttributes = "";
			if (trim(strval($this->out->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->out->CurrentValue, EW_DATATYPE_STRING, "");
			}
			$sSqlWrk = "SELECT `dbkey`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld`, '' AS `SelectFilterFld`, '' AS `SelectFilterFld2`, '' AS `SelectFilterFld3`, '' AS `SelectFilterFld4` FROM `tables_data`";
			$sWhereWrk = "";
			$this->out->LookupFilters = array();
			$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			ew_AddFilter($sWhereWrk, $sFilterWrk);
			$this->Lookup_Selecting($this->out, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			$this->out->EditValue = $arwrk;

			// regular
			$this->regular->EditAttrs["class"] = "form-control";
			$this->regular->EditCustomAttributes = "";
			$this->regular->EditValue = ew_HtmlEncode($this->regular->CurrentValue);
			$this->regular->PlaceHolder = ew_RemoveHtml($this->regular->FldCaption());
			if (strval($this->regular->EditValue) <> "" && is_numeric($this->regular->EditValue)) $this->regular->EditValue = ew_FormatNumber($this->regular->EditValue, -2, -2, -2, -2);

			// overtime
			$this->overtime->EditAttrs["class"] = "form-control";
			$this->overtime->EditCustomAttributes = "";
			$this->overtime->EditValue = ew_HtmlEncode($this->overtime->CurrentValue);
			$this->overtime->PlaceHolder = ew_RemoveHtml($this->overtime->FldCaption());
			if (strval($this->overtime->EditValue) <> "" && is_numeric($this->overtime->EditValue)) $this->overtime->EditValue = ew_FormatNumber($this->overtime->EditValue, -2, -2, -2, -2);

			// total
			$this->total->EditAttrs["class"] = "form-control";
			$this->total->EditCustomAttributes = "";
			$this->total->EditValue = ew_HtmlEncode($this->total->CurrentValue);
			$this->total->PlaceHolder = ew_RemoveHtml($this->total->FldCaption());
			if (strval($this->total->EditValue) <> "" && is_numeric($this->total->EditValue)) $this->total->EditValue = ew_FormatNumber($this->total->EditValue, -2, -1, -2, -2);

			// Edit refer script
			// dbkey_councilor

			$this->dbkey_councilor->LinkCustomAttributes = "";
			$this->dbkey_councilor->HrefValue = "";
			$this->dbkey_councilor->TooltipValue = "";

			// date
			$this->date->LinkCustomAttributes = "";
			$this->date->HrefValue = "";

			// in
			$this->in->LinkCustomAttributes = "";
			$this->in->HrefValue = "";

			// out
			$this->out->LinkCustomAttributes = "";
			$this->out->HrefValue = "";

			// regular
			$this->regular->LinkCustomAttributes = "";
			$this->regular->HrefValue = "";

			// overtime
			$this->overtime->LinkCustomAttributes = "";
			$this->overtime->HrefValue = "";

			// total
			$this->total->LinkCustomAttributes = "";
			$this->total->HrefValue = "";
		}
		if ($this->RowType == EW_ROWTYPE_ADD ||
			$this->RowType == EW_ROWTYPE_EDIT ||
			$this->RowType == EW_ROWTYPE_SEARCH) { // Add / Edit / Search row
			$this->SetupFieldTitles();
		}

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate form
	function ValidateForm() {
		global $Language, $gsFormError;

		// Initialize form error message
		$gsFormError = "";
		$lUpdateCnt = 0;
		if ($this->dbkey_councilor->MultiUpdate == "1") $lUpdateCnt++;
		if ($this->date->MultiUpdate == "1") $lUpdateCnt++;
		if ($this->in->MultiUpdate == "1") $lUpdateCnt++;
		if ($this->out->MultiUpdate == "1") $lUpdateCnt++;
		if ($this->regular->MultiUpdate == "1") $lUpdateCnt++;
		if ($this->overtime->MultiUpdate == "1") $lUpdateCnt++;
		if ($this->total->MultiUpdate == "1") $lUpdateCnt++;
		if ($lUpdateCnt == 0) {
			$gsFormError = $Language->Phrase("NoFieldSelected");
			return FALSE;
		}

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return ($gsFormError == "");
		if ($this->date->MultiUpdate <> "") {
			if (!ew_CheckDateDef($this->date->FormValue)) {
				ew_AddMessage($gsFormError, $this->date->FldErrMsg());
			}
		}
		if ($this->in->MultiUpdate <> "" && !$this->in->FldIsDetailKey && !is_null($this->in->FormValue) && $this->in->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->in->FldCaption(), $this->in->ReqErrMsg));
		}
		if ($this->out->MultiUpdate <> "" && !$this->out->FldIsDetailKey && !is_null($this->out->FormValue) && $this->out->FormValue == "") {
			ew_AddMessage($gsFormError, str_replace("%s", $this->out->FldCaption(), $this->out->ReqErrMsg));
		}
		if ($this->regular->MultiUpdate <> "") {
			if (!ew_CheckNumber($this->regular->FormValue)) {
				ew_AddMessage($gsFormError, $this->regular->FldErrMsg());
			}
		}
		if ($this->overtime->MultiUpdate <> "") {
			if (!ew_CheckNumber($this->overtime->FormValue)) {
				ew_AddMessage($gsFormError, $this->overtime->FldErrMsg());
			}
		}
		if ($this->total->MultiUpdate <> "") {
			if (!ew_CheckNumber($this->total->FormValue)) {
				ew_AddMessage($gsFormError, $this->total->FldErrMsg());
			}
		}

		// Return validate result
		$ValidateForm = ($gsFormError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateForm = $ValidateForm && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsFormError, $sFormCustomError);
		}
		return $ValidateForm;
	}

	// Update record based on key values
	function EditRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$conn = &$this->Connection();
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
		$rs = $conn->Execute($sSql);
		$conn->raiseErrorFn = '';
		if ($rs === FALSE)
			return FALSE;
		if ($rs->EOF) {
			$this->setFailureMessage($Language->Phrase("NoRecord")); // Set no record message
			$EditRow = FALSE; // Update Failed
		} else {

			// Save old values
			$rsold = &$rs->fields;
			$this->LoadDbValues($rsold);
			$rsnew = array();

			// date
			$this->date->SetDbValueDef($rsnew, ew_UnFormatDateTime($this->date->CurrentValue, 0), NULL, $this->date->ReadOnly || $this->date->MultiUpdate <> "1");

			// in
			$this->in->SetDbValueDef($rsnew, $this->in->CurrentValue, NULL, $this->in->ReadOnly || $this->in->MultiUpdate <> "1");

			// out
			$this->out->SetDbValueDef($rsnew, $this->out->CurrentValue, NULL, $this->out->ReadOnly || $this->out->MultiUpdate <> "1");

			// regular
			$this->regular->SetDbValueDef($rsnew, $this->regular->CurrentValue, 0, $this->regular->ReadOnly || $this->regular->MultiUpdate <> "1");

			// overtime
			$this->overtime->SetDbValueDef($rsnew, $this->overtime->CurrentValue, 0, $this->overtime->ReadOnly || $this->overtime->MultiUpdate <> "1");

			// total
			$this->total->SetDbValueDef($rsnew, $this->total->CurrentValue, 0, $this->total->ReadOnly || $this->total->MultiUpdate <> "1");

			// Call Row Updating event
			$bUpdateRow = $this->Row_Updating($rsold, $rsnew);
			if ($bUpdateRow) {
				$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
				if (count($rsnew) > 0)
					$EditRow = $this->Update($rsnew, "", $rsold);
				else
					$EditRow = TRUE; // No field to update
				$conn->raiseErrorFn = '';
				if ($EditRow) {
				}
			} else {
				if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

					// Use the message, do nothing
				} elseif ($this->CancelMessage <> "") {
					$this->setFailureMessage($this->CancelMessage);
					$this->CancelMessage = "";
				} else {
					$this->setFailureMessage($Language->Phrase("UpdateCancelled"));
				}
				$EditRow = FALSE;
			}
		}

		// Call Row_Updated event
		if ($EditRow)
			$this->Row_Updated($rsold, $rsnew);
		if ($EditRow) {
			$this->WriteAuditTrailOnEdit($rsold, $rsnew);
		}
		$rs->Close();
		return $EditRow;
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, $this->AddMasterUrl("timecardslist.php"), "", $this->TableVar, TRUE);
		$PageId = "update";
		$Breadcrumb->Add("update", $PageId, $url);
	}

	// Setup lookup filters of a field
	function SetupLookupFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		case "x_in":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT `dbkey` AS `LinkFld`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `tables_data`";
			$sWhereWrk = "";
			$this->in->LookupFilters = array();
			$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey` = {filter_value}', "t0" => "200", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->in, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$sSqlWrk .= " ORDER BY `dbkey`";
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		case "x_out":
			$sSqlWrk = "";
			$sSqlWrk = "SELECT `dbkey` AS `LinkFld`, `description` AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `tables_data`";
			$sWhereWrk = "";
			$this->out->LookupFilters = array();
			$lookuptblfilter = "`dbkey_tables` = 'time_interval'";
			ew_AddFilter($sWhereWrk, $lookuptblfilter);
			$fld->LookupFilters += array("s" => $sSqlWrk, "d" => "", "f0" => '`dbkey` = {filter_value}', "t0" => "200", "fn0" => "");
			$sSqlWrk = "";
			$this->Lookup_Selecting($this->out, $sWhereWrk); // Call Lookup selecting
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			if ($sSqlWrk <> "")
				$fld->LookupFilters["s"] .= $sSqlWrk;
			break;
		}
	}

	// Setup AutoSuggest filters of a field
	function SetupAutoSuggestFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Write Audit Trail start/end for grid update
	function WriteAuditTrailDummy($typ) {
		$table = 'timecards';
		$usr = CurrentUserID();
		ew_WriteAuditTrail("log", ew_StdCurrentDateTime(), ew_ScriptName(), $usr, $typ, $table, "", "", "", "");
	}

	// Write Audit Trail (edit page)
	function WriteAuditTrailOnEdit(&$rsold, &$rsnew) {
		global $Language;
		if (!$this->AuditTrailOnEdit) return;
		$table = 'timecards';

		// Get key value
		$key = "";
		if ($key <> "") $key .= $GLOBALS["EW_COMPOSITE_KEY_SEPARATOR"];
		$key .= $rsold['dbkey'];

		// Write Audit Trail
		$dt = ew_StdCurrentDateTime();
		$id = ew_ScriptName();
		$usr = CurrentUserID();
		foreach (array_keys($rsnew) as $fldname) {
			if ($this->fields[$fldname]->FldDataType <> EW_DATATYPE_BLOB) { // Ignore BLOB fields
				if ($this->fields[$fldname]->FldDataType == EW_DATATYPE_DATE) { // DateTime field
					$modified = (ew_FormatDateTime($rsold[$fldname], 0) <> ew_FormatDateTime($rsnew[$fldname], 0));
				} else {
					$modified = !ew_CompareValue($rsold[$fldname], $rsnew[$fldname]);
				}
				if ($modified) {
					if ($this->fields[$fldname]->FldHtmlTag == "PASSWORD") { // Password Field
						$oldvalue = $Language->Phrase("PasswordMask");
						$newvalue = $Language->Phrase("PasswordMask");
					} elseif ($this->fields[$fldname]->FldDataType == EW_DATATYPE_MEMO) { // Memo field
						if (EW_AUDIT_TRAIL_TO_DATABASE) {
							$oldvalue = $rsold[$fldname];
							$newvalue = $rsnew[$fldname];
						} else {
							$oldvalue = "[MEMO]";
							$newvalue = "[MEMO]";
						}
					} elseif ($this->fields[$fldname]->FldDataType == EW_DATATYPE_XML) { // XML field
						$oldvalue = "[XML]";
						$newvalue = "[XML]";
					} else {
						$oldvalue = $rsold[$fldname];
						$newvalue = $rsnew[$fldname];
					}
					ew_WriteAuditTrail("log", $dt, $id, $usr, "U", $table, $fldname, $key, $oldvalue, $newvalue);
				}
			}
		}
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($timecards_update)) $timecards_update = new ctimecards_update();

// Page init
$timecards_update->Page_Init();

// Page main
$timecards_update->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$timecards_update->Page_Render();
?>
<?php include_once "header.php" ?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "update";
var CurrentForm = ftimecardsupdate = new ew_Form("ftimecardsupdate", "update");

// Validate form
ftimecardsupdate.Validate = function() {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	var $ = jQuery, fobj = this.GetForm(), $fobj = $(fobj);
	if ($fobj.find("#a_confirm").val() == "F")
		return true;
	if (!ew_UpdateSelected(fobj)) {
		ew_Alert(ewLanguage.Phrase("NoFieldSelected"));
		return false;
	}
	var elm, felm, uelm, addcnt = 0;
	var $k = $fobj.find("#" + this.FormKeyCountName); // Get key_count
	var rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1;
	var startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
	var gridinsert = $fobj.find("#a_list").val() == "gridinsert";
	for (var i = startcnt; i <= rowcnt; i++) {
		var infix = ($k[0]) ? String(i) : "";
		$fobj.data("rowindex", infix);
			elm = this.GetElements("x" + infix + "_date");
			uelm = this.GetElements("u" + infix + "_date");
			if (uelm && uelm.checked && elm && !ew_CheckDateDef(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($timecards->date->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_in");
			uelm = this.GetElements("u" + infix + "_in");
			if (uelm && uelm.checked) {
				if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
					return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $timecards->in->FldCaption(), $timecards->in->ReqErrMsg)) ?>");
			}
			elm = this.GetElements("x" + infix + "_out");
			uelm = this.GetElements("u" + infix + "_out");
			if (uelm && uelm.checked) {
				if (elm && !ew_IsHidden(elm) && !ew_HasValue(elm))
					return this.OnError(elm, "<?php echo ew_JsEncode2(str_replace("%s", $timecards->out->FldCaption(), $timecards->out->ReqErrMsg)) ?>");
			}
			elm = this.GetElements("x" + infix + "_regular");
			uelm = this.GetElements("u" + infix + "_regular");
			if (uelm && uelm.checked && elm && !ew_CheckNumber(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($timecards->regular->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_overtime");
			uelm = this.GetElements("u" + infix + "_overtime");
			if (uelm && uelm.checked && elm && !ew_CheckNumber(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($timecards->overtime->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_total");
			uelm = this.GetElements("u" + infix + "_total");
			if (uelm && uelm.checked && elm && !ew_CheckNumber(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($timecards->total->FldErrMsg()) ?>");

			// Fire Form_CustomValidate event
			if (!this.Form_CustomValidate(fobj))
				return false;
	}
	return true;
}

// Form_CustomValidate event
ftimecardsupdate.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }

// Use JavaScript validation or not
<?php if (EW_CLIENT_VALIDATE) { ?>
ftimecardsupdate.ValidateRequired = true;
<?php } else { ?>
ftimecardsupdate.ValidateRequired = false; 
<?php } ?>

// Dynamic selection lists
ftimecardsupdate.Lists["x_dbkey_councilor"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_first","x_last","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"counselor"};
ftimecardsupdate.Lists["x_in"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"tables_data"};
ftimecardsupdate.Lists["x_out"] = {"LinkField":"x_dbkey","Ajax":true,"AutoFill":false,"DisplayFields":["x_description","","",""],"ParentFields":[],"ChildFields":[],"FilterFields":[],"Options":[],"Template":"","LinkTable":"tables_data"};

// Form object for search
</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php if (!$timecards_update->IsModal) { ?>
<div class="ewToolbar">
<?php $Breadcrumb->Render(); ?>
<?php echo $Language->SelectionForm(); ?>
<div class="clearfix"></div>
</div>
<?php } ?>
<?php $timecards_update->ShowPageHeader(); ?>
<?php
$timecards_update->ShowMessage();
?>
<form name="ftimecardsupdate" id="ftimecardsupdate" class="<?php echo $timecards_update->FormClassName ?>" action="<?php echo ew_CurrentPage() ?>" method="post">
<?php if ($timecards_update->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $timecards_update->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="timecards">
<input type="hidden" name="a_update" id="a_update" value="U">
<?php if ($timecards_update->IsModal) { ?>
<input type="hidden" name="modal" value="1">
<?php } ?>
<?php foreach ($timecards_update->RecKeys as $key) { ?>
<?php $keyvalue = is_array($key) ? implode($EW_COMPOSITE_KEY_SEPARATOR, $key) : $key; ?>
<input type="hidden" name="key_m[]" value="<?php echo ew_HtmlEncode($keyvalue) ?>">
<?php } ?>
<div id="tbl_timecardsupdate">
	<div class="checkbox">
		<label><input type="checkbox" name="u" id="u" onclick="ew_SelectAll(this);"> <?php echo $Language->Phrase("UpdateSelectAll") ?></label>
	</div>
<?php if ($timecards->date->Visible) { // date ?>
	<div id="r_date" class="form-group">
		<label for="x_date" class="col-sm-2 control-label">
<input type="checkbox" name="u_date" id="u_date" value="1"<?php echo ($timecards->date->MultiUpdate == "1") ? " checked" : "" ?>>
 <?php echo $timecards->date->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $timecards->date->CellAttributes() ?>>
<span id="el_timecards_date">
<input type="text" data-table="timecards" data-field="x_date" name="x_date" id="x_date" placeholder="<?php echo ew_HtmlEncode($timecards->date->getPlaceHolder()) ?>" value="<?php echo $timecards->date->EditValue ?>"<?php echo $timecards->date->EditAttributes() ?>>
<?php if (!$timecards->date->ReadOnly && !$timecards->date->Disabled && !isset($timecards->date->EditAttrs["readonly"]) && !isset($timecards->date->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateCalendar("ftimecardsupdate", "x_date", 0);
</script>
<?php } ?>
</span>
<?php echo $timecards->date->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($timecards->in->Visible) { // in ?>
	<div id="r_in" class="form-group">
		<label for="x_in" class="col-sm-2 control-label">
<input type="checkbox" name="u_in" id="u_in" value="1"<?php echo ($timecards->in->MultiUpdate == "1") ? " checked" : "" ?>>
 <?php echo $timecards->in->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $timecards->in->CellAttributes() ?>>
<span id="el_timecards_in">
<select data-table="timecards" data-field="x_in" data-value-separator="<?php echo $timecards->in->DisplayValueSeparatorAttribute() ?>" id="x_in" name="x_in"<?php echo $timecards->in->EditAttributes() ?>>
<?php echo $timecards->in->SelectOptionListHtml("x_in") ?>
</select>
<input type="hidden" name="s_x_in" id="s_x_in" value="<?php echo $timecards->in->LookupFilterQuery() ?>">
</span>
<?php echo $timecards->in->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($timecards->out->Visible) { // out ?>
	<div id="r_out" class="form-group">
		<label for="x_out" class="col-sm-2 control-label">
<input type="checkbox" name="u_out" id="u_out" value="1"<?php echo ($timecards->out->MultiUpdate == "1") ? " checked" : "" ?>>
 <?php echo $timecards->out->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $timecards->out->CellAttributes() ?>>
<span id="el_timecards_out">
<select data-table="timecards" data-field="x_out" data-value-separator="<?php echo $timecards->out->DisplayValueSeparatorAttribute() ?>" id="x_out" name="x_out"<?php echo $timecards->out->EditAttributes() ?>>
<?php echo $timecards->out->SelectOptionListHtml("x_out") ?>
</select>
<input type="hidden" name="s_x_out" id="s_x_out" value="<?php echo $timecards->out->LookupFilterQuery() ?>">
</span>
<?php echo $timecards->out->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($timecards->regular->Visible) { // regular ?>
	<div id="r_regular" class="form-group">
		<label for="x_regular" class="col-sm-2 control-label">
<input type="checkbox" name="u_regular" id="u_regular" value="1"<?php echo ($timecards->regular->MultiUpdate == "1") ? " checked" : "" ?>>
 <?php echo $timecards->regular->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $timecards->regular->CellAttributes() ?>>
<span id="el_timecards_regular">
<input type="text" data-table="timecards" data-field="x_regular" name="x_regular" id="x_regular" size="30" placeholder="<?php echo ew_HtmlEncode($timecards->regular->getPlaceHolder()) ?>" value="<?php echo $timecards->regular->EditValue ?>"<?php echo $timecards->regular->EditAttributes() ?>>
</span>
<?php echo $timecards->regular->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($timecards->overtime->Visible) { // overtime ?>
	<div id="r_overtime" class="form-group">
		<label for="x_overtime" class="col-sm-2 control-label">
<input type="checkbox" name="u_overtime" id="u_overtime" value="1"<?php echo ($timecards->overtime->MultiUpdate == "1") ? " checked" : "" ?>>
 <?php echo $timecards->overtime->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $timecards->overtime->CellAttributes() ?>>
<span id="el_timecards_overtime">
<input type="text" data-table="timecards" data-field="x_overtime" name="x_overtime" id="x_overtime" size="30" placeholder="<?php echo ew_HtmlEncode($timecards->overtime->getPlaceHolder()) ?>" value="<?php echo $timecards->overtime->EditValue ?>"<?php echo $timecards->overtime->EditAttributes() ?>>
</span>
<?php echo $timecards->overtime->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if ($timecards->total->Visible) { // total ?>
	<div id="r_total" class="form-group">
		<label for="x_total" class="col-sm-2 control-label">
<input type="checkbox" name="u_total" id="u_total" value="1"<?php echo ($timecards->total->MultiUpdate == "1") ? " checked" : "" ?>>
 <?php echo $timecards->total->FldCaption() ?></label>
		<div class="col-sm-10"><div<?php echo $timecards->total->CellAttributes() ?>>
<span id="el_timecards_total">
<input type="text" data-table="timecards" data-field="x_total" name="x_total" id="x_total" size="30" placeholder="<?php echo ew_HtmlEncode($timecards->total->getPlaceHolder()) ?>" value="<?php echo $timecards->total->EditValue ?>"<?php echo $timecards->total->EditAttributes() ?>>
</span>
<?php echo $timecards->total->CustomMsg ?></div></div>
	</div>
<?php } ?>
<?php if (!$timecards_update->IsModal) { ?>
	<div class="form-group">
		<div class="col-sm-offset-2 col-sm-10">
<button class="btn btn-primary ewButton" name="btnAction" id="btnAction" type="submit"><?php echo $Language->Phrase("UpdateBtn") ?></button>
<button class="btn btn-default ewButton" name="btnCancel" id="btnCancel" type="button" data-href="<?php echo $timecards_update->getReturnUrl() ?>"><?php echo $Language->Phrase("CancelBtn") ?></button>
		</div>
	</div>
<?php } ?>
</div>
</form>
<script type="text/javascript">
ftimecardsupdate.Init();
</script>
<?php
$timecards_update->ShowPageFooter();
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
?>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php include_once "footer.php" ?>
<?php
$timecards_update->Page_Terminate();
?>
